/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(Z){for(var e=[],k=0,n=Z.length;k<n;k++)e[k]=oe[Z[k]];return e};define(oe[52],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(T,R)=>` ${R} `).trim():""}e.getCodiconAriaLabel=k;class n{constructor(T,R,P){this.id=T,this.definition=R,this.description=P,n.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n.a}}e.Codicon=n,n.a=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",n.circleFilled.definition),n.closeDirty=new n("close-dirty",n.circleFilled.definition),n.debugBreakpoint=new n("debug-breakpoint",n.circleFilled.definition),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",n.circleFilled.definition),n.debugHint=new n("debug-hint",n.circleFilled.definition),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circle=new n("circle",{fontCharacter:"\\eabc"}),n.circleOutline=new n("circle-outline",n.circle.definition),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",n.circle.definition),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLarge=new n("circle-large",{fontCharacter:"\\ebb5"}),n.circleLargeOutline=new n("circle-large-outline",n.circleLarge.definition),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\ec09"}),n.commentUnresolved=new n("comment-unresolved",{fontCharacter:"\\ec0a"}),n.gitPullRequestGoToChanges=new n("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),n.gitPullRequestNewChanges=new n("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),n.searchFuzzy=new n("search-fuzzy",{fontCharacter:"\\ec0d"}),n.commentDraft=new n("comment-draft",{fontCharacter:"\\ec0e"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);var D;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function R(C){if(C instanceof n)return["codicon","codicon-"+C.id];const E=T.exec(C.id);if(!E)return R(n.error);const[,p,g]=E,h=["codicon","codicon-"+p];return g&&h.push("codicon-modifier-"+g.substring(1)),h}A.asClassNameArray=R;function P(C){return R(C).join(" ")}A.asClassName=P;function S(C){return"."+R(C).join(".")}A.asCSSSelector=S})(D=e.CSSIcon||(e.CSSIcon={}))}),define(oe[63],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(T){return(R,P,S)=>{let C=null,E=null;if(typeof S.value=="function"?(C="value",E=S.value):typeof S.get=="function"&&(C="get",E=S.get),!E)throw new Error("not supported");S[C]=T(E,P)}}function n(T,R,P){let S=null,C=null;if(typeof P.value=="function"?(S="value",C=P.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(S="get",C=P.get),!C)throw new Error("not supported");const E=`$memoize$${R}`;P[S]=function(...p){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,p)}),this[E]}}e.memoize=n;function D(T,R,P){return k((S,C)=>{const E=`$debounce$${C}`,p=`$debounce$result$${C}`;return function(...g){this[p]||(this[p]=P?P():void 0),clearTimeout(this[E]),R&&(this[p]=R(this[p],...g),g=[this[p]]),this[E]=setTimeout(()=>{S.apply(this,g),this[p]=P?P():void 0},T)}})}e.debounce=D;function A(T,R,P){return k((S,C)=>{const E=`$throttle$timer$${C}`,p=`$throttle$result$${C}`,g=`$throttle$lastRun$${C}`,h=`$throttle$pending$${C}`;return function(...y){if(this[p]||(this[p]=P?P():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),R&&(this[p]=R(this[p],...y)),this[h])return;const f=this[g]+T;f<=Date.now()?(this[g]=Date.now(),S.apply(this,[this[p]]),this[p]=P?P():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[g]=Date.now(),S.apply(this,[this[p]]),this[p]=P?P():void 0},f-Date.now()))}})}e.throttle=A}),define(oe[9],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?m.isErrorNoTelemetry(i)?new m(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(r=>{r(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=k,e.errorHandler=new k;function n(I){e.errorHandler.setUnexpectedErrorHandler(I)}e.setUnexpectedErrorHandler=n;function D(I){P(I)||e.errorHandler.onUnexpectedError(I)}e.onUnexpectedError=D;function A(I){P(I)||e.errorHandler.onUnexpectedExternalError(I)}e.onUnexpectedExternalError=A;function T(I){if(I instanceof Error){const{name:i,message:r}=I,t=I.stacktrace||I.stack;return{$isError:!0,name:i,message:r,stack:t,noTelemetry:m.isErrorNoTelemetry(I)}}return I}e.transformErrorForSerialization=T;const R="Canceled";function P(I){return I instanceof S?!0:I instanceof Error&&I.name===R&&I.message===R}e.isCancellationError=P;class S extends Error{constructor(){super(R),this.name=this.message}}e.CancellationError=S;function C(){const I=new Error(R);return I.name=I.message,I}e.canceled=C;function E(I){return I?new Error(`Illegal argument: ${I}`):new Error("Illegal argument")}e.illegalArgument=E;function p(I){return I?new Error(`Illegal state: ${I}`):new Error("Illegal state")}e.illegalState=p;function g(I){return I?new Error(`readonly property '${I} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function h(I){const i=new Error(`${I} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function y(I){return I?I.message?I.message:I.stack?I.stack.split(`
`)[0]:String(I):"Error"}e.getErrorMessage=y;class f extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=f;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class m extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof m)return i;const r=new m;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class v extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype);debugger}}e.BugIndicatingError=v}),define(oe[21],ae([0,1,9]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function n(J,_=0){return J[J.length-(1+_)]}e.tail=n;function D(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}e.tail2=D;function A(J,_,se=(ue,le)=>ue===le){if(J===_)return!0;if(!J||!_||J.length!==_.length)return!1;for(let ue=0,le=J.length;ue<le;ue++)if(!se(J[ue],_[ue]))return!1;return!0}e.equals=A;function T(J,_){const se=J.length-1;_<se&&(J[_]=J[se]),J.pop()}e.removeFastWithoutKeepingOrder=T;function R(J,_,se){return P(J.length,ue=>se(J[ue],_))}e.binarySearch=R;function P(J,_){let se=0,ue=J-1;for(;se<=ue;){const le=(se+ue)/2|0,ye=_(le);if(ye<0)se=le+1;else if(ye>0)ue=le-1;else return le}return-(se+1)}e.binarySearch2=P;function S(J,_){let se=0,ue=J.length;if(ue===0)return 0;for(;se<ue;){const le=Math.floor((se+ue)/2);_(J[le])?ue=le:se=le+1}return se}e.findFirstInSorted=S;function C(J,_,se){if(J=J|0,J>=_.length)throw new TypeError("invalid index");const ue=_[Math.floor(_.length*Math.random())],le=[],ye=[],Se=[];for(const be of _){const Ee=se(be,ue);Ee<0?le.push(be):Ee>0?ye.push(be):Se.push(be)}return J<le.length?C(J,le,se):J<le.length+Se.length?Se[0]:C(J-(le.length+Se.length),ye,se)}e.quickSelect=C;function E(J,_){const se=[];let ue;for(const le of J.slice(0).sort(_))!ue||_(ue[0],le)!==0?(ue=[le],se.push(ue)):ue.push(le);return se}e.groupBy=E;function p(J,_,se){const ue=[];function le(be,Ee,Ne){if(Ee===0&&Ne.length===0)return;const Fe=ue[ue.length-1];Fe&&Fe.start+Fe.deleteCount===be?(Fe.deleteCount+=Ee,Fe.toInsert.push(...Ne)):ue.push({start:be,deleteCount:Ee,toInsert:Ne})}let ye=0,Se=0;for(;;){if(ye===J.length){le(ye,0,_.slice(Se));break}if(Se===_.length){le(ye,J.length-ye,[]);break}const be=J[ye],Ee=_[Se],Ne=se(be,Ee);Ne===0?(ye+=1,Se+=1):Ne<0?(le(ye,1,[]),ye+=1):Ne>0&&(le(ye,0,[Ee]),Se+=1)}return ue}e.sortedDiff=p;function g(J,_,se){const ue=p(J,_,se),le=[],ye=[];for(const Se of ue)le.push(...J.slice(Se.start,Se.start+Se.deleteCount)),ye.push(...Se.toInsert);return{removed:le,added:ye}}e.delta=g;function h(J,_,se){if(se===0)return[];const ue=J.slice(0,se).sort(_);return f(J,_,ue,se,J.length),ue}e.top=h;function y(J,_,se,ue,le){return se===0?Promise.resolve([]):new Promise((ye,Se)=>{(async()=>{const be=J.length,Ee=J.slice(0,se).sort(_);for(let Ne=se,Fe=Math.min(se+ue,be);Ne<be;Ne=Fe,Fe=Math.min(Fe+ue,be)){if(Ne>se&&await new Promise(Ye=>setTimeout(Ye)),le&&le.isCancellationRequested)throw new k.CancellationError;f(J,_,Ee,Ne,Fe)}return Ee})().then(ye,Se)})}e.topAsync=y;function f(J,_,se,ue,le){for(const ye=se.length;ue<le;ue++){const Se=J[ue];if(_(Se,se[ye-1])<0){se.pop();const be=S(se,Ee=>_(Se,Ee)<0);se.splice(be,0,Se)}}}function l(J){return J.filter(_=>!!_)}e.coalesce=l;function d(J){let _=0;for(let se=0;se<J.length;se++)J[se]&&(J[_]=J[se],_+=1);J.length=_}e.coalesceInPlace=d;function m(J,_,se){J.splice(se,0,J.splice(_,1)[0])}e.move=m;function v(J){return!Array.isArray(J)||J.length===0}e.isFalsyOrEmpty=v;function I(J){return Array.isArray(J)&&J.length>0}e.isNonEmptyArray=I;function i(J,_=se=>se){const se=new Set;return J.filter(ue=>{const le=_(ue);return se.has(le)?!1:(se.add(le),!0)})}e.distinct=i;function r(J){const _=new Set;return se=>{const ue=J(se);return _.has(ue)?!1:(_.add(ue),!0)}}e.uniqueFilter=r;function t(J,_){const se=s(J,_);if(se!==-1)return J[se]}e.findLast=t;function s(J,_){for(let se=J.length-1;se>=0;se--){const ue=J[se];if(_(ue))return se}return-1}e.lastIndex=s;function o(J,_){return J.length>0?J[0]:_}e.firstOrDefault=o;function c(J,_){return J.length>0?J[J.length-1]:_}e.lastOrDefault=c;function a(J,_,se=(ue,le)=>ue===le){let ue=0;for(let le=0,ye=Math.min(J.length,_.length);le<ye&&se(J[le],_[le]);le++)ue++;return ue}e.commonPrefixLength=a;function u(J){return[].concat(...J)}e.flatten=u;function w(J,_){let se=typeof _=="number"?J:0;typeof _=="number"?se=J:(se=0,_=J);const ue=[];if(se<=_)for(let le=se;le<_;le++)ue.push(le);else for(let le=se;le>_;le--)ue.push(le);return ue}e.range=w;function b(J,_,se){return J.reduce((ue,le)=>(ue[_(le)]=se?se(le):le,ue),Object.create(null))}e.index=b;function U(J,_){return J.push(_),()=>N(J,_)}e.insert=U;function N(J,_){const se=J.indexOf(_);if(se>-1)return J.splice(se,1),_}e.remove=N;function $(J,_,se){const ue=J.slice(0,_),le=J.slice(_);return ue.concat(se,le)}e.arrayInsert=$;function F(J,_){let se;if(typeof _=="number"){let ue=_;se=()=>{const le=Math.sin(ue++)*179426549;return le-Math.floor(le)}}else se=Math.random;for(let ue=J.length-1;ue>0;ue-=1){const le=Math.floor(se()*(ue+1)),ye=J[ue];J[ue]=J[le],J[le]=ye}}e.shuffle=F;function L(J,_){const se=J.indexOf(_);se>-1&&(J.splice(se,1),J.unshift(_))}e.pushToStart=L;function j(J,_){const se=J.indexOf(_);se>-1&&(J.splice(se,1),J.push(_))}e.pushToEnd=j;function z(J,_){for(const se of _)J.push(se)}e.pushMany=z;function V(J,_){return Array.isArray(J)?J.map(_):_(J)}e.mapArrayOrNot=V;function Q(J){return Array.isArray(J)?J:[J]}e.asArray=Q;function Y(J){return J[Math.floor(Math.random()*J.length)]}e.getRandomElement=Y;function H(J,_){for(const se of J){const ue=_(se);if(ue!==void 0)return ue}}e.mapFind=H;function q(J,_,se){const ue=X(J,_),le=J.length,ye=se.length;J.length=le+ye;for(let Se=le-1;Se>=ue;Se--)J[Se+ye]=J[Se];for(let Se=0;Se<ye;Se++)J[Se+ue]=se[Se]}e.insertInto=q;function G(J,_,se,ue){const le=X(J,_),ye=J.splice(le,se);return q(J,le,ue),ye}e.splice=G;function X(J,_){return _<0?Math.max(_+J.length,0):Math.min(_,J.length)}var ee;(function(J){function _(le){return le<0}J.isLessThan=_;function se(le){return le>0}J.isGreaterThan=se;function ue(le){return le===0}J.isNeitherLessOrGreaterThan=ue,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function re(J,_){return(se,ue)=>_(J(se),J(ue))}e.compareBy=re;function te(...J){return(_,se)=>{for(const ue of J){const le=ue(_,se);if(!ee.isNeitherLessOrGreaterThan(le))return le}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=te;const O=(J,_)=>J-_;e.numberComparator=O;function M(J,_){if(J.length===0)return;let se=J[0];for(let ue=1;ue<J.length;ue++){const le=J[ue];_(le,se)>0&&(se=le)}return se}e.findMaxBy=M;function W(J,_){if(J.length===0)return;let se=J[0];for(let ue=1;ue<J.length;ue++){const le=J[ue];_(le,se)>=0&&(se=le)}return se}e.findLastMaxBy=W;function B(J,_){return M(J,(se,ue)=>-_(se,ue))}e.findMinBy=B;class x{constructor(_){this.f=_,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(_){let se=this.c;for(;se<this.f.length&&_(this.f[se]);)se++;const ue=se===this.c?null:this.f.slice(this.c,se);return this.c=se,ue}takeFromEndWhile(_){let se=this.d;for(;se>=0&&_(this.f[se]);)se--;const ue=se===this.d?null:this.f.slice(se+1,this.d+1);return this.d=se,ue}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const _=this.f[this.c];return this.c++,_}removeLast(){const _=this.f[this.d];return this.d--,_}takeCount(_){const se=this.f.slice(this.c,this.c+_);return this.c+=_,se}}e.ArrayQueue=x;class ie{constructor(_){this.iterate=_}forEach(_){this.iterate(se=>(_(se),!0))}toArray(){const _=[];return this.iterate(se=>(_.push(se),!0)),_}filter(_){return new ie(se=>this.iterate(ue=>_(ue)?se(ue):!0))}map(_){return new ie(se=>this.iterate(ue=>se(_(ue))))}some(_){let se=!1;return this.iterate(ue=>(se=_(ue),!se)),se}findFirst(_){let se;return this.iterate(ue=>_(ue)?(se=ue,!1):!0),se}findLast(_){let se;return this.iterate(ue=>(_(ue)&&(se=ue),!0)),se}findLastMaxBy(_){let se,ue=!0;return this.iterate(le=>((ue||ee.isGreaterThan(_(le,se)))&&(ue=!1,se=le),!0)),se}}e.CallbackIterable=ie,ie.empty=new ie(J=>{})}),define(oe[126],ae([0,1,9]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function n(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=n;function D(P,S="Unreachable"){throw new Error(S)}e.assertNever=D;function A(P){if(!P)throw new k.BugIndicatingError("Assertion Failed")}e.assert=A;function T(P){if(!P()){debugger;P(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function R(P,S){let C=0;for(;C<P.length-1;){const E=P[C],p=P[C+1];if(!S(E,p))return!1;C++}return!0}e.checkAdjacentItems=R}),define(oe[82],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(n){const D=this;let A=!1,T;return function(){return A||(A=!0,T=n.apply(D,arguments)),T}}e.once=k}),define(oe[64],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(n){function D(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}n.is=D;const A=Object.freeze([]);function T(){return A}n.empty=T;function*R(v){yield v}n.single=R;function P(v){return D(v)?v:R(v)}n.wrap=P;function S(v){return v||A}n.from=S;function C(v){return!v||v[Symbol.iterator]().next().done===!0}n.isEmpty=C;function E(v){return v[Symbol.iterator]().next().value}n.first=E;function p(v,I){for(const i of v)if(I(i))return!0;return!1}n.some=p;function g(v,I){for(const i of v)if(I(i))return i}n.find=g;function*h(v,I){for(const i of v)I(i)&&(yield i)}n.filter=h;function*y(v,I){let i=0;for(const r of v)yield I(r,i++)}n.map=y;function*f(...v){for(const I of v)for(const i of I)yield i}n.concat=f;function l(v,I,i){let r=i;for(const t of v)r=I(r,t);return r}n.reduce=l;function*d(v,I,i=v.length){for(I<0&&(I+=v.length),i<0?i+=v.length:i>v.length&&(i=v.length);I<i;I++)yield v[I]}n.slice=d;function m(v,I=Number.POSITIVE_INFINITY){const i=[];if(I===0)return[i,v];const r=v[Symbol.iterator]();for(let t=0;t<I;t++){const s=r.next();if(s.done)return[i,n.empty()];i.push(s.value)}return[i,{[Symbol.iterator](){return r}}]}n.consume=m})(k=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var n;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function T(i,r=!1){let t=0;const s=i.length;let o="",c=0,a=16,u=0;function w(j){let z=0,V=0;for(;z<j;){const Q=i.charCodeAt(t);if(Q>=48&&Q<=57)V=V*16+Q-48;else if(Q>=65&&Q<=70)V=V*16+Q-65+10;else if(Q>=97&&Q<=102)V=V*16+Q-97+10;else break;t++,z++}return z<j&&(V=-1),V}function b(j){t=j,o="",c=0,a=16,u=0}function U(){const j=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&S(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&S(i.charCodeAt(t)))for(t++;t<i.length&&S(i.charCodeAt(t));)t++;else return u=3,i.substring(j,t);let z=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&S(i.charCodeAt(t))){for(t++;t<i.length&&S(i.charCodeAt(t));)t++;z=t}else u=3;return i.substring(j,z)}function N(){let j="",z=t;for(;;){if(t>=s){j+=i.substring(z,t),u=2;break}const V=i.charCodeAt(t);if(V===34){j+=i.substring(z,t),t++;break}if(V===92){if(j+=i.substring(z,t),t++,t>=s){u=2;break}switch(i.charCodeAt(t++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const Y=w(4);Y>=0?j+=String.fromCharCode(Y):u=4;break}default:u=5}z=t;continue}if(V>=0&&V<=31)if(P(V)){j+=i.substring(z,t),u=2;break}else u=6;t++}return j}function $(){if(o="",u=0,c=t,t>=s)return c=s,a=17;let j=i.charCodeAt(t);if(R(j)){do t++,o+=String.fromCharCode(j),j=i.charCodeAt(t);while(R(j));return a=15}if(P(j))return t++,o+=String.fromCharCode(j),j===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(j){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=N(),a=10;case 47:{const z=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<s&&!P(i.charCodeAt(t));)t++;return o=i.substring(z,t),a=12}if(i.charCodeAt(t+1)===42){t+=2;const V=s-1;let Q=!1;for(;t<V;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,Q=!0;break}t++}return Q||(t++,u=1),o=i.substring(z,t),a=13}return o+=String.fromCharCode(j),t++,a=16}case 45:if(o+=String.fromCharCode(j),t++,t===s||!S(i.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=U(),a=11;default:for(;t<s&&F(j);)t++,j=i.charCodeAt(t);if(c!==t){switch(o=i.substring(c,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(j),t++,a=16}}function F(j){if(R(j)||P(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let j;do j=$();while(j>=12&&j<=15);return j}return{setPosition:b,getPosition:()=>t,scan:r?L:$,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>u}}e.createScanner=T;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function P(i){return i===10||i===13||i===8232||i===8233}function S(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function E(i,r){const t=[],s=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(w,b,U,N){c.value=w,c.offset=b,c.length=U,c.type=N,c.colonOffset=void 0,o=c}try{m(i,{onObjectBegin:(w,b)=>{if(r<=w)throw s;o=void 0,a=r>w,t.push("")},onObjectProperty:(w,b,U)=>{if(r<b||(u(w,b,U,"property"),t[t.length-1]=w,r<=b+U))throw s},onObjectEnd:(w,b)=>{if(r<=w)throw s;o=void 0,t.pop()},onArrayBegin:(w,b)=>{if(r<=w)throw s;o=void 0,t.push(0)},onArrayEnd:(w,b)=>{if(r<=w)throw s;o=void 0,t.pop()},onLiteralValue:(w,b,U)=>{if(r<b||(u(w,b,U,I(w)),r<=b+U))throw s},onSeparator:(w,b,U)=>{if(r<=b)throw s;if(w===":"&&o&&o.type==="property")o.colonOffset=b,a=!1,o=void 0;else if(w===","){const N=t[t.length-1];typeof N=="number"?t[t.length-1]=N+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(w){if(w!==s)throw w}return{path:t,previousNode:o,isAtPropertyKey:a,matches:w=>{let b=0;for(let U=0;b<w.length&&U<t.length;U++)if(w[b]===t[U]||w[b]==="*")b++;else if(w[b]!=="**")return!1;return b===w.length}}}e.getLocation=E;function p(i,r=[],t=A.DEFAULT){let s=null,o=[];const c=[];function a(w){Array.isArray(o)?o.push(w):s!==null&&(o[s]=w)}return m(i,{onObjectBegin:()=>{const w={};a(w),c.push(o),o=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const w=[];a(w),c.push(o),o=w,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(w,b,U)=>{r.push({error:w,offset:b,length:U})}},t),o[0]}e.parse=p;function g(i,r=[],t=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(w){s.type==="property"&&(s.length=w-s.offset,s=s.parent)}function c(w){return s.children.push(w),w}m(i,{onObjectBegin:w=>{s=c({type:"object",offset:w,length:-1,parent:s,children:[]})},onObjectProperty:(w,b,U)=>{s=c({type:"property",offset:b,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:w,offset:b,length:U,parent:s})},onObjectEnd:(w,b)=>{s.length=w+b-s.offset,s=s.parent,o(w+b)},onArrayBegin:(w,b)=>{s=c({type:"array",offset:w,length:-1,parent:s,children:[]})},onArrayEnd:(w,b)=>{s.length=w+b-s.offset,s=s.parent,o(w+b)},onLiteralValue:(w,b,U)=>{c({type:I(w),offset:b,length:U,parent:s,value:w}),o(b+U)},onSeparator:(w,b,U)=>{s.type==="property"&&(w===":"?s.colonOffset=b:w===","&&o(b))},onError:(w,b,U)=>{r.push({error:w,offset:b,length:U})}},t);const u=s.children[0];return u&&delete u.parent,u}e.parseTree=g;function h(i,r){if(!i)return;let t=i;for(const s of r)if(typeof s=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===s){t=c.children[1],o=!0;break}if(!o)return}else{const o=s;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=h;function y(i){if(!i.parent||!i.parent.children)return[];const r=y(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.getNodePath=y;function f(i){switch(i.type){case"array":return i.children.map(f);case"object":{const r=Object.create(null);for(const t of i.children){const s=t.children[1];s&&(r[t.children[0].value]=f(s))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=f;function l(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.contains=l;function d(i,r,t=!1){if(l(i,r,t)){const s=i.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=r;o++){const c=d(s[o],r,t);if(c)return c}return i}}e.findNodeAtOffset=d;function m(i,r,t=A.DEFAULT){const s=T(i,!1);function o(re){return re?()=>re(s.getTokenOffset(),s.getTokenLength()):()=>!0}function c(re){return re?te=>re(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=o(r.onObjectBegin),u=c(r.onObjectProperty),w=o(r.onObjectEnd),b=o(r.onArrayBegin),U=o(r.onArrayEnd),N=c(r.onLiteralValue),$=c(r.onSeparator),F=o(r.onComment),L=c(r.onError),j=t&&t.disallowComments,z=t&&t.allowTrailingComma;function V(){for(;;){const re=s.scan();switch(s.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:j||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(re){case 12:case 13:j?Q(10):F();break;case 16:Q(1);break;case 15:case 14:break;default:return re}}}function Q(re,te=[],O=[]){if(L(re),te.length+O.length>0){let M=s.getToken();for(;M!==17;){if(te.indexOf(M)!==-1){V();break}else if(O.indexOf(M)!==-1)break;M=V()}}}function Y(re){const te=s.getTokenValue();return re?N(te):u(te),V(),!0}function H(){switch(s.getToken()){case 11:{let re=0;try{re=JSON.parse(s.getTokenValue()),typeof re!="number"&&(Q(2),re=0)}catch{Q(2)}N(re);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return V(),!0}function q(){return s.getToken()!==10?(Q(3,[],[2,5]),!1):(Y(!1),s.getToken()===6?($(":"),V(),ee()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function G(){a(),V();let re=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(re||Q(4,[],[]),$(","),V(),s.getToken()===2&&z)break}else re&&Q(6,[],[]);q()||Q(4,[],[2,5]),re=!0}return w(),s.getToken()!==2?Q(7,[2],[]):V(),!0}function X(){b(),V();let re=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(re||Q(4,[],[]),$(","),V(),s.getToken()===4&&z)break}else re&&Q(6,[],[]);ee()||Q(4,[],[4,5]),re=!0}return U(),s.getToken()!==4?Q(8,[4],[]):V(),!0}function ee(){switch(s.getToken()){case 3:return X();case 1:return G();case 10:return Y(!0);default:return H()}}return V(),s.getToken()===17?t.allowEmptyContent?!0:(Q(4,[],[]),!1):ee()?(s.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=m;function v(i,r){const t=T(i),s=[];let o,c=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==a&&s.push(i.substring(c,a)),r!==void 0&&s.push(t.getTokenValue().replace(/[^\r\n]/g,r)),c=t.getPosition();break}while(o!==17);return s.join("")}e.stripComments=v;function I(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),define(oe[43],ae([0,1,35]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(S,C,E){let p,g,h,y,f;if(C){for(y=C.offset,f=y+C.length,h=y;h>0&&!P(S,h-1);)h--;let a=f;for(;a<S.length&&!P(S,a);)a++;g=S.substring(h,a),p=T(g,E)}else g=S,p=0,h=0,y=0,f=S.length;const l=R(E,S);let d=!1,m=0,v;E.insertSpaces?v=A(" ",E.tabSize||4):v="	";const I=(0,k.createScanner)(g,!1);let i=!1;function r(){return l+A(v,p+m)}function t(){let a=I.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=I.scan();return i=a===16||I.getTokenError()!==0,a}const s=[];function o(a,u,w){!i&&u<f&&w>y&&S.substring(u,w)!==a&&s.push({offset:u,length:w-u,content:a})}let c=t();if(c!==17){const a=I.getTokenOffset()+h,u=A(v,p);o(u,h,a)}for(;c!==17;){let a=I.getTokenOffset()+I.getTokenLength()+h,u=t(),w="";for(;!d&&(u===12||u===13);){const U=I.getTokenOffset()+h;o(" ",a,U),a=I.getTokenOffset()+I.getTokenLength()+h,w=u===12?r():"",u=t()}if(u===2)c!==1&&(m--,w=r());else if(u===4)c!==3&&(m--,w=r());else{switch(c){case 3:case 1:m++,w=r();break;case 5:case 12:w=r();break;case 13:d?w=r():w=" ";break;case 6:w=" ";break;case 10:if(u===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?w=" ":u!==5&&u!==17&&(i=!0);break;case 16:i=!0;break}d&&(u===12||u===13)&&(w=r())}const b=I.getTokenOffset()+h;o(w,a,b),c=u}return s}e.format=n;function D(S,C){const E=JSON.stringify(S,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.toFormattedString=D;function A(S,C){let E="";for(let p=0;p<C;p++)E+=S;return E}function T(S,C){let E=0,p=0;const g=C.tabSize||4;for(;E<S.length;){const h=S.charAt(E);if(h===" ")p++;else if(h==="	")p+=g;else break;E++}return Math.floor(p/g)}function R(S,C){for(let E=0;E<C.length;E++){const p=C.charAt(E);if(p==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=R;function P(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=P}),define(oe[83],ae([0,1,35,43]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(S,C,E){return A(S,C,void 0,E)}e.removeProperty=D;function A(S,C,E,p,g){const h=C.slice(),y=[],f=(0,k.parseTree)(S,y);let l,d;for(;h.length>0&&(d=h.pop(),l=(0,k.findNodeAtLocation)(f,h),l===void 0&&E!==void 0);)typeof d=="string"?E={[d]:E}:E=[E];if(l)if(l.type==="object"&&typeof d=="string"&&Array.isArray(l.children)){const m=(0,k.findNodeAtLocation)(l,[d]);if(m!==void 0)if(E===void 0){if(!m.parent)throw new Error("Malformed AST");const v=l.children.indexOf(m.parent);let I,i=m.parent.offset+m.parent.length;if(v>0){const r=l.children[v-1];I=r.offset+r.length}else I=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return T(S,{offset:I,length:i-I,content:""},p)}else return T(S,{offset:m.offset,length:m.length,content:JSON.stringify(E)},p);else{if(E===void 0)return[];const v=`${JSON.stringify(d)}: ${JSON.stringify(E)}`,I=g?g(l.children.map(r=>r.children[0].value)):l.children.length;let i;if(I>0){const r=l.children[I-1];i={offset:r.offset+r.length,length:0,content:","+v}}else l.children.length===0?i={offset:l.offset+1,length:0,content:v}:i={offset:l.offset+1,length:0,content:v+","};return T(S,i,p)}}else if(l.type==="array"&&typeof d=="number"&&Array.isArray(l.children))if(E!==void 0){const m=`${JSON.stringify(E)}`;let v;if(l.children.length===0||d===0)v={offset:l.offset+1,length:0,content:l.children.length===0?m:m+","};else{const I=d===-1||d>l.children.length?l.children.length:d,i=l.children[I-1];v={offset:i.offset+i.length,length:0,content:","+m}}return T(S,v,p)}else{const m=d,v=l.children[m];let I;if(l.children.length===1)I={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===m){const i=l.children[m-1],r=i.offset+i.length,t=l.offset+l.length;I={offset:r,length:t-2-r,content:""}}else I={offset:v.offset,length:l.children[m+1].offset-v.offset,content:""};return T(S,I,p)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${l.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return T(S,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(E)},p)}}e.setProperty=A;function T(S,C,E){let p=R(S,C),g=C.offset,h=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;g>0&&!(0,n.isEOL)(p,g-1);)g--;for(;h<p.length&&!(0,n.isEOL)(p,h);)h++}const y=(0,n.format)(p,{offset:g,length:h-g},E);for(let l=y.length-1;l>=0;l--){const d=y[l];p=R(p,d),g=Math.min(g,d.offset),h=Math.max(h,d.offset+d.length),h+=d.content.length-d.length}const f=S.length-(p.length-h)-g;return[{offset:g,length:f,content:p.substring(g,h)}]}e.withFormatting=T;function R(S,C){return S.substring(0,C.offset)+C.content+S.substring(C.offset+C.length)}e.applyEdit=R;function P(S,C){const E=C.slice(0).sort((g,h)=>{const y=g.offset-h.offset;return y===0?g.length-h.length:y});let p=S.length;for(let g=E.length-1;g>=0;g--){const h=E[g];if(h.offset+h.length<=p)S=R(S,h);else throw new Error("Overlapping edit");p=h.offset}return S}e.applyEdits=P}),define(oe[127],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(D){this.d=D,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(D){return new k(()=>D(this.getValue()))}}e.Lazy=k}),define(oe[2],ae([0,1,82,64]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let A=null;function T(c){A=c}if(e.setDisposableTracker=T,D){const c="__is_disposable_tracked__";T(new class{trackDisposable(a){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(u)},3e3)}setParent(a,u){if(a&&a!==d.None)try{a[c]=!0}catch{}}markAsDisposed(a){if(a&&a!==d.None)try{a[c]=!0}catch{}}markAsSingleton(a){}})}function R(c){return A?.trackDisposable(c),c}function P(c){A?.markAsDisposed(c)}function S(c,a){A?.setParent(c,a)}function C(c,a){if(!!A)for(const u of c)A.setParent(u,a)}function E(c){return A?.markAsSingleton(c),c}e.markAsSingleton=E;function p(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=p;function g(c){if(n.Iterable.is(c)){const a=[];for(const u of c)if(u)try{u.dispose()}catch(w){a.push(w)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=g;function h(c){for(const a of c)p(a)&&a.dispose();return[]}e.disposeIfDisposable=h;function y(...c){const a=f(()=>g(c));return C(c,a),a}e.combinedDisposable=y;function f(c){const a=R({dispose:(0,k.once)(()=>{P(a),c()})});return a}e.toDisposable=f;class l{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(P(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{g(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return S(a,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this.q=new l,R(this),S(this.q,this)}dispose(){P(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class m{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&S(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,P(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&S(a,null),a}}e.MutableDisposable=m;class v{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=v;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(a){let u=a;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,P(this))},this}}e.SafeDisposable=I;class i{constructor(){this.a=new Map}acquire(a,...u){let w=this.a.get(a);w||(w={counter:0,object:this.b(a,...u)},this.a.set(a,w));const{object:b}=w,U=(0,k.once)(()=>{--w.counter===0&&(this.c(a,w.object),this.a.delete(a))});return w.counter++,{object:b,dispose:U}}}e.ReferenceCollection=i;class r{constructor(a){this.a=a}async acquire(a,...u){const w=this.a.acquire(a,...u);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(b){throw w.dispose(),b}}}e.AsyncReferenceCollection=r;class t{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=t;function s(c){const a=new l;try{c(a)}finally{a.dispose()}}e.disposeOnReturn=s;class o{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){P(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,u,w=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this.a.get(a)?.dispose(),this.a.set(a,u)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(oe[84],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(A){this.element=A,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class n{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let A=this.a;for(;A!==k.Undefined;){const T=A.next;A.prev=k.Undefined,A.next=k.Undefined,A=T}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,T){const R=new k(A);if(this.a===k.Undefined)this.a=R,this.b=R;else if(T){const S=this.b;this.b=R,R.prev=S,S.next=R}else{const S=this.a;this.a=R,R.next=S,S.prev=R}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(R))}}shift(){if(this.a!==k.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==k.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==k.Undefined&&A.next!==k.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===k.Undefined&&A.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):A.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):A.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==k.Undefined;)yield A.element,A=A.next}}e.LinkedList=n}),define(oe[37],ae([0,1]),function(Z,e){"use strict";var k,n,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(h,y,f){let l=h.get(y);return l===void 0&&(l=f,h.set(y,l)),l}e.getOrSet=A;function T(h){const y=[];return h.forEach((f,l)=>{y.push(`${l} => ${f}`)}),`Map(${h.size}) {${y.join(", ")}}`}e.mapToString=T;function R(h){const y=[];return h.forEach(f=>{y.push(f)}),`Set(${h.size}) {${y.join(", ")}}`}e.setToString=R;class P{constructor(y,f){this.uri=y,this.value=f}}class S{constructor(y,f){this[k]="ResourceMap",y instanceof S?(this.b=new Map(y.b),this.c=f??S.a):(this.b=new Map,this.c=y??S.a)}set(y,f){return this.b.set(this.c(y),new P(y,f)),this}get(y){return this.b.get(this.c(y))?.value}has(y){return this.b.has(this.c(y))}get size(){return this.b.size}clear(){this.b.clear()}delete(y){return this.b.delete(this.c(y))}forEach(y,f){typeof f<"u"&&(y=y.bind(f));for(const[l,d]of this.b)y(d.value,d.uri,this)}*values(){for(const y of this.b.values())yield y.value}*keys(){for(const y of this.b.values())yield y.uri}*entries(){for(const y of this.b.values())yield[y.uri,y.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,y]of this.b)yield[y.uri,y.value]}}e.ResourceMap=S,S.a=h=>h.toString();class C{constructor(y,f){this[n]="ResourceSet",!y||typeof y=="function"?this.a=new S(y):(this.a=new S(f),y.forEach(this.add,this))}get size(){return this.a.size}add(y){return this.a.set(y,y),this}clear(){this.a.clear()}delete(y){return this.a.delete(y)}forEach(y,f){this.a.forEach((l,d)=>y.call(f,d,d,this))}has(y){return this.a.has(y)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var E;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class p{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(y){return this.a.has(y)}get(y,f=0){const l=this.a.get(y);if(!!l)return f!==0&&this.j(l,f),l.value}set(y,f,l=0){let d=this.a.get(y);if(d)d.value=f,l!==0&&this.j(d,l);else{switch(d={key:y,value:f,next:void 0,previous:void 0},l){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(y,d),this.d++}return this}delete(y){return!!this.remove(y)}remove(y){const f=this.a.get(y);if(!!f)return this.a.delete(y),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const y=this.b;return this.a.delete(y.key),this.i(y),this.d--,y.value}forEach(y,f){const l=this.e;let d=this.b;for(;d;){if(f?y.bind(f)(d.value,d.key,this):y(d.value,d.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const y=this,f=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.key,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return d}values(){const y=this,f=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.value,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return d}entries(){const y=this,f=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:[l.key,l.value],done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return d}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(y){if(y>=this.size)return;if(y===0){this.clear();return}let f=this.b,l=this.size;for(;f&&l>y;)this.a.delete(f.key),f=f.next,l--;this.b=f,this.d=l,f&&(f.previous=void 0),this.e++}g(y){if(!this.b&&!this.c)this.c=y;else if(this.b)y.next=this.b,this.b.previous=y;else throw new Error("Invalid list");this.b=y,this.e++}h(y){if(!this.b&&!this.c)this.b=y;else if(this.c)y.previous=this.c,this.c.next=y;else throw new Error("Invalid list");this.c=y,this.e++}i(y){if(y===this.b&&y===this.c)this.b=void 0,this.c=void 0;else if(y===this.b){if(!y.next)throw new Error("Invalid list");y.next.previous=void 0,this.b=y.next}else if(y===this.c){if(!y.previous)throw new Error("Invalid list");y.previous.next=void 0,this.c=y.previous}else{const f=y.next,l=y.previous;if(!f||!l)throw new Error("Invalid list");f.previous=l,l.next=f}y.next=void 0,y.previous=void 0,this.e++}j(y,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(y===this.b)return;const l=y.next,d=y.previous;y===this.c?(d.next=void 0,this.c=d):(l.previous=d,d.next=l),y.previous=void 0,y.next=this.b,this.b.previous=y,this.b=y,this.e++}else if(f===2){if(y===this.c)return;const l=y.next,d=y.previous;y===this.b?(l.previous=void 0,this.b=l):(l.previous=d,d.next=l),y.next=void 0,y.previous=this.c,this.c.next=y,this.c=y,this.e++}}}toJSON(){const y=[];return this.forEach((f,l)=>{y.push([l,f])}),y}fromJSON(y){this.clear();for(const[f,l]of y)this.set(f,l)}}e.LinkedMap=p;class g extends p{constructor(y,f=1){super(),this.k=y,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(y){this.k=y,this.m()}get ratio(){return this.l}set ratio(y){this.l=Math.min(Math.max(0,y),1),this.m()}get(y,f=2){return super.get(y,f)}peek(y){return super.get(y,0)}set(y,f){return super.set(y,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=g}),define(oe[85],ae([0,1,37]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new k.LRUCache(1e4);function D(S){return P(S,"NFC",n)}e.normalizeNFC=D;const A=new k.LRUCache(1e4);function T(S){return P(S,"NFD",A)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function P(S,C,E){if(!S)return S;const p=E.get(S);if(p)return p;let g;return R.test(S)?g=S.normalize(C):g=S,E.set(S,g),g}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(C){return T(C).replace(S,"")}}()}),define(oe[128],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function k(R,P,S){return Math.min(Math.max(R,P),S)}e.clamp=k;function n(R,P){return(P+R%P)%P}e.rot=n;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class A{constructor(){this.a=1,this.b=0}update(P){return this.b=this.b+(P-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class T{constructor(P){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(P),this.c.fill(0,0,P)}update(P){const S=this.c[this.d];return this.c[this.d]=P,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=P,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=T}),function(){function Z(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function T(P){A.push(P,Date.now())}function R(){const P=[];for(let S=0;S<A.length;S+=2)P.push({name:A[S],startTime:A[S+1]});return P}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(D+T.startTime)});return A}};if(typeof process=="object"){const D=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function k(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=k(n))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var n in k)(typeof exports=="object"?exports:Z)[n]=k[n]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function k(n){if(e[n])return e[n].exports;var D=e[n]={i:n,l:!1,exports:{}};return Z[n].call(D.exports,D,D.exports,k),D.l=!0,D.exports}return k.m=Z,k.c=e,k.d=function(n,D,A){k.o(n,D)||Object.defineProperty(n,D,{enumerable:!0,get:A})},k.r=function(n){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},k.t=function(n,D){if(1&D&&(n=k(n)),8&D||4&D&&typeof n=="object"&&n&&n.__esModule)return n;var A=Object.create(null);if(k.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:n}),2&D&&typeof n!="string")for(var T in n)k.d(A,T,function(R){return n[R]}.bind(null,T));return A},k.n=function(n){var D=n&&n.__esModule?function(){return n.default}:function(){return n};return k.d(D,"a",D),D},k.o=function(n,D){return Object.prototype.hasOwnProperty.call(n,D)},k.p="",k(k.s=0)}([function(Z,e,k){(function(n){var D;e=Z.exports=O,D=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],S=0,C=S++;P[C]="0|[1-9]\\d*";var E=S++;P[E]="[0-9]+";var p=S++;P[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=S++;P[g]="("+P[C]+")\\.("+P[C]+")\\.("+P[C]+")";var h=S++;P[h]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var y=S++;P[y]="(?:"+P[C]+"|"+P[p]+")";var f=S++;P[f]="(?:"+P[E]+"|"+P[p]+")";var l=S++;P[l]="(?:-("+P[y]+"(?:\\."+P[y]+")*))";var d=S++;P[d]="(?:-?("+P[f]+"(?:\\."+P[f]+")*))";var m=S++;P[m]="[0-9A-Za-z-]+";var v=S++;P[v]="(?:\\+("+P[m]+"(?:\\."+P[m]+")*))";var I=S++,i="v?"+P[g]+P[l]+"?"+P[v]+"?";P[I]="^"+i+"$";var r="[v=\\s]*"+P[h]+P[d]+"?"+P[v]+"?",t=S++;P[t]="^"+r+"$";var s=S++;P[s]="((?:<|>)?=?)";var o=S++;P[o]=P[E]+"|x|X|\\*";var c=S++;P[c]=P[C]+"|x|X|\\*";var a=S++;P[a]="[v=\\s]*("+P[c]+")(?:\\.("+P[c]+")(?:\\.("+P[c]+")(?:"+P[l]+")?"+P[v]+"?)?)?";var u=S++;P[u]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[d]+")?"+P[v]+"?)?)?";var w=S++;P[w]="^"+P[s]+"\\s*"+P[a]+"$";var b=S++;P[b]="^"+P[s]+"\\s*"+P[u]+"$";var U=S++;P[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=S++;P[N]="(?:~>?)";var $=S++;P[$]="(\\s*)"+P[N]+"\\s+",R[$]=new RegExp(P[$],"g");var F=S++;P[F]="^"+P[N]+P[a]+"$";var L=S++;P[L]="^"+P[N]+P[u]+"$";var j=S++;P[j]="(?:\\^)";var z=S++;P[z]="(\\s*)"+P[j]+"\\s+",R[z]=new RegExp(P[z],"g");var V=S++;P[V]="^"+P[j]+P[a]+"$";var Q=S++;P[Q]="^"+P[j]+P[u]+"$";var Y=S++;P[Y]="^"+P[s]+"\\s*("+r+")$|^$";var H=S++;P[H]="^"+P[s]+"\\s*("+i+")$|^$";var q=S++;P[q]="(\\s*)"+P[s]+"\\s*("+r+"|"+P[a]+")",R[q]=new RegExp(P[q],"g");var G=S++;P[G]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var X=S++;P[X]="^\\s*("+P[u]+")\\s+-\\s+("+P[u]+")\\s*$";var ee=S++;P[ee]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)D(re,P[re]),R[re]||(R[re]=new RegExp(P[re]));function te(ce,de){if(ce instanceof O)return ce;if(typeof ce!="string"||ce.length>A||!(de?R[t]:R[I]).test(ce))return null;try{return new O(ce,de)}catch{return null}}function O(ce,de){if(ce instanceof O){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof O))return new O(ce,de);D("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?R[t]:R[I]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<T)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ce,de){var ge=te(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=te(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof O||(ce=new O(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},O.prototype.compareMain=function(ce){return ce instanceof O||(ce=new O(ce,this.loose)),W(this.major,ce.major)||W(this.minor,ce.minor)||W(this.patch,ce.patch)},O.prototype.comparePre=function(ce){if(ce instanceof O||(ce=new O(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(D("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return W(ge,Ce)}while(++de)},O.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new O(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(J(ce,de))return null;var ge=te(ce),Ce=te(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=W;var M=/^[0-9]+$/;function W(ce,de){var ge=M.test(ce),Ce=M.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function B(ce,de,ge){return new O(ce,ge).compare(new O(de,ge))}function x(ce,de,ge){return B(ce,de,ge)>0}function ie(ce,de,ge){return B(ce,de,ge)<0}function J(ce,de,ge){return B(ce,de,ge)===0}function _(ce,de,ge){return B(ce,de,ge)!==0}function se(ce,de,ge){return B(ce,de,ge)>=0}function ue(ce,de,ge){return B(ce,de,ge)<=0}function le(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=J(ce,ge,Ce);break;case"!=":Pe=_(ce,ge,Ce);break;case">":Pe=x(ce,ge,Ce);break;case">=":Pe=se(ce,ge,Ce);break;case"<":Pe=ie(ce,ge,Ce);break;case"<=":Pe=ue(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function ye(ce,de){if(ce instanceof ye){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof ye))return new ye(ce,de);D("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,de){return W(de,ce)},e.major=function(ce,de){return new O(ce,de).major},e.minor=function(ce,de){return new O(ce,de).minor},e.patch=function(ce,de){return new O(ce,de).patch},e.compare=B,e.compareLoose=function(ce,de){return B(ce,de,!0)},e.rcompare=function(ce,de,ge){return B(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=x,e.lt=ie,e.eq=J,e.neq=_,e.gte=se,e.lte=ue,e.cmp=le,e.Comparator=ye;var Se={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof ye)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ne(ce,de,ge,Ce,Pe,Ae,De,je,Te,Me,Be,ke,Oe){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Te)?"":Ee(Me)?"<"+(+Te+1)+".0.0":Ee(Be)?"<"+Te+"."+(+Me+1)+".0":ke?"<="+Te+"."+Me+"."+Be+"-"+ke:"<="+je)).trim()}function Fe(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(D(ce[ge].semver),ce[ge].semver!==Se&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function ze(ce,de,ge,Ce){var Pe,Ae,De,je,Te;switch(ce=new O(ce,Ce),de=new be(de,Ce),ge){case">":Pe=x,Ae=ue,De=ie,je=">",Te=">=";break;case"<":Pe=ie,Ae=se,De=x,je="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Me=0;Me<de.set.length;++Me){var Be=de.set[Me],ke=null,Oe=null;if(Be.forEach(function(ne){ne.semver===Se&&(ne=new ye(">=0.0.0")),ke=ke||ne,Oe=Oe||ne,Pe(ne.semver,ke.semver,Ce)?ke=ne:De(ne.semver,Oe.semver,Ce)&&(Oe=ne)}),ke.operator===je||ke.operator===Te||(!Oe.operator||Oe.operator===je)&&Ae(ce,Oe.semver)||Oe.operator===Te&&De(ce,Oe.semver))return!1}return!0}ye.prototype.parse=function(ce){var de=this.loose?R[Y]:R[H],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new O(ge[2],this.loose):this.semver=Se},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===Se||(typeof ce=="string"&&(ce=new O(ce,this.loose)),le(ce,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(ce,de){if(!(ce instanceof ye))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=le(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Te=le(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Ae&&De||je||Te},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),D("range",ce,de);var ge=de?R[X]:R[G];ce=ce.replace(ge,Ne),D("hyphen replace",ce),ce=ce.replace(R[q],"$1$2$3"),D("comparator trim",ce,R[q]),ce=(ce=(ce=ce.replace(R[$],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var Ce=de?R[Y]:R[H],Pe=ce.split(" ").map(function(Ae){return function(De,je){return D("comp",De),De=function(Te,Me){return Te.trim().split(/\s+/).map(function(Be){return function(ke,Oe){D("caret",ke,Oe);var ne=Oe?R[Q]:R[V];return ke.replace(ne,function(he,fe,me,we,Ie){var Re;return D("caret",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+Ie+" <"+(+fe+1)+".0.0"):(D("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+" <"+(+fe+1)+".0.0"),D("caret return",Re),Re})}(Be,Me)}).join(" ")}(De,je),D("caret",De),De=function(Te,Me){return Te.trim().split(/\s+/).map(function(Be){return function(ke,Oe){var ne=Oe?R[L]:R[F];return ke.replace(ne,function(he,fe,me,we,Ie){var Re;return D("tilde",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0",D("tilde return",Re),Re})}(Be,Me)}).join(" ")}(De,je),D("tildes",De),De=function(Te,Me){return D("replaceXRanges",Te,Me),Te.split(/\s+/).map(function(Be){return function(ke,Oe){ke=ke.trim();var ne=Oe?R[b]:R[w];return ke.replace(ne,function(he,fe,me,we,Ie,Re){D("xRange",ke,he,fe,me,we,Ie,Re);var He=Ee(me),$e=He||Ee(we),Le=$e||Ee(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(we=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,we=0,Ie=0):Le&&(we=+we+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:we=+we+1),he=fe+me+"."+we+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0"),D("xRange return",he),he})}(Be,Me)}).join(" ")}(De,je),D("xrange",De),De=function(Te,Me){return D("replaceStars",Te,Me),Te.trim().replace(R[ee],"")}(De,je),D("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ce)})),Pe=Pe.map(function(Ae){return new ye(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ce.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new O(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Fe(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new O(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new O(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return ze(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return ze(ce,de,">",ge)},e.outside=ze,e.prerelease=function(ce,de){var ge=te(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof O)return ce;if(typeof ce!="string")return null;var de=ce.match(R[U]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,k(1))},function(Z,e){var k,n,D=Z.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(f){if(k===setTimeout)return setTimeout(f,0);if((k===A||!k)&&setTimeout)return k=setTimeout,setTimeout(f,0);try{return k(f,0)}catch{try{return k.call(null,f,0)}catch{return k.call(this,f,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:A}catch{k=A}try{n=typeof clearTimeout=="function"?clearTimeout:T}catch{n=T}})();var P,S=[],C=!1,E=-1;function p(){C&&P&&(C=!1,P.length?S=P.concat(S):E=-1,S.length&&g())}function g(){if(!C){var f=R(p);C=!0;for(var l=S.length;l;){for(P=S,S=[];++E<l;)P&&P[E].run();E=-1,l=S.length}P=null,C=!1,function(d){if(n===clearTimeout)return clearTimeout(d);if((n===T||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(d);try{n(d)}catch{try{return n.call(null,d)}catch{return n.call(this,d)}}}(f)}}function h(f,l){this.fun=f,this.array=l}function y(){}D.nextTick=function(f){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];S.push(new h(f,l)),S.length!==1||C||R(g)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(oe[129],ae([0,1]),function(Z,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,P,S){this.level=R,this.key=P,this.value=S,this.forward=[]}}const D=void 0;class A{constructor(R,P=2**16){this.comparator=R,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new n(this.c,D,D)}get size(){return this.f}clear(){this.e=new n(this.c,D,D)}has(R){return Boolean(A.g(this,R,this.comparator))}get(R){return A.g(this,R,this.comparator)?.value}set(R,P){return A.h(this,R,P,this.comparator)&&(this.f+=1),this}delete(R){const P=A.k(this,R,this.comparator);return P&&(this.f-=1),P}forEach(R,P){let S=this.e.forward[0];for(;S;)R.call(P,S.value,S.key,this),S=S.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this.e.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static g(R,P,S){let C=R.e;for(let E=R.d-1;E>=0;E--)for(;C.forward[E]&&S(C.forward[E].key,P)<0;)C=C.forward[E];if(C=C.forward[0],C&&S(C.key,P)===0)return C}static h(R,P,S,C){const E=[];let p=R.e;for(let g=R.d-1;g>=0;g--){for(;p.forward[g]&&C(p.forward[g].key,P)<0;)p=p.forward[g];E[g]=p}if(p=p.forward[0],p&&C(p.key,P)===0)return p.value=S,!1;{const g=A.j(R);if(g>R.d){for(let h=R.d;h<g;h++)E[h]=R.e;R.d=g}p=new n(g,P,S);for(let h=0;h<g;h++)p.forward[h]=E[h].forward[h],E[h].forward[h]=p;return!0}}static j(R,P=.5){let S=1;for(;Math.random()<P&&S<R.c;)S+=1;return S}static k(R,P,S){const C=[];let E=R.e;for(let p=R.d-1;p>=0;p--){for(;E.forward[p]&&S(E.forward[p].key,P)<0;)E=E.forward[p];C[p]=E}if(E=E.forward[0],!E||S(E.key,P)!==0)return!1;for(let p=0;p<R.d&&C[p].forward[p]===E;p++)C[p].forward[p]=E.forward[p];for(;R.d>0&&R.e.forward[R.d-1]===D;)R.d-=1;return!0}}e.SkipList=A}),define(oe[44],ae([0,1,9,2]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(v){const I=v;return I?typeof I.read=="function":!1}e.isReadable=D;function A(v){const I=v;return I?[I.on,I.pause,I.resume,I.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=A;function T(v){const I=v;return I?A(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.isReadableBufferedStream=T;function R(v,I){return new P(v,I)}e.newWriteableStream=R;class P{constructor(I,i){this.e=I,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(i=>i(I))}h(I){this.c.error.length===0?(0,k.onUnexpectedError)(I):this.c.error.slice(0).forEach(i=>i(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,i){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(I,i){if(this.a.destroyed)return;let r;switch(I){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(v,I){const i=[];let r;for(;(r=v.read())!==null;)i.push(r);return I(i)}e.consumeReadable=S;function C(v,I,i){const r=[];let t;for(;(t=v.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?I(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const s=t;return t=void 0,s}return v.read()}}}e.peekReadable=C;function E(v,I){return new Promise((i,r)=>{const t=[];p(v,{onData:s=>{I&&t.push(s)},onError:s=>{I?r(s):i(void 0)},onEnd:()=>{i(I?I(t):void 0)}})})}e.consumeStream=E;function p(v,I){let i=!1;return v.on("error",r=>{i||I.onError(r)}),v.on("end",()=>{i||I.onEnd()}),v.on("data",r=>{i||I.onData(r)}),(0,n.toDisposable)(()=>i=!0)}e.listenStream=p;function g(v,I){return new Promise((i,r)=>{const t=new n.DisposableStore,s=[],o=u=>{if(s.push(u),s.length>I)return t.dispose(),v.pause(),i({stream:v,buffer:s,ended:!1})},c=u=>r(u),a=()=>i({stream:v,buffer:s,ended:!0});t.add((0,n.toDisposable)(()=>v.removeListener("error",c))),v.on("error",c),t.add((0,n.toDisposable)(()=>v.removeListener("end",a))),v.on("end",a),t.add((0,n.toDisposable)(()=>v.removeListener("data",o))),v.on("data",o)})}e.peekStream=g;function h(v,I){const i=R(I);return i.end(v),i}e.toStream=h;function y(){const v=R(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=y;function f(v){let I=!1;return{read:()=>I?null:(I=!0,v)}}e.toReadable=f;function l(v,I,i){const r=R(i);return p(v,{onData:t=>r.write(I.data(t)),onError:t=>r.error(I.error?I.error(t):t),onEnd:()=>r.end()}),r}e.transform=l;function d(v,I,i){let r=!1;return{read:()=>{const t=I.read();return r?t:(r=!0,t!==null?i([v,t]):v)}}}e.prefixedReadable=d;function m(v,I,i){let r=!1;const t=R(i);return p(I,{onData:s=>r?t.write(s):(r=!0,t.write(i([v,s]))),onError:s=>t.error(s),onEnd:()=>{r||(r=!0,t.write(v)),t.end()}}),t}e.prefixedStream=m}),define(oe[17],ae([0,1,44]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer<"u";let D,A;class T{static alloc(u){return n?new T(Buffer.allocUnsafe(u)):new T(new Uint8Array(u))}static wrap(u){return n&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new T(u)}static fromString(u,w){return!(w?.dontUseNodeBuffer||!1)&&n?new T(Buffer.from(u)):(D||(D=new TextEncoder),new T(D.encode(u)))}static fromByteArray(u){const w=T.alloc(u.length);for(let b=0,U=u.length;b<U;b++)w.buffer[b]=u[b];return w}static concat(u,w){if(typeof w>"u"){w=0;for(let N=0,$=u.length;N<$;N++)w+=u[N].byteLength}const b=T.alloc(w);let U=0;for(let N=0,$=u.length;N<$;N++){const F=u[N];b.set(F,U),U+=F.byteLength}return b}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=T.alloc(this.byteLength);return u.set(this),u}toString(){return n?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(u,w){return new T(this.buffer.subarray(u,w))}set(u,w){if(u instanceof T)this.buffer.set(u.buffer,w);else if(u instanceof Uint8Array)this.buffer.set(u,w);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),w);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return S(this.buffer,u)}writeUInt32BE(u,w){C(this.buffer,u,w)}readUInt32LE(u){return E(this.buffer,u)}writeUInt32LE(u,w){p(this.buffer,u,w)}readUInt8(u){return g(this.buffer,u)}writeUInt8(u,w){h(this.buffer,u,w)}}e.VSBuffer=T;function R(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=R;function P(a,u,w){a[w+0]=u&255,u=u>>>8,a[w+1]=u&255}e.writeUInt16LE=P;function S(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=S;function C(a,u,w){a[w+3]=u,u=u>>>8,a[w+2]=u,u=u>>>8,a[w+1]=u,u=u>>>8,a[w]=u}e.writeUInt32BE=C;function E(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=E;function p(a,u,w){a[w+0]=u&255,u=u>>>8,a[w+1]=u&255,u=u>>>8,a[w+2]=u&255,u=u>>>8,a[w+3]=u&255}e.writeUInt32LE=p;function g(a,u){return a[u]}e.readUInt8=g;function h(a,u,w){a[w]=u}e.writeUInt8=h;function y(a){return k.consumeReadable(a,u=>T.concat(u))}e.readableToBuffer=y;function f(a){return k.toReadable(a)}e.bufferToReadable=f;function l(a){return k.consumeStream(a,u=>T.concat(u))}e.streamToBuffer=l;async function d(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=d;function m(a){return k.toStream(a,u=>T.concat(u))}e.bufferToStream=m;function v(a){return k.transform(a,{data:u=>typeof u=="string"?T.fromString(u):T.wrap(u)},u=>T.concat(u))}e.streamToBufferReadableStream=v;function I(a){return k.newWriteableStream(u=>T.concat(u),a)}e.newWriteableBufferStream=I;function i(a,u){return k.prefixedReadable(a,u,w=>T.concat(w))}e.prefixedBufferReadable=i;function r(a,u){return k.prefixedStream(a,u,w=>T.concat(w))}e.prefixedBufferStream=r;function t(a){let u=0,w=0,b=0;const U=new Uint8Array(Math.floor(a.length/4*3)),N=F=>{switch(w){case 3:U[b++]=u|F,w=0;break;case 2:U[b++]=u|F>>>2,u=F<<6,w=3;break;case 1:U[b++]=u|F>>>4,u=F<<4,w=2;break;default:u=F<<2,w=1}};for(let F=0;F<a.length;F++){const L=a.charCodeAt(F);if(L>=65&&L<=90)N(L-65);else if(L>=97&&L<=122)N(L-97+26);else if(L>=48&&L<=57)N(L-48+52);else if(L===43||L===45)N(62);else if(L===47||L===95)N(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${a[F]}`)}}const $=b;for(;w>0;)N(0);return T.wrap(U).slice(0,$)}e.decodeBase64=t;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},u=!0,w=!1){const b=w?o:s;let U="";const N=a.byteLength%3;let $=0;for(;$<a.byteLength-N;$+=3){const F=a[$+0],L=a[$+1],j=a[$+2];U+=b[F>>>2],U+=b[(F<<4|L>>>4)&63],U+=b[(L<<2|j>>>6)&63],U+=b[j&63]}if(N===1){const F=a[$+0];U+=b[F>>>2],U+=b[F<<4&63],u&&(U+="==")}else if(N===2){const F=a[$+0],L=a[$+1];U+=b[F>>>2],U+=b[(F<<4|L>>>4)&63],U+=b[L<<2&63],u&&(U+="=")}return U}e.encodeBase64=c}),define(oe[14],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(r){return typeof r=="string"}e.isString=k;function n(r){return Array.isArray(r)&&r.every(t=>k(t))}e.isStringArray=n;function D(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=D;function A(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=A;function T(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=T;function R(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=R;function P(r){return r===!0||r===!1}e.isBoolean=P;function S(r){return typeof r>"u"}e.isUndefined=S;function C(r){return!E(r)}e.isDefined=C;function E(r){return S(r)||r===null}e.isUndefinedOrNull=E;function p(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function g(r){if(E(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=g;function h(...r){const t=[];for(let s=0;s<r.length;s++){const o=r[s];if(E(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(o)}return t}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function f(r){if(!D(r))return!1;for(const t in r)if(y.call(r,t))return!1;return!0}e.isEmptyObject=f;function l(r){return typeof r=="function"}e.isFunction=l;function d(...r){return r.length>0&&r.every(l)}e.areFunctions=d;function m(r,t){const s=Math.min(r.length,t.length);for(let o=0;o<s;o++)v(r[o],t[o])}e.validateConstraints=m;function v(r,t){if(k(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(r instanceof t)return}catch{}if(!E(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function I(r){return r===null?void 0:r}e.withNullAsUndefined=I;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(oe[32],ae([0,1,14]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([m,v])=>{d[m]=v&&typeof v=="object"?n(v):v}),d}e.deepClone=n;function D(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const m=d.shift();Object.freeze(m);for(const v in m)if(A.call(m,v)){const I=m[v];typeof I=="object"&&!Object.isFrozen(I)&&!(0,k.isTypedArray)(I)&&d.push(I)}}return l}e.deepFreeze=D;const A=Object.prototype.hasOwnProperty;function T(l,d){return R(l,d,new Set)}e.cloneAndChange=T;function R(l,d,m){if((0,k.isUndefinedOrNull)(l))return l;const v=d(l);if(typeof v<"u")return v;if(Array.isArray(l)){const I=[];for(const i of l)I.push(R(i,d,m));return I}if((0,k.isObject)(l)){if(m.has(l))throw new Error("Cannot clone recursive data-structure");m.add(l);const I={};for(const i in l)A.call(l,i)&&(I[i]=R(l[i],d,m));return m.delete(l),I}return l}function P(l,d,m=!0){return(0,k.isObject)(l)?((0,k.isObject)(d)&&Object.keys(d).forEach(v=>{v in l?m&&((0,k.isObject)(l[v])&&(0,k.isObject)(d[v])?P(l[v],d[v],m):l[v]=d[v]):l[v]=d[v]}),l):d}e.mixin=P;function S(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let m,v;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(m=0;m<l.length;m++)if(!S(l[m],d[m]))return!1}else{const I=[];for(v in l)I.push(v);I.sort();const i=[];for(v in d)i.push(v);if(i.sort(),!S(I,i))return!1;for(m=0;m<I.length;m++)if(!S(l[I[m]],d[I[m]]))return!1}return!0}e.equals=S;function C(l){const d=new Set;return JSON.stringify(l,(m,v)=>{if((0,k.isObject)(v)||Array.isArray(v)){if(d.has(v))return"[Circular]";d.add(v)}return v})}e.safeStringify=C;function E(l,d){const m=Object.create(null);return!l||!d||Object.keys(d).forEach(I=>{const i=l[I],r=d[I];S(i,r)||(m[I]=r)}),m}e.distinct=E;function p(l,d){const m=d.toLowerCase(),v=Object.keys(l).find(I=>I.toLowerCase()===m);return v?l[v]:l[d]}e.getCaseInsensitive=p;function g(l,d){const m=Object.create(null);for(const[v,I]of Object.entries(l))d(v,I)&&(m[v]=I);return m}e.filter=g;function h(l){let d=[],m=Object.getPrototypeOf(l);for(;Object.prototype!==m;)d=d.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return d}e.getAllPropertyNames=h;function y(l){const d=[];for(const m of h(l))typeof l[m]=="function"&&d.push(m);return d}e.getAllMethodNames=y;function f(l,d){const m=I=>function(){const i=Array.prototype.slice.call(arguments,0);return d(I,i)},v={};for(const I of l)v[I]=m(I);return v}e.createProxyObject=f}),define(oe[31],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(D){return k.test(D)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),T=[];for(let R=0;R<256;R++)T.push(R.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,S="";return S+=T[A[P++]],S+=T[A[P++]],S+=T[A[P++]],S+=T[A[P++]],S+="-",S+=T[A[P++]],S+=T[A[P++]],S+="-",S+=T[A[P++]],S+=T[A[P++]],S+="-",S+=T[A[P++]],S+=T[A[P++]],S+="-",S+=T[A[P++]],S+=T[A[P++]],S+=T[A[P++]],S+=T[A[P++]],S+=T[A[P++]],S+=T[A[P++]],S}}()}),define(oe[130],ae([0,1,34]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(T){const R=T.replace(/\-/g,":").toLowerCase();return!n.has(R)}function A(){const T=(0,k.networkInterfaces)();for(const R in T){const P=T[R];if(P){for(const{mac:S}of P)if(D(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(oe[131],ae([0,1,86]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,P,S,C=1){let E=!1;return new Promise(p=>{const g=setTimeout(()=>{if(!E)return E=!0,p(0)},S);D(R,P,C,h=>{if(!E)return E=!0,clearTimeout(g),p(h)})})}e.findFreePort=n;function D(R,P,S,C){if(P===0)return C(0);const E=new k.Socket;E.once("connect",()=>(T(E),D(R+S,P-1,S,C))),E.once("data",()=>{}),E.once("error",p=>(T(E),p.code!=="ECONNREFUSED"?D(R+S,P-1,S,C):C(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,P,S,C="127.0.0.1"){let E=!1,p,g=1;const h=k.createServer({pauseOnConnect:!0});function y(f,l){E||(E=!0,h.removeAllListeners(),h.close(),p&&clearTimeout(p),l(f))}return new Promise(f=>{p=setTimeout(()=>{y(0,f)},S),h.on("listening",()=>{y(R,f)}),h.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&g<P?(R++,g++,h.listen(R,C)):y(0,f)}),h.on("close",()=>{y(0,f)}),h.listen(R,C)})}e.findFreePortFaster=A;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(oe[132],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function n(A){return A instanceof D?!0:A instanceof Error&&A.name===k&&A.message===k}e.isOfflineError=n;class D extends Error{constructor(){super(k),this.name=this.message}}e.OfflineError=D}),define(oe[133],ae([0,1,17,9,132]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(P,S){if(!navigator.onLine)throw new D.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((E,p)=>{C.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(C,P),C.responseType="arraybuffer",C.onerror=g=>p(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=g=>{E({res:{statusCode:C.status,headers:R(C)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=g=>p(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(C.timeout=P.timeout),C.send(P.data),S.onCancellationRequested(()=>{C.abort(),p((0,n.canceled)())})})}e.request=A;function T(P,S){if(S.headers){e:for(const C in S.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(C,S.headers[C])}}}function R(P){const S=Object.create(null);for(const C of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const E=C.indexOf(":");S[C.substr(0,E).trim().toLowerCase()]=C.substr(E+1).trim()}return S}}),define(oe[134],ae([10,11]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(oe[65],ae([0,1,134]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,A=D*24,T=A*7,R=A*30,P=A*365;function S(E,p,g,h){typeof E!="number"&&(E=E.getTime());const y=Math.round((new Date().getTime()-E)/1e3);if(y<-30)return(0,k.localize)(0,null,S(new Date().getTime()+y*1e3,!1));if(!h&&y<30)return(0,k.localize)(1,null);let f;return y<n?(f=y,p?f===1?g?(0,k.localize)(2,null,f):(0,k.localize)(3,null,f):g?(0,k.localize)(4,null,f):(0,k.localize)(5,null,f):f===1?g?(0,k.localize)(6,null,f):(0,k.localize)(7,null,f):g?(0,k.localize)(8,null,f):(0,k.localize)(9,null,f)):y<D?(f=Math.floor(y/n),p?f===1?g?(0,k.localize)(10,null,f):(0,k.localize)(11,null,f):g?(0,k.localize)(12,null,f):(0,k.localize)(13,null,f):f===1?g?(0,k.localize)(14,null,f):(0,k.localize)(15,null,f):g?(0,k.localize)(16,null,f):(0,k.localize)(17,null,f)):y<A?(f=Math.floor(y/D),p?f===1?g?(0,k.localize)(18,null,f):(0,k.localize)(19,null,f):g?(0,k.localize)(20,null,f):(0,k.localize)(21,null,f):f===1?g?(0,k.localize)(22,null,f):(0,k.localize)(23,null,f):g?(0,k.localize)(24,null,f):(0,k.localize)(25,null,f)):y<T?(f=Math.floor(y/A),p?f===1?(0,k.localize)(26,null,f):(0,k.localize)(27,null,f):f===1?(0,k.localize)(28,null,f):(0,k.localize)(29,null,f)):y<R?(f=Math.floor(y/T),p?f===1?g?(0,k.localize)(30,null,f):(0,k.localize)(31,null,f):g?(0,k.localize)(32,null,f):(0,k.localize)(33,null,f):f===1?g?(0,k.localize)(34,null,f):(0,k.localize)(35,null,f):g?(0,k.localize)(36,null,f):(0,k.localize)(37,null,f)):y<P?(f=Math.floor(y/R),p?f===1?g?(0,k.localize)(38,null,f):(0,k.localize)(39,null,f):g?(0,k.localize)(40,null,f):(0,k.localize)(41,null,f):f===1?g?(0,k.localize)(42,null,f):(0,k.localize)(43,null,f):g?(0,k.localize)(44,null,f):(0,k.localize)(45,null,f)):(f=Math.floor(y/P),p?f===1?g?(0,k.localize)(46,null,f):(0,k.localize)(47,null,f):g?(0,k.localize)(48,null,f):(0,k.localize)(49,null,f):f===1?g?(0,k.localize)(50,null,f):(0,k.localize)(51,null,f):g?(0,k.localize)(52,null,f):(0,k.localize)(53,null,f))}e.fromNow=S;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(oe[135],ae([10,11]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,14,135]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(E,p){return p&&(E.stack||E.stacktrace)?D.localize(0,null,R(E),T(E.stack)||T(E.stacktrace)):R(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function P(E=null,p=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const g=k.coalesce(E),h=P(g[0],p);return g.length>1?D.localize(4,null,h,g.length):h}if(n.isString(E))return E;if(E.detail){const g=E.detail;if(g.error)return A(g.error,p);if(g.exception)return A(g.exception,p)}return E.stack?A(E,p):E.message?E.message:D.localize(5,null)}e.toErrorMessage=P;function S(E){const p=E;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=S;function C(E,p){let g;return typeof E=="string"?g=new Error(E):g=E,g.actions=p,g}e.createErrorWithActions=C}),define(oe[136],ae([10,11]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(oe[137],ae([0,1,136]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(D){switch(D){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(oe[138],ae([10,11]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,138]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let n=!1,D=!1,A=!1,T=!1,R=!1,P=!1,S=!1,C=!1,E=!1,p=!1,g,h=e.LANGUAGE_DEFAULT,y,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const d=typeof l?.versions?.electron=="string",m=d&&l?.type==="renderer";if(typeof navigator=="object"&&!m)f=navigator.userAgent,n=f.indexOf("Windows")>=0,D=f.indexOf("Macintosh")>=0,C=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=f.indexOf("Linux")>=0,p=f?.indexOf("Mobi")>=0,P=!0,g=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,h=g;else if(typeof l=="object"){n=l.platform==="win32",D=l.platform==="darwin",A=l.platform==="linux",T=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,S=d,E=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const a=l.env.VSCODE_NLS_CONFIG;if(a)try{const u=JSON.parse(a),w=u.availableLanguages["*"];g=u.locale,h=w||e.LANGUAGE_DEFAULT,y=u._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var v;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function I(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let i=0;D?i=1:n?i=3:A&&(i=2),e.isWindows=n,e.isMacintosh=D,e.isLinux=A,e.isLinuxSnap=T,e.isNative=R,e.isElectron=S,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=p,e.isCI=E,e.platform=i,e.userAgent=f,e.language=h;var r;(function(a){function u(){return e.language}a.value=u;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=w;function b(){return e.language==="en"}a.isDefault=b})(r=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let b=0,U=a.length;b<U;b++){const N=a[b];if(N.id===w.data.vscodeScheduleAsyncWork){a.splice(b,1),N.callback();return}}});let u=0;return w=>{const b=++u;a.push({id:b,callback:w}),e.globals.postMessage({vscodeScheduleAsyncWork:b},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:n?1:3;let s=!0,o=!1;function c(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,s=new Uint16Array(a.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const D=k.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(oe[12],ae([0,1,36]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,A=90,T=122,R=46,P=47,S=92,C=58,E=63;class p extends Error{constructor(r,t,s){let o;typeof t=="string"&&t.indexOf("not ")===0?(o="must not be",t=t.replace(/^not /,"")):o="must be";const c=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${c} ${o} of type ${t}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,r){if(i===null||typeof i!="object")throw new p(r,"Object",i)}function h(i,r){if(typeof i!="string")throw new p(r,"string",i)}const y=k.platform==="win32";function f(i){return i===P||i===S}function l(i){return i===P}function d(i){return i>=n&&i<=A||i>=D&&i<=T}function m(i,r,t,s){let o="",c=0,a=-1,u=0,w=0;for(let b=0;b<=i.length;++b){if(b<i.length)w=i.charCodeAt(b);else{if(s(w))break;w=P}if(s(w)){if(!(a===b-1||u===1))if(u===2){if(o.length<2||c!==2||o.charCodeAt(o.length-1)!==R||o.charCodeAt(o.length-2)!==R){if(o.length>2){const U=o.lastIndexOf(t);U===-1?(o="",c=0):(o=o.slice(0,U),c=o.length-1-o.lastIndexOf(t)),a=b,u=0;continue}else if(o.length!==0){o="",c=0,a=b,u=0;continue}}r&&(o+=o.length>0?`${t}..`:"..",c=2)}else o.length>0?o+=`${t}${i.slice(a+1,b)}`:o=i.slice(a+1,b),c=b-a-1;a=b,u=0}else w===R&&u!==-1?++u:u=-1}return o}function v(i,r){g(r,"pathObject");const t=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${s}`:`${t}${i}${s}`:s}e.win32={resolve(...i){let r="",t="",s=!1;for(let o=i.length-1;o>=-1;o--){let c;if(o>=0){if(c=i[o],h(c,"path"),c.length===0)continue}else r.length===0?c=k.cwd():(c=k.env[`=${r}`]||k.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===S)&&(c=`${r}\\`));const a=c.length;let u=0,w="",b=!1;const U=c.charCodeAt(0);if(a===1)f(U)&&(u=1,b=!0);else if(f(U))if(b=!0,f(c.charCodeAt(1))){let N=2,$=N;for(;N<a&&!f(c.charCodeAt(N));)N++;if(N<a&&N!==$){const F=c.slice($,N);for($=N;N<a&&f(c.charCodeAt(N));)N++;if(N<a&&N!==$){for($=N;N<a&&!f(c.charCodeAt(N));)N++;(N===a||N!==$)&&(w=`\\\\${F}\\${c.slice($,N)}`,u=N)}}}else u=1;else d(U)&&c.charCodeAt(1)===C&&(w=c.slice(0,2),u=2,a>2&&f(c.charCodeAt(2))&&(b=!0,u=3));if(w.length>0)if(r.length>0){if(w.toLowerCase()!==r.toLowerCase())continue}else r=w;if(s){if(r.length>0)break}else if(t=`${c.slice(u)}\\${t}`,s=b,b&&r.length>0)break}return t=m(t,!s,"\\",f),s?`${r}\\${t}`:`${r}${t}`||"."},normalize(i){h(i,"path");const r=i.length;if(r===0)return".";let t=0,s,o=!1;const c=i.charCodeAt(0);if(r===1)return l(c)?"\\":i;if(f(c))if(o=!0,f(i.charCodeAt(1))){let u=2,w=u;for(;u<r&&!f(i.charCodeAt(u));)u++;if(u<r&&u!==w){const b=i.slice(w,u);for(w=u;u<r&&f(i.charCodeAt(u));)u++;if(u<r&&u!==w){for(w=u;u<r&&!f(i.charCodeAt(u));)u++;if(u===r)return`\\\\${b}\\${i.slice(w)}\\`;u!==w&&(s=`\\\\${b}\\${i.slice(w,u)}`,t=u)}}}else t=1;else d(c)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),t=2,r>2&&f(i.charCodeAt(2))&&(o=!0,t=3));let a=t<r?m(i.slice(t),!o,"\\",f):"";return a.length===0&&!o&&(a="."),a.length>0&&f(i.charCodeAt(r-1))&&(a+="\\"),s===void 0?o?`\\${a}`:a:o?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){h(i,"path");const r=i.length;if(r===0)return!1;const t=i.charCodeAt(0);return f(t)||r>2&&d(t)&&i.charCodeAt(1)===C&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,t;for(let c=0;c<i.length;++c){const a=i[c];h(a,"path"),a.length>0&&(r===void 0?r=t=a:r+=`\\${a}`)}if(r===void 0)return".";let s=!0,o=0;if(typeof t=="string"&&f(t.charCodeAt(0))){++o;const c=t.length;c>1&&f(t.charCodeAt(1))&&(++o,c>2&&(f(t.charCodeAt(2))?++o:s=!1))}if(s){for(;o<r.length&&f(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.win32.normalize(r)},relative(i,r){if(h(i,"from"),h(r,"to"),i===r)return"";const t=e.win32.resolve(i),s=e.win32.resolve(r);if(t===s||(i=t.toLowerCase(),r=s.toLowerCase(),i===r))return"";let o=0;for(;o<i.length&&i.charCodeAt(o)===S;)o++;let c=i.length;for(;c-1>o&&i.charCodeAt(c-1)===S;)c--;const a=c-o;let u=0;for(;u<r.length&&r.charCodeAt(u)===S;)u++;let w=r.length;for(;w-1>u&&r.charCodeAt(w-1)===S;)w--;const b=w-u,U=a<b?a:b;let N=-1,$=0;for(;$<U;$++){const L=i.charCodeAt(o+$);if(L!==r.charCodeAt(u+$))break;L===S&&(N=$)}if($!==U){if(N===-1)return s}else{if(b>U){if(r.charCodeAt(u+$)===S)return s.slice(u+$+1);if($===2)return s.slice(u+$)}a>U&&(i.charCodeAt(o+$)===S?N=$:$===2&&(N=3)),N===-1&&(N=0)}let F="";for($=o+N+1;$<=c;++$)($===c||i.charCodeAt($)===S)&&(F+=F.length===0?"..":"\\..");return u+=N,F.length>0?`${F}${s.slice(u,w)}`:(s.charCodeAt(u)===S&&++u,s.slice(u,w))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===S){if(r.charCodeAt(1)===S){const t=r.charCodeAt(2);if(t!==E&&t!==R)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(d(r.charCodeAt(0))&&r.charCodeAt(1)===C&&r.charCodeAt(2)===S)return`\\\\?\\${r}`;return i},dirname(i){h(i,"path");const r=i.length;if(r===0)return".";let t=-1,s=0;const o=i.charCodeAt(0);if(r===1)return f(o)?i:".";if(f(o)){if(t=s=1,f(i.charCodeAt(1))){let u=2,w=u;for(;u<r&&!f(i.charCodeAt(u));)u++;if(u<r&&u!==w){for(w=u;u<r&&f(i.charCodeAt(u));)u++;if(u<r&&u!==w){for(w=u;u<r&&!f(i.charCodeAt(u));)u++;if(u===r)return i;u!==w&&(t=s=u+1)}}}}else d(o)&&i.charCodeAt(1)===C&&(t=r>2&&f(i.charCodeAt(2))?3:2,s=t);let c=-1,a=!0;for(let u=r-1;u>=s;--u)if(f(i.charCodeAt(u))){if(!a){c=u;break}}else a=!1;if(c===-1){if(t===-1)return".";c=t}return i.slice(0,c)},basename(i,r){r!==void 0&&h(r,"ext"),h(i,"path");let t=0,s=-1,o=!0,c;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(t=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let a=r.length-1,u=-1;for(c=i.length-1;c>=t;--c){const w=i.charCodeAt(c);if(f(w)){if(!o){t=c+1;break}}else u===-1&&(o=!1,u=c+1),a>=0&&(w===r.charCodeAt(a)?--a===-1&&(s=c):(a=-1,s=u))}return t===s?s=u:s===-1&&(s=i.length),i.slice(t,s)}for(c=i.length-1;c>=t;--c)if(f(i.charCodeAt(c))){if(!o){t=c+1;break}}else s===-1&&(o=!1,s=c+1);return s===-1?"":i.slice(t,s)},extname(i){h(i,"path");let r=0,t=-1,s=0,o=-1,c=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&d(i.charCodeAt(0))&&(r=s=2);for(let u=i.length-1;u>=r;--u){const w=i.charCodeAt(u);if(f(w)){if(!c){s=u+1;break}continue}o===-1&&(c=!1,o=u+1),w===R?t===-1?t=u:a!==1&&(a=1):t!==-1&&(a=-1)}return t===-1||o===-1||a===0||a===1&&t===o-1&&t===s+1?"":i.slice(t,o)},format:v.bind(null,"\\"),parse(i){h(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const t=i.length;let s=0,o=i.charCodeAt(0);if(t===1)return f(o)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(f(o)){if(s=1,f(i.charCodeAt(1))){let N=2,$=N;for(;N<t&&!f(i.charCodeAt(N));)N++;if(N<t&&N!==$){for($=N;N<t&&f(i.charCodeAt(N));)N++;if(N<t&&N!==$){for($=N;N<t&&!f(i.charCodeAt(N));)N++;N===t?s=N:N!==$&&(s=N+1)}}}}else if(d(o)&&i.charCodeAt(1)===C){if(t<=2)return r.root=r.dir=i,r;if(s=2,f(i.charCodeAt(2))){if(t===3)return r.root=r.dir=i,r;s=3}}s>0&&(r.root=i.slice(0,s));let c=-1,a=s,u=-1,w=!0,b=i.length-1,U=0;for(;b>=s;--b){if(o=i.charCodeAt(b),f(o)){if(!w){a=b+1;break}continue}u===-1&&(w=!1,u=b+1),o===R?c===-1?c=b:U!==1&&(U=1):c!==-1&&(U=-1)}return u!==-1&&(c===-1||U===0||U===1&&c===u-1&&c===a+1?r.base=r.name=i.slice(a,u):(r.name=i.slice(a,c),r.base=i.slice(a,u),r.ext=i.slice(c,u))),a>0&&a!==s?r.dir=i.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(y){const i=/\\/g;return()=>{const r=k.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...i){let r="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const o=s>=0?i[s]:I();h(o,"path"),o.length!==0&&(r=`${o}/${r}`,t=o.charCodeAt(0)===P)}return r=m(r,!t,"/",l),t?`/${r}`:r.length>0?r:"."},normalize(i){if(h(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===P,t=i.charCodeAt(i.length-1)===P;return i=m(i,!r,"/",l),i.length===0?r?"/":t?"./":".":(t&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return h(i,"path"),i.length>0&&i.charCodeAt(0)===P},join(...i){if(i.length===0)return".";let r;for(let t=0;t<i.length;++t){const s=i[t];h(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.posix.normalize(r)},relative(i,r){if(h(i,"from"),h(r,"to"),i===r||(i=e.posix.resolve(i),r=e.posix.resolve(r),i===r))return"";const t=1,s=i.length,o=s-t,c=1,a=r.length-c,u=o<a?o:a;let w=-1,b=0;for(;b<u;b++){const N=i.charCodeAt(t+b);if(N!==r.charCodeAt(c+b))break;N===P&&(w=b)}if(b===u)if(a>u){if(r.charCodeAt(c+b)===P)return r.slice(c+b+1);if(b===0)return r.slice(c+b)}else o>u&&(i.charCodeAt(t+b)===P?w=b:b===0&&(w=0));let U="";for(b=t+w+1;b<=s;++b)(b===s||i.charCodeAt(b)===P)&&(U+=U.length===0?"..":"/..");return`${U}${r.slice(c+w)}`},toNamespacedPath(i){return i},dirname(i){if(h(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===P;let t=-1,s=!0;for(let o=i.length-1;o>=1;--o)if(i.charCodeAt(o)===P){if(!s){t=o;break}}else s=!1;return t===-1?r?"/":".":r&&t===1?"//":i.slice(0,t)},basename(i,r){r!==void 0&&h(r,"ext"),h(i,"path");let t=0,s=-1,o=!0,c;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let a=r.length-1,u=-1;for(c=i.length-1;c>=0;--c){const w=i.charCodeAt(c);if(w===P){if(!o){t=c+1;break}}else u===-1&&(o=!1,u=c+1),a>=0&&(w===r.charCodeAt(a)?--a===-1&&(s=c):(a=-1,s=u))}return t===s?s=u:s===-1&&(s=i.length),i.slice(t,s)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===P){if(!o){t=c+1;break}}else s===-1&&(o=!1,s=c+1);return s===-1?"":i.slice(t,s)},extname(i){h(i,"path");let r=-1,t=0,s=-1,o=!0,c=0;for(let a=i.length-1;a>=0;--a){const u=i.charCodeAt(a);if(u===P){if(!o){t=a+1;break}continue}s===-1&&(o=!1,s=a+1),u===R?r===-1?r=a:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||s===-1||c===0||c===1&&r===s-1&&r===t+1?"":i.slice(r,s)},format:v.bind(null,"/"),parse(i){h(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const t=i.charCodeAt(0)===P;let s;t?(r.root="/",s=1):s=0;let o=-1,c=0,a=-1,u=!0,w=i.length-1,b=0;for(;w>=s;--w){const U=i.charCodeAt(w);if(U===P){if(!u){c=w+1;break}continue}a===-1&&(u=!1,a=w+1),U===R?o===-1?o=w:b!==1&&(b=1):o!==-1&&(b=-1)}if(a!==-1){const U=c===0&&t?1:c;o===-1||b===0||b===1&&o===a-1&&o===c+1?r.base=r.name=i.slice(U,a):(r.name=i.slice(U,o),r.base=i.slice(U,a),r.ext=i.slice(o,a))}return c>0?r.dir=i.slice(0,c-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(oe[139],ae([0,1,12]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const E=(0,k.extname)(C),p=n[E.toLowerCase()];return p!==void 0?p:T(C)}e.getMediaOrTextMime=A;function T(C){const E=(0,k.extname)(C);return D[E.toLowerCase()]}e.getMediaMime=T;function R(C){for(const E in D)if(D[E]===C)return E}e.getExtensionForMimeType=R;const P=/^(.+)\/(.+?)(;.+)?$/;function S(C,E){const p=P.exec(C);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:E?void 0:C}e.normalizeMimeType=S}),define(oe[87],ae([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(R,...P){const S=P.reduce((p,g)=>(p[g]=!0,p),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(p=>!S[p]).forEach(p=>{for(let g=0;g<C.length;g++)if(p.search(C[g])!==-1){delete R[p];break}})}e.sanitizeProcessEnvironment=A;function T(R){!R||(delete R.DEBUG,k.isMacintosh&&delete R.DYLD_LIBRARY_PATH,k.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(oe[140],ae([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=k.globals.performance&&typeof k.globals.performance.now=="function";class D{static create(T=!0){return new D(T)}constructor(T){this.a=n&&T,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?k.globals.performance.now():Date.now()}}e.StopWatch=D}),define(oe[3],ae([0,1,9,82,2,84,140]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,P=!1;var S;(function(c){c.None=()=>D.Disposable.None;function a(B){if(P){const{onDidAddListener:x}=B,ie=h.create();let J=0;B.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),x?.()}}}function u(B,x){return z(B,()=>{},0,void 0,void 0,x)}c.defer=u;function w(B){return(x,ie=null,J)=>{let _=!1,se;return se=B(ue=>{if(!_)return se?se.dispose():_=!0,x.call(ie,ue)},null,J),_&&se.dispose(),se}}c.once=w;function b(B,x,ie){return j((J,_=null,se)=>B(ue=>J.call(_,x(ue)),null,se),ie)}c.map=b;function U(B,x,ie){return j((J,_=null,se)=>B(ue=>{x(ue),J.call(_,ue)},null,se),ie)}c.forEach=U;function N(B,x,ie){return j((J,_=null,se)=>B(ue=>x(ue)&&J.call(_,ue),null,se),ie)}c.filter=N;function $(B){return B}c.signal=$;function F(...B){return(x,ie=null,J)=>(0,D.combinedDisposable)(...B.map(_=>_(se=>x.call(ie,se),null,J)))}c.any=F;function L(B,x,ie,J){let _=ie;return b(B,se=>(_=x(_,se),_),J)}c.reduce=L;function j(B,x){let ie;const J={onWillAddFirstListener(){ie=B(_.fire,_)},onDidRemoveLastListener(){ie?.dispose()}};x||a(J);const _=new f(J);return x?.add(_),_.event}function z(B,x,ie=100,J=!1,_,se){let ue,le,ye,Se=0;const be={leakWarningThreshold:_,onWillAddFirstListener(){ue=B(Ne=>{Se++,le=x(le,Ne),J&&!ye&&(Ee.fire(le),le=void 0),clearTimeout(ye),ye=setTimeout(()=>{const Fe=le;le=void 0,ye=void 0,(!J||Se>1)&&Ee.fire(Fe),Se=0},ie)})},onDidRemoveLastListener(){ue.dispose()}};se||a(be);const Ee=new f(be);return se?.add(Ee),Ee.event}c.debounce=z;function V(B,x=0,ie){return c.debounce(B,(J,_)=>J?(J.push(_),J):[_],x,void 0,void 0,ie)}c.accumulate=V;function Q(B,x=(J,_)=>J===_,ie){let J=!0,_;return N(B,se=>{const ue=J||!x(se,_);return J=!1,_=se,ue},ie)}c.latch=Q;function Y(B,x,ie){return[c.filter(B,x,ie),c.filter(B,J=>!x(J),ie)]}c.split=Y;function H(B,x=!1,ie=[]){let J=ie.slice(),_=B(le=>{J?J.push(le):ue.fire(le)});const se=()=>{J?.forEach(le=>ue.fire(le)),J=null},ue=new f({onWillAddFirstListener(){_||(_=B(le=>ue.fire(le)))},onDidAddFirstListener(){J&&(x?setTimeout(se):se())},onDidRemoveLastListener(){_&&_.dispose(),_=null}});return ue.event}c.buffer=H;class q{constructor(x){this.event=x,this.c=new D.DisposableStore}map(x){return new q(b(this.event,x,this.c))}forEach(x){return new q(U(this.event,x,this.c))}filter(x){return new q(N(this.event,x,this.c))}reduce(x,ie){return new q(L(this.event,x,ie,this.c))}latch(){return new q(Q(this.event,void 0,this.c))}debounce(x,ie=100,J=!1,_){return new q(z(this.event,x,ie,J,_,this.c))}on(x,ie,J){return this.event(x,ie,J)}once(x,ie,J){return w(this.event)(x,ie,J)}dispose(){this.c.dispose()}}function G(B){return new q(B)}c.chain=G;function X(B,x,ie=J=>J){const J=(...le)=>ue.fire(ie(...le)),_=()=>B.on(x,J),se=()=>B.removeListener(x,J),ue=new f({onWillAddFirstListener:_,onDidRemoveLastListener:se});return ue.event}c.fromNodeEventEmitter=X;function ee(B,x,ie=J=>J){const J=(...le)=>ue.fire(ie(...le)),_=()=>B.addEventListener(x,J),se=()=>B.removeEventListener(x,J),ue=new f({onWillAddFirstListener:_,onDidRemoveLastListener:se});return ue.event}c.fromDOMEventEmitter=ee;function re(B){return new Promise(x=>w(B)(x))}c.toPromise=re;function te(B,x){return x(void 0),B(ie=>x(ie))}c.runAndSubscribe=te;function O(B,x){let ie=null;function J(se){ie?.dispose(),ie=new D.DisposableStore,x(se,ie)}J(void 0);const _=B(se=>J(se));return(0,D.toDisposable)(()=>{_.dispose(),ie?.dispose()})}c.runAndSubscribeWithStore=O;class M{constructor(x,ie){this.obs=x,this.c=0,this.d=!1;const J={onWillAddFirstListener:()=>{x.addObserver(this)},onDidRemoveLastListener:()=>{x.removeObserver(this)}};ie||a(J),this.emitter=new f(J),ie&&ie.add(this.emitter)}beginUpdate(x){this.c++}handleChange(x,ie){this.d=!0}endUpdate(x){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(B,x){return new M(B,x).emitter.event}c.fromObservable=W})(S=e.Event||(e.Event={}));class C{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${C.c++}`,C.all.add(this)}start(a){this.d=new T.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=C,C.all=new Set,C.c=0;let E=-1;function p(c){const a=E;return E=c,{dispose(){E=a}}}e.setGlobalLeakWarningThreshold=p;class g{constructor(a,u=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=u,this.d=0}dispose(){this.c?.clear()}check(a,u){const w=this.threshold;if(w<=0||u<w)return;this.c||(this.c=new Map);const b=this.c.get(a.value)||0;if(this.c.set(a.value,b+1),this.d-=1,this.d<=0){this.d=w*.5;let U,N=0;for(const[$,F]of this.c)(!U||N<F)&&(U=$,N=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${N}):`),console.warn(U)}return()=>{const U=this.c.get(a.value)||0;this.c.set(a.value,U-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(a,u,w){this.callback=a,this.callbackThis=u,this.stack=w,this.subscription=new D.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class f{constructor(a){this.j=!1,this.d=a,this.f=E>0||this.d?.leakWarningThreshold?new g(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const a=Array.from(this.q);queueMicrotask(()=>{for(const u of a)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,u,w)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const b=this.q.isEmpty();b&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let U,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=h.create(),U=this.f.check(N,this.q.size+1)),R&&(N=N??h.create());const $=new y(a,u,N),F=this.q.push($);b&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,u);const L=$.subscription.set(()=>{U?.(),this.j||(F(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return w instanceof D.DisposableStore?w.add(L):Array.isArray(w)&&w.push(L),L}),this.l}fire(a){if(this.q){this.m||(this.m=new d);for(const u of this.q)this.m.push(this,u,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=f;class l{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(a,u,w){this.c.push(new m(a,u,w))}clear(a){const u=new A.LinkedList;for(const w of this.c)w.emitter!==a&&u.push(w);this.c=u}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(u){(0,k.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=l;class d extends l{clear(a){this.c.clear()}}class m{constructor(a,u,w){this.emitter=a,this.listener=u,this.event=w}}class v extends f{async fireAsync(a,u,w){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const b of this.q)this.c.push([b,a]);for(;this.c.size>0&&!u.isCancellationRequested;){const[b,U]=this.c.shift(),N=[],$={...U,token:u,waitUntil:F=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");w&&(F=w(F,b.callback)),N.push(F)}};try{b.invoke($)}catch(F){(0,k.onUnexpectedError)(F);continue}Object.freeze(N),await Promise.allSettled(N).then(F=>{for(const L of F)L.status==="rejected"&&(0,k.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=v;class I extends f{constructor(a){super(a),this.h=0,this.s=new A.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=I;class i extends I{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=i;class r extends f{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new f({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const u={event:a,listener:null};this.f.push(u),this.d&&this.j(u);const w=()=>{this.d&&this.k(u);const b=this.f.indexOf(u);this.f.splice(b,1)};return(0,D.toDisposable)((0,n.once)(w))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(u=>this.c.fire(u))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class s{constructor(){this.c=[]}wrapEvent(a){return(u,w,b)=>a(U=>{const N=this.c[this.c.length-1];N?N.push(()=>u.call(w,U)):u.call(w,U)},void 0,b)}bufferEvents(a){const u=[];this.c.push(u);const w=a();return this.c.pop(),u.forEach(b=>b()),w}}e.EventBufferer=s;class o{constructor(){this.c=!1,this.d=S.None,this.f=D.Disposable.None,this.g=new f({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(oe[23],ae([0,1,3]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,P){const S=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(S)}}});var D;(function(R){function P(S){return S===R.None||S===R.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new k.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(P){this.a=void 0,this.b=void 0,this.b=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=D.Cancelled}dispose(P=!1){P&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=D.None}}e.CancellationTokenSource=T}),define(oe[141],ae([0,1,23]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new k.CancellationTokenSource,P=this.b(R.token);return this.a={promise:P,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=n;class D{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const P=JSON.stringify(R);return this.b!==P&&(this.b=P,this.a=this.c(R)),this.a}}e.LRUCachedFunction=D;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const P=this.b(R);return this.a.set(R,P),P}}e.CachedFunction=A}),define(oe[27],ae([0,1,141,127]),function(Z,e,k,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=A;const T=/{(\d+)}/g;function R(ne,...he){return he.length===0?ne:ne.replace(T,function(fe,me){const we=parseInt(me,10);return isNaN(we)||we<0||we>=he.length?fe:he[we]})}e.format=R;const P=/{([^}]+)}/g;function S(ne,he){return ne.replace(P,(fe,me)=>he[me]??fe)}e.format2=S;function C(ne){return ne.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=C;function E(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function p(ne,he){let fe=0;const me=he.charCodeAt(0);for(let we=ne.length-1;we>=0;we--)ne.charCodeAt(we)===me&&fe++;return fe}e.count=p;function g(ne,he,fe="\u2026"){return ne.length<=he?ne:`${ne.substr(0,he)}${fe}`}e.truncate=g;function h(ne,he=" "){const fe=y(ne,he);return f(fe,he)}e.trim=h;function y(ne,he){if(!ne||!he)return ne;const fe=he.length;if(fe===0||ne.length===0)return ne;let me=0;for(;ne.indexOf(he,me)===me;)me=me+fe;return ne.substring(me)}e.ltrim=y;function f(ne,he){if(!ne||!he)return ne;const fe=he.length,me=ne.length;if(fe===0||me===0)return ne;let we=me,Ie=-1;for(;Ie=ne.lastIndexOf(he,we-1),!(Ie===-1||Ie+fe!==we);){if(Ie===0)return"";we=Ie}return ne.substring(0,we)}e.rtrim=f;function l(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function d(ne){return ne.replace(/\*/g,"")}e.stripWildcards=d;function m(ne,he,fe={}){if(!ne)throw new Error("Cannot create regex from empty string");he||(ne=E(ne)),fe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(ne,me)}e.createRegExp=m;function v(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function I(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function i(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=i;function r(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ne){for(let he=0,fe=ne.length;he<fe;he++){const me=ne.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function s(ne,he=0,fe=ne.length){for(let me=he;me<fe;me++){const we=ne.charCodeAt(me);if(we!==32&&we!==9)return ne.substring(he,me)}return ne.substring(he,fe)}e.getLeadingWhitespace=s;function o(ne,he=ne.length-1){for(let fe=he;fe>=0;fe--){const me=ne.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=o;function c(ne,he,fe){const me=[];let we=0;for(const Ie of ne.matchAll(he)){if(me.push(ne.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,ne,Ie.groups))}return me.push(ne.slice(we)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=c;function a(ne,he){return ne<he?-1:ne>he?1:0}e.compare=a;function u(ne,he,fe=0,me=ne.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){const $e=ne.charCodeAt(fe),Le=he.charCodeAt(we);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstring=u;function w(ne,he){return b(ne,he,0,ne.length,0,he.length)}e.compareIgnoreCase=w;function b(ne,he,fe=0,me=ne.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){let $e=ne.charCodeAt(fe),Le=he.charCodeAt(we);if($e===Le)continue;if($e>=128||Le>=128)return u(ne.toLowerCase(),he.toLowerCase(),fe,me,we,Ie);N($e)&&($e-=32),N(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=b;function U(ne){return ne>=48&&ne<=57}e.isAsciiDigit=U;function N(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=N;function $(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=$;function F(ne,he){return ne.length===he.length&&b(ne,he)===0}e.equalsIgnoreCase=F;function L(ne,he){const fe=he.length;return he.length>ne.length?!1:b(ne,he,0,fe)===0}e.startsWithIgnoreCase=L;function j(ne,he){const fe=Math.min(ne.length,he.length);let me;for(me=0;me<fe;me++)if(ne.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=j;function z(ne,he){const fe=Math.min(ne.length,he.length);let me;const we=ne.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(ne.charCodeAt(we-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=z;function V(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=V;function Q(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=Q;function Y(ne,he){return(ne-55296<<10)+(he-56320)+65536}e.computeCodePoint=Y;function H(ne,he,fe){const me=ne.charCodeAt(fe);if(V(me)&&fe+1<he){const we=ne.charCodeAt(fe+1);if(Q(we))return Y(me,we)}return me}e.getNextCodePoint=H;function q(ne,he){const fe=ne.charCodeAt(he-1);if(Q(fe)&&he>1){const me=ne.charCodeAt(he-2);if(V(me))return Y(me,fe)}return fe}class G{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=q(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=H(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=G;class X{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new G(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(we,Re)){fe.setOffset(Ie);break}we=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,we)){fe.setOffset(Ie);break}we=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=X;function ee(ne,he){return new X(ne,he).nextGraphemeLength()}e.nextCharLength=ee;function re(ne,he){return new X(ne,he).prevGraphemeLength()}e.prevCharLength=re;function te(ne,he){he>0&&Q(ne.charCodeAt(he))&&he--;const fe=he+ee(ne,he);return[fe-re(ne,fe),fe]}e.getCharContainingOffset=te;function O(ne){const he=new X(ne);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=O;let M;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(ne){return M||(M=W()),M.test(ne)}e.containsRTL=B;const x=/^[\t\n\r\x20-\x7E]*$/;function ie(ne){return x.test(ne)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=J;function _(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=_;function se(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=se;function ue(ne,he){if(ne.length<he)return ne;const fe=/\b/g;let me=0;for(;fe.test(ne)&&!(ne.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return ne.substring(me).replace(/^\s/,"")}e.lcut=ue;const le=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function be(ne){return ne&&(ne=ne.replace(le,""),ne=ne.replace(ye,""),ne=ne.replace(Se,"")),ne}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ne(ne){return Ee(ne)?ne.substr(1):ne}e.stripUTF8BOM=Ne;function Fe(ne,he){if(!ne||!he||ne.length<he.length)return!1;const fe=he.length,me=ne.toLowerCase();let we=0,Ie=-1;for(;we<fe;){const Re=me.indexOf(he[we],Ie+1);if(Re<0)return!1;Ie=Re,we++}return!0}e.fuzzyContains=Fe;function Ye(ne,he=!1){return ne?(he&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Ye;function ze(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ze;function ce(ne,he=1){if(he===0)return"";let fe=-1;do fe=ne.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?ne:(ne[fe-1]==="\r"&&fe--,ne.substr(0,fe))}e.getNLines=ce;function de(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=de;function ge(ne){return Ae.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ge;function Ce(ne,he){return ne===0?he!==5&&he!==7:ne===2&&he===3?!1:ne===4||ne===2||ne===3||he===4||he===2||he===3?!0:!(ne===8&&(he===8||he===9||he===11||he===12)||(ne===11||ne===9)&&(he===9||he===10)||(ne===12||ne===10)&&he===10||he===5||he===13||he===7||ne===1||ne===13&&he===14||ne===6&&he===6)}var Pe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let we=1;for(;we<=me;)if(he<fe[3*we])we=2*we;else if(he>fe[3*we+1])we=2*we+1;else return fe[3*we+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ne,he){if(ne===0)return 0;const fe=Te(ne,he);if(fe!==void 0)return fe;const me=new G(he,ne);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Te(ne,he){const fe=new G(he,ne);let me=fe.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!se(me))return;let we=fe.offset;return we>0&&fe.prevCodePoint()===8205&&(we=fe.offset),we}function Me(ne){return 127995<=ne&&ne<=127999}var Be;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.getValue()}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,D=ke,ke.c=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new k.LRUCachedFunction(ne=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,ot]of qe)Ge.set(et,ot);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,ot]of Le)qe.has(et)&&Ge.set(et,ot);return Ge}const we=D.c.getValue();let Ie=ne.filter(Le=>!Le.startsWith("_")&&Le in we);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(we[Le]);Re=me(Re,qe)}const He=he(we._common),$e=fe(He,Re);return new ke($e)}),ke.e=new n.Lazy(()=>Object.keys(ke.c.getValue()).filter(ne=>!ne.startsWith("_")));class Oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Oe.c())),this.d}static isInvisibleCharacter(he){return Oe.e().has(he)}static get codePoints(){return Oe.e()}}e.InvisibleCharacters=Oe,Oe.d=void 0}),define(oe[48],ae([0,1,12,5,27,14]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function R(o){return o.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function P(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=P;function S(o,c=k.posix.sep){if(!o)return"";const a=o.length,u=o.charCodeAt(0);if(T(u)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let b=3;const U=b;for(;b<a&&!T(o.charCodeAt(b));b++);if(U!==b&&!T(o.charCodeAt(b+1))){for(b+=1;b<a;b++)if(T(o.charCodeAt(b)))return o.slice(0,b+1).replace(/[\\/]/g,c)}}return c}else if(l(u)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let w=o.indexOf("://");if(w!==-1){for(w+=3;w<a;w++)if(T(o.charCodeAt(w)))return o.slice(0,w+1)}return""}e.getRoot=S;function C(o){if(!n.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let a=2;const u=a;for(;a<o.length&&(c=o.charCodeAt(a),c!==92);a++);return!(u===a||(c=o.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=C;const E=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,c=n.isWindows){const a=c?E:p;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||c&&g.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function y(o,c,a){const u=o===c;return!a||u?u:!o||!c?!1:(0,D.equalsIgnoreCase)(o,c)}e.isEqual=y;function f(o,c,a,u=k.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let b=c.length;return c.charAt(c.length-1)===u&&b--,o.charAt(b)===u}return c.charAt(c.length-1)!==u&&(c+=u),o.indexOf(c)===0}e.isEqualOrParent=f;function l(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=l;function d(o,c){return n.isWindows&&o.endsWith(":")&&(o+=k.sep),(0,k.isAbsolute)(o)||(o=(0,k.join)(c,o)),o=(0,k.normalize)(o),n.isWindows?(o=(0,D.rtrim)(o,k.sep),o.endsWith(":")&&(o+=k.sep)):(o=(0,D.rtrim)(o,k.sep),o||(o=k.sep)),o}e.sanitizeFilePath=d;function m(o){const c=(0,k.normalize)(o);return n.isWindows?o.length>3?!1:v(c)&&(o.length===2||c.charCodeAt(2)===92):c===k.posix.sep}e.isRootOrDriveLetter=m;function v(o,c=n.isWindows){return c?l(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function I(o){return v(o)?o[0]:void 0}e.getDriveLetter=I;function i(o,c,a){return c.length>o.length?-1:o===c?0:(a&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=i;function r(o){const c=o.split(":");let a,u,w;for(const b of c){const U=Number(b);(0,A.isNumber)(U)?u===void 0?u=U:w===void 0&&(w=U):a=a?[a,b].join(":"):b}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:w!==void 0?w:u!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(o,c,a=8){let u="";for(let b=0;b<a;b++)u+=t.charAt(Math.floor(Math.random()*t.length));let w;return c?w=`${c}-${u}`:w=u,o?(0,k.join)(o,w):w}e.randomPath=s}),define(oe[66],ae([0,1,27]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(l){return D(l,0)}e.hash=n;function D(l,d){switch(typeof l){case"object":return l===null?A(349,d):Array.isArray(l)?P(l,d):S(l,d);case"string":return R(l,d);case"boolean":return T(l,d);case"number":return A(l,d);case"undefined":return A(937,d);default:return A(617,d)}}e.doHash=D;function A(l,d){return(d<<5)-d+l|0}e.numberHash=A;function T(l,d){return A(l?433:863,d)}function R(l,d){d=A(149417,d);for(let m=0,v=l.length;m<v;m++)d=A(l.charCodeAt(m),d);return d}e.stringHash=R;function P(l,d){return d=A(104579,d),l.reduce((m,v)=>D(v,m),d)}function S(l,d){return d=A(181387,d),Object.keys(l).sort().reduce((m,v)=>(m=R(v,m),D(l[v],m)),d)}class C{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=D(d,this.g),this.g}}e.Hasher=C;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function p(l,d,m=32){const v=m-d,I=~((1<<v)-1);return(l<<d|(I&l)>>>v)>>>0}function g(l,d=0,m=l.byteLength,v=0){for(let I=0;I<m;I++)l[d+I]=v}function h(l,d,m="0"){for(;l.length<d;)l=m+l;return l}function y(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(m=>m.toString(16).padStart(2,"0")).join(""):h((l>>>0).toString(16),d/4)}e.toHexString=y;class f{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const m=d.length;if(m===0)return;const v=this.p;let I=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=d.charCodeAt(0),t=0);;){let s=r;if(k.isHighSurrogate(r))if(t+1<m){const o=d.charCodeAt(t+1);k.isLowSurrogate(o)?(t++,s=k.computeCodePoint(r,o)):s=65533}else{i=r;break}else k.isLowSurrogate(r)&&(s=65533);if(I=this.w(v,I,s),t++,t<m)r=d.charCodeAt(t);else break}this.r=I,this.u=i}w(d,m,v){return v<128?d[m++]=v:v<2048?(d[m++]=192|(v&1984)>>>6,d[m++]=128|(v&63)>>>0):v<65536?(d[m++]=224|(v&61440)>>>12,d[m++]=128|(v&4032)>>>6,d[m++]=128|(v&63)>>>0):(d[m++]=240|(v&1835008)>>>18,d[m++]=128|(v&258048)>>>12,d[m++]=128|(v&4032)>>>6,d[m++]=128|(v&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=f.g,m=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,p(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let v=this.h,I=this.l,i=this.m,r=this.n,t=this.o,s,o,c;for(let a=0;a<80;a++)a<20?(s=I&i|~I&r,o=1518500249):a<40?(s=I^i^r,o=1859775393):a<60?(s=I&i|I&r|i&r,o=2400959708):(s=I^i^r,o=3395469782),c=p(v,5)+s+t+o+d.getUint32(a*4,!1)&4294967295,t=r,r=i,i=p(I,30),I=v,v=c;this.h=this.h+v&4294967295,this.l=this.l+I&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=f,f.g=new DataView(new ArrayBuffer(320))}),define(oe[88],ae([0,1,27]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(n||(n={})),function(D){const A="error",T="warning",R="warn",P="info",S="ignore";function C(p){return p?k.equalsIgnoreCase(A,p)?D.Error:k.equalsIgnoreCase(T,p)||k.equalsIgnoreCase(R,p)?D.Warning:k.equalsIgnoreCase(P,p)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function E(p){switch(p){case D.Error:return A;case D.Warning:return T;case D.Info:return P;default:return S}}D.toString=E}(n||(n={})),e.default=n}),define(oe[49],ae([0,1,21,27]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const h=g.charCodeAt(0),y=this.b.charCodeAt(this.c);return h-y}value(){return this.b[this.c]}}e.StringIterator=D;class A{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,n.compareSubstring)(g,this.b,0,g.length,this.c,this.d):(0,n.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class T{constructor(g=!0,h=!0){this.f=g,this.g=h}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let h=g.length-1;h>=0;h--,this.c--){const y=this.b.charCodeAt(h);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,n.compareSubstring)(g,this.b,0,g.length,this.d,this.e):(0,n.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=T;var R;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(g,h){this.f=g,this.g=h,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new T(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,n.compareIgnoreCase)(g,this.c.scheme);if(this.d[this.e]===2)return(0,n.compareIgnoreCase)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,n.compare)(g,this.c.query);if(this.d[this.e]===5)return(0,n.compare)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=P;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(C||(C={}));class E{static forUris(g=()=>!1,h=()=>!1){return new E(new P(g,h))}static forPaths(g=!1){return new E(new T(void 0,!g))}static forStrings(){return new E(new D)}static forConfigKeys(){return new E(new A)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,h){if(h){const y=h.slice(0);(0,k.shuffle)(y);for(const f of y)this.set(f,g)}else{const y=g.slice(0);(0,k.shuffle)(y);for(const f of y)this.set(f[0],f[1])}}set(g,h){const y=this.b.reset(g);let f;this.c||(this.c=new S,this.c.segment=y.value());const l=[];for(f=this.c;;){const m=y.cmp(f.segment);if(m>0)f.left||(f.left=new S,f.left.segment=y.value()),l.push([-1,f]),f=f.left;else if(m<0)f.right||(f.right=new S,f.right.segment=y.value()),l.push([1,f]),f=f.right;else if(y.hasNext())y.next(),f.mid||(f.mid=new S,f.mid.segment=y.value()),l.push([0,f]),f=f.mid;else break}const d=f.value;f.value=h,f.key=g;for(let m=l.length-1;m>=0;m--){const v=l[m][1];v.updateHeight();const I=v.balanceFactor();if(I<-1||I>1){const i=l[m][0],r=l[m+1][0];if(i===1&&r===1)l[m][1]=v.rotateLeft();else if(i===-1&&r===-1)l[m][1]=v.rotateRight();else if(i===1&&r===-1)v.right=l[m+1][1]=l[m+1][1].rotateRight(),l[m][1]=v.rotateLeft();else if(i===-1&&r===1)v.left=l[m+1][1]=l[m+1][1].rotateLeft(),l[m][1]=v.rotateRight();else throw new Error;if(m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this.c=l[0][1]}}return d}get(g){return this.d(g)?.value}d(g){const h=this.b.reset(g);let y=this.c;for(;y;){const f=h.cmp(y.segment);if(f>0)y=y.left;else if(f<0)y=y.right;else if(h.hasNext())h.next(),y=y.mid;else break}return y}has(g){const h=this.d(g);return!(h?.value===void 0&&h?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,h){const y=this.b.reset(g),f=[];let l=this.c;for(;l;){const d=y.cmp(l.segment);if(d>0)f.push([-1,l]),l=l.left;else if(d<0)f.push([1,l]),l=l.right;else if(y.hasNext())y.next(),f.push([0,l]),l=l.mid;else break}if(!!l){if(h?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this.f(l.right);if(d.key){const{key:m,value:v,segment:I}=d;this.e(d.key,!1),l.key=m,l.value=v,l.segment=I}}else{const d=l.left??l.right;if(f.length>0){const[m,v]=f[f.length-1];switch(m){case-1:v.left=d;break;case 0:v.mid=d;break;case 1:v.right=d;break}}else this.c=d}for(let d=f.length-1;d>=0;d--){const m=f[d][1];m.updateHeight();const v=m.balanceFactor();if(v>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),f[d][1]=m.rotateLeft()):v<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),f[d][1]=m.rotateRight()),d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this.c=f[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const h=this.b.reset(g);let y=this.c,f;for(;y;){const l=h.cmp(y.segment);if(l>0)y=y.left;else if(l<0)y=y.right;else if(h.hasNext())h.next(),f=y.value||f,y=y.mid;else break}return y&&y.value||f}findSuperstr(g){return this.g(g,!1)}g(g,h){const y=this.b.reset(g);let f=this.c;for(;f;){const l=y.cmp(f.segment);if(l>0)f=f.left;else if(l<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else return f.mid?this.h(f.mid):h?f.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[h,y]of this)g(y,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const h=[];return this.j(g,h),h[Symbol.iterator]()}j(g,h){!g||(g.left&&this.j(g.left,h),g.value&&h.push([g.key,g.value]),g.mid&&this.j(g.mid,h),g.right&&this.j(g.right,h))}_isBalanced(){const g=h=>{if(!h)return!0;const y=h.balanceFactor();return y<-1||y>1?!1:g(h.left)&&g(h.right)};return g(this.c)}}e.TernarySearchTree=E}),define(oe[7],ae([0,1,12,5]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function R(t,s){if(!t.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,s){return!t&&!s?"file":t}function S(t,s){switch(t){case"https":case"http":case"file":s?s[0]!==E&&(s=E+s):s=E;break}return s}const C="",E="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,c,a,u,w=!1){typeof s=="object"?(this.scheme=s.scheme||C,this.authority=s.authority||C,this.path=s.path||C,this.query=s.query||C,this.fragment=s.fragment||C):(this.scheme=P(s,w),this.authority=o||C,this.path=S(this.scheme,c||C),this.query=a||C,this.fragment=u||C,R(this,w))}get fsPath(){return m(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:c,path:a,query:u,fragment:w}=s;return o===void 0?o=this.scheme:o===null&&(o=C),c===void 0?c=this.authority:c===null&&(c=C),a===void 0?a=this.path:a===null&&(a=C),u===void 0?u=this.query:u===null&&(u=C),w===void 0?w=this.fragment:w===null&&(w=C),o===this.scheme&&c===this.authority&&a===this.path&&u===this.query&&w===this.fragment?this:new y(o,c,a,u,w)}static parse(s,o=!1){const c=p.exec(s);return c?new y(c[2]||C,r(c[4]||C),r(c[5]||C),r(c[7]||C),r(c[9]||C),o):new y(C,C,C,C,C)}static file(s){let o=C;if(n.isWindows&&(s=s.replace(/\\/g,E)),s[0]===E&&s[1]===E){const c=s.indexOf(E,2);c===-1?(o=s.substring(2),s=E):(o=s.substring(2,c),s=s.substring(c)||E)}return new y("file",o,s,C,C)}static from(s){const o=new y(s.scheme,s.authority,s.path,s.query,s.fragment);return R(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return n.isWindows&&s.scheme==="file"?c=g.file(k.win32.join(m(s,!0),...o)).path:c=k.posix.join(s.path,...o),s.with({path:c})}toString(s=!1){return v(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const o=new y(s);return o._formatted=s.external,o._fsPath=s._sep===h?s.fsPath:null,o}}else return s}}e.URI=g;const h=n.isWindows?1:void 0;class y extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(s=!1){return s?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(t,s,o){let c,a=-1;for(let u=0;u<t.length;u++){const w=t.charCodeAt(u);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||s&&w===47||o&&w===91||o&&w===93||o&&w===58)a!==-1&&(c+=encodeURIComponent(t.substring(a,u)),a=-1),c!==void 0&&(c+=t.charAt(u));else{c===void 0&&(c=t.substr(0,u));const b=f[w];b!==void 0?(a!==-1&&(c+=encodeURIComponent(t.substring(a,u)),a=-1),c+=b):a===-1&&(a=u)}}return a!==-1&&(c+=encodeURIComponent(t.substring(a))),c!==void 0?c:t}function d(t){let s;for(let o=0;o<t.length;o++){const c=t.charCodeAt(o);c===35||c===63?(s===void 0&&(s=t.substr(0,o)),s+=f[c]):s!==void 0&&(s+=t[o])}return s!==void 0?s:t}function m(t,s){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?s?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=m;function v(t,s){const o=s?d:l;let c="",{scheme:a,authority:u,path:w,query:b,fragment:U}=t;if(a&&(c+=a,c+=":"),(u||a==="file")&&(c+=E,c+=E),u){let N=u.indexOf("@");if(N!==-1){const $=u.substr(0,N);u=u.substr(N+1),N=$.lastIndexOf(":"),N===-1?c+=o($,!1,!1):(c+=o($.substr(0,N),!1,!1),c+=":",c+=o($.substr(N+1),!1,!0)),c+="@"}u=u.toLowerCase(),N=u.lastIndexOf(":"),N===-1?c+=o(u,!1,!0):(c+=o(u.substr(0,N),!1,!0),c+=u.substr(N))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const N=w.charCodeAt(1);N>=65&&N<=90&&(w=`/${String.fromCharCode(N+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const N=w.charCodeAt(0);N>=65&&N<=90&&(w=`${String.fromCharCode(N+32)}:${w.substr(2)}`)}c+=o(w,!0,!1)}return b&&(c+="?",c+=o(b,!1,!1)),U&&(c+="#",c+=s?U:l(U,!1,!1)),c}function I(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+I(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(i)?t.replace(i,s=>I(s)):t}}),define(oe[142],ae([0,1,7]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(S){const C=S;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=n;function D(S){const C=[];let E;try{const p=JSON.parse(S.arguments),g=p[p.length-1];g&&g.__$stack&&(p.pop(),E=g.__$stack),C.push(...p)}catch{C.push("Unable to log remote console arguments",S.arguments)}return{args:C,stack:E}}e.parse=D;function A(S){if(typeof S!="string")return A(D(S).stack);const C=S;if(C){const E=T(C),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(p&&p.length===4)return{uri:k.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=A;function T(S){if(!S)return S;const C=S.indexOf(`
`);return C===-1?S:S.substring(0,C)}function R(S,C){const{args:E,stack:p}=D(S),g=typeof E[0]=="string"&&E.length===1;let h=T(p);h&&(h=`(${h.trim()})`);let y=[];if(typeof E[0]=="string"?h&&g?y=[`%c[${C}] %c${E[0]} %c${h}`,P("blue"),P(""),P("grey")]:y=[`%c[${C}] %c${E[0]}`,P("blue"),P(""),...E.slice(1)]:y=[`%c[${C}]%`,P("blue"),...E],h&&!g&&y.push(h),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,y)}e.log=R;function P(S){return`color: ${S}`}}),define(oe[67],ae([0,1,17,27,7]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(S){return JSON.stringify(S,R)}e.stringify=A;function T(S){let C=JSON.parse(S);return C=P(C),C}e.parse=T;function R(S,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function P(S,C=0){if(!S||C>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return D.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof k.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let E=0;E<S.length;++E)S[E]=P(S[E],C+1);else for(const E in S)Object.hasOwnProperty.call(S,E)&&(S[E]=P(S[E],C+1))}return S}e.revive=P}),define(oe[24],ae([0,1,5,7]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls",P.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${D.vscodeRemoteResource}`}set(S,C,E){this.a[S]=C,this.b[S]=E}setConnectionToken(S,C){this.c[S]=C}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)return this.e(S);const C=S.authority;let E=this.a[C];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const p=this.b[C],g=this.c[C];let h=`path=${encodeURIComponent(S.path)}`;return typeof g=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),n.URI.from({scheme:k.isWeb?this.d:D.vscodeRemoteResource,authority:`${E}:${p}`,path:this.f,query:h})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class T{asBrowserUri(S){const C=this.b(S,Z);return this.uriToBrowserUri(C)}uriToBrowserUri(S){return S.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===D.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${D.vscodeFileResource}://${T.a}`)?S.with({scheme:D.vscodeFileResource,authority:S.authority||T.a,query:null,fragment:null}):S}asFileUri(S){const C=this.b(S,Z);return this.uriToFileUri(C)}uriToFileUri(S){return S.scheme===D.vscodeFileResource?S.with({scheme:D.file,authority:S.authority!==T.a?S.authority:null,query:null,fragment:null}):S}b(S,C){return n.URI.isUri(S)?S:n.URI.parse(C.toUrl(S))}}T.a="vscode-app",e.FileAccess=new T;var R;(function(P){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);P.CoopAndCoep=Object.freeze(S.get("3"));const C="vscode-coi";function E(g){let h;typeof g=="string"?h=new URL(g).searchParams:g instanceof URL?h=g.searchParams:n.URI.isUri(g)&&(h=new URL(g.toString(!0)).searchParams);const y=h?.get(C);if(!!y)return S.get(y)}P.getHeadersFromQuery=E;function p(g,h,y){if(!globalThis.crossOriginIsolated)return;const f=h&&y?"3":y?"2":"1";g instanceof URLSearchParams?g.set(C,f):g[C]=f}P.addSearchParam=p})(R=e.COI||(e.COI={}))}),define(oe[22],ae([0,1,48,24,12,5,27,7]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(g){return(0,R.uriToFsPath)(g,!0)}e.originalFSPath=P;class S{constructor(h){this.a=h}compare(h,y,f=!1){return h===y?0:(0,T.compare)(this.getComparisonKey(h,f),this.getComparisonKey(y,f))}isEqual(h,y,f=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,f)===this.getComparisonKey(y,f)}getComparisonKey(h,y=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,y,f=!1){if(h.scheme===y.scheme){if(h.scheme===n.Schemas.file)return k.isEqualOrParent(P(h),P(y),this.a(h))&&h.query===y.query&&(f||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return k.isEqualOrParent(h.path,y.path,this.a(h),"/")&&h.query===y.query&&(f||h.fragment===y.fragment)}return!1}joinPath(h,...y){return R.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===n.Schemas.file?y=R.URI.file(D.dirname(P(h))).path:(y=D.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===n.Schemas.file?y=R.URI.file(D.normalize(P(h))).path:y=D.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===n.Schemas.file){const d=D.relative(P(h),P(y));return A.isWindows?k.toSlashes(d):d}let f=h.path||"/";const l=y.path||"/";if(this.a(h)){let d=0;for(const m=Math.min(f.length,l.length);d<m&&!(f.charCodeAt(d)!==l.charCodeAt(d)&&f.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);f=l.substr(0,d)+f.substr(d)}return D.posix.relative(f,l)}resolvePath(h,y){if(h.scheme===n.Schemas.file){const f=R.URI.file(D.resolve(P(h),y));return h.with({authority:f.authority,path:f.path})}return y=k.toPosixPath(y),h.with({path:D.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,T.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=D.sep){if(h.scheme===n.Schemas.file){const f=P(h);return f.length>k.getRoot(f).length&&f[f.length-1]===y}else{const f=h.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=D.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=D.sep){let f=!1;if(h.scheme===n.Schemas.file){const l=P(h);f=l!==void 0&&l.length===k.getRoot(l).length&&l[l.length-1]===y}else{y="/";const l=h.path;f=l.length===1&&l.charCodeAt(l.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(g=>g.scheme===n.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new S(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(g,h){const y=[];for(let f=0;f<g.length;f++){const l=h(g[f]);g.some((d,m)=>m===f?!1:(0,e.isEqualOrParent)(l,h(d)))||y.push(g[f])}return y}e.distinctParents=C;var E;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function h(y){const f=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(m=>{const[v,I]=m.split(":");v&&I&&f.set(v,I)});const d=y.path.substring(0,y.path.indexOf(";"));return d&&f.set(g.META_DATA_MIME,d),f}g.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function p(g,h,y){if(h){let f=g.path;return f&&f[0]!==D.posix.sep&&(f=D.posix.sep+f),g.with({scheme:y,authority:h,path:f})}return g.with({scheme:y})}e.toLocalResource=p}),define(oe[6],ae([0,1,23,9,3,2,22,5]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(te){return!!te&&typeof te.then=="function"}e.isThenable=P;function S(te){const O=new k.CancellationTokenSource,M=te(O.token),W=new Promise((B,x)=>{const ie=O.token.onCancellationRequested(()=>{ie.dispose(),O.dispose(),x(new n.CancellationError)});Promise.resolve(M).then(J=>{ie.dispose(),O.dispose(),B(J)},J=>{ie.dispose(),O.dispose(),x(J)})});return new class{cancel(){O.cancel()}then(B,x){return W.then(B,x)}catch(B){return this.then(void 0,B)}finally(B){return W.finally(B)}}}e.createCancelablePromise=S;function C(te,O,M){return new Promise((W,B)=>{const x=O.onCancellationRequested(()=>{x.dispose(),W(M)});te.then(W,B).finally(()=>x.dispose())})}e.raceCancellation=C;function E(te,O){return new Promise((M,W)=>{const B=O.onCancellationRequested(()=>{B.dispose(),W(new n.CancellationError)});te.then(M,W).finally(()=>B.dispose())})}e.raceCancellationError=E;async function p(te){let O=-1;const M=te.map((B,x)=>B.then(ie=>(O=x,ie))),W=await Promise.race(M);return te.forEach((B,x)=>{x!==O&&B.cancel()}),W}e.raceCancellablePromises=p;function g(te,O,M){let W;const B=setTimeout(()=>{W?.(void 0),M?.()},O);return Promise.race([te.finally(()=>clearTimeout(B)),new Promise(x=>W=x)])}e.raceTimeout=g;function h(te){return new Promise((O,M)=>{const W=te();P(W)?W.then(O,M):O(W)})}e.asPromise=h;class y{constructor(){this.a=null,this.b=null,this.d=null}queue(O){if(this.a){if(this.d=O,!this.b){const M=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(M,M).then(W)})}return new Promise((M,W)=>{this.b.then(M,W)})}return this.a=O(),new Promise((M,W)=>{this.a.then(B=>{this.a=null,M(B)},B=>{this.a=null,W(B)})})}}e.Throttler=y;class f{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.Sequencer=f;class l{constructor(){this.a=new Map}queue(O,M){const B=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(O)===B&&this.a.delete(O)});return this.a.set(O,B),B}}e.SequencerByKey=l;const d=(te,O)=>{let M=!0;const W=setTimeout(()=>{M=!1,O()},te);return{isTriggered:()=>M,dispose:()=>{clearTimeout(W),M=!1}}},m=te=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,te())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class v{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,M=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((B,x)=>{this.d=B,this.f=x}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=M===e.MicrotaskDelay?m(W):d(M,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new n.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class I{constructor(O){this.a=new v(O),this.b=new y}trigger(O,M){return this.a.trigger(()=>this.b.queue(O),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=I;class i{constructor(){this.a=!1,this.b=new Promise((O,M)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class r extends i{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function t(te,O){return O?new Promise((M,W)=>{const B=setTimeout(()=>{x.dispose(),M()},te),x=O.onCancellationRequested(()=>{clearTimeout(B),x.dispose(),W(new n.CancellationError)})}):S(M=>t(te,M))}e.timeout=t;function s(te,O=0){const M=setTimeout(te,O);return(0,A.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=s;function o(te){const O=[];let M=0;const W=te.length;function B(){return M<W?te[M++]():null}function x(ie){ie!=null&&O.push(ie);const J=B();return J?J.then(x):Promise.resolve(O)}return Promise.resolve(null).then(x)}e.sequence=o;function c(te,O=W=>!!W,M=null){let W=0;const B=te.length,x=()=>{if(W>=B)return Promise.resolve(M);const ie=te[W++];return Promise.resolve(ie()).then(_=>O(_)?Promise.resolve(_):x())};return x()}e.first=c;function a(te,O=W=>!!W,M=null){if(te.length===0)return Promise.resolve(M);let W=te.length;const B=()=>{W=-1;for(const x of te)x.cancel?.()};return new Promise((x,ie)=>{for(const J of te)J.then(_=>{--W>=0&&O(_)?(B(),x(_)):W===0&&x(M)}).catch(_=>{--W>=0&&(B(),ie(_))})})}e.firstParallel=a;class u{constructor(O){this.a=0,this.d=O,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(O){return this.a++,new Promise((M,W)=>{this.f.push({factory:O,c:M,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const O=this.f.shift();this.b++;const M=O.factory();M.then(O.c,O.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class w extends u{constructor(){super(1)}}e.Queue=w;class b{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const O=new H;return this.b.add(O),O.p}d(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueFor(O,M=T.extUri){const W=M.getComparisonKey(O);let B=this.a.get(W);return B||(B=new w,D.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,B)),B}f(){!this.d()||this.g()}g(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.g()}}e.ResourceQueue=b;class U{constructor(O,M){this.a=-1,typeof O=="function"&&typeof M=="number"&&this.setIfNotSet(O,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},M)}setIfNotSet(O,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},M))}}e.TimeoutTimer=U;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(O,M){this.cancel(),this.a=setInterval(()=>{O()},M)}}e.IntervalTimer=N;class ${constructor(O,M){this.b=-1,this.a=O,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=$;class F{constructor(O,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=O,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=F;class L extends ${constructor(O,M){super(O,M),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=L;class j extends A.Disposable{constructor(O,M){super(),this.g=O,this.h=M,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of O)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new $(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=j,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,R.setTimeout0)(()=>{if(O)return;const M=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(te,O)=>{const M=requestIdleCallback(te,typeof O=="number"?{timeout:O}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(M))}}}}();class z{constructor(O){this.d=!1,this.a=()=>{try{this.f=O()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function V(te,O,M){let W;for(let B=0;B<M;B++)try{return await te()}catch(x){W=x,await t(O)}throw W}e.retry=V;class Q{hasPending(O){return this.a?typeof O=="number"?this.a.taskId===O:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(O,M,W){return this.a={taskId:O,cancel:()=>W?.(),promise:M},M.then(()=>this.d(O),()=>this.d(O)),M}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this.b)this.b.run=O;else{let M,W;const B=new Promise((x,ie)=>{M=x,W=ie});this.b={run:O,promise:B,promiseResolve:M,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=Q;class Y{constructor(O,M=()=>Date.now()){this.d=O,this.f=M,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((O,M)=>{this.a=O,this.b=M})}complete(O){return new Promise(M=>{this.a(O),this.f=!0,M()})}error(O){return new Promise(M=>{this.b(O),this.d=!0,M()})}cancel(){new Promise(O=>{this.b(new n.CancellationError),this.d=!0,O()})}}e.DeferredPromise=H;var q;(function(te){async function O(W){let B;const x=await Promise.all(W.map(ie=>ie.then(J=>J,J=>{B||(B=J)})));if(typeof B<"u")throw B;return x}te.settled=O;function M(W){return new Promise(async(B,x)=>{try{await W(B,x)}catch(ie){x(ie)}})}te.withAsyncBody=M})(q=e.Promises||(e.Promises={}));var G;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(G||(G={}));class X{static fromArray(O){return new X(M=>{M.emitMany(O)})}static fromPromise(O){return new X(async M=>{M.emitMany(await O)})}static fromPromises(O){return new X(async M=>{await Promise.all(O.map(async W=>M.emitOne(await W)))})}static merge(O){return new X(async M=>{await Promise.all(O.map(async W=>{for await(const B of W)M.emitOne(B)}))})}constructor(O){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const M={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(O(M)),this.j()}catch(W){this.k(W)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(O,M){return new X(async W=>{for await(const B of O)W.emitOne(M(B))})}map(O){return X.map(this,O)}static filter(O,M){return new X(async W=>{for await(const B of O)M(B)&&W.emitOne(B)})}filter(O){return X.filter(this,O)}static coalesce(O){return X.filter(O,M=>!!M)}coalesce(){return X.coalesce(this)}static async toPromise(O){const M=[];for await(const W of O)M.push(W);return M}toPromise(){return X.toPromise(this)}g(O){this.a===0&&(this.b.push(O),this.f.fire())}h(O){this.a===0&&(this.b=this.b.concat(O),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(O){this.a===0&&(this.a=2,this.d=O,this.f.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class ee extends X{constructor(O,M){super(M),this.l=O}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ee;function re(te){const O=new k.CancellationTokenSource,M=te(O.token);return new ee(O,async W=>{const B=O.token.onCancellationRequested(()=>{B.dispose(),O.dispose(),W.reject(new n.CancellationError)});try{for await(const x of M){if(O.token.isCancellationRequested)return;W.emitOne(x)}B.dispose(),O.dispose()}catch(x){B.dispose(),O.dispose(),W.reject(x)}})}e.createCancelableAsyncIterable=re}),define(oe[89],ae([0,1,21,6,48,37,12,5,27]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",E="[^/\\\\]",p=/\//g;function g(H,q){switch(H){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${q?`|${C}${E}+`:""})*?`}}function h(H,q){if(!H)return[];const G=[];let X=!1,ee=!1,re="";for(const te of H){switch(te){case q:if(!X&&!ee){G.push(re),re="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}re+=te}return re&&G.push(re),G}e.splitGlobAware=h;function y(H){if(!H)return"";let q="";const G=h(H,e.GLOB_SPLIT);if(G.every(X=>X===e.GLOBSTAR))q=".*";else{let X=!1;G.forEach((ee,re)=>{if(ee===e.GLOBSTAR){if(X)return;q+=g(2,re===G.length-1)}else{let te=!1,O="",M=!1,W="";for(const B of ee){if(B!=="}"&&te){O+=B;continue}if(M&&(B!=="]"||!W)){let x;B==="-"?x=B:(B==="^"||B==="!")&&!W?x="^":B===e.GLOB_SPLIT?x="":x=(0,P.escapeRegExpCharacters)(B),W+=x;continue}switch(B){case"{":te=!0;continue;case"[":M=!0;continue;case"}":{q+=`(?:${h(O,",").map(J=>y(J)).join("|")})`,te=!1,O="";break}case"]":{q+="["+W+"]",M=!1,W="";break}case"?":q+=E;continue;case"*":q+=g(1);continue;default:q+=(0,P.escapeRegExpCharacters)(B)}}re<G.length-1&&(G[re+1]!==e.GLOBSTAR||re+2<G.length)&&(q+=C)}X=ee===e.GLOBSTAR})}return q}const f=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.LRUCache(1e4),r=function(){return!1},t=function(){return null};function s(H,q){if(!H)return t;let G;typeof H!="string"?G=H.pattern:G=H,G=G.trim();const X=`${G}_${!!q.trimForExclusions}`;let ee=i.get(X);if(ee)return o(ee,H);let re;return f.test(G)?ee=a(G.substr(4),G):(re=l.exec(c(G,q)))?ee=u(re[1],G):(q.trimForExclusions?m:d).test(G)?ee=w(G,q):(re=v.exec(c(G,q)))?ee=b(re[1].substr(1),G,!0):(re=I.exec(c(G,q)))?ee=b(re[1],G,!1):ee=U(G),i.set(X,ee),o(ee,H)}function o(H,q){if(typeof q=="string")return H;const G=function(X,ee){return(0,D.isEqualOrParent)(X,q.base,!R.isLinux)?H((0,P.ltrim)(X.substr(q.base.length),T.sep),ee):null};return G.allBasenames=H.allBasenames,G.allPaths=H.allPaths,G.basenames=H.basenames,G.patterns=H.patterns,G}function c(H,q){return q.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function a(H,q){return function(G,X){return typeof G=="string"&&G.endsWith(H)?q:null}}function u(H,q){const G=`/${H}`,X=`\\${H}`,ee=function(te,O){return typeof te!="string"?null:O?O===H?q:null:te===H||te.endsWith(G)||te.endsWith(X)?q:null},re=[H];return ee.basenames=re,ee.patterns=[q],ee.allBasenames=re,ee}function w(H,q){const G=Q(H.slice(1,-1).split(",").map(O=>s(O,q)).filter(O=>O!==t),H),X=G.length;if(!X)return t;if(X===1)return G[0];const ee=function(O,M){for(let W=0,B=G.length;W<B;W++)if(G[W](O,M))return H;return null},re=G.find(O=>!!O.allBasenames);re&&(ee.allBasenames=re.allBasenames);const te=G.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return te.length&&(ee.allPaths=te),ee}function b(H,q,G){const X=T.sep===T.posix.sep,ee=X?H:H.replace(p,T.sep),re=T.sep+ee,te=T.posix.sep+H;let O;return G?O=function(M,W){return typeof M=="string"&&(M===ee||M.endsWith(re)||!X&&(M===H||M.endsWith(te)))?q:null}:O=function(M,W){return typeof M=="string"&&(M===ee||!X&&M===H)?q:null},O.allPaths=[(G?"*/":"./")+H],O}function U(H){try{const q=new RegExp(`^${y(H)}$`);return function(G){return q.lastIndex=0,typeof G=="string"&&q.test(G)?H:null}}catch{return t}}function N(H,q,G){return!H||typeof q!="string"?!1:$(H)(q,void 0,G)}e.match=N;function $(H,q={}){if(!H)return r;if(typeof H=="string"||F(H)){const G=s(H,q);if(G===t)return r;const X=function(ee,re){return!!G(ee,re)};return G.allBasenames&&(X.allBasenames=G.allBasenames),G.allPaths&&(X.allPaths=G.allPaths),X}return z(H,q)}e.parse=$;function F(H){const q=H;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=F;function L(H){return H.allBasenames||[]}e.getBasenameTerms=L;function j(H){return H.allPaths||[]}e.getPathTerms=j;function z(H,q){const G=Q(Object.getOwnPropertyNames(H).map(O=>V(O,H[O],q)).filter(O=>O!==t)),X=G.length;if(!X)return t;if(!G.some(O=>!!O.requiresSiblings)){if(X===1)return G[0];const O=function(B,x){let ie;for(let J=0,_=G.length;J<_;J++){const se=G[J](B,x);if(typeof se=="string")return se;(0,n.isThenable)(se)&&(ie||(ie=[]),ie.push(se))}return ie?(async()=>{for(const J of ie){const _=await J;if(typeof _=="string")return _}return null})():null},M=G.find(B=>!!B.allBasenames);M&&(O.allBasenames=M.allBasenames);const W=G.reduce((B,x)=>x.allPaths?B.concat(x.allPaths):B,[]);return W.length&&(O.allPaths=W),O}const ee=function(O,M,W){let B,x;for(let ie=0,J=G.length;ie<J;ie++){const _=G[ie];_.requiresSiblings&&W&&(M||(M=(0,T.basename)(O)),B||(B=M.substr(0,M.length-(0,T.extname)(O).length)));const se=_(O,M,B,W);if(typeof se=="string")return se;(0,n.isThenable)(se)&&(x||(x=[]),x.push(se))}return x?(async()=>{for(const ie of x){const J=await ie;if(typeof J=="string")return J}return null})():null},re=G.find(O=>!!O.allBasenames);re&&(ee.allBasenames=re.allBasenames);const te=G.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return te.length&&(ee.allPaths=te),ee}function V(H,q,G){if(q===!1)return t;const X=s(H,G);if(X===t)return t;if(typeof q=="boolean")return X;if(q){const ee=q.when;if(typeof ee=="string"){const re=(te,O,M,W)=>{if(!W||!X(te,O))return null;const B=ee.replace("$(basename)",()=>M),x=W(B);return(0,n.isThenable)(x)?x.then(ie=>ie?H:null):x?H:null};return re.requiresSiblings=!0,re}}return X}function Q(H,q){const G=H.filter(O=>!!O.basenames);if(G.length<2)return H;const X=G.reduce((O,M)=>{const W=M.basenames;return W?O.concat(W):O},[]);let ee;if(q){ee=[];for(let O=0,M=X.length;O<M;O++)ee.push(q)}else ee=G.reduce((O,M)=>{const W=M.patterns;return W?O.concat(W):O},[]);const re=function(O,M){if(typeof O!="string")return null;if(!M){let B;for(B=O.length;B>0;B--){const x=O.charCodeAt(B-1);if(x===47||x===92)break}M=O.substr(B)}const W=X.indexOf(M);return W!==-1?ee[W]:null};re.basenames=X,re.patterns=ee,re.allBasenames=X;const te=H.filter(O=>!O.basenames);return te.push(re),te}function Y(H,q){return(0,k.equals)(H,q,(G,X)=>typeof G=="string"&&typeof X=="string"?G===X:typeof G!="string"&&typeof X!="string"?G.base===X.base&&G.pattern===X.pattern:!1)}e.patternsEquals=Y}),define(oe[143],ae([0,1,7]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(C){return C.toJSON()}class D{constructor(E){this.a=E}transformIncoming(E){const p=this.a.transformIncoming(E);return p===E?E:n(k.URI.from(p))}transformOutgoing(E){const p=this.a.transformOutgoing(E);return p===E?E:n(k.URI.from(p))}transformOutgoingURI(E){const p=this.a.transformOutgoing(E);return p===E?E:k.URI.from(p)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,E,p){if(!C||p>200)return null;if(typeof C=="object"){if(C instanceof k.URI)return E.transformOutgoing(C);for(const g in C)if(Object.hasOwnProperty.call(C,g)){const h=A(C[g],E,p+1);h!==null&&(C[g]=h)}}return null}function T(C,E){const p=A(C,E,0);return p===null?C:p}e.transformOutgoingURIs=T;function R(C,E,p,g){if(!C||g>200)return null;if(typeof C=="object"){if(C.$mid===1)return p?k.URI.revive(E.transformIncoming(C)):E.transformIncoming(C);for(const h in C)if(Object.hasOwnProperty.call(C,h)){const y=R(C[h],E,p,g+1);y!==null&&(C[h]=y)}}return null}function P(C,E){const p=R(C,E,!1,0);return p===null?C:p}e.transformIncomingURIs=P;function S(C,E){const p=R(C,E,!0,0);return p===null?C:p}e.transformAndReviveIncomingURIs=S}),define(oe[144],ae([0,1,34,9,49,31,130]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(C){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(C)}value(){if(this.b===void 0){let C=0,E=0;const p=(0,k.networkInterfaces)();for(const g in p){const h=p[g];if(h)for(const{mac:y,internal:f}of h)f||(E+=1,this.c(y.toUpperCase())&&(C+=1))}this.b=E>0?C/E:0}return this.b}};let R;async function P(){return R||(R=(async()=>await S()||A.generateUuid())()),R}e.getMachineId=P;async function S(){try{const C=await new Promise((p,g)=>{Z(["crypto"],p,g)}),E=(0,T.getMac)();return C.createHash("sha256").update(E,"utf8").digest("hex")}catch(C){n.onUnexpectedError(C);return}}}),define(oe[28],ae([0,1,53,34,284,6,48,85,12,5,22,7]),function(Z,e,k,n,D,A,T,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function g(z,V=p.UNLINK){if((0,T.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return V===p.UNLINK?y(z):h(z)}async function h(z){try{const V=(0,T.randomPath)((0,n.tmpdir)());try{await k.promises.rename(z,V)}catch(Q){return Q.code==="ENOENT"?void 0:y(z)}y(V).catch(Q=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function y(z){return(0,D.promisify)(k.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function f(z){if((0,T.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function l(z,V){return v(await(V?d(z):(0,D.promisify)(k.readdir)(z)))}async function d(z){try{return await(0,D.promisify)(k.readdir)(z,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const V=[],Q=await l(z);for(const Y of Q){let H=!1,q=!1,G=!1;try{const X=await e.Promises.lstat((0,P.join)(z,Y));H=X.isFile(),q=X.isDirectory(),G=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}V.push({name:Y,isFile:()=>H,isDirectory:()=>q,isSymbolicLink:()=>G})}return V}function m(z){return v(k.readdirSync(z))}e.readdirSync=m;function v(z){return z.map(V=>typeof V=="string"?S.isMacintosh?(0,R.normalizeNFC)(V):V:(V.name=S.isMacintosh?(0,R.normalizeNFC)(V.name):V.name,V))}async function I(z){const V=await l(z),Q=[];for(const Y of V)await r.existsDirectory((0,P.join)(z,Y))&&Q.push(Y);return Q}function i(z,V=1e3){return new Promise(Q=>{let Y=!1;const H=setInterval(()=>{Y||(Y=!0,k.access(z,q=>{Y=!1,q&&(clearInterval(H),Q(void 0))}))},V)})}e.whenDeleted=i;var r;(function(z){async function V(H){let q;try{if(q=await e.Promises.lstat(H),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(S.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw X}throw G}}z.stat=V;async function Q(H){try{const{stat:q,symbolicLink:G}=await z.stat(H);return q.isFile()&&G?.dangling!==!0}catch{}return!1}z.existsFile=Q;async function Y(H){try{const{stat:q,symbolicLink:G}=await z.stat(H);return q.isDirectory()&&G?.dangling!==!0}catch{}return!1}z.existsDirectory=Y})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new A.ResourceQueue;function s(z,V,Q){return t.queueFor(E.URI.file(z),C.extUriBiasedIgnorePathCase).queue(()=>{const Y=w(Q);return new Promise((H,q)=>a(z,V,Y,G=>G?q(G):H()))})}let o=!0;function c(z){o=z}e.configureFlushOnWrite=c;function a(z,V,Q,Y){if(!o)return k.writeFile(z,V,{mode:Q.mode,flag:Q.flag},Y);k.open(z,Q.flag,Q.mode,(H,q)=>{if(H)return Y(H);k.writeFile(q,V,G=>{if(G)return k.close(q,()=>Y(G));k.fdatasync(q,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),c(!1)),k.close(q,ee=>Y(ee))))})})}function u(z,V,Q){const Y=w(Q);if(!o)return k.writeFileSync(z,V,{mode:Y.mode,flag:Y.flag});const H=k.openSync(z,Y.flag,Y.mode);try{k.writeFileSync(H,V);try{k.fdatasyncSync(H)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),c(!1)}}finally{k.closeSync(H)}}e.writeFileSync=u;function w(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function b(z,V){if(z!==V)try{await e.Promises.rename(z,V)}catch(Q){if(z.toLowerCase()!==V.toLowerCase()&&Q.code==="EXDEV"||z.endsWith("."))await U(z,V,{preserveSymlinks:!1}),await g(z,p.MOVE);else throw Q}}async function U(z,V,Q){return $(z,V,{root:{source:z,target:V},options:Q,handledSourcePaths:new Set})}const N=511;async function $(z,V,Q){if(Q.handledSourcePaths.has(z))return;Q.handledSourcePaths.add(z);const{stat:Y,symbolicLink:H}=await r.stat(z);if(H){if(Q.options.preserveSymlinks)try{return await j(z,V,Q)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(H.dangling)return}return Y.isDirectory()?F(z,V,Y.mode&N,Q):L(z,V,Y.mode&N)}async function F(z,V,Q,Y){await e.Promises.mkdir(V,{recursive:!0,mode:Q});const H=await l(z);for(const q of H)await $((0,P.join)(z,q),(0,P.join)(V,q),Y)}async function L(z,V,Q){await e.Promises.copyFile(z,V),await e.Promises.chmod(V,Q)}async function j(z,V,Q){let Y=await e.Promises.readlink(z);(0,T.isEqualOrParent)(Y,Q.root.source,!S.isLinux)&&(Y=(0,P.join)(Q.root.target,Y.substr(Q.root.source.length+1))),await e.Promises.symlink(Y,V)}e.Promises=new class{get access(){return(0,D.promisify)(k.access)}get stat(){return(0,D.promisify)(k.stat)}get lstat(){return(0,D.promisify)(k.lstat)}get utimes(){return(0,D.promisify)(k.utimes)}get read(){return(z,V,Q,Y,H)=>new Promise((q,G)=>{k.read(z,V,Q,Y,H,(X,ee,re)=>X?G(X):q({bytesRead:ee,buffer:re}))})}get readFile(){return(0,D.promisify)(k.readFile)}get write(){return(z,V,Q,Y,H)=>new Promise((q,G)=>{k.write(z,V,Q,Y,H,(X,ee,re)=>X?G(X):q({bytesWritten:ee,buffer:re}))})}get appendFile(){return(0,D.promisify)(k.appendFile)}get fdatasync(){return(0,D.promisify)(k.fdatasync)}get truncate(){return(0,D.promisify)(k.truncate)}get rename(){return(0,D.promisify)(k.rename)}get copyFile(){return(0,D.promisify)(k.copyFile)}get open(){return(0,D.promisify)(k.open)}get close(){return(0,D.promisify)(k.close)}get symlink(){return(0,D.promisify)(k.symlink)}get readlink(){return(0,D.promisify)(k.readlink)}get chmod(){return(0,D.promisify)(k.chmod)}get mkdir(){return(0,D.promisify)(k.mkdir)}get unlink(){return(0,D.promisify)(k.unlink)}get rmdir(){return(0,D.promisify)(k.rmdir)}get realpath(){return(0,D.promisify)(k.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return I}get writeFile(){return s}get rm(){return g}get move(){return b}get copy(){return U}}}),define(oe[145],ae([0,1,53,12,5,27,28]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(p){if(D.isLinux)return p;const g=(0,n.dirname)(p);if(p===g)return p;const h=((0,n.basename)(p)||p).toLowerCase();try{const f=(0,T.readdirSync)(g).filter(l=>l.toLowerCase()===h);if(f.length===1){const l=R(g);if(l)return(0,n.join)(l,f[0])}else if(f.length>1){const l=f.indexOf(h);if(l>=0){const d=R(g);if(d)return(0,n.join)(d,f[l])}}}catch{}return null}e.realcaseSync=R;async function P(p){if(D.isLinux)return p;const g=(0,n.dirname)(p);if(p===g)return p;const h=((0,n.basename)(p)||p).toLowerCase();try{const f=(await T.Promises.readdir(g)).filter(l=>l.toLowerCase()===h);if(f.length===1){const l=await P(g);if(l)return(0,n.join)(l,f[0])}else if(f.length>1){const l=f.indexOf(h);if(l>=0){const d=await P(g);if(d)return(0,n.join)(d,f[l])}}}catch{}return null}e.realcase=P;async function S(p){try{return await T.Promises.realpath(p)}catch{const h=E(p);return await T.Promises.access(h,k.constants.R_OK),h}}e.realpath=S;function C(p){try{return k.realpathSync(p)}catch{const h=E(p);return k.accessSync(h,k.constants.R_OK),h}}e.realpathSync=C;function E(p){return(0,A.rtrim)((0,n.normalize)(p),n.sep)}}),define(oe[90],ae([0,1,34,12,28]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var P;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(P||(P={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class E{constructor(I,i,r){this.exePath=I,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:v=!1}={}){return v?S===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:v=!1,findPreview:I=!1}={}){const i=p({useAlternateBitness:v});if(!i)return null;const r=n.join(i,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let t=-1,s=null;for(const a of await D.Promises.readdir(r)){let u=-1;if(I){const b=a.indexOf("-");if(b<0)continue;const U=a.substring(0,b);if(!A.test(U)||a.substring(b+1)!=="preview")continue;u=parseInt(U,10)}else{if(!A.test(a))continue;u=parseInt(a,10)}if(u<=t)continue;const w=n.join(r,a,"pwsh.exe");!await D.SymlinkSupport.existsFile(w)||(s=w,t=u)}if(!s)return null;const o=i.includes("x86")?" (x86)":"",c=I?" Preview":"";return new E(s,`PowerShell${c}${o}`,!0)}async function h({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const I=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(I))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=v?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(I))if(i.test(t)){const s=n.join(I,t,"pwsh.exe");return new E(s,r)}return null}function y(){const v=n.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(v,".NET Core PowerShell Global Tool")}function f(){const v=n.join(process.env.windir,S===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(v,"Windows PowerShell",!0)}async function*l(){let v=await g();v&&(yield v),v=await g({useAlternateBitness:!0}),v&&(yield v),v=await h(),v&&(yield v),v=y(),v&&(yield v),v=await g({findPreview:!0}),v&&(yield v),v=await h({findPreview:!0}),v&&(yield v),v=await g({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=f(),v&&(yield v)}async function*d(){for await(const v of l())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=d;async function m(){for await(const v of d())return v;return null}e.getFirstAvailablePowerShellInstallation=m}),define(oe[91],ae([0,1,12,5,36,87,14,28]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(E=D.env){return E.comspec||"cmd.exe"}e.getWindowsShell=P;function S(E){let p=[],g=!1;const h=function(y){if(g){p.push(y);return}(!E.send(y,l=>{if(l&&console.error(l),g=!1,p.length>0){const d=p.slice(0);p=[],d.forEach(m=>h(m))}})||n.isWindows)&&(g=!0)};return{send:h}}e.createQueuedSender=S;var C;(function(E){async function p(g,h,y){if(k.isAbsolute(g))return g;if(h===void 0&&(h=D.cwd()),k.dirname(g)!=="."||(y===void 0&&T.isString(D.env.PATH)&&(y=D.env.PATH.split(k.delimiter)),y===void 0||y.length===0))return k.join(h,g);async function l(d){if(await R.Promises.exists(d)){let m;try{m=await R.Promises.stat(d)}catch(v){v.message.startsWith("EACCES")&&(m=await R.Promises.lstat(d))}return m?!m.isDirectory():!1}return!1}for(const d of y){let m;if(k.isAbsolute(d)?m=k.join(d,g):m=k.join(h,d,g),await l(m))return m;let v=m+".com";if(await l(v)||(v=m+".exe",await l(v)))return v}return k.join(h,g)}E.findExecutable=p})(C=e.win32||(e.win32={}))}),define(oe[146],ae([0,1,50,24]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(T){return new Promise((R,P)=>{let S;const C=new Map;function E(g,h,y,f,l){const d=C.get(h);if(g===T||d){const m={name:p(y),cmd:y,pid:g,ppid:h,load:f,mem:l};C.set(g,m),g===T&&(S=m),d&&(d.children||(d.children=[]),d.children.push(m),d.children.length>1&&(d.children=d.children.sort((v,I)=>v.pid-I.pid)))}}function p(g){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,d=/--utility-sub-type=node.mojom.NodeService/,m=/--crashes-directory/,v=/\\pipe\\winpty-control/,I=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(m.exec(g))return"electron-crash-reporter";if(v.exec(g))return"winpty-process";if(I.exec(g))return"console-window-host (Windows internal process)";let r=i.exec(g);if(r&&r.length===2){if(r[1]==="renderer")return h.exec(g)?"shared-process":y.exec(g)?"issue-reporter":f.exec(g)?"process-explorer":"window";if(r[1]==="utility"){if(l.exec(g))return"utility-network-service";if(d.exec(g))return"extension-host"}else if(r[1]==="extensionHost")return"extension-host";return r[1]}const t=/[a-zA-Z-]+\.js/g;let s="";do r=t.exec(g),r&&(s+=r+" ");while(r);return s&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${s}`:g}if(process.platform==="win32"){const g=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{Z(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(T,y=>{if(!y){P(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(y,f=>{const l=new Map;f.forEach(d=>{const m=g(d.commandLine||"");l.set(d.pid,{name:p(m),cmd:m,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),S=l.get(T),S?(l.forEach(d=>{const m=l.get(d.ppid);m&&(m.children||(m.children=[]),m.children.push(d))}),l.forEach(d=>{d.children&&(d.children=d.children.sort((m,v)=>m.pid-v.pid))}),R(S)):P(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let g=function(){let h=[S];const y=[];for(;h.length;){const l=h.shift();l&&(y.push(l.pid),l.children&&(h=h.concat(l.children)))}let f=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+y.join(" "),(0,k.exec)(f,{},(l,d,m)=>{if(l||m)P(l||new Error(m.toString()));else{const v=d.toString().split(`
`);for(let I=0;I<y.length;I++){const i=C.get(y[I]);i.load=parseFloat(v[I])}if(!S){P(new Error(`Root process ${T} not found`));return}R(S)}})};(0,k.exec)("which ps",{},(h,y,f)=>{if(h||f)if(process.platform!=="linux")P(h||new Error(f.toString()));else{const l=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(l,{},(d,m,v)=>{d||v?P(d||new Error(v.toString())):(A(m,E),g())})}else{const l=y.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${l} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,v,I)=>{m||I&&!I.includes("screen size is bogus")?P(m||new Error(I.toString())):(A(v,E),process.platform==="linux"?g():S?R(S):P(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=D;function A(T,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=T.toString().split(`
`);for(const C of S){const E=P.exec(C.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(oe[147],ae([0,1,34,5,90,91]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(E,p){return E===1?n.isWindows?C():A.getWindowsShell(p):P(E,p)}e.getSystemShell=T;let R=null;function P(E,p){if(n.isLinux&&E===2||n.isMacintosh&&E===3)return"/bin/bash";if(!R){let g;if(n.isWindows)g="/bin/bash";else{if(g=p.SHELL,!g)try{g=(0,k.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}R=g}return R}let S=null;async function C(){return S||(S=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),S}});var pe=this&&this.__decorate||function(Z,e,k,n){var D=arguments.length,A=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,k):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Z,e,k,n);else for(var R=Z.length-1;R>=0;R--)(T=Z[R])&&(A=(D<3?T(A):D>3?T(e,k,A):T(e,k))||A);return D>3&&A&&Object.defineProperty(e,k,A),A};define(oe[39],ae([0,1,21,6,17,23,63,9,3,2,67,27,14]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var g;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(g||(g={}));function h(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y||(y={}));function f(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(l||(l={}));function d(q){let G=0;for(let X=0;;X+=7){const ee=q.read(1);if(G|=(ee.buffer[0]&127)<<X,!(ee.buffer[0]&128))return G}}const m=t(0);function v(q,G){if(G===0){q.write(m);return}let X=0;for(let re=G;re!==0;re=re>>>7)X++;const ee=D.VSBuffer.alloc(X);for(let re=0;G!==0;re++)ee.buffer[re]=G&127,G=G>>>7,G>0&&(ee.buffer[re]|=128);q.write(ee)}class I{constructor(G){this.b=G,this.a=0}read(G){const X=this.b.slice(this.a,this.a+G);return this.a+=X.byteLength,X}}e.BufferReader=I;class i{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(G){this.a.push(G)}}e.BufferWriter=i;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function t(q){const G=D.VSBuffer.alloc(1);return G.writeUInt8(q,0),G}const s={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},o=typeof Buffer<"u";function c(q,G){if(typeof G>"u")q.write(s.Undefined);else if(typeof G=="string"){const X=D.VSBuffer.fromString(G);q.write(s.String),v(q,X.byteLength),q.write(X)}else if(o&&Buffer.isBuffer(G)){const X=D.VSBuffer.wrap(G);q.write(s.Buffer),v(q,X.byteLength),q.write(X)}else if(G instanceof D.VSBuffer)q.write(s.VSBuffer),v(q,G.byteLength),q.write(G);else if(Array.isArray(G)){q.write(s.Array),v(q,G.length);for(const X of G)c(q,X)}else if(typeof G=="number"&&(G|0)===G)q.write(s.Uint),v(q,G);else{const X=D.VSBuffer.fromString(JSON.stringify(G));q.write(s.Object),v(q,X.byteLength),q.write(X)}}e.serialize=c;function a(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(d(q)).toString();case r.Buffer:return q.read(d(q)).buffer;case r.VSBuffer:return q.read(d(q));case r.Array:{const X=d(q),ee=[];for(let re=0;re<X;re++)ee.push(a(q));return ee}case r.Object:return JSON.parse(q.read(d(q)).toString());case r.Int:return d(q)}}e.deserialize=a;class u{constructor(G,X,ee=null,re=1e3){this.h=G,this.j=X,this.k=ee,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(G,X){this.b.set(G,X),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const X=this.o([G.type]);this.k?.logOutgoing(X,0,1,f(G.type));return}case 201:case 202:case 204:case 203:{const X=this.o([G.type,G.id],G.data);this.k?.logOutgoing(X,G.id,1,f(G.type),G.data);return}}}o(G,X=void 0){const ee=new i;return c(ee,G),c(ee,X),this.p(ee.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const X=new I(G),ee=a(X),re=a(X),te=ee[0];switch(te){case 100:return this.k?.logIncoming(G.byteLength,ee[1],1,`${h(te)}: ${ee[2]}.${ee[3]}`,re),this.s({type:te,id:ee[1],channelName:ee[2],name:ee[3],arg:re});case 102:return this.k?.logIncoming(G.byteLength,ee[1],1,`${h(te)}: ${ee[2]}.${ee[3]}`,re),this.t({type:te,id:ee[1],channelName:ee[2],name:ee[3],arg:re});case 101:return this.k?.logIncoming(G.byteLength,ee[1],1,`${h(te)}`),this.u({type:te,id:ee[1]});case 103:return this.k?.logIncoming(G.byteLength,ee[1],1,`${h(te)}`),this.u({type:te,id:ee[1]})}}s(G){const X=this.b.get(G.channelName);if(!X){this.v(G);return}const ee=new A.CancellationTokenSource;let re;try{re=X.call(this.j,G.name,G.arg,ee.token)}catch(M){re=Promise.reject(M)}const te=G.id;re.then(M=>{this.m({id:te,data:M,type:201}),this.d.delete(G.id)},M=>{M instanceof Error?this.m({id:te,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.m({id:te,data:M,type:203}),this.d.delete(G.id)});const O=(0,S.toDisposable)(()=>ee.cancel());this.d.set(G.id,O)}t(G){const X=this.b.get(G.channelName);if(!X){this.v(G);return}const ee=G.id,te=X.listen(this.j,G.name,G.arg)(O=>this.m({id:ee,data:O,type:204}));this.d.set(G.id,te)}u(G){const X=this.d.get(G.id);X&&(X.dispose(),this.d.delete(G.id))}v(G){let X=this.g.get(G.channelName);X||(X=[],this.g.set(G.channelName,X));const ee=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:G,timeoutTimer:ee})}w(G){const X=this.g.get(G);if(X){for(const ee of X)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var w;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(G,X=null){this.l=G,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=X}getChannel(G){const X=this;return{call(ee,re,te){return X.a?Promise.reject(new R.CancellationError):X.m(G,ee,re,te)},listen(ee,re){return X.a?P.Event.None:X.o(G,ee,re)}}}m(G,X,ee,re=A.CancellationToken.None){const te=this.g++,M={id:te,type:100,channelName:G,name:X,arg:ee};if(re.isCancellationRequested)return Promise.reject(new R.CancellationError);let W;return new Promise((x,ie)=>{if(re.isCancellationRequested)return ie(new R.CancellationError);const J=()=>{const le=ye=>{switch(ye.type){case 201:this.f.delete(te),x(ye.data);break;case 202:{this.f.delete(te);const Se=new Error(ye.data.message);Se.stack=Array.isArray(ye.data.stack)?ye.data.stack.join(`
`):ye.data.stack,Se.name=ye.data.name,ie(Se);break}case 203:this.f.delete(te),ie(ye.data);break}};this.f.set(te,le),this.p(M)};let _=null;this.b===l.Idle?J():(_=(0,n.createCancelablePromise)(le=>this.u()),_.then(()=>{_=null,J()}));const se=()=>{_?(_.cancel(),_=null):this.p({id:te,type:101}),ie(new R.CancellationError)},ue=re.onCancellationRequested(se);W=(0,S.combinedDisposable)((0,S.toDisposable)(se),ue),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(G,X,ee){const re=this.g++,O={id:re,type:102,channelName:G,name:X,arg:ee};let M=null;const W=new P.Emitter({onWillAddFirstListener:()=>{M=(0,n.createCancelablePromise)(x=>this.u()),M.then(()=>{M=null,this.d.add(W),this.p(O)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.d.delete(W),this.p({id:re,type:103}))}}),B=x=>W.fire(x.data);return this.f.set(re,B),W.event}p(G){switch(G.type){case 100:case 102:{const X=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(X,G.id,0,`${h(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const X=this.q([G.type,G.id]);this.j?.logOutgoing(X,G.id,0,h(G.type));return}}}q(G,X=void 0){const ee=new i;return c(ee,G),c(ee,X),this.r(ee.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const X=new I(G),ee=a(X),re=a(X),te=ee[0];switch(te){case 200:return this.j?.logIncoming(G.byteLength,0,0,f(te)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,ee[1],0,f(te),re),this.t({type:ee[0],id:ee[1],data:re})}}t(G){if(G.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}pe([T.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class U{get connections(){const G=[];return this.f.forEach(X=>G.push(X)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new P.Emitter,this.onDidAddConnection=this.g.event,this.h=new P.Emitter,this.onDidRemoveConnection=this.h.event,G(({protocol:X,onDidClientDisconnect:ee})=>{P.Event.once(X.onMessage)(te=>{const O=new I(te),M=a(O),W=new u(X,M),B=new b(X);this.a.forEach((ie,J)=>W.registerChannel(J,ie));const x={channelServer:W,channelClient:B,ctx:M};this.f.add(x),this.g.fire(x),ee(()=>{W.dispose(),B.dispose(),this.f.delete(x),this.h.fire(x)})})})}getChannel(G,X){const ee=this;return{call(re,te,O){let M;if((0,p.isFunction)(X)){const B=(0,k.getRandomElement)(ee.connections.filter(X));M=B?Promise.resolve(B):P.Event.toPromise(P.Event.filter(ee.onDidAddConnection,X))}else M=X.routeCall(ee,re,te);const W=M.then(B=>B.channelClient.getChannel(G));return $(W).call(re,te,O)},listen(re,te){if((0,p.isFunction)(X))return ee.j(G,X,re,te);const O=X.routeEvent(ee,re,te).then(M=>M.channelClient.getChannel(G));return $(O).listen(re,te)}}}j(G,X,ee,re){const te=this;let O=new S.DisposableStore;const M=new P.Emitter({onWillAddFirstListener:()=>{O=new S.DisposableStore;const W=new P.EventMultiplexer,B=new Map,x=J=>{const se=J.channelClient.getChannel(G).listen(ee,re),ue=W.add(se);B.set(J,ue)},ie=J=>{const _=B.get(J);!_||(_.dispose(),B.delete(J))};te.connections.filter(X).forEach(x),P.Event.filter(te.onDidAddConnection,X)(x,void 0,O),te.onDidRemoveConnection(ie,void 0,O),W.event(M.fire,M,O),O.add(W)},onDidRemoveLastListener:()=>{O.dispose()}});return M.event}registerChannel(G,X){this.a.set(G,X),this.f.forEach(ee=>{ee.channelServer.registerChannel(G,X)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=U;class N{constructor(G,X,ee=null){const re=new i;c(re,X),G.send(re.buffer),this.a=new b(G,ee),this.d=new u(G,X,ee)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,X){this.d.registerChannel(G,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function $(q){return{call(G,X,ee){return q.then(re=>re.call(G,X,ee))},listen(G,X){const ee=new P.Relay;return q.then(re=>ee.input=re.listen(G,X)),ee.event}}}e.getDelayedChannel=$;function F(q){let G=!1;return{call(X,ee,re){return G?q.call(X,ee,re):(0,n.timeout)(0).then(()=>G=!0).then(()=>q.call(X,ee,re))},listen(X,ee){if(G)return q.listen(X,ee);const re=new P.Relay;return(0,n.timeout)(0).then(()=>G=!0).then(()=>re.input=q.listen(X,ee)),re.event}}}e.getNextTickChannel=F;class L{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const X of G.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await P.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.StaticRouter=L;var j;(function(q){function G(te,O){const M=te,W=O&&O.disableMarshalling,B=new Map;for(const x in M)ee(x)&&B.set(x,P.Event.buffer(M[x],!0));return new class{listen(x,ie,J){const _=B.get(ie);if(_)return _;if(re(ie)){const se=M[ie];if(typeof se=="function")return se.call(M,J)}throw new Error(`Event not found: ${ie}`)}call(x,ie,J){const _=M[ie];if(typeof _=="function"){if(!W&&Array.isArray(J))for(let se=0;se<J.length;se++)J[se]=(0,C.revive)(J[se]);return _.apply(M,J)}throw new Error(`Method not found: ${ie}`)}}}q.fromService=G;function X(te,O){const M=O&&O.disableMarshalling;return new Proxy({},{get(W,B){if(typeof B=="string")return O?.properties?.has(B)?O.properties.get(B):re(B)?function(x){return te.listen(B,x)}:ee(B)?te.listen(B):async function(...x){let ie;O&&!(0,p.isUndefinedOrNull)(O.context)?ie=[O.context,...x]:ie=x;const J=await te.call(B,ie);return M?J:(0,C.revive)(J)};throw new Error(`Property not found: ${String(B)}`)}})}q.toService=X;function ee(te){return te[0]==="o"&&te[1]==="n"&&E.isUpperAsciiLetter(te.charCodeAt(2))}function re(te){return/^onDynamic/.test(te)&&E.isUpperAsciiLetter(te.charCodeAt(9))}})(j=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const G=q.toString();if(G!=="[object Object]")return G}return q}function Q(q){return Array.isArray(q)?q.map(V):V(q)}function Y(q,G,X,ee,re,te,O){O=Q(O);const M=z[re],W=M[ee%M.length];let B=[`%c[${q}]%c[${String(G).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(te)?(B=B.concat(O),B.push(")")):B.push(O),console.log.apply(console,B)}class H{constructor(G,X){this.d=G,this.f=X,this.a=0,this.b=0}logOutgoing(G,X,ee,re,te){this.b+=G,Y(this.d,this.b,G,X,ee,re,te)}logIncoming(G,X,ee,re,te){this.a+=G,Y(this.f,this.a,G,X,ee,re,te)}}e.IPCLogger=H}),define(oe[148],ae([0,1,17,3,39]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(P){this.a=P,this.onMessage=n.Event.fromDOMEventEmitter(this.a,"message",S=>k.VSBuffer.wrap(S.data)),P.start()}send(P){this.a.postMessage(P.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class T extends D.IPCClient{constructor(P,S){const C=new A(P);super(C,S),this.b=C}dispose(){this.b.disconnect()}}e.Client=T}),define(oe[92],ae([0,1,6,17,3,2,39]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(b){b.Created="created",b.Read="read",b.Write="write",b.Open="open",b.Error="error",b.Close="close",b.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",b.NodeEndReceived="nodeEndReceived",b.NodeEndSent="nodeEndSent",b.NodeDrainBegin="nodeDrainBegin",b.NodeDrainEnd="nodeDrainEnd",b.zlibInflateError="zlibInflateError",b.zlibInflateData="zlibInflateData",b.zlibInflateInitialWrite="zlibInflateInitialWrite",b.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",b.zlibInflateWrite="zlibInflateWrite",b.zlibInflateFlushFired="zlibInflateFlushFired",b.zlibDeflateError="zlibDeflateError",b.zlibDeflateData="zlibDeflateData",b.zlibDeflateWrite="zlibDeflateWrite",b.zlibDeflateFlushFired="zlibDeflateFlushFired",b.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",b.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",b.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",b.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",b.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",b.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",b.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",b.ProtocolHeaderRead="protocolHeaderRead",b.ProtocolMessageRead="protocolMessageRead",b.ProtocolHeaderWrite="protocolHeaderWrite",b.ProtocolMessageWrite="protocolMessageWrite",b.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(b){b.enableDiagnostics=!1,b.records=[];const U=new WeakMap;let N=0;function $(L,j){if(!U.has(L)){const z=String(++N);U.set(L,z)}return U.get(L)}function F(L,j,z,V){if(!b.enableDiagnostics)return;const Q=$(L,j);if(V instanceof n.VSBuffer||V instanceof Uint8Array||V instanceof ArrayBuffer||ArrayBuffer.isView(V)){const Y=n.VSBuffer.alloc(V.byteLength);Y.set(V),b.records.push({timestamp:Date.now(),id:Q,label:j,type:z,buff:Y})}else b.records.push({timestamp:Date.now(),id:Q,label:j,type:z,data:V})}b.traceSocketEvent=F})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(b){b[b.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",b[b.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function E(){return C||(C=n.VSBuffer.alloc(0)),C}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(U){this.a.push(U),this.b+=U.byteLength}read(U){return this.c(U,!0)}peek(U){return this.c(U,!1)}c(U,N){if(U===0)return E();if(U>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===U){const j=this.a[0];return N&&(this.a.shift(),this.b-=U),j}if(this.a[0].byteLength>U){const j=this.a[0].slice(0,U);return N&&(this.a[0]=this.a[0].slice(U),this.b-=U),j}const $=n.VSBuffer.alloc(U);let F=0,L=0;for(;U>0;){const j=this.a[L];if(j.byteLength>U){const z=j.slice(0,U);$.set(z,F),F+=U,N&&(this.a[L]=j.slice(U),this.b-=U),U-=U}else $.set(j,F),F+=j.byteLength,N?(this.a.shift(),this.b-=j.byteLength):L++,U-=j.byteLength}return $}}e.ChunkStream=p;var g;(function(b){b[b.None=0]="None",b[b.Regular=1]="Regular",b[b.Control=2]="Control",b[b.Ack=3]="Ack",b[b.Disconnect=5]="Disconnect",b[b.ReplayRequest=6]="ReplayRequest",b[b.Pause=7]="Pause",b[b.Resume=8]="Resume",b[b.KeepAlive=9]="KeepAlive",b[b.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",b[b.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(g||(g={}));function h(b){switch(b){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var y;(function(b){b[b.HeaderLength=13]="HeaderLength",b[b.AcknowledgeTime=2e3]="AcknowledgeTime",b[b.TimeoutTime=2e4]="TimeoutTime",b[b.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",b[b.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",b[b.KeepAliveSendTime=5e3]="KeepAliveSendTime",b[b.LatencySampleTime=6e4]="LatencySampleTime",b[b.LatencySampleCount=5]="LatencySampleCount",b[b.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",b[b.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(U,N,$,F){this.type=U,this.id=N,this.ack=$,this.data=F,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends A.Disposable{constructor(U){super(),this.f=this.B(new D.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=U,this.b=!1,this.c=new p,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(U){if(!(!U||U.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(U);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,F=this.g.id,L=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new f($,F,L,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(U){this.k=null,this.a=!1,this.b=!1,this.c=U,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(U){if(this.a)return;U.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=n.VSBuffer.alloc(13);N.writeUInt8(U.type,0),N.writeUInt32BE(U.id,1),N.writeUInt32BE(U.ack,5),N.writeUInt32BE(U.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(U.type),id:U.id,ack:U.ack,messageSize:U.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",U.data),this.j(N,U.data)}g(U,N){const $=this.f===0;return this.d.push(U,N),this.f+=U.byteLength+N.byteLength,$}h(){const U=n.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,U}j(U,N){this.g(U,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const U=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:U.byteLength}),this.c.write(U)}}class m extends A.Disposable{constructor(U){super(),this.f=new D.Emitter,this.onMessage=this.f.event,this.g=new D.Emitter,this.onDidDispose=this.g.event,this.a=U,this.b=this.B(new d(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(U){this.b.write(new f(1,0,0,U))}}e.Protocol=m;class v extends T.IPCClient{static fromSocket(U,N){return new v(new m(U),N)}get onDidDispose(){return this.b.onDidDispose}constructor(U,N,$=null){super(U,N,$),this.b=U}dispose(){super.dispose();const U=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),U.end()}}e.Client=v;class I{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(U){this.b?this.d.length>0?this.d.push(U):this.a.fire(U):this.d.push(U)}flushBuffer(){this.d=[]}}e.BufferedEmitter=I;class i{constructor(U){this.data=U,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let U=0,N=this.a;for(;N;)N=N.next,U++;return U}peek(){return this.a?this.a.data:null}toArray(){const U=[];let N=0,$=this.a;for(;$;)U[N++]=$.data,$=$.next;return U}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(U){const N=new i(U);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const U=Date.now();for(let N=0;N<t.a;N++)this.c[N]=U-1e3*N;setInterval(()=>{for(let N=t.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const U=Date.now(),N=(1+t.a)*1e3;let $=0;for(let F=0;F<t.a;F++)U-this.c[F]<=N&&$++;return 1-$/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var s;(function(b){b[b.Good=0]="Good",b[b.Poor=1]="Poor"})(s=e.ConnectionHealth||(e.ConnectionHealth={}));function o(b){switch(b){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class c{constructor(U){this.connectionHealth=U}}e.ConnectionHealthChangedEvent=c;class a{constructor(U,N){this.roundTripTime=U,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=a;class u{get unacknowledgedCount(){return this.c-this.d}constructor(U){this.x=new I,this.onControlMessage=this.x.event,this.y=new I,this.onMessage=this.y.event,this.z=new I,this.onDidDispose=this.z.event,this.A=new I,this.onSocketClose=this.A.event,this.B=new I,this.onSocketTimeout=this.B.event,this.C=new I,this.onHighRoundTripTime=this.C.event,this.D=new I,this.onDidChangeConnectionHealth=this.D.event,this.u=U.loadEstimator??t.getInstance(),this.v=U.measureRoundTripTime??!1,this.w=U.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=U.socket,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),U.initialChunk&&this.q.acceptChunk(U.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const U=new f(5,0,0,E());this.p.write(U),this.p.flush()}sendPause(){const U=new f(7,0,0,E());this.p.write(U)}sendResume(){const U=new f(8,0,0,E());this.p.write(U)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(U,N){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=U,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage($=>this.E($))),this.t.add(this.o.onClose($=>this.A.fire($))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest($=>this.J($))),this.t.add(this.r.onHighRoundTripTime($=>this.C.fire($))),this.t.add(this.r.onDidChangeConnectionHealth($=>this.D.fire($))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const U=new f(3,0,this.h,E());this.p.write(U);const N=this.b.toArray();for(let $=0,F=N.length;$<F;$++)this.p.write(N[$]);this.G()}acceptDisconnect(){this.z.fire()}E(U){if(U.ack>this.d){this.d=U.ack;do{const N=this.b.peek();if(N&&N.id<=U.ack)this.b.pop();else break}while(!0)}switch(U.type){case 0:break;case 1:{if(U.id>this.g)if(U.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new f(6,0,0,E())))}else this.g=U.id,this.j=Date.now(),this.F(),this.y.fire(U.data);break}case 2:{this.x.fire(U.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let $=0,F=N.length;$<F;$++)this.p.write(N[$]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(U.data);break}case 11:{this.r.handleResponse(U.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(U){const N=++this.c;this.h=this.g;const $=new f(1,N,this.h,U);this.b.push($),this.a||(this.p.write($),this.G())}sendControl(U){const N=new f(2,0,0,U);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const U=Date.now()-this.j;if(U>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-U+5)}G(){if(this.c<=this.d||this.f||this.a)return;const U=this.b.peek(),N=Date.now()-U.writtenTime,$=Date.now()-this.q.lastReadTime,F=Date.now()-this.n;if(N>=2e4&&$>=2e4&&F>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:$});return}const L=Math.max(2e4-N,2e4-$,2e4-F,500);this.f=setTimeout(()=>{this.f=null,this.G()},L)}H(){if(this.g<=this.h)return;this.h=this.g;const U=new f(3,0,this.h,E());this.p.write(U)}I(){this.h=this.g;const U=new f(9,0,this.h,E());this.p.write(U)}J(U){this.h=this.g;const N=new f(10,0,this.h,U);this.p.write(N)}K(U){this.h=this.g;const N=new f(11,0,this.h,U);this.p.write(N)}}e.PersistentProtocol=u;class w extends A.Disposable{constructor(){super(),this.a=this.B(new D.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new D.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new D.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new k.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},U=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const U=++this.h,N=n.VSBuffer.alloc(4);N.writeUInt32BE(U,0),this.a.fire(N)},6e4)}handleResponse(U){if(U.byteLength!==4)return;const N=U.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const $=Date.now()-this.g,F=this.k++;this.j[F%this.j.length]=$;const L=this.l,j=this.j.filter(z=>z>=1e3).length;this.l=j>=3?1:0,$>1e3&&this.b.fire(new a($,j)),L!==this.l&&this.c.fire(this.l)}}}),define(oe[149],ae([0,1,93,3,39,148]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends D.IPCServer{static b(){const P=n.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(S,C)=>C);return n.Event.map(P,S=>{const{port1:C,port2:E}=new MessageChannel,g={protocol:new A.Protocol(C),onDidClientDisconnect:n.Event.fromDOMEventEmitter(C,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[E]),g})}constructor(){super(T.b())}}e.Server=T}),define(oe[68],ae([0,1,50,6,17,23,142,9,3,2,32,91,87,39]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends g.ChannelServer{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",d=>D.VSBuffer.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=h;class y{constructor(l,d){this.i=l,this.j=d,this.c=new Set,this.g=new Map,this.h=new P.Emitter,this.onDidProcessExit=this.h.event;const m=d&&d.timeout?d.timeout:6e4;this.b=new n.Delayer(m),this.d=null,this.f=null}getChannel(l){const d=this;return{call(m,v,I){return d.k(l,m,v,I)},listen(m,v){return d.l(l,m,v)}}}k(l,d,m,v=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const I=this.n(l),i=(0,n.createCancelablePromise)(s=>I.call(d,m,s)),r=v.onCancellationRequested(()=>i.cancel()),t=(0,S.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,d,m){if(!this.b)return P.Event.None;this.b.cancel();let v;const I=new P.Emitter({onWillAddFirstListener:()=>{v=this.n(l).listen(d,m)(I.fire,I),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return I.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(d.env),this.d=(0,k.fork)(this.i,l,d);const m=new P.Emitter;P.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.j.serverName}`);return}m.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const I=this.j.useQueue?(0,E.createQueuedSender)(this.d):this.d,i=o=>this.d&&this.d.connected&&I.send(o.buffer.toString("base64")),r=m.event,t={send:i,onMessage:r};this.f=new g.ChannelClient(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,S.dispose)(a)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(l){let d=this.g.get(l);return d||(d=this.m.getChannel(l),this.g.set(l,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=y}),define(oe[150],ae([0,1,17,9,3,2,12,5,31,39,92]),function(Z,e,k,n,D,A,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function E(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class p{traceSocketEvent(a,u){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,u)}constructor(a,u=""){this.f=!0,this.debugLabel=u,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,n.onUnexpectedError)(w)}},this.socket.on("error",this.a),this.b=w=>{this.traceSocketEvent("close",{hadError:w}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const u=w=>{this.traceSocketEvent("read",w),a(k.VSBuffer.wrap(w))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(a){const u=w=>{a({type:0,hadError:w,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(a){const u=()=>{a()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,n.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,n.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=p;var g;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var h;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(h||(h={}));class y extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,u){this.socket.traceSocketEvent(a,u)}constructor(a,u,w,b){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:w?.byteLength||0,recordInflateBytes:b}),this.a=this.B(new f(this,u,w,b,this.f,(U,N)=>this.k(U,N))),this.B(this.a.onError(U=>{console.error(U),(0,n.onUnexpectedError)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new C.ChunkStream,this.B(this.socket.onData(U=>this.l(U))),this.B(this.socket.onClose(U=>this.g.fire(U)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this.a.writeMessage(a)}k(a,u){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let w=2;a.byteLength<126?w+=0:a.byteLength<2**16?w+=2:w+=8;const b=k.VSBuffer.alloc(w);if(u?b.writeUInt8(194,0):b.writeUInt8(130,0),a.byteLength<126)b.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){b.writeUInt8(126,1);let U=1;b.writeUInt8(a.byteLength>>>8&255,++U),b.writeUInt8(a.byteLength>>>0&255,++U)}else{b.writeUInt8(127,1);let U=1;b.writeUInt8(0,++U),b.writeUInt8(0,++U),b.writeUInt8(0,++U),b.writeUInt8(0,++U),b.writeUInt8(a.byteLength>>>24&255,++U),b.writeUInt8(a.byteLength>>>16&255,++U),b.writeUInt8(a.byteLength>>>8&255,++U),b.writeUInt8(a.byteLength>>>0&255,++U)}this.socket.write(k.VSBuffer.concat([b,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const u=this.b.peek(this.j.readLen),w=u.readUInt8(0),b=(w&128)>>>7,U=(w&64)>>>6,N=u.readUInt8(1),$=(N&128)>>>7,F=N&127;this.j.state=2,this.j.readLen=2+($?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=b,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(U)),this.j.firstFrameOfMessage=Boolean(b),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const u=this.b.read(this.j.readLen),w=u.readUInt8(1),b=(w&128)>>>7;let U=w&127,N=1;U===126?U=u.readUInt8(++N)*2**8+u.readUInt8(++N):U===127&&(U=u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N));let $=0;b&&($=u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N)),this.j.state=3,this.j.readLen=U,this.j.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const u=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),m(u,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(u,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class f extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(a,u,w,b,U,N){super(),this.k=a,this.l=U,this.m=N,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,u?(this.b=this.B(new l(this.k,b,w,{windowBits:15})),this.f=this.B(new d(this.k,{windowBits:15})),this.B(this.b.onError($=>this.a.fire($))),this.B(this.f.onError($=>this.a.fire($)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const u=await this.r(this.f,a);this.m(u,!0)}else this.m(a,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(a,u){return new Promise((w,b)=>{a.write(u),a.flush(U=>w(U))})}acceptFrame(a,u,w){this.h.push({data:a,isCompressed:u,isLastFrameOfMessage:w}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const u=await this.u(this.b,a.data,a.isLastFrameOfMessage);this.l.fire(u)}else this.l.fire(a.data)}this.s=!1}}u(a,u,w){return new Promise((b,U)=>{a.write(u),w&&a.write(k.VSBuffer.fromByteArray([0,0,255,255])),a.flush(N=>b(N))})}}class l extends A.Disposable{get recordedInflateBytes(){return this.j?k.VSBuffer.concat(this.f):k.VSBuffer.alloc(0)}constructor(a,u,w,b){super(),this.h=a,this.j=u,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=E().zlib.createInflateRaw(b),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(k.VSBuffer.wrap(U))}),w&&(this.h.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this.b.write(w.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const u=k.VSBuffer.concat(this.g);this.g.length=0,a(u)})}}class d extends A.Disposable{constructor(a,u){super(),this.g=a,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=E().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",w=>{this.g.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.g.traceSocketEvent("zlibDeflateData",w),this.f.push(k.VSBuffer.wrap(w))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let u=k.VSBuffer.concat(this.f);this.f.length=0,u=u.slice(0,u.byteLength-4),a(u)})}}function m(c,a){if(a===0)return;const u=c.byteLength>>>2;for(let F=0;F<u;F++){const L=c.readUInt32BE(F*4);c.writeUInt32BE(L^a,F*4)}const w=u*4,b=c.byteLength-w,U=a>>>24&255,N=a>>>16&255,$=a>>>8&255;b>=1&&c.writeUInt8(c.readUInt8(w)^U,w),b>=2&&c.writeUInt8(c.readUInt8(w+1)^N,w+1),b>=3&&c.writeUInt8(c.readUInt8(w+2)^$,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const v={[2]:107,[1]:103};function I(){const c=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):a=(0,T.join)(E().os.tmpdir(),`vscode-ipc-${c}.sock`),r(a),a}e.createRandomIPCHandle=I;function i(c,a,u){const w=E().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${u}-${a}-sock`;let b;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?b=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${w.substr(0,8)}-${u}-${a}.sock`):b=(0,T.join)(c,`${u}-${a}.sock`),r(b),b}e.createStaticIPCHandle=i;function r(c){const a=v[R.platform];typeof a=="number"&&c.length>=a&&console.warn(`WARNING: IPC handle "${c}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static b(a){const u=D.Event.fromNodeEventEmitter(a,"connection");return D.Event.map(u,w=>({protocol:new C.Protocol(new p(w,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(w,"close"))}))}constructor(a){super(t.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function s(c){return new Promise((a,u)=>{const w=E().net.createServer();w.on("error",u),w.listen(c,()=>{w.removeListener("error",u),a(new t(w))})})}e.serve=s;function o(c,a){return new Promise((u,w)=>{const b=E().net.createConnection(c,()=>{b.removeListener("error",w),u(C.Client.fromSocket(new p(b,`ipc-client${a}`),a))});b.once("error",w)})}e.connect=o}),define(oe[69],ae([0,1,6,3,2,14]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T=e.StorageHint||(e.StorageHint={}));function R(E){const p=E;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var P;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class S extends D.Disposable{constructor(p,g=Object.create(null)){super(),this.m=p,this.n=g,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=P.None,this.f=new Map,this.g=new k.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(p=>this.r(p)))}r(p){p.changed?.forEach((g,h)=>this.s(h,g)),p.deleted?.forEach(g=>this.s(g,void 0))}s(p,g){if(this.c===P.Closed)return;let h=!1;(0,A.isUndefinedOrNull)(g)?h=this.f.delete(p):this.f.get(p)!==g&&(this.f.set(p,g),h=!0),h&&this.b.fire(p)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===P.None&&(this.c=P.Initialized,this.n.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(p,g){const h=this.f.get(p);return(0,A.isUndefinedOrNull)(h)?g:h}getBoolean(p,g){const h=this.get(p);return(0,A.isUndefinedOrNull)(h)?g:h==="true"}getNumber(p,g){const h=this.get(p);return(0,A.isUndefinedOrNull)(h)?g:parseInt(h,10)}async set(p,g){if(this.c===P.Closed)return;if((0,A.isUndefinedOrNull)(g))return this.delete(p);const h=String(g);if(this.f.get(p)!==h)return this.f.set(p,h),this.j.set(p,h),this.h.delete(p),this.b.fire(p),this.w()}async delete(p){if(!(this.c===P.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire(p),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=P.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(p).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(p){if(!!this.u)return this.w(p)}async w(p){return this.g.trigger(()=>this.v(),p)}async whenFlushed(){if(!!this.u)return new Promise(p=>this.l.push(p))}isInMemory(){return this.n.hint===T.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=S,S.a=100;class C{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((g,h)=>this.a.set(h,g)),p.delete?.forEach(g=>this.a.delete(g))}async close(){}}e.InMemoryStorageDatabase=C}),define(oe[151],ae([10,11]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(oe[152],ae([10,11]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[153],ae([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(oe[154],ae([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(oe[155],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[156],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[157],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[158],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[159],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(oe[160],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[161],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[162],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[163],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(oe[164],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(oe[165],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(oe[166],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[167],ae([10,11]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[168],ae([10,11]),function(Z,e){return Z.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(oe[169],ae([10,11]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(oe[170],ae([10,11]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(oe[171],ae([10,11]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[172],ae([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[173],ae([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[174],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[175],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[176],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[177],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[178],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[179],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[180],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[181],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[182],ae([10,11]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(oe[94],ae([0,1,65,63,24,12,36,22,7]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,A.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,A.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?P.URI.file((0,A.resolve)(h)):P.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const y=T.env.VSCODE_EXTENSIONS;if(y)return y;const f=T.env.VSCODE_PORTABLE;return f?(0,A.join)(f,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(y=>/^[^:/?#]+?:\/\//.test(y)?P.URI.parse(y):P.URI.file((0,A.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const y of this.args.log||[]){const f=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);f&&f[1]&&f[2]&&h.push([f[1],f[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=T.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,y,f){this.a=h,this.b=y,this.c=f,this.editSessionId=this.args.editSessionId}}pe([n.memoize],S.prototype,"appRoot",null),pe([n.memoize],S.prototype,"userHome",null),pe([n.memoize],S.prototype,"userDataPath",null),pe([n.memoize],S.prototype,"appSettingsHome",null),pe([n.memoize],S.prototype,"tmpDir",null),pe([n.memoize],S.prototype,"cacheHome",null),pe([n.memoize],S.prototype,"stateResource",null),pe([n.memoize],S.prototype,"userRoamingDataHome",null),pe([n.memoize],S.prototype,"userDataSyncHome",null),pe([n.memoize],S.prototype,"userDataSyncLogResource",null),pe([n.memoize],S.prototype,"editSessionsLogResource",null),pe([n.memoize],S.prototype,"sync",null),pe([n.memoize],S.prototype,"machineSettingsResource",null),pe([n.memoize],S.prototype,"workspaceStorageHome",null),pe([n.memoize],S.prototype,"localHistoryHome",null),pe([n.memoize],S.prototype,"keyboardLayoutResource",null),pe([n.memoize],S.prototype,"argvResource",null),pe([n.memoize],S.prototype,"isExtensionDevelopment",null),pe([n.memoize],S.prototype,"untitledWorkspacesHome",null),pe([n.memoize],S.prototype,"installSourcePath",null),pe([n.memoize],S.prototype,"builtinExtensionsPath",null),pe([n.memoize],S.prototype,"extensionsPath",null),pe([n.memoize],S.prototype,"extensionDevelopmentLocationURI",null),pe([n.memoize],S.prototype,"extensionDevelopmentKind",null),pe([n.memoize],S.prototype,"extensionTestsLocationURI",null),pe([n.memoize],S.prototype,"debugExtensionHost",null),pe([n.memoize],S.prototype,"logLevel",null),pe([n.memoize],S.prototype,"extensionLogLevel",null),pe([n.memoize],S.prototype,"serviceMachineIdResource",null),pe([n.memoize],S.prototype,"telemetryLogResource",null),pe([n.memoize],S.prototype,"disableWorkspaceTrust",null),pe([n.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function C(g,h){return p(g["inspect-extensions"],g["inspect-brk-extensions"],5870,h,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=C;function E(g,h){return p(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,h,g.extensionEnvironment)}e.parsePtyHostPort=E;function p(g,h,y,f,l,d){const v=Number(h||g)||(f?null:y),I=v?Boolean(!!h):!1;let i;if(d)try{i=JSON.parse(d)}catch{}return{port:v,break:I,debugId:l,env:i}}}),define(oe[183],ae([0,1,285,5,153]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(y,f,l=T){const d=y.find(c=>c.length>0&&c[0]!=="-"),m={},v=["_"],I=[],i={};let r;for(const c in f){const a=f[c];a.type==="subcommand"?c===d&&(r=a):(a.alias&&(m[c]=a.alias),a.type==="string"||a.type==="string[]"?(v.push(c),a.deprecates&&v.push(...a.deprecates)):a.type==="boolean"&&(I.push(c),a.deprecates&&I.push(...a.deprecates)),a.global&&(i[c]=a))}if(r&&d){const c=i;for(const b in r.options)c[b]=r.options[b];const a=y.filter(b=>b!==d),u=l.getSubcommandReporter?l.getSubcommandReporter(d):void 0,w=R(a,c,u);return{[d]:w,_:[]}}const t=k(y,{string:v,boolean:I,alias:m}),s={},o=t;s._=t._.map(c=>String(c)).filter(c=>c.length>0),delete o._;for(const c in f){const a=f[c];if(a.type==="subcommand")continue;a.alias&&delete o[a.alias];let u=o[c];if(a.deprecates)for(const w of a.deprecates)o.hasOwnProperty(w)&&(u||(u=o[w],u&&l.onDeprecatedOption(w,a.deprecationMessage||(0,D.localize)(36,null,c))),delete o[w]);if(typeof u<"u"){if(a.type==="string[]"){if(Array.isArray(u)||(u=[u]),!a.allowEmptyValue){const w=u.filter(b=>b.length>0);w.length!==u.length&&(l.onEmptyValue(c),u=w.length>0?w:void 0)}}else a.type==="string"&&(Array.isArray(u)?(u=u.pop(),l.onMultipleValues(c,u)):!u&&!a.allowEmptyValue&&(l.onEmptyValue(c),u=void 0));s[c]=u,a.deprecationMessage&&l.onDeprecatedOption(c,a.deprecationMessage)}delete o[c]}for(const c in o)l.onUnknownOption(c);return s}e.parseArgs=R;function P(y,f){let l="";return f.args&&(Array.isArray(f.args)?l=` <${f.args.join("> <")}>`:l=` <${f.args}>`),f.alias?`-${f.alias} --${y}${l}`:`--${y}${l}`}function S(y,f){const l=[];for(const d in y){const m=y[d],v=P(d,m);l.push([v,m.description])}return C(l,f)}e.formatOptions=S;function C(y,f){const d=y.reduce((I,i)=>Math.max(I,i[0].length),12)+2+1;if(f-d<25)return y.reduce((I,i)=>I.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const m=f-d-1,v=[];for(const I of y){const i=I[0],r=p(I[1],m),t=E(d-i.length-2);v.push("  "+i+t+r[0]);for(let s=1;s<r.length;s++)v.push(E(d)+r[s])}return v}function E(y){return" ".repeat(y)}function p(y,f){const l=[];for(;y.length;){const d=y.length<f?y.length:y.lastIndexOf(" ",f),m=y.slice(0,d).trim();y=y.slice(d),l.push(m)}return l}function g(y,f,l,d,m){const v=process.stdout.isTTY&&process.stdout.columns||80,I=m?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",i=[`${y} ${l}`];i.push(""),i.push(`${(0,D.localize)(38,null)}: ${f} [${(0,D.localize)(39,null)}]${I}`),i.push(""),m?.noPipe!==!0&&(n.isWindows?i.push((0,D.localize)(40,null,f)):i.push((0,D.localize)(41,null,f)),i.push(""));const r={},t=[];for(const s in d){const o=d[s];if(o.type==="subcommand")o.description&&t.push({command:s,description:o.description});else if(o.description&&o.cat){let c=r[o.cat];c||(r[o.cat]=c={}),c[s]=o}}for(const s in r){const o=s,c=r[o];c&&(i.push(A[o]),i.push(...S(c,v)),i.push(""))}return t.length&&(i.push((0,D.localize)(42,null)),i.push(...C(t.map(s=>[s.command,s.description]),v)),i.push("")),i.join(`
`)}e.buildHelpMessage=g;function h(y,f){return`${y||(0,D.localize)(43,null)}
${f||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=h}),define(oe[184],ae([0,1,286,154,183]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function T(p,g){const h=(v,I)=>{console.warn((0,n.localize)(0,null,v,I))},y=v=>{console.warn((0,n.localize)(1,null,v))},f=(v,I)=>{console.warn((0,n.localize)(2,null,v,I))},l=v=>({onUnknownOption:I=>{v!=="tunnel"&&console.warn((0,n.localize)(3,null,I,v))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:f,getSubcommandReporter:v!=="tunnel"?l:void 0}),d={onUnknownOption:v=>{console.warn((0,n.localize)(4,null,v))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:f,getSubcommandReporter:l},m=(0,D.parseArgs)(p,D.OPTIONS,g?d:void 0);return m.goto&&m._.forEach(v=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,n.localize)(5,null))),m["max-memory"]&&k(parseInt(m["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),m}function R(p){const g=p.findIndex(h=>!/^-/.test(h));if(g>-1)return[...p.slice(0,g),...p.slice(g+1)]}function P(p){let[,...g]=p;process.env.VSCODE_DEV&&(g=R(g)||[]);const h=!E(process.env);return T(g,h)}e.parseMainProcessArgv=P;function S(p){let[,,...g]=p;return process.env.VSCODE_DEV&&(g=R(g)||[]),T(g,!0)}e.parseCLIProcessArgv=S;function C(p,...g){const h=p.indexOf("--");return h===-1?p.push(...g):p.splice(h,0,...g),p}e.addArg=C;function E(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function Z(e,k,n){function D(T,R){const P=A(T,R),S=[P];return e.isAbsolute(P)||S.unshift(n),e.resolve(...S)}function A(T,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,R);const C=T["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(E,"AppData","Roaming")}break;case"darwin":S=e.join(k.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,R)}return{getUserDataPath:D}}if(typeof define=="function")define(oe[185],ae([287,34,36]),function(e,k,n){return Z(e,k,n.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=Z(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[186],ae([0,1,34,94,185]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends n.AbstractNativeEnvironmentService{constructor(R,P){super(R,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,D.getUserDataPath)(R,P.nameShort)},P)}}e.NativeEnvironmentService=A}),define(oe[187],ae([0,1,7]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(f){const l=f.match(T);return l?l[1]:null}function C(f){if(f.indexOf("://")===-1){const l=f.match(n);return l?S(l[2]):null}try{const l=k.URI.parse(f);if(l.authority)return S(l.authority)}catch{}return null}function E(f,l){const d=new Set;let m;for(;m=R.exec(f);){const I=C(m[1]);I&&d.add(I)}const v=new Set(l);return Array.from(d).map(I=>v.has(I)?I:I.replace(P,"a"))}e.getDomainsOfRemotes=E;function p(f){const l=f.match(A);return l?l[2]:null}function g(f,l,d){return f&&l?(d&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${f}${l}`:`${f}/${l}`):null}function h(f,l){if(f.indexOf("://")===-1){const d=f.match(D);if(d)return g(d[2],d[3],l)}try{const d=k.URI.parse(f);if(d.authority)return g(p(d.authority),d.path,l)}catch{}return null}function y(f,l=!1){const d=[];let m;for(;m=R.exec(f);){const v=h(m[1],l);v&&d.push(v)}return d}e.getRemotes=y}),define(oe[188],ae([0,1,14,157]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(T,R,P){try{A(T,R,P)}catch(S){console.error(S?.message??S)}return T}e.localizeManifest=D;function A(T,R,P){const S=(C,E,p)=>{const g=C[E];if((0,k.isString)(g)){const h=g,y=h.length;if(y>1&&h[0]==="%"&&h[y-1]==="%"){const f=h.substr(1,y-2);let l=R[f];l===void 0&&P&&(l=P[f]);const d=typeof l=="string"?l:l?.message,m=P?.[f],v=typeof m=="string"?m:m?.message;if(!d){v||console.warn(`[${T.name}]: ${(0,n.localize)(0,null,f)}`);return}if(p&&(E==="title"||E==="category")&&v&&v!==d){const I={value:d,original:v};C[E]=I}else C[E]=d}}else if((0,k.isObject)(g))for(const h in g)g.hasOwnProperty(h)&&(h==="commands"?S(g,h,!0):S(g,h,p));else if(Array.isArray(g))for(let h=0;h<g.length;h++)S(g,h,p)};for(const C in T)T.hasOwnProperty(C)&&S(T,C)}}),define(oe[189],ae([0,1,9]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class n{constructor(){this.a=new Map}register(A,T){this.a.set(A,T)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const T in A.contributes){const R=this.a.get(T);if(!R)continue;const P=A.contributes[T],S=Array.isArray(P)?P:[P];try{R(S,A.activationEvents)}catch(C){(0,k.onUnexpectedError)(C)}}}}e.ImplicitActivationEventsImpl=n,e.ImplicitActivationEvents=new n}),define(oe[190],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,T,R,P){return this.a.call("promptImportantExtensionsInstallNotification",[A,T,R,P])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class n{constructor(A){this.a=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(oe[70],ae([0,1,22,88,162,54]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(l){return l=l.trim(),l==="*"||T.test(l)}e.isValidVersionStr=P;function S(l){if(!P(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(T);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=S;function C(l){if(!l)return null;const d=l.majorBase,m=l.majorMustEqual,v=l.minorBase;let I=l.minorMustEqual;const i=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(d===0||(I=!1),r=!1);let t=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,o,c,a]=s;t=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:d,majorMustEqual:m,minorBase:v,minorMustEqual:I,patchBase:i,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=C;function E(l,d,m){let v;typeof l=="string"?v=C(S(l)):v=l;let I;d instanceof Date?I=d.getTime():typeof d=="string"&&(I=new Date(d).getTime());let i;if(typeof m=="string"?i=C(S(m)):i=m,!v||!i)return!1;const r=v.majorBase,t=v.minorBase,s=v.patchBase;let o=i.majorBase,c=i.minorBase,a=i.patchBase;const u=i.notBefore;let w=i.majorMustEqual,b=i.minorMustEqual,U=i.patchMustEqual;return i.isMinimum?r>o?!0:r<o?!1:t>c?!0:t<c||I&&I<u?!1:s>=a:(r===1&&o===0&&(!w||!b||!U)&&(o=1,c=0,a=0,w=!0,b=!1,U=!1),r<o?!1:r>o?!w:t<c?!1:t>c?!b:s<a?!1:s>a?!U:!(I&&I<u))}e.isValidVersion=E;function p(l,d,m,v,I){const i=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return i.push([n.default.Error,D.localize(0,null)]),i;if(typeof v.name!="string")return i.push([n.default.Error,D.localize(1,null,"name")]),i;if(typeof v.version!="string")return i.push([n.default.Error,D.localize(2,null,"version")]),i;if(!v.engines)return i.push([n.default.Error,D.localize(3,null,"engines")]),i;if(typeof v.engines.vscode!="string")return i.push([n.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof v.extensionDependencies<"u"&&!f(v.extensionDependencies))return i.push([n.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof v.activationEvents<"u"){if(!f(v.activationEvents))return i.push([n.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof v.main>"u"&&typeof v.browser>"u")return i.push([n.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&i.push([n.default.Warning,D.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return i.push([n.default.Error,D.localize(9,null,"main")]),i;{const s=(0,k.joinPath)(m,v.main);(0,k.isEqualOrParent)(s,m)||i.push([n.default.Warning,D.localize(10,null,s.path,m.path)])}if(typeof v.activationEvents>"u")return i.push([n.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof v.browser<"u"){if(typeof v.browser!="string")return i.push([n.default.Error,D.localize(12,null,"browser")]),i;{const s=(0,k.joinPath)(m,v.browser);(0,k.isEqualOrParent)(s,m)||i.push([n.default.Warning,D.localize(13,null,s.path,m.path)])}if(typeof v.activationEvents>"u")return i.push([n.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!A.valid(v.version))return i.push([n.default.Error,D.localize(15,null)]),i;const r=[];if(!g(l,d,v,I,r))for(const s of r)i.push([n.default.Error,s]);return i}e.validateExtensionManifest=p;function g(l,d,m,v,I){return v||typeof m.main>"u"&&typeof m.browser>"u"?!0:y(l,d,m.engines.vscode,I)}e.isValidExtensionVersion=g;function h(l,d,m){return l==="*"||y(d,m,l)}e.isEngineValid=h;function y(l,d,m,v=[]){const I=C(S(m));if(!I)return v.push(D.localize(16,null,m)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return v.push(D.localize(17,null,m)),!1}else if(!I.majorMustEqual)return v.push(D.localize(18,null,m)),!1;return E(l,d,I)?!0:(v.push(D.localize(19,null,l,m)),!1)}function f(l){if(!Array.isArray(l))return!1;for(let d=0,m=l.length;d<m;d++)if(typeof l[d]!="string")return!1;return!0}}),define(oe[45],ae([0,1,17,31]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(A,T,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const C=(await T.readFile(A.serviceMachineIdResource)).value.toString();P=(0,n.isUUID)(C)?C:null}catch{P=null}if(!P){P=(0,n.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,k.VSBuffer.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=D}),define(oe[55],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(D,A=[],T=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=k}),define(oe[71],ae([0,1,55]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const n=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function A(R,P,S){P instanceof k.SyncDescriptor||(P=new k.SyncDescriptor(P,[],Boolean(S))),n.push([R,P])}e.registerSingleton=A;function T(){return n}e.getSingletonServiceDescriptors=T}),define(oe[191],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class n{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const T of this.a.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const R=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(T);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(A){const T=this.b(A);this.a.delete(T);for(const R of this.a.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(A){const T=this.b(A);let R=this.a.get(T);return R||(R=new k(T,A),this.a.set(T,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[T,R]of this.a)A.push(`${T}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this.a){const R=new Set([A]),P=this.c(T,R);if(P)return P}}c(A,T){for(const[R,P]of A.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const S=this.c(P,T);if(S)return S;T.delete(R)}}}e.Graph=n}),define(oe[4],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(k=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(T,R,P){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:T,index:P}):(R[k.DI_DEPENDENCIES]=[{id:T,index:P}],R[k.DI_TARGET]=R)}function D(T){if(k.serviceIds.has(T))return k.serviceIds.get(T);const R=function(P,S,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,P,C)};return R.toString=()=>T,k.serviceIds.set(T,R),R}e.createDecorator=D;function A(T){return T}e.refineServiceDecorator=A}),define(oe[192],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(oe[16],ae([0,1,14,7,4]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof n.URI)}e.isConfigurationOverrides=A;function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function S(l,d){const m=Object.create(null);for(const v in l)C(m,v,l[v],d);return m}e.toValuesTree=S;function C(l,d,m,v){const I=d.split("."),i=I.pop();let r=l;for(let t=0;t<I.length;t++){const s=I[t];let o=r[s];switch(typeof o){case"undefined":o=r[s]=Object.create(null);break;case"object":break;default:v(`Ignoring ${d} as ${I.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[i]=m}catch{v(`Ignoring ${d} as ${I.join(".")} is ${JSON.stringify(r)}`)}else v(`Ignoring ${d} as ${I.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=C;function E(l,d){const m=d.split(".");p(l,m)}e.removeFromValueTree=E;function p(l,d){const m=d.shift();if(d.length===0){delete l[m];return}if(Object.keys(l).indexOf(m)!==-1){const v=l[m];typeof v=="object"&&!Array.isArray(v)&&(p(v,d),Object.keys(v).length===0&&delete l[m])}}function g(l,d,m){function v(r,t){let s=r;for(const o of t){if(typeof s!="object"||s===null)return;s=s[o]}return s}const I=d.split("."),i=v(l,I);return typeof i>"u"?m:i}e.getConfigurationValue=g;function h(l,d,m){Object.keys(d).forEach(v=>{v!=="__proto__"&&(v in l?k.isObject(l[v])&&k.isObject(d[v])?h(l[v],d[v],m):m&&(l[v]=d[v]):l[v]=d[v])})}e.merge=h;function y(l,d,m){const v=l.inspect(d),I=l.inspect(m);return typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:typeof I.userValue<"u"||typeof I.workspaceValue<"u"||typeof I.workspaceFolderValue<"u"?I.value:v.defaultValue}e.getMigratedSettingValue=y;function f(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(oe[193],ae([0,1,5,27,4]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",k.isEdge),A.set("isFirefox",k.isFirefox),A.set("isChrome",k.isChrome),A.set("isSafari",k.isSafari);const T=Object.prototype.hasOwnProperty;var R;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return E.INSTANCE}static true(){return p.INSTANCE}static has(L){return g.create(L)}static equals(L,j){return h.create(L,j)}static notEquals(L,j){return l.create(L,j)}static regex(L,j){return t.create(L,j)}static in(L,j){return y.create(L,j)}static notIn(L,j){return f.create(L,j)}static not(L){return d.create(L)}static and(...L){return c.create(L,null,!0)}static or(...L){return a.create(L,null,!0)}static greater(L,j){return v.create(L,j)}static greaterEquals(L,j){return I.create(L,j)}static smaller(L,j){return i.create(L,j)}static smallerEquals(L,j){return r.create(L,j)}static deserialize(L,j=!1){if(!!L)return this.c(L,j)}static c(L,j){const z=L.split("||");return a.create(z.map(V=>this.d(V,j)),null,!0)}static d(L,j){const z=L.split("&&");return c.create(z.map(V=>this.f(V,j)),null,!0)}static f(L,j){if(L=L.trim(),L.indexOf("!=")>=0){const z=L.split("!=");return l.create(z[0].trim(),this.g(z[1],j))}if(L.indexOf("==")>=0){const z=L.split("==");return h.create(z[0].trim(),this.g(z[1],j))}if(L.indexOf("=~")>=0){const z=L.split("=~");return t.create(z[0].trim(),this.h(z[1],j))}if(L.indexOf(" not in ")>=0){const z=L.split(" not in ");return f.create(z[0].trim(),this.g(z[1],j))}if(L.indexOf(" in ")>=0){const z=L.split(" in ");return y.create(z[0].trim(),this.g(z[1],j))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const z=L.split(">=");return I.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const z=L.split(">");return v.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const z=L.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const z=L.split("<");return i.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(L)?d.create(L.substr(1).trim()):g.create(L)}static g(L,j){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const z=/^'([^']*)'$/.exec(L);return z?z[1].trim():L}static h(L,j){if((0,n.isFalsyOrWhitespace)(L)){if(j)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=L.indexOf("/"),V=L.lastIndexOf("/");if(z===V||z<0){if(j)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const Q=L.slice(z+1,V),Y=L[V+1]==="i"?"i":"";try{return new RegExp(Q,Y)}catch(H){if(j)throw new Error(`bad regexp-value '${L}', parse error: ${H}`);return console.warn(`bad regexp-value '${L}', parse error: ${H}`),null}}}e.ContextKeyExpr=P;function S(F,L){const j=F?F.substituteConstants():void 0,z=L?L.substituteConstants():void 0;return!j&&!z?!0:!j||!z?!1:j.equals(z)}e.expressionsAreEqualWithConstantSubstitution=S;function C(F,L){return F.cmp(L)}class E{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class p{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class g{static create(L,j=null){const z=A.get(L);return typeof z=="boolean"?z?p.INSTANCE:E.INSTANCE:new g(L,j)}constructor(L,j){this.key=L,this.c=j,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:w(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=A.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:E.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=g;class h{static create(L,j,z=null){if(typeof j=="boolean")return j?g.create(L,z):d.create(L,z);const V=A.get(L);return typeof V=="boolean"?j===(V?"true":"false")?p.INSTANCE:E.INSTANCE:new h(L,j,z)}constructor(L,j,z){this.c=L,this.d=j,this.f=z,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:b(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const j=L?"true":"false";return this.d===j?p.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class y{static create(L,j){return new y(L,j)}constructor(L,j){this.d=L,this.f=j,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:b(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const j=L.getValue(this.f),z=L.getValue(this.d);return Array.isArray(j)?j.includes(z):typeof z=="string"&&typeof j=="object"&&j!==null?T.call(j,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=y;class f{static create(L,j){return new f(L,j)}constructor(L,j){this.d=L,this.f=j,this.type=11,this.c=y.create(L,j)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=f;class l{static create(L,j,z=null){if(typeof j=="boolean")return j?d.create(L,z):g.create(L,z);const V=A.get(L);return typeof V=="boolean"?j===(V?"true":"false")?E.INSTANCE:p.INSTANCE:new l(L,j,z)}constructor(L,j,z){this.c=L,this.d=j,this.f=z,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:b(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const j=L?"true":"false";return this.d===j?E.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class d{static create(L,j=null){const z=A.get(L);return typeof z=="boolean"?z?E.INSTANCE:p.INSTANCE:new d(L,j)}constructor(L,j){this.c=L,this.d=j,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:w(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=A.get(this.c);return typeof L=="boolean"?L?E.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.ContextKeyNotExpr=d;function m(F,L){if(typeof F=="string"){const j=parseFloat(F);isNaN(j)||(F=j)}return typeof F=="string"||typeof F=="number"?L(F):E.INSTANCE}class v{static create(L,j,z=null){return m(j,V=>new v(L,V,z))}constructor(L,j,z){this.c=L,this.d=j,this.f=z,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:b(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=v;class I{static create(L,j,z=null){return m(j,V=>new I(L,V,z))}constructor(L,j,z){this.c=L,this.d=j,this.f=z,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:b(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=I;class i{static create(L,j,z=null){return m(j,V=>new i(L,V,z))}constructor(L,j,z){this.c=L,this.d=j,this.f=z,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:b(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class r{static create(L,j,z=null){return m(j,V=>new r(L,V,z))}constructor(L,j,z){this.c=L,this.d=j,this.f=z,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:b(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class t{static create(L,j){return new t(L,j)}constructor(L,j){this.d=L,this.f=j,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const j=this.f?this.f.source:"",z=L.f?L.f.source:"";return j<z?-1:j>z?1:0}equals(L){if(L.type===this.type){const j=this.f?this.f.source:"",z=L.f?L.f.source:"";return this.d===L.d&&j===z}return!1}substituteConstants(){return this}evaluate(L){const j=L.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=s.create(this)),this.c}}e.ContextKeyRegexExpr=t;class s{static create(L){return new s(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new s(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=s;function o(F){let L=null;for(let j=0,z=F.length;j<z;j++){const V=F[j].substituteConstants();if(F[j]!==V&&L===null){L=[];for(let Q=0;Q<j;Q++)L[Q]=F[Q]}L!==null&&(L[j]=V)}return L===null?F:L}class c{static create(L,j,z){return c.d(L,j,z)}constructor(L,j){this.expr=L,this.c=j,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let j=0,z=this.expr.length;j<z;j++){const V=C(this.expr[j],L.expr[j]);if(V!==0)return V}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let j=0,z=this.expr.length;j<z;j++)if(!this.expr[j].equals(L.expr[j]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:c.create(L,this.c,!1)}evaluate(L){for(let j=0,z=this.expr.length;j<z;j++)if(!this.expr[j].evaluate(L))return!1;return!0}static d(L,j,z){const V=[];let Q=!1;for(const Y of L)if(!!Y){if(Y.type===1){Q=!0;continue}if(Y.type===0)return E.INSTANCE;if(Y.type===6){V.push(...Y.expr);continue}V.push(Y)}if(V.length===0&&Q)return p.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(C);for(let Y=1;Y<V.length;Y++)V[Y-1].equals(V[Y])&&(V.splice(Y,1),Y--);if(V.length===1)return V[0];for(;V.length>1;){const Y=V[V.length-1];if(Y.type!==9)break;V.pop();const H=V.pop(),q=V.length===0,G=a.create(Y.expr.map(X=>c.create([X,H],null,z)),null,q);G&&(V.push(G),V.sort(C))}if(V.length===1)return V[0];if(z){for(let Y=0;Y<V.length;Y++)for(let H=Y+1;H<V.length;H++)if(V[Y].negate().equals(V[H]))return E.INSTANCE;if(V.length===1)return V[0]}return new c(V,j)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const j of this.expr)L.push(...j.keys());return L}map(L){return new c(this.expr.map(j=>j.map(L)),null)}negate(){if(!this.c){const L=[];for(const j of this.expr)L.push(j.negate());this.c=a.create(L,this,!0)}return this.c}}class a{static create(L,j,z){return a.d(L,j,z)}constructor(L,j){this.expr=L,this.c=j,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let j=0,z=this.expr.length;j<z;j++){const V=C(this.expr[j],L.expr[j]);if(V!==0)return V}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let j=0,z=this.expr.length;j<z;j++)if(!this.expr[j].equals(L.expr[j]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:a.create(L,this.c,!1)}evaluate(L){for(let j=0,z=this.expr.length;j<z;j++)if(this.expr[j].evaluate(L))return!0;return!1}static d(L,j,z){let V=[],Q=!1;if(L){for(let Y=0,H=L.length;Y<H;Y++){const q=L[Y];if(!!q){if(q.type===0){Q=!0;continue}if(q.type===1)return p.INSTANCE;if(q.type===9){V=V.concat(q.expr);continue}V.push(q)}}if(V.length===0&&Q)return E.INSTANCE;V.sort(C)}if(V.length!==0){if(V.length===1)return V[0];for(let Y=1;Y<V.length;Y++)V[Y-1].equals(V[Y])&&(V.splice(Y,1),Y--);if(V.length===1)return V[0];if(z){for(let Y=0;Y<V.length;Y++)for(let H=Y+1;H<V.length;H++)if(V[Y].negate().equals(V[H]))return p.INSTANCE;if(V.length===1)return V[0]}return new a(V,j)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const j of this.expr)L.push(...j.keys());return L}map(L){return new a(this.expr.map(j=>j.map(L)),null)}negate(){if(!this.c){const L=[];for(const j of this.expr)L.push(j.negate());for(;L.length>1;){const j=L.shift(),z=L.shift(),V=[];for(const Q of $(j))for(const Y of $(z))V.push(c.create([Q,Y],null,!1));L.unshift(a.create(V,null,!1))}this.c=a.create(L,this,!0)}return this.c}}class u extends g{static all(){return u.d.values()}constructor(L,j,z){super(L,null),this.f=j,typeof z=="object"?u.d.push({...z,key:L}):z!==!0&&u.d.push({key:L,description:z,type:j!=null?typeof j:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return h.create(this.key,L)}notEqualsTo(L){return l.create(this.key,L)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function w(F,L){return F<L?-1:F>L?1:0}function b(F,L,j,z){return F<j?-1:F>j?1:L<z?-1:L>z?1:0}function U(F,L){if(F.type===0||L.type===1)return!0;if(F.type===9)return L.type===9?N(F.expr,L.expr):!1;if(L.type===9){for(const j of L.expr)if(U(F,j))return!0;return!1}if(F.type===6){if(L.type===6)return N(L.expr,F.expr);for(const j of F.expr)if(U(j,L))return!0;return!1}return F.equals(L)}e.implies=U;function N(F,L){let j=0,z=0;for(;j<F.length&&z<L.length;){const V=F[j].cmp(L[z]);if(V<0)return!1;V===0&&j++,z++}return j===F.length}function $(F){return F.type===9?F.expr:[F]}}),define(oe[95],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function n(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=n;class D{async getPerformanceInfo(T,R){return{}}async getSystemInfo(T,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,R){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=D}),define(oe[96],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(oe[15],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[30],ae([0,1,156,4]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function R(l,d){return d==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function P(l,d,m){return R(d,m)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===m?!0:S(m).includes(l)}e.isTargetPlatformCompatible=P;function S(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=C;var E;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var p;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var g;(function(l){l.Install="install",l.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var y;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(d,m){super(d),this.code=m,this.name=m}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(oe[194],ae([0,1,3,2,67,32,7,143,30]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(f,l){return T.URI.revive(l?l.transformIncoming(f):f)}function C(f,l){return l?l.transformOutgoingURI(f):f}function E(f,l){l=l||R.DefaultURITransformer;const d=f.manifest;return{...(0,R.transformAndReviveIncomingURIs)({...f,manifest:void 0},l),manifest:d}}function p(f,l){return l?(0,A.cloneAndChange)(f,d=>d instanceof T.URI?l.transformOutgoingURI(d):void 0):f}class g{constructor(l,d){this.a=l,this.b=d,this.onInstallExtension=k.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(l.onDidUninstallExtension,!0)}listen(l,d){const m=this.b(l);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,v=>v.map(I=>({...I,local:I.local?p(I.local,m):I.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(l,d,m){const v=this.b(l);switch(d){case"zip":return this.a.zip(E(m[0],v)).then(I=>C(I,v));case"unzip":return this.a.unzip(S(m[0],v));case"install":return this.a.install(S(m[0],v),(0,D.revive)(m[1]));case"installFromLocation":return this.a.installFromLocation(S(m[0],v),T.URI.revive(m[1]));case"getManifest":return this.a.getManifest(S(m[0],v));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],(0,D.revive)(m[1]));case"uninstall":return this.a.uninstall(E(m[0],v),(0,D.revive)(m[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(m[0],v));case"getInstalled":return this.a.getInstalled(m[0],T.URI.revive(m[1])).then(I=>I.map(i=>p(i,v)));case"getMetadata":return this.a.getMetadata(E(m[0],v));case"updateMetadata":return this.a.updateMetadata(E(m[0],v),m[1]).then(I=>p(I,v));case"updateExtensionScope":return this.a.updateExtensionScope(E(m[0],v),m[1]).then(I=>p(I,v));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class h extends n.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(l){super(),this.j=l,this.c=this.B(new k.Emitter),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=this.B(new k.Emitter),this.B(this.j.listen("onInstallExtension")(d=>this.c.fire({identifier:d.identifier,source:this.k(d.source)?T.URI.revive(d.source):d.source,profileLocation:T.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(d=>this.f.fire(d.map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.k(m.source)?T.URI.revive(m.source):m.source,profileLocation:T.URI.revive(m.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(d=>this.g.fire({identifier:d.identifier,profileLocation:T.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(d=>this.h.fire({...d,profileLocation:T.URI.revive(d.profileLocation)})))}k(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(l){const d=await this.getTargetPlatform();return l.allTargetPlatforms.some(m=>(0,P.isTargetPlatformCompatible)(m,l.allTargetPlatforms,d))}zip(l){return Promise.resolve(this.j.call("zip",[l]).then(d=>T.URI.revive(d)))}unzip(l){return Promise.resolve(this.j.call("unzip",[l]))}install(l,d){return Promise.resolve(this.j.call("install",[l,d])).then(m=>E(m,null))}installFromLocation(l,d){return Promise.resolve(this.j.call("installFromLocation",[l,d])).then(m=>E(m,null))}getManifest(l){return Promise.resolve(this.j.call("getManifest",[l]))}installFromGallery(l,d){return Promise.resolve(this.j.call("installFromGallery",[l,d])).then(m=>E(m,null))}uninstall(l,d){return Promise.resolve(this.j.call("uninstall",[l,d]))}reinstallFromGallery(l){return Promise.resolve(this.j.call("reinstallFromGallery",[l])).then(d=>E(d,null))}getInstalled(l=null,d){return Promise.resolve(this.j.call("getInstalled",[l,d])).then(m=>m.map(v=>E(v,null)))}getMetadata(l){return Promise.resolve(this.j.call("getMetadata",[l]))}updateMetadata(l,d){return Promise.resolve(this.j.call("updateMetadata",[l,d])).then(m=>E(m,null))}updateExtensionScope(l,d){return Promise.resolve(this.j.call("updateExtensionScope",[l,d])).then(m=>E(m,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(l,d){const m=await this.j.call("download",[l,d]);return T.URI.revive(m)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class y{constructor(l){this.a=l}listen(l,d){throw new Error("Invalid listen")}call(l,d,m){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(T.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(oe[97],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class n{b(){return this.a||(this.a=new Promise((A,T)=>Z(["node-vsce-sign"],async R=>A(R),T))),this.a}async verify(A,T){let R;try{R=await this.b()}catch{return!1}return R.verify(A,T)}}e.ExtensionSignatureVerificationService=n}),define(oe[98],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function D(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,49,12,27,14,7,164,4]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function S(Y){return Y.create===!0}e.isFileOpenForWriteOptions=S;var C;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var E;(function(Y){Y[Y.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var p;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(Y){return!!(Y.capabilities&2)}e.hasReadWriteCapability=g;function h(Y){return!!(Y.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(Y){return!!(Y.capabilities&32768)}e.hasFileCloneCapability=y;function f(Y){return!!(Y.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function l(Y){return!!(Y.capabilities&16)}e.hasFileReadStreamCapability=l;function d(Y){return g(Y)?!!(Y.capabilities&16384):!1}e.hasFileAtomicReadCapability=d;var m;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(H,q){super(H),this.code=q}}e.FileSystemProviderError=v;function I(Y,H){const q=new v(Y.toString(),H);return r(q,H),q}e.createFileSystemProviderError=I;function i(Y){return Y||I((0,R.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=i;function r(Y,H){return Y.name=H?`${H} (FileSystemError)`:"FileSystemError",Y}e.markAsFileSystemProviderError=r;function t(Y){if(!Y)return m.Unknown;if(Y instanceof v)return Y.code;const H=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!H)return m.Unknown;switch(H[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=t;function s(Y){if(Y instanceof b)return Y.fileOperationResult;switch(t(Y)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var o;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class c{constructor(H,q,G){this.resource=H,this.operation=q,this.target=G}isOperation(H){return this.operation===H}}e.FileOperationEvent=c;var a;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class u{constructor(H,q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const G=new Map;for(const X of H){const ee=G.get(X.type);switch(ee?ee.push([X.resource,X]):G.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,ee]of G)switch(X){case 1:this.a=k.TernarySearchTree.forUris(()=>q),this.a.fill(ee);break;case 0:this.b=k.TernarySearchTree.forUris(()=>q),this.b.fill(ee);break;case 2:this.c=k.TernarySearchTree.forUris(()=>q),this.c.fill(ee);break}}contains(H,...q){return this.d(H,{includeChildren:!1},...q)}affects(H,...q){return this.d(H,{includeChildren:!0},...q)}d(H,q,...G){if(!H)return!1;const X=G.length>0;return!!((!X||G.includes(1))&&(this.a?.get(H)||q.includeChildren&&this.a?.findSuperstr(H))||(!X||G.includes(0))&&(this.b?.get(H)||q.includeChildren&&this.b?.findSuperstr(H))||(!X||G.includes(2))&&(this.c?.findSubstr(H)||q.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=u;function w(Y,H,q){return!Y||!H||Y===H||H.length>Y.length?!1:(H.charAt(H.length-1)!==n.sep&&(H+=n.sep),q?(0,D.startsWithIgnoreCase)(Y,H):Y.indexOf(H)===0)}e.isParent=w;class b extends Error{constructor(H,q,G){super(H),this.fileOperationResult=q,this.options=G}}e.FileOperationError=b;class U extends b{constructor(H,q,G,X){super(H,q,X),this.fileOperationResult=q,this.size=G}}e.TooLargeFileOperationError=U;class N extends b{constructor(H,q,G){super(H,2,G),this.stat=q}}e.NotModifiedSinceFileOperationError=N;var $;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",Y[Y.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})($=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.etag=L;async function j(Y,H){if(!H.hasProvider(T.URI.from({scheme:Y.scheme})))return new Promise(q=>{const G=H.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===Y.scheme&&X.added&&(G.dispose(),q())})})}e.whenProviderRegistered=j,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(H){return(0,A.isNumber)(H)||(H=0),H<z.KB?(0,R.localize)(1,null,H.toFixed(0)):H<z.MB?(0,R.localize)(2,null,(H/z.KB).toFixed(2)):H<z.GB?(0,R.localize)(3,null,(H/z.MB).toFixed(2)):H<z.TB?(0,R.localize)(4,null,(H/z.GB).toFixed(2)):(0,R.localize)(5,null,(H/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var V;(function(Y){Y[Y.IA32=0]="IA32",Y[Y.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function Q(Y){return{maxFileSize:Y===0?300*z.MB:16*z.GB,maxHeapSize:Y===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=Q});var K=this&&this.__param||function(Z,e){return function(k,n){e(k,n,Z)}};define(oe[195],ae([0,1,99,44,13]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const P=(await this.a.readFileStream(R)).value;return new Promise((S,C)=>{const E=(0,k.createHash)("md5");(0,n.listenStream)(P,{onData:p=>E.update(p.buffer),onError:p=>C(p),onEnd:()=>S(E.digest("base64").replace(/=+$/,""))})})}};A=pe([K(0,D.IFileService)],A),e.ChecksumService=A}),define(oe[196],ae([0,1,17,38,9,3,2,44,7,31,13]),function(Z,e,k,n,D,A,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends T.Disposable{constructor(g,h){super(),this.a=g,this.b=h,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,h){const{buffer:y}=await this.a.call("readFile",[g,h]);return y}readFileStream(g,h,y){const f=(0,R.newWriteableStream)(d=>k.VSBuffer.concat(d.map(m=>k.VSBuffer.wrap(m))).buffer),l=this.a.listen("readFileStream",[g,h])(d=>{if(d instanceof k.VSBuffer)f.write(d.buffer);else{if(d==="end")f.end();else{let m;if(d instanceof Error)m=d;else{const v=d;m=(0,C.createFileSystemProviderError)(v.message??(0,n.toErrorMessage)(v),v.code??C.FileSystemProviderErrorCode.Unknown)}f.error(m),f.end()}l.dispose()}});return y.onCancellationRequested(()=>{f.error((0,D.canceled)()),f.end(),l.dispose()}),f}writeFile(g,h,y){return this.a.call("writeFile",[g,k.VSBuffer.wrap(h),y])}open(g,h){return this.a.call("open",[g,h])}close(g){return this.a.call("close",[g])}async read(g,h,y,f,l){const[d,m]=await this.a.call("read",[g,h,l]);return y.set(d.buffer.slice(0,m),f),m}write(g,h,y,f,l){return this.a.call("write",[g,h,k.VSBuffer.wrap(y),f,l])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,h){return this.a.call("delete",[g,h])}rename(g,h,y){return this.a.call("rename",[g,h,y])}copy(g,h,y){return this.a.call("copy",[g,h,y])}cloneFile(g,h){return this.a.call("cloneFile",[g,h])}i(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const h=g;this.f.fire(h.map(y=>({resource:P.URI.revive(y.resource),type:y.type})))}else{const h=g;this.g.fire(h)}}))}watch(g,h){const y=(0,S.generateUuid)();return this.a.call("watch",[this.h,y,g,h]),(0,T.toDisposable)(()=>this.a.call("unwatch",[this.h,y]))}}e.DiskFileSystemProviderClient=E}),define(oe[100],ae([0,1,17,9,165,13]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(C,E,p,g,h,y){let f;try{await R(C,E,p,g,h,y)}catch(l){f=l}finally{f&&h.errorTransformer&&(f=h.errorTransformer(f)),typeof f<"u"&&p.error(f),p.end()}}e.readFileIntoStream=T;async function R(C,E,p,g,h,y){P(y);const f=await C.open(E,{create:!1});try{P(y);let l=0,d=0,m=h&&typeof h.length=="number"?h.length:void 0,v=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof m=="number"?m:h.bufferSize)),I=h&&typeof h.position=="number"?h.position:0,i=0;do d=await C.read(f,I,v.buffer,i,v.byteLength-i),I+=d,i+=d,l+=d,typeof m=="number"&&(m-=d),i===v.byteLength&&(await p.write(g(v)),v=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof m=="number"?m:h.bufferSize)),i=0);while(d>0&&(typeof m!="number"||m>0)&&P(y)&&S(l,h));if(i>0){let r=i;typeof m=="number"&&(r=Math.min(i,m)),p.write(g(v.slice(0,r)))}}catch(l){throw(0,A.ensureFileSystemProviderError)(l)}finally{await C.close(f)}}function P(C){if(C.isCancellationRequested)throw(0,n.canceled)();return!0}function S(C,E){if(E?.limits){if(typeof E.limits.memory=="number"&&C>E.limits.memory)throw(0,A.createFileSystemProviderError)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&C>E.limits.size)throw(0,A.createFileSystemProviderError)((0,D.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[56],ae([0,1,89,2,12,5,7,13]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(l){return l.recursive===!0}e.isRecursiveWatchRequest=P;class S extends n.Disposable{constructor(d,m,v,I){super(),this.h=d,this.i=m,this.j=v,this.k=I,this.c=this.B(new n.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new n.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(m=>this.h(m))),d.add(this.b.onDidLogMessage(m=>this.i(m))),d.add(this.b.onDidError(m=>this.n(m)))}n(d){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.a=5;class C extends S{constructor(d,m,v){super(d,m,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class E extends S{constructor(d,m,v){super(d,m,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function p(l){return l.map(d=>({type:d.type,resource:T.URI.file(d.path)}))}e.toFileChanges=p;function g(l){const d=new f;for(const m of l)d.processEvent(m);return d.coalesce()}e.coalesceEvents=g;function h(l,d){return typeof d=="string"&&!d.startsWith(k.GLOBSTAR)&&!(0,D.isAbsolute)(d)?{base:l,pattern:d}:d}e.normalizeWatcherPattern=h;function y(l,d){const m=[];for(const v of d)m.push((0,k.parse)(h(l,v)));return m}e.parseWatcherPatterns=y;class f{constructor(){this.a=new Set,this.b=new Map}c(d){return A.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const m=this.b.get(this.c(d));let v=!1;if(m){const I=m.type,i=d.type;m.path!==d.path&&(d.type===2||d.type===1)?v=!0:I===1&&i===2?(this.b.delete(this.c(d)),this.a.delete(m)):I===2&&i===1?m.type=0:I===1&&i===0||(m.type=i)}else v=!0;v&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],m=[];return Array.from(this.a).filter(v=>v.type!==2?(d.push(v),!1):!0).sort((v,I)=>v.path.length-I.path.length).filter(v=>m.some(I=>(0,R.isParent)(v.path,I,!A.isLinux))?!1:(m.push(v.path),!0)).concat(d)}}}),define(oe[197],ae([0,1,53,6,23,48,2,85,12,5,145,28,56]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends T.Disposable{constructor(f,l,d,m){super(),this.j=f,this.k=l,this.l=d,this.m=m,this.c=this.B(new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.k(v))),this.f=this.B(new n.RunOnceWorker(v=>this.u(v),g.b)),this.g=(0,p.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new D.CancellationTokenSource,this.ready=this.n()}async n(){try{const f=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await E.Promises.stat(f);this.B(await this.s(f,l.isDirectory()))}catch(f){f.code!=="ENOENT"?this.w(f):this.z(f)}}async r(f){let l=f.path;try{l=await E.Promises.realpath(f.path),f.path===l&&(l=await(0,C.realcase)(f.path)??f.path),f.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${l})`)}catch{}return l}async s(f,l){if(S.isMacintosh&&(0,A.isEqualOrParent)(f,"/Volumes/",!0))return this.w(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const d=new D.CancellationTokenSource(this.i.token),m=new T.DisposableStore;try{const v=(0,P.basename)(f),I=(0,k.watch)(f);m.add((0,T.toDisposable)(()=>{I.removeAllListeners(),I.close()})),this.z(`Started watching: '${f}'`);const i=new Set;if(l)try{for(const t of await E.Promises.readdir(f))i.add(t)}catch(t){this.w(t)}const r=new Map;m.add((0,T.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),I.on("error",(t,s)=>{this.w(`Failed to watch ${f} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),I.on("change",(t,s)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${s}`);let o="";if(s&&(o=s.toString(),S.isMacintosh&&(o=(0,R.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(l)if(t==="rename"){r.get(o)?.dispose();const c=setTimeout(async()=>{if(r.delete(o),o===v&&!await E.Promises.exists(f)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,P.join)(f,o));if(d.token.isCancellationRequested)return;let u;a?i.has(o)?u=0:(u=1,i.add(o)):(i.delete(o),u=2),this.t({path:(0,P.join)(this.j.path,o),type:u})},g.a);r.set(o,(0,T.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(o)?c=0:(c=1,i.add(o)),this.t({path:(0,P.join)(this.j.path,o),type:c})}else if(t==="rename"||o!==v){const c=setTimeout(async()=>{const a=await E.Promises.exists(f);d.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),m.add(await this.s(f,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},g.a);m.clear(),m.add((0,T.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(v){await E.Promises.exists(f)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${f} for changes using fs.watch() (${v.toString()})`)}return(0,T.toDisposable)(()=>{d.dispose(!0),m.dispose()})}t(f,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!l&&this.g.some(d=>d(f.path))?this.m&&this.z(` >> ignored (excluded) ${f.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.path))?this.m&&this.z(` >> ignored (not included) ${f.path}`):this.f.work(f))}u(f){const l=(0,p.coalesceEvents)(f);if(l.length>0){if(this.m)for(const m of l)this.z(`>> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(f){if(S.isLinux)return E.Promises.exists(f);try{const l=(0,P.basename)(f);return(await E.Promises.readdir((0,P.dirname)(f))).some(m=>m===l)}catch(l){return this.z(l),!1}}setVerboseLogging(f){this.m=f}w(f){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}y(f){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}z(f){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.a=100,g.b=75;async function h(y,f,l,d,m=512){const v=await E.Promises.open(y,"r"),I=Buffer.allocUnsafe(m),i=new D.CancellationTokenSource(d);let r,t=!1;const s={path:y,excludes:[],recursive:!1},o=new g(s,c=>{(async()=>{for(const{type:a}of c)if(a===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:u}=await E.Promises.read(v,I,0,m,null);if(!u||i.token.isCancellationRequested)break;f(I.slice(0,u))}}catch(u){r=new Error(u),i.dispose(!0)}finally{t=!1}}})()});return await o.ready,l(),new Promise((c,a)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await E.Promises.close(v)}catch(u){r=new Error(u)}r?a(r):c()})})}e.watchFileContents=h}),define(oe[198],ae([0,1,3,89,2,5,197]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new k.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(S){const C=this.i(S),E=C.filter(g=>{const h=this.c.get(g.path);return h?!(0,n.patternsEquals)(h.request.excludes,g.excludes)||!(0,n.patternsEquals)(h.request.includes,g.includes):!0}),p=Array.from(this.c.values()).filter(({request:g})=>!C.find(h=>h.path===g.path&&(0,n.patternsEquals)(h.excludes,g.excludes)&&(0,n.patternsEquals)(h.includes,g.includes))).map(({request:g})=>g.path);E.length&&this.j(`Request to start watching: ${E.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const g of p)this.h(g);for(const g of E)this.g(g)}g(S){const C=new T.NodeJSFileWatcherLibrary(S,p=>this.a.fire(p),p=>this.b.fire(p),this.f),E={request:S,instance:C};this.c.set(S.path,E)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const C=this.c.get(S);C&&(this.c.delete(S),C.instance.dispose())}i(S){const C=new Map;for(const E of S){const p=A.isLinux?E.path:E.path.toLowerCase();C.set(p,E)}return Array.from(C.values())}async setVerboseLogging(S){this.f=S;for(const[,C]of this.c)C.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,C){return C?`[File Watcher (node.js)] ${S} (path: ${C.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=R}),define(oe[199],ae([0,1,56,198]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends k.AbstractNonRecursiveWatcherClient{constructor(T,R,P){super(T,R,P),this.m()}l(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(oe[200],ae([0,1,24,39,68,56]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(P,S,C){super(P,S,C),this.m()}l(P){const S=P.add(new D.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(S.onDidProcessExit(({code:C,signal:E})=>this.n(`terminated by itself with code ${C}, signal: ${E}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(oe[72],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...D){this.a=new Map;for(const[A,T]of D)this.set(A,T)}set(D,A){const T=this.a.get(D);return this.a.set(D,A),T}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=k}),define(oe[201],ae([0,1,6,9,2,55,191,4,72,84]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class E extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class p{constructor(f=new P.ServiceCollection,l=!1,d,m=C){this.f=f,this.g=l,this.h=d,this.i=m,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=m?d?._globalGraph??new T.Graph(v=>v):void 0}createChild(f){return new p(f,this.g,this,this.i)}invokeFunction(f,...l){const d=h.traceInvocation(this.i,f);let m=!1;try{return f({get:I=>{if(m)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(I,d);if(!i)throw new Error(`[invokeFunction] unknown service '${I}'`);return i}},...l)}finally{m=!0,d.stop()}}createInstance(f,...l){let d,m;return f instanceof A.SyncDescriptor?(d=h.traceCreation(this.i,f.ctor),m=this.j(f.ctor,f.staticArguments.concat(l),d)):(d=h.traceCreation(this.i,f),m=this.j(f,l,d)),d.stop(),m}j(f,l=[],d){const m=R._util.getServiceDependencies(f).sort((i,r)=>i.index-r.index),v=[];for(const i of m){const r=this.m(i.id,d);r||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${i.id}.`,!1),v.push(r)}const I=m.length>0?m[0].index:l.length;if(l.length!==I){console.trace(`[createInstance] First service dependency of ${f.name} at position ${I+1} conflicts with ${l.length} static arguments`);const i=I-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,I)}return Reflect.construct(f,l.concat(v))}k(f,l){if(this.f.get(f)instanceof A.SyncDescriptor)this.f.set(f,l);else if(this.h)this.h.k(f,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const l=this.f.get(f);return!l&&this.h?this.h.l(f):l}m(f,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const d=this.l(f);return d instanceof A.SyncDescriptor?this.q(f,d,l.branch(f,!0)):(l.branch(f,!1),d)}q(f,l,d){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,l,d)}finally{this.o.delete(f)}}r(f,l,d){const m=new T.Graph(i=>i.id.toString());let v=0;const I=[{id:f,desc:l,_trace:d}];for(;I.length;){const i=I.pop();if(m.lookupOrInsertNode(i),v++>1e3)throw new E(m);for(const r of R._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof A.SyncDescriptor){const s={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};m.insertEdge(i,s),I.push(s)}}}for(;;){const i=m.roots();if(i.length===0){if(!m.isEmpty())throw new E(m);break}for(const{data:r}of i){if(this.l(r.id)instanceof A.SyncDescriptor){const s=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,s)}m.removeNode(r)}}return this.l(f)}s(f,l,d=[],m,v){if(this.f.get(f)instanceof A.SyncDescriptor)return this.t(f,l,d,m,v);if(this.h)return this.h.s(f,l,d,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(f,l,d=[],m,v){if(m){const I=new p(void 0,this.g,this,this.i);I.c=String(f);const i=new Map,r=new k.IdleValue(()=>{const t=I.j(l,d,v);for(const[s,o]of i){const c=t[s];if(typeof c=="function")for(const a of o)c.apply(t,a)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new S.LinkedList,i.set(s,a)),(w,b,U)=>{const N=a.push([w,b,U]);return(0,D.toDisposable)(N)}}if(s in t)return t[s];const o=r.value;let c=o[s];return typeof c!="function"||(c=c.bind(o),t[s]=c),c},set(t,s,o){return r.value[s]=o,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,d,v)}u(f,l){if(l&&console.warn(f),this.g)throw new Error(f)}}e.InstantiationService=p;var g;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(g||(g={}));class h{static traceInvocation(f,l){return f?new h(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(f,l){return f?new h(1,l.name):h.c}constructor(f,l){this.type=f,this.name=l,this.g=Date.now(),this.h=[]}branch(f,l){const d=new h(3,f.toString());return this.h.push([f,l,d]),d}stop(){const f=Date.now()-this.g;h.f+=f;let l=!1;function d(v,I){const i=[],r=new Array(v+1).join("	");for(const[t,s,o]of I.h)if(s&&o){l=!0,i.push(`${r}CREATES -> ${t}`);const c=d(v+1,o);c&&i.push(c)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(f>2||l)&&h.all.add(m.join(`
`))}}e.Trace=h,h.all=new Set,h.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}},h.f=0}),define(oe[202],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(D,A){this.a=D,this.b=A}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,A){this.a.registerChannel(D,A)}}e.MessagePortMainProcessService=k}),define(oe[57],ae([0,1,39,55,71,4]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(g,h,y,f){const l=y.getChannel(g);return R(h)?f.createInstance(new n.SyncDescriptor(h.channelClientCtor,[l])):k.ProxyChannel.toService(l,h?.proxyOptions)}}function R(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let P=class extends T{constructor(g,h,y,f){super(g,h,y,f)}};P=pe([K(2,e.IMainProcessService),K(3,A.IInstantiationService)],P);function S(p,g,h){(0,D.registerSingleton)(p,new n.SyncDescriptor(P,[g,h],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let C=class extends T{constructor(g,h,y,f){super(g,h,y,f)}};C=pe([K(2,e.ISharedProcessService),K(3,A.IInstantiationService)],C);function E(p,g,h){(0,D.registerSingleton)(p,new n.SyncDescriptor(C,[g,h],!0))}e.registerSharedProcessRemoteService=E}),define(oe[73],ae([0,1,23,2,5,167,30,4]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function P(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=P,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let S=class extends n.Disposable{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new k.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const h=p.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(f=>f.startsWith("lp-"))).map(y=>{const f=y.properties.localizedLanguages?.[0],l=P(y);return{...this.f(l,f,y),extensionId:y.identifier.id,galleryExtension:y}});return h.push({...this.f("en","English"),extensionId:"default"}),h}f(E,p,g){const h=p??E;let y;if(h!==E&&(y=`(${E})`),E.toLowerCase()===D.language.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),g?.installCount){y??="";const f=g.installCount;let l;f>1e6?l=`${Math.floor(f/1e5)/10}M`:f>1e3?l=`${Math.floor(f/1e3)}K`:l=String(f),y+=` $(cloud-download) ${l}`}return{id:E,label:h,description:y}}};S=pe([K(0,T.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(oe[203],ae([0,1,2,73]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends k.Disposable{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};D=pe([K(0,n.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(oe[8],ae([0,1,38,3,2,37,5,7,4]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function S(){return new Date().toISOString()}var C;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function E(c,a,u){switch(a){case C.Trace:c.trace(u);break;case C.Debug:c.debug(u);break;case C.Info:c.info(u);break;case C.Warning:c.warn(u);break;case C.Error:c.error(u);break;case C.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=E;function p(c){let a="";for(let u=0;u<c.length;u++){let w=c[u];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}a+=(u>0?" ":"")+w}return a}e.format=p;class g extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new n.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==C.Off&&this.b<=a}}e.AbstractLogger=g;class h extends g{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...u){this.f(C.Trace)&&this.g(C.Trace,p([a,...u]))}debug(a,...u){this.f(C.Debug)&&this.g(C.Debug,p([a,...u]))}info(a,...u){this.f(C.Info)&&this.g(C.Info,p([a,...u]))}warn(a,...u){this.f(C.Warning)&&this.g(C.Warning,p([a,...u]))}error(a,...u){if(this.f(C.Error))if(a instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=a.stack,this.g(C.Error,p(w))}else this.g(C.Error,p([a,...u]))}flush(){}}e.AbstractMessageLogger=h;class y extends g{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!T.isWindows}trace(a,...u){this.f(C.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...u):console.log(`[main ${S()}]`,a,...u))}debug(a,...u){this.f(C.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...u):console.log(`[main ${S()}]`,a,...u))}info(a,...u){this.f(C.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...u):console.log(`[main ${S()}]`,a,...u))}warn(a,...u){this.f(C.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,a,...u):console.warn(`[main ${S()}]`,a,...u))}error(a,...u){this.f(C.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,a,...u):console.error(`[main ${S()}]`,a,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class f extends g{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...u){this.f(C.Trace)&&console.log("%cTRACE","color: #888",a,...u)}debug(a,...u){this.f(C.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...u)}info(a,...u){this.f(C.Info)&&console.log("%c INFO","color: #33f",a,...u)}warn(a,...u){this.f(C.Warning)&&console.log("%c WARN","color: #993",a,...u)}error(a,...u){this.f(C.Error)&&console.log("%c  ERR","color: #f33",a,...u)}dispose(){}flush(){}}e.ConsoleLogger=f;class l extends g{constructor(a,u=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(u)}trace(a,...u){this.f(C.Trace)&&this.g.log(C.Trace,[this.h(a),...u])}debug(a,...u){this.f(C.Debug)&&this.g.log(C.Debug,[this.h(a),...u])}info(a,...u){this.f(C.Info)&&this.g.log(C.Info,[this.h(a),...u])}warn(a,...u){this.f(C.Warning)&&this.g.log(C.Warning,[this.h(a),...u])}error(a,...u){this.f(C.Error)&&this.g.log(C.Error,[this.h(a),...u])}h(a){return typeof a=="string"?a:(0,k.toErrorMessage)(a,this.f(C.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class d extends g{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const u of this.g)u.setLevel(a);super.setLevel(a)}trace(a,...u){for(const w of this.g)w.trace(a,...u)}debug(a,...u){for(const w of this.g)w.debug(a,...u)}info(a,...u){for(const w of this.g)w.info(a,...u)}warn(a,...u){for(const w of this.g)w.warn(a,...u)}error(a,...u){for(const w of this.g)w.error(a,...u)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=d;class m extends D.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...u){this.b.trace(a,...u)}debug(a,...u){this.b.debug(a,...u)}info(a,...u){this.b.info(a,...u)}warn(a,...u){this.b.warn(a,...u)}error(a,...u){this.b.error(a,...u)}flush(){this.b.flush()}}e.LogService=m;class v extends D.Disposable{constructor(a,u){super(),this.c=a,this.b=new A.ResourceMap,this.B(u(w=>this.setLevel(w)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,u,w){let b=this.b.get(a)?.logger;return b||(w=u?.always?C.Trace:w,b=this.f(a,w??this.c,u),this.b.set(a,{logger:b,logLevel:w})),b}setLevel(a,u){const w=R.URI.isUri(a)?a:void 0,b=w?u:a;if(w){const U=this.b.get(w);U&&U.logLevel!==b&&(U.logLevel=b,U.logger.setLevel(b))}else this.c=b,this.b.forEach(({logLevel:U,logger:N})=>{U===void 0&&N.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=v;class I{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(a){}getLevel(){return C.Info}trace(a,...u){}debug(a,...u){}info(a,...u){}warn(a,...u){}error(a,...u){}critical(a,...u){}dispose(){}flush(){}}e.NullLogger=I;class i extends I{}e.NullLogService=i;class r extends v{constructor(){super(C.Info,n.Event.None)}f(a,u,w){return new I}}e.NullLoggerService=r;function t(c){if(c.verbose)return C.Trace;if(typeof c.logLevel=="string"){const a=o(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function s(c){switch(c){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Off:return"off"}}e.LogLevelToString=s;function o(c){switch(c){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Error;case"off":return C.Off}}e.parseLogLevel=o}),define(oe[204],ae([0,1,6,9,2,12,28,15,8]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends D.Disposable{constructor(E,p){super(),this.a=E,this.b=p,this.B(new k.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,A.basename)(this.a.logsPath),p=(0,A.dirname)(this.a.logsPath),y=(await T.Promises.readdir(p)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==E),f=y.slice(0,Math.max(0,y.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(l=>T.Promises.rm((0,A.join)(p,l)))))}catch(E){(0,n.onUnexpectedError)(E)}}};S=pe([K(0,R.IEnvironmentService),K(1,P.ILogService)],S),e.LogsDataCleaner=S}),define(oe[205],ae([0,1,21,6,9,3,2,12,56,8]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends T.Disposable{constructor(p,g){super(),this.a=p,this.b=g,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new n.ThrottledDelayer(0)),this.s=[],this.t=this.B(new n.ThrottledDelayer(0))}watch(p,g){return g.recursive||this.b?.watcher?.forceUniversal?this.l(p,g):this.u(p,g)}l(p,g){const h={path:this.C(p),excludes:g.excludes,includes:g.includes,recursive:g.recursive},y=(0,k.insert)(this.j,h);return this.m(),(0,T.toDisposable)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,D.onUnexpectedError)(p))}n(){this.h||(this.h=this.B(this.p(g=>this.c.fire((0,P.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const g of this.j)(0,P.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const g of this.j)(0,P.isRecursiveWatchRequest)(g)&&p.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,g){const h={path:this.C(p),excludes:g.excludes,includes:g.includes,recursive:!1},y=(0,k.insert)(this.s,h);return this.v(),(0,T.toDisposable)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,D.onUnexpectedError)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,P.toFileChanges)(p)),p=>this.z(p),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,R.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(oe[206],ae([0,1,21,6,17,23,3,66,64,2,49,24,207,22,44,163,13,100,8,9]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends S.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new T.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new T.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new T.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new n.ResourceQueue)}registerProvider(i,r){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${i}`);const t=new S.DisposableStore;return this.h.set(i,r),this.c.fire({added:!0,scheme:i,provider:r}),t.add(r.onDidChangeFile(s=>this.R.fire(new f.FileChangesEvent(s,!this.O(r))))),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(s=>this.S.fire(new Error(s)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:i}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:r}),this.h.delete(i),(0,S.dispose)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const r=[];this.f.fire({scheme:i,join(t){r.push(t)}}),!this.h.has(i)&&await n.Promises.settled(r)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,r){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return P.Iterable.map(this.h,([i,r])=>({scheme:i,capabilities:r.capabilities}))}async j(i){if(!(0,g.isAbsolutePath)(i))throw new f.FileOperationError((0,y.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const r=this.h.get(i.scheme);if(!r){const t=new m.ErrorNoTelemetry;throw t.message=(0,y.localize)(1,null,i.toString()),t}return r}async k(i){const r=await this.j(i);if((0,f.hasOpenReadWriteCloseCapability)(r)||(0,f.hasReadWriteCapability)(r)||(0,f.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const r=await this.j(i);if((0,f.hasOpenReadWriteCloseCapability)(r)||(0,f.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,r){try{return await this.n(i,r)}catch(t){throw(0,f.toFileSystemProviderErrorCode)(t)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,y.localize)(2,null,this.nb(i)),1):(0,f.ensureFileSystemProviderError)(t)}}async n(i,r){const t=await this.j(i),s=this.O(t),o=r?.resolveTo,c=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,u=await t.stat(i);let w;return this.p(t,i,u,void 0,!!a,(b,U)=>(w||(w=C.TernarySearchTree.forUris(()=>!s),w.set(i,!0),o&&w.fill(!0,o)),w.get(b.resource)||w.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&c?U===1:!1))}async p(i,r,t,s,o,c){const{providerExtUri:a}=this.N(i),u={resource:r,name:a.basename(r),isFile:(t.type&f.FileType.File)!==0,isDirectory:(t.type&f.FileType.Directory)!==0,isSymbolicLink:(t.type&f.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&f.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,f.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(u.isDirectory&&c(u,s)){try{const w=await i.readdir(r),b=await n.Promises.settled(w.map(async([U,N])=>{try{const $=a.joinPath(r,U),F=o?await i.stat($):{type:N};return await this.p(i,$,F,w.length,o,c)}catch($){return this.b.trace($),null}}));u.children=(0,k.coalesce)(b)}catch(w){this.b.trace(w),u.children=[]}return u}return u}async resolveAll(i){return n.Promises.settled(i.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const r=await this.j(i),t=await r.stat(i);return this.p(r,i,t,void 0,!0,()=>!1)}async exists(i){const r=await this.j(i);try{return!!await r.stat(i)}catch{return!1}}async canCreateFile(i,r){try{await this.r(i,r)}catch(t){return t}return!0}async r(i,r){if(!r?.overwrite&&await this.exists(i))throw new f.FileOperationError((0,y.localize)(3,null,this.nb(i)),3,r)}async createFile(i,r=D.VSBuffer.fromString(""),t){await this.r(i,t);const s=await this.writeFile(i,r);return this.m.fire(new f.FileOperationEvent(i,0,s)),s}async writeFile(i,r,t){const s=this.lb(await this.l(i),i),{providerExtUri:o}=this.N(s);try{await this.s(s,i,t)||await this.P(s,o.dirname(i));let a;if((0,f.hasReadWriteCapability)(s)&&!(r instanceof D.VSBuffer))if((0,h.isReadableStream)(r)){const u=await(0,h.peekStream)(r,3);u.ended?a=D.VSBuffer.concat(u.buffer):a=u}else a=(0,h.peekReadable)(r,u=>D.VSBuffer.concat(u),3);else a=r;!(0,f.hasOpenReadWriteCloseCapability)(s)||(0,f.hasReadWriteCapability)(s)&&a instanceof D.VSBuffer?await this.cb(s,i,t,a):await this.Y(s,i,t,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this.m.fire(new f.FileOperationEvent(i,4))}catch(c){throw new f.FileOperationError((0,y.localize)(4,null,this.nb(i),(0,f.ensureFileSystemProviderError)(c).toString()),(0,f.toFileOperationResult)(c),t)}return this.resolve(i,{resolveMetadata:!0})}async s(i,r,t){if(!!t?.unlock&&!(i.capabilities&8192))throw new Error((0,y.localize)(5,null,this.nb(r)));let o;try{o=await i.stat(r)}catch{return}if((o.type&f.FileType.Directory)!==0)throw new f.FileOperationError((0,y.localize)(6,null,this.nb(r)),0,t);if(this.mb(r,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==f.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,f.etag)({mtime:t.mtime,size:o.size}))throw new f.FileOperationError((0,y.localize)(7,null),3,t);return o}async readFile(i,r,t){const s=await this.k(i);return r?.atomic?this.t(s,i,r,t):this.u(s,i,r,t)}async t(i,r,t,s){return new Promise((o,c)=>{this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{try{const a=await this.u(i,r,t,s);o(a)}catch(a){c(a)}})})}async u(i,r,t,s){const o=await this.v(i,r,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,D.streamToBuffer)(o.value)}}async readFileStream(i,r,t){const s=await this.k(i);return this.v(s,i,r,t)}async v(i,r,t,s){const o=new A.CancellationTokenSource(s),c=this.F(r,t).then(u=>u,u=>{throw o.cancel(),u});let a;try{return typeof t?.etag=="string"&&t.etag!==f.ETAG_DISABLED&&await c,t?.atomic&&(0,f.hasFileAtomicReadCapability)(i)||!((0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasFileReadStreamCapability)(i))||(0,f.hasReadWriteCapability)(i)&&t?.preferUnbuffered?a=this.D(i,r,t):(0,f.hasFileReadStreamCapability)(i)?a=this.z(i,r,o.token,t):a=this.C(i,r,o.token,t),{...await c,value:a}}catch(u){throw a&&await(0,h.consumeStream)(a),this.w(u,r,t)}}w(i,r,t){const s=(0,y.localize)(8,null,this.nb(r),(0,f.ensureFileSystemProviderError)(i).toString());return i instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(s,i.stat,t):i instanceof f.TooLargeFileOperationError?new f.TooLargeFileOperationError(s,i.fileOperationResult,i.size,i.options):new f.FileOperationError(s,(0,f.toFileOperationResult)(i),t)}z(i,r,t,s=Object.create(null)){const o=i.readFileStream(r,s,t);return(0,h.transform)(o,{data:c=>c instanceof D.VSBuffer?c:D.VSBuffer.wrap(c),error:c=>this.w(c,r,s)},c=>D.VSBuffer.concat(c))}C(i,r,t,s=Object.create(null)){const o=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(i,r,o,c=>c,{...s,bufferSize:this.a,errorTransformer:c=>this.w(c,r,s)},t),o}D(i,r,t){const s=(0,h.newWriteableStream)(o=>D.VSBuffer.concat(o));return(async()=>{try{let o;t?.atomic&&(0,f.hasFileAtomicReadCapability)(i)?o=await i.readFile(r,{atomic:!0}):o=await i.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.G(r,o.byteLength,t),s.end(D.VSBuffer.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async F(i,r){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new f.FileOperationError((0,y.localize)(9,null,this.nb(i)),0,r);if(typeof r?.etag=="string"&&r.etag!==f.ETAG_DISABLED&&r.etag===t.etag)throw new f.NotModifiedSinceFileOperationError((0,y.localize)(10,null),t,r);return this.G(i,t.size,r),t}G(i,r,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&r>t.limits.size&&(s=7),typeof s=="number")throw new f.TooLargeFileOperationError((0,y.localize)(11,null,this.nb(i)),s,r,t)}}async canMove(i,r,t){return this.H(i,r,"move",t)}async canCopy(i,r,t){return this.H(i,r,"copy",t)}async H(i,r,t,s){if(i.toString()!==r.toString())try{const o=t==="move"?this.lb(await this.l(i),i):await this.k(i),c=this.lb(await this.l(r),r);await this.M(o,i,c,r,t,s)}catch(o){return o}return!0}async move(i,r,t){const s=this.lb(await this.l(i),i),o=this.lb(await this.l(r),r),c=await this.I(s,i,o,r,"move",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(i,c==="move"?2:3,a)),a}async copy(i,r,t){const s=await this.k(i),o=this.lb(await this.l(r),r),c=await this.I(s,i,o,r,"copy",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(i,c==="copy"?3:2,a)),a}async I(i,r,t,s,o,c){if(r.toString()===s.toString())return o;const{exists:a,isSameResourceWithDifferentPathCase:u}=await this.M(i,r,t,s,o,c);if(a&&!u&&c&&await this.del(s,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(s)),o==="copy"){if(i===t&&(0,f.hasFileFolderCopyCapability)(i))await i.copy(r,s,{overwrite:c});else{const w=await this.resolve(r);w.isDirectory?await this.L(i,w,t,s):await this.J(i,r,t,s)}return o}else return i===t?(await i.rename(r,s,{overwrite:c}),o):(await this.I(i,r,t,s,"copy",c),await this.del(r,{recursive:!0}),"copy")}async J(i,r,t,s){if((0,f.hasOpenReadWriteCloseCapability)(i)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.eb(i,r,t,s);if((0,f.hasOpenReadWriteCloseCapability)(i)&&(0,f.hasReadWriteCapability)(t))return this.kb(i,r,t,s);if((0,f.hasReadWriteCapability)(i)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.ib(i,r,t,s);if((0,f.hasReadWriteCapability)(i)&&(0,f.hasReadWriteCapability)(t))return this.gb(i,r,t,s)}async L(i,r,t,s){await t.mkdir(s),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async o=>{const c=this.N(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.L(i,await this.resolve(o.resource),t,c):this.J(i,o.resource,t,c)}))}async M(i,r,t,s,o,c){let a=!1;if(i===t){const{providerExtUri:w,isPathCaseSensitive:b}=this.N(i);if(b||(a=w.isEqual(r,s)),a&&o==="copy")throw new Error((0,y.localize)(12,null,this.nb(r),this.nb(s)));if(!a&&w.isEqualOrParent(s,r))throw new Error((0,y.localize)(13,null,this.nb(r),this.nb(s)))}const u=await this.exists(s);if(u&&!a){if(!c)throw new f.FileOperationError((0,y.localize)(14,null,this.nb(r),this.nb(s)),4);if(i===t){const{providerExtUri:w}=this.N(i);if(w.isEqualOrParent(r,s))throw new Error((0,y.localize)(15,null,this.nb(r),this.nb(s)))}}return{exists:u,isSameResourceWithDifferentPathCase:a}}N(i){const r=this.O(i);return{providerExtUri:r?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:r}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const r=this.lb(await this.j(i),i);await this.P(r,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(i,0,t)),t}async P(i,r){const t=[],{providerExtUri:s}=this.N(i);for(;!s.isEqual(r,s.dirname(r));)try{if(((await i.stat(r)).type&f.FileType.Directory)===0)throw new Error((0,y.localize)(16,null,this.nb(r)));break}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(r)),r=s.dirname(r)}for(let o=t.length-1;o>=0;o--){r=s.joinPath(r,t[o]);try{await i.mkdir(r)}catch(c){if((0,f.toFileSystemProviderErrorCode)(c)!==f.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(i,r){try{await this.Q(i,r)}catch(t){return t}return!0}async Q(i,r){const t=this.lb(await this.j(i),i);if(!!r?.useTrash&&!(t.capabilities&4096))throw new Error((0,y.localize)(17,null,this.nb(i)));let o;try{o=await t.stat(i)}catch{}if(o)this.mb(i,o);else throw new f.FileOperationError((0,y.localize)(18,null,this.nb(i)),1);if(!!!r?.recursive){const a=await this.resolve(i);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,y.localize)(19,null,this.nb(i)))}return t}async del(i,r){const t=await this.Q(i,r),s=!!r?.useTrash,o=!!r?.recursive;await t.delete(i,{recursive:o,useTrash:s}),this.m.fire(new f.FileOperationEvent(i,1))}async cloneFile(i,r){const t=await this.j(i),s=this.lb(await this.l(r),r);if(t===s&&this.N(t).providerExtUri.isEqual(i,r))return;if(t===s&&(0,f.hasFileCloneCapability)(t))return t.cloneFile(i,r);await this.P(s,this.N(s).providerExtUri.dirname(r));const o=this.X.queueFor(i,this.N(t).providerExtUri);return t===s&&(0,f.hasFileFolderCopyCapability)(t)?o.queue(()=>t.copy(i,r,{overwrite:!0})):o.queue(()=>this.J(t,i,s,r))}watch(i,r={recursive:!1,excludes:[]}){const t=new S.DisposableStore;let s=!1,o=()=>{s=!0};return t.add((0,S.toDisposable)(()=>o())),(async()=>{try{const c=await this.W(i,r);s?(0,S.dispose)(c):o=()=>(0,S.dispose)(c)}catch(c){this.b.error(c)}})(),t}async W(i,r){const t=await this.j(i),s=(0,R.hash)([this.N(t).providerExtUri.getComparisonKey(i),r]);let o=this.U.get(s);return o||(o={count:0,disposable:t.watch(i,r)},this.U.set(s,o)),o.count+=1,(0,S.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,S.dispose)(o.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,S.dispose)(i.disposable);this.U.clear()}async Y(i,r,t,s){return this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{const o=await i.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,h.isReadableStream)(s)||(0,h.isReadableBufferedStream)(s)?await this.Z(i,o,s):await this.ab(i,o,s)}catch(c){throw(0,f.ensureFileSystemProviderError)(c)}finally{await i.close(o)}})}async Z(i,r,t){let s=0,o;if((0,h.isReadableBufferedStream)(t)){if(t.buffer.length>0){const c=D.VSBuffer.concat(t.buffer);await this.bb(i,r,c,c.byteLength,s,0),s+=c.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((c,a)=>{(0,h.listenStream)(o,{onData:async u=>{o.pause();try{await this.bb(i,r,u,u.byteLength,s,0)}catch(w){return a(w)}s+=u.byteLength,setTimeout(()=>o.resume())},onError:u=>a(u),onEnd:()=>c()})})}async ab(i,r,t){let s=0,o;for(;(o=t.read())!==null;)await this.bb(i,r,o,o.byteLength,s,0),s+=o.byteLength}async bb(i,r,t,s,o,c){let a=0;for(;a<s;)a+=await i.write(r,o+a,t.buffer,c+a,s-a)}async cb(i,r,t,s){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.db(i,r,t,s))}async db(i,r,t,s){let o;s instanceof D.VSBuffer?o=s:(0,h.isReadableStream)(s)?o=await(0,D.streamToBuffer)(s):(0,h.isReadableBufferedStream)(s)?o=await(0,D.bufferedStreamToBuffer)(s):o=(0,D.readableToBuffer)(s),await i.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(i,r,t,s){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.fb(i,r,t,s))}async fb(i,r,t,s){let o,c;try{o=await i.open(r,{create:!1}),c=await t.open(s,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.a);let u=0,w=0,b=0;do b=await i.read(o,u,a.buffer,w,a.byteLength-w),await this.bb(t,c,a,b,u,w),u+=b,w+=b,w===a.byteLength&&(w=0);while(b>0)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await n.Promises.settled([typeof o=="number"?i.close(o):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async gb(i,r,t,s){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.hb(i,r,t,s))}async hb(i,r,t,s){return t.writeFile(s,await i.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(i,r,t,s){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.jb(i,r,t,s))}async jb(i,r,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const c=await i.readFile(r);await this.bb(t,o,D.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,f.ensureFileSystemProviderError)(c)}finally{await t.close(o)}}async kb(i,r,t,s){const o=await(0,D.streamToBuffer)(this.C(i,r,A.CancellationToken.None));await this.cb(t,s,void 0,o)}lb(i,r){if(i.capabilities&2048)throw new f.FileOperationError((0,y.localize)(20,null,this.nb(r)),6);return i}mb(i,r){if((r.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,y.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===E.Schemas.file?i.fsPath:i.toString(!0)}};v=pe([K(0,d.ILogService)],v),e.FileService=v}),define(oe[208],ae([0,1,53,288,6,37,17,3,48,2,12,5,22,44,28,166,13,100,205,38,200,199]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(k)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(r)}`)}})();class i extends d.AbstractDiskFileSystemProvider{constructor(t,s){super(t,s),this.onDidChangeCapabilities=R.Event.None,this.H=new A.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,E.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:s,symbolicLink:o}=await h.SymlinkSupport.stat(this.C(t));return{type:this.G(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.Y(s)}}async readdir(t){try{const s=await h.Promises.readdir(this.C(t),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(t,c.name))).type:a=this.G(c),o.push([c.name,a])}catch(a){this.a.trace(a)}})),o}catch(s){throw this.Y(s)}}G(t,s){let o;return s?.dangling?o=f.FileType.Unknown:t.isFile()?o=f.FileType.File:t.isDirectory()?o=f.FileType.Directory:o=f.FileType.Unknown,s&&(o|=f.FileType.SymbolicLink),o}async I(t){const s=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const c=new D.Barrier;return this.H.set(t,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.H.get(t)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),c.open()})}async readFile(t,s){let o;try{s?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),o=await this.I(t));const c=this.C(t);return await h.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{o?.dispose()}}J(t){i.D&&this.a.trace(t)}readFileStream(t,s,o){const c=(0,g.newWriteableStream)(a=>T.VSBuffer.concat(a.map(u=>T.VSBuffer.wrap(u))).buffer);return(0,l.readFileIntoStream)(this,t,c,a=>a.buffer,{...s,bufferSize:256*1024},o),c}async writeFile(t,s,o){let c;try{const a=this.C(t);if(!o.create||!o.overwrite){if(await h.Promises.exists(a)){if(!o.overwrite)throw(0,f.createFileSystemProviderError)((0,y.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,f.createFileSystemProviderError)((0,y.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,s,0,s.byteLength)}catch(a){throw await this.Z(t,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){i.O=t}async open(t,s){const o=this.C(t);let c;(0,f.isFileOpenForWriteOptions)(s)&&(c=await this.I(t));let a;try{if((0,f.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:w}=await h.SymlinkSupport.stat(o);w.mode&128||await h.Promises.chmod(o,w.mode|128)}catch(w){this.a.trace(w)}let u;if((0,f.isFileOpenForWriteOptions)(s)){if(E.isWindows)try{await h.Promises.truncate(o,0),u="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}u||(u="w")}else u="r";a=await h.Promises.open(o,u)}catch(u){throw c?.dispose(),(0,f.isFileOpenForWriteOptions)(s)?await this.Z(t,u):this.Y(u)}if(this.L.set(a,0),(0,f.isFileOpenForWriteOptions)(s)&&this.N.set(a,t),c){const u=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.M.set(a,c),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),u.dispose())}return a}async close(t){const s=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&i.O)try{await h.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.a.error(o)}return await h.Promises.close(t)}catch(o){throw this.Y(o)}finally{s&&(this.M.get(t)===s&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),s.dispose())}}async read(t,s,o,c,a){const u=this.P(t,s);let w=null;try{w=(await h.Promises.read(t,o,c,a,u)).bytesRead}catch(b){throw this.Y(b)}finally{this.Q(t,u,w)}return w}P(t,s){return s===this.L.get(t)?null:s}Q(t,s,o){const c=this.L.get(t);typeof c=="number"&&(typeof s=="number"||(typeof o=="number"?this.L.set(t,c+o):this.L.delete(t)))}async write(t,s,o,c,a){return(0,D.retry)(()=>this.R(t,s,o,c,a),100,3)}async R(t,s,o,c,a){const u=this.P(t,s);let w=null;try{w=(await h.Promises.write(t,o,c,a,u)).bytesWritten}catch(b){throw await this.Z(this.N.get(t),b)}finally{this.Q(t,u,w)}return w}async mkdir(t){try{await h.Promises.mkdir(this.C(t))}catch(s){throw this.Y(s)}}async delete(t,s){try{const o=this.C(t);s.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(t,s,o){const c=this.C(t),a=this.C(s);if(c!==a)try{await this.S(t,s,"move",o.overwrite),await h.Promises.move(c,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,y.localize)(2,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(a)),u.toString()))),this.Y(u)}}async copy(t,s,o){const c=this.C(t),a=this.C(s);if(c!==a)try{await this.S(t,s,"copy",o.overwrite),await h.Promises.copy(c,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,y.localize)(3,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(a)),u.toString()))),this.Y(u)}}async S(t,s,o,c){const a=this.C(t),u=this.C(s);let w=!1;if(!!(this.capabilities&1024)||(w=(0,P.isEqual)(a,u,!0)),w&&o==="copy")throw(0,f.createFileSystemProviderError)((0,y.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!w&&await h.Promises.exists(u)){if(!c)throw(0,f.createFileSystemProviderError)((0,y.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(t,s){return this.U(t,s,!1)}async U(t,s,o){const c=this.C(t),a=this.C(s),u=!!(this.capabilities&1024);if((0,P.isEqual)(c,a,!u))return;const w=new S.DisposableStore;try{const[b,U]=await Promise.all([this.I(t),this.I(s)]);w.add(b),w.add(U),o&&await h.Promises.mkdir((0,C.dirname)(a),{recursive:!0}),await h.Promises.copyFile(c,a)}catch(b){if(b.code==="ENOENT"&&!o)return this.U(t,s,!0);throw this.Y(b)}finally{w.dispose()}}p(t,s,o){return new v.UniversalWatcherClient(c=>t(c),c=>s(c),o)}y(t,s,o){return new I.NodeJSWatcherClient(c=>t(c),c=>s(c),o)}Y(t){if(t instanceof f.FileSystemProviderError)return t;let s;switch(t.code){case"ENOENT":s=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=f.FileSystemProviderErrorCode.NoPermissions;break;default:s=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(t,s)}async Z(t,s){let o=this.Y(s);if(t&&o.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await h.SymlinkSupport.stat(this.C(t));c.mode&128||(o=(0,f.createFileSystemProviderError)(s,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(oe[101],ae([0,1,6,3,2,4,8]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("lifecycleSharedProcessService");let R=class extends D.Disposable{constructor(S){super(),this.c=S,this.a=void 0,this.b=this.B(new n.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this.b.fire({join(C){S.push(C)}}),this.a=(async()=>{try{await k.Promises.settled(S)}catch(C){this.c.error(C)}})(),this.a}};R=pe([K(0,T.ILogService)],R),e.SharedProcessLifecycleService=R}),define(oe[102],ae([0,1,3,7,8]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(p,g){this.a=p,this.b=g,this.onDidChangeLogLevel=k.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(p,g,h){switch(g){case"setLevel":return h[1]?this.b.setLevel(n.URI.revive(h[1]),h[0]):this.a.setLevel(h[0])}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=A;class T{constructor(p){this.a=p}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(p,g){T.setLevel(this.a,p,g)}static setLevel(p,g,h){return p.call("setLevel",[g,h])}}e.LogLevelChannelClient=T;class R{constructor(p){this.b=p,this.a=new Map}listen(p,g){throw new Error(`Event not found: ${g}`)}async call(p,g,h){switch(g){case"createLogger":this.c(n.URI.revive(h[0]),h[1]);return;case"log":return this.e(n.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1])}throw new Error(`Call not found: ${g}`)}c(p,g){this.a.set(p.toString(),this.b.createLogger(p,g))}d(p,g){let h=console.log;switch(p){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...g)}e(p,g){const h=this.a.get(p.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,f]of g)(0,D.log)(h,y,f)}}e.LoggerChannel=R;class P extends D.AbstractLoggerService{constructor(p,g,h){super(p,g),this.g=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(p,g)=>{this.g.call("consoleLog",[p,g])}})}f(p,g,h){return new S(this.g,p,g,h)}}e.LoggerChannelClient=P;class S extends D.AbstractMessageLogger{constructor(p,g,h,y){super(y?.always),this.m=p,this.n=g,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[g,y]).then(()=>{this.r(this.l),this.k=!0})}g(p,g){const h=[[p,g]];this.k?this.r(h):this.l.push(...h)}r(p){this.m.call("log",[this.n,p])}}class C extends D.LogService{constructor(p,g){super(g),this.c=p,this.B(p.onDidChangeLogLevel(h=>g.setLevel(h)))}setLevel(p){super.setLevel(p),this.c.setLevel(p)}}e.FollowerLogService=C}),define(oe[58],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(oe[59],ae([0,1,3,64,2,4]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class T extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const C=Object.keys(this.f).length;return this.f={...S,...this.f},C!==Object.keys(this.f).length&&await this.i(S),n.Iterable.reduce(this.g.entries(),(E,[p,g])=>({...E,[p]:g}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return n.Iterable.reduce(Object.entries(this.f),(S,[C,E])=>({...S,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.AbstractPolicyService=T;class R{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(oe[209],ae([0,1,3,2,59]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(P){this.b=P,this.a=new n.DisposableStore}listen(P,S){switch(S){case"onDidChange":return k.Event.map(this.b.onDidChange,C=>C.reduce((E,p)=>({...E,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(P,S,C){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class T extends D.AbstractPolicyService{constructor(P,S){super(),this.a=S;for(const C in P){const{definition:E,value:p}=P[C];this.f[C]=E,p!==void 0&&this.g.set(C,p)}this.a.listen("onDidChange")(C=>{for(const E in C){const p=C[E];p===null?this.g.delete(E):this.g.set(E,p)}this.h.fire(Object.keys(C))})}async i(P){const S=await this.a.call("updatePolicyDefinitions",P);for(const C in S)this.g.set(C,S[C])}}e.PolicyChannelClient=T}),define(oe[103],ae([0,1,5,36]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const A=k.globals.vscode.context.configuration();if(A)D=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:A.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(oe[25],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[210],ae([0,1,6,9,2,12,28,8,25]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends D.Disposable{constructor(E,p,g){super(),this.b=p,this.c=g,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new k.RunOnceScheduler(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),g=(0,A.dirname)(E),h=(0,A.basename)(E),y=await T.Promises.readdir(g);await Promise.all(y.map(async f=>{if(f===h)return;const l=(0,A.join)(g,f),d=await T.Promises.stat(l);if(d.isDirectory()&&p-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),T.Promises.rm(l)}))}catch(p){(0,n.onUnexpectedError)(p)}}};S=pe([K(1,P.IProductService),K(2,R.ILogService)],S),e.CodeCacheCleaner=S}),define(oe[211],ae([0,1,6,9,2,12,28,15,8,25]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends D.Disposable{constructor(p,g,h){super(),this.b=p,this.c=g,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new k.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),g=JSON.parse(await T.Promises.readFile((0,A.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(g)){const m=g[d];p[`${m.hash}.${d}`]=!0}const h=(0,A.join)(this.b.userDataPath,"clp");if(!await T.Promises.exists(h))return;const f=await T.Promises.readdir(h);for(const d of f){if(p[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await T.Promises.rm((0,A.join)(h,d))}const l=Date.now();for(const d of Object.keys(p)){const m=(0,A.join)(h,d),v=await T.Promises.readdir(m);for(const I of v){if(I==="tcf.json")continue;const i=(0,A.join)(m,I),r=await T.Promises.stat(i);r.isDirectory()&&l-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(d,I)}`),await T.Promises.rm(i))}}}catch(p){(0,n.onUnexpectedError)(p)}}};C=pe([K(0,R.INativeEnvironmentService),K(1,P.ILogService),K(2,S.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(oe[212],ae([0,1,21,2,22,187,13,25]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let P=class extends n.Disposable{constructor(C,E){super(),this.b=C,this.c=E,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,p])=>this.a.set(p.configPath,p))}getConfigBasedTips(C){return this.f(C)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(C){const E=[];for(const[p,g]of this.a)if(!(g.configScheme&&g.configScheme!==C.scheme))try{const h=await this.b.readFile((0,D.joinPath)(C,p)),y=new Map;Object.entries(g.recommendations).forEach(([l,d])=>{if((0,k.isNonEmptyArray)(d.remotes))for(const m of d.remotes)y.set(m,{extensionId:l,extensionName:d.name,configName:g.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else E.push({extensionId:l,extensionName:d.name,configName:g.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const f=(0,A.getDomainsOfRemotes)(h.value.toString(),[...y.keys()]);for(const l of f){const d=y.get(l);d&&E.push(d)}}catch{}return E}};P=pe([K(0,T.IFileService),K(1,R.IProductService)],P),e.ExtensionTipsService=P}),define(oe[213],ae([0,1,12,4]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var D;(function(A){function T(P){return Boolean(P.samples&&P.timeDeltas)}A.isValidProfile=T;function R(P,S="noAbsolutePaths"){for(const C of P.nodes)C.callFrame&&C.callFrame.url&&((0,k.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,k.join)(S,(0,k.basename)(C.callFrame.url)));return P}A.rewriteAbsolutePaths=R})(D=e.Utils||(e.Utils={}))}),define(oe[214],ae([0,1,31]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((S,C)=>{Z(["v8-inspect-profiler"],S,C)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,k.generateUuid)();return this.a.set(P,R),P}async stopProfiling(A){const T=this.a.get(A);if(!T)throw new Error(`UNKNOWN session '${A}'`);const R=await T.stop();return this.a.delete(A),R.profile}}e.InspectProfilingService=n}),define(oe[40],ae([0,1,126,14]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(T,R){k.ok(n.isString(T)),k.ok(n.isObject(R)),k.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,R)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.Registry=new D}),define(oe[104],ae([0,1,3,40]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new k.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,S){this.a[D(P)]=S,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const T=new A;n.Registry.add(e.Extensions.JSONContribution,T)}),define(oe[46],ae([0,1,21,3,14,152,16,104,40]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=P.Registry.as(R.Extensions.JSONContribution);class p{constructor(){this.h=new Set,this.i=new n.Emitter,this.onDidSchemaChange=this.i.event,this.j=new n.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:s,source:o}of i)for(const c in s)if(r.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.a.get(c),u=a?.valuesSources??new Map;if(o)for(const N of Object.keys(s[c]))u.set(N,o);const w={...a?.value||{},...s[c]};this.a.set(c,{source:o,value:w,valuesSources:u});const b=(0,T.getLanguageTagSettingPlainKey)(c),U={type:"object",default:w,description:A.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:D.isString(o)?void 0:o,defaultValueSource:o};t.push(...y(c)),this.d[c]=U,this.b.properties[c]=U}else{this.a.set(c,{value:s[c],source:o});const a=this.d[c];a&&(this.w(c,a),this.r(c,a))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:s}of i)for(const o in t){const c=this.a.get(o),a=D.isString(s)?s:s?.id,u=D.isString(c?.source)?c?.source:c?.source?.id;if(a===u)if(r.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const w=this.d[o];w&&(this.w(o,w),this.r(o,w))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(s=>{this.p(s,r,s.extensionInfo,s.restrictedProperties,void 0,t),this.c.push(s),this.q(s)})}o(i,r){const t=s=>{if(s.properties)for(const o in s.properties){r.add(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.s(o,s.properties[o])}s.allOf?.forEach(o=>t(o))};for(const s of i){t(s);const o=this.c.indexOf(s);o!==-1&&this.c.splice(o,1)}}p(i,r=!0,t,s,o=3,c){o=D.isUndefinedOrNull(i.scope)?o:i.scope;const a=i.properties;if(a)for(const w in a){const b=a[w];if(r&&m(w,b)){delete a[w];continue}if(b.source=t,b.defaultDefaultValue=a[w].default,this.w(w,b),e.OVERRIDE_PROPERTY_REGEX.test(w)?b.scope=void 0:(b.scope=D.isUndefinedOrNull(b.scope)?o:b.scope,b.restricted=D.isUndefinedOrNull(b.restricted)?!!s?.includes(w):b.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),c.add(w)}const u=i.allOf;if(u)for(const w of u)this.p(w,r,t,s,o,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const s=t.properties;if(s)for(const c in s)this.r(c,s[c]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let s=t?.value,o=t?.source;D.isUndefined(s)&&(s=r.defaultDefaultValue,o=void 0),D.isUndefined(s)&&(s=l(r.type)),r.default=s,r.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",h=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(I){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(I)){let r=h.exec(I);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=h.exec(I)}}return(0,k.distinct)(i)}e.overrideIdentifiersFromKey=y;function f(I){return I.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=f;function l(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const d=new p;P.Registry.add(e.Extensions.Configuration,d);function m(I,i){return I.trim()?e.OVERRIDE_PROPERTY_REGEX.test(I)?A.localize(7,null,I):d.getConfigurationProperties()[I]!==void 0?A.localize(8,null,I):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,I,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.validateProperty=m;function v(){const I=[],i=d.getConfigurationProperties();for(const r of Object.keys(i))I.push([r,i[r].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=v}),define(oe[74],ae([0,1,21,3,35,2,37,32,14,7,16,46,40]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class g{constructor(r={},t=[],s=[],o){this.c=r,this.d=t,this.f=s,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof g)return t;const s=new h("");return s.parseRaw(t),s.configurationModel});this.g=r.reduce((t,s)=>s===t?s:t.merge(s),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,C.getConfigurationValue)(this.contents,r):this.contents}inspect(r,t){const s=this.rawConfiguration.getValue(r),o=t?this.rawConfiguration.getOverrideValue(r,t):void 0,c=t?this.rawConfiguration.override(t).getValue(r):s;return{value:s,override:o,merged:c}}getOverrideValue(r,t){const s=this.l(t);return s?r?(0,C.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const s of this.overrides)s.identifiers.includes(r)&&t.push(...s.keys);return k.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return k.distinct(r)}override(r){let t=this.b.get(r);return t||(t=this.h(r),this.b.set(r,t)),t}merge(...r){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of r)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(t,a.contents);for(const u of a.overrides){const[w]=s.filter(b=>k.equals(b.identifiers,u.identifiers));w?(this.j(w.contents,u.contents),w.keys.push(...u.keys),w.keys=k.distinct(w.keys)):s.push(R.deepClone(u))}for(const u of a.keys)o.indexOf(u)===-1&&o.push(u)}return new g(t,o,s,c.every(a=>a instanceof g)?void 0:c)}freeze(){return this.a=!0,this}h(r){const t=this.l(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const o of k.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o];const a=t[o];a&&(typeof c=="object"&&typeof a=="object"?(c=R.deepClone(c),this.j(c,a)):c=a),s[o]=c}return new g(s,this.keys,this.overrides)}j(r,t){for(const s of Object.keys(t)){if(s in r&&P.isObject(r[s])&&P.isObject(t[s])){this.j(r[s],t[s]);continue}r[s]=R.deepClone(t[s])}}k(r){return this.a&&!Object.isFrozen(r)?R.deepFreeze(r):r}l(r){let t=null,s=null;const o=c=>{c&&(s?this.j(s,c):s=R.deepClone(c))};for(const c of this.overrides)k.equals(c.identifiers,[r])?t=c.contents:c.identifiers.includes(r)&&o(c.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.m(r),(0,C.addToValueTree)(this.contents,r,t,s=>{throw new Error(s)})}removeValue(r){this.n(r)&&(0,C.removeFromValueTree)(this.contents,r)}m(r){let t=this.keys.length;for(let s=0;s<t;s++)r.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,r)}n(r){const t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=g;class h{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!P.isUndefinedOrNull(r)){const s=this.g(r);this.parseRaw(s,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:s,keys:o,overrides:c,restricted:a,hasExcludedProperties:u}=this.h(r,t);this.b=new g(s,o,c,u?[r]:void 0),this.c=a||[]}g(r){let t={},s=null,o=[];const c=[],a=[];function u(b){Array.isArray(o)?o.push(b):s!==null&&(o[s]=b)}const w={onObjectBegin:()=>{const b={};u(b),c.push(o),o=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const b=[];u(b),c.push(o),o=b,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:u,onError:(b,U,N)=>{a.push({error:b,offset:U,length:N})}};if(r)try{D.visit(r,w),t=o[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return t}h(r,t){const s=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.j(r,s,!0,t);r=o.raw;const c=(0,C.toValuesTree)(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),a=Object.keys(r),u=this.l(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:c,keys:a,overrides:u,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(r,t,s,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const a={},u=[];for(const w in r)if(E.OVERRIDE_PROPERTY_REGEX.test(w)&&s){const b=this.j(r[w],t,!1,o);a[w]=b.raw,c=c||b.hasExcludedProperties,u.push(...b.restricted)}else{const b=t[w],U=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&u.push(w),(U===void 0||o.scopes===void 0||o.scopes.includes(U))&&!(o.skipRestricted&&b?.restricted)?a[w]=r[w]:c=!0}return{raw:a,restricted:u,hasExcludedProperties:c}}l(r,t){const s=[];for(const o of Object.keys(r))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in r[o])c[a]=r[o][a];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,C.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=h;class y extends A.Disposable{constructor(r,t,s,o){super(),this.f=r,this.g=t,this.h=o,this.c=this.B(new n.Emitter),this.onDidChange=this.c.event,this.a=new h(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(n.Event.any(n.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),n.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new g}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=y;class f{constructor(r,t,s,o,c,a,u,w,b,U,N,$,F){this.a=r,this.b=t,this.value=s,this.overrideIdentifiers=o,this.c=c,this.d=a,this.f=u,this.g=w,this.h=b,this.j=U,this.k=N,this.l=$,this.m=F}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,t,s,o,c=new g,a=new g,u=new T.ResourceMap,w=new g,b=new T.ResourceMap,U=!0){this.c=r,this.d=t,this.f=s,this.g=o,this.h=c,this.j=a,this.l=u,this.m=w,this.n=b,this.p=U,this.a=null,this.b=new T.ResourceMap,this.q=null}getValue(r,t,s){return this.s(r,t,s).getValue(r)}updateValue(r,t,s={}){let o;s.resource?(o=this.n.get(s.resource),o||(o=new g,this.n.set(s.resource,o))):o=this.m,t===void 0?o.removeValue(r):o.setValue(r,t),s.resource||(this.a=null)}inspect(r,t,s){const o=this.s(r,t,s),c=this.w(t.resource,s),a=t.resource?this.n.get(t.resource)||this.m:this.m,u=new Set;for(const w of o.overrides)for(const b of w.identifiers)o.getOverrideValue(r,b)!==void 0&&u.add(b);return new f(r,t,o.getValue(r),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),s?this.j.freeze():void 0,c?c.freeze():void 0,a.inspect(r,t.overrideIdentifier))}keys(r){const t=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.l.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const s=[];if(!t){const{added:o,updated:c,removed:a}=v(this.c,r);t=[...o,...c,...a]}for(const o of t)for(const c of(0,E.overrideIdentifiersFromKey)(o)){const a=this.c.getKeysForOverrideIdentifier(c),u=r.getKeysForOverrideIdentifier(c),w=[...u.filter(b=>a.indexOf(b)===-1),...a.filter(b=>u.indexOf(b)===-1),...a.filter(b=>!R.equals(this.c.override(c).getValue(b),r.override(c).getValue(b)))];s.push([c,w])}return this.updateDefaultConfiguration(r),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:s,removed:o}=v(this.d,r),c=[...t,...s,...o];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:s,removed:o,overrides:c}=v(this.applicationConfiguration,r),a=[...t,...s,...o];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:s,removed:o,overrides:c}=v(this.localUserConfiguration,r),a=[...t,...s,...o];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:s,removed:o,overrides:c}=v(this.remoteUserConfiguration,r),a=[...t,...s,...o];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:s,removed:o,overrides:c}=v(this.workspaceConfiguration,r),a=[...t,...s,...o];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(r,t){const s=this.r.get(r),{added:o,updated:c,removed:a,overrides:u}=v(s,t),w=[...o,...c,...a];return(w.length||!s)&&this.updateFolderConfiguration(r,t),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(r){const t=this.r.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:o,removed:c,overrides:a}=v(t,void 0);return{keys:[...s,...o,...c],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,t,s){let o=this.t(t,s);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}t({resource:r},t){let s=this.u();if(t&&r){const o=t.getFolder(r);o&&(s=this.v(o.uri)||s);const c=this.n.get(r);c&&(s=s.merge(c))}return s}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let t=this.b.get(r);if(!t){const s=this.u(),o=this.l.get(r);o?(t=s.merge(o),this.p&&(t=t.freeze()),this.b.set(r,t)):t=s}return t}w(r,t){if(t&&r){const s=t.getFolder(r);if(s)return this.l.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,t)=>{const{contents:s,overrides:o,keys:c}=this.l.get(t);return r.push([t,{contents:s,overrides:o,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this.j.freeze().keys.forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}y(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s)),this.j.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s)),this.l.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o))),[...t.values()]}static parse(r){const t=this.z(r.defaults),s=this.z(r.policy),o=this.z(r.application),c=this.z(r.user),a=this.z(r.workspace),u=r.folders.reduce((w,b)=>(w.set(S.URI.revive(b[0]),this.z(b[1])),w),new T.ResourceMap);return new l(t,s,o,c,new g,a,u,new g,new T.ResourceMap,!1)}static z(r){return new g(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function d(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,t=new Map;for(const o of i)o.keys.forEach(c=>r.add(c)),o.overrides.forEach(([c,a])=>{const u=(0,T.getOrSet)(t,c,new Set);a.forEach(w=>u.add(w))});const s=[];return t.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=d;class m{constructor(r,t,s,o){this.change=r,this.f=t,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const a of c)this.affectedKeys.add(a);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=l.parse(this.f.data)),this.j}affectsConfiguration(r,t){const s=this.a+r,o=this.d.indexOf(s);if(o<0)return!1;const c=o+s.length;if(c>=this.d.length)return!1;const a=this.d.charCodeAt(c);if(a!==this.b&&a!==this.c)return!1;if(t){const u=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,w=this.g.getValue(r,t,this.h);return!R.equals(u,w)}return!0}}e.ConfigurationChangeEvent=m;function v(i,r){const{added:t,removed:s,updated:o}=I(r?.rawConfiguration,i?.rawConfiguration),c=[],a=i?.getAllOverrideIdentifiers()||[],u=r?.getAllOverrideIdentifiers()||[];if(r){const w=u.filter(b=>!a.includes(b));for(const b of w)c.push([b,r.getKeysForOverrideIdentifier(b)])}if(i){const w=a.filter(b=>!u.includes(b));for(const b of w)c.push([b,i.getKeysForOverrideIdentifier(b)])}if(r&&i){for(const w of a)if(u.includes(w)){const b=I({contents:i.getOverrideValue(void 0,w)||{},keys:i.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});c.push([w,[...b.added,...b.removed,...b.updated]])}}return{added:t,removed:s,updated:o,overrides:c}}function I(i,r){const t=i?r?i.keys.filter(c=>r.keys.indexOf(c)===-1):[...i.keys]:[],s=r?i?r.keys.filter(c=>i.keys.indexOf(c)===-1):[...r.keys]:[],o=[];if(i&&r){for(const c of r.keys)if(i.keys.indexOf(c)!==-1){const a=(0,C.getConfigurationValue)(r.contents,c),u=(0,C.getConfigurationValue)(i.contents,c);R.equals(a,u)||o.push(c)}}return{added:t,removed:s,updated:o}}}),define(oe[215],ae([0,1,21,3,2,32,14,16,74,46,8,59,40]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class g extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new n.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new h(this.f())),this.b}async initialize(){return this.b=void 0,this.B(p.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:m})=>this.c(Array.from(d),m))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(d,m){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}}e.DefaultConfiguration=g;class h extends P.ConfigurationModel{constructor(d={}){const m=p.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),v=Object.keys(m),I=Object.create(null),i=[];for(const r in m){const t=d[r],s=t!==void 0?t:m[r].default;(0,R.addToValueTree)(I,r,s,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(I))S.OVERRIDE_PROPERTY_REGEX.test(r)&&i.push({identifiers:(0,S.overrideIdentifiersFromKey)(r),keys:Object.keys(I[r]),contents:(0,R.toValuesTree)(I[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(I,v,i)}}e.DefaultConfigurationModel=h;class y{constructor(){this.onDidChangeConfiguration=n.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let f=class extends D.Disposable{get configurationModel(){return this.b}constructor(d,m,v){super(),this.c=d,this.f=m,this.g=v,this.a=this.B(new n.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.i(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.j(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const m={},v=[],I=p.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const i of d){const r=I[i];if(!r){v.push(i);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}v.push(i),m[r.policy.name]={type:r.type}}}return(0,T.isEmptyObject)(m)||await this.f.updatePolicyDefinitions(m),v}i(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const m=p.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),v=(0,k.coalesce)(d.map(I=>m.get(I)));this.j(v,!0)}j(d,m){this.g.trace("PolicyConfiguration#update",d);const v=p.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),I=[],i=this.b.isEmpty();for(const r of d){const t=v[r]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(i?s!==void 0:!(0,A.equals)(this.b.getValue(r),s))&&I.push([r,s])}else this.b.getValue(r)!==void 0&&I.push([r,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const r=this.b;this.b=new P.ConfigurationModel;for(const t of r.keys)this.b.setValue(t,r.getValue(t));for(const[t,s]of I)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);m&&this.a.fire(this.b)}}};f=pe([K(1,E.IPolicyService),K(2,C.ILogService)],f),e.PolicyConfiguration=f}),define(oe[216],ae([0,1,6,3,2,22,16,74,215,59]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(p,g,h,y){super(),this.i=p,this.h=this.B(new n.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new P.DefaultConfiguration),this.c=h instanceof S.NullPolicyService?new P.NullPolicyConfiguration:this.B(new P.PolicyConfiguration(this.b,h,y)),this.f=this.B(new R.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,g)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:l})=>this.k(f,l))),this.B(this.c.onDidChangeConfiguration(f=>this.l(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,g,h]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(p,g,new R.ConfigurationModel,h)}getConfigurationData(){return this.a.toData()}getValue(p,g){const h=typeof p=="string"?p:void 0,y=(0,T.isConfigurationOverrides)(p)?p:(0,T.isConfigurationOverrides)(g)?g:{};return this.a.getValue(h,y,void 0)}updateValue(p,g,h,y){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const g=this.a.toData(),h=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(h,g,2)}k(p,g){const h=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(p,g);this.m(y,h,7)}l(p){const g=this.a.toData(),h=this.a.compareAndUpdatePolicyConfiguration(p);this.m(h,g,7)}m(p,g,h){const y=new R.ConfigurationChangeEvent(p,{data:g},this.a);y.source=h,y.sourceConfig=this.n(h),this.h.fire(y)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(oe[217],ae([0,1,9,4]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var D;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends k.ErrorNoTelemetry{static isNotAvailable(R){return R instanceof A&&R._code===D.NotAvailable}static isTemporarilyNotAvailable(R){return R instanceof A&&R._code===D.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof A&&R._code===D.NoResolverFound}static isHandled(R){return R instanceof A&&R.isHandled}constructor(R,P=D.Unknown,S){super(R),this._message=R,this._code=P,this._detail=S,this.isHandled=P===D.NotAvailable&&S===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(oe[75],ae([0,1,24]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(S){return S.scheme===k.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=n;function D(S){if(!S)return;const C=S.indexOf("+");return C<0?S:S.substr(0,C)}e.getRemoteName=D;function A(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(S){const{host:C,port:E}=P(S);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}e.parseAuthorityWithPort=T;function R(S,C){let{host:E,port:p}=P(S);return typeof p>"u"&&(p=C),{host:E,port:p}}e.parseAuthorityWithOptionalPort=R;function P(S){const C=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=S.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const p=S.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:S,port:void 0}}}),define(oe[42],ae([0,1,27,4,75]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=A;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var P;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(y){this.value=y,this.c=y.toLowerCase()}static equals(y,f){if(typeof y>"u"||y===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof y=="string"||typeof f=="string"){const l=typeof y=="string"?y:y.value,d=typeof f=="string"?f:f.value;return k.equalsIgnoreCase(l,d)}return y.c===f.c}static toKey(y){return typeof y=="string"?y.toLowerCase():y.c}}e.ExtensionIdentifier=S;function C(h){return E(h)}e.isApplicationScopedExtension=C;function E(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function p(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function g(h,y){if(y){const f=`onResolveRemoteAuthority:${(0,D.getRemoteName)(y)}`;return h.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[218],ae([0,1,2,12,28,42]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends k.Disposable{constructor(P,S){super(),this.b=P,this.a=(0,n.join)(this.b.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(C=>this.c(C))),this.B(S.onDidUninstallExtension(C=>this.f(C)))}c(P){P.some(S=>!!S.local)&&this.invalidate()}f(P){P.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(oe[219],ae([0,1,6,17,23,9,3,2,31,92,217,75]),function(Z,e,k,n,D,A,T,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var g;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function h(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function y(O){const M=new D.CancellationTokenSource;return setTimeout(()=>M.cancel(),O),M.token}function f(O,M){if(O.isCancellationRequested||M.isCancellationRequested)return D.CancellationToken.Cancelled;const W=new D.CancellationTokenSource;return O.onCancellationRequested(()=>W.cancel()),M.onCancellationRequested(()=>W.cancel()),W.token}class l{get didTimeout(){return this.c==="timedout"}constructor(M){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((W,B)=>{this.f=W,this.g=B}),M.isCancellationRequested?this.h():this.d.add(M.onCancellationRequested(()=>this.h()))}registerDisposable(M){this.c==="pending"?this.d.add(M):M.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const M=new Error("Time limit reached");return M.code="ETIMEDOUT",M.syscall="connect",M}resolve(M){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(M))}reject(M){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(M))}}function d(O,M){const W=new l(M);return W.registerDisposable(O.onControlMessage(B=>{const x=JSON.parse(B.toString()),ie=q(x);ie?W.reject(ie):W.resolve(x)})),W.promise}function m(O,M,W,B,x,ie,J,_){const se=new l(_);return M.connect(W,B,x,ie,J,(ue,le)=>{se.didTimeout?(ue&&O.error(ue),le?.dispose()):ue||!le?se.reject(ue):se.resolve(le)}),se.promise}function v(O,M){const W=new l(M);return O.then(B=>{W.didTimeout||W.resolve(B)},B=>{W.didTimeout||W.reject(B)}),W.promise}async function I(O,M,W,B){const x=re(O,M);O.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await m(O.logService,O.socketFactory,O.host,O.port,(0,E.getRemoteServerRootPath)(O),`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,`renderer-${h(M)}-${O.reconnectionToken}`,B)}catch(le){throw O.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),O.logService.error(le),le}O.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let J,_;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection(ie,null),J=O.reconnectionProtocol,_=!1):(J=new S.PersistentProtocol({socket:ie,measureRoundTripTime:!0}),_=!0),O.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const se=await v(O.signService.createNewMessage((0,P.generateUuid)()),B),ue={type:"auth",auth:O.connectionToken||"00000000000000000000",data:se.data};J.sendControl(n.VSBuffer.fromString(JSON.stringify(ue)));try{const le=await d(J,f(B,y(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(O.logService.trace(`${x} 4/6. received SignRequest control message.`),!await v(O.signService.validate(se,le.signedData),B)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const Se=await v(O.signService.sign(le.data),B),be={type:"connectionType",commit:O.commit,signedData:Se,desiredConnectionType:M};return W&&(be.args=W),O.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(n.VSBuffer.fromString(JSON.stringify(be))),{protocol:J,ownsProtocol:_}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(O.logService.error(`${x} the handshake timed out. Error:`),O.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${x} received error control message when negotiating connection. Error:`),O.logService.error(le)),_&&H(J),le}}async function i(O,M,W,B){const x=Date.now(),ie=re(O,M),{protocol:J,ownsProtocol:_}=await I(O,M,W,B),se=new l(B);return se.registerDisposable(J.onControlMessage(ue=>{const le=JSON.parse(ue.toString()),ye=q(le);ye?(O.logService.error(`${ie} received error control message when negotiating connection. Error:`),O.logService.error(ye),_&&H(J),se.reject(ye)):(O.reconnectionProtocol?.endAcceptReconnection(),O.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${te(x)}!`),se.resolve({protocol:J,firstMessage:le}))})),se.promise}async function r(O,M){const{protocol:W}=await i(O,1,void 0,M);return{protocol:W}}async function t(O,M,W){const{protocol:B,firstMessage:x}=await i(O,2,M,W),ie=x&&x.debugPort;return{protocol:B,debugPort:ie}}async function s(O,M,W){const B=Date.now(),x=re(O,3),{protocol:ie}=await I(O,3,M,W);return O.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${te(B)}!`),ie}async function o(O,M,W){const{host:B,port:x,connectionToken:ie}=await O.addressProvider.getAddress();return{commit:O.commit,quality:O.quality,host:B,port:x,connectionToken:ie,reconnectionToken:M,reconnectionProtocol:W,socketFactory:O.socketFactory,signService:O.signService,logService:O.logService}}async function c(O,M,W){return u(O,async B=>{const{protocol:x}=await r(B,D.CancellationToken.None);return new Q(O,M,W,B.reconnectionToken,x)})}e.connectRemoteAgentManagement=c;async function a(O,M){return u(O,async W=>{const{protocol:B,debugPort:x}=await t(W,M,D.CancellationToken.None);return new Y(O,M,W.reconnectionToken,B,x)})}e.connectRemoteAgentExtensionHost=a;async function u(O,M){for(let B=1;;B++)try{const x=(0,P.generateUuid)(),ie=await o(O,x,null);return await M(ie)}catch(x){if(B<5)O.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),O.logService.error(x);else throw O.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),O.logService.error(x),V.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(x)),x}}async function w(O,M,W){const B=await o(O,(0,P.generateUuid)(),null);return await s(B,{host:M,port:W},D.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function b(O){return(0,k.createCancelablePromise)(M=>new Promise((W,B)=>{const x=setTimeout(W,O*1e3);M.onCancellationRequested(()=>{clearTimeout(x),W()})}))}var U;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain",O[O.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(U=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class N{constructor(M,W){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=N;class ${constructor(M,W,B,x){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.durationSeconds=B,this.c=x,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=$;class F{constructor(M,W,B){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=F;class L{constructor(M,W,B){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.attempt=B,this.type=4}}e.ConnectionGainEvent=L;class j{constructor(M,W){this.reconnectionToken=M,this.connectionHealth=W,this.type=5}}e.ConnectionHealthChangedEvent=j;class z{constructor(M,W,B,x){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.attempt=B,this.handled=x,this.type=3}}e.ReconnectionPermanentFailureEvent=z;class V extends R.Disposable{static triggerPermanentFailure(M,W,B){this._permanentFailure=!0,this.f=M,this.g=W,this.h=B,this.i.forEach(x=>x.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(M=>M.r())}static debugPauseSocketWriting(){this.i.forEach(M=>M.v())}get k(){return this.c||V._permanentFailure}constructor(M,W,B,x,ie){super(),this.m=M,this.n=W,this.reconnectionToken=B,this.protocol=x,this.p=ie,this.j=this.B(new T.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new L(this.reconnectionToken,0,0)),this.B(x.onSocketClose(J=>{const _=ee(this.m,this.reconnectionToken,!0);J?J.type===0?(this.n.logService.info(`${_} received socket close event (hadError: ${J.hadError}).`),J.error&&this.n.logService.error(J.error)):(this.n.logService.info(`${_} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.n.logService.error(J.event)):this.n.logService.info(`${_} received socket close event.`),this.r()})),this.B(x.onSocketTimeout(J=>{const _=ee(this.m,this.reconnectionToken,!0);this.n.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(x.onHighRoundTripTime(J=>{const _=X(this.m,this.reconnectionToken);this.n.logService.info(`${_} high roundtrip time: ${J.roundTripTime}ms (${J.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(x.onDidChangeConnectionHealth(J=>{this.j.fire(new j(this.reconnectionToken,J))})),V.i.push(this),this.B((0,R.toDisposable)(()=>{const J=V.i.indexOf(this);J>=0&&V.i.splice(J,1)})),this.k&&this.u(V.f,V.g,V.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const M=ee(this.m,this.reconnectionToken,!0);this.n.logService.info(`${M} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const x=B<W.length?W[B]:W[W.length-1];try{if(x>0){const J=b(x);this.j.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,J)),this.n.logService.info(`${M} waiting for ${x} seconds before reconnecting...`);try{await J}catch{}}if(this.k){this.n.logService.error(`${M} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.n.logService.info(`${M} resolving connection...`);const ie=await o(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${M} connecting to ${ie.host}:${ie.port}...`),await this.w(ie,y(p)),this.n.logService.info(`${M} reconnected!`),this.j.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${M} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(ie),this.t(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.n.logService.error(`${M} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(ie),this.t(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ie)){this.n.logService.info(`${M} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this.n.logService.info(`${M} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(ie);continue}if((0,A.isCancellationError)(ie)){this.n.logService.info(`${M} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(ie);continue}if(ie instanceof C.RemoteAuthorityResolverError){this.n.logService.error(`${M} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(ie),this.t(this.protocol.getMillisSinceLastIncomingData(),B+1,C.RemoteAuthorityResolverError.isHandled(ie));break}this.n.logService.error(`${M} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(ie),this.t(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.k)}t(M,W,B){this.p?V.triggerPermanentFailure(M,W,B):this.u(M,W,B)}u(M,W,B){this.j.fire(new z(this.reconnectionToken,M,W,B)),H(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=V,V._permanentFailure=!1,V.f=0,V.g=0,V.h=!1,V.i=[];class Q extends V{constructor(M,W,B,x,ie){super(1,M,x,ie,!0),this.client=this.B(new S.Client(ie,{remoteAuthority:W,clientId:B},M.ipcLogger))}async w(M,W){await r(M,W)}}e.ManagementPersistentConnection=Q;class Y extends V{constructor(M,W,B,x,ie){super(2,M,B,x,!1),this.y=W,this.debugPort=ie}async w(M,W){await t(M,this.y,W)}}e.ExtensionHostPersistentConnection=Y;function H(O){try{O.acceptDisconnect();const M=O.getSocket();O.dispose(),M.dispose()}catch(M){(0,A.onUnexpectedError)(M)}}function q(O){if(O&&O.type==="error"){const M=new Error(`Connection error: ${O.reason}`);return M.code="VSCODE_CONNECTION_ERROR",M}return null}function G(O,M){for(;O.length<M;)O+=" ";return O}function X(O,M){return`[remote-connection][${G(h(O),13)}][${M.substr(0,5)}\u2026]`}function ee(O,M,W){return`${X(O,M)}[${W?"reconnect":"initial"}]`}function re(O,M){return`${ee(M,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.host}:${O.port}]`}function te(O){return`${Date.now()-O} ms`}}),define(oe[220],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[221],ae([0,1,86,150]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,A,T,R,P,S){const C=p=>S(p,void 0),E=k.createConnection({host:D,port:A},()=>{E.removeListener("error",C);const p=Buffer.alloc(16);for(let f=0;f<16;f++)p[f]=Math.round(Math.random()*256);const g=p.toString("base64"),h=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${A}${T}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];E.write(h.join(`\r
`)+`\r
\r
`);const y=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",y),S(void 0,new n.NodeSocket(E,P)))};E.on("data",y)});E.setNoDelay(!0),E.once("error",C)}}}),define(oe[105],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService");var n;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=A=>({type:"connected",info:A}),D.connecting=A=>({type:"connecting",progress:A})})(n=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME="remoteTunnelService",e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(oe[222],ae([0,1,133,16,8]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,P){this.a=R,this.b=P}async request(R,P){this.b.trace("RequestService#request (browser) - begin",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const S=await(0,k.request)(R,P);return this.b.trace("RequestService#request (browser) - success",R.url),S}catch(S){throw this.b.error("RequestService#request (browser) - error",R.url,S),S}}async resolveProxy(R){}};A=pe([K(0,n.IConfigurationService),K(1,D.ILogService)],A),e.RequestService=A}),define(oe[60],ae([0,1,17,169,46,4,40]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function R(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=R;function P(y){return y.res.statusCode===204}async function S(y){return P(y)?null:(await(0,k.streamToBuffer)(y.stream)).toString()}e.asText=S;async function C(y){if(!R(y))throw new Error("Server returned "+y.res.statusCode);return S(y)}e.asTextOrError=C;async function E(y){if(!R(y))throw new Error("Server returned "+y.res.statusCode);if(P(y))return null;const l=(await(0,k.streamToBuffer)(y.stream)).toString();try{return JSON.parse(l)}catch(d){throw d.message+=`:
`+l,d}}e.asJson=E;function p(y){h(y)}e.updateProxyConfigurationsScope=p;let g;function h(y){const f=T.Registry.as(D.Extensions.Configuration),l=g;g={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[g],remove:l?[l]:[]})}h(2)}),define(oe[223],ae([0,1,23,24,13,60]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(P,S){this.a=P,this.b=S}async download(P,S,C=k.CancellationToken.None){if(P.scheme===n.Schemas.file||P.scheme===n.Schemas.vscodeRemote){await this.b.copy(P,S);return}const E={type:"GET",url:P.toString(!0)},p=await this.a.request(E,C);if(p.res.statusCode===200)await this.b.writeFile(S,p.stream);else{const g=await(0,A.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${g}`)}}};T=pe([K(0,A.IRequestService),K(1,D.IFileService)],T),e.DownloadService=T}),define(oe[224],ae([0,1,17,23]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(R){this.a=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,S,C=n.CancellationToken.None){switch(P){case"request":return this.a.request(S[0],C).then(async({res:E,stream:p})=>{const g=await(0,k.streamToBuffer)(p);return[{statusCode:E.statusCode,headers:E.headers},g]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class A{constructor(R){this.a=R}async request(R,P){const[S,C]=await this.a.call("request",[R],P);return{res:S,stream:(0,k.bufferToStream)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=A}),define(oe[225],ae([0,1,14,222,224]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class A{constructor(R,P,S,C){this.c=P,this.d=S,this.e=C,this.a=new n.RequestService(P,C),this.b=new D.RequestChannelClient(R.getChannel("request"))}request(R,P){return this.f().request(R,P)}async resolveProxy(R){return this.f().resolveProxy(R)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const R=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,k.isBoolean)(R)?R:this.d.quality!=="stable"}}e.SharedProcessRequestService=A}),define(oe[106],ae([0,1,66,4]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(A){return(0,k.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(oe[226],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[227],ae([0,1,93,6,23,3,2,24,31,8,106,226]),function(Z,e,k,n,D,A,T,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(y){this.d=y,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(y){const f=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${f})`);const l=(0,C.hash)(y);this.b.has(l)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${f})`),this.f(y));const d=new D.CancellationTokenSource;let m,v,I;this.b.set(l,s=>{d.dispose(!0),m?.terminate(y,D.CancellationToken.None),v?.close(),I?.close(),this.b.delete(l);const o=this.c.get(l);o&&(this.c.delete(l),o({reason:s}))}),m=await this.e(y);const i=new Promise(s=>{this.c.set(l,s)});if(d.token.isCancellationRequested)return i;const{port1:r,port2:t}=new MessageChannel;return v=r,I=t,await m.spawn(y,I,d.token),d.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${f})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[v])),i}e(y){let f=this.a.get(y.process.moduleId);if(!f){this.d.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const l=new g(y.process.type,this.d);f=l.init(),l.onDidProcessSelfTerminate(({configuration:d,reason:m})=>{this.f(d,m)}),this.a.set(y.process.moduleId,f)}return f}async disposeWorker(y){return this.f(y)}f(y,f){const l=this.b.get((0,C.hash)(y));l&&(this.d.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),l(f))}};p=pe([K(0,S.ILogService)],p),e.SharedProcessWorkerService=p;class g extends T.Disposable{constructor(y,f){super(),this.f=y,this.g=f,this.a=this.B(new A.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const y=new n.DeferredPromise,f=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return f.onerror=l=>{this.g.error(`SharedProcess: worker error (${this.f})`,l.message)},f.onmessageerror=l=>{this.g.error(`SharedProcess: worker message error (${this.f})`,l)},f.onmessage=l=>{const{id:d,message:m,configuration:v,nonce:I}=l.data;switch(d){case E.SharedProcessWorkerMessages.Ready:y.complete(f);break;case E.SharedProcessWorkerMessages.Ack:if(I){const i=this.c.get(I);i&&(this.c.delete(I),i())}break;case E.SharedProcessWorkerMessages.SelfTerminated:v&&m&&this.a.fire({configuration:v,reason:JSON.parse(m)});break;case E.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,m);break;case E.SharedProcessWorkerMessages.Info:m&&this.g.info(m);break;case E.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,m);break;case E.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,m);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,l)}},f.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async i(y,f,l){const d=await this.b;if(!f.isCancellationRequested)return new Promise(m=>{const v=(0,P.generateUuid)();this.c.set(v,m);const I={...y,nonce:v};l?d.postMessage(I,[l]):d.postMessage(I),f.onCancellationRequested(()=>{this.c.delete(v)&&m()})})}spawn(y,f,l){const d={id:E.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(d,l,f)}terminate(y,f){const l={id:E.SharedProcessWorkerMessages.Terminate,configuration:y};return this.i(l,f)}}}),define(oe[228],ae([0,1,63,24,186]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}pe([k.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(oe[229],ae([0,1,50,12,170,23,38,9,5,31,147,184,6,128]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let h;async function y(l,d,m,v){return m["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(v)&&!m["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(v)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=p.Promises.withAsyncBody(async(I,i)=>{const r=new A.CancellationTokenSource;let t=1e4;const s=l.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(t=(0,g.clamp)(s,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),i(new Error((0,D.localize)(0,null)))},t);try{I(await f(d,r.token))}catch(c){!(0,R.isCancellationError)(c)&&!r.token.isCancellationRequested?i(new Error((0,D.localize)(1,null,(0,T.toErrorMessage)(c)))):I({})}finally{clearTimeout(o),r.dispose()}})),h)}e.getResolvedShellEnv=y;async function f(l,d){const m=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",m);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",v);const I=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(I+"({.*})"+I),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const t=await(0,C.getSystemShell)(P.OS,r);return l.trace("getUnixShellEnvironment#shell",t),new Promise((s,o)=>{if(d.isCancellationRequested)return o(new R.CancellationError);const c=(0,n.basename)(t);let a,u;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${w} -p '''${I}'' + JSON.stringify(process.env) + ''${I}'''`,u=["-Login","-Command"]):(a=`'${process.execPath}' ${w} -p '"${I}" + JSON.stringify(process.env) + "${I}"'`,c==="tcsh"||c==="csh"?u=["-ic"]:u=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),a);const b=(0,k.spawn)(t,[...u,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});d.onCancellationRequested(()=>(b.kill(),o(new R.CancellationError))),b.on("error",$=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)($)),o($)});const U=[];b.stdout.on("data",$=>U.push($));const N=[];b.stderr.on("data",$=>N.push($)),b.on("close",($,F)=>{const L=Buffer.concat(U).toString("utf8");l.trace("getUnixShellEnvironment#raw",L);const j=Buffer.concat(N).toString("utf8");if(j.trim()&&l.trace("getUnixShellEnvironment#stderr",j),$||F)return o(new Error((0,D.localize)(2,null,$,F)));const z=i.exec(L),V=z?z[1]:"{}";try{const Q=JSON.parse(V);m?Q.ELECTRON_RUN_AS_NODE=m:delete Q.ELECTRON_RUN_AS_NODE,v?Q.ELECTRON_NO_ATTACH_CONSOLE=v:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.VSCODE_RESOLVING_ENVIRONMENT,delete Q.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",Q),s(Q)}catch(Q){l.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(Q)),o(Q)}})})}}),define(oe[107],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[230],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.b=new Map}c(){return new Promise((D,A)=>Z(["vsda"],D,A))}async createNewMessage(D){try{const A=await this.c(),T=new A.validator;if(T){const R=String(k.a++);return this.b.set(R,T),{id:R,data:T.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,A){if(!D.id)return!0;const T=this.b.get(D.id);if(!T)return!1;this.b.delete(D.id);try{return T.validate(A)==="ok"}catch{return!1}}async sign(D){try{const A=await this.c(),T=new A.signer;if(T)return T.sign(D)}catch{}return D}}e.SignService=k,k.a=1}),define(oe[76],ae([0,1,3,2]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends n.Disposable{constructor(E,p,g){super(),this.a=E,this.b=p,this.c=g}async getItems(){const E={profile:this.b,workspace:this.c},p=await this.a.call("getItems",E);return new Map(p)}updateItems(E){const p={profile:this.b,workspace:this.c};return E.insert&&(p.insert=Array.from(E.insert.entries())),E.delete&&(p.delete=Array.from(E.delete.values())),this.a.call("updateItems",p)}}class A extends D{constructor(E,p){super(E,p,void 0),this.f=this.B(new k.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class T extends A{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class R extends A{constructor(E,p){super(E,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class P extends D{constructor(E,p){super(E,void 0,p),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class S{constructor(E){this.a=E}isUsed(E){const p={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",p)}}e.StorageClient=S}),define(oe[108],ae([0,1,5,36,7,31]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(S){if(k.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function R(S,C,E,p,g,h,y,f,l,d){const m=Object.create(null);m["common.machineId"]=y,m.sessionID=(0,A.generateUuid)()+Date.now(),m.commitHash=g,m.version=h,m["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,k.PlatformToString)(k.platform),m["common.nodePlatform"]=n.platform,m["common.nodeArch"]=p,m["common.product"]=d||"desktop",f&&(m["common.msftInternal"]=f);let v=0;const I=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),k.isLinuxSnap&&(m["common.snap"]="true");const i=T(E);i&&(m["common.platformDetail"]=i);try{const r=await S.readFile(D.URI.file(l));m["common.source"]=r.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=R;function P(S){const C=n.env.USERDNSDOMAIN;if(!C)return!1;const E=C.toLowerCase();return S.some(p=>E===p)}e.verifyMicrosoftInternalDomain=P}),define(oe[19],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[231],ae([0,1,34,6,35,24,12,5,7,144,28,146,95,13,25,19]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const f=new Map;async function l(i,r){const t=`${i}::${r.join(":")}`,s=f.get(t);if(s)return s;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,a=new Map,u=2e4;function w(U,N,$,F){const L=N.substring(U.length+1);return n.Promises.withAsyncBody(async j=>{let z;try{z=await C.Promises.readdir(N,{withFileTypes:!0})}catch{j();return}if(F.count>=u){F.count+=z.length,F.maxReached=!0,j();return}let V=z.length;if(V===0){j();return}let Q=z;F.count+z.length>u&&(F.maxReached=!0,V=u-F.count,Q=z.slice(0,V)),F.count+=z.length;for(const Y of Q)if(Y.isDirectory()){if($.includes(Y.name)||await w(U,(0,T.join)(N,Y.name),$,F),--V===0){j();return}}else{const H=Y.name.lastIndexOf(".");if(H>=0){const q=Y.name.substring(H+1);q&&c.set(q,(c.get(q)??0)+1)}for(const q of o)q.relativePathPattern?.test(L)!==!1&&q.filePattern.test(Y.name)&&a.set(q.tag,(a.get(q.tag)??0)+1);if(--V===0){j();return}}})}const b=n.Promises.withAsyncBody(async U=>{const N={count:0,maxReached:!1};await w(i,i,r,N);const $=await v(i);U({configFiles:d(a),fileTypes:d(c),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:$})});return f.set(t,b),b}e.collectWorkspaceStats=l;function d(i){return Array.from(i.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function m(){const i={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},r=k.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=m;async function v(i){try{const r=new Map,t=(0,T.join)(i,".vscode","launch.json"),s=await C.Promises.readFile(t),o=[],c=(0,D.parse)(s.toString(),o);if(o.length)return console.log(`Unable to parse ${t}`),[];if((0,D.getNodeType)(c)==="object"&&c.configurations)for(const a of c.configurations){const u=a.type;u&&(r.has(u)?r.set(u,r.get(u)+1):r.set(u,1))}return d(r)}catch{return[]}}e.collectLaunchConfigs=v;let I=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const s=k.cpus();return s&&s.length>0&&t.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||t.push(`Load (avg):       ${k.loadavg().map(o=>Math.round(o)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,E.listProcesses)(r.mainPID),this.k(r)]).then(async s=>{let[o,c]=s,a=this.m(r,o);return t.forEach(u=>{if((0,p.isRemoteDiagnosticError)(u))a+=`
${u.errorMessage}`,c+=`
${u.errorMessage}`;else if(a+=`

Remote: ${u.hostName}`,u.processes&&(a+=`
${this.m(r,u.processes)}`),u.workspaceMetadata){c+=`
|  Remote: ${u.hostName}`;for(const w of Object.keys(u.workspaceMetadata)){const b=u.workspaceMetadata[w];let U=`${b.fileCount} files`;b.maxFilesReached&&(U=`more than ${U}`),c+=`|    Folder (${w}): ${U}`,c+=this.h(b)}}}),{processInfo:a,workspaceInfo:c}})}async getSystemInfo(r,t){const{memory:s,vmHint:o,os:c,cpus:a}=m(),u={os:c,memory:s,cpus:a,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return R.isWindows||(u.load=`${k.loadavg().map(w=>Math.round(w)).join(", ")}`),R.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(r,t){const s=[];return(0,E.listProcesses)(r.mainPID).then(async o=>(s.push(""),s.push(this.g(r)),s.push(""),s.push(this.m(r,o)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(r))),t.forEach(c=>{if((0,p.isRemoteDiagnosticError)(c))s.push(`
${c.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${c.hostName}`),s.push(this.f(c.machineInfo)),c.processes&&s.push(this.m(r,c.processes)),c.workspaceMetadata)for(const a of Object.keys(c.workspaceMetadata)){const u=c.workspaceMetadata[a];let w=`${u.fileCount} files`;u.maxFilesReached&&(w=`more than ${w}`),s.push(`Folder (${a}): ${w}`),s.push(this.h(u))}}),s.push(""),s.push(""),s.join(`
`)))}h(r){const t=[];let o=0;const c=(b,U)=>{const N=` ${b}(${U})`;o+N.length>60?(t.push(a),a="|                 ",o=a.length):o+=N.length,a+=N};let a="|      File types:";const u=10,w=r.fileTypes.length>u?u:r.fileTypes.length;for(let b=0;b<w;b++){const U=r.fileTypes[b];c(U.name,U.count)}if(t.push(a),r.configFiles.length>=0&&(a="|      Conf files:",o=0,r.configFiles.forEach(b=>{c(b.name,b.count)}),t.push(a)),r.launchConfigFiles.length>0){let b="|      Launch Configs:";r.launchConfigFiles.forEach(U=>{b+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),t.push(b)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(t-s.length)}  ${r[s]}`).join(`
                  `)}k(r){const t=[],s=[];return r.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(t.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const a=P.URI.revive(c);if(a.scheme===A.Schemas.file){const u=a.fsPath;s.push(l(u,["node_modules",".git"]).then(w=>{let b=`${w.fileCount} files`;w.maxFilesReached&&(b=`more than ${b}`),t.push(`|    Folder (${(0,T.basename)(u)}): ${b}`),t.push(this.h(w))}).catch(w=>{t.push(`|      Error: Unable to collect workspace stats for folder ${u} (${w.toString()})`)}))}else t.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>t.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,t){const s=new Map;r.windows.forEach(c=>s.set(c.pid,c.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,s,o,t,0),o.join(`
`)}n(r,t,s,o,c){const a=c===0;let u;a?u=o.pid===r?`${this.d.applicationName} main`:"remote agent":(u=`${"  ".repeat(c)} ${o.name}`,o.name==="window"&&(u=`${u} (${t.get(o.pid)})`));const w=process.platform==="win32"?o.mem:k.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(w/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(o.children)&&o.children.forEach(b=>this.n(r,t,s,b,c+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:s}of r.folders){const o=P.URI.revive(s);if(o.scheme!==A.Schemas.file)continue;const c=o.fsPath;try{(await l(c,["node_modules",".git"])).fileTypes.forEach(u=>t.add(u.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const s=P.URI.revive(t);if(s.scheme!==A.Schemas.file)continue;const o=s.fsPath;try{const c=await l(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};I=pe([K(0,y.ITelemetryService),K(1,h.IProductService)],I),e.DiagnosticsService=I}),define(oe[232],ae([0,1,105,3,19,15,2,8,12,50,25,5,6,101,16,168,34,7]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let d=class extends T.Disposable{constructor(v,I,i,r,t,s){super(),this.p=v,this.r=I,this.s=i,this.t=s,this.b=new n.Emitter,this.onDidTokenFailed=this.b.event,this.c=new n.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new n.Emitter,this.onDidChangeAccount=this.f.event,this.j=k.TunnelStates.disconnected;const o=l.URI.file((0,P.join)(i.logsPath,k.LOG_FILE_NAME));this.g=this.B(r.createLogger(o,{name:k.LOGGER_NAME})),this.k=new p.Delayer(100),this.B(this.g.onDidChangeLogLevel(c=>this.g.info("Log level changed to "+(0,R.LogLevelToString)(c)))),this.B(t.onWillShutdown(c=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(s.onDidChangeConfiguration(c=>{c.affectsConfiguration(k.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(v){if(v&&this.h?v.token!==this.h.token||v.providerId!==this.h.providerId:v!==this.h){this.h=v,this.f.fire(v),v?this.g.info(`Account updated: ${v.accountLabel} (${v.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!v});try{await this.k.trigger(()=>this.v())}catch(I){this.g.error(I)}}return this.j}u(){if(!this.n){let v;E.isMacintosh?v=this.s.appRoot:v=(0,P.dirname)((0,P.dirname)(this.s.appRoot)),this.n=(0,P.join)(v,"bin",`${this.r.tunnelApplicationName}${E.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(k.TunnelStates.disconnected);return}const{token:v,providerId:I,accountLabel:i}=this.h;this.w(k.TunnelStates.connecting((0,y.localize)(0,null,i,I)));const r=(a,u)=>{a=a.replaceAll(v,"*".repeat(4)),u?this.g.error(a):this.g.info(a),!this.s.isBuilt&&a.startsWith("   Compiling")&&this.w(k.TunnelStates.connecting((0,y.localize)(1,null)))},t=this.y("login",["user","login","--provider",I,"--access-token",v,"--log",(0,R.LogLevelToString)(this.g.getLevel())],r);this.i=t;try{if(await t,this.i!==t)return}catch(a){this.g.error(a),this.i=void 0,this.b.fire(!0),this.w(k.TunnelStates.disconnected);return}const s=this.z();s?this.w(k.TunnelStates.connecting((0,y.localize)(2,null,s))):this.w(k.TunnelStates.connecting((0,y.localize)(3,null)));const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.g.getLevel())];s?o.push("--name",s):o.push("--random-name");const c=this.y("tunnel",o,(a,u)=>{u?this.g.error(a):this.g.info(a);const w=a.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(w){const b={link:w[1],domain:w[2],hostName:w[4]};this.w(k.TunnelStates.connected(b))}else a.match(/error refreshing token/)&&(c.cancel(),this.b.fire(!0),this.w(k.TunnelStates.disconnected))});this.i=c,c.finally(()=>{c===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(k.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(v){this.j=v,this.c.fire(v)}y(v,I,i=()=>{}){return(0,p.createCancelablePromise)(r=>new Promise((t,s)=>{r.isCancellationRequested&&t();let o;if(r.onCancellationRequested(()=>{o&&(this.g.info(`${v} terminating(${o.pid})`),o.kill())}),!this.s.isBuilt)i("Building tunnel CLI from sources and run",!1),i(`${v} Spawning: cargo run -- tunnel ${I.join(" ")}`,!1),o=(0,S.spawn)("cargo",["run","--","tunnel",...I],{cwd:(0,P.join)(this.s.appRoot,"cli")});else{i("Running tunnel CLI",!1);const c=this.u();i(`${v} Spawning: ${c} tunnel ${I.join(" ")}`,!1),o=(0,S.spawn)(c,["tunnel",...I],{cwd:(0,f.homedir)()})}o.stdout.on("data",c=>{if(o){const a=c.toString();i(a,!1)}}),o.stderr.on("data",c=>{if(o){const a=c.toString();i(a,!0)}}),o.on("exit",c=>{o&&(i(`${v} exit(${o.pid}): + ${c} `,!1),o=void 0,c===0?t():s())}),o.on("error",c=>{o&&(i(`${v} error(${o.pid}): + ${c} `,!0),o=void 0,s())})}))}async getHostName(){return this.z()}z(){let v=this.t.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,f.hostname)();return v=v.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),v||void 0}};d=pe([K(0,D.ITelemetryService),K(1,C.IProductService),K(2,A.INativeEnvironmentService),K(3,R.ILoggerService),K(4,g.ISharedProcessLifecycleService),K(5,h.IConfigurationService)],d),e.RemoteTunnelService=d}),define(oe[109],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(A){this.b=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:R,data:P}){return this.b.forEach(S=>S.log(R,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class n{constructor(A){this.b=A}log(A,T){return this.b.call("log",{eventName:A,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(oe[47],ae([0,1,32,14,3,16,75,108,19]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(a){this.value=a}}e.TrustedTelemetryValue=S;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,u){return Promise.resolve(void 0)}publicLog2(a,u){return this.publicLog(a,u)}publicLogError(a,u){return Promise.resolve(void 0)}publicLogError2(a,u){return this.publicLogError(a,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class E{async publicLog(a,u,w){}async publicLogError(a,u,w){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(c,a){return D.Event.debounce(a.onDidChangeConfiguration,(w,b)=>{const U=w?new Set([...w.affectedKeys,...b.affectedKeys]):b.affectedKeys;return{...b,affectedKeys:U}},1e3,!0)(w=>{w.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(w.source),configurationKeys:v(w.affectedKeys)})})}e.configurationTelemetry=p;function g(c,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!c.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=g;function h(c,a){return!(a.isBuilt||a.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=h;function y(c){const a=c.getValue(P.TELEMETRY_SETTING_ID),u=c.getValue(P.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function f(c){const a={},u={},w={};m(c,w);for(let b in w){b=b.length>150?b.substr(b.length-149):b;const U=w[b];typeof U=="number"?u[b]=U:typeof U=="boolean"?u[b]=U?1:0:typeof U=="string"?(U.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${U.length}`),a[b]=U.substring(0,8191)):typeof U<"u"&&U!==null&&(a[b]=U)}return{properties:a,measurements:u}}e.validateTelemetryData=f;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(c){if(!c)return"none";const a=(0,T.getRemoteName)(c);return l.has(a)?a:"other"}e.cleanRemoteAuthority=d;function m(c,a,u=0,w){if(!!c)for(const b of Object.getOwnPropertyNames(c)){const U=c[b],N=w?w+b:b;Array.isArray(U)?a[N]=(0,k.safeStringify)(U):U instanceof Date?a[N]=U.toISOString():(0,n.isObject)(U)?u<2?m(U,a,u+1,N+"."):a[N]=(0,k.safeStringify)(U):a[N]=U}}function v(c){if(!c)return[];const a=[];return I(a,"",c),a}function I(c,a,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(w=>I(c,a?`${a}.${w}`:w,u[w])):c.push(a)}function i(c,a){const u=c.msftInternalDomains||[],w=a.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(u)||w}e.isInternalTelemetry=i;function r(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=r;function t(c,a){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let u=c;const w=[];for(const $ of a)for(;;){const F=$.exec(c);if(!F)break;w.push([F.index,$.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,U=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(u="";;){const $=U.exec(c);if(!$)break;const F=w.some(([L,j])=>$.index<j&&L<U.lastIndex);!b.test($[0])&&!F&&(u+=c.substring(N,$.index)+"<REDACTED: user-file-path>",N=U.lastIndex)}return N<c.length&&(u+=c.substr(N)),u}function s(c){if(!c)return c;const a=c.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const w of u)if(w.regex.test(a))return`<REDACTED: ${w.label}>`;return c}function o(c,a){return(0,k.cloneAndChange)(c,u=>{if(u instanceof S)return u.value;if(typeof u=="string"){let w=u.replaceAll("%20"," ");w=t(w,a);for(const b of a)w=w.replace(b,"");return w=s(w),w}})}e.cleanData=o}),define(oe[33],ae([0,1,27,30,42,5,7,9,36,47]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(t,s){return t.uuid&&s.uuid?t.uuid===s.uuid:t.id===s.id?!0:(0,k.compareIgnoreCase)(t.id,s.id)===0}e.areSameExtensions=C;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(s){const o=s.manifest?s.manifest.version:s.version,c=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new p(s.identifier,o,c)}static parse(s){const o=E.exec(s);return o&&o[1]&&o[2]?new p({id:o[1]},o[2],o[4]||void 0):null}constructor(s,o,c="undefined"){this.version=o,this.targetPlatform=c,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof p?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=p;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(t){const s=g.exec(t);return s&&s[1]?[f(s[1]),s[2]]:[f(t),void 0]}e.getIdAndVersion=h;function y(t,s){return`${t}.${s}`}e.getExtensionId=y;function f(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=f;function l(t,s){return f(y(t,s))}e.getGalleryExtensionId=l;function d(t,s){const o=[],c=a=>{for(const u of o)if(u.some(w=>C(s(w),s(a))))return u;return null};for(const a of t){const u=c(a);u?u.push(a):o.push([a])}return o}e.groupByExtension=d;function m(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function v(t){return{id:new S.TrustedTelemetryValue(t.identifier.id),name:new S.TrustedTelemetryValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function I(t,s){const o=[],c=s.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const a=c.shift();if(a&&o.every(u=>!C(u.identifier,{id:a}))){const u=t.filter(w=>C(w.identifier,{id:a}));u.length===1&&(o.push(u[0]),c.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=I;async function i(t,s){if(!A.isLinux)return!1;let o;try{o=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function r(t,s){const o=await i(t,s),c=(0,n.getTargetPlatform)(o?"alpine":A.platform,P.arch);return s.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=r}),define(oe[233],ae([0,1,23,33]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(A,T,R,P,S){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const E=await A.getInstalled(1);for(const[p,g]of Object.entries(C.deprecated)){if(!g?.extension)continue;const{id:h,autoMigrate:y,preRelease:f}=g.extension;if(!y)continue;const l=E.find(m=>(0,n.areSameExtensions)(m.identifier,{id:p}));if(!l)continue;const d=(await T.getExtensions([{id:h,preRelease:f}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!d){S.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{S.info(`Migrating '${l.identifier.id}' extension to '${h}' extension...`);const m=!P.getDisabledExtensions().some(I=>(0,n.areSameExtensions)(I,l.identifier));await A.uninstall(l),S.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let v=E.find(I=>(0,n.areSameExtensions)(I.identifier,{id:h}));(!v||!v.isPreReleaseVersion&&m)&&(v=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${v.identifier.id}'`),m||(await P.disableExtension(v.identifier),S.info(`Disabled the pre-release extension '${v.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,n.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,n.getExtensionId)(v.manifest.publisher,v.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${l.identifier.id}' extension to '${h}' extension.`)}catch(m){S.error(m)}}}catch(C){S.error(C)}}e.migrateUnsupportedExtensions=D}),define(oe[234],ae([0,1,6,9,2,24,5,22,54,14,31,28,16,15,30,33,97,13,8,25]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class yt extends D.Disposable{constructor(i,r,t,s,o,c,a){super(),this.h=r,this.i=t,this.j=s,this.k=o,this.l=c,this.m=a,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(i,r){await this.g;const t=(0,R.joinPath)(this.extensionsDownloadDir,this.w(i));try{await this.t(i,t,o=>this.i.download(i,o,r))}catch(o){throw new h.ExtensionManagementError(o.message,h.ExtensionManagementErrorCode.Download)}let s="Unverified";if(await this.n(i)){const o=await this.r(i);try{await this.l.verify(t.fsPath,o.fsPath)&&(s="Verified"),this.m.info(`Extension signature verification: ${i.identifier.id}. Verification status: ${s}.`)}catch(c){const a=c.code;if(a==="UnknownError")s="UnknownError",this.m.warn(`Extension signature verification: ${i.identifier.id}. Verification status: ${s}.`);else throw await this.delete(o),await this.delete(t),new h.ExtensionManagementError(a,h.ExtensionManagementErrorCode.Signature)}}return{location:t,verificationStatus:s}}async n(i){if(!i.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,S.isBoolean)(r)?r:this.k.quality!=="stable"}async r(i){await this.g;const r=(0,R.joinPath)(this.extensionsDownloadDir,`${this.w(i)}${yt.c}`);return await this.t(i,r,t=>this.i.downloadSignatureArchive(i,t)),r}async t(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const s=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.h.exists(s)||await t(s);try{await this.u(s,r,Date.now()+2*60*1e3)}catch(o){try{await this.h.del(s)}catch{}if(o.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.m.info(`Rename failed because of ${(0,n.getErrorMessage)(o)}. Deleted the file from downloaded location`,s.path),o}}async delete(i){await this.g,await this.h.del(i)}async u(i,r,t){try{await E.Promises.rename(i.fsPath,r.fsPath)}catch(s){if(T.isWindows&&s&&s.code==="EPERM"&&Date.now()<t)return this.m.info(`Failed renaming ${i} to ${r} with 'EPERM' error. Trying again...`),this.u(i,r,t);throw s}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],s=[];for(const a of i.children)if(a.name.endsWith(yt.c))s.push(a.resource);else{const u=y.ExtensionKey.parse(a.name);u&&t.push([u,a])}const o=(0,y.groupByExtension)(t,([a])=>a),c=[];for(const a of o)a.sort((u,w)=>P.rcompare(u[0].version,w[0].version)),r.push(...a.slice(1).map(u=>u[1].resource)),c.push(a[0][1]);c.sort((a,u)=>a.mtime-u.mtime),r.push(...c.slice(0,Math.max(0,c.length-this.f)).map(a=>a.resource)),r.push(...s),await k.Promises.settled(r.map(a=>(this.m.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.m.error(i)}}w(i){return this.f?y.ExtensionKey.create(i).toString().toLowerCase():(0,C.generateUuid)()}};v.c=".sigzip",v=pe([K(0,g.INativeEnvironmentService),K(1,l.IFileService),K(2,h.IExtensionGalleryService),K(3,p.IConfigurationService),K(4,m.IProductService),K(5,f.IExtensionSignatureVerificationService),K(6,d.ILogService)],v),e.ExtensionsDownloader=v}),define(oe[235],ae([0,1,3,2,37,33,42]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends n.Disposable{constructor(S,C,E,p,g,h,y){super(),this.f=S,this.g=C,this.h=E,this.i=p,this.j=g,this.k=h,this.l=y,this.a=this.B(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new n.DisposableMap),this.m().then(null,f=>y.error(f))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,C){try{await Promise.all(C.map(E=>(this.c.deleteAndDispose(E.id),this.z(E.extensionsResource)))),S.length&&await Promise.all(S.map(E=>(this.c.set(E.id,(0,n.combinedDisposable)(this.k.watch(this.j.extUri.dirname(E.extensionsResource)),this.k.watch(E.extensionsResource))),this.y(E.extensionsResource))))}catch(E){throw this.l.error(E),E}}async r(S){for(const C of S.extensions)this.D(this.G(C.identifier,C.version),S.profileLocation)}async s(S){for(const C of S.extensions){const E=this.G(C.identifier,C.version);S.error?this.F(E,S.profileLocation):this.D(E,S.profileLocation)}}async t(S){for(const C of S.extensions)this.F(this.G(C.identifier,C.version),S.profileLocation)}async u(S){let C=!1;for(const E of S.extensions){const p=this.G(E.identifier,E.version);S.error?this.D(p,S.profileLocation):(this.F(p,S.profileLocation),C=C||!this.b.has(p))}C&&await this.C()}v(S){for(const C of this.h.profiles)S.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(S){const C=[],E=[],p=await this.i.scanProfileExtensions(S),g=new Set,h=new Set;for(const[y,f]of this.b)f.has(S)&&h.add(y);for(const y of p){const f=this.G(y.identifier,y.version);g.add(f),h.has(f)||(C.push(y.identifier),this.D(f,S))}for(const y of h)if(!g.has(y)){const f=this.H(y);f&&(E.push(f.identifier),this.F(y,S))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:S}:void 0,removed:E.length?{extensions:E,profileLocation:S}:void 0})}async y(S){const C=await this.i.scanProfileExtensions(S);for(const E of C)this.D(this.G(E.identifier,E.version),S)}async z(S){for(const C of[...this.b.keys()])this.F(C,S);await this.C()}async C(){const C=(await this.f.getAllUserInstalled()).filter(E=>E.installedTimestamp&&!this.b.has(this.G(E.identifier,E.manifest.version)));C.length&&await this.f.markAsUninstalled(...C)}D(S,C){let E=this.b.get(S);E||this.b.set(S,E=new D.ResourceSet(p=>this.j.extUri.getComparisonKey(p))),E.add(C)}F(S,C){const E=this.b.get(S);E&&E.delete(C),E?.size||this.b.delete(S)}G(S,C){return`${T.ExtensionIdentifier.toKey(S.id)}@${C}`}H(S){const[C,E]=(0,A.getIdAndVersion)(S);return E?{identifier:{id:C},version:E}:void 0}}e.ExtensionsWatcher=R}),define(oe[236],ae([0,1,45,47]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(A,T,R,P,S,C,E){const p={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${T.nameShort})`};if((0,n.supportsTelemetry)(T,R)&&(0,n.getTelemetryLevel)(P)===3){const g=await(0,k.getServiceMachineId)(R,S,C),{machineId:h}=await E.getTelemetryInfo();p["X-Market-User-Id"]=g,p["VSCode-SessionId"]=h||g}return p}e.resolveMarketplaceHeaders=D}),define(oe[237],ae([0,1,99,21,6,2,24,12,28,15,30,33,8,73,5,7]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let f=class extends g.LanguagePackBaseService{constructor(v,I,i,r){super(i),this.h=v,this.i=r,this.g=this.B(new l(I,r)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(v){const i=(await this.g.getLanguagePacks())[h.Language.value()];if(!i){this.i.warn(`No language pack found for ${h.Language.value()}`);return}const r=i.translations[v];return r?y.URI.file(r):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),I=Object.keys(v).map(i=>{const r=v[i];return{...this.f(i,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return I.push({...this.f("en","English"),extensionId:"default"}),I.sort((i,r)=>i.label.localeCompare(r.label)),I}async j(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",v.identifier.id),await this.update())}async k(v){const I=await this.g.getLanguagePacks();Object.keys(I).some(i=>I[i]&&I[i].extensions.some(r=>(0,E.areSameExtensions)(r.extensionIdentifier,v.identifier)))&&(this.i.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,I]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(I);return!(0,n.equals)(Object.keys(v),Object.keys(i))}};f=pe([K(0,C.IExtensionManagementService),K(1,S.INativeEnvironmentService),K(2,C.IExtensionGalleryService),K(3,p.ILogService)],f),e.NativeLanguagePackService=f;let l=class extends A.Disposable{constructor(v,I){super(),this.i=I,this.c={},this.f=(0,R.join)(v.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.m(I=>{Object.keys(I).forEach(i=>delete I[i]),this.j(I,...v)}).then(()=>this.c)}j(v,...I){for(const i of I)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(v,i);Object.keys(v).forEach(i=>this.l(v[i]))}k(v,I){const i=I.identifier,r=I.manifest.contributes&&I.manifest.contributes.localizations?I.manifest.contributes.localizations:[];for(const t of r)if(I.location.scheme===T.Schemas.file&&d(t)){let s=v[t.languageId];s||(s={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},v[t.languageId]=s);const o=s.extensions.filter(c=>(0,E.areSameExtensions)(c.extensionIdentifier,i))[0];o?o.version=I.manifest.version:s.extensions.push({extensionIdentifier:i,version:I.manifest.version});for(const c of t.translations)s.translations[c.id]=(0,R.join)(I.location.fsPath,c.path)}}l(v){if(v){const I=(0,k.createHash)("md5");for(const i of v.extensions)I.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);v.hash=I.digest("hex")}}m(v=()=>null){return this.g.queue(()=>{let I=null;return P.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(I=v(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.c=i,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),P.Promises.writeFile(this.f,r)}).then(()=>I,i=>this.i.error(i))})}};l=pe([K(0,S.INativeEnvironmentService),K(1,p.ILogService)],l);function d(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const v of m.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(oe[238],ae([0,1,9,32,47]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",T="https://mobile.events.data.microsoft.com/ping";async function R(S,C,E){const p=await new Promise((l,d)=>{Z(["@microsoft/1ds-core-js"],l,d)}),g=await new Promise((l,d)=>{Z(["@microsoft/1ds-post-js"],l,d)}),h=new p.AppInsightsCore,y=new g.PostChannel,f={instrumentationKey:S,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(E){f.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:E};f.extensionConfig[y.identifier]=l}return h.initialize(f,[]),h.addTelemetryInitializer(l=>{C&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),h}class P{constructor(C,E,p,g,h){this.e=C,this.f=E,this.g=p,this.h=h,this.c=A,this.d=T,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(C){if(!!this.a){if(typeof this.a!="string"){C(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(E=>{C(E)},E=>{(0,k.onUnexpectedError)(E),console.error(E)})}}log(C,E){if(!this.a)return;E=(0,n.mixin)(E,this.g),E=(0,D.validateTelemetryData)(E);const p=this.f+"/"+C;try{this.i(g=>{g.pluginVersionString=E?.properties.version??"Unknown",g.track({name:p,baseData:{name:p,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(C=>{this.i(E=>{E.unload(!0,()=>{this.a=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(oe[110],ae([0,1,2,15,8,47]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends k.Disposable{constructor(P,S,C=""){super(),this.b=C;const E=P.getLogger(S.telemetryLogResource);E?this.a=this.B(E):(this.a=this.B(P.createLogger(S.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,S){this.a.trace(`${this.b}telemetry/${P}`,(0,A.validateTelemetryData)(S))}};T=pe([K(0,D.ILoggerService),K(1,n.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(oe[111],ae([0,1,2,32,5,27,171,16,46,103,25,40,19,47]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(l,d,m){this.k=d,this.l=m,this.d={},this.i=new k.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(p.TELEMETRY_SETTING_ID)||v.affectsConfiguration(p.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(p.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(l,d){this.d[l]=d}m(){let l=(0,g.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const m=d.usage?3:d.error?2:0;l=Math.min(l,m)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,d=l.sessionID,m=l["common.machineId"],v=l["common.firstSessionDate"],I=l["common.msftInternal"];return{sessionId:d,machineId:m,firstSessionDate:v,msftInternal:I}}dispose(){this.i.dispose()}n(l,d,m){return this.g<d?Promise.resolve(void 0):this.c.then(v=>{m=(0,n.mixin)(m,this.d),m=(0,g.cleanData)(m,this.j),m=(0,n.mixin)(m,v),this.b.forEach(I=>I.log(l,m))},v=>{console.error(v)})}publicLog(l,d){return this.n(l,3,d)}publicLog2(l,d){return this.publicLog(l,d)}publicLogError(l,d){return this.h?this.n(l,2,d):Promise.resolve(void 0)}publicLogError2(l,d){return this.publicLogError(l,d)}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=pe([K(1,R.IConfigurationService),K(2,C.IProductService)],h),e.TelemetryService=h;function y(){const f=(0,T.localize)(0,null,S.default.nameLong),l=S.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=D.isWeb?"":(0,T.localize)(3,null),m=(0,T.localize)(4,null),v=(0,T.localize)(5,null),I=(0,T.localize)(6,null),i=(0,T.localize)(7,null),r=`
|       | ${m} | ${v} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${f} ${l} ${d}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,T.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,T.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[239],ae([0,1,289,238]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends n.AbstractOneDataSystemAppender{constructor(T,R,P,S){const C={sendPOST:(E,p)=>{const g={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const h=k.request(E.urlString,g,y=>{y.on("data",function(f){p(y.statusCode??200,y.headers,f.toString())}),y.on("error",function(f){p(0,{})})});h.write(E.data),h.end()}catch{p(0,{})}}};super(T,R,P,S,C)}}e.OneDataSystemAppender=D}),define(oe[240],ae([0,1,24,68,16,15,8,25,19,109,110,111]),function(Z,e,k,n,D,A,T,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(h,y,f,l,d){this.b=h,this.c=y,this.d=f,this.e=l,this.f=d,this.a=new Map}async g(h){if(!this.a.has(h.id)){const{machineId:y,sessionId:f}=await this.c.getTelemetryInfo(),l=Object.create(null);l["common.vscodemachineid"]=y,l["common.vscodesessionid"]=f;const d=[h.id,JSON.stringify(l),h.aiKey],v=new n.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new S.TelemetryAppenderClient(v),new C.TelemetryLogAppender(this.d,this.e,`[${h.id}] `)];this.a.set(h.id,new E.TelemetryService({appenders:I,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.f))}return this.a.get(h.id)}async publicLog(h,y,f){await(await this.g(h)).publicLog(y,f)}async publicLogError(h,y,f){await(await this.g(h)).publicLogError(y,f)}};p=pe([K(0,D.IConfigurationService),K(1,P.ITelemetryService),K(2,T.ILoggerService),K(3,A.IEnvironmentService),K(4,R.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(oe[241],ae([0,1,6,23,3,2,8]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(S,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((C,E)=>{const p=++this.a;this.c.set(p,C),this.g.fire({requestId:p,...S});const g=new n.CancellationTokenSource;(0,k.timeout)(this.b,g.token).then(()=>E(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,A.toDisposable)(()=>g.cancel())])})}acceptReply(S,C){const E=this.c.get(S);E?(this.c.delete(S),(0,A.dispose)(this.f.get(S)||[]),this.f.delete(S),E(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};R=pe([K(1,T.ILogService)],R),e.RequestStore=R}),define(oe[112],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(m){m.Shell="terminal.integrated.shell.",m.ShellArgs="terminal.integrated.shellArgs.",m.DefaultProfile="terminal.integrated.defaultProfile.",m.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(m){m.ShellLinux="terminal.integrated.shell.linux",m.ShellMacOs="terminal.integrated.shell.osx",m.ShellWindows="terminal.integrated.shell.windows",m.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",m.AutomationShellLinux="terminal.integrated.automationShell.linux",m.AutomationShellMacOs="terminal.integrated.automationShell.osx",m.AutomationShellWindows="terminal.integrated.automationShell.windows",m.AutomationProfileLinux="terminal.integrated.automationProfile.linux",m.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",m.AutomationProfileWindows="terminal.integrated.automationProfile.windows",m.ShellArgsLinux="terminal.integrated.shellArgs.linux",m.ShellArgsMacOs="terminal.integrated.shellArgs.osx",m.ShellArgsWindows="terminal.integrated.shellArgs.windows",m.ProfilesWindows="terminal.integrated.profiles.windows",m.ProfilesMacOs="terminal.integrated.profiles.osx",m.ProfilesLinux="terminal.integrated.profiles.linux",m.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",m.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",m.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",m.UseWslProfiles="terminal.integrated.useWslProfiles",m.TabsDefaultColor="terminal.integrated.tabs.defaultColor",m.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",m.TabsEnabled="terminal.integrated.tabs.enabled",m.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",m.TabsHideCondition="terminal.integrated.tabs.hideCondition",m.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",m.TabsShowActions="terminal.integrated.tabs.showActions",m.TabsLocation="terminal.integrated.tabs.location",m.TabsFocusMode="terminal.integrated.tabs.focusMode",m.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",m.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",m.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",m.CopyOnSelection="terminal.integrated.copyOnSelection",m.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",m.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",m.FontFamily="terminal.integrated.fontFamily",m.FontSize="terminal.integrated.fontSize",m.LetterSpacing="terminal.integrated.letterSpacing",m.LineHeight="terminal.integrated.lineHeight",m.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",m.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",m.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",m.BellDuration="terminal.integrated.bellDuration",m.FontWeight="terminal.integrated.fontWeight",m.FontWeightBold="terminal.integrated.fontWeightBold",m.CursorBlinking="terminal.integrated.cursorBlinking",m.CursorStyle="terminal.integrated.cursorStyle",m.CursorWidth="terminal.integrated.cursorWidth",m.Scrollback="terminal.integrated.scrollback",m.DetectLocale="terminal.integrated.detectLocale",m.DefaultLocation="terminal.integrated.defaultLocation",m.GpuAcceleration="terminal.integrated.gpuAcceleration",m.TerminalTitleSeparator="terminal.integrated.tabs.separator",m.TerminalTitle="terminal.integrated.tabs.title",m.TerminalDescription="terminal.integrated.tabs.description",m.RightClickBehavior="terminal.integrated.rightClickBehavior",m.Cwd="terminal.integrated.cwd",m.ConfirmOnExit="terminal.integrated.confirmOnExit",m.ConfirmOnKill="terminal.integrated.confirmOnKill",m.EnableBell="terminal.integrated.enableBell",m.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",m.AllowChords="terminal.integrated.allowChords",m.AllowMnemonics="terminal.integrated.allowMnemonics",m.EnvMacOs="terminal.integrated.env.osx",m.EnvLinux="terminal.integrated.env.linux",m.EnvWindows="terminal.integrated.env.windows",m.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",m.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",m.ShowExitAlert="terminal.integrated.showExitAlert",m.SplitCwd="terminal.integrated.splitCwd",m.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",m.WordSeparators="terminal.integrated.wordSeparators",m.EnableFileLinks="terminal.integrated.enableFileLinks",m.UnicodeVersion="terminal.integrated.unicodeVersion",m.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",m.LocalEchoEnabled="terminal.integrated.localEchoEnabled",m.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",m.LocalEchoStyle="terminal.integrated.localEchoStyle",m.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",m.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",m.CustomGlyphs="terminal.integrated.customGlyphs",m.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",m.InheritEnv="terminal.integrated.inheritEnv",m.ShowLinkHover="terminal.integrated.showLinkHover",m.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",m.AutoReplies="terminal.integrated.autoReplies",m.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",m.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",m.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",m.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",m.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(m){m.FileName="ptyhost"})(A=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(m){m.PowerShell="pwsh",m.Bash="bash",m.Fish="fish",m.Sh="sh",m.Csh="csh",m.Ksh="ksh",m.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var R;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(m){m[m.Api=0]="Api",m[m.Process=1]="Process",m[m.Sequence=2]="Sequence",m[m.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var C;(function(m){m.Cwd="cwd",m.InitialCwd="initialCwd",m.FixedDimensions="fixedDimensions",m.Title="title",m.ShellType="shellType",m.HasChildProcesses="hasChildProcesses",m.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",m.OverrideDimensions="overrideDimensions",m.FailedShellIntegrationActivation="failedShellIntegrationActivation",m.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(m){m[m.Panel=1]="Panel",m[m.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var g;(function(m){m.TerminalView="view",m.Editor="editor"})(g=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(m){m[m.GraceTime=6e4]="GraceTime",m[m.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(m){m.GitBash="Git Bash",m.Pwsh="PowerShell"})(f=e.ProfileSource||(e.ProfileSource={}));var l;(function(m){m[m.Off=0]="Off",m[m.FinalTerm=1]="FinalTerm",m[m.VSCode=2]="VSCode"})(l=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var d;(function(m){m[m.Unknown=0]="Unknown",m[m.Shutdown=1]="Shutdown",m[m.Process=2]="Process",m[m.User=3]="User",m[m.Extension=4]="Extension"})(d=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[242],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(oe[243],ae([0,1,34,24,32,12,5,36,27,14,28]),function(Z,e,k,n,D,A,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let i=0;return I&&I.length===4&&(i=parseInt(I[3])),i}e.getWindowsBuildNumber=E;async function p(I,i,r,t=R.env,s=C.Promises.exists){if(A.isAbsolute(I))return await s(I)?I:void 0;if(i===void 0&&(i=R.cwd()),A.dirname(I)!=="."){const u=A.join(i,I);return await s(u)?u:void 0}const c=(0,D.getCaseInsensitive)(t,"PATH");if(r===void 0&&(0,S.isString)(c)&&(r=c.split(A.delimiter)),r===void 0||r.length===0){const u=A.join(i,I);return await s(u)?u:void 0}for(const u of r){let w;if(A.isAbsolute(u)?w=A.join(u,I):w=A.join(i,u,I),await s(w))return w;if(T.isWindows){let b=w+".com";if(await s(b)||(b=w+".exe",await s(b)))return b}}const a=A.join(i,I);return await s(a)?a:void 0}e.findExecutable=p;function g(I,i,r,t,s){if(!i.shellIntegration.enabled||!I.executable||I.isFeatureTerminal||I.hideFromUser||I.ignoreShellIntegration||T.isWindows&&!i.windowsEnableConpty)return;const o=I.args,c=R.platform==="win32"?A.basename(I.executable).toLowerCase():A.basename(I.executable),a=A.dirname(n.FileAccess.asFileUri("").fsPath);let u;const w={VSCODE_INJECTION:"1"};if(T.isWindows){if(c==="pwsh.exe"||c==="powershell.exe")return!o||m(o)?u=y.get(h.WindowsPwsh):d(o)&&(u=y.get(h.WindowsPwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a,""),{newArgs:u,envMixin:w}):void 0;t.warn(`Shell integration cannot be enabled for executable "${I.executable}" and args`,I.args);return}switch(c){case"bash":return!o||o.length===0?u=y.get(h.Bash):v(o)&&(w.VSCODE_SHELL_LOGIN="1",u=y.get(h.Bash)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a),{newArgs:u,envMixin:w}):void 0;case"fish":{const b=r?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",U=A.join(a,"out/vs/workbench/contrib/xdg_data");return w.XDG_DATA_DIRS=`${b}:${U}`,{newArgs:void 0,envMixin:w}}case"pwsh":return!o||m(o)?u=y.get(h.Pwsh):d(o)&&(u=y.get(h.PwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a,""),{newArgs:u,envMixin:w}):void 0;case"zsh":{if(!o||o.length===0?u=y.get(h.Zsh):v(o)?u=y.get(h.ZshLogin):(o===y.get(h.Zsh)||o===y.get(h.ZshLogin))&&(u=o),!u)return;u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a);let b;try{b=k.userInfo().username}catch{b="unknown"}const U=A.join(k.tmpdir(),`${b}-${s.applicationName}-zsh`);w.ZDOTDIR=U;const N=r?.ZDOTDIR??k.homedir()??"~";w.USER_ZDOTDIR=N;const $=[];return $.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(U,".zshrc")}),$.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(U,".zprofile")}),$.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(U,".zshenv")}),$.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(U,".zlogin")}),{newArgs:u,envMixin:w,filesToCopy:$}}}t.warn(`Shell integration cannot be enabled for executable "${I.executable}" and args`,I.args)}e.getShellIntegrationInjection=g;var h;(function(I){I.WindowsPwsh="windows-pwsh",I.WindowsPwshLogin="windows-pwsh-login",I.Pwsh="pwsh",I.PwshLogin="pwsh-login",I.Zsh="zsh",I.ZshLogin="zsh-login",I.Bash="bash"})(h||(h={}));const y=new Map;y.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),y.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),y.set(h.Zsh,["-i"]),y.set(h.ZshLogin,["-il"]),y.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const f=["-login","-l"],l=["-nol","-nologo"];function d(I){return typeof I=="string"?f.includes(I.toLowerCase()):I.length===1&&f.includes(I[0].toLowerCase())||I.length===2&&(f.includes(I[0].toLowerCase())||f.includes(I[1].toLowerCase()))&&(l.includes(I[0].toLowerCase())||l.includes(I[1].toLowerCase()))}function m(I){return typeof I=="string"?l.includes(I.toLowerCase()):I.length===0||I?.length===1&&l.includes(I[0].toLowerCase())}function v(I){return I==="string"&&f.includes(I.toLowerCase())||typeof I!="string"&&I.length===1&&f.includes(I[0].toLowerCase())}}),define(oe[244],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var k;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function n(A){return A===k.HIGH_CONTRAST_DARK||A===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function D(A){return A===k.DARK||A===k.HIGH_CONTRAST_DARK}e.isDark=D}),define(oe[113],ae([0,1,52,3,2,4,40,244]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var P;(function(f){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"}f.isThemeColor=l})(P=e.ThemeColor||(e.ThemeColor={}));function S(f){return{id:f}}e.themeColorFromId=S;var C;(function(f){function l(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||P.isThemeColor(s.color))}f.isThemeIcon=l;const d=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function m(s){const o=d.exec(s);if(!o)return;const[,c]=o;return{id:c}}f.fromString=m;function v(s){return{id:s}}f.fromId=v;function I(s,o){let c=s.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),o&&(c=`${c}~${o}`),{id:c}}f.modify=I;function i(s){const o=s.id.lastIndexOf("~");if(o!==-1)return s.id.substring(o+1)}f.getModifier=i;function r(s,o){return s.id===o.id&&s.color?.id===o.color?.id}f.isEqual=r;function t(s,o){return{id:s.id,color:o?S(o):void 0}}f.asThemeIcon=t,f.asClassNameArray=k.CSSIcon.asClassNameArray,f.asClassName=k.CSSIcon.asClassName,f.asCSSSelector=k.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(f){switch(f){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.a=[],this.a=[],this.b=new n.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,D.toDisposable)(()=>{const d=this.a.indexOf(l);this.a.splice(d,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const g=new p;T.Registry.add(e.Extensions.ThemingContribution,g);function h(f){return g.onColorThemeChange(f)}e.registerThemingParticipant=h;class y extends D.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(d=>this.n(d)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,d){let m=this.h.getColor(l);return m&&d&&(m=d(m,this.h)),m?m.toString():null}}e.Themable=y}),define(oe[245],ae([0,1,52,7,173,113]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(p,g){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...p.map(y=>({name:y.profileName,description:R(y)}))),g&&h.push(...g.map(y=>({name:y.title,description:P(y)}))),{values:h.map(y=>y.name),markdownDescriptions:h.map(y=>y.description)}}e.createProfileSchemaEnums=T;function R(p){let g=`$(${A.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:k.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?g+=`
- args: "${p.args}"`:g+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(g+=`
- overrideName: ${p.overrideName}`),p.color&&(g+=`
- color: ${p.color}`),p.env&&(g+=`
- env: ${JSON.stringify(p.env)}`),g}function P(p){return`$(${A.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:k.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function S(p,g){if(!p&&!g)return!0;if(typeof p=="string"&&typeof g=="string")return p===g;if(Array.isArray(p)&&Array.isArray(g)){if(p.length!==g.length)return!1;for(let h=0;h<p.length;h++)if(p[h]!==g[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function C(p,g){if(!p&&!g)return!0;if(!p||!g)return!1;if(A.ThemeIcon.isThemeIcon(p)&&A.ThemeIcon.isThemeIcon(g))return p.id===g.id&&p.color===g.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof g=="object"&&"light"in g&&"dark"in g){const h=p,y=g;if((n.URI.isUri(h.light)||E(h.light))&&(n.URI.isUri(h.dark)||E(h.dark))&&(n.URI.isUri(y.light)||E(y.light))&&(n.URI.isUri(y.dark)||E(y.dark)))return h.light.path===y.light.path&&h.dark.path===y.dark.path}if(n.URI.isUri(p)&&n.URI.isUri(g)||E(p)||E(g)){const h=p,y=g;return h.path===y.path&&h.scheme===y.scheme}return!1}e.terminalIconsEqual=C;function E(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=E}),define(oe[246],ae([0,1,52,172,46,40,245]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(k.Codicon.getAll(),v=>v.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),v=>`$(${v.id})`)};const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),...e.terminalIconSchema},color:{description:(0,n.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},S={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},C=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){A.Registry.as(D.Extensions.Configuration).registerConfiguration(f),m()}e.registerTerminalPlatformConfiguration=l;let d;function m(v,I){const i=A.Registry.as(D.Extensions.Configuration);let r;v&&(r=(0,T.createProfileSchemaEnums)(v?.profiles,I));const t=d;d={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?r?.values:void 0,markdownEnumDescriptions:v?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?r?.values:void 0,markdownEnumDescriptions:v?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?r?.values:void 0,markdownEnumDescriptions:v?.os===1?r?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[d],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=m}),define(oe[247],ae([0,1,50,52,12,5,28,90,243,113]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,E=!0;function p(r,t,s,o,c=process.env,a,u,w,b){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},A.isWindows?g(s,a,c,u,o.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),b,w):v(a,u,s,r&&typeof r=="object"?{...r}:o.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),b,w,c)}e.detectAvailableProfiles=p;async function g(r,t,s,o,c,a,u,w,b){const U=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${U?"Sysnative":"System32"}`;let $=!1;(0,P.getWindowsBuildNumber)()>=16299&&($=!0),await f(w);const F=new Map;r&&(F.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0}),F.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),F.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:n.Codicon.terminalBash,isAutoDetected:!0})),I(a,F);const L=await h(F.entries(),u,t,s,o,b);if(r||c)try{const j=await d(`${N}\\${$?"wsl":"bash"}.exe`,u);for(const z of j)(!a||!(z.profileName in a))&&L.push(z)}catch{E&&(o?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return L}async function h(r,t,s,o=process.env,c,a){const u=[];for(const[w,b]of r){if(b===null)continue;let U,N,$;if("source"in b){const j=C?.get(b.source);if(!j)continue;U=j.paths,N=b.args||j.args,b.icon?$=y(b.icon):j.icon&&($=j.icon)}else U=Array.isArray(b.path)?b.path:[b.path],N=A.isWindows||Array.isArray(b.args)?b.args:void 0,$=y(b.icon);let F;if(a){const j=U.map(V=>typeof V=="string"?V:V.path),z=await a(j);F=new Array(U.length);for(let V=0;V<U.length;V++)typeof U[V]=="string"?F[V]=U[V]:F[V]={path:z[V],isUnsafe:!0}}else F=U.slice();const L=await i(w,t,F,s,o,N,b.env,b.overrideName,b.isAutoDetected,c);L?(L.isAutoDetected=b.isAutoDetected,L.icon=$,L.color=b.color,u.push(L)):c?.debug("Terminal profile not validated",w,U)}return c?.debug("Validated terminal profiles",u),u}function y(r){return typeof r=="string"?{id:r}:r}async function f(r){C&&!r||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),C.set("PowerShell",{profileName:"PowerShell",paths:r||await l(),icon:S.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function l(){const r=[];for await(const t of(0,R.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function d(r,t){const s=[],o=await new Promise((u,w)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(b,U)=>{if(b)return w("Problem occurred when getting wsl distros");u(U)})});if(!o)return[];const c=new RegExp(/[\r?\n]/),a=o.split(c).filter(u=>u.trim().length>0&&u!=="");for(const u of a){if(u===""||u.startsWith("docker-desktop"))continue;const w=`${u} (WSL)`,b={profileName:w,path:r,args:["-d",`${u}`],isDefault:w===t,icon:m(u),isAutoDetected:!1};s.push(b)}return s}function m(r){return r.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):r.includes("Debian")?S.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function v(r,t,s,o,c,a,u,w){const b=new Map;if(s){const U=(await r.readFile("/etc/shells")).toString(),N=a||U.split(`
`).filter(F=>F.trim().includes("#")&&F.trim().length>0),$=new Map;for(const F of N){let L=(0,D.basename)(F),j=$.get(L)||0;j++,j>1&&(L=`${L} (${j})`),$.set(L,j),b.set(L,{path:F,isAutoDetected:!0})}}return I(o,b),await h(b.entries(),c,r,w,t,u)}function I(r,t){if(!!r)for(const[s,o]of Object.entries(r))o===null||!("path"in o)&&!("source"in o)?t.delete(s):(o.icon=o.icon||t.get(s)?.icon,t.set(s,o))}async function i(r,t,s,o,c,a,u,w,b,U){if(s.length===0)return Promise.resolve(void 0);const N=s.shift();if(N==="")return i(r,t,s,o,c,a,u,w,b);const $=typeof N!="string"&&N.isUnsafe,F=typeof N=="string"?N:N.path,L={profileName:r,path:F,args:a,env:u,overrideName:w,isAutoDetected:b,isDefault:r===t,isUnsafePath:$};if((0,D.basename)(F)===F){const z=c.PATH?c.PATH.split(D.delimiter):void 0,V=await(0,P.findExecutable)(F,void 0,z,void 0,o.existsFile);return V?(L.path=V,L.isFromPath=!0,L):i(r,t,s,o,c,a)}return await o.existsFile((0,D.normalize)(F))?L:i(r,t,s,o,c,a,u,w,b)}}),define(oe[248],ae([0,1,3,2,24,5,39,68,16,15,94,229,8,102,241,112,246,247]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let m=0,v=class extends n.Disposable{constructor(i,r,t,s){super(),this.C=i,this.D=r,this.F=t,this.G=s,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new k.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new k.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new k.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new k.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new k.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new k.Emitter),this.onProcessData=this.s.event,this.t=this.B(new k.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new k.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new k.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new k.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new k.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new k.Emitter),this.onProcessExit=this.z.event,(0,f.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,n.toDisposable)(()=>this.M())),this.f=this.B(new h.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(A.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this.D,this.G,{_:[]},process.env)}catch(i){return this.G.error("ptyHost was unable to resolve shell environment",i),{}}}L(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:m,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,C.parsePtyHostPort)(this.F.args,this.F.isBuilt);r&&(r.break&&r.port?i.debugBrk=r.port:!r.break&&r.port&&(i.debug=r.port));const t=new R.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this.m.fire(),T.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(t.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=d.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=t.getChannel(y.TerminalIpcChannels.Log);g.LogLevelChannelClient.setLevel(o,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{g.LogLevelChannelClient.setLevel(o,this.G.getLevel())}));const c=T.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(c.onProcessData(a=>this.s.fire(a))),this.B(c.onProcessReady(a=>this.t.fire(a))),this.B(c.onProcessExit(a=>this.z.fire(a))),this.B(c.onDidChangeProperty(a=>this.y.fire(a))),this.B(c.onProcessReplay(a=>this.u.fire(a))),this.B(c.onProcessOrphanQuestion(a=>this.v.fire(a))),this.B(c.onDidRequestDetach(a=>this.w.fire(a))),[t,c]}dispose(){this.i=!0,super.dispose()}async createProcess(i,r,t,s,o,c,a,u,w,b,U){const N=setTimeout(()=>this.Q(),y.HeartbeatConstants.CreateProcessTimeout),$=await this.b.createProcess(i,r,t,s,o,c,a,u,w,b,U);return clearTimeout(N),m=Math.max(m,$),$}updateTitle(i,r,t){return this.b.updateTitle(i,r,t)}updateIcon(i,r,t,s){return this.b.updateIcon(i,r,t,s)}attachToProcess(i){return this.b.attachToProcess(i)}detachFromProcess(i,r){return this.b.detachFromProcess(i,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(i){return this.b.start(i)}shutdown(i,r){return this.b.shutdown(i,r)}input(i,r){return this.b.input(i,r)}processBinary(i,r){return this.b.processBinary(i,r)}resize(i,r,t){return this.b.resize(i,r,t)}acknowledgeDataEvent(i,r){return this.b.acknowledgeDataEvent(i,r)}setUnicodeVersion(i,r){return this.b.setUnicodeVersion(i,r)}getInitialCwd(i){return this.b.getInitialCwd(i)}getCwd(i){return this.b.getCwd(i)}getLatency(i){return this.b.getLatency(i)}orphanQuestionReply(i){return this.b.orphanQuestionReply(i)}installAutoReply(i,r){return this.b.installAutoReply(i,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(i){return this.b.uninstallAutoReply(i)}getDefaultSystemShell(i){return this.b.getDefaultSystemShell(i)}async getProfiles(i,r,t,s=!1){const o=await this.c;return(0,l.detectAvailableProfiles)(r,t,s,this.D,o,void 0,this.G,this.S.bind(this,i))}getEnvironment(){return this.b.getEnvironment()}getWslPath(i,r){return this.b.getWslPath(i,r)}getRevivedPtyNewId(i){return this.b.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this.b.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this.b.getTerminalLayoutInfo(i)}async requestDetachInstance(i,r){return this.b.requestDetachInstance(i,r)}async acceptDetachInstanceReply(i,r){return this.b.acceptDetachInstanceReply(i,r)}async freePortKillProcess(i){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(i)}async serializeTerminalState(i){return this.b.serializeTerminalState(i)}async reviveTerminalProcesses(i,r){return this.b.reviveTerminalProcesses(i,r)}async refreshProperty(i,r){return this.b.refreshProperty(i,r)}async updateProperty(i,r,t){return this.b.updateProperty(i,r,t)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(i,r){return this.f.createRequest({workspaceId:i,originalText:r})}async acceptPtyHostResolvedVariables(i,r){this.f.acceptReply(i,r)}};v=pe([K(1,P.IConfigurationService),K(2,S.IEnvironmentService),K(3,p.ILogService)],v),e.PtyHostService=v}),define(oe[77],ae([0,1,3,16,4,8]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var T;(function(y){y.Http="http",y.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=E;function p(y,f,l,d){if(l===1)return!1;if(l===2&&E(f)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(m?.length===4&&parseInt(m[1])>=18)return!1}return y<1024}e.isPortPrivileged=p;class g{constructor(f,l,d){this.remoteAddress=f,this.localAddress=l,this.b=d,this.a=new k.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=g;let h=class{constructor(f,l){this.i=f,this.j=l,this.a=new k.Emitter,this.onTunnelOpened=this.a.event,this.b=new k.Emitter,this.onTunnelClosed=this.b.event,this.c=new k.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const f=this.j.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this.e=f,f?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this.f=f.elevation,this.g=f.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const f=[],l=Array.from(this.d.values());for(const d of l){const m=Array.from(d.values());for(const v of m){const I=await v.value;I&&f.push(I)}}return f}async dispose(){for(const f of this.d.values()){for(const{value:l}of f.values())await l.then(d=>d?.dispose());f.clear()}this.d.clear()}setEnvironmentTunnel(f,l,d,m,v){this.o(f,l,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:l,localAddress:d,privacy:m,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,l){(E(f)||C(f))&&(f=e.LOCALHOST_ADDRESSES[0]);const d=this.q(f,l);if(d)return++d.refcount,d.value}openTunnel(f,l,d,m,v=!1,I,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${d} on local port ${m}.`),!f)return;if(l||(l="localhost"),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(f,l,d,m,v,I,i);return r?r.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(t);return(t.tunnelRemoteHost!==l||t.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const l=this.d.get(f.tunnelRemoteHost);if(l){const d=l.get(f.tunnelRemotePort);d&&(d.refcount--,await this.n(f.tunnelRemoteHost,f.tunnelRemotePort,d))}}}}async n(f,l,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${l}.`);const m=d.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(f)&&this.d.get(f).delete(l),m}}async closeTunnel(f,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${l} `);const d=this.d.get(f);if(d&&d.has(l)){const m=d.get(l);m.refcount=0,await this.n(f,l,m)}}o(f,l,d){this.d.has(f)||this.d.set(f,new Map),this.d.get(f).set(l,{refcount:1,value:d})}async p(f,l){const d=this.d.get(f);d&&(await d.get(l)||d.delete(l),d.size===0&&this.d.delete(f))}q(f,l){const d=[f];C(f)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):E(f)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const m=d.map(v=>this.d.get(v));for(const v of m){const I=v?.get(l);if(I)return I}}canTunnel(f){return!!S(f)}s(f,l,d,m,v,I,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${d} on local port ${m}.`);const r=d;this.h.add(r);const t=m===void 0?d:m,s={elevationRequired:v?this.isPortPrivileged(t):!1},o={remoteAddress:{host:l,port:d},localAddressPort:m,privacy:I,public:I?I!==R.Private:void 0,protocol:i},c=f.forwardPort(o,s);return c?(this.o(l,d,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),c}};h=pe([K(0,A.ILogService),K(1,n.IConfigurationService)],h),e.AbstractTunnelService=h}),define(oe[249],ae([0,1,8,77,2,9,6]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends D.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.DeferredPromise),this.b.p)}setAddress(C){this.a=C,this.b&&(this.b.complete(C),this.b=null)}setTunnel(C){this.B(C)}}let P=class Dt extends D.Disposable{constructor(C,E){super(),this.f=C,this.g=E,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++Dt.a)}}async startTunnel(C,E,p,g,h,y){const f=new R,l=await Promise.resolve(this.f.openTunnel(C,f,p,g,h,y));if(!l)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${g} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(E))throw this.c.delete(E),f.dispose(),await l.dispose(),(0,A.canceled)();return f.setTunnel(l),this.b.set(E,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${l.localAddress} (local) to ${p}:${g} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(C,E){const p=this.b.get(C);!p||p.setAddress(E)}async destroyTunnel(C){const E=this.b.get(C);if(E){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this.b.delete(C),await E.dispose();return}this.c.add(C)}};P.a=0,P=pe([K(0,n.ISharedTunnelsService),K(1,k.ILogService)],P),e.SharedProcessTunnelService=P}),define(oe[250],ae([0,1,86,34,131,221,6,2,16,8,25,219,77,107,5]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(v,I,i,r,t){let s;for(let o=3;o&&(s?.dispose(),s=await new f(v,I,i,r,t).waitForReady(),!(t&&D.BROWSER_RESTRICTED_PORTS[t]||!D.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));o--);return s}class f extends R.Disposable{constructor(I,i,r,t,s){super(),this.j=i,this.k=s,this.privacy=p.TunnelPrivacyId.Private,this.i=new Map,this.a=I,this.b=k.createServer(),this.c=new T.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const I=this.k??this.tunnelRemotePort,i=(0,p.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,D.findFreePortFaster)(I,2,1e3,i),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(I){I.pause();const i=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,E.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),t=r.getSocket().socket,s=r.readEntireBuffer();r.dispose(),s.byteLength>0&&I.write(s.buffer),I.on("end",()=>{I.localAddress&&this.i.delete(I.localAddress),t.end()}),I.on("close",()=>t.end()),I.on("error",()=>{I.localAddress&&this.i.delete(I.localAddress),t.destroy()}),t.on("end",()=>I.end()),t.on("close",()=>I.end()),t.on("error",()=>{I.destroy()}),I.pipe(t),t.pipe(I),I.localAddress&&this.i.set(I.localAddress,()=>{I.end(),t.end()})}}let l=class extends p.AbstractTunnelService{constructor(I,i,r,t,s){super(i,s),this.t=I,this.u=r,this.v=t}isPortPrivileged(I){return(0,p.isPortPrivileged)(I,this.k,h.OS,n.release())}r(I,i,r,t,s,o,c){const a=this.q(i,r);if(a)return++a.refcount,a.value;if(this.e)return this.s(this.e,i,r,t,s,o,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${r} on local port ${t}.`);const u={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:I,signService:this.u,logService:this.i,ipcLogger:null},w=y(u,this.k,i,r,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,r,w),w}}};l=pe([K(1,S.ILogService),K(2,g.ISignService),K(3,C.IProductService),K(4,P.IConfigurationService)],l),e.BaseTunnelService=l;let d=class extends l{constructor(I,i,r,t){super(A.nodeSocketFactory,I,i,r,t)}};d=pe([K(0,S.ILogService),K(1,g.ISignService),K(2,C.IProductService),K(3,P.IConfigurationService)],d),e.TunnelService=d;let m=class extends R.Disposable{constructor(I,i,r,t){super(),this.b=I,this.c=i,this.f=r,this.g=t,this.a=new Map}async openTunnel(I,i,r,t,s,o,c,a){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this.a.has(I)){const u=new d(this.b,this.f,this.c,this.g);this.B(u),this.a.set(I,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this.a.delete(I))})}return this.a.get(I).openTunnel(i,r,t,s,o,c,a)}};m=pe([K(0,S.ILogService),K(1,C.IProductService),K(2,g.ISignService),K(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(oe[29],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(oe[251],ae([0,1,29,71,13,22,129,3,2]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(p){this.uri=p,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let C=class{constructor(p){this.g=p,this.c=new P.DisposableStore,this.f=2**16;const g=new Map,h=y=>{let f=g.get(y.scheme);return f===void 0&&(f=p.hasProvider(y)&&!this.g.hasCapability(y,1024),g.set(y.scheme,f)),f};this.c.add(R.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(y=>{g.delete(y.scheme)})),this.extUri=new A.ExtUri(h),this.d=new T.SkipList((y,f)=>this.extUri.compare(y,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,A.normalizePath)(p));const g=this.d.get(p);return g?g.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new S(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);S._clock=0,this.d.clear();const g=this.f*.5;for(let h=0;h<g;h++)this.d.set(p[h][0],p[h][1].touch())}};C=pe([K(0,D.IFileService)],C),e.UriIdentityService=C,(0,n.registerSingleton)(k.IUriIdentityService,C,1)}),define(oe[252],ae([0,1,3,2,13,44,49,17]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends n.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(C,E,p,g){super(),this.c=C,this.f=E,this.g=p,this.h=g,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(h=>this.i(h)))}watch(C,E){this.b.set(C,C);const p=this.f.watch(this.j(C),E);return(0,n.toDisposable)(()=>{this.b.delete(C),p.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,E,p){return this.f.rename(this.j(C),this.j(E),p)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,E,p){const g=(0,A.newWriteableStream)(h=>R.VSBuffer.concat(h.map(y=>R.VSBuffer.wrap(y))).buffer);return(async()=>{try{const h=await this.readFile(C);g.end(h)}catch(h){g.error(h),g.end()}})(),g}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,E,p){return this.f.writeFile(this.j(C),E,p)}delete(C,E){return this.f.delete(this.j(C),E)}copy(C,E,p){if((0,D.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(C),this.j(E),p);throw new Error("copy not supported")}i(C){const E=[];for(const p of C){if(p.resource.scheme!==this.c)continue;const g=this.k(p.resource);this.b.findSubstr(g)&&E.push({resource:g,type:p.type})}E.length&&(this.h.debug("User data changed"),this.a.fire(E))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.FileUserDataProvider=P}),define(oe[61],ae([0,1,83]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(T,R,P,S){const C=(0,k.setProperty)(T,R,P,S)[0];return C&&(T=T.substring(0,C.offset)+C.content+T.substring(C.offset+C.length)),T}e.edit=n;function D(T,R,P){let S=P;for(;S>=0;){if(T.charAt(S)===R.charAt(R.length-1)&&R.length===1)return S+1;if(S--,R.length===2&&S>=0&&T.charAt(S)===R.charAt(0))return S+2}return 0}e.getLineStartOffset=D;function A(T,R,P){let S=P;for(;S>=0;)if(T.charAt(S)===R.charAt(R.length-1)&&R.length===1||(S++,R.length===2&&S>=0&&T.charAt(S)===R.charAt(1)))return S;return T.length-1}e.getLineEndOffset=A}),define(oe[253],ae([0,1,32,54,14]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(g,h,y,f,l,d){const m=[],v=[],I=[];if(!h){const j=g.filter(({identifier:z})=>l.every(V=>V.toLowerCase()!==z.id.toLowerCase()));return{local:{added:m,removed:v,updated:I},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}g=g.map(E),h=h.map(E),y=y?y.map(E):null;const i=new Map,r=j=>{j.uuid&&i.set(j.id.toLowerCase(),j.uuid)};g.forEach(({identifier:j})=>r(j)),h.forEach(({identifier:j})=>r(j)),y?.forEach(({identifier:j})=>r(j));const t=j=>{const z=j.identifier.uuid||i.get(j.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${j.identifier.id.toLowerCase()}`},s=(j,z)=>(j.set(t(z),z),j),o=g.reduce(s,new Map),c=h.reduce(s,new Map),a=h.reduce((j,z)=>s(j,(0,k.deepClone)(z)),new Map),u=y?y.reduce(s,new Map):null,w=f.reduce(s,new Map),b=l.reduce((j,z)=>{const V=i.get(z.toLowerCase());return j.add(V?`uuid:${V}`:`id:${z.toLowerCase()}`)},new Set),U=d.reduce((j,{id:z,uuid:V})=>(V=V??i.get(z.toLowerCase()),j.add(V?`uuid:${V}`:`id:${z.toLowerCase()}`)),new Set),N=T(o,c,b,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const j=T(u,o,b,!1),z=T(u,c,b,!0),V=(Q,Y,H,q)=>({...q,installed:Y.installed||H.installed,version:H.version&&(!Y.installed||n.gt(H.version,Y.version))?H.version:Y.version,state:P(Y,H,u?.get(Q)),preRelease:(Y.installed?q.preRelease:H.preRelease)??Y.preRelease});for(const Q of z.removed.values()){const Y=o.get(Q);if(!Y)continue;const H=(0,D.assertIsDefined)(u?.get(Q)),q=!U.has(Q)&&H.installed;Y.installed&&q?v.push(Y.identifier):a.set(Q,Y)}for(const Q of z.added.values()){const Y=(0,D.assertIsDefined)(c.get(Q)),H=o.get(Q);if(H){if(N.updated.has(Q)){const q=V(Q,H,Y,Y);R(H,Y,!1,!1)||I.push(p(q,Q)),a.set(Q,q)}}else Y.installed&&m.push(p(Y,Q))}for(const Q of z.updated.values()){const Y=(0,D.assertIsDefined)(c.get(Q)),H=(0,D.assertIsDefined)(u?.get(Q)),q=o.get(Q);if(q)if(!U.has(Q)&&H.installed&&q.installed&&!Y.installed)v.push(q.identifier);else{const X=V(Q,q,Y,Y);I.push(p(X,Q)),a.set(Q,X)}else Y.installed&&m.push(p(Y,Q))}for(const Q of j.added.values())z.added.has(Q)||a.set(Q,(0,D.assertIsDefined)(o.get(Q)));for(const Q of j.updated.values()){if(z.removed.has(Q)||z.updated.has(Q))continue;const Y=(0,D.assertIsDefined)(o.get(Q)),H=(0,D.assertIsDefined)(c.get(Q));a.set(Q,V(Q,Y,H,Y))}for(const Q of j.removed.values())z.updated.has(Q)||z.removed.has(Q)||w.has(Q)||!(0,D.assertIsDefined)(c.get(Q)).installed||U.has(Q)||!(0,D.assertIsDefined)(u?.get(Q)).installed||a.delete(Q)}const $=[],F=T(c,a,new Set,!0),L=F.added.size>0||F.updated.size>0||F.removed.size>0;return L&&a.forEach((j,z)=>$.push(p(j,z))),{local:{added:m,removed:v,updated:I},remote:L?{added:[...F.added].map(j=>a.get(j)),updated:[...F.updated].map(j=>a.get(j)),removed:[...F.removed].map(j=>c.get(j)),all:$}:null}}e.merge=A;function T(g,h,y,f){const l=g?[...g.keys()].filter(i=>!y.has(i)):[],d=[...h.keys()].filter(i=>!y.has(i)),m=d.filter(i=>l.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),v=l.filter(i=>d.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),I=new Set;for(const i of l){if(v.has(i))continue;const r=g.get(i),t=h.get(i);(!t||!R(r,t,f,!0))&&I.add(i)}return{added:m,removed:v,updated:I}}function R(g,h,y,f){return!(g.disabled!==h.disabled||f&&g.installed!==h.installed||g.installed&&h.installed&&g.preRelease!==h.preRelease||!C(g.state,h.state)||y&&g.version!==h.version)}function P(g,h,y){const f=g.state,l=h.state,d=y?.state;if(!h.version||f&&n.gt(g.version,h.version))return f;if(l&&n.gt(h.version,g.version)||!f)return l;if(!l)return f;const m=(0,k.deepClone)(f),v=d?S(d,l):{added:Object.keys(l).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set},I=d?S(d,f):{added:Object.keys(f).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set};for(const i of[...v.added.values(),...v.updated.values()])m[i]=l[i];for(const i of v.removed.values())I.updated.has(i)||delete m[i];return m}function S(g,h){const y=Object.keys(g),f=Object.keys(h),l=f.filter(v=>y.indexOf(v)===-1).reduce((v,I)=>(v.add(I),v),new Set),d=y.filter(v=>f.indexOf(v)===-1).reduce((v,I)=>(v.add(I),v),new Set),m=new Set;for(const v of y){if(d.has(v))continue;const I=g[v],i=h[v];(0,k.equals)(I,i)||m.add(v)}return{added:l,removed:d,updated:m}}function C(g={},h={}){const{added:y,removed:f,updated:l}=S(g,h);return y.size===0&&f.size===0&&l.size===0}function E(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function p(g,h){const y={identifier:{id:g.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!g.preRelease};return g.version&&(y.version=g.version),g.disabled&&(y.disabled=!0),g.installed&&(y.installed=!0),g.state&&(y.state=g.state),y}}),define(oe[114],ae([0,1,21,16,4]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==R&&C!==`-${R}`),P&&S.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(R,P){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==R&&C!==`-${R}`),P&&S.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(R){const P=R.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),S=this.b().map(p=>p.toLowerCase()),C=[],E=[];if(Array.isArray(S))for(const p of S)p.startsWith("-")?E.push(p.substring(1)):C.push(p);return(0,k.distinct)([...P,...C].filter(p=>E.indexOf(p)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};A=pe([K(0,n.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(oe[254],ae([0,1,21,35,32,193,61]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(v){return(0,n.parse)(v)||[]}e.parseKeybindings=R;async function P(v,I,i,r,t){const s=R(v),o=R(I),c=i?R(i):null,a=[...s,...o,...c||[]].map(V=>V.key),u=await t.resolveUserBindings(a),w=C(s,o,c,u);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:v,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:I,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};const b=p(s),U=p(o),N=c?p(c):null,$=h(b,U,u),F=N?h(N,b,u):{added:[...b.keys()].reduce((V,Q)=>(V.add(Q),V),new Set),removed:new Set,updated:new Set},L=N?h(N,U,u):{added:[...U.keys()].reduce((V,Q)=>(V.add(Q),V),new Set),removed:new Set,updated:new Set},j=S($,F,L);let z=v;for(const V of j.removed.values())j.conflicts.has(V)||(z=d(z,V,r));for(const V of j.added.values()){if(j.conflicts.has(V))continue;const Q=U.get(V);if(Q.some(Y=>Y.command!==`-${V}`&&w.conflicts.has(u[Y.key]))){j.conflicts.add(V);continue}z=l(z,Q,r)}for(const V of j.updated.values()){if(j.conflicts.has(V))continue;const Q=U.get(V);if(Q.some(Y=>Y.command!==`-${V}`&&w.conflicts.has(u[Y.key]))){j.conflicts.add(V);continue}z=m(z,V,Q,r)}return{mergeContent:z,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=P;function S(v,I,i){const r=new Set,t=new Set,s=new Set,o=new Set;for(const c of I.removed.values())i.updated.has(c)&&o.add(c);for(const c of i.removed.values())o.has(c)||(I.updated.has(c)?o.add(c):t.add(c));for(const c of I.added.values())o.has(c)||i.added.has(c)&&v.updated.has(c)&&o.add(c);for(const c of i.added.values())o.has(c)||(I.added.has(c)?v.updated.has(c)&&o.add(c):r.add(c));for(const c of I.updated.values())o.has(c)||i.updated.has(c)&&v.updated.has(c)&&o.add(c);for(const c of i.updated.values())o.has(c)||(I.updated.has(c)?v.updated.has(c)&&o.add(c):s.add(c));return{added:r,removed:t,updated:s,conflicts:o}}function C(v,I,i,r){const t=new Set,s=E(v,r),o=E(I,r),c=i?E(i,r):null,a=g(s,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const u=c?g(c,s):{added:[...s.keys()].reduce((F,L)=>(F.add(L),F),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const w=c?g(c,o):{added:[...o.keys()].reduce((F,L)=>(F.add(L),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:b,removed:U,updated:N,conflicts:$}=S(a,u,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:b,removed:U,updated:N,conflicts:$}}function E(v,I){const i=new Map;for(const r of v){const t=I[r.key];let s=i.get(t);s||(s=[],i.set(t,s)),s.push(r)}return i}function p(v){const I=new Map;for(const i of v){const r=i.command[0]==="-"?i.command.substring(1):i.command;let t=I.get(r);t||(t=[],I.set(r,t)),t.push(i)}return I}function g(v,I){const i=[...v.keys()],r=[...I.keys()],t=r.filter(c=>i.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),s=i.filter(c=>r.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),o=new Set;for(const c of i){if(s.has(c))continue;const a=v.get(c).map(w=>({...w,key:c})),u=I.get(c).map(w=>({...w,key:c}));(0,k.equals)(a,u,(w,b)=>f(w,b))||o.add(c)}return{added:t,removed:s,updated:o}}function h(v,I,i){const r=[...v.keys()],t=[...I.keys()],s=t.filter(a=>r.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),o=r.filter(a=>t.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),c=new Set;for(const a of r){if(o.has(a))continue;const u=v.get(a).map(b=>({...b,key:i[b.key]})),w=I.get(a).map(b=>({...b,key:i[b.key]}));y(u,w)||c.add(a)}return{added:s,removed:o,updated:c}}function y(v,I){return!(!(0,k.equals)(v.filter(({command:i})=>i[0]!=="-"),I.filter(({command:i})=>i[0]!=="-"),(i,r)=>f(i,r))||!(0,k.equals)(v.filter(({command:i})=>i[0]==="-"),I.filter(({command:i})=>i[0]==="-"),(i,r)=>f(i,r)))}function f(v,I){if(v.command!==I.command||v.key!==I.key)return!1;const i=A.ContextKeyExpr.deserialize(v.when),r=A.ContextKeyExpr.deserialize(I.when);return!(i&&!r||!i&&r||i&&r&&!i.equals(r)||!D.equals(v.args,I.args))}function l(v,I,i){for(const r of I)v=T.edit(v,[-1],r,i);return v}function d(v,I,i){const r=R(v);for(let t=r.length-1;t>=0;t--)(r[t].command===I||r[t].command===`-${I}`)&&(v=T.edit(v,[t],void 0,i));return v}function m(v,I,i,r){const t=R(v),s=t.findIndex(o=>o.command===I||o.command===`-${I}`);for(let o=t.length-1;o>=0;o--)(t[o].command===I||t[o].command===`-${I}`)&&(v=T.edit(v,[o],void 0,r));for(let o=i.length-1;o>=0;o--)v=T.edit(v,[s],i[o],r);return v}}),define(oe[255],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(A,T,R){const P={},S={},C=new Set;if(!T)return{local:{added:P,updated:S,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const E=n(A,T);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:P,updated:S,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=n(R,A),g=n(R,T),h={},y={},f=new Set,l=new Set;for(const d of p.removed.values())g.updated.has(d)?P[d]=T[d]:f.add(d);for(const d of g.removed.values())l.has(d)||(p.updated.has(d)?l.add(d):C.add(d));for(const d of p.updated.values())l.has(d)||(g.updated.has(d)?E.updated.has(d)&&l.add(d):y[d]=A[d]);for(const d of g.updated.values())l.has(d)||(p.updated.has(d)?E.updated.has(d)&&l.add(d):A[d]!==void 0&&(S[d]=T[d]));for(const d of p.added.values())l.has(d)||(g.added.has(d)?E.updated.has(d)&&l.add(d):h[d]=A[d]);for(const d of g.added.values())l.has(d)||(p.added.has(d)?E.updated.has(d)&&l.add(d):P[d]=T[d]);return{local:{added:P,removed:[...C.values()],updated:S},remote:{added:h,removed:[...f.values()],updated:y},conflicts:[...l.values()]}}e.merge=k;function n(A,T){const R=A?Object.keys(A):[],P=T?Object.keys(T):[],S=P.filter(p=>R.indexOf(p)===-1).reduce((p,g)=>(p.add(g),p),new Set),C=R.filter(p=>P.indexOf(p)===-1).reduce((p,g)=>(p.add(g),p),new Set),E=new Set;for(const p of R){if(C.has(p))continue;const g=A[p],h=T[p];g!==h&&E.add(p)}return{added:S,removed:C,updated:E}}function D(A,T){const{added:R,removed:P,updated:S}=n(A,T);return R.size===0&&P.size===0&&S.size===0}e.areSame=D}),define(oe[256],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(D,A,T,R){const P={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!A){const E=D.filter(({id:p})=>!R.includes(p));return E.length?S.added=E:S=null,{local:P,remote:S}}const C=n(D,A,R);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const E=n(T,D,R),p=n(T,A,R);for(const g of p.removed){const h=D.find(y=>y.id===g);h&&P.removed.push(h)}for(const g of p.added){const h=A.find(y=>y.id===g);E.added.includes(g)?C.updated.includes(g)&&P.updated.push(h):P.added.push(h)}for(const g of p.updated)P.updated.push(A.find(h=>h.id===g));for(const g of E.added)p.added.includes(g)||S.added.push(D.find(h=>h.id===g));for(const g of E.updated)p.removed.includes(g)||p.updated.includes(g)||S.updated.push(D.find(h=>h.id===g));for(const g of E.removed){const h=A.find(y=>y.id===g);h&&S.removed.push(h)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:P,remote:S}}e.merge=k;function n(D,A,T){D=D?D.filter(({id:p})=>!T.includes(p)):[],A=A.filter(({id:p})=>!T.includes(p));const R=D.map(({id:p})=>p),P=A.map(({id:p})=>p),S=P.filter(p=>R.indexOf(p)===-1),C=R.filter(p=>P.indexOf(p)===-1),E=[];for(const{id:p,name:g,shortName:h}of D){if(C.includes(p))continue;const y=A.find(f=>f.id===p);(!y||y.name!==g||y.shortName!==h)&&E.push(p)}return{added:S,removed:C,updated:E}}}),define(oe[26],ae([0,1,21,14,179,46,30,4,104,40]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EXTENSIONS_SYNC_CONTEXT_KEY=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const o=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(c=>!!o[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function E(){const o=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(o).filter(w=>!!o[w].ignoreSync),a=Object.keys(o).filter(w=>o[w].scope===2||o[w].scope===6),u=C();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...a,...u])}e.getDefaultIgnoredSettings=E,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function p(){const o="vscode://schemas/ignoredSettings",c=S.Registry.as(A.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=S.Registry.as(P.Extensions.JSONContribution),u=()=>{const w=C(),b=E().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),U=Object.keys(A.allSettings.properties).filter(F=>b.indexOf(F)===-1),N=b.filter(F=>w.indexOf(F)===-1),$={items:{type:"string",enum:[...U,...N.map(F=>`-${F}`)]}};a.registerSchema(o,$)};return c.onDidUpdateConfiguration(()=>u())}e.registerConfiguration=p;function g(o){return o&&(0,n.isObject)(o)&&(0,n.isString)(o.id)&&Array.isArray(o.scopes)}e.isAuthenticationProvider=g;var h;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(o,...c){return o?[o,...c]:c}e.getPathSegments=y;function f(o,c,a,u){return u.joinPath(a.userDataSyncHome,...y(o,c,`lastSync${c}.json`))}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(o){const c={};return c[e.HEADER_EXECUTION_ID]=o,c}e.createSyncHeaders=l;var d;(function(o){o.Unauthorized="Unauthorized",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})(d=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class m extends Error{constructor(c,a,u,w){super(c),this.code=a,this.resource=u,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=m;class v extends m{constructor(c,a,u,w,b){super(c,u,void 0,b),this.url=a,this.serverCode=w}}e.UserDataSyncStoreError=v;class I extends m{constructor(c,a){super(c,a)}}e.UserDataAutoSyncError=I,function(o){function c(a){if(a instanceof o)return a;const u=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(u&&u[1]){const w=u[2]==="unknown"?void 0:u[2],b=u[3]==="unknown"?void 0:u[3];return new o(a.message,u[1],w,b)}return new o(a.message,"Unknown")}o.toUserDataSyncError=c}(m=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var r;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(o){return`sync.enable.${o}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview",e.EXTENSIONS_SYNC_CONTEXT_KEY="extensionsSync"}),define(oe[257],ae([0,1,32,26]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(T,R,P,S,C){if(!R)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const E=A(T,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const p=P?A(P,R):{added:Object.keys(R).reduce((d,m)=>(d.add(m),d),new Set),removed:new Set,updated:new Set},g=P?A(P,T):{added:Object.keys(T).reduce((d,m)=>(d.add(m),d),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},y=k.deepClone(R),f=!P;for(const d of g.added.values())d!==n.SYNC_SERVICE_URL_TYPE&&f&&p.added.has(d)||(y[d]=T[d]);for(const d of g.updated.values())y[d]=T[d];for(const d of g.removed.values())S.unregistered.includes(d)||delete y[d];for(const d of p.added.values()){const m=R[d];if(S.machine.includes(d)){C.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(P&&g.added.has(d))continue;const v=T[d];v&&v.value===m.value||d===n.SYNC_SERVICE_URL_TYPE&&f&&g.added.has(d)||(v?h.updated[d]=m:h.added[d]=m)}for(const d of p.updated.values()){const m=R[d];if(S.machine.includes(d)){C.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(g.updated.has(d)||g.removed.has(d))continue;const v=T[d];v&&v.value===m.value||(h.updated[d]=m)}for(const d of p.removed.values()){if(S.machine.includes(d)){C.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}g.updated.has(d)||g.removed.has(d)||h.removed.push(d)}const l=A(R,y);return{local:h,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:y}}}e.merge=D;function A(T,R){const P=Object.keys(T),S=Object.keys(R),C=S.filter(g=>P.indexOf(g)===-1).reduce((g,h)=>(g.add(h),g),new Set),E=P.filter(g=>S.indexOf(g)===-1).reduce((g,h)=>(g.add(h),g),new Set),p=new Set;for(const g of P){if(E.has(g))continue;const h=T[g],y=R[g];k.equals(h,y)||p.add(g)}return{added:C,removed:E,updated:p}}}),define(oe[258],ae([0,1,21,35,83,43,32,61,26]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(a,u,w){let b=[];w?b=E(w):b=C(u);const U=[],N=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(b))for(const $ of b)$.startsWith("-")?N.push($.substring(1)):U.push($);return(0,k.distinct)([...a,...U].filter($=>N.indexOf($)===-1))}e.getIgnoredSettings=S;function C(a){let u=a.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=a.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const u=(0,n.parse)(a);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function p(a,u){const w=(0,n.parse)(a)||{};let b="{}";for(const U of Object.keys(w)){const N=(0,D.setProperty)(b,[U],w[U],u);b=(0,D.applyEdits)(b,N)}return b}e.removeComments=p;function g(a,u,w,b){if(w.length){const U=c(u),N=(0,n.parse)(u)||{},$=(0,n.parse)(a);if(!$)return a;const F=[];for(const L of w){const j=N[L],z=$[L];j===void 0?a=R.edit(a,[L],void 0,b):z!==void 0?a=R.edit(a,[L],j,b):F.push(i(L,U))}F.sort((L,j)=>L.startOffset-j.startOffset),F.forEach(L=>a=d(L.setting.key,u,a,b))}return a}e.updateIgnoredSettings=g;function h(a,u,w,b,U,N){const $=g(a,u,b,N),F=w!==$,L=w!==u;if(!F&&!L)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!L)return{conflictsSettings:[],localContent:null,remoteContent:$,hasConflicts:!1};if(L&&!F)return{conflictsSettings:[],localContent:g(u,a,b,N),remoteContent:null,hasConflicts:!1};if(w===null&&f(a)){const B=y(a,u,b)?null:g(u,a,b,N);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let j=a,z=u;const V=(0,n.parse)(a),Q=(0,n.parse)(u),Y=w?(0,n.parse)(w):null,H=b.reduce((B,x)=>(B.add(x),B),new Set),q=l(V,Q,H),G=l(Y,V,H),X=l(Y,Q,H),ee=new Map,re=new Set,te=B=>{re.add(B);const x=U.filter(({key:ie})=>ie===B)[0];x?(j=R.edit(j,[B],x.value,N),z=R.edit(z,[B],x.value,N)):ee.set(B,{key:B,localValue:V[B],remoteValue:Q[B]})};for(const B of G.removed.values())X.updated.has(B)?te(B):z=R.edit(z,[B],void 0,N);for(const B of X.removed.values())re.has(B)||(G.updated.has(B)?te(B):j=R.edit(j,[B],void 0,N));for(const B of G.updated.values())re.has(B)||(X.updated.has(B)?q.updated.has(B)&&te(B):z=R.edit(z,[B],V[B],N));for(const B of X.updated.values())re.has(B)||(G.updated.has(B)?q.updated.has(B)&&te(B):j=R.edit(j,[B],Q[B],N));for(const B of G.added.values())re.has(B)||(X.added.has(B)?q.updated.has(B)&&te(B):z=d(B,j,z,N));for(const B of X.added.values())re.has(B)||(G.added.has(B)?q.updated.has(B)&&te(B):j=d(B,z,j,N));const O=ee.size>0||!y(j,z,b),M=O||!y(j,a,[]),W=O||!y(z,u,[]);return{localContent:M?j:null,remoteContent:W?z:null,conflictsSettings:[...ee.values()],hasConflicts:O}}e.merge=h;function y(a,u,w){if(a===u)return!0;const b=(0,n.parse)(a),U=(0,n.parse)(u),N=w.reduce((L,j)=>(L.add(j),L),new Set),$=c(a).filter(L=>!(L.setting&&N.has(L.setting.key))),F=c(u).filter(L=>!(L.setting&&N.has(L.setting.key)));if($.length!==F.length)return!1;for(let L=0;L<$.length;L++){const j=$[L],z=F[L];if(j.setting&&z.setting){if(j.setting.key!==z.setting.key||!T.equals(b[j.setting.key],U[j.setting.key]))return!1}else if(!j.setting&&!z.setting){if(j.value!==z.value)return!1}else return!1}return!0}e.areSame=y;function f(a){return a?c(a).length===0:!0}e.isEmpty=f;function l(a,u,w){const b=a?Object.keys(a).filter(L=>!w.has(L)):[],U=Object.keys(u).filter(L=>!w.has(L)),N=U.filter(L=>b.indexOf(L)===-1).reduce((L,j)=>(L.add(j),L),new Set),$=b.filter(L=>U.indexOf(L)===-1).reduce((L,j)=>(L.add(j),L),new Set),F=new Set;if(a)for(const L of b){if($.has(L))continue;const j=a[L],z=u[L];T.equals(j,z)||F.add(L)}return{added:N,removed:$,updated:F}}function d(a,u,w,b){const U=(0,n.parse)(u),N=c(u),$=c(w),F=m(a,N,$);return v(w,a,U[a],F,$,b)}e.addSetting=d;function m(a,u,w){const b=u.findIndex(N=>N.setting?.key===a),U=u[b-1];if(U){if(U.setting){const $=i(U.setting.key,w);if($)return{index:w.indexOf($),insertAfter:!0}}else{const $=r(b,u);if($){const F=i($.setting.key,w);if(F){const L=t(w.indexOf(F),w),j=s(u,$,u[b]);if(L){const z=s(w,F,L),V=o(j,z);return V?{index:w.indexOf(V),insertAfter:!0}:{index:w.indexOf(L),insertAfter:!1}}else{const z=s(w,F,w[w.length-1]),V=o(j,z);return V?{index:w.indexOf(V),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const N=u[b+1];if(N)if(N.setting){const $=i(N.setting.key,w);if($)return{index:w.indexOf($),insertAfter:!1}}else{const $=t(b,u);if($){const F=i($.setting.key,w);if(F){const L=r(w.indexOf(F),w),j=s(u,u[b],$);if(L){const z=s(w,L,F),V=o(j.reverse(),z.reverse());return V?{index:w.indexOf(V),insertAfter:!1}:{index:w.indexOf(L),insertAfter:!0}}else{const z=s(w,w[0],F),V=o(j.reverse(),z.reverse());return V?{index:w.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function v(a,u,w,b,U,N){let $;return b.index===-1?$=(0,D.setProperty)(a,[u],w,N):$=I(a,u,w,b,U,N).map(F=>(0,D.withFormatting)(a,F,N)[0]),(0,D.applyEdits)(a,$)}function I(a,u,w,b,U,N){const $=`${JSON.stringify(u)}: ${JSON.stringify(w)}`,F=(0,A.getEOL)(N,a),L=U[b.index];if(b.insertAfter){const j=[];if(L.setting)j.push({offset:L.endOffset,length:0,content:","+$});else{const z=t(b.index,U),V=r(b.index,U),Q=V?.setting?.commaOffset;V&&Q===void 0&&j.push({offset:V.endOffset,length:0,content:","});const Y=Q!==void 0&&Q>L.endOffset;j.push({offset:Y?Q+1:L.endOffset,length:0,content:z?F+$+",":F+$})}return j}else{if(L.setting)return[{offset:L.startOffset,length:0,content:$+","}];const j=(U[b.index-1]&&!U[b.index-1].setting?F:"")+$+(t(b.index,U)?",":"")+F;return[{offset:L.startOffset,length:0,content:j}]}}function i(a,u){return u.filter(w=>w.setting?.key===a)[0]}function r(a,u){for(let w=a-1;w>=0;w--)if(u[w].setting)return u[w]}function t(a,u){for(let w=a+1;w<u.length;w++)if(u[w].setting)return u[w]}function s(a,u,w){const b=a.indexOf(u),U=a.indexOf(w);return a.filter((N,$)=>b<$&&$<U)}function o(a,u){if(a.length&&u.length){let w=0;for(;w<u.length&&w<a.length;w++)if(a[w].value!==u[w].value)return u[w-1];return u[w-1]}}function c(a){const u=[];let w=-1,b,U;const N={onObjectBegin:$=>{w++},onObjectProperty:($,F,L)=>{w===0&&(b=F,U=$)},onObjectEnd:($,F)=>{w--,w===0&&u.push({startOffset:b,endOffset:$+F,value:a.substring(b,$+F),setting:{key:U,commaOffset:void 0}})},onArrayBegin:($,F)=>{w++},onArrayEnd:($,F)=>{w--,w===0&&u.push({startOffset:b,endOffset:$+F,value:a.substring(b,$+F),setting:{key:U,commaOffset:void 0}})},onLiteralValue:($,F,L)=>{w===0&&u.push({startOffset:b,endOffset:F+L,value:a.substring(b,F+L),setting:{key:U,commaOffset:void 0}})},onSeparator:($,F,L)=>{if(w===0&&$===","){let j=u.length-1;for(;j>=0&&!u[j].setting;j--);const z=u[j];z&&u.splice(j,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:F}})}},onComment:($,F)=>{w===0&&u.push({startOffset:$,endOffset:$+F,value:a.substring($,$+F)})}};return(0,n.visit)(a,N),u}}),define(oe[78],ae([0,1,3,2,4,26]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let T=class extends n.Disposable{get account(){return this.a}constructor(P,S){super(),this.g=P,this.h=S,this.b=this.B(new k.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new k.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};T=pe([K(0,A.IUserDataSyncStoreService),K(1,A.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(oe[259],ae([0,1,2,7]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(p){this.a=p}listen(p,g){switch(g){case"onError":return this.a.onError}throw new Error(`Event not found: ${g}`)}call(p,g,h){switch(g){case"triggerSync":return this.a.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class A{constructor(p){this.a=p}listen(p,g){throw new Error(`Event not found: ${g}`)}call(p,g,h){switch(g){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(n.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class T{constructor(p){this.a=p}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.a.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.a.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(p){this.a=p}listen(p,g){switch(g){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${g}`)}async call(p,g,h){switch(g){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(h[0],h[1]);case"setEnablements":return this.a.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class P{constructor(p){this.a=p}listen(p,g){switch(g){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${g}`)}call(p,g,h){switch(g){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class S{constructor(p){this.a=p}listen(p,g){switch(g){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${g}`)}call(p,g,h){switch(g){case"switch":return this.a.switch(h[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class C extends k.Disposable{constructor(p){super(),this.a=p,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.a.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.a.call("getPreviousUserDataSyncStore");return this.b(p)}b(p){return{url:n.URI.revive(p.url),type:p.type,defaultUrl:n.URI.revive(p.defaultUrl),insidersUrl:n.URI.revive(p.insidersUrl),stableUrl:n.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(oe[260],ae([0,1,15,8]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends n.AbstractLogger{constructor(T,R){super(),this.g=this.B(T.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...R){this.g.trace(T,...R)}debug(T,...R){this.g.debug(T,...R)}info(T,...R){this.g.info(T,...R)}warn(T,...R){this.g.warn(T,...R)}error(T,...R){this.g.error(T,...R)}flush(){this.g.flush()}};D=pe([K(0,n.ILoggerService),K(1,k.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(oe[261],ae([0,1,6,3,2]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends D.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:P,getActiveWindowId:S}){super(),this.a=this.B(new D.DisposableStore),n.Event.latch(n.Event.any(R,P))(this.f,this,this.a),this.b=(0,k.createCancelablePromise)(()=>S()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(oe[115],ae([0,1,182,12,49,22,7,4,24]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function S(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=S;function C(t){return typeof t?.id=="string"&&!S(t)&&!p(t)}e.isEmptyWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,n.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=E;function p(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=p;function g(t){const s=t;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=g;var h;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function y(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=y;function f(t){const s=t;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=f;class l{constructor(s,o,c,a,u){this.h=s,this.j=c,this.k=a,this.l=u,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class d{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function m(t){return new d({uri:t,index:0,name:(0,A.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(t,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function I(t){let s;return T.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=I;function i(t,s){return!v(t,s)&&!I(t)}e.isSavedWorkspace=i;function r(t){return(typeof t=="string"?(0,n.extname)(t):(0,A.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(oe[18],ae([0,1,66,3,2,22,7,174,15,13,4,8,115,37,29,6,31,27,14]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function m(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&T.URI.isUri(s.location)&&T.URI.isUri(s.globalStorageHome)&&T.URI.isUri(s.settingsResource)&&T.URI.isUri(s.keybindingsResource)&&T.URI.isUri(s.tasksResource)&&T.URI.isUri(s.snippetsHome)&&T.URI.isUri(s.extensionsResource))}e.isUserDataProfile=m,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function v(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:T.URI.revive(t.location).with({scheme:s}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:T.URI.revive(t.extensionsResource)?.with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=v;function I(t,s,o,c){return{id:t,name:s,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,A.joinPath)(o,"globalStorage"),settingsResource:(0,A.joinPath)(o,"settings.json"),keybindingsResource:(0,A.joinPath)(o,"keybindings.json"),tasksResource:(0,A.joinPath)(o,"tasks.json"),snippetsHome:(0,A.joinPath)(o,"snippets"),extensionsResource:(0,A.joinPath)(o,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=I;let i=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(s,o,c,a){super(),this.m=s,this.n=o,this.r=c,this.s=a,this.f=!1,this.g=this.B(new n.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new n.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new n.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new n.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(s){this.f!==s&&(this.t=void 0,this.f=s)}isEnabled(){return this.f}get u(){if(!this.t){const s=[];if(this.f)for(const u of this.G()){if(!u.name||!(0,d.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}s.push(I((0,A.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}const o=new g.ResourceMap,c=new Map,a=I((0,k.hash)(this.m.userRoamingDataHome.path).toString(16),(0,R.localize)(0,null),this.m.userRoamingDataHome);if(s.unshift({...a,extensionsResource:this.L()??a.extensionsResource,isDefault:!0}),s.length){const u=this.I();if(u.workspaces)for(const[w,b]of Object.entries(u.workspaces)){const U=T.URI.parse(w),N=T.URI.parse(b),$=s.find(F=>this.r.extUri.isEqual(F.location,N));$&&o.set(U,$)}if(u.emptyWindows)for(const[w,b]of Object.entries(u.emptyWindows)){const U=T.URI.parse(b),N=s.find($=>this.r.extUri.isEqual($.location,U));N&&c.set(w,N)}}this.t={profiles:s,workspaces:o,emptyWindows:c}}return this.t}async createTransientProfile(s){const o="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const w of this.profiles){const b=c.exec(w.name),U=b?parseInt(b[1]):0;a=U>a?U:a}const u=`${o} ${a+1}`;return this.createProfile((0,k.hash)((0,f.generateUuid)()).toString(16),u,{transient:!0},s)}async createNamedProfile(s,o,c){return this.createProfile((0,k.hash)((0,f.generateUuid)()).toString(16),s,o,c)}async createProfile(s,o,c,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.v(s,o,c);return a&&await this.setProfileForWorkspace(a,u),u}async v(s,o,c){if(!(0,d.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(o);return a||(a=(async()=>{try{const u=this.profiles.find(U=>U.name===o||U.id===s);if(u)return u;const w=I(s,o,(0,A.joinPath)(this.profilesHome,s),c);await this.n.createFolder(w.location);const b=[];return this.h.fire({profile:w,join(U){b.push(U)}}),await y.Promises.settled(b),this.z([w],[],[]),w}finally{this.k.delete(o)}})(),this.k.set(o,a)),a}async updateProfile(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);return c=I(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.z([],[],[c]),c}async removeProfile(s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const c=[];this.i.fire({profile:o,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.F(),this.z([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.D(s,c)}unsetWorkspace(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(s,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const s=await this.n.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.l.profiles.filter(o=>!this.y(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.w(s);return T.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}w(s){return(0,p.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,p.isWorkspaceIdentifier)(s)?s.configPath:s.id}y(s){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location)))}z(s,o,c){const a=[...this.profiles,...s],u=[];this.l.profiles=[];for(let w of a)w.isDefault||o.some(b=>w.id===b.id)||(w=c.find(b=>w.id===b.id)??w,w.isTransient?this.l.profiles.push(w):u.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.H(u),this.t=void 0,this.C(s,o,c)}C(s,o,c){this.g.fire({added:s,removed:o,updated:c,all:this.profiles})}D(s,o,c){c=o?.isTransient?!0:c,c||this.D(s,void 0,!0);const a=this.w(s),u=c?this.l:this.u;T.URI.isUri(a)?(u.workspaces.delete(a),o&&u.workspaces.set(a,o)):(u.emptyWindows.delete(a),o&&u.emptyWindows.set(a,o)),c||this.F()}F(){const s={};for(const[c,a]of this.u.workspaces.entries())s[c.toString()]=a.location.toString();const o={};for(const[c,a]of this.u.emptyWindows.entries())o[c.toString()]=a.location.toString();this.J({workspaces:s,emptyWindows:o}),this.t=void 0}G(){return[]}H(s){throw new Error("not implemented")}I(){return{}}J(s){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([K(0,P.IEnvironmentService),K(1,S.IFileService),K(2,h.IUriIdentityService),K(3,E.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(s){this.a=s}I(){return this.O}J(s){this.O=s}}e.InMemoryUserDataProfilesService=r}),define(oe[262],ae([0,1,6,2,18]),function(Z,e,k,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends n.Disposable{constructor(R){super(),this.B(new k.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};A=pe([K(0,D.IUserDataProfilesService)],A),e.UserDataProfilesCleaner=A}),define(oe[263],ae([0,1,21,6,23,9,3,2,5,7,155,30,33,42,8,25,19,18]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var d;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(d=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let m=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(s,o,c,a,u){super(),this.t=s,this.u=o,this.v=c,this.w=a,this.y=u,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new T.Emitter),this.m=this.B(new T.Emitter),this.n=this.B(new T.Emitter),this.p=this.B(new T.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(c=>(0,E.isTargetPlatformCompatible)(c,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{if(!this.t.isEnabled())throw new E.ExtensionManagementError(C.localize(0,null),E.ExtensionManagementErrorCode.Internal);const c=await this.G(s,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.z(c.manifest,c.extension,o)}catch(c){throw i(this.u,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(s),error:c}),this.v.error("Failed to install extension.",s.identifier.id),this.v.error(c),I(c)}}async uninstall(s,o={}){return this.v.trace("ExtensionManagementService#uninstall",s.identifier.id),this.I(s,o)}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.O(),this.h=s),this.g}registerParticipant(s){this.s.push(s)}async z(s,o,c){const a={...c,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(o)?c.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,g.isApplicationScopedExtension)(s)?this.y.defaultProfile.extensionsResource:c.profileLocation??this.P()},u=F=>`${p.ExtensionKey.create(F).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!S.URI.isUri(o)){const F=this.j.get(u(o));if(F){this.v.info("Extensions is already requested to install",o.identifier.id);const{local:L}=await F.task.waitUntilTaskIsFinished();return L}}const w=[],b=[],U=[],N=this.Q(s,o,a);S.URI.isUri(o)||this.j.set(u(o),{task:N,waitingTasks:[]}),this.l.fire({identifier:N.identifier,source:o,profileLocation:a.profileLocation}),this.v.info("Installing extension:",N.identifier.id),w.push({task:N,manifest:s});let $=!1;try{if(a.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const L=await this.F(N.identifier,s,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),j=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:z,manifest:V}of(0,k.distinct)(L,({gallery:Q})=>Q.identifier.id)){$=$||!!V.extensionDependencies?.some(H=>(0,p.areSameExtensions)({id:H},N.identifier));const Q=u(z),Y=this.j.get(Q);if(Y){if(this.C(N,Y.task)){const H=Y.task.identifier;this.v.info("Waiting for already requested installing extension",H.id,N.identifier.id),Y.waitingTasks.push(N),b.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,q=>q.some(G=>(0,p.areSameExtensions)(G.identifier,H)))).then(q=>{if(this.v.info("Finished waiting for already requested installing extension",H.id,N.identifier.id),!q.find(X=>(0,p.areSameExtensions)(X.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!j.some(({identifier:H})=>(0,p.areSameExtensions)(H,z.identifier))){const H=this.Q(V,z,{...a,donotIncludePackAndDependencies:!0});this.j.set(Q,{task:H,waitingTasks:[N]}),this.l.fire({identifier:H.identifier,source:z,profileLocation:a.profileLocation}),this.v.info("Installing extension:",H.identifier.id,N.identifier.id),w.push({task:H,manifest:V})}}}catch(L){if(S.URI.isUri(N.source))(0,k.isNonEmptyArray)(s.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",N.identifier.id,L.message),(0,k.isNonEmptyArray)(s.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",N.identifier.id,L.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),L}const F=w.reduce((L,{task:j,manifest:z})=>(L.set(j.identifier.id.toLowerCase(),{task:j,manifest:z}),L),new Map);for(;F.size;){let L;const j=[...F.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(V=>F.has(V.toLowerCase())));j.length?L=F.size===1?j:j.filter(({task:z})=>!(z===N&&!$)):(this.v.info("Found extensions with circular dependencies",j.map(({task:z})=>z.identifier.id)),L=[...F.values()]),await this.D(L.map(async({task:z})=>{const V=new Date().getTime();try{const{local:Q}=await z.run();if(await this.D(this.s.map(Y=>Y.postInstall(Q,z.source,a,D.CancellationToken.None))),!S.URI.isUri(z.source)){const Y=z.operation===3,H=Y?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(i(this.u,Y?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:H}),P.isWeb&&z.operation!==3)try{await this.t.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}U.push({local:Q,identifier:z.identifier,operation:z.operation,source:z.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw S.URI.isUri(z.source)||i(this.u,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-V,error:Q}),this.v.error("Error while installing the extension:",z.identifier.id),Q}finally{F.delete(z.identifier.id.toLowerCase())}}))}return b.length&&await this.D(b),U.forEach(({identifier:L})=>this.v.info("Extension installed successfully:",L.id)),this.m.fire(U),U.filter(({identifier:L})=>(0,p.areSameExtensions)(L,N.identifier))[0].local}catch(F){if(w.forEach(({task:L})=>L.cancel()),U.length)try{const L=await Promise.allSettled(U.map(({local:j})=>this.R(j,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let j=0;j<L.length;j++){const z=L[j],{identifier:V}=U[j];z.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",V.id):this.v.warn("Rollback: Error while uninstalling extension",V.id,(0,A.getErrorMessage)(z.reason))}}catch(L){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)(L),U.map(({identifier:j})=>j.id))}throw this.m.fire(w.map(({task:L})=>({identifier:L.identifier,operation:2,source:L.source,context:a.context,profileLocation:a.profileLocation}))),F}finally{for(const{task:F}of w)F.source&&!S.URI.isUri(F.source)&&this.j.delete(u(F.source))}}C(s,o){for(const[,{task:c,waitingTasks:a}]of this.j.entries())if(c===s&&(a.includes(o)||a.some(u=>this.C(u,o)))||c===o&&a[0]&&!this.C(s,a[0]))return!1;return!0}async D(s){const o=[],c=[],a=await Promise.allSettled(s);for(const u of a)u.status==="fulfilled"?o.push(u.value):c.push(u.reason);if(c.length)throw v(c);return o}async F(s,o,c,a,u){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,u),b=[],U=[],N=async($,F)=>{b.push($);const L=F.extensionDependencies||[],j=[...L];if(F.extensionPack){const z=c?w.find(V=>(0,p.areSameExtensions)(V.identifier,$)):void 0;for(const V of F.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(Q=>(0,p.areSameExtensions)({id:Q},{id:V}))||j.every(Q=>!(0,p.areSameExtensions)({id:Q},{id:V}))&&j.push(V)}if(j.length){const z=j.filter(V=>b.every(Q=>!(0,p.areSameExtensions)(Q,{id:V})));if(z.length){const V=await this.t.getExtensions(z.map(Q=>({id:Q,preRelease:a})),D.CancellationToken.None);for(const Q of V){if(b.find(q=>(0,p.areSameExtensions)(q,Q.identifier)))continue;const Y=L.some(q=>(0,p.areSameExtensions)({id:q},Q.identifier));let H;try{H=await this.G(Q,!1,a)}catch(q){if(q instanceof E.ExtensionManagementError&&q.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Y){this.v.info("Skipping the packed extension as it cannot be installed",Q.identifier.id);continue}else throw q}U.push({gallery:H.extension,manifest:H.manifest}),await N(H.extension.identifier,H.manifest)}}}};return await N(s,o),U}async G(s,o,c){if((await this.getExtensionsControlManifest()).malicious.some(b=>(0,p.areSameExtensions)(s.identifier,b)))throw new E.ExtensionManagementError(C.localize(1,null,s.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(s)){const b=await this.getTargetPlatform();throw new E.ExtensionManagementError(C.localize(2,null,s.identifier.id,this.w.nameLong,(0,E.TargetPlatformToString)(b)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.H(s,o,c);if(u){if(c&&!o&&s.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(C.localize(3,null,s.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!c&&s.properties.isPreReleaseVersion&&(await this.t.getExtensions([s.identifier],D.CancellationToken.None))[0]?new E.ExtensionManagementError(C.localize(4,null,s.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(C.localize(5,null,s.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",u.identifier.id);const w=await this.t.getManifest(u,D.CancellationToken.None);if(w===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(w.version!==u.version)throw new E.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:w}}async H(s,o,c){const a=await this.getTargetPlatform();let u=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==c&&(u=(await this.t.getExtensions([{...s.identifier,preRelease:c}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null),!u&&await this.t.isExtensionCompatible(s,c,a)&&(u=s),u||(o?u=(await this.t.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null:u=await this.t.getCompatibleExtension(s,c,a)),u}async I(s,o){const c={...o,profileLocation:s.isApplicationScoped?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},a=$=>`${$.id.toLowerCase()}${c.versionOnly?`-${s.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,u=this.k.get(a(s.identifier));if(u)return this.v.info("Extensions is already requested to uninstall",s.identifier.id),u.waitUntilTaskIsFinished();const w=$=>{const F=this.R($,c);return this.k.set(a(F.extension.identifier),F),c.profileLocation?this.v.info("Uninstalling extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,c.profileLocation.toString()):this.v.info("Uninstalling extension:",`${$.identifier.id}@${$.manifest.version}`),this.n.fire({identifier:$.identifier,profileLocation:c.profileLocation,applicationScoped:$.isApplicationScoped}),F},b=($,F)=>{F?c.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,c.profileLocation.toString(),F.message):this.v.error("Failed to uninstall extension:",`${$.identifier.id}@${$.manifest.version}`,F.message):c.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${$.identifier.id}@${$.manifest.version}`,c.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${$.identifier.id}@${$.manifest.version}`),i(this.u,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)($),error:F}),this.p.fire({identifier:$.identifier,error:F?.code,profileLocation:c.profileLocation,applicationScoped:$.isApplicationScoped})},U=[],N=[];try{U.push(w(s));const $=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const F=this.M(s,$);for(const L of F)this.k.has(a(L.identifier))?this.v.info("Extensions is already requested to uninstall",L.identifier.id):U.push(w(L))}c.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.J(U.map(F=>F.extension),$,s),await this.D(U.map(async F=>{try{if(await F.run(),await this.D(this.s.map(L=>L.postUninstall(F.extension,c,D.CancellationToken.None))),F.extension.identifier.uuid)try{await this.t.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}b(F.extension)}catch(L){const j=L instanceof E.ExtensionManagementError?L:new E.ExtensionManagementError((0,A.getErrorMessage)(L),E.ExtensionManagementErrorCode.Internal);throw b(F.extension,j),j}finally{N.push(F)}}))}catch($){const F=$ instanceof E.ExtensionManagementError?$:new E.ExtensionManagementError((0,A.getErrorMessage)($),E.ExtensionManagementErrorCode.Internal);for(const L of U){try{L.cancel()}catch{}N.includes(L)||b(L.extension,F)}throw F}finally{for(const $ of U)this.k.delete(a($.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",$.extension.identifier.id)}}J(s,o,c){for(const a of s){const u=this.N(a,o);if(u.length){const w=u.filter(b=>!s.some(U=>(0,p.areSameExtensions)(U.identifier,b.identifier)));if(w.length)throw new Error(this.L(a,w,c))}}}L(s,o,c){return c===s?o.length===1?C.localize(6,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(7,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(8,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?C.localize(9,null,c.manifest.displayName||c.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(10,null,c.manifest.displayName||c.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(11,null,c.manifest.displayName||c.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}M(s,o,c=[]){if(c.indexOf(s)!==-1)return[];c.push(s);const a=s.manifest.extensionPack?s.manifest.extensionPack:[];if(a.length){const u=o.filter(b=>!b.isBuiltin&&a.some(U=>(0,p.areSameExtensions)({id:U},b.identifier))),w=[];for(const b of u)w.push(...this.M(b,o,c));return[...u,...w]}return[]}N(s,o){return o.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(a=>(0,p.areSameExtensions)({id:a},s.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const s=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};m=pe([K(0,E.IExtensionGalleryService),K(1,f.ITelemetryService),K(2,h.ILogService),K(3,y.IProductService),K(4,l.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function v(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=v;function I(t){if(t instanceof E.ExtensionManagementError)return t;const s=new E.ExtensionManagementError(t.message,E.ExtensionManagementErrorCode.Internal);return s.stack=t.stack,s}function i(t,s,{extensionData:o,verificationStatus:c,duration:a,error:u,durationSinceUpdate:w}){let b,U;u&&(u instanceof E.ExtensionManagementError?(b=u.code,u.code===E.ExtensionManagementErrorCode.Signature&&(U=u.message)):b=E.ExtensionManagementErrorCode.Internal),t.publicLog(s,{...o,verificationStatus:c,success:!u,duration:a,errorcode:b,errorcodeDetail:U,durationSinceUpdate:w})}e.reportTelemetry=i;class r{constructor(){this.d=new n.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,n.createCancelablePromise)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,n.createCancelablePromise)(s=>new Promise((o,c)=>{const a=s.onCancellationRequested(()=>{a.dispose(),c(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(oe[51],ae([0,1,6,17,2,3,37,7,33,42,13,4,8,18,29,14,9,19]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class m extends Error{constructor(t,s){super(t),this.code=s}}e.ExtensionsProfileScanningError=m,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let v=class extends D.Disposable{constructor(t,s,o,c,a,u){super(),this.h=t,this.i=s,this.j=o,this.k=c,this.l=a,this.m=u,this.a=this.B(new A.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new A.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new T.ResourceMap}scanProfileExtensions(t,s){return this.n(t,void 0,s)}async addExtensionsToProfile(t,s){const o=[],c=[];try{return await this.n(s,a=>{const u=[];for(const w of a)t.some(([b])=>(0,P.areSameExtensions)(b.identifier,w.identifier)&&b.manifest.version!==w.version)?o.push(w):u.push(w);for(const[w,b]of t)if(!u.some(U=>(0,P.areSameExtensions)(U.identifier,w.identifier)&&U.version===w.manifest.version)){const U={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:b};c.push(U),u.push(U)}return c.length&&this.a.fire({extensions:c,profileLocation:s}),o.length&&this.c.fire({extensions:o,profileLocation:s}),u}),c.length&&this.b.fire({extensions:c,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),c}catch(a){throw c.length&&this.b.fire({extensions:c,error:a,profileLocation:s}),o.length&&this.f.fire({extensions:o,error:a,profileLocation:s}),a}}async removeExtensionFromProfile(t,s){const o=[];this.c.fire({extensions:o,profileLocation:s});try{await this.n(s,c=>{const a=[];for(const u of c)(0,P.areSameExtensions)(u.identifier,t.identifier)?o.push(u):a.push(u);return o.length&&this.c.fire({extensions:o,profileLocation:s}),a}),o.length&&this.f.fire({extensions:o,profileLocation:s})}catch(c){throw o.length&&this.f.fire({extensions:o,error:c,profileLocation:s}),c}}async n(t,s,o){return this.v(t).queue(async()=>{let c=[],a;try{const u=await this.i.readFile(t);a=JSON.parse(u.value.toString())}catch(u){if((0,C.toFileOperationResult)(u)!==1)throw u;if(this.k.extUri.isEqual(t,this.j.defaultProfile.extensionsResource)&&(a=await this.u()),!a&&o?.bailOutWhenFileNotFound)throw new m((0,f.getErrorMessage)(u),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.p(t);let u=!1;for(const w of a){I(w)||this.p(t);let b;if((0,y.isString)(w.location))b=this.s(w.location);else{b=R.URI.revive(w.location);const U=this.r(b);U&&(u=!0,w.location=U)}c.push({identifier:w.identifier,location:b,version:w.version,metadata:w.metadata})}u&&await this.i.writeFile(t,n.VSBuffer.fromString(JSON.stringify(a)))}if(s){c=s(c);const u=c.map(w=>({identifier:w.identifier,version:w.version,location:this.r(w.location)??w.location.toJSON(),metadata:w.metadata}));await this.i.writeFile(t,n.VSBuffer.fromString(JSON.stringify(u)))}return c})}p(t){const s=new m(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}r(t){return this.k.extUri.isEqualOrParent(t,this.h)?this.k.extUri.relativePath(this.h,t):void 0}s(t){return this.k.extUri.joinPath(this.h,t)}async u(){return this.t||(this.t=(async()=>{const t=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let s;try{s=(await this.i.readFile(t)).value.toString()}catch(c){if((0,C.toFileOperationResult)(c)===1)return;throw c}this.m.info("Migrating extensions from old default profile location",t.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(a=>I(a))?o=c:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.m.error(c)}if(o)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,n.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",t.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(c){if((0,C.toFileOperationResult)(c)===3)this.m.info("Migration from old default profile location to new location is done by another window",t.toString(),this.j.defaultProfile.extensionsResource.toString());else throw c}try{await this.i.del(t)}catch(c){(0,C.toFileOperationResult)(c)!==1&&this.m.error(c)}return o})()),this.t}v(t){let s=this.g.get(t);return s||(s=new k.Queue,this.g.set(t,s)),s}};v=pe([K(1,C.IFileService),K(2,g.IUserDataProfilesService),K(3,h.IUriIdentityService),K(4,l.ITelemetryService),K(5,p.ILogService)],v),e.AbstractExtensionsProfileScannerService=v;function I(r){return(0,y.isObject)(r)&&(0,S.isIExtensionIdentifier)(r.identifier)&&(i(r.location)||(0,y.isString)(r.location))&&r.version&&(0,y.isString)(r.version)}function i(r){return r?(0,y.isString)(r.path)&&(0,y.isString)(r.scheme):!1}}),define(oe[79],ae([0,1,21,6,32,17,9,35,137,2,24,12,5,22,54,88,14,7,158,15,33,42,70,13,4,8,25,3,67,51,18,29,188,189]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v,I,i,r,t,s,o,c,a,u,w,b,U,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var $;(function(Y){function H(q,G){if(q===G)return!0;const X=Object.keys(q),ee=new Set;for(const re of Object.keys(G))ee.add(re);if(X.length!==ee.size)return!1;for(const re of X){if(q[re]!==G[re])return!1;ee.delete(re)}return ee.size===0}Y.equals=H})($=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let F=class extends S.Disposable{constructor(H,q,G,X,ee,re,te,O,M,W,B,x){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=q,this.l=G,this.m=X,this.n=ee,this.p=re,this.r=te,this.s=O,this.t=M,this.u=W,this.v=B,this.w=x,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,g.joinPath)(this.m,I.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,g.joinPath)(this.m,I.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(j,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,v.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(H,q,G){const[X,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(q)]),re=G?await this.scanExtensionsUnderDevelopment(H,[...X,...ee]):[];return this.F(X,ee,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const q=[];q.push(this.G(!!H.useCache,H.language)),q.push(this.H(H.language,!!H.checkControlFile));const[G,X]=await Promise.all(q);return this.D([...G,...X],0,H,!1)}async scanUserExtensions(H){const q=H.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",q);const G=this.v.extUri.isEqual(H.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,X=await this.J(q,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,G),ee=H.useCache&&!X.devMode&&X.excludeObsolete?this.j:this.k;let re;try{re=await ee.scanExtensions(X)}catch(te){if(te instanceof u.ExtensionsProfileScanningError&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),re=await ee.scanExtensions(X);else throw te}return re=await this.D(re,1,H,!0),this.s.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(H,q){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const G=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(X=>X.scheme===C.Schemas.file).map(async X=>{const ee=await this.J(X,!1,1,!0,H.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ee)).map(te=>(te.type=q.find(O=>(0,v.areSameExtensions)(O.identifier,te.identifier))?.type??te.type,this.k.validate(te,ee)))}))).flat();return this.D(G,"development",H,!0)}return[]}async scanExistingExtension(H,q,G){const X=await this.J(H,!1,q,!0,G.language,!0,void 0),ee=await this.k.scanExtension(X);return!ee||!G.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,q,G){const X=await this.J(H,!1,q,!0,G.language,!0,void 0),ee=await this.k.scanOneOrMultipleExtensions(X);return this.D(ee,q,G,!0)}async scanMetadata(H){const q=(0,g.joinPath)(H,"package.json"),G=(await this.r.readFile(q)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(H,q){const G=(0,g.joinPath)(H,"package.json"),X=(await this.r.readFile(G)).value.toString(),ee=JSON.parse(X);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.installedTimestamp=q.installedTimestamp||void 0,ee.__metadata={...ee.__metadata,...q},await this.r.writeFile((0,g.joinPath)(H,"package.json"),A.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof u.ExtensionsProfileScanningError&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw H}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.p.addExtensionsToProfile(H.map(q=>[q,q.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(q){(0,r.toFileOperationResult)(q)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(q))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.s.error(H)}finally{this.z=void 0}})()),this.z}async D(H,q,G,X){return G.includeAllVersions||(H=this.F(q===0?H:void 0,q===1?H:void 0,q==="development"?H:void 0,await this.getTargetPlatform(),X)),G.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,re)=>{const te=E.basename(ee.location.fsPath),O=E.basename(re.location.fsPath);return te<O?-1:te>O?1:0})}F(H,q,G,X,ee){const re=(O,M,W)=>{if(O.isValid&&!M.isValid)return!1;if(O.isValid===M.isValid){if(ee&&h.gt(O.manifest.version,M.manifest.version))return this.s.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${O.location.path} with version ${O.manifest.version}`),!1;if(h.eq(O.manifest.version,M.manifest.version)){if(O.type===0)return this.s.debug(`Skipping extension ${M.location.path} in favour of system extension ${O.location.path} with same version`),!1;if(O.targetPlatform===X)return this.s.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${O.location.path} with ${M.location.path}.`):this.s.debug(`Overwriting user extension ${O.location.path} with ${M.location.path}.`),!0},te=new Map;return H?.forEach(O=>{const M=I.ExtensionIdentifier.toKey(O.identifier.id),W=te.get(M);(!W||re(W,O,!1))&&te.set(M,O)}),q?.forEach(O=>{const M=I.ExtensionIdentifier.toKey(O.identifier.id),W=te.get(M);if(!W&&H&&O.type===0){this.s.debug(`Skipping obsolete system extension ${O.location.path}.`);return}(!W||re(W,O,!1))&&te.set(M,O)}),G?.forEach(O=>{const M=I.ExtensionIdentifier.toKey(O.identifier.id),W=te.get(M);(!W||re(W,O,!0))&&te.set(M,O),te.set(M,O)}),[...te.values()]}async G(H,q){this.s.trace("Started scanning system extensions");const G=await this.J(this.systemExtensionsLocation,!1,0,!0,q,!0,void 0),ee=await(H&&!G.devMode?this.i:this.k).scanExtensions(G);return this.s.trace("Scanned system extensions:",ee.length),ee}async H(H,q){const G=this.t.isBuilt?[]:this.u.builtInExtensions;if(!G?.length)return[];this.s.trace("Started scanning dev system extensions");const X=q?await this.I():{},ee=[],re=l.URI.file(E.normalize(E.join(C.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const O of G){const M=X[O.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":ee.push((0,g.joinPath)(re,O.name));break;default:ee.push(l.URI.file(M));break}}const te=await Promise.all(ee.map(async O=>this.k.scanExtension(await this.J(O,!1,0,!0,H,!0,void 0))));return this.s.trace("Scanned dev system extensions:",te.length),(0,k.coalesce)(te)}async I(){try{const H=await this.r.readFile(this.l);return JSON.parse(H.value.toString())}catch{return{}}}async J(H,q,G,X,ee,re,te){const O=await this.f(ee??p.language),M=await this.L(H),W=q&&!this.v.extUri.isEqual(H,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,B=W?await this.L(W):void 0;return new L(H,M,W,B,q,te,G,X,re,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ee,O)}async L(H){try{const q=await this.r.stat(H);if(typeof q.mtime=="number")return q.mtime}catch{}}};F=pe([K(4,w.IUserDataProfilesService),K(5,u.IExtensionsProfileScannerService),K(6,r.IFileService),K(7,s.ILogService),K(8,m.IEnvironmentService),K(9,o.IProductService),K(10,b.IUriIdentityService),K(11,t.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class L{constructor(H,q,G,X,ee,re,te,O,M,W,B,x,ie,J,_){this.location=H,this.mtime=q,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=X,this.profile=ee,this.profileScanOptions=re,this.type=te,this.excludeObsolete=O,this.validate=M,this.productVersion=W,this.productDate=B,this.productCommit=x,this.devMode=ie,this.language=J,this.translations=_}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,q){return(0,g.isEqual)(H.location,q.location)&&H.mtime===q.mtime&&(0,g.isEqual)(H.applicationExtensionslocation,q.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&H.profile===q.profile&&H.profileScanOptions===q.profileScanOptions&&H.type===q.type&&H.excludeObsolete===q.excludeObsolete&&H.validate===q.validate&&H.productVersion===q.productVersion&&H.productDate===q.productDate&&H.productCommit===q.productCommit&&H.devMode===q.devMode&&H.language===q.language&&$.equals(H.translations,q.translations)}}let j=class extends S.Disposable{constructor(H,q,G,X,ee){super(),this.f=H,this.g=q,this.h=G,this.i=X,this.j=ee}async scanExtensions(H){const q=H.profile?await this.l(H):await this.k(H);let G={};if(H.excludeObsolete&&H.type===1)try{const X=(await this.i.readFile(this.f)).value.toString();G=JSON.parse(X)}catch{}return(0,f.isEmptyObject)(G)?q:q.filter(X=>!G[v.ExtensionKey.create(X).toString()])}async k(H){const q=await this.i.resolve(H.location);if(!q.children?.length)return[];const G=await Promise.all(q.children.map(async X=>{if(!X.isDirectory||H.type===1&&(0,g.basename)(X.resource).indexOf(".")===0)return null;const ee=new L(X.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,k.coalesce)(G).sort((X,ee)=>X.location.path<ee.location.path?-1:1)}async l(H){let q=await this.m(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){q=q.filter(X=>!X.metadata?.isApplicationScoped);const G=await this.m(H.applicationExtensionslocation,X=>!!X.metadata?.isApplicationScoped,H);q.push(...G)}return q}async m(H,q,G){const X=await this.g.scanProfileExtensions(H,G.profileScanOptions);if(!X.length)return[];const ee=await Promise.all(X.map(async re=>{if(q(re)){const te=new L(re.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(te,re.metadata)}return null}));return(0,k.coalesce)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.i.exists((0,g.joinPath)(H.location,"package.json"))){const q=await this.scanExtension(H);return q?[q]:[]}else return await this.scanExtensions(H)}catch(q){return this.j.error(`Error scanning extensions at ${H.location.path}:`,(0,T.getErrorMessage)(q)),[]}}async scanExtension(H,q){try{let G=await this.scanExtensionManifest(H.location);if(G){G.publisher||(G.publisher=I.UNDEFINED_PUBLISHER),q=q??G.__metadata,delete G.__metadata;const X=(0,v.getGalleryExtensionId)(G.publisher,G.name),ee=q?.id?{id:X,uuid:q.id}:{id:X},re=q?.isSystem?0:H.type,te=re===0||!!q?.isBuiltin;N.ImplicitActivationEvents.updateManifest(G),G=await this.n(H.location,G,L.createNlsConfiguration(H));const O={type:re,identifier:ee,manifest:G,location:H.location,isBuiltin:te,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return H.validate?this.validate(O,H):O}}catch(G){H.type!==0&&this.j.error(G)}return null}validate(H,q){let G=!0;const X=(0,i.validateExtensionManifest)(q.productVersion,q.productDate,q.location,H.manifest,H.isBuiltin);for(const[ee,re]of X)ee===y.default.Error&&(G=!1,this.j.error(this.t(q.location,re)));return H.isValid=G,H.validations=X,H}async scanExtensionManifest(H){const q=(0,g.joinPath)(H,"package.json");let G;try{G=(await this.i.readFile(q)).value.toString()}catch(ee){return(0,r.toFileOperationResult)(ee)!==1&&this.j.error(this.t(H,(0,d.localize)(0,null,q.path,ee.message))),null}let X;try{X=JSON.parse(G)}catch{const re=[];(0,R.parse)(G,re);for(const te of re)this.j.error(this.t(H,(0,d.localize)(1,null,q.path,te.offset,te.length,(0,P.getParseErrorMessage)(te.error))));return null}return(0,R.getNodeType)(X)!=="object"?(this.j.error(this.t(H,(0,d.localize)(2,null,q.path))),null):X}async n(H,q,G){const X=await this.p(H,q,G);if(X)try{const ee=[],re=await this.r(X.default,ee);if(ee.length>0)return ee.forEach(O=>{this.j.error(this.t(H,(0,d.localize)(3,null,X.default?.path,(0,P.getParseErrorMessage)(O.error))))}),q;if((0,R.getNodeType)(X)!=="object")return this.j.error(this.t(H,(0,d.localize)(4,null,X.default?.path))),q;const te=X.values||Object.create(null);return(0,U.localizeManifest)(q,te,re)}catch{}return q}async p(H,q,G){const X=(0,g.joinPath)(H,"package.nls.json"),ee=(M,W)=>{W.forEach(B=>{this.j.error(this.t(H,(0,d.localize)(5,null,M?.path,(0,P.getParseErrorMessage)(B.error))))})},re=M=>{this.j.error(this.t(H,(0,d.localize)(6,null,M?.path)))},te=`${q.publisher}.${q.name}`,O=G.translations[te];if(O)try{const M=l.URI.file(O),W=(await this.i.readFile(M)).value.toString(),B=[],x=(0,R.parse)(W,B);return B.length>0?(ee(M,B),{values:void 0,default:X}):(0,R.getNodeType)(x)!=="object"?(re(M),{values:void 0,default:X}):{values:x.contents?x.contents.package:void 0,default:X}}catch{return{values:void 0,default:X}}else{if(!await this.i.exists(X))return;let W;try{W=await this.s(H,G)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const B=(await this.i.readFile(W.localized)).value.toString(),x=[],ie=(0,R.parse)(B,x);return x.length>0?(ee(W.localized,x),{values:void 0,default:W.original}):(0,R.getNodeType)(ie)!=="object"?(re(W.localized),{values:void 0,default:W.original}):{values:ie,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(H,q){if(H)try{const G=(await this.i.readFile(H)).value.toString();return(0,R.parse)(G,q)}catch{}}s(H,q){return new Promise((G,X)=>{const ee=re=>{const te=(0,g.joinPath)(H,`package.nls.${re}.json`);this.i.exists(te).then(O=>{O&&G({localized:te,original:(0,g.joinPath)(H,"package.nls.json")});const M=re.lastIndexOf("-");M===-1?G({localized:(0,g.joinPath)(H,"package.nls.json"),original:null}):(re=re.substring(0,M),ee(re))})};if(q.devMode||q.pseudo||!q.language)return G({localized:(0,g.joinPath)(H,"package.nls.json"),original:null});ee(q.language)})}t(H,q){return`[${H.path}]: ${q}`}};j=pe([K(1,u.IExtensionsProfileScannerService),K(2,b.IUriIdentityService),K(3,r.IFileService),K(4,s.ILogService)],j);let z=class extends j{constructor(H,q,G,X,ee,re){super(q,G,X,ee,re),this.y=H,this.v=this.B(new n.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(H){const q=await this.z();if(this.u=H,q&&q.input&&L.equals(q.input,this.u))return this.v.trigger(()=>this.D()),q.result.map(X=>(X.location=l.URI.revive(X.location),X));const G=await super.scanExtensions(H);return await this.C({input:H,result:G}),G}async z(){try{const H=await this.i.readFile(this.y),q=JSON.parse(H.value.toString());return{result:q.result,input:(0,a.revive)(q.input)}}catch(H){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,T.getErrorMessage)(H))}return null}async C(H){try{await this.i.writeFile(this.y,A.VSBuffer.fromString(JSON.stringify(H)))}catch(q){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,T.getErrorMessage)(q))}}async D(){if(!this.u)return;const H=await this.z();if(!H)return;const q=H.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(G,q))try{await this.i.del(this.y),this.w.fire()}catch(X){this.j.error(X)}}};z=pe([K(2,u.IExtensionsProfileScannerService),K(3,b.IUriIdentityService),K(4,r.IFileService),K(5,s.ILogService)],z);function V(Y,H){const q=(0,v.getExtensionId)(Y.manifest.publisher,Y.manifest.name);return{id:q,identifier:new I.ExtensionIdentifier(q),isBuiltin:Y.type===0,isUserBuiltin:Y.type===1&&Y.isBuiltin,isUnderDevelopment:H,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,...Y.manifest}}e.toExtensionDescription=V;class Q extends F{constructor(H,q,G,X,ee,re,te,O,M,W,B,x){super(H,q,(0,g.joinPath)(G,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(X,I.MANIFEST_CACHE_FOLDER),ee,re,te,O,M,W,B,x),this.M=(async()=>{if(p.translationsConfigFile)try{const ie=await this.r.readFile(l.URI.file(p.translationsConfigFile));return JSON.parse(ie.value.toString())}catch{}return Object.create(null)})()}f(H){return this.M}}e.NativeExtensionsScannerService=Q}),define(oe[264],ae([0,1,8,18,29,19,51,13,15,7]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let C=class extends T.AbstractExtensionsProfileScannerService{constructor(p,g,h,y,f,l){super(S.URI.file(p.extensionsPath),g,h,y,f,l)}};C=pe([K(0,P.INativeEnvironmentService),K(1,R.IFileService),K(2,n.IUserDataProfilesService),K(3,D.IUriIdentityService),K(4,A.ITelemetryService),K(5,k.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(oe[265],ae([0,1,50,6,38,3,2,24,12,28,8,18]),function(Z,e,k,n,D,A,T,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends T.Disposable{constructor(h,y){super(),this.b=h,this.f=y,this.a=new n.Limiter(5)}async postUninstall(h){const y=this.g(h,"uninstall");return y&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(y.script,"uninstall",y.args,!0,h).then(()=>this.f.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),f=>this.f.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${f}`)))),S.Promises.rm(this.j(h)).then(void 0,f=>this.f.error("Error while removing extension storage path",f))}g(h,y){const f=`vscode:${y}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[f]=="string"){const l=h.manifest.scripts[f].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${f} should be a node script`),null):{script:(0,P.join)(h.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(h,y,f,l,d){return new Promise((m,v)=>{const I=this.i(h,y,f,d);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?v(t):m(void 0)};I.on("error",t=>{r((0,D.toErrorMessage)(t)||"Unknown")}),I.on("exit",(t,s)=>{r(t?`post-${y} process exited with code ${t}`:void 0)}),l&&(i=setTimeout(()=>{i=null,I.kill(),v("timed out")},5e3))})}i(h,y,f,l){const d={silent:!0,execArgv:void 0},m=(0,k.fork)(h,[`--type=extension-post-${y}`,...f],d);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const v=A.Event.fromNodeEventEmitter(m.stdout,"data"),I=A.Event.fromNodeEventEmitter(m.stderr,"data");v(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${y}`,t)),I(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${y}`,t));const i=A.Event.any(A.Event.map(v,t=>({data:`%c${t}`,format:[""]})),A.Event.map(I,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(i,(t,s)=>t?{data:t.data+s.data,format:[...t.format,...s.format]}:{data:s.data,format:s.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),m}j(h){return(0,P.join)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};p=pe([K(0,E.IUserDataProfilesService),K(1,C.ILogService)],p),e.ExtensionsLifecycle=p}),define(oe[266],ae([0,1,7,15,51,79,13,4,8,25,29,18]),function(Z,e,k,n,D,A,T,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends A.NativeExtensionsScannerService{constructor(h,y,f,l,d,m,v,I){super(k.URI.file(d.builtinExtensionsPath),k.URI.file(d.extensionsPath),d.userHome,k.URI.file(d.userDataPath),h,y,f,l,d,m,v,I)}};p=pe([K(0,E.IUserDataProfilesService),K(1,D.IExtensionsProfileScannerService),K(2,T.IFileService),K(3,P.ILogService),K(4,n.INativeEnvironmentService),K(5,S.IProductService),K(6,C.IUriIdentityService),K(7,R.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(oe[20],ae([0,1,6,3,2,207,14,69,4,18]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var C;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var p;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function g(d){const m=d.get(e.TARGET_KEY);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.loadKeyTargets=g;class h extends D.Disposable{constructor(m={flushInterval:h.a}){super(),this.j=m,this.b=this.B(new n.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new n.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new n.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new k.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,k.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(m,v){if(v===e.TARGET_KEY){switch(m){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:v,target:this.F(m)[v]})}r(m){this.f.fire({reason:m})}get(m,v,I){return this.L(v)?.get(m,I)}getBoolean(m,v,I){return this.L(v)?.getBoolean(m,I)}getNumber(m,v,I){return this.L(v)?.getNumber(m,I)}store(m,v,I,i){if((0,T.isUndefinedOrNull)(v)){this.remove(m,I);return}this.t(()=>{this.u(m,I,i),this.L(I)?.set(m,v)})}remove(m,v){this.t(()=>{this.u(m,v,void 0),this.L(v)?.delete(m)})}t(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,v){const I=[],i=this.F(m);for(const r of Object.keys(i))i[r]===v&&I.push(r);return I}u(m,v,I){const i=this.F(v);typeof I=="number"?i[m]!==I&&(i[m]=I,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[m]=="number"&&(delete i[m],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(m){switch(m){case-1:return this.D;case 0:return this.z;default:return this.w}}G(m){const v=this.L(m);return v?g(v):Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=C.NONE){this.f.fire({reason:m});const v=this.L(-1),I=this.L(0),i=this.L(1);switch(m){case C.NONE:await k.Promises.settled([v?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await k.Promises.settled([v?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,I=this.L(1)?.items??new Map;return l(m,v,I,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(m,v){return this.r(C.NONE),(0,S.isUserDataProfile)(m)?this.N(m,v):this.O(m,v)}H(m,v){return!(m.id===v.id||y(v)&&y(m))}I(m,v,I,i){this.t(()=>{if(i)for(const[r,t]of m)v.set(r,t);else{const r=new Set;for(const[t,s]of m)r.add(t),v.get(t)!==s&&this.n(I,t);for(const[t]of v.items)r.has(t)||this.n(I,t)}})}}e.AbstractStorageService=h,h.a=60*1e3;function y(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class f extends h{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(m=>this.n(1,m))),this.B(this.P.onDidChangeStorage(m=>this.n(0,m))),this.B(this.p.onDidChangeStorage(m=>this.n(-1,m)))}L(m){switch(m){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(m){return!1}}e.InMemoryStorageService=f;async function l(d,m,v,I,i,r){const t=N=>{try{return JSON.parse(N)}catch{return N}},s=new Map,o=new Map;d.forEach((N,$)=>{s.set($,N),o.set($,t(N))});const c=new Map,a=new Map;m.forEach((N,$)=>{c.set($,N),a.set($,t(N))});const u=new Map,w=new Map;v.forEach((N,$)=>{u.set($,N),w.set($,t(N))}),console.group(I!==i?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const b=[];if(s.forEach((N,$)=>{b.push({key:$,value:N})}),console.table(b),console.groupEnd(),console.log(o),I!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const N=[];c.forEach(($,F)=>{N.push({key:F,value:$})}),console.table(N),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const U=[];u.forEach((N,$)=>{U.push({key:$,value:N})}),console.table(U),console.groupEnd(),console.log(w)}e.logStorage=l}),define(oe[116],ae([0,1,3,2,14,30,33,20]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends n.Disposable{constructor(E,p){super(),this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(E)),this.B(this.b.onDidChange(g=>this.a.fire({extensions:g,source:"storage"}))),this.B(p.onDidInstallExtensions(g=>g.forEach(({local:h,operation:y})=>{h&&y===4&&this.f(h.identifier)})))}async enableExtension(E,p){return this.f(E)?(this.a.fire({extensions:[E],source:p}),!0):!1}async disableExtension(E,p){return this.c(E)?(this.a.fire({extensions:[E],source:p}),!0):!1}getDisabledExtensions(){return this.h(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const p=this.getDisabledExtensions();return p.every(g=>!(0,T.areSameExtensions)(g,E))?(p.push(E),this.g(p),!0):!1}f(E){const p=this.getDisabledExtensions();for(let g=0;g<p.length;g++){const h=p[g];if((0,T.areSameExtensions)(h,E))return p.splice(g,1),this.g(p),!0}return!1}g(E){this.i(A.DISABLED_EXTENSIONS_STORAGE_PATH,E)}h(E){return this.b.get(E,0)}i(E,p){this.b.set(E,p,0)}};P=pe([K(0,R.IStorageService),K(1,A.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class S extends n.Disposable{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new k.Emitter),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(p=>this.f(p)))}get(E,p){let g;return p===0?((0,D.isUndefinedOrNull)(this.a[E])&&(this.a[E]=this.g(E,p)),g=this.a[E]):g=this.g(E,p),JSON.parse(g)}set(E,p,g){const h=JSON.stringify(p.map(({id:f,uuid:l})=>({id:f,uuid:l})));this.g(E,g)!==h&&(g===0&&(p.length?this.a[E]=h:delete this.a[E]),this.h(E,p.length?h:void 0,g))}f(E){if(E.scope===0&&!(0,D.isUndefinedOrNull)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const g=this.get(E.key,E.scope);delete this.a[E.key];const h=this.get(E.key,E.scope),y=g.filter(l=>!h.some(d=>(0,T.areSameExtensions)(l,d))),f=h.filter(l=>!g.some(d=>(0,T.areSameExtensions)(d,l)));(y.length||f.length)&&this.b.fire([...y,...f])}}g(E,p){return this.c.get(E,p,"[]")}h(E,p,g){p?this.c.store(E,p,g,1):this.c.remove(E,g)}}e.StorageManager=S}),define(oe[267],ae([0,1,21,23,9,5,36,14,7,16,15,30,33,70,13,8,25,60,236,20,19]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const I=A.isWeb?"web":(0,E.getTargetPlatform)(A.platform,T.arch);var i;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function r(...O){return String(O.reduce((M,W)=>M|W,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class u{constructor(M=a){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,W=this.d.pageSize){return new u({...this.d,pageNumber:M,pageSize:W})}withFilter(M,...W){const B=[...this.d.criteria,...W.length?W.map(x=>({filterType:M,value:x})):[{filterType:M}]];return new u({...this.d,criteria:B})}withSortBy(M){return new u({...this.d,sortBy:M})}withSortOrder(M){return new u({...this.d,sortOrder:M})}withFlags(...M){return new u({...this.d,flags:M.reduce((W,B)=>W|B,0)})}withAssetTypes(...M){return new u({...this.d,assetTypes:M})}withSource(M){return new u({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:W,pageSize:B,sortBy:x,sortOrder:ie,flags:J,assetTypes:_}=this.d;return{filters:[{criteria:M,pageNumber:W,pageSize:B,sortBy:x,sortOrder:ie}],assetTypes:_,flags:J}}get searchText(){const M=this.d.criteria.filter(W=>W.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function w(O,M){const W=(O||[]).filter(B=>B.statisticName===M)[0];return W?W.value:0}function b(O){const M="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(B=>B.assetType.indexOf(M)===0).reduce((B,x)=>{const ie=$(O,x.assetType);return ie&&B.push([x.assetType.substring(M.length),ie]),B},[])}function U(O){if(O.properties){const M=O.properties.filter(x=>x.key===s.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=M.filter(x=>W.test(x.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return $(O,s.Repository)}function N(O){return{uri:`${O.fallbackAssetUri}/${s.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${s.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function $(O,M){return O.files.filter(B=>B.assetType===M)[0]?{uri:`${O.assetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function F(O,M){const W=O.properties?O.properties.filter(x=>x.key===M):[],B=W.length>0&&W[0].value;return B?B.split(",").map(x=>(0,p.adoptToGalleryExtensionId)(x)):[]}function L(O){const M=O.properties?O.properties.filter(W=>W.key===o.Engine):[];return M.length>0&&M[0].value||""}function j(O){const M=O.properties?O.properties.filter(W=>W.key===o.PreRelease):[];return M.length>0&&M[0].value==="true"}function z(O){const M=O.properties?O.properties.filter(B=>B.key===o.LocalizedLanguages):[],W=M.length>0&&M[0].value||"";return W?W.split(","):[]}function V(O){return O.properties?.find(M=>M.key===o.SponsorLink)?.value}function Q(O){return O.indexOf("preview")!==-1}function Y(O){return O.targetPlatform?(0,E.toTargetPlatform)(O.targetPlatform):"undefined"}function H(O){const M=(0,k.distinct)(O.versions.map(Y)),W=!!O.tags?.includes(E.WEB_EXTENSION_TAG),B=M.indexOf("web");return W?B===-1&&M.push("web"):B!==-1&&M.splice(B,1),M}function q(O,M){const W=(0,E.getFallbackTargetPlarforms)(M);for(let B=0;B<O.length;B++){const x=O[B];if(x.version===O[B-1]?.version){let ie=B;const J=Y(x);if(J===M)for(;ie>0&&O[ie-1].version===x.version;)ie--;else if(W.includes(J))for(;ie>0&&O[ie-1].version===x.version&&Y(O[ie-1])!==M;)ie--;ie!==B&&(O.splice(B,1),O.splice(ie,0,x))}}return O}e.sortExtensionVersions=q;function G(O,M,W){O.telemetryData={index:M,querySource:W}}function X(O,M,W){const B=O.versions[0],x={manifest:$(M,s.Manifest),readme:$(M,s.Details),changelog:$(M,s.Changelog),license:$(M,s.License),repository:U(M),download:N(M),icon:$(M,s.Icon),signature:$(M,s.Signature),coreTranslations:b(M)};return{identifier:{id:(0,p.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:M.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(B),description:O.shortDescription||"",installCount:w(O.statistics,"install"),rating:w(O.statistics,"averagerating"),ratingCount:w(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:W,assets:x,properties:{dependencies:F(M,o.Dependency),extensionPack:F(M,o.ExtensionPack),engine:L(M),localizedLanguages:z(M),targetPlatform:Y(M),isPreReleaseVersion:j(M)},hasPreReleaseVersion:j(B),hasReleaseVersion:!0,preview:Q(O.flags),isSigned:!!x.signature}}let ee=class{constructor(M,W,B,x,ie,J,_,se){this.k=W,this.l=B,this.n=x,this.o=ie,this.q=J,this.u=_,this.w=se;const ue=_.extensionsGallery,le=ue?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=le?ue.servicePPEUrl:ue?.serviceUrl,this.g=le?void 0:ue?.searchUrl,this.h=ue?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(_.version,_,this.n,this.w,this.q,M,this.o)}x(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,W,B){const x=n.CancellationToken.isCancellationToken(W)?{}:W,ie=n.CancellationToken.isCancellationToken(W)?W:B,J=[],_=[],se=[],ue=[];let le=!0;for(const be of M){be.uuid?_.push(be.uuid):J.push(be.id);const Ee=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&ue.push({id:be.id,uuid:be.uuid,version:be.version}),le=le&&!!be.hasPreRelease&&!Ee}if(!_.length&&!J.length)return[];let ye=new u().withPage(1,M.length);_.length&&(ye=ye.withFilter(t.ExtensionId,..._)),J.length&&(ye=ye.withFilter(t.ExtensionName,...J)),(x.queryAllVersions||le)&&(ye=ye.withFlags(ye.flags,i.IncludeVersions)),x.source&&(ye=ye.withSource(x.source));const{extensions:Se}=await this.z(ye,{targetPlatform:x.targetPlatform??I,includePreRelease:se,versions:ue,compatible:!!x.compatible},ie);return x.source&&Se.forEach((be,Ee)=>G(be,Ee,x.source)),Se}async getCompatibleExtension(M,W,B){if((0,E.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(M,W,B))return M;const x=new u().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:ie}=await this.z(x,{targetPlatform:B,compatible:!0,includePreRelease:W},n.CancellationToken.None);return ie[0]||null}async isExtensionCompatible(M,W,B){if(!(0,E.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,B)||!W&&M.properties.isPreReleaseVersion)return!1;let x=M.properties.engine;if(!x){const ie=await this.getManifest(M,n.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");x=ie.engines.vscode}return(0,g.isEngineValid)(x,this.u.version,this.u.date)}async y(M,W,B,x,ie){if(!(0,E.isTargetPlatformCompatible)(Y(M),x,ie)||W!=="any"&&j(M)!==(W==="prerelease"))return!1;if(B)try{const J=await this.E(M);if(!(0,g.isEngineValid)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,D.getErrorMessage)(J)),!1}return!0}async query(M,W){let B=M.text||"";const x=M.pageSize??50;let ie=new u().withPage(1,x);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ye,Se)=>(ie=ie.withFilter(t.Category,Se||ye),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ye,Se)=>(ie=ie.withFilter(t.Tag,Se||ye),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(t.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),ie=ie.withFilter(t.SearchText,B)),ie=ie.withSortBy(0)):M.ids?ie=ie.withFilter(t.ExtensionId,...M.ids):M.names?ie=ie.withFilter(t.ExtensionName,...M.names):ie=ie.withSortBy(4),typeof M.sortBy=="number"&&(ie=ie.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(ie=ie.withSortOrder(M.sortOrder)),M.source&&(ie=ie.withSource(M.source));const J=async(le,ye)=>{const{extensions:Se,total:be}=await this.z(le,{targetPlatform:I,compatible:!1,includePreRelease:!!M.includePreRelease},ye);return Se.forEach((Ee,Ne)=>G(Ee,(le.pageNumber-1)*le.pageSize+Ne,M.source)),{extensions:Se,total:be}},{extensions:_,total:se}=await J(ie,W),ue=async(le,ye)=>{if(ye.isCancellationRequested)throw new D.CancellationError;const{extensions:Se}=await J(ie.withPage(le+1),ye);return Se};return{firstPage:_,total:se,pageSize:ie.pageSize,getPage:ue}}async z(M,W,B){const x=M.flags;!!(M.flags&i.IncludeLatestVersionOnly)&&!!(M.flags&i.IncludeVersions)&&(M=M.withFlags(M.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(M.flags&i.IncludeLatestVersionOnly)&&!(M.flags&i.IncludeVersions)&&(M=M.withFlags(M.flags,i.IncludeLatestVersionOnly)),W.versions?.length&&(M=M.withFlags(M.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),M=M.withFlags(M.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ie,total:J}=await this.B(M,B);if(!(M.flags&i.IncludeLatestVersionOnly)){const le=[];for(const ye of ie){const Se=await this.A(ye,W);Se&&le.push(Se)}return{extensions:le,total:J}}const se=[],ue=new Map;for(let le=0;le<ie.length;le++){const ye=ie[le],Se={id:(0,p.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},be=(0,R.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Ne=>(0,p.areSameExtensions)(Ne,Se))?.includePreRelease;if(W.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(H(ye),W.targetPlatform))continue;const Ee=await this.A(ye,W);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==W.targetPlatform&&Ee.hasPreReleaseVersion?ue.set(ye.extensionId,le):se.push([le,Ee])}if(ue.size){const le=new Date().getTime(),ye=new u().withFlags(x&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:Se}=await this.z(ye,W,B);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ue.size});for(const be of Se){const Ee=ue.get(be.identifier.uuid);se.push([Ee,be])}}return{extensions:se.sort((le,ye)=>le[0]-ye[0]).map(([,le])=>le),total:J}}async A(M,W){const B={id:(0,p.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},x=W.versions?.find(se=>(0,p.areSameExtensions)(se,B))?.version,ie=(0,R.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(se=>(0,p.areSameExtensions)(se,B))?.includePreRelease,J=H(M),_=q(M.versions,W.targetPlatform);if(W.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(J,W.targetPlatform))return null;for(let se=0;se<_.length;se++){const ue=_[se];if(!(x&&ue.version!==x)){if(await this.y(ue,ie?"any":"release",W.compatible,J,W.targetPlatform))return X(M,ue,J);if(x&&ue.version===x)return null}}return x||W.compatible?null:X(M,M.versions[0],J)}async B(M,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(i.Unpublished));const B=await this.j,x=JSON.stringify(M.raw),ie={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},J=new Date().getTime();let _,se,ue=0;try{if(_=await this.k.request({type:"POST",url:this.g&&M.criteria.some(ye=>ye.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:x,headers:ie},W),_.res.statusCode&&_.res.statusCode>=400&&_.res.statusCode<500)return{galleryExtensions:[],total:ue};const le=await(0,l.asJson)(_);if(le){const ye=le.results[0],Se=ye.extensions,be=ye.resultMetadata&&ye.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ue=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:ue}}return{galleryExtensions:[],total:ue}}catch(le){throw se=le,le}finally{this.o.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(x.length),duration:new Date().getTime()-J,success:!!_&&(0,l.isSuccess)(_),responseBodySize:_?.res.headers["Content-Length"],statusCode:_?String(_.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(M,W,B,x){if(!this.isEnabled())return;const ie=A.isWeb?this.x(`/itemName/${M}.${W}/version/${B}/statType/${x==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${M}/extensions/${W}/${B}/stats?statType=${x}`),J=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:ie,headers:se},n.CancellationToken.None)}catch{}}async download(M,W,B){this.l.trace("ExtensionGalleryService#download",M.identifier.id);const x=(0,p.getGalleryExtensionTelemetryData)(M),ie=new Date().getTime(),J=le=>this.o.publicLog("galleryService:downloadVSIX",{...x,duration:le}),_=B===2?"install":B===3?"update":"",se=_?{uri:`${M.assets.download.uri}${P.URI.parse(M.assets.download.uri).query?"&":"?"}${_}=true`,fallbackUri:`${M.assets.download.fallbackUri}${P.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${_}=true`}:M.assets.download,ue=await this.D(se);await this.q.writeFile(W,ue.stream),J(new Date().getTime()-ie)}async downloadSignatureArchive(M,W){if(!M.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const B=await this.D(M.assets.signature);await this.q.writeFile(W,B.stream)}async getReadme(M,W){if(M.assets.readme){const B=await this.D(M.assets.readme,{},W);return await(0,l.asTextOrError)(B)||""}return""}async getManifest(M,W){if(M.assets.manifest){const B=await this.D(M.assets.manifest,{},W),x=await(0,l.asTextOrError)(B);return x?JSON.parse(x):null}return null}async C(M,W){const B=$(M,s.Manifest);if(!B)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},ie=await this.D(B,{headers:x});return await(0,l.asJson)(ie)}async getCoreTranslation(M,W){const B=M.assets.coreTranslations.filter(x=>x[0]===W.toUpperCase())[0];if(B){const x=await this.D(B[1]),ie=await(0,l.asTextOrError)(x);return ie?JSON.parse(ie):null}return null}async getChangelog(M,W){if(M.assets.changelog){const B=await this.D(M.assets.changelog,{},W);return await(0,l.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(M,W,B){let x=new u().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?x=x.withFilter(t.ExtensionId,M.identifier.uuid):x=x.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:ie}=await this.B(x,n.CancellationToken.None);if(!ie.length)return[];const J=H(ie[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(J,B))return[];const _=[];await Promise.all(ie[0].versions.map(async le=>{try{await this.y(le,W?"any":"release",!0,J,B)&&_.push(le)}catch{}}));const se=[],ue=new Set;for(const le of q(_,B))ue.has(le.version)||(ue.add(le.version),se.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:j(le)}));return se}async D(M,W={},B=n.CancellationToken.None){const x=await this.j,ie={type:"GET"},J={...x,...W.headers||{}};W={...W,...ie,headers:J};const _=M.uri,se=M.fallbackUri,ue={...W,url:_};try{const le=await this.k.request(ue,B);if(le.res.statusCode===200)return le;const ye=await(0,l.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ye}`)}catch(le){if((0,D.isCancellationError)(le))throw le;const ye=(0,D.getErrorMessage)(le);this.o.publicLog2("galleryService:cdnFallback",{url:_,message:ye});const Se={...W,url:se};return this.k.request(Se,B)}}async E(M){let W=L(M);if(!W){const B=await this.C(M,n.CancellationToken.None);if(!B)throw new Error("Manifest was not found");W=B.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const M=await this.k.request({type:"GET",url:this.h},n.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,l.asJson)(M),B=[],x={};if(W){for(const ie of W.malicious)B.push({id:ie});if(W.migrateToPreRelease)for(const[ie,J]of Object.entries(W.migrateToPreRelease))(!J.engine||(0,g.isEngineValid)(J.engine,this.u.version,this.u.date))&&(x[ie.toLowerCase()]={disallowInstall:!0,extension:{id:J.id,displayName:J.displayName,autoMigrate:{storage:!!J.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[ie,J]of Object.entries(W.deprecated))J&&(x[ie.toLowerCase()]=(0,R.isBoolean)(J)?{}:J)}return{malicious:B,deprecated:x}}};ee=pe([K(1,l.IRequestService),K(2,y.ILogService),K(3,C.IEnvironmentService),K(4,v.ITelemetryService),K(5,h.IFileService),K(6,f.IProductService),K(7,S.IConfigurationService)],ee);let re=class extends ee{constructor(M,W,B,x,ie,J,_,se){super(M,W,B,x,ie,J,_,se)}};re=pe([K(0,m.IStorageService),K(1,l.IRequestService),K(2,y.ILogService),K(3,C.IEnvironmentService),K(4,v.ITelemetryService),K(5,h.IFileService),K(6,f.IProductService),K(7,S.IConfigurationService)],re),e.ExtensionGalleryService=re;let te=class extends ee{constructor(M,W,B,x,ie,J,_){super(void 0,M,W,B,x,ie,J,_)}};te=pe([K(0,l.IRequestService),K(1,y.ILogService),K(2,C.IEnvironmentService),K(3,v.ITelemetryService),K(4,h.IFileService),K(5,f.IProductService),K(6,S.IConfigurationService)],te),e.ExtensionGalleryServiceWithNoStorageService=te}),define(oe[80],ae([0,1,4,3,2,20,33,25,21,8,14]),function(Z,e,k,n,D,A,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Ze extends D.Disposable{static b(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static c(h){const y=E.exec(h);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(h,y){const f=await h.getInstalled(),l=[];for(const[d,m]of Ze.f(y)){const v=f.find(I=>(0,T.areSameExtensions)(I.identifier,{id:d}))?.manifest.version;for(const I of m)v!==I&&l.push(Ze.b({id:d,version:I}))}for(const d of l)y.remove(d,0)}static f(h){const y=new Map,f=h.keys(0,1);for(const l of f){const d=Ze.c(l);if(d){let m=y.get(d.id.toLowerCase());m||y.set(d.id.toLowerCase(),m=[]),m.push(d.version)}}return y}constructor(h,y,f){super(),this.i=h,this.j=y,this.k=f,this.g=this.B(new n.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(h),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l(h){if(h.scope!==0)return;if(this.h.has(h.key.toLowerCase())){this.g.fire();return}const y=Ze.c(h.key);if(y){if(this.i.get(h.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let f=this.h.get(y.id.toLowerCase());f||this.h.set(y.id.toLowerCase(),f=[]),f.push(y.version),this.g.fire()}return}}m(h){if((0,C.isString)(h))return h;const y=h.manifest?h.manifest.publisher:h.publisher,f=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(y,f)}getExtensionState(h,y){const f=this.m(h),l=this.getExtensionStateRaw(h,y);if(l)try{return JSON.parse(l)}catch(d){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${y}): ${d}`)}}getExtensionStateRaw(h,y){const f=this.m(h),l=this.i.get(f,y?0:1);return l&&l?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${y}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(h,y,f){const l=this.m(h);y===void 0?this.i.remove(l,f?0:1):this.i.store(l,JSON.stringify(y),f?0:1,1)}setKeysForSync(h,y){this.i.store(Ze.b(h),JSON.stringify(y),0,1)}getKeysForSync(h){const y=this.j.extensionSyncedKeys?.[h.id.toLowerCase()],f=this.i.get(Ze.b(h),0),l=f?JSON.parse(f):void 0;return l&&y?(0,P.distinct)([...l,...y]):l||y}addToMigrationList(h,y){if(h!==y){const f=this.n.filter(l=>!l.includes(h)&&!l.includes(y));f.push([h,y]),this.n=f}}getSourceExtensionToMigrate(h){const y=this.n.find(([,f])=>h===f);return y?y[0]:void 0}get n(){const h=this.i.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(h);if(Array.isArray(y))return y}catch{}return[]}set n(h){h.length?this.i.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};p.a=512*1024,p=pe([K(0,A.IStorageService),K(1,R.IProductService),K(2,S.ILogService)],p),e.ExtensionStorageService=p}),define(oe[268],ae([0,1,21,6,3,12,5,36,7,159,15,30,33,212,98,13,58,25,20,19]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const v="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";let i=class extends g.ExtensionTipsService{constructor(t,s,o,c,a,u,w,b){super(w,b),this.m=t,this.n=s,this.p=o,this.r=c,this.s=a,this.t=u,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,b.exeBasedExtensionTips&&Object.entries(b.exeBasedExtensionTips).forEach(([U,N])=>{const $=[],F=[],L=[];Object.entries(N.recommendations).forEach(([j,z])=>{z.important?N.important?$.push({extensionId:j,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):F.push({extensionId:j,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):L.push({extensionId:j,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),$.length&&this.g.set(U,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:$}),F.length&&this.h.set(U,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:F}),L.length&&this.j.set(U,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:L})}),(0,n.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),s=await this.I(this.h);return[...t,...s]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),s=await this.I(this.h),o=await this.p.getInstalled();this.k=this.v(t,o),this.l=this.v(s,o)}v(t,s){const o=new Map;t.forEach(b=>o.set(b.extensionId.toLowerCase(),b));const{installed:c,uninstalled:a}=this.H([...o.keys()],s);for(const b of c){const U=o.get(b);U&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:b,exeName:U.exeName})}for(const b of a){const U=o.get(b);U&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:b,exeName:U.exeName})}const u=this.F(),w=new Map;for(const b of a){const U=o.get(b);if(U&&(!u[U.exeName]||!u[U.exeName].includes(U.extensionId))){let N=w.get(U.exeName);N||(N=[],w.set(U.exeName,N)),N.push(U)}}return w}w(){if(this.k.size===0)return;const[t,s]=[...this.k.entries()][0];this.z(s).then(o=>{switch(o){case"reacted":this.G(s[0].exeName,s);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const c=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(c(()=>this.w()));break}case"toomany":{const c=this.B((0,n.disposableTimeout)(()=>{c.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),s=Date.now()-t,o=7*24*60*60*1e3;if(s<o){const u=this.B((0,n.disposableTimeout)(()=>{u.dispose(),this.y()},o-s));return}const[c,a]=[...this.l.entries()][0];this.z(a).then(u=>{switch(u){case"reacted":{this.D(Date.now()),this.l.delete(c),this.G(a[0].exeName,a);const w=this.B((0,n.disposableTimeout)(()=>{w.dispose(),this.y()},o));break}case"ignored":this.l.delete(c),this.y();break;case"incompatibleWindow":{const w=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(w(()=>this.y()));break}case"toomany":{const w=this.B((0,n.disposableTimeout)(()=>{w.dispose(),this.y()},36e5));break}}})}async z(t){const s=await this.p.getInstalled(1),o=t.filter(a=>!a.whenNotInstalled||a.whenNotInstalled.every(u=>s.every(w=>!(0,p.areSameExtensions)(w.identifier,{id:u})))).map(({extensionId:a})=>a.toLowerCase()),c=(0,S.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(o,c,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(I,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(I,t,-1,1)}F(){return JSON.parse(this.r.get(v,-1,"{}"))}G(t,s){const o=this.F();o[t]=s.map(({extensionId:c})=>c.toLowerCase()),this.r.store(v,JSON.stringify(o),-1,0)}H(t,s){const o=[],c=[],a=s.reduce((u,w)=>(u.add(w.identifier.id.toLowerCase()),u),new Set);return t.forEach(u=>{a.has(u.toLowerCase())?o.push(u):c.push(u)}),{installed:o,uninstalled:c}}async I(t){const s=[],o=new Map;for(const c of t.keys()){const a=t.get(c);if(!a||!(0,k.isNonEmptyArray)(a.recommendations))continue;const u=[];T.isWindows?a.windowsPath&&u.push(a.windowsPath.replace("%USERPROFILE%",()=>R.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>R.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>R.env.ProgramFiles).replace("%APPDATA%",()=>R.env.APPDATA).replace("%WINDIR%",()=>R.env.WINDIR)):(u.push((0,A.join)("/usr/local/bin",c)),u.push((0,A.join)("/usr/bin",c)),u.push((0,A.join)(this.m.userHome.fsPath,c)));for(const w of u){let b=o.get(w);if(b===void 0&&(b=await this.b.exists(P.URI.file(w)),o.set(w,b)),b)for(const{extensionId:U,extensionName:N,isExtensionPack:$,whenNotInstalled:F}of a.recommendations)s.push({extensionId:U,extensionName:N,isExtensionPack:$,exeName:c,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:F})}}return s}};i=pe([K(0,C.INativeEnvironmentService),K(1,m.ITelemetryService),K(2,E.IExtensionManagementService),K(3,d.IStorageService),K(4,f.INativeHostService),K(5,h.IExtensionRecommendationNotificationService),K(6,y.IFileService),K(7,l.IProductService)],i),e.ExtensionTipsService=i}),define(oe[269],ae([0,1,6,2,22,69,20,76,18]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends T.AbstractStorageService{constructor(E,p,g,h){super(),this.X=E,this.Y=p,this.Z=g,this.ab=h,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new n.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new n.DisposableStore),this.W=this.db(this.X)}bb(){const E=this.B(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),p=this.B(new A.Storage(E));return this.B(p.onDidChangeStorage(g=>this.n(-1,g))),p}cb(E){this.Q.clear(),this.P=E;let p;if((0,T.isProfileUsingDefaultStorage)(E))p=this.s;else{const g=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),E));p=this.Q.add(new A.Storage(g))}return this.Q.add(p.onDidChangeStorage(g=>this.n(0,g))),p}db(E){this.U.clear(),this.S=E?.id;let p;if(E){const g=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),E));p=this.U.add(new A.Storage(g)),this.U.add(p.onDidChangeStorage(h=>this.n(1,h)))}return p}async J(){await k.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(E){switch(E){case-1:return this.s;case 0:return this.R;default:return this.W}}M(E){switch(E){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(T.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(E,p){if(!this.H(this.P,E))return;const g=this.R,h=g.items;g!==this.s&&await g.close(),this.R=this.cb(E),await this.R.init(),this.I(h,this.R,0,p)}async O(E,p){const g=this.W,h=g?.items??new Map;await g?.close(),this.W=this.db(E),await this.W.init(),this.I(h,this.W,1,p)}hasScope(E){return(0,P.isUserDataProfile)(E)?this.P.id===E.id:this.S===E.id}}e.NativeStorageService=S}),define(oe[62],ae([0,1,2,69,4,20]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,D.createDecorator)("IUserDataProfileStorageService");let T=class extends k.Disposable{constructor(S){super(),this.a=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async C=>this.b(C))}async updateStorageData(S,C,E){return this.withProfileScopedStorageService(S,async p=>this.c(p,C,E))}async withProfileScopedStorageService(S,C){if(this.a.hasScope(S))return C(this.a);const E=await this.createStorageDatabase(S),p=new R(E);try{await p.initialize();const g=await C(p);return await p.flush(),g}finally{p.dispose(),await this.f(E)}}b(S){const C=new Map,E=p=>{for(const g of S.keys(0,p))C.set(g,{value:S.get(g,0),target:p})};return E(0),E(1),C}c(S,C,E){for(const[p,g]of C)S.store(p,g,0,E)}async f(S){try{await S.close()}finally{(0,k.isDisposable)(S)&&S.dispose()}}};T=pe([K(0,A.IStorageService)],T),e.AbstractUserDataProfileStorageService=T;class R extends A.AbstractStorageService{constructor(S){super({flushInterval:100}),this.p=this.B(new n.Storage(S))}J(){return this.p.init()}L(S){return S===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[270],ae([0,1,3,2,22,15,57,18]),function(Z,e,k,n,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(C,E,p){super(),this.b=[],this.c=this.B(new k.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=E.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(p.userRoamingDataHome,"profiles"),this.b=C.map(g=>(0,R.reviveProfile)(g,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(g=>{const h=g.added.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),y=g.removed.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),f=g.updated.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme));this.b=g.all.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),this.c.fire({added:h,removed:y,updated:f,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(C){this.f=C}isEnabled(){return this.f}async createNamedProfile(C,E,p){const g=await this.a.call("createNamedProfile",[C,E,p]);return(0,R.reviveProfile)(g,this.profilesHome.scheme)}async createProfile(C,E,p,g){const h=await this.a.call("createProfile",[C,E,p,g]);return(0,R.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(C){const E=await this.a.call("createTransientProfile",[C]);return(0,R.reviveProfile)(E,this.profilesHome.scheme)}async setProfileForWorkspace(C,E){await this.a.call("setProfileForWorkspace",[C,E])}removeProfile(C){return this.a.call("removeProfile",[C])}async updateProfile(C,E){const p=await this.a.call("updateProfile",[C,E]);return(0,R.reviveProfile)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};P=pe([K(1,T.IMainProcessService),K(2,A.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(oe[271],ae([0,1,3,2,57,8,62,20,76,18,71]),function(Z,e,k,n,D,A,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let E=class extends T.AbstractUserDataProfileStorageService{constructor(g,h,y,f){super(y),this.h=g;const l=g.getChannel("profileStorageListener"),d=this.B(new n.MutableDisposable);this.g=this.B(new k.Emitter({onWillAddFirstListener:()=>{d.value=l.listen("onDidChange")(m=>{f.trace("profile storage changes",m),this.g.fire({targetChanges:m.targetChanges.map(v=>(0,S.reviveProfile)(v,h.profilesHome.scheme)),valueChanges:m.valueChanges.map(v=>({...v,profile:(0,S.reviveProfile)(v.profile,h.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(g){const h=this.h.getChannel("storage");return(0,R.isProfileUsingDefaultStorage)(g)?new P.ApplicationStorageDatabaseClient(h):new P.ProfileStorageDatabaseClient(h,g)}};E=pe([K(0,D.IMainProcessService),K(1,S.IUserDataProfilesService),K(2,R.IStorageService),K(3,A.ILogService)],E),e.UserDataProfileStorageService=E,(0,C.registerSingleton)(T.IUserDataProfileStorageService,E,1)}),define(oe[41],ae([0,1,21,6,17,23,3,35,2,27,14,175,16,15,13,8,45,20,19,29,26,18]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||r(u.syncData)))}e.isRemoteUserData=i;function r(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=r;function t(u,w){return`${(0,S.uppercaseFirstLetter)(u)}${w.isDefault?"":` (${w.name})`}`}e.getSyncResourceLogLabel=t;let s=class extends P.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(w,b,U,N,$,F,L,j,z,V,Q,Y){super(),this.syncResource=w,this.collection=b,this.C=U,this.D=N,this.F=$,this.G=F,this.H=L,this.I=j,this.J=z,this.L=V,this.M=Q,this.c=null,this.k="idle",this.l=this.B(new T.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new T.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new n.ThrottledDelayer(50),this.t=this.B(new T.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(w.syncResource,w.profile),this.h=Y.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,v.getPathSegments)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,v.PREVIEW_DIR_NAME),this.u=(0,v.getLastSyncResourceUri)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,N,this.h),this.j=(0,f.getServiceMachineId)(N,U,$)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const b=await this.S(w.remoteUserData,w.lastSyncUserData,!0,this.lb());this.O(b)}else{this.L.trace(`${this.y}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.rb(w):!0)&&this.t.fire()}}O(w){this.k!==w&&(this.k=w,this.l.fire(w))}async sync(w,b={}){await this.P(w,!0,this.lb(),b)}async preview(w,b,U={}){return this.P(w,!1,b,U)}async apply(w,b={}){try{this.z={...b};const U=await this.X(w);return this.O(U),this.c}finally{this.z={}}}async P(w,b,U,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let $="idle";try{const F=await this.getLastSyncUserData(),L=await this.R(w,F);return $=await this.S(L,F,b,U),$==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):$==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O($)}}finally{this.z={}}}async replace(w){const b=this.hb(w);if(!b)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const U=await this.getLastSyncUserData(),N=await this.R(null,U),$=await this.Q(N),F=await this.nb({ref:N.ref,syncData:b},U,$,this.lb(),A.CancellationToken.None),L=[];for(const j of F){const z=await this.pb(j,j.remoteResource,void 0,A.CancellationToken.None),{remoteChange:V}=await this.pb(j,j.previewResource,j.remoteContent,A.CancellationToken.None);L.push([j,{...z,remoteChange:V!==0?V:2}])}await this.qb(N,U,L,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(w){const b=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===b}async R(w,b){if(b){const U=w?w[this.resource]:void 0;if(b.ref===U||U===void 0&&b.syncData===null)return b}return this.getRemoteUserData(b)}async S(w,b,U,N){if(w.syncData&&w.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new v.UserDataSyncError((0,E.localize)(0,null,this.resource,this.mb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(w,b,U,N)}catch($){if($ instanceof v.UserDataSyncError)switch($.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(w,b,U,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),b=await this.getLastSyncUserData(),this.S(w,b,U,N)}throw $}}async U(w,b,U,N){try{const $=await this.Q(w),F=!$&&b===null&&this.db()!==void 0,L=U&&!F;this.c||(this.c=(0,n.createCancelablePromise)(z=>this.bb(w,b,$,L,N,z)));let j=await this.c;if(U&&F){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of j.resourcePreviews)j=await this.accept(z.remoteResource)||j}return this.Z(j.resourcePreviews),j.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":U?await this.X(!1):"syncing"}catch($){throw this.c=null,$}}async merge(w){return await this.W(w,async b=>{const U=await this.ob(b,A.CancellationToken.None);await this.C.writeFile(b.previewResource,D.VSBuffer.fromString(U?.content||""));const N=U&&!U.hasConflicts?await this.pb(b,b.previewResource,void 0,A.CancellationToken.None):void 0;return b.acceptResult=N,b.mergeState=U.hasConflicts?"conflict":N?"accepted":"preview",b.localChange=N?N.localChange:U.localChange,b.remoteChange=N?N.remoteChange:U.remoteChange,b}),this.c}async accept(w,b){return await this.W(w,async U=>{const N=await this.pb(U,w,b,A.CancellationToken.None);return U.acceptResult=N,U.mergeState="accepted",U.localChange=N.localChange,U.remoteChange=N.remoteChange,U}),this.c}async discard(w){return await this.W(w,async b=>{const U=await this.ob(b,A.CancellationToken.None);return await this.C.writeFile(b.previewResource,D.VSBuffer.fromString(U.content||"")),b.acceptResult=void 0,b.mergeState="preview",b.localChange=U.localChange,b.remoteChange=U.remoteChange,b}),this.c}async W(w,b){if(!this.c)return;let U=await this.c;const N=U.resourcePreviews.findIndex(({localResource:$,remoteResource:F,previewResource:L})=>this.h.isEqual($,w)||this.h.isEqual(F,w)||this.h.isEqual(L,w));N!==-1&&(this.c=(0,n.createCancelablePromise)(async $=>{const F=[...U.resourcePreviews];return F[N]=await b(F[N]),{...U,resourcePreviews:F}}),U=await this.c,this.Z(U.resourcePreviews),U.resourcePreviews.some(({mergeState:$})=>$==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(w){if(!this.c)return"idle";const b=await this.c;return b.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":b.resourcePreviews.some(({mergeState:U})=>U!=="accepted")?"syncing":(await this.qb(b.remoteUserData,b.lastSyncUserData,b.resourcePreviews.map(U=>[U,U.acceptResult]),w),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(w){const b=w.filter(({mergeState:U})=>U==="conflict");(0,k.equals)(this.m,b,(U,N)=>this.h.isEqual(U.previewResource,N.previewResource))||(this.m=b,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async ab(w){const b=this.c?await this.c:null;if(b)for(const U of b.resourcePreviews){if(this.h.isEqual(U.acceptedResource,w))return U.acceptResult?U.acceptResult.content:null;if(this.h.isEqual(U.remoteResource,w))return U.remoteContent;if(this.h.isEqual(U.localResource,w))return U.localContent;if(this.h.isEqual(U.baseResource,w))return U.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(w){(0,h.toFileOperationResult)(w)!==1&&this.L.error(w)}}async bb(w,b,U,N,$,F){const L=await this.nb(w,b,U,$,F),j=[];for(const z of L){const V=z.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)j.push({...z,acceptedResource:V,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=N?await this.ob(z,F):void 0;if(F.isCancellationRequested)break;await this.C.writeFile(z.previewResource,D.VSBuffer.fromString(Q?.content||""));const Y=Q&&!Q.hasConflicts?await this.pb(z,z.previewResource,void 0,F):void 0;j.push({...z,acceptResult:Y,mergeState:Q?.hasConflicts?"conflict":Y?"accepted":"preview",localChange:Y?Y.localChange:Q?Q.localChange:z.localChange,remoteChange:Y?Y.remoteChange:Q?Q.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:b,resourcePreviews:j,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){let w=this.db();if(w||(w=await this.gb()),!w)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const b=JSON.parse(w),U=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!b.version&&!!U&&b.version!==U,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${b.version} is not compatible with current sync state version ${U}.`),await this.resetLocal(),null;let N,$=1;for(;N===void 0&&$++<6;)try{const F=await this.eb();F&&(F.ref===b.ref?N=F.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof h.FileOperationError&&F.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof v.UserDataSyncError)throw F;this.L.error(F,$)}}if(N===void 0)try{const F=await this.G.resolveResourceContent(this.resource,b.ref,this.collection,this.z);N=F===null?null:this.hb(F),await this.fb({ref:b.ref,syncData:N})}catch(F){if(F instanceof v.UserDataSyncError&&F.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw F}return N===void 0?null:{...b,syncData:N}}async cb(w,b={}){if(b.ref||b.version)throw new Error("Cannot have core properties as additional");const U=this.I.getResourceSyncStateVersion(this.resource),N={ref:w.ref,version:U,...b};this.F.store(this.v,JSON.stringify(N),-1,1),await this.fb(w)}db(){return this.F.get(this.v,-1)}async eb(){const w=(await this.C.readFile(this.u)).value.toString();try{const b=w?JSON.parse(w):void 0;if(i(b))return b}catch(b){this.L.error(b)}}async fb(w){await this.C.writeFile(this.u,D.VSBuffer.fromString(JSON.stringify(w)))}async gb(){try{const w=await this.C.readFile(this.u),b=JSON.parse(w.value.toString());await this.C.del(this.u),b.ref&&b.content!==void 0&&(this.F.store(this.v,JSON.stringify({...b,content:void 0}),-1,1),await this.fb({ref:b.ref,syncData:b.content===null?null:JSON.parse(b.content)}))}catch(w){w instanceof h.FileOperationError&&w.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(w)}return this.F.get(this.v,-1)}async getRemoteUserData(w){const{ref:b,content:U}=await this.ib(w);let N=null;return U!==null&&(N=this.hb(U)),{ref:b,syncData:N}}hb(w){try{const b=JSON.parse(w);if(r(b))return b}catch(b){this.L.error(b)}throw new v.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(w){const b=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.G.readResource(this.resource,b,this.collection,this.z)}async jb(w,b){const U=await this.j,N={version:this.mb,machineId:U,content:w};try{return b=await this.G.writeResource(this.resource,JSON.stringify(N),b,this.collection,this.z),{ref:b,syncData:N}}catch($){throw $ instanceof v.UserDataSyncError&&$.code==="TooLarge"&&($=new v.UserDataSyncError($.message,$.code,this.resource)),$}}async kb(w){const b={version:this.mb,content:w};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(b))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};s=pe([K(2,h.IFileService),K(3,g.IEnvironmentService),K(4,l.IStorageService),K(5,v.IUserDataSyncStoreService),K(6,v.IUserDataSyncBackupStoreService),K(7,v.IUserDataSyncEnablementService),K(8,d.ITelemetryService),K(9,v.IUserDataSyncLogService),K(10,p.IConfigurationService),K(11,m.IUriIdentityService)],s),e.AbstractSynchroniser=s;let o=class extends s{constructor(w,b,U,N,$,F,L,j,z,V,Q,Y,H){super(b,U,N,$,F,L,j,z,V,Q,Y,H),this.i=w,this.B(this.C.watch(this.h.dirname(w))),this.B(this.C.onDidFilesChange(q=>this.tb(q)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(w,b,U){try{b?await this.C.writeFile(this.i,D.VSBuffer.fromString(w),U?void 0:b):await this.C.createFile(this.i,D.VSBuffer.fromString(w),{overwrite:U})}catch(N){throw N instanceof h.FileOperationError&&N.fileOperationResult===1||N instanceof h.FileOperationError&&N.fileOperationResult===3?new v.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}async sb(){try{await this.C.del(this.i)}catch(w){if(!(w instanceof h.FileOperationError&&w.fileOperationResult===1))throw w}}tb(w){!w.contains(this.i)||this.triggerLocalChange()}};o=pe([K(3,h.IFileService),K(4,g.IEnvironmentService),K(5,l.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncBackupStoreService),K(8,v.IUserDataSyncEnablementService),K(9,d.ITelemetryService),K(10,v.IUserDataSyncLogService),K(11,p.IConfigurationService),K(12,m.IUriIdentityService)],o),e.AbstractFileSynchroniser=o;let c=class extends o{constructor(w,b,U,N,$,F,L,j,z,V,Q,Y,H,q){super(w,b,U,N,$,F,L,j,z,V,Q,H,q),this.ub=Y,this.wb=void 0}vb(w,b){const U=[],N=(0,R.parse)(w,U,{allowEmptyContent:!0,allowTrailingComma:!0});return U.length>0||!(0,C.isUndefined)(N)&&b!==Array.isArray(N)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};c=pe([K(3,h.IFileService),K(4,g.IEnvironmentService),K(5,l.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncBackupStoreService),K(8,v.IUserDataSyncEnablementService),K(9,d.ITelemetryService),K(10,v.IUserDataSyncLogService),K(11,v.IUserDataSyncUtilService),K(12,p.IConfigurationService),K(13,m.IUriIdentityService)],c),e.AbstractJsonFileSynchroniser=c;let a=class{constructor(w,b,U,N,$,F,L){this.resource=w,this.g=b,this.h=U,this.j=N,this.k=$,this.l=F,this.d=L.extUri,this.f=(0,v.getLastSyncResourceUri)(void 0,this.resource,U,this.d)}async initialize({ref:w,content:b}){if(!b){this.j.info("Remote content does not exist.",this.resource);return}const U=this.m(b);if(!!U)try{await this.doInitialize({ref:w,syncData:U})}catch(N){this.j.error(N)}}m(w){try{const b=JSON.parse(w);if(r(b))return b}catch(b){this.j.error(b)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,b={}){if(b.ref||b.version)throw new Error("Cannot have core properties as additional");const U={ref:w.ref,version:void 0,...b};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(U),-1,1),await this.k.writeFile(this.f,D.VSBuffer.fromString(JSON.stringify(w)))}};a=pe([K(1,I.IUserDataProfilesService),K(2,g.IEnvironmentService),K(3,y.ILogService),K(4,h.IFileService),K(5,l.IStorageService),K(6,m.IUriIdentityService)],a),e.AbstractInitializer=a}),define(oe[117],ae([0,1,6,23,9,3,43,2,27,16,15,116,30,33,80,13,4,72,8,20,19,29,18,41,253,114,26,62]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v,I,i,r,t,s,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a($,F){const L=JSON.parse($.content);if($.version===1||$.version===2){const j=(await F.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of L)$.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),$.version===2&&j.every(V=>!(0,g.areSameExtensions)(V.identifier,z.identifier))&&(z.installed=!0)}return L}function u($){return JSON.parse($.content)}e.parseExtensions=u;function w($,F){return $.sort((L,j)=>!L.identifier.uuid&&j.identifier.uuid?-1:L.identifier.uuid&&!j.identifier.uuid?1:(0,P.compare)(L.identifier.id,j.identifier.id)),F?(0,T.toFormattedString)($,{}):JSON.stringify($)}e.stringify=w;let b=class extends r.AbstractSynchroniser{constructor(F,L,j,z,V,Q,Y,H,q,G,X,ee,re,te,O,M,W){super({syncResource:"extensions",profile:F},L,z,j,V,Q,Y,ee,re,G,X,O),this.yb=H,this.zb=q,this.Ab=W,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(U),this.B(A.Event.any(A.Event.filter(this.yb.onDidInstallExtensions,B=>B.some(({local:x})=>!!x)),A.Event.filter(this.yb.onDidUninstallExtension,B=>!B.error),A.Event.filter(M.onDidChange,B=>B.valueChanges.some(({profile:x,changes:ie})=>this.syncResource.profile.id===x.id&&ie.some(J=>J.key===p.DISABLED_EXTENSIONS_STORAGE_PATH))),te.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(F,L){const j=F.syncData?await a(F.syncData,this.yb):null,z=L?.skippedExtensions||[],V=L?.builtinExtensions||[],Q=L?.syncData?await a(L.syncData,this.yb):null,{localExtensions:Y,ignoredExtensions:H}=await this.xb.getLocalExtensions(this.syncResource.profile);j?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:G}=(0,t.merge)(Y,j,Q,z,H,V),X={local:q,remote:G,content:this.Db(Y,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:G!==null?2:0},ee=this.Jb(Y,!1);return[{skippedExtensions:z,builtinExtensions:V,baseResource:this.tb,baseContent:Q?this.Jb(Q,!1):ee,localResource:this.ub,localContent:ee,localExtensions:Y,remoteResource:this.vb,remoteExtensions:j,remoteContent:j?this.Jb(j,!1):null,previewResource:this.sb,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.wb}]}async rb(F){const L=F.syncData?await a(F.syncData,this.yb):null,{localExtensions:j,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:V}=(0,t.merge)(j,L,L,F.skippedExtensions||[],z,F.builtinExtensions||[]);return V!==null}Db(F,L,j,z){const V=[...L,...j],Q=new Set,Y=H=>{Q.add(H.id.toLowerCase()),H.uuid&&Q.add(H.uuid)};V.forEach(({identifier:H})=>Y(H)),z.forEach(Y);for(const H of F)Q.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&Q.has(H.identifier.uuid)||V.push(H);return this.Jb(V,!1)}async ob(F,L){return{...F.previewResult,hasConflicts:!1}}async pb(F,L,j,z){if(this.h.isEqual(L,this.ub))return this.Gb(F);if(this.h.isEqual(L,this.vb))return this.Hb(F);if(this.h.isEqual(L,this.sb))return F.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb(F){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),j=this.zb.getIgnoredExtensions(L),z=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,j,F.builtinExtensions),{local:V,remote:Q}=z;return{content:F.localContent,local:V,remote:Q,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:Q!==null?2:0}}async Hb(F){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),j=this.zb.getIgnoredExtensions(L),z=F.remoteContent?JSON.parse(F.remoteContent):null;if(z!==null){const V=(0,t.merge)(F.localExtensions,z,F.localExtensions,[],j,F.builtinExtensions),{local:Q,remote:Y}=V;return{content:F.remoteContent,local:Q,remote:Y,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(F,L,j,z){let{skippedExtensions:V,localExtensions:Q}=j[0][0];const{local:Y,remote:H,localChange:q,remoteChange:G}=j[0][1];if(q===0&&G===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),q!==0&&(await this.kb(JSON.stringify(Q)),V=await this.xb.updateLocalExtensions(Y.added,Y.removed,Y.updated,V,this.syncResource.profile)),H){this.L.trace(`${this.y}: Updating remote extensions...`);const X=JSON.stringify(H.all);F=await this.jb(X,z?null:F.ref),this.L.info(`${this.y}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(ee=>ee.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(ee=>ee.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(ee=>ee.identifier.id))}.`:""}`)}if(L?.ref!==F.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const X=Q.filter(ee=>!ee.installed).map(ee=>ee.identifier);await this.cb(F,{skippedExtensions:V,builtinExtensions:X}),this.L.info(`${this.y}: Updated last synchronized extensions.${V.length?` Skipped: ${JSON.stringify(V.map(ee=>ee.identifier.id))}.`:""}`)}}async resolveContent(F){if(this.h.isEqual(this.vb,F)||this.h.isEqual(this.tb,F)||this.h.isEqual(this.ub,F)||this.h.isEqual(this.wb,F)){const L=await this.ab(F);return L&&this.Jb(JSON.parse(L),!0)}return null}Jb(F,L){return w(F,L)}async hasLocalData(){try{const{localExtensions:F}=await this.xb.getLocalExtensions(this.syncResource.profile);if(F.some(L=>L.installed||L.disabled))return!0}catch{}return!1}};b=pe([K(2,C.IEnvironmentService),K(3,y.IFileService),K(4,m.IStorageService),K(5,o.IUserDataSyncStoreService),K(6,o.IUserDataSyncBackupStoreService),K(7,p.IExtensionManagementService),K(8,s.IIgnoredExtensionsManagementService),K(9,o.IUserDataSyncLogService),K(10,S.IConfigurationService),K(11,o.IUserDataSyncEnablementService),K(12,v.ITelemetryService),K(13,h.IExtensionStorageService),K(14,I.IUriIdentityService),K(15,c.IUserDataProfileStorageService),K(16,f.IInstantiationService)],b),e.ExtensionsSynchroniser=b;let U=class{constructor(F,L,j,z,V,Q){this.a=F,this.b=L,this.c=j,this.d=z,this.f=V,this.g=Q}async getLocalExtensions(F){const L=await this.a.getInstalled(void 0,F.extensionsResource),j=this.d.getIgnoredExtensions(L);return{localExtensions:await this.j(F,async(V,Q)=>{const Y=V.getDisabledExtensions();return L.map(H=>{const{identifier:q,isBuiltin:G,manifest:X,preRelease:ee}=H,re={identifier:q,preRelease:ee,version:X.version};Y.some(te=>(0,g.areSameExtensions)(te,q))&&(re.disabled=!0),G||(re.installed=!0);try{const te=Q.getKeysForSync({id:q.id,version:X.version});if(te){const O=Q.getExtensionState(H,!0)||{};re.state=Object.keys(O).reduce((M,W)=>(te.includes(W)&&(M[W]=O[W]),M),{})}}catch(te){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,D.getErrorMessage)(te))}return re})}),ignoredExtensions:j}}async updateLocalExtensions(F,L,j,z,V){const Q=(0,r.getSyncResourceLogLabel)("extensions",V),Y=[],H=[],q=[],G=await this.a.getInstalled(void 0,V.extensionsResource);if((F.length||j.length)&&await this.j(V,async(ee,re)=>{await k.Promises.settled([...F,...j].map(async te=>{const O=G.find(W=>(0,g.areSameExtensions)(W.identifier,te.identifier));if(O&&O.isBuiltin){te.state&&O.manifest.version===te.version&&this.h(te.state,O,O.manifest.version,re),ee.getDisabledExtensions().some(B=>(0,g.areSameExtensions)(B,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${Q}: Disabling extension...`,te.identifier.id),await ee.disableExtension(te.identifier),this.g.info(`${Q}: Disabled extension`,te.identifier.id)):(this.g.trace(`${Q}: Enabling extension...`,te.identifier.id),await ee.enableExtension(te.identifier),this.g.info(`${Q}: Enabled extension`,te.identifier.id))),H.push(te.identifier);return}const M=(await this.c.getExtensions([{...te.identifier,preRelease:te.preRelease}],n.CancellationToken.None))[0];if(te.state&&(O?O.manifest.version===te.version:!!M)&&this.h(te.state,O||M,O?.manifest.version,re),M)try{ee.getDisabledExtensions().some(B=>(0,g.areSameExtensions)(B,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${Q}: Disabling extension...`,te.identifier.id,M.version),await ee.disableExtension(M.identifier),this.g.info(`${Q}: Disabled extension`,te.identifier.id,M.version)):(this.g.trace(`${Q}: Enabling extension...`,te.identifier.id,M.version),await ee.enableExtension(M.identifier),this.g.info(`${Q}: Enabled extension`,te.identifier.id,M.version))),(!O||O.preRelease!==te.preRelease)&&(await this.a.canInstall(M)?Y.push([te,M]):(this.g.info(`${Q}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),q.push(te)))}catch(W){q.push(te),this.g.error(W),this.g.info(`${Q}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else q.push(te),this.g.info(`${Q}: Skipped synchronizing extension because the extension is not found.`,te.identifier.id)}))}),L.length){const ee=G.filter(({identifier:re,isBuiltin:te})=>!te&&L.some(O=>(0,g.areSameExtensions)(re,O)));await k.Promises.settled(ee.map(async re=>{this.g.trace(`${Q}: Uninstalling local extension...`,re.identifier.id),await this.a.uninstall(re,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:V.extensionsResource}),this.g.info(`${Q}: Uninstalled local extension.`,re.identifier.id),H.push(re.identifier)}))}for(const[ee,re]of Y)try{this.g.trace(`${Q}: Installing extension...`,re.identifier.id,re.version),await this.a.installFromGallery(re,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:ee.preRelease,profileLocation:V.extensionsResource,context:{[o.EXTENSIONS_SYNC_CONTEXT_KEY]:!0}}),this.g.info(`${Q}: Installed extension.`,re.identifier.id,re.version),H.push(re.identifier)}catch(te){q.push(ee),te instanceof p.ExtensionManagementError&&[p.ExtensionManagementErrorCode.Incompatible,p.ExtensionManagementErrorCode.IncompatiblePreRelease,p.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(te.code)?this.g.info(`${Q}: Skipped synchronizing extension because the compatible extension is not found.`,re.displayName||re.identifier.id):(this.g.error(te),this.g.info(`${Q}: Skipped synchronizing extension`,re.displayName||re.identifier.id))}const X=[];for(const ee of z)H.some(re=>(0,g.areSameExtensions)(re,ee.identifier))||X.push(ee);for(const ee of q)X.some(re=>(0,g.areSameExtensions)(re.identifier,ee.identifier))||X.push(ee);return X}h(F,L,j,z){const V=z.getExtensionState(L,!0)||{},Q=j?z.getKeysForSync({id:L.identifier.id,version:j}):void 0;Q?Q.forEach(Y=>{V[Y]=F[Y]}):Object.keys(F).forEach(Y=>V[Y]=F[Y]),z.setExtensionState(L,V,!0)}async j(F,L){return this.b.withProfileScopedStorageService(F,async j=>{const z=new R.DisposableStore,V=this.f.createChild(new l.ServiceCollection([m.IStorageService,j])),Q=z.add(V.createInstance(E.GlobalExtensionEnablementService)),Y=z.add(V.createInstance(h.ExtensionStorageService));try{return await L(Q,Y)}finally{z.dispose()}})}};U=pe([K(0,p.IExtensionManagementService),K(1,c.IUserDataProfileStorageService),K(2,p.IExtensionGalleryService),K(3,s.IIgnoredExtensionsManagementService),K(4,f.IInstantiationService),K(5,o.IUserDataSyncLogService)],U),e.LocalExtensionsProvider=U;let N=class extends r.AbstractInitializer{constructor(F,L,j,z,V,Q,Y,H){super("extensions",z,V,Q,j,Y,H),this.o=F,this.p=L}async q(F){return F.syncData?await a(F.syncData,this.o):null}t(F,L){const j=[],z=[],V=[];for(const Q of F){if(this.p.hasToNeverSyncExtension(Q.identifier.id))continue;const Y=L.find(H=>(0,g.areSameExtensions)(H.identifier,Q.identifier));Y?(j.push(Y),Q.disabled&&V.push(Q.identifier)):Q.installed&&(z.push({...Q.identifier,preRelease:!!Q.preRelease}),Q.disabled&&V.push(Q.identifier))}return{installedExtensions:j,newExtensions:z,disabledExtensions:V,remoteExtensions:F}}};N=pe([K(0,p.IExtensionManagementService),K(1,s.IIgnoredExtensionsManagementService),K(2,y.IFileService),K(3,i.IUserDataProfilesService),K(4,C.IEnvironmentService),K(5,d.ILogService),K(6,m.IStorageService),K(7,I.IUriIdentityService)],N),e.AbstractExtensionsInitializer=N}),define(oe[118],ae([0,1,17,9,3,35,43,5,31,16,15,13,8,45,20,19,29,41,61,257,26,18,62,4]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v,I,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",s=["locale"];function o(U,N){const $=U.storage?Object.keys(U.storage).sort():[],F={};return $.forEach(L=>F[L]=U.storage[L]),U.storage=F,N?(0,T.toFormattedString)(U,{}):JSON.stringify(U)}e.stringify=o;const c=1;let a=class extends l.AbstractSynchroniser{constructor(N,$,F,L,j,z,V,Q,Y,H,q,G,X,ee){super({syncResource:"globalState",profile:N},$,L,Q,G,j,z,Y,H,V,q,X),this.wb=F,this.mb=c,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=ee.createInstance(u),this.B(L.watch(this.h.dirname(this.D.argvResource))),this.B(D.Event.any(D.Event.filter(L.onDidFilesChange,re=>re.contains(this.D.argvResource)),D.Event.filter(F.onDidChange,re=>!!(re.targetChanges.some(te=>this.syncResource.profile.id===te.id)||re.valueChanges.some(({profile:te,changes:O})=>this.syncResource.profile.id===te.id&&O.some(M=>M.target===0)))))(()=>this.triggerLocalChange()))}async nb(N,$,F){const L=N.syncData?JSON.parse(N.syncData.content):null;$=$===null&&F?N:$;const j=$&&$.syncData?JSON.parse($.syncData.content):null,z=await this.vb.getLocalGlobalState(this.syncResource.profile);L?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=await this.Eb(j),{local:Q,remote:Y}=(0,m.merge)(z.storage,L?L.storage:null,j?j.storage:null,V,this.L),H={content:null,local:Q,remote:Y,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:Y.all!==null?2:0},q=o(z,!1);return[{baseResource:this.r,baseContent:j?o(j,!1):q,localResource:this.sb,localContent:q,localUserData:z,remoteResource:this.tb,remoteContent:L?o(L,!1):null,previewResource:this.p,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.ub,storageKeys:V}]}async rb(N){const $=N.syncData?JSON.parse(N.syncData.content):null;if($===null)return!0;const F=await this.vb.getLocalGlobalState(this.syncResource.profile),L=await this.Eb($),{remote:j}=(0,m.merge)(F.storage,$.storage,$.storage,L,this.L);return j.all!==null}async ob(N,$){return{...N.previewResult,hasConflicts:!1}}async pb(N,$,F,L){if(this.h.isEqual($,this.sb))return this.Bb(N);if(this.h.isEqual($,this.tb))return this.Cb(N);if(this.h.isEqual($,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${$.toString()}`)}async Bb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Cb(N){if(N.remoteContent!==null){const $=JSON.parse(N.remoteContent),{local:F,remote:L}=(0,m.merge)(N.localUserData.storage,$.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:F,remote:L,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(N,$,F,L){const{localUserData:j}=F[0][0],{local:z,remote:V,localChange:Q,remoteChange:Y}=F[0][1];if(Q===0&&Y===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),Q!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(j)),await this.vb.writeLocalGlobalState(z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),Y!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const H=JSON.stringify({storage:V.all});N=await this.jb(H,L?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${V.added.length?` Added: ${V.added}.`:""}${V.updated.length?` Updated: ${V.updated}.`:""}${V.removed.length?` Removed: ${V.removed}.`:""}`)}$?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.tb,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.sb,N)||this.h.isEqual(this.ub,N)){const $=await this.ab(N);return $&&o(JSON.parse($),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(N){const $=await this.wb.readStorageData(this.syncResource.profile),F=[],L=[];for(const[V,Q]of $)Q.target===0?F.push(V):Q.target===1&&L.push(V);const j=[...F,...L],z=N?.storage?Object.keys(N.storage).filter(V=>!V.startsWith(t)&&!j.includes(V)&&$.get(V)!==void 0):[];if(!R.isWeb){const V=[...v.ALL_SYNC_RESOURCES.map(Q=>(0,v.getEnablementKey)(Q)),v.SYNC_SERVICE_URL_TYPE];z.push(...V),L.push(...V)}return{user:F,machine:L,unregistered:z}}};a=pe([K(2,i.IUserDataProfileStorageService),K(3,E.IFileService),K(4,v.IUserDataSyncStoreService),K(5,v.IUserDataSyncBackupStoreService),K(6,v.IUserDataSyncLogService),K(7,C.IEnvironmentService),K(8,v.IUserDataSyncEnablementService),K(9,y.ITelemetryService),K(10,S.IConfigurationService),K(11,h.IStorageService),K(12,f.IUriIdentityService),K(13,r.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let u=class{constructor(N,$,F,L){this.a=N,this.b=$,this.c=F,this.d=L}async getLocalGlobalState(N){const $={};if(N.isDefault){const L=await this.f(),j=(0,A.parse)(L);for(const z of s)j[z]!==void 0&&($[`${t}${z}`]={version:1,value:j[z]})}const F=await this.c.readStorageData(N);for(const[L,j]of F)j.value&&j.target===0&&($[L]={version:1,value:j.value});return{storage:$}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,n.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:$,updated:F},L){const j=(0,l.getSyncResourceLogLabel)("globalState",L),z={},V=new Map,Q=await this.c.readStorageData(L),Y=(H,q)=>{for(const G of H){if(G.startsWith(t)){z[G.substring(t.length)]=q?q[G].value:void 0;continue}if(q){const X=q[G];X.value!==Q.get(G)?.value&&V.set(G,X.value)}else Q.get(G)!==void 0&&V.set(G,void 0)}};if(Y(Object.keys(N),N),Y(Object.keys(F),F),Y($),Object.keys(z).length){this.d.trace(`${j}: Updating locale...`);const H=await this.f();let q=H;for(const G of Object.keys(z))q=(0,d.edit)(q,[G],z[G],{});H!==q&&(this.d.trace(`${j}: Updating locale...`),await this.a.writeFile(this.b.argvResource,k.VSBuffer.fromString(q)),this.d.info(`${j}: Updated locale.`)),this.d.info(`${j}: Updated locale`)}V.size&&(this.d.trace(`${j}: Updating global state...`),await this.c.updateStorageData(L,V,0),this.d.info(`${j}: Updated global state`,[...V.keys()]))}};u=pe([K(0,E.IFileService),K(1,C.IEnvironmentService),K(2,i.IUserDataProfileStorageService),K(3,v.IUserDataSyncLogService)],u),e.LocalGlobalStateProvider=u;let w=class extends l.AbstractInitializer{constructor(N,$,F,L,j,z){super("globalState",F,L,j,$,N,z)}async doInitialize(N){const $=N.syncData?JSON.parse(N.syncData.content):null;if(!$){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},L={};for(const j of Object.keys($.storage))j.startsWith(t)?F[j.substring(t.length)]=$.storage[j].value:this.l.get(j,0)===void 0&&(L[j]=$.storage[j].value);if(Object.keys(F).length){let j="{}";try{j=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const z of Object.keys(F))j=(0,d.edit)(j,[z],F[z],{});await this.k.writeFile(this.h.argvResource,k.VSBuffer.fromString(j))}if(Object.keys(L).length)for(const j of Object.keys(L))this.l.store(j,L[j],0,0)}};w=pe([K(0,h.IStorageService),K(1,E.IFileService),K(2,I.IUserDataProfilesService),K(3,C.IEnvironmentService),K(4,v.IUserDataSyncLogService),K(5,f.IUriIdentityService)],w),e.GlobalStateInitializer=w;let b=class{constructor(N,$,F,L,j){this.a=N,this.b=$,this.c=F,this.d=L,this.f=j}getSyncStoreType(N){return this.h(N)?.storage[v.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const $=(0,v.createSyncHeaders)((0,P.generateUuid)());try{return await this.g(N,$)}catch(F){if(F instanceof v.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,$)}throw F}}async g(N,$){const F=await this.a.readResource("globalState",null,void 0,$),L=this.h(F)||{storage:{}};L.storage[v.SYNC_SERVICE_URL_TYPE]={value:N,version:c};const j=await(0,g.getServiceMachineId)(this.c,this.d,this.b),z={version:c,machineId:j,content:o(L,!1)};await this.a.writeResource("globalState",JSON.stringify(z),F.ref,void 0,$)}h({content:N}){if(!N)return null;const $=JSON.parse(N);if((0,l.isSyncData)($))return $?JSON.parse($.content):null;throw new Error("Invalid remote data")}};b=pe([K(1,h.IStorageService),K(2,C.IEnvironmentService),K(3,E.IFileService),K(4,p.ILogService)],b),e.UserDataSyncStoreTypeSynchronizer=b}),define(oe[119],ae([0,1,21,17,3,35,5,14,176,16,15,13,20,19,29,18,41,254,26]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function m(i,r,t){try{const s=JSON.parse(i);if(!r)return(0,R.isUndefined)(s.all)?null:s.all;switch(T.OS){case 2:return(0,R.isUndefined)(s.mac)?null:s.mac;case 3:return(0,R.isUndefined)(s.linux)?null:s.linux;case 1:return(0,R.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=m;let v=class extends f.AbstractJsonFileSynchroniser{constructor(r,t,s,o,c,a,u,w,b,U,N,$,F){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,w,b,U,s,o,u,$,c,N,a,F),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(D.Event.filter(a.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(r,t,s,o){const c=r.syncData?m(r.syncData.content,o.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&s?r:t;const a=t?this.Jb(t):null,u=await this.p(),w=await this.xb();let b=null,U=!1,N=!1,$=!1;if(c){let j=u?u.value.toString():"[]";if(j=j||"[]",this.vb(j,!0))throw new d.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==j||a!==c){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const z=await(0,l.merge)(j,c,a,w,this.ub);z.hasChanges&&(b=z.mergeContent,$=z.hasConflicts,U=$||z.mergeContent!==j,N=$||z.mergeContent!==c)}}else u&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),b=u.value.toString(),N=!0);const F={content:$?a:b,localChange:U?u?2:1:0,remoteChange:N?2:0,hasConflicts:$},L=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Ab,baseContent:a,localResource:this.Bb,localContent:L,localChange:F.localChange,remoteResource:this.Cb,remoteContent:c,remoteChange:F.remoteChange,previewResource:this.zb,previewResult:F,acceptedResource:this.Db}]}async rb(r){const t=this.Jb(r);if(t===null)return!0;const s=await this.p(),o=s?s.value.toString():"",c=await this.xb(),a=await(0,l.merge)(o||"[]",t,t,c,this.ub);return a.hasConflicts||a.mergeContent!==t}async ob(r,t){return r.previewResult}async pb(r,t,s,o){if(this.h.isEqual(t,this.Bb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,s,o){const{fileContent:c}=s[0][0];let{content:a,localChange:u,remoteChange:w}=s[0][1];if(u===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.vb(a,!0)))throw new d.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),c&&await this.kb(this.Kb(c.value.toString())),await this.r(a||"[]",c,o),this.L.info(`${this.y}: Updated local keybindings`)),w!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const b=this.Kb(a||"[]",r.syncData?.content);r=await this.jb(b,o?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(r,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,A.parse)(r.value.toString());if((0,k.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Ab,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Db,r)?this.ab(r):null}Jb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Lb()?null:m(r.syncData.content,this.Lb(),this.L)}Kb(r,t){let s={};try{s=JSON.parse(t||"{}")}catch(o){this.L.error(o)}switch(this.Lb()?delete s.all:s.all=r,T.OS){case 2:s.mac=r;break;case 3:s.linux=r;break;case 1:s.windows=r;break}return JSON.stringify(s)}Lb(){return!!this.M.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};v=pe([K(2,d.IUserDataSyncStoreService),K(3,d.IUserDataSyncBackupStoreService),K(4,d.IUserDataSyncLogService),K(5,S.IConfigurationService),K(6,d.IUserDataSyncEnablementService),K(7,E.IFileService),K(8,C.IEnvironmentService),K(9,p.IStorageService),K(10,d.IUserDataSyncUtilService),K(11,g.ITelemetryService),K(12,h.IUriIdentityService)],v),e.KeybindingsSynchroniser=v;let I=class extends f.AbstractInitializer{constructor(r,t,s,o,c,a){super("keybindings",t,s,o,r,c,a)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,n.VSBuffer.fromString(t)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,A.parse)(r.value.toString());return!(0,k.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}i(r){try{return m(r,!0,this.j)}catch(t){return this.j.error(t),null}}};I=pe([K(0,E.IFileService),K(1,y.IUserDataProfilesService),K(2,C.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,p.IStorageService),K(5,h.IUriIdentityService)],I),e.KeybindingsInitializer=I}),define(oe[120],ae([0,1,17,3,177,16,74,15,30,13,20,19,29,18,41,61,258,26]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function m(i){const r=JSON.parse(i);return d(r)?r:{settings:i}}e.parseSettingsSyncContent=m;let v=class extends h.AbstractJsonFileSynchroniser{constructor(r,t,s,o,c,a,u,w,b,U,N,$,F,L){super(r.settingsResource,{syncResource:"settings",profile:r},t,s,o,c,a,u,N,$,w,b,U,L),this.zb=F,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),s=await this.R(r,t),o=this.Gb(s),c=new T.ConfigurationModelParser(l.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&c.parse(o.settings),c.configurationModel.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(r,t,s){const o=await this.p(),c=await this.xb(),a=this.Gb(r);t=t===null&&s?r:t;const u=t?this.Gb(t):null,w=await this.Kb();let b=null,U=!1,N=!1,$=!1;if(a){let z=o?o.value.toString().trim():"{}";z=z||"{}",this.Lb(z),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const V=(0,f.merge)(z,a.settings,u?u.settings:null,w,[],c);b=V.localContent||V.remoteContent,U=V.localContent!==null,N=V.remoteContent!==null,$=V.hasConflicts}else o&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),b=o.value.toString().trim()||"{}",this.Lb(b),N=!0);const F=o?o.value.toString():null,L=u?.settings??null,j={content:$?L:b,localChange:U?2:0,remoteChange:N?2:0,hasConflicts:$};return[{fileContent:o,baseResource:this.baseResource,baseContent:L,localResource:this.localResource,localContent:F,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async rb(r){const t=this.Gb(r);if(t===null)return!0;const s=await this.p(),o=s?s.value.toString().trim():"",c=await this.Kb(),a=await this.xb();return(0,f.merge)(o||"{}",t.settings,t.settings,c,[],a).remoteContent!==null}async ob(r,t){const s=await this.xb(),o=await this.Kb();return{...r.previewResult,content:r.previewResult.content?(0,f.updateIgnoredSettings)(r.previewResult.content,"{}",o,s):null}}async pb(r,t,s,o){const c=await this.xb(),a=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,f.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",a,c):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,f.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s!==null?(0,f.updateIgnoredSettings)(s,r.fileContent?r.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,s,o){const{fileContent:c}=s[0][0];let{content:a,localChange:u,remoteChange:w}=s[0][1];if(u===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.Lb(a),u!==0&&(this.L.trace(`${this.y}: Updating local settings...`),c&&await this.kb(JSON.stringify(this.Ib(c.value.toString()))),await this.r(a,c,o),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),w!==0){const b=await this.xb(),U=this.Gb(r),N=await this.Kb(a);a=(0,f.updateIgnoredSettings)(a,U?U.settings:"{}",N,b),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.jb(JSON.stringify(this.Ib(a)),o?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.xb(),s=(0,y.edit)(r.value.toString(),[l.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,f.isEmpty)(s)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.ab(r):null}async ab(r){let t=await super.ab(r);if(t){const s=await this.xb(),o=await this.Kb();t=(0,f.updateIgnoredSettings)(t,"{}",o,s)}return t}Gb(r){return r.syncData?this.Hb(r.syncData.content):null}Hb(r){try{return m(r)}catch(t){this.L.error(t)}return null}Ib(r){return{settings:r}}async Kb(r){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const s=n.Event.any(n.Event.filter(this.zb.onDidInstallExtensions,o=>o.some(({local:c})=>!!c)),n.Event.filter(this.zb.onDidUninstallExtension,o=>!o.error))(()=>{s.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,f.getIgnoredSettings)(t,this.M,r)}Lb(r){if(this.vb(r,!1))throw new l.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};v=pe([K(2,S.IFileService),K(3,R.IEnvironmentService),K(4,C.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncLogService),K(8,l.IUserDataSyncUtilService),K(9,A.IConfigurationService),K(10,l.IUserDataSyncEnablementService),K(11,E.ITelemetryService),K(12,P.IExtensionManagementService),K(13,p.IUriIdentityService)],v),e.SettingsSynchroniser=v;let I=class extends h.AbstractInitializer{constructor(r,t,s,o,c,a){super("settings",t,s,o,r,c,a)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,k.VSBuffer.fromString(t.settings)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,f.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}i(r){try{return m(r)}catch(t){this.j.error(t)}return null}};I=pe([K(0,S.IFileService),K(1,g.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,l.IUserDataSyncLogService),K(4,C.IStorageService),K(5,p.IUriIdentityService)],I),e.SettingsInitializer=I}),define(oe[121],ae([0,1,17,3,32,16,15,13,20,19,29,18,41,255,26]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function y(d){return JSON.parse(d.content)}e.parseSnippets=y;let f=class extends p.AbstractSynchroniser{constructor(m,v,I,i,r,t,s,o,c,a,u,w){super({syncResource:"snippets",profile:m},v,i,I,r,t,s,a,u,o,c,w),this.mb=1,this.p=m.snippetsHome,this.B(this.C.watch(I.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(n.Event.filter(this.C.onDidFilesChange,b=>b.affects(this.p))(()=>this.triggerLocalChange()))}async nb(m,v,I){const i=await this.Cb(),r=this.Bb(i),t=m.syncData?this.Ab(m.syncData):null;v=v===null&&I?m:v;const s=v&&v.syncData?this.Ab(v.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const o=(0,g.merge)(r,t,s);return this.wb(o,i,t||{},s||{})}async rb(m){const v=m.syncData?this.Ab(m.syncData):null;if(v===null)return!0;const I=await this.Cb(),i=this.Bb(I),r=(0,g.merge)(i,v,v);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async ob(m,v){return m.previewResult}async pb(m,v,I,i){if(this.h.isEqualOrParent(v,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(v,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(v,this.g))return I===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:I,localChange:I===null?m.fileContent!==null?3:0:2,remoteChange:I===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async qb(m,v,I,i){const r=I.map(([t,s])=>({...t,acceptResult:s}));r.every(({localChange:t,remoteChange:s})=>t===0&&s===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.xb(r),await this.yb(r,i)),r.some(({remoteChange:t})=>t!==0)&&(m=await this.zb(r,m,i)),v?.ref!==m.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(m),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.C.del(t)}catch{}}wb(m,v,I,i){const r=new Map;for(const t of Object.keys(m.local.added)){const s={content:m.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(m.local.updated)){const s={content:m.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of m.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(m.remote.added)){const s={content:m.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(m.remote.updated)){const s={content:m.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of m.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of m.conflicts){const s={content:i[t]??null,hasConflicts:!0,localChange:v[t]?2:1,remoteChange:I[t]?2:1},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v))if(!r.has(t)){const s={content:v[t]?v[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(m){return this.h.isEqualOrParent(m,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(m,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(m,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(m,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(m):null}async hasLocalData(){try{const m=await this.Cb();if(Object.keys(m).length)return!0}catch{}return!1}async xb(m){const v={};for(const I of m)I.fileContent&&(v[this.h.basename(I.localResource)]=I.fileContent);await this.kb(JSON.stringify(this.Bb(v)))}async yb(m,v){for(const{fileContent:I,acceptResult:i,localResource:r,remoteResource:t,localChange:s}of m)if(s!==0){const o=t?this.h.basename(t):this.h.basename(r),c=this.h.joinPath(this.p,o);s===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(c)),await this.C.del(c),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(c))):s===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(c)),await this.C.createFile(c,k.VSBuffer.fromString(i.content),{overwrite:v}),this.L.info(`${this.y}: Created snippet`,this.h.basename(c))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(c)),await this.C.writeFile(c,k.VSBuffer.fromString(i.content),v?void 0:I),this.L.info(`${this.y}: Updated snippet`,this.h.basename(c)))}}async zb(m,v,I){const i=v.syncData?this.Ab(v.syncData):{},r=(0,D.deepClone)(i);for(const{acceptResult:t,localResource:s,remoteResource:o,remoteChange:c}of m)if(c!==0){const a=s?this.h.basename(s):this.h.basename(o);c===3?delete r[a]:r[a]=t.content}return(0,g.areSame)(i,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),v=await this.jb(JSON.stringify(r),I?null:v.ref),this.L.info(`${this.y}: Updated remote snippets`)),v}Ab(m){return y(m)}Bb(m){const v={};for(const I of Object.keys(m))v[I]=m[I].value.toString();return v}async Cb(){const m={};let v;try{v=await this.C.resolve(this.p)}catch(I){if(I instanceof R.FileOperationError&&I.fileOperationResult===1)return m;throw I}for(const I of v.children||[]){const i=I.resource,r=this.h.extname(i);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,i),s=await this.C.readFile(i);m[t]=s}}return m}};f=pe([K(2,T.IEnvironmentService),K(3,R.IFileService),K(4,P.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncLogService),K(8,A.IConfigurationService),K(9,h.IUserDataSyncEnablementService),K(10,S.ITelemetryService),K(11,C.IUriIdentityService)],f),e.SnippetsSynchroniser=f;let l=class extends p.AbstractInitializer{constructor(m,v,I,i,r,t){super("snippets",v,I,i,m,r,t)}async doInitialize(m){const v=m.syncData?JSON.parse(m.syncData.content):null;if(!v){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(v)){const r=v[i];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(t,k.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(m)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};l=pe([K(0,R.IFileService),K(1,E.IUserDataProfilesService),K(2,T.IEnvironmentService),K(3,h.IUserDataSyncLogService),K(4,P.IStorageService),K(5,C.IUriIdentityService)],l),e.SnippetsInitializer=l}),define(oe[122],ae([0,1,17,16,15,13,20,19,29,18,41,26]),function(Z,e,k,n,D,A,T,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(f,l){try{return JSON.parse(f).tasks??null}catch(d){return l.error(d),null}}e.getTasksContentFromSyncContent=p;let g=class extends C.AbstractFileSynchroniser{constructor(l,d,m,v,I,i,r,t,s,o,c,a){super(l.tasksResource,{syncResource:"tasks",profile:l},d,t,s,o,m,v,r,c,I,i,a),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(l,d,m,v){const I=l.syncData?p(l.syncData.content,this.L):null;d=d===null&&m?l:d;const i=d?.syncData?p(d.syncData.content,this.L):null,r=await this.p();let t=null,s=!1,o=!1,c=!1;if(l.syncData){const w=r?r.value.toString():null;if(!i||i!==w||i!==I){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const b=y(w,I,i);t=b.content,c=b.hasConflicts,s=b.hasLocalChanged,o=b.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),o=!0);const a={content:c?i:t,localChange:s?r?2:1:0,remoteChange:o?2:0,hasConflicts:c},u=r?r.value.toString():null;return[{fileContent:r,baseResource:this.wb,baseContent:i,localResource:this.xb,localContent:u,localChange:a.localChange,remoteResource:this.yb,remoteContent:I,remoteChange:a.remoteChange,previewResource:this.vb,previewResult:a,acceptedResource:this.zb}]}async rb(l){const d=l?.syncData?p(l.syncData.content,this.L):null;if(d===null)return!0;const m=await this.p(),v=m?m.value.toString():null,I=y(v,d,d);return I.hasLocalChanged||I.hasRemoteChanged}async ob(l,d){return l.previewResult}async pb(l,d,m,v){if(this.h.isEqual(d,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.vb))return m===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(l,d,m,v){const{fileContent:I}=m[0][0],{content:i,localChange:r,remoteChange:t}=m[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),I&&await this.kb(JSON.stringify(this.Fb(I.value.toString()))),i?await this.r(i,I,v):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const s=JSON.stringify(this.Fb(i));l=await this.jb(s,v?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};g=pe([K(2,E.IUserDataSyncStoreService),K(3,E.IUserDataSyncBackupStoreService),K(4,E.IUserDataSyncLogService),K(5,n.IConfigurationService),K(6,E.IUserDataSyncEnablementService),K(7,A.IFileService),K(8,D.IEnvironmentService),K(9,T.IStorageService),K(10,R.ITelemetryService),K(11,P.IUriIdentityService)],g),e.TasksSynchroniser=g;let h=class extends C.AbstractInitializer{constructor(l,d,m,v,I,i){super("tasks",d,m,v,l,I,i),this.c=this.g.defaultProfile.tasksResource}async doInitialize(l){const d=l.syncData?p(l.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,k.VSBuffer.fromString(d)),await this.n(l)}async i(){return this.k.exists(this.c)}};h=pe([K(0,A.IFileService),K(1,S.IUserDataProfilesService),K(2,D.IEnvironmentService),K(3,E.IUserDataSyncLogService),K(4,T.IStorageService),K(5,P.IUriIdentityService)],h),e.TasksInitializer=h;function y(f,l,d){if(f===null&&l===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(f===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=d!==f,v=d!==l;return!m&&!v?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!v?{content:f,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:v&&!m?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:f,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[123],ae([0,1,43,16,15,13,20,19,29,18,41,256,26]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let g=class extends C.AbstractSynchroniser{constructor(l,d,m,v,I,i,r,t,s,o,c,a,u){super({syncResource:"profiles",profile:l},d,v,I,i,r,t,c,a,s,o,u),this.r=m,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?y(l.syncData):null}async getRemoteSyncedProfiles(l){const d=await this.getLastSyncUserData(),m=await this.R(l,d);return m?.syncData?y(m.syncData):null}async nb(l,d,m){if(!this.r.isEnabled())throw new p.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const v=l.syncData?y(l.syncData):null,I=d?.syncData?y(d.syncData):null,i=this.zb(),{local:r,remote:t}=(0,E.merge)(i,v,I,[]),s={local:r,remote:t,content:I?this.Ab(I):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},o=h(i,!1);return[{baseResource:this.baseResource,baseContent:I?this.Ab(I):null,localResource:this.localResource,localContent:o,remoteResource:this.remoteResource,remoteContent:v?this.Ab(v):null,remoteProfiles:v,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const d=l?.syncData?y(l.syncData):null,m=this.zb(),{remote:v}=(0,E.merge)(m,d,d,[]);return!!v?.added.length||!!v?.removed.length||!!v?.updated.length}async ob(l,d){return{...l.previewResult,hasConflicts:!1}}async pb(l,d,m,v){if(this.h.isEqual(d,this.localResource))return this.wb(l);if(this.h.isEqual(d,this.remoteResource))return this.xb(l);if(this.h.isEqual(d,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async wb(l){const d=this.zb(),m=(0,E.merge)(d,null,null,[]),{local:v,remote:I}=m;return{content:l.localContent,local:v,remote:I,localChange:v.added.length>0||v.removed.length>0||v.updated.length>0?2:0,remoteChange:I!==null?2:0}}async xb(l){const d=l.remoteContent?JSON.parse(l.remoteContent):null,m=[],v=[];for(const I of this.zb()){const i=d?.find(r=>r.id===I.id);i&&(m.push({id:I.id,name:I.name,collection:i.collection}),v.push(I))}if(d!==null){const I=(0,E.merge)(v,d,m,[]),{local:i,remote:r}=I;return{content:l.remoteContent,local:i,remote:r,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,d,m,v){const{local:I,remote:i,localChange:r,remoteChange:t}=m[0][1];r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const s=m[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new p.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.kb(h(this.zb(),!1));const o=[];for(const c of I.added)o.push((async()=>{this.L.trace(`${this.y}: Creating '${c.name}' profile...`),await this.r.createProfile(c.id,c.name,{shortName:c.shortName}),this.L.info(`${this.y}: Created profile '${c.name}'.`)})());for(const c of I.removed)o.push((async()=>{this.L.trace(`${this.y}: Removing '${c.name}' profile...`),await this.r.removeProfile(c),this.L.info(`${this.y}: Removed profile '${c.name}'.`)})());for(const c of I.updated){const a=this.r.profiles.find(u=>u.id===c.id);a?o.push((async()=>{this.L.trace(`${this.y}: Updating '${c.name}' profile...`),await this.r.updateProfile(a,{name:c.name,shortName:c.shortName}),this.L.info(`${this.y}: Updated profile '${c.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${c.id}' to update.`)}await Promise.all(o)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const o=[],c=s.length+(i?.added.length??0)<=20;if(c)for(const a of i?.added||[]){const u=await this.G.createCollection(this.z);o.push(u),s.push({id:a.id,name:a.name,collection:u,shortName:a.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:u})=>a.id===u),1);for(const a of i?.updated||[]){const u=s.find(({id:w})=>a.id===w);u&&s.splice(s.indexOf(u),1,{id:a.id,name:a.name,collection:u.collection,shortName:a.shortName})}try{l=await this.updateRemoteProfiles(s,v?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${c&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(o.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of o)await this.G.deleteCollection(u,this.z)}throw a}for(const a of i?.removed||[])await this.G.deleteCollection(a.collection,this.z)}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,d){return this.jb(this.Ab(l),d)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const d=await this.ab(l);return d&&(0,k.toFormattedString)(JSON.parse(d),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((d,m)=>d.name.localeCompare(m.name)))}};g=pe([K(2,S.IUserDataProfilesService),K(3,A.IFileService),K(4,D.IEnvironmentService),K(5,T.IStorageService),K(6,p.IUserDataSyncStoreService),K(7,p.IUserDataSyncBackupStoreService),K(8,p.IUserDataSyncLogService),K(9,n.IConfigurationService),K(10,p.IUserDataSyncEnablementService),K(11,R.ITelemetryService),K(12,P.IUriIdentityService)],g),e.UserDataProfilesManifestSynchroniser=g;function h(f,l){const d=[...f].sort((m,v)=>m.name.localeCompare(v.name)).map(m=>({id:m.id,name:m.name}));return l?(0,k.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=h;function y(f){return JSON.parse(f.content)}e.parseUserDataProfilesManifest=y}),define(oe[272],ae([0,1,6,17,65,2,22,16,15,13,18,26]),function(Z,e,k,n,D,A,T,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends A.Disposable{constructor(h,y,f,l,d){super(),this.a=h,this.b=y,this.c=f,this.f=l,this.g=d,this.h()}async h(){for(const y of this.g.profiles)for(const f of E.ALL_SYNC_RESOURCES)try{await this.j(this.i(y,f))}catch(l){this.f.error(l)}let h;try{h=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,S.toFileOperationResult)(y)!==1&&this.f.error(y);return}if(h.children){for(const y of h.children)if(y.isDirectory&&!this.g.profiles.some(f=>f.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(f){this.f.error(f)}}}async getAllRefs(h,y){const f=this.i(h,y),l=await this.b.resolve(f);return l.children?l.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.k(m)})):[]}async resolveContent(h,y,f){const l=this.i(h,y),d=(0,T.joinPath)(l,f);try{return(await this.b.readFile(d)).value.toString()}catch(m){return this.f.error(m),null}}async backup(h,y,f){const l=this.i(h,y),d=(0,T.joinPath)(l,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,n.VSBuffer.fromString(f))}catch(m){this.f.error(m)}try{this.j(l)}catch{}}i(h,y){return(0,T.joinPath)(this.a.userDataSyncHome,...h.isDefault?[y]:[h.id,y])}async j(h){try{try{if(!await this.b.exists(h))return}catch{return}const y=await this.b.resolve(h);if(y.children){const f=y.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=f.filter(v=>Date.now()-this.k(v)>l);const m=f.length-d.length;m<10&&(d=d.slice(10-m)),await k.Promises.settled(d.map(async v=>{this.f.info("Deleting from backup",v.resource.path),await this.b.del(v.resource)}))}}catch(y){this.f.error(y)}}k(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};p=pe([K(0,P.IEnvironmentService),K(1,S.IFileService),K(2,R.IConfigurationService),K(3,E.IUserDataSyncLogService),K(4,C.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(oe[273],ae([0,1,3,2,5,15,20,19,26]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let C=class extends n.Disposable{constructor(p,g,h,y){super(),this.c=p,this.f=g,this.g=h,this.h=y,this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new k.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(p.onDidChangeValue(f=>this.j(f)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:p}),this.c.store(S,p,-1,1))}isResourceEnabled(p){return this.c.getBoolean((0,P.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,g){if(this.isResourceEnabled(p)!==g){const h=(0,P.getEnablementKey)(p);this.i(h,g)}}getResourceSyncStateVersion(p){}i(p,g){this.c.store(p,g,-1,D.isWeb?0:1)}j(p){if(p.scope!==-1)return;if(S===p.key){this.a.fire(this.isEnabled());return}const g=P.ALL_SYNC_RESOURCES.filter(h=>(0,P.getEnablementKey)(h)===p.key)[0];if(g){this.b.fire([g,this.isResourceEnabled(g)]);return}}};C=pe([K(0,T.IStorageService),K(1,R.ITelemetryService),K(2,A.IEnvironmentService),K(3,P.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(oe[81],ae([0,1,3,2,5,27,180,15,13,4,25,45,20,26]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",y="Safari",f="Chrome",l="Edge",d="Firefox",m="Android";function v(r){switch(r){case y:case f:case l:case d:case m:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=v;function I(){return D.isSafari?y:D.isChrome?f:D.isEdge?l:D.isFirefox?d:D.isAndroid?m:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let i=class rt extends n.Disposable{constructor(t,s,o,c,a,u){super(),this.h=o,this.i=c,this.j=a,this.k=u,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.getServiceMachineId)(t,s,o)}async getMachines(t){const s=await this.f;return(await this.m(t)).machines.map(c=>({...c,isCurrent:c.id===s}))}async addCurrentMachine(t){const s=await this.f,o=await this.m(t);o.machines.some(({id:c})=>c===s)||(o.machines.push({id:s,name:this.l(o.machines),platform:I()}),await this.n(o))}async removeCurrentMachine(t){const s=await this.f,o=await this.m(t),c=o.machines.filter(({id:a})=>a!==s);c.length!==o.machines.length&&(o.machines=c,await this.n(o))}async renameMachine(t,s,o){const c=await this.m(o),a=c.machines.find(({id:u})=>u===t);if(a){a.name=s,await this.n(c);const u=await this.f;t===u&&this.h.store(h,s,-1,1)}}async setEnablements(t){const s=await this.m();for(const[o,c]of t){const a=s.machines.find(u=>u.id===o);a&&(a.disabled=c?void 0:!0)}await this.n(s)}l(t){const s=this.h.get(h,-1);if(s)return s;const o=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${I()} (${this.k.nameShort})`,c=new RegExp(`${(0,A.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const u of t){const w=c.exec(u.name),b=w?parseInt(w[1]):0;a=b>a?b:a}return`${o} #${a+1}`}async m(t){this.g=await this.p(t);const s=this.r(this.g);if(s.version!==rt.a)throw new Error((0,T.localize)(0,null,this.k.nameLong));return s}async n(t){const s=JSON.stringify(t),o=await this.i.writeResource(rt.b,s,this.g?.ref||null);this.g={ref:o,content:s},this.c.fire()}async p(t){if(this.g){const s=t&&t.latest?t.latest[rt.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.i.readResource(rt.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.j.error(s)}return{version:rt.a,machines:[]}}};i.a=1,i.b="machines",i=pe([K(0,R.IEnvironmentService),K(1,P.IFileService),K(2,p.IStorageService),K(3,g.IUserDataSyncStoreService),K(4,g.IUserDataSyncLogService),K(5,C.IProductService)],i),e.UserDataSyncMachinesService=i}),define(oe[274],ae([0,1,6,65,38,9,3,2,5,22,7,178,25,20,19,26,78,81]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",m="sync.sessionId",v="sync.storeUrl",I="sync.productQuality";let i=class extends R.Disposable{get j(){const s=this.z.get(v,-1);return s?C.URI.parse(s):void 0}set j(s){s?this.z.store(v,s.toString(),-1,1):this.z.remove(v,-1)}get l(){return this.z.get(I,-1)}set l(s){s?this.z.store(I,s,-1,1):this.z.remove(I,-1)}constructor(s,o,c,a,u,w,b,U,N,$){super(),this.n=o,this.p=c,this.r=a,this.s=u,this.u=w,this.v=b,this.w=U,this.y=N,this.z=$,this.a=this.B(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new k.ThrottledDelayer(this.O())),this.i=this.j,this.j=o.userDataSyncStore?.url,this.k=this.l,this.l=s.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(o.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,o.userDataSyncStore?.url)||(this.i=this.j,this.j=o.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(b.onDidChangeAccount(()=>this.C())),this.B(c.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(u.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(T.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:s,message:o}=this.F();s?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(c=>this.I(c))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(o&&this.u.info(o),this.a.clear()):o&&this.r.isEnabled()&&this.u.info(o))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(s,o,c){try{this.v.account&&!c&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(m,-1),s?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),o)this.G(!1);else throw a}}G(s){this.r.isEnabled()!==s&&(this.r.setEnablement(s),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(s){if(!s){this.b=0;return}const o=y.UserDataSyncError.toUserDataSyncError(s);o instanceof y.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:o.code,service:this.n.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?P.isWeb&&o.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(o),this.b++),this.h.fire(o)}async J(){this.z.store(d,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(d,-1,!1)}M(){this.z.remove(d,-1)}async triggerSync(s,o,c){if(this.a.value===void 0)return this.f.cancel();if(o&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...s),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",c)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};i=pe([K(0,p.IProductService),K(1,y.IUserDataSyncStoreManagementService),K(2,y.IUserDataSyncStoreService),K(3,y.IUserDataSyncEnablementService),K(4,y.IUserDataSyncService),K(5,y.IUserDataSyncLogService),K(6,f.IUserDataSyncAccountService),K(7,h.ITelemetryService),K(8,l.IUserDataSyncMachinesService),K(9,g.IStorageService)],i),e.UserDataAutoSyncService=i;class r extends R.Disposable{constructor(s,o,c,a,u,w,b,U){super(),this.j=s,this.k=o,this.l=c,this.m=a,this.n=u,this.p=w,this.r=b,this.s=U,this.b=this.B(new R.MutableDisposable),this.c=this.B(new T.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new T.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}u(){this.b.value=(0,k.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(s,o){const c=(0,k.createCancelablePromise)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(u){if((0,A.isCancellationError)(u))return}return this.y(s,o,a)});return this.i=c,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const s=await this.l.getPreviousUserDataSyncStore(),o=this.l.userDataSyncStore;return!!o&&!!s&&(!(0,S.isEqual)(o.defaultUrl,s.defaultUrl)||!(0,S.isEqual)(o.insidersUrl,s.insidersUrl)||!(0,S.isEqual)(o.stableUrl,s.stableUrl))}async y(s,o,c){this.r.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.z(o,c)}catch(u){if(this.r.error(u),a=u,y.UserDataSyncError.toUserDataSyncError(u).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(o,c),a=void 0}catch(w){this.r.error(w),a=w}}this.f.fire(a)}async z(s,o){if(this.h=await this.n.createSyncTask(this.g,s),o.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const c=this.s.get(m,-1);if(c&&this.g&&c!==this.g.session)throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(o.isCancellationRequested)return;const u=a.find(w=>w.isCurrent);if(u?.disabled)throw new y.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(w){throw new y.UserDataAutoSyncError((0,D.toErrorMessage)(w),w instanceof y.UserDataSyncError?w.code:"Unknown")}this.g&&this.g.session!==c&&this.s.store(m,this.g.session,-1,1),!o.isCancellationRequested&&(u||await this.p.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}r.a="Interval"}),define(oe[275],ae([0,1,7,181,15,13,45,20,29,26,18,41,121,120,119,16,122,117,118,4,123,43]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let i=class Ve{constructor(t,s,o,c,a,u,w,b,U,N){this.e=t,this.f=s,this.g=o,this.h=a,this.i=u,this.j=w,this.k=b,this.l=U,this.m=N,this.d=c.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const s=this.K(t.content,"profiles");return(0,v.parseUserDataProfilesManifest)(s)}return[]}async getRemoteSyncResourceHandles(t,s){return(await this.e.getAllResourceRefs(t,s?.collection)).map(({created:c,ref:a})=>({created:c,uri:this.I({remote:!0,syncResource:t,profile:s?.id??this.k.defaultProfile.id,collection:s?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(t,s){return(await this.f.getAllRefs(s,t)).map(({created:c,ref:a})=>({created:c,uri:this.I({remote:!1,syncResource:t,profile:s.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const s=this.J(t),o=s?this.k.profiles.find(c=>c.id===s.profile):void 0;return s&&o?{profile:o,syncResource:s?.syncResource}:void 0}async getAssociatedResources({uri:t}){const s=this.J(t);if(!s)return[];const o=this.k.profiles.find(c=>c.id===s.profile);switch(s.syncResource){case"settings":return this.r(t,o);case"keybindings":return this.t(t,o);case"tasks":return this.v(t,o);case"snippets":return this.x(t,o);case"globalState":return this.C(t,o);case"extensions":return this.z(t,o);case"profiles":return this.F(t,o)}}async getMachineId({uri:t}){const s=this.J(t);if(!!s){if(s.remote){if(s.ref){const{content:o}=await this.L(s.syncResource,s.ref,s.collection);if(o)return this.K(o,s.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const s=this.J(t);if(!s||s.node===Ve.a)return null;if(s.ref){const o=await this.n(s.remote,s.syncResource,s.profile,s.collection,s.ref);return s.node&&o?this.o(s.syncResource,o,s.node):o}return!s.remote&&!s.node?this.q(s.syncResource,s.profile):null}async n(t,s,o,c,a){if(t){const{content:w}=await this.L(s,a,c);return w}const u=this.k.profiles.find(w=>w.id===o);return u?this.f.resolveContent(u,s,a):null}o(t,s,o){const c=this.K(s,t);switch(t){case"settings":return this.s(c,o);case"keybindings":return this.u(c,o);case"tasks":return this.w(c,o);case"snippets":return this.y(c,o);case"globalState":return this.D(c,o);case"extensions":return this.A(c,o);case"profiles":return this.G(c,o)}}async q(t,s){const o=this.k.profiles.find(c=>c.id===s);if(!o)return null;switch(t){case"globalState":return this.E(o);case"extensions":return this.B(o);case"profiles":return this.H(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,s){const o=this.d.joinPath(t,"settings.json"),c=s?s.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}s(t,s){switch(s){case"settings.json":return(0,g.parseSettingsSyncContent)(t.content).settings}return null}t(t,s){const o=this.d.joinPath(t,"keybindings.json"),c=s?s.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}u(t,s){switch(s){case"keybindings.json":return(0,h.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,s){const o=this.d.joinPath(t,"tasks.json"),c=s?s.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}w(t,s){switch(s){case"tasks.json":return(0,f.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,s){const o=await this.resolveContent(t);if(o){const c=this.K(o,"snippets");if(c){const a=(0,p.parseSnippets)(c),u=[];for(const w of Object.keys(a)){const b=this.d.joinPath(t,w),U=s?this.d.joinPath(s.snippetsHome,w):this.d.joinPath(t,Ve.a);u.push({resource:b,comparableResource:U})}return u}}return[]}y(t,s){return(0,p.parseSnippets)(t)[s]||null}z(t,s){const o=this.d.joinPath(t,"extensions.json"),c=s?this.I({remote:!1,syncResource:"extensions",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}A(t,s){switch(s){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:s}=await this.m.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(s,!0)}C(t,s){const o=this.d.joinPath(t,"globalState.json"),c=s?this.I({remote:!1,syncResource:"globalState",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}D(t,s){switch(s){case"globalState.json":return(0,d.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const s=await this.m.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,d.stringify)(s,!0)}F(t,s){const o=this.d.joinPath(t,"profiles.json"),c=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:c}]}G(t,s){switch(s){case"profiles.json":return(0,I.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,v.stringifyLocalProfiles)(this.k.profiles.filter(s=>!s.isDefault&&!s.isTransient),!0)}I(t){const s=t.remote?Ve.b:Ve.c,o=[t.syncResource,t.profile];return t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(k.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:s,path:"/"}),...o)}J(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const s=[];for(;t.path!=="/";)s.unshift(this.d.basename(t)),t=this.d.dirname(t);if(s.length<2)return;const o=t.authority===Ve.b,c=s.shift(),a=s.shift();let u,w,b;for(;s.length;){const U=s.shift();U.startsWith("collection:")?u=U.substring(11):U.startsWith("ref:")?w=U.substring(4):b=U}return{remote:o,syncResource:c,profile:a,collection:u,ref:w,node:b}}K(t,s){try{const o=JSON.parse(t);if((0,E.isSyncData)(o))return o}catch(o){this.g.error(o)}throw new S.UserDataSyncError((0,n.localize)(0,null),"IncompatibleRemoteContent",s)}async L(t,s,o){const c=await this.e.resolveResourceContent(t,s,o);return{ref:s,content:c}}};i.a="not-existing-resource",i.b="remote-backup",i.c="local-backup",i=pe([K(0,S.IUserDataSyncStoreService),K(1,S.IUserDataSyncBackupStoreService),K(2,S.IUserDataSyncLogService),K(3,P.IUriIdentityService),K(4,D.IEnvironmentService),K(5,R.IStorageService),K(6,A.IFileService),K(7,C.IUserDataProfilesService),K(8,y.IConfigurationService),K(9,m.IInstantiationService)],i),e.UserDataSyncResourceProviderService=i}),define(oe[276],ae([0,1,21,6,23,38,3,2,22,14,31,16,30,4,20,19,18,117,118,119,120,121,122,123,26]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v,I,i,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let o=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(b,U,N,$,F,L,j,z,V){super(),this.v=b,this.w=U,this.y=N,this.z=$,this.C=F,this.D=L,this.F=j,this.G=z,this.H=V,this.f="uninitialized",this.g=this.B(new T.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new T.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new T.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new T.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new T.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new T.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=U.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(s,-1,void 0),this.B((0,R.toDisposable)(()=>this.W()))}async createSyncTask(b,U){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),$=(0,C.generateUuid)();try{const z=(0,t.createSyncHeaders)($);U&&(z["Cache-Control"]="no-cache"),b=await this.v.manifest(b,z)}catch(z){const V=t.UserDataSyncError.toUserDataSyncError(z);throw u(V,$,this.w,this.C),V}const F=!1,L=this;let j;return{manifest:b,async run(){if(F)throw new Error("Can run a task only once");j=(0,n.createCancelablePromise)(z=>L.I(b,!1,$,z)),await j.finally(()=>j=void 0),L.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),L.S()},stop(){return j?.cancel(),L.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const b=new Date().getTime(),U=(0,C.generateUuid)(),N=(0,t.createSyncHeaders)(U);let $;try{$=await this.v.manifest(null,N)}catch(j){const z=t.UserDataSyncError.toUserDataSyncError(j);throw u(z,U,this.w,this.C),z}await this.resetLocal();const F=this,L=new D.CancellationTokenSource;return{id:U,async merge(){return F.I($,!0,U,L.token)},async apply(){try{try{await F.L($,U,L.token)}catch(j){if(t.UserDataSyncError.toUserDataSyncError(j).code==="MethodNotFound")F.z.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.z.info("Applying manual sync again..."),await F.L($,U,L.token);else throw j}}catch(j){throw F.z.error(j),j}F.z.info(`Sync done. Took ${new Date().getTime()-b}ms`),F.S()},async stop(){L.cancel(),await F.N(),await F.resetLocal()}}}async I(b,U,N,$){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(F,b,U,N,$));const L=F.enabled.find(j=>j.resource==="profiles");if(L){const j=await L.getLastSyncedProfiles()||[];if($.isCancellationRequested)return;await this.J(j,b,U,N,$)}}finally{this.l.fire(this.k)}}async J(b,U,N,$,F){for(const L of b){if(F.isCancellationRequested)return;const j=this.G.profiles.find(V=>V.id===L.id);if(!j){this.z.error(`Profile with id:${L.id} and name: ${L.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",L.name);const z=this.getOrCreateActiveProfileSynchronizer(j,L);this.k.push(...await this.M(z,U,N,$,F))}for(const[L,j]of this.u.entries())this.G.profiles.some(z=>z.id===j[0].profile.id)||(j[1].dispose(),this.u.delete(L))}async L(b,U,N){const $=this.U();for(const V of $){if(N.isCancellationRequested)return;await V.apply(U,N)}const F=$.find(V=>V.profile.isDefault);if(!F)return;const L=F.enabled.find(V=>V.resource==="profiles");if(!L)return;const z=(await L.getRemoteSyncedProfiles(b?.latest??null)||[]).filter(V=>$.every(Q=>Q.profile.id!==V.id));z.length&&await this.J(z,b,!1,U,N)}async M(b,U,N,$,F){return(await b.sync(U,N,$,F)).map(([j,z])=>({profile:b.profile,syncResource:j,error:z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(b=>b.stop()))}async resolveContent(b){const U=await this.H.resolveContent(b);if(U)return U;for(const N of this.U())for(const $ of N.enabled){const F=await $.resolveContent(b);if(F)return F}return null}async replace(b){this.X();const U=this.H.resolveUserDataSyncResource(b);if(!U)return;const N=await this.resolveContent(b.uri);!N||await this.O(U.profile,async $=>{if(U.syncResource===$.resource)return await $.replace(N),!0})}async accept(b,U,N,$){this.X(),await this.O(b.profile,async F=>{if(b.syncResource===F.resource)return await F.accept(U,N),$&&await F.apply((0,S.isBoolean)($)?!1:$.force,(0,t.createSyncHeaders)((0,C.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(b,U){return this.H.getRemoteSyncResourceHandles(b,U)}async getLocalSyncResourceHandles(b,U){return this.H.getLocalSyncResourceHandles(b,U??this.G.defaultProfile)}async getAssociatedResources(b){return this.H.getAssociatedResources(b)}async getMachineId(b){return this.H.getMachineId(b)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async U=>{if(U.resource!=="globalState"&&await U.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async U=>{if(await U.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(b){this.z.error(b)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(s,-1);for(const[b]of this.u.values())try{await b.resetLocal()}catch(U){this.z.error(U)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const b=await this.H.getRemoteSyncedProfiles(),U=b.map(L=>L.collection),N=await this.v.getAllCollections(),$=N.filter(L=>!U.includes(L));$.length&&(this.z.info(`Deleting ${$.length} redundant collections on server`),await Promise.allSettled($.map(L=>this.v.deleteCollection(L))),this.z.info("Deleted redundant collections on server"));const F=b.filter(L=>N.includes(L.collection));if(F.length!==b.length){this.z.info("Updating remote profiles with invalid collections on server");const L=this.y.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await L.updateRemoteProfiles(F,null),this.z.info("Updated remote profiles on server")}finally{L.dispose()}}}async O(b,U){const N=new R.DisposableStore;try{const $=this.u.get(b.id);if($){const V=await this.P($[0],U,N);return(0,S.isUndefined)(V)?null:V}if(b.isDefault){const V=N.add(this.y.createInstance(c,b,void 0)),Q=await this.P(V,U,N);return(0,S.isUndefined)(Q)?null:Q}if(this.G.isEnabled())return null;const F=N.add(this.y.createInstance(r.UserDataProfilesManifestSynchroniser,b,void 0)),L=await this.v.manifest(null),z=(await F.getRemoteSyncedProfiles(L?.latest??null)||[]).find(V=>V.id===b.id);if(z){const V=N.add(this.y.createInstance(c,b,z.collection)),Q=await this.P(V,U,N);return(0,S.isUndefined)(Q)?null:Q}return null}finally{N.dispose()}}async P(b,U,N){const $=[...b.enabled,...b.disabled.map(F=>N.add(b.createSynchronizer(F)))];for(const F of $){const L=await U(F);if(!(0,S.isUndefined)(L))return L}}Q(b){const U=this.f;this.f!==b&&(this.f=b,this.g.fire(b),U==="hasConflicts"&&this.S())}R(){const b=this.U().map(U=>U.conflicts).flat();(0,k.equals)(this.i,b,(U,N)=>U.profile.id===N.profile.id&&U.syncResource===N.syncResource&&(0,k.equals)(U.conflicts,N.conflicts,($,F)=>(0,P.isEqual)($.previewResource,F.previewResource)))||(this.i=b,this.j.fire(b))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(s,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(b,U){let N=this.u.get(b.id);if(N&&N[0].collection!==U?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(b.id)),!N){const $=new R.DisposableStore,F=$.add(this.y.createInstance(c,b,U?.collection));$.add(F.onDidChangeStatus(L=>this.Q(L))),$.add(F.onDidChangeConflicts(L=>this.R())),$.add(F.onDidChangeLocal(L=>this.h.fire(L))),this.u.set(b.id,N=[F,$])}return N[0]}U(){const b=[];for(const[U]of this.u.values())b.push(U);return b}W(){this.u.forEach(([,b])=>b.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};o=pe([K(0,t.IUserDataSyncStoreService),K(1,t.IUserDataSyncStoreManagementService),K(2,g.IInstantiationService),K(3,t.IUserDataSyncLogService),K(4,y.ITelemetryService),K(5,h.IStorageService),K(6,t.IUserDataSyncEnablementService),K(7,f.IUserDataProfilesService),K(8,t.IUserDataSyncResourceProviderService)],o),e.UserDataSyncService=o;let c=class extends R.Disposable{get enabled(){return this.f.sort((b,U)=>b[1]-U[1]).map(([b])=>b)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(b=>!this.l.isResourceEnabled(b))}get status(){return this.g}get conflicts(){return this.j}constructor(b,U,N,$,F,L,j,z,V,Q){super(),this.profile=b,this.collection=U,this.l=N,this.m=$,this.n=F,this.r=L,this.t=j,this.u=z,this.v=V,this.w=Q,this.f=[],this.g="idle",this.h=this.B(new T.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new T.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new T.Emitter),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([Y,H])=>this.y(Y,H))),this.B((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,Y])=>Y.dispose())));for(const Y of t.ALL_SYNC_RESOURCES)N.isResourceEnabled(Y)&&this.z(Y)}y(b,U){U?this.z(b):this.C(b)}z(b){if(this.f.some(([F])=>F.resource===b))return;if(b==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(b==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const U=new R.DisposableStore,N=U.add(this.createSynchronizer(b));U.add(N.onDidChangeStatus(()=>this.G())),U.add(N.onDidChangeConflicts(()=>this.H())),U.add(N.onDidChangeLocal(()=>this.i.fire(b)));const $=this.I(b);this.f.push([N,$,U])}C(b){const U=this.f.findIndex(([N])=>N.resource===b);if(U!==-1){const[[N,,$]]=this.f.splice(U,1);$.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,F=>this.u.error(F))}}createSynchronizer(b){switch(b){case"settings":return this.m.createInstance(v.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(m.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(I.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(i.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(b,U,N,$){if($.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const L=[],j=(0,t.createSyncHeaders)(N),z=(this.collection?b?.collections?.[this.collection]?.latest:b?.latest)??null,V=U?await this.D(z):{};for(const Q of F){if($.isCancellationRequested)return[];if(!this.l.isResourceEnabled(Q.resource))return[];try{if(U){const Y=await Q.preview(z,V,j);if(Y)for(const H of Y.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await Q.merge(H.previewResource)}else await Q.sync(z,j)}catch(Y){const H=t.UserDataSyncError.toUserDataSyncError(Y);if(u(H,N,this.r,this.t),a(Y))throw H;this.u.error(Y),this.u.error(`${Q.resource}: ${(0,A.toErrorMessage)(Y)}`),L.push([Q.resource,H])}}return L}finally{this.G()}}async apply(b,U){const N=(0,t.createSyncHeaders)(b);for(const $ of this.enabled){if(U.isCancellationRequested)return;try{await $.apply(!1,N)}catch(F){const L=t.UserDataSyncError.toUserDataSyncError(F);if(u(L,b,this.r,this.t),a(F))throw L;this.u.error(F),this.u.error(`${$.resource}: ${(0,A.toErrorMessage)(F)}`)}}}async stop(){for(const b of this.enabled)try{b.status!=="idle"&&await b.stop()}catch(U){this.u.error(U)}}async resetLocal(){for(const b of this.enabled)try{await b.resetLocal()}catch(U){this.u.error(`${b.resource}: ${(0,A.toErrorMessage)(U)}`),this.u.error(U)}}async D(b){if(!this.profile.isDefault)return{};const U=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find($=>$ instanceof v.SettingsSynchroniser);if(N){const $=await N.getRemoteUserDataSyncConfiguration(b);return{...U,...$}}return U}F(b){this.g!==b&&(this.g=b,this.h.fire(b))}G(){return this.H(),this.enabled.some(b=>b.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(b=>b.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const b=this.enabled.filter(U=>U.status==="hasConflicts").filter(U=>U.conflicts.conflicts.length>0).map(U=>U.conflicts);(0,k.equals)(this.j,b,(U,N)=>U.syncResource===N.syncResource&&(0,k.equals)(U.conflicts,N.conflicts,($,F)=>(0,P.isEqual)($.previewResource,F.previewResource)))||(this.j=b,this.k.fire(b))}I(b){switch(b){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};c=pe([K(2,t.IUserDataSyncEnablementService),K(3,g.IInstantiationService),K(4,p.IExtensionGalleryService),K(5,t.IUserDataSyncStoreManagementService),K(6,y.ITelemetryService),K(7,t.IUserDataSyncLogService),K(8,f.IUserDataProfilesService),K(9,E.IConfigurationService)],c);function a(w){if(w instanceof t.UserDataSyncError)switch(w.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function u(w,b,U,N){N.publicLog2("sync/error",{code:w.code,serverCode:w instanceof t.UserDataSyncStoreError?String(w.serverCode):void 0,url:w instanceof t.UserDataSyncStoreError?w.url:void 0,resource:w.resource,executionId:b,service:U.userDataSyncStore.url.toString()})}}),define(oe[277],ae([0,1,3,2,7,18,26]),function(Z,e,k,n,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(p,g){return{...p,profile:(0,A.reviveProfile)(p.profile,g.profilesHome.scheme)}}function P(p){return{created:p.created,uri:D.URI.revive(p.uri)}}class S{constructor(g,h,y){this.c=g,this.d=h,this.f=y,this.a=new Map,this.b=new k.Emitter}listen(g,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${h}`)}async call(g,h,y){try{return await this.g(g,h,y)}catch(f){throw this.f.error(f),f}}async g(g,h,y){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),D.URI.revive(y[1]),y[2],y[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(y[0],(0,A.reviveProfile)(y[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(y[0],y[1]);case"replace":return this.c.replace(P(y[0]));case"getAssociatedResources":return this.c.getAssociatedResources(P(y[0]));case"getMachineId":return this.c.getMachineId(P(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const f=h.substring(11),l=y[0],d=this.h(l);switch(y=y.slice(1),f){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(g){const h=this.a.get(this.j(g));if(!h)throw new Error(`Manual sync taks not found: ${g}`);return h}async i(){const g=await this.c.createManualSyncTask();return this.a.set(this.j(g.id),g),g.id}j(g){return`manualSyncTask-${g}`}}e.UserDataSyncChannel=S;let C=class extends n.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(g,h){super(),this.k=h,this.b="uninitialized",this.c=this.B(new k.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new k.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new k.Emitter),this.onSyncErrors=this.j.event,this.a={call(y,f,l){return g.call(y,f,l).then(null,d=>{throw T.UserDataSyncError.toUserDataSyncError(d)})},listen(y,f){return g.listen(y,f)}},this.a.call("_getInitialData").then(([y,f,l])=>{this.l(y),this.m(f),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(d=>this.l(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.n(d)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.m(y))),this.B(this.a.listen("onSyncErrors")(y=>this.j.fire(y.map(f=>({...f,error:T.UserDataSyncError.toUserDataSyncError(f.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const g=await this.a.call("createManualSyncTask"),h=this;return new E(g,{async call(f,l,d){return h.a.call(`manualSync/${f}`,[g,...Array.isArray(l)?l:[l]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(g,h,y,f){return this.a.call("accept",[g,h,y,f])}resolveContent(g){return this.a.call("resolveContent",[g])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(g,h){return(await this.a.call("getLocalSyncResourceHandles",[g,h])).map(({created:f,uri:l})=>({created:f,uri:D.URI.revive(l)}))}async getRemoteSyncResourceHandles(g,h){return(await this.a.call("getRemoteSyncResourceHandles",[g,h])).map(({created:f,uri:l})=>({created:f,uri:D.URI.revive(l)}))}async getAssociatedResources(g){return(await this.a.call("getAssociatedResources",[g])).map(({resource:y,comparableResource:f})=>({resource:D.URI.revive(y),comparableResource:D.URI.revive(f)}))}getMachineId(g){return this.a.call("getMachineId",[g])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(g){return this.a.call("replace",[g])}async l(g){this.b=g,this.c.fire(g)}async m(g){this.f=g.map(h=>({syncResource:h.syncResource,profile:(0,A.reviveProfile)(h.profile,this.k.profilesHome.scheme),conflicts:h.conflicts.map(y=>({...y,baseResource:D.URI.revive(y.baseResource),localResource:D.URI.revive(y.localResource),remoteResource:D.URI.revive(y.remoteResource),previewResource:D.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}n(g){this.h!==g&&(this.h=g,this.i.fire(g))}};C=pe([K(1,A.IUserDataProfilesService)],C),e.UserDataSyncChannelClient=C;class E extends n.Disposable{constructor(g,h){super(),this.id=g,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[278],ae([0,1,6,23,9,3,2,139,5,22,14,7,31,16,15,13,25,60,45,20,26]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const I="sync.previous.store",i="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",s=100,o=1e3*60*5;let c=class extends T.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(v.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(v.SYNC_SERVICE_URL_TYPE,N,-1,P.isWeb?0:1)}constructor(N,$,F){super(),this.f=N,this.g=$,this.h=F,this.a=this.B(new A.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(A.Event.filter(F.onDidChangeValue,L=>L.key===v.SYNC_SERVICE_URL_TYPE&&L.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[v.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(v.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,$){N=P.isWeb&&N?.web?{...N,...N.web}:N;const F={...N||{},...$||{}};if(F&&(0,C.isString)(F.url)&&(0,C.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(L=>Array.isArray(F.authenticationProviders[L].scopes))){const L=F,j=!!L.canSwitch&&!$?.url,z=L.url===L.insidersUrl?"insiders":"stable",V=(j?this.c:void 0)||z,Q=$?.url||(V==="insiders"?L.insidersUrl:V==="stable"?L.stableUrl:L.url);return{url:E.URI.parse(Q),type:V,defaultType:z,defaultUrl:E.URI.parse(L.url),stableUrl:E.URI.parse(L.stableUrl),insidersUrl:E.URI.parse(L.insidersUrl),canSwitch:j,authenticationProviders:Object.keys(L.authenticationProviders).reduce((Y,H)=>(Y.push({id:H,scopes:L.authenticationProviders[H].scopes}),Y),[])}}}};c=pe([K(0,f.IProductService),K(1,g.IConfigurationService),K(2,m.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let a=class extends c{constructor(N,$,F){super(N,$,F);const L=this.h.get(I,-1);L&&(this.k=JSON.parse(L));const j=this.f[v.CONFIGURATION_SYNC_STORE_KEY];j?this.h.store(I,JSON.stringify(j),-1,1):this.h.remove(I,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};a=pe([K(0,f.IProductService),K(1,g.IConfigurationService),K(2,m.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let u=class extends T.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,$,F,L,j,z,V){super(),this.k=F,this.l=L,this.n=V,this.g=this.B(new A.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new A.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,d.getServiceMachineId)(j,z,V).then(Q=>{const Y={"X-Client-Name":`${$.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":$.version};return $.commit&&(Y["X-Client-Commit"]=$.commit),Y}),this.f=new b(s,o,this.k,this.l),this.r(),this.B((0,T.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,$){this.b={token:N,type:$}}p(N){this.a=N?(0,S.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(i,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(i,this.i.getTime(),-1,1),this.s=(0,k.createCancelablePromise)($=>(0,k.timeout)(this.i.getTime()-Date.now(),$).then(()=>this.t(void 0))),this.s.then(null,$=>null)):this.n.remove(i,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const F=await this.w($,{type:"GET",headers:N},[],n.CancellationToken.None);return(await(0,l.asJson)(F))?.map(({id:L})=>L)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const F=await this.w($,{type:"POST",headers:N},[],n.CancellationToken.None),L=await(0,l.asTextOrError)(F);if(!L)throw new v.UserDataSyncStoreError("Server did not return the collection id",$,"NoCollection",F.res.statusCode,F.res.headers[v.HEADER_OPERATION_ID]);return L}async deleteCollection(N,$={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=N?(0,S.joinPath)(this.a,"collection",N).toString():(0,S.joinPath)(this.a,"collection").toString();$={...$},await this.w(F,{type:"DELETE",headers:$},[],n.CancellationToken.None)}async getAllResourceRefs(N,$){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.u(this.a,$,N),L={},j=await this.w(F.toString(),{type:"GET",headers:L},[],n.CancellationToken.None);return(await(0,l.asJson)(j)||[]).map(({url:V,created:Q})=>({ref:(0,S.relativePath)(F,F.with({path:V})),created:Q*1e3}))}async resolveResourceContent(N,$,F,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.u(this.a,F,N),$).toString();L={...L},L["Cache-Control"]="no-cache";const z=await this.w(j,{type:"GET",headers:L},[],n.CancellationToken.None);return await(0,l.asTextOrError)(z)}async deleteResource(N,$,F){if(!this.a)throw new Error("No settings sync store url configured.");const L=$!==null?(0,S.joinPath)(this.u(this.a,F,N),$).toString():this.u(this.a,F,N).toString(),j={};await this.w(L,{type:"DELETE",headers:j},[],n.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.a,"resource").toString(),$={"Content-Type":R.Mimes.text};await this.w(N,{type:"DELETE",headers:$},[],n.CancellationToken.None)}async readResource(N,$,F,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.u(this.a,F,N),"latest").toString();L={...L},L["Cache-Control"]="no-cache",$&&(L["If-None-Match"]=$.ref);const z=await this.w(j,{type:"GET",headers:L},[304],n.CancellationToken.None);let V=null;if(z.res.statusCode===304&&(V=$),V===null){const Q=z.res.headers.etag;if(!Q)throw new v.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);const Y=await(0,l.asTextOrError)(z);if(!Y&&z.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",j,"EmptyResponse",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);V={ref:Q,content:Y}}return V}async writeResource(N,$,F,L,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,L,N).toString();j={...j},j["Content-Type"]=R.Mimes.text,F&&(j["If-Match"]=F);const V=await this.w(z,{type:"POST",data:$,headers:j},[],n.CancellationToken.None),Q=V.res.headers.etag;if(!Q)throw new v.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",V.res.statusCode,V.res.headers[v.HEADER_OPERATION_ID]);return Q}async manifest(N,$={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.a,"manifest").toString();$={...$},$["Content-Type"]="application/json",N&&($["If-None-Match"]=N.ref);const L=await this.w(F,{type:"GET",headers:$},[304],n.CancellationToken.None);let j=null;if(L.res.statusCode===304&&(j=N),!j){const V=L.res.headers.etag;if(!V)throw new v.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",L.res.statusCode,L.res.headers[v.HEADER_OPERATION_ID]);const Q=await(0,l.asTextOrError)(L);if(!Q&&L.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",F,"EmptyResponse",L.res.statusCode,L.res.headers[v.HEADER_OPERATION_ID]);Q&&(j={...JSON.parse(Q),ref:V})}const z=this.n.get(r,-1);return z&&j&&z!==j.session&&this.v(),j===null&&z&&this.v(),j&&this.n.store(r,j.session,-1,1),j}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(N,$,F){return $?(0,S.joinPath)(N,"collection",$,"resource",F):(0,S.joinPath)(N,"resource",F)}v(){this.n.remove(r,-1),this.n.remove(t,-1)}async w(N,$,F,L){if(!this.b)throw new v.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const j=await this.c;$.headers={...$.headers||{},...j,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y($.headers),this.l.trace("Sending request to server",{url:N,type:$.type,headers:{...$.headers,authorization:void 0}});let z;try{z=await this.f.request(N,$,L)}catch(q){if(!(q instanceof v.UserDataSyncStoreError)){let G="RequestFailed";const X=(0,D.getErrorMessage)(q).toLowerCase();X.includes("xhr timeout")?G="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?G="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?G="RequestPathNotEscaped":X.includes("headers must be an object")?G="RequestHeadersNotObject":(0,D.isCancellationError)(q)&&(G="RequestCanceled"),q=new v.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,G,void 0,void 0)}throw this.l.info("Request failed",N),q}const V=z.res.headers[v.HEADER_OPERATION_ID],Q={url:N,status:z.res.statusCode,"execution-id":$.headers[v.HEADER_EXECUTION_ID],"operation-id":V},Y=(0,l.isSuccess)(z)||z.res.statusCode&&F.indexOf(z.res.statusCode)!==-1;let H="";if(Y?this.l.trace("Request succeeded",Q):(this.l.info("Request failed",Q),H=await(0,l.asText)(z)||""),z.res.statusCode===401)throw this.b=void 0,this.g.fire(),new v.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",z.res.statusCode,V);if(this.h.fire(),z.res.statusCode===404)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",z.res.statusCode,V);if(z.res.statusCode===405)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because the requested endpoint is not found (405). ${H}`,N,"MethodNotFound",z.res.statusCode,V);if(z.res.statusCode===409)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",z.res.statusCode,V);if(z.res.statusCode===410)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",z.res.statusCode,V);if(z.res.statusCode===412)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",z.res.statusCode,V);if(z.res.statusCode===413)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",z.res.statusCode,V);if(z.res.statusCode===426)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",z.res.statusCode,V);if(z.res.statusCode===429){const q=z.res.headers["retry-after"];throw q?(this.t(new Date(Date.now()+parseInt(q)*1e3)),new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",z.res.statusCode,V)):new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",z.res.statusCode,V)}if(!Y)throw new v.UserDataSyncStoreError("Server returned "+z.res.statusCode,N,"Unknown",z.res.statusCode,V);return z}y(N){let $=this.n.get(t,-1);$===void 0&&($=(0,p.generateUuid)(),this.n.store(t,$,-1,1)),N["X-Machine-Session-Id"]=$;const F=this.n.get(r,-1);F!==void 0&&(N["X-User-Session-Id"]=F)}};u=pe([K(1,f.IProductService),K(2,l.IRequestService),K(3,v.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,y.IFileService),K(6,m.IStorageService)],u),e.UserDataSyncStoreClient=u;let w=class extends u{constructor(N,$,F,L,j,z,V){super(N.userDataSyncStore?.url,$,F,L,j,z,V),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};w=pe([K(0,v.IUserDataSyncStoreManagementService),K(1,f.IProductService),K(2,l.IRequestService),K(3,v.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,y.IFileService),K(6,m.IStorageService)],w),e.UserDataSyncStoreService=w;class b{constructor(N,$,F,L){this.c=N,this.d=$,this.f=F,this.g=L,this.a=[],this.b=void 0}request(N,$,F){if(this.h()&&this.i(),$.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new v.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request($,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=b}),define(oe[279],ae([0,1,3,58,25,20,19,274,26,78,81]),function(Z,e,k,n,D,A,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(g,h,y,f,l,d,m,v,I,i,r){super(g,h,y,f,l,m,v,I,i,r),this.B(k.Event.debounce(k.Event.any(k.Event.map(d.onDidFocusWindow,()=>"windowFocus"),k.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(t,s)=>t?[...t,s]:[s],1e3)(t=>this.triggerSync(t,!0,!1)))}};E=pe([K(0,D.IProductService),K(1,P.IUserDataSyncStoreManagementService),K(2,P.IUserDataSyncStoreService),K(3,P.IUserDataSyncEnablementService),K(4,P.IUserDataSyncService),K(5,n.INativeHostService),K(6,P.IUserDataSyncLogService),K(7,S.IUserDataSyncAccountService),K(8,T.ITelemetryService),K(9,C.IUserDataSyncMachinesService),K(10,A.IStorageService)],E),e.UserDataAutoSyncService=E}),define(oe[280],ae([0,1,99,24,5,22]),function(Z,e,k,n,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(S){function C(){let E=S.scheme===n.Schemas.file?(0,A.originalFSPath)(S):S.toString();return D.isLinux||(E=E.toLowerCase()),(0,k.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:S}}e.getWorkspaceIdentifier=T;function R(S,C){function E(){if(S.scheme!==n.Schemas.file)return(0,k.createHash)("md5").update(S.toString()).digest("hex");if(!C)return;let g;return D.isLinux?g=C.ino:D.isMacintosh?g=C.birthtime.getTime():D.isWindows&&(typeof C.birthtimeMs=="number"?g=Math.floor(C.birthtimeMs):g=C.birthtime.getTime()),(0,k.createHash)("md5").update(S.fsPath).update(g?String(g):"").digest("hex")}const p=E();if(typeof p=="string")return{id:p,uri:S}}e.getSingleFolderWorkspaceIdentifier=R;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(oe[281],ae([0,1,6,9,2,12,28,15,57,8,58,76,115,280]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends D.Disposable{constructor(f,l,d,m){super(),this.a=f,this.b=l,this.c=d,this.f=m,this.B(new k.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=await T.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new E.StorageClient(this.f.getChannel("storage"));await Promise.all(f.map(async d=>{const m=(0,A.join)(this.a.workspaceStorageHome.fsPath,d);d.length===g.NON_EMPTY_WORKSPACE_ID_LENGTH||d===p.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(i=>i.workspace?.id===d)||await l.isUsed(m)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await T.Promises.rm(m))}))}catch(f){(0,n.onUnexpectedError)(f)}}};h=pe([K(0,R.INativeEnvironmentService),K(1,S.ILogService),K(2,C.INativeHostService),K(3,P.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(oe[124],ae([0,1,53,6,12,14,28,151,290,291]),function(Z,e,k,n,D,A,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(i,r){let t=r.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=r}}e.ExtractError=C;function E(I){const i=I.externalFileAttributes>>16||33188;return[448,56,7].map(r=>i&r).reduce((r,t)=>r+t,i&61440)}function p(I){if(I instanceof C)return I;let i;return/end of central directory record signature not found/.test(I.message)&&(i="CorruptZip"),new C(i,I)}function g(I,i,r,t,s,o){const c=D.dirname(i),a=D.join(t,c);if(!a.startsWith(t))return Promise.reject(new Error(R.localize(0,null,i)));const u=D.join(t,i);let w;return o.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(T.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((b,U)=>{if(!o.isCancellationRequested)try{w=(0,k.createWriteStream)(u,{mode:r}),w.once("close",()=>b()),w.once("error",U),I.once("error",U),I.pipe(w)}catch(N){U(N)}}))}function h(I,i,r,t){let s=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{s.cancel(),I.close()}),new Promise((c,a)=>{const u=new n.Sequencer,w=b=>{b.isCancellationRequested||(o++,I.readEntry())};I.once("error",a),I.once("close",()=>s.then(()=>{t.isCancellationRequested||I.entryCount===o?c():a(new C("Incomplete",new Error(R.localize(1,null,o,I.entryCount))))},a)),I.readEntry(),I.on("entry",b=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(b.fileName)){w(t);return}const U=b.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(U)){const F=D.join(i,U);s=(0,n.createCancelablePromise)(L=>T.Promises.mkdir(F,{recursive:!0}).then(()=>w(L)).then(void 0,a));return}const N=f(I,b),$=E(b);s=(0,n.createCancelablePromise)(F=>u.queue(()=>N.then(L=>g(L,U,$,i,r,F).then(()=>w(F)))).then(null,a))})})}function y(I,i=!1){return new Promise((r,t)=>{(0,P.open)(I,i?{lazyEntries:!0}:void 0,(s,o)=>{s?t(p(s)):r((0,A.assertIsDefined)(o))})})}function f(I,i){return new Promise((r,t)=>{I.openReadStream(i,(s,o)=>{s?t(p(s)):r((0,A.assertIsDefined)(o))})})}function l(I,i){return new Promise((r,t)=>{const s=new S.ZipFile;i.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const o=(0,k.createWriteStream)(I);s.outputStream.pipe(o),s.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>r(I))})}e.zip=l;function d(I,i,r={},t){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=y(I,!0);return r.overwrite&&(o=o.then(c=>T.Promises.rm(i).then(()=>c))),o.then(c=>h(c,i,{sourcePathRegex:s},t))}e.extract=d;function m(I,i){return y(I).then(r=>new Promise((t,s)=>{r.on("entry",o=>{o.fileName===i&&f(r,o).then(c=>t(c),c=>s(c))}),r.once("close",()=>s(new Error(R.localize(2,null,i))))}))}function v(I,i){return m(I,i).then(r=>new Promise((t,s)=>{const o=[];r.once("error",s),r.on("data",c=>o.push(c)),r.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=v}),define(oe[282],ae([0,1,124,161]),function(Z,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(A){return(0,k.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=D}),define(oe[125],ae([0,1,6,23,38,9,3,2,37,24,12,5,22,54,14,7,31,28,124,160,96,15,263,30,33,51,79,234,265,282,218,235,42,70,13,4,8,25,19,29,18]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v,I,i,r,t,s,o,c,a,u,w,b,U,N,$,F,L,j,z,V,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(r.IExtensionManagementService);let Y=class extends i.AbstractExtensionManagementService{constructor(O,M,W,B,x,ie,J,_,se,ue,le,ye){super(O,M,W,ue,ye),this.Y=x,this.Z=ie,this.ab=J,this.bb=se,this.cb=le,this.X=new Map,this.kb=new P.ResourceSet;const Se=this.B(_.createInstance(a.ExtensionsLifecycle));this.S=this.B(_.createInstance(H,Ee=>Se.postUninstall(Ee))),this.U=this.B(new w.ExtensionsManifestCache(B,this)),this.W=this.B(_.createInstance(c.ExtensionsDownloader));const be=this.B(new b.ExtensionsWatcher(this,this.Y,ye,ie,le,se,W));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.jb(Ee))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(O){this.v.trace("ExtensionManagementService#zip",O.identifier.id);const M=await this.ib(O),W=await(0,d.zip)((0,p.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,M);return y.URI.file(W)}async unzip(O){return this.v.trace("ExtensionManagementService#unzip",O.toString()),(await this.install(O)).identifier}async getManifest(O){const{location:M,cleanup:W}=await this.eb(O),B=C.resolve(M.fsPath);try{return await(0,u.getManifest)(B)}finally{await W()}}getInstalled(O,M){return this.S.scanExtensions(O??null,M)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(O,M={}){this.v.trace("ExtensionManagementService#install",O.toString());const{location:W,cleanup:B}=await this.eb(O);try{const x=await(0,u.getManifest)(C.resolve(W.fsPath));if(x.engines&&x.engines.vscode&&!(0,N.isEngineValid)(x.engines.vscode,this.w.version,this.w.date))throw new Error(m.localize(0,null,(0,t.getGalleryExtensionId)(x.publisher,x.name),this.w.version));return await this.z(x,W,M)}finally{await B()}}async installFromLocation(O,M){this.v.trace("ExtensionManagementService#installFromLocation",O.toString());const W=await this.S.scanUserExtensionAtLocation(O);if(!W)throw new Error(`Cannot find a valid extension from the location ${O.toString()}`);return await this.nb([W],M),this.v.info("Successfully installed extension",W.identifier.id,M.toString()),W}getMetadata(O){return this.Y.scanMetadata(O.location)}async updateMetadata(O,M){this.v.trace("ExtensionManagementService#updateMetadata",O.identifier.id);const W={...M};return M.isPreReleaseVersion&&(W.preRelease=!0),O=await this.S.updateMetadata(O,W),this.U.invalidate(),O}async updateExtensionScope(O,M){return this.v.trace("ExtensionManagementService#updateExtensionScope",O.identifier.id),O=await this.S.updateMetadata(O,{isMachineScoped:M}),this.U.invalidate(),O}async reinstallFromGallery(O){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",O.identifier.id),!this.t.isEnabled())throw new Error(m.localize(1,null));const M=await this.getTargetPlatform(),[W]=await this.t.getExtensions([{...O.identifier,preRelease:O.preRelease}],{targetPlatform:M,compatible:!0},n.CancellationToken.None);if(!W)throw new Error(m.localize(2,null));await this.S.setUninstalled(O);try{await this.S.removeUninstalledExtension(O)}catch(B){throw new Error(m.localize(3,null,(0,D.toErrorMessage)(B)))}return this.installFromGallery(W)}markAsUninstalled(...O){return this.S.setUninstalled(...O)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(O,M){const{location:W}=await this.W.download(O,M);return W}async eb(O){if(O.scheme===S.Schemas.file)return{location:O,async cleanup(){}};this.v.trace("Downloading extension from",O.toString());const M=(0,p.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.ab.download(O,M),this.v.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.bb.del(M)}catch(B){this.v.error(B)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(O,M,W){let B;if(y.URI.isUri(M))B=new X(O,M,W,this.t,this.S,this.v);else{const x=t.ExtensionKey.create(M).toString();B=this.X.get(x),B||(this.X.set(x,B=new G(O,M,W,this.W,this.S,this.v)),B.waitUntilTaskIsFinished().then(()=>this.X.delete(x)))}return new ee(B,W.profileLocation,this.cb,this.y,this.Y,this.Z)}R(O,M){return new re(O,M.profileLocation,this.Z)}async ib(O){const M=async B=>{let x=await l.Promises.readdir(B);x=x.map(_=>C.join(B,_));const ie=await Promise.all(x.map(_=>l.Promises.stat(_)));let J=Promise.resolve([]);return ie.forEach((_,se)=>{const ue=x[se];_.isFile()&&(J=J.then(le=>[...le,ue])),_.isDirectory()&&(J=J.then(le=>M(ue).then(ye=>[...le,...ye])))}),J};return(await M(O.location.fsPath)).map(B=>({path:`extension/${C.relative(O.location.fsPath,B)}`,localPath:B}))}async jb({added:O,removed:M}){if(M)for(const W of M.extensions)this.v.info("Extensions removed from another source",W.id,M.profileLocation.toString()),this.p.fire({identifier:W,profileLocation:M.profileLocation});if(O){const B=(await this.S.scanExtensions(1,O.profileLocation)).filter(x=>O.extensions.some(ie=>(0,t.areSameExtensions)(ie,x.identifier)));this.m.fire(B.map(x=>(this.v.info("Extensions added from another source",x.identifier.id,O.profileLocation.toString()),{identifier:x.identifier,local:x,profileLocation:O.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(M=>this.kb.add(M)));const O=await this.bb.resolve(this.Y.userExtensionsLocation);for(const M of O.children??[])M.isDirectory&&this.kb.add(M.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(M=>this.mb(M)))}async mb(O){if(!O.affects(this.Y.userExtensionsLocation,1))return;const M=[];for(const W of O.rawAdded){if(this.kb.has(W)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(W),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(W,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(W).startsWith(".")||!(await this.bb.stat(W)).isDirectory)continue;const B=await this.S.scanUserExtensionAtLocation(W);B&&B.installedTimestamp===void 0&&(this.kb.add(W),M.push(B))}M.length&&(await this.nb(M,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",M.map(W=>W.identifier.id)))}async nb(O,M){await this.Z.addExtensionsToProfile(O.map(W=>[W,void 0]),M),this.m.fire(O.map(W=>({local:W,identifier:W.identifier,operation:1,profileLocation:M})))}};Y=pe([K(0,r.IExtensionGalleryService),K(1,z.ITelemetryService),K(2,L.ILogService),K(3,I.INativeEnvironmentService),K(4,o.IExtensionsScannerService),K(5,s.IExtensionsProfileScannerService),K(6,v.IDownloadService),K(7,F.IInstantiationService),K(8,$.IFileService),K(9,j.IProductService),K(10,V.IUriIdentityService),K(11,Q.IUserDataProfilesService)],Y),e.ExtensionManagementService=Y;let H=class extends R.Disposable{constructor(O,M,W,B){super(),this.j=O,this.k=M,this.l=W,this.m=B,this.h=this.B(new T.Emitter),this.onExtract=this.h.event,this.c=(0,p.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new k.Queue}async cleanUp(){await this.v()}async scanExtensions(O,M){const W={includeInvalid:!0,profileLocation:M};let B=[];return O===null||O===0?B.push(...await this.l.scanAllExtensions({includeInvalid:!0},W,!1)):O===1&&B.push(...await this.l.scanUserExtensions(W)),B=O!==null?B.filter(x=>x.type===O):B,Promise.all(B.map(x=>this.u(x)))}async scanAllUserExtensions(O){const M=await this.l.scanUserExtensions({includeAllVersions:!O,includeInvalid:!0});return Promise.all(M.map(W=>this.u(W)))}async scanUserExtensionAtLocation(O){try{const M=await this.l.scanExistingExtension(O,1,{includeInvalid:!0});if(M)return await this.u(M)}catch(M){this.m.error(M)}return null}async extractUserExtension(O,M,W,B){const x=O.toString(),ie=C.join(this.l.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),J=C.join(this.l.userExtensionsLocation.fsPath,x);try{await l.Promises.rm(J)}catch{throw new r.ExtensionManagementError(m.localize(4,null,J,O.id),r.ExtensionManagementErrorCode.Delete)}await this.p(O,M,ie,B),await this.l.updateMetadata(y.URI.file(ie),W);try{this.h.fire(y.URI.file(J)),await this.s(O,ie,J,Date.now()+2*60*1e3),this.m.info("Renamed to",J)}catch(_){try{await l.Promises.rm(ie)}catch{}if(_.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",O.id);else throw this.m.info(`Rename failed because of ${(0,A.getErrorMessage)(_)}. Deleted from extracted location`,ie),_}return this.t(y.URI.file(J),1)}async updateMetadata(O,M){return await this.l.updateMetadata(O.location,M),this.t(O.location,O.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...O){const M=O.map(W=>t.ExtensionKey.create(W));await this.n(W=>M.forEach(B=>{W[B.toString()]=!0,this.m.info("Marked extension as uninstalled",B.toString())}))}async setInstalled(O){await this.n(B=>delete B[O.toString()]);const W=(await this.scanAllUserExtensions(!0)).find(B=>t.ExtensionKey.create(B).equals(O))||null;return W?this.updateMetadata(W,{installedTimestamp:Date.now()}):null}async removeExtension(O,M){this.m.trace(`Deleting ${M} extension from disk`,O.identifier.id,O.location.fsPath),await l.Promises.rm(O.location.fsPath),this.m.info("Deleted from disk",O.identifier.id,O.location.fsPath)}async removeUninstalledExtension(O){await this.removeExtension(O,"uninstalled"),await this.n(M=>delete M[t.ExtensionKey.create(O).toString()])}async n(O){return this.g.queue(async()=>{let M;try{M=await l.Promises.readFile(this.c,"utf8")}catch(B){if(B.code!=="ENOENT")throw B}let W={};if(M)try{W=JSON.parse(M)}catch{}return O&&(O(W),Object.keys(W).length?await l.Promises.writeFile(this.c,JSON.stringify(W)):await l.Promises.rm(this.c)),W})}async p(O,M,W,B){this.m.trace(`Started extracting the extension from ${M} to ${W}`);try{await l.Promises.rm(W)}catch(x){throw new r.ExtensionManagementError(this.w(x).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(M,W,{sourcePath:"extension",overwrite:!0},B),this.m.info(`Extracted extension to ${W}:`,O.id)}catch(x){try{await l.Promises.rm(W)}catch{}let ie=r.ExtensionManagementErrorCode.Extract;throw x instanceof d.ExtractError&&(x.type==="CorruptZip"?ie=r.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(ie=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(x.message,ie)}}async s(O,M,W,B){try{await l.Promises.rename(M,W)}catch(x){if(E.isWindows&&x&&x.code==="EPERM"&&Date.now()<B)return this.m.info(`Failed renaming ${M} to ${W} with 'EPERM' error. Trying again...`,O.id),this.s(O,M,W,B);throw new r.ExtensionManagementError(x.message||m.localize(5,null,M,W),x.code||r.ExtensionManagementErrorCode.Rename)}}async t(O,M){const W=await this.l.scanExistingExtension(O,M,{includeInvalid:!0});if(W)return this.u(W);throw new Error(m.localize(6,null,O.path))}async u(O){const M=await this.k.resolve(O.location);let W,B;return M.children&&(W=M.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,B=M.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:O.identifier,type:O.type,isBuiltin:O.isBuiltin||!!O.metadata?.isBuiltin,location:O.location,manifest:O.manifest,targetPlatform:O.targetPlatform,validations:O.validations,isValid:O.isValid,readmeUrl:W,changelogUrl:B,publisherDisplayName:O.metadata?.publisherDisplayName||null,publisherId:O.metadata?.publisherId||null,isApplicationScoped:!!O.metadata?.isApplicationScoped,isMachineScoped:!!O.metadata?.isMachineScoped,isPreReleaseVersion:!!O.metadata?.isPreReleaseVersion,preRelease:!!O.metadata?.preRelease,installedTimestamp:O.metadata?.installedTimestamp,updated:!!O.metadata?.updated}}async v(){const O=await this.getUninstalledExtensions(),M=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const ie of M)O[t.ExtensionKey.create(ie).toString()]||W.add(ie.identifier.id.toLowerCase());const B=(0,t.groupByExtension)(M,ie=>ie.identifier);await k.Promises.settled(B.map(async ie=>{const J=ie.sort((_,se)=>g.rcompare(_.manifest.version,se.manifest.version))[0];W.has(J.identifier.id.toLowerCase())||await this.j(await this.u(J))}));const x=M.filter(ie=>ie.metadata&&O[t.ExtensionKey.create(ie).toString()]);await k.Promises.settled(x.map(ie=>this.removeUninstalledExtension(ie)))}w(O){const M=Array.isArray(O)?O:[O];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((W,B)=>new Error(`${W.message}${W.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}};H=pe([K(1,$.IFileService),K(2,o.IExtensionsScannerService),K(3,L.ILogService)],H),e.ExtensionsScanner=H;class q extends i.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,h.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(O,M,W,B,x){super(),this.identifier=O,this.source=M,this.l=W,this.m=B,this.n=x,this.j="Unverified",this.k=2}async o(O,M){try{const W=await this.p(O.key);if(W)return this.m.updateMetadata(W,O.metadata)}catch{throw E.isMacintosh?new r.ExtensionManagementError(m.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(m.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.s(O,M)}async p(O){if(!await this.q(O))return null;this.n.trace("Removing the extension from uninstalled list:",O.id);const W=await this.m.setInstalled(O);return this.n.info("Removed the extension from uninstalled list:",O.id),W}async q(O){return!!(await this.m.getUninstalledExtensions())[O.toString()]}async s({zipPath:O,key:M,metadata:W},B){const x=await this.m.extractUserExtension(M,O,W,B);return this.n.info("Extracting completed.",M.id),x}}class G extends q{constructor(O,M,W,B,x,ie){super(M.identifier,M,W,x,ie),this.t=O,this.u=M,this.v=B}async h(O){const W=(await this.m.scanExtensions(null,void 0)).find(J=>(0,t.areSameExtensions)(J.identifier,this.u.identifier));W&&(this.k=3);const B={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,U.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||W?.isMachineScoped,isBuiltin:this.l.isBuiltin||W?.isBuiltin,isSystem:W?.type===0?!0:void 0,updated:!!W,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.u.properties.isPreReleaseVersion||((0,h.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:W?.preRelease)};if(W?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(W,B),metadata:B};const{location:x,verificationStatus:ie}=await this.v.download(this.u,this.k);try{return this.j=ie,this.x(x.fsPath),{local:await this.o({zipPath:x.fsPath,key:t.ExtensionKey.create(this.u),metadata:B},O),metadata:B}}catch(J){try{await this.v.delete(x)}catch(_){this.n.warn("Error while deleting the downloaded file",x.toString(),(0,A.getErrorMessage)(_))}throw J}}async x(O){try{await(0,u.getManifest)(O)}catch(M){throw new r.ExtensionManagementError((0,i.joinErrors)(M).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=G;class X extends q{constructor(O,M,W,B,x,ie){super({id:(0,t.getGalleryExtensionId)(O.publisher,O.name)},M,W,x,ie),this.t=O,this.u=M,this.v=B}async h(O){const M=new t.ExtensionKey(this.identifier,this.t.version),B=(await this.m.scanExtensions(1,void 0)).find(J=>(0,t.areSameExtensions)(this.identifier,J.identifier)),x=await this.x(this.identifier.id,this.t.version,O);if(x.isApplicationScoped=(0,U.isApplicationScopedExtension)(this.t),x.isMachineScoped=this.l.isMachineScoped||B?.isMachineScoped,x.isBuiltin=this.l.isBuiltin||B?.isBuiltin,x.installedTimestamp=Date.now(),B)if(this.k=3,M.equals(new t.ExtensionKey(B.identifier,B.manifest.version)))try{await this.m.removeExtension(B,"existing")}catch{throw new Error(m.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&g.gt(B.manifest.version,this.t.version)&&await this.m.setUninstalled(B);else{const J=await this.p(M);if(J)try{await this.m.removeExtension(J,"existing")}catch{throw new Error(m.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:C.resolve(this.u.fsPath),key:M,metadata:x},O),metadata:x}}async x(O,M,W){try{let[B]=await this.v.getExtensions([{id:O,version:M}],W);if(B||([B]=await this.v.getExtensions([{id:O}],W)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class ee{get verificationStatus(){return this.d.verificationStatus}constructor(O,M,W,B,x,ie){this.d=O,this.g=M,this.h=W,this.j=B,this.k=x,this.l=ie,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const O=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[O.local,O.metadata]],this.g),O}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class re extends i.AbstractExtensionTask{constructor(O,M,W){super(),this.extension=O,this.j=M,this.k=W}async h(O){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[283],ae([0,1,2,30,80,233,125,8,20]),function(Z,e,k,n,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends k.Disposable{constructor(E,p,g,h,y,f){super(),E.removeUninstalledExtensions(),(0,A.migrateUnsupportedExtensions)(E,p,g,h,f),D.ExtensionStorageService.removeOutdatedExtensionVersions(E,y)}};S=pe([K(0,T.INativeServerExtensionManagementService),K(1,n.IExtensionGalleryService),K(2,D.IExtensionStorageService),K(3,n.IGlobalExtensionEnablementService),K(4,P.IStorageService),K(5,R.ILogService)],S),e.ExtensionsContributions=S}),define(oe[292],ae([0,1,93,34,38,9,2,24,22,7,39,149,210,211,203,204,281,192,195,16,216,95,231,96,223,15,228,116,267,30,97,194,268,125,98,190,13,206,208,55,4,201,72,202,57,73,237,8,102,58,103,25,60,20,269,108,19,109,110,111,47,240,112,242,248,80,114,26,78,272,259,260,81,273,276,277,278,279,271,62,261,107,230,77,250,220,249,106,227,29,251,5,252,196,214,213,79,266,18,51,209,59,270,225,239,262,232,105,101,275,283,264]),function(Z,e,k,n,D,A,T,R,P,S,C,E,p,g,h,y,f,l,d,m,v,I,i,r,t,s,o,c,a,u,w,b,U,N,$,F,L,j,z,V,Q,Y,H,q,G,X,ee,re,te,O,M,W,B,x,ie,J,_,se,ue,le,ye,Se,be,Ee,Ne,Fe,Ye,ze,ce,de,ge,Ce,Pe,Ae,De,je,Te,Me,Be,ke,Oe,ne,he,fe,me,we,Ie,Re,He,$e,Le,qe,Ge,et,ot,wt,kt,At,vt,Lt,Tt,St,Ot,Nt,Ut,Mt,Ft,bt,Et,jt,$t,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Bt extends T.Disposable{constructor(ve){super(),this.f=ve,this.a=this.B(new E.Server),this.b=void 0,this.c=void 0,this.g()}g(){const ve=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",We=(Je,tt)=>{this.h(tt)};k.ipcRenderer.on(Ue,We),this.B((0,T.toDisposable)(()=>k.ipcRenderer.removeListener(Ue,We)))}h(ve){this.b?.disposeWorker(ve)}async open(){const ve=await this.i();(0,ze.registerConfiguration)(),ve.invokeFunction(Ue=>{const We=Ue.get(re.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ue),this.k(We)}),this.B((0,T.combinedDisposable)(ve.createInstance(p.CodeCacheCleaner,this.f.codeCachePath),ve.createInstance(g.LanguagePackCachedDataCleaner),ve.createInstance(f.UnusedWorkspaceStorageDataCleaner),ve.createInstance(y.LogsDataCleaner),ve.createInstance(h.LocalizationsUpdater),ve.createInstance($t.ExtensionsContributions),ve.createInstance(Mt.UserDataProfilesCleaner)))}async i(){const ve=new H.ServiceCollection,Ue={_serviceBrand:void 0,...M.default};ve.set(W.IProductService,Ue);const We=new C.StaticRouter(Qe=>Qe==="main"),Je=new q.MessagePortMainProcessService(this.a,We);ve.set(G.IMainProcessService,Je);const tt=this.f.policiesData?new Tt.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new St.NullPolicyService;ve.set(St.IPolicyService,tt);const Ke=new o.SharedProcessEnvironmentService(this.f.args,Ue);ve.set(s.INativeEnvironmentService,Ke);const lt=new te.LogLevelChannelClient(this.a.getChannel("logLevel",We)),it=new te.LoggerChannelClient(this.f.logLevel,lt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(re.ILoggerService,it);const ht=this.B(new re.MultiplexLogService([this.B(new re.ConsoleLogger(this.f.logLevel)),this.B(it.createLogger((0,P.joinPath)(S.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),xe=this.B(new te.FollowerLogService(lt,ht));ve.set(re.ILogService,xe),this.c=new Et.SharedProcessLifecycleService(xe),ve.set(Et.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(xe),ve.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new j.FileService(xe));ve.set(L.IFileService,_e);const ft=this.B(new z.DiskFileSystemProvider(xe));_e.registerProvider(R.Schemas.file,ft);const dt=this.B(new Ge.FileUserDataProvider(R.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),R.Schemas.vscodeUserData,xe));_e.registerProvider(R.Schemas.vscodeUserData,dt);const nt=this.B(new Ot.UserDataProfilesNativeService(this.f.profiles,Je,Ke));ve.set(vt.IUserDataProfilesService,nt);const Xe=this.B(new v.ConfigurationService(nt.defaultProfile.settingsResource,_e,tt,xe));ve.set(m.IConfigurationService,Xe);const at=new ie.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);ve.set(x.IStorageService,at),this.B((0,T.toDisposable)(()=>at.flush())),await Promise.all([Xe.initialize(),at.initialize()]),ve.set($e.IUriIdentityService,new Le.UriIdentityService(_e)),ve.set(B.IRequestService,new Nt.SharedProcessRequestService(Je,Xe,Ue,xe)),ve.set(l.IChecksumService,new V.SyncDescriptor(d.ChecksumService,void 0,!1)),ve.set(wt.IV8InspectProfilingService,new V.SyncDescriptor(ot.InspectProfilingService,void 0,!1));const ut=C.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});ve.set(O.INativeHostService,ut),ve.set(r.IDownloadService,new V.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this.B(new Oe.ActiveWindowManager(ut)),mt=new C.StaticRouter(Qe=>gt.getActiveClientId().then(pt=>Qe===pt));ve.set($.IExtensionRecommendationNotificationService,new F.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],It=(0,ye.isInternalTelemetry)(Ue,Xe);if((0,ye.supportsTelemetry)(Ue,Ke)){const Qe=new ue.TelemetryLogAppender(it,Ke);ct.push(Qe);const{installSourcePath:pt}=Ke;if(Ue.aiConfig?.ariaKey){const Rt=new Ut.OneDataSystemAppender(It,"monacoworkbench",null,Ue.aiConfig.ariaKey);this.B((0,T.toDisposable)(()=>Rt.flush())),ct.push(Rt)}st=new le.TelemetryService({appenders:ct,commonProperties:(0,J.resolveCommonProperties)(_e,(0,n.release)(),(0,n.hostname)(),process.arch,Ue.commit,Ue.version,this.f.machineId,It,pt),sendErrorTelemetry:!0,piiPaths:(0,ye.getPiiPathsFromEnvironment)(Ke)},Xe,Ue)}else{st=ye.NullTelemetryService;const Qe=ye.NullAppender;ct.push(Qe)}this.a.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(ct)),ve.set(_.ITelemetryService,st);const Wt=new Se.CustomEndpointTelemetryService(Xe,st,it,Ke,Ue);ve.set(_.ICustomEndpointTelemetryService,Wt),ve.set(Lt.IExtensionsProfileScannerService,new V.SyncDescriptor(zt.ExtensionsProfileScannerService,void 0,!0)),ve.set(kt.IExtensionsScannerService,new V.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),ve.set(w.IExtensionSignatureVerificationService,new V.SyncDescriptor(w.ExtensionSignatureVerificationService,void 0,!0)),ve.set(N.INativeServerExtensionManagementService,new V.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),ve.set(u.IExtensionGalleryService,new V.SyncDescriptor(a.ExtensionGalleryService,void 0,!0)),ve.set(u.IExtensionTipsService,new V.SyncDescriptor(U.ExtensionTipsService,void 0,!1)),ve.set(X.ILanguagePackService,new V.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1)),ve.set(I.IDiagnosticsService,new V.SyncDescriptor(i.DiagnosticsService,void 0,!1)),ve.set(ce.IUserDataSyncAccountService,new V.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),ve.set(ze.IUserDataSyncLogService,new V.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ve.set(ze.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),ve.set(u.IGlobalExtensionEnablementService,new V.SyncDescriptor(c.GlobalExtensionEnablementService,void 0,!1)),ve.set(Ye.IIgnoredExtensionsManagementService,new V.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),ve.set(Fe.IExtensionStorageService,new V.SyncDescriptor(Fe.ExtensionStorageService)),ve.set(ze.IUserDataSyncStoreManagementService,new V.SyncDescriptor(Te.UserDataSyncStoreManagementService,void 0,!0)),ve.set(ze.IUserDataSyncStoreService,new V.SyncDescriptor(Te.UserDataSyncStoreService,void 0,!0)),ve.set(Pe.IUserDataSyncMachinesService,new V.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),ve.set(ze.IUserDataSyncBackupStoreService,new V.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ve.set(ze.IUserDataSyncEnablementService,new V.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),ve.set(ze.IUserDataSyncService,new V.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ve.set(ke.IUserDataProfileStorageService,new V.SyncDescriptor(Be.UserDataProfileStorageService,void 0,!0)),ve.set(ze.IUserDataSyncResourceProviderService,new V.SyncDescriptor(jt.UserDataSyncResourceProviderService,void 0,!0));const Pt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},Xe,Ke,xe);return Pt.initialize(),ve.set(Ee.ILocalPtyService,this.B(Pt)),ve.set(ne.ISignService,new V.SyncDescriptor(he.SignService,void 0,!1)),ve.set(fe.ISharedTunnelsService,new V.SyncDescriptor(me.SharedTunnelsService)),ve.set(we.ISharedProcessTunnelService,new V.SyncDescriptor(Ie.SharedProcessTunnelService)),ve.set(bt.IRemoteTunnelService,new V.SyncDescriptor(Ft.RemoteTunnelService)),new Y.InstantiationService(ve)}j(ve){const Ue=new te.LogLevelChannel(ve.get(re.ILogService),ve.get(re.ILoggerService));this.a.registerChannel("logLevel",Ue);const We=new b.ExtensionManagementChannel(ve.get(u.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=C.ProxyChannel.fromService(ve.get(X.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const tt=C.ProxyChannel.fromService(ve.get(I.IDiagnosticsService));this.a.registerChannel("diagnostics",tt);const Ke=new b.ExtensionTipsChannel(ve.get(u.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const lt=C.ProxyChannel.fromService(ve.get(l.IChecksumService));this.a.registerChannel("checksum",lt);const it=C.ProxyChannel.fromService(ve.get(wt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(ve.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ht);const xe=C.ProxyChannel.fromService(ve.get(_.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",xe);const _e=new ge.UserDataSyncAccountServiceChannel(ve.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const ft=new ge.UserDataSyncStoreManagementServiceChannel(ve.get(ze.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",ft);const dt=new je.UserDataSyncChannel(ve.get(ze.IUserDataSyncService),ve.get(vt.IUserDataProfilesService),ve.get(re.ILogService));this.a.registerChannel("userDataSync",dt);const nt=this.B(ve.get(Q.IInstantiationService).createInstance(Me.UserDataAutoSyncService)),Xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",Xe);const at=ve.get(Ee.ILocalPtyService),ut=C.ProxyChannel.fromService(at);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ut);const gt=C.ProxyChannel.fromService(ve.get(we.ISharedProcessTunnelService));this.a.registerChannel(we.ipcSharedProcessTunnelChannelName,gt);const mt=C.ProxyChannel.fromService(ve.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const st=C.ProxyChannel.fromService(ve.get(bt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}k(ve){window.addEventListener("unhandledrejection",Ue=>{(0,A.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Ue=>{const We=(0,D.toErrorMessage)(Ue,!0);!We||ve.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function qt(Ct){const ve=new Bt(Ct);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=qt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/717d7d62c8b4566ab6704de931e7fe8e0649d810/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
