/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/registry/common/platform","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(te){for(var e=[],o=0,t=te.length;o<t;o++)e[o]=ye[te[o]];return e};define(ye[80],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function o(R){return R?R.replace(/\$\((.*?)\)/g,(I,A)=>` ${A} `).trim():""}e.getCodiconAriaLabel=o;class t{constructor(I,A,y){this.id=I,this.definition=A,this.description=y,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function A(L){if(L instanceof t)return["codicon","codicon-"+L.id];const P=I.exec(L.id);if(!P)return A(t.error);const[,v,C]=P,S=["codicon","codicon-"+v];return C&&S.push("codicon-modifier-"+C.substring(1)),S}R.asClassNameArray=A;function y(L){return A(L).join(" ")}R.asClassName=y;function D(L){return"."+A(L).join(".")}R.asCSSSelector=D})(k=e.CSSIcon||(e.CSSIcon={}))}),define(ye[81],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(I,A){const y=Object.create(null);for(const D of I){const L=A(D);let P=y[L];P||(P=y[L]=[]),P.push(D)}return y}e.groupBy=o;function t(I,A){const y=[],D=[];for(const L of I)A.has(L)||y.push(L);for(const L of A)I.has(L)||D.push(L);return{removed:y,added:D}}e.diffSets=t;function k(I,A){const y=[],D=[];for(const[L,P]of I)A.has(L)||y.push(P);for(const[L,P]of A)I.has(L)||D.push(P);return{removed:y,added:D}}e.diffMaps=k;class R{constructor(){this.a=new Map}add(A,y){let D=this.a.get(A);D||(D=new Set,this.a.set(A,D)),D.add(y)}delete(A,y){const D=this.a.get(A);!D||(D.delete(y),D.size===0&&this.a.delete(A))}forEach(A,y){const D=this.a.get(A);!D||D.forEach(y)}}e.SetMap=R}),define(ye[60],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function o(I){return(A,y,D)=>{let L=null,P=null;if(typeof D.value=="function"?(L="value",P=D.value):typeof D.get=="function"&&(L="get",P=D.get),!P)throw new Error("not supported");D[L]=I(P,y)}}function t(I,A,y){let D=null,L=null;if(typeof y.value=="function"?(D="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(D="get",L=y.get),!L)throw new Error("not supported");const P=`$memoize$${A}`;y[D]=function(...v){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[P]}}e.memoize=t;function k(I,A,y){return o((D,L)=>{const P=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...C){this[v]||(this[v]=y?y():void 0),clearTimeout(this[P]),A&&(this[v]=A(this[v],...C),C=[this[v]]),this[P]=setTimeout(()=>{D.apply(this,C),this[v]=y?y():void 0},I)}})}e.debounce=k;function R(I,A,y){return o((D,L)=>{const P=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,C=`$throttle$lastRun$${L}`,S=`$throttle$pending$${L}`;return function(...m){if(this[v]||(this[v]=y?y():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),A&&(this[v]=A(this[v],...m)),this[S])return;const d=this[C]+I;d<=Date.now()?(this[C]=Date.now(),D.apply(this,[this[v]]),this[v]=y?y():void 0):(this[S]=!0,this[P]=setTimeout(()=>{this[S]=!1,this[C]=Date.now(),D.apply(this,[this[v]]),this[v]=y?y():void 0},d-Date.now()))}})}e.throttle=R}),define(ye[10],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class o{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?g.isErrorNoTelemetry(i)?new g(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=o,e.errorHandler=new o;function t(w){e.errorHandler.setUnexpectedErrorHandler(w)}e.setUnexpectedErrorHandler=t;function k(w){y(w)||e.errorHandler.onUnexpectedError(w)}e.onUnexpectedError=k;function R(w){y(w)||e.errorHandler.onUnexpectedExternalError(w)}e.onUnexpectedExternalError=R;function I(w){if(w instanceof Error){const{name:i,message:s}=w,a=w.stacktrace||w.stack;return{$isError:!0,name:i,message:s,stack:a,noTelemetry:g.isErrorNoTelemetry(w)}}return w}e.transformErrorForSerialization=I;const A="Canceled";function y(w){return w instanceof D?!0:w instanceof Error&&w.name===A&&w.message===A}e.isCancellationError=y;class D extends Error{constructor(){super(A),this.name=this.message}}e.CancellationError=D;function L(){const w=new Error(A);return w.name=w.message,w}e.canceled=L;function P(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}e.illegalArgument=P;function v(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}e.illegalState=v;function C(w){return w?new Error(`readonly property '${w} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function S(w){const i=new Error(`${w} has been disposed`);return i.name="DISPOSED",i}e.disposed=S;function m(w){return w?w.message?w.message:w.stack?w.stack.split(`
`)[0]:String(w):"Error"}e.getErrorMessage=m;class d extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=d;class h extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=h;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class g extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof g)return i;const s=new g;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class p extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(ye[18],Ce([1,0,10]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,ue=0){return se[se.length-(1+ue)]}e.tail=t;function k(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=k;function R(se,ue,de=(Z,ae)=>Z===ae){if(se===ue)return!0;if(!se||!ue||se.length!==ue.length)return!1;for(let Z=0,ae=se.length;Z<ae;Z++)if(!de(se[Z],ue[Z]))return!1;return!0}e.equals=R;function I(se,ue){const de=se.length-1;ue<de&&(se[ue]=se[de]),se.pop()}e.removeFastWithoutKeepingOrder=I;function A(se,ue,de){return y(se.length,Z=>de(se[Z],ue))}e.binarySearch=A;function y(se,ue){let de=0,Z=se-1;for(;de<=Z;){const ae=(de+Z)/2|0,ie=ue(ae);if(ie<0)de=ae+1;else if(ie>0)Z=ae-1;else return ae}return-(de+1)}e.binarySearch2=y;function D(se,ue){let de=0,Z=se.length;if(Z===0)return 0;for(;de<Z;){const ae=Math.floor((de+Z)/2);ue(se[ae])?Z=ae:de=ae+1}return de}e.findFirstInSorted=D;function L(se,ue,de){if(se=se|0,se>=ue.length)throw new TypeError("invalid index");const Z=ue[Math.floor(ue.length*Math.random())],ae=[],ie=[],O=[];for(const W of ue){const X=de(W,Z);X<0?ae.push(W):X>0?ie.push(W):O.push(W)}return se<ae.length?L(se,ae,de):se<ae.length+O.length?O[0]:L(se-(ae.length+O.length),ie,de)}e.quickSelect=L;function P(se,ue){const de=[];let Z;for(const ae of se.slice(0).sort(ue))!Z||ue(Z[0],ae)!==0?(Z=[ae],de.push(Z)):Z.push(ae);return de}e.groupBy=P;function v(se,ue,de){const Z=[];function ae(W,X,Q){if(X===0&&Q.length===0)return;const he=Z[Z.length-1];he&&he.start+he.deleteCount===W?(he.deleteCount+=X,he.toInsert.push(...Q)):Z.push({start:W,deleteCount:X,toInsert:Q})}let ie=0,O=0;for(;;){if(ie===se.length){ae(ie,0,ue.slice(O));break}if(O===ue.length){ae(ie,se.length-ie,[]);break}const W=se[ie],X=ue[O],Q=de(W,X);Q===0?(ie+=1,O+=1):Q<0?(ae(ie,1,[]),ie+=1):Q>0&&(ae(ie,0,[X]),O+=1)}return Z}e.sortedDiff=v;function C(se,ue,de){const Z=v(se,ue,de),ae=[],ie=[];for(const O of Z)ae.push(...se.slice(O.start,O.start+O.deleteCount)),ie.push(...O.toInsert);return{removed:ae,added:ie}}e.delta=C;function S(se,ue,de){if(de===0)return[];const Z=se.slice(0,de).sort(ue);return d(se,ue,Z,de,se.length),Z}e.top=S;function m(se,ue,de,Z,ae){return de===0?Promise.resolve([]):new Promise((ie,O)=>{(async()=>{const W=se.length,X=se.slice(0,de).sort(ue);for(let Q=de,he=Math.min(de+Z,W);Q<W;Q=he,he=Math.min(he+Z,W)){if(Q>de&&await new Promise(we=>setTimeout(we)),ae&&ae.isCancellationRequested)throw new o.CancellationError;d(se,ue,X,Q,he)}return X})().then(ie,O)})}e.topAsync=m;function d(se,ue,de,Z,ae){for(const ie=de.length;Z<ae;Z++){const O=se[Z];if(ue(O,de[ie-1])<0){de.pop();const W=D(de,X=>ue(O,X)<0);de.splice(W,0,O)}}}function h(se){return se.filter(ue=>!!ue)}e.coalesce=h;function b(se){let ue=0;for(let de=0;de<se.length;de++)se[de]&&(se[ue]=se[de],ue+=1);se.length=ue}e.coalesceInPlace=b;function g(se,ue,de){se.splice(de,0,se.splice(ue,1)[0])}e.move=g;function p(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=p;function w(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=w;function i(se,ue=de=>de){const de=new Set;return se.filter(Z=>{const ae=ue(Z);return de.has(ae)?!1:(de.add(ae),!0)})}e.distinct=i;function s(se){const ue=new Set;return de=>{const Z=se(de);return ue.has(Z)?!1:(ue.add(Z),!0)}}e.uniqueFilter=s;function a(se,ue){const de=u(se,ue);if(de!==-1)return se[de]}e.findLast=a;function u(se,ue){for(let de=se.length-1;de>=0;de--){const Z=se[de];if(ue(Z))return de}return-1}e.lastIndex=u;function l(se,ue){return se.length>0?se[0]:ue}e.firstOrDefault=l;function c(se,ue){return se.length>0?se[se.length-1]:ue}e.lastOrDefault=c;function n(se,ue,de=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ie=Math.min(se.length,ue.length);ae<ie&&de(se[ae],ue[ae]);ae++)Z++;return Z}e.commonPrefixLength=n;function r(se){return[].concat(...se)}e.flatten=r;function f(se,ue){let de=typeof ue=="number"?se:0;typeof ue=="number"?de=se:(de=0,ue=se);const Z=[];if(de<=ue)for(let ae=de;ae<ue;ae++)Z.push(ae);else for(let ae=de;ae>ue;ae--)Z.push(ae);return Z}e.range=f;function E(se,ue,de){return se.reduce((Z,ae)=>(Z[ue(ae)]=de?de(ae):ae,Z),Object.create(null))}e.index=E;function T(se,ue){return se.push(ue),()=>M(se,ue)}e.insert=T;function M(se,ue){const de=se.indexOf(ue);if(de>-1)return se.splice(de,1),ue}e.remove=M;function K(se,ue,de){const Z=se.slice(0,ue),ae=se.slice(ue);return Z.concat(de,ae)}e.arrayInsert=K;function V(se,ue){let de;if(typeof ue=="number"){let Z=ue;de=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else de=Math.random;for(let Z=se.length-1;Z>0;Z-=1){const ae=Math.floor(de()*(Z+1)),ie=se[Z];se[Z]=se[ae],se[ae]=ie}}e.shuffle=V;function F(se,ue){const de=se.indexOf(ue);de>-1&&(se.splice(de,1),se.unshift(ue))}e.pushToStart=F;function U(se,ue){const de=se.indexOf(ue);de>-1&&(se.splice(de,1),se.push(ue))}e.pushToEnd=U;function N(se,ue){for(const de of ue)se.push(de)}e.pushMany=N;function B(se,ue){return Array.isArray(se)?se.map(ue):ue(se)}e.mapArrayOrNot=B;function j(se){return Array.isArray(se)?se:[se]}e.asArray=j;function z(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=z;function ne(se,ue){for(const de of se){const Z=ue(de);if(Z!==void 0)return Z}}e.mapFind=ne;function _(se,ue,de){const Z=J(se,ue),ae=se.length,ie=de.length;se.length=ae+ie;for(let O=ae-1;O>=Z;O--)se[O+ie]=se[O];for(let O=0;O<ie;O++)se[O+Z]=de[O]}e.insertInto=_;function Y(se,ue,de,Z){const ae=J(se,ue),ie=se.splice(ae,de);return _(se,ae,Z),ie}e.splice=Y;function J(se,ue){return ue<0?Math.max(ue+se.length,0):Math.min(ue,se.length)}var ee;(function(se){function ue(ae){return ae<0}se.isLessThan=ue;function de(ae){return ae>0}se.isGreaterThan=de;function Z(ae){return ae===0}se.isNeitherLessOrGreaterThan=Z,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function ge(se,ue){return(de,Z)=>ue(se(de),se(Z))}e.compareBy=ge;function q(...se){return(ue,de)=>{for(const Z of se){const ae=Z(ue,de);if(!ee.isNeitherLessOrGreaterThan(ae))return ae}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=q;const G=(se,ue)=>se-ue;e.numberComparator=G;function le(se,ue){if(se.length===0)return;let de=se[0];for(let Z=1;Z<se.length;Z++){const ae=se[Z];ue(ae,de)>0&&(de=ae)}return de}e.findMaxBy=le;function be(se,ue){if(se.length===0)return;let de=se[0];for(let Z=1;Z<se.length;Z++){const ae=se[Z];ue(ae,de)>=0&&(de=ae)}return de}e.findLastMaxBy=be;function ve(se,ue){return le(se,(de,Z)=>-ue(de,Z))}e.findMinBy=ve;class Pe{constructor(ue){this.f=ue,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let de=this.c;for(;de<this.f.length&&ue(this.f[de]);)de++;const Z=de===this.c?null:this.f.slice(this.c,de);return this.c=de,Z}takeFromEndWhile(ue){let de=this.d;for(;de>=0&&ue(this.f[de]);)de--;const Z=de===this.d?null:this.f.slice(de+1,this.d+1);return this.d=de,Z}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ue=this.f[this.c];return this.c++,ue}removeLast(){const ue=this.f[this.d];return this.d--,ue}takeCount(ue){const de=this.f.slice(this.c,this.c+ue);return this.c+=ue,de}}e.ArrayQueue=Pe;class Ne{constructor(ue){this.iterate=ue}forEach(ue){this.iterate(de=>(ue(de),!0))}toArray(){const ue=[];return this.iterate(de=>(ue.push(de),!0)),ue}filter(ue){return new Ne(de=>this.iterate(Z=>ue(Z)?de(Z):!0))}map(ue){return new Ne(de=>this.iterate(Z=>de(ue(Z))))}some(ue){let de=!1;return this.iterate(Z=>(de=ue(Z),!de)),de}findFirst(ue){let de;return this.iterate(Z=>ue(Z)?(de=Z,!1):!0),de}findLast(ue){let de;return this.iterate(Z=>(ue(Z)&&(de=Z),!0)),de}findLastMaxBy(ue){let de,Z=!0;return this.iterate(ae=>((Z||ee.isGreaterThan(ue(ae,de)))&&(Z=!1,de=ae),!0)),de}}e.CallbackIterable=Ne,Ne.empty=new Ne(se=>{})}),define(ye[50],Ce([1,0,10]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(y,D){if(!y)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=t;function k(y,D="Unreachable"){throw new Error(D)}e.assertNever=k;function R(y){if(!y)throw new o.BugIndicatingError("Assertion Failed")}e.assert=R;function I(y){if(!y()){debugger;y(),(0,o.onUnexpectedError)(new o.BugIndicatingError("Assertion Failed"))}}e.assertFn=I;function A(y,D){let L=0;for(;L<y.length-1;){const P=y[L],v=y[L+1];if(!D(P,v))return!1;L++}return!0}e.checkAdjacentItems=A}),define(ye[61],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function o(t){const k=this;let R=!1,I;return function(){return R||(R=!0,I=t.apply(k,arguments)),I}}e.once=o}),define(ye[100],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(ye[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(t){function k(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function I(){return R}t.empty=I;function*A(p){yield p}t.single=A;function y(p){return k(p)?p:A(p)}t.wrap=y;function D(p){return p||R}t.from=D;function L(p){return!p||p[Symbol.iterator]().next().done===!0}t.isEmpty=L;function P(p){return p[Symbol.iterator]().next().value}t.first=P;function v(p,w){for(const i of p)if(w(i))return!0;return!1}t.some=v;function C(p,w){for(const i of p)if(w(i))return i}t.find=C;function*S(p,w){for(const i of p)w(i)&&(yield i)}t.filter=S;function*m(p,w){let i=0;for(const s of p)yield w(s,i++)}t.map=m;function*d(...p){for(const w of p)for(const i of w)yield i}t.concat=d;function h(p,w,i){let s=i;for(const a of p)s=w(s,a);return s}t.reduce=h;function*b(p,w,i=p.length){for(w<0&&(w+=p.length),i<0?i+=p.length:i>p.length&&(i=p.length);w<i;w++)yield p[w]}t.slice=b;function g(p,w=Number.POSITIVE_INFINITY){const i=[];if(w===0)return[i,p];const s=p[Symbol.iterator]();for(let a=0;a<w;a++){const u=s.next();if(u.done)return[i,t.empty()];i.push(u.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=g})(o=e.Iterable||(e.Iterable={}))}),define(ye[146],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function I(i,s=!1){let a=0;const u=i.length;let l="",c=0,n=16,r=0;function f(U){let N=0,B=0;for(;N<U;){const j=i.charCodeAt(a);if(j>=48&&j<=57)B=B*16+j-48;else if(j>=65&&j<=70)B=B*16+j-65+10;else if(j>=97&&j<=102)B=B*16+j-97+10;else break;a++,N++}return N<U&&(B=-1),B}function E(U){a=U,l="",c=0,n=16,r=0}function T(){const U=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&D(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&D(i.charCodeAt(a)))for(a++;a<i.length&&D(i.charCodeAt(a));)a++;else return r=3,i.substring(U,a);let N=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&D(i.charCodeAt(a))){for(a++;a<i.length&&D(i.charCodeAt(a));)a++;N=a}else r=3;return i.substring(U,N)}function M(){let U="",N=a;for(;;){if(a>=u){U+=i.substring(N,a),r=2;break}const B=i.charCodeAt(a);if(B===34){U+=i.substring(N,a),a++;break}if(B===92){if(U+=i.substring(N,a),a++,a>=u){r=2;break}switch(i.charCodeAt(a++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const z=f(4);z>=0?U+=String.fromCharCode(z):r=4;break}default:r=5}N=a;continue}if(B>=0&&B<=31)if(y(B)){U+=i.substring(N,a),r=2;break}else r=6;a++}return U}function K(){if(l="",r=0,c=a,a>=u)return c=u,n=17;let U=i.charCodeAt(a);if(A(U)){do a++,l+=String.fromCharCode(U),U=i.charCodeAt(a);while(A(U));return n=15}if(y(U))return a++,l+=String.fromCharCode(U),U===13&&i.charCodeAt(a)===10&&(a++,l+=`
`),n=14;switch(U){case 123:return a++,n=1;case 125:return a++,n=2;case 91:return a++,n=3;case 93:return a++,n=4;case 58:return a++,n=6;case 44:return a++,n=5;case 34:return a++,l=M(),n=10;case 47:{const N=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<u&&!y(i.charCodeAt(a));)a++;return l=i.substring(N,a),n=12}if(i.charCodeAt(a+1)===42){a+=2;const B=u-1;let j=!1;for(;a<B;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,j=!0;break}a++}return j||(a++,r=1),l=i.substring(N,a),n=13}return l+=String.fromCharCode(U),a++,n=16}case 45:if(l+=String.fromCharCode(U),a++,a===u||!D(i.charCodeAt(a)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=T(),n=11;default:for(;a<u&&V(U);)a++,U=i.charCodeAt(a);if(c!==a){switch(l=i.substring(c,a),l){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return l+=String.fromCharCode(U),a++,n=16}}function V(U){if(A(U)||y(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let U;do U=K();while(U>=12&&U<=15);return U}return{setPosition:E,getPosition:()=>a,scan:s?F:K,getToken:()=>n,getTokenValue:()=>l,getTokenOffset:()=>c,getTokenLength:()=>a-c,getTokenError:()=>r}}e.createScanner=I;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function D(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function P(i,s){const a=[],u=new Object;let l;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function r(f,E,T,M){c.value=f,c.offset=E,c.length=T,c.type=M,c.colonOffset=void 0,l=c}try{g(i,{onObjectBegin:(f,E)=>{if(s<=f)throw u;l=void 0,n=s>f,a.push("")},onObjectProperty:(f,E,T)=>{if(s<E||(r(f,E,T,"property"),a[a.length-1]=f,s<=E+T))throw u},onObjectEnd:(f,E)=>{if(s<=f)throw u;l=void 0,a.pop()},onArrayBegin:(f,E)=>{if(s<=f)throw u;l=void 0,a.push(0)},onArrayEnd:(f,E)=>{if(s<=f)throw u;l=void 0,a.pop()},onLiteralValue:(f,E,T)=>{if(s<E||(r(f,E,T,w(f)),s<=E+T))throw u},onSeparator:(f,E,T)=>{if(s<=E)throw u;if(f===":"&&l&&l.type==="property")l.colonOffset=E,n=!1,l=void 0;else if(f===","){const M=a[a.length-1];typeof M=="number"?a[a.length-1]=M+1:(n=!0,a[a.length-1]=""),l=void 0}}})}catch(f){if(f!==u)throw f}return{path:a,previousNode:l,isAtPropertyKey:n,matches:f=>{let E=0;for(let T=0;E<f.length&&T<a.length;T++)if(f[E]===a[T]||f[E]==="*")E++;else if(f[E]!=="**")return!1;return E===f.length}}}e.getLocation=P;function v(i,s=[],a=R.DEFAULT){let u=null,l=[];const c=[];function n(f){Array.isArray(l)?l.push(f):u!==null&&(l[u]=f)}return g(i,{onObjectBegin:()=>{const f={};n(f),c.push(l),l=f,u=null},onObjectProperty:f=>{u=f},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const f=[];n(f),c.push(l),l=f,u=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:n,onError:(f,E,T)=>{s.push({error:f,offset:E,length:T})}},a),l[0]}e.parse=v;function C(i,s=[],a=R.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(f){u.type==="property"&&(u.length=f-u.offset,u=u.parent)}function c(f){return u.children.push(f),f}g(i,{onObjectBegin:f=>{u=c({type:"object",offset:f,length:-1,parent:u,children:[]})},onObjectProperty:(f,E,T)=>{u=c({type:"property",offset:E,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:f,offset:E,length:T,parent:u})},onObjectEnd:(f,E)=>{u.length=f+E-u.offset,u=u.parent,l(f+E)},onArrayBegin:(f,E)=>{u=c({type:"array",offset:f,length:-1,parent:u,children:[]})},onArrayEnd:(f,E)=>{u.length=f+E-u.offset,u=u.parent,l(f+E)},onLiteralValue:(f,E,T)=>{c({type:w(f),offset:E,length:T,parent:u,value:f}),l(E+T)},onSeparator:(f,E,T)=>{u.type==="property"&&(f===":"?u.colonOffset=E:f===","&&l(E))},onError:(f,E,T)=>{s.push({error:f,offset:E,length:T})}},a);const r=u.children[0];return r&&delete r.parent,r}e.parseTree=C;function S(i,s){if(!i)return;let a=i;for(const u of s)if(typeof u=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let l=!1;for(const c of a.children)if(Array.isArray(c.children)&&c.children[0].value===u){a=c.children[1],l=!0;break}if(!l)return}else{const l=u;if(a.type!=="array"||l<0||!Array.isArray(a.children)||l>=a.children.length)return;a=a.children[l]}return a}e.findNodeAtLocation=S;function m(i){if(!i.parent||!i.parent.children)return[];const s=m(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;s.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&s.push(a)}return s}e.getNodePath=m;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const s=Object.create(null);for(const a of i.children){const u=a.children[1];u&&(s[a.children[0].value]=d(u))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=d;function h(i,s,a=!1){return s>=i.offset&&s<i.offset+i.length||a&&s===i.offset+i.length}e.contains=h;function b(i,s,a=!1){if(h(i,s,a)){const u=i.children;if(Array.isArray(u))for(let l=0;l<u.length&&u[l].offset<=s;l++){const c=b(u[l],s,a);if(c)return c}return i}}e.findNodeAtOffset=b;function g(i,s,a=R.DEFAULT){const u=I(i,!1);function l(ge){return ge?()=>ge(u.getTokenOffset(),u.getTokenLength()):()=>!0}function c(ge){return ge?q=>ge(q,u.getTokenOffset(),u.getTokenLength()):()=>!0}const n=l(s.onObjectBegin),r=c(s.onObjectProperty),f=l(s.onObjectEnd),E=l(s.onArrayBegin),T=l(s.onArrayEnd),M=c(s.onLiteralValue),K=c(s.onSeparator),V=l(s.onComment),F=c(s.onError),U=a&&a.disallowComments,N=a&&a.allowTrailingComma;function B(){for(;;){const ge=u.scan();switch(u.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:U||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(ge){case 12:case 13:U?j(10):V();break;case 16:j(1);break;case 15:case 14:break;default:return ge}}}function j(ge,q=[],G=[]){if(F(ge),q.length+G.length>0){let le=u.getToken();for(;le!==17;){if(q.indexOf(le)!==-1){B();break}else if(G.indexOf(le)!==-1)break;le=B()}}}function z(ge){const q=u.getTokenValue();return ge?M(q):r(q),B(),!0}function ne(){switch(u.getToken()){case 11:{let ge=0;try{ge=JSON.parse(u.getTokenValue()),typeof ge!="number"&&(j(2),ge=0)}catch{j(2)}M(ge);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return B(),!0}function _(){return u.getToken()!==10?(j(3,[],[2,5]),!1):(z(!1),u.getToken()===6?(K(":"),B(),ee()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function Y(){n(),B();let ge=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(ge||j(4,[],[]),K(","),B(),u.getToken()===2&&N)break}else ge&&j(6,[],[]);_()||j(4,[],[2,5]),ge=!0}return f(),u.getToken()!==2?j(7,[2],[]):B(),!0}function J(){E(),B();let ge=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(ge||j(4,[],[]),K(","),B(),u.getToken()===4&&N)break}else ge&&j(6,[],[]);ee()||j(4,[],[4,5]),ge=!0}return T(),u.getToken()!==4?j(8,[4],[]):B(),!0}function ee(){switch(u.getToken()){case 3:return J();case 1:return Y();case 10:return z(!0);default:return ne()}}return B(),u.getToken()===17?a.allowEmptyContent?!0:(j(4,[],[]),!1):ee()?(u.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=g;function p(i,s){const a=I(i),u=[];let l,c=0,n;do switch(n=a.getPosition(),l=a.scan(),l){case 12:case 13:case 17:c!==n&&u.push(i.substring(c,n)),s!==void 0&&u.push(a.getTokenValue().replace(/[^\r\n]/g,s)),c=a.getPosition();break}while(l!==17);return u.join("")}e.stripComments=p;function w(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(ye[82],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class o{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new o(()=>k(this.getValue()))}}e.Lazy=o}),define(ye[6],Ce([1,0,61,62]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function I(c){R=c}if(e.setDisposableTracker=I,k){const c="__is_disposable_tracked__";I(new class{trackDisposable(n){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[c]||console.log(r)},3e3)}setParent(n,r){if(n&&n!==b.None)try{n[c]=!0}catch{}}markAsDisposed(n){if(n&&n!==b.None)try{n[c]=!0}catch{}}markAsSingleton(n){}})}function A(c){return R?.trackDisposable(c),c}function y(c){R?.markAsDisposed(c)}function D(c,n){R?.setParent(c,n)}function L(c,n){if(!!R)for(const r of c)R.setParent(r,n)}function P(c){return R?.markAsSingleton(c),c}e.markAsSingleton=P;function v(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=v;function C(c){if(t.Iterable.is(c)){const n=[];for(const r of c)if(r)try{r.dispose()}catch(f){n.push(f)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=C;function S(c){for(const n of c)v(n)&&n.dispose();return[]}e.disposeIfDisposable=S;function m(...c){const n=d(()=>C(c));return L(c,n),n}e.combinedDisposable=m;function d(c){const n=A({dispose:(0,o.once)(()=>{y(n),c()})});return n}e.toDisposable=d;class h{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{C(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return D(n,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this.q=new h,A(this),D(this.q,this)}dispose(){y(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&D(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&D(n,null),n}}e.MutableDisposable=g;class p{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=p;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(n){let r=n;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,y(this))},this}}e.SafeDisposable=w;class i{constructor(){this.a=new Map}acquire(n,...r){let f=this.a.get(n);f||(f={counter:0,object:this.b(n,...r)},this.a.set(n,f));const{object:E}=f,T=(0,o.once)(()=>{--f.counter===0&&(this.c(n,f.object),this.a.delete(n))});return f.counter++,{object:E,dispose:T}}}e.ReferenceCollection=i;class s{constructor(n){this.a=n}async acquire(n,...r){const f=this.a.acquire(n,...r);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(E){throw f.dispose(),E}}}e.AsyncReferenceCollection=s;class a{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=a;function u(c){const n=new h;try{c(n)}finally{n.dispose()}}e.disposeOnReturn=u;class l{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{C(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,r,f=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),f||this.a.get(n)?.dispose(),this.a.set(n,r)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=l}),define(ye[63],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class o{constructor(R){this.element=R,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class t{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let R=this.a;for(;R!==o.Undefined;){const I=R.next;R.prev=o.Undefined,R.next=o.Undefined,R=I}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,I){const A=new o(R);if(this.a===o.Undefined)this.a=A,this.b=A;else if(I){const D=this.b;this.b=A,A.prev=D,D.next=A}else{const D=this.a;this.a=A,A.next=D,D.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==o.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==o.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==o.Undefined&&R.next!==o.Undefined){const I=R.prev;I.next=R.next,R.next.prev=I}else R.prev===o.Undefined&&R.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):R.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):R.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==o.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ye[28],Ce([1,0]),function(te,e){"use strict";var o,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(S,m,d){let h=S.get(m);return h===void 0&&(h=d,S.set(m,h)),h}e.getOrSet=R;function I(S){const m=[];return S.forEach((d,h)=>{m.push(`${h} => ${d}`)}),`Map(${S.size}) {${m.join(", ")}}`}e.mapToString=I;function A(S){const m=[];return S.forEach(d=>{m.push(d)}),`Set(${S.size}) {${m.join(", ")}}`}e.setToString=A;class y{constructor(m,d){this.uri=m,this.value=d}}class D{constructor(m,d){this[o]="ResourceMap",m instanceof D?(this.b=new Map(m.b),this.c=d??D.a):(this.b=new Map,this.c=m??D.a)}set(m,d){return this.b.set(this.c(m),new y(m,d)),this}get(m){return this.b.get(this.c(m))?.value}has(m){return this.b.has(this.c(m))}get size(){return this.b.size}clear(){this.b.clear()}delete(m){return this.b.delete(this.c(m))}forEach(m,d){typeof d<"u"&&(m=m.bind(d));for(const[h,b]of this.b)m(b.value,b.uri,this)}*values(){for(const m of this.b.values())yield m.value}*keys(){for(const m of this.b.values())yield m.uri}*entries(){for(const m of this.b.values())yield[m.uri,m.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.b)yield[m.uri,m.value]}}e.ResourceMap=D,D.a=S=>S.toString();class L{constructor(m,d){this[t]="ResourceSet",!m||typeof m=="function"?this.a=new D(m):(this.a=new D(d),m.forEach(this.add,this))}get size(){return this.a.size}add(m){return this.a.set(m,m),this}clear(){this.a.clear()}delete(m){return this.a.delete(m)}forEach(m,d){this.a.forEach((h,b)=>m.call(d,b,b,this))}has(m){return this.a.has(m)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var P;(function(S){S[S.None=0]="None",S[S.AsOld=1]="AsOld",S[S.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class v{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(m){return this.a.has(m)}get(m,d=0){const h=this.a.get(m);if(!!h)return d!==0&&this.j(h,d),h.value}set(m,d,h=0){let b=this.a.get(m);if(b)b.value=d,h!==0&&this.j(b,h);else{switch(b={key:m,value:d,next:void 0,previous:void 0},h){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(m,b),this.d++}return this}delete(m){return!!this.remove(m)}remove(m){const d=this.a.get(m);if(!!d)return this.a.delete(m),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const m=this.b;return this.a.delete(m.key),this.i(m),this.d--,m.value}forEach(m,d){const h=this.e;let b=this.b;for(;b;){if(d?m.bind(d)(b.value,b.key,this):m(b.value,b.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const m=this,d=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(m.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:h.key,done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return b}values(){const m=this,d=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(m.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:h.value,done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return b}entries(){const m=this,d=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(m.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:[h.key,h.value],done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return b}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(m){if(m>=this.size)return;if(m===0){this.clear();return}let d=this.b,h=this.size;for(;d&&h>m;)this.a.delete(d.key),d=d.next,h--;this.b=d,this.d=h,d&&(d.previous=void 0),this.e++}g(m){if(!this.b&&!this.c)this.c=m;else if(this.b)m.next=this.b,this.b.previous=m;else throw new Error("Invalid list");this.b=m,this.e++}h(m){if(!this.b&&!this.c)this.b=m;else if(this.c)m.previous=this.c,this.c.next=m;else throw new Error("Invalid list");this.c=m,this.e++}i(m){if(m===this.b&&m===this.c)this.b=void 0,this.c=void 0;else if(m===this.b){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this.b=m.next}else if(m===this.c){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this.c=m.previous}else{const d=m.next,h=m.previous;if(!d||!h)throw new Error("Invalid list");d.previous=h,h.next=d}m.next=void 0,m.previous=void 0,this.e++}j(m,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(m===this.b)return;const h=m.next,b=m.previous;m===this.c?(b.next=void 0,this.c=b):(h.previous=b,b.next=h),m.previous=void 0,m.next=this.b,this.b.previous=m,this.b=m,this.e++}else if(d===2){if(m===this.c)return;const h=m.next,b=m.previous;m===this.b?(h.previous=void 0,this.b=h):(h.previous=b,b.next=h),m.next=void 0,m.previous=this.c,this.c.next=m,this.c=m,this.e++}}}toJSON(){const m=[];return this.forEach((d,h)=>{m.push([h,d])}),m}fromJSON(m){this.clear();for(const[d,h]of m)this.set(d,h)}}e.LinkedMap=v;class C extends v{constructor(m,d=1){super(),this.k=m,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(m){this.k=m,this.m()}get ratio(){return this.l}set ratio(m){this.l=Math.min(Math.max(0,m),1),this.m()}get(m,d=2){return super.get(m,d)}peek(m){return super.get(m,0)}set(m,d){return super.set(m,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=C}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(se,ue){for(var de=0;de<ue.length;de++){var Z=ue[de];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(se,Z.key,Z)}}function o(se,ue,de){return ue&&e(se.prototype,ue),de&&e(se,de),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,ue){if(!!se){if(typeof se=="string")return k(se,ue);var de=Object.prototype.toString.call(se).slice(8,-1);if(de==="Object"&&se.constructor&&(de=se.constructor.name),de==="Map"||de==="Set")return Array.from(se);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return k(se,ue)}}function k(se,ue){(ue==null||ue>se.length)&&(ue=se.length);for(var de=0,Z=new Array(ue);de<ue;de++)Z[de]=se[de];return Z}function R(se,ue){var de=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(de)return(de=de.call(se)).next.bind(de);if(Array.isArray(se)||(de=t(se))||ue&&se&&typeof se.length=="number"){de&&(se=de);var Z=0;return function(){return Z>=se.length?{done:!0}:{done:!1,value:se[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=I();function A(se){te.defaults=se}var y=/[&<>"']/,D=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ue){return v[ue]};function S(se,ue){if(ue){if(y.test(se))return se.replace(D,C)}else if(L.test(se))return se.replace(P,C);return se}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(se){return se.replace(m,function(ue,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var h=/(^|[^\[])\^/g;function b(se,ue){se=typeof se=="string"?se:se.source,ue=ue||"";var de={replace:function(ae,ie){return ie=ie.source||ie,ie=ie.replace(h,"$1"),se=se.replace(ae,ie),de},getRegex:function(){return new RegExp(se,ue)}};return de}var g=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(se,ue,de){if(se){var Z;try{Z=decodeURIComponent(d(de)).replace(g,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ue&&!p.test(de)&&(de=l(ue,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var i={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(se,ue){i[" "+se]||(s.test(se)?i[" "+se]=se+"/":i[" "+se]=f(se,"/",!0)),se=i[" "+se];var de=se.indexOf(":")===-1;return ue.substring(0,2)==="//"?de?ue:se.replace(a,"$1")+ue:ue.charAt(0)==="/"?de?ue:se.replace(u,"$1")+ue:se+ue}var c={exec:function(){}};function n(se){for(var ue=1,de,Z;ue<arguments.length;ue++){de=arguments[ue];for(Z in de)Object.prototype.hasOwnProperty.call(de,Z)&&(se[Z]=de[Z])}return se}function r(se,ue){var de=se.replace(/\|/g,function(ie,O,W){for(var X=!1,Q=O;--Q>=0&&W[Q]==="\\";)X=!X;return X?"|":" |"}),Z=de.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>ue)Z.splice(ue);else for(;Z.length<ue;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function f(se,ue,de){var Z=se.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ie=se.charAt(Z-ae-1);if(ie===ue&&!de)ae++;else if(ie!==ue&&de)ae++;else break}return se.slice(0,Z-ae)}function E(se,ue){if(se.indexOf(ue[1])===-1)return-1;for(var de=se.length,Z=0,ae=0;ae<de;ae++)if(se[ae]==="\\")ae++;else if(se[ae]===ue[0])Z++;else if(se[ae]===ue[1]&&(Z--,Z<0))return ae;return-1}function T(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(se,ue){if(ue<1)return"";for(var de="";ue>1;)ue&1&&(de+=se),ue>>=1,se+=se;return de+se}function K(se,ue,de,Z){var ae=ue.href,ie=ue.title?S(ue.title):null,O=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){Z.state.inLink=!0;var W={type:"link",raw:de,href:ae,title:ie,text:O,tokens:Z.inlineTokens(O)};return Z.state.inLink=!1,W}return{type:"image",raw:de,href:ae,title:ie,text:S(O)}}function V(se,ue){var de=se.match(/^(\s+)(?:```)/);if(de===null)return ue;var Z=de[1];return ue.split(`
`).map(function(ae){var ie=ae.match(/^\s+/);if(ie===null)return ae;var O=ie[0];return O.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var F=function(){function se(de){this.options=de||te.defaults}var ue=se.prototype;return ue.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ue.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ie=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:f(ie,`
`)}}},ue.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ie=ae[0],O=V(ie,ae[3]||"");return{type:"code",raw:ie,lang:ae[2]?ae[2].trim():ae[2],text:O}}},ue.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ie=ae[2].trim();if(/#$/.test(ie)){var O=f(ie,"#");(this.options.pedantic||!O||/ $/.test(O))&&(ie=O.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ie,tokens:this.lexer.inline(ie)}}},ue.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},ue.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ie=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ue.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ie,O,W,X,Q,he,we,Ae,pe,De,ke,je,Ge=ae[1].trim(),et=Ge.length>1,_e={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(je=!1,!(!(ae=nt.exec(Z))||this.rules.block.hr.test(Z)));){if(ie=ae[0],Z=Z.substring(ie.length),Ae=ae[2].split(`
`,1)[0],pe=Z.split(`
`,1)[0],this.options.pedantic?(X=2,ke=Ae.trimLeft()):(X=ae[2].search(/[^ ]/),X=X>4?1:X,ke=Ae.slice(X),X+=ae[1].length),he=!1,!Ae&&/^ *$/.test(pe)&&(ie+=pe+`
`,Z=Z.substring(pe.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,X-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,X-1)+"}#");Z&&(De=Z.split(`
`,1)[0],Ae=De,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Ae)||it.test(Ae)||st.test(Ae)||ht.test(Z)));){if(Ae.search(/[^ ]/)>=X||!Ae.trim())ke+=`
`+Ae.slice(X);else if(!he)ke+=`
`+Ae;else break;!he&&!Ae.trim()&&(he=!0),ie+=De+`
`,Z=Z.substring(De.length+1)}_e.loose||(we?_e.loose=!0:/\n *\n *$/.test(ie)&&(we=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ke),O&&(W=O[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),_e.items.push({type:"list_item",raw:ie,task:!!O,checked:W,loose:!1,text:ke}),_e.raw+=ie}_e.items[_e.items.length-1].raw=ie.trimRight(),_e.items[_e.items.length-1].text=ke.trimRight(),_e.raw=_e.raw.trimRight();var oe=_e.items.length;for(Q=0;Q<oe;Q++){this.lexer.state.top=!1,_e.items[Q].tokens=this.lexer.blockTokens(_e.items[Q].text,[]);var $=_e.items[Q].tokens.filter(function(Ie){return Ie.type==="space"}),ce=$.every(function(Ie){for(var Le=Ie.raw.split(""),Be=0,xe=R(Le),Ze;!(Ze=xe()).done;){var gt=Ze.value;if(gt===`
`&&(Be+=1),Be>1)return!0}return!1});!_e.loose&&$.length&&ce&&(_e.loose=!0,_e.items[Q].loose=!0)}return _e}},ue.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ie={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(ae[0]):S(ae[0]);ie.type="paragraph",ie.text=O,ie.tokens=this.lexer.inline(O)}return ie}},ue.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ie=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ae[0],href:ae[2],title:ae[3]}}},ue.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ie={type:"table",header:r(ae[1]).map(function(we){return{text:we}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ae[0];var O=ie.align.length,W,X,Q,he;for(W=0;W<O;W++)/^ *-+: *$/.test(ie.align[W])?ie.align[W]="right":/^ *:-+: *$/.test(ie.align[W])?ie.align[W]="center":/^ *:-+ *$/.test(ie.align[W])?ie.align[W]="left":ie.align[W]=null;for(O=ie.rows.length,W=0;W<O;W++)ie.rows[W]=r(ie.rows[W],ie.header.length).map(function(we){return{text:we}});for(O=ie.header.length,X=0;X<O;X++)ie.header[X].tokens=this.lexer.inline(ie.header[X].text);for(O=ie.rows.length,X=0;X<O;X++)for(he=ie.rows[X],Q=0;Q<he.length;Q++)he[Q].tokens=this.lexer.inline(he[Q].text);return ie}}},ue.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ue.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ie=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ie,tokens:this.lexer.inline(ie)}}},ue.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ue.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:S(ae[1])}},ue.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):S(ae[0]):ae[0]}},ue.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ie=ae[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var O=f(ie.slice(0,-1),"\\");if((ie.length-O.length)%2===0)return}else{var W=E(ae[2],"()");if(W>-1){var X=ae[0].indexOf("!")===0?5:4,Q=X+ae[1].length+W;ae[2]=ae[2].substring(0,W),ae[0]=ae[0].substring(0,Q).trim(),ae[3]=""}}var he=ae[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ae&&(he=Ae[1],we=Ae[3])}else we=ae[3]?ae[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(ie)?he=he.slice(1):he=he.slice(1,-1)),K(ae,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ue.reflink=function(Z,ae){var ie;if((ie=this.rules.inline.reflink.exec(Z))||(ie=this.rules.inline.nolink.exec(Z))){var O=(ie[2]||ie[1]).replace(/\s+/g," ");if(O=ae[O.toLowerCase()],!O||!O.href){var W=ie[0].charAt(0);return{type:"text",raw:W,text:W}}return K(ie,O,ie[0],this.lexer)}},ue.emStrong=function(Z,ae,ie){ie===void 0&&(ie="");var O=this.rules.inline.emStrong.lDelim.exec(Z);if(!!O&&!(O[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=O[1]||O[2]||"";if(!W||W&&(ie===""||this.rules.inline.punctuation.exec(ie))){var X=O[0].length-1,Q,he,we=X,Ae=0,pe=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ae=ae.slice(-1*Z.length+X);(O=pe.exec(ae))!=null;)if(Q=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Q){if(he=Q.length,O[3]||O[4]){we+=he;continue}else if((O[5]||O[6])&&X%3&&!((X+he)%3)){Ae+=he;continue}if(we-=he,!(we>0)){if(he=Math.min(he,he+we+Ae),Math.min(X,he)%2){var De=Z.slice(1,X+O.index+he);return{type:"em",raw:Z.slice(0,X+O.index+he+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ke=Z.slice(2,X+O.index+he-1);return{type:"strong",raw:Z.slice(0,X+O.index+he+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ue.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ie=ae[2].replace(/\n/g," "),O=/[^ ]/.test(ie),W=/^ /.test(ie)&&/ $/.test(ie);return O&&W&&(ie=ie.substring(1,ie.length-1)),ie=S(ie,!0),{type:"codespan",raw:ae[0],text:ie}}},ue.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},ue.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ue.autolink=function(Z,ae){var ie=this.rules.inline.autolink.exec(Z);if(ie){var O,W;return ie[2]==="@"?(O=S(this.options.mangle?ae(ie[1]):ie[1]),W="mailto:"+O):(O=S(ie[1]),W=O),{type:"link",raw:ie[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},ue.url=function(Z,ae){var ie;if(ie=this.rules.inline.url.exec(Z)){var O,W;if(ie[2]==="@")O=S(this.options.mangle?ae(ie[0]):ie[0]),W="mailto:"+O;else{var X;do X=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(X!==ie[0]);O=S(ie[0]),ie[1]==="www."?W="http://"+O:W=O}return{type:"link",raw:ie[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},ue.inlineText=function(Z,ae){var ie=this.rules.inline.text.exec(Z);if(ie){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]):ie[0]:O=S(this.options.smartypants?ae(ie[0]):ie[0]),{type:"text",raw:ie[0],text:O}}},se}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=b(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=b(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=b(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=b(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=b(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=b(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=n({},U),U.gfm=n({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=b(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=b(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=n({},U.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:b(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=b(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=b(U._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=b(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=b(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=b(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=b(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=b(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=b(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=b(N.reflink).replace("label",N._label).replace("ref",U._label).getRegex(),N.nolink=b(N.nolink).replace("ref",U._label).getRegex(),N.reflinkSearch=b(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=n({},N),N.pedantic=n({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=n({},N.normal,{escape:b(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=b(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=n({},N.gfm,{br:b(N.br).replace("{2,}","*").getRegex(),text:b(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(se){var ue="",de,Z,ae=se.length;for(de=0;de<ae;de++)Z=se.charCodeAt(de),Math.random()>.5&&(Z="x"+Z.toString(16)),ue+="&#"+Z+";";return ue}var z=function(){function se(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||te.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:U.normal,inline:N.normal};this.options.pedantic?(Z.block=U.pedantic,Z.inline=N.pedantic):this.options.gfm&&(Z.block=U.gfm,this.options.breaks?Z.inline=N.breaks:Z.inline=N.gfm),this.tokenizer.rules=Z}se.lex=function(Z,ae){var ie=new se(ae);return ie.lex(Z)},se.lexInline=function(Z,ae){var ie=new se(ae);return ie.inlineTokens(Z)};var ue=se.prototype;return ue.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ue.blockTokens=function(Z,ae){var ie=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(we,Ae,pe){return Ae+"    ".repeat(pe.length)});for(var O,W,X,Q;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(O=we.call({lexer:ie},Z,ae))?(Z=Z.substring(O.raw.length),ae.push(O),!0):!1}))){if(O=this.tokenizer.space(Z)){Z=Z.substring(O.raw.length),O.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(O);continue}if(O=this.tokenizer.code(Z)){Z=Z.substring(O.raw.length),W=ae[ae.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):ae.push(O);continue}if(O=this.tokenizer.fences(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.heading(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.hr(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.blockquote(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.list(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.html(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.def(Z)){Z=Z.substring(O.raw.length),W=ae[ae.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.lheading(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(X=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=Z.slice(1),pe=void 0;ie.options.extensions.startBlock.forEach(function(De){pe=De.call({lexer:this},Ae),typeof pe=="number"&&pe>=0&&(we=Math.min(we,pe))}),we<1/0&&we>=0&&(X=Z.substring(0,we+1))}(),this.state.top&&(O=this.tokenizer.paragraph(X))){W=ae[ae.length-1],Q&&W.type==="paragraph"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ae.push(O),Q=X.length!==Z.length,Z=Z.substring(O.raw.length);continue}if(O=this.tokenizer.text(Z)){Z=Z.substring(O.raw.length),W=ae[ae.length-1],W&&W.type==="text"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ae.push(O);continue}if(Z){var he="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,ae},ue.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},ue.inlineTokens=function(Z,ae){var ie=this;ae===void 0&&(ae=[]);var O,W,X,Q=Z,he,we,Ae;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(Q))!=null;)pe.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(Q=Q.slice(0,he.index)+"["+M("a",he[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(Q))!=null;)Q=Q.slice(0,he.index)+"["+M("a",he[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(Q))!=null;)Q=Q.slice(0,he.index)+"++"+Q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(O=ke.call({lexer:ie},Z,ae))?(Z=Z.substring(O.raw.length),ae.push(O),!0):!1}))){if(O=this.tokenizer.escape(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.tag(Z)){Z=Z.substring(O.raw.length),W=ae[ae.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):ae.push(O);continue}if(O=this.tokenizer.link(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(O.raw.length),W=ae[ae.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):ae.push(O);continue}if(O=this.tokenizer.emStrong(Z,Q,Ae)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.codespan(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.br(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.del(Z)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.autolink(Z,j)){Z=Z.substring(O.raw.length),ae.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(Z,j))){Z=Z.substring(O.raw.length),ae.push(O);continue}if(X=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=Z.slice(1),Ge=void 0;ie.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(X=Z.substring(0,ke+1))}(),O=this.tokenizer.inlineText(X,B)){Z=Z.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Ae=O.raw.slice(-1)),we=!0,W=ae[ae.length-1],W&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):ae.push(O);continue}if(Z){var De="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return ae},o(se,null,[{key:"rules",get:function(){return{block:U,inline:N}}}]),se}(),ne=function(){function se(de){this.options=de||te.defaults}var ue=se.prototype;return ue.code=function(Z,ae,ie){var O=(ae||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(Z,O);W!=null&&W!==Z&&(ie=!0,Z=W)}return Z=Z.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+S(O,!0)+'">'+(ie?Z:S(Z,!0))+`</code></pre>
`:"<pre><code>"+(ie?Z:S(Z,!0))+`</code></pre>
`},ue.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ue.html=function(Z){return Z},ue.heading=function(Z,ae,ie,O){if(this.options.headerIds){var W=this.options.headerPrefix+O.slug(ie);return"<h"+ae+' id="'+W+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(Z,ae,ie){var O=ae?"ol":"ul",W=ae&&ie!==1?' start="'+ie+'"':"";return"<"+O+W+`>
`+Z+"</"+O+`>
`},ue.listitem=function(Z){return"<li>"+Z+`</li>
`},ue.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(Z){return"<p>"+Z+`</p>
`},ue.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},ue.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ue.tablecell=function(Z,ae){var ie=ae.header?"th":"td",O=ae.align?"<"+ie+' align="'+ae.align+'">':"<"+ie+">";return O+Z+("</"+ie+`>
`)},ue.strong=function(Z){return"<strong>"+Z+"</strong>"},ue.em=function(Z){return"<em>"+Z+"</em>"},ue.codespan=function(Z){return"<code>"+Z+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(Z){return"<del>"+Z+"</del>"},ue.link=function(Z,ae,ie){if(Z=w(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ie;var O='<a href="'+S(Z)+'"';return ae&&(O+=' title="'+ae+'"'),O+=">"+ie+"</a>",O},ue.image=function(Z,ae,ie){if(Z=w(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ie;var O='<img src="'+Z+'" alt="'+ie+'"';return ae&&(O+=' title="'+ae+'"'),O+=this.options.xhtml?"/>":">",O},ue.text=function(Z){return Z},se}(),_=function(){function se(){}var ue=se.prototype;return ue.strong=function(Z){return Z},ue.em=function(Z){return Z},ue.codespan=function(Z){return Z},ue.del=function(Z){return Z},ue.html=function(Z){return Z},ue.text=function(Z){return Z},ue.link=function(Z,ae,ie){return""+ie},ue.image=function(Z,ae,ie){return""+ie},ue.br=function(){return""},se}(),Y=function(){function se(){this.seen={}}var ue=se.prototype;return ue.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(Z,ae){var ie=Z,O=0;if(this.seen.hasOwnProperty(ie)){O=this.seen[Z];do O++,ie=Z+"-"+O;while(this.seen.hasOwnProperty(ie))}return ae||(this.seen[Z]=O,this.seen[ie]=0),ie},ue.slug=function(Z,ae){ae===void 0&&(ae={});var ie=this.serialize(Z);return this.getNextSafeSlug(ie,ae.dryrun)},se}(),J=function(){function se(de){this.options=de||te.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new Y}se.parse=function(Z,ae){var ie=new se(ae);return ie.parse(Z)},se.parseInline=function(Z,ae){var ie=new se(ae);return ie.parseInline(Z)};var ue=se.prototype;return ue.parse=function(Z,ae){ae===void 0&&(ae=!0);var ie="",O,W,X,Q,he,we,Ae,pe,De,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe=Z.length;for(O=0;O<oe;O++){if(ke=Z[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ie+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,d(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Ae="",Q=ke.header.length,W=0;W<Q;W++)Ae+=this.renderer.tablecell(this.parseInline(ke.header[W].tokens),{header:!0,align:ke.align[W]});for(pe+=this.renderer.tablerow(Ae),De="",Q=ke.rows.length,W=0;W<Q;W++){for(we=ke.rows[W],Ae="",he=we.length,X=0;X<he;X++)Ae+=this.renderer.tablecell(this.parseInline(we[X].tokens),{header:!1,align:ke.align[X]});De+=this.renderer.tablerow(Ae)}ie+=this.renderer.table(pe,De);continue}case"blockquote":{De=this.parse(ke.tokens),ie+=this.renderer.blockquote(De);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,Q=ke.items.length,De="",W=0;W<Q;W++)nt=ke.items[W],st=nt.checked,ht=nt.task,_e="",nt.task&&(Me=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Me+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Me+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Me}):_e+=Me),_e+=this.parse(nt.tokens,et),De+=this.renderer.listitem(_e,ht,st);ie+=this.renderer.list(De,je,Ge);continue}case"html":{ie+=this.renderer.html(ke.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(De=ke.tokens?this.parseInline(ke.tokens):ke.text;O+1<oe&&Z[O+1].type==="text";)ke=Z[++O],De+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ie+=ae?this.renderer.paragraph(De):De;continue}default:{var $='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return ie},ue.parseInline=function(Z,ae){ae=ae||this.renderer;var ie="",O,W,X,Q=Z.length;for(O=0;O<Q;O++){if(W=Z[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(X=this.options.extensions.renderers[W.type].call({parser:this},W),X!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){ie+=X||"";continue}switch(W.type){case"escape":{ie+=ae.text(W.text);break}case"html":{ie+=ae.html(W.text);break}case"link":{ie+=ae.link(W.href,W.title,this.parseInline(W.tokens,ae));break}case"image":{ie+=ae.image(W.href,W.title,W.text);break}case"strong":{ie+=ae.strong(this.parseInline(W.tokens,ae));break}case"em":{ie+=ae.em(this.parseInline(W.tokens,ae));break}case"codespan":{ie+=ae.codespan(W.text);break}case"br":{ie+=ae.br();break}case"del":{ie+=ae.del(this.parseInline(W.tokens,ae));break}case"text":{ie+=ae.text(W.text);break}default:{var he='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return ie},se}();function ee(se,ue,de){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof ue=="function"&&(de=ue,ue=null),ue=n({},ee.defaults,ue||{}),T(ue),de){var Z=ue.highlight,ae;try{ae=z.lex(se,ue)}catch(Q){return de(Q)}var ie=function(he){var we;if(!he)try{ue.walkTokens&&ee.walkTokens(ae,ue.walkTokens),we=J.parse(ae,ue)}catch(Ae){he=Ae}return ue.highlight=Z,he?de(he):de(null,we)};if(!Z||Z.length<3||(delete ue.highlight,!ae.length))return ie();var O=0;ee.walkTokens(ae,function(Q){Q.type==="code"&&(O++,setTimeout(function(){Z(Q.text,Q.lang,function(he,we){if(he)return ie(he);we!=null&&we!==Q.text&&(Q.text=we,Q.escaped=!0),O--,O===0&&ie()})},0))}),O===0&&ie();return}function W(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(Q.message+"",!0)+"</pre>";throw Q}try{var X=z.lex(se,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ee.walkTokens(X,ue.walkTokens)).then(function(){return J.parse(X,ue)}).catch(W);ee.walkTokens(X,ue.walkTokens)}return J.parse(X,ue)}catch(Q){W(Q)}}ee.options=ee.setOptions=function(se){return n(ee.defaults,se),A(ee.defaults),ee},ee.getDefaults=I,ee.defaults=te.defaults,ee.use=function(){for(var se=arguments.length,ue=new Array(se),de=0;de<se;de++)ue[de]=arguments[de];var Z=n.apply(void 0,[{}].concat(ue)),ae=ee.defaults.extensions||{renderers:{},childTokens:{}},ie;ue.forEach(function(O){if(O.extensions&&(ie=!0,O.extensions.forEach(function(X){if(!X.name)throw new Error("extension name required");if(X.renderer){var Q=ae.renderers?ae.renderers[X.name]:null;Q?ae.renderers[X.name]=function(){for(var he=arguments.length,we=new Array(he),Ae=0;Ae<he;Ae++)we[Ae]=arguments[Ae];var pe=X.renderer.apply(this,we);return pe===!1&&(pe=Q.apply(this,we)),pe}:ae.renderers[X.name]=X.renderer}if(X.tokenizer){if(!X.level||X.level!=="block"&&X.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[X.level]?ae[X.level].unshift(X.tokenizer):ae[X.level]=[X.tokenizer],X.start&&(X.level==="block"?ae.startBlock?ae.startBlock.push(X.start):ae.startBlock=[X.start]:X.level==="inline"&&(ae.startInline?ae.startInline.push(X.start):ae.startInline=[X.start]))}X.childTokens&&(ae.childTokens[X.name]=X.childTokens)})),O.renderer&&function(){var X=ee.defaults.renderer||new ne,Q=function(Ae){var pe=X[Ae];X[Ae]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=O.renderer[Ae].apply(X,ke);return Ge===!1&&(Ge=pe.apply(X,ke)),Ge}};for(var he in O.renderer)Q(he);Z.renderer=X}(),O.tokenizer&&function(){var X=ee.defaults.tokenizer||new F,Q=function(Ae){var pe=X[Ae];X[Ae]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=O.tokenizer[Ae].apply(X,ke);return Ge===!1&&(Ge=pe.apply(X,ke)),Ge}};for(var he in O.tokenizer)Q(he);Z.tokenizer=X}(),O.walkTokens){var W=ee.defaults.walkTokens;Z.walkTokens=function(X){var Q=[];return Q.push(O.walkTokens.call(this,X)),W&&(Q=Q.concat(W.call(this,X))),Q}}ie&&(Z.extensions=ae),ee.setOptions(Z)})},ee.walkTokens=function(se,ue){for(var de=[],Z=function(){var W=ie.value;switch(de=de.concat(ue.call(ee,W)),W.type){case"table":{for(var X=R(W.header),Q;!(Q=X()).done;){var he=Q.value;de=de.concat(ee.walkTokens(he.tokens,ue))}for(var we=R(W.rows),Ae;!(Ae=we()).done;)for(var pe=Ae.value,De=R(pe),ke;!(ke=De()).done;){var je=ke.value;de=de.concat(ee.walkTokens(je.tokens,ue))}break}case"list":{de=de.concat(ee.walkTokens(W.items,ue));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[W.type]?ee.defaults.extensions.childTokens[W.type].forEach(function(Ge){de=de.concat(ee.walkTokens(W[Ge],ue))}):W.tokens&&(de=de.concat(ee.walkTokens(W.tokens,ue)))}},ae=R(se),ie;!(ie=ae()).done;)Z();return de},ee.parseInline=function(se,ue){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");ue=n({},ee.defaults,ue||{}),T(ue);try{var de=z.lexInline(se,ue);return ue.walkTokens&&ee.walkTokens(de,ue.walkTokens),J.parseInline(de,ue)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(Z.message+"",!0)+"</pre>";throw Z}},ee.Parser=J,ee.parser=J.parse,ee.Renderer=ne,ee.TextRenderer=_,ee.Lexer=z,ee.lexer=z.lex,ee.Tokenizer=F,ee.Slugger=Y,ee.parse=ee;var ge=ee.options,q=ee.setOptions,G=ee.use,le=ee.walkTokens,be=ee.parseInline,ve=ee,Pe=J.parse,Ne=z.lex;te.Lexer=z,te.Parser=J,te.Renderer=ne,te.Slugger=Y,te.TextRenderer=_,te.Tokenizer=F,te.getDefaults=I,te.lexer=Ne,te.marked=ee,te.options=ge,te.parse=ve,te.parseInline=be,te.parser=Pe,te.setOptions=q,te.use=G,te.walkTokens=le,Object.defineProperty(te,"__esModule",{value:!0})}),define(ye[83],Ce([1,0,28]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new o.LRUCache(1e4);function k(D){return y(D,"NFC",t)}e.normalizeNFC=k;const R=new o.LRUCache(1e4);function I(D){return y(D,"NFD",R)}e.normalizeNFD=I;const A=/[^\u0000-\u0080]/;function y(D,L,P){if(!D)return D;const v=P.get(D);if(v)return v;let C;return A.test(D)?C=D.normalize(L):C=D,P.set(D,C),C}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(L){return I(L).replace(D,"")}}()}),define(ye[101],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(A,y,D){return Math.min(Math.max(A,y),D)}e.clamp=o;function t(A,y){return(y+A%y)%y}e.rot=t;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class I{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const D=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=I}),function(){function te(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function I(y){R.push(y,Date.now())}function A(){const y=[];for(let D=0;D<R.length;D+=2)y.push({name:R[D],startTime:R[D+1]});return y}return{mark:I,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const I of performance.getEntriesByType("mark"))R.push({name:I.name,startTime:Math.round(k+I.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function o(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=o(t))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var t in o)(typeof exports=="object"?exports:te)[t]=o[t]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function o(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return te[t].call(k.exports,k,k.exports,o),k.l=!0,k.exports}return o.m=te,o.c=e,o.d=function(t,k,R){o.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},o.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},o.t=function(t,k){if(1&k&&(t=o(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(o.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var I in t)o.d(R,I,function(A){return t[A]}.bind(null,I));return R},o.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return o.d(k,"a",k),k},o.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},o.p="",o(o.s=0)}([function(te,e,o){(function(t){var k;e=te.exports=G,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],D=0,L=D++;y[L]="0|[1-9]\\d*";var P=D++;y[P]="[0-9]+";var v=D++;y[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=D++;y[C]="("+y[L]+")\\.("+y[L]+")\\.("+y[L]+")";var S=D++;y[S]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var m=D++;y[m]="(?:"+y[L]+"|"+y[v]+")";var d=D++;y[d]="(?:"+y[P]+"|"+y[v]+")";var h=D++;y[h]="(?:-("+y[m]+"(?:\\."+y[m]+")*))";var b=D++;y[b]="(?:-?("+y[d]+"(?:\\."+y[d]+")*))";var g=D++;y[g]="[0-9A-Za-z-]+";var p=D++;y[p]="(?:\\+("+y[g]+"(?:\\."+y[g]+")*))";var w=D++,i="v?"+y[C]+y[h]+"?"+y[p]+"?";y[w]="^"+i+"$";var s="[v=\\s]*"+y[S]+y[b]+"?"+y[p]+"?",a=D++;y[a]="^"+s+"$";var u=D++;y[u]="((?:<|>)?=?)";var l=D++;y[l]=y[P]+"|x|X|\\*";var c=D++;y[c]=y[L]+"|x|X|\\*";var n=D++;y[n]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[h]+")?"+y[p]+"?)?)?";var r=D++;y[r]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[b]+")?"+y[p]+"?)?)?";var f=D++;y[f]="^"+y[u]+"\\s*"+y[n]+"$";var E=D++;y[E]="^"+y[u]+"\\s*"+y[r]+"$";var T=D++;y[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=D++;y[M]="(?:~>?)";var K=D++;y[K]="(\\s*)"+y[M]+"\\s+",A[K]=new RegExp(y[K],"g");var V=D++;y[V]="^"+y[M]+y[n]+"$";var F=D++;y[F]="^"+y[M]+y[r]+"$";var U=D++;y[U]="(?:\\^)";var N=D++;y[N]="(\\s*)"+y[U]+"\\s+",A[N]=new RegExp(y[N],"g");var B=D++;y[B]="^"+y[U]+y[n]+"$";var j=D++;y[j]="^"+y[U]+y[r]+"$";var z=D++;y[z]="^"+y[u]+"\\s*("+s+")$|^$";var ne=D++;y[ne]="^"+y[u]+"\\s*("+i+")$|^$";var _=D++;y[_]="(\\s*)"+y[u]+"\\s*("+s+"|"+y[n]+")",A[_]=new RegExp(y[_],"g");var Y=D++;y[Y]="^\\s*("+y[n]+")\\s+-\\s+("+y[n]+")\\s*$";var J=D++;y[J]="^\\s*("+y[r]+")\\s+-\\s+("+y[r]+")\\s*$";var ee=D++;y[ee]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)k(ge,y[ge]),A[ge]||(A[ge]=new RegExp(y[ge]));function q(pe,De){if(pe instanceof G)return pe;if(typeof pe!="string"||pe.length>R||!(De?A[a]:A[w]).test(pe))return null;try{return new G(pe,De)}catch{return null}}function G(pe,De){if(pe instanceof G){if(pe.loose===De)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof G))return new G(pe,De);k("SemVer",pe,De),this.loose=De;var ke=pe.trim().match(De?A[a]:A[w]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<I)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=q,e.valid=function(pe,De){var ke=q(pe,De);return ke?ke.version:null},e.clean=function(pe,De){var ke=q(pe.trim().replace(/^[=v]+/,""),De);return ke?ke.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(pe){return k("SemVer.compare",this.version,this.loose,pe),pe instanceof G||(pe=new G(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},G.prototype.compareMain=function(pe){return pe instanceof G||(pe=new G(pe,this.loose)),be(this.major,pe.major)||be(this.minor,pe.minor)||be(this.patch,pe.patch)},G.prototype.comparePre=function(pe){if(pe instanceof G||(pe=new G(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var De=0;do{var ke=this.prerelease[De],je=pe.prerelease[De];if(k("prerelease compare",De,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return be(ke,je)}while(++De)},G.prototype.inc=function(pe,De){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,De,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new G(pe,ke).inc(De,je).version}catch{return null}},e.diff=function(pe,De){if(se(pe,De))return null;var ke=q(pe),je=q(De);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=be;var le=/^[0-9]+$/;function be(pe,De){var ke=le.test(pe),je=le.test(De);return ke&&je&&(pe=+pe,De=+De),ke&&!je?-1:je&&!ke?1:pe<De?-1:pe>De?1:0}function ve(pe,De,ke){return new G(pe,ke).compare(new G(De,ke))}function Pe(pe,De,ke){return ve(pe,De,ke)>0}function Ne(pe,De,ke){return ve(pe,De,ke)<0}function se(pe,De,ke){return ve(pe,De,ke)===0}function ue(pe,De,ke){return ve(pe,De,ke)!==0}function de(pe,De,ke){return ve(pe,De,ke)>=0}function Z(pe,De,ke){return ve(pe,De,ke)<=0}function ae(pe,De,ke,je){var Ge;switch(De){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=se(pe,ke,je);break;case"!=":Ge=ue(pe,ke,je);break;case">":Ge=Pe(pe,ke,je);break;case">=":Ge=de(pe,ke,je);break;case"<":Ge=Ne(pe,ke,je);break;case"<=":Ge=Z(pe,ke,je);break;default:throw new TypeError("Invalid operator: "+De)}return Ge}function ie(pe,De){if(pe instanceof ie){if(pe.loose===De)return pe;pe=pe.value}if(!(this instanceof ie))return new ie(pe,De);k("comparator",pe,De),this.loose=De,this.parse(pe),this.semver===O?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(pe,De){return be(De,pe)},e.major=function(pe,De){return new G(pe,De).major},e.minor=function(pe,De){return new G(pe,De).minor},e.patch=function(pe,De){return new G(pe,De).patch},e.compare=ve,e.compareLoose=function(pe,De){return ve(pe,De,!0)},e.rcompare=function(pe,De,ke){return ve(De,pe,ke)},e.sort=function(pe,De){return pe.sort(function(ke,je){return e.compare(ke,je,De)})},e.rsort=function(pe,De){return pe.sort(function(ke,je){return e.rcompare(ke,je,De)})},e.gt=Pe,e.lt=Ne,e.eq=se,e.neq=ue,e.gte=de,e.lte=Z,e.cmp=ae,e.Comparator=ie;var O={};function W(pe,De){if(pe instanceof W)return pe.loose===De?pe:new W(pe.raw,De);if(pe instanceof ie)return new W(pe.value,De);if(!(this instanceof W))return new W(pe,De);if(this.loose=De,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function X(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Q(pe,De,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe){return((De=X(ke)?"":X(je)?">="+ke+".0.0":X(Ge)?">="+ke+"."+je+".0":">="+De)+" "+(nt=X(st)?"":X(ht)?"<"+(+st+1)+".0.0":X(Me)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Me+"-"+it:"<="+nt)).trim()}function he(pe,De){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(De))return!1;if(De.prerelease.length){for(ke=0;ke<pe.length;ke++)if(k(pe[ke].semver),pe[ke].semver!==O&&pe[ke].semver.prerelease.length>0){var je=pe[ke].semver;if(je.major===De.major&&je.minor===De.minor&&je.patch===De.patch)return!0}return!1}return!0}function we(pe,De,ke){try{De=new W(De,ke)}catch{return!1}return De.test(pe)}function Ae(pe,De,ke,je){var Ge,et,_e,nt,st;switch(pe=new G(pe,je),De=new W(De,je),ke){case">":Ge=Pe,et=Z,_e=Ne,nt=">",st=">=";break;case"<":Ge=Ne,et=de,_e=Pe,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(pe,De,je))return!1;for(var ht=0;ht<De.set.length;++ht){var Me=De.set[ht],it=null,oe=null;if(Me.forEach(function($){$.semver===O&&($=new ie(">=0.0.0")),it=it||$,oe=oe||$,Ge($.semver,it.semver,je)?it=$:_e($.semver,oe.semver,je)&&(oe=$)}),it.operator===nt||it.operator===st||(!oe.operator||oe.operator===nt)&&et(pe,oe.semver)||oe.operator===st&&_e(pe,oe.semver))return!1}return!0}ie.prototype.parse=function(pe){var De=this.loose?A[z]:A[ne],ke=pe.match(De);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new G(ke[2],this.loose):this.semver=O},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(pe){return k("Comparator.test",pe,this.loose),this.semver===O||(typeof pe=="string"&&(pe=new G(pe,this.loose)),ae(pe,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(pe,De){if(!(pe instanceof ie))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new W(pe.value,De),we(this.value,ke,De);if(pe.operator==="")return ke=new W(this.value,De),we(pe.semver,ke,De);var je=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=ae(this.semver,"<",pe.semver,De)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=ae(this.semver,">",pe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return je||Ge||et&&_e||nt||st},e.Range=W,W.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},W.prototype.toString=function(){return this.range},W.prototype.parseRange=function(pe){var De=this.loose;pe=pe.trim(),k("range",pe,De);var ke=De?A[J]:A[Y];pe=pe.replace(ke,Q),k("hyphen replace",pe),pe=pe.replace(A[_],"$1$2$3"),k("comparator trim",pe,A[_]),pe=(pe=(pe=pe.replace(A[K],"$1~")).replace(A[N],"$1^")).split(/\s+/).join(" ");var je=De?A[z]:A[ne],Ge=pe.split(" ").map(function(et){return function(_e,nt){return k("comp",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){k("caret",it,oe);var $=oe?A[j]:A[B];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return k("caret",it,ce,Ie,Le,Be,xe),X(Ie)?Ze="":X(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":X(Be)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":xe?(k("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+xe+" <"+(+Ie+1)+".0.0"):(k("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+" <"+(+Ie+1)+".0.0"),k("caret return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),k("caret",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){var $=oe?A[F]:A[V];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return k("tilde",it,ce,Ie,Le,Be,xe),X(Ie)?Ze="":X(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":X(Be)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":xe?(k("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0",k("tilde return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),k("tildes",_e),_e=function(st,ht){return k("replaceXRanges",st,ht),st.split(/\s+/).map(function(Me){return function(it,oe){it=it.trim();var $=oe?A[E]:A[f];return it.replace($,function(ce,Ie,Le,Be,xe,Ze){k("xRange",it,ce,Ie,Le,Be,xe,Ze);var gt=X(Le),mt=gt||X(Be),lt=mt||X(xe);return Ie==="="&&lt&&(Ie=""),gt?ce=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&lt?(mt&&(Be=0),lt&&(xe=0),Ie===">"?(Ie=">=",mt?(Le=+Le+1,Be=0,xe=0):lt&&(Be=+Be+1,xe=0)):Ie==="<="&&(Ie="<",mt?Le=+Le+1:Be=+Be+1),ce=Ie+Le+"."+Be+"."+xe):mt?ce=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(ce=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),k("xRange return",ce),ce})}(Me,ht)}).join(" ")}(_e,nt),k("xrange",_e),_e=function(st,ht){return k("replaceStars",st,ht),st.trim().replace(A[ee],"")}(_e,nt),k("stars",_e),_e}(et,De)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new ie(et,De)})},W.prototype.intersects=function(pe,De){if(!(pe instanceof W))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return pe.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,De)})})})})},e.toComparators=function(pe,De){return new W(pe,De).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},W.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new G(pe,this.loose));for(var De=0;De<this.set.length;De++)if(he(this.set[De],pe))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new W(De,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==-1||(Ge=new G(je=_e,ke)))}),je},e.minSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new W(De,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==1||(Ge=new G(je=_e,ke)))}),je},e.validRange=function(pe,De){try{return new W(pe,De).range||"*"}catch{return null}},e.ltr=function(pe,De,ke){return Ae(pe,De,"<",ke)},e.gtr=function(pe,De,ke){return Ae(pe,De,">",ke)},e.outside=Ae,e.prerelease=function(pe,De){var ke=q(pe,De);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,De,ke){return pe=new W(pe,ke),De=new W(De,ke),pe.intersects(De)},e.coerce=function(pe){if(pe instanceof G)return pe;if(typeof pe!="string")return null;var De=pe.match(A[T]);return De==null?null:q((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,o(1))},function(te,e){var o,t,k=te.exports={};function R(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function A(d){if(o===setTimeout)return setTimeout(d,0);if((o===R||!o)&&setTimeout)return o=setTimeout,setTimeout(d,0);try{return o(d,0)}catch{try{return o.call(null,d,0)}catch{return o.call(this,d,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:R}catch{o=R}try{t=typeof clearTimeout=="function"?clearTimeout:I}catch{t=I}})();var y,D=[],L=!1,P=-1;function v(){L&&y&&(L=!1,y.length?D=y.concat(D):P=-1,D.length&&C())}function C(){if(!L){var d=A(v);L=!0;for(var h=D.length;h;){for(y=D,D=[];++P<h;)y&&y[P].run();P=-1,h=D.length}y=null,L=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===I||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(d)}}function S(d,h){this.fun=d,this.array=h}function m(){}k.nextTick=function(d){var h=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)h[b-1]=arguments[b];D.push(new S(d,h)),D.length!==1||L||A(C)},S.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=m,k.addListener=m,k.once=m,k.off=m,k.removeListener=m,k.removeAllListeners=m,k.emit=m,k.prependListener=m,k.prependOnceListener=m,k.listeners=function(d){return[]},k.binding=function(d){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(d){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ye[102],Ce([1,0,10,6]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=k;function R(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function I(p){const w=p;return w?R(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=I;function A(p,w){return new y(p,w)}e.newWriteableStream=A;class y{constructor(w,i){this.e=w,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(i=>i(w))}h(w){this.c.error.length===0?(0,o.onUnexpectedError)(w):this.c.error.slice(0).forEach(i=>i(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,i){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(w,i){if(this.a.destroyed)return;let s;switch(w){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(i);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(p,w){const i=[];let s;for(;(s=p.read())!==null;)i.push(s);return w(i)}e.consumeReadable=D;function L(p,w,i){const s=[];let a;for(;(a=p.read())!==null&&s.length<i;)s.push(a);return a===null&&s.length>0?w(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const u=a;return a=void 0,u}return p.read()}}}e.peekReadable=L;function P(p,w){return new Promise((i,s)=>{const a=[];v(p,{onData:u=>{w&&a.push(u)},onError:u=>{w?s(u):i(void 0)},onEnd:()=>{i(w?w(a):void 0)}})})}e.consumeStream=P;function v(p,w){let i=!1;return p.on("error",s=>{i||w.onError(s)}),p.on("end",()=>{i||w.onEnd()}),p.on("data",s=>{i||w.onData(s)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=v;function C(p,w){return new Promise((i,s)=>{const a=new t.DisposableStore,u=[],l=r=>{if(u.push(r),u.length>w)return a.dispose(),p.pause(),i({stream:p,buffer:u,ended:!1})},c=r=>s(r),n=()=>i({stream:p,buffer:u,ended:!0});a.add((0,t.toDisposable)(()=>p.removeListener("error",c))),p.on("error",c),a.add((0,t.toDisposable)(()=>p.removeListener("end",n))),p.on("end",n),a.add((0,t.toDisposable)(()=>p.removeListener("data",l))),p.on("data",l)})}e.peekStream=C;function S(p,w){const i=A(w);return i.end(p),i}e.toStream=S;function m(){const p=A(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=m;function d(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=d;function h(p,w,i){const s=A(i);return v(p,{onData:a=>s.write(w.data(a)),onError:a=>s.error(w.error?w.error(a):a),onEnd:()=>s.end()}),s}e.transform=h;function b(p,w,i){let s=!1;return{read:()=>{const a=w.read();return s?a:(s=!0,a!==null?i([p,a]):p)}}}e.prefixedReadable=b;function g(p,w,i){let s=!1;const a=A(i);return v(w,{onData:u=>s?a.write(u):(s=!0,a.write(i([p,u]))),onError:u=>a.error(u),onEnd:()=>{s||(s=!0,a.write(p)),a.end()}}),a}e.prefixedStream=g}),define(ye[22],Ce([1,0,102]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class I{static alloc(r){return t?new I(Buffer.allocUnsafe(r)):new I(new Uint8Array(r))}static wrap(r){return t&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new I(r)}static fromString(r,f){return!(f?.dontUseNodeBuffer||!1)&&t?new I(Buffer.from(r)):(k||(k=new TextEncoder),new I(k.encode(r)))}static fromByteArray(r){const f=I.alloc(r.length);for(let E=0,T=r.length;E<T;E++)f.buffer[E]=r[E];return f}static concat(r,f){if(typeof f>"u"){f=0;for(let M=0,K=r.length;M<K;M++)f+=r[M].byteLength}const E=I.alloc(f);let T=0;for(let M=0,K=r.length;M<K;M++){const V=r[M];E.set(V,T),T+=V.byteLength}return E}constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}clone(){const r=I.alloc(this.byteLength);return r.set(this),r}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(r,f){return new I(this.buffer.subarray(r,f))}set(r,f){if(r instanceof I)this.buffer.set(r.buffer,f);else if(r instanceof Uint8Array)this.buffer.set(r,f);else if(r instanceof ArrayBuffer)this.buffer.set(new Uint8Array(r),f);else if(ArrayBuffer.isView(r))this.buffer.set(new Uint8Array(r.buffer,r.byteOffset,r.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(r){return D(this.buffer,r)}writeUInt32BE(r,f){L(this.buffer,r,f)}readUInt32LE(r){return P(this.buffer,r)}writeUInt32LE(r,f){v(this.buffer,r,f)}readUInt8(r){return C(this.buffer,r)}writeUInt8(r,f){S(this.buffer,r,f)}}e.VSBuffer=I;function A(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=A;function y(n,r,f){n[f+0]=r&255,r=r>>>8,n[f+1]=r&255}e.writeUInt16LE=y;function D(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=D;function L(n,r,f){n[f+3]=r,r=r>>>8,n[f+2]=r,r=r>>>8,n[f+1]=r,r=r>>>8,n[f]=r}e.writeUInt32BE=L;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=P;function v(n,r,f){n[f+0]=r&255,r=r>>>8,n[f+1]=r&255,r=r>>>8,n[f+2]=r&255,r=r>>>8,n[f+3]=r&255}e.writeUInt32LE=v;function C(n,r){return n[r]}e.readUInt8=C;function S(n,r,f){n[f]=r}e.writeUInt8=S;function m(n){return o.consumeReadable(n,r=>I.concat(r))}e.readableToBuffer=m;function d(n){return o.toReadable(n)}e.bufferToReadable=d;function h(n){return o.consumeStream(n,r=>I.concat(r))}e.streamToBuffer=h;async function b(n){return n.ended?I.concat(n.buffer):I.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=b;function g(n){return o.toStream(n,r=>I.concat(r))}e.bufferToStream=g;function p(n){return o.transform(n,{data:r=>typeof r=="string"?I.fromString(r):I.wrap(r)},r=>I.concat(r))}e.streamToBufferReadableStream=p;function w(n){return o.newWriteableStream(r=>I.concat(r),n)}e.newWriteableBufferStream=w;function i(n,r){return o.prefixedReadable(n,r,f=>I.concat(f))}e.prefixedBufferReadable=i;function s(n,r){return o.prefixedStream(n,r,f=>I.concat(f))}e.prefixedBufferStream=s;function a(n){let r=0,f=0,E=0;const T=new Uint8Array(Math.floor(n.length/4*3)),M=V=>{switch(f){case 3:T[E++]=r|V,f=0;break;case 2:T[E++]=r|V>>>2,r=V<<6,f=3;break;case 1:T[E++]=r|V>>>4,r=V<<4,f=2;break;default:r=V<<2,f=1}};for(let V=0;V<n.length;V++){const F=n.charCodeAt(V);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${n[V]}`)}}const K=E;for(;f>0;)M(0);return I.wrap(T).slice(0,K)}e.decodeBase64=a;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:n},r=!0,f=!1){const E=f?l:u;let T="";const M=n.byteLength%3;let K=0;for(;K<n.byteLength-M;K+=3){const V=n[K+0],F=n[K+1],U=n[K+2];T+=E[V>>>2],T+=E[(V<<4|F>>>4)&63],T+=E[(F<<2|U>>>6)&63],T+=E[U&63]}if(M===1){const V=n[K+0];T+=E[V>>>2],T+=E[V<<4&63],r&&(T+="==")}else if(M===2){const V=n[K+0],F=n[K+1];T+=E[V>>>2],T+=E[(V<<4|F>>>4)&63],T+=E[F<<2&63],r&&(T+="=")}return T}e.encodeBase64=c}),define(ye[11],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function o(s){return typeof s=="string"}e.isString=o;function t(s){return Array.isArray(s)&&s.every(a=>o(a))}e.isStringArray=t;function k(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=k;function R(s){const a=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof a}e.isTypedArray=R;function I(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=I;function A(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=A;function y(s){return s===!0||s===!1}e.isBoolean=y;function D(s){return typeof s>"u"}e.isUndefined=D;function L(s){return!P(s)}e.isDefined=L;function P(s){return D(s)||s===null}e.isUndefinedOrNull=P;function v(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=v;function C(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=C;function S(...s){const a=[];for(let u=0;u<s.length;u++){const l=s[u];if(P(l))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);a.push(l)}return a}e.assertAllDefined=S;const m=Object.prototype.hasOwnProperty;function d(s){if(!k(s))return!1;for(const a in s)if(m.call(s,a))return!1;return!0}e.isEmptyObject=d;function h(s){return typeof s=="function"}e.isFunction=h;function b(...s){return s.length>0&&s.every(h)}e.areFunctions=b;function g(s,a){const u=Math.min(s.length,a.length);for(let l=0;l<u;l++)p(s[l],a[l])}e.validateConstraints=g;function p(s,a){if(o(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(h(a)){try{if(s instanceof a)return}catch{}if(!P(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function w(s){return s===null?void 0:s}e.withNullAsUndefined=w;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ye[23],Ce([1,0,11]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const b=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([g,p])=>{b[g]=p&&typeof p=="object"?t(p):p}),b}e.deepClone=t;function k(h){if(!h||typeof h!="object")return h;const b=[h];for(;b.length>0;){const g=b.shift();Object.freeze(g);for(const p in g)if(R.call(g,p)){const w=g[p];typeof w=="object"&&!Object.isFrozen(w)&&!(0,o.isTypedArray)(w)&&b.push(w)}}return h}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function I(h,b){return A(h,b,new Set)}e.cloneAndChange=I;function A(h,b,g){if((0,o.isUndefinedOrNull)(h))return h;const p=b(h);if(typeof p<"u")return p;if(Array.isArray(h)){const w=[];for(const i of h)w.push(A(i,b,g));return w}if((0,o.isObject)(h)){if(g.has(h))throw new Error("Cannot clone recursive data-structure");g.add(h);const w={};for(const i in h)R.call(h,i)&&(w[i]=A(h[i],b,g));return g.delete(h),w}return h}function y(h,b,g=!0){return(0,o.isObject)(h)?((0,o.isObject)(b)&&Object.keys(b).forEach(p=>{p in h?g&&((0,o.isObject)(h[p])&&(0,o.isObject)(b[p])?y(h[p],b[p],g):h[p]=b[p]):h[p]=b[p]}),h):b}e.mixin=y;function D(h,b){if(h===b)return!0;if(h==null||b===null||b===void 0||typeof h!=typeof b||typeof h!="object"||Array.isArray(h)!==Array.isArray(b))return!1;let g,p;if(Array.isArray(h)){if(h.length!==b.length)return!1;for(g=0;g<h.length;g++)if(!D(h[g],b[g]))return!1}else{const w=[];for(p in h)w.push(p);w.sort();const i=[];for(p in b)i.push(p);if(i.sort(),!D(w,i))return!1;for(g=0;g<w.length;g++)if(!D(h[w[g]],b[w[g]]))return!1}return!0}e.equals=D;function L(h){const b=new Set;return JSON.stringify(h,(g,p)=>{if((0,o.isObject)(p)||Array.isArray(p)){if(b.has(p))return"[Circular]";b.add(p)}return p})}e.safeStringify=L;function P(h,b){const g=Object.create(null);return!h||!b||Object.keys(b).forEach(w=>{const i=h[w],s=b[w];D(i,s)||(g[w]=s)}),g}e.distinct=P;function v(h,b){const g=b.toLowerCase(),p=Object.keys(h).find(w=>w.toLowerCase()===g);return p?h[p]:h[b]}e.getCaseInsensitive=v;function C(h,b){const g=Object.create(null);for(const[p,w]of Object.entries(h))b(p,w)&&(g[p]=w);return g}e.filter=C;function S(h){let b=[],g=Object.getPrototypeOf(h);for(;Object.prototype!==g;)b=b.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return b}e.getAllPropertyNames=S;function m(h){const b=[];for(const g of S(h))typeof h[g]=="function"&&b.push(g);return b}e.getAllMethodNames=m;function d(h,b){const g=w=>function(){const i=Array.prototype.slice.call(arguments,0);return b(w,i)},p={};for(const w of h)p[w]=g(w);return p}e.createProxyObject=d}),define(ye[103],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var o;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o=e.Constants||(e.Constants={}));function t(R){return R<0?0:R>255?255:R|0}e.toUint8=t;function k(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=k}),define(ye[30],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return o.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const R=new Uint8Array(16),I=[];for(let A=0;A<256;A++)I.push(A.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,D="";return D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D}}()}),define(ye[148],Ce([1,0,18,30]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function k(A){return{id:(0,t.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=k;function R(A,y,D){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:D}),value:void 0}}e.createFileDataTransferItem=R;class I{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,D){const L=this.a.get(y);L?L.push(D):this.a.set(this.b(y),[D])}replace(y,D){this.a.set(this.b(y),[D])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,D]of this.a.entries())for(const L of D)yield[y,L]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[D,L]of this.entries())y(L,D)}b(y){return y.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:A=>(0,o.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(ye[104],Ce([1,0,103]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(A){const y=(0,o.toUint8)(A);this.c=y,this.a=t.d(y),this.b=new Map}static d(A){const y=new Uint8Array(256);return y.fill(A),y}set(A,y){const D=(0,o.toUint8)(y);A>=0&&A<256?this.a[A]=D:this.b.set(A,D)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var k;(function(I){I[I.False=0]="False",I[I.True=1]="True"})(k||(k={}));class R{constructor(){this.a=new t(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[51],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class o{constructor(k,R){this.lineNumber=k,this.column=R}with(k=this.lineNumber,R=this.column){return k===this.lineNumber&&R===this.column?this:new o(k,R)}delta(k=0,R=0){return this.with(this.lineNumber+k,this.column+R)}equals(k){return o.equals(this,k)}static equals(k,R){return!k&&!R?!0:!!k&&!!R&&k.lineNumber===R.lineNumber&&k.column===R.column}isBefore(k){return o.isBefore(this,k)}static isBefore(k,R){return k.lineNumber<R.lineNumber?!0:R.lineNumber<k.lineNumber?!1:k.column<R.column}isBeforeOrEqual(k){return o.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,R){return k.lineNumber<R.lineNumber?!0:R.lineNumber<k.lineNumber?!1:k.column<=R.column}static compare(k,R){const I=k.lineNumber|0,A=R.lineNumber|0;if(I===A){const y=k.column|0,D=R.column|0;return y-D}return I-A}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new o(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=o}),define(ye[35],Ce([1,0,51]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(R,I,A,y){R>A||R===A&&I>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=R,this.endColumn=I):(this.startLineNumber=R,this.startColumn=I,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return t.containsPosition(this,R)}static containsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<R.startColumn||I.lineNumber===R.endLineNumber&&I.column>R.endColumn)}static strictContainsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<=R.startColumn||I.lineNumber===R.endLineNumber&&I.column>=R.endColumn)}containsRange(R){return t.containsRange(this,R)}static containsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>R.endColumn)}strictContainsRange(R){return t.strictContainsRange(this,R)}static strictContainsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<=R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>=R.endColumn)}plusRange(R){return t.plusRange(this,R)}static plusRange(R,I){let A,y,D,L;return I.startLineNumber<R.startLineNumber?(A=I.startLineNumber,y=I.startColumn):I.startLineNumber===R.startLineNumber?(A=I.startLineNumber,y=Math.min(I.startColumn,R.startColumn)):(A=R.startLineNumber,y=R.startColumn),I.endLineNumber>R.endLineNumber?(D=I.endLineNumber,L=I.endColumn):I.endLineNumber===R.endLineNumber?(D=I.endLineNumber,L=Math.max(I.endColumn,R.endColumn)):(D=R.endLineNumber,L=R.endColumn),new t(A,y,D,L)}intersectRanges(R){return t.intersectRanges(this,R)}static intersectRanges(R,I){let A=R.startLineNumber,y=R.startColumn,D=R.endLineNumber,L=R.endColumn;const P=I.startLineNumber,v=I.startColumn,C=I.endLineNumber,S=I.endColumn;return A<P?(A=P,y=v):A===P&&(y=Math.max(y,v)),D>C?(D=C,L=S):D===C&&(L=Math.min(L,S)),A>D||A===D&&y>L?null:new t(A,y,D,L)}equalsRange(R){return t.equalsRange(this,R)}static equalsRange(R,I){return!R&&!I?!0:!!R&&!!I&&R.startLineNumber===I.startLineNumber&&R.startColumn===I.startColumn&&R.endLineNumber===I.endLineNumber&&R.endColumn===I.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(R){return new o.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(R){return new o.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,I){return new t(this.startLineNumber,this.startColumn,R,I)}setStartPosition(R,I){return new t(R,I,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(R){return new t(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(R){return new t(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new t(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,I=R){return new t(R.lineNumber,R.column,I.lineNumber,I.column)}static lift(R){return R?new t(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn)}static areIntersecting(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,I){if(R&&I){const D=R.startLineNumber|0,L=I.startLineNumber|0;if(D===L){const P=R.startColumn|0,v=I.startColumn|0;if(P===v){const C=R.endLineNumber|0,S=I.endLineNumber|0;if(C===S){const m=R.endColumn|0,d=I.endColumn|0;return m-d}return C-S}return P-v}return D-L}return(R?1:0)-(I?1:0)}static compareRangesUsingEnds(R,I){return R.endLineNumber===I.endLineNumber?R.endColumn===I.endColumn?R.startLineNumber===I.startLineNumber?R.startColumn-I.startColumn:R.startLineNumber-I.startLineNumber:R.endColumn-I.endColumn:R.endLineNumber-I.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=t}),define(ye[149],Ce([1,0,51,35]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(I){I[I.LTR=0]="LTR",I[I.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class R extends t.Range{constructor(A,y,D,L){super(A,y,D,L),this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=D,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return R.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,A,y):new R(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new o.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,y){return this.getDirection()===0?new R(A,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new R(A.lineNumber,A.column,y.lineNumber,y.column)}static fromRange(A,y){return y===0?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new R(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new R(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let D=0,L=A.length;D<L;D++)if(!this.selectionsEqual(A[D],y[D]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,D,L,P){return P===0?new R(A,y,D,L):new R(D,L,A,y)}}e.Selection=R}),define(ye[150],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[151],Ce([1,0,104]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(I){I[I.Regular=0]="Regular",I[I.Whitespace=1]="Whitespace",I[I.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends o.CharacterClassifier{constructor(A){super(0);for(let y=0,D=A.length;y<D;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function R(I){const A={};return y=>(A.hasOwnProperty(y)||(A[y]=I(y)),A[y])}e.getMapForWordSeparators=R(I=>new k(I))}),define(ye[105],Ce([1,0,62,6,63]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)P.indexOf(C)>=0||(v+="\\"+C);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function I(P){let v=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)v=P;else{let C="g";P.ignoreCase&&(C+="i"),P.multiline&&(C+="m"),P.unicode&&(C+="u"),v=new RegExp(P.source,C)}return v.lastIndex=0,v}e.ensureValidWordDefinition=I;const A=new k.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(P){const v=A.unshift(P);return(0,t.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=y;function D(P,v,C,S,m){if(m||(m=o.Iterable.first(A)),C.length>m.maxLen){let p=P-m.maxLen/2;return p<0?p=0:S+=p,C=C.substring(p,P+m.maxLen/2),D(P,v,C,S,m)}const d=Date.now(),h=P-1-S;let b=-1,g=null;for(let p=1;!(Date.now()-d>=m.timeBudget);p++){const w=h-m.windowSize*p;v.lastIndex=Math.max(0,w);const i=L(v,C,h,b);if(!i&&g||(g=i,w<=0))break;b=w}if(g){const p={word:g[0],startColumn:S+1+g.index,endColumn:S+1+g.index+g[0].length};return v.lastIndex=0,p}return null}e.getWordAtText=D;function L(P,v,C,S){let m;for(;m=P.exec(v);){const d=m.index||0;if(d<=C&&P.lastIndex>=C)return m;if(S>0&&d>S)return null}return null}}),define(ye[152],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class t{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,D=A.notIn.length;y<D;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const D=A.findTokenIndexAtOffset(y-2),L=A.getStandardTokenType(D);return this.isOK(L)}g(A,y){for(let D=A;D<=y;D++){const L=String.fromCharCode(D);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class k{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=k;function R(I,A,y){I.has(A)?I.get(A).push(y):I.set(A,[y])}}),define(ye[153],Ce([1,0,104]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class k{constructor(S,m,d){const h=new Uint8Array(S*m);for(let b=0,g=S*m;b<g;b++)h[b]=d;this.a=h,this.rows=S,this.cols=m}get(S,m){return this.a[S*this.cols+m]}set(S,m,d){this.a[S*this.cols+m]=d}}class R{constructor(S){let m=0,d=0;for(let b=0,g=S.length;b<g;b++){const[p,w,i]=S[b];w>m&&(m=w),p>d&&(d=p),i>d&&(d=i)}m++,d++;const h=new k(d,m,0);for(let b=0,g=S.length;b<g;b++){const[p,w,i]=S[b];h.set(p,w,i)}this.a=h,this.b=m}nextState(S,m){return m<0||m>=this.b?0:this.a.get(S,m)}}e.StateMachine=R;let I=null;function A(){return I===null&&(I=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I}var y;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let D=null;function L(){if(D===null){D=new o.CharacterClassifier(0);const C=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<C.length;m++)D.set(C.charCodeAt(m),1);const S=".;:";for(let m=0;m<S.length;m++)D.set(S.charCodeAt(m),2)}return D}class P{static a(S,m,d,h,b){let g=b-1;do{const p=m.charCodeAt(g);if(S.get(p)!==2)break;g--}while(g>h);if(h>0){const p=m.charCodeAt(h-1),w=m.charCodeAt(g);(p===40&&w===41||p===91&&w===93||p===123&&w===125)&&g--}return{range:{startLineNumber:d,startColumn:h+1,endLineNumber:d,endColumn:g+2},url:m.substring(h,g+1)}}static computeLinks(S,m=A()){const d=L(),h=[];for(let b=1,g=S.getLineCount();b<=g;b++){const p=S.getLineContent(b),w=p.length;let i=0,s=0,a=0,u=1,l=!1,c=!1,n=!1,r=!1;for(;i<w;){let f=!1;const E=p.charCodeAt(i);if(u===13){let T;switch(E){case 40:l=!0,T=0;break;case 41:T=l?0:1;break;case 91:n=!0,c=!0,T=0;break;case 93:n=!1,T=c?0:1;break;case 123:r=!0,T=0;break;case 125:T=r?0:1;break;case 39:case 34:case 96:a===E?T=1:a===39||a===34||a===96?T=0:T=1;break;case 42:T=a===42?1:0;break;case 124:T=a===124?1:0;break;case 32:T=n?0:1;break;default:T=d.get(E)}T===1&&(h.push(P.a(d,p,b,s,i)),f=!0)}else if(u===12){let T;E===91?(c=!0,T=0):T=d.get(E),T===1?f=!0:u=13}else u=m.nextState(u,E),u===0&&(f=!0);f&&(u=1,l=!1,c=!1,r=!1,s=i+1,a=E),i++}u===13&&h.push(P.a(d,p,b,s,w))}return h}}e.LinkComputer=P;function v(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:P.computeLinks(C)}e.computeLinks=v}),define(ye[106],Ce([1,0,23]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var I;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),p.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,p.indentSize|0),this.a=!1),this.insertSpaces=Boolean(p.insertSpaces),this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=Boolean(p.trimAutoWhitespace),this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this.a===p.a&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,o.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class L{constructor(p,w){this._findMatchBrand=void 0,this.range=p,this.matches=w}}e.FindMatch=L;var P;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(g){return g&&typeof g.read=="function"}e.isITextSnapshot=v;var C;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(C=e.PositionAffinity||(e.PositionAffinity={}));var S;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(S=e.ModelConstants||(e.ModelConstants={}));class m{constructor(p,w,i,s,a,u){this.identifier=p,this.range=w,this.text=i,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=a,this._isTracked=u}}e.ValidAnnotatedEditOperation=m;class d{constructor(p,w,i){this.regex=p,this.wordSeparators=w,this.simpleSearch=i}}e.SearchData=d;class h{constructor(p,w,i){this.reverseEdits=p,this.changes=w,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=h;function b(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(ye[154],Ce([1,0,18,103]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,D){y=(0,t.toUint32)(y);const L=this.a,P=this.b,v=D.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y),y+v),this.a.set(D,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(y,D){return y=(0,t.toUint32)(y),D=(0,t.toUint32)(D),this.a[y]===D?!1:(this.a[y]=D,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,D){y=(0,t.toUint32)(y),D=(0,t.toUint32)(D);const L=this.a,P=this.b;if(y>=L.length)return!1;const v=L.length-y;return D>=v&&(D=v),D===0?!1:(this.a=new Uint32Array(L.length-D),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y+D),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,t.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let D=this.c[0]+1;D===0&&(this.b[0]=this.a[0],D++),y>=this.a.length&&(y=this.a.length-1);for(let L=D;L<=y;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let D=0,L=this.a.length-1,P=0,v=0,C=0;for(;D<=L;)if(P=D+(L-D)/2|0,v=this.b[P],C=v-this.a[P],y<C)L=P-1;else if(y>=v)D=P+1;else break;return new I(P,y-C)}}e.PrefixSumComputer=k;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const D=this.e[y],L=D>0?this.d[D-1]:0;return new I(D,y-L)}removeValues(y,D){this.a.splice(y,D),this.f(y)}insertValues(y,D){this.a=(0,o.arrayInsert)(this.a,y,D),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,D=this.a.length;y<D;y++){const L=this.a[y],P=y>0?this.d[y-1]:0;this.d[y]=P+L;for(let v=0;v<L;v++)this.e[P+v]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,D){this.a[y]!==D&&(this.a[y]=D,this.f(y))}}e.ConstantTimePrefixSumComputer=R;class I{constructor(y,D){this.index=y,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=D}}e.PrefixSumIndexOfResult=I}),define(ye[155],Ce([19,20]),function(te,e){return te.create("vs/base/common/actions",e)}),define(ye[156],Ce([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(ye[157],Ce([1,0,156]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,I=R*7,A=R*30,y=R*365;function D(P,v,C,S){typeof P!="number"&&(P=P.getTime());const m=Math.round((new Date().getTime()-P)/1e3);if(m<-30)return(0,o.localize)(0,null,D(new Date().getTime()+m*1e3,!1));if(!S&&m<30)return(0,o.localize)(1,null);let d;return m<t?(d=m,v?d===1?C?(0,o.localize)(2,null,d):(0,o.localize)(3,null,d):C?(0,o.localize)(4,null,d):(0,o.localize)(5,null,d):d===1?C?(0,o.localize)(6,null,d):(0,o.localize)(7,null,d):C?(0,o.localize)(8,null,d):(0,o.localize)(9,null,d)):m<k?(d=Math.floor(m/t),v?d===1?C?(0,o.localize)(10,null,d):(0,o.localize)(11,null,d):C?(0,o.localize)(12,null,d):(0,o.localize)(13,null,d):d===1?C?(0,o.localize)(14,null,d):(0,o.localize)(15,null,d):C?(0,o.localize)(16,null,d):(0,o.localize)(17,null,d)):m<R?(d=Math.floor(m/k),v?d===1?C?(0,o.localize)(18,null,d):(0,o.localize)(19,null,d):C?(0,o.localize)(20,null,d):(0,o.localize)(21,null,d):d===1?C?(0,o.localize)(22,null,d):(0,o.localize)(23,null,d):C?(0,o.localize)(24,null,d):(0,o.localize)(25,null,d)):m<I?(d=Math.floor(m/R),v?d===1?(0,o.localize)(26,null,d):(0,o.localize)(27,null,d):d===1?(0,o.localize)(28,null,d):(0,o.localize)(29,null,d)):m<A?(d=Math.floor(m/I),v?d===1?C?(0,o.localize)(30,null,d):(0,o.localize)(31,null,d):C?(0,o.localize)(32,null,d):(0,o.localize)(33,null,d):d===1?C?(0,o.localize)(34,null,d):(0,o.localize)(35,null,d):C?(0,o.localize)(36,null,d):(0,o.localize)(37,null,d)):m<y?(d=Math.floor(m/A),v?d===1?C?(0,o.localize)(38,null,d):(0,o.localize)(39,null,d):C?(0,o.localize)(40,null,d):(0,o.localize)(41,null,d):d===1?C?(0,o.localize)(42,null,d):(0,o.localize)(43,null,d):C?(0,o.localize)(44,null,d):(0,o.localize)(45,null,d)):(d=Math.floor(m/y),v?d===1?C?(0,o.localize)(46,null,d):(0,o.localize)(47,null,d):C?(0,o.localize)(48,null,d):(0,o.localize)(49,null,d):d===1?C?(0,o.localize)(50,null,d):(0,o.localize)(51,null,d):C?(0,o.localize)(52,null,d):(0,o.localize)(53,null,d))}e.fromNow=D;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[158],Ce([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ye[45],Ce([1,0,18,11,158]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,v){return v&&(P.stack||P.stacktrace)?k.localize(0,null,A(P),I(P.stack)||I(P.stacktrace)):A(P)}function I(P){return Array.isArray(P)?P.join(`
`):P}function A(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function y(P=null,v=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const C=o.coalesce(P),S=y(C[0],v);return C.length>1?k.localize(4,null,S,C.length):S}if(t.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return R(C.error,v);if(C.exception)return R(C.exception,v)}return P.stack?R(P,v):P.message?P.message:k.localize(5,null)}e.toErrorMessage=y;function D(P){const v=P;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=D;function L(P,v){let C;return typeof P=="string"?C=new Error(P):C=P,C.actions=v,C}e.createErrorWithActions=L}),define(ye[159],Ce([19,20]),function(te,e){return te.create("vs/base/common/platform",e)}),define(ye[12],Ce([1,0,159]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,I=!1,A=!1,y=!1,D=!1,L=!1,P=!1,v=!1,C,S=e.LANGUAGE_DEFAULT,m,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const b=typeof h?.versions?.electron=="string",g=b&&h?.type==="renderer";if(typeof navigator=="object"&&!g)d=navigator.userAgent,t=d.indexOf("Windows")>=0,k=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,v=d?.indexOf("Mobi")>=0,y=!0,C=o.getConfiguredDefaultLocale(o.localize(0,null))||e.LANGUAGE_DEFAULT,S=C;else if(typeof h=="object"){t=h.platform==="win32",k=h.platform==="darwin",R=h.platform==="linux",I=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,D=b,P=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),f=r.availableLanguages["*"];C=r.locale,S=f||e.LANGUAGE_DEFAULT,m=r._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var p;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function w(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let i=0;k?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=I,e.isNative=A,e.isElectron=D,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=v,e.isCI=P,e.platform=i,e.userAgent=d,e.language=S;var s;(function(n){function r(){return e.language}n.value=r;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=f;function E(){return e.language==="en"}n.isDefault=E})(s=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let E=0,T=n.length;E<T;E++){const M=n[E];if(M.id===f.data.vscodeScheduleAsyncWork){n.splice(E,1),M.callback();return}}});let r=0;return f=>{const E=++r;n.push({id:E,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return n=>setTimeout(n)})();var a;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||L?2:t?1:3;let u=!0,l=!1;function c(){if(!l){l=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,u=new Uint16Array(n.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],Ce([1,0,12]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.process<"u"){const k=o.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return o.isWindows?"win32":o.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ye[9],Ce([1,0,36]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,I=122,A=46,y=47,D=92,L=58,P=63;class v extends Error{constructor(s,a,u){let l;typeof a=="string"&&a.indexOf("not ")===0?(l="must not be",a=a.replace(/^not /,"")):l="must be";const c=s.indexOf(".")!==-1?"property":"argument";let n=`The "${s}" ${c} ${l} of type ${a}`;n+=`. Received type ${typeof u}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function C(i,s){if(i===null||typeof i!="object")throw new v(s,"Object",i)}function S(i,s){if(typeof i!="string")throw new v(s,"string",i)}const m=o.platform==="win32";function d(i){return i===y||i===D}function h(i){return i===y}function b(i){return i>=t&&i<=R||i>=k&&i<=I}function g(i,s,a,u){let l="",c=0,n=-1,r=0,f=0;for(let E=0;E<=i.length;++E){if(E<i.length)f=i.charCodeAt(E);else{if(u(f))break;f=y}if(u(f)){if(!(n===E-1||r===1))if(r===2){if(l.length<2||c!==2||l.charCodeAt(l.length-1)!==A||l.charCodeAt(l.length-2)!==A){if(l.length>2){const T=l.lastIndexOf(a);T===-1?(l="",c=0):(l=l.slice(0,T),c=l.length-1-l.lastIndexOf(a)),n=E,r=0;continue}else if(l.length!==0){l="",c=0,n=E,r=0;continue}}s&&(l+=l.length>0?`${a}..`:"..",c=2)}else l.length>0?l+=`${a}${i.slice(n+1,E)}`:l=i.slice(n+1,E),c=E-n-1;n=E,r=0}else f===A&&r!==-1?++r:r=-1}return l}function p(i,s){C(s,"pathObject");const a=s.dir||s.root,u=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${u}`:`${a}${i}${u}`:u}e.win32={resolve(...i){let s="",a="",u=!1;for(let l=i.length-1;l>=-1;l--){let c;if(l>=0){if(c=i[l],S(c,"path"),c.length===0)continue}else s.length===0?c=o.cwd():(c=o.env[`=${s}`]||o.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==s.toLowerCase()&&c.charCodeAt(2)===D)&&(c=`${s}\\`));const n=c.length;let r=0,f="",E=!1;const T=c.charCodeAt(0);if(n===1)d(T)&&(r=1,E=!0);else if(d(T))if(E=!0,d(c.charCodeAt(1))){let M=2,K=M;for(;M<n&&!d(c.charCodeAt(M));)M++;if(M<n&&M!==K){const V=c.slice(K,M);for(K=M;M<n&&d(c.charCodeAt(M));)M++;if(M<n&&M!==K){for(K=M;M<n&&!d(c.charCodeAt(M));)M++;(M===n||M!==K)&&(f=`\\\\${V}\\${c.slice(K,M)}`,r=M)}}}else r=1;else b(T)&&c.charCodeAt(1)===L&&(f=c.slice(0,2),r=2,n>2&&d(c.charCodeAt(2))&&(E=!0,r=3));if(f.length>0)if(s.length>0){if(f.toLowerCase()!==s.toLowerCase())continue}else s=f;if(u){if(s.length>0)break}else if(a=`${c.slice(r)}\\${a}`,u=E,E&&s.length>0)break}return a=g(a,!u,"\\",d),u?`${s}\\${a}`:`${s}${a}`||"."},normalize(i){S(i,"path");const s=i.length;if(s===0)return".";let a=0,u,l=!1;const c=i.charCodeAt(0);if(s===1)return h(c)?"\\":i;if(d(c))if(l=!0,d(i.charCodeAt(1))){let r=2,f=r;for(;r<s&&!d(i.charCodeAt(r));)r++;if(r<s&&r!==f){const E=i.slice(f,r);for(f=r;r<s&&d(i.charCodeAt(r));)r++;if(r<s&&r!==f){for(f=r;r<s&&!d(i.charCodeAt(r));)r++;if(r===s)return`\\\\${E}\\${i.slice(f)}\\`;r!==f&&(u=`\\\\${E}\\${i.slice(f,r)}`,a=r)}}}else a=1;else b(c)&&i.charCodeAt(1)===L&&(u=i.slice(0,2),a=2,s>2&&d(i.charCodeAt(2))&&(l=!0,a=3));let n=a<s?g(i.slice(a),!l,"\\",d):"";return n.length===0&&!l&&(n="."),n.length>0&&d(i.charCodeAt(s-1))&&(n+="\\"),u===void 0?l?`\\${n}`:n:l?`${u}\\${n}`:`${u}${n}`},isAbsolute(i){S(i,"path");const s=i.length;if(s===0)return!1;const a=i.charCodeAt(0);return d(a)||s>2&&b(a)&&i.charCodeAt(1)===L&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,a;for(let c=0;c<i.length;++c){const n=i[c];S(n,"path"),n.length>0&&(s===void 0?s=a=n:s+=`\\${n}`)}if(s===void 0)return".";let u=!0,l=0;if(typeof a=="string"&&d(a.charCodeAt(0))){++l;const c=a.length;c>1&&d(a.charCodeAt(1))&&(++l,c>2&&(d(a.charCodeAt(2))?++l:u=!1))}if(u){for(;l<s.length&&d(s.charCodeAt(l));)l++;l>=2&&(s=`\\${s.slice(l)}`)}return e.win32.normalize(s)},relative(i,s){if(S(i,"from"),S(s,"to"),i===s)return"";const a=e.win32.resolve(i),u=e.win32.resolve(s);if(a===u||(i=a.toLowerCase(),s=u.toLowerCase(),i===s))return"";let l=0;for(;l<i.length&&i.charCodeAt(l)===D;)l++;let c=i.length;for(;c-1>l&&i.charCodeAt(c-1)===D;)c--;const n=c-l;let r=0;for(;r<s.length&&s.charCodeAt(r)===D;)r++;let f=s.length;for(;f-1>r&&s.charCodeAt(f-1)===D;)f--;const E=f-r,T=n<E?n:E;let M=-1,K=0;for(;K<T;K++){const F=i.charCodeAt(l+K);if(F!==s.charCodeAt(r+K))break;F===D&&(M=K)}if(K!==T){if(M===-1)return u}else{if(E>T){if(s.charCodeAt(r+K)===D)return u.slice(r+K+1);if(K===2)return u.slice(r+K)}n>T&&(i.charCodeAt(l+K)===D?M=K:K===2&&(M=3)),M===-1&&(M=0)}let V="";for(K=l+M+1;K<=c;++K)(K===c||i.charCodeAt(K)===D)&&(V+=V.length===0?"..":"\\..");return r+=M,V.length>0?`${V}${u.slice(r,f)}`:(u.charCodeAt(r)===D&&++r,u.slice(r,f))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===D){if(s.charCodeAt(1)===D){const a=s.charCodeAt(2);if(a!==P&&a!==A)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(b(s.charCodeAt(0))&&s.charCodeAt(1)===L&&s.charCodeAt(2)===D)return`\\\\?\\${s}`;return i},dirname(i){S(i,"path");const s=i.length;if(s===0)return".";let a=-1,u=0;const l=i.charCodeAt(0);if(s===1)return d(l)?i:".";if(d(l)){if(a=u=1,d(i.charCodeAt(1))){let r=2,f=r;for(;r<s&&!d(i.charCodeAt(r));)r++;if(r<s&&r!==f){for(f=r;r<s&&d(i.charCodeAt(r));)r++;if(r<s&&r!==f){for(f=r;r<s&&!d(i.charCodeAt(r));)r++;if(r===s)return i;r!==f&&(a=u=r+1)}}}}else b(l)&&i.charCodeAt(1)===L&&(a=s>2&&d(i.charCodeAt(2))?3:2,u=a);let c=-1,n=!0;for(let r=s-1;r>=u;--r)if(d(i.charCodeAt(r))){if(!n){c=r;break}}else n=!1;if(c===-1){if(a===-1)return".";c=a}return i.slice(0,c)},basename(i,s){s!==void 0&&S(s,"ext"),S(i,"path");let a=0,u=-1,l=!0,c;if(i.length>=2&&b(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(a=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let n=s.length-1,r=-1;for(c=i.length-1;c>=a;--c){const f=i.charCodeAt(c);if(d(f)){if(!l){a=c+1;break}}else r===-1&&(l=!1,r=c+1),n>=0&&(f===s.charCodeAt(n)?--n===-1&&(u=c):(n=-1,u=r))}return a===u?u=r:u===-1&&(u=i.length),i.slice(a,u)}for(c=i.length-1;c>=a;--c)if(d(i.charCodeAt(c))){if(!l){a=c+1;break}}else u===-1&&(l=!1,u=c+1);return u===-1?"":i.slice(a,u)},extname(i){S(i,"path");let s=0,a=-1,u=0,l=-1,c=!0,n=0;i.length>=2&&i.charCodeAt(1)===L&&b(i.charCodeAt(0))&&(s=u=2);for(let r=i.length-1;r>=s;--r){const f=i.charCodeAt(r);if(d(f)){if(!c){u=r+1;break}continue}l===-1&&(c=!1,l=r+1),f===A?a===-1?a=r:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||l===-1||n===0||n===1&&a===l-1&&a===u+1?"":i.slice(a,l)},format:p.bind(null,"\\"),parse(i){S(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.length;let u=0,l=i.charCodeAt(0);if(a===1)return d(l)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(d(l)){if(u=1,d(i.charCodeAt(1))){let M=2,K=M;for(;M<a&&!d(i.charCodeAt(M));)M++;if(M<a&&M!==K){for(K=M;M<a&&d(i.charCodeAt(M));)M++;if(M<a&&M!==K){for(K=M;M<a&&!d(i.charCodeAt(M));)M++;M===a?u=M:M!==K&&(u=M+1)}}}}else if(b(l)&&i.charCodeAt(1)===L){if(a<=2)return s.root=s.dir=i,s;if(u=2,d(i.charCodeAt(2))){if(a===3)return s.root=s.dir=i,s;u=3}}u>0&&(s.root=i.slice(0,u));let c=-1,n=u,r=-1,f=!0,E=i.length-1,T=0;for(;E>=u;--E){if(l=i.charCodeAt(E),d(l)){if(!f){n=E+1;break}continue}r===-1&&(f=!1,r=E+1),l===A?c===-1?c=E:T!==1&&(T=1):c!==-1&&(T=-1)}return r!==-1&&(c===-1||T===0||T===1&&c===r-1&&c===n+1?s.base=s.name=i.slice(n,r):(s.name=i.slice(n,c),s.base=i.slice(n,r),s.ext=i.slice(c,r))),n>0&&n!==u?s.dir=i.slice(0,n-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(m){const i=/\\/g;return()=>{const s=o.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>o.cwd()})();e.posix={resolve(...i){let s="",a=!1;for(let u=i.length-1;u>=-1&&!a;u--){const l=u>=0?i[u]:w();S(l,"path"),l.length!==0&&(s=`${l}/${s}`,a=l.charCodeAt(0)===y)}return s=g(s,!a,"/",h),a?`/${s}`:s.length>0?s:"."},normalize(i){if(S(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===y,a=i.charCodeAt(i.length-1)===y;return i=g(i,!s,"/",h),i.length===0?s?"/":a?"./":".":(a&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return S(i,"path"),i.length>0&&i.charCodeAt(0)===y},join(...i){if(i.length===0)return".";let s;for(let a=0;a<i.length;++a){const u=i[a];S(u,"path"),u.length>0&&(s===void 0?s=u:s+=`/${u}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(S(i,"from"),S(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const a=1,u=i.length,l=u-a,c=1,n=s.length-c,r=l<n?l:n;let f=-1,E=0;for(;E<r;E++){const M=i.charCodeAt(a+E);if(M!==s.charCodeAt(c+E))break;M===y&&(f=E)}if(E===r)if(n>r){if(s.charCodeAt(c+E)===y)return s.slice(c+E+1);if(E===0)return s.slice(c+E)}else l>r&&(i.charCodeAt(a+E)===y?f=E:E===0&&(f=0));let T="";for(E=a+f+1;E<=u;++E)(E===u||i.charCodeAt(E)===y)&&(T+=T.length===0?"..":"/..");return`${T}${s.slice(c+f)}`},toNamespacedPath(i){return i},dirname(i){if(S(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===y;let a=-1,u=!0;for(let l=i.length-1;l>=1;--l)if(i.charCodeAt(l)===y){if(!u){a=l;break}}else u=!1;return a===-1?s?"/":".":s&&a===1?"//":i.slice(0,a)},basename(i,s){s!==void 0&&S(s,"ext"),S(i,"path");let a=0,u=-1,l=!0,c;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let n=s.length-1,r=-1;for(c=i.length-1;c>=0;--c){const f=i.charCodeAt(c);if(f===y){if(!l){a=c+1;break}}else r===-1&&(l=!1,r=c+1),n>=0&&(f===s.charCodeAt(n)?--n===-1&&(u=c):(n=-1,u=r))}return a===u?u=r:u===-1&&(u=i.length),i.slice(a,u)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===y){if(!l){a=c+1;break}}else u===-1&&(l=!1,u=c+1);return u===-1?"":i.slice(a,u)},extname(i){S(i,"path");let s=-1,a=0,u=-1,l=!0,c=0;for(let n=i.length-1;n>=0;--n){const r=i.charCodeAt(n);if(r===y){if(!l){a=n+1;break}continue}u===-1&&(l=!1,u=n+1),r===A?s===-1?s=n:c!==1&&(c=1):s!==-1&&(c=-1)}return s===-1||u===-1||c===0||c===1&&s===u-1&&s===a+1?"":i.slice(s,u)},format:p.bind(null,"/"),parse(i){S(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.charCodeAt(0)===y;let u;a?(s.root="/",u=1):u=0;let l=-1,c=0,n=-1,r=!0,f=i.length-1,E=0;for(;f>=u;--f){const T=i.charCodeAt(f);if(T===y){if(!r){c=f+1;break}continue}n===-1&&(r=!1,n=f+1),T===A?l===-1?l=f:E!==1&&(E=1):l!==-1&&(E=-1)}if(n!==-1){const T=c===0&&a?1:c;l===-1||E===0||E===1&&l===n-1&&l===c+1?s.base=s.name=i.slice(T,n):(s.name=i.slice(T,l),s.base=i.slice(T,n),s.ext=i.slice(l,n))}return c>0?s.dir=i.slice(0,c-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m?e.win32.normalize:e.posix.normalize,e.isAbsolute=m?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m?e.win32.join:e.posix.join,e.resolve=m?e.win32.resolve:e.posix.resolve,e.relative=m?e.win32.relative:e.posix.relative,e.dirname=m?e.win32.dirname:e.posix.dirname,e.basename=m?e.win32.basename:e.posix.basename,e.extname=m?e.win32.extname:e.posix.extname,e.format=m?e.win32.format:e.posix.format,e.parse=m?e.win32.parse:e.posix.parse,e.toNamespacedPath=m?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m?e.win32.sep:e.posix.sep,e.delimiter=m?e.win32.delimiter:e.posix.delimiter}),define(ye[84],Ce([1,0,9]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const P=(0,o.extname)(L),v=t[P.toLowerCase()];return v!==void 0?v:I(L)}e.getMediaOrTextMime=R;function I(L){const P=(0,o.extname)(L);return k[P.toLowerCase()]}e.getMediaMime=I;function A(L){for(const P in k)if(k[P]===L)return P}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function D(L,P){const v=y.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:P?void 0:L}e.normalizeMimeType=D}),define(ye[107],Ce([1,0,12]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(A,...y){const D=y.reduce((v,C)=>(v[C]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(v=>!D[v]).forEach(v=>{for(let C=0;C<L.length;C++)if(v.search(L[C])!==-1){delete A[v];break}})}e.sanitizeProcessEnvironment=R;function I(A){!A||(delete A.DEBUG,o.isMacintosh&&delete A.DYLD_LIBRARY_PATH,o.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=I}),define(ye[43],Ce([1,0,12]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=o.globals.performance&&typeof o.globals.performance.now=="function";class k{static create(I=!0){return new k(I)}constructor(I){this.a=t&&I,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?o.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ye[3],Ce([1,0,10,61,6,63,43]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var D;(function(c){c.None=()=>k.Disposable.None;function n(ve){if(y){const{onDidAddListener:Pe}=ve,Ne=S.create();let se=0;ve.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ne.print()),Pe?.()}}}function r(ve,Pe){return N(ve,()=>{},0,void 0,void 0,Pe)}c.defer=r;function f(ve){return(Pe,Ne=null,se)=>{let ue=!1,de;return de=ve(Z=>{if(!ue)return de?de.dispose():ue=!0,Pe.call(Ne,Z)},null,se),ue&&de.dispose(),de}}c.once=f;function E(ve,Pe,Ne){return U((se,ue=null,de)=>ve(Z=>se.call(ue,Pe(Z)),null,de),Ne)}c.map=E;function T(ve,Pe,Ne){return U((se,ue=null,de)=>ve(Z=>{Pe(Z),se.call(ue,Z)},null,de),Ne)}c.forEach=T;function M(ve,Pe,Ne){return U((se,ue=null,de)=>ve(Z=>Pe(Z)&&se.call(ue,Z),null,de),Ne)}c.filter=M;function K(ve){return ve}c.signal=K;function V(...ve){return(Pe,Ne=null,se)=>(0,k.combinedDisposable)(...ve.map(ue=>ue(de=>Pe.call(Ne,de),null,se)))}c.any=V;function F(ve,Pe,Ne,se){let ue=Ne;return E(ve,de=>(ue=Pe(ue,de),ue),se)}c.reduce=F;function U(ve,Pe){let Ne;const se={onWillAddFirstListener(){Ne=ve(ue.fire,ue)},onDidRemoveLastListener(){Ne?.dispose()}};Pe||n(se);const ue=new d(se);return Pe?.add(ue),ue.event}function N(ve,Pe,Ne=100,se=!1,ue,de){let Z,ae,ie,O=0;const W={leakWarningThreshold:ue,onWillAddFirstListener(){Z=ve(Q=>{O++,ae=Pe(ae,Q),se&&!ie&&(X.fire(ae),ae=void 0),clearTimeout(ie),ie=setTimeout(()=>{const he=ae;ae=void 0,ie=void 0,(!se||O>1)&&X.fire(he),O=0},Ne)})},onDidRemoveLastListener(){Z.dispose()}};de||n(W);const X=new d(W);return de?.add(X),X.event}c.debounce=N;function B(ve,Pe=0,Ne){return c.debounce(ve,(se,ue)=>se?(se.push(ue),se):[ue],Pe,void 0,void 0,Ne)}c.accumulate=B;function j(ve,Pe=(se,ue)=>se===ue,Ne){let se=!0,ue;return M(ve,de=>{const Z=se||!Pe(de,ue);return se=!1,ue=de,Z},Ne)}c.latch=j;function z(ve,Pe,Ne){return[c.filter(ve,Pe,Ne),c.filter(ve,se=>!Pe(se),Ne)]}c.split=z;function ne(ve,Pe=!1,Ne=[]){let se=Ne.slice(),ue=ve(ae=>{se?se.push(ae):Z.fire(ae)});const de=()=>{se?.forEach(ae=>Z.fire(ae)),se=null},Z=new d({onWillAddFirstListener(){ue||(ue=ve(ae=>Z.fire(ae)))},onDidAddFirstListener(){se&&(Pe?setTimeout(de):de())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return Z.event}c.buffer=ne;class _{constructor(Pe){this.event=Pe,this.c=new k.DisposableStore}map(Pe){return new _(E(this.event,Pe,this.c))}forEach(Pe){return new _(T(this.event,Pe,this.c))}filter(Pe){return new _(M(this.event,Pe,this.c))}reduce(Pe,Ne){return new _(F(this.event,Pe,Ne,this.c))}latch(){return new _(j(this.event,void 0,this.c))}debounce(Pe,Ne=100,se=!1,ue){return new _(N(this.event,Pe,Ne,se,ue,this.c))}on(Pe,Ne,se){return this.event(Pe,Ne,se)}once(Pe,Ne,se){return f(this.event)(Pe,Ne,se)}dispose(){this.c.dispose()}}function Y(ve){return new _(ve)}c.chain=Y;function J(ve,Pe,Ne=se=>se){const se=(...ae)=>Z.fire(Ne(...ae)),ue=()=>ve.on(Pe,se),de=()=>ve.removeListener(Pe,se),Z=new d({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return Z.event}c.fromNodeEventEmitter=J;function ee(ve,Pe,Ne=se=>se){const se=(...ae)=>Z.fire(Ne(...ae)),ue=()=>ve.addEventListener(Pe,se),de=()=>ve.removeEventListener(Pe,se),Z=new d({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return Z.event}c.fromDOMEventEmitter=ee;function ge(ve){return new Promise(Pe=>f(ve)(Pe))}c.toPromise=ge;function q(ve,Pe){return Pe(void 0),ve(Ne=>Pe(Ne))}c.runAndSubscribe=q;function G(ve,Pe){let Ne=null;function se(de){Ne?.dispose(),Ne=new k.DisposableStore,Pe(de,Ne)}se(void 0);const ue=ve(de=>se(de));return(0,k.toDisposable)(()=>{ue.dispose(),Ne?.dispose()})}c.runAndSubscribeWithStore=G;class le{constructor(Pe,Ne){this.obs=Pe,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Ne||n(se),this.emitter=new d(se),Ne&&Ne.add(this.emitter)}beginUpdate(Pe){this.c++}handleChange(Pe,Ne){this.d=!0}endUpdate(Pe){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function be(ve,Pe){return new le(ve,Pe).emitter.event}c.fromObservable=be})(D=e.Event||(e.Event={}));class L{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${L.c++}`,L.all.add(this)}start(n){this.d=new I.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=L,L.all=new Set,L.c=0;let P=-1;function v(c){const n=P;return P=c,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=v;class C{constructor(n,r=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=r,this.d=0}dispose(){this.c?.clear()}check(n,r){const f=this.threshold;if(f<=0||r<f)return;this.c||(this.c=new Map);const E=this.c.get(n.value)||0;if(this.c.set(n.value,E+1),this.d-=1,this.d<=0){this.d=f*.5;let T,M=0;for(const[K,V]of this.c)(!T||M<V)&&(T=K,M=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${M}):`),console.warn(T)}return()=>{const T=this.c.get(n.value)||0;this.c.set(n.value,T-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(n,r,f){this.callback=n,this.callbackThis=r,this.stack=f,this.subscription=new k.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class d{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new C(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const n=Array.from(this.q);queueMicrotask(()=>{for(const r of n)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,r,f)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,M;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(M=S.create(),T=this.f.check(M,this.q.size+1)),A&&(M=M??S.create());const K=new m(n,r,M),V=this.q.push(K);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,r);const F=K.subscription.set(()=>{T?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return f instanceof k.DisposableStore?f.add(F):Array.isArray(f)&&f.push(F),F}),this.l}fire(n){if(this.q){this.m||(this.m=new b);for(const r of this.q)this.m.push(this,r,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=d;class h{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(n,r,f){this.c.push(new g(n,r,f))}clear(n){const r=new R.LinkedList;for(const f of this.c)f.emitter!==n&&r.push(f);this.c=r}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(r){(0,o.onUnexpectedError)(r)}}}}e.EventDeliveryQueue=h;class b extends h{clear(n){this.c.clear()}}class g{constructor(n,r,f){this.emitter=n,this.listener=r,this.event=f}}class p extends d{async fireAsync(n,r,f){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const E of this.q)this.c.push([E,n]);for(;this.c.size>0&&!r.isCancellationRequested;){const[E,T]=this.c.shift(),M=[],K={...T,token:r,waitUntil:V=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");f&&(V=f(V,E.callback)),M.push(V)}};try{E.invoke(K)}catch(V){(0,o.onUnexpectedError)(V);continue}Object.freeze(M),await Promise.allSettled(M).then(V=>{for(const F of V)F.status==="rejected"&&(0,o.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=p;class w extends d{constructor(n){super(n),this.h=0,this.s=new R.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=w;class i extends w{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=i;class s extends d{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(r=>super.fire(r)),this.c=[]}))}}e.MicrotaskEmitter=s;class a{constructor(){this.d=!1,this.f=[],this.c=new d({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const r={event:n,listener:null};this.f.push(r),this.d&&this.j(r);const f=()=>{this.d&&this.k(r);const E=this.f.indexOf(r);this.f.splice(E,1)};return(0,k.toDisposable)((0,t.once)(f))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(r=>this.c.fire(r))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=a;class u{constructor(){this.c=[]}wrapEvent(n){return(r,f,E)=>n(T=>{const M=this.c[this.c.length-1];M?M.push(()=>r.call(f,T)):r.call(f,T)},void 0,E)}bufferEvents(n){const r=[];this.c.push(r);const f=n();return this.c.pop(),r.forEach(E=>E()),f}}e.EventBufferer=u;class l{constructor(){this.c=!1,this.d=D.None,this.f=k.Disposable.None,this.g=new d({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=l}),define(ye[160],Ce([1,0,3,6,155]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends t.Disposable{constructor(v,C="",S="",m=!0,d){super(),this.h=this.B(new o.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=C,this.u=S,this.w=m,this.C=d}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,C){this.C&&await this.C(v)}}e.Action=R;class I extends t.Disposable{constructor(){super(...arguments),this.f=this.B(new o.Emitter),this.onWillRun=this.f.event,this.h=this.B(new o.Emitter),this.onDidRun=this.h.event}async run(v,C){if(!v.enabled)return;this.f.fire({action:v});let S;try{await this.runAction(v,C)}catch(m){S=m}this.h.fire({action:v,error:S})}async runAction(v,C){await v.run(C)}}e.ActionRunner=I;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let C=[];for(const S of v)S.length&&(C.length?C=[...C,new A,...S]:C=S);return C}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(v,C,S,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=C,this.class=m,this.a=S}async run(){}}e.SubmenuAction=y;class D extends R{constructor(){super(D.ID,k.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=D,D.ID="vs.actions.empty";function L(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}e.toAction=L}),define(ye[21],Ce([1,0,3]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(A,y){const D=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(D)}}});var k;(function(A){function y(D){return D===A.None||D===A.Cancelled||D instanceof R?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new o.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=k.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=I}),define(ye[161],Ce([1,0,21]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new o.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=t;class k{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=k;class R{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=R}),define(ye[8],Ce([1,0,161,82]),function(te,e,o,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const I=/{(\d+)}/g;function A($,...ce){return ce.length===0?$:$.replace(I,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=ce.length?Ie:ce[Be]})}e.format=A;const y=/{([^}]+)}/g;function D($,ce){return $.replace(y,(Ie,Le)=>ce[Le]??Ie)}e.format2=D;function L($){return $.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=L;function P($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function v($,ce){let Ie=0;const Le=ce.charCodeAt(0);for(let Be=$.length-1;Be>=0;Be--)$.charCodeAt(Be)===Le&&Ie++;return Ie}e.count=v;function C($,ce,Ie="\u2026"){return $.length<=ce?$:`${$.substr(0,ce)}${Ie}`}e.truncate=C;function S($,ce=" "){const Ie=m($,ce);return d(Ie,ce)}e.trim=S;function m($,ce){if(!$||!ce)return $;const Ie=ce.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(ce,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=m;function d($,ce){if(!$||!ce)return $;const Ie=ce.length,Le=$.length;if(Ie===0||Le===0)return $;let Be=Le,xe=-1;for(;xe=$.lastIndexOf(ce,Be-1),!(xe===-1||xe+Ie!==Be);){if(xe===0)return"";Be=xe}return $.substring(0,Be)}e.rtrim=d;function h($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function b($){return $.replace(/\*/g,"")}e.stripWildcards=b;function g($,ce,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");ce||($=P($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=g;function p($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function w($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function i($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=i;function s($){return $.split(/\r\n|\r|\n/)}e.splitLines=s;function a($){for(let ce=0,Ie=$.length;ce<Ie;ce++){const Le=$.charCodeAt(ce);if(Le!==32&&Le!==9)return ce}return-1}e.firstNonWhitespaceIndex=a;function u($,ce=0,Ie=$.length){for(let Le=ce;Le<Ie;Le++){const Be=$.charCodeAt(Le);if(Be!==32&&Be!==9)return $.substring(ce,Le)}return $.substring(ce,Ie)}e.getLeadingWhitespace=u;function l($,ce=$.length-1){for(let Ie=ce;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=l;function c($,ce,Ie){const Le=[];let Be=0;for(const xe of $.matchAll(ce)){if(Le.push($.slice(Be,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Be=xe.index+xe[0].length,Le.push(Ie(xe[0],...xe.slice(1),xe.index,$,xe.groups))}return Le.push($.slice(Be)),Promise.all(Le).then(xe=>xe.join(""))}e.replaceAsync=c;function n($,ce){return $<ce?-1:$>ce?1:0}e.compare=n;function r($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){const mt=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(mt<lt)return-1;if(mt>lt)return 1}const Ze=Le-Ie,gt=xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstring=r;function f($,ce){return E($,ce,0,$.length,0,ce.length)}e.compareIgnoreCase=f;function E($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){let mt=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(mt===lt)continue;if(mt>=128||lt>=128)return r($.toLowerCase(),ce.toLowerCase(),Ie,Le,Be,xe);M(mt)&&(mt-=32),M(lt)&&(lt-=32);const ot=mt-lt;if(ot!==0)return ot}const Ze=Le-Ie,gt=xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstringIgnoreCase=E;function T($){return $>=48&&$<=57}e.isAsciiDigit=T;function M($){return $>=97&&$<=122}e.isLowerAsciiLetter=M;function K($){return $>=65&&$<=90}e.isUpperAsciiLetter=K;function V($,ce){return $.length===ce.length&&E($,ce)===0}e.equalsIgnoreCase=V;function F($,ce){const Ie=ce.length;return ce.length>$.length?!1:E($,ce,0,Ie)===0}e.startsWithIgnoreCase=F;function U($,ce){const Ie=Math.min($.length,ce.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==ce.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=U;function N($,ce){const Ie=Math.min($.length,ce.length);let Le;const Be=$.length-1,xe=ce.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Be-Le)!==ce.charCodeAt(xe-Le))return Le;return Ie}e.commonSuffixLength=N;function B($){return 55296<=$&&$<=56319}e.isHighSurrogate=B;function j($){return 56320<=$&&$<=57343}e.isLowSurrogate=j;function z($,ce){return($-55296<<10)+(ce-56320)+65536}e.computeCodePoint=z;function ne($,ce,Ie){const Le=$.charCodeAt(Ie);if(B(Le)&&Ie+1<ce){const Be=$.charCodeAt(Ie+1);if(j(Be))return z(Le,Be)}return Le}e.getNextCodePoint=ne;function _($,ce){const Ie=$.charCodeAt(ce-1);if(j(Ie)&&ce>1){const Le=$.charCodeAt(ce-2);if(B(Le))return z(Le,Ie)}return Ie}class Y{get offset(){return this.e}constructor(ce,Ie=0){this.c=ce,this.d=ce.length,this.e=Ie}setOffset(ce){this.e=ce}prevCodePoint(){const ce=_(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=ne(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=Y;class J{get offset(){return this.c.offset}constructor(ce,Ie=0){this.c=new Y(ce,Ie)}nextGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.nextCodePoint());if(je(Be,Ze)){Ie.setOffset(xe);break}Be=Ze}return Ie.offset-Le}prevGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.prevCodePoint());if(je(Ze,Be)){Ie.setOffset(xe);break}Be=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function ee($,ce){return new J($,ce).nextGraphemeLength()}e.nextCharLength=ee;function ge($,ce){return new J($,ce).prevGraphemeLength()}e.prevCharLength=ge;function q($,ce){ce>0&&j($.charCodeAt(ce))&&ce--;const Ie=ce+ee($,ce);return[Ie-ge($,Ie),Ie]}e.getCharContainingOffset=q;function G($){const ce=new J($);let Ie=0;for(;!ce.eol();)Ie++,ce.nextGraphemeLength();return Ie}e.charCount=G;let le;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve($){return le||(le=be()),le.test($)}e.containsRTL=ve;const Pe=/^[\t\n\r\x20-\x7E]*$/;function Ne($){return Pe.test($)}e.isBasicASCII=Ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=se;function ue($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=ue;function de($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=de;function Z($,ce){if($.length<ce)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<ce);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=Z;const ae=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function W($){return $&&($=$.replace(ae,""),$=$.replace(ie,""),$=$.replace(O,"")),$}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function X($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=X;function Q($){return X($)?$.substr(1):$}e.stripUTF8BOM=Q;function he($,ce){if(!$||!ce||$.length<ce.length)return!1;const Ie=ce.length,Le=$.toLowerCase();let Be=0,xe=-1;for(;Be<Ie;){const Ze=Le.indexOf(ce[Be],xe+1);if(Ze<0)return!1;xe=Ze,Be++}return!0}e.fuzzyContains=he;function we($,ce=!1){return $?(ce&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=we;function Ae($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Ae;function pe($,ce=1){if(ce===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),ce--;while(ce>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=pe;function De($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=De;function ke($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=ke;function je($,ce){return $===0?ce!==5&&ce!==7:$===2&&ce===3?!1:$===4||$===2||$===3||ce===4||ce===2||ce===3?!0:!($===8&&(ce===8||ce===9||ce===11||ce===12)||($===11||$===9)&&(ce===9||ce===10)||($===12||$===10)&&ce===10||ce===5||ce===13||ce===7||$===1||$===13&&ce===14||$===6&&ce===6)}var Ge;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=_e()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(ce<Ie[3*Be])Be=2*Be;else if(ce>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}et.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,ce){if($===0)return 0;const Ie=st($,ce);if(Ie!==void 0)return Ie;const Le=new Y(ce,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,ce){const Ie=new Y(ce,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!de(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function ht($){return 127995<=$&&$<=127999}var Me;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class it{static getInstance(ce){return it.d.get(Array.from(ce))}static getLocales(){return it.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,k=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new o.LRUCachedFunction($=>{function ce(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ie(lt,ot){const rt=new Map(lt);for(const[kt,Tt]of ot)rt.set(kt,Tt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[kt,Tt]of lt)ot.has(kt)&&rt.set(kt,Tt);return rt}const Be=k.c.getValue();let xe=$.filter(lt=>!lt.startsWith("_")&&lt in Be);xe.length===0&&(xe=["_default"]);let Ze;for(const lt of xe){const ot=ce(Be[lt]);Ze=Le(Ze,ot)}const gt=ce(Be._common),mt=Ie(gt,Ze);return new it(mt)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter($=>!$.startsWith("_")));class oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(oe.c())),this.d}static isInvisibleCharacter(ce){return oe.e().has(ce)}static get codePoints(){return oe.e()}}e.InvisibleCharacters=oe,oe.d=void 0}),define(ye[32],Ce([1,0,9,12,8,11]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(l){return l===47||l===92}e.isPathSeparator=I;function A(l){return l.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=A;function y(l){return l.indexOf("/")===-1&&(l=A(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=y;function D(l,c=o.posix.sep){if(!l)return"";const n=l.length,r=l.charCodeAt(0);if(I(r)){if(I(l.charCodeAt(1))&&!I(l.charCodeAt(2))){let E=3;const T=E;for(;E<n&&!I(l.charCodeAt(E));E++);if(T!==E&&!I(l.charCodeAt(E+1))){for(E+=1;E<n;E++)if(I(l.charCodeAt(E)))return l.slice(0,E+1).replace(/[\\/]/g,c)}}return c}else if(h(r)&&l.charCodeAt(1)===58)return I(l.charCodeAt(2))?l.slice(0,2)+c:l.slice(0,2);let f=l.indexOf("://");if(f!==-1){for(f+=3;f<n;f++)if(I(l.charCodeAt(f)))return l.slice(0,f+1)}return""}e.getRoot=D;function L(l){if(!t.isWindows||!l||l.length<5)return!1;let c=l.charCodeAt(0);if(c!==92||(c=l.charCodeAt(1),c!==92))return!1;let n=2;const r=n;for(;n<l.length&&(c=l.charCodeAt(n),c!==92);n++);return!(r===n||(c=l.charCodeAt(n+1),isNaN(c)||c===92))}e.isUNC=L;const P=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(l,c=t.isWindows){const n=c?P:v;return!(!l||l.length===0||/^\s+$/.test(l)||(n.lastIndex=0,n.test(l))||c&&C.test(l)||l==="."||l===".."||c&&l[l.length-1]==="."||c&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=S;function m(l,c,n){const r=l===c;return!n||r?r:!l||!c?!1:(0,k.equalsIgnoreCase)(l,c)}e.isEqual=m;function d(l,c,n,r=o.sep){if(l===c)return!0;if(!l||!c||c.length>l.length)return!1;if(n){if(!(0,k.startsWithIgnoreCase)(l,c))return!1;if(c.length===l.length)return!0;let E=c.length;return c.charAt(c.length-1)===r&&E--,l.charAt(E)===r}return c.charAt(c.length-1)!==r&&(c+=r),l.indexOf(c)===0}e.isEqualOrParent=d;function h(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=h;function b(l,c){return t.isWindows&&l.endsWith(":")&&(l+=o.sep),(0,o.isAbsolute)(l)||(l=(0,o.join)(c,l)),l=(0,o.normalize)(l),t.isWindows?(l=(0,k.rtrim)(l,o.sep),l.endsWith(":")&&(l+=o.sep)):(l=(0,k.rtrim)(l,o.sep),l||(l=o.sep)),l}e.sanitizeFilePath=b;function g(l){const c=(0,o.normalize)(l);return t.isWindows?l.length>3?!1:p(c)&&(l.length===2||c.charCodeAt(2)===92):c===o.posix.sep}e.isRootOrDriveLetter=g;function p(l,c=t.isWindows){return c?h(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function w(l){return p(l)?l[0]:void 0}e.getDriveLetter=w;function i(l,c,n){return c.length>l.length?-1:l===c?0:(n&&(l=l.toLowerCase(),c=c.toLowerCase()),l.indexOf(c))}e.indexOfPath=i;function s(l){const c=l.split(":");let n,r,f;for(const E of c){const T=Number(E);(0,R.isNumber)(T)?r===void 0?r=T:f===void 0&&(f=T):n=n?[n,E].join(":"):E}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:r!==void 0?r:void 0,column:f!==void 0?f:r!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(l,c,n=8){let r="";for(let E=0;E<n;E++)r+=a.charAt(Math.floor(Math.random()*a.length));let f;return c?f=`${c}-${r}`:f=r,l?(0,o.join)(l,f):f}e.randomPath=u}),define(ye[108],Ce([1,0,28,8]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...ie){return function(O,W){for(let X=0,Q=ie.length;X<Q;X++){const he=ie[X](O,W);if(he)return he}return null}}e.or=k,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ie,O,W){if(!W||W.length<O.length)return null;let X;return ie?X=t.startsWithIgnoreCase(W,O):X=W.indexOf(O)===0,X?O.length>0?[{start:0,end:O.length}]:[]:null}function I(ie,O){const W=O.toLowerCase().indexOf(ie.toLowerCase());return W===-1?null:[{start:W,end:W+ie.length}]}e.matchesContiguousSubString=I;function A(ie,O){return y(ie.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=A;function y(ie,O,W,X){if(W===ie.length)return[];if(X===O.length)return null;if(ie[W]===O[X]){let Q=null;return(Q=y(ie,O,W+1,X+1))?h({start:X,end:X+1},Q):null}return y(ie,O,W,X+1)}function D(ie){return 97<=ie&&ie<=122}function L(ie){return 65<=ie&&ie<=90}e.isUpper=L;function P(ie){return 48<=ie&&ie<=57}function v(ie){return ie===32||ie===9||ie===10||ie===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>C.add(ie.charCodeAt(0)));function S(ie){return v(ie)||C.has(ie)}function m(ie,O){return ie===O||S(ie)&&S(O)}function d(ie){return D(ie)||L(ie)||P(ie)}function h(ie,O){return O.length===0?O=[ie]:ie.end===O[0].start?O[0].start=ie.start:O.unshift(ie),O}function b(ie,O){for(let W=O;W<ie.length;W++){const X=ie.charCodeAt(W);if(L(X)||P(X)||W>0&&!d(ie.charCodeAt(W-1)))return W}return ie.length}function g(ie,O,W,X){if(W===ie.length)return[];if(X===O.length)return null;if(ie[W]!==O[X].toLowerCase())return null;{let Q=null,he=X+1;for(Q=g(ie,O,W+1,X+1);!Q&&(he=b(O,he))<O.length;)Q=g(ie,O,W+1,he),he++;return Q===null?null:h({start:X,end:X+1},Q)}}function p(ie){let O=0,W=0,X=0,Q=0,he=0;for(let ke=0;ke<ie.length;ke++)he=ie.charCodeAt(ke),L(he)&&O++,D(he)&&W++,d(he)&&X++,P(he)&&Q++;const we=O/ie.length,Ae=W/ie.length,pe=X/ie.length,De=Q/ie.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:pe,numericPercent:De}}function w(ie){const{upperPercent:O,lowerPercent:W}=ie;return W===0&&O>.6}function i(ie){const{upperPercent:O,lowerPercent:W,alphaPercent:X,numericPercent:Q}=ie;return W>.2&&O<.8&&X>.6&&Q<.2}function s(ie){let O=0,W=0,X=0,Q=0;for(let he=0;he<ie.length;he++)X=ie.charCodeAt(he),L(X)&&O++,D(X)&&W++,v(X)&&Q++;return(O===0||W===0)&&Q===0?ie.length<=30:O<=5}function a(ie,O){if(!O||(O=O.trim(),O.length===0)||!s(ie)||O.length>60)return null;const W=p(O);if(!i(W)){if(!w(W))return null;O=O.toLowerCase()}let X=null,Q=0;for(ie=ie.toLowerCase();Q<O.length&&(X=g(ie,O,0,Q))===null;)Q=b(O,Q+1);return X}e.matchesCamelCase=a;function u(ie,O,W=!1){if(!O||O.length===0)return null;let X=null,Q=0;for(ie=ie.toLowerCase(),O=O.toLowerCase();Q<O.length&&(X=l(ie,O,0,Q,W))===null;)Q=c(O,Q+1);return X}e.matchesWords=u;function l(ie,O,W,X,Q){if(W===ie.length)return[];if(X===O.length)return null;if(m(ie.charCodeAt(W),O.charCodeAt(X))){let he=null,we=X+1;if(he=l(ie,O,W+1,X+1,Q),!Q)for(;!he&&(we=c(O,we))<O.length;)he=l(ie,O,W+1,we,Q),we++;return he?ie.charCodeAt(W)!==O.charCodeAt(X)?he:h({start:X,end:X+1},he):null}else return null}function c(ie,O){for(let W=O;W<ie.length;W++)if(S(ie.charCodeAt(W))||W>0&&S(ie.charCodeAt(W-1)))return W;return ie.length}const n=k(e.matchesPrefix,a,I),r=k(e.matchesPrefix,a,A),f=new o.LRUCache(1e4);function E(ie,O,W=!1){if(typeof ie!="string"||typeof O!="string")return null;let X=f.get(ie);X||(X=new RegExp(t.convertSimple2RegExpPattern(ie),"i"),f.set(ie,X));const Q=X.exec(O);return Q?[{start:Q.index,end:Q.index+Q[0].length}]:W?r(ie,O):n(ie,O)}e.matchesFuzzy=E;function T(ie,O){const W=Pe(ie,ie.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?K(W):null}e.matchesFuzzy2=T;function M(ie,O,W,X,Q,he){const we=Math.min(13,ie.length);for(;W<we;W++){const Ae=Pe(ie,O,W,X,Q,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,he]}e.anyScore=M;function K(ie){if(typeof ie>"u")return[];const O=[],W=ie[1];for(let X=ie.length-1;X>1;X--){const Q=ie[X]+W,he=O[O.length-1];he&&he.end===Q?he.end=Q+1:O.push({start:Q,end:Q+1})}return O}e.createMatches=K;const V=128;function F(){const ie=[],O=[];for(let W=0;W<=V;W++)O[W]=0;for(let W=0;W<=V;W++)ie.push(O.slice(0));return ie}function U(ie){const O=[];for(let W=0;W<=ie;W++)O[W]=0;return O}const N=U(2*V),B=U(2*V),j=F(),z=F(),ne=F(),_=!1;function Y(ie,O,W,X,Q){function he(Ae,pe,De=" "){for(;Ae.length<pe;)Ae=De+Ae;return Ae}let we=` |   |${X.split("").map(Ae=>he(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=W;Ae++)Ae===0?we+=" |":we+=`${O[Ae-1]}|`,we+=ie[Ae].slice(0,Q+1).map(pe=>he(pe.toString(),3)).join("|")+`
`;return we}function J(ie,O,W,X){ie=ie.substr(O),W=W.substr(X),console.log(Y(z,ie,ie.length,W,W.length)),console.log(Y(ne,ie,ie.length,W,W.length)),console.log(Y(j,ie,ie.length,W,W.length))}function ee(ie,O){if(O<0||O>=ie.length)return!1;const W=ie.codePointAt(O);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(W)}}function ge(ie,O){if(O<0||O>=ie.length)return!1;switch(ie.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function q(ie,O,W){return O[ie]!==W[ie]}function G(ie,O,W,X,Q,he,we=!1){for(;O<W&&Q<he;)ie[O]===X[Q]&&(we&&(N[O]=Q),O+=1),Q+=1;return O===W}e.isPatternInWord=G;var le;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(le||(le={}));var be;(function(ie){ie.Default=[-100,0];function O(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}ie.isDefault=O})(be=e.FuzzyScore||(e.FuzzyScore={}));class ve{constructor(O,W){this.firstMatchCanBeWeak=O,this.boostFullMatch=W}}e.FuzzyScoreOptions=ve,ve.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Pe(ie,O,W,X,Q,he,we=ve.default){const Ae=ie.length>V?V:ie.length,pe=X.length>V?V:X.length;if(W>=Ae||he>=pe||Ae-W>pe-he||!G(O,W,Ae,Q,he,pe,!0))return;Ne(Ae,pe,W,he,O,Q);let De=1,ke=1,je=W,Ge=he;const et=[!1];for(De=1,je=W;je<Ae;De++,je++){const Me=N[je],it=B[je],oe=je+1<Ae?B[je+1]:pe;for(ke=Me-he+1,Ge=Me;Ge<oe;ke++,Ge++){let $=Number.MIN_SAFE_INTEGER,ce=!1;Ge<=it&&($=se(ie,O,je,W,X,Q,Ge,pe,he,j[De-1][ke-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(ce=!0,Ie=$+z[De-1][ke-1]);const Le=Ge>Me,Be=Le?z[De][ke-1]+(j[De][ke-1]>0?-5:0):0,xe=Ge>Me+1&&j[De][ke-1]>0,Ze=xe?z[De][ke-2]+(j[De][ke-2]>0?-5:0):0;if(xe&&(!Le||Ze>=Be)&&(!ce||Ze>=Ie))z[De][ke]=Ze,ne[De][ke]=3,j[De][ke]=0;else if(Le&&(!ce||Be>=Ie))z[De][ke]=Be,ne[De][ke]=2,j[De][ke]=0;else if(ce)z[De][ke]=Ie,ne[De][ke]=1,j[De][ke]=j[De-1][ke-1]+1;else throw new Error("not possible")}}if(_&&J(ie,W,X,he),!et[0]&&!we.firstMatchCanBeWeak)return;De--,ke--;const _e=[z[De][ke],he];let nt=0,st=0;for(;De>=1;){let Me=ke;do{const it=ne[De][Me];if(it===3)Me=Me-2;else if(it===2)Me=Me-1;else break}while(Me>=1);nt>1&&O[W+De-1]===Q[he+ke-1]&&!q(Me+he-1,X,Q)&&nt+1>j[De][Me]&&(Me=ke),Me===ke?nt++:nt=1,st||(st=Me),De--,ke=Me-1,_e.push(ke)}pe===Ae&&we.boostFullMatch&&(_e[0]+=2);const ht=st-Ae;return _e[0]-=ht,_e}e.fuzzyScore=Pe;function Ne(ie,O,W,X,Q,he){let we=ie-1,Ae=O-1;for(;we>=W&&Ae>=X;)Q[we]===he[Ae]&&(B[we]=Ae,we--),Ae--}function se(ie,O,W,X,Q,he,we,Ae,pe,De,ke){if(O[W]!==he[we])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return we===W-X?je=ie[W]===Q[we]?7:5:q(we,Q,he)&&(we===0||!q(we-1,Q,he))?(je=ie[W]===Q[we]?7:5,Ge=!0):ee(he,we)&&(we===0||!ee(he,we-1))?je=5:(ee(he,we-1)||ge(he,we-1))&&(je=5,Ge=!0),je>1&&W===X&&(ke[0]=!0),Ge||(Ge=q(we,Q,he)||ee(he,we-1)||ge(he,we-1)),W===X?we>pe&&(je-=Ge?3:5):De?je+=Ge?2:0:je+=Ge?0:1,we+1===Ae&&(je-=Ge?3:5),je}function ue(ie,O,W,X,Q,he,we){return Z(ie,O,W,X,Q,he,!0,we)}e.fuzzyScoreGracefulAggressive=ue;function de(ie,O,W,X,Q,he,we){return Z(ie,O,W,X,Q,he,!1,we)}e.fuzzyScoreGraceful=de;function Z(ie,O,W,X,Q,he,we,Ae){let pe=Pe(ie,O,W,X,Q,he,Ae);if(pe&&!we)return pe;if(ie.length>=3){const De=Math.min(7,ie.length-1);for(let ke=W+1;ke<De;ke++){const je=ae(ie,ke);if(je){const Ge=Pe(je,je.toLowerCase(),W,X,Q,he,Ae);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function ae(ie,O){if(O+1>=ie.length)return;const W=ie[O],X=ie[O+1];if(W!==X)return ie.slice(0,O)+X+W+ie.slice(O+2)}}),define(ye[85],Ce([1,0,8]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return k(h,0)}e.hash=t;function k(h,b){switch(typeof h){case"object":return h===null?R(349,b):Array.isArray(h)?y(h,b):D(h,b);case"string":return A(h,b);case"boolean":return I(h,b);case"number":return R(h,b);case"undefined":return R(937,b);default:return R(617,b)}}e.doHash=k;function R(h,b){return(b<<5)-b+h|0}e.numberHash=R;function I(h,b){return R(h?433:863,b)}function A(h,b){b=R(149417,b);for(let g=0,p=h.length;g<p;g++)b=R(h.charCodeAt(g),b);return b}e.stringHash=A;function y(h,b){return b=R(104579,b),h.reduce((g,p)=>k(p,g),b)}function D(h,b){return b=R(181387,b),Object.keys(h).sort().reduce((g,p)=>(g=A(p,g),k(h[p],g)),b)}class L{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=k(b,this.g),this.g}}e.Hasher=L;var P;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function v(h,b,g=32){const p=g-b,w=~((1<<p)-1);return(h<<b|(w&h)>>>p)>>>0}function C(h,b=0,g=h.byteLength,p=0){for(let w=0;w<g;w++)h[b+w]=p}function S(h,b,g="0"){for(;h.length<b;)h=g+h;return h}function m(h,b=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(g=>g.toString(16).padStart(2,"0")).join(""):S((h>>>0).toString(16),b/4)}e.toHexString=m;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const g=b.length;if(g===0)return;const p=this.p;let w=this.r,i=this.u,s,a;for(i!==0?(s=i,a=-1,i=0):(s=b.charCodeAt(0),a=0);;){let u=s;if(o.isHighSurrogate(s))if(a+1<g){const l=b.charCodeAt(a+1);o.isLowSurrogate(l)?(a++,u=o.computeCodePoint(s,l)):u=65533}else{i=s;break}else o.isLowSurrogate(s)&&(u=65533);if(w=this.w(p,w,u),a++,a<g)s=b.charCodeAt(a);else break}this.r=w,this.u=i}w(b,g,p){return p<128?b[g++]=p:p<2048?(b[g++]=192|(p&1984)>>>6,b[g++]=128|(p&63)>>>0):p<65536?(b[g++]=224|(p&61440)>>>12,b[g++]=128|(p&4032)>>>6,b[g++]=128|(p&63)>>>0):(b[g++]=240|(p&1835008)>>>18,b[g++]=128|(p&258048)>>>12,b[g++]=128|(p&4032)>>>6,b[g++]=128|(p&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=d.g,g=this.q;for(let n=0;n<64;n+=4)b.setUint32(n,g.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)b.setUint32(n,v(b.getUint32(n-12,!1)^b.getUint32(n-32,!1)^b.getUint32(n-56,!1)^b.getUint32(n-64,!1),1),!1);let p=this.h,w=this.l,i=this.m,s=this.n,a=this.o,u,l,c;for(let n=0;n<80;n++)n<20?(u=w&i|~w&s,l=1518500249):n<40?(u=w^i^s,l=1859775393):n<60?(u=w&i|w&s|i&s,l=2400959708):(u=w^i^s,l=3395469782),c=v(p,5)+u+a+l+b.getUint32(n*4,!1)&4294967295,a=s,s=i,i=v(w,30),w=p,p=c;this.h=this.h+p&4294967295,this.l=this.l+w&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+a&4294967295}}e.StringSHA1=d,d.g=new DataView(new ArrayBuffer(320))}),define(ye[162],Ce([1,0,80,108,8]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",I=new RegExp(`\\$\\(${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${I.source}`,"g");function y(d){return d.replace(A,(h,b)=>b?h:`\\${h}`)}e.escapeIcons=y;const D=new RegExp(`\\\\${I.source}`,"g");function L(d){return d.replace(D,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=L;const P=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function v(d){return d.indexOf(R)===-1?d:d.replace(P,(h,b,g,p)=>g?h:b||p||"")}e.stripIcons=v;const C=new RegExp(`\\$\\(${o.CSSIcon.iconNameCharacter}+\\)`,"g");function S(d){C.lastIndex=0;let h="";const b=[];let g=0;for(;;){const p=C.lastIndex,w=C.exec(d),i=d.substring(p,w?.index);if(i.length>0){h+=i;for(let s=0;s<i.length;s++)b.push(g)}if(!w)break;g+=w[0].length}return{text:h,iconOffsets:b}}e.parseLabelWithIcons=S;function m(d,h,b=!1){const{text:g,iconOffsets:p}=h;if(!p||p.length===0)return(0,t.matchesFuzzy)(d,g,b);const w=(0,k.ltrim)(g," "),i=g.length-w.length,s=(0,t.matchesFuzzy)(d,w,b);if(s)for(const a of s){const u=p[a.start+i]+i;a.start+=u,a.end+=u}return s}e.matchesFuzzyIconAware=m}),define(ye[37],Ce([1,0,8]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",I="warning",A="warn",y="info",D="ignore";function L(v){return v?o.equalsIgnoreCase(R,v)?k.Error:o.equalsIgnoreCase(I,v)||o.equalsIgnoreCase(A,v)?k.Warning:o.equalsIgnoreCase(y,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=L;function P(v){switch(v){case k.Error:return R;case k.Warning:return I;case k.Info:return y;default:return D}}k.toString=P}(t||(t={})),e.default=t}),define(ye[64],Ce([1,0,18,8]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(C){return this.b=C,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(C){const S=C.charCodeAt(0),m=this.b.charCodeAt(this.c);return S-m}value(){return this.b[this.c]}}e.StringIterator=k;class R{constructor(C=!0){this.e=C}reset(C){return this.b=C,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let C=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(C)this.c++;else break;else C=!1;return this}cmp(C){return this.e?(0,t.compareSubstring)(C,this.b,0,C.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class I{constructor(C=!0,S=!0){this.f=C,this.g=S}reset(C){this.d=0,this.e=0,this.b=C,this.c=C.length;for(let S=C.length-1;S>=0;S--,this.c--){const m=this.b.charCodeAt(S);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let C=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(C)this.d++;else break;else C=!1}return this}cmp(C){return this.g?(0,t.compareSubstring)(C,this.b,0,C.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=I;var A;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(C,S){this.f=C,this.g=S,this.d=[],this.e=0}reset(C){return this.c=C,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(C)),this.b.reset(C.path),this.b.value()&&this.d.push(3)),this.g(C)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(C){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(C,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(C,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(C);if(this.d[this.e]===4)return(0,t.compare)(C,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(C,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class P{static forUris(C=()=>!1,S=()=>!1){return new P(new y(C,S))}static forPaths(C=!1){return new P(new I(void 0,!C))}static forStrings(){return new P(new k)}static forConfigKeys(){return new P(new R)}constructor(C){this.b=C}clear(){this.c=void 0}fill(C,S){if(S){const m=S.slice(0);(0,o.shuffle)(m);for(const d of m)this.set(d,C)}else{const m=C.slice(0);(0,o.shuffle)(m);for(const d of m)this.set(d[0],d[1])}}set(C,S){const m=this.b.reset(C);let d;this.c||(this.c=new D,this.c.segment=m.value());const h=[];for(d=this.c;;){const g=m.cmp(d.segment);if(g>0)d.left||(d.left=new D,d.left.segment=m.value()),h.push([-1,d]),d=d.left;else if(g<0)d.right||(d.right=new D,d.right.segment=m.value()),h.push([1,d]),d=d.right;else if(m.hasNext())m.next(),d.mid||(d.mid=new D,d.mid.segment=m.value()),h.push([0,d]),d=d.mid;else break}const b=d.value;d.value=S,d.key=C;for(let g=h.length-1;g>=0;g--){const p=h[g][1];p.updateHeight();const w=p.balanceFactor();if(w<-1||w>1){const i=h[g][0],s=h[g+1][0];if(i===1&&s===1)h[g][1]=p.rotateLeft();else if(i===-1&&s===-1)h[g][1]=p.rotateRight();else if(i===1&&s===-1)p.right=h[g+1][1]=h[g+1][1].rotateRight(),h[g][1]=p.rotateLeft();else if(i===-1&&s===1)p.left=h[g+1][1]=h[g+1][1].rotateLeft(),h[g][1]=p.rotateRight();else throw new Error;if(g>0)switch(h[g-1][0]){case-1:h[g-1][1].left=h[g][1];break;case 1:h[g-1][1].right=h[g][1];break;case 0:h[g-1][1].mid=h[g][1];break}else this.c=h[0][1]}}return b}get(C){return this.d(C)?.value}d(C){const S=this.b.reset(C);let m=this.c;for(;m;){const d=S.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(S.hasNext())S.next(),m=m.mid;else break}return m}has(C){const S=this.d(C);return!(S?.value===void 0&&S?.mid===void 0)}delete(C){return this.e(C,!1)}deleteSuperstr(C){return this.e(C,!0)}e(C,S){const m=this.b.reset(C),d=[];let h=this.c;for(;h;){const b=m.cmp(h.segment);if(b>0)d.push([-1,h]),h=h.left;else if(b<0)d.push([1,h]),h=h.right;else if(m.hasNext())m.next(),d.push([0,h]),h=h.mid;else break}if(!!h){if(S?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const b=this.f(h.right);if(b.key){const{key:g,value:p,segment:w}=b;this.e(b.key,!1),h.key=g,h.value=p,h.segment=w}}else{const b=h.left??h.right;if(d.length>0){const[g,p]=d[d.length-1];switch(g){case-1:p.left=b;break;case 0:p.mid=b;break;case 1:p.right=b;break}}else this.c=b}for(let b=d.length-1;b>=0;b--){const g=d[b][1];g.updateHeight();const p=g.balanceFactor();if(p>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),d[b][1]=g.rotateLeft()):p<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),d[b][1]=g.rotateRight()),b>0)switch(d[b-1][0]){case-1:d[b-1][1].left=d[b][1];break;case 1:d[b-1][1].right=d[b][1];break;case 0:d[b-1][1].mid=d[b][1];break}else this.c=d[0][1]}}}f(C){for(;C.left;)C=C.left;return C}findSubstr(C){const S=this.b.reset(C);let m=this.c,d;for(;m;){const h=S.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(S.hasNext())S.next(),d=m.value||d,m=m.mid;else break}return m&&m.value||d}findSuperstr(C){return this.g(C,!1)}g(C,S){const m=this.b.reset(C);let d=this.c;for(;d;){const h=m.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(m.hasNext())m.next(),d=d.mid;else return d.mid?this.h(d.mid):S?d.value:void 0}}hasElementOrSubtree(C){return this.g(C,!0)!==void 0}forEach(C){for(const[S,m]of this)C(m,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(C){const S=[];return this.j(C,S),S[Symbol.iterator]()}j(C,S){!C||(C.left&&this.j(C.left,S),C.value&&S.push([C.key,C.value]),C.mid&&this.j(C.mid,S),C.right&&this.j(C.right,S))}_isBalanced(){const C=S=>{if(!S)return!0;const m=S.balanceFactor();return m<-1||m>1?!1:C(S.left)&&C(S.right)};return C(this.c)}}e.TernarySearchTree=P}),define(ye[2],Ce([1,0,9,12]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,I=/^\/\//;function A(a,u){if(!a.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!k.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!R.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(a,u){return!a&&!u?"file":a}function D(a,u){switch(a){case"https":case"http":case"file":u?u[0]!==P&&(u=P+u):u=P;break}return u}const L="",P="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(u){return u instanceof C?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,l,c,n,r,f=!1){typeof u=="object"?(this.scheme=u.scheme||L,this.authority=u.authority||L,this.path=u.path||L,this.query=u.query||L,this.fragment=u.fragment||L):(this.scheme=y(u,f),this.authority=l||L,this.path=D(this.scheme,c||L),this.query=n||L,this.fragment=r||L,A(this,f))}get fsPath(){return g(this,!1)}with(u){if(!u)return this;let{scheme:l,authority:c,path:n,query:r,fragment:f}=u;return l===void 0?l=this.scheme:l===null&&(l=L),c===void 0?c=this.authority:c===null&&(c=L),n===void 0?n=this.path:n===null&&(n=L),r===void 0?r=this.query:r===null&&(r=L),f===void 0?f=this.fragment:f===null&&(f=L),l===this.scheme&&c===this.authority&&n===this.path&&r===this.query&&f===this.fragment?this:new m(l,c,n,r,f)}static parse(u,l=!1){const c=v.exec(u);return c?new m(c[2]||L,s(c[4]||L),s(c[5]||L),s(c[7]||L),s(c[9]||L),l):new m(L,L,L,L,L)}static file(u){let l=L;if(t.isWindows&&(u=u.replace(/\\/g,P)),u[0]===P&&u[1]===P){const c=u.indexOf(P,2);c===-1?(l=u.substring(2),u=P):(l=u.substring(2,c),u=u.substring(c)||P)}return new m("file",l,u,L,L)}static from(u){const l=new m(u.scheme,u.authority,u.path,u.query,u.fragment);return A(l,!0),l}static joinPath(u,...l){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&u.scheme==="file"?c=C.file(o.win32.join(g(u,!0),...l)).path:c=o.posix.join(u.path,...l),u.with({path:c})}toString(u=!1){return p(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof C)return u;{const l=new m(u);return l._formatted=u.external,l._fsPath=u._sep===S?u.fsPath:null,l}}else return u}}e.URI=C;const S=t.isWindows?1:void 0;class m extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(u=!1){return u?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=S),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(a,u,l){let c,n=-1;for(let r=0;r<a.length;r++){const f=a.charCodeAt(r);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||u&&f===47||l&&f===91||l&&f===93||l&&f===58)n!==-1&&(c+=encodeURIComponent(a.substring(n,r)),n=-1),c!==void 0&&(c+=a.charAt(r));else{c===void 0&&(c=a.substr(0,r));const E=d[f];E!==void 0?(n!==-1&&(c+=encodeURIComponent(a.substring(n,r)),n=-1),c+=E):n===-1&&(n=r)}}return n!==-1&&(c+=encodeURIComponent(a.substring(n))),c!==void 0?c:a}function b(a){let u;for(let l=0;l<a.length;l++){const c=a.charCodeAt(l);c===35||c===63?(u===void 0&&(u=a.substr(0,l)),u+=d[c]):u!==void 0&&(u+=a[l])}return u!==void 0?u:a}function g(a,u){let l;return a.authority&&a.path.length>1&&a.scheme==="file"?l=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?u?l=a.path.substr(1):l=a.path[1].toLowerCase()+a.path.substr(2):l=a.path,t.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=g;function p(a,u){const l=u?b:h;let c="",{scheme:n,authority:r,path:f,query:E,fragment:T}=a;if(n&&(c+=n,c+=":"),(r||n==="file")&&(c+=P,c+=P),r){let M=r.indexOf("@");if(M!==-1){const K=r.substr(0,M);r=r.substr(M+1),M=K.lastIndexOf(":"),M===-1?c+=l(K,!1,!1):(c+=l(K.substr(0,M),!1,!1),c+=":",c+=l(K.substr(M+1),!1,!0)),c+="@"}r=r.toLowerCase(),M=r.lastIndexOf(":"),M===-1?c+=l(r,!1,!0):(c+=l(r.substr(0,M),!1,!0),c+=r.substr(M))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const M=f.charCodeAt(1);M>=65&&M<=90&&(f=`/${String.fromCharCode(M+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const M=f.charCodeAt(0);M>=65&&M<=90&&(f=`${String.fromCharCode(M+32)}:${f.substr(2)}`)}c+=l(f,!0,!1)}return E&&(c+="?",c+=l(E,!1,!1)),T&&(c+="#",c+=u?T:h(T,!1,!1)),c}function w(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+w(a.substr(3)):a}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(a){return a.match(i)?a.replace(i,u=>w(u)):a}}),define(ye[86],Ce([1,0,22,8,2]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(D){return JSON.stringify(D,A)}e.stringify=R;function I(D){let L=JSON.parse(D);return L=y(L),L}e.parse=I;function A(D,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function y(D,L=0){if(!D||L>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return k.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 16:return new Date(D.source)}if(D instanceof o.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let P=0;P<D.length;++P)D[P]=y(D[P],L+1);else for(const P in D)Object.hasOwnProperty.call(D,P)&&(D[P]=y(D[P],L+1))}return D}e.revive=y}),define(ye[15],Ce([1,0,12,2]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(D){this.d=D}setDelegate(D){this.e=D}setServerRootPath(D){this.f=`${D}/${k.vscodeRemoteResource}`}set(D,L,P){this.a[D]=L,this.b[D]=P}setConnectionToken(D,L){this.c[D]=L}getPreferredWebSchema(){return this.d}rewrite(D){if(this.e)return this.e(D);const L=D.authority;let P=this.a[L];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const v=this.b[L],C=this.c[L];let S=`path=${encodeURIComponent(D.path)}`;return typeof C=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),t.URI.from({scheme:o.isWeb?this.d:k.vscodeRemoteResource,authority:`${P}:${v}`,path:this.f,query:S})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(D){const L=this.b(D,te);return this.uriToBrowserUri(L)}uriToBrowserUri(D){return D.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(D):D.scheme===k.file&&(o.isNative||o.isWebWorker&&o.globals.origin===`${k.vscodeFileResource}://${I.a}`)?D.with({scheme:k.vscodeFileResource,authority:D.authority||I.a,query:null,fragment:null}):D}asFileUri(D){const L=this.b(D,te);return this.uriToFileUri(L)}uriToFileUri(D){return D.scheme===k.vscodeFileResource?D.with({scheme:k.file,authority:D.authority!==I.a?D.authority:null,query:null,fragment:null}):D}b(D,L){return t.URI.isUri(D)?D:t.URI.parse(L.toUrl(D))}}I.a="vscode-app",e.FileAccess=new I;var A;(function(y){const D=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(D.get("3"));const L="vscode-coi";function P(C){let S;typeof C=="string"?S=new URL(C).searchParams:C instanceof URL?S=C.searchParams:t.URI.isUri(C)&&(S=new URL(C.toString(!0)).searchParams);const m=S?.get(L);if(!!m)return D.get(m)}y.getHeadersFromQuery=P;function v(C,S,m){if(!globalThis.crossOriginIsolated)return;const d=S&&m?"3":m?"2":"1";C instanceof URLSearchParams?C.set(L,d):C[L]=d}y.addSearchParam=v})(A=e.COI||(e.COI={}))}),define(ye[24],Ce([1,0,32,15,9,12,8,2]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(C){return(0,A.uriToFsPath)(C,!0)}e.originalFSPath=y;class D{constructor(S){this.a=S}compare(S,m,d=!1){return S===m?0:(0,I.compare)(this.getComparisonKey(S,d),this.getComparisonKey(m,d))}isEqual(S,m,d=!1){return S===m?!0:!S||!m?!1:this.getComparisonKey(S,d)===this.getComparisonKey(m,d)}getComparisonKey(S,m=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,m,d=!1){if(S.scheme===m.scheme){if(S.scheme===t.Schemas.file)return o.isEqualOrParent(y(S),y(m),this.a(S))&&S.query===m.query&&(d||S.fragment===m.fragment);if((0,e.isEqualAuthority)(S.authority,m.authority))return o.isEqualOrParent(S.path,m.path,this.a(S),"/")&&S.query===m.query&&(d||S.fragment===m.fragment)}return!1}joinPath(S,...m){return A.URI.joinPath(S,...m)}basenameOrAuthority(S){return(0,e.basename)(S)||S.authority}basename(S){return k.posix.basename(S.path)}extname(S){return k.posix.extname(S.path)}dirname(S){if(S.path.length===0)return S;let m;return S.scheme===t.Schemas.file?m=A.URI.file(k.dirname(y(S))).path:(m=k.posix.dirname(S.path),S.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),m="/")),S.with({path:m})}normalizePath(S){if(!S.path.length)return S;let m;return S.scheme===t.Schemas.file?m=A.URI.file(k.normalize(y(S))).path:m=k.posix.normalize(S.path),S.with({path:m})}relativePath(S,m){if(S.scheme!==m.scheme||!(0,e.isEqualAuthority)(S.authority,m.authority))return;if(S.scheme===t.Schemas.file){const b=k.relative(y(S),y(m));return R.isWindows?o.toSlashes(b):b}let d=S.path||"/";const h=m.path||"/";if(this.a(S)){let b=0;for(const g=Math.min(d.length,h.length);b<g&&!(d.charCodeAt(b)!==h.charCodeAt(b)&&d.charAt(b).toLowerCase()!==h.charAt(b).toLowerCase());b++);d=h.substr(0,b)+d.substr(b)}return k.posix.relative(d,h)}resolvePath(S,m){if(S.scheme===t.Schemas.file){const d=A.URI.file(k.resolve(y(S),m));return S.with({authority:d.authority,path:d.path})}return m=o.toPosixPath(m),S.with({path:k.posix.resolve(S.path,m)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,m){return S===m||S!==void 0&&m!==void 0&&(0,I.equalsIgnoreCase)(S,m)}hasTrailingPathSeparator(S,m=k.sep){if(S.scheme===t.Schemas.file){const d=y(S);return d.length>o.getRoot(d).length&&d[d.length-1]===m}else{const d=S.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,m=k.sep){return(0,e.hasTrailingPathSeparator)(S,m)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,m=k.sep){let d=!1;if(S.scheme===t.Schemas.file){const h=y(S);d=h!==void 0&&h.length===o.getRoot(h).length&&h[h.length-1]===m}else{m="/";const h=S.path;d=h.length===1&&h.charCodeAt(h.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(S,m)?S.with({path:S.path+"/"}):S}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(C=>C.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new D(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(C,S){const m=[];for(let d=0;d<C.length;d++){const h=S(C[d]);C.some((b,g)=>g===d?!1:(0,e.isEqualOrParent)(h,S(b)))||m.push(C[d])}return m}e.distinctParents=L;var P;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function S(m){const d=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(g=>{const[p,w]=g.split(":");p&&w&&d.set(p,w)});const b=m.path.substring(0,m.path.indexOf(";"));return b&&d.set(C.META_DATA_MIME,b),d}C.parseMetaData=S})(P=e.DataUri||(e.DataUri={}));function v(C,S,m){if(S){let d=C.path;return d&&d[0]!==k.posix.sep&&(d=k.posix.sep+d),C.with({scheme:m,authority:S,path:d})}return C.with({scheme:m})}e.toLocalResource=v}),define(ye[16],Ce([1,0,21,10,3,6,24,12]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(q){return!!q&&typeof q.then=="function"}e.isThenable=y;function D(q){const G=new o.CancellationTokenSource,le=q(G.token),be=new Promise((ve,Pe)=>{const Ne=G.token.onCancellationRequested(()=>{Ne.dispose(),G.dispose(),Pe(new t.CancellationError)});Promise.resolve(le).then(se=>{Ne.dispose(),G.dispose(),ve(se)},se=>{Ne.dispose(),G.dispose(),Pe(se)})});return new class{cancel(){G.cancel()}then(ve,Pe){return be.then(ve,Pe)}catch(ve){return this.then(void 0,ve)}finally(ve){return be.finally(ve)}}}e.createCancelablePromise=D;function L(q,G,le){return new Promise((be,ve)=>{const Pe=G.onCancellationRequested(()=>{Pe.dispose(),be(le)});q.then(be,ve).finally(()=>Pe.dispose())})}e.raceCancellation=L;function P(q,G){return new Promise((le,be)=>{const ve=G.onCancellationRequested(()=>{ve.dispose(),be(new t.CancellationError)});q.then(le,be).finally(()=>ve.dispose())})}e.raceCancellationError=P;async function v(q){let G=-1;const le=q.map((ve,Pe)=>ve.then(Ne=>(G=Pe,Ne))),be=await Promise.race(le);return q.forEach((ve,Pe)=>{Pe!==G&&ve.cancel()}),be}e.raceCancellablePromises=v;function C(q,G,le){let be;const ve=setTimeout(()=>{be?.(void 0),le?.()},G);return Promise.race([q.finally(()=>clearTimeout(ve)),new Promise(Pe=>be=Pe)])}e.raceTimeout=C;function S(q){return new Promise((G,le)=>{const be=q();y(be)?be.then(G,le):G(be)})}e.asPromise=S;class m{constructor(){this.a=null,this.b=null,this.d=null}queue(G){if(this.a){if(this.d=G,!this.b){const le=()=>{this.b=null;const be=this.queue(this.d);return this.d=null,be};this.b=new Promise(be=>{this.a.then(le,le).then(be)})}return new Promise((le,be)=>{this.b.then(le,be)})}return this.a=G(),new Promise((le,be)=>{this.a.then(ve=>{this.a=null,le(ve)},ve=>{this.a=null,be(ve)})})}}e.Throttler=m;class d{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.Sequencer=d;class h{constructor(){this.a=new Map}queue(G,le){const ve=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(G)===ve&&this.a.delete(G)});return this.a.set(G,ve),ve}}e.SequencerByKey=h;const b=(q,G)=>{let le=!0;const be=setTimeout(()=>{le=!1,G()},q);return{isTriggered:()=>le,dispose:()=>{clearTimeout(be),le=!1}}},g=q=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,q())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,le=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((ve,Pe)=>{this.d=ve,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const be=()=>{this.a=null,this.d?.(null)};return this.a=le===e.MicrotaskDelay?g(be):b(le,be),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class w{constructor(G){this.a=new p(G),this.b=new m}trigger(G,le){return this.a.trigger(()=>this.b.queue(G),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class i{constructor(){this.a=!1,this.b=new Promise((G,le)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class s extends i{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function a(q,G){return G?new Promise((le,be)=>{const ve=setTimeout(()=>{Pe.dispose(),le()},q),Pe=G.onCancellationRequested(()=>{clearTimeout(ve),Pe.dispose(),be(new t.CancellationError)})}):D(le=>a(q,le))}e.timeout=a;function u(q,G=0){const le=setTimeout(q,G);return(0,R.toDisposable)(()=>clearTimeout(le))}e.disposableTimeout=u;function l(q){const G=[];let le=0;const be=q.length;function ve(){return le<be?q[le++]():null}function Pe(Ne){Ne!=null&&G.push(Ne);const se=ve();return se?se.then(Pe):Promise.resolve(G)}return Promise.resolve(null).then(Pe)}e.sequence=l;function c(q,G=be=>!!be,le=null){let be=0;const ve=q.length,Pe=()=>{if(be>=ve)return Promise.resolve(le);const Ne=q[be++];return Promise.resolve(Ne()).then(ue=>G(ue)?Promise.resolve(ue):Pe())};return Pe()}e.first=c;function n(q,G=be=>!!be,le=null){if(q.length===0)return Promise.resolve(le);let be=q.length;const ve=()=>{be=-1;for(const Pe of q)Pe.cancel?.()};return new Promise((Pe,Ne)=>{for(const se of q)se.then(ue=>{--be>=0&&G(ue)?(ve(),Pe(ue)):be===0&&Pe(le)}).catch(ue=>{--be>=0&&(ve(),Ne(ue))})})}e.firstParallel=n;class r{constructor(G){this.a=0,this.d=G,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(G){return this.a++,new Promise((le,be)=>{this.f.push({factory:G,c:le,e:be}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const G=this.f.shift();this.b++;const le=G.factory();le.then(G.c,G.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=r;class f extends r{constructor(){super(1)}}e.Queue=f;class E{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const G=new ne;return this.b.add(G),G.p}d(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueFor(G,le=I.extUri){const be=le.getComparisonKey(G);let ve=this.a.get(be);return ve||(ve=new f,k.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(be),this.f()}),this.a.set(be,ve)),ve}f(){!this.d()||this.g()}g(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.g()}}e.ResourceQueue=E;class T{constructor(G,le){this.a=-1,typeof G=="function"&&typeof le=="number"&&this.setIfNotSet(G,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},le)}setIfNotSet(G,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},le))}}e.TimeoutTimer=T;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(G,le){this.cancel(),this.a=setInterval(()=>{G()},le)}}e.IntervalTimer=M;class K{constructor(G,le){this.b=-1,this.a=G,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class V{constructor(G,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=G,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class F extends K{constructor(G,le){super(G,le),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=F;class U extends R.Disposable{constructor(G,le){super(),this.g=G,this.h=le,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of G)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,A.setTimeout0)(()=>{if(G)return;const le=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(q,G)=>{const le=requestIdleCallback(q,typeof G=="number"?{timeout:G}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(le))}}}}();class N{constructor(G){this.d=!1,this.a=()=>{try{this.f=G()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=N;async function B(q,G,le){let be;for(let ve=0;ve<le;ve++)try{return await q()}catch(Pe){be=Pe,await a(G)}throw be}e.retry=B;class j{hasPending(G){return this.a?typeof G=="number"?this.a.taskId===G:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(G,le,be){return this.a={taskId:G,cancel:()=>be?.(),promise:le},le.then(()=>this.d(G),()=>this.d(G)),le}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this.b)this.b.run=G;else{let le,be;const ve=new Promise((Pe,Ne)=>{le=Pe,be=Ne});this.b={run:G,promise:ve,promiseResolve:le,promiseReject:be}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class z{constructor(G,le=()=>Date.now()){this.d=G,this.f=le,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.IntervalCounter=z;class ne{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((G,le)=>{this.a=G,this.b=le})}complete(G){return new Promise(le=>{this.a(G),this.f=!0,le()})}error(G){return new Promise(le=>{this.b(G),this.d=!0,le()})}cancel(){new Promise(G=>{this.b(new t.CancellationError),this.d=!0,G()})}}e.DeferredPromise=ne;var _;(function(q){async function G(be){let ve;const Pe=await Promise.all(be.map(Ne=>Ne.then(se=>se,se=>{ve||(ve=se)})));if(typeof ve<"u")throw ve;return Pe}q.settled=G;function le(be){return new Promise(async(ve,Pe)=>{try{await be(ve,Pe)}catch(Ne){Pe(Ne)}})}q.withAsyncBody=le})(_=e.Promises||(e.Promises={}));var Y;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(Y||(Y={}));class J{static fromArray(G){return new J(le=>{le.emitMany(G)})}static fromPromise(G){return new J(async le=>{le.emitMany(await G)})}static fromPromises(G){return new J(async le=>{await Promise.all(G.map(async be=>le.emitOne(await be)))})}static merge(G){return new J(async le=>{await Promise.all(G.map(async be=>{for await(const ve of be)le.emitOne(ve)}))})}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const le={emitOne:be=>this.g(be),emitMany:be=>this.h(be),reject:be=>this.k(be)};try{await Promise.resolve(G(le)),this.j()}catch(be){this.k(be)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(G,le){return new J(async be=>{for await(const ve of G)be.emitOne(le(ve))})}map(G){return J.map(this,G)}static filter(G,le){return new J(async be=>{for await(const ve of G)le(ve)&&be.emitOne(ve)})}filter(G){return J.filter(this,G)}static coalesce(G){return J.filter(G,le=>!!le)}coalesce(){return J.coalesce(this)}static async toPromise(G){const le=[];for await(const be of G)le.push(be);return le}toPromise(){return J.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ee extends J{constructor(G,le){super(le),this.l=G}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ee;function ge(q){const G=new o.CancellationTokenSource,le=q(G.token);return new ee(G,async be=>{const ve=G.token.onCancellationRequested(()=>{ve.dispose(),G.dispose(),be.reject(new t.CancellationError)});try{for await(const Pe of le){if(G.token.isCancellationRequested)return;be.emitOne(Pe)}ve.dispose(),G.dispose()}catch(Pe){ve.dispose(),G.dispose(),be.reject(Pe)}})}e.createCancelableAsyncIterable=ge}),define(ye[109],Ce([1,0,16,9]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new o.IdleValue(()=>{const r=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:r,collatorIsNumeric:r.resolvedOptions().numeric}}),R=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(r,f,E=!1){const T=r||"",M=f||"",K=k.value.collator.compare(T,M);return k.value.collatorIsNumeric&&K===0&&T!==M?T<M?-1:1:K}e.compareFileNames=A;function y(r,f){const E=R.value.collator;return r=r||"",f=f||"",p(E,r,f)}e.compareFileNamesDefault=y;function D(r,f){const E=R.value.collator;return r=r||"",f=f||"",a(r,f)||p(E,r,f)}e.compareFileNamesUpper=D;function L(r,f){const E=R.value.collator;return r=r||"",f=f||"",s(r,f)||p(E,r,f)}e.compareFileNamesLower=L;function P(r,f){return r=r||"",f=f||"",r===f?0:r<f?-1:1}e.compareFileNamesUnicode=P;function v(r,f){const[E,T]=b(r),[M,K]=b(f);let V=k.value.collator.compare(T,K);if(V===0){if(k.value.collatorIsNumeric&&T!==K)return T<K?-1:1;if(V=k.value.collator.compare(E,M),k.value.collatorIsNumeric&&V===0&&E!==M)return E<M?-1:1}return V}e.compareFileExtensions=v;function C(r,f){r=r||"",f=f||"";const E=g(r),T=g(f),M=R.value.collator,K=I.value.collator;return p(K,E,T)||p(M,r,f)}e.compareFileExtensionsDefault=C;function S(r,f){r=r||"",f=f||"";const E=g(r),T=g(f),M=R.value.collator,K=I.value.collator;return p(K,E,T)||a(r,f)||p(M,r,f)}e.compareFileExtensionsUpper=S;function m(r,f){r=r||"",f=f||"";const E=g(r),T=g(f),M=R.value.collator,K=I.value.collator;return p(K,E,T)||s(r,f)||p(M,r,f)}e.compareFileExtensionsLower=m;function d(r,f){r=r||"",f=f||"";const E=g(r).toLowerCase(),T=g(f).toLowerCase();return E!==T?E<T?-1:1:r!==f?r<f?-1:1:0}e.compareFileExtensionsUnicode=d;const h=/^(.*?)(\.([^.]*))?$/;function b(r,f=!1){const E=r?h.exec(r):[];let T=[E&&E[1]||"",E&&E[3]||""];return f&&(!T[0]&&T[1]||T[0]&&T[0].charAt(0)===".")&&(T=[T[0]+"."+T[1],""]),T}function g(r){const f=r?h.exec(r):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function p(r,f,E){const T=r.compare(f,E);return T!==0?T:f.length!==E.length?f.length<E.length?-1:1:0}function w(r){const f=r.charAt(0);return f.toLocaleUpperCase()!==f}function i(r){const f=r.charAt(0);return f.toLocaleLowerCase()!==f}function s(r,f){return w(r)&&i(f)?-1:i(r)&&w(f)?1:0}function a(r,f){return i(r)&&w(f)?-1:w(r)&&i(f)?1:0}function u(r,f,E=!1){return E||(r=r&&r.toLowerCase(),f=f&&f.toLowerCase()),r===f?0:r<f?-1:1}function l(r,f,E=!1){const T=r.split(t.sep),M=f.split(t.sep),K=T.length-1,V=M.length-1;let F,U;for(let N=0;;N++){if(F=K===N,U=V===N,F&&U)return A(T[N],M[N],E);if(F)return-1;if(U)return 1;const B=u(T[N],M[N],E);if(B!==0)return B}}e.comparePaths=l;function c(r,f,E){const T=r.toLowerCase(),M=f.toLowerCase(),K=n(r,f,E);if(K)return K;const V=T.endsWith(E),F=M.endsWith(E);if(V!==F)return V?-1:1;const U=A(T,M);return U!==0?U:T.localeCompare(M)}e.compareAnything=c;function n(r,f,E){const T=r.toLowerCase(),M=f.toLowerCase(),K=T.startsWith(E),V=M.startsWith(E);if(K!==V)return K?-1:1;if(K&&V){if(T.length<M.length)return-1;if(T.length>M.length)return 1}return 0}e.compareByPrefix=n}),define(ye[110],Ce([1,0,109,108,85,9,12,8]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,D=[y,[]];function L(j,z,ne,_){if(!j||!z)return D;const Y=j.length,J=z.length;if(Y<J)return D;const ee=j.toLowerCase();return P(z,ne,J,j,ee,Y,_)}e.scoreFuzzy=L;function P(j,z,ne,_,Y,J,ee){const ge=[],q=[];for(let ve=0;ve<ne;ve++){const Pe=ve*J,Ne=Pe-J,se=ve>0,ue=j[ve],de=z[ve];for(let Z=0;Z<J;Z++){const ae=Z>0,ie=Pe+Z,O=ie-1,W=Ne+Z-1,X=ae?ge[O]:0,Q=se&&ae?ge[W]:0,he=se&&ae?q[W]:0;let we;!Q&&se?we=0:we=v(ue,de,_,Y,Z,he),we&&Q+we>=X&&(ee||se||Y.startsWith(z,Z))?(q[ie]=he+1,ge[ie]=Q+we):(q[ie]=y,ge[ie]=X)}}const G=[];let le=ne-1,be=J-1;for(;le>=0&&be>=0;){const ve=le*J+be;q[ve]===y||(G.push(be),le--),be--}return[ge[ne*J-1],G.reverse()]}function v(j,z,ne,_,Y,J){let ee=0;if(!C(z,_[Y]))return ee;if(ee+=1,J>0&&(ee+=J*5),j===ne[Y]&&(ee+=1),Y===0)ee+=8;else{const ge=S(ne.charCodeAt(Y-1));ge?ee+=ge:(0,t.isUpper)(ne.charCodeAt(Y))&&J===0&&(ee+=2)}return ee}function C(j,z){return j===z?!0:j==="/"||j==="\\"?z==="/"||z==="\\":!1}function S(j){switch(j){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const m=[void 0,[]];function d(j,z,ne=0,_=0){const Y=z;return Y.values&&Y.values.length>1?h(j,Y.values,ne,_):b(j,z,ne,_)}e.scoreFuzzy2=d;function h(j,z,ne,_){let Y=0;const J=[];for(const ee of z){const[ge,q]=b(j,ee,ne,_);if(typeof ge!="number")return m;Y+=ge,J.push(...q)}return[Y,r(J)]}function b(j,z,ne,_){const Y=(0,t.fuzzyScore)(z.original,z.originalLowercase,ne,j,j.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,t.createMatches)(Y)]:m}const g=Object.freeze({score:0}),p=1<<18,w=1<<17,i=1<<16;function s(j,z,ne,_){const Y=_.values?_.values:[_];return(0,k.hash)({[_.normalized]:{values:Y.map(ee=>({value:ee.normalized,expectContiguousMatch:ee.expectContiguousMatch})),label:j,description:z,allowNonContiguousMatches:ne}})}function a(j,z,ne,_,Y){if(!j||!z.normalized)return g;const J=_.getItemLabel(j);if(!J)return g;const ee=_.getItemDescription(j),ge=s(J,ee,ne,z),q=Y[ge];if(q)return q;const G=u(J,ee,_.getItemPath(j),z,ne);return Y[ge]=G,G}e.scoreItemFuzzy=a;function u(j,z,ne,_,Y){const J=!ne||!_.containsPathSeparator;return ne&&(I.isLinux?_.pathNormalized===ne:(0,A.equalsIgnoreCase)(_.pathNormalized,ne))?{score:p,labelMatch:[{start:0,end:j.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:_.values&&_.values.length>1?l(j,z,ne,_.values,J,Y):c(j,z,ne,_,J,Y)}function l(j,z,ne,_,Y,J){let ee=0;const ge=[],q=[];for(const G of _){const{score:le,labelMatch:be,descriptionMatch:ve}=c(j,z,ne,G,Y,J);if(le===y)return g;ee+=le,be&&ge.push(...be),ve&&q.push(...ve)}return{score:ee,labelMatch:r(ge),descriptionMatch:r(q)}}function c(j,z,ne,_,Y,J){if(Y||!z){const[ee,ge]=L(j,_.normalized,_.normalizedLowercase,J&&!_.expectContiguousMatch);if(ee){const q=(0,t.matchesPrefix)(_.normalized,j);let G;return q?(G=w,G+=Math.round(_.normalized.length/j.length*100)):G=i,{score:G+ee,labelMatch:q||n(ge)}}}if(z){let ee=z;ne&&(ee=`${z}${R.sep}`);const ge=ee.length,q=`${ee}${j}`,[G,le]=L(q,_.normalized,_.normalizedLowercase,J&&!_.expectContiguousMatch);if(G){const be=n(le),ve=[],Pe=[];return be.forEach(Ne=>{Ne.start<ge&&Ne.end>ge?(ve.push({start:0,end:Ne.end-ge}),Pe.push({start:Ne.start,end:ge})):Ne.start>=ge?ve.push({start:Ne.start-ge,end:Ne.end-ge}):Pe.push(Ne)}),{score:G,labelMatch:ve,descriptionMatch:Pe}}}return g}function n(j){const z=[];if(!j)return z;let ne;for(const _ of j)ne&&ne.end===_?ne.end+=1:(ne={start:_,end:_+1},z.push(ne));return z}function r(j){const z=j.sort((Y,J)=>Y.start-J.start),ne=[];let _;for(const Y of z)!_||!f(_,Y)?(_=Y,ne.push(Y)):(_.start=Math.min(_.start,Y.start),_.end=Math.max(_.end,Y.end));return ne}function f(j,z){return!(j.end<z.start||z.end<j.start)}function E(j,z,ne,_,Y,J){const ee=a(j,ne,_,Y,J),ge=a(z,ne,_,Y,J),q=ee.score,G=ge.score;if((q===p||G===p)&&q!==G)return q===p?-1:1;if(q>i||G>i){if(q!==G)return q>G?-1:1;if(q<w&&G<w){const ue=M(ee.labelMatch,ge.labelMatch);if(ue!==0)return ue}const Ne=Y.getItemLabel(j)||"",se=Y.getItemLabel(z)||"";if(Ne.length!==se.length)return Ne.length-se.length}if(q!==G)return q>G?-1:1;const le=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0,be=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(le&&!be)return-1;if(be&&!le)return 1;const ve=T(j,ee,Y),Pe=T(z,ge,Y);return ve&&Pe&&ve!==Pe?Pe>ve?-1:1:K(j,z,ne,Y)}e.compareItemsByFuzzyScore=E;function T(j,z,ne){let _=-1,Y=-1;if(z.descriptionMatch&&z.descriptionMatch.length?_=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(_=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(Y=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const J=ne.getItemDescription(j);J&&(Y+=J.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(Y=z.descriptionMatch[z.descriptionMatch.length-1].end);return Y-_}function M(j,z){if(!j&&!z||(!j||!j.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!j||!j.length)return 1;const ne=j[0].start,Y=j[j.length-1].end-ne,J=z[0].start,ge=z[z.length-1].end-J;return Y===ge?0:ge<Y?1:-1}function K(j,z,ne,_){const Y=_.getItemLabel(j)||"",J=_.getItemLabel(z)||"",ee=_.getItemDescription(j),ge=_.getItemDescription(z),q=Y.length+(ee?ee.length:0),G=J.length+(ge?ge.length:0);if(q!==G)return q-G;const le=_.getItemPath(j),be=_.getItemPath(z);return le&&be&&le.length!==be.length?le.length-be.length:Y!==J?(0,o.compareAnything)(Y,J,ne.normalized):ee&&ge&&ee!==ge?(0,o.compareAnything)(ee,ge,ne.normalized):le&&be&&le!==be?(0,o.compareAnything)(le,be,ne.normalized):0}function V(j){return j.startsWith('"')&&j.endsWith('"')}const F=" ";function U(j){typeof j!="string"&&(j="");const z=j.toLowerCase(),{pathNormalized:ne,normalized:_,normalizedLowercase:Y}=N(j),J=ne.indexOf(R.sep)>=0,ee=V(j);let ge;const q=j.split(F);if(q.length>1)for(const G of q){const le=V(G),{pathNormalized:be,normalized:ve,normalizedLowercase:Pe}=N(G);ve&&(ge||(ge=[]),ge.push({original:G,originalLowercase:G.toLowerCase(),pathNormalized:be,normalized:ve,normalizedLowercase:Pe,expectContiguousMatch:le}))}return{original:j,originalLowercase:z,pathNormalized:ne,normalized:_,normalizedLowercase:Y,values:ge,containsPathSeparator:J,expectContiguousMatch:ee}}e.prepareQuery=U;function N(j){let z;I.isWindows?z=j.replace(/\//g,R.sep):z=j.replace(/\\/g,R.sep);const ne=(0,A.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:ne,normalizedLowercase:ne.toLowerCase()}}function B(j){return Array.isArray(j)?U(j.map(z=>z.original).join(F)):U(j.original)}e.pieceToQuery=B}),define(ye[38],Ce([1,0,18,16,32,28,9,12,8]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",P="[^/\\\\]",v=/\//g;function C(ne,_){switch(ne){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${_?`|${L}${P}+`:""})*?`}}function S(ne,_){if(!ne)return[];const Y=[];let J=!1,ee=!1,ge="";for(const q of ne){switch(q){case _:if(!J&&!ee){Y.push(ge),ge="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ge+=q}return ge&&Y.push(ge),Y}e.splitGlobAware=S;function m(ne){if(!ne)return"";let _="";const Y=S(ne,e.GLOB_SPLIT);if(Y.every(J=>J===e.GLOBSTAR))_=".*";else{let J=!1;Y.forEach((ee,ge)=>{if(ee===e.GLOBSTAR){if(J)return;_+=C(2,ge===Y.length-1)}else{let q=!1,G="",le=!1,be="";for(const ve of ee){if(ve!=="}"&&q){G+=ve;continue}if(le&&(ve!=="]"||!be)){let Pe;ve==="-"?Pe=ve:(ve==="^"||ve==="!")&&!be?Pe="^":ve===e.GLOB_SPLIT?Pe="":Pe=(0,y.escapeRegExpCharacters)(ve),be+=Pe;continue}switch(ve){case"{":q=!0;continue;case"[":le=!0;continue;case"}":{_+=`(?:${S(G,",").map(se=>m(se)).join("|")})`,q=!1,G="";break}case"]":{_+="["+be+"]",le=!1,be="";break}case"?":_+=P;continue;case"*":_+=C(1);continue;default:_+=(0,y.escapeRegExpCharacters)(ve)}}ge<Y.length-1&&(Y[ge+1]!==e.GLOBSTAR||ge+2<Y.length)&&(_+=L)}J=ee===e.GLOBSTAR})}return _}const d=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),s=function(){return!1},a=function(){return null};function u(ne,_){if(!ne)return a;let Y;typeof ne!="string"?Y=ne.pattern:Y=ne,Y=Y.trim();const J=`${Y}_${!!_.trimForExclusions}`;let ee=i.get(J);if(ee)return l(ee,ne);let ge;return d.test(Y)?ee=n(Y.substr(4),Y):(ge=h.exec(c(Y,_)))?ee=r(ge[1],Y):(_.trimForExclusions?g:b).test(Y)?ee=f(Y,_):(ge=p.exec(c(Y,_)))?ee=E(ge[1].substr(1),Y,!0):(ge=w.exec(c(Y,_)))?ee=E(ge[1],Y,!1):ee=T(Y),i.set(J,ee),l(ee,ne)}function l(ne,_){if(typeof _=="string")return ne;const Y=function(J,ee){return(0,k.isEqualOrParent)(J,_.base,!A.isLinux)?ne((0,y.ltrim)(J.substr(_.base.length),I.sep),ee):null};return Y.allBasenames=ne.allBasenames,Y.allPaths=ne.allPaths,Y.basenames=ne.basenames,Y.patterns=ne.patterns,Y}function c(ne,_){return _.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function n(ne,_){return function(Y,J){return typeof Y=="string"&&Y.endsWith(ne)?_:null}}function r(ne,_){const Y=`/${ne}`,J=`\\${ne}`,ee=function(q,G){return typeof q!="string"?null:G?G===ne?_:null:q===ne||q.endsWith(Y)||q.endsWith(J)?_:null},ge=[ne];return ee.basenames=ge,ee.patterns=[_],ee.allBasenames=ge,ee}function f(ne,_){const Y=j(ne.slice(1,-1).split(",").map(G=>u(G,_)).filter(G=>G!==a),ne),J=Y.length;if(!J)return a;if(J===1)return Y[0];const ee=function(G,le){for(let be=0,ve=Y.length;be<ve;be++)if(Y[be](G,le))return ne;return null},ge=Y.find(G=>!!G.allBasenames);ge&&(ee.allBasenames=ge.allBasenames);const q=Y.reduce((G,le)=>le.allPaths?G.concat(le.allPaths):G,[]);return q.length&&(ee.allPaths=q),ee}function E(ne,_,Y){const J=I.sep===I.posix.sep,ee=J?ne:ne.replace(v,I.sep),ge=I.sep+ee,q=I.posix.sep+ne;let G;return Y?G=function(le,be){return typeof le=="string"&&(le===ee||le.endsWith(ge)||!J&&(le===ne||le.endsWith(q)))?_:null}:G=function(le,be){return typeof le=="string"&&(le===ee||!J&&le===ne)?_:null},G.allPaths=[(Y?"*/":"./")+ne],G}function T(ne){try{const _=new RegExp(`^${m(ne)}$`);return function(Y){return _.lastIndex=0,typeof Y=="string"&&_.test(Y)?ne:null}}catch{return a}}function M(ne,_,Y){return!ne||typeof _!="string"?!1:K(ne)(_,void 0,Y)}e.match=M;function K(ne,_={}){if(!ne)return s;if(typeof ne=="string"||V(ne)){const Y=u(ne,_);if(Y===a)return s;const J=function(ee,ge){return!!Y(ee,ge)};return Y.allBasenames&&(J.allBasenames=Y.allBasenames),Y.allPaths&&(J.allPaths=Y.allPaths),J}return N(ne,_)}e.parse=K;function V(ne){const _=ne;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=V;function F(ne){return ne.allBasenames||[]}e.getBasenameTerms=F;function U(ne){return ne.allPaths||[]}e.getPathTerms=U;function N(ne,_){const Y=j(Object.getOwnPropertyNames(ne).map(G=>B(G,ne[G],_)).filter(G=>G!==a)),J=Y.length;if(!J)return a;if(!Y.some(G=>!!G.requiresSiblings)){if(J===1)return Y[0];const G=function(ve,Pe){let Ne;for(let se=0,ue=Y.length;se<ue;se++){const de=Y[se](ve,Pe);if(typeof de=="string")return de;(0,t.isThenable)(de)&&(Ne||(Ne=[]),Ne.push(de))}return Ne?(async()=>{for(const se of Ne){const ue=await se;if(typeof ue=="string")return ue}return null})():null},le=Y.find(ve=>!!ve.allBasenames);le&&(G.allBasenames=le.allBasenames);const be=Y.reduce((ve,Pe)=>Pe.allPaths?ve.concat(Pe.allPaths):ve,[]);return be.length&&(G.allPaths=be),G}const ee=function(G,le,be){let ve,Pe;for(let Ne=0,se=Y.length;Ne<se;Ne++){const ue=Y[Ne];ue.requiresSiblings&&be&&(le||(le=(0,I.basename)(G)),ve||(ve=le.substr(0,le.length-(0,I.extname)(G).length)));const de=ue(G,le,ve,be);if(typeof de=="string")return de;(0,t.isThenable)(de)&&(Pe||(Pe=[]),Pe.push(de))}return Pe?(async()=>{for(const Ne of Pe){const se=await Ne;if(typeof se=="string")return se}return null})():null},ge=Y.find(G=>!!G.allBasenames);ge&&(ee.allBasenames=ge.allBasenames);const q=Y.reduce((G,le)=>le.allPaths?G.concat(le.allPaths):G,[]);return q.length&&(ee.allPaths=q),ee}function B(ne,_,Y){if(_===!1)return a;const J=u(ne,Y);if(J===a)return a;if(typeof _=="boolean")return J;if(_){const ee=_.when;if(typeof ee=="string"){const ge=(q,G,le,be)=>{if(!be||!J(q,G))return null;const ve=ee.replace("$(basename)",()=>le),Pe=be(ve);return(0,t.isThenable)(Pe)?Pe.then(Ne=>Ne?ne:null):Pe?ne:null};return ge.requiresSiblings=!0,ge}}return J}function j(ne,_){const Y=ne.filter(G=>!!G.basenames);if(Y.length<2)return ne;const J=Y.reduce((G,le)=>{const be=le.basenames;return be?G.concat(be):G},[]);let ee;if(_){ee=[];for(let G=0,le=J.length;G<le;G++)ee.push(_)}else ee=Y.reduce((G,le)=>{const be=le.patterns;return be?G.concat(be):G},[]);const ge=function(G,le){if(typeof G!="string")return null;if(!le){let ve;for(ve=G.length;ve>0;ve--){const Pe=G.charCodeAt(ve-1);if(Pe===47||Pe===92)break}le=G.substr(ve)}const be=J.indexOf(le);return be!==-1?ee[be]:null};ge.basenames=J,ge.patterns=ee,ge.allBasenames=J;const q=ne.filter(G=>!G.basenames);return q.push(ge),q}function z(ne,_){return(0,o.equals)(ne,_,(Y,J)=>typeof Y=="string"&&typeof J=="string"?Y===J:typeof Y!="string"&&typeof J!="string"?Y.base===J.base&&Y.pattern===J.pattern:!1)}e.patternsEquals=z}),define(ye[111],Ce([1,0,10,162,24,8,2]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",b=!1){if(this.value=h,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(h,b=0){return this.value+=v(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(g,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,b){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(h,b,g){return this.value+="[",this.value+=this.c(b,"]"),this.value+="](",this.value+=this.c(String(h),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(h,b){const g=new RegExp((0,R.escapeRegExpCharacters)(b),"g");return h.replace(g,(p,w)=>h.charAt(w-1)!=="\\"?`\\${p}`:p)}}e.MarkdownString=y;function D(d){return L(d)?!d.value:Array.isArray(d)?d.every(D):!0}e.isEmptyMarkdownString=D;function L(d){return d instanceof y?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function P(d,h){return d===h?!0:!d||!h?!1:d.value===h.value&&d.isTrusted===h.isTrusted&&d.supportThemeIcons===h.supportThemeIcons&&d.supportHtml===h.supportHtml&&(d.baseUri===h.baseUri||!!d.baseUri&&!!h.baseUri&&(0,k.isEqual)(I.URI.from(d.baseUri),I.URI.from(h.baseUri)))}e.markdownStringEqual=P;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function C(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=C;function S(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=S;function m(d){const h=[],b=d.split("|").map(p=>p.trim());d=b[0];const g=b[1];if(g){const p=/height=(\d+)/.exec(g),w=/width=(\d+)/.exec(g),i=p?p[1]:"",s=w?w[1]:"",a=isFinite(parseInt(s)),u=isFinite(parseInt(i));a&&h.push(`width="${s}"`),u&&h.push(`height="${i}"`)}return{href:d,dimensions:h}}e.parseHrefAndDimensions=m}),define(ye[112],Ce([1,0,18,32,9,12,24,8]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(a,u){const{os:l,tildify:c,relative:n}=u;if(n){const E=D(a,n,l);if(typeof E=="string")return E}let r=a.fsPath;if(l===1&&!R.isWindows?r=r.replace(/\//g,"\\"):l!==1&&R.isWindows&&(r=r.replace(/\\/g,"/")),l!==1&&c?.userHome){const E=c.userHome.fsPath;let T;a.scheme!==c.userHome.scheme&&a.path.startsWith(k.posix.sep)?T=c.userHome.with({path:a.path}).fsPath:T=a.fsPath,r=v(T,E,l)}return(l===1?k.win32:k.posix).normalize(L(r,l===1))}e.getPathLabel=y;function D(a,u,l){const c=l===1?k.win32:k.posix,n=l===3?I.extUri:I.extUriIgnorePathCase,r=u.getWorkspace(),f=(0,o.firstOrDefault)(r.folders);if(!f)return;a.scheme!==f.uri.scheme&&a.path.startsWith(k.posix.sep)&&(a=f.uri.with({path:a.path}));const E=u.getWorkspaceFolder(a);if(!E)return;let T;if(n.isEqual(E.uri,a)?T="":T=n.relativePath(E.uri,a)??"",T&&(T=c.normalize(T)),r.folders.length>1&&!u.noPrefix){const M=E.name?E.name:n.basenameOrAuthority(E.uri);T=T?`${M} \u2022 ${T}`:M}return T}function L(a,u=R.isWindows){return(0,t.hasDriveLetter)(a,u)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=L;let P=Object.create(null);function v(a,u,l=R.OS){if(l===1||!a||!u)return a;let c=P.original===u?P.normalized:void 0;c||(c=u,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,A.rtrim)(c,k.posix.sep)}${k.posix.sep}`,P={original:u,normalized:c});let n=a;return R.isWindows&&(n=(0,t.toSlashes)(n)),(l===3?n.startsWith(c):(0,A.startsWithIgnoreCase)(n,c))?`~/${n.substr(c.length)}`:a}e.tildify=v;function C(a,u){return a.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=C;const S="\u2026",m="\\\\",d="~";function h(a,u=k.sep){const l=new Array(a.length);let c=!1;for(let n=0;n<a.length;n++){const r=a[n];if(r===""){l[n]=`.${u}`;continue}if(!r){l[n]=r;continue}c=!0;let f="",E=r;E.indexOf(m)===0?(f=E.substr(0,E.indexOf(m)+m.length),E=E.substr(E.indexOf(m)+m.length)):E.indexOf(u)===0?(f=E.substr(0,E.indexOf(u)+u.length),E=E.substr(E.indexOf(u)+u.length)):E.indexOf(d)===0&&(f=E.substr(0,E.indexOf(d)+d.length),E=E.substr(E.indexOf(d)+d.length));const T=E.split(u);for(let M=1;c&&M<=T.length;M++)for(let K=T.length-M;c&&K>=0;K--){c=!1;let V=T.slice(K,K+M).join(u);for(let F=0;!c&&F<a.length;F++)if(F!==n&&a[F]&&a[F].indexOf(V)>-1){const U=K+M===T.length,N=K>0&&a[F].indexOf(u)>-1?u+V:V,B=a[F].endsWith(N);c=!U||B}if(!c){let F="";(T[0].endsWith(":")||f!=="")&&(K===1&&(K=0,M++,V=T[0]+u+V),K>0&&(F=T[0]+u),F=f+F),K>0&&(F=F+S+u),F=F+V,K+M<T.length&&(F=F+u+S),l[n]=F}}c&&(l[n]=r)}return l}e.shorten=h;var b;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function g(a,u=Object.create(null)){const l=[];let c=!1,n="";for(const r of a)if(r==="$"||c&&r==="{")n&&l.push({value:n,type:b.TEXT}),n="",c=!0;else if(r==="}"&&c){const f=u[n];if(typeof f=="string")f.length&&l.push({value:f,type:b.VARIABLE});else if(f){const E=l[l.length-1];(!E||E.type!==b.SEPARATOR)&&l.push({value:f.label,type:b.SEPARATOR})}n="",c=!1}else n+=r;return n&&!c&&l.push({value:n,type:b.TEXT}),l.filter((r,f)=>{if(r.type===b.SEPARATOR){const E=l[f-1],T=l[f+1];return[E,T].every(M=>M&&(M.type===b.VARIABLE||M.type===b.TEXT)&&M.value.length>0)}return!0}).map(r=>r.value).join("")}e.template=g;function p(a,u){return R.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):a.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function w(a,u){return R.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,""):R.isWindows?a.replace(/&&|&/g,l=>l==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(a){const u=a.indexOf("/")!==-1?k.posix:k.win32,l=u.basename(a),c=u.dirname(a);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=s}),define(ye[113],Ce([1,0,2]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class k{constructor(P){this.a=P}transformIncoming(P){const v=this.a.transformIncoming(P);return v===P?P:t(o.URI.from(v))}transformOutgoing(P){const v=this.a.transformOutgoing(P);return v===P?P:t(o.URI.from(v))}transformOutgoingURI(P){const v=this.a.transformOutgoing(P);return v===P?P:o.URI.from(v)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function R(L,P,v){if(!L||v>200)return null;if(typeof L=="object"){if(L instanceof o.URI)return P.transformOutgoing(L);for(const C in L)if(Object.hasOwnProperty.call(L,C)){const S=R(L[C],P,v+1);S!==null&&(L[C]=S)}}return null}function I(L,P){const v=R(L,P,0);return v===null?L:v}e.transformOutgoingURIs=I;function A(L,P,v,C){if(!L||C>200)return null;if(typeof L=="object"){if(L.$mid===1)return v?o.URI.revive(P.transformIncoming(L)):P.transformIncoming(L);for(const S in L)if(Object.hasOwnProperty.call(L,S)){const m=A(L[S],P,v,C+1);m!==null&&(L[S]=m)}}return null}function y(L,P){const v=A(L,P,!1,0);return v===null?L:v}e.transformIncomingURIs=y;function D(L,P){const v=A(L,P,!0,0);return v===null?L:v}e.transformAndReviveIncomingURIs=D}),define(ye[29],Ce([1,0,65,87,311,16,32,83,9,12,24,2]),function(te,e,o,t,k,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function C(N,B=v.UNLINK){if((0,I.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return B===v.UNLINK?m(N):S(N)}async function S(N){try{const B=(0,I.randomPath)((0,t.tmpdir)());try{await o.promises.rename(N,B)}catch(j){return j.code==="ENOENT"?void 0:m(N)}m(B).catch(j=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function m(N){return(0,k.promisify)(o.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function d(N){if((0,I.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function h(N,B){return p(await(B?b(N):(0,k.promisify)(o.readdir)(N)))}async function b(N){try{return await(0,k.promisify)(o.readdir)(N,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const B=[],j=await h(N);for(const z of j){let ne=!1,_=!1,Y=!1;try{const J=await e.Promises.lstat((0,y.join)(N,z));ne=J.isFile(),_=J.isDirectory(),Y=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}B.push({name:z,isFile:()=>ne,isDirectory:()=>_,isSymbolicLink:()=>Y})}return B}function g(N){return p(o.readdirSync(N))}e.readdirSync=g;function p(N){return N.map(B=>typeof B=="string"?D.isMacintosh?(0,A.normalizeNFC)(B):B:(B.name=D.isMacintosh?(0,A.normalizeNFC)(B.name):B.name,B))}async function w(N){const B=await h(N),j=[];for(const z of B)await s.existsDirectory((0,y.join)(N,z))&&j.push(z);return j}function i(N,B=1e3){return new Promise(j=>{let z=!1;const ne=setInterval(()=>{z||(z=!0,o.access(N,_=>{z=!1,_&&(clearInterval(ne),j(void 0))}))},B)})}e.whenDeleted=i;var s;(function(N){async function B(ne){let _;try{if(_=await e.Promises.lstat(ne),!_.isSymbolicLink())return{stat:_}}catch{}try{return{stat:await e.Promises.stat(ne),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(D.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ne)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw J}throw Y}}N.stat=B;async function j(ne){try{const{stat:_,symbolicLink:Y}=await N.stat(ne);return _.isFile()&&Y?.dangling!==!0}catch{}return!1}N.existsFile=j;async function z(ne){try{const{stat:_,symbolicLink:Y}=await N.stat(ne);return _.isDirectory()&&Y?.dangling!==!0}catch{}return!1}N.existsDirectory=z})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new R.ResourceQueue;function u(N,B,j){return a.queueFor(P.URI.file(N),L.extUriBiasedIgnorePathCase).queue(()=>{const z=f(j);return new Promise((ne,_)=>n(N,B,z,Y=>Y?_(Y):ne()))})}let l=!0;function c(N){l=N}e.configureFlushOnWrite=c;function n(N,B,j,z){if(!l)return o.writeFile(N,B,{mode:j.mode,flag:j.flag},z);o.open(N,j.flag,j.mode,(ne,_)=>{if(ne)return z(ne);o.writeFile(_,B,Y=>{if(Y)return o.close(_,()=>z(Y));o.fdatasync(_,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),c(!1)),o.close(_,ee=>z(ee))))})})}function r(N,B,j){const z=f(j);if(!l)return o.writeFileSync(N,B,{mode:z.mode,flag:z.flag});const ne=o.openSync(N,z.flag,z.mode);try{o.writeFileSync(ne,B);try{o.fdatasyncSync(ne)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),c(!1)}}finally{o.closeSync(ne)}}e.writeFileSync=r;function f(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function E(N,B){if(N!==B)try{await e.Promises.rename(N,B)}catch(j){if(N.toLowerCase()!==B.toLowerCase()&&j.code==="EXDEV"||N.endsWith("."))await T(N,B,{preserveSymlinks:!1}),await C(N,v.MOVE);else throw j}}async function T(N,B,j){return K(N,B,{root:{source:N,target:B},options:j,handledSourcePaths:new Set})}const M=511;async function K(N,B,j){if(j.handledSourcePaths.has(N))return;j.handledSourcePaths.add(N);const{stat:z,symbolicLink:ne}=await s.stat(N);if(ne){if(j.options.preserveSymlinks)try{return await U(N,B,j)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(ne.dangling)return}return z.isDirectory()?V(N,B,z.mode&M,j):F(N,B,z.mode&M)}async function V(N,B,j,z){await e.Promises.mkdir(B,{recursive:!0,mode:j});const ne=await h(N);for(const _ of ne)await K((0,y.join)(N,_),(0,y.join)(B,_),z)}async function F(N,B,j){await e.Promises.copyFile(N,B),await e.Promises.chmod(B,j)}async function U(N,B,j){let z=await e.Promises.readlink(N);(0,I.isEqualOrParent)(z,j.root.source,!D.isLinux)&&(z=(0,y.join)(j.root.target,z.substr(j.root.source.length+1))),await e.Promises.symlink(z,B)}e.Promises=new class{get access(){return(0,k.promisify)(o.access)}get stat(){return(0,k.promisify)(o.stat)}get lstat(){return(0,k.promisify)(o.lstat)}get utimes(){return(0,k.promisify)(o.utimes)}get read(){return(N,B,j,z,ne)=>new Promise((_,Y)=>{o.read(N,B,j,z,ne,(J,ee,ge)=>J?Y(J):_({bytesRead:ee,buffer:ge}))})}get readFile(){return(0,k.promisify)(o.readFile)}get write(){return(N,B,j,z,ne)=>new Promise((_,Y)=>{o.write(N,B,j,z,ne,(J,ee,ge)=>J?Y(J):_({bytesWritten:ee,buffer:ge}))})}get appendFile(){return(0,k.promisify)(o.appendFile)}get fdatasync(){return(0,k.promisify)(o.fdatasync)}get truncate(){return(0,k.promisify)(o.truncate)}get rename(){return(0,k.promisify)(o.rename)}get copyFile(){return(0,k.promisify)(o.copyFile)}get open(){return(0,k.promisify)(o.open)}get close(){return(0,k.promisify)(o.close)}get symlink(){return(0,k.promisify)(o.symlink)}get readlink(){return(0,k.promisify)(o.readlink)}get chmod(){return(0,k.promisify)(o.chmod)}get mkdir(){return(0,k.promisify)(o.mkdir)}get unlink(){return(0,k.promisify)(o.unlink)}get rmdir(){return(0,k.promisify)(o.rmdir)}get realpath(){return(0,k.promisify)(o.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return w}get writeFile(){return u}get rm(){return C}get move(){return E}get copy(){return T}}}),define(ye[114],Ce([1,0,65,9,12,8,29]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(v){if(k.isLinux)return v;const C=(0,t.dirname)(v);if(v===C)return v;const S=((0,t.basename)(v)||v).toLowerCase();try{const d=(0,I.readdirSync)(C).filter(h=>h.toLowerCase()===S);if(d.length===1){const h=A(C);if(h)return(0,t.join)(h,d[0])}else if(d.length>1){const h=d.indexOf(S);if(h>=0){const b=A(C);if(b)return(0,t.join)(b,d[h])}}}catch{}return null}e.realcaseSync=A;async function y(v){if(k.isLinux)return v;const C=(0,t.dirname)(v);if(v===C)return v;const S=((0,t.basename)(v)||v).toLowerCase();try{const d=(await I.Promises.readdir(C)).filter(h=>h.toLowerCase()===S);if(d.length===1){const h=await y(C);if(h)return(0,t.join)(h,d[0])}else if(d.length>1){const h=d.indexOf(S);if(h>=0){const b=await y(C);if(b)return(0,t.join)(b,d[h])}}}catch{}return null}e.realcase=y;async function D(v){try{return await I.Promises.realpath(v)}catch{const S=P(v);return await I.Promises.access(S,o.constants.R_OK),S}}e.realpath=D;function L(v){try{return o.realpathSync(v)}catch{const S=P(v);return o.accessSync(S,o.constants.R_OK),S}}e.realpathSync=L;function P(v){return(0,R.rtrim)((0,t.normalize)(v),t.sep)}}),define(ye[115],Ce([1,0,9,12,36,107,11,29]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(P=k.env){return P.comspec||"cmd.exe"}e.getWindowsShell=y;function D(P){let v=[],C=!1;const S=function(m){if(C){v.push(m);return}(!P.send(m,h=>{if(h&&console.error(h),C=!1,v.length>0){const b=v.slice(0);v=[],b.forEach(g=>S(g))}})||t.isWindows)&&(C=!0)};return{send:S}}e.createQueuedSender=D;var L;(function(P){async function v(C,S,m){if(o.isAbsolute(C))return C;if(S===void 0&&(S=k.cwd()),o.dirname(C)!=="."||(m===void 0&&I.isString(k.env.PATH)&&(m=k.env.PATH.split(o.delimiter)),m===void 0||m.length===0))return o.join(S,C);async function h(b){if(await A.Promises.exists(b)){let g;try{g=await A.Promises.stat(b)}catch(p){p.message.startsWith("EACCES")&&(g=await A.Promises.lstat(b))}return g?!g.isDirectory():!1}return!1}for(const b of m){let g;if(o.isAbsolute(b)?g=o.join(b,C):g=o.join(S,b,C),await h(g))return g;let p=g+".com";if(await h(p)||(p=g+".exe",await h(p)))return p}return o.join(S,C)}P.findExecutable=v})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(te,e,o,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,o):t,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(te,e,o,t);else for(var A=te.length-1;A>=0;A--)(I=te[A])&&(R=(k<3?I(R):k>3?I(e,o,R):I(e,o))||R);return k>3&&R&&Object.defineProperty(e,o,R),R};define(ye[116],Ce([1,0,18,16,22,21,60,10,3,6,86,8,11]),function(te,e,o,t,k,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var C;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(C||(C={}));function S(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(m||(m={}));function d(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(h||(h={}));function b(_){let Y=0;for(let J=0;;J+=7){const ee=_.read(1);if(Y|=(ee.buffer[0]&127)<<J,!(ee.buffer[0]&128))return Y}}const g=a(0);function p(_,Y){if(Y===0){_.write(g);return}let J=0;for(let ge=Y;ge!==0;ge=ge>>>7)J++;const ee=k.VSBuffer.alloc(J);for(let ge=0;Y!==0;ge++)ee.buffer[ge]=Y&127,Y=Y>>>7,Y>0&&(ee.buffer[ge]|=128);_.write(ee)}class w{constructor(Y){this.b=Y,this.a=0}read(Y){const J=this.b.slice(this.a,this.a+Y);return this.a+=J.byteLength,J}}e.BufferReader=w;class i{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(Y){this.a.push(Y)}}e.BufferWriter=i;var s;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(s||(s={}));function a(_){const Y=k.VSBuffer.alloc(1);return Y.writeUInt8(_,0),Y}const u={Undefined:a(s.Undefined),String:a(s.String),Buffer:a(s.Buffer),VSBuffer:a(s.VSBuffer),Array:a(s.Array),Object:a(s.Object),Uint:a(s.Int)},l=typeof Buffer<"u";function c(_,Y){if(typeof Y>"u")_.write(u.Undefined);else if(typeof Y=="string"){const J=k.VSBuffer.fromString(Y);_.write(u.String),p(_,J.byteLength),_.write(J)}else if(l&&Buffer.isBuffer(Y)){const J=k.VSBuffer.wrap(Y);_.write(u.Buffer),p(_,J.byteLength),_.write(J)}else if(Y instanceof k.VSBuffer)_.write(u.VSBuffer),p(_,Y.byteLength),_.write(Y);else if(Array.isArray(Y)){_.write(u.Array),p(_,Y.length);for(const J of Y)c(_,J)}else if(typeof Y=="number"&&(Y|0)===Y)_.write(u.Uint),p(_,Y);else{const J=k.VSBuffer.fromString(JSON.stringify(Y));_.write(u.Object),p(_,J.byteLength),_.write(J)}}e.serialize=c;function n(_){switch(_.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return _.read(b(_)).toString();case s.Buffer:return _.read(b(_)).buffer;case s.VSBuffer:return _.read(b(_));case s.Array:{const J=b(_),ee=[];for(let ge=0;ge<J;ge++)ee.push(n(_));return ee}case s.Object:return JSON.parse(_.read(b(_)).toString());case s.Int:return b(_)}}e.deserialize=n;class r{constructor(Y,J,ee=null,ge=1e3){this.h=Y,this.j=J,this.k=ee,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:200})}registerChannel(Y,J){this.b.set(Y,J),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const J=this.o([Y.type]);this.k?.logOutgoing(J,0,1,d(Y.type));return}case 201:case 202:case 204:case 203:{const J=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(J,Y.id,1,d(Y.type),Y.data);return}}}o(Y,J=void 0){const ee=new i;return c(ee,Y),c(ee,J),this.p(ee.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const J=new w(Y),ee=n(J),ge=n(J),q=ee[0];switch(q){case 100:return this.k?.logIncoming(Y.byteLength,ee[1],1,`${S(q)}: ${ee[2]}.${ee[3]}`,ge),this.s({type:q,id:ee[1],channelName:ee[2],name:ee[3],arg:ge});case 102:return this.k?.logIncoming(Y.byteLength,ee[1],1,`${S(q)}: ${ee[2]}.${ee[3]}`,ge),this.t({type:q,id:ee[1],channelName:ee[2],name:ee[3],arg:ge});case 101:return this.k?.logIncoming(Y.byteLength,ee[1],1,`${S(q)}`),this.u({type:q,id:ee[1]});case 103:return this.k?.logIncoming(Y.byteLength,ee[1],1,`${S(q)}`),this.u({type:q,id:ee[1]})}}s(Y){const J=this.b.get(Y.channelName);if(!J){this.v(Y);return}const ee=new R.CancellationTokenSource;let ge;try{ge=J.call(this.j,Y.name,Y.arg,ee.token)}catch(le){ge=Promise.reject(le)}const q=Y.id;ge.then(le=>{this.m({id:q,data:le,type:201}),this.d.delete(Y.id)},le=>{le instanceof Error?this.m({id:q,data:{message:le.message,name:le.name,stack:le.stack?le.stack.split?le.stack.split(`
`):le.stack:void 0},type:202}):this.m({id:q,data:le,type:203}),this.d.delete(Y.id)});const G=(0,D.toDisposable)(()=>ee.cancel());this.d.set(Y.id,G)}t(Y){const J=this.b.get(Y.channelName);if(!J){this.v(Y);return}const ee=Y.id,q=J.listen(this.j,Y.name,Y.arg)(G=>this.m({id:ee,data:G,type:204}));this.d.set(Y.id,q)}u(Y){const J=this.d.get(Y.id);J&&(J.dispose(),this.d.delete(Y.id))}v(Y){let J=this.g.get(Y.channelName);J||(J=[],this.g.set(Y.channelName,J));const ee=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:Y,timeoutTimer:ee})}w(Y){const J=this.g.get(Y);if(J){for(const ee of J)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,D.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=r;var f;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(Y,J=null){this.l=Y,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=J}getChannel(Y){const J=this;return{call(ee,ge,q){return J.a?Promise.reject(new A.CancellationError):J.m(Y,ee,ge,q)},listen(ee,ge){return J.a?y.Event.None:J.o(Y,ee,ge)}}}m(Y,J,ee,ge=R.CancellationToken.None){const q=this.g++,le={id:q,type:100,channelName:Y,name:J,arg:ee};if(ge.isCancellationRequested)return Promise.reject(new A.CancellationError);let be;return new Promise((Pe,Ne)=>{if(ge.isCancellationRequested)return Ne(new A.CancellationError);const se=()=>{const ae=ie=>{switch(ie.type){case 201:this.f.delete(q),Pe(ie.data);break;case 202:{this.f.delete(q);const O=new Error(ie.data.message);O.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,O.name=ie.data.name,Ne(O);break}case 203:this.f.delete(q),Ne(ie.data);break}};this.f.set(q,ae),this.p(le)};let ue=null;this.b===h.Idle?se():(ue=(0,t.createCancelablePromise)(ae=>this.u()),ue.then(()=>{ue=null,se()}));const de=()=>{ue?(ue.cancel(),ue=null):this.p({id:q,type:101}),Ne(new A.CancellationError)},Z=ge.onCancellationRequested(de);be=(0,D.combinedDisposable)((0,D.toDisposable)(de),Z),this.d.add(be)}).finally(()=>{this.d.delete(be)})}o(Y,J,ee){const ge=this.g++,G={id:ge,type:102,channelName:Y,name:J,arg:ee};let le=null;const be=new y.Emitter({onWillAddFirstListener:()=>{le=(0,t.createCancelablePromise)(Pe=>this.u()),le.then(()=>{le=null,this.d.add(be),this.p(G)})},onDidRemoveLastListener:()=>{le?(le.cancel(),le=null):(this.d.delete(be),this.p({id:ge,type:103}))}}),ve=Pe=>be.fire(Pe.data);return this.f.set(ge,ve),be.event}p(Y){switch(Y.type){case 100:case 102:{const J=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(J,Y.id,0,`${S(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const J=this.q([Y.type,Y.id]);this.j?.logOutgoing(J,Y.id,0,S(Y.type));return}}}q(Y,J=void 0){const ee=new i;return c(ee,Y),c(ee,J),this.r(ee.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const J=new w(Y),ee=n(J),ge=n(J),q=ee[0];switch(q){case 200:return this.j?.logIncoming(Y.byteLength,0,0,d(q)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,ee[1],0,d(q),ge),this.t({type:ee[0],id:ee[1],data:ge})}}t(Y){if(Y.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,D.dispose)(this.d.values()),this.d.clear()}}qe([I.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class T{get connections(){const Y=[];return this.f.forEach(J=>Y.push(J)),Y}constructor(Y){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,Y(({protocol:J,onDidClientDisconnect:ee})=>{y.Event.once(J.onMessage)(q=>{const G=new w(q),le=n(G),be=new r(J,le),ve=new E(J);this.a.forEach((Ne,se)=>be.registerChannel(se,Ne));const Pe={channelServer:be,channelClient:ve,ctx:le};this.f.add(Pe),this.g.fire(Pe),ee(()=>{be.dispose(),ve.dispose(),this.f.delete(Pe),this.h.fire(Pe)})})})}getChannel(Y,J){const ee=this;return{call(ge,q,G){let le;if((0,v.isFunction)(J)){const ve=(0,o.getRandomElement)(ee.connections.filter(J));le=ve?Promise.resolve(ve):y.Event.toPromise(y.Event.filter(ee.onDidAddConnection,J))}else le=J.routeCall(ee,ge,q);const be=le.then(ve=>ve.channelClient.getChannel(Y));return K(be).call(ge,q,G)},listen(ge,q){if((0,v.isFunction)(J))return ee.j(Y,J,ge,q);const G=J.routeEvent(ee,ge,q).then(le=>le.channelClient.getChannel(Y));return K(G).listen(ge,q)}}}j(Y,J,ee,ge){const q=this;let G=new D.DisposableStore;const le=new y.Emitter({onWillAddFirstListener:()=>{G=new D.DisposableStore;const be=new y.EventMultiplexer,ve=new Map,Pe=se=>{const de=se.channelClient.getChannel(Y).listen(ee,ge),Z=be.add(de);ve.set(se,Z)},Ne=se=>{const ue=ve.get(se);!ue||(ue.dispose(),ve.delete(se))};q.connections.filter(J).forEach(Pe),y.Event.filter(q.onDidAddConnection,J)(Pe,void 0,G),q.onDidRemoveConnection(Ne,void 0,G),be.event(le.fire,le,G),G.add(be)},onDidRemoveLastListener:()=>{G.dispose()}});return le.event}registerChannel(Y,J){this.a.set(Y,J),this.f.forEach(ee=>{ee.channelServer.registerChannel(Y,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class M{constructor(Y,J,ee=null){const ge=new i;c(ge,J),Y.send(ge.buffer),this.a=new E(Y,ee),this.d=new r(Y,J,ee)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,J){this.d.registerChannel(Y,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=M;function K(_){return{call(Y,J,ee){return _.then(ge=>ge.call(Y,J,ee))},listen(Y,J){const ee=new y.Relay;return _.then(ge=>ee.input=ge.listen(Y,J)),ee.event}}}e.getDelayedChannel=K;function V(_){let Y=!1;return{call(J,ee,ge){return Y?_.call(J,ee,ge):(0,t.timeout)(0).then(()=>Y=!0).then(()=>_.call(J,ee,ge))},listen(J,ee){if(Y)return _.listen(J,ee);const ge=new y.Relay;return(0,t.timeout)(0).then(()=>Y=!0).then(()=>ge.input=_.listen(J,ee)),ge.event}}}e.getNextTickChannel=V;class F{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const J of Y.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await y.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.StaticRouter=F;var U;(function(_){function Y(q,G){const le=q,be=G&&G.disableMarshalling,ve=new Map;for(const Pe in le)ee(Pe)&&ve.set(Pe,y.Event.buffer(le[Pe],!0));return new class{listen(Pe,Ne,se){const ue=ve.get(Ne);if(ue)return ue;if(ge(Ne)){const de=le[Ne];if(typeof de=="function")return de.call(le,se)}throw new Error(`Event not found: ${Ne}`)}call(Pe,Ne,se){const ue=le[Ne];if(typeof ue=="function"){if(!be&&Array.isArray(se))for(let de=0;de<se.length;de++)se[de]=(0,L.revive)(se[de]);return ue.apply(le,se)}throw new Error(`Method not found: ${Ne}`)}}}_.fromService=Y;function J(q,G){const le=G&&G.disableMarshalling;return new Proxy({},{get(be,ve){if(typeof ve=="string")return G?.properties?.has(ve)?G.properties.get(ve):ge(ve)?function(Pe){return q.listen(ve,Pe)}:ee(ve)?q.listen(ve):async function(...Pe){let Ne;G&&!(0,v.isUndefinedOrNull)(G.context)?Ne=[G.context,...Pe]:Ne=Pe;const se=await q.call(ve,Ne);return le?se:(0,L.revive)(se)};throw new Error(`Property not found: ${String(ve)}`)}})}_.toService=J;function ee(q){return q[0]==="o"&&q[1]==="n"&&P.isUpperAsciiLetter(q.charCodeAt(2))}function ge(q){return/^onDynamic/.test(q)&&P.isUpperAsciiLetter(q.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const Y=_.toString();if(Y!=="[object Object]")return Y}return _}function j(_){return Array.isArray(_)?_.map(B):B(_)}function z(_,Y,J,ee,ge,q,G){G=j(G);const le=N[ge],be=le[ee%le.length];let ve=[`%c[${_}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${be}`];/\($/.test(q)?(ve=ve.concat(G),ve.push(")")):ve.push(G),console.log.apply(console,ve)}class ne{constructor(Y,J){this.d=Y,this.f=J,this.a=0,this.b=0}logOutgoing(Y,J,ee,ge,q){this.b+=Y,z(this.d,this.b,Y,J,ee,ge,q)}logIncoming(Y,J,ee,ge,q){this.a+=Y,z(this.f,this.a,Y,J,ee,ge,q)}}e.IPCLogger=ne}),define(ye[117],Ce([1,0,16,22,3,6,116]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(E){E.enableDiagnostics=!1,E.records=[];const T=new WeakMap;let M=0;function K(F,U){if(!T.has(F)){const N=String(++M);T.set(F,N)}return T.get(F)}function V(F,U,N,B){if(!E.enableDiagnostics)return;const j=K(F,U);if(B instanceof t.VSBuffer||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const z=t.VSBuffer.alloc(B.byteLength);z.set(B),E.records.push({timestamp:Date.now(),id:j,label:U,type:N,buff:z})}else E.records.push({timestamp:Date.now(),id:j,label:U,type:N,data:B})}E.traceSocketEvent=V})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var D;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function P(){return L||(L=t.VSBuffer.alloc(0)),L}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,M){if(T===0)return P();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const U=this.a[0];return M&&(this.a.shift(),this.b-=T),U}if(this.a[0].byteLength>T){const U=this.a[0].slice(0,T);return M&&(this.a[0]=this.a[0].slice(T),this.b-=T),U}const K=t.VSBuffer.alloc(T);let V=0,F=0;for(;T>0;){const U=this.a[F];if(U.byteLength>T){const N=U.slice(0,T);K.set(N,V),V+=T,M&&(this.a[F]=U.slice(T),this.b-=T),T-=T}else K.set(U,V),V+=U.byteLength,M?(this.a.shift(),this.b-=U.byteLength):F++,T-=U.byteLength}return K}}e.ChunkStream=v;var C;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(C||(C={}));function S(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var m;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(T,M,K,V){this.type=T,this.id=M,this.ack=K,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends R.Disposable{constructor(T){super(),this.f=this.B(new k.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new v,this.B(this.a.onData(M=>this.acceptChunk(M))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const M=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=M.readUInt32BE(9),this.g.messageType=M.readUInt8(0),this.g.id=M.readUInt32BE(1),this.g.ack=M.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const K=this.g.messageType,V=this.g.id,F=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",M),this.f.fire(new d(K,V,F,M)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const M=t.VSBuffer.alloc(13);M.writeUInt8(T.type,0),M.writeUInt32BE(T.id,1),M.writeUInt32BE(T.ack,5),M.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(M,T.data)}g(T,M){const K=this.f===0;return this.d.push(T,M),this.f+=T.byteLength+M.byteLength,K}h(){const T=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,M){this.g(T,M)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class g extends R.Disposable{constructor(T){super(),this.f=new k.Emitter,this.onMessage=this.f.event,this.g=new k.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new b(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(M=>{M.type===1&&this.f.fire(M.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new d(1,0,0,T))}}e.Protocol=g;class p extends I.IPCClient{static fromSocket(T,M){return new p(new g(T),M)}get onDidDispose(){return this.b.onDidDispose}constructor(T,M,K=null){super(T,M,K),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=p;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new k.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=w;class i{constructor(T){this.data=T,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let T=0,M=this.a;for(;M;)M=M.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let M=0,K=this.a;for(;K;)T[M++]=K.data,K=K.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const M=new i(T);if(!this.a){this.a=M,this.b=M;return}this.b.next=M,this.b=M}}class a{static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const T=Date.now();for(let M=0;M<a.a;M++)this.c[M]=T-1e3*M;setInterval(()=>{for(let M=a.a;M>=1;M--)this.c[M]=this.c[M-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),M=(1+a.a)*1e3;let K=0;for(let V=0;V<a.a;V++)T-this.c[V]<=M&&K++;return 1-K/a.a}hasHighLoad(){return this.d()>=.5}}a.a=10,a.b=null;var u;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(u=e.ConnectionHealth||(e.ConnectionHealth={}));function l(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=l;class c{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=c;class n{constructor(T,M){this.roundTripTime=T,this.recentHighRoundTripCount=M}}e.HighRoundTripTimeEvent=n;class r{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new w,this.onControlMessage=this.x.event,this.y=new w,this.onMessage=this.y.event,this.z=new w,this.onDidDispose=this.z.event,this.A=new w,this.onSocketClose=this.A.event,this.B=new w,this.onSocketTimeout=this.B.event,this.C=new w,this.onHighRoundTripTime=this.C.event,this.D=new w,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??a.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=T.socket,this.p=this.t.add(new b(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new f),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new d(5,0,0,P());this.p.write(T),this.p.flush()}sendPause(){const T=new d(7,0,0,P());this.p.write(T)}sendResume(){const T=new d(8,0,0,P());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,M){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new b(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(K=>this.E(K))),this.t.add(this.o.onClose(K=>this.A.fire(K))),this.r=this.t.add(new f),this.t.add(this.r.onSendLatencyRequest(K=>this.J(K))),this.t.add(this.r.onHighRoundTripTime(K=>this.C.fire(K))),this.t.add(this.r.onDidChangeConnectionHealth(K=>this.D.fire(K))),this.q.acceptChunk(M)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new d(3,0,this.h,P());this.p.write(T);const M=this.b.toArray();for(let K=0,V=M.length;K<V;K++)this.p.write(M[K]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const M=this.b.peek();if(M&&M.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const M=Date.now();M-this.m>1e4&&(this.m=M,this.p.write(new d(6,0,0,P())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const M=this.b.toArray();for(let K=0,V=M.length;K<V;K++)this.p.write(M[K]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const M=++this.c;this.h=this.g;const K=new d(1,M,this.h,T);this.b.push(K),this.a||(this.p.write(K),this.G())}sendControl(T){const M=new d(2,0,0,T);this.p.write(M)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),M=Date.now()-T.writtenTime,K=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(M>=2e4&&K>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:M,timeSinceLastReceivedSomeData:K});return}const F=Math.max(2e4-M,2e4-K,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},F)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new d(3,0,this.h,P());this.p.write(T)}I(){this.h=this.g;const T=new d(9,0,this.h,P());this.p.write(T)}J(T){this.h=this.g;const M=new d(10,0,this.h,T);this.p.write(M)}K(T){this.h=this.g;const M=new d(11,0,this.h,T);this.p.write(M)}}e.PersistentProtocol=r;class f extends R.Disposable{constructor(){super(),this.a=this.B(new k.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new k.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new k.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new o.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,M=t.VSBuffer.alloc(4);M.writeUInt32BE(T,0),this.a.fire(M)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const M=T.readUInt32BE(0);if(this.g<=0||M!==this.h)return;const K=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=K;const F=this.l,U=this.j.filter(N=>N>=1e3).length;this.l=U>=3?1:0,K>1e3&&this.b.fire(new n(K,U)),F!==this.l&&this.c.fire(this.l)}}}),define(ye[118],Ce([1,0,22,10,3,6,9,12,30,116,117]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(n,r){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,r)}constructor(n,r=""){this.f=!0,this.debugLabel=r,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=f=>{if(this.traceSocketEvent("error",{code:f?.code,message:f?.message}),f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}},this.socket.on("error",this.a),this.b=f=>{this.traceSocketEvent("close",{hadError:f}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const r=f=>{this.traceSocketEvent("read",f),n(o.VSBuffer.wrap(f))};return this.socket.on("data",r),{dispose:()=>this.socket.off("data",r)}}onClose(n){const r=f=>{n({type:0,hadError:f,error:void 0})};return this.socket.on("close",r),{dispose:()=>this.socket.off("close",r)}}onEnd(n){const r=()=>{n()};return this.socket.on("end",r),{dispose:()=>this.socket.off("end",r)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,r=>{if(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}})}catch(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,r)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=v;var C;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(C||(C={}));var S;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(S||(S={}));class m extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,r){this.socket.traceSocketEvent(n,r)}constructor(n,r,f,E){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:r,inflateBytesLength:f?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new d(this,r,f,E,this.f,(T,M)=>this.k(T,M))),this.B(this.a.onError(T=>{console.error(T),(0,t.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new L.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(T=>this.g.fire(T)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,r){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let f=2;n.byteLength<126?f+=0:n.byteLength<2**16?f+=2:f+=8;const E=o.VSBuffer.alloc(f);if(r?E.writeUInt8(194,0):E.writeUInt8(130,0),n.byteLength<126)E.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){E.writeUInt8(126,1);let T=1;E.writeUInt8(n.byteLength>>>8&255,++T),E.writeUInt8(n.byteLength>>>0&255,++T)}else{E.writeUInt8(127,1);let T=1;E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(n.byteLength>>>24&255,++T),E.writeUInt8(n.byteLength>>>16&255,++T),E.writeUInt8(n.byteLength>>>8&255,++T),E.writeUInt8(n.byteLength>>>0&255,++T)}this.socket.write(o.VSBuffer.concat([E,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const r=this.b.peek(this.j.readLen),f=r.readUInt8(0),E=(f&128)>>>7,T=(f&64)>>>6,M=r.readUInt8(1),K=(M&128)>>>7,V=M&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const r=this.b.read(this.j.readLen),f=r.readUInt8(1),E=(f&128)>>>7;let T=f&127,M=1;T===126?T=r.readUInt8(++M)*2**8+r.readUInt8(++M):T===127&&(T=r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*2**24+r.readUInt8(++M)*2**16+r.readUInt8(++M)*2**8+r.readUInt8(++M));let K=0;E&&(K=r.readUInt8(++M)*2**24+r.readUInt8(++M)*2**16+r.readUInt8(++M)*2**8+r.readUInt8(++M)),this.j.state=3,this.j.readLen=T,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const r=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",r),g(r,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",r),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(r,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class d extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:o.VSBuffer.alloc(0)}constructor(n,r,f,E,T,M){super(),this.k=n,this.l=T,this.m=M,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,r?(this.b=this.B(new h(this.k,E,f,{windowBits:15})),this.f=this.B(new b(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const r=await this.r(this.f,n);this.m(r,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,r){return new Promise((f,E)=>{n.write(r),n.flush(T=>f(T))})}acceptFrame(n,r,f){this.h.push({data:n,isCompressed:r,isLastFrameOfMessage:f}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const r=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(r)}else this.l.fire(n.data)}this.s=!1}}u(n,r,f){return new Promise((E,T)=>{n.write(r),f&&n.write(o.VSBuffer.fromByteArray([0,0,255,255])),n.flush(M=>E(M))})}}class h extends R.Disposable{get recordedInflateBytes(){return this.j?o.VSBuffer.concat(this.f):o.VSBuffer.alloc(0)}constructor(n,r,f,E){super(),this.h=n,this.j=r,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(E),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(o.VSBuffer.wrap(T))}),f&&(this.h.traceSocketEvent("zlibInflateInitialWrite",f.buffer),this.b.write(f.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const r=o.VSBuffer.concat(this.g);this.g.length=0,n(r)})}}class b extends R.Disposable{constructor(n,r){super(),this.g=n,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",f=>{this.g.traceSocketEvent("zlibDeflateError",{message:f?.message,code:f?.code}),this.a.fire(f)}),this.b.on("data",f=>{this.g.traceSocketEvent("zlibDeflateData",f),this.f.push(o.VSBuffer.wrap(f))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let r=o.VSBuffer.concat(this.f);this.f.length=0,r=r.slice(0,r.byteLength-4),n(r)})}}function g(c,n){if(n===0)return;const r=c.byteLength>>>2;for(let V=0;V<r;V++){const F=c.readUInt32BE(V*4);c.writeUInt32BE(F^n,V*4)}const f=r*4,E=c.byteLength-f,T=n>>>24&255,M=n>>>16&255,K=n>>>8&255;E>=1&&c.writeUInt8(c.readUInt8(f)^T,f),E>=2&&c.writeUInt8(c.readUInt8(f+1)^M,f+1),E>=3&&c.writeUInt8(c.readUInt8(f+2)^K,f+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const p={[2]:107,[1]:103};function w(){const c=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):n=(0,I.join)(P().os.tmpdir(),`vscode-ipc-${c}.sock`),s(n),n}e.createRandomIPCHandle=w;function i(c,n,r){const f=P().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${r}-${n}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${r}-${n}.sock`):E=(0,I.join)(c,`${r}-${n}.sock`),s(E),E}e.createStaticIPCHandle=i;function s(c){const n=p[A.platform];typeof n=="number"&&c.length>=n&&console.warn(`WARNING: IPC handle "${c}" is longer than ${n} chars, try a shorter --user-data-dir`)}class a extends D.IPCServer{static b(n){const r=k.Event.fromNodeEventEmitter(n,"connection");return k.Event.map(r,f=>({protocol:new L.Protocol(new v(f,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(f,"close"))}))}constructor(n){super(a.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=a;function u(c){return new Promise((n,r)=>{const f=P().net.createServer();f.on("error",r),f.listen(c,()=>{f.removeListener("error",r),n(new a(f))})})}e.serve=u;function l(c,n){return new Promise((r,f)=>{const E=P().net.createConnection(c,()=>{E.removeListener("error",f),r(L.Client.fromSocket(new v(E,`ipc-client${n}`),n))});E.once("error",f)})}e.connect=l}),define(ye[163],Ce([1,0,38,9]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(R,I,A,y,D,L){if(Array.isArray(R)){let P=0;for(const v of R){const C=k(v,I,A,y,D,L);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof R=="string")return y?R==="*"?5:R===A?10:0:0;if(R){const{language:P,pattern:v,scheme:C,hasAccessToAllModels:S,notebookType:m}=R;if(!y&&!S)return 0;m&&D&&(I=D);let d=0;if(C)if(C===I.scheme)d=10;else if(C==="*")d=5;else return 0;if(P)if(P===A)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(m)if(m===L)d=10;else if(m==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if(v){let h;if(typeof v=="string"?h=v:h={...v,base:(0,t.normalize)(v.base)},h===I.fsPath||(0,o.match)(h,I.fsPath))d=10;else return 0}return d}else return 0}}e.score=k}),define(ye[164],Ce([1,0,8,51,154]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(A,y,D,L){this.c=A,this.d=y,this.f=D,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(A){A.eol&&A.eol!==this.f&&(this.f=A.eol,this.h=null);const y=A.changes;for(const D of y)this.n(D.range),this.o(new t.Position(D.range.startLineNumber,D.range.startColumn),D.text);this.g=A.versionId,this.j=null}k(){if(!this.h){const A=this.f.length,y=this.d.length,D=new Uint32Array(y);for(let L=0;L<y;L++)D[L]=this.d[L].length+A;this.h=new k.PrefixSumComputer(D)}}l(A,y){this.d[A]=y,this.h&&this.h.setValue(A,this.d[A].length+this.f.length)}n(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.startLineNumber-1].substring(A.endColumn-1));return}this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.endLineNumber-1].substring(A.endColumn-1)),this.d.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.h&&this.h.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}o(A,y){if(y.length===0)return;const D=(0,o.splitLines)(y);if(D.length===1){this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+D[0]+this.d[A.lineNumber-1].substring(A.column-1));return}D[D.length-1]+=this.d[A.lineNumber-1].substring(A.column-1),this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+D[0]);const L=new Uint32Array(D.length-1);for(let P=1;P<D.length;P++)this.d.splice(A.lineNumber+P-1,0,D[P]),L[P-1]=D[P].length+this.f.length;this.h&&this.h.insertValues(A.lineNumber,L)}}e.MirrorTextModel=R}),define(ye[165],Ce([1,0,8,151,51,35,106]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(b,g,p,w){this.searchString=b,this.isRegex=g,this.matchCase=p,this.wordSeparators=w}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=D(this.searchString):b=this.searchString.indexOf(`
`)>=0;let g=null;try{g=o.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!g)return null;let p=!this.isRegex&&!b;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new I.SearchData(g,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=y;function D(h){if(!h||h.length===0)return!1;for(let b=0,g=h.length;b<g;b++){const p=h.charCodeAt(b);if(p===10)return!0;if(p===92){if(b++,b>=g)break;const w=h.charCodeAt(b);if(w===110||w===114||w===87)return!0}}return!1}e.isMultilineRegexSource=D;function L(h,b,g){if(!g)return new I.FindMatch(h,null);const p=[];for(let w=0,i=b.length;w<i;w++)p[w]=b[w];return new I.FindMatch(h,p)}e.createFindMatch=L;class P{constructor(b){const g=[];let p=0;for(let w=0,i=b.length;w<i;w++)b.charCodeAt(w)===10&&(g[p++]=w);this.a=g}findLineFeedCountBeforeOffset(b){const g=this.a;let p=0,w=g.length-1;if(w===-1||b<=g[0])return 0;for(;p<w;){const i=p+((w-p)/2>>0);g[i]>=b?w=i-1:g[i+1]>=b?(p=i,w=i):p=i+1}return p+1}}class v{static findMatches(b,g,p,w,i){const s=g.parseSearchRequest();return s?s.regex.multiline?this.b(b,p,new d(s.wordSeparators,s.regex),w,i):this.c(b,p,s,w,i):[]}static a(b,g,p,w,i,s){let a,u=0;w?(u=w.findLineFeedCountBeforeOffset(i),a=g+i+u):a=g+i;let l;if(w){const f=w.findLineFeedCountBeforeOffset(i+s.length)-u;l=a+s.length+f}else l=a+s.length;const c=b.getPositionAt(a),n=b.getPositionAt(l);return new R.Range(c.lineNumber,c.column,n.lineNumber,n.column)}static b(b,g,p,w,i){const s=b.getOffsetAt(g.getStartPosition()),a=b.getValueInRange(g,1),u=b.getEOL()===`\r
`?new P(a):null,l=[];let c=0,n;for(p.reset(0);n=p.next(a);)if(l[c++]=L(this.a(b,s,a,u,n.index,n[0]),n,w),c>=i)return l;return l}static c(b,g,p,w,i){const s=[];let a=0;if(g.startLineNumber===g.endLineNumber){const l=b.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return a=this.d(p,l,g.startLineNumber,g.startColumn-1,a,s,w,i),s}const u=b.getLineContent(g.startLineNumber).substring(g.startColumn-1);a=this.d(p,u,g.startLineNumber,g.startColumn-1,a,s,w,i);for(let l=g.startLineNumber+1;l<g.endLineNumber&&a<i;l++)a=this.d(p,b.getLineContent(l),l,0,a,s,w,i);if(a<i){const l=b.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);a=this.d(p,l,g.endLineNumber,0,a,s,w,i)}return s}static d(b,g,p,w,i,s,a,u){const l=b.wordSeparators;if(!a&&b.simpleSearch){const r=b.simpleSearch,f=r.length,E=g.length;let T=-f;for(;(T=g.indexOf(r,T+f))!==-1;)if((!l||m(l,g,E,T,f))&&(s[i++]=new I.FindMatch(new R.Range(p,T+1+w,p,T+1+f+w),null),i>=u))return i;return i}const c=new d(b.wordSeparators,b.regex);let n;c.reset(0);do if(n=c.next(g),n&&(s[i++]=L(new R.Range(p,n.index+1+w,p,n.index+1+n[0].length+w),n,a),i>=u))return i;while(n);return i}static findNextMatch(b,g,p,w){const i=g.parseSearchRequest();if(!i)return null;const s=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.e(b,p,s,w):this.f(b,p,s,w)}static e(b,g,p,w){const i=new k.Position(g.lineNumber,1),s=b.getOffsetAt(i),a=b.getLineCount(),u=b.getValueInRange(new R.Range(i.lineNumber,i.column,a,b.getLineMaxColumn(a)),1),l=b.getEOL()===`\r
`?new P(u):null;p.reset(g.column-1);const c=p.next(u);return c?L(this.a(b,s,u,l,c.index,c[0]),c,w):g.lineNumber!==1||g.column!==1?this.e(b,new k.Position(1,1),p,w):null}static f(b,g,p,w){const i=b.getLineCount(),s=g.lineNumber,a=b.getLineContent(s),u=this.g(p,a,s,g.column,w);if(u)return u;for(let l=1;l<=i;l++){const c=(s+l-1)%i,n=b.getLineContent(c+1),r=this.g(p,n,c+1,1,w);if(r)return r}return null}static g(b,g,p,w,i){b.reset(w-1);const s=b.next(g);return s?L(new R.Range(p,s.index+1,p,s.index+1+s[0].length),s,i):null}static findPreviousMatch(b,g,p,w){const i=g.parseSearchRequest();if(!i)return null;const s=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.h(b,p,s,w):this.j(b,p,s,w)}static h(b,g,p,w){const i=this.b(b,new R.Range(1,1,g.lineNumber,g.column),p,w,10*A);if(i.length>0)return i[i.length-1];const s=b.getLineCount();return g.lineNumber!==s||g.column!==b.getLineMaxColumn(s)?this.h(b,new k.Position(s,b.getLineMaxColumn(s)),p,w):null}static j(b,g,p,w){const i=b.getLineCount(),s=g.lineNumber,a=b.getLineContent(s).substring(0,g.column-1),u=this.k(p,a,s,w);if(u)return u;for(let l=1;l<=i;l++){const c=(i+s-l-1)%i,n=b.getLineContent(c+1),r=this.k(p,n,c+1,w);if(r)return r}return null}static k(b,g,p,w){let i=null,s;for(b.reset(0);s=b.next(g);)i=L(new R.Range(p,s.index+1,p,s.index+1+s[0].length),s,w);return i}}e.TextModelSearch=v;function C(h,b,g,p,w){if(p===0)return!0;const i=b.charCodeAt(p-1);if(h.get(i)!==0||i===13||i===10)return!0;if(w>0){const s=b.charCodeAt(p);if(h.get(s)!==0)return!0}return!1}function S(h,b,g,p,w){if(p+w===g)return!0;const i=b.charCodeAt(p+w);if(h.get(i)!==0||i===13||i===10)return!0;if(w>0){const s=b.charCodeAt(p+w-1);if(h.get(s)!==0)return!0}return!1}function m(h,b,g,p,w){return C(h,b,g,p,w)&&S(h,b,g,p,w)}e.isValidMatch=m;class d{constructor(b,g){this._wordSeparators=b,this.a=g,this.b=-1,this.c=0}reset(b){this.a.lastIndex=b,this.b=-1,this.c=0}next(b){const g=b.length;let p;do{if(this.b+this.c===g||(p=this.a.exec(b),!p))return null;const w=p.index,i=p[0].length;if(w===this.b&&i===this.c){if(i===0){o.getNextCodePoint(b,g,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=w,this.c=i,!this._wordSeparators||m(this._wordSeparators,b,g,w,i))return p}while(p);return null}}e.Searcher=d}),define(ye[119],Ce([1,0,22,12]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(k||(k={}));function R(P){for(let v=0,C=P.length;v<C;v+=4){const S=P[v+0],m=P[v+1],d=P[v+2],h=P[v+3];P[v+0]=h,P[v+1]=d,P[v+2]=m,P[v+3]=S}}function I(P){const v=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||R(v),o.VSBuffer.wrap(v)}function A(P){const v=P.buffer;if(t.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const C=new Uint8Array(v.byteLength);return C.set(v),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function y(P){const v=new Uint32Array(D(P));let C=0;if(v[C++]=P.id,P.type==="full")v[C++]=1,v[C++]=P.data.length,v.set(P.data,C),C+=P.data.length;else{v[C++]=2,v[C++]=P.deltas.length;for(const S of P.deltas)v[C++]=S.start,v[C++]=S.deleteCount,S.data?(v[C++]=S.data.length,v.set(S.data,C),C+=S.data.length):v[C++]=0}return I(v)}e.encodeSemanticTokensDto=y;function D(P){let v=0;if(v+=1+1,P.type==="full")v+=1+P.data.length;else{v+=1,v+=(1+1+1)*P.deltas.length;for(const C of P.deltas)C.data&&(v+=C.data.length)}return v}function L(P){const v=A(P);let C=0;const S=v[C++];if(v[C++]===1){const b=v[C++],g=v.subarray(C,C+b);return C+=b,{id:S,type:"full",data:g}}const d=v[C++],h=[];for(let b=0;b<d;b++){const g=v[C++],p=v[C++],w=v[C++];let i;w>0&&(i=v.subarray(C,C+w),C+=w),h[b]={start:g,deleteCount:p,data:i}}return{id:S,type:"delta",deltas:h}}e.decodeSemanticTokensDto=L}),define(ye[166],Ce([1,0,3,6]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this.a=new Map,this.b=new Map,this.c=new o.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.fire([A]),(0,t.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,y){this.b.get(A)?.dispose();const D=new R(this,A,y);return this.b.set(A,D),(0,t.toDisposable)(()=>{const L=this.b.get(A);!L||L!==D||(this.b.delete(A),L.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const D=this.b.get(A);return!D||D.isResolved?null:(await D.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const D=this.b.get(A);return!!(!D||D.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=k;class R extends t.Disposable{get isResolved(){return this.c}constructor(A,y,D){super(),this.f=A,this.g=y,this.h=D,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ye[66],Ce([1,0,80,2,35,166]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class I{constructor(f,E,T){this._tokenBrand=void 0,this.offset=f,this.type=E,this.language=T}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=I;class A{constructor(f,E){this._tokenizationResultBrand=void 0,this.tokens=f,this.endState=E}}e.TokenizationResult=A;class y{constructor(f,E){this._encodedTokenizationResultBrand=void 0,this.tokens=f,this.endState=E}}e.EncodedTokenizationResult=y;var D;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(r){const f=new Map;f.set(0,o.Codicon.symbolMethod),f.set(1,o.Codicon.symbolFunction),f.set(2,o.Codicon.symbolConstructor),f.set(3,o.Codicon.symbolField),f.set(4,o.Codicon.symbolVariable),f.set(5,o.Codicon.symbolClass),f.set(6,o.Codicon.symbolStruct),f.set(7,o.Codicon.symbolInterface),f.set(8,o.Codicon.symbolModule),f.set(9,o.Codicon.symbolProperty),f.set(10,o.Codicon.symbolEvent),f.set(11,o.Codicon.symbolOperator),f.set(12,o.Codicon.symbolUnit),f.set(13,o.Codicon.symbolValue),f.set(15,o.Codicon.symbolEnum),f.set(14,o.Codicon.symbolConstant),f.set(15,o.Codicon.symbolEnum),f.set(16,o.Codicon.symbolEnumMember),f.set(17,o.Codicon.symbolKeyword),f.set(27,o.Codicon.symbolSnippet),f.set(18,o.Codicon.symbolText),f.set(19,o.Codicon.symbolColor),f.set(20,o.Codicon.symbolFile),f.set(21,o.Codicon.symbolReference),f.set(22,o.Codicon.symbolCustomColor),f.set(23,o.Codicon.symbolFolder),f.set(24,o.Codicon.symbolTypeParameter),f.set(25,o.Codicon.account),f.set(26,o.Codicon.issues);function E(K){let V=f.get(K);return V||(console.info("No codicon found for CompletionItemKind "+K),V=o.Codicon.symbolProperty),V}r.toIcon=E;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function M(K,V){let F=T.get(K);return typeof F>"u"&&!V&&(F=9),F}r.fromString=M})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(r){r[r.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var C;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(r){return r&&t.URI.isUri(r.uri)&&k.Range.isIRange(r.range)&&(k.Range.isIRange(r.originSelectionRange)||k.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=b;var g;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(g=e.SymbolKind||(e.SymbolKind={}));var p;(function(r){r[r.Deprecated=1]="Deprecated"})(p=e.SymbolTag||(e.SymbolTag={}));var w;(function(r){const f=new Map;f.set(0,o.Codicon.symbolFile),f.set(1,o.Codicon.symbolModule),f.set(2,o.Codicon.symbolNamespace),f.set(3,o.Codicon.symbolPackage),f.set(4,o.Codicon.symbolClass),f.set(5,o.Codicon.symbolMethod),f.set(6,o.Codicon.symbolProperty),f.set(7,o.Codicon.symbolField),f.set(8,o.Codicon.symbolConstructor),f.set(9,o.Codicon.symbolEnum),f.set(10,o.Codicon.symbolInterface),f.set(11,o.Codicon.symbolFunction),f.set(12,o.Codicon.symbolVariable),f.set(13,o.Codicon.symbolConstant),f.set(14,o.Codicon.symbolString),f.set(15,o.Codicon.symbolNumber),f.set(16,o.Codicon.symbolBoolean),f.set(17,o.Codicon.symbolArray),f.set(18,o.Codicon.symbolObject),f.set(19,o.Codicon.symbolKey),f.set(20,o.Codicon.symbolNull),f.set(21,o.Codicon.symbolEnumMember),f.set(22,o.Codicon.symbolStruct),f.set(23,o.Codicon.symbolEvent),f.set(24,o.Codicon.symbolOperator),f.set(25,o.Codicon.symbolTypeParameter);function E(T){let M=f.get(T);return M||(console.info("No codicon found for SymbolKind "+T),M=o.Codicon.symbolProperty),M}r.toIcon=E})(w=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(f){this.value=f}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var s;(function(r){function f(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}r.is=f})(s=e.Command||(e.Command={}));var a;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(r){r[r.Unresolved=0]="Unresolved",r[r.Resolved=1]="Resolved"})(u=e.CommentThreadState||(e.CommentThreadState={}));var l;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var n;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[167],Ce([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ye[120],Ce([1,0,167,12,105,18,23,150]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=D;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return C($,ce)}compute($,ce,Ie){return Ie}}class v{constructor($,ce){this.newValue=$,this.didChange=ce}}e.ApplyUpdateResult=v;function C(oe,$){if(typeof oe!="object"||typeof $!="object"||!oe||!$)return new v($,oe!==$);if(Array.isArray(oe)||Array.isArray($)){const Ie=Array.isArray(oe)&&Array.isArray($)&&R.equals(oe,$);return new v($,!Ie)}let ce=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=C(oe[Ie],$[Ie]);Le.didChange&&(oe[Ie]=Le.newValue,ce=!0)}return new v(oe,ce)}class S{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,ce){return C($,ce)}validate($){return this.defaultValue}}class m{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return C($,ce)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,ce,Ie){return Ie}}function d(oe,$){return typeof oe>"u"?$:oe==="false"?!1:Boolean(oe)}e.boolean=d;class h extends m{constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,ce,Ie,Le)}validate($){return d($,this.defaultValue)}}function b(oe,$,ce,Ie){if(typeof oe>"u")return $;let Le=parseInt(oe,10);return isNaN(Le)?$:(Le=Math.max(ce,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=b;class g extends m{static clampedInt($,ce,Ie,Le){return b($,ce,Ie,Le)}constructor($,ce,Ie,Le,Be,xe=void 0){typeof xe<"u"&&(xe.type="integer",xe.default=Ie,xe.minimum=Le,xe.maximum=Be),super($,ce,Ie,xe),this.minimum=Le,this.maximum=Be}validate($){return g.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class p extends m{static clamp($,ce,Ie){return $<ce?ce:$>Ie?Ie:$}static float($,ce){if(typeof $=="number")return $;if(typeof $>"u")return ce;const Ie=parseFloat($);return isNaN(Ie)?ce:Ie}constructor($,ce,Ie,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ie),super($,ce,Ie,Be),this.validationFn=Le}validate($){return this.validationFn(p.float($,this.defaultValue))}}class w extends m{static string($,ce){return typeof $!="string"?ce:$}constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,ce,Ie,Le)}validate($){return w.string($,this.defaultValue)}}function i(oe,$,ce){return typeof oe!="string"||ce.indexOf(oe)===-1?$:oe}e.stringSet=i;class s extends m{constructor($,ce,Ie,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ie),super($,ce,Ie,Be),this.c=Le}validate($){return i($,this.defaultValue,this.c)}}class a extends P{constructor($,ce,Ie,Le,Be,xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super($,ce,Ie,Ze),this.c=Be,this.d=xe}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function u(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,ce,Ie){return Ie===0?$.accessibilitySupport:Ie}}class c extends P{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:o.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertSpace:d(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(oe){switch(oe){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function T(oe){switch(oe){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class M extends S{constructor(){super(135)}compute($,ce,Ie){const Le=["monaco-editor"];return ce.get(36)&&Le.push(ce.get(36)),$.extraEditorClassName&&Le.push($.extraEditorClassName),ce.get(70)==="default"?Le.push("mouse-default"):ce.get(70)==="copy"&&Le.push("mouse-copy"),ce.get(105)&&Le.push("showUnused"),ce.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class K extends h{constructor(){super(34,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute($,ce,Ie){return Ie&&$.emptySelectionClipboard}}class V extends P{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:o.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:o.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{cursorMoveOnType:d(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":i(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":i(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ce.loop,this.defaultValue.loop)}}}class F extends P{constructor(){super(48,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?F.OFF:$==="true"?F.ON:$:Boolean($)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class U extends P{constructor(){super(51,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?U.OFF:$==="true"?U.TRANSLATE:$:Boolean($)?U.TRANSLATE:U.OFF}compute($,ce,Ie){return $.fontInfo.fontVariationSettings}}e.EditorFontVariations=U,U.OFF="normal",U.TRANSLATE="translate";class N extends S{constructor(){super(47)}compute($,ce,Ie){return $.fontInfo}}class B extends m{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate($){const ce=p.float($,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ce,6,100)}compute($,ce,Ie){return $.fontInfo.fontSize}}class j extends P{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.d,maximum:j.e,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(g.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,j.d,j.e))}}j.c=["normal","bold","100","200","300","400","500","600","700","800","900"],j.d=1,j.e=1e3;class z extends P{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...ce},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...ce},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:o.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{multiple:i(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??i(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??i(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??i(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??i(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??i(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ne extends P{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:o.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:o.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:d(ce.enabled,this.defaultValue.enabled),delay:g.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:d(ce.sticky,this.defaultValue.sticky),above:d(ce.above,this.defaultValue.above)}}}var _;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(_=e.RenderMinimap||(e.RenderMinimap={}));class Y extends S{constructor(){super(138)}compute($,ce,Ie){return Y.computeLayout(ce,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const ce=$.height/$.lineHeight,Ie=Math.floor($.paddingTop/$.lineHeight);let Le=Math.floor($.paddingBottom/$.lineHeight);$.scrollBeyondLastLine&&(Le=Math.max(Le,ce-1));const Be=(Ie+$.viewLineCount+Le)/($.pixelRatio*$.height),xe=Math.floor($.viewLineCount/Be);return{typicalViewportLineCount:ce,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:Be,minimapLineCount:xe}}static c($,ce){const Ie=$.outerWidth,Le=$.outerHeight,Be=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const xe=ce.stableMinimapLayoutInput,Ze=xe&&$.outerHeight===xe.outerHeight&&$.lineHeight===xe.lineHeight&&$.typicalHalfwidthCharacterWidth===xe.typicalHalfwidthCharacterWidth&&$.pixelRatio===xe.pixelRatio&&$.scrollBeyondLastLine===xe.scrollBeyondLastLine&&$.paddingTop===xe.paddingTop&&$.paddingBottom===xe.paddingBottom&&$.minimap.enabled===xe.minimap.enabled&&$.minimap.side===xe.minimap.side&&$.minimap.size===xe.minimap.size&&$.minimap.showSlider===xe.minimap.showSlider&&$.minimap.renderCharacters===xe.minimap.renderCharacters&&$.minimap.maxColumn===xe.minimap.maxColumn&&$.minimap.scale===xe.minimap.scale&&$.verticalScrollbarWidth===xe.verticalScrollbarWidth&&$.isViewportWrapping===xe.isViewportWrapping,gt=$.lineHeight,mt=$.typicalHalfwidthCharacterWidth,lt=$.scrollBeyondLastLine,ot=$.minimap.renderCharacters;let rt=Be>=2?Math.round($.minimap.scale*2):$.minimap.scale;const kt=$.minimap.maxColumn,Tt=$.minimap.size,Nt=$.minimap.side,pt=$.verticalScrollbarWidth,Dt=$.viewLineCount,zt=$.remainingWidth,Ft=$.isViewportWrapping,Xe=ot?2:3;let Mt=Math.floor(Be*Le);const Ut=Mt/Be;let Bt=!1,wt=!1,Pt=Xe*rt,Re=rt/Be,Oe=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeforeFirstLine:St,extraLinesBeyondLastLine:Et,desiredRatio:Lt,minimapLineCount:vt}=Y.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:lt,paddingTop:$.paddingTop,paddingBottom:$.paddingBottom,height:Le,lineHeight:gt,pixelRatio:Be});if(Dt/vt>1)Bt=!0,wt=!0,rt=1,Pt=1,Re=rt/Be;else{let ft=!1,Gt=rt+1;if(Tt==="fit"){const jt=Math.ceil((St+Dt+Et)*Pt);Ft&&Ze&&zt<=ce.stableFitRemainingWidth?(ft=!0,Gt=ce.stableFitMaxMinimapScale):ft=jt>Mt}if(Tt==="fill"||ft){Bt=!0;const jt=rt;Pt=Math.min(gt*Be,Math.max(1,Math.floor(1/Lt))),Ft&&Ze&&zt<=ce.stableFitRemainingWidth&&(Gt=ce.stableFitMaxMinimapScale),rt=Math.min(Gt,Math.max(1,Math.floor(Pt/Xe))),rt>jt&&(Oe=Math.min(2,rt/jt)),Re=rt/Be/Oe,Mt=Math.ceil(Math.max(tt,St+Dt+Et)*Pt),Ft?(ce.stableMinimapLayoutInput=$,ce.stableFitRemainingWidth=zt,ce.stableFitMaxMinimapScale=rt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const Se=Math.floor(kt*Re),re=Math.min(Se,Math.max(0,Math.floor((zt-pt-2)*Re/(mt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Be*re);const $e=Fe/Be;Fe=Math.floor(Fe*Oe);const Qe=ot?1:2,Ve=Nt==="left"?0:Ie-re-pt;return{renderMinimap:Qe,minimapLeft:Ve,minimapWidth:re,minimapHeightIsEditorHeight:Bt,minimapIsSampling:wt,minimapScale:rt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Ut}}static computeLayout($,ce){const Ie=ce.outerWidth|0,Le=ce.outerHeight|0,Be=ce.lineHeight|0,xe=ce.lineNumbersDigitCount|0,Ze=ce.typicalHalfwidthCharacterWidth,gt=ce.maxDigitWidth,mt=ce.pixelRatio,lt=ce.viewLineCount,ot=$.get(130),rt=ot==="inherit"?$.get(129):ot,kt=rt==="inherit"?$.get(125):rt,Tt=$.get(128),Nt=ce.isDominatedByLongLines,pt=$.get(54),Dt=$.get(64).renderType!==0,zt=$.get(65),Ft=$.get(99),Xe=$.get(80),Mt=$.get(69),Ut=$.get(97),Bt=Ut.verticalScrollbarSize,wt=Ut.verticalHasArrows,Pt=Ut.arrowSize,Re=Ut.horizontalScrollbarSize,Oe=$.get(40),Se=$.get(104)!=="never";let re=$.get(62);Oe&&Se&&(re+=16);let Fe=0;if(Dt){const _t=Math.max(xe,zt);Fe=Math.round(_t*gt)}let $e=0;pt&&($e=Be);let Qe=0,Ve=Qe+$e,tt=Ve+Fe,St=tt+re;const Et=Ie-$e-Fe-re;let Lt=!1,vt=!1,It=-1;rt==="inherit"&&Nt?(Lt=!0,vt=!0):kt==="on"||kt==="bounded"?vt=!0:kt==="wordWrapColumn"&&(It=Tt);const ft=Y.c({outerWidth:Ie,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:mt,scrollBeyondLastLine:Ft,paddingTop:Xe.top,paddingBottom:Xe.bottom,minimap:Mt,verticalScrollbarWidth:Bt,viewLineCount:lt,remainingWidth:Et,isViewportWrapping:vt},ce.memory||new L);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Qe+=ft.minimapWidth,Ve+=ft.minimapWidth,tt+=ft.minimapWidth,St+=ft.minimapWidth);const Gt=Et-ft.minimapWidth,jt=Math.max(1,Math.floor((Gt-Bt-2)/Ze)),yt=wt?Pt:0;return vt&&(It=Math.max(1,jt),kt==="bounded"&&(It=Math.min(It,Tt))),{width:Ie,height:Le,glyphMarginLeft:Qe,glyphMarginWidth:$e,lineNumbersLeft:Ve,lineNumbersWidth:Fe,decorationsLeft:tt,decorationsWidth:re,contentLeft:St,contentWidth:Gt,minimap:ft,viewportColumn:jt,isWordWrapMinified:Lt,isViewportWrapping:vt,wrappingColumn:It,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Re,overviewRuler:{top:yt,width:Bt,height:Le-2*yt,right:0}}}}e.EditorLayoutInfoComputer=Y;class J extends P{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(46,null),o.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(48,null)}})}validate($){return i($,"simple",["simple","advanced"])}compute($,ce,Ie){return ce.get(2)===2?"advanced":Ie}}class ee extends P{constructor(){const $={enabled:!0};super(61,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:o.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}class ge extends P{constructor(){const $={enabled:!1,maxLineCount:5};super(109,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:o.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:o.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:d(ce.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(ce.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class q extends P{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:o.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(53,null),o.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:o.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:o.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:o.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return typeof ce.enabled=="boolean"&&(ce.enabled=ce.enabled?"on":"off"),{enabled:i(ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ce.fontFamily,this.defaultValue.fontFamily),padding:d(ce.padding,this.defaultValue.padding)}}}class G extends P{constructor(){super(62,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):g.clampedInt($,this.defaultValue,0,1e3)}compute($,ce,Ie){return Ie<0?g.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class le extends p{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>p.clamp($,0,150),{markdownDescription:o.localize(60,null)})}compute($,ce,Ie){return $.fontInfo.lineHeight}}class be extends P{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:o.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:o.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(63,null),o.localize(64,null),o.localize(65,null)],default:$.size,description:o.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:o.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:o.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:o.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:o.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:d(ce.enabled,this.defaultValue.enabled),autohide:d(ce.autohide,this.defaultValue.autohide),size:i(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(ce.side,this.defaultValue.side,["right","left"]),showSlider:i(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ce.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(ce.scale,1,1,3),maxColumn:g.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(oe){return oe==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Pe extends P{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{top:g.clampedInt(ce.top,0,0,1e3),bottom:g.clampedInt(ce.bottom,0,0,1e3)}}}class Ne extends P{constructor(){const $={enabled:!0,cycle:!0};super(81,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:o.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:o.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:d(ce.enabled,this.defaultValue.enabled),cycle:d(ce.cycle,this.defaultValue.cycle)}}}class se extends S{constructor(){super(136)}compute($,ce,Ie){return $.pixelRatio}}class ue extends P{constructor(){const $={other:"on",comments:"off",strings:"off"},ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(76,null),o.localize(77,null),o.localize(78,null)]}];super(84,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ce,default:$.strings,description:o.localize(79,null)},comments:{anyOf:ce,default:$.comments,description:o.localize(80,null)},other:{anyOf:ce,default:$.other,description:o.localize(81,null)}},default:$,markdownDescription:o.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const mt=$?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!$||typeof $!="object")return this.defaultValue;const{other:ce,comments:Ie,strings:Le}=$,Be=["on","inline","off"];let xe,Ze,gt;return typeof ce=="boolean"?xe=ce?"on":"off":xe=i(ce,this.defaultValue.other,Be),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=i(Ie,this.defaultValue.comments,Be),typeof Le=="boolean"?gt=Le?"on":"off":gt=i(Le,this.defaultValue.strings,Be),{other:xe,comments:Ze,strings:gt}}}var de;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(de=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Z extends P{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(83,null),o.localize(84,null),o.localize(85,null),o.localize(86,null)],default:"on",description:o.localize(87,null)})}validate($){let ce=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(ce=4,Ie=$):$==="interval"?ce=3:$==="relative"?ce=2:$==="on"?ce=1:ce=0),{renderType:ce,renderFn:Ie}}}function ae(oe){const $=oe.get(92);return $==="editable"?oe.get(86):$!=="on"}e.filterValidationDecorations=ae;class ie extends P{constructor(){const $=[],ce={type:"number",description:o.localize(88,null)};super(96,"rulers",$,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:o.localize(89,null),format:"color-hex"}}}]},default:$,description:o.localize(90,null)})}validate($){if(Array.isArray($)){const ce=[];for(const Ie of $)if(typeof Ie=="number")ce.push({column:g.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ce.push({column:g.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ce.sort((Ie,Le)=>Ie.column-Le.column),ce}return this.defaultValue}}function O(oe,$){if(typeof oe!="string")return $;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends P{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(91,null),o.localize(92,null),o.localize(93,null)],default:"auto",description:o.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(95,null),o.localize(96,null),o.localize(97,null)],default:"auto",description:o.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:o.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:o.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:o.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$,Ie=g.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=g.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ce.vertical,this.defaultValue.vertical),horizontal:O(ce.horizontal,this.defaultValue.horizontal),useShadows:d(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:g.clampedInt(ce.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:g.clampedInt(ce.verticalSliderSize,Le,0,1e3),scrollByPage:d(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends P{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:o.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:o.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:o.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:o.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:o.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:o.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:o.localize(108,null)}})}applyUpdate($,ce){let Ie=!1;ce.allowedCharacters&&$&&(I.equals($.allowedCharacters,ce.allowedCharacters)||($={...$,allowedCharacters:ce.allowedCharacters},Ie=!0)),ce.allowedLocales&&$&&(I.equals($.allowedLocales,ce.allowedLocales)||($={...$,allowedLocales:ce.allowedLocales},Ie=!0));const Le=super.applyUpdate($,ce);return Ie?new v(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{nonBasicASCII:Ae(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,ce){if(typeof $!="object"||!$)return ce;const Ie={};for(const[Le,Be]of Object.entries($))Be===!0&&(Ie[Le]=!0);return Ie}}class Q extends P{constructor(){const $={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:o.localize(109,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:d(ce.enabled,this.defaultValue.enabled),mode:i(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class he extends P{constructor(){const $={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:o.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:o.localize(111,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:d(ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends P{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(112,null),o.localize(113,null),o.localize(114,null)],default:$.bracketPairs,description:o.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(116,null),o.localize(117,null),o.localize(118,null)],default:$.bracketPairsHorizontal,description:o.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:o.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:o.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(122,null),o.localize(123,null),o.localize(124,null)],default:$.highlightActiveIndentation,description:o.localize(125,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{bracketPairs:Ae(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(oe,$,ce){const Ie=ce.indexOf(oe);return Ie===-1?$:ce[Ie]}class pe extends P{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(126,null),o.localize(127,null)],default:$.insertMode,description:o.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:o.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:o.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:o.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(132,null),o.localize(133,null),o.localize(134,null),o.localize(135,null)],default:$.selectionMode,markdownDescription:o.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:o.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:o.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:o.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:o.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:o.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertMode:i(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(ce.showIcons,this.defaultValue.showIcons),showStatusBar:d(ce.showStatusBar,this.defaultValue.showStatusBar),preview:d(ce.preview,this.defaultValue.preview),previewMode:i(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ce.showMethods,this.defaultValue.showMethods),showFunctions:d(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(ce.showFields,this.defaultValue.showFields),showVariables:d(ce.showVariables,this.defaultValue.showVariables),showClasses:d(ce.showClasses,this.defaultValue.showClasses),showStructs:d(ce.showStructs,this.defaultValue.showStructs),showInterfaces:d(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ce.showModules,this.defaultValue.showModules),showProperties:d(ce.showProperties,this.defaultValue.showProperties),showEvents:d(ce.showEvents,this.defaultValue.showEvents),showOperators:d(ce.showOperators,this.defaultValue.showOperators),showUnits:d(ce.showUnits,this.defaultValue.showUnits),showValues:d(ce.showValues,this.defaultValue.showValues),showConstants:d(ce.showConstants,this.defaultValue.showConstants),showEnums:d(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ce.showKeywords,this.defaultValue.showKeywords),showWords:d(ce.showWords,this.defaultValue.showWords),showColors:d(ce.showColors,this.defaultValue.showColors),showFiles:d(ce.showFiles,this.defaultValue.showFiles),showReferences:d(ce.showReferences,this.defaultValue.showReferences),showFolders:d(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ce.showSnippets,this.defaultValue.showSnippets),showUsers:d(ce.showUsers,this.defaultValue.showUsers),showIssues:d(ce.showIssues,this.defaultValue.showIssues)}}}class De extends P{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(174,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends S{constructor(){super(137)}compute($,ce,Ie){return ce.get(86)?!0:$.tabFocusMode}}var je;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends P{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(175,null),o.localize(176,null),o.localize(177,null),o.localize(178,null)],description:o.localize(179,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,ce,Ie){return ce.get(2)===2?0:Ie}}class et extends S{constructor(){super(139)}compute($,ce,Ie){const Le=ce.get(138);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class _e extends P{constructor(){const $={enabled:!0};super(33,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:o.localize(180,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var it;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.autoClosingBrackets=5]="autoClosingBrackets",oe[oe.autoClosingDelete=6]="autoClosingDelete",oe[oe.autoClosingOvertype=7]="autoClosingOvertype",oe[oe.autoClosingQuotes=8]="autoClosingQuotes",oe[oe.autoIndent=9]="autoIndent",oe[oe.automaticLayout=10]="automaticLayout",oe[oe.autoSurround=11]="autoSurround",oe[oe.bracketPairColorization=12]="bracketPairColorization",oe[oe.guides=13]="guides",oe[oe.codeLens=14]="codeLens",oe[oe.codeLensFontFamily=15]="codeLensFontFamily",oe[oe.codeLensFontSize=16]="codeLensFontSize",oe[oe.colorDecorators=17]="colorDecorators",oe[oe.colorDecoratorsLimit=18]="colorDecoratorsLimit",oe[oe.columnSelection=19]="columnSelection",oe[oe.comments=20]="comments",oe[oe.contextmenu=21]="contextmenu",oe[oe.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=23]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=25]="cursorStyle",oe[oe.cursorSurroundingLines=26]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=28]="cursorWidth",oe[oe.disableLayerHinting=29]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",oe[oe.domReadOnly=31]="domReadOnly",oe[oe.dragAndDrop=32]="dragAndDrop",oe[oe.dropIntoEditor=33]="dropIntoEditor",oe[oe.emptySelectionClipboard=34]="emptySelectionClipboard",oe[oe.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",oe[oe.extraEditorClassName=36]="extraEditorClassName",oe[oe.fastScrollSensitivity=37]="fastScrollSensitivity",oe[oe.find=38]="find",oe[oe.fixedOverflowWidgets=39]="fixedOverflowWidgets",oe[oe.folding=40]="folding",oe[oe.foldingStrategy=41]="foldingStrategy",oe[oe.foldingHighlight=42]="foldingHighlight",oe[oe.foldingImportsByDefault=43]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=44]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=46]="fontFamily",oe[oe.fontInfo=47]="fontInfo",oe[oe.fontLigatures=48]="fontLigatures",oe[oe.fontSize=49]="fontSize",oe[oe.fontWeight=50]="fontWeight",oe[oe.fontVariations=51]="fontVariations",oe[oe.formatOnPaste=52]="formatOnPaste",oe[oe.formatOnType=53]="formatOnType",oe[oe.glyphMargin=54]="glyphMargin",oe[oe.gotoLocation=55]="gotoLocation",oe[oe.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",oe[oe.hover=57]="hover",oe[oe.inDiffEditor=58]="inDiffEditor",oe[oe.inlineSuggest=59]="inlineSuggest",oe[oe.letterSpacing=60]="letterSpacing",oe[oe.lightbulb=61]="lightbulb",oe[oe.lineDecorationsWidth=62]="lineDecorationsWidth",oe[oe.lineHeight=63]="lineHeight",oe[oe.lineNumbers=64]="lineNumbers",oe[oe.lineNumbersMinChars=65]="lineNumbersMinChars",oe[oe.linkedEditing=66]="linkedEditing",oe[oe.links=67]="links",oe[oe.matchBrackets=68]="matchBrackets",oe[oe.minimap=69]="minimap",oe[oe.mouseStyle=70]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=72]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=74]="multiCursorModifier",oe[oe.multiCursorPaste=75]="multiCursorPaste",oe[oe.multiCursorLimit=76]="multiCursorLimit",oe[oe.occurrencesHighlight=77]="occurrencesHighlight",oe[oe.overviewRulerBorder=78]="overviewRulerBorder",oe[oe.overviewRulerLanes=79]="overviewRulerLanes",oe[oe.padding=80]="padding",oe[oe.parameterHints=81]="parameterHints",oe[oe.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=84]="quickSuggestions",oe[oe.quickSuggestionsDelay=85]="quickSuggestionsDelay",oe[oe.readOnly=86]="readOnly",oe[oe.renameOnType=87]="renameOnType",oe[oe.renderControlCharacters=88]="renderControlCharacters",oe[oe.renderFinalNewline=89]="renderFinalNewline",oe[oe.renderLineHighlight=90]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=92]="renderValidationDecorations",oe[oe.renderWhitespace=93]="renderWhitespace",oe[oe.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",oe[oe.roundedSelection=95]="roundedSelection",oe[oe.rulers=96]="rulers",oe[oe.scrollbar=97]="scrollbar",oe[oe.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=99]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=100]="scrollPredominantAxis",oe[oe.selectionClipboard=101]="selectionClipboard",oe[oe.selectionHighlight=102]="selectionHighlight",oe[oe.selectOnLineNumbers=103]="selectOnLineNumbers",oe[oe.showFoldingControls=104]="showFoldingControls",oe[oe.showUnused=105]="showUnused",oe[oe.snippetSuggestions=106]="snippetSuggestions",oe[oe.smartSelect=107]="smartSelect",oe[oe.smoothScrolling=108]="smoothScrolling",oe[oe.stickyScroll=109]="stickyScroll",oe[oe.stickyTabStops=110]="stickyTabStops",oe[oe.stopRenderingLineAfter=111]="stopRenderingLineAfter",oe[oe.suggest=112]="suggest",oe[oe.suggestFontSize=113]="suggestFontSize",oe[oe.suggestLineHeight=114]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",oe[oe.suggestSelection=116]="suggestSelection",oe[oe.tabCompletion=117]="tabCompletion",oe[oe.tabIndex=118]="tabIndex",oe[oe.unicodeHighlighting=119]="unicodeHighlighting",oe[oe.unusualLineTerminators=120]="unusualLineTerminators",oe[oe.useShadowDOM=121]="useShadowDOM",oe[oe.useTabStops=122]="useTabStops",oe[oe.wordBreak=123]="wordBreak",oe[oe.wordSeparators=124]="wordSeparators",oe[oe.wordWrap=125]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=128]="wordWrapColumn",oe[oe.wordWrapOverride1=129]="wordWrapOverride1",oe[oe.wordWrapOverride2=130]="wordWrapOverride2",oe[oe.wrappingIndent=131]="wrappingIndent",oe[oe.wrappingStrategy=132]="wrappingStrategy",oe[oe.showDeprecated=133]="showDeprecated",oe[oe.inlayHints=134]="inlayHints",oe[oe.editorClassName=135]="editorClassName",oe[oe.pixelRatio=136]="pixelRatio",oe[oe.tabFocusMode=137]="tabFocusMode",oe[oe.layoutInfo=138]="layoutInfo",oe[oe.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(181,null)})),acceptSuggestionOnEnter:Me(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(182,null),""],markdownDescription:o.localize(183,null)})),accessibilitySupport:Me(new l),accessibilityPageSize:Me(new g(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(184,null),tags:["accessibility"]})),ariaLabel:Me(new w(4,"ariaLabel",o.localize(185,null))),autoClosingBrackets:Me(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(186,null),o.localize(187,null),""],description:o.localize(188,null)})),autoClosingDelete:Me(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(189,null),""],description:o.localize(190,null)})),autoClosingOvertype:Me(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(191,null),""],description:o.localize(192,null)})),autoClosingQuotes:Me(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(193,null),o.localize(194,null),""],description:o.localize(195,null)})),autoIndent:Me(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[o.localize(196,null),o.localize(197,null),o.localize(198,null),o.localize(199,null),o.localize(200,null)],description:o.localize(201,null)})),automaticLayout:Me(new h(10,"automaticLayout",!1)),autoSurround:Me(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(202,null),o.localize(203,null),o.localize(204,null),""],description:o.localize(205,null)})),bracketPairColorization:Me(new he),bracketPairGuides:Me(new we),stickyTabStops:Me(new h(110,"stickyTabStops",!1,{description:o.localize(206,null)})),codeLens:Me(new h(14,"codeLens",!0,{description:o.localize(207,null)})),codeLensFontFamily:Me(new w(15,"codeLensFontFamily","",{description:o.localize(208,null)})),codeLensFontSize:Me(new g(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(209,null)})),colorDecorators:Me(new h(17,"colorDecorators",!0,{description:o.localize(210,null)})),colorDecoratorsLimit:Me(new g(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(211,null)})),columnSelection:Me(new h(19,"columnSelection",!1,{description:o.localize(212,null)})),comments:Me(new c),contextmenu:Me(new h(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new h(22,"copyWithSyntaxHighlighting",!0,{description:o.localize(213,null)})),cursorBlinking:Me(new a(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:o.localize(214,null)})),cursorSmoothCaretAnimation:Me(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(215,null),o.localize(216,null),o.localize(217,null)],description:o.localize(218,null)})),cursorStyle:Me(new a(25,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:o.localize(219,null)})),cursorSurroundingLines:Me(new g(26,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(220,null)})),cursorSurroundingLinesStyle:Me(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(221,null),o.localize(222,null)],description:o.localize(223,null)})),cursorWidth:Me(new g(28,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(224,null)})),disableLayerHinting:Me(new h(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new h(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new h(31,"domReadOnly",!1)),dragAndDrop:Me(new h(32,"dragAndDrop",!0,{description:o.localize(225,null)})),emptySelectionClipboard:Me(new K),dropIntoEditor:Me(new _e),stickyScroll:Me(new ge),experimentalWhitespaceRendering:Me(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(226,null),o.localize(227,null),o.localize(228,null)],description:o.localize(229,null)})),extraEditorClassName:Me(new w(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new p(37,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:o.localize(230,null)})),find:Me(new V),fixedOverflowWidgets:Me(new h(39,"fixedOverflowWidgets",!1)),folding:Me(new h(40,"folding",!0,{description:o.localize(231,null)})),foldingStrategy:Me(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(232,null),o.localize(233,null)],description:o.localize(234,null)})),foldingHighlight:Me(new h(42,"foldingHighlight",!0,{description:o.localize(235,null)})),foldingImportsByDefault:Me(new h(43,"foldingImportsByDefault",!1,{description:o.localize(236,null)})),foldingMaximumRegions:Me(new g(44,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(237,null)})),unfoldOnClickAfterEndOfLine:Me(new h(45,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(238,null)})),fontFamily:Me(new w(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(239,null)})),fontInfo:Me(new N),fontLigatures2:Me(new F),fontSize:Me(new B),fontWeight:Me(new j),fontVariations:Me(new U),formatOnPaste:Me(new h(52,"formatOnPaste",!1,{description:o.localize(240,null)})),formatOnType:Me(new h(53,"formatOnType",!1,{description:o.localize(241,null)})),glyphMargin:Me(new h(54,"glyphMargin",!0,{description:o.localize(242,null)})),gotoLocation:Me(new z),hideCursorInOverviewRuler:Me(new h(56,"hideCursorInOverviewRuler",!1,{description:o.localize(243,null)})),hover:Me(new ne),inDiffEditor:Me(new h(58,"inDiffEditor",!1)),letterSpacing:Me(new p(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>p.clamp(oe,-5,20),{description:o.localize(244,null)})),lightbulb:Me(new ee),lineDecorationsWidth:Me(new G),lineHeight:Me(new le),lineNumbers:Me(new Z),lineNumbersMinChars:Me(new g(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new h(66,"linkedEditing",!1,{description:o.localize(245,null)})),links:Me(new h(67,"links",!0,{description:o.localize(246,null)})),matchBrackets:Me(new s(68,"matchBrackets","always",["always","near","never"],{description:o.localize(247,null)})),minimap:Me(new be),mouseStyle:Me(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new p(71,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:o.localize(248,null)})),mouseWheelZoom:Me(new h(72,"mouseWheelZoom",!1,{markdownDescription:o.localize(249,null)})),multiCursorMergeOverlapping:Me(new h(73,"multiCursorMergeOverlapping",!0,{description:o.localize(250,null)})),multiCursorModifier:Me(new a(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[o.localize(251,null),o.localize(252,null)],markdownDescription:o.localize(253,null)})),multiCursorPaste:Me(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(254,null),o.localize(255,null)],markdownDescription:o.localize(256,null)})),multiCursorLimit:Me(new g(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(257,null)})),occurrencesHighlight:Me(new h(77,"occurrencesHighlight",!0,{description:o.localize(258,null)})),overviewRulerBorder:Me(new h(78,"overviewRulerBorder",!0,{description:o.localize(259,null)})),overviewRulerLanes:Me(new g(79,"overviewRulerLanes",3,0,3)),padding:Me(new Pe),parameterHints:Me(new Ne),peekWidgetDefaultFocus:Me(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(260,null),o.localize(261,null)],description:o.localize(262,null)})),definitionLinkOpensInPeek:Me(new h(83,"definitionLinkOpensInPeek",!1,{description:o.localize(263,null)})),quickSuggestions:Me(new ue),quickSuggestionsDelay:Me(new g(85,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(264,null)})),readOnly:Me(new h(86,"readOnly",!1)),renameOnType:Me(new h(87,"renameOnType",!1,{description:o.localize(265,null),markdownDeprecationMessage:o.localize(266,null)})),renderControlCharacters:Me(new h(88,"renderControlCharacters",!0,{description:o.localize(267,null),restricted:!0})),renderFinalNewline:Me(new s(89,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(268,null)})),renderLineHighlight:Me(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(269,null)],description:o.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Me(new h(91,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(271,null)})),renderValidationDecorations:Me(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(272,null),o.localize(273,null),o.localize(274,null),""],description:o.localize(275,null)})),revealHorizontalRightPadding:Me(new g(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new h(95,"roundedSelection",!0,{description:o.localize(276,null)})),rulers:Me(new ie),scrollbar:Me(new W),scrollBeyondLastColumn:Me(new g(98,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(277,null)})),scrollBeyondLastLine:Me(new h(99,"scrollBeyondLastLine",!0,{description:o.localize(278,null)})),scrollPredominantAxis:Me(new h(100,"scrollPredominantAxis",!0,{description:o.localize(279,null)})),selectionClipboard:Me(new h(101,"selectionClipboard",!0,{description:o.localize(280,null),included:t.isLinux})),selectionHighlight:Me(new h(102,"selectionHighlight",!0,{description:o.localize(281,null)})),selectOnLineNumbers:Me(new h(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(282,null),o.localize(283,null),o.localize(284,null)],description:o.localize(285,null)})),showUnused:Me(new h(105,"showUnused",!0,{description:o.localize(286,null)})),showDeprecated:Me(new h(133,"showDeprecated",!0,{description:o.localize(287,null)})),inlayHints:Me(new q),snippetSuggestions:Me(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(288,null),o.localize(289,null),o.localize(290,null),o.localize(291,null)],description:o.localize(292,null)})),smartSelect:Me(new De),smoothScrolling:Me(new h(108,"smoothScrolling",!1,{description:o.localize(293,null)})),stopRenderingLineAfter:Me(new g(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new pe),inlineSuggest:Me(new Q),suggestFontSize:Me(new g(113,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new g(114,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new h(115,"suggestOnTriggerCharacters",!0,{description:o.localize(296,null)})),suggestSelection:Me(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(297,null),o.localize(298,null),o.localize(299,null)],description:o.localize(300,null)})),tabCompletion:Me(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(301,null),o.localize(302,null),o.localize(303,null)],description:o.localize(304,null)})),tabIndex:Me(new g(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new X),unusualLineTerminators:Me(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(305,null),o.localize(306,null),o.localize(307,null)],description:o.localize(308,null)})),useShadowDOM:Me(new h(121,"useShadowDOM",!0)),useTabStops:Me(new h(122,"useTabStops",!0,{description:o.localize(309,null)})),wordBreak:Me(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(310,null),o.localize(311,null)],description:o.localize(312,null)})),wordSeparators:Me(new w(124,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:o.localize(313,null)})),wordWrap:Me(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(314,null),o.localize(315,null),o.localize(316,null),o.localize(317,null)],description:o.localize(318,null)})),wordWrapBreakAfterCharacters:Me(new w(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new w(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new g(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(319,null)})),wordWrapOverride1:Me(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new M),pixelRatio:Me(new se),tabFocusMode:Me(new ke),layoutInfo:Me(new Y),wrappingInfo:Me(new et),wrappingIndent:Me(new Ge),wrappingStrategy:Me(new J)}}),define(ye[168],Ce([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[169],Ce([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[170],Ce([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[171],Ce([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[172],Ce([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ye[173],Ce([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ye[174],Ce([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ye[175],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[176],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[177],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[178],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[179],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[180],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[181],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[182],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[183],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[184],Ce([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ye[185],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[186],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[187],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[188],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[189],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[190],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[191],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[192],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[193],Ce([1,0,10]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,I){this.a.set(R,I)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const I in R.contributes){const A=this.a.get(I);if(!A)continue;const y=R.contributes[I],D=Array.isArray(y)?y:[y];try{A(D,R.activationEvents)}catch(L){(0,o.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ye[194],Ce([1,0,24,37,170,312]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(h){return h=h.trim(),h==="*"||I.test(h)}e.isValidVersionStr=y;function D(h){if(!y(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=h.match(I);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=D;function L(h){if(!h)return null;const b=h.majorBase,g=h.majorMustEqual,p=h.minorBase;let w=h.minorMustEqual;const i=h.patchBase;let s=h.patchMustEqual;h.hasCaret&&(b===0||(w=!1),s=!1);let a=0;if(h.preRelease){const u=A.exec(h.preRelease);if(u){const[,l,c,n]=u;a=Date.UTC(Number(l),Number(c)-1,Number(n))}}return{majorBase:b,majorMustEqual:g,minorBase:p,minorMustEqual:w,patchBase:i,patchMustEqual:s,isMinimum:h.hasGreaterEquals,notBefore:a}}e.normalizeVersion=L;function P(h,b,g){let p;typeof h=="string"?p=L(D(h)):p=h;let w;b instanceof Date?w=b.getTime():typeof b=="string"&&(w=new Date(b).getTime());let i;if(typeof g=="string"?i=L(D(g)):i=g,!p||!i)return!1;const s=p.majorBase,a=p.minorBase,u=p.patchBase;let l=i.majorBase,c=i.minorBase,n=i.patchBase;const r=i.notBefore;let f=i.majorMustEqual,E=i.minorMustEqual,T=i.patchMustEqual;return i.isMinimum?s>l?!0:s<l?!1:a>c?!0:a<c||w&&w<r?!1:u>=n:(s===1&&l===0&&(!f||!E||!T)&&(l=1,c=0,n=0,f=!0,E=!1,T=!1),s<l?!1:s>l?!f:a<c?!1:a>c?!E:u<n?!1:u>n?!T:!(w&&w<r))}e.isValidVersion=P;function v(h,b,g,p,w){const i=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof p.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof p.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!p.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof p.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof p.extensionDependencies<"u"&&!d(p.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof p.activationEvents<"u"){if(!d(p.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof p.main>"u"&&typeof p.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const u=(0,o.joinPath)(g,p.main);(0,o.isEqualOrParent)(u,g)||i.push([t.default.Warning,k.localize(10,null,u.path,g.path)])}if(typeof p.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof p.browser<"u"){if(typeof p.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const u=(0,o.joinPath)(g,p.browser);(0,o.isEqualOrParent)(u,g)||i.push([t.default.Warning,k.localize(13,null,u.path,g.path)])}if(typeof p.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(p.version))return i.push([t.default.Error,k.localize(15,null)]),i;const s=[];if(!C(h,b,p,w,s))for(const u of s)i.push([t.default.Error,u]);return i}e.validateExtensionManifest=v;function C(h,b,g,p,w){return p||typeof g.main>"u"&&typeof g.browser>"u"?!0:m(h,b,g.engines.vscode,w)}e.isValidExtensionVersion=C;function S(h,b,g){return h==="*"||m(b,g,h)}e.isEngineValid=S;function m(h,b,g,p=[]){const w=L(D(g));if(!w)return p.push(k.localize(16,null,g)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return p.push(k.localize(17,null,g)),!1}else if(!w.majorMustEqual)return p.push(k.localize(18,null,g)),!1;return P(h,b,w)?!0:(p.push(k.localize(19,null,h,g)),!1)}function d(h){if(!Array.isArray(h))return!1;for(let b=0,g=h.length;b<g;b++)if(typeof h[b]!="string")return!1;return!0}}),define(ye[121],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(k,R=[],I=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=o}),define(ye[88],Ce([1,0,121]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(A,y,D){y instanceof o.SyncDescriptor||(y=new o.SyncDescriptor(y,[],Boolean(D))),t.push([A,y])}e.registerSingleton=R;function I(){return t}e.getSingletonServiceDescriptors=I}),define(ye[195],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(R,I){this.key=R,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=o;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const I of this.a.values())I.outgoing.size===0&&R.push(I);return R}insertEdge(R,I){const A=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(I);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(R){const I=this.b(R);this.a.delete(I);for(const A of this.a.values())A.outgoing.delete(I),A.incoming.delete(I)}lookupOrInsertNode(R){const I=this.b(R);let A=this.a.get(I);return A||(A=new o(I,R),this.a.set(I,A)),A}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[I,A]of this.a)R.push(`${I}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,I]of this.a){const A=new Set([R]),y=this.c(I,A);if(y)return y}}c(R,I){for(const[A,y]of R.outgoing){if(I.has(A))return[...I,A].join(" -> ");I.add(A);const D=this.c(y,I);if(D)return D;I.delete(A)}}}e.Graph=t}),define(ye[4],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=A})(o=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(I,A,y){A[o.DI_TARGET]===A?A[o.DI_DEPENDENCIES].push({id:I,index:y}):(A[o.DI_DEPENDENCIES]=[{id:I,index:y}],A[o.DI_TARGET]=A)}function k(I){if(o.serviceIds.has(I))return o.serviceIds.get(I);const A=function(y,D,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,y,L)};return A.toString=()=>I,o.serviceIds.set(I,A),A}e.createDecorator=k;function R(I){return I}e.refineServiceDecorator=R}),define(ye[52],Ce([1,0,11,2,4]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=R;function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=I;var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function D(h,b){const g=Object.create(null);for(const p in h)L(g,p,h[p],b);return g}e.toValuesTree=D;function L(h,b,g,p){const w=b.split("."),i=w.pop();let s=h;for(let a=0;a<w.length;a++){const u=w[a];let l=s[u];switch(typeof l){case"undefined":l=s[u]=Object.create(null);break;case"object":break;default:p(`Ignoring ${b} as ${w.slice(0,a+1).join(".")} is ${JSON.stringify(l)}`);return}s=l}if(typeof s=="object"&&s!==null)try{s[i]=g}catch{p(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(s)}`)}else p(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=L;function P(h,b){const g=b.split(".");v(h,g)}e.removeFromValueTree=P;function v(h,b){const g=b.shift();if(b.length===0){delete h[g];return}if(Object.keys(h).indexOf(g)!==-1){const p=h[g];typeof p=="object"&&!Array.isArray(p)&&(v(p,b),Object.keys(p).length===0&&delete h[g])}}function C(h,b,g){function p(s,a){let u=s;for(const l of a){if(typeof u!="object"||u===null)return;u=u[l]}return u}const w=b.split("."),i=p(h,w);return typeof i>"u"?g:i}e.getConfigurationValue=C;function S(h,b,g){Object.keys(b).forEach(p=>{p!=="__proto__"&&(p in h?o.isObject(h[p])&&o.isObject(b[p])?S(h[p],b[p],g):g&&(h[p]=b[p]):h[p]=b[p])})}e.merge=S;function m(h,b,g){const p=h.inspect(b),w=h.inspect(g);return typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:p.defaultValue}e.getMigratedSettingValue=m;function d(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(ye[53],Ce([1,0,12,8,4]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",o.isMacintosh),R.set("isLinux",o.isLinux),R.set("isWindows",o.isWindows),R.set("isWeb",o.isWeb),R.set("isMacNative",o.isMacintosh&&!o.isWeb),R.set("isEdge",o.isEdge),R.set("isFirefox",o.isFirefox),R.set("isChrome",o.isChrome),R.set("isSafari",o.isSafari);const I=Object.prototype.hasOwnProperty;var A;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return P.INSTANCE}static true(){return v.INSTANCE}static has(F){return C.create(F)}static equals(F,U){return S.create(F,U)}static notEquals(F,U){return h.create(F,U)}static regex(F,U){return a.create(F,U)}static in(F,U){return m.create(F,U)}static notIn(F,U){return d.create(F,U)}static not(F){return b.create(F)}static and(...F){return c.create(F,null,!0)}static or(...F){return n.create(F,null,!0)}static greater(F,U){return p.create(F,U)}static greaterEquals(F,U){return w.create(F,U)}static smaller(F,U){return i.create(F,U)}static smallerEquals(F,U){return s.create(F,U)}static deserialize(F,U=!1){if(!!F)return this.c(F,U)}static c(F,U){const N=F.split("||");return n.create(N.map(B=>this.d(B,U)),null,!0)}static d(F,U){const N=F.split("&&");return c.create(N.map(B=>this.f(B,U)),null,!0)}static f(F,U){if(F=F.trim(),F.indexOf("!=")>=0){const N=F.split("!=");return h.create(N[0].trim(),this.g(N[1],U))}if(F.indexOf("==")>=0){const N=F.split("==");return S.create(N[0].trim(),this.g(N[1],U))}if(F.indexOf("=~")>=0){const N=F.split("=~");return a.create(N[0].trim(),this.h(N[1],U))}if(F.indexOf(" not in ")>=0){const N=F.split(" not in ");return d.create(N[0].trim(),this.g(N[1],U))}if(F.indexOf(" in ")>=0){const N=F.split(" in ");return m.create(N[0].trim(),this.g(N[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const N=F.split(">=");return w.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const N=F.split(">");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const N=F.split("<=");return s.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const N=F.split("<");return i.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(F)?b.create(F.substr(1).trim()):C.create(F)}static g(F,U){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const N=/^'([^']*)'$/.exec(F);return N?N[1].trim():F}static h(F,U){if((0,t.isFalsyOrWhitespace)(F)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const N=F.indexOf("/"),B=F.lastIndexOf("/");if(N===B||N<0){if(U)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const j=F.slice(N+1,B),z=F[B+1]==="i"?"i":"";try{return new RegExp(j,z)}catch(ne){if(U)throw new Error(`bad regexp-value '${F}', parse error: ${ne}`);return console.warn(`bad regexp-value '${F}', parse error: ${ne}`),null}}}e.ContextKeyExpr=y;function D(V,F){const U=V?V.substituteConstants():void 0,N=F?F.substituteConstants():void 0;return!U&&!N?!0:!U||!N?!1:U.equals(N)}e.expressionsAreEqualWithConstantSubstitution=D;function L(V,F){return V.cmp(F)}class P{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class v{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class C{static create(F,U=null){const N=R.get(F);return typeof N=="boolean"?N?v.INSTANCE:P.INSTANCE:new C(F,U)}constructor(F,U){this.key=F,this.c=U,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:f(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=R.get(this.key);return typeof F=="boolean"?F?v.INSTANCE:P.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=b.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=C;class S{static create(F,U,N=null){if(typeof U=="boolean")return U?C.create(F,N):b.create(F,N);const B=R.get(F);return typeof B=="boolean"?U===(B?"true":"false")?v.INSTANCE:P.INSTANCE:new S(F,U,N)}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const U=F?"true":"false";return this.d===U?v.INSTANCE:P.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=S;class m{static create(F,U){return new m(F,U)}constructor(F,U){this.d=F,this.f=U,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:E(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const U=F.getValue(this.f),N=F.getValue(this.d);return Array.isArray(U)?U.includes(N):typeof N=="string"&&typeof U=="object"&&U!==null?I.call(U,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class d{static create(F,U){return new d(F,U)}constructor(F,U){this.d=F,this.f=U,this.type=11,this.c=m.create(F,U)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=d;class h{static create(F,U,N=null){if(typeof U=="boolean")return U?b.create(F,N):C.create(F,N);const B=R.get(F);return typeof B=="boolean"?U===(B?"true":"false")?P.INSTANCE:v.INSTANCE:new h(F,U,N)}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const U=F?"true":"false";return this.d===U?P.INSTANCE:v.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class b{static create(F,U=null){const N=R.get(F);return typeof N=="boolean"?N?P.INSTANCE:v.INSTANCE:new b(F,U)}constructor(F,U){this.c=F,this.d=U,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:f(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=R.get(this.c);return typeof F=="boolean"?F?P.INSTANCE:v.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=C.create(this.c,this)),this.d}}e.ContextKeyNotExpr=b;function g(V,F){if(typeof V=="string"){const U=parseFloat(V);isNaN(U)||(V=U)}return typeof V=="string"||typeof V=="number"?F(V):P.INSTANCE}class p{static create(F,U,N=null){return g(U,B=>new p(F,B,N))}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=p;class w{static create(F,U,N=null){return g(U,B=>new w(F,B,N))}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class i{static create(F,U,N=null){return g(U,B=>new i(F,B,N))}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class s{static create(F,U,N=null){return g(U,B=>new s(F,B,N))}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class a{static create(F,U){return new a(F,U)}constructor(F,U){this.d=F,this.f=U,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const U=this.f?this.f.source:"",N=F.f?F.f.source:"";return U<N?-1:U>N?1:0}equals(F){if(F.type===this.type){const U=this.f?this.f.source:"",N=F.f?F.f.source:"";return this.d===F.d&&U===N}return!1}substituteConstants(){return this}evaluate(F){const U=F.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=a;class u{static create(F){return new u(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new u(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function l(V){let F=null;for(let U=0,N=V.length;U<N;U++){const B=V[U].substituteConstants();if(V[U]!==B&&F===null){F=[];for(let j=0;j<U;j++)F[j]=V[j]}F!==null&&(F[U]=B)}return F===null?V:F}class c{static create(F,U,N){return c.d(F,U,N)}constructor(F,U){this.expr=F,this.c=U,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const B=L(this.expr[U],F.expr[U]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(F.expr[U]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:c.create(F,this.c,!1)}evaluate(F){for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].evaluate(F))return!1;return!0}static d(F,U,N){const B=[];let j=!1;for(const z of F)if(!!z){if(z.type===1){j=!0;continue}if(z.type===0)return P.INSTANCE;if(z.type===6){B.push(...z.expr);continue}B.push(z)}if(B.length===0&&j)return v.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(L);for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];for(;B.length>1;){const z=B[B.length-1];if(z.type!==9)break;B.pop();const ne=B.pop(),_=B.length===0,Y=n.create(z.expr.map(J=>c.create([J,ne],null,N)),null,_);Y&&(B.push(Y),B.sort(L))}if(B.length===1)return B[0];if(N){for(let z=0;z<B.length;z++)for(let ne=z+1;ne<B.length;ne++)if(B[z].negate().equals(B[ne]))return P.INSTANCE;if(B.length===1)return B[0]}return new c(B,U)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const U of this.expr)F.push(...U.keys());return F}map(F){return new c(this.expr.map(U=>U.map(F)),null)}negate(){if(!this.c){const F=[];for(const U of this.expr)F.push(U.negate());this.c=n.create(F,this,!0)}return this.c}}class n{static create(F,U,N){return n.d(F,U,N)}constructor(F,U){this.expr=F,this.c=U,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const B=L(this.expr[U],F.expr[U]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(F.expr[U]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:n.create(F,this.c,!1)}evaluate(F){for(let U=0,N=this.expr.length;U<N;U++)if(this.expr[U].evaluate(F))return!0;return!1}static d(F,U,N){let B=[],j=!1;if(F){for(let z=0,ne=F.length;z<ne;z++){const _=F[z];if(!!_){if(_.type===0){j=!0;continue}if(_.type===1)return v.INSTANCE;if(_.type===9){B=B.concat(_.expr);continue}B.push(_)}}if(B.length===0&&j)return P.INSTANCE;B.sort(L)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(N){for(let z=0;z<B.length;z++)for(let ne=z+1;ne<B.length;ne++)if(B[z].negate().equals(B[ne]))return v.INSTANCE;if(B.length===1)return B[0]}return new n(B,U)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const U of this.expr)F.push(...U.keys());return F}map(F){return new n(this.expr.map(U=>U.map(F)),null)}negate(){if(!this.c){const F=[];for(const U of this.expr)F.push(U.negate());for(;F.length>1;){const U=F.shift(),N=F.shift(),B=[];for(const j of K(U))for(const z of K(N))B.push(c.create([j,z],null,!1));F.unshift(n.create(B,null,!1))}this.c=n.create(F,this,!0)}return this.c}}class r extends C{static all(){return r.d.values()}constructor(F,U,N){super(F,null),this.f=U,typeof N=="object"?r.d.push({...N,key:F}):N!==!0&&r.d.push({key:F,description:N,type:U!=null?typeof U:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return S.create(this.key,F)}notEqualsTo(F){return h.create(this.key,F)}}e.RawContextKey=r,r.d=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function f(V,F){return V<F?-1:V>F?1:0}function E(V,F,U,N){return V<U?-1:V>U?1:F<N?-1:F>N?1:0}function T(V,F){if(V.type===0||F.type===1)return!0;if(V.type===9)return F.type===9?M(V.expr,F.expr):!1;if(F.type===9){for(const U of F.expr)if(T(V,U))return!0;return!1}if(V.type===6){if(F.type===6)return M(F.expr,V.expr);for(const U of V.expr)if(T(U,F))return!0;return!1}return V.equals(F)}e.implies=T;function M(V,F){let U=0,N=0;for(;U<V.length&&N<F.length;){const B=V[U].cmp(F[N]);if(B<0)return!1;B===0&&U++,N++}return U===V.length}function K(V){return V.type===9?V.expr:[V]}}),define(ye[196],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[122],Ce([1,0,169,4]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function I(h,b){switch(h){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function A(h,b){return b==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(h,b,g){return A(b,g)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===g?!0:D(g).includes(h)}e.isTargetPlatformCompatible=y;function D(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function L(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=L;var P;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var C;(function(h){h.Install="install",h.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var S;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var m;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(b,g){super(b),this.code=g,this.name=g}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,o.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[197],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,o.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,o.createDecorator)("externalTerminal")}),define(ye[198],Ce([1,0,46,15,9,12,107,29,115,171,197]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=D.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:C.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class C extends v{openTerminal(p,w){return this.spawnTerminal(o,p,y.getWindowsShell(),w)}spawnTerminal(p,w,i,s){const a=w.windowsExec||C.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const u=k.basename(a).toLowerCase();if(u==="cmder"||u==="cmder.exe")return p.spawn(a,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return a.indexOf(" ")>=0&&l.push('""'),l.push(a),(u==="wt"||u==="wt.exe")&&l.push("-d ."),new Promise((c,n)=>{const r=d(process),f=p.spawn(i,l,{cwd:s,env:r});f.on("error",n),f.on("exit",()=>c())})}runInTerminal(p,w,i,s,a){const u="windowsExec"in a&&a.windowsExec?a.windowsExec:C.getDefaultTerminalWindows();return new Promise((l,c)=>{const n=`"${w} - ${P}"`,r=`""${i.join('" "')}" & pause"`,f=["/c","start",n,"/wait",u,"/c",r],E=Object.assign({},d(process),s);Object.keys(E).filter(K=>E[K]===null).forEach(K=>delete E[K]);const T={cwd:w,env:E,windowsVerbatimArguments:!0};o.spawn(C.b,f,T).on("error",K=>{c(h(K))}),l(void 0)})}static getDefaultTerminalWindows(){if(!C.d){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");C.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return C.d}}e.WindowsExternalTerminalService=C,C.b="cmd.exe";class S extends v{openTerminal(p,w){return this.spawnTerminal(o,p,w)}runInTerminal(p,w,i,s,a){const u=a.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((l,c)=>{if(u===L.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const n=u===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",p||P,"-w",w];for(const M of i)f.push("-a"),f.push(M);if(s){const M=Object.assign({},d(process),s);for(const K in M){const V=M[K];V===null?(f.push("-u"),f.push(K)):(f.push("-e"),f.push(`${K}=${V}`))}}let E="";const T=o.spawn(S.b,f);T.on("error",M=>{c(h(M))}),T.stderr.on("data",M=>{E+=M.toString()}),T.on("exit",M=>{if(M===0)l(void 0);else if(E){const K=E.split(`
`,1);c(new Error(K[0]))}else c(new Error(D.localize(1,null,n,M)))})}else c(new Error(D.localize(2,null,u)))})}spawnTerminal(p,w,i){const s=w.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((a,u)=>{const l=["-a",s];i&&l.push(i);const c=d(process),n=p.spawn("/usr/bin/open",l,{cwd:i,env:c});n.on("error",u),n.on("exit",()=>a())})}}e.MacExternalTerminalService=S,S.b="/usr/bin/osascript";class m extends v{openTerminal(p,w){return this.spawnTerminal(o,p,w)}runInTerminal(p,w,i,s,a){const u=a.linuxExec?Promise.resolve(a.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,c)=>{const n=[];u.then(r=>{r.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const f=`${b(i)}; echo; read -p "${m.b}" -n1;`;n.push(`''${f}''`);const E=Object.assign({},d(process),s);Object.keys(E).filter(V=>E[V]===null).forEach(V=>delete E[V]);const T={cwd:w,env:E};let M="";const K=o.spawn(r,n,T);K.on("error",V=>{c(h(V))}),K.stderr.on("data",V=>{M+=V.toString()}),K.on("exit",V=>{if(V===0)l(void 0);else if(M){const F=M.split(`
`,1);c(new Error(F[0]))}else c(new Error(D.localize(4,null,r,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.isLinux)m.d=Promise.resolve("xterm");else{const p=await A.Promises.exists("/etc/debian_version");m.d=new Promise(w=>{p?w("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?w("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?w("konsole"):process.env.COLORTERM?w(process.env.COLORTERM):process.env.TERM?w(process.env.TERM):w("xterm")})}return m.d}spawnTerminal(p,w,i){const s=w.linuxExec?Promise.resolve(w.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((a,u)=>{s.then(l=>{const c=d(process),n=p.spawn(l,[],{cwd:i,env:c});n.on("error",u),n.on("exit",()=>a())})})}}e.LinuxExternalTerminalService=m,m.b=D.localize(3,null);function d(g){const p={...g.env};return(0,I.sanitizeProcessEnvironment)(p),p}function h(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(D.localize(5,null,g.path)):g}function b(g){let p="";for(const w of g)w.indexOf(" ")>=0?p+='"'+w+'"':p+=w,p+=" ";return p}}),define(ye[39],Ce([1,0,64,9,8,11,2,172,4]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function D(z){return z.create===!0}e.isFileOpenForWriteOptions=D;var L;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var P;(function(z){z[z.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var v;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=C;function S(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=S;function m(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=m;function d(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function h(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=h;function b(z){return C(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var g;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(ne,_){super(ne),this.code=_}}e.FileSystemProviderError=p;function w(z,ne){const _=new p(z.toString(),ne);return s(_,ne),_}e.createFileSystemProviderError=w;function i(z){return z||w((0,A.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=i;function s(z,ne){return z.name=ne?`${ne} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=s;function a(z){if(!z)return g.Unknown;if(z instanceof p)return z.code;const ne=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!ne)return g.Unknown;switch(ne[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=a;function u(z){if(z instanceof E)return z.fileOperationResult;switch(a(z)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var l;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class c{constructor(ne,_,Y){this.resource=ne,this.operation=_,this.target=Y}isOperation(ne){return this.operation===ne}}e.FileOperationEvent=c;var n;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class r{constructor(ne,_){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Y=new Map;for(const J of ne){const ee=Y.get(J.type);switch(ee?ee.push([J.resource,J]):Y.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,ee]of Y)switch(J){case 1:this.a=o.TernarySearchTree.forUris(()=>_),this.a.fill(ee);break;case 0:this.b=o.TernarySearchTree.forUris(()=>_),this.b.fill(ee);break;case 2:this.c=o.TernarySearchTree.forUris(()=>_),this.c.fill(ee);break}}contains(ne,..._){return this.d(ne,{includeChildren:!1},..._)}affects(ne,..._){return this.d(ne,{includeChildren:!0},..._)}d(ne,_,...Y){if(!ne)return!1;const J=Y.length>0;return!!((!J||Y.includes(1))&&(this.a?.get(ne)||_.includeChildren&&this.a?.findSuperstr(ne))||(!J||Y.includes(0))&&(this.b?.get(ne)||_.includeChildren&&this.b?.findSuperstr(ne))||(!J||Y.includes(2))&&(this.c?.findSubstr(ne)||_.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=r;function f(z,ne,_){return!z||!ne||z===ne||ne.length>z.length?!1:(ne.charAt(ne.length-1)!==t.sep&&(ne+=t.sep),_?(0,k.startsWithIgnoreCase)(z,ne):z.indexOf(ne)===0)}e.isParent=f;class E extends Error{constructor(ne,_,Y){super(ne),this.fileOperationResult=_,this.options=Y}}e.FileOperationError=E;class T extends E{constructor(ne,_,Y,J){super(ne,_,J),this.fileOperationResult=_,this.size=Y}}e.TooLargeFileOperationError=T;class M extends E{constructor(ne,_,Y){super(ne,2,Y),this.stat=_}}e.NotModifiedSinceFileOperationError=M;var K;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(K=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=F;async function U(z,ne){if(!ne.hasProvider(I.URI.from({scheme:z.scheme})))return new Promise(_=>{const Y=ne.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===z.scheme&&J.added&&(Y.dispose(),_())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(ne){return(0,R.isNumber)(ne)||(ne=0),ne<N.KB?(0,A.localize)(1,null,ne.toFixed(0)):ne<N.MB?(0,A.localize)(2,null,(ne/N.KB).toFixed(2)):ne<N.GB?(0,A.localize)(3,null,(ne/N.MB).toFixed(2)):ne<N.TB?(0,A.localize)(4,null,(ne/N.GB).toFixed(2)):(0,A.localize)(5,null,(ne/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var B;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function j(z){return{maxFileSize:z===0?300*N.MB:16*N.GB,maxHeapSize:z===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=j}),define(ye[89],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...k){this.a=new Map;for(const[R,I]of k)this.set(R,I)}set(k,R){const I=this.a.get(k);return this.a.set(k,R),I}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=o}),define(ye[199],Ce([1,0,16,10,6,121,195,4,89,63]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class P extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new y.ServiceCollection,h=!1,b,g=L){this.f=d,this.g=h,this.h=b,this.i=g,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=g?b?._globalGraph??new I.Graph(p=>p):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...h){const b=S.traceInvocation(this.i,d);let g=!1;try{return d({get:w=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(w,b);if(!i)throw new Error(`[invokeFunction] unknown service '${w}'`);return i}},...h)}finally{g=!0,b.stop()}}createInstance(d,...h){let b,g;return d instanceof R.SyncDescriptor?(b=S.traceCreation(this.i,d.ctor),g=this.j(d.ctor,d.staticArguments.concat(h),b)):(b=S.traceCreation(this.i,d),g=this.j(d,h,b)),b.stop(),g}j(d,h=[],b){const g=A._util.getServiceDependencies(d).sort((i,s)=>i.index-s.index),p=[];for(const i of g){const s=this.m(i.id,b);s||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${i.id}.`,!1),p.push(s)}const w=g.length>0?g[0].index:h.length;if(h.length!==w){console.trace(`[createInstance] First service dependency of ${d.name} at position ${w+1} conflicts with ${h.length} static arguments`);const i=w-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,w)}return Reflect.construct(d,h.concat(p))}k(d,h){if(this.f.get(d)instanceof R.SyncDescriptor)this.f.set(d,h);else if(this.h)this.h.k(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const h=this.f.get(d);return!h&&this.h?this.h.l(d):h}m(d,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const b=this.l(d);return b instanceof R.SyncDescriptor?this.q(d,b,h.branch(d,!0)):(h.branch(d,!1),b)}q(d,h,b){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,h,b)}finally{this.o.delete(d)}}r(d,h,b){const g=new I.Graph(i=>i.id.toString());let p=0;const w=[{id:d,desc:h,_trace:b}];for(;w.length;){const i=w.pop();if(g.lookupOrInsertNode(i),p++>1e3)throw new P(g);for(const s of A._util.getServiceDependencies(i.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),a instanceof R.SyncDescriptor){const u={id:s.id,desc:a,_trace:i._trace.branch(s.id,!0)};g.insertEdge(i,u),w.push(u)}}}for(;;){const i=g.roots();if(i.length===0){if(!g.isEmpty())throw new P(g);break}for(const{data:s}of i){if(this.l(s.id)instanceof R.SyncDescriptor){const u=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,u)}g.removeNode(s)}}return this.l(d)}s(d,h,b=[],g,p){if(this.f.get(d)instanceof R.SyncDescriptor)return this.t(d,h,b,g,p);if(this.h)return this.h.s(d,h,b,g,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(d,h,b=[],g,p){if(g){const w=new v(void 0,this.g,this,this.i);w.c=String(d);const i=new Map,s=new o.IdleValue(()=>{const a=w.j(h,b,p);for(const[u,l]of i){const c=a[u];if(typeof c=="function")for(const n of l)c.apply(a,n)}return i.clear(),a});return new Proxy(Object.create(null),{get(a,u){if(!s.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let n=i.get(u);return n||(n=new D.LinkedList,i.set(u,n)),(f,E,T)=>{const M=n.push([f,E,T]);return(0,k.toDisposable)(M)}}if(u in a)return a[u];const l=s.value;let c=l[u];return typeof c!="function"||(c=c.bind(l),a[u]=c),c},set(a,u,l){return s.value[u]=l,!0},getPrototypeOf(a){return h.prototype}})}else return this.j(h,b,p)}u(d,h){if(h&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=v;var C;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(C||(C={}));class S{static traceInvocation(d,h){return d?new S(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(d,h){return d?new S(1,h.name):S.c}constructor(d,h){this.type=d,this.name=h,this.g=Date.now(),this.h=[]}branch(d,h){const b=new S(3,d.toString());return this.h.push([d,h,b]),b}stop(){const d=Date.now()-this.g;S.f+=d;let h=!1;function b(p,w){const i=[],s=new Array(p+1).join("	");for(const[a,u,l]of w.h)if(u&&l){h=!0,i.push(`${s}CREATES -> ${a}`);const c=b(p+1,l);c&&i.push(c)}else i.push(`${s}uses -> ${a}`);return i.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(d>2||h)&&S.all.add(g.join(`
`))}}e.Trace=S,S.all=new Set,S.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}},S.f=0}),define(ye[13],Ce([1,0,45,3,6,28,12,2,4]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function D(){return new Date().toISOString()}var L;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(L=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=L.Info;function P(c,n,r){switch(n){case L.Trace:c.trace(r);break;case L.Debug:c.debug(r);break;case L.Info:c.info(r);break;case L.Warning:c.warn(r);break;case L.Error:c.error(r);break;case L.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=P;function v(c){let n="";for(let r=0;r<c.length;r++){let f=c[r];if(typeof f=="object")try{f=JSON.stringify(f)}catch{}n+=(r>0?" ":"")+f}return n}e.format=v;class C extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==L.Off&&this.b<=n}}e.AbstractLogger=C;class S extends C{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...r){this.f(L.Trace)&&this.g(L.Trace,v([n,...r]))}debug(n,...r){this.f(L.Debug)&&this.g(L.Debug,v([n,...r]))}info(n,...r){this.f(L.Info)&&this.g(L.Info,v([n,...r]))}warn(n,...r){this.f(L.Warning)&&this.g(L.Warning,v([n,...r]))}error(n,...r){if(this.f(L.Error))if(n instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=n.stack,this.g(L.Error,v(f))}else this.g(L.Error,v([n,...r]))}flush(){}}e.AbstractMessageLogger=S;class m extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!I.isWindows}trace(n,...r){this.f(L.Trace)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.log(`[main ${D()}]`,n,...r))}debug(n,...r){this.f(L.Debug)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.log(`[main ${D()}]`,n,...r))}info(n,...r){this.f(L.Info)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.log(`[main ${D()}]`,n,...r))}warn(n,...r){this.f(L.Warning)&&(this.g?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,n,...r):console.warn(`[main ${D()}]`,n,...r))}error(n,...r){this.f(L.Error)&&(this.g?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,n,...r):console.error(`[main ${D()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class d extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.f(L.Trace)&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.f(L.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.f(L.Info)&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.f(L.Warning)&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.f(L.Error)&&console.log("%c  ERR","color: #f33",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends C{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(r)}trace(n,...r){this.f(L.Trace)&&this.g.log(L.Trace,[this.h(n),...r])}debug(n,...r){this.f(L.Debug)&&this.g.log(L.Debug,[this.h(n),...r])}info(n,...r){this.f(L.Info)&&this.g.log(L.Info,[this.h(n),...r])}warn(n,...r){this.f(L.Warning)&&this.g.log(L.Warning,[this.h(n),...r])}error(n,...r){this.f(L.Error)&&this.g.log(L.Error,[this.h(n),...r])}h(n){return typeof n=="string"?n:(0,o.toErrorMessage)(n,this.f(L.Trace))}dispose(){}flush(){}}e.AdapterLogger=h;class b extends C{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.g)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const f of this.g)f.trace(n,...r)}debug(n,...r){for(const f of this.g)f.debug(n,...r)}info(n,...r){for(const f of this.g)f.info(n,...r)}warn(n,...r){for(const f of this.g)f.warn(n,...r)}error(n,...r){for(const f of this.g)f.error(n,...r)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=b;class g extends k.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...r){this.b.trace(n,...r)}debug(n,...r){this.b.debug(n,...r)}info(n,...r){this.b.info(n,...r)}warn(n,...r){this.b.warn(n,...r)}error(n,...r){this.b.error(n,...r)}flush(){this.b.flush()}}e.LogService=g;class p extends k.Disposable{constructor(n,r){super(),this.c=n,this.b=new R.ResourceMap,this.B(r(f=>this.setLevel(f)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,r,f){let E=this.b.get(n)?.logger;return E||(f=r?.always?L.Trace:f,E=this.f(n,f??this.c,r),this.b.set(n,{logger:E,logLevel:f})),E}setLevel(n,r){const f=A.URI.isUri(n)?n:void 0,E=f?r:n;if(f){const T=this.b.get(f);T&&T.logLevel!==E&&(T.logLevel=E,T.logger.setLevel(E))}else this.c=E,this.b.forEach(({logLevel:T,logger:M})=>{T===void 0&&M.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=p;class w{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return L.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogger=w;class i extends w{}e.NullLogService=i;class s extends p{constructor(){super(L.Info,t.Event.None)}f(n,r,f){return new w}}e.NullLoggerService=s;function a(c){if(c.verbose)return L.Trace;if(typeof c.logLevel=="string"){const n=l(c.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function u(c){switch(c){case L.Trace:return"trace";case L.Debug:return"debug";case L.Info:return"info";case L.Warning:return"warn";case L.Error:return"error";case L.Off:return"off"}}e.LogLevelToString=u;function l(c){switch(c){case"trace":return L.Trace;case"debug":return L.Debug;case"info":return L.Info;case"warn":return L.Warning;case"error":return L.Error;case"critical":return L.Error;case"off":return L.Off}}e.parseLogLevel=l}),define(ye[200],Ce([1,0,39,13]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(D){D[D.Trace=0]="Trace",D[D.Debug=1]="Debug",D[D.Info=2]="Info",D[D.Warning=3]="Warning",D[D.Error=4]="Error",D[D.Critical=5]="Critical",D[D.Off=6]="Off"})(k||(k={}));async function R(D,L,P,v,C){try{const S=await new Promise((d,h)=>{te(["spdlog"],d,h)});S.setFlushOn(k.Trace);const m=await S.createAsyncRotatingLogger(D,L,P,v);return C?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(S){console.error(S)}return null}function I(D,L,P){switch(L){case t.LogLevel.Trace:D.trace(P);break;case t.LogLevel.Debug:D.debug(P);break;case t.LogLevel.Info:D.info(P);break;case t.LogLevel.Warning:D.warn(P);break;case t.LogLevel.Error:D.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function A(D,L){switch(L){case t.LogLevel.Trace:D.setLevel(k.Trace);break;case t.LogLevel.Debug:D.setLevel(k.Debug);break;case t.LogLevel.Info:D.setLevel(k.Info);break;case t.LogLevel.Warning:D.setLevel(k.Warning);break;case t.LogLevel.Error:D.setLevel(k.Error);break;case t.LogLevel.Off:D.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class y extends t.AbstractMessageLogger{constructor(L,P,v,C,S){super(),this.k=[],this.setLevel(S),this.l=this.n(L,P,v,C),this.B(this.onDidChangeLogLevel(m=>{this.m&&A(this.m,m)}))}async n(L,P,v,C){const S=v?6:1,m=30/S*o.ByteSize.MB,d=await R(L,P,m,S,C);if(d){this.m=d,A(this.m,this.getLevel());for(const{level:h,message:b}of this.k)I(this.m,h,b);this.k=[]}}g(L,P){this.m?I(this.m,L,P):this.getLevel()<=L&&this.k.push({level:L,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(ye[123],Ce([1,0,37,173,4]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var I;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function D(S,m){return m-S}y.compare=D;const L=Object.create(null);L[y.Error]=(0,t.localize)(0,null),L[y.Warning]=(0,t.localize)(1,null),L[y.Info]=(0,t.localize)(2,null);function P(S){return L[S]||""}y.toString=P;function v(S){switch(S){case o.default.Error:return y.Error;case o.default.Warning:return y.Warning;case o.default.Info:return y.Info;case o.default.Ignore:return y.Hint}}y.fromSeverity=v;function C(S){switch(S){case y.Error:return o.default.Error;case y.Warning:return o.default.Warning;case y.Info:return o.default.Info;case y.Hint:return o.default.Ignore}}y.toSeverity=C}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const D="";function L(v){return P(v,!0)}y.makeKey=L;function P(v,C){const S=[D];return v.source?S.push(v.source.replace("\xA6","\\\xA6")):S.push(D),v.code?typeof v.code=="string"?S.push(v.code.replace("\xA6","\\\xA6")):S.push(v.code.value.replace("\xA6","\\\xA6")):S.push(D),v.severity!==void 0&&v.severity!==null?S.push(I.toString(v.severity)):S.push(D),v.message&&C?S.push(v.message.replace("\xA6","\\\xA6")):S.push(D),v.startLineNumber!==void 0&&v.startLineNumber!==null?S.push(v.startLineNumber.toString()):S.push(D),v.startColumn!==void 0&&v.startColumn!==null?S.push(v.startColumn.toString()):S.push(D),v.endLineNumber!==void 0&&v.endLineNumber!==null?S.push(v.endLineNumber.toString()):S.push(D),v.endColumn!==void 0&&v.endColumn!==null?S.push(v.endColumn.toString()):S.push(D),S.push(D),S.join("\xA6")}y.makeKeyOptionalMessage=P})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(ye[201],Ce([1,0,3,37,4]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,k.createDecorator)("notificationService");var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(ye[124],Ce([1,0,8,2,4]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService");function R(D,L){return t.URI.isUri(D)?(0,o.equalsIgnoreCase)(D.scheme,L):(0,o.startsWithIgnoreCase)(D,L+":")}e.matchesScheme=R;function I(D,...L){return L.some(P=>R(D,P))}e.matchesSomeScheme=I;function A(D,L){return D.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=A;function y(D){let L;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(D.fragment);return P&&(L={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},D=D.with({fragment:""})),{selection:L,uri:D}}e.extractSelection=y}),define(ye[202],Ce([1,0,12,36]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.context<"u"){const R=o.globals.vscode.context.configuration();if(R)k=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:R.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(ye[203],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(te,e){return function(o,t){e(o,t,te)}};define(ye[125],Ce([1,0,16,21,6,4]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var I;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends k.Disposable{constructor(P,v){super(),this.a=new o.DeferredPromise,v.withProgress(P,C=>(this.b=C,this.c&&C.report(this.c),this.a.p)),this.B((0,k.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};y=qe([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class D extends k.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new k.DisposableStore)}start(P){this.stop();const v=++this.a,C=new t.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,k.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,k.toDisposable)(()=>C.cancel())),this.b.add((0,k.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:C.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[44],Ce([1,0,50,11]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(I,A){o.ok(t.isString(I)),o.ok(t.isObject(A)),o.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,A)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new k}),define(ye[126],Ce([1,0,3,44]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this.b=new o.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,D){this.a[k(y)]=D,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const I=new R;t.Registry.add(e.Extensions.JSONContribution,I)}),define(ye[127],Ce([1,0,18,3,11,168,52,126,44]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=y.Registry.as(A.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const a=new Set;this.n(i,s,a),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const s=new Set;this.o(i,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const a=new Set;this.o(s,a),this.n(i,!1,a),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const a=[];for(const{overrides:u,source:l}of i)for(const c in u)if(s.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const n=this.a.get(c),r=n?.valuesSources??new Map;if(l)for(const M of Object.keys(u[c]))r.set(M,l);const f={...n?.value||{},...u[c]};this.a.set(c,{source:l,value:f,valuesSources:r});const E=(0,I.getLanguageTagSettingPlainKey)(c),T={type:"object",default:f,description:R.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:k.isString(l)?void 0:l,defaultValueSource:l};a.push(...m(c)),this.d[c]=T,this.b.properties[c]=T}else{this.a.set(c,{value:u[c],source:l});const n=this.d[c];n&&(this.w(c,n),this.r(c,n))}this.m(a)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:a,source:u}of i)for(const l in a){const c=this.a.get(l),n=k.isString(u)?u:u?.id,r=k.isString(c?.source)?c?.source:c?.source?.id;if(n===r)if(s.add(l),this.a.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.d[l],delete this.b.properties[l];else{const f=this.d[l];f&&(this.w(l,f),this.r(l,f))}}this.u()}deltaConfiguration(i){let s=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,a){i.forEach(u=>{this.p(u,s,u.extensionInfo,u.restrictedProperties,void 0,a),this.c.push(u),this.q(u)})}o(i,s){const a=u=>{if(u.properties)for(const l in u.properties){s.add(l);const c=this.d[l];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[l],this.s(l,u.properties[l])}u.allOf?.forEach(l=>a(l))};for(const u of i){a(u);const l=this.c.indexOf(u);l!==-1&&this.c.splice(l,1)}}p(i,s=!0,a,u,l=3,c){l=k.isUndefinedOrNull(i.scope)?l:i.scope;const n=i.properties;if(n)for(const f in n){const E=n[f];if(s&&g(f,E)){delete n[f];continue}if(E.source=a,E.defaultDefaultValue=n[f].default,this.w(f,E),e.OVERRIDE_PROPERTY_REGEX.test(f)?E.scope=void 0:(E.scope=k.isUndefinedOrNull(E.scope)?l:E.scope,E.restricted=k.isUndefinedOrNull(E.restricted)?!!u?.includes(f):E.restricted),n[f].hasOwnProperty("included")&&!n[f].included){this.f[f]=n[f],delete n[f];continue}else this.d[f]=n[f],n[f].policy?.name&&this.e.set(n[f].policy.name,f);!n[f].deprecationMessage&&n[f].markdownDeprecationMessage&&(n[f].deprecationMessage=n[f].markdownDeprecationMessage),c.add(f)}const r=i.allOf;if(r)for(const f of r)this.p(f,s,a,u,l,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=a=>{const u=a.properties;if(u)for(const c in u)this.r(c,u[c]);a.allOf?.forEach(s)};s(i)}r(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,a={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,a),e.allSettings.properties[s]=a,e.applicationSettings.properties[s]=a,e.machineSettings.properties[s]=a,e.machineOverridableSettings.properties[s]=a,e.windowSettings.properties[s]=a,e.resourceSettings.properties[s]=a}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,s){const a=this.a.get(i);let u=a?.value,l=a?.source;k.isUndefined(u)&&(u=s.defaultDefaultValue,l=void 0),k.isUndefined(u)&&(u=h(s.type)),s.default=u,s.defaultValueSource=l}}const C="\\[([^\\]]+)\\]",S=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(w){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let s=S.exec(w);for(;s?.length;){const a=s[1].trim();a&&i.push(a),s=S.exec(w)}}return(0,o.distinct)(i)}e.overrideIdentifiersFromKey=m;function d(w){return w.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=d;function h(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const b=new v;y.Registry.add(e.Extensions.Configuration,b);function g(w,i){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?R.localize(7,null,w):b.getConfigurationProperties()[w]!==void 0?R.localize(8,null,w):i.policy?.name&&b.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,w,i.policy?.name,b.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function p(){const w=[],i=b.getConfigurationProperties();for(const s of Object.keys(i))w.push([s,i[s].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=p}),define(ye[204],Ce([1,0,18,3,146,6,28,23,11,2,52,127,44]),function(te,e,o,t,k,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class C{constructor(s={},a=[],u=[],l){this.c=s,this.d=a,this.f=u,this.raw=l,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof C)return a;const u=new S("");return u.parseRaw(a),u.configurationModel});this.g=s.reduce((a,u)=>u===a?u:a.merge(u),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,a){const u=this.rawConfiguration.getValue(s),l=a?this.rawConfiguration.getOverrideValue(s,a):void 0,c=a?this.rawConfiguration.override(a).getValue(s):u;return{value:u,override:l,merged:c}}getOverrideValue(s,a){const u=this.l(a);return u?s?(0,L.getConfigurationValue)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const u of this.overrides)u.identifiers.includes(s)&&a.push(...u.keys);return o.distinct(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return o.distinct(s)}override(s){let a=this.b.get(s);return a||(a=this.h(s),this.b.set(s,a)),a}merge(...s){const a=A.deepClone(this.contents),u=A.deepClone(this.overrides),l=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const n of s)if(c.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(a,n.contents);for(const r of n.overrides){const[f]=u.filter(E=>o.equals(E.identifiers,r.identifiers));f?(this.j(f.contents,r.contents),f.keys.push(...r.keys),f.keys=o.distinct(f.keys)):u.push(A.deepClone(r))}for(const r of n.keys)l.indexOf(r)===-1&&l.push(r)}return new C(a,l,u,c.every(n=>n instanceof C)?void 0:c)}freeze(){return this.a=!0,this}h(s){const a=this.l(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const u={};for(const l of o.distinct([...Object.keys(this.contents),...Object.keys(a)])){let c=this.contents[l];const n=a[l];n&&(typeof c=="object"&&typeof n=="object"?(c=A.deepClone(c),this.j(c,n)):c=n),u[l]=c}return new C(u,this.keys,this.overrides)}j(s,a){for(const u of Object.keys(a)){if(u in s&&y.isObject(s[u])&&y.isObject(a[u])){this.j(s[u],a[u]);continue}s[u]=A.deepClone(a[u])}}k(s){return this.a&&!Object.isFrozen(s)?A.deepFreeze(s):s}l(s){let a=null,u=null;const l=c=>{c&&(u?this.j(u,c):u=A.deepClone(c))};for(const c of this.overrides)o.equals(c.identifiers,[s])?a=c.contents:c.identifiers.includes(s)&&l(c.contents);return l(a),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,a){this.m(s),(0,L.addToValueTree)(this.contents,s,a,u=>{throw new Error(u)})}removeValue(s){this.n(s)&&(0,L.removeFromValueTree)(this.contents,s)}m(s){let a=this.keys.length;for(let u=0;u<a;u++)s.indexOf(this.keys[u])===0&&(a=u);this.keys.splice(a,1,s)}n(s){const a=this.keys.indexOf(s);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=C;class S{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!y.isUndefinedOrNull(s)){const u=this.g(s);this.parseRaw(u,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:u,keys:l,overrides:c,restricted:n,hasExcludedProperties:r}=this.h(s,a);this.b=new C(u,l,c,r?[s]:void 0),this.c=n||[]}g(s){let a={},u=null,l=[];const c=[],n=[];function r(E){Array.isArray(l)?l.push(E):u!==null&&(l[u]=E)}const f={onObjectBegin:()=>{const E={};r(E),c.push(l),l=E,u=null},onObjectProperty:E=>{u=E},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const E=[];r(E),c.push(l),l=E,u=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:r,onError:(E,T,M)=>{n.push({error:E,offset:T,length:M})}};if(s)try{k.visit(s,f),a=l[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return a}h(s,a){const u=v.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),l=this.j(s,u,!0,a);s=l.raw;const c=(0,L.toValuesTree)(s,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),n=Object.keys(s),r=this.l(s,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:c,keys:n,overrides:r,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(s,a,u,l){let c=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:c};const n={},r=[];for(const f in s)if(P.OVERRIDE_PROPERTY_REGEX.test(f)&&u){const E=this.j(s[f],a,!1,l);n[f]=E.raw,c=c||E.hasExcludedProperties,r.push(...E.restricted)}else{const E=a[f],T=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&r.push(f),(T===void 0||l.scopes===void 0||l.scopes.includes(T))&&!(l.skipRestricted&&E?.restricted)?n[f]=s[f]:c=!0}return{raw:n,restricted:r,hasExcludedProperties:c}}l(s,a){const u=[];for(const l of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(l)){const c={};for(const n in s[l])c[n]=s[l][n];u.push({identifiers:(0,P.overrideIdentifiersFromKey)(l),keys:Object.keys(c),contents:(0,L.toValuesTree)(c,a)})}return u}}e.ConfigurationModelParser=S;class m extends R.Disposable{constructor(s,a,u,l){super(),this.f=s,this.g=a,this.h=l,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new S(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&u.isEqual(c.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=m;class d{constructor(s,a,u,l,c,n,r,f,E,T,M,K,V){this.a=s,this.b=a,this.value=u,this.overrideIdentifiers=l,this.c=c,this.d=n,this.f=r,this.g=f,this.h=E,this.j=T,this.k=M,this.l=K,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class h{constructor(s,a,u,l,c=new C,n=new C,r=new I.ResourceMap,f=new C,E=new I.ResourceMap,T=!0){this.c=s,this.d=a,this.f=u,this.g=l,this.h=c,this.j=n,this.l=r,this.m=f,this.n=E,this.p=T,this.a=null,this.b=new I.ResourceMap,this.q=null}getValue(s,a,u){return this.s(s,a,u).getValue(s)}updateValue(s,a,u={}){let l;u.resource?(l=this.n.get(u.resource),l||(l=new C,this.n.set(u.resource,l))):l=this.m,a===void 0?l.removeValue(s):l.setValue(s,a),u.resource||(this.a=null)}inspect(s,a,u){const l=this.s(s,a,u),c=this.w(a.resource,u),n=a.resource?this.n.get(a.resource)||this.m:this.m,r=new Set;for(const f of l.overrides)for(const E of f.identifiers)l.getOverrideValue(s,E)!==void 0&&r.add(E);return new d(s,a,l.getValue(s),r.size?[...r]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this.j.freeze():void 0,c?c.freeze():void 0,n.inspect(s,a.overrideIdentifier))}keys(s){const a=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,a){this.l.set(s,a),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const u=[];if(!a){const{added:l,updated:c,removed:n}=p(this.c,s);a=[...l,...c,...n]}for(const l of a)for(const c of(0,P.overrideIdentifiersFromKey)(l)){const n=this.c.getKeysForOverrideIdentifier(c),r=s.getKeysForOverrideIdentifier(c),f=[...r.filter(E=>n.indexOf(E)===-1),...n.filter(E=>r.indexOf(E)===-1),...n.filter(E=>!A.equals(this.c.override(c).getValue(E),s.override(c).getValue(E)))];u.push([c,f])}return this.updateDefaultConfiguration(s),{keys:a,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:u,removed:l}=p(this.d,s),c=[...a,...u,...l];return c.length&&this.updatePolicyConfiguration(s),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:u,removed:l,overrides:c}=p(this.applicationConfiguration,s),n=[...a,...u,...l];return n.length&&this.updateApplicationConfiguration(s),{keys:n,overrides:c}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:u,removed:l,overrides:c}=p(this.localUserConfiguration,s),n=[...a,...u,...l];return n.length&&this.updateLocalUserConfiguration(s),{keys:n,overrides:c}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:u,removed:l,overrides:c}=p(this.remoteUserConfiguration,s),n=[...a,...u,...l];return n.length&&this.updateRemoteUserConfiguration(s),{keys:n,overrides:c}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:u,removed:l,overrides:c}=p(this.workspaceConfiguration,s),n=[...a,...u,...l];return n.length&&this.updateWorkspaceConfiguration(s),{keys:n,overrides:c}}compareAndUpdateFolderConfiguration(s,a){const u=this.r.get(s),{added:l,updated:c,removed:n,overrides:r}=p(u,a),f=[...l,...c,...n];return(f.length||!u)&&this.updateFolderConfiguration(s,a),{keys:f,overrides:r}}compareAndDeleteFolderConfiguration(s){const a=this.r.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:l,removed:c,overrides:n}=p(a,void 0);return{keys:[...u,...l,...c],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,a,u){let l=this.t(a,u);return a.overrideIdentifier&&(l=l.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(l=l.merge(this.d)),l}t({resource:s},a){let u=this.u();if(a&&s){const l=a.getFolder(s);l&&(u=this.v(l.uri)||u);const c=this.n.get(s);c&&(u=u.merge(c))}return u}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let a=this.b.get(s);if(!a){const u=this.u(),l=this.l.get(s);l?(a=u.merge(l),this.p&&(a=a.freeze()),this.b.set(s,a)):a=u}return a}w(s,a){if(a&&s){const u=a.getFolder(s);if(u)return this.l.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,a)=>{const{contents:u,overrides:l,keys:c}=this.l.get(a);return s.push([a,{contents:u,overrides:l,keys:c}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(a=>s.add(a)),this.userConfiguration.freeze().keys.forEach(a=>s.add(a)),this.j.freeze().keys.forEach(a=>s.add(a)),this.l.forEach(a=>a.freeze().keys.forEach(u=>s.add(u))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.j.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.l.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}y(s){const a=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u)),this.j.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u)),this.l.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l))),[...a.values()]}static parse(s){const a=this.z(s.defaults),u=this.z(s.policy),l=this.z(s.application),c=this.z(s.user),n=this.z(s.workspace),r=s.folders.reduce((f,E)=>(f.set(D.URI.revive(E[0]),this.z(E[1])),f),new I.ResourceMap);return new h(a,u,l,c,new C,n,r,new C,new I.ResourceMap,!1)}static z(s){return new C(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=h;function b(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const s=new Set,a=new Map;for(const l of i)l.keys.forEach(c=>s.add(c)),l.overrides.forEach(([c,n])=>{const r=(0,I.getOrSet)(a,c,new Set);n.forEach(f=>r.add(f))});const u=[];return a.forEach((l,c)=>u.push([c,[...l.values()]])),{keys:[...s.values()],overrides:u}}e.mergeChanges=b;class g{constructor(s,a,u,l){this.change=s,this.f=a,this.g=u,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const c of s.keys)this.affectedKeys.add(c);for(const[,c]of s.overrides)for(const n of c)this.affectedKeys.add(n);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=h.parse(this.f.data)),this.j}affectsConfiguration(s,a){const u=this.a+s,l=this.d.indexOf(u);if(l<0)return!1;const c=l+u.length;if(c>=this.d.length)return!1;const n=this.d.charCodeAt(c);if(n!==this.b&&n!==this.c)return!1;if(a){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,f=this.g.getValue(s,a,this.h);return!A.equals(r,f)}return!0}}e.ConfigurationChangeEvent=g;function p(i,s){const{added:a,removed:u,updated:l}=w(s?.rawConfiguration,i?.rawConfiguration),c=[],n=i?.getAllOverrideIdentifiers()||[],r=s?.getAllOverrideIdentifiers()||[];if(s){const f=r.filter(E=>!n.includes(E));for(const E of f)c.push([E,s.getKeysForOverrideIdentifier(E)])}if(i){const f=n.filter(E=>!r.includes(E));for(const E of f)c.push([E,i.getKeysForOverrideIdentifier(E)])}if(s&&i){for(const f of n)if(r.includes(f)){const E=w({contents:i.getOverrideValue(void 0,f)||{},keys:i.getKeysForOverrideIdentifier(f)},{contents:s.getOverrideValue(void 0,f)||{},keys:s.getKeysForOverrideIdentifier(f)});c.push([f,[...E.added,...E.removed,...E.updated]])}}return{added:a,removed:u,updated:l,overrides:c}}function w(i,s){const a=i?s?i.keys.filter(c=>s.keys.indexOf(c)===-1):[...i.keys]:[],u=s?i?s.keys.filter(c=>i.keys.indexOf(c)===-1):[...s.keys]:[],l=[];if(i&&s){for(const c of s.keys)if(i.keys.indexOf(c)!==-1){const n=(0,L.getConfigurationValue)(s.contents,c),r=(0,L.getConfigurationValue)(i.contents,c);A.equals(n,r)||l.push(c)}}return{added:a,removed:u,updated:l}}}),define(ye[128],Ce([1,0,10,4]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends o.ErrorNoTelemetry{static isNotAvailable(A){return A instanceof R&&A._code===k.NotAvailable}static isTemporarilyNotAvailable(A){return A instanceof R&&A._code===k.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof R&&A._code===k.NoResolverFound}static isHandled(A){return A instanceof R&&A.isHandled}constructor(A,y=k.Unknown,D){super(A),this._message=A,this._code=y,this._detail=D,this.isHandled=y===k.NotAvailable&&D===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(ye[67],Ce([1,0,15]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(D){return D.scheme===o.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=t;function k(D){if(!D)return;const L=D.indexOf("+");return L<0?D:D.substr(0,L)}e.getRemoteName=k;function R(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=R;function I(D){const{host:L,port:P}=y(D);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.parseAuthorityWithPort=I;function A(D,L){let{host:P,port:v}=y(D);return typeof v>"u"&&(v=L),{host:P,port:v}}e.parseAuthorityWithOptionalPort=A;function y(D){const L=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=D.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const v=D.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:D,port:void 0}}}),define(ye[26],Ce([1,0,8,4,67]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=R;function I(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,d){if(typeof m>"u"||m===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof m=="string"||typeof d=="string"){const h=typeof m=="string"?m:m.value,b=typeof d=="string"?d:d.value;return o.equalsIgnoreCase(h,b)}return m.c===d.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=D;function L(S){return P(S)}e.isApplicationScopedExtension=L;function P(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function v(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function C(S,m){if(m){const d=`onResolveRemoteAuthority:${(0,k.getRemoteName)(m)}`;return S.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[205],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class o{constructor(){this.b=new Map}c(){return new Promise((k,R)=>te(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.c(),I=new R.validator;if(I){const A=String(o.a++);return this.b.set(A,I),{id:A,data:I.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const I=this.b.get(k.id);if(!I)return!1;this.b.delete(k.id);try{return I.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.c(),I=new R.signer;if(I)return I.sign(k)}catch{}return k}}e.SignService=o,o.a=1}),define(ye[206],Ce([1,0,12,36,2,30]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(D){if(o.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function A(D,L,P,v,C,S,m,d,h,b){const g=Object.create(null);g["common.machineId"]=m,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=C,g.version=S,g["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,o.PlatformToString)(o.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=v,g["common.product"]=b||"desktop",d&&(g["common.msftInternal"]=d);let p=0;const w=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),o.isLinuxSnap&&(g["common.snap"]="true");const i=I(P);i&&(g["common.platformDetail"]=i);try{const s=await D.readFile(k.URI.file(h));g["common.source"]=s.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=A;function y(D){const L=t.env.USERDNSDOMAIN;if(!L)return!1;const P=L.toLowerCase();return D.some(v=>P===v)}e.verifyMicrosoftInternalDomain=y}),define(ye[207],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,o.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,o.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[68],Ce([1,0,23,11,3,52,67,206,207]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class D{constructor(n){this.value=n}}e.TrustedTelemetryValue=D;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,r){return Promise.resolve(void 0)}publicLog2(n,r){return this.publicLog(n,r)}publicLogError(n,r){return Promise.resolve(void 0)}publicLogError2(n,r){return this.publicLogError(n,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class P{async publicLog(n,r,f){}async publicLogError(n,r,f){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(c,n){return k.Event.debounce(n.onDidChangeConfiguration,(f,E)=>{const T=f?new Set([...f.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:T}},1e3,!0)(f=>{f.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(f.source),configurationKeys:p(f.affectedKeys)})})}e.configurationTelemetry=v;function C(c,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!c.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=C;function S(c,n){return!(n.isBuilt||n.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=S;function m(c){const n=c.getValue(y.TELEMETRY_SETTING_ID),r=c.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function d(c){const n={},r={},f={};g(c,f);for(let E in f){E=E.length>150?E.substr(E.length-149):E;const T=f[E];typeof T=="number"?r[E]=T:typeof T=="boolean"?r[E]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${T.length}`),n[E]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(n[E]=T)}return{properties:n,measurements:r}}e.validateTelemetryData=d;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function b(c){if(!c)return"none";const n=(0,I.getRemoteName)(c);return h.has(n)?n:"other"}e.cleanRemoteAuthority=b;function g(c,n,r=0,f){if(!!c)for(const E of Object.getOwnPropertyNames(c)){const T=c[E],M=f?f+E:E;Array.isArray(T)?n[M]=(0,o.safeStringify)(T):T instanceof Date?n[M]=T.toISOString():(0,t.isObject)(T)?r<2?g(T,n,r+1,M+"."):n[M]=(0,o.safeStringify)(T):n[M]=T}}function p(c){if(!c)return[];const n=[];return w(n,"",c),n}function w(c,n,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(f=>w(c,n?`${n}.${f}`:f,r[f])):c.push(n)}function i(c,n){const r=c.msftInternalDomains||[],f=n.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(r)||f}e.isInternalTelemetry=i;function s(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=s;function a(c,n){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let r=c;const f=[];for(const K of n)for(;;){const V=K.exec(c);if(!V)break;f.push([V.index,K.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(r="";;){const K=T.exec(c);if(!K)break;const V=f.some(([F,U])=>K.index<U&&F<T.lastIndex);!E.test(K[0])&&!V&&(r+=c.substring(M,K.index)+"<REDACTED: user-file-path>",M=T.lastIndex)}return M<c.length&&(r+=c.substr(M)),r}function u(c){if(!c)return c;const n=c.toLowerCase(),r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of r)if(f.regex.test(n))return`<REDACTED: ${f.label}>`;return c}function l(c,n){return(0,o.cloneAndChange)(c,r=>{if(r instanceof D)return r.value;if(typeof r=="string"){let f=r.replaceAll("%20"," ");f=a(f,n);for(const E of n)f=f.replace(E,"");return f=u(f),f}})}e.cleanData=l}),define(ye[208],Ce([1,0,8,122,26,12,2,10,36,68]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(a,u){return a.uuid&&u.uuid?a.uuid===u.uuid:a.id===u.id?!0:(0,o.compareIgnoreCase)(a.id,u.id)===0}e.areSameExtensions=L;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(u){const l=u.manifest?u.manifest.version:u.version,c=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new v(u.identifier,l,c)}static parse(u){const l=P.exec(u);return l&&l[1]&&l[2]?new v({id:l[1]},l[2],l[4]||void 0):null}constructor(u,l,c="undefined"){this.version=l,this.targetPlatform=c,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof v?L(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=v;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(a){const u=C.exec(a);return u&&u[1]?[d(u[1]),u[2]]:[d(a),void 0]}e.getIdAndVersion=S;function m(a,u){return`${a}.${u}`}e.getExtensionId=m;function d(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function h(a,u){return d(m(a,u))}e.getGalleryExtensionId=h;function b(a,u){const l=[],c=n=>{for(const r of l)if(r.some(f=>L(u(f),u(n))))return r;return null};for(const n of a){const r=c(n);r?r.push(n):l.push([n])}return l}e.groupByExtension=b;function g(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function p(a){return{id:new D.TrustedTelemetryValue(a.identifier.id),name:new D.TrustedTelemetryValue(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function w(a,u){const l=[],c=u.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const n=c.shift();if(n&&l.every(r=>!L(r.identifier,{id:n}))){const r=a.filter(f=>L(f.identifier,{id:n}));r.length===1&&(l.push(r[0]),c.push(...r[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=w;async function i(a,u){if(!R.isLinux)return!1;let l;try{l=(await a.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await a.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){u.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(n))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function s(a,u){const l=await i(a,u),c=(0,t.getTargetPlatform)(l?"alpine":R.platform,y.arch);return u.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=s}),define(ye[209],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,R,I=5){const A=R(y=>{const D=typeof y=="string"?y:y.data;let L=this.a.get(k);if(L){L.data.push(D);return}const P=setTimeout(()=>this.flushBuffer(k),I);L={data:[D],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(k),A.dispose()}},this.a.set(k,L)});return A}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const R=this.a.get(k);R&&(this.a.delete(k),this.b(k,R.data.join("")))}}e.TerminalDataBufferer=o}),define(ye[210],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var o;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(o=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===o.HIGH_CONTRAST_DARK||R===o.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===o.DARK||R===o.HIGH_CONTRAST_DARK}e.isDark=k}),define(ye[90],Ce([1,0,80,3,6,4,44,210]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var y;(function(d){function h(b){return b&&typeof b=="object"&&typeof b.id=="string"}d.isThemeColor=h})(y=e.ThemeColor||(e.ThemeColor={}));function D(d){return{id:d}}e.themeColorFromId=D;var L;(function(d){function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||y.isThemeColor(u.color))}d.isThemeIcon=h;const b=new RegExp(`^\\$\\((${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?)\\)$`);function g(u){const l=b.exec(u);if(!l)return;const[,c]=l;return{id:c}}d.fromString=g;function p(u){return{id:u}}d.fromId=p;function w(u,l){let c=u.id;const n=c.lastIndexOf("~");return n!==-1&&(c=c.substring(0,n)),l&&(c=`${c}~${l}`),{id:c}}d.modify=w;function i(u){const l=u.id.lastIndexOf("~");if(l!==-1)return u.id.substring(l+1)}d.getModifier=i;function s(u,l){return u.id===l.id&&u.color?.id===l.color?.id}d.isEqual=s;function a(u,l){return{id:u.id,color:l?D(l):void 0}}d.asThemeIcon=a,d.asClassNameArray=o.CSSIcon.asClassNameArray,d.asClassName=o.CSSIcon.asClassName,d.asCSSSelector=o.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=o.Codicon.file,e.FolderThemeIcon=o.Codicon.folder;function P(d){switch(d){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(h){return this.a.push(h),this.b.fire(h),(0,k.toDisposable)(()=>{const b=this.a.indexOf(h);this.a.splice(b,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const C=new v;I.Registry.add(e.Extensions.ThemingContribution,C);function S(d){return C.onColorThemeChange(d)}e.registerThemingParticipant=S;class m extends k.Disposable{constructor(h){super(),this.k=h,this.h=h.getColorTheme(),this.B(this.k.onDidColorThemeChange(b=>this.n(b)))}n(h){this.h=h,this.updateStyles()}updateStyles(){}w(h,b){let g=this.h.getColor(h);return g&&b&&(g=b(g,this.h)),g?g.toString():null}}e.Themable=m}),define(ye[129],Ce([1,0,3,52,4,13]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var I;(function(m){m.Http="http",m.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=P;function v(m,d,h,b){if(h===1)return!1;if(h===2&&P(d)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(g?.length===4&&parseInt(g[1])>=18)return!1}return m<1024}e.isPortPrivileged=v;class C{constructor(d,h,b){this.remoteAddress=d,this.localAddress=h,this.b=b,this.a=new o.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=C;let S=class{constructor(d,h){this.i=d,this.j=h,this.a=new o.Emitter,this.onTunnelOpened=this.a.event,this.b=new o.Emitter,this.onTunnelClosed=this.b.event,this.c=new o.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const d=this.j.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.e=d,d?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.f=d.elevation,this.g=d.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const d=[],h=Array.from(this.d.values());for(const b of h){const g=Array.from(b.values());for(const p of g){const w=await p.value;w&&d.push(w)}}return d}async dispose(){for(const d of this.d.values()){for(const{value:h}of d.values())await h.then(b=>b?.dispose());d.clear()}this.d.clear()}setEnvironmentTunnel(d,h,b,g,p){this.o(d,h,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:h,localAddress:b,privacy:g,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,h){(P(d)||L(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const b=this.q(d,h);if(b)return++b.refcount,b.value}openTunnel(d,h,b,g,p=!1,w,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${b} on local port ${g}.`),!d)return;if(h||(h="localhost"),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(d,h,b,g,p,w,i);return s?s.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(a);return(a.tunnelRemoteHost!==h||a.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const h=this.d.get(d.tunnelRemoteHost);if(h){const b=h.get(d.tunnelRemotePort);b&&(b.refcount--,await this.n(d.tunnelRemoteHost,d.tunnelRemotePort,b))}}}}async n(d,h,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${h}.`);const g=b.value.then(async p=>{p&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.d.has(d)&&this.d.get(d).delete(h),g}}async closeTunnel(d,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${h} `);const b=this.d.get(d);if(b&&b.has(h)){const g=b.get(h);g.refcount=0,await this.n(d,h,g)}}o(d,h,b){this.d.has(d)||this.d.set(d,new Map),this.d.get(d).set(h,{refcount:1,value:b})}async p(d,h){const b=this.d.get(d);b&&(await b.get(h)||b.delete(h),b.size===0&&this.d.delete(d))}q(d,h){const b=[d];L(d)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):P(d)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const g=b.map(p=>this.d.get(p));for(const p of g){const w=p?.get(h);if(w)return w}}canTunnel(d){return!!D(d)}s(d,h,b,g,p,w,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${b} on local port ${g}.`);const s=b;this.h.add(s);const a=g===void 0?b:g,u={elevationRequired:p?this.isPortPrivileged(a):!1},l={remoteAddress:{host:h,port:b},localAddressPort:g,privacy:w,public:w?w!==A.Private:void 0,protocol:i},c=d.forwardPort(l,u);return c?(this.o(h,b,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),c}};S=qe([We(0,R.ILogService),We(1,t.IConfigurationService)],S),e.AbstractTunnelService=S}),define(ye[211],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,o.createDecorator)("editSessionIdentityService");var t;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[212],Ce([1,0,15]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(y){return y.scheme!==o.Schemas.file&&y.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=t;function k(y){if(y.folders.length)return y.folders.every(D=>t(D.uri))?y.folders[0].uri:void 0;if(y.configuration&&t(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=k;function R(y){return k(y)?.scheme}e.getVirtualWorkspaceScheme=R;function I(y){return k(y)?.authority}e.getVirtualWorkspaceAuthority=I;function A(y){return k(y)!==void 0}e.isVirtualWorkspace=A}),define(ye[47],Ce([1,0,174,9,64,24,2,4,15]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function D(a){const u=a;return typeof u?.id=="string"&&I.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=D;function L(a){return typeof a?.id=="string"&&!D(a)&&!v(a)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(a,u){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,t.basename)(a)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=a;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=P;function v(a){const u=a;return typeof u?.id=="string"&&I.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=v;function C(a){const u=a;if(u?.uri)return{id:u.id,uri:I.URI.revive(u.uri)};const l=a;if(l?.configPath)return{id:l.id,configPath:I.URI.revive(l.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=C;var S;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function m(a){const u=a;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=m;function d(a){const u=a;return!!(u&&typeof u=="object"&&I.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=d;class h{constructor(u,l,c,n,r){this.h=u,this.j=c,this.k=n,this.l=r,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=l}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class b{constructor(u,l){this.raw=l,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,R.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function g(a){return new b({uri:a,index:0,name:(0,R.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(a,u){return R.extUriBiasedIgnorePathCase.isEqualOrParent(a,u.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function w(a){let u;return I.URI.isUri(a)?u=a:u=a.configuration,u?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=w;function i(a,u){return!p(a,u)&&!w(a)}e.isSavedWorkspace=i;function s(a){return(typeof a=="string"?(0,t.extname)(a):(0,R.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ye[69],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const R=this.c++;return this.b.set(R,k),this.e(),R}get(k,R){return this.b.has(k)?this.b.get(k)[R]:void 0}delete(k){this.b.delete(k),this.e()}e(){!o.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=o,o.a=!1}),define(ye[48],Ce([1,0,15,24,4]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(o.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(ye[213],Ce([1,0,16]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(I,A,y){this.h=new Map,this.a=I,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new o.RunOnceScheduler(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of D.values())L.complete()}catch(L){for(const P of D.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this.d}get(I,A){let y=this.f[I];return typeof y>"u"&&(y=A),y}update(I,A){this.f[I]=A;const y=this.h.get(I);if(y!==void 0)return y.p;const D=new o.DeferredPromise;return this.h.set(I,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class k extends t{setKeysForSync(I){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},I)}constructor(I,A){super(I.identifier.value,!0,A),this.j=I}}e.ExtensionGlobalMemento=k}),define(ye[214],Ce([1,0,3,2]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(I){this.c=I,this.a=new o.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new o.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(I,A,y,D){const P=this.c.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(A.value,y,D);this.b.fire(P)}$acceptDirtyStateChanged(I,A){this.c.getNotebookDocument(t.URI.revive(I)).acceptDirty(A)}$acceptModelSaved(I){const A=this.c.getNotebookDocument(t.URI.revive(I));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(ye[17],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class t{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[215],Ce([1,0,26,3]),function(te,e,o,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(A,y){k.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=o.ExtensionIdentifier.toKey(A.identifier),Je(this,k,y,"f"),Ue(this,k,"f").onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return Ue(this,k,"f").get(this.a,A)}store(A,y){return Ue(this,k,"f").store(this.a,A,y)}delete(A){return Ue(this,k,"f").delete(this.a,A)}}e.ExtensionSecrets=R,k=new WeakMap}),define(ye[54],Ce([1,0,4,129,3,17]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(y){function D(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}y.fromApiTunnel=D;function L(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}y.fromServiceTunnel=L})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let A=class{constructor(D){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,L){}async getTunnels(){return[]}async setTunnelFactory(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,L){return{dispose:()=>{}}}async $providePortAttributes(D,L,P,v,C){return[]}async $forwardPort(D,L){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([We(0,R.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(ye[55],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class t{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=t}),define(ye[216],Ce([1,0,22]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(y){let D=this.buffers.indexOf(y);return D<0&&(D=this.buffers.length,this.buffers.push(y)),D}}function k(A,y){if(y.serializeBuffersForPostMessage){const D=new t,L=(C,S)=>{if(S instanceof ArrayBuffer){const m=D.add(S);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(S)){const m=R(S);if(m){const d=D.add(S.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:m,byteLength:S.byteLength,byteOffset:S.byteOffset}}}}return S},P=JSON.stringify(A,L),v=D.buffers.map(C=>{const S=new Uint8Array(C);return o.VSBuffer.wrap(S)});return{message:P,buffers:v}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=k;function R(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(A,y){const D=y.map(v=>{const C=new ArrayBuffer(v.byteLength);return new Uint8Array(C).set(v.buffer),C}),L=y.length?(v,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const S=C,{index:m}=S,d=D[m];if(S.view)switch(S.view.type){case 1:return new Int8Array(d,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return C}:void 0;return{message:JSON.parse(A,L),arrayBuffers:D}}e.deserializeWebviewMessage=I}),define(ye[217],Ce([1,0,113]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(R){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:R,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function k(R){return new o.URITransformer(t(R))}e.createURITransformer=k}),define(ye[130],Ce([1,0,184,11,2,6,4,44,39,15,45,160,37]),function(te,e,o,t,k,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(q){q[q.PROGRAMMATIC=1]="PROGRAMMATIC",q[q.USER=2]="USER",q[q.EDIT=3]="EDIT",q[q.NAVIGATION=4]="NAVIGATION",q[q.JUMP=5]="JUMP"})(C=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var S;(function(q){q[q.IDENTICAL=1]="IDENTICAL",q[q.SIMILAR=2]="SIMILAR",q[q.DIFFERENT=3]="DIFFERENT"})(S=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(q){const G=q;return!!G&&typeof G.getSelection=="function"&&!!G.onDidChangeSelection}e.isEditorPaneWithSelection=m;function d(q,G,le){for(const be of le.visibleEditorPanes)if(be.group.id===G&&q.matches(be.input))return be.getViewState()}e.findViewStateForEditor=d;function h(q){if(r(q))return!1;const G=q;return k.URI.isUri(G?.resource)}e.isResourceEditorInput=h;function b(q){if(r(q))return!1;const G=q;return G?.original!==void 0&&G.modified!==void 0}e.isResourceDiffEditorInput=b;function g(q){if(r(q)||b(q))return!1;const G=q;return G?.primary!==void 0&&G.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function p(q){if(r(q))return!1;const G=q;return G?G.resource===void 0||G.resource.scheme===D.Schemas.untitled||G.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;const w=/Untitled-\d+/;function i(q){return q.scheme===D.Schemas.untitled&&q.path.length>1&&!w.test(q.path)}e.isUntitledWithAssociatedResource=i;function s(q){if(r(q))return!1;const G=q;return k.URI.isUri(G?.base?.resource)&&k.URI.isUri(G?.input1?.resource)&&k.URI.isUri(G?.input2?.resource)&&k.URI.isUri(G?.result?.resource)}e.isResourceMergeEditorInput=s;var a;(function(q){q[q.SHORT=0]="SHORT",q[q.MEDIUM=1]="MEDIUM",q[q.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var u;(function(q){q[q.EXPLICIT=1]="EXPLICIT",q[q.AUTO=2]="AUTO",q[q.FOCUS_CHANGE=3]="FOCUS_CHANGE",q[q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u=e.SaveReason||(e.SaveReason={}));class l{constructor(){this.a=new Map}registerSource(G,le){let be=this.a.get(G);return be||(be={source:G,label:le},this.a.set(G,be)),be.source}getSourceLabel(G){return this.a.get(G)?.label??G}}e.SaveSourceRegistry=new l;var c;(function(q){q[q.None=0]="None",q[q.Readonly=2]="Readonly",q[q.Untitled=4]="Untitled",q[q.Singleton=8]="Singleton",q[q.RequiresTrust=16]="RequiresTrust",q[q.CanSplitInGroup=32]="CanSplitInGroup",q[q.ForceDescription=64]="ForceDescription",q[q.CanDropIntoEditor=128]="CanDropIntoEditor",q[q.MultipleEditors=256]="MultipleEditors"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends R.Disposable{}e.AbstractEditorInput=n;function r(q){return q instanceof n}e.isEditorInput=r;function f(q){const G=q;return k.URI.isUri(G?.preferredResource)}function E(q){const G=q;return r(G?.primary)&&r(G?.secondary)}e.isSideBySideEditorInput=E;function T(q){const G=q;return r(G?.modified)&&r(G?.original)}e.isDiffEditorInput=T;function M(q,G,le,be,ve){return ge(be,[(0,P.toAction)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const Pe={...le,limits:{size:Number.MAX_VALUE}};q.openEditor(G,Pe)}}),(0,P.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=M;function K(q){return r(q?.editor)}e.isEditorInputWithOptions=K;function V(q){const G=q;return K(q)&&G?.group!==void 0}e.isEditorInputWithOptionsAndGroup=V;function F(q){const G=q;return typeof G?.groupId=="number"&&r(G.editor)}e.isEditorIdentifier=F;var U;(function(q){q[q.UNKNOWN=0]="UNKNOWN",q[q.REPLACE=1]="REPLACE",q[q.MOVE=2]="MOVE",q[q.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var N;(function(q){q[q.GROUP_ACTIVE=0]="GROUP_ACTIVE",q[q.GROUP_INDEX=1]="GROUP_INDEX",q[q.GROUP_LOCKED=2]="GROUP_LOCKED",q[q.EDITOR_OPEN=3]="EDITOR_OPEN",q[q.EDITOR_CLOSE=4]="EDITOR_CLOSE",q[q.EDITOR_MOVE=5]="EDITOR_MOVE",q[q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",q[q.EDITOR_LABEL=7]="EDITOR_LABEL",q[q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",q[q.EDITOR_PIN=9]="EDITOR_PIN",q[q.EDITOR_STICKY=10]="EDITOR_STICKY",q[q.EDITOR_DIRTY=11]="EDITOR_DIRTY",q[q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(N=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(q){q[q.PRIMARY=1]="PRIMARY",q[q.SECONDARY=2]="SECONDARY",q[q.BOTH=3]="BOTH",q[q.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class j{getOriginalUri(G,le){if(!G)return;if(s(G))return e.EditorResourceAccessor.getOriginalUri(G.result,le);if(le?.supportSideBySide){const{primary:ve,secondary:Pe}=this.a(G);if(ve&&Pe){if(le?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:le.filterByScheme}),secondary:this.getOriginalUri(Pe,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===B.ANY)return this.getOriginalUri(ve,{filterByScheme:le.filterByScheme})??this.getOriginalUri(Pe,{filterByScheme:le.filterByScheme});G=le.supportSideBySide===B.PRIMARY?ve:Pe}}if(b(G)||g(G)||s(G))return;const be=f(G)?G.preferredResource:G.resource;return!be||!le||!le.filterByScheme?be:this.b(be,le.filterByScheme)}a(G){return E(G)||g(G)?{primary:G.primary,secondary:G.secondary}:T(G)||b(G)?{primary:G.modified,secondary:G.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(G,le){if(!G)return;if(s(G))return e.EditorResourceAccessor.getCanonicalUri(G.result,le);if(le?.supportSideBySide){const{primary:ve,secondary:Pe}=this.a(G);if(ve&&Pe){if(le?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:le.filterByScheme}),secondary:this.getCanonicalUri(Pe,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===B.ANY)return this.getCanonicalUri(ve,{filterByScheme:le.filterByScheme})??this.getCanonicalUri(Pe,{filterByScheme:le.filterByScheme});G=le.supportSideBySide===B.PRIMARY?ve:Pe}}if(b(G)||g(G)||s(G))return;const be=G.resource;return!be||!le||!le.filterByScheme?be:this.b(be,le.filterByScheme)}b(G,le){if(Array.isArray(le)){if(le.some(be=>G.scheme===be))return G}else if(le===G.scheme)return G}}e.EditorResourceAccessor=new j;var z;(function(q){q[q.LEFT=0]="LEFT",q[q.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class ne{constructor(){this.c=new Map,this.d=new Map}start(G){const le=this.a=G.get(I.IInstantiationService);for(const[be,ve]of this.c)this.e(be,ve,le);this.c.clear()}e(G,le,be){const ve=be.createInstance(le);this.d.set(G,ve)}registerFileEditorFactory(G){if(this.b)throw new Error("Can only register one file editor factory.");this.b=G}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(G,le){if(this.c.has(G)||this.d.has(G))throw new Error(`A editor serializer with type ID '${G}' was already registered.`);return this.a?this.e(G,le,this.a):this.c.set(G,le),(0,R.toDisposable)(()=>{this.c.delete(G),this.d.delete(G)})}getEditorSerializer(G){return this.d.get(typeof G=="string"?G:G.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new ne);async function _(q,G,le){return!q||!q.length?[]:await Promise.all(q.map(async be=>{const ve=k.URI.revive(be.fileUri);if(!ve){le.info("Cannot resolve the path because it is not valid.",be);return}if(!await G.canHandleResource(ve)){le.info("Cannot resolve the path because it cannot be handled",be);return}let Ne=be.exists,se=be.type;if(typeof Ne!="boolean"||typeof se!="number")try{se=(await G.stat(ve)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Ne=!0}catch(de){le.error(de),Ne=!1}if(!Ne&&be.openOnlyIfExists){le.info("Cannot resolve the path because it does not exist",be);return}if(se===y.FileType.Directory){le.info("Cannot resolve the path because it is a directory",be);return}const ue={...be.options,pinned:!0};return Ne?{resource:ve,options:ue}:{resource:ve,options:ue,forceUntitled:!0}}))}e.pathsToEditors=_;var Y;(function(q){q[q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",q[q.SEQUENTIAL=1]="SEQUENTIAL"})(Y=e.EditorsOrder||(e.EditorsOrder={}));function J(q){const G=q;if(!G)return!1;const le=G;if(le.modified)return J(le.modified);const be=G;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}e.isTextEditorViewState=J;function ee(q){return(0,L.isErrorWithActions)(q)}e.isEditorOpenError=ee;function ge(q,G,le){const be=(0,L.createErrorWithActions)(q,G);return be.forceMessage=le?.forceMessage,be.forceSeverity=le?.forceSeverity,be.allowDialog=le?.allowDialog,be}e.createEditorOpenError=ge}),define(ye[131],Ce([1,0,3,16,185]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new o.Emitter,this.n=new o.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,D,L){const P={command:A};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.s("request",P),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const C=this.f.get(P.seq);if(C){this.f.delete(P.seq);const S={type:"response",seq:0,request_seq:P.seq,success:!1,command:A,message:(0,k.localize)(0,null,L,A)};C(S)}},L)}return D&&this.f.set(P.seq,D),P.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,t.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,D=this.f.get(y.request_seq);D&&(this.f.delete(y.request_seq),D(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,D)=>A.set(D,y)),await(0,t.timeout)(500),A.forEach((y,D)=>{y({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[218],Ce([1,0,186,53,4]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new t.RawContextKey("hasDebugged",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const R=v=>o.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var I;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(I=e.State||(e.State={}));function A(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var D;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(D=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,k.createDecorator)("debugService");var P;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[219],Ce([1,0,8,2,9,23,15]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(a,u,l){return a.replace(A,function(c,n){return u&&n.length>0&&n[0]!=="_"?c:l&&l.hasOwnProperty(n)?l[n]:c})}e.formatPII=y;function D(a){const u={};for(const l of Object.keys(a))l.startsWith("!")||(u[l]=a[l]);return u}e.filterExceptionsFromTelemetry=D;function L(a){return a.configuration.request==="attach"&&!P(a)&&(!a.parentSession||L(a.parentSession))}e.isSessionAttach=L;function P(a){let u=a.configuration.type;if(!!u)return u==="vslsShare"&&(u=a.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(u,"extensionhost")||(0,o.equalsIgnoreCase)(u,"pwa-extensionhost")?a:a.parentSession?P(a.parentSession):void 0}e.getExtensionHostDebugSession=P;function v(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=v;function C(a,u,l){let c,n=0;const r=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=r.exec(a);){const E=f.index+1,T=E+f[0].length;if(E<=u&&T>=l){c=f[0],n=E;break}}if(c){const E=/\w+/g;let T=null;for(;(T=E.exec(c))&&!(T.index+1+n+T[0].length>=l););T&&(c=c.substring(0,E.lastIndex))}return c?{start:n,end:n+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=C;const S=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(a){return!!(a&&a.match(S))}e.isUri=m;function d(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(m(a.path))return t.URI.parse(a.path);if((0,k.isAbsolute)(a.path))return t.URI.file(a.path)}return a.path}function h(a){if(typeof a.path=="object"){const u=t.URI.revive(a.path);if(u)return u.scheme===I.Schemas.file?u.fsPath:u.toString()}return a.path}function b(a,u){const l=u?d:h,c=(0,R.deepClone)(a);return p(c,(n,r)=>{n&&r&&(r.path=l(r))}),c}e.convertToDAPaths=b;function g(a,u){const l=u?d:h,c=(0,R.deepClone)(a);return p(c,(n,r)=>{!n&&r&&(r.path=l(r))}),c}e.convertToVSCPaths=g;function p(a,u){switch(a.type){case"event":{const l=a;switch(l.event){case"output":u(!1,l.body.source);break;case"loadedSource":u(!1,l.body.source);break;case"breakpoint":u(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=a;switch(l.command){case"setBreakpoints":u(!0,l.arguments.source);break;case"breakpointLocations":u(!0,l.arguments.source);break;case"source":u(!0,l.arguments.source);break;case"gotoTargets":u(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(c=>u(!1,c));break;default:break}break}case"response":{const l=a;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(c=>u(!1,c.source));break;case"loadedSources":l.body.sources.forEach(c=>u(!1,c));break;case"scopes":l.body.scopes.forEach(c=>u(!1,c.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(c=>u(!1,c.source));break;case"setBreakpoints":l.body.breakpoints.forEach(c=>u(!1,c.source));break;case"disassemble":l.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function w(a){return a.filter(u=>!u.presentation?.hidden).sort((u,l)=>u.presentation?l.presentation?u.presentation.group?l.presentation.group?u.presentation.group!==l.presentation.group?u.presentation.group.localeCompare(l.presentation.group):i(u.presentation.order,l.presentation.order):-1:l.presentation.group?1:i(u.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=w;function i(a,u){return typeof a!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:a-u}async function s(a,u){const l=a.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(l!=="none"&&(await u.saveAll(),l==="allEditorsInActiveGroup")){const c=u.activeEditorPane;c&&c.input.resource?.scheme===I.Schemas.untitled&&await u.save({editor:c.input,groupId:c.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(ye[220],Ce([1,0,46,221,23,9,12,8,29,187,131]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(h,b){this.p=b,this.r=Buffer.allocUnsafe(0),this.t=-1,h.on("data",g=>this.w(g))}sendMessage(h){if(this.p){const b=JSON.stringify(h);this.p.write(`Content-Length: ${Buffer.byteLength(b,"utf8")}${P.a}${b}`,"utf8")}}w(h){for(this.r=Buffer.concat([this.r,h]);;){if(this.t>=0){if(this.r.length>=this.t){const b=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,b.length>0)try{this.acceptMessage(JSON.parse(b))}catch(g){this.m.fire(new Error((g.message||g)+`
`+b))}continue}}else{const b=this.r.indexOf(P.a);if(b!==-1){const p=this.r.toString("utf8",0,b).split(P.b);for(const w of p){const i=w.split(P.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(b+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class v extends P{startSession(){return new Promise((h,b)=>{let g=!1;this.x=this.y(()=>{this.v(this.x,this.x),h(),g=!0}),this.x.on("close",()=>{g?this.m.fire(new Error("connection closed")):b(new Error("connection closed"))}),this.x.on("error",p=>{g?this.m.fire(p):b(p)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class C extends v{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",h)}}e.SocketDebugAdapter=C;class S extends v{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.path,h)}}e.NamedPipeDebugAdapter=S;class m extends P{constructor(h,b){super(),this.y=h,this.z=b}async startSession(){const h=this.y.command,b=this.y.args,g=this.y.options||{};try{if(h)if(R.isAbsolute(h)){if(!await y.Promises.exists(h))throw new Error(D.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.z));let p=process.env;if(g.env&&Object.keys(g.env).length>0&&(p=k.mixin(k.deepClone(process.env),g.env)),h==="node")if(Array.isArray(b)&&b.length>0){const w=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:p,execArgv:w?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};g.cwd&&(i.cwd=g.cwd);const s=o.fork(b[0],b.slice(1),i);if(!s.pid)throw new Error(D.localize(2,null,b[0]));this.x=s}else throw new Error(D.localize(3,null));else{const w={env:p};g.cwd&&(w.cwd=g.cwd),this.x=o.spawn(h,b,w)}this.x.on("error",w=>{this.m.fire(w)}),this.x.on("exit",(w,i)=>{this.n.fire(w)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",w=>{this.m.fire(w)}),this.x.stdin.on("error",w=>{this.m.fire(w)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(p){this.m.fire(p)}}async stopSession(){return this.x?(await this.u(),I.isWindows?new Promise((h,b)=>{const g=o.exec(`taskkill /F /T /PID ${this.x.pid}`,function(p,w,i){if(p)return b(p)});g.on("exit",h),g.on("error",b)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(h,b){if(!h)return;const g=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?g.runtime=R.join(b,h.runtime):g.runtime=h.runtime),h.runtimeArgs&&(g.runtimeArgs=h.runtimeArgs),h.program&&(R.isAbsolute(h.program)?g.program=h.program:g.program=R.join(b,h.program)),h.args&&(g.args=h.args);const p=h;return p.win&&(g.win=m.A(p.win,b)),p.winx86&&(g.winx86=m.A(p.winx86,b)),p.windows&&(g.windows=m.A(p.windows,b)),p.osx&&(g.osx=m.A(p.osx,b)),p.linux&&(g.linux=m.A(p.linux,b)),g}static platformAdapterExecutable(h,b){let g=Object.create(null);b=b.toLowerCase();for(const u of h)if(u.contributes){const l=u.contributes.debuggers;l&&l.length>0&&l.filter(c=>typeof c.type=="string"&&A.equalsIgnoreCase(c.type,b)).forEach(c=>{const n=m.A(c,u.extensionLocation.fsPath);g=k.mixin(g,n,u.isBuiltin)})}let p;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=g.winx86||g.win||g.windows:I.isWindows?p=g.win||g.windows:I.isMacintosh?p=g.osx:I.isLinux&&(p=g.linux),p=p||g;const w=p.program||g.program,i=p.args||g.args,s=p.runtime||g.runtime,a=p.runtimeArgs||g.runtimeArgs;if(s)return{type:"executable",command:s,args:(a||[]).concat(typeof w=="string"?[w]:[]).concat(i||[])};if(w)return{type:"executable",command:w,args:i||[]}}}e.ExecutableDebugAdapter=m}),define(ye[222],Ce([1,0,46,32,12]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(D,L){return new Promise((P,v)=>{let C="";const S=o.spawn(D,L);S.pid&&S.stdout.on("data",m=>{C+=m.toString()}),S.on("error",m=>{v(m)}),S.on("close",m=>{P(C)})})}async function I(D){if(D)if(k.isWindows){const L=await new Promise((P,v)=>{te(["windows-process-tree"],P,v)});return new Promise(P=>{L.getProcessTree(D,v=>{P(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(D)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var A;(function(D){D[D.cmd=0]="cmd",D[D.powershell=1]="powershell",D[D.bash=2]="bash"})(A||(A={}));function y(D,L,P,v,C){D=D.trim().toLowerCase();let S;D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0?S=1:D.indexOf("cmd.exe")>=0?S=0:D.indexOf("bash")>=0?S=2:k.isWindows?S=0:S=2;let m,d=" ";switch(S){case 1:if(m=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),v){const h=(0,t.getDriveLetter)(v);h&&(d+=`${h}:; `),d+=`cd ${m(v)}; `}if(C)for(const h in C){const b=C[h];b===null?d+=`Remove-Item env:${h}; `:d+=`\${env:${h}}='${b}'; `}if(L.length>0){const h=L.shift(),b=P?h:m(h);d+=b[0]==="'"?`& ${b} `:`${b} `;for(const g of L)d+=g==="<"||g===">"||P?g:m(g),d+=" "}break;case 0:if(m=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(b=>h.includes(b))||h.length===0?`"${h}"`:h),v){const h=(0,t.getDriveLetter)(v);h&&(d+=`${h}: && `),d+=`cd ${m(v)} && `}if(C){d+='cmd /C "';for(const h in C){let b=C[h];b===null?d+=`set "${h}=" && `:(b=b.replace(/[&^|<>]/g,g=>`^${g}`),d+=`set "${h}=${b}" && `)}}for(const h of L)d+=h==="<"||h===">"||P?h:m(h),d+=" ";C&&(d+='"');break;case 2:{m=b=>(b=b.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),b.length===0?'""':b);const h=b=>/[^\w@%\/+=,.:^-]/.test(b)?`'${b.replace(/'/g,"'\\''")}'`:b;if(v&&(d+=`cd ${m(v)} ; `),C){d+="/usr/bin/env";for(const b in C){const g=C[b];g===null?d+=` -u ${h(b)}`:d+=` ${h(`${b}=${g}`)}`}d+=" "}for(const b of L)d+=b==="<"||b===">"||P?b:m(b),d+=" ";break}}return d}e.prepareCommand=y}),define(ye[91],Ce([1,0,22,38,62,84,15,9,12,53]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var S;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(S=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var b;(function(B){B.scheme=I.Schemas.vscodeNotebookCell;const j=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${j.join("")}]+`),ne=7;function _(G,le){const be=le.toString(ne),Pe=`${be.length<j.length?j[be.length-1]:"z"}${be}s${(0,o.encodeBase64)(o.VSBuffer.fromString(G.scheme),!0,!0)}`;return G.with({scheme:B.scheme,fragment:Pe})}B.generate=_;function Y(G){if(G.scheme!==B.scheme)return;const le=G.fragment.indexOf("s");if(le<0)return;const be=parseInt(G.fragment.substring(0,le).replace(z,""),ne),ve=(0,o.decodeBase64)(G.fragment.substring(le+1)).toString();if(!isNaN(be))return{handle:be,notebook:G.with({scheme:ve,fragment:null})}}B.parse=Y;function J(G,le){return G.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${le??""},${G.scheme!==I.Schemas.file?G.scheme:""}`})}B.generateCellOutputUri=J;function ee(G){if(G.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const le=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(G.fragment);if(!le)return;const be=le[1]&&le[1]!==""?le[1]:void 0,ve=le[2];return{outputId:be,notebook:G.with({scheme:ve||I.Schemas.file,fragment:null})}}B.parseCellOutputUri=ee;function ge(G,le,be){return B.generate(G,le).with({scheme:be})}B.generateCellPropertyUri=ge;function q(G,le){if(G.scheme===le)return B.parse(G.with({scheme:B.scheme}))}B.parseCellPropertyUri=q})(b=e.CellUri||(e.CellUri={}));const g=B=>y.isWindows?B.replace(/\//g,"\\"):B;class p{constructor(j=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.e=z,this.d=[...new Set(j)].map(ne=>({pattern:ne,matches:t.parse(g(ne))}))}sort(j){const z=new Map(k.Iterable.map(j,_=>[_,g(_)]));let ne=[];for(const{matches:_}of this.d)for(const[Y,J]of z)if(_(J)){ne.push(Y),z.delete(Y);break}return z.size&&(ne=ne.concat([...z.keys()].sort((_,Y)=>this.e.indexOf(_)-this.e.indexOf(Y)))),ne}prioritize(j,z){const ne=this.f(j);if(ne===-1){this.d.unshift({pattern:j,matches:t.parse(g(j))});return}const _=new Set(z.map(J=>this.f(J,ne)));_.delete(-1);const Y=Array.from(_).sort();this.d.splice(ne+1,0,...Y.map(J=>this.d[J]));for(let J=Y.length-1;J>=0;J--)this.d.splice(Y[J],1)}toArray(){return this.d.map(j=>j.pattern)}f(j,z=this.d.length){const ne=g(j);for(let _=0;_<z;_++)if(this.d[_].matches(ne))return _;return-1}}e.MimeTypeDisplayOrder=p;function w(B,j,z,ne=(_,Y)=>_===Y){const _=[];function Y(ge,q,G){if(q===0&&G.length===0)return;const le=_[_.length-1];le&&le.start+le.deleteCount===ge?(le.deleteCount+=q,le.toInsert.push(...G)):_.push({start:ge,deleteCount:q,toInsert:G})}let J=0,ee=0;for(;;){if(J===B.length){Y(J,0,j.slice(ee));break}if(ee===j.length){Y(J,B.length-J,[]);break}const ge=B[J],q=j[ee];if(ne(ge,q)){J+=1,ee+=1;continue}z(q)?(Y(J,1,[]),J+=1):(Y(J,0,[q]),ee+=1)}return _}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(B){B.default="default",B.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(B){const j=B;return!!((typeof j.include=="string"||t.isRelativePattern(j.include))&&(typeof j.exclude=="string"||t.isRelativePattern(j.exclude)))}e.isDocumentExcludePattern=s;function a(B,j,z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(j)>=0||B.viewType===j)return!0;if(B.filenamePattern){const ne=s(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,_=s(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(t.match(ne,(0,A.basename)(z.fsPath).toLowerCase()))return!(_&&t.match(_,(0,A.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(j){return`${l.d}${j}`}static parse(j){if(j.startsWith(l.d))return j.substring(l.d.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l.d="notebook/";function c(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=c;const n=new TextDecoder;function r(B){const j=[];let z=!1;for(const ne of B)(j.length===0||z)&&(j.push(ne),z=!0);return M(j),N(o.VSBuffer.concat(j.map(ne=>o.VSBuffer.wrap(ne))))}e.compressOutputItemStreams=r;const f=`${String.fromCharCode(27)}[A`,E=f.split("").map(B=>B.charCodeAt(0)),T=10;function M(B){B.forEach((j,z)=>{if(z===0||j.length<f.length)return;const ne=B[z-1],_=j.subarray(0,f.length);if(_[0]===E[0]&&_[1]===E[1]&&_[2]===E[2]){const Y=ne.lastIndexOf(T);if(Y===-1)return;B[z-1]=ne.subarray(0,Y),B[z]=j.subarray(f.length)}})}function K(B){let j=B;do B=j,j=B.replace(/[^\n]\x08/gm,"");while(j.length<B.length);return B}function V(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const j=B.match(/^(.*)\r+/m)[1];let z=B.match(/\r+(.*)$/m)[1];z=z+j.slice(z.length,j.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return B}const F="\b".charCodeAt(0),U="\r".charCodeAt(0);function N(B){return!B.buffer.includes(F)&&!B.buffer.includes(U)?B:o.VSBuffer.fromString(V(K(n.decode(B.buffer))))}}),define(ye[223],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(ye[224],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=o;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t;function k(I){return Array.from(I.entries()).map(A=>[A[0],o(A[1].map)])}e.serializeEnvironmentVariableCollections=k;function R(I){return new Map(I.map(A=>[A[0],{map:t(A[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[56],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(R){R.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{static fromExtHostTestItem(I,A,y=I.parent){if(I._isRoot)return new k([A]);const D=[I.id];for(let L=y;L&&L.id!==A;L=L.parent)D.push(L.id);return D.push(A),new k(D.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const A=I.indexOf("\0");return A===-1?I:I.slice(0,A)}static fromString(I){return new k(I.split("\0"))}static join(I,A){return new k([...I.path,A])}static joinToString(I,A){return I.toString()+"\0"+A}static parentId(I){const A=I.lastIndexOf("\0");return A===-1?void 0:I.slice(0,A)}static localId(I){const A=I.lastIndexOf("\0");return A===-1?I:I.slice(A+1)}static compare(I,A){return I===A?0:A.startsWith(I+"\0")?2:I.startsWith(A+"\0")?3:1}constructor(I,A=I.length){if(this.path=I,this.d=A,I.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new k(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new k(this.path,I)}compare(I){if(typeof I=="string")return k.compare(this.toString(),I);for(let A=0;A<I.d&&A<this.d;A++)if(I.path[A]!==this.path[A])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.TestId=k}),define(ye[70],Ce([1,0,2,35,56]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var I;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(c){c.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),c.deserialize=n=>({range:t.Range.lift(n.range),uri:o.URI.revive(n.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var y;(function(c){c[c.Error=0]="Error",c[c.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var D;(function(c){c.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&A.serialize(n.location)}),c.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&A.deserialize(n.location)})})(D=e.ITestErrorMessage||(e.ITestErrorMessage={}));const L=(c,n)=>`${n?"s":"e"}${c}`;e.getMarkId=L;var P;(function(c){c.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&A.serialize(n.location)}),c.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&A.deserialize(n.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var v;(function(c){c.serialize=n=>n.type===0?D.serialize(n):P.serialize(n),c.deserialize=n=>n.type===0?D.deserialize(n):P.deserialize(n)})(v=e.ITestMessage||(e.ITestMessage={}));var C;(function(c){c.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),c.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(v.serialize)}),c.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(v.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",m=(c,n)=>c+S+n;e.namespaceTestTag=m;const d=c=>{const n=c.indexOf(S);return{ctrlId:c.slice(0,n),tagId:c.slice(n+1)}};e.denamespaceTestTag=d;var h;(function(c){c.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),c.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?o.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(h=e.ITestItem||(e.ITestItem={}));var b;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(c){c.serialize=n=>({expand:n.expand,item:h.serialize(n.item)}),c.deserialize=n=>({controllerId:k.TestId.root(n.item.extId),expand:n.expand,item:h.deserialize(n.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(c){c.serialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.uri!==void 0&&(r.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(r.range=n.item.range?.toJSON()),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}},c.deserialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.range!==void 0&&(r.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(c,n)=>{n.expand!==void 0&&(c.expand=n.expand),n.item!==void 0&&(c.item=c.item?Object.assign(c.item,n.item):n.item)};e.applyTestItemUpdate=w;var i;(function(c){c.serializeWithoutMessages=n=>({...g.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serializeWithoutMessages),retired:n.retired}),c.serialize=n=>({...g.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serialize),retired:n.retired}),c.deserialize=n=>({...g.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var s;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var a;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.DocumentSynced=2]="DocumentSynced",c[c.Remove=3]="Remove",c[c.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",c[c.Retire=5]="Retire",c[c.AddTag=6]="AddTag",c[c.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(c){c.deserialize=n=>n.op===0?{op:n.op,item:g.deserialize(n.item)}:n.op===1?{op:n.op,item:p.deserialize(n.item)}:n.op===2?{op:n.op,uri:o.URI.revive(n.uri),docv:n.docv}:n,c.serialize=n=>n.op===0?{op:n.op,item:g.serialize(n.item)}:n.op===1?{op:n.op,item:p.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class l{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const r=this.o();for(const f of n)switch(f.op){case 0:this.j(g.deserialize(f.item),r);break;case 1:this.k(p.deserialize(f.item),r);break;case 3:this.l(f.itemId,r);break;case 5:this.m(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this.c.set(f.tag.id,f.tag);break;case 7:this.c.delete(f.id);break}r.complete?.()}j(n,r){const f=k.TestId.parentId(n.item.extId)?.toString();let E;if(!f)E=this.p(n),this.f.add(E),this.d.set(n.item.extId,E);else if(this.d.has(f)){const T=this.d.get(f);T.children.add(n.item.extId),E=this.p(n,T),this.d.set(n.item.extId,E)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return r.add?.(E),n.expand===2&&this.g++,E}k(n,r){const f=this.d.get(n.extId);if(!!f)return n.expand!==void 0&&(f.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(f,n),r.update?.(f),f}l(n,r){const f=this.d.get(n);if(!f)return;const E=k.TestId.parentId(f.item.extId)?.toString();E?this.d.get(E).children.delete(f.item.extId):this.f.delete(f);const T=[[n]];for(;T.length;)for(const M of T.pop()){const K=this.d.get(M);K&&(T.push(K.children),this.d.delete(M),r.remove?.(K,K!==f),K.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=l}),define(ye[92],Ce([1,0,16,3,6,50,70,56]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(b){b[b.Upsert=0]="Upsert",b[b.SetTags=1]="SetTags",b[b.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",b[b.RemoveChild=3]="RemoveChild",b[b.SetProp=4]="SetProp",b[b.Bulk=5]="Bulk",b[b.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(b,g)=>b===g,P=Object.entries({range:(b,g)=>b===g?!0:!b||!g?!1:b.equalsRange(g),busy:D,label:D,description:D,error:D,sortText:D,tags:(b,g)=>!(b.length!==g.length||b.some(p=>!g.includes(p)))}),v=(b,g)=>{let p;for(const[w,i]of P)i(b[w],g[w])||(p?p[w]=g[w]:p={[w]:g[w]});return p};class C extends k.Disposable{get root(){return this.m.root}constructor(g){super(),this.m=g,this.f=this.B(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(g){this.h=g;for(const p of this.tree.values())this.G(p)}collectDiff(){const g=this.k;return this.k=[],g}pushDiff(g){switch(g.op){case 2:{for(const p of this.k)if(p.op===2&&p.uri===g.uri){p.docv=g.docv;return}break}case 1:{const p=this.k[this.k.length-1];if(p){if(p.op===1&&p.item.extId===g.item.extId){(0,I.applyTestItemUpdate)(p.item,g.item);return}if(p.op===0&&p.item.item.extId===g.item.extId){(0,I.applyTestItemUpdate)(p.item,g.item);return}}break}}this.k.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,p){const w=this.tree.get(g);if(!!w){if((w.expandLevels===void 0||p>w.expandLevels)&&(w.expandLevels=p),w.expand===1){const i=this.I(w);return i.isOpen()?this.H(w,p-1):i.wait().then(()=>this.H(w,p-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,p-1)):this.H(w,p-1)}}dispose(){for(const g of this.tree.values())this.m.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(g,p){switch(p.op){case 3:this.L(A.TestId.joinToString(g.fullId,p.id));break;case 0:this.u(p.item,g);break;case 5:for(const w of p.ops)this.p(g,w);break;case 1:this.w(p.new,p.old,g.fullId.toString());break;case 2:this.G(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:p.update}});break;case 6:this.s(g.actual.uri);break;default:(0,R.assertNever)(p)}}s(g){g&&this.pushDiff({op:2,uri:g,docv:this.m.getDocumentVersion(g)})}u(g,p){const w=A.TestId.fromExtHostTestItem(g,this.root.id,p?.actual),i=this.m.getApiFor(g);i.parent&&i.parent!==p?.actual&&this.m.getChildren(i.parent).delete(g.id);let s=this.tree.get(w.toString());if(!s){s={fullId:w,actual:g,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},g.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(g,p),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(g)}}),this.F(g,s,p);return}if(s.actual===g){this.D(g,s,p);return}if(s.actual.uri?.toString()!==g.uri?.toString())return this.L(w.toString()),this.u(g,p);const a=this.m.getChildren(s.actual),u=s.actual,l=v(this.m.toITestItem(u),this.m.toITestItem(g));this.m.getApiFor(u).listener=void 0,s.actual=g,s.expand=0,l&&(l.hasOwnProperty("tags")&&(this.w(g.tags,u.tags,w.toString()),delete l.tags),this.p(s,{op:4,update:l})),this.F(g,s,p);for(const[c,n]of a)this.m.getChildren(g).get(n.id)||this.L(A.TestId.joinToString(w,n.id));this.s(s.actual.uri)}w(g,p,w){const i=new Set(p.map(s=>s.id));for(const s of g)i.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:w,item:{tags:g.map(s=>(0,I.namespaceTestTag)(this.m.controllerId,s.id))}}}),i.forEach(this.z,this)}y(g){const p=this.j.get(g.id);p?p.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.m.controllerId,g.id)}}))}z(g){const p=this.j.get(g);p&&!--p.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.m.controllerId,g)}))}C(g,p){this.m.getApiFor(g).parent=p&&p.actual!==this.root?p.actual:void 0}D(g,p,w){this.C(g,w);const i=this.m.getApiFor(g);i.parent=w?.actual,i.listener=s=>this.p(p,s),this.G(p)}F(g,p,w){this.D(g,p,w);for(const[i,s]of this.m.getChildren(g))this.u(s,p)}G(g){let p;this.h?g.resolveBarrier?p=g.resolveBarrier.isOpen()?3:2:p=g.actual.canResolveChildren?1:0:p=0,p!==g.expand&&(g.expand=p,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:p}}),p===1&&g.expandLevels!==void 0&&this.I(g))}H(g,p){if(p<0)return;const w=[];for(const[i,s]of this.m.getChildren(g.actual)){const a=this.expand(A.TestId.joinToString(g.fullId,s.id),p);(0,o.isThenable)(a)&&w.push(a)}if(w.length)return Promise.all(w).then(()=>{})}I(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const s=new o.Barrier;return s.open(),s}g.expand=2,this.J(g);const p=g.resolveBarrier=new o.Barrier,w=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let i;try{i=this.h(g.actual===this.root?void 0:g.actual)}catch(s){w(s)}return(0,o.isThenable)(i)?i.catch(w).then(()=>{p.open(),this.G(g)}):(p.open(),this.G(g)),g.resolveBarrier}J(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}L(g){const p=this.tree.get(g);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const w=[p];for(;w.length;){const i=w.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.z(s.id);this.tree.delete(i.fullId.toString());for(const[s,a]of this.m.getChildren(i.actual))w.push(this.tree.get(A.TestId.joinToString(i.fullId,a.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.TestItemCollection=C;class S extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=S;class m extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class d extends Error{constructor(g,p,w){super(`TestItem with ID "${g}" is from controller "${p}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=d;const h=(b,g,p)=>{let w=new Map;return{get size(){return w.size},forEach(i,s){for(const a of w.values())i.call(s,a,this)},[Symbol.iterator](){return w.entries()},replace(i){const s=new Map,a=new Set(w.keys()),u={op:5,ops:[]};for(const l of i){if(!(l instanceof p))throw new m(l.id);const c=g(l).controllerId;if(c!==b.controllerId)throw new d(l.id,c,b.controllerId);if(s.has(l.id))throw new S(l.id);s.set(l.id,l),a.delete(l.id),u.ops.push({op:0,item:l})}for(const l of a.keys())u.ops.push({op:3,id:l});b.listener?.(u),w=s},add(i){if(!(i instanceof p))throw new m(i.id);w.set(i.id,i),b.listener?.({op:0,item:i})},delete(i){w.delete(i)&&b.listener?.({op:3,id:i})},get(i){return w.get(i)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=h}),define(ye[132],Ce([1,0,92]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,k=(I,A)=>{const y={controllerId:A};return t.set(I,y),y};e.createPrivateApiFor=k;const R=I=>{const A=t.get(I);if(!A)throw new o.InvalidTestItemError(I?.id||"<unknown>");return A};e.getPrivateApiFor=R}),define(ye[93],Ce([1,0,15,2]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(A,y){return A.scheme===o.Schemas.http||A.scheme===o.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===o.Schemas.file&&(A=t.URI.from({scheme:o.Schemas.vscodeRemote,authority:y.authority,path:A.path})),t.URI.from({scheme:o.Schemas.https,authority:`${A.scheme}+${R(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=k;function R(A){return A.replace(/./g,y=>{const D=y.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?y:"-"+D.toString(16).padStart(4,"0")})}function I(A){return A.replace(/-([0-9a-f]{4})/g,(y,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=I}),define(ye[225],Ce([1,0,3,6,93]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(A,y,D){this.d=A,this.e=y,this.f=D,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,D,L,P){let v;for(const g of this.e.getVisibleTextEditors(!0))if(g.value===A){v=g;break}if(!v)throw new Error("not a visible editor");const C=this,S=this.a++,m=new o.Emitter,d=new o.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(g){return(0,k.asWebviewUri)(g,C.f)}get cspSource(){return k.webviewGenericCspSource}set options(g){this.b=g,C.d.$setOptions(S,g)}get options(){return this.b}set html(g){this.a=g,C.d.$setHtml(S,g)}get html(){return this.a}get onDidReceiveMessage(){return m.event}postMessage(g){return C.d.$postMessage(S,g)}},b=new class{constructor(){this.editor=A,this.line=y,this.height=D,this.webview=h,this.onDidDispose=d.event}dispose(){C.c.has(S)&&(C.c.delete(S),C.d.$disposeEditorInset(S),d.fire(),d.dispose(),m.dispose())}};return this.d.$createEditorInset(S,v.id,v.value.document.uri,y+1,D,L||{},P.identifier,P.extensionLocation),this.c.set(S,{editor:A,inset:b,onDidReceiveMessage:m}),b}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(ye[226],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,o.createDecorator)("configurationResolverService");var t;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class k extends Error{constructor(I,A){super(A),this.variable=I}}e.VariableError=k}),define(ye[227],Ce([1,0,9,36,11,23,12,112,190,226,8]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,S,m,d){this.g=new Map,this.a=C,this.b=S,this.d=m,d&&(this.c=d.then(h=>this.h(h)))}h(C){if(I.isWindows){const S=Object.create(null);return Object.keys(C).forEach(m=>{S[m.toLowerCase()]=C[m]}),S}return C}resolveWithEnvironment(C,S,m){return this.j({env:this.h(C),userHome:void 0},S?S.uri:void 0,m)}async resolveAsync(C,S){const m={env:await this.c,userHome:await this.d};return this.j(m,C?C.uri:void 0,S)}async i(C,S,m,d){const h=R.deepClone(S);I.isWindows&&h.windows?Object.keys(h.windows).forEach(g=>h[g]=h.windows[g]):I.isMacintosh&&h.osx?Object.keys(h.osx).forEach(g=>h[g]=h.osx[g]):I.isLinux&&h.linux&&Object.keys(h.linux).forEach(g=>h[g]=h.linux[g]),delete h.windows,delete h.osx,delete h.linux;const b={env:await this.c,userHome:await this.d};return this.j(b,C?C.uri:void 0,h,m,d)}async resolveAnyAsync(C,S,m){return this.i(C,S,m)}async resolveAnyMap(C,S,m){const d=new Map;return{newConfig:await this.i(C,S,m,d),resolvedVariables:d}}resolveWithInteractionReplace(C,S,m,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,S,m,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,S){if(this.g.has(C))throw new Error("Variable "+C+" is contributed twice.");this.g.set(C,S)}async j(C,S,m,d,h){if(k.isString(m))return this.l(C,S,m,d,h);if(Array.isArray(m))return Promise.all(m.map(b=>this.j(C,S,b,d,h)));if(k.isObject(m)){const b=Object.create(null),g=await Promise.all(Object.keys(m).map(async p=>[await this.l(C,S,p,d,h),await this.j(C,S,m[p],d,h)]));for(const[p,w]of g)b[p]=w;return b}return m}l(C,S,m,d,h){return(0,L.replaceAsync)(m,P.VARIABLE_REGEXP,async(b,g)=>{if(g.includes(P.VARIABLE_LHS))return b;let p=await this.n(C,b,g,S,d);return h?.set(g,p),p!==b&&k.isString(p)&&p.match(P.VARIABLE_REGEXP)&&(p=await this.l(C,S,p,d,h)),p})}m(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async n(C,S,m,d,h){let b;const g=m.split(":");g.length>1&&(m=g[0],b=g[1]);const p=s=>{const a=this.a.getFilePath();if(a)return(0,A.normalizeDriveLetter)(a);throw new D.VariableError(s,(0,y.localize)(0,null,S))},w=s=>{const a=p(s);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,A.normalizeDriveLetter)(u)}throw new D.VariableError(s,(0,y.localize)(1,null,S,o.basename(a)))},i=s=>{if(b){const a=this.a.getFolderUri(b);if(a)return a;throw new D.VariableError(s,(0,y.localize)(2,null,S,b))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new D.VariableError(s,(0,y.localize)(3,null,S)):new D.VariableError(s,(0,y.localize)(4,null,S))};switch(m){case"env":if(b){if(C.env){const s=C.env[I.isWindows?b.toLowerCase():b];if(k.isString(s))return s}return""}throw new D.VariableError(D.VariableKind.Env,(0,y.localize)(5,null,S));case"config":if(b){const s=this.a.getConfigurationValue(d,b);if(k.isUndefinedOrNull(s))throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(6,null,S,b));if(k.isObject(s))throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(7,null,S,b));return s}throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(8,null,S));case"command":return this.o(D.VariableKind.Command,S,b,h,"command");case"input":return this.o(D.VariableKind.Input,S,b,h,"input");case"extensionInstallFolder":if(b){const s=await this.a.getExtension(b);if(!s)throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,S,b));return this.m(s.extensionLocation)}throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,S));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(D.VariableKind.WorkspaceFolder)));case"cwd":return d||b?(0,A.normalizeDriveLetter)(this.m(i(D.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(o.basename(this.m(i(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new D.VariableError(D.VariableKind.UserHome,(0,y.localize)(11,null,S))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new D.VariableError(D.VariableKind.LineNumber,(0,y.localize)(12,null,S))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new D.VariableError(D.VariableKind.SelectedText,(0,y.localize)(13,null,S))}case"file":return p(D.VariableKind.File);case"fileWorkspaceFolder":return w(D.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||b?o.relative(this.m(i(D.VariableKind.RelativeFile)),p(D.VariableKind.RelativeFile)):p(D.VariableKind.RelativeFile);case"relativeFileDirname":{const s=o.dirname(p(D.VariableKind.RelativeFileDirname));if(d||b){const a=o.relative(this.m(i(D.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return o.dirname(p(D.VariableKind.FileDirname));case"fileExtname":return o.extname(p(D.VariableKind.FileExtname));case"fileBasename":return o.basename(p(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=o.basename(p(D.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-o.extname(s).length)}case"fileDirnameBasename":return o.basename(o.dirname(p(D.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||S}case"execInstallFolder":{const s=this.a.getAppRoot();return s||S}case"pathSeparator":return o.sep;default:try{const s=b?`${m}:${b}`:m;return this.o(D.VariableKind.Unknown,S,s,h,void 0)}catch{return S}}}}o(C,S,m,d,h){if(m&&d){const b=h===void 0?d[m]:d[h+":"+m];if(typeof b=="string")return b;throw new D.VariableError(C,(0,y.localize)(14,null,S))}return S}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[133],Ce([1,0,4,130]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var k;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var R;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var A;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EVEN=1]="EVEN",S[S.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function D(S){const m=S;return(0,t.isEditorInput)(m?.editor)&&(0,t.isEditorInput)(m?.replacement)}e.isEditorReplacement=D;var L;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function v(S){const m=S;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.isEditorGroup=v;function C(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ye[228],Ce([1,0,4,133]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(R){const I=R;return typeof R=="number"||(0,t.isEditorGroup)(I)}e.isPreferredGroup=k}),define(ye[229],Ce([1,0,4,196]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[134],Ce([1,0,26,3,9]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=R;class I{static isHostExtension(P,v,C){if(v.getExtensionDescription(P))return!1;const S=C.getExtensionDescription(P);return S?!!((S.main||S.browser)&&S.api==="none"):!1}constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(o.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(o.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let v of P.activationEvents)v==="onUri"&&(v=`onUri:${o.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,v){this.d=D(this.d,v),this.d=this.d.concat(P);const C=I.j(this.d);return this.d=D(this.d,C.map(S=>S.identifier)),this.h(),this.c.fire(void 0),new R(C)}static j(P){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,b){this.addNode(h),this.addNode(b),this.c.has(h)?this.c.get(h).push(b):this.c.set(h,[b])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,b){const g=v.getArcs(h);for(let p=0;p<g.length;p++)if(!b.has(g[p]))return!1;return!0}getNodes(){return this.e}},C=new Map;for(const h of P){const b=o.ExtensionIdentifier.toKey(h.identifier);if(C.set(b,h),h.extensionDependencies)for(const g of h.extensionDependencies){const p=o.ExtensionIdentifier.toKey(g);v.addArc(b,p)}}const S=new Set;v.getNodes().filter(h=>v.getArcs(h).length===0).forEach(h=>S.add(h));const m=v.getNodes().filter(h=>!S.has(h));let d;do{d=!1;for(let h=0;h<m.length;h++){const b=m[h];v.hasOnlyGoodArcs(b,S)&&(m.splice(h,1),h--,S.add(b),d=!0)}}while(d);return m.map(h=>C.get(h))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(o.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const v=this.g.get(P);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const v=this.e.get(o.ExtensionIdentifier.toKey(P));return v||void 0}getExtensionDescriptionByUUID(P){for(const v of this.f)if(v.uuid===P)return v}getExtensionDescriptionByIdOrUUID(P,v){return this.getExtensionDescription(P)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=I;var A;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(A||(A={}));function y(L,P){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,C=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(v!==C)return v-C;const S=k.posix.basename(L.extensionLocation.path),m=k.posix.basename(P.extensionLocation.path);return S<m?-1:S>m?1:0}function D(L,P){const v=new Set;return P.forEach(C=>v.add(o.ExtensionIdentifier.toKey(C))),L.filter(C=>!v.has(o.ExtensionIdentifier.toKey(C.identifier)))}}),define(ye[230],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var o;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(o=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class k{constructor(){this.type=2}serialize(P){P[k.ENV_KEY]="1"}}e.SocketExtHostConnection=k,k.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(P){P[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function I(L){delete L[t.ENV_KEY],delete L[k.ENV_KEY],delete L[R.ENV_KEY]}function A(L,P){I(P),L.serialize(P)}e.writeExtHostConnection=A;function y(L){if(L[t.ENV_KEY])return D(L,new t(L[t.ENV_KEY]));if(L[k.ENV_KEY])return D(L,new k);if(L[R.ENV_KEY])return D(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function D(L,P){return I(L),P}}),define(ye[94],Ce([1,0,22]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var k;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function I(D){const L=o.VSBuffer.alloc(1);switch(D){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=I;function A(D,L){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=A;var y;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[95],Ce([1,0,4,3,13,25,94,67,68,23,2]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(m,d){this.i=m,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=d.createLogger(L.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(m,d,h){const b=this.getTelemetryDetails(),g=new v(d,h,m,this.g,this.f,this.getBuiltInCommonProperties(m),{isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled});return this.h.set(m.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(m,d,h){this.d=m,this.f=d,this.c=h??{usage:!0,error:!0}}getBuiltInCommonProperties(m){const d={};switch(d["common.extname"]=m.name,d["common.extversion"]=m.version,d["common.vscodemachineid"]=this.i.telemetryInfo.machineId,d["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,d["common.vscodeversion"]=this.i.version,d["common.isnewappinstall"]=C(this.i.telemetryInfo.firstSessionDate),d["common.product"]=this.i.environment.appHost,this.i.uiKind){case I.UIKind.Web:d["common.uikind"]="web";break;case I.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),d}$onDidChangeTelemetryLevel(m){this.e=this.getTelemetryConfiguration(),this.d=m;const d=this.getTelemetryDetails();this.h.forEach(h=>{h.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(m,d){const h=this.h.get(m.value);return!h||h.ignoreUnhandledExtHostErrors?!1:(h.logError(d),!0)}};P=qe([We(0,R.IExtHostInitDataService),We(1,k.ILoggerService)],P),e.ExtHostTelemetry=P;class v{constructor(m,d,h,b,g,p,w){this.g=h,this.h=b,this.i=g,this.j=p,this.b=new t.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.e=d?.ignoreBuiltInCommonProperties??!1,this.f=d?.additionalCommonProperties,this.a=m,this.c={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(m,d){this.d&&(this.c={isUsageEnabled:m,isErrorsEnabled:d},this.b.fire(this.d))}mixInCommonPropsAndCleanData(m){let d=m.properties??m;return d=(0,y.cleanData)(d,[]),this.f&&(d=(0,D.mixin)(d,this.f)),this.e||(d=(0,D.mixin)(d,this.j)),m.properties?m.properties=d:m=d,m}k(m,d){this.g.publisher==="vscode"?m=this.g.name+"/"+m:m=this.g.identifier.value+"/"+m,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.a.logEvent(m,d),this.h.trace(m,d)}logUsage(m,d){!this.c.isUsageEnabled||this.k(m,d)}logError(m,d){!this.c.isErrorsEnabled||(typeof m=="string"?this.k(m,d):this.a.logError(m,d))}get apiTelemetryLogger(){if(!this.d){const m=this,d={logUsage:m.logUsage.bind(m),get isUsageEnabled(){return m.c.isUsageEnabled},get isErrorsEnabled(){return m.c.isErrorsEnabled},logError:m.logError.bind(m),dispose:m.dispose.bind(m),onDidChangeEnableStates:m.b.event.bind(m)};this.d=Object.freeze(d)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=v;function C(S){const m=Date.now()-new Date(S).getTime();return isNaN(m)?!1:m<1e3*60*60*24}e.isNewAppInstall=C,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(ye[27],Ce([1,0,3,2,4,26,208]),function(te,e,o,t,k,R,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class y{constructor(c){this.affinity=c,this.kind=1}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class D{constructor(c){this.affinity=c,this.kind=2}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=D;class L{constructor(){this.kind=3,this.affinity=0}equals(c){return this.kind===c.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class P{constructor(c){this.dependency=c}}e.MissingExtensionDependency=P;var v;(function(l){l[l.LocalProcess=1]="LocalProcess",l[l.LocalWebWorker=2]="LocalWebWorker",l[l.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(l){if(l===null)return"None";switch(l){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=C;class S{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(c,n){const r=[],f=[],E=[],T=[],M=h(this.c),K=h(c),V=(B,j)=>B.extensionLocation.toString()===j.extensionLocation.toString()||B.isBuiltin===j.isBuiltin||B.isUserBuiltin===j.isUserBuiltin||B.isUnderDevelopment===j.isUnderDevelopment;for(const B of this.c){const j=K.get(R.ExtensionIdentifier.toKey(B.identifier));if(!j){r.push(B.identifier),M.delete(R.ExtensionIdentifier.toKey(B.identifier));continue}if(!V(B,j)){r.push(B.identifier),M.delete(R.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of c){const j=M.get(R.ExtensionIdentifier.toKey(B.identifier));if(!j){f.push(B);continue}if(!V(j,B)){r.push(j.identifier),M.delete(R.ExtensionIdentifier.toKey(j.identifier));continue}}const F=d(this.d),U=d(n);for(const B of this.d)U.has(R.ExtensionIdentifier.toKey(B))||E.push(B);for(const B of n)F.has(R.ExtensionIdentifier.toKey(B))||T.push(B);const N={toRemove:r,toAdd:f,myToRemove:E,myToAdd:T};return this.delta(N),N}delta(c){const{toRemove:n,toAdd:r,myToRemove:f,myToAdd:E}=c,T=d(n),M=d(f);for(let K=0;K<this.c.length;K++)T.has(R.ExtensionIdentifier.toKey(this.c[K].identifier))&&(this.c.splice(K,1),K--);for(let K=0;K<this.d.length;K++)M.has(R.ExtensionIdentifier.toKey(this.d[K]))&&(this.d.splice(K,1),K--);for(const K of r)this.c.push(K);for(const K of E)this.d.push(K)}containsExtension(c){for(const n of this.d)if(R.ExtensionIdentifier.equals(n,c))return!0;return!1}}e.ExtensionHostExtensions=S;class m{constructor(c){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,c)for(const n of c)this.add(n)}get size(){return this.c.size}add(c){return this.c.set(this.d(c),c),this}clear(){this.c.clear()}delete(c){return this.c.delete(this.d(c))}has(c){return this.c.has(this.d(c))}forEach(c,n){this.c.forEach(r=>c.call(n,r,r,this))}*entries(){for(const[c,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=m;function d(l){const c=new Set;for(const n of l)c.add(R.ExtensionIdentifier.toKey(n));return c}e.extensionIdentifiersArrayToSet=d;function h(l){const c=new Map;for(const n of l)c.set(R.ExtensionIdentifier.toKey(n.identifier),n);return c}function b(l,c){return l.enabledApiProposals?l.enabledApiProposals.includes(c):!1}e.isProposedApiEnabled=b;function g(l,c){if(!b(l,c))throw new Error(`Extension '${l.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${l.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${l.identifier.value}`)}e.checkProposedApiEnabled=g;class p{constructor(c,n,r,f){this.codeLoadingTime=c,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=f}}e.ActivationTimes=p;class w{constructor(c,n){this.description=c,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(l){l[l.Normal=0]="Normal",l[l.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function s(l){return{type:l.isBuiltin?0:1,isBuiltin:l.isBuiltin||l.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(l.publisher,l.name),uuid:l.uuid},manifest:l,location:l.extensionLocation,targetPlatform:l.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function a(l,c){return{identifier:new R.ExtensionIdentifier((0,I.getExtensionId)(l.manifest.publisher,l.manifest.name)),isBuiltin:l.type===0,isUserBuiltin:l.type===1&&l.isBuiltin,isUnderDevelopment:!!c,extensionLocation:l.location,...l.manifest,uuid:l.identifier.uuid,targetPlatform:l.targetPlatform,browserNlsBundleUris:l.browserNlsBundleUris}}e.toExtensionDescription=a;class u{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c,n){return Promise.resolve(0)}getInspectPorts(c,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(ye[231],Ce([1,0,10,134,26,27,13,16]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(h,b,g,p){this.startup=h,this.codeLoadingTime=b,this.activateCallTime=g,this.activateResolvedTime=p}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class D{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,b){return h===-1||b===-1?-1:b-h}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=D;class L{constructor(h,b,g,p,w,i){this.activationFailed=h,this.activationFailedError=b,this.activationTimes=g,this.module=p,this.exports=w,this.subscriptions=i}}e.ActivatedExtension=L;class P extends L{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class v extends L{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class C extends L{constructor(h){super(!0,h,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(h,b,g,p){this.g=p,this.a=h,this.b=b,this.c=g,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[h,b]of this.d)b.dispose()}isActivated(h){const b=this.d.get(k.ExtensionIdentifier.toKey(h));return Boolean(b&&b.value)}getActivatedExtension(h){const b=this.d.get(k.ExtensionIdentifier.toKey(h));if(!b||!b.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return b.value}async activateByEvent(h,b){if(this.f[h])return;const g=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(g.map(p=>({id:p.identifier,reason:{startup:b,extensionId:p.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,b){const g=this.a.getExtensionDescription(h);if(!g)throw new Error(`Extension '${h}' is not known`);return this.h([{id:g.identifier,reason:b}])}async h(h){const b=h.filter(g=>!this.isActivated(g.id)).map(g=>this.j(g));await Promise.all(b.map(g=>g.wait()))}j(h){if(this.d.has(k.ExtensionIdentifier.toKey(h.id)))return this.d.get(k.ExtensionIdentifier.toKey(h.id));if(this.l(h.id))return this.k(h,null,[],null);const b=this.a.getExtensionDescription(h.id);if(!b){const w=new Error(`Cannot activate unknown extension '${h.id.value}'`),i=this.k(h,null,[],new C(w));return this.c.onExtensionActivationError(h.id,w,new R.MissingExtensionDependency(h.id.value)),i}const g=[],p=typeof b.extensionDependencies>"u"?[]:b.extensionDependencies;for(const w of p){if(this.m(w))continue;const i=this.d.get(k.ExtensionIdentifier.toKey(w));if(i){g.push(i);continue}if(this.l(w)){g.push(this.j({id:this.b.getExtensionDescription(w).identifier,reason:h.reason}));continue}const s=this.a.getExtensionDescription(w);if(s){if(!s.main&&!s.browser)continue;g.push(this.j({id:s.identifier,reason:h.reason}));continue}const a=b.displayName||b.identifier.value,u=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${w}'`),l=this.k(h,b.displayName,[],new C(u));return this.c.onExtensionActivationError(b.identifier,u,new R.MissingExtensionDependency(w)),l}return this.k(h,b.displayName,g,null)}k(h,b,g,p){const w=new m(h.id,b,h.reason,g,p,this.c,this.g);return this.d.set(k.ExtensionIdentifier.toKey(h.id),w),w}l(h){return t.ExtensionDescriptionRegistry.isHostExtension(h,this.a,this.b)}m(h){const b=this.b.getExtensionDescription(h);return b?!b.main&&!b.browser:!1}};S=qe([We(3,I.ILogService)],S),e.ExtensionsActivator=S;let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,b,g,p,w,i,s){this.c=h,this.d=b,this.f=g,this.g=p,this.h=w,this.j=i,this.k=s,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const b=this.g[h];if(b.value&&!b.value.activationFailed){this.g.splice(h,1),h--;continue}if(b.value&&b.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${b.friendlyName}' failed to activate`);g.detail=b.value.activationFailedError,this.h=new C(g),this.j.onExtensionActivationError(this.c,g,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const b=new Error;if(h&&h.name&&(b.name=h.name),h&&h.message?b.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:b.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(b.stack=h.stack),this.h=new C(b),this.b&&o.isCancellationError(h))return;this.j.onExtensionActivationError(this.c,b,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};m=qe([We(6,I.ILogService)],m)}),define(ye[232],Ce([1,0,13,25,27]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends o.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:k.ExtensionHostLogFileName}))}};R=qe([We(0,o.ILoggerService),We(1,t.IExtHostInitDataService)],R),e.ExtHostLogService=R});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[7],Ce([1,0,18,10,111,28,84,8,11,2,30,39,128,91,27]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S){"use strict";var m,d,h,b,g,p,w,i,s,a,u,l,c,n,r,f,E,T,M,K,V,F,U;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function N(x){return Object.assign(x,{apply:function(){const fe=arguments.length===1?[]:arguments[1];return Reflect.construct(x,fe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[fe,...Te]=arguments;return Reflect.construct(x,Te,fe.constructor)}}})}var B;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(B=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var j;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})(j=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let z=p=class{static from(...H){let fe=H;return new p(function(){if(fe){for(const Te of fe)Te&&typeof Te.dispose=="function"&&Te.dispose();fe=void 0}})}constructor(H){m.set(this,void 0),Je(this,m,H,"f")}dispose(){typeof Ue(this,m,"f")=="function"&&(Ue(this,m,"f").call(this),Je(this,m,void 0,"f"))}};m=new WeakMap,z=p=qe([N],z),e.Disposable=z;let ne=w=class{static Min(...H){if(H.length===0)throw new TypeError;let fe=H[0];for(let Te=1;Te<H.length;Te++){const Ke=H[Te];Ke.isBefore(fe)&&(fe=Ke)}return fe}static Max(...H){if(H.length===0)throw new TypeError;let fe=H[0];for(let Te=1;Te<H.length;Te++){const Ke=H[Te];Ke.isAfter(fe)&&(fe=Ke)}return fe}static isPosition(H){if(!H)return!1;if(H instanceof w)return!0;const{line:fe,character:Te}=H;return typeof fe=="number"&&typeof Te=="number"}static of(H){if(H instanceof w)return H;if(this.isPosition(H))return new w(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,fe){if(H<0)throw(0,t.illegalArgument)("line must be non-negative");if(fe<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=H,this.e=fe}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,fe=0){if(H===null||fe===null)throw(0,t.illegalArgument)();let Te;return typeof H>"u"?Te=0:typeof H=="number"?Te=H:(Te=typeof H.lineDelta=="number"?H.lineDelta:0,fe=typeof H.characterDelta=="number"?H.characterDelta:0),Te===0&&fe===0?this:new w(this.line+Te,this.character+fe)}with(H,fe=this.character){if(H===null||fe===null)throw(0,t.illegalArgument)();let Te;return typeof H>"u"?Te=this.line:typeof H=="number"?Te=H:(Te=typeof H.line=="number"?H.line:this.line,fe=typeof H.character=="number"?H.character:this.character),Te===this.line&&fe===this.character?this:new w(Te,fe)}toJSON(){return{line:this.line,character:this.character}}};ne=w=qe([N],ne),e.Position=ne;let _=i=class{static isRange(H){return H instanceof i?!0:H?ne.isPosition(H.start)&&ne.isPosition(H.end):!1}static of(H){if(H instanceof i)return H;if(this.isRange(H))return new i(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,fe,Te,Ke){let Ye,ct;if(typeof H=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new ne(H,fe),ct=new ne(Te,Ke)):ne.isPosition(H)&&ne.isPosition(fe)&&(Ye=ne.of(H),ct=ne.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(H){return i.isRange(H)?this.contains(H.start)&&this.contains(H.end):ne.isPosition(H)?!(ne.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const fe=ne.Max(H.start,this.c),Te=ne.Min(H.end,this.e);if(!fe.isAfter(Te))return new i(fe,Te)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const fe=ne.Min(H.start,this.c),Te=ne.Max(H.end,this.end);return new i(fe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,fe=this.end){if(H===null||fe===null)throw(0,t.illegalArgument)();let Te;return H?ne.isPosition(H)?Te=H:(Te=H.start||this.start,fe=H.end||this.end):Te=this.start,Te.isEqual(this.c)&&fe.isEqual(this.end)?this:new i(Te,fe)}toJSON(){return[this.start,this.end]}};_=i=qe([N],_),e.Range=_;let Y=s=class extends _{static isSelection(H){return H instanceof s?!0:H?_.isRange(H)&&ne.isPosition(H.anchor)&&ne.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,fe,Te,Ke){let Ye,ct;if(typeof H=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new ne(H,fe),ct=new ne(Te,Ke)):ne.isPosition(H)&&ne.isPosition(fe)&&(Ye=ne.of(H),ct=ne.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Y=s=qe([N],Y),e.Selection=Y;class J{constructor(H,fe,Te){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(fe),this.connectionToken=Te}}e.ResolvedAuthority=J;class ee extends Error{static NotAvailable(H,fe){return new ee(H,v.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(H){return new ee(H,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,fe=v.RemoteAuthorityResolverErrorCode.Unknown,Te){super(H),this._message=H,this._code=fe,this._detail=Te,Object.setPrototypeOf(this,ee.prototype)}}e.RemoteAuthorityResolverError=ee;var ge;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ge=e.EndOfLine||(e.EndOfLine={}));var q;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=a=class{static isTextEdit(H){return H instanceof a?!0:H?_.isRange(H)&&typeof H.newText=="string":!1}static replace(H,fe){return new a(H,fe)}static insert(H,fe){return a.replace(new _(H,H),fe)}static delete(H){return a.replace(H,"")}static setEndOfLine(H){const fe=new a(new _(new ne(0,0),new ne(0,0)),"");return fe.newEol=H,fe}get range(){return this.c}set range(H){if(H&&!_.isRange(H))throw(0,t.illegalArgument)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,t.illegalArgument)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,t.illegalArgument)("newEol");this.f=H}constructor(H,fe){this.c=H,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};G=a=qe([N],G),e.TextEdit=G;let le=u=class{static isNotebookCellEdit(H){return H instanceof u?!0:H?xt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,fe){return new u(H,fe)}static insertCells(H,fe){return new u(new xt(H,H),fe)}static deleteCells(H){return new u(H,[])}static updateCellMetadata(H,fe){const Te=new u(new xt(H,H),[]);return Te.newCellMetadata=fe,Te}static updateNotebookMetadata(H){const fe=new u(new xt(0,0),[]);return fe.newNotebookMetadata=H,fe}constructor(H,fe){this.range=H,this.newCells=fe}};le=u=qe([N],le),e.NotebookEdit=le;class be{static isSnippetTextEdit(H){return H instanceof be?!0:H?_.isRange(H.range)&&Ne.isSnippetString(H.snippet):!1}static replace(H,fe){return new be(H,fe)}static insert(H,fe){return be.replace(new _(H,H),fe)}constructor(H,fe){this.range=H,this.snippet=fe}}e.SnippetTextEdit=be;var ve;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,fe,Te,Ke){this.c.push({_type:1,from:H,to:fe,options:Te,metadata:Ke})}createFile(H,fe,Te){this.c.push({_type:1,from:void 0,to:H,options:fe,metadata:Te})}deleteFile(H,fe,Te){this.c.push({_type:1,from:H,to:void 0,options:fe,metadata:Te})}e(H,fe,Te){this.c.push({_type:3,metadata:Te,uri:H,edit:{editType:5,metadata:fe},notebookMetadata:fe})}f(H,fe,Te,Ke){const Ye=fe.start,ct=fe.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:H,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(H,fe,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:H,edit:{editType:8,index:fe,metadata:Te}})}replace(H,fe,Te,Ke){this.c.push({_type:2,uri:H,edit:new G(fe,Te),metadata:Ke})}insert(H,fe,Te,Ke){this.replace(H,new _(fe,fe),Te,Ke)}delete(H,fe,Te){this.replace(H,fe,"",Te)}has(H){return this.c.some(fe=>fe._type===2&&fe.uri.toString()===H.toString())}set(H,fe){if(fe)for(const Te of fe){if(!Te)continue;let Ke,Ye;if(Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,le.isNotebookCellEdit(Ke)){if(H.scheme===C.CellUri.scheme)throw new Error("set must be called with a notebook document URI, not a cell URI.");Ke.newCellMetadata?this.g(H,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(H,Ke.newNotebookMetadata,Ye):this.f(H,Ke.range,Ke.newCells,Ye)}else be.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:H,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:H,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===H.toString()&&(this.c[Te]=void 0);break}}(0,o.coalesceInPlace)(this.c)}}get(H){const fe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===H.toString()&&fe.push(Te.edit);return fe}entries(){const H=new R.ResourceMap;for(const fe of this.c)if(fe._type===2){let Te=H.get(fe.uri);Te||(Te=[fe.uri,[]],H.set(fe.uri,Te)),Te[1].push(fe.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Pe=qe([N],Pe),e.WorkspaceEdit=Pe;let Ne=l=class{static isSnippetString(H){return H instanceof l?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=l.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,fe=this.e++){if(typeof H=="function"){const Te=new l;Te.e=this.e,H(Te),this.e=Te.e,H=Te.value}else H=l.c(H);return this.value+="${",this.value+=fe,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,fe=this.e++){const Te=H.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(H,fe){if(typeof fe=="function"){const Te=new l;Te.e=this.e,fe(Te),this.e=Te.e,fe=Te.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};Ne=l=qe([N],Ne),e.SnippetString=Ne;var se;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=c=class{static isLocation(H){return H instanceof c?!0:H?_.isRange(H.range)&&D.URI.isUri(H.uri):!1}constructor(H,fe){if(this.uri=H,fe)if(_.isRange(fe))this.range=_.of(fe);else if(ne.isPosition(fe))this.range=new _(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};de=c=qe([N],de),e.Location=de;let Z=class{static is(H){return H?typeof H.message=="string"&&H.location&&_.isRange(H.location.range)&&D.URI.isUri(H.location.uri):!1}constructor(H,fe){this.location=H,this.message=fe}static isEqual(H,fe){return H===fe?!0:!H||!fe?!1:H.message===fe.message&&H.location.range.isEqual(fe.location.range)&&H.location.uri.toString()===fe.location.uri.toString()}};Z=qe([N],Z),e.DiagnosticRelatedInformation=Z;let ae=class{constructor(H,fe,Te=ue.Error){if(!_.isRange(H))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=H,this.message=fe,this.severity=Te}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,fe){return H===fe?!0:!H||!fe?!1:H.message===fe.message&&H.severity===fe.severity&&H.code===fe.code&&H.severity===fe.severity&&H.source===fe.source&&H.range.isEqual(fe.range)&&(0,o.equals)(H.tags,fe.tags)&&(0,o.equals)(H.relatedInformation,fe.relatedInformation,Z.isEqual)}};ae=qe([N],ae),e.Diagnostic=ae;let ie=class{constructor(H,fe){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=fe}};ie=qe([N],ie),e.Hover=ie;var O;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(O=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let W=class{constructor(H,fe=O.Text){this.range=H,this.kind=fe}toJSON(){return{range:this.range,kind:O[this.kind]}}};W=qe([N],W),e.DocumentHighlight=W;var X;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(X=e.SymbolKind||(e.SymbolKind={}));var Q;(function(x){x[x.Deprecated=1]="Deprecated"})(Q=e.SymbolTag||(e.SymbolTag={}));let he=n=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,fe,Te,Ke,Ye){this.name=H,this.kind=fe,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof de?this.location=Ke:Te instanceof _&&(this.location=new de(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:X[this.kind],location:this.location,containerName:this.containerName}}};he=n=qe([N],he),e.SymbolInformation=he;let we=r=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(r.validate)}constructor(H,fe,Te,Ke,Ye){this.name=H,this.detail=fe,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],r.validate(this)}};we=r=qe([N],we),e.DocumentSymbol=we;var Ae;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(H,fe){this.title=H,this.kind=fe}};pe=qe([N],pe),e.CodeAction=pe;let De=f=class{constructor(H){this.value=H}append(H){return new f(this.value?this.value+f.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+f.c)}};De.c=".",De=f=qe([N],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorMove=De.Refactor.append("move"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let ke=class{constructor(H,fe){if(this.range=H,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([N],ke),e.SelectionRange=ke;class je{constructor(H,fe,Te,Ke,Ye,ct){this.kind=H,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(H,fe){this.fromRanges=fe,this.from=H}}e.CallHierarchyIncomingCall=Ge;class et{constructor(H,fe){this.fromRanges=fe,this.to=H}}e.CallHierarchyOutgoingCall=et;var _e;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(_e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(H,fe){this.range=H,this.command=fe}get isResolved(){return!!this.command}};nt=qe([N],nt),e.CodeLens=nt;let st=E=class{static isMarkdownString(H){return H instanceof E?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,fe=!1){d.set(this,void 0),Je(this,d,new k.MarkdownString(H,{supportThemeIcons:fe}),"f")}get value(){return Ue(this,d,"f").value}set value(H){Ue(this,d,"f").value=H}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(H){Ue(this,d,"f").isTrusted=H}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}set supportThemeIcons(H){Ue(this,d,"f").supportThemeIcons=H}get supportHtml(){return Ue(this,d,"f").supportHtml}set supportHtml(H){Ue(this,d,"f").supportHtml=H}get baseUri(){return Ue(this,d,"f").baseUri}set baseUri(H){Ue(this,d,"f").baseUri=H}appendText(H){return Ue(this,d,"f").appendText(H),this}appendMarkdown(H){return Ue(this,d,"f").appendMarkdown(H),this}appendCodeblock(H,fe){return Ue(this,d,"f").appendCodeblock(fe??"",H),this}};d=new WeakMap,st=E=qe([N],st),e.MarkdownString=st;let ht=class{constructor(H,fe){this.label=H,this.documentation=fe}};ht=qe([N],ht),e.ParameterInformation=ht;let Me=class{constructor(H,fe){this.label=H,this.documentation=fe,this.parameters=[]}};Me=qe([N],Me),e.SignatureInformation=Me;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([N],it),e.SignatureHelp=it;var oe;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let ce=class{constructor(H){this.value=H}};ce=qe([N],ce),e.InlayHintLabelPart=ce;let Ie=class{constructor(H,fe,Te){this.position=H,this.label=fe,this.kind=Te}};Ie=qe([N],Ie),e.InlayHint=Ie;var Le;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var xe;(function(x){x[x.Deprecated=1]="Deprecated"})(xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(H,fe){this.label=H,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([N],Ze),e.CompletionItem=Ze;let gt=class{constructor(H=[],fe=!1){this.items=H,this.isIncomplete=fe}};gt=qe([N],gt),e.CompletionList=gt;let mt=class{constructor(H,fe,Te){this.insertText=H,this.range=fe,this.command=Te}};mt=qe([N],mt),e.InlineSuggestion=mt;let lt=class{constructor(H){this.commands=void 0,this.items=H}};lt=qe([N],lt),e.InlineSuggestionList=lt;var ot;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var kt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(kt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Tt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function H(fe){switch(fe){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=H}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(H,fe){if(fe&&!D.URI.isUri(fe))throw(0,t.illegalArgument)("target");if(!_.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.target=fe}};Ft=qe([N],Ft),e.DocumentLink=Ft;let Xe=class{constructor(H,fe,Te,Ke){this.red=H,this.green=fe,this.blue=Te,this.alpha=Ke}};Xe=qe([N],Xe),e.Color=Xe;let Mt=class{constructor(H,fe){if(fe&&!(fe instanceof Xe))throw(0,t.illegalArgument)("color");if(!_.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.color=fe}};Mt=qe([N],Mt),e.ColorInformation=Mt;let Ut=class{constructor(H){if(!H||typeof H!="string")throw(0,t.illegalArgument)("label");this.label=H}};Ut=qe([N],Ut),e.ColorPresentation=Ut;var Bt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Bt=e.ColorFormat||(e.ColorFormat={}));var wt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Pt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(Pt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(H,fe,Te){if(this.startIndex=H,this.length=fe,this.tooltip=Te,typeof H!="number"||H<0)throw(0,t.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Oe{constructor(H){this.uri=H}}e.TerminalQuickFixOpener=Oe;class Se{constructor(H){this.terminalCommand=H}}e.TerminalQuickFixCommand=Se;var re;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(H){if(this.options=H,typeof H!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Fe;var $e;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=T=class{static from(H){switch(H){case"clean":return T.Clean;case"build":return T.Build;case"rebuild":return T.Rebuild;case"test":return T.Test;default:return}}constructor(H,fe){if(this.label=fe,typeof H!="string"||typeof fe!="string")throw(0,t.illegalArgument)("name");this.c=H}get id(){return this.c}};Ve.Clean=new T("clean","Clean"),Ve.Build=new T("build","Build"),Ve.Rebuild=new T("rebuild","Rebuild"),Ve.Test=new T("test","Test"),Ve=T=qe([N],Ve),e.TaskGroup=Ve;function tt(x){let H="";for(let fe=0;fe<x.length;fe++)H+=x[fe].replace(/,/g,",,")+",";return H}let St=class{constructor(H,fe,Te){if(typeof H!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=H,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Te):this.f=fe)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,t.illegalArgument)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)H.push(fe);return tt(H)}};St=qe([N],St),e.ProcessExecution=St;let Et=class{constructor(H,fe,Te){if(this.f=[],Array.isArray(fe)){if(!H)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this.e=H,this.f=fe,this.g=Te}else{if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this.c=H,this.g=fe}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)H.push(typeof fe=="string"?fe:fe.value);return tt(H)}};Et=qe([N],Et),e.ShellExecution=Et;var Lt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Lt=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class It{constructor(H){this.c=H}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(H){this.c=H}get callback(){return this.c}}e.CustomExecution=It;let ft=M=class{constructor(H,fe,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=H;let dt;typeof fe=="string"?(this.m=this.name=fe,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):fe===vt.Global||fe===vt.Workspace?(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(H){this.h=H}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof St?this.k={type:M.e,id:this.n.computeId()}:this.n instanceof Et?this.k={type:M.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:M.c,id:this.n.computeId()}:this.k={type:M.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(H){if(H==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=H}get scope(){return this.l}set target(H){this.y(),this.l=H}get name(){return this.m}set name(H){if(typeof H!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=H}get execution(){return this.n}set execution(H){H===null&&(H=void 0),this.y(),this.n=H;const fe=this.k.type;(M.g===fe||M.e===fe||M.f===fe||M.c===fe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(H){if(Array.isArray(H))this.y(),this.o=H,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.y(),this.r=H}get source(){return this.t}set source(H){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=H}get group(){return this.u}set group(H){H===null&&(H=void 0),this.y(),this.u=H}get detail(){return this.x}set detail(H){H===null&&(H=void 0),this.x=H}get presentationOptions(){return this.v}set presentationOptions(H){H==null&&(H=Object.create(null)),this.y(),this.v=H}get runOptions(){return this.w}set runOptions(H){H==null&&(H=Object.create(null)),this.y(),this.w=H}};ft.c="customExecution",ft.e="process",ft.f="shell",ft.g="$empty",ft=M=qe([N],ft),e.Task=ft;var Gt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Gt=e.ProgressLocation||(e.ProgressLocation={}));var jt;(function(x){function H(fe){const Te=fe;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}x.isViewBadge=H})(jt=e.ViewBadge||(e.ViewBadge={}));let yt=K=class{static isTreeItem(H,fe){if(H instanceof K)return!0;const Te=H;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!D.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!D.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!D.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!D.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<_t.None&&Te.collapsibleState>_t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,S.checkProposedApiEnabled)(fe,"treeItemCheckbox");const Ke=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==sn.Checked&&Ke!==sn.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(H,fe=_t.None){this.collapsibleState=fe,D.URI.isUri(H)?this.resourceUri=H:this.label=H}};yt=K=qe([N],yt),e.TreeItem=yt;var _t;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var sn;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(sn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let en=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H,fe){this.value=H,this.id=fe??(0,L.generateUuid)()}};en=qe([N],en),e.DataTransferItem=en;let vn=class{constructor(H){h.set(this,new Map);for(const[fe,Te]of H??[]){const Ke=Ue(this,h,"f").get(fe);Ke?Ke.push(Te):Ue(this,h,"f").set(fe,[Te])}}get(H){return Ue(this,h,"f").get(H)?.[0]}set(H,fe){Ue(this,h,"f").set(H,[fe])}forEach(H,fe){for(const[Te,Ke]of Ue(this,h,"f"))for(const Ye of Ke)H.call(fe,Ye,Te,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[H,fe]of Ue(this,h,"f"))for(const Te of fe)yield[H,Te]}};vn=qe([N],vn),e.DataTransfer=vn;let At=class{constructor(H){this.insertText=H}};At=qe([N],At),e.DocumentDropEdit=At;let on=class{constructor(H){this.insertText=H}};on=qe([N],on),e.DocumentPasteEdit=on;let Vt=class{constructor(H,fe){this.id=H,this.color=fe}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};Vt=qe([N],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let tn=class{constructor(H){this.id=H}};tn=qe([N],tn),e.ThemeColor=tn;var an;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(an=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{get base(){return this.c}set base(H){this.c=H,this.e=D.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,fe){if(typeof H!="string"&&(!H||!D.URI.isUri(H)&&!D.URI.isUri(H.uri)))throw(0,t.illegalArgument)("base");if(typeof fe!="string")throw(0,t.illegalArgument)("pattern");typeof H=="string"?this.baseUri=D.URI.file(H):D.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ut=qe([N],ut),e.RelativePattern=ut;const On=new WeakMap;function Qt(x,H){On.set(x,H)}e.setBreakpointId=Qt;let Wt=class{constructor(H,fe,Te,Ke){this.enabled=typeof H=="boolean"?H:!0,typeof fe=="string"&&(this.condition=fe),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=On.get(this)??(0,L.generateUuid)()),this.c}};Wt=qe([N],Wt),e.Breakpoint=Wt;let cn=class extends Wt{constructor(H,fe,Te,Ke,Ye){if(super(fe,Te,Ke,Ye),H===null)throw(0,t.illegalArgument)("location");this.location=H}};cn=qe([N],cn),e.SourceBreakpoint=cn;let En=class extends Wt{constructor(H,fe,Te,Ke,Ye){super(fe,Te,Ke,Ye),this.functionName=H}};En=qe([N],En),e.FunctionBreakpoint=En;let ln=class extends Wt{constructor(H,fe,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!fe)throw(0,t.illegalArgument)("dataId");this.label=H,this.dataId=fe,this.canPersist=Te}};ln=qe([N],ln),e.DataBreakpoint=ln;let Sn=class{constructor(H,fe,Te){this.command=H,this.args=fe||[],this.options=Te}};Sn=qe([N],Sn),e.DebugAdapterExecutable=Sn;let un=class{constructor(H,fe){this.port=H,this.host=fe}};un=qe([N],un),e.DebugAdapterServer=un;let nn=class{constructor(H){this.path=H}};nn=qe([N],nn),e.DebugAdapterNamedPipeServer=nn;let yn=class{constructor(H){this.implementation=H}};yn=qe([N],yn),e.DebugAdapterInlineImplementation=yn;let rn=class{constructor(H,fe){this.range=H,this.expression=fe}};rn=qe([N],rn),e.EvaluatableExpression=rn;var Cn;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Dn=class{constructor(H,fe){this.range=H,this.text=fe}};Dn=qe([N],Dn),e.InlineValueText=Dn;let In=class{constructor(H,fe,Te=!0){this.range=H,this.variableName=fe,this.caseSensitiveLookup=Te}};In=qe([N],In),e.InlineValueVariableLookup=In;let Yt=class{constructor(H,fe){this.range=H,this.expression=fe}};Yt=qe([N],Yt),e.InlineValueEvaluatableExpression=Yt;let kn=class{constructor(H,fe){this.frameId=H,this.stoppedLocation=fe}};kn=qe([N],kn),e.InlineValueContext=kn;var zn;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(zn=e.FileChangeType||(e.FileChangeType={}));let Tn=V=class extends Error{static FileExists(H){return new V(H,P.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(H){return new V(H,P.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(H){return new V(H,P.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(H){return new V(H,P.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(H){return new V(H,P.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(H){return new V(H,P.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(H,fe=P.FileSystemProviderErrorCode.Unknown,Te){super(D.URI.isUri(H)?H.toString(!0):H),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,fe),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Tn=V=qe([N],Tn),e.FileSystemError=Tn;let Pn=class{constructor(H,fe,Te){this.start=H,this.end=fe,this.kind=Te}};Pn=qe([N],Pn),e.FoldingRange=Pn;var $n;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})($n=e.FoldingRangeKind||(e.FoldingRangeKind={}));var An;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(An=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Nn;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Nn=e.CommentMode||(e.CommentMode={}));var Fn;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Fn=e.CommentThreadState||(e.CommentThreadState={}));class He{constructor(H,fe=[]){this.tokenTypes=H,this.tokenModifiers=fe}}e.SemanticTokensLegend=He;function Kt(x){return typeof x>"u"||(0,y.isStringArray)(x)}class dn{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,H){this.l=!0;for(let fe=0,Te=H.tokenTypes.length;fe<Te;fe++)this.j.set(H.tokenTypes[fe],fe);for(let fe=0,Te=H.tokenModifiers.length;fe<Te;fe++)this.k.set(H.tokenModifiers[fe],fe)}}push(H,fe,Te,Ke,Ye){if(typeof H=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(H,fe,Te,Ke,Ye);if(_.isRange(H)&&typeof fe=="string"&&Kt(Te))return this.m(H,fe,Te);throw(0,t.illegalArgument)()}m(H,fe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ke=H.start.line,Ye=H.start.character,ct=H.end.character-H.start.character,dt=this.j.get(fe);let Ot=0;if(Te)for(const Ht of Te){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Ot|=1<<qt>>>0}this.n(Ke,Ye,ct,dt,Ot)}n(H,fe,Te,Ke,Ye){if(this.f&&(H<this.c||H===this.c&&fe<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Ht=0,qt=0;for(let Xt=0;Xt<Ot;Xt++){let Jt=this.g[5*Xt],Rn=this.g[5*Xt+1];Jt===0?(Jt=Ht,Rn+=qt):Jt+=Ht,this.g[5*Xt]=Jt,this.g[5*Xt+1]=Rn,Ht=Jt,qt=Rn}}let ct=H,dt=fe;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=H,this.e=fe}static o(H){const fe=[],Te=H.length/5|0;for(let dt=0;dt<Te;dt++)fe[dt]=dt;fe.sort((dt,Ot)=>{const Ht=H[5*dt],qt=H[5*Ot];if(Ht===qt){const Xt=H[5*dt+1],Jt=H[5*Ot+1];return Xt-Jt}return Ht-qt});const Ke=new Uint32Array(H.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Ot=5*fe[dt],Ht=H[Ot+0],qt=H[Ot+1],Xt=H[Ot+2],Jt=H[Ot+3],Rn=H[Ot+4],ni=Ht-Ye,Ai=ni===0?qt-ct:qt,Ln=5*dt;Ke[Ln+0]=ni,Ke[Ln+1]=Ai,Ke[Ln+2]=Xt,Ke[Ln+3]=Jt,Ke[Ln+4]=Rn,Ye=Ht,ct=qt}return Ke}build(H){return this.f?new bt(new Uint32Array(this.g),H):new bt(dn.o(this.g),H)}}e.SemanticTokensBuilder=dn;class bt{constructor(H,fe){this.resultId=fe,this.data=H}}e.SemanticTokens=bt;class Wn{constructor(H,fe,Te){this.start=H,this.deleteCount=fe,this.data=Te}}e.SemanticTokensEdit=Wn;class Hn{constructor(H,fe){this.resultId=fe,this.edits=H}}e.SemanticTokensEdits=Hn;var Mn;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Mn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let hn=class{constructor(){}};hn.Back={iconPath:new Vt("arrow-left")},hn=qe([N],hn),e.QuickInputButtons=hn;var fn;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(fn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var jn;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(jn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Vn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Vn=e.ExtensionKind||(e.ExtensionKind={}));class qn{static validate(H){if(typeof H.badge=="string"){let fe=(0,A.nextCharLength)(H.badge,0);if(fe<H.badge.length&&(fe+=(0,A.nextCharLength)(H.badge,fe)),H.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Vt.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,fe,Te){this.badge=H,this.tooltip=fe,this.color=Te}}e.FileDecoration=qn;let mn=class{constructor(H){this.kind=H}};mn=qe([N],mn),e.ColorTheme=mn;var Gn;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(Gn=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(H){return H instanceof xt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,fe){if(H<0)throw(0,t.illegalArgument)("start must be positive");if(fe<0)throw(0,t.illegalArgument)("end must be positive");H<=fe?(this.c=H,this.e=fe):(this.c=fe,this.e=H)}with(H){let fe=this.c,Te=this.e;return H.start!==void 0&&(fe=H.start),H.end!==void 0&&(Te=H.end),fe===this.c&&Te===this.e?this:new xt(fe,Te)}}e.NotebookRange=xt;class gn{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(fe=>gn.isNotebookCellData(fe))}static isNotebookCellData(H){return!0}constructor(H,fe,Te,Ke,Ye,ct,dt){this.kind=H,this.value=fe,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,gn.validate(this)}}e.NotebookCellData=gn;class Kn{constructor(H){this.cells=H}}e.NotebookData=Kn;class $t{static isNotebookCellOutputItem(H){return H instanceof $t?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const fe={name:H.name,message:H.message,stack:H.stack};return $t.json(fe,"application/vnd.code.notebook.error")}static stdout(H){return $t.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return $t.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,fe="application/octet-stream"){return new $t(H,fe)}static text(H,fe=I.Mimes.text){const Te=Ue($t,b,"f",g).encode(String(H));return new $t(Te,fe)}static json(H,fe="text/x-json"){const Te=JSON.stringify(H,void 0,"	");return $t.text(Te,fe)}constructor(H,fe){this.data=H,this.mime=fe;const Te=(0,I.normalizeMimeType)(fe,!0);if(!Te)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=$t,b=$t,g={value:new TextEncoder};class pn{static isNotebookCellOutput(H){return H instanceof pn?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,fe=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<H.length;Ye++){const ct=H[Ye],dt=(0,I.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,C.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),fe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?H:H.filter((Ye,ct)=>!Ke.has(ct))}constructor(H,fe,Te){this.items=pn.ensureUniqueMimeTypes(H,!0),typeof fe=="string"?(this.id=fe,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=fe??Te)}}e.NotebookCellOutput=pn;var me;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(me=e.NotebookCellKind||(e.NotebookCellKind={}));var Ee;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Ee=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ze=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var at;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(at=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ct{constructor(H,fe){this.text=H,this.alignment=fe}}e.NotebookCellStatusBarItem=Ct;var Rt;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Rt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var oi;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(oi=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ai{constructor(H,fe=[]){this.uri=H,this.provides=(0,o.asArray)(fe)}}e.NotebookRendererScript=ai;class ci{constructor(H){this.label=H}}e.NotebookKernelSourceAction=ci;let xn=class{constructor(H,fe){this.label=H,this.timestamp=fe}};xn=qe([N],xn),e.TimelineItem=xn;var li;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(li=e.ExtensionMode||(e.ExtensionMode={}));var ui;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(ui=e.ExtensionRuntime||(e.ExtensionRuntime={}));var di;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(di=e.StandardTokenType||(e.StandardTokenType={}));class hi{constructor(H,fe){this.ranges=H,this.wordPattern=fe}}e.LinkedEditingRanges=hi;class fi{constructor(H,fe){this.c=H,this.e=fe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=fi;var mi;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(mi=e.TestResultState||(e.TestResultState={}));var gi;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(gi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Xn=class{constructor(H=void 0,fe=void 0,Te=void 0){this.include=H,this.exclude=fe,this.profile=Te}};Xn=qe([N],Xn),e.TestRunRequest=Xn;let _n=F=class{static diff(H,fe,Te){const Ke=new F(H);return Ke.expectedOutput=fe,Ke.actualOutput=Te,Ke}constructor(H){this.message=H}};_n=F=qe([N],_n),e.TestMessage=_n;let Qn=class{constructor(H){this.id=H}};Qn=qe([N],Qn),e.TestTag=Qn;let bn=class{constructor(H,fe){this.covered=H,this.total=fe}};bn=qe([N],bn),e.CoveredCount=bn;let Yn=U=class{static fromDetails(H,fe){const Te=new bn(0,0),Ke=new bn(0,0),Ye=new bn(0,0);for(const dt of fe)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ot of dt.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new U(H,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=fe,ct}constructor(H,fe,Te,Ke){this.uri=H,this.statementCoverage=fe,this.branchCoverage=Te,this.functionCoverage=Ke}};Yn=U=qe([N],Yn),e.FileCoverage=Yn;let Jn=class{constructor(H,fe,Te=[]){this.executionCount=H,this.location=fe,this.branches=Te}};Jn=qe([N],Jn),e.StatementCoverage=Jn;let Zn=class{constructor(H,fe){this.executionCount=H,this.location=fe}};Zn=qe([N],Zn),e.BranchCoverage=Zn;let ei=class{constructor(H,fe){this.executionCount=H,this.location=fe}};ei=qe([N],ei),e.FunctionCoverage=ei;var pi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(pi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bi;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(bi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(wi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class vi{constructor(H,fe,Te,Ke,Ye,ct){this.kind=H,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=vi;class Ei{constructor(H){this.uri=H}}e.TextTabInput=Ei;class Si{constructor(H,fe){this.original=H,this.modified=fe}}e.TextDiffTabInput=Si;class yi{constructor(H,fe,Te,Ke){this.base=H,this.input1=fe,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=yi;class Ci{constructor(H,fe){this.uri=H,this.viewType=fe}}e.CustomEditorTabInput=Ci;class Di{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=Di;class Ii{constructor(H,fe){this.uri=H,this.notebookType=fe}}e.NotebookEditorTabInput=Ii;class ki{constructor(H,fe,Te){this.original=H,this.modified=fe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=ki;class Ti{constructor(){}}e.TerminalEditorTabInput=Ti;class Pi{constructor(H,fe){this.uri=H,this.inputBoxUri=fe}}e.InteractiveWindowInput=Pi}),define(ye[135],Ce([1,0,50,15,8,164,105,7,18]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const D=new Map;function L(S,m){m?D.set(S,m):D.delete(S)}e.setWordDefinitionFor=L;function P(S){return D.get(S)}class v extends R.MirrorTextModel{constructor(m,d,h,b,g,p,w,i){super(d,h,b,g),this.m=m,this.p=p,this.q=w,this.notebook=i,this.b=!1}dispose(){(0,o.ok)(!this.b),this.b=!0,this.q=!1}equalLines(m){return(0,y.equals)(this.d,m)}get document(){if(!this.a){const m=this;this.a={get uri(){return m.c},get fileName(){return m.c.fsPath},get isUntitled(){return m.c.scheme===t.Schemas.untitled},get languageId(){return m.p},get version(){return m.g},get isClosed(){return m.b},get isDirty(){return m.q},save(){return m.r()},getText(d){return d?m.s(d):m.getText()},get eol(){return m.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return m.d.length},lineAt(d){return m.t(d)},offsetAt(d){return m.u(d)},positionAt(d){return m.v(d)},validateRange(d){return m.w(d)},validatePosition(d){return m.x(d)},getWordRangeAtPosition(d,h){return m.y(d,h)}}}return Object.freeze(this.a)}_acceptLanguageId(m){(0,o.ok)(!this.b),this.p=m}_acceptIsDirty(m){(0,o.ok)(!this.b),this.q=m}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(m){const d=this.w(m);if(d.isEmpty)return"";if(d.isSingleLine)return this.d[d.start.line].substring(d.start.character,d.end.character);const h=this.f,b=d.start.line,g=d.end.line,p=[];p.push(this.d[b].substring(d.start.character));for(let w=b+1;w<g;w++)p.push(this.d[w]);return p.push(this.d[g].substring(0,d.end.character)),p.join(h)}t(m){let d;if(m instanceof A.Position?d=m.line:typeof m=="number"&&(d=m),typeof d!="number"||d<0||d>=this.d.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new C(d,this.d[d],d===this.d.length-1)}u(m){return m=this.x(m),this.k(),this.h.getPrefixSum(m.line-1)+m.character}v(m){m=Math.floor(m),m=Math.max(0,m),this.k();const d=this.h.getIndexOf(m),h=this.d[d.index].length;return new A.Position(d.index,Math.min(d.remainder,h))}w(m){if(!(m instanceof A.Range))throw new Error("Invalid argument");const d=this.x(m.start),h=this.x(m.end);return d===m.start&&h===m.end?m:new A.Range(d.line,d.character,h.line,h.character)}x(m){if(!(m instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return m.with(0,0);let{line:d,character:h}=m,b=!1;if(d<0)d=0,h=0,b=!0;else if(d>=this.d.length)d=this.d.length-1,h=this.d[d].length,b=!0;else{const g=this.d[d].length;h<0?(h=0,b=!0):h>g&&(h=g,b=!0)}return b?new A.Position(d,h):m}y(m,d){const h=this.x(m);if(!d)d=P(this.p);else if((0,k.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const b=(0,I.getWordAtText)(h.character+1,(0,I.ensureValidWordDefinition)(d),this.d[h.line],0);if(b)return new A.Range(h.line,b.startColumn-1,h.line,b.endColumn-1)}}e.ExtHostDocumentData=v;class C{constructor(m,d,h){this.a=m,this.b=d,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=C}),define(ye[233],Ce([1,0,7,17,3]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(A){this.a=new o.ColorTheme(o.ColorThemeKind.Dark),this.b=new k.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=o.ColorThemeKind.Light;break;case"hcDark":y=o.ColorThemeKind.HighContrast;break;case"hcLight":y=o.ColorThemeKind.HighContrastLight;break;default:y=o.ColorThemeKind.Dark}this.a=new o.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[14],Ce([1,0,18,22,148,61,111,28,147,86,84,23,11,2,35,66,123,132,130,91,56,70,228,7]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p,w,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Re){function Oe(re){const{selectionStartLineNumber:Fe,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Ve}=re,tt=new s.Position(Fe-1,$e-1),St=new s.Position(Qe-1,Ve-1);return new s.Selection(tt,St)}Re.to=Oe;function Se(re){const{anchor:Fe,active:$e}=re;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Re.from=Se})(a=e.Selection||(e.Selection={}));var u;(function(Re){function Oe(re){if(!re)return;const{start:Fe,end:$e}=re;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Re.from=Oe;function Se(re){if(!re)return;const{startLineNumber:Fe,startColumn:$e,endLineNumber:Qe,endColumn:Ve}=re;return new s.Range(Fe-1,$e-1,Qe-1,Ve-1)}Re.to=Se})(u=e.Range||(e.Range={}));var l;(function(Re){function Oe(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=Oe})(l=e.TokenType||(e.TokenType={}));var c;(function(Re){function Oe(re){return new s.Position(re.lineNumber-1,re.column-1)}Re.to=Oe;function Se(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Se})(c=e.Position||(e.Position={}));var n;(function(Re){function Oe(Fe,$e){return(0,o.coalesce)((0,o.asArray)(Fe).map(Qe=>Se(Qe,$e)))}Re.from=Oe;function Se(Fe,$e){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:re(Fe.scheme,$e),pattern:$.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function re(Fe,$e){return $e&&typeof Fe=="string"?$e.transformOutgoingScheme(Fe):Fe}})(n=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(Re){function Oe(re){switch(re){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=Oe;function Se(re){switch(re){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Re){function Oe(re){let Fe;return re.code&&((0,v.isString)(re.code)||(0,v.isNumber)(re.code)?Fe=String(re.code):Fe={value:String(re.code.value),target:re.code.target}),{...u.from(re.range),message:re.message,source:re.source,code:Fe,severity:T.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,o.coalesce)(re.tags.map(r.from)):void 0}}Re.from=Oe;function Se(re){const Fe=new s.Diagnostic(u.to(re),re.message,T.to(re.severity));return Fe.source=re.source,Fe.code=(0,v.isString)(re.code)?re.code:re.code?.value,Fe.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Fe.tags=re.tags&&(0,o.coalesce)(re.tags.map(r.to)),Fe}Re.to=Se})(f=e.Diagnostic||(e.Diagnostic={}));var E;(function(Re){function Oe(re){return{...u.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Oe;function Se(re){return new s.DiagnosticRelatedInformation(new s.Location(re.resource,u.to(re)),re.message)}Re.to=Se})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var T;(function(Re){function Oe(re){switch(re){case s.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Re.from=Oe;function Se(re){switch(re){case d.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=Se})(T=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var M;(function(Re){function Oe(re){return typeof re=="number"&&re>=s.ViewColumn.One?re-1:re===s.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Oe;function Se(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(M=e.ViewColumn||(e.ViewColumn={}));function K(Re){return typeof Re.range<"u"}function V(Re){return Re.length===0?!0:!!K(Re[0])}e.isDecorationOptionsArr=V;var F;(function(Re){function Oe(Ve){return Ve.map(Re.from)}Re.fromMany=Oe;function Se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function re(Ve){let tt;if(Se(Ve)){const{language:vt,value:It}=Ve;tt={value:"```"+vt+`
`+It+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const St=Object.create(null);tt.uris=St;const Et=vt=>{try{let It=C.URI.parse(vt,!0);It=It.with({query:Fe(It.query,St)}),St[vt]=It}catch{}return""},Lt=new y.marked.Renderer;return Lt.link=Et,Lt.image=vt=>typeof vt=="string"?Et(I.parseHrefAndDimensions(vt).href):"",(0,y.marked)(tt.value,{renderer:Lt}),tt}Re.from=re;function Fe(Ve,tt){if(!Ve)return Ve;let St;try{St=(0,D.parse)(Ve)}catch{}if(!St)return Ve;let Et=!1;return St=(0,P.cloneAndChange)(St,Lt=>{if(C.URI.isUri(Lt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[vt]=Lt,Et=!0,vt}else return}),Et?JSON.stringify(St):Ve}function $e(Ve){const tt=new s.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?C.URI.from(Ve.baseUri):void 0,tt}Re.to=$e;function Qe(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Re.from(Ve)}Re.fromStrict=Qe})(F=e.MarkdownString||(e.MarkdownString={}));function U(Re){return V(Re)?Re.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?F.fromMany(Oe.hoverMessage):Oe.hoverMessage?F.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Re.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=U;function N(Re){return typeof Re>"u"?Re:typeof Re=="string"?C.URI.file(Re):Re}e.pathOrURIToURI=N;var B;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?N(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Oe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var j;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?N(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Re.from=Oe})(j=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(Re){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Oe})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ne;(function(Re){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?z.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?j.from(Se.light):void 0,dark:Se.dark?j.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?N(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Re.from=Oe})(ne=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _;(function(Re){function Oe(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:u.from(re.range)}}Re.from=Oe;function Se(re){const Fe=new s.TextEdit(u.to(re.range),re.text);return Fe.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Fe}Re.to=Se})(_=e.TextEdit||(e.TextEdit={}));var Y;(function(Re){function Oe(re,Fe){const $e={edits:[]};if(re instanceof s.WorkspaceEdit){const Qe=new A.ResourceSet;for(const Ve of re._allEntries())Ve._type===1&&C.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of re._allEntries())Ve._type===1?$e.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?$e.edits.push({resource:Ve.uri,textEdit:_.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?$e.edits.push({resource:Ve.uri,textEdit:{range:u.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(gt.from)}})}return $e}Re.from=Oe;function Se(re){const Fe=new s.WorkspaceEdit;for(const $e of re.edits)$e.textEdit?Fe.replace(C.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Fe.renameFile(C.URI.revive($e.oldResource),C.URI.revive($e.newResource),$e.options);return Fe}Re.to=Se})(Y=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Re.from=Se;function re(Fe){for(const $e in Oe)if(Oe[$e]===Fe)return Number($e);return s.SymbolKind.Property}Re.to=re})(J=e.SymbolKind||(e.SymbolKind={}));var ee;(function(Re){function Oe(re){switch(re){case s.SymbolTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return s.SymbolTag.Deprecated}}Re.to=Se})(ee=e.SymbolTag||(e.SymbolTag={}));var ge;(function(Re){function Oe(re){return{name:re.name,kind:J.from(re.kind),tags:re.tags&&re.tags.map(ee.from),containerName:re.containerName,location:ve.from(re.location)}}Re.from=Oe;function Se(re){const Fe=new s.SymbolInformation(re.name,J.to(re.kind),re.containerName,ve.to(re.location));return Fe.tags=re.tags&&re.tags.map(ee.to),Fe}Re.to=Se})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(Re){function Oe(re){const Fe={name:re.name||"!!MISSING: name!!",detail:re.detail,range:u.from(re.range),selectionRange:u.from(re.selectionRange),kind:J.from(re.kind),tags:re.tags?.map(ee.from)??[]};return re.children&&(Fe.children=re.children.map(Oe)),Fe}Re.from=Oe;function Se(re){const Fe=new s.DocumentSymbol(re.name,re.detail,J.to(re.kind),u.to(re.range),u.to(re.selectionRange));return(0,o.isNonEmptyArray)(re.tags)&&(Fe.tags=re.tags.map(ee.to)),re.children&&(Fe.children=re.children.map(Se)),Fe}Re.to=Se})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(Re){function Oe(re){const Fe=new s.CallHierarchyItem(J.to(re.kind),re.name,re.detail||"",C.URI.revive(re.uri),u.to(re.range),u.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Re.to=Oe;function Se(re,Fe,$e){if(Fe=Fe??re._sessionId,$e=$e??re._itemId,Fe===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:$e,name:re.name,detail:re.detail,kind:J.from(re.kind),uri:re.uri,range:u.from(re.range),selectionRange:u.from(re.selectionRange),tags:re.tags?.map(ee.from)}}Re.from=Se})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var le;(function(Re){function Oe(Se){return new s.CallHierarchyIncomingCall(G.to(Se.from),Se.fromRanges.map(re=>u.to(re)))}Re.to=Oe})(le=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(Re){function Oe(Se){return new s.CallHierarchyOutgoingCall(G.to(Se.to),Se.fromRanges.map(re=>u.to(re)))}Re.to=Oe})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Re){function Oe(re){return{range:re.range&&u.from(re.range),uri:re.uri}}Re.from=Oe;function Se(re){return new s.Location(C.URI.revive(re.uri),u.to(re.range))}Re.to=Se})(ve=e.location||(e.location={}));var Pe;(function(Re){function Oe(re){const Fe=re,$e=re;return{originSelectionRange:Fe.originSelectionRange?u.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:$e.uri,range:u.from(Fe.targetRange?Fe.targetRange:$e.range),targetSelectionRange:Fe.targetSelectionRange?u.from(Fe.targetSelectionRange):void 0}}Re.from=Oe;function Se(re){return{targetUri:C.URI.revive(re.uri),targetRange:u.to(re.range),targetSelectionRange:re.targetSelectionRange?u.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?u.to(re.originSelectionRange):void 0}}Re.to=Se})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Ne;(function(Re){function Oe(re){return{range:u.from(re.range),contents:F.fromMany(re.contents)}}Re.from=Oe;function Se(re){return new s.Hover(re.contents.map(F.to),u.to(re.range))}Re.to=Se})(Ne=e.Hover||(e.Hover={}));var se;(function(Re){function Oe(re){return{range:u.from(re.range),expression:re.expression}}Re.from=Oe;function Se(re){return new s.EvaluatableExpression(u.to(re.range),re.expression)}Re.to=Se})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ue;(function(Re){function Oe(re){if(re instanceof s.InlineValueText)return{type:"text",range:u.from(re.range),text:re.text};if(re instanceof s.InlineValueVariableLookup)return{type:"variable",range:u.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Oe;function Se(re){switch(re.type){case"text":return{range:u.to(re.range),text:re.text};case"variable":return{range:u.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:u.to(re.range),expression:re.expression}}}Re.to=Se})(ue=e.InlineValue||(e.InlineValue={}));var de;(function(Re){function Oe(re){return{frameId:re.frameId,stoppedLocation:u.from(re.stoppedLocation)}}Re.from=Oe;function Se(re){return new s.InlineValueContext(re.frameId,u.to(re.stoppedLocation))}Re.to=Se})(de=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Re){function Oe(re){return{range:u.from(re.range),kind:re.kind}}Re.from=Oe;function Se(re){return new s.DocumentHighlight(u.to(re.range),re.kind)}Re.to=Se})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Re){function Oe(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=Oe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(Re){function Oe(Se){return{triggerKind:ae.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Oe})(ie=e.CompletionContext||(e.CompletionContext={}));var O;(function(Re){function Oe(re){switch(re){case s.CompletionItemTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return s.CompletionItemTag.Deprecated}}Re.to=Se})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Re){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se($e){return Oe.get($e)??9}Re.from=Se;const re=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe($e){return re.get($e)??s.CompletionItemKind.Property}Re.to=Fe})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(Re){function Oe(Se,re){const Fe=new s.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=W.to(Se.kind),Fe.tags=Se.tags?.map(O.to),Fe.detail=Se.detail,Fe.documentation=I.isMarkdownString(Se.documentation)?F.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,S.Range.isIRange(Se.range)?Fe.range=u.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:u.to(Se.range.insert),replacing:u.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new s.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof s.Range?new s.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map($e=>_.to($e))),Fe.command=re&&Se.command?re.fromInternal(Se.command):void 0,Fe}Re.to=Oe})(X=e.CompletionItem||(e.CompletionItem={}));var Q;(function(Re){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:F.fromStrict(re.documentation)}}Re.from=Oe;function Se(re){return{label:re.label,documentation:I.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation}}Re.to=Se})(Q=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Re){function Oe(re){return{label:re.label,documentation:F.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Q.from):[],activeParameter:re.activeParameter}}Re.from=Oe;function Se(re){return{label:re.label,documentation:I.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Q.to):[],activeParameter:re.activeParameter}}Re.to=Se})(he=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Re){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.from):[]}}Re.from=Oe;function Se(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.to):[]}}Re.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Oe(Se,re){const Fe=new s.InlayHint(c.to(re.position),typeof re.label=="string"?re.label:re.label.map(pe.to.bind(void 0,Se)),re.kind&&De.to(re.kind));return Fe.textEdits=re.textEdits&&re.textEdits.map(_.to),Fe.tooltip=I.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,Fe.paddingLeft=re.paddingLeft,Fe.paddingRight=re.paddingRight,Fe}Re.to=Oe})(Ae=e.InlayHint||(e.InlayHint={}));var pe;(function(Re){function Oe(Se,re){const Fe=new s.InlayHintLabelPart(re.label);return Fe.tooltip=I.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,m.Command.is(re.command)&&(Fe.command=Se.fromInternal(re.command)),re.location&&(Fe.location=ve.to(re.location)),Fe}Re.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Re){function Oe(re){return re}Re.from=Oe;function Se(re){return re}Re.to=Se})(De=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Re){function Oe(re){return{range:u.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Oe;function Se(re){let Fe;if(re.url)try{Fe=typeof re.url=="string"?C.URI.parse(re.url,!0):C.URI.revive(re.url)}catch{}return new s.DocumentLink(u.to(re.range),Fe)}Re.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Re){function Oe(re){const Fe=new s.ColorPresentation(re.label);return re.textEdit&&(Fe.textEdit=_.to(re.textEdit)),re.additionalTextEdits&&(Fe.additionalTextEdits=re.additionalTextEdits.map($e=>_.to($e))),Fe}Re.to=Oe;function Se(re){return{label:re.label,textEdit:re.textEdit?_.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Fe=>_.from(Fe)):void 0}}Re.from=Se})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Re){function Oe(re){return new s.Color(re[0],re[1],re[2],re[3])}Re.to=Oe;function Se(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Se})(Ge=e.Color||(e.Color={}));var et;(function(Re){function Oe(re){return{range:u.from(re.range)}}Re.from=Oe;function Se(re){return new s.SelectionRange(u.to(re.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Re){function Oe(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=Oe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Oe(re){switch(re){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Oe;function Se(re){switch(re){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Oe(re){if(re===s.EndOfLine.CRLF)return 1;if(re===s.EndOfLine.LF)return 0}Re.from=Oe;function Se(re){if(re===1)return s.EndOfLine.CRLF;if(re===0)return s.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(Re){function Oe(Se){const re={start:Se.start+1,end:Se.end+1};return Se.kind&&(re.kind=it.from(Se.kind)),re}Re.from=Oe})(Me=e.FoldingRange||(e.FoldingRange={}));var it;(function(Re){function Oe(Se){if(Se)switch(Se){case s.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Re.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(Re){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?u.from(Se.selection):void 0,override:typeof Se.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Oe})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Re){function Oe($e){return $e instanceof s.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Se($e)||re($e)?new s.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Re.from=Oe;function Se($e){const Qe=$e;return Qe?C.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function re($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Fe($e){return typeof $e=="string"?$e:new s.RelativePattern(C.URI.revive($e.baseUri),$e.pattern)}Re.to=Fe})($=e.GlobPattern||(e.GlobPattern={}));var ce;(function(Re){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const re=Se;return{language:re.language,scheme:re.scheme,pattern:$.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Oe})(ce=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Oe(re){return{start:re.start,end:re.end}}Re.from=Oe;function Se(re){return new s.NotebookRange(re.start,re.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Oe;function Se(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Re){function Oe(Se){if(Se===g.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===g.NotebookCellExecutionState.Pending)return;if(Se===g.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xe;(function(Re){function Oe(re){switch(re){case s.NotebookCellKind.Markup:return g.CellKind.Markup;case s.NotebookCellKind.Code:default:return g.CellKind.Code}}Re.from=Oe;function Se(re){switch(re){case g.CellKind.Markup:return s.NotebookCellKind.Markup;case g.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=Se})(xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Oe(re){const Fe={metadata:re.metadata??Object.create(null),cells:[]};for(const $e of re.cells)s.NotebookCellData.validate($e),Fe.cells.push(gt.from($e));return Fe}Re.from=Oe;function Se(re){const Fe=new s.NotebookData(re.cells.map(gt.to));return(0,v.isEmptyObject)(re.metadata)||(Fe.metadata=re.metadata),Fe}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var gt;(function(Re){function Oe(re){return{cellKind:xe.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(lt.from):[]}}Re.from=Oe;function Se(re){return new s.NotebookCellData(xe.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(lt.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Re.to=Se})(gt=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Re){function Oe(re){return{mime:re.mime,valueBytes:t.VSBuffer.wrap(re.data)}}Re.from=Oe;function Se(re){return new s.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Re.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Re){function Oe(re){return{outputId:re.id,items:re.items.map(mt.from),metadata:re.metadata}}Re.from=Oe;function Se(re){const Fe=re.items.map(mt.to);return new s.NotebookCellOutput(Fe,re.outputId,re.metadata)}Re.to=Se})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Re){function Oe(Fe){return re(Fe)?{include:(0,v.withNullAsUndefined)($.from(Fe.include)),exclude:(0,v.withNullAsUndefined)($.from(Fe.exclude))}:(0,v.withNullAsUndefined)($.from(Fe))}Re.from=Oe;function Se(Fe){return re(Fe)?{include:$.to(Fe.include),exclude:$.to(Fe.exclude)}:$.to(Fe)}Re.to=Se;function re(Fe){const $e=Fe;return $e?!(0,v.isUndefinedOrNull)($e.include)&&!(0,v.isUndefinedOrNull)($e.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Re){function Oe(Se,re,Fe){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal($e,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var kt;(function(Re){function Oe(Se,re,Fe){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:re.toInternal($e,Fe),label:Se.label,description:Se.description,detail:Se.detail}}Re.from=Oe})(kt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Tt;(function(Re){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Oe})(Tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Nt;(function(Re){function Oe(re){return{uri:re.uri,provides:re.provides}}Re.from=Oe;function Se(re){return new s.NotebookRendererScript(C.URI.revive(re.uri),re.provides)}Re.to=Se})(Nt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Re){function Oe(re){return{message:F.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:u.from(re.location.range),uri:re.location.uri}}}Re.from=Oe;function Se(re){const Fe=new s.TestMessage(typeof re.message=="string"?re.message:F.to(re.message));return Fe.actualOutput=re.actual,Fe.expectedOutput=re.expected,Fe.location=re.location?ve.to(re.location):void 0,Fe}Re.to=Se})(pt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Re){Re.namespace=w.namespaceTestTag,Re.denamespace=w.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var zt;(function(Re){function Oe(re){const Fe=(0,h.getPrivateApiFor)(re).controllerId;return{extId:p.TestId.fromExtHostTestItem(re,Fe).toString(),label:re.label,uri:C.URI.revive(re.uri),busy:re.busy,tags:re.tags.map($e=>Dt.namespace(Fe,$e.id)),range:S.Range.lift(u.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&F.fromStrict(re.error)||null}}Re.from=Oe;function Se(re){return{parent:void 0,error:void 0,id:p.TestId.fromString(re.extId).localId,label:re.label,uri:C.URI.revive(re.uri),tags:(re.tags||[]).map(Fe=>{const{tagId:$e}=Dt.denamespace(Fe);return new s.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Se})(zt=e.TestItem||(e.TestItem={})),function(Re){function Oe(re){return{id:re.id}}Re.from=Oe;function Se(re){return new s.TestTag(re.id)}Re.to=Se}(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(Re){const Oe=(re,Fe)=>{const $e=[];for(const[Ve,tt]of Fe)p.TestId.compare(tt.item.extId,Ve)===2&&(Fe.delete(Ve),$e.push(tt));const Qe={...zt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(pt.to)})),children:$e.map(Ve=>Oe(Ve,Fe))};for(const Ve of Qe.children)Ve.parent=Qe;return Qe};function Se(re){const Fe=[],$e=new Map;for(const Qe of re.items){$e.set(Qe.item.extId,Qe);const Ve=p.TestId.root(Qe.item.extId);re.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Qe.item.extId))&&Fe.push(Qe)}return{completedAt:re.completedAt,results:Fe.map(Qe=>Oe(Qe,$e))}}Re.to=Se})(Ft=e.TestResults||(e.TestResults={}));var Xe;(function(Re){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Se($e){return"line"in $e?c.from($e):u.from($e)}function re($e){return"branches"in $e?{count:$e.executionCount,location:Se($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Se(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:Se($e.location)}}Re.fromDetailed=re;function Fe($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(re)}}Re.fromFile=Fe})(Xe=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(Re){function Oe(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=Oe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Re){function Oe(re){const Fe=new s.TypeHierarchyItem(J.to(re.kind),re.name,re.detail||"",C.URI.revive(re.uri),u.to(re.range),u.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Re.to=Oe;function Se(re,Fe,$e){if(Fe=Fe??re._sessionId,$e=$e??re._itemId,Fe===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:$e,kind:J.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:u.from(re.range),selectionRange:u.from(re.selectionRange),tags:re.tags?.map(ee.from)}}Re.from=Se})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Bt;(function(Re){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Oe})(Bt=e.ViewBadge||(e.ViewBadge={}));var wt;(function(Re){function Oe($e,Qe,Ve){const tt=Qe.fileData;return tt?new class extends s.DataTransferItem{asFile(){return{name:tt.name,uri:C.URI.revive(tt.uri),data:(0,R.once)(()=>Ve())}}}("",Qe.id):$e===L.Mimes.uriList&&Qe.uriListData?new s.DataTransferItem(Fe(Qe.uriListData)):new s.DataTransferItem(Qe.asString)}Re.to=Oe;async function Se($e,Qe){const Ve=await Qe.asString();if($e===L.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:re(Ve)};const tt=Qe.asFile();return{id:Qe.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Re.from=Se;function re($e){return k.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return C.URI.parse(Qe)}catch{}return Qe})}function Fe($e){return k.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:C.URI.revive(Qe)))}})(wt=e.DataTransferItem||(e.DataTransferItem={}));var Pt;(function(Re){function Oe(re,Fe){const $e=re.items.map(([Qe,Ve])=>[Qe,wt.to(Qe,Ve,()=>Fe(Ve.id))]);return new s.DataTransfer($e)}Re.toDataTransfer=Oe;async function Se(re){const Fe={items:[]},$e=[];return re.forEach((Qe,Ve)=>{$e.push((async()=>{Fe.items.push([Ve,await wt.from(Ve,Qe)])})())}),await Promise.all($e),Fe}Re.toDataTransferDTO=Se})(Pt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[234],Ce([1,0,2,10,7,14,63]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(D,L,P,v={timeout:1500,errors:3}){this.c=D,this.d=L,this.f=P,this.g=v,this.a=new I.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(D){return(L,P,v)=>{const S={dispose:this.a.push([L,P,D])};return Array.isArray(v)&&v.push(S),S}}async $participateInSave(D,L){const P=o.URI.revive(D);let v=!1;const C=setTimeout(()=>v=!0,this.g.timeout),S=[];try{for(const m of[...this.a]){if(v)break;const d=this.d.getDocument(P),h=await this.h(m,{document:d,reason:R.TextDocumentSaveReason.to(L)});S.push(h)}}finally{clearTimeout(C)}return S}h([D,L,P],v){const C=this.b.get(D);return typeof C=="number"&&C>this.g.errors?Promise.resolve(!1):this.i(P,D,L,v).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const m=this.b.get(D);this.b.set(D,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(D,L,P,v){const C=[],S=Date.now(),{document:m,reason:d}=v,{version:h}=m,b=Object.freeze({document:m,reason:d,waitUntil(g){if(Object.isFrozen(C))throw(0,t.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(g))}});try{L.apply(P,[b])}catch(g){return Promise.reject(g)}return Object.freeze(C),new Promise((g,p)=>{const w=setTimeout(()=>p(new Error("timeout")),this.g.timeout);return Promise.all(C).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(w),g(i)}).catch(i=>{clearTimeout(w),p(i)})}).then(g=>{const p={edits:[]};for(const w of g)if(Array.isArray(w)&&w.every(i=>i instanceof k.TextEdit))for(const{newText:i,newEol:s,range:a}of w)p.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:a&&R.Range.from(a),text:i,eol:s&&R.EndOfLine.from(s)}});if(p.edits.length!==0)return h===m.version?this.f.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ye[235],Ce([1,0,15,2,14,7,91]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(P,v,C,S){this.start=P,this.deletedCount=v,this.deletedItems=C,this.items=S}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(P,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,v,C){this.notebook=P,this.h=v,this.j=C,this.handle=C.handle,this.uri=t.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(k.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return P.g},set mime(S){P.g=S},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(C)}return this.f}setOutputs(P){this.a=P.map(k.NotebookCellOutput.to)}setOutputItems(P,v,C){const S=C.map(k.NotebookCellOutputItem.to),m=this.a.find(d=>d.id===P);if(m&&(v||(m.items.length=0),m.items.push(...S),m.items.length>1&&m.items.every(d=>I.isTextStreamMime(d.mime)))){const d=new Map,h=[];m.items.forEach(b=>{let g;d.has(b.mime)?g=d.get(b.mime):(g=[],d.set(b.mime,g),h.push(b.mime)),g.push(b.data)}),m.items.length=0,h.forEach(b=>{const g=I.compressOutputItemStreams(d.get(b));m.items.push({mime:b,data:g.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=y;class D{constructor(P,v,C,S,m){this.k=P,this.l=v,this.m=C,this.uri=S,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=m.viewType,this.f=Object.freeze(m.metadata??Object.create(null)),this.r([[0,0,m.cells]],!0,void 0),this.g=m.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,v={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===o.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(C){return C=P.n(C),P.b[C].apiCell},getCells(C){return(C?P.p(C):P.b).map(m=>m.apiCell)},save(){return P.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,v,C){this.g=P.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:C});const S={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},m=[];for(const h of P.rawEvents)h.kind===I.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,S.contentChanges):h.kind===I.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,S.contentChanges):h.kind===I.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),m.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===I.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),m.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),m.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===I.NotebookCellsChangeType.ChangeCellContent?m.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===I.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),m.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),m.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const d=new Map;for(let h=0;h<m.length;h++){const b=m[h],g=d.get(b.cell);if(g===void 0){const p=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});d.set(b.cell,p-1)}else S.cellChanges[g]={...S.cellChanges[g],...b}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let v=P.start|0,C=P.end|0;return v<0&&(v=0),C>this.b.length&&(C=this.b.length),P.with({start:v,end:C})}p(P){P=this.o(P);const v=[];for(let C=P.start;C<P.end;C++)v.push(this.b[C]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,v,C){if(this.j)return;const S=[],m=[],d=[];if(P.reverse().forEach(h=>{const g=h[2].map(i=>{const s=new y(this,this.l,i);return v||m.push(y.asModelAddData(this.apiNotebook,i)),s}),p=new A(h[0],h[1],[],g),w=this.b.splice(h[0],h[1],...g);for(const i of w)d.push(i.uri),p.deletedItems.push(i.apiCell);S.push(p)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:d}),C)for(const h of S)C.push(h.asApiEvent())}s(P,v,C,S){const m=this.b.splice(P,v);this.b.splice(C,0,...m);const d=[new A(P,v,m.map(h=>h.apiCell),[]),new A(C,0,[],m)];for(const h of d)S.push(h.asApiEvent())}t(P,v){this.b[P].setOutputs(v)}u(P,v,C,S){this.b[P].setOutputItems(v,C,S)}v(P,v){const C=this.b[P];C.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(C.uri,v)}w(P,v){const C=this.b[P];C.apiCell.mime=v}x(P,v){this.b[P].setMetadata(v)}y(P,v){this.b[P].setInternalMetadata(v)}getCellFromApiCell(P){return this.b.find(v=>v.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(v=>v.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=D,D.a=0}),define(ye[136],Ce([1,0,10,14,7]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(A,y,D,L,P,v){this.id=A,this.f=y,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=v}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(k.NotebookRange.isNotebookRange))throw(0,o.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,D){A.f.$tryRevealRange(A.id,t.NotebookRange.from(y),D??k.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(t.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(ye[236],Ce([1,0,3,13,14]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(A,y){this.c=A,this.d=y,this.a=new o.Emitter,this.b=new o.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const D=this.d.getEditorById(A);y.visibleRanges&&D._acceptVisibleRanges(y.visibleRanges.ranges.map(k.NotebookRange.to)),y.selections&&D._acceptSelections(y.selections.selections.map(k.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this.d.getEditorById(y)._acceptViewColumn(k.ViewColumn.to(A[y]))}};R=qe([We(0,t.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[237],Ce([1,0,14,125,177,21,60,10]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,C,S){const m=this.b++,{title:d,location:h,cancellable:b}=C,g={label:(0,k.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(m,{location:o.ProgressLocation.from(h),title:d,source:g,cancellable:b},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.onUnexpectedExternalError),this.d(m,S,!!b)}d(v,C,S){let m;S&&(m=new R.CancellationTokenSource,this.c.set(v,m));const d=b=>{this.a.$progressEnd(b),this.c.delete(b),m?.dispose()};let h;try{h=C(new L(this.a,v),S&&m?m.token:R.CancellationToken.None)}catch(b){throw d(v),b}return h.then(b=>d(v),b=>d(v)),h}$acceptProgressCanceled(v){const C=this.c.get(v);C&&(C.cancel(),this.c.delete(v))}}e.ExtHostProgress=y;function D(P,v){return P.message=v.message,typeof v.increment=="number"&&(typeof P.increment=="number"?P.increment+=v.increment:P.increment=v.increment),P}class L extends t.Progress{constructor(v,C){super(S=>this.throttledReport(S)),this.c=v,this.d=C}throttledReport(v){this.c.$progressReport(this.d,v)}}qe([(0,I.throttle)(100,(P,v)=>D(P,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],Ce([1,0,35,132,56,92,70,14,2]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(g,p,w,i)=>{let s=p;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!w(s,a)){const u=s;s=a,g.listener?.(i(a,u))}}}},L=(g,p)=>g===p,P={range:(g,p)=>g===p?!0:!g||!p?!1:g.isEqual(p),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(g,p)=>!(g.length!==p.length||g.some(w=>!p.find(i=>w.id===i.id)))},v=g=>p=>({op:4,update:g(p)}),C=(g,p)=>({range:(()=>{let w;const i=v(s=>({range:o.Range.lift(A.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return w},set(s){g.listener?.({op:6}),P.range(w,s)||(w=s,g.listener?.(i(s)))}}})(),label:D(g,p,P.label,v(w=>({label:w}))),description:D(g,void 0,P.description,v(w=>({description:w}))),sortText:D(g,void 0,P.sortText,v(w=>({sortText:w}))),canResolveChildren:D(g,!1,P.canResolveChildren,w=>({op:2,state:w})),busy:D(g,!1,P.busy,v(w=>({busy:w}))),error:D(g,void 0,P.error,v(w=>({error:A.MarkdownString.fromStrict(w)||null}))),tags:D(g,[],P.tags,(w,i)=>({op:1,new:w.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),S=g=>{const p=k.TestId.fromString(g.extId),w=new d(p.controllerId,p.localId,g.label,y.URI.revive(g.uri)||void 0);return w.range=A.Range.to(g.range||void 0),w.description=g.description||void 0,w.sortText=g.sortText||void 0,w.tags=g.tags.map(i=>A.TestTag.to({id:(0,I.denamespaceTestTag)(i).tagId})),w},m=g=>{let p;for(const w of g.tests){const i=S(w.item);(0,t.getPrivateApiFor)(i).parent=p,p=i}return p};e.toItemFromContext=m;class d{constructor(p,w,i,s){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const a=(0,t.createPrivateApiFor)(this,p);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof h?void 0:a.parent}},children:{value:(0,R.createTestItemChildren)(a,t.getPrivateApiFor,d),enumerable:!0,writable:!1},...C(a,i)})}}e.TestItemImpl=d;class h extends d{constructor(p,w){super(p,p,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class b extends R.TestItemCollection{constructor(p,w,i){super({controllerId:p,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:t.getPrivateApiFor,getChildren:s=>s.children,root:new h(p,w),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(ye[138],Ce([1,0,50,10,100,14,7]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(v,C,S){const m=A.c.nextId();v.$registerTextEditorDecorationType(C.identifier,m,R.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:m,dispose(){v.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=A,A.c=new k.IdGenerator("TextEditorDecorationType");class y{constructor(v,C){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,C){this.k();let S=null;if(v instanceof I.Position)S=new I.Range(v,v);else if(v instanceof I.Range)S=v;else throw new Error("Unrecognized location");this.l(S,C,!1)}insert(v,C){this.k(),this.l(new I.Range(v,v),C,!0)}delete(v){this.k();let C=null;if(v instanceof I.Range)C=v;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(v,C,S){const m=this.c.validateRange(v);this.g.push({range:m,text:C,forceMoveMarkers:S})}setEndOfLine(v){if(this.k(),v!==I.EndOfLine.LF&&v!==I.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=v}}class D{constructor(v,C,S,m){this.c=v,this.d=C,this._accept(S),this.e=m;const d=this;this.value={get tabSize(){return d.f},set tabSize(h){d.m(h)},get indentSize(){return d.g},set indentSize(h){d.o(h)},get insertSpaces(){return d.h},set insertSpaces(h){d.q(h)},get cursorStyle(){return d.j},set cursorStyle(h){d.s(h)},get lineNumbers(){return d.k},set lineNumbers(h){d.t(h)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const C=Math.floor(v);return C>0?C:null}if(typeof v=="string"){const C=parseInt(v,10);return isNaN(C)?null:C>0?C:null}return null}m(v){const C=this.l(v);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const C=Math.floor(v);return C>0?C:null}if(typeof v=="string"){const C=parseInt(v,10);return isNaN(C)?null:C>0?C:null}return null}o(v){const C=this.n(v);if(C!==null){if(typeof C=="number"){if(this.g===C)return;this.g=C}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const C=this.p(v);if(typeof C=="boolean"){if(this.h===C)return;this.h=C}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const C={};let S=!1;if(typeof v.tabSize<"u"){const m=this.l(v.tabSize);m==="auto"?(S=!0,C.tabSize=m):typeof m=="number"&&this.f!==m&&(this.f=m,S=!0,C.tabSize=m)}if(typeof v.indentSize<"u"){const m=this.n(v.indentSize);m==="tabSize"?(S=!0,C.indentSize=m):typeof m=="number"&&this.g!==m&&(this.g=m,S=!0,C.indentSize=m)}if(typeof v.insertSpaces<"u"){const m=this.p(v.insertSpaces);m==="auto"?(S=!0,C.insertSpaces=m):this.h!==m&&(this.h=m,S=!0,C.insertSpaces=m)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,S=!0,C.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,S=!0,C.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,C))}u(v,C){C.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(S)})}}e.ExtHostTextEditorOptions=D;class L{constructor(v,C,S,m,d,h,b,g){this.id=v,this.j=C,this.k=S,this.g=!1,this.h=new Set,this.c=d,this.d=new D(this.j,this.id,h,S),this.e=b,this.f=g;const p=this;this.value=Object.freeze({get document(){return m.getValue()},set document(w){throw(0,t.readonly)("document")},get selection(){return p.c&&p.c[0]},set selection(w){if(!(w instanceof I.Selection))throw(0,t.illegalArgument)("selection");p.c=[w],p.l()},get selections(){return p.c},set selections(w){if(!Array.isArray(w)||w.some(i=>!(i instanceof I.Selection)))throw(0,t.illegalArgument)("selections");p.c=w,p.l()},get visibleRanges(){return p.e},set visibleRanges(w){throw(0,t.readonly)("visibleRanges")},get options(){return p.d.value},set options(w){p.g||p.d.assign(w)},get viewColumn(){return p.f},set viewColumn(w){throw(0,t.readonly)("viewColumn")},edit(w,i={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(m.getValue(),i);return w(s),p.m(s)},insertSnippet(w,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=p.c.map(u=>R.Range.from(u));else if(i instanceof I.Position){const{lineNumber:u,column:l}=R.Position.from(i);a=[{startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l}]}else if(i instanceof I.Range)a=[R.Range.from(i)];else{a=[];for(const u of i)if(u instanceof I.Range)a.push(R.Range.from(u));else{const{lineNumber:l,column:c}=R.Position.from(u);a.push({startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c})}}return C.$tryInsertSnippet(v,m.getValue().version,w.value,a,s)},setDecorations(w,i){const s=i.length===0;s&&!p.h.has(w.key)||(s?p.h.delete(w.key):p.h.add(w.key),p.n(()=>{if(R.isDecorationOptionsArr(i))return C.$trySetDecorations(v,w.key,R.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let u=0,l=i.length;u<l;u++){const c=i[u];a[4*u]=c.start.line+1,a[4*u+1]=c.start.character+1,a[4*u+2]=c.end.line+1,a[4*u+3]=c.end.character+1}return C.$trySetDecorationsFast(v,w.key,a)}}))},revealRange(w,i){p.n(()=>C.$tryRevealRange(v,R.Range.from(w),i||I.TextEditorRevealType.Default))},show(w){C.$tryShowEditor(v,R.ViewColumn.from(w))},hide(){C.$tryHideEditor(v)}})}dispose(){(0,o.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,o.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,o.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,o.ok)(!this.g),this.f=v}_acceptSelections(v){(0,o.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const C=v.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const S=C.edits.map(d=>d.range);S.sort((d,h)=>d.end.line===h.end.line?d.end.character===h.end.character?d.start.line===h.start.line?d.start.character-h.start.character:d.start.line-h.start.line:d.end.character-h.end.character:d.end.line-h.end.line);for(let d=0,h=S.length-1;d<h;d++){const b=S[d].end;if(S[d+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=C.edits.map(d=>({range:R.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,m,{setEndOfLine:typeof C.setEndOfLine=="number"?R.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.ExtHostTextEditor=L}),define(ye[238],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[239],Ce([1,0,191,10,37,122,126,44,26,238,203,193]),function(te,e,o,t,k,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=A.Registry.as(I.Extensions.JSONContribution);class C{constructor(w,i,s){this.a=w,this.b=i,this.c=s}d(w,i){this.a({type:w,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(k.default.Error,w)}warn(w){this.d(k.default.Warning,w)}info(w){this.d(k.default.Info,w)}}e.ExtensionMessageCollector=C;class S{static a(w){const i=new Set;for(let s=0,a=w.length;s<a;s++)i.add(y.ExtensionIdentifier.toKey(w[s].description.identifier));return i}static compute(w,i){if(!w||!w.length)return new S(i,[]);if(!i||!i.length)return new S([],w);const s=this.a(w),a=this.a(i),u=i.filter(c=>!s.has(y.ExtensionIdentifier.toKey(c.description.identifier))),l=w.filter(c=>!a.has(y.ExtensionIdentifier.toKey(c.description.identifier)));return new S(u,l)}constructor(w,i){this.added=w,this.removed=i}}e.ExtensionPointUserDelta=S;class m{constructor(w,i){this.name=w,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=S.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,t.onUnexpectedError)(w)}}}e.ExtensionPoint=m;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"*",description:o.localize(42,null),body:"*"}]}},badges:{type:"array",description:o.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(44,null)},href:{type:"string",description:o.localize(45,null)},description:{type:"string",description:o.localize(46,null)}}}},markdown:{type:"string",description:o.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(52,null)},{body:["workspace"],description:o.localize(53,null)},{body:["ui","workspace"],description:o.localize(54,null)},{body:["workspace","ui"],description:o.localize(55,null)},{body:[],description:o.localize(56,null)}]},capabilities:{description:o.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(60,null),o.localize(61,null),o.localize(62,null)]},description:{type:"string",markdownDescription:o.localize(63,null)}}},untrustedWorkspaces:{description:o.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null)]},restrictedConfigurations:{description:o.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(70,null)}}}}},sponsor:{description:o.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(73,null),type:"string"},"vscode:uninstall":{description:o.localize(74,null),type:"string"}}},icon:{type:"string",description:o.localize(75,null)},l10n:{type:"string",description:o.localize(76,null)}}};class b{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const i=new m(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,i),w.activationEventsGenerator&&P.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,v.registerSchema(h,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=b;const g={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(g.ExtensionsRegistry,new b),e.ExtensionsRegistry=A.Registry.as(g.ExtensionsRegistry),v.registerSchema(h,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(ye[240],Ce([1,0,188,11,23,239,53,3]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var D;(function(v){function C(S,m,d){if(!S)return;const h=t.isString(S.type)?S.type:void 0;if(!h||h.length===0){d.error(o.localize(3,null));return}const b=[];if(Array.isArray(S.required))for(const g of S.required)t.isString(g)&&b.push(g);return{extensionId:m.value,taskType:h,required:b,properties:S.properties?k.deepClone(S.properties):{},when:S.when?I.ContextKeyExpr.deserialize(S.when):void 0}}v.from=C})(D||(D={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:o.localize(4,null),type:"array",items:y}});class P{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,S)=>{L.setHandler((m,d)=>{this.c=void 0;try{for(const h of d.removed){const b=h.value;for(const g of b)this.a&&g.type&&this.a[g.type]&&delete this.a[g.type]}for(const h of d.added){const b=h.value;for(const g of b){const p=D.from(g,h.description.identifier,h.collector);p&&(this.a[p.taskType]=p)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const S of this.all()){const m={type:"object",additionalProperties:!1};S.required.length>0&&(m.required=S.required.slice(0)),S.properties!==void 0?m.properties=k.deepClone(S.properties):m.properties=Object.create(null),m.properties.type={type:"string",enum:[S.taskType]},C.push(m)}this.c={oneOf:C}}return this.c}}e.TaskDefinitionRegistry=new P}),define(ye[241],Ce([1,0,189,11,24,23,53,240]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var y;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function B(j){if(!j)return N.Strong;switch(j.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=B}(y=e.ShellQuoting||(e.ShellQuoting={}));var D;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(D=e.CommandOptions||(e.CommandOptions={}));var L;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(N){function B(j){switch(j.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=B}(L=e.RevealKind||(e.RevealKind={}));var P;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function B(j){switch(j.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=B}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(N){function B(j){switch(j.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=B}(v=e.PanelKind||(e.PanelKind={}));var C;(function(N){N.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(C=e.PresentationOptions||(e.PresentationOptions={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S=e.RuntimeType||(e.RuntimeType={})),function(N){function B(z){switch(z.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=B;function j(z){switch(z){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=j}(S=e.RuntimeType||(e.RuntimeType={}));var m;(function(N){function B(j){return t.isString(j)?j:j.value}N.value=B})(m=e.CommandString||(e.CommandString={}));var d;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function B(z){return z===N.Clean._id||z===N.Build._id||z===N.Rebuild._id||z===N.Test._id}N.is=B;function j(z){if(z!==void 0)return t.isString(z)?B(z)?{_id:z,isDefault:!1}:void 0:z}N.from=j})(d=e.TaskGroup||(e.TaskGroup={}));var h;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var b;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function B(j){switch(j){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=B})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var g;(function(N){N.parallel="parallel",N.sequence="sequence"})(g=e.DependsOrder||(e.DependsOrder={}));var p;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(p=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:p.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class i{constructor(B,j,z,ne,_,Y){this._label="",this._id=B,j&&(this._label=j),z&&(this.type=z),this.runOptions=ne,this.configurationProperties=_,this._source=Y}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,j=!1){if(B===void 0)return!1;if(t.isString(B))return B===this._label||B===this.configurationProperties.identifier||j&&B===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class s extends i{constructor(B,j,z,ne,_,Y,J,ee){super(B,z,void 0,J,ee,j),this.command={},this._source=j,this.hasDefinedMatchers=Y,_&&(this.command=_)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let j;switch(this.command?this.command.runtime:void 0){case S.Shell:j="shell";break;case S.Process:j="process";break;case S.CustomExecution:j="customExecution";break;case void 0:j="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:j,_key:this._id,id:this._id}}}static is(B){return B instanceof s}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let j=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(j+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:j};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new s(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=s;class a extends i{constructor(B,j,z,ne,_,Y,J){super(B,z,ne,Y,J,j),this._source=j,this.configures=_}static is(B){return B instanceof a}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let j=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(j+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:j};return JSON.stringify(z)}}e.ConfiguringTask=a;class u extends i{constructor(B,j,z,ne,_,Y,J,ee,ge){super(B,z,ne,ee,ge,j),this.defines=_,this.hasDefinedMatchers=J,this.command=Y,this.icon=ge.icon,this.hide=ge.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof u}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new u(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=u;class l extends i{constructor(B,j,z,ne,_,Y){super(B,z,ne,_,Y,j),this._source=j}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new l(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=l;var c;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(c=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(c=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class r{constructor(B){this.c=new Map;for(let j=0;j<B.length;j++)this.c.set(B[j].uri.toString(),j)}compare(B,j){const z=B.getWorkspaceFolder(),ne=j.getWorkspaceFolder();if(z&&ne){let _=this.c.get(z.uri.toString());_=_===void 0?0:_+1;let Y=this.c.get(ne.uri.toString());return Y=Y===void 0?0:Y+1,_===Y?B._label.localeCompare(j._label):_-Y}else return!z&&ne?-1:z&&!ne?1:0}}e.TaskSorter=r;var f;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(N){N.SingleRun="singleRun",N.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var T;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(T=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(N){function B(j,z,ne,_){if(z){const Y={kind:j,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ne,__task:z};return j==="start"?Y.resolvedVariables=_:j==="processStarted"?Y.processId=_:j==="processEnded"&&(Y.exitCode=_),Object.freeze(Y)}else return Object.freeze({kind:"changed"})}N.create=B})(M=e.TaskEvent||(e.TaskEvent={}));var K;(function(N){function B(z){const ne=Object.keys(z).sort();let _="";for(const Y of ne){let J=z[Y];J instanceof Object?J=B(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),_+=Y+","+J+","}return _}function j(z){const _={_key:B(z),type:z.taskType};return Object.assign(_,z),_}N.create=j})(K=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var F;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(F=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(N){function B(j,z){const ne=A.TaskDefinitionRegistry.get(j.type);if(ne===void 0){const ee=R.deepClone(j);return delete ee._key,K.create(ee)}const _=Object.create(null);_.type=ne.taskType;const Y=new Set;ne.required.forEach(ee=>Y.add(ee));const J=ne.properties;for(const ee of Object.keys(J)){const ge=j[ee];if(ge!=null)_[ee]=ge;else if(Y.has(ee)){const q=J[ee];if(q.default!==void 0)_[ee]=R.deepClone(q.default);else switch(q.type){case"boolean":_[ee]=!1;break;case"number":case"integer":_[ee]=0;break;case"string":_[ee]="";break;default:z.error(o.localize(2,null,JSON.stringify(j,void 0,0),ee));return}}}return K.create(_)}N.createTaskIdentifier=B})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[242],Ce([1,0,10]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((I,A)=>{this.b=I,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(I){this.f||this.h||(this.f=!0,this.g=I,this.a&&this.b(I))}resolveErr(I){this.f||this.h||(this.h=!0,this.i=I,this.a?this.d(I):(0,o.onUnexpectedError)(I))}then(I,A){return this.j().then(I,A)}catch(I){return this.j().then(void 0,I)}finally(I){return this.j().finally(I)}}e.LazyPromise=t;class k extends t{constructor(){super(),this.h=!0,this.i=new o.CancellationError}}e.CanceledLazyPromise=k}),define(ye[57],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const t=[];function k(A){const y=new o(A);return t[y.nid]=y,y}e.createProxyIdentifier=k;function R(A){return t[A].sid}e.getStringIdentifierForProxy=R;class I{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=I}),define(ye[5],Ce([1,0,57]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var R;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(d){return d._id=P.a++,d}}e.IdObject=P,P.a=0;var v;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var C;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(C=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,o.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,o.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,o.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,o.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,o.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,o.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,o.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,o.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,o.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,o.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,o.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,o.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,o.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,o.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,o.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,o.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,o.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,o.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,o.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,o.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,o.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,o.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,o.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,o.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,o.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,o.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,o.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,o.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,o.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,o.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,o.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,o.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,o.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,o.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,o.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,o.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,o.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,o.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,o.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,o.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,o.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,o.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,o.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,o.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,o.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,o.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,o.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,o.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,o.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,o.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,o.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,o.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,o.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,o.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,o.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,o.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,o.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,o.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,o.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,o.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,o.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,o.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[71],Ce([1,0,4,13,5,17]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(y,D){this.c=D,this.a=new Set,this.b=y.getProxy(k.MainContext.MainThreadTelemetry)}report(y,D,L){const P=this.d(y,D);this.a.has(P)||(this.a.add(P),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:y}))}d(y,D){return`${y}-${D.identifier.value}`}};I=qe([We(0,R.IExtHostRpcService),We(1,t.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,D){}})}),define(ye[243],Ce([1,0,3,5,7,26]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(y){this.b=new Map,this.c=[],this.d=new o.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,D,L,P={}){const v=R.ExtensionIdentifier.toKey(y.identifier),C=this.f.get(v)||[],S=[...L].sort().join(" ");let m=C.find(d=>d.providerId===D&&d.scopes===S);if(m)return m.result;{const d=this.g(y,v,D,L,P);m={providerId:D,scopes:S,result:d},C.push(m),this.f.set(v,C);try{await d}finally{const h=C.findIndex(b=>b.providerId===D&&b.scopes===S);h>-1&&(C.splice(h),this.f.set(v,C))}return d}}async g(y,D,L,P,v={}){await this.a.$ensureProvider(L);const C=y.displayName||y.name;return this.a.$getSession(L,P,D,C,v)}async removeSession(y,D){const L=this.b.get(y);return L?L.provider.removeSession(D):this.a.$removeSession(y,D)}registerAuthenticationProvider(y,D,L,P){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:D,provider:L,options:P??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===y)||this.c.push({id:y,label:D});const v=L.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions(y,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider(y,D,P?.supportsMultipleAccounts??!1),new k.Disposable(()=>{v.dispose(),this.b.delete(y);const C=this.c.findIndex(S=>S.id===y);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,D){return this.d.fire({provider:{id:y,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(ye[244],Ce([1,0,5,17,14]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(A,y){this.a=A.getProxy(o.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:D=>y.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,D){const L=k.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,D?.isRefactoring??!1)}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[245],Ce([1,0,5]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(R){const I=R.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(A){return I.$writeText(A)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[40],Ce([1,0,11,7,14,23,5,18,13,86,35,51,2,6,4,17,137,22,57,45,43,68]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p,w){"use strict";var i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(f,E){i.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Je(this,i,f.getProxy(I.MainContext.MainThreadCommands),"f"),this.d=E,Je(this,s,f.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,T=>{const M=this.c.get(T);return M?.result===c.Void?M:void 0},E),this.f=[{processArgument(T){return(0,D.revive)(T)}},{processArgument(T){return(0,R.cloneAndChange)(T,function(M){if(L.Range.isIRange(M))return k.Range.to(M);if(P.Position.isIPosition(M))return k.Position.to(M);if(L.Range.isIRange(M.range)&&v.URI.isUri(M.uri))return k.location.to(M);if(M instanceof h.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const E=this.registerCommand(!1,f.id,async(...T)=>{const M=f.args.map((V,F)=>{if(!V.validate(T[F]))throw new Error(`Invalid argument '${V.name}' when running '${f.id}', received: ${T[F]}`);return V.convert(T[F])}),K=await this.executeCommand(f.internalId,...M);return f.result.convert(K,T,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new t.Disposable(()=>{E.dispose(),this.c.delete(f.id)})}registerCommand(f,E,T,M,K,V){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:T,thisArg:M,description:K,extension:V}),f&&Ue(this,i,"f").$registerCommand(E),new t.Disposable(()=>{this.b.delete(E)&&f&&Ue(this,i,"f").$unregisterCommand(E)})}executeCommand(f,...E){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,E,!0)}async g(f,E,T){if(this.b.has(f))return Ue(this,i,"f").$fireCommandActivationEvent(f),this.h(f,E,!1);{let M=!1;const K=(0,R.cloneAndChange)(E,function(V){if(V instanceof t.Position)return k.Position.from(V);if(V instanceof t.Range)return k.Range.from(V);if(V instanceof t.Location)return k.location.from(V);if(t.NotebookRange.isNotebookRange(V))return k.NotebookRange.from(V);if(V instanceof ArrayBuffer)return M=!0,h.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return M=!0,h.VSBuffer.wrap(V);if(V instanceof h.VSBuffer)return M=!0,V;if(!Array.isArray(V))return V});try{const V=await Ue(this,i,"f").$executeCommand(f,M?new b.SerializableObjectWithBuffers(K):K,T);return(0,D.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(f,E,!1);throw V}}}async h(f,E,T){const M=this.b.get(f);if(!M)throw new Error("Unknown command");const{callback:K,thisArg:V,description:F}=M;if(F)for(let N=0;N<F.args.length;N++)try{(0,o.validateConstraint)(E[N],F.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${F.args[N].name}' - ${F.args[N].description}`)}const U=p.StopWatch.create();try{return await K.apply(V,E)}catch(N){if(f===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...E);B&&(f=B.command)}throw this.d.error(N,f,M.extension?.identifier),T?new class extends Error{constructor(){super((0,g.toErrorMessage)(N)),this.id=f,this.source=M.extension?.displayName??M.extension?.name}}:N}finally{this.j(M,f,U.elapsed())}}j(f,E,T){!f.extension||Ue(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new w.TrustedTelemetryValue(E),duration:T})}$executeContributedCommand(f,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const T=this.b.get(f);return T?(E=E.map(M=>this.f.reduce((K,V)=>V.processArgument(K,T.extension?.identifier),M)),this.h(f,E,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),Ue(this,i,"f").$getCommands().then(E=>(f&&(E=E.filter(T=>T[0]!=="_")),E))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(const[E,T]of this.b){const{description:M}=T;M&&(f[E]=M)}return Promise.resolve(f)}};i=new WeakMap,s=new WeakMap,a=qe([We(0,m.IExtHostRpcService),We(1,y.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,S.createDecorator)("IExtHostCommands");class u{constructor(f,E,T){this.d=f,this.f=E,this.g=T,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,E){if(!f)return;const T={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return T;const M=this.f(f.command);if(M)T.id=M.internalId,T.arguments=M.args.map((K,V)=>K.convert(f.arguments&&f.arguments[V]));else if((0,A.isNonEmptyArray)(f.arguments)){const K=`${f.command}/${++this.c}`;this.b.set(K,f),E.add((0,C.toDisposable)(()=>{this.b.delete(K),this.g.trace("CommandsConverter#DISPOSE",K)})),T.$ident=K,T.id=this.delegatingCommandId,T.arguments=[K],this.g.trace("CommandsConverter#CREATE",f.command,K)}return T}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const E=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.CommandsConverter=u;class l{constructor(f,E,T,M){this.name=f,this.description=E,this.validate=T,this.convert=M}optional(){return new l(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,E){return new l(f??this.name,E??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",r=>v.URI.isUri(r),r=>r),l.Position=new l("position","A position in a text document",r=>t.Position.isPosition(r),k.Position.from),l.Range=new l("range","A range in a text document",r=>t.Range.isRange(r),k.Range.from),l.Selection=new l("selection","A selection in a text document",r=>t.Selection.isSelection(r),k.Selection.from),l.Number=new l("number","",r=>typeof r=="number",r=>r),l.String=new l("string","",r=>typeof r=="string",r=>r),l.CallHierarchyItem=new l("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",r=>r instanceof d.TestItemImpl,k.TestItem.from);class c{constructor(f,E){this.description=f,this.convert=E}}e.ApiCommandResult=c,c.Void=new c("no result",r=>r);class n{constructor(f,E,T,M,K){this.id=f,this.internalId=E,this.description=T,this.args=M,this.result=K}}e.ApiCommand=n}),define(ye[246],Ce([1,0,2,14,7,66,40,18,119,124,15]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(t.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(m,d)=>{if((0,A.isFalsyOrEmpty)(m))return;class h extends k.SymbolInformation{static to(g){const p=new h(g.name,t.SymbolKind.to(g.kind),g.containerName||"",new k.Location(d[0],t.Range.to(g.range)));return p.detail=g.detail,p.range=p.location.range,p.selectionRange=t.Range.to(g.selectionRange),p.children=g.children?g.children.map(h.to):[],p}}return m.map(h.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",m=>typeof m=="string",m=>m),new I.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(t.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(t.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",m=>Array.isArray(m)&&m.every(d=>k.Position.isPosition(d)),m=>m.map(t.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",m=>m.map(d=>{let h;for(const b of d.reverse())h=new k.SelectionRange(t.Range.to(b),h);return h}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",m=>m.map(t.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",m=>m.map(t.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",m=>m.map(t.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",m=>m.map(t.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",m=>{if(!!m)return{range:t.Range.to(m.range),placeholder:m.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",m=>{if(!!m){if(m.rejectReason)throw new Error(m.rejectReason);return t.WorkspaceEdit.to(m)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",m=>m.map(t.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new k.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const d=(0,y.decodeSemanticTokensDto)(m);if(d.type==="full")return new k.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new k.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const d=(0,y.decodeSemanticTokensDto)(m);if(d.type==="full")return new k.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(m,d,h)=>{if(!m)return new k.CompletionList([]);const b=m.suggestions.map(g=>t.CompletionItem.to(g,h));return new k.CompletionList(b,m.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",m=>{if(m)return t.SignatureHelp.to(m)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(m,d,h)=>C(b=>new k.CodeLens(t.Range.to(b.range),b.command&&h.fromInternal(b.command)))(m))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",m=>k.Range.isRange(m),m=>k.Selection.isSelection(m)?t.Selection.from(m):t.Range.from(m)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(m,d,h)=>C(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(b.command)}else{const g=new k.CodeAction(b.title,b.kind?new k.CodeActionKind(b.kind):void 0);return b.edit&&(g.edit=t.WorkspaceEdit.to(b.edit)),b.command&&(g.command=h.fromInternal(b.command)),g.isPreferred=b.isPreferred,g}})(m))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",m=>m?m.map(d=>new k.ColorInformation(t.Range.to(d.range),t.Color.to(d.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",m=>m instanceof k.Color,t.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",m=>!0,m=>({uri:m.uri,range:t.Range.from(m.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",m=>m?m.map(t.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(m,d,h)=>m.map(t.InlayHint.to.bind(void 0,h)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(m=>({viewType:m.viewType,displayName:m.displayName,options:{transientOutputs:m.options.transientOutputs,transientCellMetadata:m.options.transientCellMetadata,transientDocumentMetadata:m.options.transientDocumentMetadata},filenamePattern:m.filenamePattern.map(d=>t.NotebookExclusiveDocumentPattern.to(d))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",m=>m.map(t.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",m=>o.URI.isUri(m)||typeof m=="string"&&(0,D.matchesSomeScheme)(m,L.Schemas.http,L.Schemas.https),m=>m),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[t.ViewColumn.from(m),void 0]:[t.ViewColumn.from(m.viewColumn),t.TextEditorOpenOptions.from(m)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[t.ViewColumn.from(m),void 0]:[t.ViewColumn.from(m.viewColumn),t.TextEditorOpenOptions.from(m)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="object",m=>m&&[t.ViewColumn.from(m.viewColumn),t.TextEditorOpenOptions.from(m)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void),new I.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[I.ApiCommandArgument.String.with("name","The context key name"),new I.ApiCommandArgument("value","The context key value",()=>!0,m=>m)],I.ApiCommandResult.Void)];class v{static register(d){P.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=v;function C(m){return d=>{if(Array.isArray(d))return d.map(m)}}function S(m){if(!Array.isArray(m))return;const d=[];for(const h of m)R.isLocationLink(h)?d.push(t.DefinitionLink.to(h)):d.push(t.location.to(h));return d}}),define(ye[247],Ce([1,0,16,60,3,6,2,66,26,14,7,27,5]),function(te,e,o,t,k,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function C(S,m,d){const h=S.getProxy(v.MainContext.MainThreadComments);class b{constructor(){this.b=new Map,this.c=new Map,m.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const n=this.b.get(c.handle);return n?n.value:c}else if(c&&c.$mid===7){const n=this.b.get(c.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.commentThreadHandle);return r?r.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const n=this.b.get(c.thread.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.thread.commentThreadHandle);return r?c.$mid===8?r.value:{thread:r.value,text:c.text}:c}else if(c&&c.$mid===10){const n=this.b.get(c.thread.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.thread.commentThreadHandle);if(!r)return c;const f=c.commentUniqueId,E=r.getCommentByUniqueId(f);return E||c}else if(c&&c.$mid===11){const n=this.b.get(c.thread.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.thread.commentThreadHandle);if(!r)return c;const f=c.text,E=c.commentUniqueId,T=r.getCommentByUniqueId(E);return T?(typeof T.body=="string"?T.body=f:T.body=new L.MarkdownString(f),T):c}return c}})}createCommentController(c,n,r){const f=b.a++,E=new p(c,f,n,r);this.b.set(E.handle,E);const T=this.c.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return T.push(E),this.c.set(y.ExtensionIdentifier.toKey(c.identifier),T),E.value}$createCommentThreadTemplate(c,n,r){const f=this.b.get(c);!f||f.$createCommentThreadTemplate(n,r)}async $updateCommentThreadTemplate(c,n,r){const f=this.b.get(c);!f||f.$updateCommentThreadTemplate(n,r)}$deleteCommentThread(c,n){this.b.get(c)?.$deleteCommentThread(n)}$provideCommentingRanges(c,n,r){const f=this.b.get(c);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const E=d.getDocument(I.URI.revive(n));return(0,o.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(E,r)).then(T=>T?T.map(M=>D.Range.from(M)):void 0)}$toggleReaction(c,n,r,f,E){const T=this.b.get(c);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const M=T.getCommentThread(n);if(M){const K=M.getCommentByUniqueId(f.uniqueIdInThread);if(T!==void 0&&K&&T.reactionHandler)return T.reactionHandler(K,s(E))}return Promise.resolve(void 0)})}dispose(){}}b.a=0;class g{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){c.isEqual(this.p)||(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(c){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,n,r,f,E,T,M,K){this.m=n,this.n=r,this.o=f,this.p=E,this.q=T,this.extensionDescription=M,this.r=K,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${c}.${this.handle}`),h.$createCommentThread(n,this.handle,this.n,this.o,D.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this.i.push({dispose:()=>{h.$deleteCommentThread(n,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(F){V.range=F},get comments(){return V.comments},set comments(F){V.comments=F},get collapsibleState(){return V.collapsibleState},set collapsibleState(F){V.collapsibleState=F},get canReply(){return V.canReply},set canReply(F){V.canReply=F},get contextValue(){return V.contextValue},set contextValue(F){V.contextValue=F},get label(){return V.label},set label(F){V.label=F},get state(){return V.state},set state(F){V.state=F},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const c=r=>Object.prototype.hasOwnProperty.call(this.b,r),n={};c("range")&&(n.range=D.Range.from(this.p)),c("label")&&(n.label=this.label),c("contextValue")&&(n.contextValue=this.contextValue??null),c("comments")&&(n.comments=this.q.map(r=>w(this,r,this.k))),c("collapsibleState")&&(n.collapseState=a(this.g)),c("canReply")&&(n.canReply=this.canReply),c("state")&&(n.state=u(this.h)),c("isTemplate")&&(n.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(c){for(const n of this.k){const r=n[0],f=n[1];if(c===f)return r}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}g.a=0,qe([(0,t.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,n,r,f){this.f=c,this.g=n,this.h=r,this.i=f,this.a=new Map,h.$registerCommentController(this.handle,r,f);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(T){E.options=T},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(T){E.commentingRangeProvider=T},get reactionHandler(){return E.reactionHandler},set reactionHandler(T){E.reactionHandler=T},createCommentThread(T,M,K){return E.createCommentThread(T,M,K).value},dispose:()=>{E.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(c,n,r,f){if(typeof c=="string"){const E=new g(this.id,this.handle,c,n,r,f,this.f,!1);return this.a.set(E.handle,E),E}else{const E=new g(this.id,this.handle,void 0,c,n,r,this.f,!1);return this.a.set(E.handle,E),E}}$createCommentThreadTemplate(c,n){const r=new g(this.id,this.handle,void 0,I.URI.revive(c),D.Range.to(n),[],this.f,!0);return r.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(r.handle,r),r}$updateCommentThreadTemplate(c,n){const r=this.a.get(c);r&&(r.range=D.Range.to(n))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function w(l,c,n){let r=n.get(c);r||(r=++l.commentHandle,n.set(c,r));const f=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:r,body:typeof c.body=="string"?c.body:D.MarkdownString.from(c.body),userName:c.author.name,userIconPath:f,label:c.label,commentReactions:c.reactions?c.reactions.map(E=>i(E)):void 0,timestamp:c.timestamp?.toJSON()}}function i(l){return{label:l.label,iconPath:l.iconPath?D.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function s(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?I.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function a(l){if(l!==void 0)switch(l){case L.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function u(l){if(l!==void 0)switch(l){case L.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new b}e.createExtHostComments=C}),define(ye[248],Ce([1,0,23,5,25,17]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(L,P){this.a=L.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const v=this,C=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,P,C,arguments)}})}e(L,P,v,C){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:y(C,this.b)}),this.c&&this.f(L,v,C)}};I=qe([We(0,R.IExtHostRpcService),We(1,k.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const A=1e5;function y(D,L){const P=[];if(D.length)for(let v=0;v<D.length;v++){let C=D[v];if(typeof C>"u")C="undefined";else if(C instanceof Error){const S=C;S.stack?C=S.stack:C=S.toString()}P.push(C)}if(L){const v=new Error().stack;v&&P.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,o.safeStringify)(P);return v.length>A?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],Ce([1,0,2,5,7,4,17,13,18,8,9,27]),function(te,e,o,t,k,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Un{constructor(S,m){this.h=m,this.f=new Map,this.g=S.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(S,m){const d=Un.c++;this.f.set(d,{provider:S,extensionDescription:m}),this.g.$registerDecorationProvider(d,m.identifier.value);const h=S.onDidChangeFileDecorations&&S.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(d,null);return}const g=(0,y.asArray)(b);if(g.length<=Un.d){this.g.$onDidChange(d,g);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,g.length);const p=g.map(s=>({uri:s,rank:(0,D.count)(s.path,"/")})),w=(0,y.groupBy)(p,(s,a)=>s.rank-a.rank||(0,D.compare)(s.uri.path,a.uri.path)),i=[];e:for(const s of w){let a;for(const u of s){const l=(0,L.dirname)(u.uri.path);if(a!==l&&(a=l,i.push(u.uri)>=Un.d))break e}}this.g.$onDidChange(d,i)});return new k.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(S,m,d){if(!this.f.has(S))return Object.create(null);const h=Object.create(null),{provider:b,extensionDescription:g}=this.f.get(S);return await Promise.all(m.map(async p=>{try{const{uri:w,id:i}=p,s=await Promise.resolve(b.provideFileDecoration(o.URI.revive(w),d));if(!s)return;try{k.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.checkProposedApiEnabled)(g,"codiconDecoration"),h[i]=[s.propagate,s.tooltip,s.badge,s.color]}catch(a){this.h.warn(`INVALID decoration from extension '${g}': ${a}`)}}catch(w){this.h.error(w)}})),h}};v.c=0,v.d=250,v=qe([We(0,I.IExtHostRpcService),We(1,A.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[249],Ce([1,0,175,123,2,5,7,14,3,13,28,48]),function(te,e,o,t,k,R,I,A,y,D,L,P){"use strict";var v,C,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class m{constructor(b,g,p,w,i,s,a){this.d=b,this.e=g,this.f=p,this.g=w,v.set(this,void 0),C.set(this,void 0),S.set(this,void 0),this.c=!1,Je(this,S,new L.ResourceMap(u=>i.getComparisonKey(u)),"f"),Je(this,v,s,"f"),Je(this,C,a,"f")}dispose(){this.c||(Ue(this,C,"f").fire([...Ue(this,S,"f").keys()]),Ue(this,v,"f")?.$clear(this.e),Ue(this,S,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(b,g){if(!b){this.clear();return}this.h();let p=[];if(k.URI.isUri(b)){if(!g){this.delete(b);return}Ue(this,S,"f").set(b,g.slice()),p=[b]}else if(Array.isArray(b)){p=[];let i;b=[...b].sort(m.j);for(const s of b){const[a,u]=s;if((!i||a.toString()!==i.toString())&&(i&&Ue(this,S,"f").get(i).length===0&&Ue(this,S,"f").delete(i),i=a,p.push(a),Ue(this,S,"f").set(a,[])),u)Ue(this,S,"f").get(a)?.push(...u);else{const l=Ue(this,S,"f").get(a);l&&(l.length=0)}}}if(Ue(this,C,"f").fire(p),!Ue(this,v,"f"))return;const w=[];for(const i of p){let s=[];const a=Ue(this,S,"f").get(i);if(a)if(a.length>this.f){s=[];const u=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const c of a)if(c.severity===u[l]&&s.push({...A.Diagnostic.from(c),modelVersionId:this.g(i)})===this.f)break e;s.push({severity:t.MarkerSeverity.Info,message:(0,o.localize)(0,null,a.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=a.map(u=>({...A.Diagnostic.from(u),modelVersionId:this.g(i)}));w.push([i,s])}Ue(this,v,"f").$changeMany(this.e,w)}delete(b){this.h(),Ue(this,C,"f").fire([b]),Ue(this,S,"f").delete(b),Ue(this,v,"f")?.$changeMany(this.e,[[b,void 0]])}clear(){this.h(),Ue(this,C,"f").fire([...Ue(this,S,"f").keys()]),Ue(this,S,"f").clear(),Ue(this,v,"f")?.$clear(this.e)}forEach(b,g){this.h();for(const[p,w]of this)b.call(g,p,w,this)}*[(v=new WeakMap,C=new WeakMap,S=new WeakMap,Symbol.iterator)](){this.h();for(const b of Ue(this,S,"f").keys())yield[b,this.get(b)]}get(b){this.h();const g=Ue(this,S,"f").get(b);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(b){return this.h(),Array.isArray(Ue(this,S,"f").get(b))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(b,g){return b[0].toString()<g[0].toString()?-1:b[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=m;let d=class wn{static _mapper(b){const g=new L.ResourceMap;for(const p of b)g.set(p,p);return{uris:Object.freeze(Array.from(g.values()))}}constructor(b,g,p,w){this.h=g,this.j=p,this.k=w,this.f=new Map,this.g=new y.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,wn._mapper),this.e=b.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,g){const{f:p,e:w,g:i,h:s,j:a,k:u}=this,l=new class{$changeMany(r,f){w.$changeMany(r,f),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,r,f.length===0?"CLEARING":f)}$clear(r){w.$clear(r),s.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,r)}dispose(){w.dispose()}};let c;if(!g)g="_generated_diagnostic_collection_name_#"+wn.c++,c=g;else if(!p.has(g))c=g;else{this.h.warn(`DiagnosticCollection with name '${g}' does already exist.`);do c=g+wn.c++;while(p.has(c))}return new class extends m{constructor(){super(g,c,wn.d,r=>u.getDocument(r)?.version,a.extUri,l,i),p.set(c,this)}dispose(){super.dispose(),p.delete(c)}}}getDiagnostics(b){if(b)return this.l(b);{const g=new Map,p=[];for(const w of this.f.values())w.forEach((i,s)=>{let a=g.get(i.toString());typeof a>"u"&&(a=p.length,g.set(i.toString(),a),p.push([i,[]])),p[a][1]=p[a][1].concat(...s)});return p}}l(b){let g=[];for(const p of this.f.values())p.has(b)&&(g=g.concat(p.get(b)));return g}$acceptMarkersChange(b){if(!this.m){const g="_generated_mirror",p=new m(g,g,wn.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(g,p),this.m=p}for(const[g,p]of b)this.m.set(k.URI.revive(g),p.map(A.Diagnostic.to))}};d.c=0,d.d=1e3,d=qe([We(1,D.ILogService),We(2,P.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[250],Ce([1,0,2,5]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(I){this.a=I.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(I){return this.a.$showOpenDialog(I).then(A=>A?A.map(y=>o.URI.revive(y)):void 0)}showSaveDialog(I){return this.a.$showSaveDialog(I).then(A=>A?o.URI.revive(A):void 0)}}e.ExtHostDialogs=k}),define(ye[251],Ce([1,0,10,2,7,5,15,21,8]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(P,v,C){this.d=v,this.e=C,this.b=new Map,this.c=P.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,v){if(Object.keys(I.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const C=D.a++;this.b.set(C,v),this.c.$registerTextContentProvider(C,P);let S;return typeof v.onDidChange=="function"&&(S=v.onDidChange(m=>{if(m.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this.d.getDocument(m)&&this.$provideTextDocumentContent(C,m).then(d=>{if(!d&&typeof d!="string")return;const h=this.d.getDocument(m);if(!h)return;const b=(0,y.splitLines)(d);if(!h.equalLines(b))return this.c.$onVirtualDocumentChange(m,d)},o.onUnexpectedError)})),new k.Disposable(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(P,v){const C=this.b.get(P);return C?Promise.resolve(C.provideTextDocumentContent(t.URI.revive(v),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=D,D.a=0}),define(ye[252],Ce([1,0,3,6,2,5,135,14,11,23,7]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(C,S){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=C.getProxy(R.MainContext.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(m=>{for(const d of m)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(m=>{for(const d of m)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const S=this.g.getDocument(C);if(S)return S}getDocument(C){const S=this.getDocumentData(C);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return S.document}ensureDocumentData(C){const S=this.g.getDocument(C);if(S)return Promise.resolve(S);let m=this.h.get(C.toString());return m||(m=this.f.$tryOpenDocument(C).then(d=>{this.h.delete(C.toString());const h=k.URI.revive(d);return(0,y.assertIsDefined)(this.g.getDocument(h))},d=>(this.h.delete(C.toString()),Promise.reject(d))),this.h.set(C.toString(),m)),m}createDocumentData(C){return this.f.$tryCreateDocument(C).then(S=>k.URI.revive(S))}$acceptModelLanguageChanged(C,S){const m=k.URI.revive(C),d=this.g.getDocument(m);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(S),this.a.fire(d.document)}$acceptModelSaved(C){const S=k.URI.revive(C),m=this.g.getDocument(S);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(m.document)}$acceptDirtyStateChanged(C,S){const m=k.URI.revive(C),d=this.g.getDocument(m);if(!d)throw new Error("unknown document");d._acceptIsDirty(S),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,S,m){const d=k.URI.revive(C),h=this.g.getDocument(d);if(!h)throw new Error("unknown document");h._acceptIsDirty(m),h.onEvents(S);let b;S.isUndoing?b=L.TextDocumentChangeReason.Undo:S.isRedoing&&(b=L.TextDocumentChangeReason.Redo),this.c.fire((0,D.deepFreeze)({document:h.document,contentChanges:S.changes.map(g=>({range:A.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:b}))}setWordDefinitionFor(C,S){(0,I.setWordDefinitionFor)(C,S)}}e.ExtHostDocuments=P}),define(ye[58],Ce([1,0,50,3,6,2,4,5,135,17,138,14,13,28,15,62,82]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(p){this.value=p,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let b=class{constructor(p,w){this.h=p,this.i=w,this.a=null,this.b=new Map,this.c=new C.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const w=[],i=[],s=[];if(p.removedDocuments)for(const a of p.removedDocuments){const u=R.URI.revive(a),l=this.c.get(u);l?.unref()&&(this.c.delete(u),w.push(l.value))}if(p.addedDocuments)for(const a of p.addedDocuments){const u=R.URI.revive(a.uri);let l=this.c.get(u);if(l&&u.scheme!==S.Schemas.vscodeNotebookCell&&u.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);l||(l=new h(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),u,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(u,l),i.push(l.value)),l.ref()}if(p.removedEditors)for(const a of p.removedEditors){const u=this.b.get(a);this.b.delete(a),u&&s.push(u)}if(p.addedEditors)for(const a of p.addedEditors){const u=R.URI.revive(a.documentUri);o.ok(this.c.has(u),`document '${u}' does not exist`),o.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const l=this.c.get(u).value,c=new L.ExtHostTextEditor(a.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new d.Lazy(()=>l.document),a.selections.map(P.Selection.to),a.options,a.visibleRanges.map(n=>P.Range.to(n)),typeof a.editorPosition=="number"?P.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,c)}p.newActiveEditor!==void 0&&(o.ok(p.newActiveEditor===null||this.b.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this.a=p.newActiveEditor),(0,k.dispose)(w),(0,k.dispose)(s),p.removedDocuments&&this.e.fire(w),p.addedDocuments&&this.d.fire(i),(p.removedEditors||p.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),p.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(p){return this.c.get(p)?.value}allDocuments(){return m.Iterable.map(this.c.values(),p=>p.value)}getEditor(p){return this.b.get(p)}activeEditor(p){if(!this.a)return;const w=this.b.get(this.a);return p?w:w?.value}allEditors(){return[...this.b.values()]}};b=qe([We(0,D.IExtHostRpcService),We(1,v.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[59],Ce([1,0,14,5,2,3,4,7,17,11,81]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class P{constructor(d,h,b){this.e=b,this.d=h,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,h={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(k.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(k.URI.revive(this.b.input.base),k.URI.revive(this.b.input.input1),k.URI.revive(this.b.input.input2),k.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(k.URI.revive(this.b.input.uri),k.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(d,h){this.c=[],this.d="",this.b=d,this.e=h;for(const b of d.tabs)b.isActive&&(this.d=b.id),this.c.push(new P(b,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,h={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return o.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(b=>b.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(b=>b.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const b=new P(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,b),d.tabDto.isActive&&(this.d=b.tabId),b}else if(d.kind===1){const b=this.c.splice(d.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return b.tabId===this.d&&(this.d=""),b}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this.c.splice(d.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,b),b}const h=this.c.find(b=>b.tabId===d.tabDto.id);if(!h)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(d.tabDto),h}activeTabId(){return this.d}}let C=class{constructor(d){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=d.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,h={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(b=>b.apiObject))},get activeTabGroup(){const b=d.d;return(0,D.assertIsDefined)(d.e.find(p=>p.groupId===b)?.apiObject)},close:async(b,g)=>{const p=Array.isArray(b)?b:[b];return p.length?S(p[0])?this.j(p,g):this.i(p,g):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(d){const h=new Set(this.e.map(a=>a.groupId)),b=new Set(d.map(a=>a.groupId)),g=(0,L.diffSets)(h,b),p=this.e.filter(a=>g.removed.includes(a.groupId)).map(a=>a.apiObject),w=[],i=[];this.e=d.map(a=>{const u=new v(a,()=>this.d);return g.added.includes(u.groupId)?w.push(u.apiObject):i.push(u.apiObject),u});const s=(0,D.assertIsDefined)(d.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:w,closed:p,changed:i}))}$acceptTabGroupUpdate(d){const h=this.e.find(b=>b.groupId===d.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const h=this.e.find(g=>g.groupId===d.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const b=h.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}g(d){for(const h of this.e)for(const b of h.tabs)if(b.apiObject===d)return b}h(d){return this.e.find(h=>h.apiObject===d)}async i(d,h){const b=[];for(const g of d){const p=this.g(g);if(!p)throw new Error("Tab close: Invalid tab not found!");b.push(p.tabId)}return this.a.$closeTab(b,h)}async j(d,h){const b=[];for(const g of d){const p=this.h(g);if(!p)throw new Error("Group close: Invalid group not found!");b.push(p.groupId)}return this.a.$closeGroup(b,h)}};C=qe([We(0,y.IExtHostRpcService)],C),e.ExtHostEditorTabs=C;function S(m){return m.tabs!==void 0}}),define(ye[253],Ce([1,0,2,5,6,7,14,153,8,22,27]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(S){this.b=void 0,this.a.push(S)}delete(S){const m=this.a.indexOf(S);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const S=this.a.sort(),m=[];let d,h,b=14,g=14;for(const p of S){let w=d?(0,y.commonPrefixLength)(d,p):0;for(w===0?h=1:h=g;w<p.length;w++)w+1===p.length?(b=g,g=9):g+=1,m.push([h,p.toUpperCase().charCodeAt(w),g]),m.push([h,p.toLowerCase().charCodeAt(w),g]),h=g;d=p,g=b}m.push([9,58,10]),m.push([10,47,12]),this.b=new A.StateMachine(m)}}provideDocumentLinks(S){this.c();const m=[],d=A.LinkComputer.computeLinks({getLineContent(h){return S.lineAt(h-1).text},getLineCount(){return S.lineCount}},this.b);for(const h of d){const b=I.DocumentLink.to(h);b.target&&m.push(b)}return m}}class v{constructor(S,m){this.i=m,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=S.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(S,m,d,h={}){if(this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(S,"*",this.b));const b=this.h++;this.b.add(m),this.d.add(m),this.c.set(b,d);let g=2;h.isCaseSensitive&&(g+=1024),h.isReadonly&&(g+=2048),typeof d.copy=="function"&&(g+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,L.checkProposedApiEnabled)(S,"fsChunks"),g+=4),this.a.$registerFileSystemProvider(b,m,g).catch(w=>{console.error(`FAILED to register filesystem provider of ${S.identifier.value}-extension for the scheme ${m}`),console.error(w)});const p=d.onDidChangeFile(w=>{const i=[];for(const s of w){const{uri:a,type:u}=s;if(a.scheme!==m)continue;let l;switch(u){case R.FileChangeType.Changed:l=0;break;case R.FileChangeType.Created:l=1;break;case R.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:a,type:l})}this.a.$onFileSystemChange(b,i)});return(0,k.toDisposable)(()=>{p.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(S){const{type:m,ctime:d,mtime:h,size:b,permissions:g}=S;return{type:m,ctime:d,mtime:h,size:b,permissions:g}}$stat(S,m){return Promise.resolve(this.k(S).stat(o.URI.revive(m))).then(d=>v.j(d))}$readdir(S,m){return Promise.resolve(this.k(S).readDirectory(o.URI.revive(m)))}$readFile(S,m){return Promise.resolve(this.k(S).readFile(o.URI.revive(m))).then(d=>D.VSBuffer.wrap(d))}$writeFile(S,m,d,h){return Promise.resolve(this.k(S).writeFile(o.URI.revive(m),d.buffer,h))}$delete(S,m,d){return Promise.resolve(this.k(S).delete(o.URI.revive(m),d))}$rename(S,m,d,h){return Promise.resolve(this.k(S).rename(o.URI.revive(m),o.URI.revive(d),h))}$copy(S,m,d,h){const b=this.k(S);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(o.URI.revive(m),o.URI.revive(d),h))}$mkdir(S,m){return Promise.resolve(this.k(S).createDirectory(o.URI.revive(m)))}$watch(S,m,d,h){const b=this.k(S).watch(o.URI.revive(d),h);this.f.set(m,b)}$unwatch(S,m){const d=this.f.get(m);d&&(d.dispose(),this.f.delete(m))}$open(S,m,d){const h=this.k(S);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(o.URI.revive(m),d))}$close(S,m){const d=this.k(S);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(m))}$read(S,m,d,h){const b=this.k(S);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const g=D.VSBuffer.alloc(h);return Promise.resolve(b.read(m,d,g.buffer,0,h)).then(p=>g.slice(0,p))}$write(S,m,d,h){const b=this.k(S);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(m,d,h.buffer,0,h.byteLength))}k(S){const m=this.c.get(S);if(!m){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return m}}e.ExtHostFileSystem=v}),define(ye[72],Ce([1,0,5,39,7,22,4,17,48,6]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Zt{constructor(v,C){this.b=new Map,this.a=v.getProxy(o.MainContext.MainThreadFileSystem);const S=this;this.value=Object.freeze({async stat(m){try{const d=S.b.get(m.scheme);if(!d)return await S.a.$stat(m);await S.a.$ensureActivation(m.scheme);const h=await d.stat(m);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(d){Zt.c(d)}},async readDirectory(m){try{const d=S.b.get(m.scheme);return d?(await S.a.$ensureActivation(m.scheme),(await d.readDirectory(m)).slice()):await S.a.$readdir(m)}catch(d){return Zt.c(d)}},async createDirectory(m){try{return await S.a.$mkdir(m)}catch(d){return Zt.c(d)}},async readFile(m){try{const d=S.b.get(m.scheme);return d?(await S.a.$ensureActivation(m.scheme),(await d.readFile(m)).slice()):(await S.a.$readFile(m)).buffer}catch(d){return Zt.c(d)}},async writeFile(m,d){try{return await S.a.$writeFile(m,R.VSBuffer.wrap(d))}catch(h){return Zt.c(h)}},async delete(m,d){try{const h=S.b.get(m.scheme);return h?(await S.a.$ensureActivation(m.scheme),await h.delete(m,{recursive:!1,...d})):await S.a.$delete(m,{recursive:!1,useTrash:!1,...d})}catch(h){return Zt.c(h)}},async rename(m,d,h){try{return await S.a.$rename(m,d,{overwrite:!1,...h})}catch(b){return Zt.c(b)}},async copy(m,d,h){try{return await S.a.$copy(m,d,{overwrite:!1,...h})}catch(b){return Zt.c(b)}},isWritableFileSystem(m){const d=C.getCapabilities(m);if(typeof d=="number")return!(d&2048)}})}static c(v){if(v instanceof k.FileSystemError)throw v;if(!(v instanceof Error))throw new k.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw k.FileSystemError.Unavailable(v.message);switch(v.name){case t.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(v.message);case t.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(v.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(v.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(v.message);case t.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(v.message);case t.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(v.message);default:throw new k.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,C){return this.b.set(v,C),(0,D.toDisposable)(()=>this.b.delete(v))}};L=qe([We(0,A.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[254],Ce([1,0,3,38,2,5,14,7]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,v,C,S,m,d,h,b){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter;const g=this.h(P,C,m);this.g=0,d&&(this.g+=1),h&&(this.g+=2),b&&(this.g+=4);const p=(0,t.parse)(m),w=typeof m=="string",i=S(s=>{if(!d)for(const a of s.created){const u=k.URI.revive(a);p(u.fsPath)&&(!w||v.getWorkspaceFolder(u))&&this.a.fire(u)}if(!h)for(const a of s.changed){const u=k.URI.revive(a);p(u.fsPath)&&(!w||v.getWorkspaceFolder(u))&&this.b.fire(u)}if(!b)for(const a of s.deleted){const u=k.URI.revive(a);p(u.fsPath)&&(!w||v.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=A.Disposable.from(g,this.a,this.b,this.c,i)}h(P,v,C){const S=A.Disposable.from();if(typeof C=="string")return S;const m=P.getProxy(R.MainContext.MainThreadFileSystem);let d=!1;(C.pattern.includes(t.GLOBSTAR)||C.pattern.includes(t.GLOB_SPLIT))&&(d=!0);const h=Math.random();return m.$watch(v.identifier.value,h,C.baseUri,{recursive:d,excludes:[]}),A.Disposable.from({dispose:()=>m.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class D{constructor(P,v,C){this.j=P,this.k=v,this.l=C,this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.g=new o.AsyncEmitter,this.h=new o.AsyncEmitter,this.i=new o.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,v,C,S,m,d){return new y(this.j,P,v,this.a.event,I.GlobPattern.from(C),S,m,d)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,v){switch(P){case 2:this.b.fire(Object.freeze({files:v.map(C=>({oldUri:k.URI.revive(C.source),newUri:k.URI.revive(C.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(C=>k.URI.revive(C.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(C=>k.URI.revive(C.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,v){return(C,S,m)=>{const d=function(b){C.call(S,b)};return d.extension=P,v.event(d,void 0,m)}}async $onWillRunFileOperation(P,v,C,S){switch(P){case 2:return await this.n(this.g,{files:v.map(m=>({oldUri:k.URI.revive(m.source),newUri:k.URI.revive(m.target)}))},C,S);case 1:return await this.n(this.i,{files:v.map(m=>k.URI.revive(m.target))},C,S);case 0:case 3:return await this.n(this.h,{files:v.map(m=>k.URI.revive(m.target))},C,S)}}async n(P,v,C,S){const m=new Set,d=[];if(await P.fireAsync(v,S,async(b,g)=>{const p=Date.now(),w=await Promise.resolve(b);w instanceof A.WorkspaceEdit&&(d.push([g.extension,w]),m.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-p>C&&this.k.warn("SLOW file-participant",g.extension.identifier)}),S.isCancellationRequested||d.length===0)return;const h={edits:[]};for(const[,b]of d){const{edits:g}=I.WorkspaceEdit.from(b,{getTextDocumentVersion:p=>this.l.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(g)}return{edit:h,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=D}),define(ye[255],Ce([1,0,2,40]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(I,A,y,D,L){this.a=A,this.b=y,this.c=D;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new t.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new t.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new t.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new t.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const C=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri),notebookEditor:C.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(I,A,y,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:I,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(o.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=k}),define(ye[256],Ce([1,0,6,5]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(I){this.b=0,this.a=I.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,I),(0,o.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=k}),define(ye[257],Ce([1,0,2,23,14,7,66,5,8,35,18,11,149,21,6,119,100,69,43,10,16,27]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(O,W){this.d=O,this.e=W}async provideDocumentSymbols(O,W){const X=this.d.getDocument(O),Q=await this.e.provideDocumentSymbols(X,W);if(!(0,L.isFalsyOrEmpty)(Q))return Q[0]instanceof R.DocumentSymbol?Q.map(k.DocumentSymbol.from):i.f(Q)}static f(O){O=O.slice(0).sort((Q,he)=>{let we=Q.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(Q.location.range.end)),we});const W=[],X=[];for(const Q of O){const he={name:Q.name||"!!MISSING: name!!",kind:k.SymbolKind.from(Q.kind),tags:Q.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:k.Range.from(Q.location.range),selectionRange:k.Range.from(Q.location.range),children:[]};for(;;){if(X.length===0){X.push(he),W.push(he);break}const we=X[X.length-1];if(D.Range.containsRange(we.range,he.range)&&!D.Range.equalsRange(we.range,he.range)){we.children?.push(he),X.push(he);break}X.pop()}}return W}}class s{constructor(O,W,X){this.g=O,this.h=W,this.j=X,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(O,W){const X=this.g.getDocument(O),Q=await this.j.provideCodeLenses(X,W);if(!Q||W.isCancellationRequested)return;const he=this.e.add(Q),we=new S.DisposableStore;this.f.set(he,we);const Ae={cacheId:he,lenses:[]};for(let pe=0;pe<Q.length;pe++)Ae.lenses.push({cacheId:[he,pe],range:k.Range.from(Q[pe].range),command:this.h.toInternal(Q[pe].command,we)});return Ae}async resolveCodeLens(O,W){const X=O.cacheId&&this.e.get(...O.cacheId);if(!X)return;let Q;if(typeof this.j.resolveCodeLens!="function"||X.isResolved?Q=X:Q=await this.j.resolveCodeLens(X,W),Q||(Q=X),W.isCancellationRequested)return;const he=O.cacheId&&this.f.get(O.cacheId[0]);if(!!he)return O.command=this.h.toInternal(Q.command??s.d,he),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}s.d={command:"missing",title:"!!MISSING: command!!"};function a(ie){return Array.isArray(ie)?ie.map(k.DefinitionLink.from):ie?[k.DefinitionLink.from(ie)]:[]}class u{constructor(O,W){this.d=O,this.e=W}async provideDefinition(O,W,X){const Q=this.d.getDocument(O),he=k.Position.to(W),we=await this.e.provideDefinition(Q,he,X);return a(we)}}class l{constructor(O,W){this.d=O,this.e=W}async provideDeclaration(O,W,X){const Q=this.d.getDocument(O),he=k.Position.to(W),we=await this.e.provideDeclaration(Q,he,X);return a(we)}}class c{constructor(O,W){this.d=O,this.e=W}async provideImplementation(O,W,X){const Q=this.d.getDocument(O),he=k.Position.to(W),we=await this.e.provideImplementation(Q,he,X);return a(we)}}class n{constructor(O,W){this.d=O,this.e=W}async provideTypeDefinition(O,W,X){const Q=this.d.getDocument(O),he=k.Position.to(W),we=await this.e.provideTypeDefinition(Q,he,X);return a(we)}}class r{constructor(O,W){this.d=O,this.e=W}async provideHover(O,W,X){const Q=this.d.getDocument(O),he=k.Position.to(W),we=await this.e.provideHover(Q,he,X);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=Q.getWordRangeAtPosition(he)),we.range||(we.range=new R.Range(he,he)),k.Hover.from(we)}}class f{constructor(O,W){this.d=O,this.e=W}async provideEvaluatableExpression(O,W,X){const Q=this.d.getDocument(O),he=k.Position.to(W),we=await this.e.provideEvaluatableExpression(Q,he,X);if(we)return k.EvaluatableExpression.from(we)}}class E{constructor(O,W){this.d=O,this.e=W}async provideInlineValues(O,W,X,Q){const he=this.d.getDocument(O),we=await this.e.provideInlineValues(he,k.Range.to(W),k.InlineValueContext.to(X),Q);if(Array.isArray(we))return we.map(Ae=>k.InlineValue.from(Ae))}}class T{constructor(O,W){this.d=O,this.e=W}async provideDocumentHighlights(O,W,X){const Q=this.d.getDocument(O),he=k.Position.to(W),we=await this.e.provideDocumentHighlights(Q,he,X);if(Array.isArray(we))return we.map(k.DocumentHighlight.from)}}class M{constructor(O,W){this.d=O,this.e=W}async provideLinkedEditingRanges(O,W,X){const Q=this.d.getDocument(O),he=k.Position.to(W),we=await this.e.provideLinkedEditingRanges(Q,he,X);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(k.Range.from)),wordPattern:we.wordPattern}}}class K{constructor(O,W){this.d=O,this.e=W}async provideReferences(O,W,X,Q){const he=this.d.getDocument(O),we=k.Position.to(W),Ae=await this.e.provideReferences(he,we,X,Q);if(Array.isArray(Ae))return Ae.map(k.location.from)}}class V{constructor(O,W,X,Q,he,we,Ae){this.g=O,this.h=W,this.j=X,this.k=Q,this.l=he,this.m=we,this.n=Ae,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(O,W,X,Q){const he=this.g.getDocument(O),we=v.Selection.isISelection(W)?k.Selection.to(W):k.Range.to(W),Ae=[];for(const et of this.j.getDiagnostics(O))if(we.intersection(et.range)&&Ae.push(et)>V.d)break;const pe={diagnostics:Ae,only:X.only?new R.CodeActionKind(X.only):void 0,triggerKind:k.CodeActionTriggerKind.to(X.trigger)},De=await this.k.provideCodeActions(he,we,pe,Q);if(!(0,L.isNonEmptyArray)(De)||Q.isCancellationRequested)return;const ke=this.e.add(De),je=new S.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<De.length;et++){const _e=De[et];!_e||(V.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,je)})):(pe.only&&(_e.kind?pe.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(k.Diagnostic.from),edit:_e.edit&&k.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(O,W){const[X,Q]=O,he=this.e.get(X,Q);if(!he||V.o(he)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(he,W)??he;return we?.edit?k.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}V.d=1e3;class F{constructor(O,W,X,Q){this.d=O,this.e=W,this.f=X,this.g=Q}async prepareDocumentPaste(O,W,X,Q){if(!this.f.prepareDocumentPaste)return;const he=this.e.getDocument(O),we=W.map(pe=>k.Range.to(pe)),Ae=k.DataTransfer.toDataTransfer(X,()=>{throw new g.NotImplementedError});return await this.f.prepareDocumentPaste(he,we,Ae,Q),k.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(O,W,X,Q,he){const we=this.e.getDocument(W),Ae=X.map(ke=>k.Range.to(ke)),pe=k.DataTransfer.toDataTransfer(Q,async ke=>(await this.d.$resolvePasteFileData(this.g,O,ke)).buffer),De=await this.f.provideDocumentPasteEdits(we,Ae,pe,he);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class U{constructor(O,W){this.d=O,this.e=W}async provideDocumentFormattingEdits(O,W,X){const Q=this.d.getDocument(O),he=await this.e.provideDocumentFormattingEdits(Q,W,X);if(Array.isArray(he))return he.map(k.TextEdit.from)}}class N{constructor(O,W){this.d=O,this.e=W}async provideDocumentRangeFormattingEdits(O,W,X,Q){const he=this.d.getDocument(O),we=k.Range.to(W),Ae=await this.e.provideDocumentRangeFormattingEdits(he,we,X,Q);if(Array.isArray(Ae))return Ae.map(k.TextEdit.from)}}class B{constructor(O,W){this.d=O,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,W,X,Q,he){const we=this.d.getDocument(O),Ae=k.Position.to(W),pe=await this.e.provideOnTypeFormattingEdits(we,Ae,X,Q,he);if(Array.isArray(pe))return pe.map(k.TextEdit.from)}}class j{constructor(O,W){this.e=O,this.f=W,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,W){const X=await this.e.provideWorkspaceSymbols(O,W);if(!(0,L.isNonEmptyArray)(X))return{symbols:[]};const Q=this.d.add(X),he={cacheId:Q,symbols:[]};for(let we=0;we<X.length;we++){const Ae=X[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}he.symbols.push({...k.WorkspaceSymbol.from(Ae),cacheId:[Q,we]})}return he}async resolveWorkspaceSymbol(O,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const X=this.d.get(...O.cacheId);if(X){const Q=await this.e.resolveWorkspaceSymbol(X,W);return Q&&(0,t.mixin)(O,k.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class z{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,W,X){this.d=O,this.e=W,this.f=X}async provideRenameEdits(O,W,X,Q){const he=this.d.getDocument(O),we=k.Position.to(W);try{const Ae=await this.e.provideRenameEdits(he,we,X,Q);return Ae?k.WorkspaceEdit.from(Ae):void 0}catch(Ae){const pe=z.g(Ae);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(O,W,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(O),he=k.Position.to(W);try{const we=await this.e.prepareRename(Q,he,X);let Ae,pe;if(R.Range.isRange(we)?(Ae=we,pe=Q.getText(we)):(0,P.isObject)(we)&&(Ae=we.range,pe=we.placeholder),!Ae||!pe)return;if(Ae.start.line>he.line||Ae.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(Ae),text:pe}}catch(we){const Ae=z.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class ne{constructor(O,W){this.resultId=O,this.tokens=W}}class _{constructor(O,W){this.f=O,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,W,X){const Q=this.f.getDocument(O),he=W!==0?this.d.get(W):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,he.resultId,X):await this.g.provideDocumentSemanticTokens(Q,X);return he&&this.d.delete(W),we?(we=_.h(we),this.o(_.n(he,we),we)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return _.j(O)?_.k(O)?O:new R.SemanticTokens(new Uint32Array(O.data),O.resultId):_.l(O)?_.m(O)?O:new R.SemanticTokensEdits(O.edits.map(W=>new R.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const W of O.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(O,W){if(!_.j(W)||!O||!O.tokens)return W;const X=O.tokens,Q=X.length,he=W.data,we=he.length;let Ae=0;const pe=Math.min(Q,we);for(;Ae<pe&&X[Ae]===he[Ae];)Ae++;if(Ae===Q&&Ae===we)return new R.SemanticTokensEdits([],W.resultId);let De=0;const ke=pe-Ae;for(;De<ke&&X[Q-De-1]===he[we-De-1];)De++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:Q-Ae-De,data:he.subarray(Ae,we-De)}],W.resultId)}o(O,W){if(_.j(O)){const X=this.e++;return this.d.set(X,new ne(O.resultId,O.data)),(0,m.encodeSemanticTokensDto)({id:X,type:"full",data:O.data})}if(_.l(O)){const X=this.e++;return _.j(W)?this.d.set(X,new ne(W.resultId,W.data)):this.d.set(X,new ne(O.resultId)),(0,m.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(O.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class Y{constructor(O,W){this.d=O,this.e=W}async provideDocumentRangeSemanticTokens(O,W,X){const Q=this.d.getDocument(O),he=await this.e.provideDocumentRangeSemanticTokens(Q,k.Range.to(W),X);return he?this.f(he):null}f(O){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class J{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,W,X,Q,he){this.f=O,this.g=W,this.h=X,this.j=Q,this.k=he,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(O,W,X,Q){const he=this.f.getDocument(O),we=k.Position.to(W),Ae=he.getWordRangeAtPosition(we)||new R.Range(we,we),pe=Ae.with({end:we}),De=new b.StopWatch(!0),ke=await this.h.provideCompletionItems(he,we,Q,k.CompletionContext.to(X));if(!ke||Q.isCancellationRequested)return;const je=Array.isArray(ke)?new R.CompletionList(ke):ke,Ge=J.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new S.DisposableStore;this.e.set(Ge,et);const _e=[],nt={x:Ge,b:_e,a:{replace:k.Range.from(Ae),insert:k.Range.from(pe)},c:je.isIncomplete||void 0,d:De.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Me=this.l(ht,[Ge,st],pe,Ae);_e.push(Me)}return nt}async resolveCompletionItem(O,W){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...O);if(!X)return;const Q=await this.h.resolveCompletionItem(X,W);if(!!Q)return this.l(Q,O)}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,W,X,Q){const he=this.e.get(W[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(O.command,he),Ae={x:W,a:O.label,b:O.kind!==void 0?k.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(k.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:k.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(k.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=O.textEdit.newText):typeof O.insertText=="string"?Ae.h=O.insertText:O.insertText instanceof R.SnippetString&&(Ae.h=O.insertText.value,Ae.i|=4);let pe;return O.textEdit?pe=O.textEdit.range:O.range&&(pe=O.range),R.Range.isRange(pe)?Ae.j=k.Range.from(pe):pe&&(!X?.isEqual(pe.inserting)||!Q?.isEqual(pe.replacing))&&(Ae.j={insert:k.Range.from(pe.inserting),replace:k.Range.from(pe.replacing)}),Ae}}class ee{async provideInlineCompletions(O,W,X,Q){}disposeCompletions(O){}handleDidShowCompletionItem(O,W){}}class ge extends ee{constructor(O,W,X,Q){super(),this.f=O,this.g=W,this.h=X,this.j=Q,this.d=new q,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[I.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,W,X,Q){const he=this.g.getDocument(O),we=k.Position.to(W),Ae=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:k.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Q);if(!Ae||Q.isCancellationRequested)return;const pe=Array.isArray(Ae)?Ae:Ae.items,De=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let _e;Ge.command&&(ke||(ke=new S.DisposableStore),_e=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?k.Range.from(Ge.range):void 0,command:_e,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:De.map(Ge=>(ke||(ke=new S.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,W){const X=this.d.get(O)?.items[W];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X)}}class q{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const W=this.e++;return this.d.set(W,O),W}disposeReferenceId(O){const W=this.d.get(O);return this.d.delete(O),W}get(O){return this.d.get(O)}}class G{constructor(O,W){this.e=O,this.f=W,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(O,W,X,Q){const he=this.e.getDocument(O),we=k.Position.to(W),Ae=this.g(X),pe=await this.f.provideSignatureHelp(he,we,Q,Ae);if(pe){const De=this.d.add([pe]);return{...k.SignatureHelp.from(pe),id:De}}}g(O){let W;if(O.activeSignatureHelp){const X=k.SignatureHelp.to(O.activeSignatureHelp),Q=this.d.get(O.activeSignatureHelp.id,0);Q?(W=Q,W.activeSignature=X.activeSignature,W.activeParameter=X.activeParameter):W=X}return{...O,activeSignatureHelp:W}}releaseSignatureHelp(O){this.d.delete(O)}}class le{constructor(O,W,X,Q,he){this.f=O,this.g=W,this.h=X,this.j=Q,this.k=he,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(O,W,X){const Q=this.f.getDocument(O),he=k.Range.to(W),we=await this.h.provideInlayHints(Q,he,X);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(X.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new S.DisposableStore);const pe={hints:[],cacheId:Ae};for(let De=0;De<we.length;De++)this.l(we[De],he)&&pe.hints.push(this.m(we[De],[Ae,De]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),pe}async resolveInlayHint(O,W){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...O);if(!X)return;const Q=await this.h.resolveInlayHint(X,W);if(!!Q&&!!this.l(Q))return this.m(Q,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,W){return O.label.length===0||Array.isArray(O.label)&&O.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(W&&!W.contains(O.position))}m(O,W){const X=this.e.get(W[0]);if(!X)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:W,tooltip:k.MarkdownString.fromStrict(O.tooltip),position:k.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(k.TextEdit.from),kind:O.kind&&k.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Q.label=O.label:Q.label=O.label.map(he=>{const we={label:he.value};return we.tooltip=k.MarkdownString.fromStrict(he.tooltip),R.Location.isLocation(he.location)&&(we.location=k.location.from(he.location)),he.command&&(we.command=this.g.toInternal(he.command,X)),we}),Q}}class be{constructor(O,W){this.e=O,this.f=W,this.d=new h.Cache("DocumentLink")}async provideLinks(O,W){const X=this.e.getDocument(O),Q=await this.f.provideDocumentLinks(X,W);if(!(!Array.isArray(Q)||Q.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(be.g).map(k.DocumentLink.from)};{const he=this.d.add(Q),we={links:[],cacheId:he};for(let Ae=0;Ae<Q.length;Ae++){if(!be.g(Q[Ae]))continue;const pe=k.DocumentLink.from(Q[Ae]);pe.cacheId=[he,Ae],we.links.push(pe)}return we}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,W){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...O);if(!X)return;const Q=await this.f.resolveDocumentLink(X,W);if(!(!Q||!be.g(Q)))return k.DocumentLink.from(Q)}releaseLinks(O){this.d.delete(O)}}class ve{constructor(O,W){this.d=O,this.e=W}async provideColors(O,W){const X=this.d.getDocument(O),Q=await this.e.provideDocumentColors(X,W);return Array.isArray(Q)?Q.map(we=>({color:k.Color.from(we.color),range:k.Range.from(we.range)})):[]}async provideColorPresentations(O,W,X){const Q=this.d.getDocument(O),he=k.Range.to(W.range),we=k.Color.to(W.color),Ae=await this.e.provideColorPresentations(we,{document:Q,range:he},X);if(!!Array.isArray(Ae))return Ae.map(k.ColorPresentation.from)}}class Pe{constructor(O,W){this.d=O,this.e=W}async provideFoldingRanges(O,W,X){const Q=this.d.getDocument(O),he=await this.e.provideFoldingRanges(Q,W,X);if(!!Array.isArray(he))return he.map(k.FoldingRange.from)}}class Ne{constructor(O,W,X){this.d=O,this.e=W,this.f=X}async provideSelectionRanges(O,W,X){const Q=this.d.getDocument(O),he=W.map(k.Position.to),we=await this.e.provideSelectionRanges(Q,he,X);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let pe=0;pe<he.length;pe++){const De=[];Ae.push(De);let ke=he[pe],je=we[pe];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(De.push(k.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Ae}}class se{constructor(O,W){this.f=O,this.g=W,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(O,W,X){const Q=this.f.getDocument(O),he=k.Position.to(W),we=await this.g.prepareCallHierarchy(Q,he,X);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideCallsTo(O,W,X){const Q=this.j(O,W);if(!Q)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Q,X);if(!!he)return he.map(we=>({from:this.h(O,we.from),fromRanges:we.fromRanges.map(Ae=>k.Range.from(Ae))}))}async provideCallsFrom(O,W,X){const Q=this.j(O,W);if(!Q)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Q,X);if(!!he)return he.map(we=>({to:this.h(O,we.to),fromRanges:we.fromRanges.map(Ae=>k.Range.from(Ae))}))}releaseSession(O){this.e.delete(O)}h(O,W){const X=this.e.get(O),Q=k.CallHierarchyItem.from(W,O,X.size.toString(36));return X.set(Q._itemId,W),Q}j(O,W){return this.e.get(O)?.get(W)}}class ue{constructor(O,W){this.f=O,this.g=W,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(O,W,X){const Q=this.f.getDocument(O),he=k.Position.to(W),we=await this.g.prepareTypeHierarchy(Q,he,X);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideSupertypes(O,W,X){const Q=this.j(O,W);if(!Q)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Q,X);if(!!he)return he.map(we=>this.h(O,we))}async provideSubtypes(O,W,X){const Q=this.j(O,W);if(!Q)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Q,X);if(!!he)return he.map(we=>this.h(O,we))}releaseSession(O){this.e.delete(O)}h(O,W){const X=this.e.get(O),Q=k.TypeHierarchyItem.from(W,O,X.size.toString(36));return X.set(Q._itemId,W),Q}j(O,W){return this.e.get(O)?.get(W)}}class de{constructor(O,W,X,Q){this.d=O,this.e=W,this.f=X,this.g=Q}async provideDocumentOnDropEdits(O,W,X,Q,he){const we=this.e.getDocument(W),Ae=k.Position.to(X),pe=k.DataTransfer.toDataTransfer(Q,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,ke)).buffer),De=await this.f.provideDocumentDropEdits(we,Ae,pe,he);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class Z{constructor(O,W){this.adapter=O,this.extension=W}}class ae{constructor(O,W,X,Q,he,we,Ae,pe){this.g=W,this.h=X,this.j=Q,this.k=he,this.l=we,this.m=Ae,this.n=pe,this.f=new Map,this.e=O.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(O){return k.DocumentSelector.from(O,this.g)}p(O){return new R.Disposable(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return ae.d++}async s(O,W,X,Q,he,we=!1){const Ae=this.f.get(O);if(!Ae||!(Ae.adapter instanceof W))return Q;const pe=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const De=X(Ae.adapter,Ae.extension);return Promise.resolve(De).catch(ke=>{(0,g.isCancellationError)(ke)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Ae.extension.identifier,ke))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),C.CancellationToken.isCancellationToken(he)?(0,p.raceCancellationError)(De,he):De}t(O,W){const X=this.q();return this.f.set(X,new Z(O,W)),X}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,W,X,Q){const he=this.t(new i(this.h,X),O),we=Q&&Q.label||ae.u(O);return this.e.$registerDocumentSymbolProvider(he,this.o(W),we),this.p(he)}$provideDocumentSymbols(O,W,X){return this.s(O,i,Q=>Q.provideDocumentSymbols(o.URI.revive(W),X),void 0,X)}registerCodeLensProvider(O,W,X){const Q=this.q(),he=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new Z(new s(this.h,this.j.converter,X),O)),this.e.$registerCodeLensSupport(Q,this.o(W),he);let we=this.p(Q);if(he!==void 0){const Ae=X.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideCodeLenses(O,W,X){return this.s(O,s,Q=>Q.provideCodeLenses(o.URI.revive(W),X),void 0,X)}$resolveCodeLens(O,W,X){return this.s(O,s,Q=>Q.resolveCodeLens(W,X),void 0,void 0)}$releaseCodeLenses(O,W){this.s(O,s,X=>Promise.resolve(X.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(O,W,X){const Q=this.t(new u(this.h,X),O);return this.e.$registerDefinitionSupport(Q,this.o(W)),this.p(Q)}$provideDefinition(O,W,X,Q){return this.s(O,u,he=>he.provideDefinition(o.URI.revive(W),X,Q),[],Q)}registerDeclarationProvider(O,W,X){const Q=this.t(new l(this.h,X),O);return this.e.$registerDeclarationSupport(Q,this.o(W)),this.p(Q)}$provideDeclaration(O,W,X,Q){return this.s(O,l,he=>he.provideDeclaration(o.URI.revive(W),X,Q),[],Q)}registerImplementationProvider(O,W,X){const Q=this.t(new c(this.h,X),O);return this.e.$registerImplementationSupport(Q,this.o(W)),this.p(Q)}$provideImplementation(O,W,X,Q){return this.s(O,c,he=>he.provideImplementation(o.URI.revive(W),X,Q),[],Q)}registerTypeDefinitionProvider(O,W,X){const Q=this.t(new n(this.h,X),O);return this.e.$registerTypeDefinitionSupport(Q,this.o(W)),this.p(Q)}$provideTypeDefinition(O,W,X,Q){return this.s(O,n,he=>he.provideTypeDefinition(o.URI.revive(W),X,Q),[],Q)}registerHoverProvider(O,W,X,Q){const he=this.t(new r(this.h,X),O);return this.e.$registerHoverProvider(he,this.o(W)),this.p(he)}$provideHover(O,W,X,Q){return this.s(O,r,he=>he.provideHover(o.URI.revive(W),X,Q),void 0,Q)}registerEvaluatableExpressionProvider(O,W,X,Q){const he=this.t(new f(this.h,X),O);return this.e.$registerEvaluatableExpressionProvider(he,this.o(W)),this.p(he)}$provideEvaluatableExpression(O,W,X,Q){return this.s(O,f,he=>he.provideEvaluatableExpression(o.URI.revive(W),X,Q),void 0,Q)}registerInlineValuesProvider(O,W,X,Q){const he=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new E(this.h,X),O);this.e.$registerInlineValuesProvider(we,this.o(W),he);let Ae=this.p(we);if(he!==void 0){const pe=X.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(he));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideInlineValues(O,W,X,Q,he){return this.s(O,E,we=>we.provideInlineValues(o.URI.revive(W),X,Q,he),void 0,he)}registerDocumentHighlightProvider(O,W,X){const Q=this.t(new T(this.h,X),O);return this.e.$registerDocumentHighlightProvider(Q,this.o(W)),this.p(Q)}$provideDocumentHighlights(O,W,X,Q){return this.s(O,T,he=>he.provideDocumentHighlights(o.URI.revive(W),X,Q),void 0,Q)}registerLinkedEditingRangeProvider(O,W,X){const Q=this.t(new M(this.h,X),O);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(W)),this.p(Q)}$provideLinkedEditingRanges(O,W,X,Q){return this.s(O,M,async he=>{const we=await he.provideLinkedEditingRanges(o.URI.revive(W),X,Q);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ae.w(we.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(O,W,X){const Q=this.t(new K(this.h,X),O);return this.e.$registerReferenceSupport(Q,this.o(W)),this.p(Q)}$provideReferences(O,W,X,Q,he){return this.s(O,K,we=>we.provideReferences(o.URI.revive(W),X,Q,he),void 0,he)}registerCodeActionProvider(O,W,X,Q){const he=new S.DisposableStore,we=this.t(new V(this.h,this.j.converter,this.k,X,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(we,this.o(W),{providedKinds:Q?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Q?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,he)}))},ae.u(O),Boolean(X.resolveCodeAction)),he.add(this.p(we)),he}$provideCodeActions(O,W,X,Q,he){return this.s(O,V,we=>we.provideCodeActions(o.URI.revive(W),X,Q,he),void 0,he)}$resolveCodeAction(O,W,X){return this.s(O,V,Q=>Q.resolveCodeAction(W,X),void 0,void 0)}$releaseCodeActions(O,W){this.s(O,V,X=>Promise.resolve(X.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(O,W,X){const Q=this.t(new U(this.h,X),O);return this.e.$registerDocumentFormattingSupport(Q,this.o(W),O.identifier,O.displayName||O.name),this.p(Q)}$provideDocumentFormattingEdits(O,W,X,Q){return this.s(O,U,he=>he.provideDocumentFormattingEdits(o.URI.revive(W),X,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(O,W,X){const Q=this.t(new N(this.h,X),O);return this.e.$registerRangeFormattingSupport(Q,this.o(W),O.identifier,O.displayName||O.name),this.p(Q)}$provideDocumentRangeFormattingEdits(O,W,X,Q,he){return this.s(O,N,we=>we.provideDocumentRangeFormattingEdits(o.URI.revive(W),X,Q,he),void 0,he)}registerOnTypeFormattingEditProvider(O,W,X,Q){const he=this.t(new B(this.h,X),O);return this.e.$registerOnTypeFormattingSupport(he,this.o(W),Q,O.identifier),this.p(he)}$provideOnTypeFormattingEdits(O,W,X,Q,he,we){return this.s(O,B,Ae=>Ae.provideOnTypeFormattingEdits(o.URI.revive(W),X,Q,he,we),void 0,we)}registerWorkspaceSymbolProvider(O,W){const X=this.t(new j(W,this.l),O);return this.e.$registerNavigateTypeSupport(X,typeof W.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(O,W,X){return this.s(O,j,Q=>Q.provideWorkspaceSymbols(W,X),{symbols:[]},X)}$resolveWorkspaceSymbol(O,W,X){return this.s(O,j,Q=>Q.resolveWorkspaceSymbol(W,X),void 0,void 0)}$releaseWorkspaceSymbols(O,W){this.s(O,j,X=>X.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(O,W,X){const Q=this.t(new z(this.h,X,this.l),O);return this.e.$registerRenameSupport(Q,this.o(W),z.supportsResolving(X)),this.p(Q)}$provideRenameEdits(O,W,X,Q,he){return this.s(O,z,we=>we.provideRenameEdits(o.URI.revive(W),X,Q,he),void 0,he)}$resolveRenameLocation(O,W,X,Q){return this.s(O,z,he=>he.resolveRenameLocation(o.URI.revive(W),X,Q),void 0,Q)}registerDocumentSemanticTokensProvider(O,W,X,Q){const he=this.t(new _(this.h,X),O),we=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(W),Q,we);let Ae=this.p(he);if(we){const pe=X.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideDocumentSemanticTokens(O,W,X,Q){return this.s(O,_,he=>he.provideDocumentSemanticTokens(o.URI.revive(W),X,Q),null,Q)}$releaseDocumentSemanticTokens(O,W){this.s(O,_,X=>X.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,W,X,Q){const he=this.t(new Y(this.h,X),O);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(W),Q),this.p(he)}$provideDocumentRangeSemanticTokens(O,W,X,Q){return this.s(O,Y,he=>he.provideDocumentRangeSemanticTokens(o.URI.revive(W),X,Q),null,Q)}registerCompletionItemProvider(O,W,X,Q){const he=this.t(new J(this.h,this.j.converter,X,this.m,O),O);return this.e.$registerCompletionsProvider(he,this.o(W),Q,J.supportsResolving(X),`${O.identifier.value}(${Q.join("")})`),this.p(he)}$provideCompletionItems(O,W,X,Q,he){return this.s(O,J,we=>we.provideCompletionItems(o.URI.revive(W),X,Q,he),void 0,he)}$resolveCompletionItem(O,W,X){return this.s(O,J,Q=>Q.resolveCompletionItem(W,X),void 0,X)}$releaseCompletionItems(O,W){this.s(O,J,X=>X.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(O,W,X){const Q=new ge(O,this.h,X,this.j.converter),he=this.t(Q,O);return this.e.$registerInlineCompletionsSupport(he,this.o(W),Q.supportsHandleDidShowCompletionItem),this.p(he)}$provideInlineCompletions(O,W,X,Q,he){return this.s(O,ee,we=>we.provideInlineCompletions(o.URI.revive(W),X,Q,he),void 0,he)}$handleInlineCompletionDidShow(O,W,X){this.s(O,ee,async Q=>{Q.handleDidShowCompletionItem(W,X)},void 0,void 0)}$freeInlineCompletionsList(O,W){this.s(O,ee,async X=>{X.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(O,W,X,Q){const he=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,we=this.t(new G(this.h,X),O);return this.e.$registerSignatureHelpProvider(we,this.o(W),he),this.p(we)}$provideSignatureHelp(O,W,X,Q,he){return this.s(O,G,we=>we.provideSignatureHelp(o.URI.revive(W),X,Q,he),void 0,he)}$releaseSignatureHelp(O,W){this.s(O,G,X=>X.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(O,W,X){const Q=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new le(this.h,this.j.converter,X,this.l,O),O);this.e.$registerInlayHintsProvider(he,this.o(W),typeof X.resolveInlayHint=="function",Q,ae.u(O));let we=this.p(he);if(Q!==void 0){const Ae=X.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Q));we=R.Disposable.from(we,Ae)}return we}$provideInlayHints(O,W,X,Q){return this.s(O,le,he=>he.provideInlayHints(o.URI.revive(W),X,Q),void 0,Q)}$resolveInlayHint(O,W,X){return this.s(O,le,Q=>Q.resolveInlayHint(W,X),void 0,X)}$releaseInlayHints(O,W){this.s(O,le,X=>X.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(O,W,X){const Q=this.t(new be(this.h,X),O);return this.e.$registerDocumentLinkProvider(Q,this.o(W),typeof X.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(O,W,X){return this.s(O,be,Q=>Q.provideLinks(o.URI.revive(W),X),void 0,X,W.scheme==="output")}$resolveDocumentLink(O,W,X){return this.s(O,be,Q=>Q.resolveLink(W,X),void 0,void 0,!0)}$releaseDocumentLinks(O,W){this.s(O,be,X=>X.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(O,W,X){const Q=this.t(new ve(this.h,X),O);return this.e.$registerDocumentColorProvider(Q,this.o(W)),this.p(Q)}$provideDocumentColors(O,W,X){return this.s(O,ve,Q=>Q.provideColors(o.URI.revive(W),X),[],X)}$provideColorPresentations(O,W,X,Q){return this.s(O,ve,he=>he.provideColorPresentations(o.URI.revive(W),X,Q),void 0,Q)}registerFoldingRangeProvider(O,W,X){const Q=this.q(),he=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new Z(new Pe(this.h,X),O)),this.e.$registerFoldingRangeProvider(Q,this.o(W),O.identifier,he);let we=this.p(Q);if(he!==void 0){const Ae=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideFoldingRanges(O,W,X,Q){return this.s(O,Pe,he=>he.provideFoldingRanges(o.URI.revive(W),X,Q),void 0,Q)}registerSelectionRangeProvider(O,W,X){const Q=this.t(new Ne(this.h,X,this.l),O);return this.e.$registerSelectionRangeProvider(Q,this.o(W)),this.p(Q)}$provideSelectionRanges(O,W,X,Q){return this.s(O,Ne,he=>he.provideSelectionRanges(o.URI.revive(W),X,Q),[],Q)}registerCallHierarchyProvider(O,W,X){const Q=this.t(new se(this.h,X),O);return this.e.$registerCallHierarchyProvider(Q,this.o(W)),this.p(Q)}$prepareCallHierarchy(O,W,X,Q){return this.s(O,se,he=>Promise.resolve(he.prepareSession(o.URI.revive(W),X,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(O,W,X,Q){return this.s(O,se,he=>he.provideCallsTo(W,X,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(O,W,X,Q){return this.s(O,se,he=>he.provideCallsFrom(W,X,Q),void 0,Q)}$releaseCallHierarchy(O,W){this.s(O,se,X=>Promise.resolve(X.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(O,W,X){const Q=this.t(new ue(this.h,X),O);return this.e.$registerTypeHierarchyProvider(Q,this.o(W)),this.p(Q)}$prepareTypeHierarchy(O,W,X,Q){return this.s(O,ue,he=>Promise.resolve(he.prepareSession(o.URI.revive(W),X,Q)),void 0,Q)}$provideTypeHierarchySupertypes(O,W,X,Q){return this.s(O,ue,he=>he.provideSupertypes(W,X,Q),void 0,Q)}$provideTypeHierarchySubtypes(O,W,X,Q){return this.s(O,ue,he=>he.provideSubtypes(W,X,Q),void 0,Q)}$releaseTypeHierarchy(O,W){this.s(O,ue,X=>Promise.resolve(X.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(O,W,X){const Q=this.q();return this.f.set(Q,new Z(new de(this.e,this.h,X,Q),O)),this.e.$registerDocumentOnDropEditProvider(Q,this.o(W)),this.p(Q)}$provideDocumentOnDropEdits(O,W,X,Q,he,we){return this.s(O,de,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(W,o.URI.revive(X),Q,he,we)),void 0,void 0)}registerDocumentPasteEditProvider(O,W,X,Q){const he=this.q();return this.f.set(he,new Z(new F(this.e,this.h,X,he),O)),this.e.$registerPasteEditProvider(he,this.o(W),!!X.prepareDocumentPaste,Q.pasteMimeTypes),this.p(he)}$prepareDocumentPaste(O,W,X,Q,he){return this.s(O,F,we=>we.prepareDocumentPaste(o.URI.revive(W),X,Q,he),void 0,he)}$providePasteEdits(O,W,X,Q,he,we){return this.s(O,F,Ae=>Ae.providePasteEdits(W,o.URI.revive(X),Q,he,we),void 0,we)}static w(O){return{pattern:O.source,flags:(0,y.regExpFlags)(O)}}static y(O){return{decreaseIndentPattern:ae.w(O.decreaseIndentPattern),increaseIndentPattern:ae.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ae.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ae.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:ae.w(O.beforeText),afterText:O.afterText?ae.w(O.afterText):void 0,previousLineText:O.previousLineText?ae.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(ae.z)}setLanguageConfiguration(O,W,X){const{wordPattern:Q}=X;if(Q&&(0,y.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(W,Q):this.h.setWordDefinitionFor(W,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const he=this.q(),we={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?ae.w(X.wordPattern):void 0,indentationRules:X.indentationRules?ae.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?ae.B(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this.e.$setLanguageConfiguration(he,W,we),this.p(he)}$setWordDefinitions(O){for(const W of O)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=ae,ae.d=0}),define(ye[258],Ce([1,0,5,14,7,37,16,6]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,P,v,C){this.c=P,this.d=v,this.e=C,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,P){await this.a.$changeLanguage(L,P);const v=this.c.getDocumentData(L);if(!v)throw new Error(`document '${L.toString()}' NOT found`);return v.document}async tokenAtPosition(L,P){const v=L.version,C=t.Position.from(P),S=await this.a.$tokensAtPosition(L.uri,C),m={type:k.StandardTokenType.Other,range:L.getWordRangeAtPosition(P)??new k.Range(P.line,P.character,P.line,P.character)};if(!S)return m;const d={range:t.Range.to(S.range),type:t.TokenType.to(S.type)};return!d.range.contains(P)||v!==L.version?m:d}createLanguageStatusItem(L,P,v){const C=this.f++,S=this.a,m=this.g,d=`${L.identifier.value}/${P}`;if(m.has(d))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);m.add(d);const h={selector:v,id:P,name:L.displayName??L.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const g=new A.DisposableStore,p=()=>{b?.dispose(),b=(0,I.disposableTimeout)(()=>{g.clear(),this.a.$setLanguageStatus(C,{id:d,name:h.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===k.LanguageStatusSeverity.Error?R.default.Error:h.severity===k.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:h.command&&this.d.toInternal(h.command,g),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},w={dispose(){g.dispose(),b?.dispose(),S.$removeLanguageStatus(C),m.delete(d)},get id(){return h.id},get name(){return h.name},set name(i){h.name=i,p()},get selector(){return h.selector},set selector(i){h.selector=i,p()},get text(){return h.text},set text(i){h.text=i,p()},get detail(){return h.detail},set detail(i){h.detail=i,p()},get severity(){return h.severity},set severity(i){h.severity=i,p()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(i){h.accessibilityInformation=i,p()},get command(){return h.command},set command(i){h.command=i,p()},get busy(){return h.busy},set busy(i){h.busy=i,p()}};return p(),w}}e.ExtHostLanguages=y}),define(ye[96],Ce([1,0,12,8,2,4,13,5,25,17]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,C,S){this.f=S,this.d=new Map,this.a=C.getProxy(A.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===o.LANGUAGE_DEFAULT}getMessage(v,C){const{message:S,args:m,comment:d}=C;if(this.c)return(0,t.format2)(S,m??{});let h=S;d&&d.length>0&&(h+=`/${Array.isArray(d)?d.join():d}`);const b=this.d.get(v)?.contents[h];return b||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,t.format2)(b??S,m??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let C;const S=await this.g(v);if(!S){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const m=await this.a.$fetchBundleContents(S),d=JSON.parse(m);C=v.isBuiltin?d.contents?.bundle:d}catch(m){this.f.error(`Failed to load translations for ${v.identifier.value} from ${S}: ${m.message}`);return}C&&this.d.set(v.identifier.value,{contents:C,uri:S})}async g(v){if(v.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(v.identifier.value);return k.URI.revive(C)}return v.l10n?k.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([We(0,y.IExtHostInitDataService),We(1,D.IExtHostRpcService),We(2,I.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],Ce([1,0,13,5,25,17,2,3,11]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends o.AbstractLoggerService{constructor(v,C){super(C.logLevel,A.Event.None),this.g=v.getProxy(t.MainContext.MainThreadLogger)}$setLevel(v,C){C?this.setLevel(I.URI.revive(C),v):(0,y.isUndefined)(v)||this.setLevel(v)}f(v,C,S){return new L(this.g,v,C,S)}};D=qe([We(0,R.IExtHostRpcService),We(1,k.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class L extends o.AbstractMessageLogger{constructor(v,C,S,m){super(m?.always),this.m=v,this.n=C,this.k=!1,this.l=[],this.setLevel(S),this.m.$createLogger(C,m).then(()=>{this.r(this.l),this.k=!0})}g(v,C){const S=[[v,C]];this.k?this.r(S):this.l.push(...S)}r(v){this.m.$log(this.n,v)}}}),define(ye[259],Ce([1,0,5,13,27]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(A){return A&&A.title}let I=class{constructor(y,D){this.b=D,this.a=y.getProxy(o.MainContext.MainThreadMessageService)}showMessage(y,D,L,P,v){const C={source:{identifier:y.identifier,label:y.displayName||y.name}};let S;typeof P=="string"||R(P)?S=[P,...v]:(C.modal=P?.modal,C.useCustom=P?.useCustom,C.detail=P?.detail,S=v),C.useCustom&&(0,k.checkProposedApiEnabled)(y,"resolvers");const m=[];for(let d=0;d<S.length;d++){const h=S[d];if(typeof h=="string")m.push({title:h,handle:d,isCloseAffordance:!1});else if(typeof h=="object"){const{title:b,isCloseAffordance:g}=h;m.push({title:b,isCloseAffordance:!!g,handle:d})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(D,L,C,m).then(d=>{if(typeof d=="number")return S[d]})}};I=qe([We(1,t.ILogService)],I),e.ExtHostMessageService=I}),define(ye[260],Ce([1,0,22,3,6,28,8,11,2,69,5,40,14,7,57,235,136]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(g=>g.apiEditor)}constructor(g,p,w,i){this.q=w,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=g.getProxy(L.MainContext.MainThreadNotebook),this.c=g.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=g.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const a=s.notebookEditor?.notebookUri,u=s.cell.handle,c=this.g.get(a)?.getCell(u);if(c)return c.apiCell}if(s&&s.$mid===14){const a=s.uri,u=this.g.get(a);if(u)return u.apiNotebook}return s}}),h.x(p)}getEditorById(g){const p=this.h.get(g);if(!p)throw new Error(`unknown text editor: ${g}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(g){for(const[p,w]of this.h)if(w.apiEditor===g)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(g,p){const w=this.g.get(g);if(!w&&!p)throw new Error(`NO notebook document for '${g}'`);return w}static s(g,p){if(!p)return;const w=p.filenamePattern.map(i=>v.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(p.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:p.displayName,filenamePattern:w,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,p,w){const i=h.a++,s=typeof w.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(i,w),this.b.$registerNotebookCellStatusBarItemProvider(i,s,p);let a;return s!==void 0&&(a=w.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(s))),new C.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,s),a?.dispose()})}async createNotebookDocument(g){const p=await this.c.$tryCreateNotebook({viewType:g.viewType,content:g.content&&v.NotebookData.from(g.content)});return y.URI.revive(p)}async openNotebookDocument(g){const p=this.g.get(g);if(p)return p.apiNotebook;const w=await this.c.$tryOpenNotebook(g),i=this.g.get(y.URI.revive(w));return(0,A.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(g,p){y.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let w;typeof p=="object"?w={position:v.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(v.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:w={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(g.uri,g.notebookType,w),s=i&&this.h.get(i)?.apiEditor;if(s)return s;throw i?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,p,w,i){const s=this.f.get(g),a=y.URI.revive(p),u=this.g.get(a);if(!u||!s)return;const l=u.getCellFromIndex(w);if(!l)return;const c=await s.provideCellStatusBarItems(l.apiCell,i);if(!c)return;const n=new k.DisposableStore,r=this.p.add([n]),E=(Array.isArray(c)?c:[c]).map(T=>v.NotebookStatusBarItem.from(T,this.i,n));return{cacheId:r,items:E}}$releaseNotebookCellStatusBarItems(g){this.p.delete(g)}registerNotebookSerializer(g,p,w,i,s){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,w),this.b.$registerNotebookSerializer(a,{id:g.identifier,location:g.extensionLocation},p,v.NotebookDocumentContentOptions.from(i),h.s(g,s)),(0,k.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(g,p,w){const i=this.u.get(g);if(!i)throw new Error("NO serializer found");const s=await i.deserializeNotebook(p.buffer,w);return new S.SerializableObjectWithBuffers(v.NotebookData.from(s))}async $notebookToData(g,p,w){const i=this.u.get(g);if(!i)throw new Error("NO serializer found");const s=await i.serializeNotebook(v.NotebookData.to(p.value),w);return o.VSBuffer.wrap(s)}w(g,p,w){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const i=new d.ExtHostNotebookEditor(p,this.d,g,w.visibleRanges.map(v.NotebookRange.to),w.selections.map(v.NotebookRange.to),typeof w.viewColumn=="number"?v.ViewColumn.to(w.viewColumn):void 0);this.h.set(p,i)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const w of g.value.removedDocuments){const i=y.URI.revive(w),s=this.g.get(i);s&&(s.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(s.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===i.toString()&&this.h.delete(a.id)}if(g.value.addedDocuments){const w=[];for(const i of g.value.addedDocuments){const s=y.URI.revive(i.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const a=new m.ExtHostNotebookDocument(this.c,this.q,this.r,s,i);w.push(...i.cells.map(u=>m.ExtHostCell.asModelAddData(a.apiNotebook,u))),this.g.get(s)?.dispose(),this.g.set(s,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(a.apiNotebook)}}if(g.value.addedEditors)for(const w of g.value.addedEditors){if(this.h.has(w.id))return;const i=y.URI.revive(w.documentUri),s=this.g.get(i);s&&this.w(s,w.id,w)}const p=[];if(g.value.removedEditors)for(const w of g.value.removedEditors){const i=this.h.get(w);i&&(this.h.delete(w),this.k?.id===i.id&&(this.k=void 0),p.push(i))}if(g.value.visibleEditors){this.l=g.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const w=new Set;this.l.forEach(i=>w.add(i.id));for(const i of this.h.values()){const s=w.has(i.id);i._acceptVisibility(s)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this.k=void 0:g.value.newActiveEditor&&(this.k=this.h.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(g){const p=P.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new P.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>o.VSBuffer.wrap(s))],new P.ApiCommandResult("Notebook Data",s=>v.NotebookData.to(s.value))),i=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new S.SerializableObjectWithBuffers(v.NotebookData.from(s)))],new P.ApiCommandResult("Bytes",s=>s.buffer));g.registerApiCommand(w),g.registerApiCommand(i)}}e.ExtHostNotebookController=h,h.a=0}),define(ye[261],Ce([1,0,18,16,21,3,6,28,2,26,13,69,5,40,14,7,93,223,27,57]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let p=class{constructor(l,c,n,r,f){this.k=c,this.l=n,this.m=r,this.n=f,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=l.getProxy(v.MainContext.MainThreadNotebookKernels);const E=new C.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new C.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const M=this.l.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:M}}else if(T&&"notebookEditor"in T){const M=this.l.getIdByEditor(T.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return T})],C.ApiCommandResult.Void);this.m.registerApiCommand(E)}createNotebookController(l,c,n,r,f,E){for(const ee of this.h.values())if(ee.controller.id===c&&D.ExtensionIdentifier.equals(l.identifier,ee.extensionId))throw new Error(`notebook controller with id '${c}' ALREADY exist`);const T=this.i++,M=this;this.n.trace(`NotebookController[${T}], CREATED by ${l.identifier.value}, ${c}`);const K=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${l.identifier}'`);let V=!1;const F=new I.DisposableStore,U=new R.Emitter,N=new R.Emitter,B={id:a(l.identifier,c),notebookType:n,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:r||l.identifier.value,preloads:E?E.map(S.NotebookRendererScript.from):[]};let j=f??K,z;this.a.$addKernel(T,B).catch(ee=>{console.log(ee),V=!0});let ne=0;const _=()=>{if(V)return;const ee=++ne;Promise.resolve().then(()=>{ee===ne&&this.a.$updateKernel(T,B)})},Y=new A.ResourceMap,J={get id(){return c},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return B.label},set label(ee){B.label=ee??l.displayName??l.name,_()},get detail(){return B.detail??""},set detail(ee){B.detail=ee,_()},get description(){return B.description??""},set description(ee){B.description=ee,_()},get kind(){return(0,b.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind??""},set kind(ee){(0,b.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind=ee,_()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ee){B.supportedLanguages=ee,_()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ee){B.supportsExecutionOrder=ee,_()},get rendererScripts(){return B.preloads?B.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return j},set executeHandler(ee){j=ee??K},get interruptHandler(){return z},set interruptHandler(ee){z=ee,B.supportsInterrupt=Boolean(ee),_()},createNotebookCellExecution(ee){if(V)throw new Error("notebook controller is DISPOSED");if(!Y.has(ee.notebook.uri))throw M.n.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ge=>ge.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.notebook.uri.toString()}`);return M._createNotebookCellExecution(ee,a(l.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${T}], DISPOSED`),V=!0,this.h.delete(T),F.dispose(),U.dispose(),N.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity(ee,ge){ge===m.NotebookControllerAffinity2.Hidden&&(0,b.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),M.a.$updateNotebookPriority(T,ee.uri,ge)},onDidReceiveMessage:N.event,postMessage(ee,ge){return(0,b.checkProposedApiEnabled)(l,"notebookMessaging"),M.a.$postMessage(T,ge&&M.l.getIdByEditor(ge),ee)},asWebviewUri(ee){return(0,b.checkProposedApiEnabled)(l,"notebookMessaging"),(0,d.asWebviewUri)(ee,M.k.remote)}};return this.h.set(T,{extensionId:l.identifier,controller:J,onDidReceiveMessage:N,onDidChangeSelection:U,associatedNotebooks:Y}),J}getIdByController(l){for(const[c,n]of this.h)if(n.controller===l)return a(n.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,c){const n=this.d++,r=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(n,c);const f={dispose:()=>{this.c.delete(n),r.a.$removeKernelDetectionTask(n)}};return this.c.set(n,f),f}registerKernelSourceActionProvider(l,c,n){const r=this.f++,f=this;return this.e.set(r,n),this.n.trace(`NotebookKernelSourceActionProvider[${r}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(r,c),{dispose:()=>{this.e.delete(r),f.a.$removeKernelSourceActionProvider(r)}}}async $provideKernelSourceActions(l,c){const n=this.e.get(l);if(n){const r=new I.DisposableStore;return this.g.add([r]),(await n.provideNotebookKernelSourceActions(c)??[]).map(E=>S.NotebookKernelSourceAction.from(E,this.m.converter,r))}return[]}$acceptNotebookAssociation(l,c,n){const r=this.h.get(l);if(r){const f=this.l.getNotebookDocument(y.URI.revive(c));n?r.associatedNotebooks.set(f.uri,!0):r.associatedNotebooks.delete(f.uri),this.n.trace(`NotebookController[${l}] ASSOCIATE notebook`,f.uri.toString(),n),r.onDidChangeSelection.fire({selected:n,notebook:f.apiNotebook})}}async $executeCells(l,c,n){const r=this.h.get(l);if(!r)return;const f=this.l.getNotebookDocument(y.URI.revive(c)),E=[];for(const T of n){const M=f.getCell(T);M&&E.push(M.apiCell)}try{this.n.trace(`NotebookController[${l}] EXECUTE cells`,f.uri.toString(),E.length),await r.controller.executeHandler.call(r.controller,E,f.apiNotebook,r.controller)}catch(T){this.n.error(`NotebookController[${l}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(l,c,n){const r=this.h.get(l);if(!r)return;const f=this.l.getNotebookDocument(y.URI.revive(c));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,f.apiNotebook);else for(const E of n){const T=f.getCell(E);T&&this.b.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,c,n){const r=this.h.get(l);if(!r)return;const f=this.l.getEditorById(c);r.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:n}))}$cellExecutionChanged(l,c,n){const f=this.l.getNotebookDocument(y.URI.revive(l)).getCell(c);if(f){const E=n?S.NotebookCellExecutionState.to(n):m.NotebookCellExecutionState.Idle;E!==void 0&&this.j.fire({cell:f.apiCell,state:E})}}_createNotebookCellExecution(l,c){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this.l.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!r)throw new Error("invalid cell");if(this.b.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const f=new i(c,r,this.a);this.b.set(r.uri,f);const E=f.onDidChangeState(()=>{f.state===w.Resolved&&(f.dispose(),E.dispose(),this.b.delete(r.uri))});return f.asApiObject()}};p=qe([We(4,L.ILogService)],p),e.ExtHostNotebookKernels=p;var w;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(w||(w={}));class i extends I.Disposable{get state(){return this.f}constructor(l,c,n){super(),this.j=c,this.k=n,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new k.CancellationTokenSource),this.h=new s(10,r=>this.m(r)),this.i=c.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const c=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new g.SerializableObjectWithBuffers(c))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(l){let c=this.j;if(l&&(c=this.j.notebook.getCellFromApiCell(l)),!c)throw new Error("INVALID cell");return c.handle}s(l){return l.map(c=>{const n=m.NotebookCellOutput.ensureUniqueMimeTypes(c.items,!0);return n===c.items?S.NotebookCellOutput.from(c):S.NotebookCellOutput.from({items:n,id:c.id,metadata:c.metadata})})}async t(l,c,n){const r=this.r(c),f=this.s((0,o.asArray)(l));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:r,append:n,outputs:f})}async w(l,c,n){return l=m.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(l),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:l.map(S.NotebookCellOutputItem.from),outputId:c.id,append:n})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(n){l.i=n,l.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(n){if(l.f===w.Resolved||l.f===w.Started)throw new Error("Cannot call start again");l.f=w.Started,l.c.fire(),l.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,r){if(l.f===w.Resolved)throw new Error("Cannot call resolve twice");l.f=w.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new g.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:n}))},clearOutput(n){return l.n(),l.t([],n,!1)},appendOutput(n,r){return l.n(),l.t(n,r,!0)},replaceOutput(n,r){return l.n(),l.t(n,r,!1)},appendOutputItems(n,r){return l.n(),l.w(n,r,!0)},replaceOutputItems(n,r){return l.n(),l.w(n,r,!1)}})}}i.a=0;class s{constructor(l,c){this.d=l,this.e=c,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const c=this.a;return this.a=[],this.e(c).finally(()=>l.complete())}}function a(u,l){return`${u.value}/${l}`}e.createKernelId=a}),define(ye[262],Ce([1,0,3,5,136]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,D){const L=this.c.getEditorById(A);this.a.get(y)?.fire({editor:L.apiEditor,message:D})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(L=>L.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(L,P,v)=>this.d(y).event(L,P,v),postMessage:(L,P)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const v=P&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(v?.id,y,L)}}}d(A){let y=this.a.get(A);return y||(y=new o.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=R}),define(ye[263],Ce([1,0,6,11,2,27,5]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(D){this.b=new Map,this.a=D.getProxy(I.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(D,L,P){if((0,R.checkProposedApiEnabled)(D,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,P),this.a.$registerProfileContentHandler(L,P.name,P.description,D.identifier.value),(0,o.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(D,L,P,v){const C=this.b.get(D);if(!C)throw new Error(`Unknown handler with id: ${D}`);return C.saveProfile(L,P,v)}async $readProfile(D,L,P){const v=this.b.get(D);if(!v)throw new Error(`Unknown handler with id: ${D}`);return v.readProfile((0,t.isString)(L)?L:k.URI.revive(L),P)}}e.ExtHostProfileContentHandlers=A}),define(ye[264],Ce([1,0,21,3,6,5,2,7,10,18,37,90]),function(te,e,o,t,k,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(C,S,m){const d=C.getProxy(R.MainContext.MainThreadQuickOpen);class h{constructor(l,c){this.e=new Map,this.f=0,this.a=l,this.b=c}showQuickPick(l,c,n=o.CancellationToken.None){this.c=void 0;const r=Promise.resolve(l),f=++this.f,E=d.$show(f,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},n),T={},M=E.then(()=>T);return Promise.race([M,r]).then(K=>{if(K!==T)return r.then(V=>{const F=[];for(let U=0;U<V.length;U++){const N=V[U];typeof N=="string"?F.push({label:N,handle:U}):N.kind===A.QuickPickItemKind.Separator?F.push({type:"separator",label:N.label}):F.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:U})}return c&&typeof c.onDidSelectItem=="function"&&(this.c=U=>{c.onDidSelectItem(V[U])}),d.$setItems(f,F),E.then(U=>{if(typeof U=="number")return V[U];if(Array.isArray(U))return U.map(N=>V[N])})})}).then(void 0,K=>{if(!(0,y.isCancellationError)(K))return d.$setError(f,K),Promise.reject(K)})}$onItemSelected(l){this.c?.(l)}showInput(l,c=o.CancellationToken.None){return this.d=l?.validateInput,d.$input(l,typeof this.d=="function",c).then(void 0,n=>{if(!(0,y.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(l){if(!this.d)return;const c=await this.d(l);if(!c||typeof c=="string")return c;let n;switch(c.severity){case A.InputBoxValidationSeverity.Info:n=L.default.Info;break;case A.InputBoxValidationSeverity.Warning:n=L.default.Warning;break;case A.InputBoxValidationSeverity.Error:n=L.default.Error;break;default:n=c.message?L.default.Error:L.default.Ignore;break}return{content:c.message,severity:n}}async showWorkspaceFolderPick(l,c=o.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!n)return;const r=await this.a.getWorkspaceFolders2();if(!!r)return r.find(f=>f.uri.toString()===n.uri.toString())}createQuickPick(l){const c=new s(l,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}createInputBox(l){const c=new a(l,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}$onDidChangeValue(l,c){this.e.get(l)?._fireDidChangeValue(c)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,c){const n=this.e.get(l);n instanceof s&&n._fireDidChangeActive(c)}$onDidChangeSelection(l,c){const n=this.e.get(l);n instanceof s&&n._fireDidChangeSelection(c)}$onDidTriggerButton(l,c){this.e.get(l)?._fireDidTriggerButton(c)}$onDidTriggerItemButton(l,c,n){const r=this.e.get(l);r instanceof s&&r._fireDidTriggerItemButton(c,n)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class b{constructor(l,c){this.x=l,this.y=c,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((c,n)=>{const r=c===A.QuickInputButtons.Back?-1:n;this.o.set(r,c)}),this.z({buttons:l.map((c,n)=>({...i(c),tooltip:c.tooltip,handle:c===A.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const c=this.o.get(l);c&&this.r.fire(c)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(l){if(!this.v){for(const c of Object.keys(l)){const n=l[c];this.u[c]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}b.a=1;function g(u){if(u instanceof A.ThemeIcon)return{id:u.id};const l=w(u),c=p(u);return{dark:typeof l=="string"?I.URI.file(l):l,light:typeof c=="string"?I.URI.file(c):c}}function p(u){return typeof u=="object"&&"light"in u?u.light:u}function w(u){return typeof u=="object"&&"dark"in u?u.dark:u}function i(u){const l=g(u.iconPath);let c,n;return"id"in l?n=P.ThemeIcon.asClassName(l):c=l,{iconPath:c,iconClass:n}}class s extends b{constructor(l,c){super(l.identifier,c),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((n,r)=>{this.C.set(r,n),this.D.set(n,r)});const c=[];for(let n=0;n<l.length;n++){const r=l[n];r.kind===A.QuickPickItemKind.Separator?c.push({type:"separator",label:r.label}):c.push({handle:n,label:r.label,description:r.description,detail:r.detail,picked:r.picked,alwaysShow:r.alwaysShow,buttons:r.buttons?.map((f,E)=>({...i(f),tooltip:f.tooltip,handle:E}))})}this.z({items:c})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(c=>this.D.has(c)),this.z({activeItems:this.J.map(c=>this.D.get(c))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(c=>this.D.has(c)),this.z({selectedItems:this.L.map(c=>this.D.get(c))})}_fireDidChangeActive(l){const c=(0,D.coalesce)(l.map(n=>this.C.get(n)));this.J=c,this.K.fire(c)}_fireDidChangeSelection(l){const c=(0,D.coalesce)(l.map(n=>this.C.get(n)));this.L=c,this.M.fire(c)}_fireDidTriggerItemButton(l,c){const n=this.C.get(l);if(!n||!n.buttons||!n.buttons.length)return;const r=n.buttons[c];r&&this.N.fire({button:r,item:n})}}class a extends b{constructor(l,c){super(l.identifier,c),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:L.default.Error}):this.z({validationMessage:l.message,severity:l.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new h(S,m)}e.createExtHostQuickOpen=v});var Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o};define(ye[265],Ce([1,0,2,3,60,6,16,5,18,109,13,26,90,14,27]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S){"use strict";var m,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(r){if(r)return typeof r.iconPath=="string"?o.URI.file(r.iconPath):o.URI.isUri(r.iconPath)||v.ThemeIcon.isThemeIcon(r.iconPath)?r.iconPath:void 0}function b(r,f){if(!r.iconPath&&!f.iconPath)return 0;if(r.iconPath){if(!f.iconPath)return 1}else return-1;const E=typeof r.iconPath=="string"?r.iconPath:o.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id,T=typeof f.iconPath=="string"?f.iconPath:o.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,D.comparePaths)(E,T)}function g(r,f){let E=0;if(r.strikeThrough!==f.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==f.faded)return r.faded?1:-1;if(r.tooltip!==f.tooltip)return(r.tooltip||"").localeCompare(f.tooltip||"");if(E=b(r,f),E!==0)return E;if(r.light&&f.light)E=b(r.light,f.light);else{if(r.light)return 1;if(f.light)return-1}if(E!==0)return E;if(r.dark&&f.dark)E=b(r.dark,f.dark);else{if(r.dark)return 1;if(f.dark)return-1}return E}function p(r,f){if(r.command!==f.command)return r.command<f.command?-1:1;if(r.title!==f.title)return r.title<f.title?-1:1;if(r.tooltip!==f.tooltip){if(r.tooltip!==void 0&&f.tooltip!==void 0)return r.tooltip<f.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(r.arguments===f.arguments)return 0;if(r.arguments)if(f.arguments){if(r.arguments.length!==f.arguments.length)return r.arguments.length-f.arguments.length}else return 1;else return-1;for(let E=0;E<r.arguments.length;E++){const T=r.arguments[E],M=f.arguments[E];if(T!==M)return T<M?-1:1}return 0}function w(r,f){let E=(0,D.comparePaths)(r.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(E!==0)return E;if(r.command&&f.command)E=p(r.command,f.command);else{if(r.command)return 1;if(f.command)return-1}if(E!==0)return E;if(r.decorations&&f.decorations)E=g(r.decorations,f.decorations);else{if(r.decorations)return 1;if(f.decorations)return-1}return E}function i(r,f){for(let E=0;E<r.length;E++)if(r[E]!==f[E])return!1;return!0}function s(r,f){return r.command===f.command&&r.title===f.title&&r.tooltip===f.tooltip&&(r.arguments&&f.arguments?i(r.arguments,f.arguments):r.arguments===f.arguments)}function a(r,f){return(0,y.equals)(r,f,s)}class u{get value(){return this.d}set value(f){f=f??"",Ue(this,m,"f").$setInputBoxValue(this.l,f),this.m(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){Ue(this,m,"f").$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,S.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,S.checkProposedApiEnabled)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,Ue(this,m,"f").$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,Ue(this,m,"f").$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,Ue(this,m,"f").$setInputBoxVisibility(this.l,f))}constructor(f,E,T){this.k=f,this.l=T,m.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,m,E,"f")}showValidationMessage(f,E){(0,S.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,m,"f").$showValidationMessage(this.l,f,E)}$onInputBoxValueChange(f){this.m(f)}m(f){this.d=f,this.e.fire(f)}}e.ExtHostSCMInputBox=u,m=new WeakMap;class l{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,E,T,M,K){this.q=f,this.s=E,this.t=T,this.u=M,this.v=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=l.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,E){const T=this.h.get(f);return T?(0,I.asPromise)(()=>this.s.executeCommand(T.command,...T.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(w),T=(0,y.sortedDiff)(this.o,f,w).map(V=>{const F=V.toInsert.map(U=>{const N=this.e++;this.g.set(N,U);const B=U.resourceUri;let j;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const le=new R.DisposableStore;j=this.s.converter.toInternal(U.command,le),this.j.set(N,le)}else this.h.set(N,U.command);const z=h(U.decorations),ne=U.decorations&&h(U.decorations.light)||z,_=U.decorations&&h(U.decorations.dark)||z,Y=[ne,_],J=U.decorations&&U.decorations.tooltip||"",ee=U.decorations&&!!U.decorations.strikeThrough,ge=U.decorations&&!!U.decorations.faded,q=U.contextValue||"";return{rawResource:[N,B,Y,J,ee,ge,q,j],handle:N}});return{start:V.start,deleteCount:V.deleteCount,toInsert:F}}),M=T.map(({start:V,deleteCount:F,toInsert:U})=>[V,F,U.map(N=>N.rawResource)]),K=T.reverse();for(const{start:V,deleteCount:F,toInsert:U}of K){const N=U.map(j=>j.handle),B=this.n.splice(V,F,...N);for(const j of B)this.g.delete(j),this.h.delete(j),this.j.get(j)?.dispose(),this.j.delete(j)}return this.o=f,M}dispose(){this.l=!0,this.m.fire()}}l.d=0;class c{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,Ue(this,d,"f").$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f,Ue(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,Ue(this,d,"f").$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new R.DisposableStore,this.l=f;const E=this.v.converter.toInternal(f,this.k.value);Ue(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:E})}get actionButton(){return(0,S.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,S.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=f;const E=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(T=>T.map(M=>this.v.converter.toInternal(M,this.m.value))),description:f.description,enabled:f.enabled}:void 0;Ue(this,d,"f").$updateSourceControl(this.t,{actionButton:E??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&a(this.p,f))return;this.o.value=new R.DisposableStore,this.p=f;const E=(f||[]).map(T=>this.v.converter.toInternal(T,this.o.value));Ue(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:E})}get selected(){return this.q}constructor(f,E,T,M,K,V){this.u=f,this.v=T,this.w=M,this.x=K,this.y=V,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=c.d++,this.z=new Map,this.A=new Set,Je(this,d,E,"f"),this.f=new u(f,Ue(this,d,"f"),this.t),Ue(this,d,"f").$registerSourceControl(this.t,M,K,V)}createResourceGroup(f,E){const T=new l(Ue(this,d,"f"),this.v,this.t,f,E),M=t.Event.once(T.onDidDispose)(()=>this.z.delete(T));return this.z.set(T,M),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const f=[],E=[];for(const[T,M]of this.z){M.dispose();const K=T.onDidUpdateResourceStates(()=>{this.A.add(T),this.eventuallyUpdateResourceStates()});t.Event.once(T.onDidDispose)(()=>{this.A.delete(T),K.dispose(),this.e.delete(T.handle),Ue(this,d,"f").$unregisterGroup(this.t,T.handle)}),f.push([T.handle,T.id,T.label,T.features]);const V=T._takeResourceStateSnapshot();V.length>0&&E.push([T.handle,V]),this.e.set(T.handle,T)}Ue(this,d,"f").$registerGroups(this.t,f,E),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(E=>{const T=E._takeResourceStateSnapshot();T.length!==0&&f.push([E.handle,T])}),f.length>0&&Ue(this,d,"f").$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),Ue(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,c.d=0,qe([(0,k.debounce)(100)],c.prototype,"eventuallyAddResourceGroups",null),qe([(0,k.debounce)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let n=class ii{get onDidChangeActiveProvider(){return this.j.event}constructor(f,E,T){this.l=E,this.m=T,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=f.getProxy(A.MainContext.MainThreadSCM),this.f=f.getProxy(A.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const K=this.g.get(M.sourceControlHandle);if(!K)return M;const V=K.getResourceGroup(M.groupHandle);return V?V.getResourceState(M.handle):M}else if(M&&M.$mid===4){const K=this.g.get(M.sourceControlHandle);return K?K.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const K=this.g.get(M.handle);return K||M}return M}})}createSourceControl(f,E,T,M){this.m.trace("ExtHostSCM#createSourceControl",f.identifier.value,E,T,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const K=ii.d++,V=new c(f,this.e,this.l,E,T,M);this.g.set(K,V);const F=this.h.get(P.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(V),this.h.set(P.ExtensionIdentifier.toKey(f.identifier),F),V}getLastInputBox(f){this.m.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const E=this.h.get(P.ExtensionIdentifier.toKey(f.identifier)),T=E&&E[E.length-1];return T&&T.inputBox}$provideOriginalResource(f,E,T){const M=o.URI.revive(E);this.m.trace("ExtHostSCM#$provideOriginalResource",f,M.toString());const K=this.g.get(f);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>K.quickDiffProvider.provideOriginalResource(M,T)).then(V=>V||null)}$onInputBoxValueChange(f,E){this.m.trace("ExtHostSCM#$onInputBoxValueChange",f);const T=this.g.get(f);return T&&T.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(f,E,T,M){this.m.trace("ExtHostSCM#$executeResourceCommand",f,E,T);const K=this.g.get(f);if(!K)return Promise.resolve(void 0);const V=K.getResourceGroup(E);return V?V.$executeResourceCommand(T,M):Promise.resolve(void 0)}$validateInput(f,E,T){this.m.trace("ExtHostSCM#$validateInput",f);const M=this.g.get(f);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>M.inputBox.validateInput(E,T)).then(K=>{if(!K)return Promise.resolve(void 0);const V=C.MarkdownString.fromStrict(K.message);return V?Promise.resolve([V,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};n.d=0,n=qe([We(2,L.ILogService)],n),e.ExtHostSCM=n}),define(ye[97],Ce([1,0,5,3,4]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(A){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,D){return this.a.$setPassword(A,y,D)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[266],Ce([1,0,7,5,178,6,14,11]),function(te,e,o,t,k,R,I,A){"use strict";var y,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(S,m,d,h,b=o.StatusBarAlignment.Left,g){y.set(this,void 0),D.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new R.DisposableStore,Je(this,y,S,"f"),Je(this,D,m,"f"),this.c=L.a++,this.e=d,this.f=h,this.g=b,this.h=this.t(g)}t(S){if(!!(0,A.isNumber)(S))return S===Number.POSITIVE_INFINITY?Number.MAX_VALUE:S===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:S}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(S){this.k=S,this.u()}set name(S){this.m=S,this.u()}set tooltip(S){this.l=S,this.u()}set color(S){this.n=S,this.u()}set backgroundColor(S){S&&!L.b.has(S.id)&&(S=void 0),this.o=S,this.u()}set command(S){this.q?.fromApi!==S&&(this.p.clear(),typeof S=="string"?this.q={fromApi:S,internal:Ue(this,D,"f").toInternal({title:"",command:S},this.p)}:S?this.q={fromApi:S,internal:Ue(this,D,"f").toInternal(S,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(S){this.s=S,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Ue(this,y,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let S;this.e?this.f?S=`${this.e.identifier.value}.${this.f}`:S=this.e.identifier.value:S=this.f;let m;this.m?m=this.m:m=(0,k.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=L.b.get(this.o.id));const h=I.MarkdownString.fromStrict(this.l);Ue(this,y,"f").$setEntry(this.c,S,m,this.k,h,this.q?.internal,d,this.o,this.g===o.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,D=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(S){this.b=[],this.a=S.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(S){const m={message:S};return this.b.unshift(m),this.c(),new o.Disposable(()=>{const d=this.b.indexOf(m);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(S,m){this.a=S.getProxy(t.MainContext.MainThreadStatusBar),this.b=m,this.c=new P(this)}createStatusBarEntry(S,m,d,h){return new L(this.a,this.b,S,m,d,h)}setStatusBarMessage(S,m){const d=this.c.setMessage(S);let h;return typeof m=="number"?h=setTimeout(()=>d.dispose(),m):typeof m<"u"&&m.then(()=>d.dispose(),()=>d.dispose()),new o.Disposable(()=>{d.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=v}),define(ye[98],Ce([1,0,5,3,4]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(A,y){this.c=y,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,D){const L=await this.a.$initializeExtensionStorage(A,y);let P;return L&&(P=this.d(A,y,L)),P||D}setValue(A,y,D){return this.a.$setValue(A,y,D)}$acceptValue(A,y,D){const L=this.d(A,y,D);L&&this.b.fire({shared:A,key:y,value:L})}d(A,y,D){try{return JSON.parse(D)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(ye[73],Ce([1,0,4,25,13,72,2]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let A=class{constructor(D,L,P){this.d=L,this.f=P,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(D){return I.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,L=await this.g(D);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(I.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:I.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(D){if(this.c)return I.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return I.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([We(0,t.IExtHostInitDataService),We(1,k.ILogService),We(2,R.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ye[41],Ce([1,0,3,5,4,2,17,6,7,179,10,224,21,30,209,90,11,16,14]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class g{constructor(n,r,f,E){this.k=n,this._id=r,this.l=f,this.m=E,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(M=>this.f=M);const T=this;this.value={get name(){return T.m||""},get processId(){return T.b},get creationOptions(){return T.l},get exitStatus(){return T.h},get state(){return T.j},sendText(M,K=!0){T.o(),T.k.$sendText(T._id,M,K)},show(M){T.o(),T.k.$show(T._id,M)},hide(){T.o(),T.k.$hide(T._id)},dispose(){T.a||(T.a=!0,T.k.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,d.withNullAsUndefined)(n.shellPath),shellArgs:(0,d.withNullAsUndefined)(n.shellArgs),cwd:(0,d.withNullAsUndefined)(n.cwd),env:(0,d.withNullAsUndefined)(n.env),icon:(0,d.withNullAsUndefined)(u(n.iconPath)),color:m.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,d.withNullAsUndefined)(n.message),strictEnv:(0,d.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this.n(n.location,r?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,r,f,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:m.ThemeColor.isThemeColor(E)?E.id:void 0,location:this.n(n,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,r){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in n?{viewColumn:b.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,r){this.h=Object.freeze({code:n,reason:r})}setDimensions(n,r){return n===this.d&&r===this.g||n===0||r===0?!1:(this.d=n,this.g=r,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(r=>{r!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=g;class p{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new o.Emitter,this.onProcessData=this.a.event,this.b=new o.Emitter,this.d=new o.Emitter,this.onDidChangeProperty=this.d.event,this.f=new o.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${r}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,r){this.g.setDimensions?.({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(r=>this.a.fire(r)),this.g.onDidClose?.((r=void 0)=>{this.f.fire(r===void 0?void 0:r)}),this.g.onDidOverrideDimensions?.(r=>{r&&this.d.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this.g.onDidChangeName?.(r=>{this.d.fire({type:"title",value:r})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,i=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,r){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new o.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new o.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new o.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new o.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new o.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new o.Emitter,this.onDidChangeShell=this.J.event,this.a=r.getProxy(t.MainContext.MainThreadTerminalService),this.s=new S.TerminalDataBufferer(this.a.$sendProcessData),this.I=new o.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[f,E]of this.g)E.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,r){const f=new g(this.a,(0,C.generateUuid)(),n,n.name),E=new p(n.pty);return f.createExtensionTerminal(n.location,this.L(n,r).resolvedExtHostIdentifier,u(n.iconPath),l(n.color)).then(T=>{const M=this.M(T,E);this.h[T]=M}),this.f.push(f),f.value}L(n,r){if(r=r||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const f=n.location.parentTerminal;if(f){const E=this.f.find(T=>T.value===f);E&&(r.resolvedExtHostIdentifier=E._id)}}else n.location&&typeof n.location!="object"?r.location=n.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(n,r){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const E=new p(r),T=this.M(n,E);this.h[n]=T}async $acceptActiveTerminalChanged(n){const r=this.b;if(n===null){this.b=void 0,r!==this.b&&this.F.fire(this.b);return}const f=this.O(n);f&&(this.b=f,r!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,r){const f=this.O(n);f&&this.I.fire({terminal:f.value,data:r})}async $acceptTerminalDimensions(n,r,f){const E=this.O(n);E&&E.setDimensions(r,f)&&this.G.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,f){this.g.get(n)?.resize(r,f)}async $acceptTerminalTitleChange(n,r){const f=this.O(n);f&&(f.name=r)}async $acceptTerminalClosed(n,r,f){const E=this.Q(this.f,n);if(E!==null){const T=this.f.splice(E,1)[0];T.setExitStatus(r,f),this.C.fire(T.value)}}$acceptTerminalOpened(n,r,f,E){if(r){const K=this.Q(this.f,r);if(K!==null){this.f[K]._id=n,this.D.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const T={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:R.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},M=new g(this.a,n,T,f);this.f.push(M),this.D.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(n,r){this.O(n)?._setProcessId(r)}async $startExtensionTerminal(n,r){const f=this.O(n);if(!f)return{message:(0,D.localize)(0,null,n)};f.isOpen||await new Promise(T=>{const M=this.onDidOpenTerminal(async K=>{K===f.value&&(M.dispose(),T())})});const E=this.g.get(n);E?E.startSendingEvents(r):this.j[n]={initialDimensions:r}}M(n,r){const f=new A.DisposableStore;f.add(r.onProcessReady(T=>this.a.$sendProcessReady(n,T.pid,T.cwd))),f.add(r.onDidChangeProperty(T=>this.a.$sendProcessProperty(n,T))),this.s.startBuffering(n,r.onProcessData),f.add(r.onProcessExit(T=>this.N(n,T))),this.g.set(n,r);const E=this.j[n];return E&&r instanceof p&&(r.startSendingEvents(E.initialDimensions),delete this.j[n]),f}$acceptProcessAckDataEvent(n,r){this.g.get(n)?.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){this.g.get(n)?.input(r)}$acceptTerminalInteraction(n){const r=this.O(n);r?.setInteractedWith()&&this.H.fire(r.value)}$acceptProcessResize(n,r,f){try{this.g.get(n)?.resize(r,f)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(n,r){this.g.get(n)?.shutdown(r)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(r=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(r=>this.a.$sendProcessProperty(n,{type:"cwd",value:r}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,r,f){if(this.v.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this.v.set(r,f),this.a.$registerProfileProvider(r,n.identifier.value),new y.Disposable(()=>{this.v.delete(r),this.a.$unregisterProfileProvider(r)})}registerTerminalQuickFixProvider(n,r,f){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,f),this.a.$registerQuickFixProvider(n,r),new y.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,r){const f=new v.CancellationTokenSource().token;if(f.isCancellationRequested)return;const E=this.w.get(n);if(!E)return;const T=await E.provideTerminalQuickFixes(r,f);if(T!==null)return T}async $createContributedProfileTerminal(n,r){const f=new v.CancellationTokenSource().token;let E=await this.v.get(n)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,r);return}this.createTerminalFromOptions(E.options,r)}}async $provideLinks(n,r){const f=this.O(n);if(!f)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const T=new v.CancellationTokenSource;this.z.set(n,T);const M=[],K={terminal:f.value,line:r},V=[];for(const N of this.u)V.push(h.Promises.withAsyncBody(async B=>{T.token.onCancellationRequested(()=>B({provider:N,links:[]}));const j=await N.provideTerminalLinks(K,T.token)||[];T.token.isCancellationRequested||B({provider:N,links:j})}));const F=await Promise.all(V);if(T.token.isCancellationRequested)return[];const U=new Map;for(const N of F)N&&N.links.length>0&&M.push(...N.links.map(B=>{const j={id:w++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return U.set(j.id,{provider:N.provider,link:B}),j}));return this.y.set(n,U),M}$activateLink(n,r){const f=this.y.get(n)?.get(r);!f||f.provider.handleTerminalLink(f.link)}N(n,r){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const f=this.h[n];f&&(f.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,r)}O(n){return this.P(this.f,n)}P(n,r){const f=this.Q(n,r);return f!==null?n[f]:null}Q(n,r){let f=null;return n.some((E,T)=>E._id===r?(f=T,!0):!1),f}getEnvironmentVariableCollection(n){let r=this.l.get(n.identifier.value);return r||(r=new s,this.S(n.identifier.value,r)),r}R(n,r){const f=(0,P.serializeEnvironmentVariableCollection)(r.map);this.a.$setEnvironmentVariableCollection(n,r.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const f=r[0],E=new s(r[1]);this.S(f,E)})}$acceptDefaultProfile(n,r){const f=this.m;this.m=n,this.n=r,f?.path!==n.path&&this.J.fire(n.path)}S(n,r){this.l.set(n,r),r.onDidChangeCollection(()=>{this.R(n,r)})}};i=qe([We(1,I.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class s{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new o.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,r){this.d(n,{value:r,type:y.EnvironmentVariableMutatorType.Replace})}append(n,r){this.d(n,{value:r,type:y.EnvironmentVariableMutatorType.Append})}prepend(n,r){this.d(n,{value:r,type:y.EnvironmentVariableMutatorType.Prepend})}d(n,r){const f=this.map.get(n);(!f||f.value!==r.value||f.type!==r.type)&&(this.map.set(n,r),this.b.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((f,E)=>n.call(r,E,f,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let a=class extends i{constructor(n){super(!1,n)}createTerminal(n,r,f){throw new L.NotSupportedError}createTerminalFromOptions(n,r){throw new L.NotSupportedError}};a=qe([We(0,I.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function u(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function l(c){return m.ThemeColor.isThemeColor(c)?c:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o};define(ye[267],Ce([1,0,18,16,22,21,3,61,85,6,23,11,30,5,17,137,14,7,56,92,70]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p){"use strict";var w,i;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(U,N,B){this.j=B,this.c=new I.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(C.MainContext.MainThreadTesting),this.h=new M(this.f),this.g=new c(this.f),N.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const z=j,ne=z.tests[z.tests.length-1].item.extId;return this.d.get(b.TestId.root(ne))?.collection.tree.get(ne)?.actual??(0,m.toItemFromContext)(j)}})}createTestController(U,N,B){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const j=new D.DisposableStore,z=j.add(new m.ExtHostTestItemCollection(U,N,this.j));z.root.label=N;const ne=new Map,_=this.f,Y={items:z.root.children,get label(){return N},set label(ee){N=ee,z.root.label=ee,_.$updateController(U,{label:N})},get refreshHandler(){return B},set refreshHandler(ee){B=ee,_.$updateController(U,{canRefresh:!!ee})},get id(){return U},createRunProfile:(ee,ge,q,G,le)=>{let be=(0,y.hash)(ee);for(;ne.has(be);)be++;return new K(this.f,ne,U,be,ee,ge,q,G,le)},createTestItem(ee,ge,q){return new m.TestItemImpl(U,ee,ge,q)},createTestRun:(ee,ge,q=!0)=>this.g.createTestRun(U,z,ee,ge,q),set resolveHandler(ee){z.resolveHandler=ee},get resolveHandler(){return z.resolveHandler},dispose:()=>{j.dispose()}};_.$registerTestController(U,N,!!B),j.add((0,D.toDisposable)(()=>_.$unregisterTestController(U)));const J={controller:Y,collection:z,profiles:ne};return this.d.set(U,J),j.add((0,D.toDisposable)(()=>this.d.delete(U))),j.add(z.onDidGenerateDiff(ee=>_.$publishDiff(U,ee.map(p.TestsDiffOp.serialize)))),Y}createTestObserver(){return this.h.checkout()}async runTests(U,N=R.CancellationToken.None){const B=n(U);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(B.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(z=>b.TestId.fromExtHostTestItem(z,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:V[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:U.exclude?.map(z=>z.id)},N)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,N,B){return(0,o.mapFind)(this.g.trackers,z=>z.id===U?z.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(U,N,B,j){return(0,o.mapFind)(this.g.trackers,ne=>ne.id===U?ne.getCoverage(N):void 0)?.resolveFileCoverage(B,j)??Promise.resolve([])}$configureRunProfile(U,N){this.d.get(U)?.profiles.get(N)?.configureHandler?.()}async $refreshTests(U,N){await this.d.get(U)?.controller.refreshHandler?.(N)}$publishTestResults(U){this.results=Object.freeze(U.map(N=>(0,L.deepFreeze)(d.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,N){const B=this.d.get(b.TestId.fromString(U).controllerId)?.collection;B&&(await B.expand(U,N<0?1/0:N),B.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(p.TestsDiffOp.deserialize))}async $runControllerTests(U,N){return Promise.all(U.map(B=>this.runControllerTestRequest(B,N)))}async runControllerTestRequest(U,N){const B=this.d.get(U.controllerId);if(!B)return{};const{collection:j,profiles:z}=B,ne=z.get(U.profileId);if(!ne)return{};const _=U.testIds.map(ge=>j.tree.get(ge)).filter(P.isDefined),Y=U.excludeExtIds.map(ge=>B.collection.tree.get(ge)).filter(P.isDefined).filter(ge=>_.some(q=>q.fullId.compare(ge.fullId)===2));if(!_.length)return{};const J=new h.TestRunRequest(_.some(ge=>ge.actual instanceof m.TestItemRootImpl)?void 0:_.map(ge=>ge.actual),Y.map(ge=>ge.actual),ne),ee=this.g.prepareForMainThreadTestRun(J,r.fromInternal(U,B.collection),N);try{return await ne.runHandler(J,N),{}}catch(ge){return{error:String(ge)}}finally{ee.hasRunningTasks&&!N.isCancellationRequested&&await I.Event.toPromise(ee.onEnd),ee.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};s=qe([We(0,S.IExtHostRpcService)],s),e.ExtHostTesting=s;const a=1e4;var u;(function(F){F[F.Running=0]="Running",F[F.Cancelling=1]="Cancelling",F[F.Ended=2]="Ended"})(u||(u={}));class l extends D.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,N,B){super(),this.k=U,this.l=N,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(B));const j=this.B(new t.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const N=this.k.id,B=this.k.controllerId,j=(0,v.generateUuid)(),z=new f(this.l,N,j),ne=ee=>(ge,...q)=>{if(Y){console.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(ge)||(this.s(ge),ee(ge,...q))},_=(ee,ge)=>{const q=ge instanceof Array?ge.map(d.TestMessage.from):[d.TestMessage.from(ge)];if(ee.uri&&ee.range){const G={range:d.Range.from(ee.range),uri:ee.uri};for(const le of q)le.location=le.location||G}this.l.$appendTestMessagesInRun(N,j,b.TestId.fromExtHostTestItem(ee,B).toString(),q)};let Y=!1;const J={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return z.coverageProvider},set coverageProvider(ee){z.coverageProvider=ee},enqueued:ne(ee=>{this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(ee,B).toString(),1)}),skipped:ne(ee=>{this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(ee,B).toString(),5)}),started:ne(ee=>{this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(ee,B).toString(),2)}),errored:ne((ee,ge,q)=>{_(ee,ge),this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(ee,B).toString(),6,q)}),failed:ne((ee,ge,q)=>{_(ee,ge),this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(ee,B).toString(),4,q)}),passed:ne((ee,ge)=>{this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(ee,this.k.controllerId).toString(),3,ge)}),appendOutput:(ee,ge,q)=>{Y||(q&&(this.k.isIncluded(q)?this.s(q):q=void 0),this.l.$appendOutputToRun(N,j,k.VSBuffer.fromString(ee),ge&&d.location.from(ge),q&&b.TestId.fromExtHostTestItem(q,B).toString()))},end:()=>{Y||(Y=!0,this.l.$finishedTestRunTask(N,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:J,coverage:z}),this.l.$startedTestRunTask(N,{id:j,name:U,running:!0}),J}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof m.TestItemImpl))throw new g.InvalidTestItemError(U.id);if(this.g.has(b.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const N=[],B=this.k.colllection.root;for(;;){const j=d.TestItem.from(U);if(N.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),U===B))break;U=U.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,N)}}class c{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,N,B){return this.f(U,N,B)}cancelRunById(U){for(const N of this.c.values())if(N.id===U){N.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,N,B,j,z){const ne=this.c.get(B);if(ne)return ne.createRun(j);const _=r.fromPublic(U,N,B,z),Y=n(B);this.d.$startedExtensionTestRun({controllerId:U,profile:Y&&{group:V[Y.kind],id:Y.profileId},exclude:B.exclude?.map(ee=>b.TestId.fromExtHostTestItem(ee,N.root.id).toString())??[],id:_.id,include:B.include?.map(ee=>b.TestId.fromExtHostTestItem(ee,N.root.id).toString())??[N.root.id],persist:z});const J=this.f(B,_);return J.onEnd(()=>{this.d.$finishedExtensionTestRun(_.id),J.dispose()}),J.createRun(j)}f(U,N,B){const j=new l(N,this.d,B);return this.c.set(U,j),j.onEnd(()=>this.c.delete(U)),j}}e.TestRunCoordinator=c;const n=F=>{if(!!F.profile){if(!(F.profile instanceof K))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class r{static fromPublic(U,N,B,j){return new r(U,(0,v.generateUuid)(),B.include?.map(z=>b.TestId.fromExtHostTestItem(z,U).toString())??[U],B.exclude?.map(z=>b.TestId.fromExtHostTestItem(z,U).toString())??[],j,N)}static fromInternal(U,N){return new r(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,N)}constructor(U,N,B,j,z,ne){this.controllerId=U,this.id=N,this.isPersisted=z,this.colllection=ne,this.c=B.map(_=>_+"\0"),this.d=j.map(_=>_+"\0")}isIncluded(U){const N=b.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const B of this.d)if(N===B||N.startsWith(B))return!1;for(const B of this.c)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=r;class f{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,N,B){this.f=U,this.g=N,this.h=B}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(N){throw this.d=void 0,N}}async resolveFileCoverage(U,N){const B=await this.d;let j=B?.[U];return!this.c||!B||!j?[]:(j.detailedCoverage||(j=B[U]=await this.c.resolveFileCoverage?.(j,N)??j),j.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class E{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,d.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const N=b.TestId.parentId(U.item.extId);if(N&&this.g.has(N.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:N,f:B}=this;return{get added(){return[...U].map(j=>j.revived)},get updated(){return[...N].map(j=>j.revived)},get removed(){return[...B].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class T extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new I.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,N){return{...U,revived:d.TestItem.toPlain(U.item),depth:N?N.depth+1:0,children:new Set}}o(){return new E(this.q)}}e.MirroredTestCollection=T;class M{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(N=>N.revived)},dispose:(0,A.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new T;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class K{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?d.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,N,B,j,z,ne,_,Y=!1,J=void 0){this.controllerId=B,this.profileId=j,this.d=z,this.kind=ne,this.runHandler=_,this.f=Y,this._tag=J,w.set(this,void 0),i.set(this,void 0),Je(this,w,U,"f"),Je(this,i,N,"f"),N.set(j,this);const ee=V[ne];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${ne}`);Ue(this,w,"f").$publishTestRunProfile({profileId:j,controllerId:B,tag:J?d.TestTag.namespace(this.controllerId,J.id):null,label:z,group:ee,isDefault:Y,hasConfigurationHandler:!1})}dispose(){Ue(this,i,"f")?.delete(this.profileId)&&(Je(this,i,void 0,"f"),Ue(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=K,w=new WeakMap,i=new WeakMap;const V={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(ye[268],Ce([1,0,18,3,5,138,14,7]),function(te,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(k.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const P=this.i.allEditors();return L?P:P.map(v=>v.value)}async showTextDocument(L,P,v){let C;typeof P=="number"?C={position:I.ViewColumn.from(P),preserveFocus:v}:typeof P=="object"?C={position:I.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?I.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:C={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(L.uri,C),m=S&&this.i.getEditor(S);if(m)return m.value;throw S?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,P){return new R.TextEditorDecorationType(this.h,L,P).value}$acceptEditorPropertiesChanged(L,P){const v=this.i.getEditor(L);if(!v)throw new Error("unknown text editor");if(P.options&&v._acceptOptions(P.options),P.selections){const C=P.selections.selections.map(I.Selection.to);v._acceptSelections(C)}if(P.visibleRanges){const C=o.coalesce(P.visibleRanges.map(I.Range.to));v._acceptVisibleRanges(C)}if(P.options&&this.b.fire({textEditor:v.value,options:{...P.options,lineNumbers:I.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const C=A.TextEditorSelectionChangeKind.fromValue(P.selections.source),S=P.selections.selections.map(I.Selection.to);this.a.fire({textEditor:v.value,selections:S,kind:C})}if(P.visibleRanges){const C=o.coalesce(P.visibleRanges.map(I.Range.to));this.c.fire({textEditor:v.value,visibleRanges:C})}}$acceptEditorPositionData(L){for(const P in L){const v=this.i.getEditor(P);if(!v)throw new Error("Unknown text editor");const C=I.ViewColumn.to(L[P]);v.value.viewColumn!==C&&(v._acceptViewColumn(C),this.d.fire({textEditor:v.value,viewColumn:C}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(ye[269],Ce([1,0,2,4,5,6,7,14,26,11]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class L{constructor(C,S){this.b=new Map,this.c=new Map,this.a=C.getProxy(k.MainContext.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(m,d)=>{if(m&&m.$mid===12)if(this.b.get(m.source)&&y.ExtensionIdentifier.equals(d,this.b.get(m.source)?.extension)){const h=m.uri===void 0?void 0:o.URI.revive(m.uri);return this.c.get(m.source)?.get(P(h))?.get(m.handle)}else return;return m}})}async $getTimeline(C,S,m,d){return this.b.get(C)?.provider.provideTimeline(o.URI.revive(S),m,d)}registerTimelineProvider(C,S,m,d){const h=new R.DisposableStore,b=this.d(S.id,d,h).bind(this);let g;S.onDidChange&&(g=S.onDidChange(w=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:S.id}),this));const p=this.c;return this.f({...S,scheme:C,onDidChange:void 0,async provideTimeline(w,i,s){i?.resetCache&&(h.clear(),p.get(S.id)?.clear());const a=await S.provideTimeline(w,i,s);if(a==null)return;const u=b(w,i);return{...a,source:S.id,items:a.items.map(u)}},dispose(){for(const w of p.values())w.get(S.id)?.clear();g?.dispose(),h.dispose()}},m)}d(C,S,m){return(d,h)=>{let b;if(h?.cacheResults){let g=this.c.get(C);g===void 0&&(g=new Map,this.c.set(C,g));const p=P(d);b=g.get(p),b===void 0&&(b=new Map,g.set(p,b))}return g=>{const{iconPath:p,...w}=g,i=`${C}|${g.id??g.timestamp}`;b?.set(i,g);let s,a,u;g.iconPath&&(p instanceof I.ThemeIcon?u={id:p.id,color:p.color}:o.URI.isUri(p)?(s=p,a=p):{light:s,dark:a}=p);let l;return I.MarkdownString.isMarkdownString(w.tooltip)?l=A.MarkdownString.from(w.tooltip):(0,D.isString)(w.tooltip)?l=w.tooltip:I.MarkdownString.isMarkdownString(w.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=A.MarkdownString.from(w.detail)):(0,D.isString)(w.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=w.detail),{...w,id:w.id??void 0,handle:i,source:C,command:g.command?S.toInternal(g.command,m):void 0,icon:s,iconDark:a,themeIcon:u,tooltip:l,accessibilityInformation:g.accessibilityInformation}}}}f(C,S){if(this.b.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this.a.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this.b.set(C.id,{provider:C,extension:S}),(0,R.toDisposable)(()=>{for(const d of this.c.values())d.get(C.id)?.clear();this.b.delete(C.id),this.a.$unregisterTimelineProvider(C.id),C.dispose()})}}e.ExtHostTimeline=L;function P(v){return v?.toString()}}),define(ye[270],Ce([1,0,6,15,2,5]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(y){this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,D,L,P){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const v=P.schemes.find(C=>!I.a.has(C));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(D,L),this.b.$registerUriOpener(D,P.schemes,y,P.label),(0,o.toDisposable)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(y,D,L){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const v=k.URI.revive(D);return P.canOpenExternalUri(v,L)}async $openUri(y,D,L){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(k.URI.revive(D.resolvedUri),{sourceUri:k.URI.revive(D.sourceUri)},L)}}e.ExtHostUriOpeners=I,I.a=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[271],Ce([1,0,5,2,6,10,26]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(D){this.c=new Set,this.d=new Map,this.b=D.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(D,L){if(this.c.has(I.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const P=A.a++;return this.c.add(I.ExtensionIdentifier.toKey(D)),this.d.set(P,L),this.b.$registerUriHandler(P,D),(0,k.toDisposable)(()=>{this.c.delete(I.ExtensionIdentifier.toKey(D)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(D,L){const P=this.d.get(D);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(L))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(D){return t.URI.revive(await this.b.$createAppUri(D))}}e.ExtHostUrls=A,A.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[74],Ce([1,0,3,15,23,2,194,216,93,5]),function(te,e,o,t,k,R,I,A,y,D){"use strict";var L,P,v,C,S,m,d,h,b,g,p,w,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(T,M,K,V,F,U,N){L.set(this,void 0),P.set(this,void 0),v.set(this,void 0),C.set(this,void 0),S.set(this,void 0),m.set(this,void 0),d.set(this,""),h.set(this,void 0),b.set(this,!1),g.set(this,!1),p.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new o.Emitter),this._onDidDispose=Ue(this,i,"f").event,Je(this,L,T,"f"),Je(this,P,M,"f"),Je(this,h,K,"f"),Je(this,C,V,"f"),Je(this,S,F,"f"),Je(this,m,U,"f"),Je(this,p,a(U),"f"),Je(this,w,u(U),"f"),Je(this,v,N,"f")}dispose(){Je(this,b,!0,"f"),Ue(this,i,"f").fire(),Ue(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(T){return Je(this,g,!0,"f"),(0,y.asWebviewUri)(T,Ue(this,C,"f"))}get cspSource(){const T=Ue(this,m,"f").extensionLocation;if(T.scheme===t.Schemas.https||T.scheme===t.Schemas.http){let M=T.toString();return M.endsWith("/")||(M+="/"),M+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Ue(this,d,"f")}set html(T){this.a(),Ue(this,d,"f")!==T&&(Je(this,d,T,"f"),Ue(this,w,"f")&&!Ue(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(T)&&(Je(this,g,!0,"f"),Ue(this,v,"f").report("Webview vscode-resource: uris",Ue(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,P,"f").$setHtml(Ue(this,L,"f"),this.b(T)))}get options(){return this.a(),Ue(this,h,"f")}set options(T){this.a(),k.equals(Ue(this,h,"f"),T)||Ue(this,P,"f").$setOptions(Ue(this,L,"f"),n(Ue(this,m,"f"),Ue(this,S,"f"),T)),Je(this,h,T,"f")}async postMessage(T){if(Ue(this,b,"f"))return!1;const M=(0,A.serializeWebviewMessage)(T,{serializeBuffersForPostMessage:Ue(this,p,"f")});return Ue(this,P,"f").$postMessage(Ue(this,L,"f"),M.message,...M.buffers)}a(){if(Ue(this,b,"f"))throw new Error("Webview is disposed")}b(T){if(!Ue(this,w,"f"))return T;const M=Ue(this,m,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,K=Ue(this,m,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Ue(this,m,"f").extensionLocation.authority:void 0;return T.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,F,U,N,B,j)=>{const z=R.URI.from({scheme:N||"file",path:decodeURIComponent(B)}),ne=(0,y.asWebviewUri)(z,{isRemote:M,authority:K}).toString();return`${F}${ne}${j}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,F,U,N,B,j)=>{const z=R.URI.from({scheme:N||"file",path:decodeURIComponent(B)}),ne=(0,y.asWebviewUri)(z,{isRemote:M,authority:K}).toString();return`${F}${ne}${j}`})}}e.ExtHostWebview=s,L=new WeakMap,P=new WeakMap,v=new WeakMap,C=new WeakMap,S=new WeakMap,m=new WeakMap,d=new WeakMap,h=new WeakMap,b=new WeakMap,g=new WeakMap,p=new WeakMap,w=new WeakMap,i=new WeakMap;function a(E){try{const T=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return!!T&&T.majorBase>=1&&T.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function u(E){try{const T=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return T?T.majorBase<1||T.majorBase===1&&T.minorBase<60:!1}catch{return!1}}class l{constructor(T,M,K,V,F){this.c=M,this.d=K,this.e=V,this.f=F,this.b=new Map,this.a=T.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(T,M,K){const V=this.g(T);if(V){const{message:F}=(0,A.deserializeWebviewMessage)(M,K.value);V._onMessageEmitter.fire(F)}}$onMissingCsp(T,M){this.e.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(T,M,K){const V=new s(T,this.a,r(M),this.c,this.d,K,this.f);return this.b.set(T,V),V._onDidDispose(()=>{this.b.delete(T)}),V}deleteWebview(T){this.b.delete(T)}g(T){return this.b.get(T)}}e.ExtHostWebviews=l;function c(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=c;function n(E,T,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||f(E,T)}}e.serializeWebviewOptions=n;function r(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(T=>R.URI.from(T))}}function f(E,T){return[...(T?.getWorkspaceFolders()||[]).map(M=>M.uri),E.extensionLocation]}}),define(ye[272],Ce([1,0,21,85,6,15,24,2,14,74,69,5,7]),function(te,e,o,t,k,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(s,a){this.document=s,this.b=a,this.a=1,this.c=new L.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,a){await this.f(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.f(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=w(this.document.uri)+this.a++;return(0,I.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const a=this.c.get(s,0);if(!a)throw new Error("No edit found");return a}}class S{constructor(){this.a=new Map}get(s,a){return this.a.get(this.b(s,a))}add(s,a,u){const l=this.b(s,a.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const c=new C(a,u);return this.a.set(l,c),c}delete(s,a){const u=this.b(s,a.uri);this.a.delete(u)}b(s,a){return`${s}@@@${a}`}}var m;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(m||(m={}));class d{constructor(){this.a=new Map}addTextProvider(s,a,u){return this.b(0,s,a,u)}addCustomProvider(s,a,u){return this.b(1,s,a,u)}get(s){return this.a.get(s)}b(s,a,u,l){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:s,extension:u,provider:l}),new v.Disposable(()=>this.a.delete(a))}}class h{constructor(s,a,u,l,c){this.d=a,this.f=u,this.g=l,this.h=c,this.b=new d,this.c=new S,this.a=s.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,u,l){const c=new k.DisposableStore;return g(u)?(c.add(this.b.addTextProvider(a,s,u)),this.a.$registerTextEditorProvider((0,D.toExtensionData)(s),a,l.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(s))):(c.add(this.b.addCustomProvider(a,s,u)),b(u)&&c.add(u.onDidChangeCustomDocument(n=>{const r=this.i(a,n.document.uri);if(p(n)){const f=r.addEdit(n);this.a.$onDidEdit(n.document.uri,a,f,n.label)}else this.a.$onContentChange(n.document.uri,a)})),this.a.$registerCustomEditorProvider((0,D.toExtensionData)(s),a,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(s))),v.Disposable.from(c,new v.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,u,l,c){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${a}'`);const r=A.URI.revive(s),f=await n.provider.openCustomDocument(r,{backupId:u,untitledDocumentData:l?.buffer},c);let E;return b(n.provider)&&this.f&&(E=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(a,f,E),{editable:b(n.provider)}}async $disposeCustomDocument(s,a){const u=this.b.get(a);if(!u)throw new Error(`No provider found for '${a}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${a}'`);const l=A.URI.revive(s),{document:c}=this.i(a,l);this.c.delete(a,c),c.dispose()}async $resolveCustomEditor(s,a,u,l,c,n){console.log("xxxx");const r=this.b.get(u);if(!r)throw new Error(`No provider found for '${u}'`);const f=y.ViewColumn.to(c),E=this.g.createNewWebview(a,l.contentOptions,r.extension),T=this.h.createNewWebviewPanel(a,u,l.title,f,l.options,E,!0),M=A.URI.revive(s);switch(r.type){case 1:{const{document:K}=this.i(u,M);return r.provider.resolveCustomEditor(K,T,n)}case 0:{const K=this.d.getDocument(M);return r.provider.resolveCustomTextEditor(K,T,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,u){this.i(a,s).disposeEdits(u)}async $onMoveCustomEditor(s,a,u){const l=this.b.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const c=this.h.getWebviewPanel(s);if(!c)throw new Error("No webview found");const n=A.URI.revive(a),r=this.d.getDocument(n);await l.provider.moveCustomTextEditor(r,c,o.CancellationToken.None)}async $undo(s,a,u,l){return this.i(a,s).undo(u,l)}async $redo(s,a,u,l){return this.i(a,s).redo(u,l)}async $revert(s,a,u){const l=this.i(a,s);await this.j(a).revertCustomDocument(l.document,u),l.disposeBackup()}async $onSave(s,a,u){const l=this.i(a,s);await this.j(a).saveCustomDocument(l.document,u),l.disposeBackup()}async $onSaveAs(s,a,u,l){const c=this.i(a,s);return this.j(a).saveCustomDocumentAs(c.document,A.URI.revive(u),l)}async $backup(s,a,u){const l=this.i(a,s),n=await this.j(a).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},u);return l.updateBackup(n),n.id}i(s,a){const u=this.c.get(s,A.URI.revive(a));if(!u)throw new Error("No custom document found");return u}j(s){const u=this.b.get(s)?.provider;if(!u||!b(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=h;function b(i){return!!i.onDidChangeCustomDocument}function g(i){return typeof i.resolveCustomTextEditor=="function"}function p(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function w(i){const s=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,t.hash)(s)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[273],Ce([1,0,3,6,2,30,14,74,5,7]),function(te,e,o,t,k,R,I,A,y,D){"use strict";var L,P,v,C,S,m,d,h,b,g,p,w,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends t.Disposable{constructor(c,n,r,f){super(),L.set(this,void 0),P.set(this,void 0),v.set(this,void 0),C.set(this,void 0),S.set(this,void 0),m.set(this,void 0),d.set(this,void 0),h.set(this,void 0),b.set(this,!0),g.set(this,void 0),p.set(this,!1),w.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,w,"f").event,i.set(this,this.B(new o.Emitter)),this.onDidChangeViewState=Ue(this,i,"f").event,Je(this,L,c,"f"),Je(this,P,n,"f"),Je(this,C,r,"f"),Je(this,v,f.viewType,"f"),Je(this,S,f.panelOptions,"f"),Je(this,h,f.viewColumn,"f"),Je(this,m,f.title,"f"),Je(this,g,f.active,"f")}dispose(){Ue(this,p,"f")||(Je(this,p,!0,"f"),Ue(this,w,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,C,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,C,"f")}get viewType(){return this.c(),Ue(this,v,"f")}get title(){return this.c(),Ue(this,m,"f")}set title(c){this.c(),Ue(this,m,"f")!==c&&(Je(this,m,c,"f"),Ue(this,P,"f").$setTitle(Ue(this,L,"f"),c))}get iconPath(){return this.c(),Ue(this,d,"f")}set iconPath(c){this.c(),Ue(this,d,"f")!==c&&(Je(this,d,c,"f"),Ue(this,P,"f").$setIconPath(Ue(this,L,"f"),k.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Ue(this,S,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,h,"f")=="number"&&Ue(this,h,"f")<0))return Ue(this,h,"f")}get active(){return this.c(),Ue(this,g,"f")}get visible(){return this.c(),Ue(this,b,"f")}_updateViewState(c){Ue(this,p,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(Je(this,g,c.active,"f"),Je(this,b,c.visible,"f"),Je(this,h,c.viewColumn,"f"),Ue(this,i,"f").fire({webviewPanel:this}))}reveal(c,n){this.c(),Ue(this,P,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof c>"u"?void 0:I.ViewColumn.from(c),preserveFocus:!!n})}c(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,P=new WeakMap,v=new WeakMap,C=new WeakMap,S=new WeakMap,m=new WeakMap,d=new WeakMap,h=new WeakMap,b=new WeakMap,g=new WeakMap,p=new WeakMap,w=new WeakMap,i=new WeakMap;class a{static c(){return(0,R.generateUuid)()}constructor(c,n,r){this.g=n,this.h=r,this.e=new Map,this.f=new Map,this.d=c.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(c,n,r,f,E={}){const T=typeof f=="object"?f.viewColumn:f,M={viewColumn:I.ViewColumn.from(T),preserveFocus:typeof f=="object"&&!!f.preserveFocus},K=(0,A.shouldSerializeBuffersForPostMessage)(c),V=a.c();this.d.$createWebviewPanel((0,A.toExtensionData)(c),V,n,{title:r,panelOptions:u(E),webviewOptions:(0,A.serializeWebviewOptions)(c,this.h,E),serializeBuffersForPostMessage:K},M);const F=this.g.createNewWebview(V,E,c);return this.createNewWebviewPanel(V,n,r,T,E,F,!0)}$onDidChangeWebviewPanelViewStates(c){const n=Object.keys(c);n.sort((r,f)=>{const E=c[r],T=c[f];return E.active?1:T.active?-1:+E.visible-+T.visible});for(const r of n){const f=this.getWebviewPanel(r);if(!f)continue;const E=c[r];f._updateViewState({active:E.active,visible:E.visible,viewColumn:I.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this.e.delete(c),this.g.deleteWebview(c)}registerWebviewPanelSerializer(c,n,r){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:r,extension:c}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(c)}),new D.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(c,n,r,f){const E=this.f.get(n);if(!E)throw new Error(`No serializer found for '${n}'`);const{serializer:T,extension:M}=E,K=this.g.createNewWebview(c,r.webviewOptions,M),V=this.createNewWebviewPanel(c,n,r.title,f,r.panelOptions,K,r.active);await T.deserializeWebviewPanel(V,r.state)}createNewWebviewPanel(c,n,r,f,E,T,M){const K=new s(c,this.d,T,{viewType:n,title:r,viewColumn:f,panelOptions:E,active:M});return this.e.set(c,K),K}getWebviewPanel(c){return this.e.get(c)}}e.ExtHostWebviewPanels=a;function u(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[274],Ce([1,0,3,6,74,14,5,7]),function(te,e,o,t,k,R,I,A){"use strict";var y,D,L,P,v,C,S,m,d,h,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends t.Disposable{constructor(i,s,a,u,l,c){super(),y.set(this,void 0),D.set(this,void 0),L.set(this,void 0),P.set(this,void 0),v.set(this,!1),C.set(this,void 0),S.set(this,void 0),m.set(this,void 0),d.set(this,void 0),h.set(this,this.B(new o.Emitter)),this.onDidChangeVisibility=Ue(this,h,"f").event,b.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,b,"f").event,Je(this,L,a,"f"),Je(this,S,u,"f"),Je(this,y,i,"f"),Je(this,D,s,"f"),Je(this,P,l,"f"),Je(this,C,c,"f")}dispose(){Ue(this,v,"f")||(Je(this,v,!0,"f"),Ue(this,b,"f").fire(),Ue(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,S,"f")}set title(i){this.a(),Ue(this,S,"f")!==i&&(Je(this,S,i,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,y,"f"),i))}get description(){return this.a(),Ue(this,m,"f")}set description(i){this.a(),Ue(this,m,"f")!==i&&(Je(this,m,i,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,y,"f"),i))}get visible(){return Ue(this,C,"f")}get webview(){return Ue(this,P,"f")}get viewType(){return Ue(this,L,"f")}_setVisible(i){i===Ue(this,C,"f")||Ue(this,v,"f")||(Je(this,C,i,"f"),Ue(this,h,"f").fire())}get badge(){return this.a(),Ue(this,d,"f")}set badge(i){this.a(),!(i?.value===Ue(this,d,"f")?.value&&i?.tooltip===Ue(this,d,"f")?.tooltip)&&(Je(this,d,R.ViewBadge.from(i),"f"),Ue(this,D,"f").$setWebviewViewBadge(Ue(this,y,"f"),i))}show(i){this.a(),Ue(this,D,"f").$show(Ue(this,y,"f"),!!i)}a(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,D=new WeakMap,L=new WeakMap,P=new WeakMap,v=new WeakMap,C=new WeakMap,S=new WeakMap,m=new WeakMap,d=new WeakMap,h=new WeakMap,b=new WeakMap;class p{constructor(i,s){this.d=s,this.b=new Map,this.c=new Map,this.a=i.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,s,a,u){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:a,extension:i}),this.a.$registerWebviewViewProvider((0,k.toExtensionData)(i),s,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(i,s,a,u,l){const c=this.b.get(s);if(!c)throw new Error(`No view provider found for '${s}'`);const{provider:n,extension:r}=c,f=this.d.createNewWebview(i,{},r),E=new g(i,this.a,s,a,f,!0);this.c.set(i,E),await n.resolveWebviewView(E,{state:u},l)}async $onDidChangeWebviewViewVisibility(i,s){this.e(i)._setVisible(s)}async $disposeWebviewView(i){const s=this.e(i);this.c.delete(i),s.dispose(),this.d.deleteWebview(i)}e(i){const s=this.c.get(i);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=p}),define(ye[141],Ce([1,0,3,5,2,15,8,4,17]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class ri{get state(){return this.d}constructor(P){this.c=new o.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ri.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,v){let C;if(typeof P=="string"){C=P;try{P=k.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,I.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,C,v)}async asExternalUri(P,v){if((0,I.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this.b.$asExternalUri(P,v);return k.URI.from(C)}};D.a={focused:!0},D=qe([We(0,y.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ye[275],Ce([1,0,118,276,65,40,2,13,47]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(v,C,S){this.b=v,this.c=C,this.f=S,this.a=t.createServer((m,d)=>this.h(m,d)),this.g().catch(m=>(C.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,C){const S=(d,h)=>{C.writeHead(d,{"content-type":"application/json"}),C.end(JSON.stringify(h||null),b=>b&&this.c.error(b))},m=[];v.setEncoding("utf8"),v.on("data",d=>m.push(d)),v.on("end",async()=>{try{const d=JSON.parse(m.join(""));let h;switch(d.type){case"open":h=await this.i(d);break;case"openExternal":h=await this.j(d);break;case"status":h=await this.l(d);break;case"extensionManagement":h=await this.k(d);break;default:S(404,`Unknown message type: ${d.type}`);break}S(200,h)}catch(d){const h=d instanceof Error?d.message:JSON.stringify(d);S(500,h),this.c.error("Error while processing pipe request",d)}})}async i(v){const{fileURIs:C,folderURIs:S,forceNewWindow:m,diffMode:d,mergeMode:h,addMode:b,forceReuseWindow:g,gotoLineMode:p,waitMarkerFilePath:w,remoteAuthority:i}=v,s=[];if(Array.isArray(S))for(const c of S)try{s.push({folderUri:I.URI.parse(c)})}catch{}if(Array.isArray(C))for(const c of C)try{(0,y.hasWorkspaceFileExtension)(c)?s.push({workspaceUri:I.URI.parse(c)}):s.push({fileUri:I.URI.parse(c)})}catch{}const a=w?I.URI.file(w):void 0,l={forceNewWindow:m,diffMode:d,mergeMode:h,addMode:b,gotoLineMode:p,forceReuseWindow:g,preferNewWindow:!g&&!a&&!b,waitMarkerFileURI:a,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",s,l),""}async j(v){for(const C of v.uris){const S=I.URI.parse(C),m=S.scheme==="file"?S:C;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(v){const C=m=>m?.map(d=>/\.vsix$/i.test(d)?I.URI.parse(d):d),S={list:v.list,install:C(v.install),uninstall:C(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&k.existsSync(this.f)&&k.unlinkSync(this.f)}}e.CLIServerBase=D;let L=class extends D{constructor(v,C){super(v,C,(0,o.createRandomIPCHandle)())}};L=qe([We(0,R.IExtHostCommands),We(1,A.ILogService)],L),e.CLIServer=L}),define(ye[277],Ce([1,0,248,25,17]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let I=class extends o.AbstractExtHostConsoleForwarder{constructor(y,D){super(y,D),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,D,L){const P=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),D.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,D){const L=process[y],P=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(C,S,m)=>{if(!this.g){v+=C.toString(S);const d=v.length>R?v.length:v.lastIndexOf(`
`);d!==-1&&(console[D](v.slice(0,d)),v=v.slice(d+1))}P.call(L,C,S,m)}})}};I=qe([We(0,k.IExtHostRpcService),We(1,t.IExtHostInitDataService)],I),e.ExtHostConsoleForwarder=I}),define(ye[278],Ce([1,0,9,87,30,40,6,5,2,17]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends I.Disposable{constructor(v,C){super();const S=v.getProxy(A.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async m=>{const d=y.URI.file((0,o.join)((0,t.tmpdir)(),(0,k.generateUuid)()));return await S.$download(m,d),d})}};L=qe([We(0,D.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[279],Ce([1,0,140,15,200,30]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class I extends o.ExtHostLoggerService{f(y,D,L){return y.scheme===t.Schemas.file?new k.SpdLogLogger(L?.name||(0,R.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,D):super.f(y,D,L)}}e.ExtHostLoggerService=I}),define(ye[280],Ce([1,0,65,9,2,73,6,15,16,29]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const s=await super.g(i);if(s.scheme!==A.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const a=s.fsPath;let u=0;do{let l;u===0?l=a:l=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${u}`:`${a}-${u}`,await P(l);const c=t.join(l,"vscode.lock"),n=await m(this.d,c,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),k.URI.file(l);u++}while(u<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function P(w){try{await D.Promises.stat(w);return}catch{}try{await D.Promises.mkdir(w,{recursive:!0})}catch{}}const v=1e3,C=10*60*1e3;class S extends I.Disposable{constructor(i,s){super(),this.b=i,this.c=s,this.a=this.B(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const a=await d(i,s);(!a||a.pid!==process.pid)&&(i.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await D.Promises.utimes(s,new Date,new Date)}catch(u){i.error(u),i.info(`Lock '${s}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{o.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+i};await D.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function m(w,i,s){try{const u={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(i,JSON.stringify(u),{flag:"wx"})}catch(u){w.error(u)}const a=await d(w,i);return!a||a.pid!==process.pid?s?(w.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(w.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),g(w,i)):(w.info(`Lock '${i}': Lock acquired.`),new S(w,i))}async function d(w,i){let s;try{s=await D.Promises.readFile(i)}catch(a){return w.error(a),null}try{return JSON.parse(String(s))}catch(a){return w.error(a),null}}async function h(w,i){let s;try{s=await D.Promises.stat(i)}catch(a){return w.error(a),0}return s.mtime.getTime()}function b(w){try{return process.kill(w,0),!0}catch{return!1}}async function g(w,i){const s=await d(w,i);if(!s)return w.info(`Lock '${i}': Could not read pid of lock holder.`),p(w,i);if(s.willReleaseAt){let n=s.willReleaseAt-Date.now();if(n<5e3){for(n>0?w.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):w.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,y.timeout)(Math.min(100,n)),await h(w,i)===0)return p(w,i);n=s.willReleaseAt-Date.now()}return p(w,i)}}if(!b(s.pid))return w.info(`Lock '${i}': The pid ${s.pid} appears to be gone.`),p(w,i);const a=await h(w,i),u=Date.now()-a;if(u<=C)return w.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;w.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const l=await h(w,i),c=Date.now()-l;return c<=C?(w.info(`Lock '${i}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(w.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),p(w,i))}async function p(w,i){w.info(`Lock '${i}': Deleting a stale lock.`);try{await D.Promises.unlink(i)}catch{}return m(w,i,!0)}}),define(ye[281],Ce([1,0,30,17,41]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends k.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,y,D){return this.createTerminalFromOptions({name:A,shellPath:y,shellArgs:D})}createTerminalFromOptions(A,y){const D=new k.ExtHostTerminal(this.a,(0,o.generateUuid)(),A,A.name);return this.f.push(D),D.create(A,this.L(A,y)),D.value}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[282],Ce([1,0,5,17,183,6,25,2,46,24,29,7,12,54,3,129,101,13]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class b extends m.DisposableTunnel{}function g(n){const r=n.trim().split(`
`),f=[];return r.forEach(T=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);M&&M.length>=3&&f.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),f.reduce((T,M)=>(T[M.socket]=M,T),{})}e.getSockets=g;function p(...n){const r=[].concat(...n.map(i));return[...new Map(r.filter(f=>f.st==="0A").map(f=>{const E=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:w(E[0]),port:parseInt(E[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=p;function w(n){let r="";if(n.length===8)for(let f=n.length-2;f>=0;f-=2)r+=parseInt(n.substr(f,2),16),f!==0&&(r+=".");else for(let f=n.length-4;f>=0;f-=4)r+=parseInt(n.substr(f,4),16).toString(16),f!==0&&(r+=":");return r}function i(n){const r=n.trim().split(`
`),f=r.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return r.map(T=>T.trim().split(/\s+/).reduce((M,K,V)=>(M[f[V]||V]=K,M),{}))}e.loadConnectionTable=i;function s(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function a(n){const r=n.trim().split(`
`),f=[];return r.forEach(E=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);T&&T.length>=4&&f.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),f}e.getRootProcesses=a;async function u(n,r,f){const E=f.reduce((M,K)=>(M[K.pid]=K,M),{}),T=[];return n.forEach(({socket:M,ip:K,port:V})=>{const F=r[M]?r[M].pid:void 0,U=F?E[F]?.cmd:void 0;F&&U&&!s(U)&&T.push({host:K,port:V,detail:U,pid:F})}),T}e.findPorts=u;function l(n,r,f){const E=new Map,T=a(r);for(const M of n){const K=f.get(M.port);if(K){E.set(M.port,K);continue}const V=T.find(F=>F.cmd.includes(`${M.port}`));if(V){let F=V,U;do U=T.find(N=>N.ppid===F.pid),U&&(F=U);while(U);E.set(M.port,{host:M.ip,port:M.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else E.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=l;let c=class extends R.Disposable{constructor(r,f,E){super(),this.n=E,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new S.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=r.getProxy(o.MainContext.MainThreadTunnelService),v.isLinux&&f.remote.isRemote&&f.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(r,f){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const E=await this.a.$openTunnel(f,r.displayName);if(E){const T=new b(E.remoteAddress,E.localAddress,()=>this.a.$closeTunnel(E.remoteAddress));return this.B(T),T}}async getTunnels(){return this.a.$getTunnels()}p(r){return Math.max(r*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(r,f){const E=this.r();return this.l.set(E,{selector:r,provider:f}),this.a.$registerPortsAttributesProvider(r,E),new P.Disposable(()=>{this.l.delete(E),this.a.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(r,f,E,T,M){const K=[];for(const F of r){const U=this.l.get(F);if(!U)return[];K.push(...await Promise.all(f.map(async N=>U.provider.providePortAttributes(N,E,T,M))))}const V=K.filter(F=>!!F);return V.length>0?V.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(r){if(r&&this.h)return;this.h=r;const f=new d.MovingAverage;let E;for(;this.h;){const T=new Date().getTime(),M=(await this.findCandidatePorts()).filter(V=>(0,m.isLocalhost)(V.host)||(0,m.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(V=>V.port).join(", ")}`);const K=new Date().getTime()-T;f.update(K),(!E||JSON.stringify(E)!==JSON.stringify(M))&&(E=M,await this.a.$onFoundNewCandidates(E)),await new Promise(V=>setTimeout(()=>V(),this.p(f.value)))}}async setTunnelFactory(r){if(r){if(r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.c=r.showCandidatePort,this.a.$setCandidateFilter()),r.tunnelFactory){this.b=r.tunnelFactory;let f=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const E=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:f}:void 0;this.a.$setTunnelProvider(E)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(r,f){if(this.f.has(r.host)){const E=this.f.get(r.host);E.has(r.port)&&(f&&E.get(r.port).disposeListener.dispose(),await E.get(r.port).tunnel.dispose(),E.delete(r.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(r,f){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this.b(r,f);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const T=await E;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(r.remoteAddress.host)||this.f.set(r.remoteAddress.host,new Map);const M=this.B(T.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(T.remoteAddress))));return this.f.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:T,disposeListener:M}),C.TunnelDtoConverter.fromApiTunnel(T)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(r){const f=await Promise.all(r.map(T=>this.c(T.host,T.port,T.detail??""))),E=r.filter((T,M)=>f[M]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(T=>T.port).join(", ")} to ${E.map(T=>T.port).join(", ")}`),E}async findCandidatePorts(){let r="",f="";try{r=await L.Promises.readFile("/proc/net/tcp","utf8"),f=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=p(r,f),T=await new Promise(j=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,ne,_)=>{j(ne)})}),M=g(T),K=await L.Promises.readdir("/proc"),V=[];for(const j of K)try{const z=Number(j),ne=D.joinPath(A.URI.file("/proc"),j);if((await L.Promises.stat(ne.fsPath)).isDirectory()&&!isNaN(z)){const Y=await L.Promises.readlink(D.joinPath(ne,"cwd").fsPath),J=await L.Promises.readFile(D.joinPath(ne,"cmdline").fsPath,"utf8");V.push({pid:z,cwd:Y,cmd:J})}}catch{}const F=[],U=E.filter(j=>{const z=M[j.socket];return z||F.push(j),z}),N=u(U,M,V);let B;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const j=await new Promise(z=>{(0,y.exec)("ps -F -A -l | grep root",(ne,_,Y)=>{z(_)})});this.j=l(F,j,this.j),B=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(z=>z.port).join(", ")}`)}return N.then(j=>B?j.concat(B):j)}};c=qe([We(0,t.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,h.ILogService)],c),e.ExtHostTunnelService=c}),define(ye[283],Ce([1,0,16,22,21,10,3,6,113,242,57]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(E,T){try{return JSON.stringify(E,T)}catch{return"null"}}const C="$$ref$$",S={[C]:-1};class m{constructor(T,M){this.jsonString=T,this.referencedBuffers=M}}function d(E,T=null,M=!1){const K=[];return{jsonString:(M?v:JSON.stringify)(E,(F,U)=>{if(typeof U>"u")return S;if(typeof U=="object"){if(U instanceof t.VSBuffer){const N=K.push(U)-1;return{[C]:N}}if(T)return T(F,U)}return U}),referencedBuffers:K}}e.stringifyJsonWithBufferRefs=d;function h(E,T,M){return JSON.parse(E,(K,V)=>{if(V){const F=V[C];if(typeof F=="number")return T[F];if(M&&V.$mid===1)return M.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=h;function b(E,T){return JSON.stringify(E,T)}function g(E){return E?(T,M)=>M&&M.$mid===1?E.transformOutgoing(M):M:null}var p;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class u extends A.Disposable{constructor(T,M=null,K=null){super(),this[P]=!0,this.b=this.B(new I.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=M,this.g=K,this.h=g(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,F=L.ProxyIdentifier.count;V<F;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new o.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(T=>{this.s[T].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(T){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(T){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(T){this.t!==T&&(this.t=T,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(T){return this.g?(0,y.transformIncomingURIs)(T,this.g):T}getProxy(T){const{nid:M,sid:K}=T;return this.l[M]||(this.l[M]=this.F(M,K)),this.l[M]}F(T,M){const K={get:(V,F)=>(typeof F=="string"&&!V[F]&&F.charCodeAt(0)===36&&(V[F]=(...U)=>this.O(T,F,U)),F===a?M:V[F])};return new Proxy(Object.create(null),K)}set(T,M){return this.k[T.nid]=M,M}assertRegistered(T){for(let M=0,K=T.length;M<K;M++){const V=T[M];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(T){if(this.j)return;const M=T.byteLength,K=l.read(T,0),V=K.readUInt8(),F=K.readUInt32();switch(V){case 1:case 2:{let{rpcId:U,method:N,args:B}=n.deserializeRequestJSONArgs(K);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.H(M,F,U,N,B,V===2);break}case 3:case 4:{let{rpcId:U,method:N,args:B}=n.deserializeRequestMixedArgs(K);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.H(M,F,U,N,B,V===4);break}case 5:{this.f?.logIncoming(M,F,0,"ack"),this.z(F);break}case 6:{this.I(M,F);break}case 7:{this.J(M,F,void 0);break}case 9:{let U=n.deserializeReplyOKJSON(K);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.J(M,F,U);break}case 10:{const U=n.deserializeReplyOKJSONWithBuffers(K,this.g);this.J(M,F,U);break}case 8:{const U=n.deserializeReplyOKVSBuffer(K);this.J(M,F,U);break}case 11:{let U=n.deserializeReplyErrError(K);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.L(M,F,U);break}case 12:{this.L(M,F,void 0);break}default:console.error("received unexpected message"),console.error(T)}}H(T,M,K,V,F,U){this.f?.logIncoming(T,M,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(K)}.${V}(`,F);const N=String(M);let B,j;if(U){const ne=new k.CancellationTokenSource;F.push(ne.token),B=this.M(K,V,F),j=()=>ne.cancel()}else B=this.M(K,V,F),j=i;this.p[N]=j;const z=n.serializeAcknowledged(M);this.f?.logOutgoing(z.byteLength,M,1,"ack"),this.c.send(z),B.then(ne=>{delete this.p[N];const _=n.serializeReplyOK(M,ne,this.h);this.f?.logOutgoing(_.byteLength,M,1,"reply:",ne),this.c.send(_)},ne=>{delete this.p[N];const _=n.serializeReplyErr(M,ne);this.f?.logOutgoing(_.byteLength,M,1,"replyErr:",ne),this.c.send(_)})}I(T,M){this.f?.logIncoming(T,M,1,"receiveCancel");const K=String(M);this.p[K]?.()}J(T,M,K){this.f?.logIncoming(T,M,0,"receiveReply:",K);const V=String(M);if(!this.s.hasOwnProperty(V))return;const F=this.s[V];delete this.s[V],F.resolveOk(K)}L(T,M,K){this.f?.logIncoming(T,M,0,"receiveReplyErr:",K);const V=String(M);if(!this.s.hasOwnProperty(V))return;const F=this.s[V];delete this.s[V];let U;K&&(K.$isError?(U=new Error,U.name=K.name,U.message=K.message,U.stack=K.stack):U=K),F.resolveErr(U)}M(T,M,K){try{return Promise.resolve(this.N(T,M,K))}catch(V){return Promise.reject(V)}}N(T,M,K){const V=this.k[T];if(!V)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(T));const F=V[M];if(typeof F!="function")throw new Error("Unknown method "+M+" on actor "+(0,L.getStringIdentifierForProxy)(T));return F.apply(V,K)}O(T,M,K){if(this.j)return new D.CanceledLazyPromise;let V=null;if(K.length>0&&k.CancellationToken.isCancellationToken(K[K.length-1])&&(V=K.pop()),V&&V.isCancellationRequested)return Promise.reject(R.canceled());const F=n.serializeRequestArguments(K,this.h),U=++this.m,N=String(U),B=new D.LazyPromise;V&&V.onCancellationRequested(()=>{const z=n.serializeCancel(U);this.f?.logOutgoing(z.byteLength,U,0,"cancel"),this.c.send(n.serializeCancel(U))}),this.s[N]=B,this.y(U);const j=n.serializeRequest(U,T,M,F,!!V);return this.f?.logOutgoing(j.byteLength,U,0,`request: ${(0,L.getStringIdentifierForProxy)(T)}.${M}(`,K),this.c.send(j),B}}e.RPCProtocol=u,P=s,u.a=3*1e3;class l{static alloc(T,M,K){const V=new l(t.VSBuffer.alloc(K+1+4),0);return V.writeUInt8(T),V.writeUInt32(M),V}static read(T,M){return new l(T,M)}get buffer(){return this.a}constructor(T,M){this.a=T,this.b=M}static sizeUInt8(){return 1}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+T).toString();return this.b+=T,K}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+T).toString();return this.b+=T,K}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+T);return this.b+=T,M}static sizeMixedArray(T){let M=0;M+=1;for(let K=0,V=T.length;K<V;K++){const F=T[K];switch(M+=1,F.type){case 1:M+=this.sizeLongString(F.value);break;case 2:M+=this.sizeVSBuffer(F.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(F.value);for(let U=0;U<F.buffers.length;++U)M+=this.sizeVSBuffer(F.buffers[U]);break;case 4:break}}return M}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let M=0,K=T.length;M<K;M++){const V=T[M];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let F=0;F<V.buffers.length;++F)this.writeBuffer(V.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const M=new Array(T);for(let K=0;K<T;K++)switch(this.readUInt8()){case 1:M[K]=this.readLongString();break;case 2:M[K]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),U=this.readLongString(),N=[];for(let B=0;B<F;++B)N.push(this.readVSBuffer());M[K]=new L.SerializableObjectWithBuffers(h(U,N,null));break}case 4:M[K]=void 0;break}return M}}l.sizeUInt32=4;var c;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(c||(c={}));class n{static a(T){for(let M=0,K=T.length;M<K;M++)if(T[M]instanceof t.VSBuffer||T[M]instanceof L.SerializableObjectWithBuffers||typeof T[M]>"u")return!0;return!1}static serializeRequestArguments(T,M){if(this.a(T)){const K=[];for(let V=0,F=T.length;V<F;V++){const U=T[V];if(U instanceof t.VSBuffer)K[V]={type:2,value:U};else if(typeof U>"u")K[V]={type:4};else if(U instanceof L.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:B}=d(U.value,M);K[V]={type:3,value:t.VSBuffer.fromString(N),buffers:B}}else K[V]={type:1,value:t.VSBuffer.fromString(b(U,M))}}return{type:1,args:K}}return{type:0,args:b(T,M)}}static serializeRequest(T,M,K,V,F){switch(V.type){case 0:return this.b(T,M,K,V.args,F);case 1:return this.c(T,M,K,V.args,F)}}static b(T,M,K,V,F){const U=t.VSBuffer.fromString(K),N=t.VSBuffer.fromString(V);let B=0;B+=l.sizeUInt8(),B+=l.sizeShortString(U),B+=l.sizeLongString(N);const j=l.alloc(F?2:1,T,B);return j.writeUInt8(M),j.writeShortString(U),j.writeLongString(N),j.buffer}static deserializeRequestJSONArgs(T){const M=T.readUInt8(),K=T.readShortString(),V=T.readLongString();return{rpcId:M,method:K,args:JSON.parse(V)}}static c(T,M,K,V,F){const U=t.VSBuffer.fromString(K);let N=0;N+=l.sizeUInt8(),N+=l.sizeShortString(U),N+=l.sizeMixedArray(V);const B=l.alloc(F?4:3,T,N);return B.writeUInt8(M),B.writeShortString(U),B.writeMixedArray(V),B.buffer}static deserializeRequestMixedArgs(T){const M=T.readUInt8(),K=T.readShortString(),V=T.readMixedArray(),F=new Array(V.length);for(let U=0,N=V.length;U<N;U++){const B=V[U];typeof B=="string"?F[U]=JSON.parse(B):F[U]=B}return{rpcId:M,method:K,args:F}}static serializeAcknowledged(T){return l.alloc(5,T,0).buffer}static serializeCancel(T){return l.alloc(6,T,0).buffer}static serializeReplyOK(T,M,K){if(typeof M>"u")return this.d(T);if(M instanceof t.VSBuffer)return this.e(T,M);if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:F}=d(M.value,K,!0);return this.g(T,V,F)}else return this.f(T,v(M,K))}static d(T){return l.alloc(7,T,0).buffer}static e(T,M){let K=0;K+=l.sizeVSBuffer(M);const V=l.alloc(8,T,K);return V.writeVSBuffer(M),V.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,M){const K=t.VSBuffer.fromString(M);let V=0;V+=l.sizeLongString(K);const F=l.alloc(9,T,V);return F.writeLongString(K),F.buffer}static g(T,M,K){const V=t.VSBuffer.fromString(M);let F=0;F+=l.sizeUInt32,F+=l.sizeLongString(V);for(const N of K)F+=l.sizeVSBuffer(N);const U=l.alloc(10,T,F);U.writeUInt32(K.length),U.writeLongString(V);for(const N of K)U.writeBuffer(N);return U.buffer}static deserializeReplyOKJSON(T){const M=T.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(T,M){const K=T.readUInt32(),V=T.readLongString(),F=[];for(let U=0;U<K;++U)F.push(T.readVSBuffer());return new L.SerializableObjectWithBuffers(h(V,F,M))}static serializeReplyErr(T,M){const K=M?v(R.transformErrorForSerialization(M),null):void 0;if(typeof K!="string")return this.h(T);const V=t.VSBuffer.fromString(K);let F=0;F+=l.sizeLongString(V);const U=l.alloc(11,T,F);return U.writeLongString(V),U.buffer}static deserializeReplyErrError(T){const M=T.readLongString();return JSON.parse(M)}static h(T){return l.alloc(12,T,0).buffer}}var r;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var f;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(f||(f={}))}),define(ye[284],Ce([1,0,3,44,53,4,39,10,16]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.a=new Map,this.b=new o.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new o.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(S){this.a.has(S.id)||(this.a.set(S.id,S),this.b.fire(S.id))}getChannels(){const S=[];return this.a.forEach(m=>S.push(m)),S}getChannel(S){return this.a.get(S)}removeChannel(S){this.a.delete(S),this.c.fire(S)}}t.Registry.add(e.Extensions.OutputChannels,new L);function P(C,S,m,d,h){return(0,y.createCancelablePromise)(async b=>{await(0,I.whenProviderRegistered)(m,d);const g=t.Registry.as(e.Extensions.OutputChannels);try{await v(m,1,d,h,b),g.registerChannel({id:C,label:S,file:m,log:!0})}catch(p){(0,A.isCancellationError)(p)||h.error("Error while registering log channel",m.toString(),(0,A.getErrorMessage)(p))}})}e.registerLogChannel=P;async function v(C,S,m,d,h){if(!await m.exists(C)){if(h.isCancellationRequested)throw new A.CancellationError;if(S>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",C.toString()),await(0,y.timeout)(1e3,h),await v(C,S+1,m,d,h)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(ye[142],Ce([1,0,5,4,17,26,13,284,72,25,48,157,22,11,39,3,6]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends I.AbstractMessageLogger{get disposed(){return this.l}constructor(w,i,s,a,u){super(),this.id=w,this.name=i,this.m=s,this.n=a,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,w)}replace(w){const i=this.k;this.info(w),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(w,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:i))}hide(){this.n.$close(this.id)}g(w,i){this.k+=v.VSBuffer.fromString(i).byteLength,(0,I.log)(this.m,w,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class b extends h{appendLine(w){this.append(w)}}let g=class{constructor(w,i,s,a,u,l){this.i=i,this.j=s,this.k=a,this.l=u,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(o.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(w,i,s){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,u=(0,C.isString)(i)?i:void 0;if((0,C.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const c=this.i.environment.extensionLogLevel?.find(([r])=>R.ExtensionIdentifier.equals(s.identifier,r))?.[1];c&&(l=(0,I.parseLogLevel)(c));const n=a?this.o(w,l,s):this.n(w,u,s);return n.then(r=>{this.g.set(r.id,r),r.visible=r.id===this.h}),a?this.r(w,l??this.m.getLevel(),n):this.q(w,n)}async n(w,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,u=this.k.extUri.joinPath(a,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),c=await this.a.$register(w,u,!1,i,s.identifier.value);return new h(c,w,l,this.a,s)}async o(w,i,s){const a=await this.p(s),u=this.k.extUri.joinPath(a,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(u,{name:w},i),c=await this.a.$register(w,u,!0,void 0,s.identifier.value);return new b(c,w,l,this.a,s)}p(w){let i=this.d.get(w.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(a){if((0,S.toFileSystemProviderErrorCode)(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return i}q(w,i){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return w},append(u){a(),i.then(l=>l.append(u))},appendLine(u){a(),i.then(l=>l.appendLine(u))},clear(){a(),i.then(u=>u.clear())},replace(u){a(),i.then(l=>l.replace(u))},show(u,l){a(),i.then(c=>c.show(u,l))},hide(){a(),i.then(u=>u.hide())},dispose(){s=!0,i.then(u=>u.dispose())}}}r(w,i,s){const a=new d.DisposableStore,u=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},l=a.add(new m.Emitter);return s.then(c=>{a.add(c),a.add(c.onDidChangeLogLevel(n=>{i=n,l.fire(n)}))}),{...this.q(w,s),get logLevel(){return i},onDidChangeLogLevel:l.event,trace(c,...n){u(),s.then(r=>r.trace(c,...n))},debug(c,...n){u(),s.then(r=>r.debug(c,...n))},info(c,...n){u(),s.then(r=>r.info(c,...n))},warn(c,...n){u(),s.then(r=>r.warn(c,...n))},error(c,...n){u(),s.then(r=>r.error(c,...n))},dispose(){a.dispose()}}}};g=qe([We(0,k.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,I.ILoggerService),We(5,I.ILogService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(ye[285],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(ye[286],Ce([1,0,32,15,9,12,24,2,4,212,47,229,285]),function(te,e,o,t,k,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let C=class si{constructor(m,d,h,b){this.d=m,this.e=d,this.f=h,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const g=await this.e.getEnvironment();return this.c=g?.userHome??m})()}hasValidBasename(m,d,h){return typeof d=="string"||typeof d>"u"?this.a.then(b=>this.h(m,b,d)):this.h(m,d,h)}h(m,d,h){return m.scheme===t.Schemas.file||m.scheme===t.Schemas.vscodeRemote?(0,o.isValidBasename)(h??(0,I.basename)(m),d===1):!0}get defaultUriScheme(){return si.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,d){if(m.remoteAuthority)return t.Schemas.vscodeRemote;const h=(0,D.getVirtualWorkspaceScheme)(d.getWorkspace());if(h)return h;const b=d.getWorkspace().folders[0];if(b)return b.uri.scheme;const g=d.getWorkspace().configuration;return g?g.scheme:t.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?k.win32:k.posix)}async fileURI(m){let d="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const b=m.indexOf("/",2);b===-1?(d=m.substring(2),m="/"):(d=m.substring(2,b),m=m.substring(b)||"/")}return A.URI.from({scheme:t.Schemas.file,authority:d,path:m,query:"",fragment:""})}};C=qe([We(1,v.IRemoteAgentService),We(2,P.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(ye[75],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(I,A){this.line=I,this.character=A}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,A){return new o(0,0)}with(I){return new o(0,0)}}e.Position=o;class t{constructor(I,A,y,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(I,A),this.end=new o(y,D)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new t(0,0,0,0)}with(I){return new t(0,0,0,0)}}e.Range=t;var k;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],Ce([1,0,18,38,23,32,8,4,9,10,75,16]),function(te,e,o,t,k,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",C=" characters skipped \u27EB",S=(v.length+C.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var m;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function h(J){return!!J.preview}e.resultIsMatch=h;function b(J){return!!J.resource}e.isFileMatch=b;function g(J){return!!J.message}e.isProgressMessage=g;var p;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(ee){this.resource=ee,this.results=[]}}e.FileMatch=w;class i{constructor(ee,ge,q){this.ranges=ge;const G=Array.isArray(ge)?ge:[ge];if(q&&q.matchLines===1&&s(G)){ee=(0,I.getNLines)(ee,q.matchLines);let le="",be=0,ve=0;const Pe=Math.floor(q.charsPerLine/5),Ne=[];for(const se of G){const ue=Math.max(se.startColumn-Pe,0),de=se.startColumn+q.charsPerLine;if(ue>ve+Pe+S){const Z=v+(ue-ve)+C;le+=Z+ee.slice(ue,de),be+=ue-(ve+Z.length)}else le+=ee.slice(ve,de);Ne.push(new u(0,se.startColumn-be,se.endColumn-be)),ve=de}this.preview={text:le,matches:Array.isArray(this.ranges)?Ne:Ne[0]}}else{const le=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:ee,matches:(0,o.mapArrayOrNot)(ge,be=>new a(be.startLineNumber-le,be.startColumn,be.endLineNumber-le,be.endColumn))}}}}e.TextSearchMatch=i;function s(J){const ee=J[0].startLineNumber;for(const ge of J)if(ge.startLineNumber!==ee||ge.endLineNumber!==ee)return!1;return!0}class a{constructor(ee,ge,q,G){this.startLineNumber=ee,this.startColumn=ge,this.endLineNumber=q,this.endColumn=G}}e.SearchRange=a;class u extends a{constructor(ee,ge,q){super(ee,ge,ee,q)}}e.OneLineRange=u;var l;(function(J){J.List="list",J.Tree="tree"})(l=e.ViewMode||(e.ViewMode={}));var c;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function n(J,ee=!0){const ge=J&&J.files&&J.files.exclude,q=ee&&J&&J.search&&J.search.exclude;if(!ge&&!q)return;if(!ge||!q)return ge||q;let G=Object.create(null);return G=k.mixin(G,k.deepClone(ge)),G=k.mixin(G,k.deepClone(q),!0),G}e.getExcludes=n;function r(J,ee){return J.excludePattern&&t.match(J.excludePattern,ee)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&t.match(J.includePattern,ee)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ge=>{const q=ge.folder.fsPath;if(R.isEqualOrParent(ee,q)){const G=y.relative(q,ee);return!ge.includePattern||!!t.match(ge.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var f;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(ee,ge){super(ee),this.code=ge}}e.SearchError=E;function T(J){const ee=J.message;if((0,D.isCancellationError)(J))return new E(ee,f.canceled);try{const ge=JSON.parse(ee);return new E(ge.message,ge.code)}catch{return new E(ee,f.other)}}e.deserializeSearchError=T;function M(J){const ee={message:J.message,code:J.code};return new Error(JSON.stringify(ee))}e.serializeSearchError=M;function K(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=K;function V(J){return J.type==="success"}e.isSerializedSearchSuccess=V;function F(J){return!!J.path}e.isSerializedFileMatch=F;function U(J,ee){const ge=J.searchPath?J.searchPath:J.relativePath;return(0,I.fuzzyContains)(ge,ee)}e.isFilePatternMatch=U;class N{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function B(J,ee){const ge={...J||{},...ee||{}};return Object.keys(ge).filter(q=>{const G=ge[q];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=B;class j{constructor(ee,ge){this.c=null,this.a={...ee.excludePattern||{},...ge.excludePattern||{}},this.b=t.parse(this.a);let q=ee.includePattern;ge.includePattern&&(q?q={...q,...ge.includePattern}:q=ge.includePattern),q&&(this.c=t.parse(q))}matchesExcludesSync(ee,ge,q){return!!(this.b&&this.b(ee,ge,q))}includedInQuerySync(ee,ge,q){return!(this.b&&this.b(ee,ge,q)||this.c&&!this.c(ee,ge,q))}includedInQuery(ee,ge,q){const G=this.b(ee,ge,q),le=()=>this.c?!!this.c(ee,ge,q):!0;return(0,P.isThenable)(G)?G.then(be=>be?!1:le()):le()}hasSiblingExcludeClauses(){return z(this.a)}}e.QueryGlobTester=j;function z(J){for(const ee in J)if(typeof J[ee]!="boolean")return!0;return!1}function ne(J){if(!J)return;let ee;return ge=>(ee||(ee=(J()||Promise.resolve([])).then(q=>q?Y(q):{})),ee.then(q=>!!q[ge]))}e.hasSiblingPromiseFn=ne;function _(J){if(!J)return;let ee;return ge=>{if(!ee){const q=J();ee=q?Y(q):{}}return!!ee[ge]}}e.hasSiblingFn=_;function Y(J){const ee={};for(const ge of J)ee[ge]=!0;return ee}}),define(ye[33],Ce([1,0,18,16,21,3,6,64,15,101,24,8,11,2,181,4,13,201,47,48,25,17,14,7,55,31,5]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p,w,i,s,a,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function c(V,F,U){return new L.ExtUri(N=>E(N,U)).isEqual(V,F)}function n(V,F,U){return c(V.uri,F.uri,U)?0:(0,P.compare)(V.uri.toString(),F.uri.toString())}function r(V,F,U){return V.index!==F.index?V.index<F.index?-1:1:c(V.uri,F.uri,U)?(0,P.compare)(V.name,F.name):(0,P.compare)(V.uri.toString(),F.uri.toString())}function f(V,F,U,N){const B=V.slice(0).sort((z,ne)=>U(z,ne,N)),j=F.slice(0).sort((z,ne)=>U(z,ne,N));return(0,o.delta)(B,j,(z,ne)=>U(z,ne,N))}function E(V,F){const U=F.getCapabilities(V.scheme);return!(U&&U&1024)}class T extends b.Workspace{static toExtHostWorkspace(F,U,N,B){if(!F)return{workspace:null,added:[],removed:[]};const{id:j,name:z,folders:ne,configuration:_,transient:Y,isUntitled:J}=F,ee=[],ge=U;U?ne.forEach((be,ve)=>{const Pe=C.URI.revive(be.uri),Ne=T.e(N||U,Pe,B);Ne?(Ne.name=be.name,Ne.index=be.index,ee.push(Ne)):ee.push({uri:Pe,name:be.name,index:ve})}):ee.push(...ne.map(({uri:be,name:ve,index:Pe})=>({uri:C.URI.revive(be),name:ve,index:Pe}))),ee.sort((be,ve)=>be.index<ve.index?-1:1);const q=new T(j,z,ee,!!Y,_?C.URI.revive(_):null,!!J,be=>E(be,B)),{added:G,removed:le}=f(ge?ge.workspaceFolders:[],q.workspaceFolders,n,B);return{workspace:q,added:G,removed:le}}static e(F,U,N){for(let B=0;B<F.folders.length;B++){const j=F.workspaceFolders[B];if(c(j.uri,U,N))return j}}constructor(F,U,N,B,j,z,ne){super(F,N.map(_=>new b.WorkspaceFolder(_)),B,j,ne),this.s=U,this.t=z,this.o=[],this.q=A.TernarySearchTree.forUris(ne),N.forEach(_=>{this.o.push(_),this.q.set(_.uri,_)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(F,U){return U&&this.q.get(F)&&(F=(0,L.dirname)(F)),this.q.findSubstr(F)}resolveWorkspaceFolder(F){return this.q.get(F)}}let M=class{constructor(F,U,N,B,j){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new R.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=B,this.q=N,this.s=j,this.h=new D.Counter,this.j=new t.Barrier,this.n=F.getProxy(l.MainContext.MainThreadWorkspace),this.o=F.getProxy(l.MainContext.MainThreadMessageService);const z=U.workspace;this.k=z?new T(z.id,z.name,[],!!z.transient,z.configuration?C.URI.revive(z.configuration):null,!!z.isUntitled,ne=>E(ne,N)):void 0}$initializeWorkspace(F,U){this.u=U,this.$acceptWorkspaceData(F),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?C.URI.from({scheme:y.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(F,U,N,...B){const j=[];if(Array.isArray(B)&&B.forEach(J=>{C.URI.isUri(J.uri)&&!j.some(ee=>c(ee.uri,J.uri,this.q))&&j.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.l||[U,N].some(J=>typeof J!="number"||J<0)||N===0&&j.length===0)return!1;const z=this.w?this.w.workspaceFolders:[];if(U+N>z.length)return!1;const ne=z.slice(0);ne.splice(U,N,...j.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<ne.length;J++){const ee=ne[J];if(ne.some((ge,q)=>q!==J&&c(ee.uri,ge.uri,this.q)))return!1}ne.forEach((J,ee)=>J.index=ee);const{added:_,removed:Y}=f(z,ne,r,this.q);if(_.length===0&&Y.length===0)return!1;if(this.n){const J=F.displayName||F.name;this.n.$updateWorkspaceFolders(J,U,N,j).then(void 0,ee=>{this.l=void 0;const ge={source:{identifier:F.identifier,label:F.displayName||F.name}};this.o.$showMessage(h.Severity.Error,(0,S.localize)(0,null,J,ee.toString()),ge,[])})}return this.x(ne),!0}getWorkspaceFolder(F,U){if(!!this.w)return this.w.getWorkspaceFolder(F,U)}async getWorkspaceFolder2(F,U){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(F,U)}async resolveWorkspaceFolder(F){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(F)}getPath(){if(!this.w)return;const{folders:F}=this.w;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,U){let N,B="";if(typeof F=="string"?(N=C.URI.file(F),B=F):typeof F<"u"&&(N=F,B=F.fsPath),!N)return B;const j=this.getWorkspaceFolder(N,!0);if(!j)return B;typeof U>"u"&&this.w&&(U=this.w.folders.length>1);let z=(0,L.relativePath)(j.uri,N);return U&&j.name&&(z=`${j.name}/${z}`),z}x(F){this.w&&(this.l=T.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:F,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:U,added:N,removed:B}=T.toExtHostWorkspace(F,this.k,this.l,this.q);this.k=U||void 0,this.l=void 0,this.c.fire(Object.freeze({added:N,removed:B}))}findFiles(F,U,N,B,j=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let z;if(U===null?z=!1:U&&(typeof U=="string"?z=U:z=U.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:ne,folder:_}=K(i.GlobPattern.from(F));return this.n.$startFileSearch((0,v.withUndefinedAsNull)(ne),(0,v.withUndefinedAsNull)(_),(0,v.withUndefinedAsNull)(z),(0,v.withUndefinedAsNull)(N),j).then(Y=>Array.isArray(Y)?Y.map(J=>C.URI.revive(J)):[])}async findTextInFiles(F,U,N,B,j=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const z=this.h.getNext(),ne=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:_,folder:Y}=K(i.GlobPattern.from(U.include)),J=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ee={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ne,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:_,excludePattern:J},ge=!1;if(this.t[z]=q=>{if(ge)return;const G=C.URI.revive(q.resource);q.results.forEach(le=>{(0,u.resultIsMatch)(le)?N({uri:G,preview:{text:le.preview.text,matches:(0,o.mapArrayOrNot)(le.preview.matches,be=>new s.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,o.mapArrayOrNot)(le.ranges,be=>new s.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):N({uri:G,text:le.text,lineNumber:le.lineNumber})})},j.isCancellationRequested)return{};try{const q=await this.n.$startTextSearch(F,(0,v.withUndefinedAsNull)(Y),ee,z,j);return delete this.t[z],q||{}}catch(q){throw delete this.t[z],q}}$handleTextSearchResult(F,U){this.t[U]?.(F)}saveAll(F){return this.n.$saveAll(F)}resolveProxy(F){return this.n.$resolveProxy(F)}get trusted(){return this.u}requestWorkspaceTrust(F){return this.n.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(F,U){if(this.v.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.v.set(F,U);const N=this.s.transformOutgoingScheme(F),B=this.y++;return this.n.$registerEditSessionIdentityProvider(B,N),(0,I.toDisposable)(()=>{this.v.delete(F),this.n.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(F,U){this.g.info("Getting edit session identifier for workspaceFolder",F);const N=await this.resolveWorkspaceFolder(C.URI.revive(F));if(!N){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const B=this.v.get(N.uri.scheme);if(this.g.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!B),!B)return;const j=await B.provideEditSessionIdentity(N,U);if(this.g.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(F,U,N,B){this.g.info("Getting edit session identifier for workspaceFolder",F);const j=await this.resolveWorkspaceFolder(C.URI.revive(F));if(!j){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const z=this.v.get(j.uri.scheme);if(this.g.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!z),!z)return;const ne=await z.provideEditSessionIdentityMatch?.(U,N,B);if(this.g.info("Provider returned edit session identifier match result: ",ne),!!ne)return ne}};M=qe([We(0,w.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,g.IExtHostFileSystemInfo),We(3,d.ILogService),We(4,a.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,m.createDecorator)("IExtHostWorkspace");function K(V){let F,U;return V&&(typeof V=="string"?F=V:(F=V.pattern,U=C.URI.revive(V.baseUri))),{includePattern:F,folder:U}}}),define(ye[34],Ce([1,0,23,3,33,5,7,204,127,11,16,4,17,13,2]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(s,a){if(a){const u=a.split(".");let l=s;for(let c=0;l&&c<u.length;c++)l=l[u[c]];return l}}function d(s){return s instanceof S.URI}function h(s){return s&&s.uri instanceof S.URI&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function g(s){return s&&s.uri instanceof S.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function p(s){if(d(s))return{resource:s};if(h(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(b(s))return{overrideIdentifier:s.languageId};if(g(s))return{resource:s.uri};if(s===null)return{resource:null}}let w=class{constructor(a,u,l){this.a=a.getProxy(R.MainContext.MainThreadConfiguration),this.c=u,this.b=l,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,u){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(a,u))}};w=qe([We(0,v.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,C.ILogService)],w),e.ExtHostConfiguration=w;class i{constructor(a,u,l,c){this.a=new t.Emitter,this.b=a,this.f=c,this.c=u,this.e=A.Configuration.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,u){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(u,l))}getConfiguration(a,u,l){const c=p(u)||{},n=this.g(a?m(this.e.getValue(void 0,c,this.c.workspace),a):this.e.getValue(void 0,c,this.c.workspace));a&&this.h(a,c,l?.identifier);function r(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case I.ConfigurationTarget.Global:return 2;case I.ConfigurationTarget.Workspace:return 5;case I.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(E){return typeof m(n,E)<"u"},get:(E,T)=>{this.h(a?`${a}.${E}`:E,c,l?.identifier);let M=m(n,E);if(typeof M>"u")M=T;else{let K;const V=(F,U)=>{let N;const B=()=>{K=K||(0,o.deepClone)(n),N=N||m(K,U)};return(0,D.isObject)(F)?new Proxy(F,{get:(j,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return B(),()=>N;if(K)return N=N||m(K,U),N[z];const ne=j[z];return typeof z=="string"?V(ne,`${U}.${z}`):ne},set:(j,z,ne)=>(B(),N&&(N[z]=ne),!0),deleteProperty:(j,z)=>(B(),N&&delete N[z],!0),defineProperty:(j,z,ne)=>(B(),N&&Object.defineProperty(N,z,ne),!0)}):F};M=V(M,E)}return M},update:(E,T,M,K)=>{E=a?`${a}.${E}`:E;const V=r(M);return T!==void 0?this.b.$updateConfigurationOption(V,E,T,c,K):this.b.$removeConfigurationOption(V,E,c,K)},inspect:E=>{E=a?`${a}.${E}`:E;const T=this.e.inspect(E,c,this.c.workspace);if(T)return{key:E,defaultValue:(0,o.deepClone)(T.policy?.value??T.default?.value),globalValue:(0,o.deepClone)(T.user?.value??T.application?.value),workspaceValue:(0,o.deepClone)(T.workspace?.value),workspaceFolderValue:(0,o.deepClone)(T.workspaceFolder?.value),defaultLanguageValue:(0,o.deepClone)(T.default?.override),globalLanguageValue:(0,o.deepClone)(T.user?.override??T.application?.override),workspaceLanguageValue:(0,o.deepClone)(T.workspace?.override),workspaceFolderLanguageValue:(0,o.deepClone)(T.workspaceFolder?.override),languageIds:(0,o.deepClone)(T.overrideIdentifiers)}}};return typeof n=="object"&&(0,o.mixin)(f,n,!1),Object.freeze(f)}g(a){const u=l=>(0,D.isObject)(l)?new Proxy(l,{get:(c,n)=>u(c[n]),set:(c,n,r)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(c,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(c,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return u(a)}h(a,u,l){const c=y.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),n=l?`[${l.value}] `:"";if(c===4){typeof u?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){u?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,u){const l=new A.ConfigurationChangeEvent(a,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(c,n)=>l.affectsConfiguration(c,p(n))})}k(a){return a.reduce((u,l)=>(u.set(l[0],l[1]),u),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[76],Ce([1,0,2,16,3,5,7,33,58,34,21,41,17,25,4,15,12,13,71,241,10]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(F){function U(B){if(B!=null)return B}F.from=U;function N(B){if(B!=null)return B}F.to=N})(i||(i={}));var s;(function(F){function U(B){if(B!=null)return B}F.from=U;function N(B){if(B!=null)return B}F.to=N})(s||(s={}));var a;(function(F){function U(B){if(B!=null)return B}F.from=U;function N(B){if(B!=null)return B}F.to=N})(a||(a={}));var u;(function(F){function U(j){if(j){const z=j;return z&&!!z.process}else return!1}F.is=U;function N(j){if(j==null)return;const z={process:j.process,args:j.args};return j.options&&(z.options=a.from(j.options)),z}F.from=N;function B(j){if(j!=null)return new I.ProcessExecution(j.process,j.args,j.options)}F.to=B})(u||(u={}));var l;(function(F){function U(B){if(B!=null)return B}F.from=U;function N(B){if(B!=null)return B}F.to=N})(l||(l={}));var c;(function(F){function U(j){if(j){const z=j;return z&&(!!z.commandLine||!!z.command)}else return!1}F.is=U;function N(j){if(j==null)return;const z={};return j.commandLine!==void 0?z.commandLine=j.commandLine:(z.command=j.command,z.args=j.args),j.options&&(z.options=l.from(j.options)),z}F.from=N;function B(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new I.ShellExecution(j.commandLine,j.options):new I.ShellExecution(j.command,j.args?j.args:[],j.options)}F.to=B})(c||(c={}));var n;(function(F){function U(j){if(j){const z=j;return z&&z.customExecution==="customExecution"}else return!1}F.is=U;function N(j){return{customExecution:"customExecution"}}F.from=N;function B(j,z){return z.get(j)}F.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var r;(function(F){function U(N,B){let j;return N.scope!==void 0&&typeof N.scope!="number"?j=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===I.TaskScope.Workspace&&B&&B.workspaceFile?j=B.workspaceFile:j=g.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:j}}F.from=U})(r=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(F){function U(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}F.from=U})(f||(f={}));var E;(function(F){function U(j,z){if(j==null)return[];const ne=[];for(const _ of j){const Y=N(_,z);Y&&ne.push(Y)}return ne}F.fromMany=U;function N(j,z){if(j==null)return;let ne;j.execution instanceof I.ProcessExecution?ne=u.from(j.execution):j.execution instanceof I.ShellExecution?ne=c.from(j.execution):j.execution&&j.execution instanceof I.CustomExecution&&(ne=n.from(j.execution));const _=i.from(j.definition);let Y;return j.scope?typeof j.scope=="number"?Y=j.scope:Y=j.scope.uri:Y=I.TaskScope.Workspace,!_||!Y?void 0:{_id:j._id,definition:_,name:j.name,source:{extensionId:z.identifier.value,label:j.source,scope:Y},execution:ne,isBackground:j.isBackground,group:f.from(j.group),presentationOptions:s.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}F.from=N;async function B(j,z,ne){if(j==null)return;let _;u.is(j.execution)?_=u.to(j.execution):c.is(j.execution)?_=c.to(j.execution):n.is(j.execution)&&(_=n.to(j._id,ne));const Y=i.to(j.definition);let J;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?J=j.source.scope:J=await z.resolveWorkspaceFolder(o.URI.revive(j.source.scope)):J=I.TaskScope.Workspace),!Y||!J)return;const ee=new I.Task(Y,J,j.name,j.source.label,_,j.problemMatchers);return j.isBackground!==void 0&&(ee.isBackground=j.isBackground),j.group!==void 0&&(ee.group=I.TaskGroup.from(j.group._id),ee.group&&j.group.isDefault&&(ee.group=new I.TaskGroup(ee.group.id,ee.group.label),j.group.isDefault===!0&&(ee.group.isDefault=j.group.isDefault))),j.presentationOptions&&(ee.presentationOptions=s.to(j.presentationOptions)),j._id&&(ee._id=j._id),j.detail&&(ee.detail=j.detail),ee}F.to=B})(E=e.TaskDTO||(e.TaskDTO={}));var T;(function(F){function U(B){return B}F.from=U;function N(B){if(!!B)return Object.assign(Object.create(null),B)}F.to=N})(T||(T={}));class M{constructor(U,N,B){this._id=N,this.a=B,w.set(this,void 0),Je(this,w,U,"f")}get task(){return this.a}terminate(){Ue(this,w,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}w=new WeakMap;let K=class{constructor(U,N,B,j,z,ne,_,Y){this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.t=new k.Emitter,this.a=U.getProxy(R.MainContext.MainThreadTask),this.b=B,this.c=j,this.d=z,this.e=ne,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=Y,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,N,B){if(!B)return new I.Disposable(()=>{});const j=this.w();return this.j.set(j,{type:N,provider:B,extension:U}),this.a.$registerTaskProvider(j,N),new I.Disposable(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(U,N){this.a.$registerTaskSystem(U,N)}fetchTasks(U){return this.a.$fetchTasks(T.from(U)).then(async N=>{const B=[];for(const j of N){const z=await E.to(j,this.b,this.m);z&&B.push(z)}return B})}get taskExecutions(){const U=[];return this.k.forEach(N=>U.push(N)),U}terminateTask(U){if(!(U instanceof M))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,N,B){const j=this.m.get(U.id);j&&(this.o.set(U.id,j),this.e.attachPtyToTerminal(N,await j.callback(B))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const N=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const N=await this.y(U.id);this.s.fire({execution:N,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const N=await this.y(U.id);this.t.fire({execution:N,exitCode:U.exitCode})}$provideTasks(U,N){const B=this.j.get(U);if(!B)return Promise.reject(new Error("no handler found"));const j=[],z=(0,t.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then(ne=>this.u(N,j,B,ne));return new Promise(ne=>{z.then(_=>{Promise.all(j).then(()=>{ne(_)})})})}async $resolveTask(U,N){const B=this.j.get(U);if(!B)return Promise.reject(new Error("no handler found"));if(N.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${B.type}].`);const j=await E.to(N,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const z=await B.provider.resolveTask(j,L.CancellationToken.None);if(!z)return;this.z(z,B);const ne=E.from(z,B.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(ne.execution)&&await this.x(ne,z,!0),await this.v(ne)}w(){return this.h++}async x(U,N,B){const j=await this.a.$createTaskId(U);!B&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,N.execution)),this.m.set(j,N.execution)}async y(U,N){if(typeof U=="string"){const z=this.l.get(U);if(!z)throw new p.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const B=this.l.get(U.id);if(B)return B;const j=new Promise((z,ne)=>{function _(Y,J,ee){ee?z(new M(Y,J.id,ee)):ne("Unexpected: Task does not exist.")}N?_(this,U,N):E.to(U.task,this.b,this.m).then(Y=>_(this,U,Y))});return this.l.set(U.id,j),j.then(z=>(this.k.set(U.id,z),z),z=>Promise.reject(z))}z(U,N){U._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const B=this.n.values();let j=B.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=B.next()}};K=qe([We(0,v.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,h.ILogService),We(7,b.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let V=class extends K{constructor(U,N,B,j,z,ne,_,Y){super(U,N,B,j,z,ne,_,Y),this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(U,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const B=E.from(N,U);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.x(B,N,!1);else throw new p.NotSupportedError;const j=await this.y(await this.a.$getTaskExecution(B),N);return this.a.$executeTask(B).catch(z=>{throw new Error(z)}),j}u(U,N,B,j){const z=[];if(j)for(const ne of j){this.z(ne,B),(!ne.definition||!U[ne.definition.type])&&this.f.warn(`The task [${ne.source}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`);const _=E.from(ne,B.extension);_&&n.is(_.execution)?(z.push(_),N.push(this.x(_,ne,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:B.extension}}async v(U){if(n.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,N,B){}};V=qe([We(0,v.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,h.ILogService),We(7,b.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,S.createDecorator)("IExtHostTask")}),define(ye[287],Ce([1,0,9,21,45,38,24,43,31]),function(te,e,o,t,k,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(v,C,S){this.k=v,this.l=C,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const C=this.k.folderQueries||[];return new Promise((S,m)=>{const d=h=>{this.f++,v(h)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const b=h.toString(),g=o.basename(b);this.j&&this.j(b,g)||this.v(d,{base:h,basename:g})}),Promise.all(C.map(h=>this.p(h,d))).then(h=>{S({limitHit:this.e,stats:h[0]||void 0})},h=>{m(new Error((0,k.toErrorMessage)(h)))})})}async p(v,C){const S=new t.CancellationTokenSource,m=this.q(v),d=this.r(),h=new y.QueryGlobTester(this.k,v),b=!h.hasSiblingExcludeClauses();let g;try{this.h.add(S),g=A.StopWatch.create();const p=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},m,S.token),w=g.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(p&&p.forEach(s=>{const a=o.posix.relative(v.folder.path,s.path);if(b){const u=o.basename(s.path);this.v(C,{base:v.folder,relativePath:a,basename:u});return}this.s(d,v.folder,a,C)}),this.g&&!this.e)?null:(this.u(d,h,C),{providerTime:w,postProcessTime:i.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(v){const C=(0,y.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),S=(0,y.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:S,includes:C,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},C,S,m){if(S===this.a){const h=o.basename(this.a);this.v(m,{base:C,relativePath:this.a,basename:h})}function d(h){const b=o.basename(h),g=o.dirname(h);let p=v[g];p||(p=v[g]=[],d(g)),p.push({base:C,relativePath:h,basename:b})}d(S)}u({rootEntries:v,pathToEntries:C},S,m){const d=this,h=this.a;function b(g){const p=(0,y.hasSiblingFn)(()=>g.map(w=>w.basename));for(let w=0,i=g.length;w<i;w++){const s=g[w],{relativePath:a,basename:u}=s;if(S.matchesExcludesSync(a,u,h!==u?p:void 0))continue;const l=C[a];if(l)b(l);else{if(a===h)continue;d.v(m,s)}if(d.e)break}}b(v)}v(v,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(C))}}class L{constructor(){this.b=new Map}fileSearch(v,C,S,m){const d=this.c(v.cacheKey),h=new D(v,C,d&&d.token);let b=0;const g=p=>{b+=p.length,S(p.map(w=>this.d(w)))};return this.e(h,L.a,g,m).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:p.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new t.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:I.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,C,S,m){m.onCancellationRequested(()=>{v.cancel()});const d=b=>{b&&(h.push(b),C>0&&h.length>=C&&(S(h),h=[]))};let h=[];return v.search(d).then(b=>(h.length&&S(h),b),b=>(h.length&&S(h),Promise.reject(b)))}}e.FileSearchManager=L,L.a=512}),define(ye[288],Ce([1,0,18,81,38,112,28,15,9,24,8,11,2,165,192,52,13,47,133,286,31]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(f,E,T,M,K){this.a=f,this.b=E,this.c=T,this.d=M,this.e=K}text(f,E,T={}){f=this.f(f,T);const M=this.a.getValue(),K=E&&E.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(E?.map(h.toWorkspaceFolder),T),type:2,contentPattern:f,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:M.search.usePCRE2||K||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}f(f,E){const T=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const M={...f,wordSeparators:T.editor.wordSeparators};return this.j(f,E)&&(M.isCaseSensitive=!0),this.k(f)&&(M.isMultiline=!0),M}file(f,E={}){return{...this.h(f,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(f,E){return f?(f=Array.isArray(f)?f.map(l):l(f),E?this.parseSearchPaths(f):{pattern:s(...Array.isArray(f)?f:[f])}):{}}h(f=[],E={}){const T=this.g(E.includePattern,E.expandPatterns),M=this.g(E.excludePattern,E.expandPatterns),K=f.length>1,V=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(N=>this.q(N,E,M)):f.map(N=>this.r(N,E,M,K))).filter(N=>!!N),F={_reason:E._reason,folderQueries:V,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:M.pattern,includePattern:T.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const N=o.coalesce(o.flatten(this.c.groups.map(z=>z.editors.map(ne=>ne.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const B=N.filter(z=>(0,p.pathIncludedInQuery)(F,z.fsPath)),j=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...F,...j}}const U=E.extraFileResources&&E.extraFileResources.filter(N=>(0,p.pathIncludedInQuery)(F,N.fsPath));return F.extraFileResources=U&&U.length?U:void 0,F}i(f){const E=[],T=new I.ResourceMap,M={};let K=!1;return f.forEach(V=>{if(V.scheme===A.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(V)){const U=this.b.getWorkspaceFolder(V)?.uri??V.with({path:y.dirname(V.fsPath)});let N=T.get(U);N||(K=!0,N={folder:U,includePattern:{}},E.push(N),T.set(U,N));const B=y.relative(U.fsPath,V.fsPath);(0,P.assertIsDefined)(N.includePattern)[B.replace(/\\/g,"/")]=!0}else V.fsPath&&(K=!0,M[V.fsPath]=!0)}),{folderQueries:E,includePattern:M,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(f,E){if(E.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,C.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const E=j=>y.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),M=(Array.isArray(f)?f:a(f)).map(j=>{const z=this.e.resolvedUserHome;return z?(0,R.untildify)(j,z.scheme===A.Schemas.file?z.fsPath:z.path):j}),K=t.groupBy(M,j=>E(j)?"searchPaths":"exprSegments"),V=(K.exprSegments||[]).map(j=>L.rtrim(j,"/")).map(j=>L.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),u(j))),F={},U=this.m(K.searchPaths||[]);U&&U.length&&(F.searchPaths=U);const N=o.flatten(V),B=s(...N);return B&&(F.pattern=B),F}l(f,E){return E.disregardExcludeSettings?void 0:(0,p.getExcludes)(f,!E.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const E=f.flatMap(M=>{let{pathPortion:K,globPortion:V}=i(M);return V&&(V=c(V)),this.n(K).flatMap(U=>this.o(U,V))}),T=new Map;return E.forEach(M=>{const K=M.searchPath.toString(),V=T.get(K);V?M.pattern&&(V.pattern=V.pattern||{},V.pattern[M.pattern]=!0):T.set(K,{searchPath:M.searchPath,pattern:M.pattern?s(M.pattern):void 0})}),Array.from(T.values())}n(f){if(y.isAbsolute(f)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==A.Schemas.file?[{searchPath:E[0].uri.with({path:f})}]:[{searchPath:v.URI.file(y.normalize(f))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(f=l(f),f.startsWith("../")||f===".."){const M=y.posix.resolve(E.path,f);return[{searchPath:E.with({path:M})}]}const T=c(f);return[{searchPath:E,pattern:T}]}else{if(f==="./"||f===".\\")return[];{const E=f.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(K=>{const V=E.match(new RegExp(`^${L.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return V?{match:V,folder:K}:null}).filter(P.isDefined);if(M.length)return M.map(K=>{const V=K.match[1];return{searchPath:K.folder.uri,pattern:V&&c(V)}});{const K=f.match(/\.[\/\\](.+)[\/\\]?/),V=K?K[1]:f,F=S.localize(0,null,V);throw new Error(F)}}}}o(f,E){const T=f.pattern&&E?`${f.pattern}/${E}`:f.pattern||E,M=[{searchPath:f.searchPath,pattern:T}];return T&&!T.endsWith("**")&&M.push({searchPath:f.searchPath,pattern:T+"/**"}),M}q(f,E,T){const M=this.r((0,h.toWorkspaceFolder)(f.searchPath),E,T,!1);return M?{...M,includePattern:f.pattern}:null}r(f,E,T,M){let K;const V=v.URI.isUri(f)?f:f.uri;if(T.searchPaths){const j=T.searchPaths.filter(z=>(0,D.isEqual)(z.searchPath,V))[0];if(j&&!j.pattern)return null;j&&(K=j.pattern)}const F=this.a.getValue({resource:V}),N={...this.l(F,E)||{},...K||{}},B=v.URI.isUri(f)?(0,D.basename)(f):f.name;return{folder:V,folderName:M?B:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!F.search.followSymlinks}}};w=qe([We(0,m.IConfigurationService),We(1,h.IWorkspaceContextService),We(2,b.IEditorGroupsService),We(3,d.ILogService),We(4,g.IPathService)],w),e.QueryBuilder=w;function i(r){const f=r.match(/[\*\{\}\(\)\[\]\?]/);if(f){const E=f.index,T=r.substr(0,E).match(/[/|\\][^/\\]*$/);if(T){let M=r.substr(0,T.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:r.substr((T.index||0)+1)}}}return{pathPortion:r}}function s(...r){return r.length?r.reduce((f,E)=>(f[E]=!0,f),Object.create(null)):void 0}function a(r){return k.splitGlobAware(r,",").map(f=>f.trim()).filter(f=>!!f.length)}function u(r){return[`**/${r}/**`,`**/${r}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function l(r){return r.replace(/\\/g,"/")}function c(r){return l(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(r,f){r=o.distinct(r,M=>M.toString());const E=[],T=f.getWorkspace();return r&&r.forEach(M=>{let K;if(f.getWorkbenchState()===2)K=(0,D.relativePath)(T.folders[0].uri,M),K&&K!=="."&&(K="./"+K);else{const V=f.getWorkspaceFolder(M);if(V){const F=V.name;if(T.folders.filter(N=>N.name===F).length===1){const N=(0,D.relativePath)(V.uri,M);N===""?K=`./${V.name}`:K=`./${V.name}/${N}`}else K=M.fsPath}}K&&E.push(K)}),E}e.resolveResourcesForSearchIncludes=n}),define(ye[289],Ce([1,0,24,2,21,10,4,288,31,47]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function P(m,d){const h=d.activationEvents;if(!h)return Promise.resolve(void 0);const b=[],g=[];for(const u of h)if(/^workspaceContains:/.test(u)){const l=u.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||m.forceUsingSearch?g.push(l):b.push(l)}if(b.length===0&&g.length===0)return Promise.resolve(void 0);let p;const w=new Promise((u,l)=>{p=u}),i=u=>p({activationEvent:u}),s=Promise.all(b.map(u=>v(m,u,i))).then(()=>{}),a=C(m,d.identifier,g,i);return Promise.all([s,a]).then(()=>{p(void 0)}),w}e.checkActivateWorkspaceContainsExtension=P;async function v(m,d,h){for(const b of m.folders)if(await m.exists(o.joinPath(t.URI.revive(b),d))){h(`workspaceContains:${d}`);return}}async function C(m,d,h,b){if(h.length===0)return Promise.resolve(void 0);const g=new k.CancellationTokenSource,p=m.checkExists(m.folders,h,g.token),w=setTimeout(async()=>{g.cancel(),m.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},L);let i=!1;try{i=await p}catch(s){R.isCancellationError(s)||R.onUnexpectedError(s)}g.dispose(),clearTimeout(w),i&&b(`workspaceContains:${h.join(",")}`)}function S(m,d,h,b){const g=m.get(I.IInstantiationService),p=m.get(y.ISearchService),i=g.createInstance(A.QueryBuilder).file(d.map(s=>(0,D.toWorkspaceFolder)(t.URI.revive(s))),{_reason:"checkExists",includePattern:h,exists:!0});return p.fileSearch(i,b).then(s=>!!s.limitHit,s=>R.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=S});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,o):k?k.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[42],Ce([1,0,176,9,77,24,16,6,64,2,13,5,34,231,98,33,27,134,10,26,22,213,7,128,4,25,73,17,89,54,41,3,289,97,215,15,96,43]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p,w,i,s,a,u,l,c,n,r,f,E,T,M,K,V,F,U){"use strict";var N,B,j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let z=class Bn extends A.Disposable{constructor(q,G,le,be,ve,Pe,Ne,se,ue,de,Z){super(),this.a=this.B(new E.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=G,this.g=le,this.f=Ne,this.j=be,this.k=ve,this.l=Pe,this.m=ue,this.p=de,this.s=Z,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new I.Barrier,this.y=new I.Barrier,this.z=new I.Barrier,this.C=new I.Barrier,this.F=new h.ExtensionDescriptionRegistry(this.f.allExtensions);const ae=(0,d.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new h.ExtensionDescriptionRegistry(Y(this.F,ae)),this.G=new S.ExtHostStorage(this.g,this.l),this.H=new M.ExtHostSecretState(this.g),this.I=se,this.h=q.createChild(new n.ServiceCollection([S.IExtHostStorage,this.G],[M.IExtHostSecretState,this.H])),this.J=this.B(new C.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ie,O,W)=>{this.v.$onExtensionActivationError(ie,b.transformErrorForSerialization(O),W)},actualActivateExtension:async(ie,O)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(ie,this.D,this.F))return await this.v.$activateExtension(ie,O),new C.HostExtension;const W=this.D.getExtensionDescription(ie);return this.Y(W,O)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(q){b.onUnexpectedError(q)}}async Q(){this.I.onWillDeactivateAll();let q=[];try{q=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(q)}terminate(q,G=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${q}`),this.l.flush(),this.p.dispose(),this.J.dispose(),b.setUnexpectedErrorHandler(be=>{this.l.error(be)}),this.g.dispose();const le=this.Q();Promise.race([(0,I.timeout)(5e3),le]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${G}`):this.l.info(`Extension host exiting with code ${G}`),this.l.flush(),this.l.dispose(),this.c.exit(G)})}isActivated(q){return this.z.isOpen()?this.J.isActivated(q):!1}async getExtension(q){const G=await this.v.$getExtension(q);let le;if(G?.browserNlsBundleUris){le={};for(const be of Object.keys(G.browserNlsBundleUris))le[be]=D.URI.revive(G.browserNlsBundleUris[be])}return G&&{...G,identifier:new g.ExtensionIdentifier(G.identifier.value),extensionLocation:D.URI.revive(G.extensionLocation),browserNlsBundleUris:le}}R(q,G){return this.J.activateByEvent(q,G)}S(q,G){return this.J.activateById(q,G)}activateByIdWithErrors(q,G){return this.S(q,G).then(()=>{const le=this.J.getActivatedExtension(q);if(le.activationFailed)return Promise.reject(le.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(q=>this.D)}getExtensionExports(q){return this.z.isOpen()?this.J.getActivatedExtension(q).exports:null}async U(q){if(q.scheme!==V.Schemas.file)return q;const G=await this.c.realpath(q.fsPath);return D.URI.file(G)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(q=>new ee(q))),this.L}async W(q){const G=y.TernarySearchTree.forUris(le=>R.extUriBiasedIgnorePathCase.ignorePathCasing(le));return await Promise.all(q.map(async le=>{if(this.ob(le)){const be=await this.U(le.extensionLocation);G.set(be,le)}})),G}X(q){let G=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(q))return G;const le=this.J.getActivatedExtension(q);if(!le)return G;try{typeof le.module.deactivate=="function"&&(G=Promise.resolve(le.module.deactivate()).then(void 0,be=>(this.l.error(be),Promise.resolve(void 0))))}catch(be){this.l.error(`An error occurred when deactivating the extension '${q.value}':`),this.l.error(be)}try{(0,A.dispose)(le.subscriptions)}catch(be){this.l.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this.l.error(be)}return G}async Y(q,G){return this.f.remote.isRemote?this.v.$onWillActivateExtension(q.identifier):await this.v.$onWillActivateExtension(q.identifier),this.ab(q,G).then(le=>{const be=le.activationTimes;return this.v.$onDidActivateExtension(q.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,G),this.Z(q,G,"success",be),le},le=>{throw this.Z(q,G,"failure"),le})}Z(q,G,le,be){const ve=ne(q,G);this.u.$publicLog2("extensionActivationTimes",{...ve,...be||{},outcome:le})}ab(q,G){const le=ne(q,G);this.u.$publicLog2("activatePlugin",le);const be=this.ob(q);if(!be)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${G.startup}, activationEvent: '${G.activationEvent}'${q.identifier.value!==G.extensionId.value?`, root cause: ${G.extensionId.value}`:""}`),this.l.flush();const ve=new C.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this.pb(q,(0,R.joinPath)(q.extensionLocation,be),ve),this.bb(q)]).then(Pe=>(k.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),Bn.cb(this.l,q.identifier,Pe[0],Pe[1],ve))).then(Pe=>(k.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),Pe))}bb(q){const G=new w.ExtensionGlobalMemento(q,this.G),le=new w.ExtensionMemento(q.identifier.value,!1,this.G),be=new K.ExtensionSecrets(q,this.H),ve=q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Pe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([G.whenReady,le.whenReady,this.I.whenReady]).then(()=>{const Ne=this;let se,ue;const de=(0,d.isProposedApiEnabled)(q,"ipc")?this.f.messagePorts?.get(g.ExtensionIdentifier.toKey(q.identifier)):void 0;return Object.freeze({globalState:G,workspaceState:le,secrets:be,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(Z){return t.join(q.extensionLocation.fsPath,Z)},get storagePath(){return Ne.I.workspaceValue(q)?.fsPath},get globalStoragePath(){return Ne.I.globalValue(q).fsPath},get logPath(){return t.join(Ne.f.logsLocation.fsPath,q.identifier.value)},get logUri(){return D.URI.joinPath(Ne.f.logsLocation,q.identifier.value)},get storageUri(){return Ne.I.workspaceValue(q)},get globalStorageUri(){return Ne.I.globalValue(q)},get extensionMode(){return ve},get extension(){return se===void 0&&(se=new _(Ne,q.identifier,q,Pe,!1)),se},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(q,"extensionRuntime"),Ne.extensionRuntime},get environmentVariableCollection(){return Ne.p.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!ue){if(!de)return;const Z=E.Event.buffer(E.Event.fromDOMEventEmitter(de,"message",ae=>ae.data));de.start(),ue={onDidReceiveMessage:Z,postMessage:de.postMessage.bind(de)}}return ue}})})}static cb(q,G,le,be,ve){return le=le||{activate:void 0,deactivate:void 0},this.db(q,G,le,be,ve).then(Pe=>new C.ActivatedExtension(!1,null,ve.build(),le,Pe,be.subscriptions))}static db(q,G,le,be,ve){if(typeof le.activate=="function")try{ve.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${G.value}`);const Pe=typeof global=="object"?global:self,Ne=le.activate.apply(Pe,[be]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Ne).then(se=>(ve.activateResolveStop(),se))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(le)}eb(q,G){this.S(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:G}).then(void 0,le=>{this.l.error(le)})}fb(){this.v.$setPerformanceMarks(k.getMarks());for(const q of this.D.getAllExtensionDescriptions())if(q.activationEvents)for(const G of q.activationEvents)G==="onStartupFinished"&&this.eb(q,G)}gb(){const q=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.hb(ve.added)));const G=this.j.workspace?this.j.workspace.folders:[],le=this.hb(G),be=Promise.all([q,le]).then(()=>{});return Promise.race([be,(0,I.timeout)(1e4)]).then(()=>{this.fb()}),be}hb(q){return q.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(G=>this.ib(q,G))).then(()=>{})}async ib(q,G){if(this.isActivated(G.identifier))return;const le=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.l,folders:q.map(Pe=>Pe.uri),forceUsingSearch:le,exists:Pe=>this.c.exists(Pe.fsPath),checkExists:(Pe,Ne,se)=>this.t.$checkExists(Pe,Ne,se)},ve=await(0,T.checkActivateWorkspaceContainsExtension)(be,G);if(!!ve)return this.S(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:ve.activationEvent}).then(void 0,Pe=>this.l.error(Pe))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(q){throw console.error(q),q}}async jb(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:G}=this.f.environment;if(!q||!G)throw new Error(o.localize(0,null));const le=await this.pb(null,G,new C.ExtensionActivationTimesBuilder(!1));if(!le||typeof le.run!="function")throw new Error(o.localize(1,null,G.toString()));return new Promise((be,ve)=>{const Pe=(ue,de)=>{ue?ve(ue):be(typeof de=="number"&&de>0?1:0)},Ne=(0,R.originalFSPath)(G),se=le.run(Ne,Pe);se&&se.then&&se.then(()=>{be(0)}).catch(ue=>{ve(ue instanceof Error&&ue.stack?ue.stack:String(ue))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,G){return this.M[q]=G,(0,A.toDisposable)(()=>{delete this.M[q]})}async lb(q){const G=q.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const le=q.substr(0,G);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${le}`,!1),{authorityPrefix:le,resolver:this.M[le]}}async $resolveAuthority(q,G){const le=U.StopWatch.create(!1),be=()=>`[resolveAuthority(${J(q)},${G})][${le.elapsed()}ms] `,ve=de=>this.l.info(`${be()}${de}`),Pe=(de,Z=void 0)=>this.l.error(`${be()}${de}`,Z);ve("activating resolver...");const{authorityPrefix:Ne,resolver:se}=await this.lb(q);if(!se)return Pe("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ne}.`,detail:void 0}};const ue=new I.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(se)),ue.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),k.mark(`code/extHost/willResolveAuthority/${Ne}`);const de=await se.resolve(q,{resolveAttempt:G});k.mark(`code/extHost/didResolveAuthorityOK/${Ne}`),ue.dispose(),ve(`returned ${de.host}:${de.port}`);const Z={authority:q,host:de.host,port:de.port,connectionToken:de.connectionToken},ae={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Z,options:ae,tunnelInformation:{environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures}}}}catch(de){if(k.mark(`code/extHost/didResolveAuthorityError/${Ne}`),ue.dispose(),Pe("returned an error",de),de instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:de._code,message:de._message,detail:de._detail}};throw de}}async $getCanonicalURI(q,G){this.l.info(`$getCanonicalURI invoked for authority (${J(q)})`);const{resolver:le}=await this.lb(q);if(!le)return null;const be=D.URI.revive(G);if(typeof le.getCanonicalURI>"u")return be;const ve=await(0,I.asPromise)(()=>le.getCanonicalURI(be));return ve||be}static mb(q,G,le){const be=new h.ExtensionDescriptionRegistry(q.getAllExtensionDescriptions());be.deltaExtensions(le.toAdd,le.toRemove);const ve=(0,d.extensionIdentifiersArrayToSet)(G.getAllExtensionDescriptions().map(Ne=>Ne.identifier));for(const Ne of le.myToRemove)ve.delete(g.ExtensionIdentifier.toKey(Ne));for(const Ne of le.myToAdd)ve.add(g.ExtensionIdentifier.toKey(Ne));const Pe=Y(be,ve);return{globalRegistry:be,myExtensions:Pe}}$startExtensionHost(q){q.toAdd.forEach(be=>be.extensionLocation=D.URI.revive(be.extensionLocation));const{globalRegistry:G,myExtensions:le}=Bn.mb(this.F,this.D,q);return this.F.set(G.getAllExtensionDescriptions()),this.D.set(le),this.kb()}$activateByEvent(q,G){return G===1?this.R(q,!1):this.z.wait().then(le=>this.R(q,!1))}async $activate(q,G){return await this.z.wait(),this.D.getExtensionDescription(q)?(await this.S(q,G),!0):!1}async $deltaExtensions(q){q.toAdd.forEach(Pe=>Pe.extensionLocation=D.URI.revive(Pe.extensionLocation));const{globalRegistry:G,myExtensions:le}=Bn.mb(this.F,this.D,q),be=await this.W(le);return(await this.getExtensionPathIndex()).setSearchTree(be),this.F.set(G.getAllExtensionDescriptions()),this.D.set(le),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){const G=p.VSBuffer.alloc(q),le=Math.random()%256;for(let be=0;be<q;be++)G.writeUInt8(le,be);return G}async $updateRemoteConnectionData(q){this.P=q,this.a.fire()}};z=qe([We(0,a.IInstantiationService),We(1,e.IHostUtils),We(2,c.IExtHostRpcService),We(3,m.IExtHostWorkspace),We(4,v.IExtHostConfiguration),We(5,L.ILogService),We(6,u.IExtHostInitDataService),We(7,l.IExtensionStoragePaths),We(8,r.IExtHostTunnelService),We(9,f.IExtHostTerminalService),We(10,F.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function ne(ge,q){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class _{constructor(q,G,le,be,ve){N.set(this,void 0),B.set(this,void 0),j.set(this,void 0),Je(this,N,q,"f"),Je(this,B,G,"f"),Je(this,j,le.identifier,"f"),this.id=le.identifier.value,this.extensionUri=le.extensionLocation,this.extensionPath=t.normalize((0,R.originalFSPath)(le.extensionLocation)),this.packageJSON=le,this.extensionKind=be,this.isFromDifferentExtensionHost=ve}get isActive(){return Ue(this,N,"f").isActivated(Ue(this,j,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,N,"f").getExtensionExports(Ue(this,j,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,N,"f").activateByIdWithErrors(Ue(this,j,"f"),{startup:!1,extensionId:Ue(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=_,N=new WeakMap,B=new WeakMap,j=new WeakMap;function Y(ge,q){return ge.getAllExtensionDescriptions().filter(G=>q.has(g.ExtensionIdentifier.toKey(G.identifier)))}function J(ge){const q=ge.indexOf("+");return q===-1?ge:ge.substring(0,q)}class ee{constructor(q){this.a=q}setSearchTree(q){this.a=q}findSubstr(q){return this.a.findSubstr(q)}forEach(q){return this.a.forEach(q)}}e.ExtensionPaths=ee}),define(ye[290],Ce([1,0,77,2,5,34,27,26,17,25,4,42,36,13,8]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let m=class{constructor(w,i,s,a,u,l,c){this.c=w,this.d=i,this.e=s,this.f=a,this.g=u,this.h=l,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),o.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new h(this.c,i,this.d,w,this.i)),this.register(this.e.createInstance(b,i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(g,i,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const i of w.nodeModuleName)this.a.set(i,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(i=>w.alternativeModuleName(i))}};m=qe([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,D.IExtHostInitDataService),We(6,C.ILogService)],m),e.RequireInterceptor=m;let d=class ti{constructor(w){if(w.environment.appRoot&&ti.a.size){const i=(0,S.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),s="[a-z0-9_.-]",a=`@${s}+\\/${s}+|${s}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${u}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const i=this.b.exec(this.c(w));if(!i)return;const[,s,a,u]=i,l=ti.a.get(a);if(l!==void 0)return console.warn(`${a} as been renamed to ${l}, please update your imports`),s+l+u}c(w){return w.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=qe([We(0,D.IExtHostInitDataService)],d);class h{constructor(w,i,s,a,u){this.c=w,this.d=i,this.e=s,this.f=a,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(w,i){const s=this.d.findSubstr(i);if(s){let a=this.a.get(A.ExtensionIdentifier.toKey(s.identifier));return a||(a=this.c(s,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(s.identifier),a)),a}if(!this.b){let a="";this.d.forEach((u,l)=>a+=`	${l} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${a}`),this.b=this.c(I.nullExtensionDescription,this.e,this.f)}return this.b}}let b=class{constructor(w,i,s){this.d=w,this.nodeModuleName="keytar",this.a=i.getProxy(k.MainContext.MainThreadTelemetry);const{environment:a}=s,u=i.getProxy(k.MainContext.MainThreadKeytar);if(a.appRoot){let l=a.appRoot.fsPath;v.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.b=new Set,this.b.add(`${l}/node_modules.asar/keytar`),this.b.add(`${l}/node_modules/keytar`)}this.c={getPassword:(l,c)=>u.$getPassword(l,c),setPassword:(l,c,n)=>u.$setPassword(l,c,n),deletePassword:(l,c)=>u.$deletePassword(l,c),findPassword:l=>u.$findPassword(l),findCredentials(l){return u.$findCredentials(l)}}}load(w,i){const s=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const i=w.length;if(i<=7||!this.b)return;const s=i-7;if((w.charAt(s)==="/"||w.charAt(s)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};b=qe([We(1,y.IExtHostRpcService),We(2,D.IExtHostInitDataService)],b);let g=class{constructor(w,i,s){this.e=w,this.f=i,this.nodeModuleName=["open","opn"],this.d=s.getProxy(k.MainContext.MainThreadTelemetry);const a=s.getProxy(k.MainContext.MainThreadWindow);this.c=(u,l)=>{const c=t.URI.parse(u);return l?this.g(u,l):c.scheme==="http"||c.scheme==="https"?a.$openUri(c,u,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?a.$openUri(c,u,{}):this.g(u,l)}}load(w,i,s){const a=this.e.findSubstr(i);return a&&(this.a=a.identifier.value,this.h()),this.b=s(w),this.c}g(w,i){return this.i(),this.b(w,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};g=qe([We(2,y.IExtHostRpcService)],g)}),define(ye[49],Ce([1,0,82,6,9,36,4,58,59,42,7,33,227,34]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class S extends v.AbstractVariableResolverService{constructor(h,b,g,p,w,i,s){function a(){if(g){const u=g.activeEditor();if(u)return u.document.uri;const l=p.tabGroups.all.find(c=>c.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof L.TextDiffTabInput||l.input instanceof L.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof L.TextTabInput||l.input instanceof L.NotebookEditorTabInput||l.input instanceof L.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:u=>{const l=i.folders.filter(c=>c.name===u);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(u,l)=>w.getConfiguration(void 0,u).get(l),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=a();if(u)return k.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const u=a();if(u){const l=b.getWorkspaceFolder(u);if(l)return k.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(g){const u=g.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(g){const u=g.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>h.getExtension(u)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let m=class extends t.Disposable{constructor(h,b,g,p,w){super(),this.b=h,this.c=b,this.g=g,this.h=p,this.i=w,this.a=new o.Lazy(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.i,i,a,this.j())})}getResolver(){return this.a.getValue()}j(){}};m=qe([We(0,D.IExtHostExtensionService),We(1,P.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,C.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],m),e.ExtHostVariableResolverProviderService=m}),define(ye[78],Ce([1,0,16,3,11,2,4,5,59,42,17,7,33,131,219,34,49]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,u,l,c,n,r){this.D=u,this.E=l,this.F=c,this.G=n,this.H=r,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=a.getProxy(A.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new g(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(f=>{f.onDidChange(E=>{this.I(f)}),this.I(f)})}asDebugSourceUri(a,u){const l=a;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let c=`debug:${encodeURIComponent(l.path||"")}`,n="?";return u&&(c+=`${n}session=${encodeURIComponent(u.id)}`,n="&"),c+=`${n}ref=${l.sourceReference}`,R.URI.parse(c)}else{if(l.path)return R.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(a){const u=[];for(const l of a.getAllExtensionDescriptions())if(l.contributes){const c=l.contributes.debuggers;if(c&&c.length>0)for(const n of c)(0,S.isDebuggerMainContribution)(n)&&u.push(n.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const a=[];return this.w.forEach(u=>a.push(u)),a}addBreakpoints(a){this.T();const u=a.filter(n=>{const r=n.id;return this.w.has(r)?!1:(this.w.set(r,n),!0)});this.U(u,[],[]);const l=[],c=new Map;for(const n of u)if(n instanceof P.SourceBreakpoint){let r=c.get(n.location.uri.toString());r||(r={type:"sourceMulti",uri:n.location.uri,lines:[]},c.set(n.location.uri.toString(),r),l.push(r)),r.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&l.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(a){this.T();const u=a.filter(r=>this.w.delete(r.id));this.U([],u,[]);const l=u.filter(r=>r instanceof P.SourceBreakpoint).map(r=>r.id),c=u.filter(r=>r instanceof P.FunctionBreakpoint).map(r=>r.id),n=u.filter(r=>r instanceof P.DataBreakpoint).map(r=>r.id);return this.k.$unregisterBreakpoints(l,c,n)}startDebugging(a,u,l){return this.k.$startDebugging(a?a.uri:void 0,u,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,u,l){if(!u)return new P.Disposable(()=>{});const c=this.d++;return this.f.push({type:a,handle:c,provider:u}),this.k.$registerDebugConfigurationProvider(a,l,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,c),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==u),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(a,u,l){if(!l)return new P.Disposable(()=>{});if(!this.P(a,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:u,handle:c,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(u,c),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(a,u){if(!u)return new P.Disposable(()=>{});const l=this.i++;return this.j.push({type:a,handle:l,factory:u}),new P.Disposable(()=>{this.j=this.j.filter(c=>c.factory!==u)})}async $runInTerminal(a,u){return Promise.resolve(void 0)}async $substituteVariables(a,u){let l;const c=await this.W(a);return c&&(l={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(l,u)}J(a,u){if(a.type==="implementation")return new w(a.implementation)}K(){}async $startDASession(a,u){const l=this,c=await this.V(u);return this.R(this.M(c.type),c).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const r=this.L(n),f=this.J(r,c);if(!f)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const E=f;return this.A.set(a,E),this.Q(c).then(T=>(T&&this.B.set(a,T),E.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const K=M,V={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const F=await this.C.sign(K.arguments.value);V.body={signature:F},E.sendResponse(V)}else throw new Error("no signer")}catch(F){V.success=!1,V.message=F.message,E.sendResponse(V)}}else T&&T.onDidSendMessage&&T.onDidSendMessage(M),M=(0,S.convertToVSCPaths)(M,!0),l.k.$acceptDAMessage(a,M)}),E.onError(M=>{T&&T.onError&&T.onError(M),this.k.$acceptDAError(a,M.name,M.message,M.stack)}),E.onExit(M=>{T&&T.onExit&&T.onExit((0,k.withNullAsUndefined)(M),void 0),this.k.$acceptDAExit(a,(0,k.withNullAsUndefined)(M),void 0)}),T&&T.onWillStartSession&&T.onWillStartSession(),E.startSession()))})}$sendDAMessage(a,u){u=(0,S.convertToDAPaths)(u,!1);const l=this.B.get(a);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(u),this.A.get(a)?.sendMessage(u)}$stopDASession(a){const u=this.B.get(a);this.B.delete(a),u&&u.onWillStopSession&&u.onWillStopSession();const l=this.A.get(a);return this.A.delete(a),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const u=[],l=[],c=[];if(a.added)for(const n of a.added){const r=n.id;if(r&&!this.w.has(r)){let f;if(n.type==="function")f=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")f=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const E=R.URI.revive(n.uri);f=new P.SourceBreakpoint(new P.Location(E,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,P.setBreakpointId)(f,r),this.w.set(r,f),u.push(f)}}if(a.removed)for(const n of a.removed){const r=this.w.get(n);r&&(this.w.delete(n),l.push(r))}if(a.changed){for(const n of a.changed)if(n.id){const r=this.w.get(n.id);if(r){if(r instanceof P.FunctionBreakpoint&&n.type==="function"){const f=r;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.functionName=n.functionName}else if(r instanceof P.SourceBreakpoint&&n.type==="source"){const f=r;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.location=new P.Location(R.URI.revive(n.uri),new P.Position(n.line,n.character))}c.push(r)}}}this.U(u,l,c)}$provideDebugConfigurations(a,u,l){return(0,o.asPromise)(async()=>{const c=this.O(a);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(u);return c.provideDebugConfigurations(n,l)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(a,u,l,c){return(0,o.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const r=await this.W(u);return n.resolveDebugConfiguration(r,l,c)})}$resolveDebugConfigurationWithSubstitutedVariables(a,u,l,c){return(0,o.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const r=await this.W(u);return n.resolveDebugConfigurationWithSubstitutedVariables(r,l,c)})}async $provideDebugAdapter(a,u){const l=this.N(a);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(u);return this.R(l,c).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(a){const u=await this.V(a);this.m.fire(u)}async $acceptDebugSessionTerminated(a){const u=await this.V(a);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,u){(await this.V(a))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(a,u){const c={session:await this.V(a),event:u.event,body:u.body};this.u.fire(c)}L(a){if(a instanceof P.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}M(a){const u=this.h.filter(l=>l.type===a);if(u.length>0)return u[0].factory}N(a){const u=this.h.filter(l=>l.handle===a);if(u.length>0)return u[0].factory}O(a){const u=this.f.filter(l=>l.handle===a);if(u.length>0)return u[0].provider}P(a,u){if(a.contributes){const l=a.contributes.debuggers;if(l&&l.length>0){for(const c of l)if(c.label&&c.type&&c.type===u)return!0}}return!1}Q(a){const l=a.configuration.type,c=this.j.filter(n=>n.type===l||n.type==="*").map(n=>(0,o.asPromise)(()=>n.factory.createDebugAdapterTracker(a)).then(r=>r,r=>null));return Promise.race([Promise.all(c).then(n=>{const r=n.filter(f=>!!f);if(r.length>0)return new p(r)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(a,u){const l=u.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new P.DebugAdapterServer(l));if(a){const n=await this.E.getExtensionRegistry();return(0,o.asPromise)(()=>a.createDebugAdapterDescriptor(u,this.S(u,n))).then(r=>{if(r)return r})}const c=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,c))}S(a,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(a,u,l){(a.length>0||u.length>0||l.length>0)&&this.z.fire(Object.freeze({added:a,removed:u,changed:l}))}async V(a){if(a)if(typeof a=="string"){const u=this.l.get(a);if(u)return u}else{let u=this.l.get(a.id);if(!u){const l=await this.W(a.folderUri),c=a.parent?this.l.get(a.parent):void 0;u=new b(this.k,a.id,a.type,a.name,l,a.configuration,c),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(a){if(a){const u=R.URI.revive(a);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};h=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class b{constructor(a,u,l,c,n,r,f){this.d=a,this.f=u,this.g=l,this.h=c,this.i=n,this.j=r,this.k=f}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,u){return this.d.$customDebugAdapterRequest(this.f,a,u)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=b;class g{constructor(a){this.value=Object.freeze({append(u){a.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=g;class p{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(u=>u.onError?u.onError(a):void 0)}onExit(a,u){this.d.forEach(l=>l.onExit?l.onExit(a,u):void 0)}}class w extends C.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends h{constructor(a,u,l,c,n,r){super(a,u,l,c,n,r)}};i=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[291],Ce([1,0,10,77,2,5,283,13,88,89,25,199,17,55,42,95]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(g){const p=g.get(A.ILogService),i=g.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(s=>{p.error(s);const a=o.transformErrorForSerialization(s);i.$onUnexpectedError(a)})}static async installFullHandler(g){const p=g.get(A.ILogService),w=g.get(v.IExtHostRpcService),i=g.get(S.IExtHostExtensionService),s=g.get(m.IExtHostTelemetry),a=w.getProxy(R.MainContext.MainThreadExtensionService),u=w.getProxy(R.MainContext.MainThreadErrors),l=await i.getExtensionPathIndex(),c=new WeakMap;Error.prepareStackTrace=(n,r)=>{let f="",E,T;for(const M of r)f+=`
	at ${M.toString()}`,T=M.getFileName(),!E&&T&&(E=l.findSubstr(k.URI.file(T)));return c.set(n,E?.identifier),`${n.name||"Error"}: ${n.message||""}${f}`},o.setUnexpectedErrorHandler(n=>{p.error(n);const r=o.transformErrorForSerialization(n),f=c.get(n);if(!f){u.$onUnexpectedError(r);return}a.$onExtensionRuntimeError(f,r);const E=s.onExtensionError(f,n);p.trace("forwarded error to extension?",E,f)})}}Error.stackTraceLimit=100;class h{constructor(g,p,w,i,s){this.a=w,this.b=new I.RPCProtocol(g,null,i),p=h.e(p,this.b);const a=new D.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());a.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...p,messagePorts:s}),a.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),a.set(C.IURITransformerService,new C.URITransformerService(i)),a.set(S.IHostUtils,w);const u=new P.InstantiationService(a,!0);u.invokeFunction(d.installEarlyHandler),this.d=u.invokeFunction(l=>l.get(A.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",p),this.c=u.invokeFunction(l=>l.get(S.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(d.installFullHandler)}async asBrowserUri(g){const p=this.b.getProxy(R.MainContext.MainThreadExtensionService);return k.URI.revive(await p.$asBrowserUri(g))}terminate(g){this.c.terminate(g)}static e(g,p){g.allExtensions.forEach(i=>{i.extensionLocation=k.URI.revive(p.transformIncomingURIs(i.extensionLocation));const s={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(a=>s[a]=k.URI.revive(p.transformIncomingURIs(i.browserNlsBundleUris[a]))),i.browserNlsBundleUris=s)}),g.environment.appRoot=k.URI.revive(p.transformIncomingURIs(g.environment.appRoot));const w=g.environment.extensionDevelopmentLocationURI;return w&&(g.environment.extensionDevelopmentLocationURI=w.map(i=>k.URI.revive(p.transformIncomingURIs(i)))),g.environment.extensionTestsLocationURI=k.URI.revive(p.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=k.URI.revive(p.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=k.URI.revive(p.transformIncomingURIs(g.environment.workspaceStorageHome)),g.environment.extensionTelemetryLogResource=k.URI.revive(p.transformIncomingURIs(g.environment.extensionTelemetryLogResource)),g.nlsBaseUrl=k.URI.revive(p.transformIncomingURIs(g.nlsBaseUrl)),g.logsLocation=k.URI.revive(p.transformIncomingURIs(g.logsLocation)),g.logFile=k.URI.revive(p.transformIncomingURIs(g.logFile)),g.workspace=p.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=h}),define(ye[292],Ce([1,0,16,12,182,198,205,78,59,42,17,41,7,49,33,220,222,34]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends A.ExtHostDebugServiceBase{constructor(s,a,u,l,c,n,r){super(s,a,u,l,n,r),this.Z=c,this.X=new w}J(s,a){switch(s.type){case"server":return new m.SocketDebugAdapter(s);case"pipeServer":return new m.NamedPipeDebugAdapter(s);case"executable":return new m.ExecutableDebugAdapter(s,a.type)}return super.J(s,a)}S(s,a){const u=m.ExecutableDebugAdapter.platformAdapterExecutable(a.getAllExtensionDescriptions(),s.type);if(u)return new v.DebugAdapterExecutable(u.command,u.args,u.options)}K(){return new I.SignService}async $runInTerminal(s,a){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const u=await this.F.getConfigProvider(),l=this.Z.getDefaultShell(!0),c=this.Z.getDefaultShellArgs(!0),n=s.title||k.localize(0,null),r=JSON.stringify({shell:l,shellArgs:c});let f=await this.X.checkout(r,n),E,T=!1;if(f)E=s.cwd;else{const F={shellPath:l,shellArgs:c,cwd:s.cwd,name:n,iconPath:new v.ThemeIcon("debug")};T=!0,f=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(f,r)}f.show(!0);const M=await f.processId;T?await new Promise(F=>setTimeout(F,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?f.sendText("cls"):l.indexOf("bash")>=0?f.sendText("clear"):t.isWindows?f.sendText("cls"):f.sendText("clear"));const K=(0,d.prepareCommand)(l,s.args,!!s.argsCanBeInterpretedByShell,E,s.env);f.sendText(K);const V=this.onDidTerminateDebugSession(F=>{F.id===a&&(this.X.free(f),V.dispose())});return M}else if(s.kind==="external")return p(s,await this.F.getConfigProvider());return super.$runInTerminal(s,a)}};b=qe([We(0,L.IExtHostRpcService),We(1,S.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,h.IExtHostConfiguration),We(4,P.IExtHostTerminalService),We(5,y.IExtHostEditorTabs),We(6,C.IExtHostVariableResolverProvider)],b),e.ExtHostDebugService=b;let g;function p(i,s){if(!g)if(t.isWindows)g=new R.WindowsExternalTerminalService;else if(t.isMacintosh)g=new R.MacExternalTerminalService;else if(t.isLinux)g=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const a=s.getConfiguration("terminal");return g.runInTerminal(i.title,i.cwd,i.args,i.env||{},a.external||{})}class w{constructor(){this.b=new Map}async checkout(s,a){const l=[...this.b.entries()].map(([c,n])=>(0,o.createCancelablePromise)(async r=>{if(c.name!==a||n.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await c.processId))return null;const f=Date.now();return n.lastUsedAt+w.a>f||r.isCancellationRequested||n.config!==s?null:(n.lastUsedAt=f,c)}));return await(0,o.firstParallel)(l,c=>!!c)}insert(s,a){this.b.set(s,{lastUsedAt:Date.now(),config:a})}free(s){const a=this.b.get(s);a&&(a.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}w.a=1e3}),define(ye[293],Ce([1,0,9,2,115,33,58,34,47,41,17,25,76,15,13,71,24,87,49]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let g=class extends v.ExtHostTaskBase{constructor(w,i,s,a,u,l,c,n,r){super(w,i,s,a,u,l,c,n),this.B=s,this.C=r,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(w,i){const s=i;if(!i.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const a=v.TaskHandleDTO.from(s,this.B),u=await this.a.$getTaskExecution(a);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(u,i);return this.a.$executeTask(a).catch(()=>{}),l}else{const a=v.TaskDTO.from(i,w);if(a===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(a.execution)&&await this.x(a,i,!1);const u=await this.y(await this.a.$getTaskExecution(a),i);return this.a.$executeTask(a).catch(()=>{}),u}}u(w,i,s,a){const u=[];if(a)for(const l of a){this.z(l,s),(!l.definition||!w[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const c=v.TaskDTO.from(l,s.extension);c&&(u.push(c),v.CustomExecutionDTO.is(c.execution)&&i.push(this.x(c,l,!0)))}return{tasks:u,extension:s.extension}}async v(w){return w}async F(w){let i=w&&w.length>0?w[0]:void 0;if(!i){const s=t.URI.file((0,h.homedir)());i=new y.WorkspaceFolder({uri:s,name:d.basename(s),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(w,i){const s=t.URI.revive(w),a={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(s),l=await this.b.getWorkspaceFolders2()??[],c=await this.C.getResolver(),n=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const r of i.variables)a.variables[r]=await c.resolveAsync(n,r);if(i.process!==void 0){let r;if(i.process.path!==void 0){r=i.process.path.split(o.delimiter);for(let f=0;f<r.length;f++)r[f]=await c.resolveAsync(n,r[f])}a.process=await k.win32.findExecutable(await c.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await c.resolveAsync(n,i.process.cwd):void 0,r)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(w,i,s){return k.win32.findExecutable(w,i,s)}};g=qe([We(0,L.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,I.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,D.IExtHostTerminalService),We(6,S.ILogService),We(7,m.IExtHostApiDeprecationService),We(8,b.IExtHostVariableResolverProvider)],g),e.ExtHostTask=g}),define(ye[294],Ce([1,0,87,49]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class k extends t.ExtHostVariableResolverProviderService{j(){return(0,o.homedir)()}}e.NodeExtHostVariableResolverProviderService=k}),define(ye[143],Ce([1,0,18,16,21,45,15,9,24,2,31]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(b,g,p,w){this.d=b,this.e=g,this.f=p,this.g=w,this.a=null,this.b=!1,this.c=0}search(b,g){const p=this.d.folderQueries||[],w=new k.CancellationTokenSource;return g.onCancellationRequested(()=>w.cancel()),new Promise((i,s)=>{this.a=new C(b);let a=!1;const u=(l,c)=>{if(!a&&!this.b){const n=this.h(l);m(l)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,a=!0,w.cancel(),l=this.j(l,this.d.maxResults-this.c));const r=this.h(l);this.c+=r,(r>0||!m(l))&&this.a.add(l,c)}};Promise.all(p.map((l,c)=>this.k(l,n=>u(n,c),w.token))).then(l=>{w.dispose(),this.a.flush();const c=l.some(n=>!!n&&!!n.limitHit);i({limitHit:this.b||c,messages:(0,o.flatten)(l.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},l=>{w.dispose();const c=(0,R.toErrorMessage)(l);s(new Error(c))})})}h(b){return m(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}j(b,g){const p=Array.isArray(b.ranges)?b.ranges:[b.ranges],w=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:p.slice(0,g),preview:{matches:w.slice(0,g),text:b.preview.text},uri:b.uri}}async k(b,g,p){const w=new L.QueryGlobTester(this.d,b),i=[],s={report:l=>{if(!this.l(l))return;const c=b.folder.scheme===I.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(l.uri))):void 0,n=y.relativePath(b.folder,l.uri);if(n){const r=w.includedInQuery(n,A.basename(n),c);(0,t.isThenable)(r)?i.push(r.then(f=>{f&&g(l)})):r&&g(l)}}},a=this.n(b),u=await this.e.provideTextSearchResults(v(this.d.contentPattern),a,s,p);return i.length&&await Promise.all(i),u}l(b){if(m(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(b){const g=(0,L.resolvePatternsForProvider)(this.d.includePattern,b.includePattern),p=(0,L.resolvePatternsForProvider)(this.d.excludePattern,b.excludePattern),w={folder:D.URI.from(b.folder),excludes:p,includes:g,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.f.toCanonicalName(b.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=P;function v(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class C{constructor(b){this.e=b,this.b=-1,this.d=null,this.a=new d(512,g=>this.g(g))}add(b,g){this.d&&(this.b!==g||!y.isEqual(this.c,b.uri))&&(this.f(),this.d=null),this.d||(this.b=g,this.d={resource:b.uri,results:[]}),this.d.results.push(S(b))}f(){const b=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,b)}flush(){this.f(),this.a.flush()}g(b){this.e(b)}}e.TextSearchResultsCollector=C;function S(h){return m(h)?{preview:{matches:(0,o.mapArrayOrNot)(h.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:h.preview.text},ranges:(0,o.mapArrayOrNot)(h.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function m(h){return!!h.preview}e.extensionResultIsMatch=m;class d{constructor(b,g){this.g=b,this.h=g,this.c=0,this.d=[],this.e=0}addItem(b,g){!b||this.j(b,g)}addItems(b,g){!b||this.k(b,g)}j(b,g){this.d.push(b),this.e+=g,this.l()}k(b,g){this.d=this.d.concat(b),this.e+=g,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=d,d.a=4e3,d.b=50}),define(ye[79],Ce([1,0,6,5,4,287,17,55,13,2,143]),function(te,e,o,t,k,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let P=class{constructor(m,d,h){this.k=m,this.l=d,this.n=h,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(m){return this.l.transformOutgoingScheme(m)}registerTextSearchProvider(m,d){if(this.g.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this.g.add(m);const h=this.d++;return this.e.set(h,d),this.c.$registerTextSearchProvider(h,this.o(m)),(0,o.toDisposable)(()=>{this.g.delete(m),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(m,d){if(this.i.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this.i.add(m);const h=this.d++;return this.h.set(h,d),this.c.$registerFileSearchProvider(h,this.o(m)),(0,o.toDisposable)(()=>{this.i.delete(m),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(m,d,h,b){const g=v(h),p=this.h.get(m);if(p)return this.j.fileSearch(g,p,w=>{this.c.$handleFileMatch(m,d,w.map(i=>i.resource))},b);throw new Error("unknown provider: "+m)}$clearCache(m){return this.j.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,d,h,b){const g=this.e.get(m);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const p=v(h);return this.q(p,g).search(i=>this.c.$handleTextMatch(m,d,i),b)}$enableExtensionHostSearch(){}q(m,d){return new L.TextSearchManager(m,d,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};P=qe([We(0,I.IExtHostRpcService),We(1,A.IURITransformerService),We(2,y.ILogService)],P),e.ExtHostSearch=P;function v(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(C),extraFileResources:S.extraFileResources&&S.extraFileResources.map(m=>D.URI.revive(m))}}e.reviveQuery=v;function C(S){return{...S,folder:D.URI.revive(S.folder)}}}),define(ye[295],Ce([1,0,88,142,33,139,34,40,58,41,76,78,79,98,54,71,141,72,48,97,95,59,140,13,232,49,96]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p,w,i,s,a,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(l.IExtHostLocalizationService,l.ExtHostLocalizationService,1),(0,o.registerSingleton)(s.ILoggerService,i.ExtHostLoggerService,1),(0,o.registerSingleton)(s.ILogService,a.ExtHostLogService,1),(0,o.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService,1),(0,o.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,o.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration,0),(0,o.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,o.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,o.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,o.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,o.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,0),(0,o.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,o.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,o.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,0),(0,o.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,o.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService,0),(0,o.registerSingleton)(S.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,o.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,o.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,0),(0,o.registerSingleton)(g.IExtHostSecretState,g.ExtHostSecretState,0),(0,o.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry,0),(0,o.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,o.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(ye[99],Ce([1,0,18,13,31,75]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function I(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=I;function A(P,v,C,S){const m=(0,o.mapArrayOrNot)(C,y),d=new k.TextSearchMatch(v,m,S),h=d.preview.matches;return{ranges:(0,o.mapArrayOrNot)(m,D),uri:P,preview:{text:d.preview.text,matches:(0,o.mapArrayOrNot)(h,D)}}}e.createTextSearchResult=A;function y(P){return new k.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function D(P){return new R.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(v,C){this.a=v,this.b=C}appendLine(v){this.b.debug(`${this.a}#search`,v)}};L=qe([We(1,t.ILogService)],L),e.OutputChannel=L}),define(ye[296],Ce([1,0,46,9,83,32,12,8,99,297]),function(te,e,o,t,k,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(g,p,w,i){const s=v(g,p,w,i),a=p.folder.fsPath;return{cmd:o.spawn(L,s.args,{cwd:a}),rgDiskPath:L,siblingClauses:s.siblingClauses,rgArgs:s,cwd:a}}e.spawnRipgrepCmd=P;function v(g,p,w,i){const s=["--files","--hidden","--case-sensitive"];S([p],w,!1).forEach(u=>{const l=(0,y.anchorGlob)(u);if(s.push("-g",l),I.isMacintosh){const c=(0,k.normalizeNFD)(l);c!==l&&s.push("-g",c)}});const a=C([p],i,void 0,!1);return a.globArgs.forEach(u=>{const l=`!${(0,y.anchorGlob)(u)}`;if(s.push("-g",l),I.isMacintosh){const c=(0,k.normalizeNFD)(l);c!==l&&s.push("-g",c)}}),p.disregardIgnoreFiles!==!1?s.push("--no-ignore"):p.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),p.ignoreSymlinks||s.push("--follow"),g.exists&&s.push("--quiet"),s.push("--no-config"),p.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:a.siblingClauses}}function C(g,p,w,i=!0){const s=[];let a={};return g.forEach(u=>{const l=Object.assign({},u.excludePattern||{},p||{}),c=m(l,i?u.folder.fsPath:void 0,w);s.push(...c.globArgs),c.siblingClauses&&(a=Object.assign(a,c.siblingClauses))}),{globArgs:s,siblingClauses:a}}function S(g,p,w=!0){const i=[];return g.forEach(s=>{const a=Object.assign({},p||{},s.includePattern||{}),u=m(a,w?s.folder.fsPath:void 0);i.push(...u.globArgs)}),i}function m(g,p,w){const i=[],s={};return Object.keys(g).forEach(a=>{if(w&&w.has(a)||!a)return;const u=g[a];a=h(p?d(p,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof u=="boolean"&&u?(a.startsWith("\\\\")&&(a+="**"),i.push(b(a))):u&&u.when&&(s[a]=u)}),{globArgs:i,siblingClauses:s}}function d(g,p){return t.isAbsolute(p)?p:t.join(g,p)}e.getAbsoluteGlob=d;function h(g){return g=A.rtrim(g,"\\"),A.rtrim(g,"/")}function b(g){return R.getRoot(g).toLowerCase()==="c:/"?g.replace(/^c:[/\\]/i,"/"):g}e.fixDriveC=b}),define(ye[298],Ce([1,0,46,65,9,299,18,45,38,83,32,12,43,8,11,29,31,296,110]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const g=new Set;process.on("exit",()=>{g.forEach(a=>a())});class p{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&y.parse(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,b.prepareQuery)(this.b).normalizedLowercase),this.u=u.excludePattern&&y.parse(u.excludePattern),this.t=new Map,u.folderQueries.forEach(l=>{const c=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),n=l.folder.fsPath;u.folderQueries.map(r=>r.folder.fsPath).filter(r=>r!==n).forEach(r=>{(0,L.isEqualOrParent)(r,n)&&(c[k.relative(n,r)]=!0)}),this.t.set(n,new i(c,n))})}cancel(){this.l=!0,g.forEach(u=>u())}walk(u,l,c,n,r){if(this.m=v.StopWatch.create(!1),this.l)return r(null,this.j);l.forEach(f=>{const E=k.basename(f.fsPath);this.u&&this.u(f.fsPath,E)||this.J(c,{relativePath:f.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(u,(f,E)=>{this.x(this.y,this,f,c,n,T=>{if(T){const M=(0,A.toErrorMessage)(T);console.error(M),this.q.push(M),E(T,void 0)}else E(null,void 0)})},(f,E)=>{this.m.stop();const T=f?I.coalesce(f)[0]:null;r(T,this.j)})}w(u,l,c){const n=new Array(u.length),r=new Array(u.length);let f=!1,E=0;if(u.length===0)return c(null,[]);u.forEach((T,M)=>{l(T,(K,V)=>{if(K?(f=!0,n[M]=null,r[M]=K):(n[M]=V,r[M]=null),++E===u.length)return c(f?r:null,n)})})}x(u,l,...c){try{u.apply(l,c)}catch(n){c[c.length-1](n)}}y(u,l,c,n){const r=u.folder.fsPath,f=P.isMacintosh,E=()=>F&&F.kill();g.add(E);let T=j=>{g.delete(E),T=()=>{},n(j)},M="";const K=this.D(),V=(0,h.spawnRipgrepCmd)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),F=V.cmd,U=!Object.keys(V.siblingClauses).length,N=V.rgArgs.args.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");let B=`${V.rgDiskPath} ${N}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),c({message:B}),this.s=0,this.z(F,"utf8",c,(j,z,ne)=>{if(j){T(j);return}if(this.j){T();return}const Y=(M+(f?D.normalizeNFC(z||""):z)).split(`
`);if(ne){const J=Y.length;Y[J-1]=Y[J-1].trim(),Y[J-1]||Y.pop()}else M=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){T(new Error("Splitting up files failed"));return}if(this.s+=Y.length,U){for(const J of Y)if(this.J(l,{base:r,relativePath:J,searchPath:this.N(u,J)}),this.j){E();break}(ne||this.j)&&T();return}this.G(u,K,r,Y,l),ne&&(this.H(K,r,l),T())})}spawnFindCmd(u){const l=this.t.get(u.folder.fsPath),c=l.getBasenameTerms(),n=l.getPathTerms(),r=["-L","."];if(c.length||n.length){r.push("-not","(","(");for(const f of c)r.push("-name",f),r.push("-o");for(const f of n)r.push("-path",f),r.push("-o");r.pop(),r.push(")","-prune",")")}return r.push("-type","f"),o.spawn("find",r,{cwd:u.folder.fsPath})}readStdout(u,l,c){let n="";this.z(u,l,()=>{},(r,f,E)=>{if(r){c(r);return}n+=f,E&&c(null,n)})}z(u,l,c,n){let r=(T,M,K)=>{(T||K)&&(r=()=>{},this.r?.stop()),n(T,M,K)},f=!1;u.stdout?(this.A(u.stdout,l,r),u.stdout.once("data",()=>f=!0)):c({message:"stdout is null"});let E;u.stderr?E=this.B(u.stderr):c({message:"stderr is null"}),u.on("error",T=>{r(T)}),u.on("close",T=>{let M;!f&&(M=this.C(E,l))&&s(M)?r(new Error(`command failed with error code ${T}: ${this.C(E,l)}`)):(this.g&&T===0&&(this.j=!0),r(null,"",!0))})}A(u,l,c){const n=new R.StringDecoder(l);return u.on("data",r=>{c(null,n.write(r))}),n}B(u){const l=[];return u.on("data",c=>{l.push(c)}),l}C(u,l){const c=new R.StringDecoder(l);return u.map(n=>c.write(n)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:l},c,n,r){n.indexOf(this.b)!==-1&&this.J(r,{base:c,relativePath:this.b,searchPath:this.N(u,this.b)});const f=E=>{const T=k.basename(E),M=k.dirname(E);let K=l[M];K||(K=l[M]=[],f(M)),K.push({base:c,relativePath:E,basename:T,searchPath:this.N(u,E)})};n.forEach(f)}H({rootEntries:u,pathToEntries:l},c,n){const r=this,f=this.t.get(c),E=this.b;function T(M){r.o++;const K=(0,d.hasSiblingFn)(()=>M.map(V=>V.basename));for(let V=0,F=M.length;V<F;V++){const U=M[V],{relativePath:N,basename:B}=U;if(f.test(N,B,E!==B?K:void 0))continue;const j=l[N];if(j)T(j);else{if(r.p++,N===E)continue;r.J(n,U)}if(r.j)break}}T(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,l,c,n,r){const f=u.folder,E=(0,d.hasSiblingFn)(()=>c);this.w(c,(T,M)=>{if(this.l||this.j)return M(null);const K=l?[l,T].join(k.sep):T;if(this.t.get(u.folder.fsPath).test(K,T,this.a.filePattern!==T?E:void 0))return M(null);const V=[f.fsPath,K].join(k.sep);t.lstat(V,(F,U)=>{if(F||this.l||this.j)return M(null);this.L(V,U,(N,B)=>N||this.l||this.j?M(null):B.isDirectory()?(this.o++,this.M(V,U,(j,z)=>j||this.l||this.j||(z=z||"",this.v[z])?M(null):(this.v[z]=!0,m.Promises.readdir(V).then(ne=>{if(this.l||this.j)return M(null);this.I(u,K,ne,n,_=>M(_||null))},ne=>{M(null)})))):(this.p++,K===this.b||this.h&&S.isNumber(B.size)&&B.size>this.h||this.J(n,{base:f.fsPath,relativePath:K,searchPath:this.N(u,K)}),M(null,void 0)))})},T=>{const M=T&&I.coalesce(T);return r(M&&M.length>0?M[0]:void 0)})}J(u,l){this.K(l)&&(!this.d||this.d(l.relativePath,k.basename(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(l))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.isFilePatternMatch)(u,this.c)}return!0}L(u,l,c){return l.isSymbolicLink()?t.stat(u,c):c(null,l)}M(u,l,c){return l.isSymbolicLink()?t.realpath(u,(n,r)=>n?c(n):c(null,r)):c(null,u)}N(u,l){return u.folderName?k.join(u.folderName,l):l}}e.FileWalker=p;class w{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new p(u)}search(u,l,c){this.c.walk(this.a,this.b,u,l,(n,r)=>{c(n,{limitHit:r,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=w;class i{constructor(u,l){this.expression=u,this.c=l,this.d(u)}d(u){let l,c;Object.keys(u).filter(n=>u[n]).forEach(n=>{k.isAbsolute(n)?(l=l||y.getEmptyExpression(),l[n]=u[n]):(c=c||y.getEmptyExpression(),c[n]=u[n])}),this.a=l&&y.parse(l,{trimForExclusions:!0}),this.b=c&&y.parse(c,{trimForExclusions:!0})}test(u,l,c){return this.b&&this.b(u,l,c)||this.a&&this.a(k.join(this.c,u),l,c)}getBasenameTerms(){const u=[];return this.a&&u.push(...y.getBasenameTerms(this.a)),this.b&&u.push(...y.getBasenameTerms(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...y.getPathTerms(this.a)),this.b&&u.push(...y.getPathTerms(this.b)),u}}function s(a){const u=a.trim().split(`
`),l=u[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return C.uppercaseFirstLetter(u[u.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ye[300],Ce([1,0,102,22]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===a)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,I=512,A=512*8,y=512*128;var D;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(u,l){super(u),this.decodeStreamErrorKind=l}}e.DecodeStreamError=L;class P{static async create(u){let l;if(u!==e.UTF8)l=(await new Promise((n,r)=>{te(["@vscode/iconv-lite-umd"],n,r)})).getDecoder(m(u));else{const c=new TextDecoder;l={write(n){return c.decode(n,{stream:!0})},end(){return c.decode()}}}return new P(l)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function v(a,u){const l=u.minBytesRequiredForDetection??u.guessEncoding?A:I;return new Promise((c,n)=>{const r=(0,o.newWriteableStream)(V=>V.join("")),f=[];let E=0,T,M;const K=async()=>{try{const V=await s({buffer:t.VSBuffer.concat(f),bytesRead:E},u.guessEncoding);if(V.seemsBinary&&u.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);V.encoding=await u.overwriteEncoding(V.encoding),T=await P.create(V.encoding);const F=T.write(t.VSBuffer.concat(f).buffer);r.write(F),f.length=0,E=0,c({stream:r,detected:V})}catch(V){M?.dispose(),r.destroy(),n(V)}};M=(0,o.listenStream)(a,{onData:async V=>{T?r.write(T.write(V.buffer)):(f.push(V),E+=V.byteLength,E>=l&&(a.pause(),await K(),setTimeout(()=>a.resume())))},onError:V=>r.error(V),onEnd:async()=>{T||await K(),r.end(T?.end())}})})}e.toDecodeStream=v;async function C(a,u,l){const n=(await new Promise((E,T)=>{te(["@vscode/iconv-lite-umd"],E,T)})).getEncoder(m(u),l);let r=!1,f=!1;return{read(){if(f)return null;const E=a.read();if(typeof E!="string"){if(f=!0,!r&&l?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const T=n.end();return T&&T.length>0?(r=!0,t.VSBuffer.wrap(T)):null}return r=!0,t.VSBuffer.wrap(n.write(E))}}}e.toEncodeReadable=C;async function S(a){return(await new Promise((l,c)=>{te(["@vscode/iconv-lite-umd"],l,c)})).encodingExists(m(a))}e.encodingExists=S;function m(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=m;function d(a,u){if(!a||u<e.UTF16be_BOM.length)return null;const l=a.readUInt8(0),c=a.readUInt8(1);if(l===e.UTF16be_BOM[0]&&c===e.UTF16be_BOM[1])return e.UTF16be;if(l===e.UTF16le_BOM[0]&&c===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const n=a.readUInt8(2);return l===e.UTF8_BOM[0]&&c===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const h=["ascii","utf-16","utf-32"];async function b(a){const u=await new Promise((f,E)=>{te(["jschardet"],f,E)}),l=a.slice(0,y),c=w(l.buffer),n=u.detect(c);if(!n||!n.encoding)return null;const r=n.encoding.toLowerCase();return 0<=h.indexOf(r)?null:p(n.encoding)}const g={ibm866:"cp866",big5:"cp950"};function p(a){const u=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[u]||u}function w(a){let u="";for(let l=0;l<a.length;l++)u+=String.fromCharCode(a[l]);return u}function i(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=a.match(/windows(\d+)/);return u?"windows-"+u[1]:a}}}e.toCanonicalName=i;function s({buffer:a,bytesRead:u},l){let c=d(a,u),n=!1;if(c!==e.UTF16be&&c!==e.UTF16le&&a){let r=!0,f=!0,E=!1;for(let T=0;T<u&&T<R;T++){const M=T%2===1,K=a.readUInt8(T)===0;if(K&&(E=!0),r&&(M&&!K||!M&&K)&&(r=!1),f&&(M&&K||!M&&!K)&&(f=!1),K&&!r&&!f)break}E&&(r?c=e.UTF16le:f?c=e.UTF16be:n=!0)}return l&&!n&&!c&&a?b(a.slice(0,u)).then(r=>({seemsBinary:!1,encoding:r})):{seemsBinary:n,encoding:c}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],Ce([1,0,300,29,143]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends k.TextSearchManager{constructor(A,y,D=t,L="searchProcess"){super(A,y,{readdir:P=>D.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,o.toCanonicalName)(P)},L)}}e.NativeTextSearchManager=R}),define(ye[301],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(k){if(k&&this.a.has(k)){const R=this.a.get(k);return this.a.delete(k),R}}addDragOperationTransfer(k,R){this.a.set(k,R)}getRenderedTreeElement(k){if(this.b.has(k))return this.b.get(k)}addRenderedTreeItemElement(k,R){this.b.set(k,R)}removeRenderedTreeItemElement(k){this.b.has(k)&&this.b.delete(k)}}e.TreeviewsService=o}),define(ye[302],Ce([1,0,180,7,24,2,3,6,16,7,11,18,14,21,301,27]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(g,p){if((0,L.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let w;return Array.isArray(g.highlights)&&(w=g.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),w=w.length?w:void 0),{label:g.label,highlights:w}}}class h{constructor(p,w,i){this.d=p,this.e=w,this.f=i,this.a=new Map,this.b=new S.TreeviewsService;function s(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:a=>s(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(u=>s(u)?this.i(u):u):a})}registerTreeDataProvider(p,w,i){const s=this.createTreeView(p,{treeDataProvider:w},i);return{dispose:()=>s.dispose()}}createTreeView(p,w,i){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=w.dragAndDropController?.dropMimeTypes??[],a=w.dragAndDropController?.dragMimeTypes??[],u=!!w.dragAndDropController?.handleDrag,l=!!w.dragAndDropController?.handleDrop,c=this.h(p,w,i),n=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:s,dragMimeTypes:a,hasHandleDrag:u,hasHandleDrop:l});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,m.checkProposedApiEnabled)(i,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(r){c.message=r},get title(){return c.title},set title(r){c.title=r},get description(){return c.description},set description(r){c.description=r},get badge(){return c.badge},set badge(r){r!==void 0&&D.ViewBadge.isViewBadge(r)?c.badge={value:Math.floor(Math.abs(r.value)),tooltip:r.tooltip}:r===void 0&&(c.badge=void 0)},reveal:(r,f)=>c.reveal(r,f),dispose:async()=>{await n,this.a.delete(p),c.dispose()}}}$getChildren(p,w){const i=this.a.get(p);return i?i.getChildren(w):Promise.reject(new Error((0,o.localize)(0,null,p)))}async $handleDrop(p,w,i,s,a,u,l,c){const n=this.a.get(p);if(!n)return Promise.reject(new Error((0,o.localize)(1,null,p)));const r=v.DataTransfer.toDataTransfer(i,async f=>(await this.d.$resolveDropFileData(p,w,f)).buffer);return l===p&&c&&await this.g(r,n,c,a,u),n.onDrop(r,s,a)}async g(p,w,i,s,a){const u=this.b.removeDragOperationTransfer(a);if(u)(await u)?.forEach((l,c)=>{l&&p.set(c,l)});else if(a&&w.handleDrag){const l=w.handleDrag(i,p,s);this.b.addDragOperationTransfer(a,l),await l}return p}async $handleDrag(p,w,i,s){const a=this.a.get(p);if(!a)return Promise.reject(new Error((0,o.localize)(2,null,p)));const u=await this.g(new t.DataTransfer,a,w,s,i);if(!!u)return v.DataTransfer.toDataTransferDTO(u)}async $hasResolve(p){const w=this.a.get(p);if(!w)throw new Error((0,o.localize)(3,null,p));return w.hasResolve}$resolve(p,w,i){const s=this.a.get(p);if(!s)throw new Error((0,o.localize)(4,null,p));return s.resolveTreeItem(w,i)}$setExpanded(p,w,i){const s=this.a.get(p);if(!s)throw new Error((0,o.localize)(5,null,p));s.setExpanded(w,i)}$setSelection(p,w){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(6,null,p));i.setSelection(w)}$setFocus(p,w){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(7,null,p));i.setFocus(w)}$setVisible(p,w){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(8,null,p));i.setVisible(w)}$changeCheckboxState(p,w){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(9,null,p));i.setCheckboxState(w)}h(p,w,i){const s=new b(p,w,this.d,this.e.converter,this.f,i);return this.a.set(p,s),s}i(p){const w=this.a.get(p.$treeViewId);return w&&"$treeItemHandle"in p?w.getExtensionElement(p.$treeItemHandle):w&&"$focusedTreeItem"in p&&p.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=h;class b extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,L.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,w,i,s,a,u){if(super(),this.C=p,this.D=i,this.F=s,this.G=a,this.H=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new I.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new I.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new I.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new I.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new I.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new I.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new C.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const r of u.contributes.views[n])r.id===p&&(this.J=r.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let l,c;this.B(I.Event.debounce(this.w.event,(n,r)=>(n||(n={message:!1,elements:[]}),r.element!==!1&&(l||(l=new Promise(f=>c=f),this.y=this.y.then(()=>l)),Array.isArray(r.element)?n.elements.push(...r.element):n.elements.push(r.element)),r.message&&(n.message=!0),n),200,!0)(({message:n,elements:r})=>{r.length&&(this.z=this.z.then(()=>{const f=c;return l=null,this.U(r).then(()=>f())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const w=p?this.getExtensionElement(p):void 0;if(p&&!w)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let i=this.Q(p);return i||(i=await this.R(w)),i?i.map(s=>s.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,w){w=w||{select:!0,focus:!1};const i=(0,L.isUndefinedOrNull)(w.select)?!0:w.select,s=(0,L.isUndefinedOrNull)(w.focus)?!1:w.focus,a=(0,L.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(u=>this.P(p,u[u.length-1]).then(l=>this.D.$reveal(this.C,{item:l.item,parentChain:u.map(c=>c.item)},{select:i,focus:s,expand:a})),u=>this.G.error(u)):this.D.$reveal(this.C,void 0,{select:i,focus:s,expand:a})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=v.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,w){const i=this.getExtensionElement(p);i&&(w?this.r.fire(Object.freeze({element:i})):this.s.fire(Object.freeze({element:i})))}setSelection(p){(0,P.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const w=(await Promise.all(p.map(async i=>{const s=this.getExtensionElement(i.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:i.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);w.forEach(i=>{i.treeItem.checkboxState=i.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(i=>[i.extensionItem,i.newState])})}async handleDrag(p,w,i){const s=[];for(const a of p){const u=this.getExtensionElement(a);u&&s.push(u)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,w,i),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,w,i){const s=w?this.getExtensionElement(w):void 0;if(!(!s&&w||!this.g?.handleDrop))return(0,y.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,p,i):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,w){if(!this.f.resolveTreeItem)return;const i=this.i.get(p);if(i){const s=this.j.get(i);if(s){const a=await this.f.resolveTreeItem(s.extensionItem,i,w)??s.extensionItem;return this.db(a),s.item.tooltip=this.ab(a.tooltip),s.item.command=this.bb(s.disposableStore,a.command),s.item}}}N(p){return this.O(p).then(w=>w?this.N(w).then(i=>this.P(w,i[i.length-1]).then(s=>(i.push(s),i))):Promise.resolve([]))}O(p){const w=this.j.get(p);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,y.asPromise)(()=>this.f.getParent(p))}P(p,w){const i=this.j.get(p);return i?Promise.resolve(i):(0,y.asPromise)(()=>this.f.getTreeItem(p)).then(s=>this.gb(p,s,w,!0)).then(s=>this.getChildren(w?w.item.handle:void 0).then(()=>{const a=this.getExtensionElement(s);if(a){const u=this.j.get(a);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(p){if(p){let w;if(typeof p=="string"){const i=this.getExtensionElement(p);w=i?this.j.get(i):void 0}else w=p;return w&&w.children||void 0}return this.h}async R(p){this.nb(p);const w=new C.CancellationTokenSource(this.S.token);try{const i=p?this.j.get(p):void 0,s=await this.f.getChildren(p);if(w.token.isCancellationRequested)return;const a=await Promise.all((0,P.coalesce)(s||[]).map(async u=>{const l=await this.f.getTreeItem(u);return l&&!w.token.isCancellationRequested?this.Z(u,l,i):null}));return w.token.isCancellationRequested?void 0:(0,P.coalesce)(a)}finally{w.dispose()}}U(p){if(p.some(i=>!i))return this.S.dispose(!0),this.S=new C.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const i=this.W(p);if(i.length)return this.X(i)}return Promise.resolve(void 0)}W(p){const w=new Set,i=p.map(a=>this.j.get(a));for(const a of i)if(a&&!w.has(a.item.handle)){let u=a;for(;u&&u.parent&&i.findIndex(l=>u&&u.parent&&l&&l.item.handle===u.parent.item.handle)===-1;){const l=this.i.get(u.parent.item.handle);u=l?this.j.get(l):void 0}u&&!u.parent&&w.add(a.item.handle)}const s=[];return w.forEach(a=>{const u=this.i.get(a);if(u){const l=this.j.get(u);l&&(!l.parent||!w.has(l.parent.item.handle))&&s.push(a)}}),s}X(p){const w={};return Promise.all(p.map(i=>this.Y(i).then(s=>{s&&(w[i]=s.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(p){const w=this.getExtensionElement(p);if(w){const i=this.j.get(w);if(i)return this.nb(w),(0,y.asPromise)(()=>this.f.getTreeItem(w)).then(s=>{if(s){const a=this.eb(w,s,i.parent);return this.lb(w,a,i,i.parent),i.dispose(),a}return null})}return Promise.resolve(null)}Z(p,w,i){const s=this.eb(p,w,i);if(w.id&&this.i.has(s.item.handle))throw new Error((0,o.localize)(10,null,w.id));return this.kb(p,s),this.mb(s,i),s}ab(p){return D.MarkdownString.isMarkdownString(p)?v.MarkdownString.from(p):p}bb(p,w){return w?{...this.F.toInternal(w,p),originalId:w.command}:void 0}cb(p){if(!p.checkboxState)return;let w,i;return typeof p.checkboxState=="number"?w=p.checkboxState:(w=p.checkboxState.state,i=p.checkboxState.tooltip),{isChecked:w===D.TreeItemCheckboxState.Checked,tooltip:i}}db(p){if(!D.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,w,i){this.db(w);const s=new A.DisposableStore,a=this.gb(p,w,i),u=this.hb(w);return{item:{handle:a,parentHandle:i?i.item.handle:void 0,label:d(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(s,w.command),contextValue:w.contextValue,icon:u,iconDark:this.ib(w)||u,themeIcon:this.fb(w),collapsibleState:(0,L.isUndefinedOrNull)(w.collapsibleState)?D.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:i,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(p){return p.iconPath instanceof D.ThemeIcon?p.iconPath:void 0}gb(p,{id:w,label:i,resourceUri:s},a,u){if(w)return`${b.b}/${w}`;const l=d(i,this.H),c=a?a.item.handle:b.a;let n=l?l.label:s?(0,k.basename)(s):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const r=this.j.has(p)?this.j.get(p).item.handle:void 0,f=this.Q(a)||[];let E,T=0;do{if(E=`${c}/${T}:${n}`,u||!this.i.has(E)||r===E)break;T++}while(T<=f.length);return E}hb(p){if(p.iconPath&&!(p.iconPath instanceof D.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof D.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return R.URI.isUri(p)?p:R.URI.file(p)}kb(p,w){this.i.set(w.item.handle,p),this.j.set(p,w)}lb(p,w,i,s){this.i.delete(w.item.handle),this.j.delete(p),w.item.handle!==i.item.handle&&this.i.delete(i.item.handle),this.kb(p,w);const a=this.Q(s)||[],u=a.filter(l=>l.item.handle===i.item.handle)[0];u&&a.splice(a.indexOf(u),1,w)}mb(p,w){w?(w.children||(w.children=[]),w.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const w=this.j.get(p);if(w){if(w.children)for(const i of w.children){const s=this.i.get(i.item.handle);s&&this.ob(s)}w.children=void 0}}else this.pb()}ob(p){const w=this.j.get(p);if(w){if(w.children)for(const i of w.children){const s=this.i.get(i.item.handle);s&&this.ob(s)}this.j.delete(p),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[303],Ce([1,0,21,10,3,37,2,120,106,152,163,39,5,94,246,245,40,247,34,249,250,251,234,252,58,42,253,254,257,258,259,142,237,264,265,266,98,41,268,302,14,7,68,271,74,141,33,225,256,67,139,76,78,79,13,55,17,25,260,233,54,71,243,269,73,72,274,272,273,244,48,267,270,97,59,95,261,75,262,15,124,236,214,255,6,27,218,96,211,263]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p,w,i,s,a,u,l,c,n,r,f,E,T,M,K,V,F,U,N,B,j,z,ne,_,Y,J,ee,ge,q,G,le,be,ve,Pe,Ne,se,ue,de,Z,ae,ie,O,W,X,Q,he,we,Ae,pe,De,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe,$,ce,Ie,Le,Be,xe,Ze,gt,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(de.IExtHostInitDataService),kt=ot.get(ke.IExtHostFileSystemInfo),Tt=ot.get(he.IExtHostConsumerFileSystem),Nt=ot.get(u.IExtHostExtensionService),pt=ot.get(ee.IExtHostWorkspace),Dt=ot.get(nt.IExtHostTelemetry),zt=ot.get(b.IExtHostConfiguration),Ft=ot.get(se.IURITransformerService),Xe=ot.get(ue.IExtHostRpcService),Mt=ot.get(F.IExtHostStorage),Ut=ot.get(Q.IExtensionStoragePaths),Bt=ot.get(Ne.ILoggerService),wt=ot.get(Ne.ILogService),Pt=ot.get(ie.IExtHostTunnelService),Re=ot.get(O.IExtHostApiDeprecationService),Oe=ot.get(J.IExtHostWindow),Se=ot.get(et.IExtHostSecretState),re=ot.get(_e.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,kt),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Bt),Xe.set(v.ExtHostContext.ExtHostWorkspace,pt),Xe.set(v.ExtHostContext.ExtHostConfiguration,zt),Xe.set(v.ExtHostContext.ExtHostExtensionService,Nt),Xe.set(v.ExtHostContext.ExtHostStorage,Mt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Pt),Xe.set(v.ExtHostContext.ExtHostWindow,Oe),Xe.set(v.ExtHostContext.ExtHostSecretState,Se),Xe.set(v.ExtHostContext.ExtHostTelemetry,Dt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,re);const Fe=Xe.set(v.ExtHostContext.ExtHostDecorations,ot.get(le.IExtHostDecorations)),$e=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(a.IExtHostDocumentsAndEditors)),Qe=Xe.set(v.ExtHostContext.ExtHostCommands,ot.get(d.IExtHostCommands)),Ve=Xe.set(v.ExtHostContext.ExtHostTerminalService,ot.get(U.IExtHostTerminalService)),tt=Xe.set(v.ExtHostContext.ExtHostDebugService,ot.get(ve.IExtHostDebugService)),St=Xe.set(v.ExtHostContext.ExtHostSearch,ot.get(Pe.IExtHostSearch)),Et=Xe.set(v.ExtHostContext.ExtHostTask,ot.get(be.IExtHostTask)),Lt=Xe.set(v.ExtHostContext.ExtHostOutputService,ot.get(E.IExtHostOutputService)),vt=Xe.set(v.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),It=Xe.set(v.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(Xe)),ft=Xe.set(v.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Xe,$e)),Gt=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Xe,$e,wt)),jt=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(wt,ft,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),yt=Xe.set(v.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(Xe,Qe,$e,ft)),_t=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new ce.ExtHostNotebookDocuments(yt)),sn=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(wt,yt)),en=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,rt,yt,Qe,wt)),vn=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(Xe,yt)),At=Xe.set(v.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Xe,$e)),on=Xe.set(v.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),Qe,wt)),Vt=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),At,rt.remote)),tn=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(Xe,wt,kt,$e)),an=Xe.set(v.ExtHostContext.ExtHostLanguages,new r.ExtHostLanguages(Xe,ft,Qe.converter,Ft)),ut=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Ft,ft,Qe,tn,wt,Re,Dt)),On=Xe.set(v.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Xe,ut)),Qt=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(Xe,wt,$e)),Wt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Xe,pt,Qe)),cn=Xe.set(v.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(Xe,Qe,wt)),En=Xe.set(v.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Xe,Qe,ft)),ln=Xe.set(v.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Sn=Xe.set(v.ExtHostContext.ExtHosLabelService,new q.ExtHostLabelService(Xe)),un=Xe.set(v.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Xe)),nn=Xe.set(v.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(Xe)),yn=Xe.set(v.ExtHostContext.ExtHostTimeline,new X.ExtHostTimeline(Xe,Qe)),rn=Xe.set(v.ExtHostContext.ExtHostWebviews,new Y.ExtHostWebviews(Xe,rt.remote,pt,wt,Re)),Cn=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(Xe,rn,pt)),Dn=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(Xe,ft,Ut,rn,Cn)),In=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Xe,rn)),Yt=Xe.set(v.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Xe,Qe,$e)),kn=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),zn=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,yt,$e,Qe,wt));const Tn=Object.values(v.ExtHostContext);Xe.assertRegistered(Tn);const Pn=new De.ExtHostBulkEdits(Xe,$e),$n=new m.ExtHostClipboard(Xe),An=new f.ExtHostMessageService(Xe,wt),Nn=new p.ExtHostDialogs(Xe),Fn=new V.ExtHostStatusBar(Xe,Qe.converter);return S.ExtHostApiCommands.register(Qe),function(He,Kt,dn){const bt=function(){let me=!He.isUnderDevelopment;function Ee(){me||(wt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function ze(at){if(Array.isArray(at))at.forEach(ze);else if(typeof at=="string")Ee();else{const Ct=at;typeof Ct.scheme>"u"&&Ee(),typeof Ct.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),Wn={getSession(me,Ee,ze){return nn.getSession(He,me,Ee,ze)},async hasSession(me,Ee){return(0,Be.checkProposedApiEnabled)(He,"authSession"),!!await nn.getSession(He,me,Ee,{silent:!0})},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(me,Ee,ze,at){return nn.registerAuthenticationProvider(me,Ee,ze,at)}},Hn={registerCommand(me,Ee,ze){return Qe.registerCommand(!0,me,Ee,ze,void 0,He)},registerTextEditorCommand(me,Ee,ze){return Qe.registerCommand(!0,me,(...at)=>{const Ct=At.getActiveTextEditor();if(!Ct){wt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Ct.edit(Rt=>{Ee.apply(ze,[Ct,Rt,...at])}).then(Rt=>{Rt||wt.warn("Edits from command "+me+" were not applied.")},Rt=>{wt.warn("An error occurred while running command "+me,Rt)})},void 0,void 0,He)},registerDiffInformationCommand:(me,Ee,ze)=>((0,Be.checkProposedApiEnabled)(He,"diffCommand"),Qe.registerCommand(!0,me,async(...at)=>{const Ct=$e.activeEditor(!0);if(!Ct){wt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Ct.id);Ee.apply(ze,[Rt,...at])},void 0,void 0,He)),executeCommand(me,...Ee){return Qe.executeCommand(me,...Ee)},getCommands(me=!1){return Qe.getCommands(me)}},Mn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(He,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Be.checkProposedApiEnabled)(He,"telemetryLogger"),Dt.instantiateLogger(He,me)},openExternal(me,Ee){return Oe.openUri(me,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===rt.environment.appUriScheme)return It.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!rt.remote.authority})}catch(Ee){if((0,oe.matchesScheme)(me,it.Schemas.http)||(0,oe.matchesScheme)(me,it.Schemas.https))return me;throw Ee}},get remoteName(){return(0,G.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(He,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return wt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Mn);const hn={createTestController(me,Ee,ze){return Yt.createTestController(me,Ee,ze)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.createTestObserver()},runTests(me){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.runTests(me)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.results}},fn=rt.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,jn={getExtension(me,Ee){(0,Be.isProposedApiEnabled)(He,"extensionsAny")||(Ee=!1);const ze=Kt.mine.getExtensionDescription(me);if(ze)return new u.Extension(Nt,He.identifier,ze,fn,!1);if(Ee){const at=Kt.all.getExtensionDescription(me);if(at)return new u.Extension(Nt,He.identifier,at,fn,!0)}},get all(){const me=[];for(const Ee of Kt.mine.getAllExtensionDescriptions())me.push(new u.Extension(Nt,He.identifier,Ee,fn,!1));return me},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(He,"extensionsAny");const me=new Be.ExtensionIdentifierSet(Kt.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of Kt.all.getAllExtensionDescriptions()){const at=!me.has(ze.identifier);Ee.push(new u.Extension(Nt,He.identifier,ze,fn,at))}return Ee},get onDidChange(){return(0,Be.isProposedApiEnabled)(He,"extensionsAny")?k.Event.any(Kt.mine.onDidChange,Kt.all.onDidChange):Kt.mine.onDidChange}},Vn={createDiagnosticCollection(me){return tn.createDiagnosticCollection(He.identifier,me)},get onDidChangeDiagnostics(){return tn.onDidChangeDiagnostics},getDiagnostics:me=>tn.getDiagnostics(me),getLanguages(){return an.getLanguages()},setTextDocumentLanguage(me,Ee){return an.changeLanguage(me.uri,Ee)},match(me,Ee){const ze=ft.getDocumentData(Ee.uri)?.notebook;return(0,L.score)(j.LanguageSelector.from(me),Ee.uri,Ee.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(me,Ee,ze){return ut.registerCodeActionProvider(He,bt(me),Ee,ze)},registerDocumentPasteEditProvider(me,Ee,ze){return(0,Be.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,bt(me),Ee,ze)},registerCodeLensProvider(me,Ee){return ut.registerCodeLensProvider(He,bt(me),Ee)},registerDefinitionProvider(me,Ee){return ut.registerDefinitionProvider(He,bt(me),Ee)},registerDeclarationProvider(me,Ee){return ut.registerDeclarationProvider(He,bt(me),Ee)},registerImplementationProvider(me,Ee){return ut.registerImplementationProvider(He,bt(me),Ee)},registerTypeDefinitionProvider(me,Ee){return ut.registerTypeDefinitionProvider(He,bt(me),Ee)},registerHoverProvider(me,Ee){return ut.registerHoverProvider(He,bt(me),Ee,He.identifier)},registerEvaluatableExpressionProvider(me,Ee){return ut.registerEvaluatableExpressionProvider(He,bt(me),Ee,He.identifier)},registerInlineValuesProvider(me,Ee){return ut.registerInlineValuesProvider(He,bt(me),Ee,He.identifier)},registerDocumentHighlightProvider(me,Ee){return ut.registerDocumentHighlightProvider(He,bt(me),Ee)},registerLinkedEditingRangeProvider(me,Ee){return ut.registerLinkedEditingRangeProvider(He,bt(me),Ee)},registerReferenceProvider(me,Ee){return ut.registerReferenceProvider(He,bt(me),Ee)},registerRenameProvider(me,Ee){return ut.registerRenameProvider(He,bt(me),Ee)},registerDocumentSymbolProvider(me,Ee,ze){return ut.registerDocumentSymbolProvider(He,bt(me),Ee,ze)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(He,me)},registerDocumentFormattingEditProvider(me,Ee){return ut.registerDocumentFormattingEditProvider(He,bt(me),Ee)},registerDocumentRangeFormattingEditProvider(me,Ee){return ut.registerDocumentRangeFormattingEditProvider(He,bt(me),Ee)},registerOnTypeFormattingEditProvider(me,Ee,ze,...at){return ut.registerOnTypeFormattingEditProvider(He,bt(me),Ee,[ze].concat(at))},registerDocumentSemanticTokensProvider(me,Ee,ze){return ut.registerDocumentSemanticTokensProvider(He,bt(me),Ee,ze)},registerDocumentRangeSemanticTokensProvider(me,Ee,ze){return ut.registerDocumentRangeSemanticTokensProvider(He,bt(me),Ee,ze)},registerSignatureHelpProvider(me,Ee,ze,...at){return typeof ze=="object"?ut.registerSignatureHelpProvider(He,bt(me),Ee,ze):ut.registerSignatureHelpProvider(He,bt(me),Ee,typeof ze>"u"?[]:[ze,...at])},registerCompletionItemProvider(me,Ee,...ze){return ut.registerCompletionItemProvider(He,bt(me),Ee,ze)},registerInlineCompletionItemProvider(me,Ee){return Ee.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,bt(me),Ee)},registerDocumentLinkProvider(me,Ee){return ut.registerDocumentLinkProvider(He,bt(me),Ee)},registerColorProvider(me,Ee){return ut.registerColorProvider(He,bt(me),Ee)},registerFoldingRangeProvider(me,Ee){return ut.registerFoldingRangeProvider(He,bt(me),Ee)},registerSelectionRangeProvider(me,Ee){return ut.registerSelectionRangeProvider(He,me,Ee)},registerCallHierarchyProvider(me,Ee){return ut.registerCallHierarchyProvider(He,me,Ee)},registerTypeHierarchyProvider(me,Ee){return ut.registerTypeHierarchyProvider(He,me,Ee)},setLanguageConfiguration:(me,Ee)=>ut.setLanguageConfiguration(He,me,Ee),getTokenInformationAtPosition(me,Ee){return(0,Be.checkProposedApiEnabled)(He,"tokenInformation"),an.tokenAtPosition(me,Ee)},registerInlayHintsProvider(me,Ee){return ut.registerInlayHintsProvider(He,me,Ee)},createLanguageStatusItem(me,Ee){return an.createLanguageStatusItem(He,me,Ee)},registerDocumentDropEditProvider(me,Ee){return ut.registerDocumentOnDropEditProvider(He,me,Ee)}},qn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(me,Ee,ze){const at=await(I.URI.isUri(me)?Promise.resolve(mn.openTextDocument(me)):Promise.resolve(me));return At.showTextDocument(at,Ee,ze)},createTextEditorDecorationType(me){return At.createTextEditorDecorationType(He,me)},onDidChangeActiveTextEditor(me,Ee,ze){return At.onDidChangeActiveTextEditor(me,Ee,ze)},onDidChangeVisibleTextEditors(me,Ee,ze){return At.onDidChangeVisibleTextEditors(me,Ee,ze)},onDidChangeTextEditorSelection(me,Ee,ze){return At.onDidChangeTextEditorSelection(me,Ee,ze)},onDidChangeTextEditorOptions(me,Ee,ze){return At.onDidChangeTextEditorOptions(me,Ee,ze)},onDidChangeTextEditorVisibleRanges(me,Ee,ze){return At.onDidChangeTextEditorVisibleRanges(me,Ee,ze)},onDidChangeTextEditorViewColumn(me,Ee,ze){return At.onDidChangeTextEditorViewColumn(me,Ee,ze)},onDidCloseTerminal(me,Ee,ze){return Ve.onDidCloseTerminal(me,Ee,ze)},onDidOpenTerminal(me,Ee,ze){return Ve.onDidOpenTerminal(me,Ee,ze)},onDidChangeActiveTerminal(me,Ee,ze){return Ve.onDidChangeActiveTerminal(me,Ee,ze)},onDidChangeTerminalDimensions(me,Ee,ze){return(0,Be.checkProposedApiEnabled)(He,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(me,Ee,ze)},onDidChangeTerminalState(me,Ee,ze){return Ve.onDidChangeTerminalState(me,Ee,ze)},onDidWriteTerminalData(me,Ee,ze){return(0,Be.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(me,Ee,ze)},get state(){return Oe.state},onDidChangeWindowState(me,Ee,ze){return Oe.onDidChangeWindowState(me,Ee,ze)},showInformationMessage(me,...Ee){return An.showMessage(He,R.default.Info,me,Ee[0],Ee.slice(1))},showWarningMessage(me,...Ee){return An.showMessage(He,R.default.Warning,me,Ee[0],Ee.slice(1))},showErrorMessage(me,...Ee){return An.showMessage(He,R.default.Error,me,Ee[0],Ee.slice(1))},showQuickPick(me,Ee,ze){return Wt.showQuickPick(me,Ee,ze)},showWorkspaceFolderPick(me){return Wt.showWorkspaceFolderPick(me)},showInputBox(me,Ee){return Wt.showInput(me,Ee)},showOpenDialog(me){return Nn.showOpenDialog(me)},showSaveDialog(me){return Nn.showSaveDialog(me)},createStatusBarItem(me,Ee,ze){let at,Ct,Rt;return typeof me=="string"?(at=me,Ct=Ee,Rt=ze):(Ct=me,Rt=Ee),Fn.createStatusBarEntry(He,at,Ct,Rt)},setStatusBarMessage(me,Ee){return Fn.setStatusBarMessage(me,Ee)},withScmProgress(me){return Re.report("window.withScmProgress",He,"Use 'withProgress' instead."),ln.withProgress(He,{location:z.ProgressLocation.SourceControl},(Ee,ze)=>me({report(at){}}))},withProgress(me,Ee){return ln.withProgress(He,me,Ee)},createOutputChannel(me,Ee){return Lt.createOutputChannel(me,Ee,He)},createWebviewPanel(me,Ee,ze,at){return Cn.createWebviewPanel(He,me,Ee,ze,at)},createWebviewTextEditorInset(me,Ee,ze,at){return(0,Be.checkProposedApiEnabled)(He,"editorInsets"),Vt.createWebviewEditorInset(me,Ee,ze,at,He)},createTerminal(me,Ee,ze){return typeof me=="object"?"pty"in me?Ve.createExtensionTerminal(me):Ve.createTerminalFromOptions(me):Ve.createTerminal(me,Ee,ze)},registerTerminalLinkProvider(me){return Ve.registerLinkProvider(me)},registerTerminalProfileProvider(me,Ee){return Ve.registerProfileProvider(He,me,Ee)},registerTerminalQuickFixProvider(me,Ee){return(0,Be.checkProposedApiEnabled)(He,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(me,He.identifier.value,Ee)},registerTreeDataProvider(me,Ee){return on.registerTreeDataProvider(me,Ee,He)},createTreeView(me,Ee){return on.createTreeView(me,Ee,He)},registerWebviewPanelSerializer:(me,Ee)=>Cn.registerWebviewPanelSerializer(He,me,Ee),registerCustomEditorProvider:(me,Ee,ze={})=>Dn.registerCustomEditorProvider(He,me,Ee,ze),registerFileDecorationProvider(me){return Fe.registerFileDecorationProvider(me,He)},registerUriHandler(me){return It.registerUriHandler(He.identifier,me)},createQuickPick(){return Wt.createQuickPick(He)},createInputBox(){return Wt.createInputBox(He)},get activeColorTheme(){return un.activeColorTheme},onDidChangeActiveColorTheme(me,Ee,ze){return un.onDidChangeActiveColorTheme(me,Ee,ze)},registerWebviewViewProvider(me,Ee,ze){return In.registerWebviewViewProvider(He,me,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,Ee,ze){return yt.onDidChangeActiveNotebookEditor(me,Ee,ze)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,Ee,ze){return sn.onDidChangeNotebookEditorSelection(me,Ee,ze)},onDidChangeNotebookEditorVisibleRanges(me,Ee,ze){return sn.onDidChangeNotebookEditorVisibleRanges(me,Ee,ze)},showNotebookDocument(me,Ee){return yt.showNotebookDocument(me,Ee)},registerExternalUriOpener(me,Ee,ze){return(0,Be.checkProposedApiEnabled)(He,"externalUriOpener"),kn.registerExternalUriOpener(He.identifier,me,Ee,ze)},registerProfileContentHandler(me,Ee){return(0,Be.checkProposedApiEnabled)(He,"profileContentHandlers"),zn.registrProfileContentHandler(He,me,Ee)},get tabGroups(){return re.tabGroups}},mn={get rootPath(){return Re.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return pt.getWorkspaceFolder(me)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(me){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,Ee,...ze)=>pt.updateWorkspaceFolders(He,me,Ee||0,...ze),onDidChangeWorkspaceFolders:function(me,Ee,ze){return pt.onDidChangeWorkspace(me,Ee,ze)},asRelativePath:(me,Ee)=>pt.getRelativePath(me,Ee),findFiles:(me,Ee,ze,at)=>pt.findFiles(me,Ee,ze,He.identifier,at),findTextInFiles:(me,Ee,ze,at)=>{(0,Be.checkProposedApiEnabled)(He,"findTextInFiles");let Ct,Rt;return typeof Ee=="object"?(Ct=Ee,Rt=ze):(Ct={},Rt=Ee,at=ze),pt.findTextInFiles(me,Ct||{},Rt,He.identifier,at)},saveAll:me=>pt.saveAll(me),applyEdit(me,Ee){return Pn.applyWorkspaceEdit(me,He,Ee)},createFileSystemWatcher:(me,Ee,ze,at)=>Qt.createFileSystemWatcher(pt,He,me,Ee,ze,at),get textDocuments(){return ft.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let Ee;const ze=me;if(typeof me=="string")Ee=Promise.resolve(I.URI.file(me));else if(I.URI.isUri(me))Ee=Promise.resolve(me);else if(!ze||typeof ze=="object")Ee=ft.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(at=>ft.ensureDocumentData(at).then(Ct=>Ct.document))},onDidOpenTextDocument:(me,Ee,ze)=>ft.onDidAddDocument(me,Ee,ze),onDidCloseTextDocument:(me,Ee,ze)=>ft.onDidRemoveDocument(me,Ee,ze),onDidChangeTextDocument:(me,Ee,ze)=>ft.onDidChangeDocument(me,Ee,ze),onDidSaveTextDocument:(me,Ee,ze)=>ft.onDidSaveDocument(me,Ee,ze),onWillSaveTextDocument:(me,Ee,ze)=>jt.getOnWillSaveTextDocumentEvent(He)(me,Ee,ze),get notebookDocuments(){return yt.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,Ee){let ze;if(I.URI.isUri(me))ze=me,await yt.openNotebookDocument(me);else if(typeof me=="string")ze=I.URI.revive(await yt.createNotebookDocument({viewType:me,content:Ee}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(me,Ee,ze){return _t.onDidSaveNotebookDocument(me,Ee,ze)},onDidChangeNotebookDocument(me,Ee,ze){return _t.onDidChangeNotebookDocument(me,Ee,ze)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(me,Ee,ze,at){return yt.registerNotebookSerializer(He,me,Ee,ze,(0,Be.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,Ee,ze)=>dn.onDidChangeConfiguration(me,Ee,ze),getConfiguration(me,Ee){return Ee=arguments.length===1?void 0:Ee,dn.getConfiguration(me,Ee,He)},registerTextDocumentContentProvider(me,Ee){return Gt.registerTextDocumentContentProvider(me,Ee)},registerTaskProvider:(me,Ee)=>(Re.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,me,Ee)),registerFileSystemProvider(me,Ee,ze){return(0,Le.combinedDisposable)(On.registerFileSystemProvider(He,me,Ee,ze),Tt.addFileSystemProvider(me,Ee))},get fs(){return Tt.value},registerFileSearchProvider:(me,Ee)=>((0,Be.checkProposedApiEnabled)(He,"fileSearchProvider"),St.registerFileSearchProvider(me,Ee)),registerTextSearchProvider:(me,Ee)=>((0,Be.checkProposedApiEnabled)(He,"textSearchProvider"),St.registerTextSearchProvider(me,Ee)),registerRemoteAuthorityResolver:(me,Ee)=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Nt.registerRemoteAuthorityResolver(me,Ee)),registerResourceLabelFormatter:me=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Sn.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,Ee,ze)=>Qt.onDidCreateFile(me,Ee,ze),onDidDeleteFiles:(me,Ee,ze)=>Qt.onDidDeleteFile(me,Ee,ze),onDidRenameFiles:(me,Ee,ze)=>Qt.onDidRenameFile(me,Ee,ze),onWillCreateFiles:(me,Ee,ze)=>Qt.getOnWillCreateFileEvent(He)(me,Ee,ze),onWillDeleteFiles:(me,Ee,ze)=>Qt.getOnWillDeleteFileEvent(He)(me,Ee,ze),onWillRenameFiles:(me,Ee,ze)=>Qt.getOnWillRenameFileEvent(He)(me,Ee,ze),openTunnel:me=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.openTunnel(He,me).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.getTunnels()},onDidChangeTunnels:(me,Ee,ze)=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.onDidChangeTunnels(me,Ee,ze)),registerPortAttributesProvider:(me,Ee)=>((0,Be.checkProposedApiEnabled)(He,"portsAttributes"),Pt.registerPortsAttributesProvider(me,Ee)),registerTimelineProvider:(me,Ee)=>((0,Be.checkProposedApiEnabled)(He,"timeline"),yn.registerTimelineProvider(me,Ee,He.identifier,Qe.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:me=>((0,Be.checkProposedApiEnabled)(He,"workspaceTrust"),pt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,Ee,ze)=>pt.onDidGrantWorkspaceTrust(me,Ee,ze),registerEditSessionIdentityProvider:(me,Ee)=>((0,Be.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(me,Ee))},Gn={get inputBox(){return Re.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(He)},createSourceControl(me,Ee,ze){return cn.createSourceControl(He,me,Ee,ze)}},xt={createCommentController(me,Ee){return En.createCommentController(He,me,Ee)}},gn={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(me,Ee,ze){return tt.onDidStartDebugSession(me,Ee,ze)},onDidTerminateDebugSession(me,Ee,ze){return tt.onDidTerminateDebugSession(me,Ee,ze)},onDidChangeActiveDebugSession(me,Ee,ze){return tt.onDidChangeActiveDebugSession(me,Ee,ze)},onDidReceiveDebugSessionCustomEvent(me,Ee,ze){return tt.onDidReceiveDebugSessionCustomEvent(me,Ee,ze)},onDidChangeBreakpoints(me,Ee,ze){return tt.onDidChangeBreakpoints(me,Ee,ze)},registerDebugConfigurationProvider(me,Ee,ze){return tt.registerDebugConfigurationProvider(me,Ee,ze||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,Ee){return tt.registerDebugAdapterDescriptorFactory(He,me,Ee)},registerDebugAdapterTrackerFactory(me,Ee){return tt.registerDebugAdapterTrackerFactory(me,Ee)},startDebugging(me,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?tt.startDebugging(me,Ee,{parentSession:ze}):tt.startDebugging(me,Ee,ze||{})},stopDebugging(me){return tt.stopDebugging(me)},addBreakpoints(me){return tt.addBreakpoints(me)},removeBreakpoints(me){return tt.removeBreakpoints(me)},asDebugSourceUri(me,Ee){return tt.asDebugSourceUri(me,Ee)}},Kn={registerTaskProvider:(me,Ee)=>Et.registerTaskProvider(He,me,Ee),fetchTasks:me=>Et.fetchTasks(me),executeTask:me=>Et.executeTask(He,me),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(me,Ee,ze)=>Et.onDidStartTask(me,Ee,ze),onDidEndTask:(me,Ee,ze)=>Et.onDidEndTask(me,Ee,ze),onDidStartTaskProcess:(me,Ee,ze)=>Et.onDidStartTaskProcess(me,Ee,ze),onDidEndTaskProcess:(me,Ee,ze)=>Et.onDidEndTaskProcess(me,Ee,ze)},$t={createNotebookController(me,Ee,ze,at,Ct){return en.createNotebookController(He,me,Ee,ze,at,(0,Be.isProposedApiEnabled)(He,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(me,Ee)=>yt.registerNotebookCellStatusBarItemProvider(He,me,Ee),createRendererMessaging(me){return vn.createRendererMessaging(He,me)},createNotebookControllerDetectionTask(me){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),en.createNotebookControllerDetectionTask(He,me)},registerKernelSourceActionProvider(me,Ee){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),en.registerKernelSourceActionProvider(He,me,Ee)},onDidChangeNotebookCellExecutionState(me,Ee,ze){return(0,Be.checkProposedApiEnabled)(He,"notebookCellExecutionState"),en.onDidChangeNotebookCellExecutionState(me,Ee,ze)}},pn={t(...me){if(typeof me[0]=="string"){const Ee=me.shift(),ze=!me||typeof me[0]!="object"?me:me[0];return vt.getMessage(He.identifier.value,{message:Ee,args:ze})}return vt.getMessage(He.identifier.value,me[0])},get bundle(){return vt.getBundle(He.identifier.value)},get uri(){return vt.getBundleUri(He.identifier.value)}};return{version:rt.version,authentication:Wn,commands:Hn,comments:xt,debug:gn,env:Mn,extensions:jn,l10n:pn,languages:Vn,notebooks:$t,scm:Gn,tasks:Kn,tests:hn,window:qn,workspace:mn,Breakpoint:z.Breakpoint,TerminalOutputAnchor:z.TerminalOutputAnchor,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileDecoration2:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestionList,Hover:z.Hover,IndentAction:D.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalQuickFixCommand:z.TerminalQuickFixCommand,TerminalQuickFixOpener:z.TerminalQuickFixOpener,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TerminalExitReason:z.TerminalExitReason,TerminalQuickFixType:z.TerminalQuickFixType,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:C.UIKind,Uri:I.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,NotebookKernelSourceAction:z.NotebookKernelSourceAction,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TrustedTelemetryValue:ne.TrustedTelemetryValue,LogLevel:Ne.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(ye[304],Ce([1,0,276,313,314,2,315]),function(te,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(P,v,C,S,m,d){const h=d.environment.useHostProxy,b=typeof h=="boolean"?h:!d.remote.isRemote,g=(0,I.createProxyResolver)({resolveProxy:w=>P.resolveProxy(w),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(w,i,...s)=>{switch(w){case I.LogLevel.Trace:S.trace(i,...s);break;case I.LogLevel.Debug:S.debug(i,...s);break;case I.LogLevel.Info:S.info(i,...s);break;case I.LogLevel.Warning:S.warn(i,...s);break;case I.LogLevel.Error:S.error(i,...s);break;case I.LogLevel.Critical:S.error(i,...s);break;case I.LogLevel.Off:break;default:a(w,i,s);break}function a(u,l,...c){S.error("Unknown log level",u),S.error(l,...c)}},getLogLevel:()=>S.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),p=y(v,g);return L(C,p)}e.connectProxyResolver=A;function y(P,v){const C={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(m=>{C.config=P.getConfiguration("http").get("proxySupport")||"off"});const S={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(m=>{S.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},o,(0,I.createHttpPatch)(o,v,{config:"off"},S,!0)),on:Object.assign({},o,(0,I.createHttpPatch)(o,v,{config:"on"},S,!0)),override:Object.assign({},o,(0,I.createHttpPatch)(o,v,{config:"override"},S,!0)),onRequest:Object.assign({},o,(0,I.createHttpPatch)(o,v,C,S,!0)),default:Object.assign(o,(0,I.createHttpPatch)(o,v,C,S,!1))},https:{off:Object.assign({},t,(0,I.createHttpPatch)(t,v,{config:"off"},S,!0)),on:Object.assign({},t,(0,I.createHttpPatch)(t,v,{config:"on"},S,!0)),override:Object.assign({},t,(0,I.createHttpPatch)(t,v,{config:"override"},S,!0)),onRequest:Object.assign({},t,(0,I.createHttpPatch)(t,v,C,S,!0)),default:Object.assign(t,(0,I.createHttpPatch)(t,v,C,S,!1))},tls:Object.assign(k,(0,I.createTlsPatch)(k))}}const D=new Map;function L(P,v){return P.getExtensionPathIndex().then(C=>{const S=globalThis._VSCODE_NODE_MODULES.module,m=S._load;S._load=function(h,b,g){if(h==="tls")return v.tls;if(h!=="http"&&h!=="https")return m.apply(this,arguments);const p=v[h],w=C.findSubstr(R.URI.file(b.filename));let i=D.get(w);if(i||D.set(w,i={}),!i[h]){const s=p.default;i[h]={...s}}return i[h]}})}}),define(ye[305],Ce([1,0,77,303,290,304,42,278,2,15,7,275,114,277]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class S extends k.RequireInterceptor{j(){const h=this,b=globalThis._VSCODE_NODE_MODULES.module,g=b._load;b._load=function(s,a,u){return s=w(s),h.a.has(s)?h.a.get(s).load(s,y.URI.file((0,v.realpathSync)(a.filename)),l=>g.apply(this,[l,a,u])):g.apply(this,arguments)};const p=b._resolveLookupPaths;b._resolveLookupPaths=(i,s)=>p.call(this,w(i),s);const w=i=>{for(const s of h.b){const a=s(i);if(a){i=a;break}}return i}}}class m extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(C.ExtHostConsoleForwarder);const h=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(A.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const p=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=p.ipcHandlePath}await this.h.createInstance(S,h,{mine:this.D,all:this.F}).install(),o.mark("code/extHost/didInitAPI");const g=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,g,this,this.l,this.u,this.f),o.mark("code/extHost/didInitProxyResolver")}ob(h){return h.main}async pb(h,b,g){if(b.scheme!==D.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let p=null;g.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this.l.flush();const w=h?.identifier.value;h&&await this.s.initializeLocalizedMessages(h);try{w&&o.mark(`code/extHost/willLoadExtensionCode/${w}`),p=te.__$__nodeRequire(b.fsPath)}finally{w&&o.mark(`code/extHost/didLoadExtensionCode/${w}`),g.codeLoadingStop()}return p}async $setRemoteEnvironment(h){if(!!this.f.remote.isRemote)for(const b in h){const g=h[b];g===null?delete process.env[b]:process.env[b]=g}}}e.ExtHostExtensionService=m}),define(ye[145],Ce([1,0,46,316,299,18,81,38,9,8,2,31,75,317,297,99]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(f){this.a=f}provideTextSearchResults(f,E,T,M){return this.a.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((K,V)=>{M.onCancellationRequested(()=>_());const F=s(f,E),U=E.folder.fsPath,N=F.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");this.a.appendLine(`${d} ${N}
 - cwd: ${U}`);let B=o.spawn(d,F,{cwd:U});B.on("error",q=>{console.error(q),this.a.appendLine("Error: "+(q&&q.message)),V((0,P.serializeSearchError)(new P.SearchError(q&&q.message,P.SearchErrorCode.rgProcessError)))});let j=!1;const z=new p(E.maxResults,U,E.previewOptions);z.on("result",q=>{j=!0,J="",T.report(q)});let ne=!1;const _=()=>{ne=!0,B?.kill(),z?.cancel()};let Y=!1;z.on("hitLimit",()=>{Y=!0,_()});let J="";B.stdout.on("data",q=>{z.handleData(q),j||(J+=q)});let ee=!1;B.stdout.once("data",()=>ee=!0);let ge="";B.stderr.on("data",q=>{const G=q.toString();this.a.appendLine(G),ge.length+G.length<1e6&&(ge+=G)}),B.on("close",()=>{if(this.a.appendLine(ee?"Got data from stdout":"No data from stdout"),this.a.appendLine(j?"Got result from parser":"No result from parser"),J&&this.a.appendLine(`Got data without result: ${J}`),this.a.appendLine(""),ne)K({limitHit:Y});else{z.flush(),B=null;let q;ge&&!ee&&(q=b(ge))?V((0,P.serializeSearchError)(new P.SearchError(q.message,q.code))):K({limitHit:Y})}})})}}e.RipgrepTextSearchEngine=h;function b(r){const f=r.split(`
`),E=f[0].trim();if(f.some(M=>M.startsWith("regex parse error")))return new P.SearchError(g(f),P.SearchErrorCode.regexParseError);const T=E.match(/grep config error: unknown encoding: (.*)/);if(T)return new P.SearchError(`Unknown encoding: ${T[1]}`,P.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new P.SearchError(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new P.SearchError(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(E,P.SearchErrorCode.regexParseError)}function g(r){const f=["Regex parse error"],E=r.filter(T=>T.startsWith("PCRE2:"));if(E.length>=1){const T=E[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const M=T.split(":")[1];f.push(":"+M)}}return f.join("")}class p extends t.EventEmitter{constructor(f,E,T){super(),this.g=f,this.h=E,this.j=T,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new k.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(f,E){return super.on(f,E),this}handleData(f){if(this.b)return;const E=typeof f=="string"?f:this.d.write(f);this.k(E)}k(f){let E=f.indexOf(`
`);const T=this.a+f;if(E>=0)E+=this.a.length;else{this.a=T;return}let M=0;for(;E>=0;)this.m(T.substring(M,E).trim()),M=E+1,E=T.indexOf(`
`,M);this.a=T.substring(M)}m(f){if(this.b||!f)return;let E;try{E=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(E.type==="match"){const T=w(E.data.path),M=L.URI.file(y.join(this.h,T)),K=this.n(E.data,M);this.p(K),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const T=w(E.data.path),M=L.URI.file(y.join(this.h,T));this.o(E.data,M).forEach(V=>this.p(V))}}n(f,E){const T=f.line_number-1,M=w(f.lines),K=Buffer.from(M);let V=0,F=0,U=T;f.submatches.length===0&&f.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const N=(0,R.coalesce)(f.submatches.map((B,j)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const z=w(B.match),ne=K.slice(V,B.start).toString(),_=i(ne),Y=_.numLines>0?_.lastLineLength:_.lastLineLength+F,J=i(z),ee=_.numLines+U,ge=J.numLines+ee,q=J.numLines>0?J.lastLineLength:J.lastLineLength+Y;return V=B.end,F=q,U=ge,new v.Range(ee,Y,ge,q)}));return(0,m.createTextSearchResult)(E,M,N,this.j)}o(f,E){const T=w(f.lines),M=f.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((K,V)=>({text:K,uri:E,lineNumber:M+V}))}p(f){this.emit("result",f)}}e.RipgrepParser=p;function w(r){return r.bytes?Buffer.from(r.bytes,"base64").toString():r.text}function i(r){const f=/\n/g;let E=0,T=-1,M;for(;M=f.exec(r);)E++,T=M.index;const K=T>=0?r.length-T-1:r.length;return{numLines:E,lastLineLength:K}}function s(r,f){const E=["--hidden"];E.push(r.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:M}=(0,I.groupBy)(f.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const V=new Set;M.forEach(F=>{V.add(F)}),E.push("-g","!*"),V.forEach(F=>{a(F).map(m.anchorGlob).forEach(U=>{E.push("-g",U)})})}T&&T.length&&T.forEach(V=>{E.push("-g",V)}),f.excludes.map(m.anchorGlob).forEach(V=>E.push("-g",`!${V}`)),f.maxFileSize&&E.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),f.followSymlinks&&E.push("--follow"),f.encoding&&f.encoding!=="utf8"&&E.push("--encoding",f.encoding),r.pattern==="--"&&(r.isRegExp=!0,r.pattern="\\-\\-"),r.isMultiline&&!r.isRegExp&&(r.pattern=(0,D.escapeRegExpCharacters)(r.pattern),r.isRegExp=!0),f.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),r.isRegExp&&(r.pattern=u(r.pattern),E.push("--engine","auto"));let K;if(r.isWordMatch){const F=(0,D.createRegExp)(r.pattern,!!r.isRegExp,{wholeWord:r.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",F)}else if(r.isRegExp){let V=c(r.pattern);V=n(V),E.push("--regexp",V)}else K=r.pattern,E.push("--fixed-strings");return E.push("--no-config"),f.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),r.isMultiline&&E.push("--multiline"),f.beforeContext&&E.push("--before-context",f.beforeContext+""),f.afterContext&&E.push("--after-context",f.afterContext+""),E.push("--"),K&&E.push(K),E.push("."),E}function a(r){const f=(0,A.splitGlobAware)(r,"/");return f.map((E,T)=>f.slice(0,T+1).join("/"))}function u(r){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;r.match(f);)r=r.replace(f,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;r.match(E);)r=r.replace(E,"$1\\x{$2}");return r}e.unicodeEscapesToPCRE2=u;const l=r=>r.type==="Assertion"&&r.kind==="lookbehind";function c(r){let f;try{f=new C.RegExpParser().parsePattern(r)}catch{return r}let E="",T=0;const M=(F,U,N)=>{E+=r.slice(T,F)+N,T=U},K=[];return new C.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const U=K[0];if(!U)M(F.start,F.end,"\\r?\\n");else if(!K.some(l))if(U.type==="CharacterClass")if(U.negate){const N=r.slice(U.start+2,F.start)+r.slice(F.end,U.end-1);U.parent?.type==="Quantifier"?M(U.start,U.end,N?`[^${N}]`:"."):M(U.start,U.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=r.slice(U.start+1,F.start)+r.slice(F.end,U.end-1);M(U.start,U.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else U.type==="Quantifier"&&M(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){K.unshift(F)},onQuantifierLeave(){K.shift()},onCharacterClassRangeEnter(F){K.unshift(F)},onCharacterClassRangeLeave(){K.shift()},onCharacterClassEnter(F){K.unshift(F)},onCharacterClassLeave(){K.shift()},onAssertionEnter(F){l(F)&&K.push(F)},onAssertionLeave(F){K[0]===F&&K.shift()}}).visit(f),E+=r.slice(T),E}e.fixRegexNewline=c;function n(r){return r.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(ye[306],Ce([1,0,21,145,125,15]),function(te,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class I{constructor(D){this.b=D,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(D,L,P,v){const C=new t.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const S={...L,folder:L.folder.with({scheme:R.Schemas.file})},m=new k.Progress(d=>P.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.c(v,d=>C.provideTextSearchResults(D,S,m,d))}else return this.c(v,S=>C.provideTextSearchResults(D,L,P,S))}async c(D,L){const P=A(D);this.a.add(P);const v=await L(P.token);return this.a.delete(P),v}d(){this.a.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=I;function A(y){const D=new o.CancellationTokenSource;return y.onCancellationRequested(()=>D.cancel()),D}}),define(ye[307],Ce([1,0,29,145,144]),function(te,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.a=y}search(y,D,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(C){L({message:C})}},v=new k.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),o);return new Promise((C,S)=>v.search(m=>{D(m.map(I))},y).then(m=>C({limitHit:m.limitHit,type:"success",stats:m.stats}),S))}}e.TextSearchEngineAdapter=R;function I(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,D)=>{if(D.ranges){const L=D;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(ye[308],Ce([1,0,18,16,10,3,110,9,43,2,39,31,298,307]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class S{constructor(p="searchProcess"){this.d=p,this.b=Object.create(null)}fileSearch(p){let w;const i=h(p),s=new R.Emitter({onDidAddFirstListener:()=>{w=(0,t.createCancelablePromise)(a=>this.doFileSearchWithEngine(v.Engine,i,u=>s.fire(u),a)),w.then(a=>s.fire(a),a=>s.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{w.cancel()}});return s.event}textSearch(p){let w;const i=h(p),s=new R.Emitter({onDidAddFirstListener:()=>{w=(0,t.createCancelablePromise)(a=>this.f(i,u=>s.fire(u),a)),w.then(a=>s.fire(a),a=>s.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{w.cancel()}});return s.event}f(p,w,i){return p.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new C.TextSearchEngineAdapter(p).search(i,w,w)}doFileSearch(p,w,i){return this.doFileSearchWithEngine(v.Engine,p,w,i)}doFileSearchWithEngine(p,w,i,s,a=S.a){let u=0;const l=n=>{Array.isArray(n)?(u+=n.length,i(n.map(r=>this.g(r)))):n.relativePath?(u++,i(this.g(n))):i(n)};if(w.sortByScore){let n=this.k(w,l,s);if(!n){const r=w.maxResults?Object.assign({},w,{maxResults:null}):w,f=new p(r);n=this.h(f,w,i,l,s)}return new Promise((r,f)=>{n.then(([E,T])=>{const M=T.map(K=>this.g(K));this.n(M,i,a),r(E)},f)})}const c=new p(w);return this.q(c,l,a,s).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}g(p){return{path:p.base?(0,A.join)(p.base,p.relativePath):p.relativePath}}h(p,w,i,s,a){const u=new R.Emitter;let l=(0,t.createCancelablePromise)(n=>{let r=[];const f=E=>{Array.isArray(E)?r=E:(s(E),u.fire(E))};return this.q(p,f,-1,n).then(E=>[E,r])}),c;if(w.cacheKey){c=this.j(w.cacheKey);const n={promise:l,event:u.event,resolved:!1};c.resultsToSearchCache[w.filePattern||""]=n,l.then(()=>{n.resolved=!0},r=>{delete c.resultsToSearchCache[w.filePattern||""]}),l=this.r(l)}return l.then(([n,r])=>{const f=c?c.scorerCache:Object.create(null),E=(typeof w.maxResults!="number"||w.maxResults>0)&&y.StopWatch.create(!1);return this.l(w,r,f,a).then(T=>{const M=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:M,fromCache:!1,type:this.d,workspaceFolderCount:w.folderQueries.length,resultCount:T.length},messages:n.messages,limitHit:n.limitHit||typeof w.maxResults=="number"&&r.length>w.maxResults},T]})})}j(p){const w=this.b[p];return w||(this.b[p]=new m)}k(p,w,i){const s=p.cacheKey&&this.b[p.cacheKey];if(!s)return;const a=this.o(s,p.filePattern||"",w,i);if(a)return a.then(([u,l,c])=>{const n=y.StopWatch.create(!1);return this.l(p,l,s.scorerCache,i).then(r=>{const f=n.elapsed(),E={fromCache:!0,detailStats:c,type:this.d,resultCount:l.length,sortingTime:f};return[{type:"success",limitHit:u.limitHit||typeof p.maxResults=="number"&&l.length>p.maxResults,stats:E},r]})})}l(p,w,i,s){const a=(0,I.prepareQuery)(p.filePattern||""),u=(c,n)=>(0,I.compareItemsByFuzzyScore)(c,n,a,!0,d,i),l=typeof p.maxResults=="number"?p.maxResults:Number.MAX_VALUE;return o.topAsync(w,u,l,1e4,s)}n(p,w,i){if(i&&i>0)for(let s=0;s<p.length;s+=i)w(p.slice(s,s+i));else w(p)}o(p,w,i,s){const a=y.StopWatch.create(!1),u=w.indexOf(A.sep)>=0;let l;for(const f in p.resultsToSearchCache)if(w.startsWith(f)){if(u&&f.indexOf(A.sep)<0&&f!=="")continue;const E=p.resultsToSearchCache[f];l={promise:this.r(E.promise),event:E.event,resolved:E.resolved};break}if(!l)return null;const c=a.elapsed(),n=y.StopWatch.create(!1),r=l.event(i);return s&&s.onCancellationRequested(()=>{r.dispose()}),l.promise.then(([f,E])=>{if(s&&s.isCancellationRequested)throw(0,k.canceled)();const T=[],M=(0,I.prepareQuery)(w).normalizedLowercase;for(const K of E)!(0,P.isFilePatternMatch)(K,M)||T.push(K);return[f,T,{cacheWasResolved:l.resolved,cacheLookupTime:c,cacheFilterTime:n.elapsed(),cacheEntryCount:E.length}]})}q(p,w,i,s){return new Promise((a,u)=>{let l=[];s?.onCancellationRequested(()=>p.cancel()),p.search(c=>{c&&(i?(l.push(c),i>0&&l.length>=i&&(w(l),l=[])):w(c))},c=>{w(c)},(c,n)=>{l.length&&w(l),c?u(c):a(n)})})}clearCache(p){return delete this.b[p],Promise.resolve(void 0)}r(p){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(w,i){return p.then(w,i)}catch(w){return this.then(void 0,w)}finally(w){return p.finally(w)}}}}e.SearchService=S,S.a=512;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(g){return(0,A.basename)(g.relativePath)}getItemDescription(g){return(0,A.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function h(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(b),extraFileResources:g.extraFileResources&&g.extraFileResources.map(p=>D.URI.revive(p))}}function b(g){return{...g,folder:D.URI.revive(g.folder)}}}),define(ye[309],Ce([1,0,6,15,2,29,13,25,17,79,55,31,308,306,99,144]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends D.ExtHostSearch{constructor(b,g,p,w){super(b,p,w),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new S.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new C.RipgrepSearchProvider(i)),g.remote.isRemote&&g.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const b=new S.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new C.RipgrepSearchProvider(b)),this.y(t.Schemas.file,new v.SearchService("fileSearchProvider"))}y(b,g){const p=this.d++;return this.v=g,this.t=p,this.c.$registerFileSearchProvider(p,this.o(b)),(0,o.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(p)})}$provideFileSearchResults(b,g,p,w){const i=(0,D.reviveQuery)(p);return b===this.t?this.z(b,g,i,w):super.$provideFileSearchResults(b,g,p,w)}z(b,g,p,w){const i=s=>{if((0,P.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(b,g,s.map(a=>k.URI.file(a.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(p,i,w)}$clearCache(b){return this.v?.clearCache(b),super.$clearCache(b)}q(b,g){return new m.NativeTextSearchManager(b,g,void 0,"textSearchProvider")}};d=qe([We(0,y.IExtHostRpcService),We(1,A.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,I.ILogService)],d),e.NativeExtHostSearch=d}),define(ye[310],Ce([1,0,88,281,293,292,309,305,282,78,42,79,76,41,54,73,280,279,13,294,49]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h,b,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(L.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,o.registerSingleton)(b.ILoggerService,h.ExtHostLoggerService,1),(0,o.registerSingleton)(m.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,o.registerSingleton)(D.IExtHostDebugService,R.ExtHostDebugService,0),(0,o.registerSingleton)(P.IExtHostSearch,I.NativeExtHostSearch,0),(0,o.registerSingleton)(v.IExtHostTask,k.ExtHostTask,0),(0,o.registerSingleton)(C.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,o.registerSingleton)(S.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,o.registerSingleton)(p.IExtHostVariableResolverProvider,g.NodeExtHostVariableResolverProviderService,0)}),define(ye[318],Ce([1,0,221,319,77,10,117,118,202,94,291,22,29,114,16,120,217,230,295,310]),function(te,e,o,t,k,R,I,A,y,D,L,P,v,C,S,m,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let c=0;c<process.execArgv.length;c++)process.execArgv[c]==="--inspect-port=0"&&(process.execArgv.splice(c,1),c--)}();const b=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,c=l._load;l._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return c.apply(this,arguments)}})();const g=process.exit.bind(process);function p(l){process.exit=function(c){if(l)g(c);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const c=new Error("An extension called process.crash() and this was prevented.");console.warn(c.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let w=function(l){g()};function i(){const l=(0,h.readExtHostConnection)(process.env);if(l.type===3)return new Promise((c,n)=>{const r=f=>{const E=f[0],T=new I.BufferedEmitter;E.on("message",M=>T.fire(P.VSBuffer.wrap(M.data))),E.on("close",()=>{w("renderer closed the MessagePort")}),E.start(),c({onMessage:T.event,send:M=>E.postMessage(M.buffer)})};process?.parentPort.on("message",f=>r(f.ports))});if(l.type===2)return new Promise((c,n)=>{let r=null;const f=setTimeout(()=>{w("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,T=3e5,M=new S.ProcessTimeRunOnceScheduler(()=>w("renderer disconnected for too long (1)"),E),K=new S.ProcessTimeRunOnceScheduler(()=>w("renderer disconnected for too long (2)"),T);process.on("message",(F,U)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const N=P.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let B;if(F.skipWebSocketFrames)B=new A.NodeSocket(U,"extHost-socket");else{const j=P.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));B=new A.WebSocketNodeSocket(new A.NodeSocket(U,"extHost-socket"),F.permessageDeflate,j,!1)}r?(M.cancel(),K.cancel(),r.beginAcceptReconnection(B,N),r.endAcceptReconnection(),r.sendResume()):(clearTimeout(f),r=new I.PersistentProtocol({socket:B,initialChunk:N}),r.sendResume(),r.onDidDispose(()=>w("renderer disconnected")),c(r),r.onSocketClose(()=>{M.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(K.isScheduled())return;M.isScheduled()&&K.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const c=l.pipeName;return new Promise((n,r)=>{const f=o.createConnection(c,()=>{f.removeListener("error",r);const E=new I.PersistentProtocol({socket:new A.NodeSocket(f,"extHost-renderer")});E.sendResume(),n(E)});f.once("error",r),f.on("close",()=>{w("renderer closed the socket")})})}}async function s(){const l=await i();return new class{constructor(){this.a=new I.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,l.onMessage(c=>{(0,D.isMessageOfType)(c,2)?(this.b=!0,w("received terminate message from renderer")):this.a.fire(c)})}send(c){this.b||l.send(c)}async drain(){if(l.drain)return l.drain()}}}function a(l){return new Promise(c=>{const n=l.onMessage(r=>{n.dispose();const f=JSON.parse(r.toString()),E=f.commit,T=y.default.commit;if(E&&T&&E!==T&&g(55),f.parentPid){let M=0;setInterval(function(){try{process.kill(f.parentPid,0),M=0}catch(V){V&&V.code==="EPERM"?(M++,M>=3&&w(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):w(`parent process ${f.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let K;try{K=globalThis._VSCODE_NODE_MODULES["native-watchdog"],K.start(f.parentPid)}catch(V){(0,R.onUnexpectedError)(V)}}l.send((0,D.createMessageOfType)(0)),c({protocol:l,initData:f})});l.send((0,D.createMessageOfType)(1))})}async function u(){const l=[];process.on("unhandledRejection",(M,K)=>{l.push(K),setTimeout(()=>{const V=l.indexOf(K);V>=0&&K.catch(F=>{l.splice(V,1),(0,R.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),M&&(0,R.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const K=l.indexOf(M);K>=0&&l.splice(K,1)}),process.on("uncaughtException",function(M){(0,R.onUnexpectedError)(M)}),k.mark("code/extHost/willConnectToRenderer");const c=await s();k.mark("code/extHost/didConnectToRenderer");const n=await a(c);k.mark("code/extHost/didWaitForInitData");const{initData:r}=n;p(!!r.environment.extensionTestsLocationURI),r.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,r.environment.skipWorkspaceStorageLock=(0,m.boolean)(b.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(K){g(K)}exists(K){return v.Promises.exists(K)}realpath(K){return(0,C.realpath)(K)}};let E=null;r.remote.authority&&b.transformURIs&&(E=(0,d.createURITransformer)(r.remote.authority));const T=new L.ExtensionHostMain(n.protocol,r,f,E);w=M=>T.terminate(M)}u().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/717d7d62c8b4566ab6704de931e7fe8e0649d810/core/vs/workbench/api/node/extensionHostProcess.js.map
