/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],ke=function(ee){for(var e=[],t=0,T=ee.length;t<T;t++)e[t]=Ce[ee[t]];return e};define(Ce[80],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function t(C,R){const D=Object.create(null);for(const k of C){const M=R(k);let S=D[M];S||(S=D[M]=[]),S.push(k)}return D}e.groupBy=t;function T(C,R){const D=[],k=[];for(const M of C)R.has(M)||D.push(M);for(const M of R)C.has(M)||k.push(M);return{removed:D,added:k}}e.diffSets=T;function y(C,R){const D=[],k=[];for(const[M,S]of C)R.has(M)||D.push(S);for(const[M,S]of R)C.has(M)||k.push(S);return{removed:D,added:k}}e.diffMaps=y;class N{constructor(){this.a=new Map}add(R,D){let k=this.a.get(R);k||(k=new Set,this.a.set(R,k)),k.add(D)}delete(R,D){const k=this.a.get(R);!k||(k.delete(D),k.size===0&&this.a.delete(R))}forEach(R,D){const k=this.a.get(R);!k||k.forEach(D)}}e.SetMap=N}),define(Ce[61],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function t(C){return(R,D,k)=>{let M=null,S=null;if(typeof k.value=="function"?(M="value",S=k.value):typeof k.get=="function"&&(M="get",S=k.get),!S)throw new Error("not supported");k[M]=C(S,D)}}function T(C,R,D){let k=null,M=null;if(typeof D.value=="function"?(k="value",M=D.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(k="get",M=D.get),!M)throw new Error("not supported");const S=`$memoize$${R}`;D[k]=function(...f){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,f)}),this[S]}}e.memoize=T;function y(C,R,D){return t((k,M)=>{const S=`$debounce$${M}`,f=`$debounce$result$${M}`;return function(...p){this[f]||(this[f]=D?D():void 0),clearTimeout(this[S]),R&&(this[f]=R(this[f],...p),p=[this[f]]),this[S]=setTimeout(()=>{k.apply(this,p),this[f]=D?D():void 0},C)}})}e.debounce=y;function N(C,R,D){return t((k,M)=>{const S=`$throttle$timer$${M}`,f=`$throttle$result$${M}`,p=`$throttle$lastRun$${M}`,m=`$throttle$pending$${M}`;return function(...i){if(this[f]||(this[f]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...i)),this[m])return;const r=this[p]+C;r<=Date.now()?(this[p]=Date.now(),k.apply(this,[this[f]]),this[f]=D?D():void 0):(this[m]=!0,this[S]=setTimeout(()=>{this[m]=!1,this[p]=Date.now(),k.apply(this,[this[f]]),this[f]=D?D():void 0},r-Date.now()))}})}e.throttle=N}),define(Ce[81],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class t{constructor(y){this.a=y,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=t,e.defaultGenerator=new t("id#")}),define(Ce[109],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var t;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(t=e.ScanError||(e.ScanError={}));var T;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var N;(function(s){s.DEFAULT={allowTrailingComma:!0}})(N=e.ParseOptions||(e.ParseOptions={}));function C(s,o=!1){let a=0;const d=s.length;let c="",u=0,n=16,h=0;function g(F){let P=0,B=0;for(;P<F;){const V=s.charCodeAt(a);if(V>=48&&V<=57)B=B*16+V-48;else if(V>=65&&V<=70)B=B*16+V-65+10;else if(V>=97&&V<=102)B=B*16+V-97+10;else break;a++,P++}return P<F&&(B=-1),B}function A(F){a=F,c="",u=0,n=16,h=0}function L(){const F=a;if(s.charCodeAt(a)===48)a++;else for(a++;a<s.length&&k(s.charCodeAt(a));)a++;if(a<s.length&&s.charCodeAt(a)===46)if(a++,a<s.length&&k(s.charCodeAt(a)))for(a++;a<s.length&&k(s.charCodeAt(a));)a++;else return h=3,s.substring(F,a);let P=a;if(a<s.length&&(s.charCodeAt(a)===69||s.charCodeAt(a)===101))if(a++,(a<s.length&&s.charCodeAt(a)===43||s.charCodeAt(a)===45)&&a++,a<s.length&&k(s.charCodeAt(a))){for(a++;a<s.length&&k(s.charCodeAt(a));)a++;P=a}else h=3;return s.substring(F,P)}function q(){let F="",P=a;for(;;){if(a>=d){F+=s.substring(P,a),h=2;break}const B=s.charCodeAt(a);if(B===34){F+=s.substring(P,a),a++;break}if(B===92){if(F+=s.substring(P,a),a++,a>=d){h=2;break}switch(s.charCodeAt(a++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const z=g(4);z>=0?F+=String.fromCharCode(z):h=4;break}default:h=5}P=a;continue}if(B>=0&&B<=31)if(D(B)){F+=s.substring(P,a),h=2;break}else h=6;a++}return F}function Z(){if(c="",h=0,u=a,a>=d)return u=d,n=17;let F=s.charCodeAt(a);if(R(F)){do a++,c+=String.fromCharCode(F),F=s.charCodeAt(a);while(R(F));return n=15}if(D(F))return a++,c+=String.fromCharCode(F),F===13&&s.charCodeAt(a)===10&&(a++,c+=`
`),n=14;switch(F){case 123:return a++,n=1;case 125:return a++,n=2;case 91:return a++,n=3;case 93:return a++,n=4;case 58:return a++,n=6;case 44:return a++,n=5;case 34:return a++,c=q(),n=10;case 47:{const P=a-1;if(s.charCodeAt(a+1)===47){for(a+=2;a<d&&!D(s.charCodeAt(a));)a++;return c=s.substring(P,a),n=12}if(s.charCodeAt(a+1)===42){a+=2;const B=d-1;let V=!1;for(;a<B;){if(s.charCodeAt(a)===42&&s.charCodeAt(a+1)===47){a+=2,V=!0;break}a++}return V||(a++,h=1),c=s.substring(P,a),n=13}return c+=String.fromCharCode(F),a++,n=16}case 45:if(c+=String.fromCharCode(F),a++,a===d||!k(s.charCodeAt(a)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=L(),n=11;default:for(;a<d&&x(F);)a++,F=s.charCodeAt(a);if(u!==a){switch(c=s.substring(u,a),c){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return c+=String.fromCharCode(F),a++,n=16}}function x(F){if(R(F)||D(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let F;do F=Z();while(F>=12&&F<=15);return F}return{setPosition:A,getPosition:()=>a,scan:o?O:Z,getToken:()=>n,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>a-u,getTokenError:()=>h}}e.createScanner=C;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function D(s){return s===10||s===13||s===8232||s===8233}function k(s){return s>=48&&s<=57}var M;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(M||(M={}));function S(s,o){const a=[],d=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function h(g,A,L,q){u.value=g,u.offset=A,u.length=L,u.type=q,u.colonOffset=void 0,c=u}try{b(s,{onObjectBegin:(g,A)=>{if(o<=g)throw d;c=void 0,n=o>g,a.push("")},onObjectProperty:(g,A,L)=>{if(o<A||(h(g,A,L,"property"),a[a.length-1]=g,o<=A+L))throw d},onObjectEnd:(g,A)=>{if(o<=g)throw d;c=void 0,a.pop()},onArrayBegin:(g,A)=>{if(o<=g)throw d;c=void 0,a.push(0)},onArrayEnd:(g,A)=>{if(o<=g)throw d;c=void 0,a.pop()},onLiteralValue:(g,A,L)=>{if(o<A||(h(g,A,L,w(g)),o<=A+L))throw d},onSeparator:(g,A,L)=>{if(o<=A)throw d;if(g===":"&&c&&c.type==="property")c.colonOffset=A,n=!1,c=void 0;else if(g===","){const q=a[a.length-1];typeof q=="number"?a[a.length-1]=q+1:(n=!0,a[a.length-1]=""),c=void 0}}})}catch(g){if(g!==d)throw g}return{path:a,previousNode:c,isAtPropertyKey:n,matches:g=>{let A=0;for(let L=0;A<g.length&&L<a.length;L++)if(g[A]===a[L]||g[A]==="*")A++;else if(g[A]!=="**")return!1;return A===g.length}}}e.getLocation=S;function f(s,o=[],a=N.DEFAULT){let d=null,c=[];const u=[];function n(g){Array.isArray(c)?c.push(g):d!==null&&(c[d]=g)}return b(s,{onObjectBegin:()=>{const g={};n(g),u.push(c),c=g,d=null},onObjectProperty:g=>{d=g},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const g=[];n(g),u.push(c),c=g,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:n,onError:(g,A,L)=>{o.push({error:g,offset:A,length:L})}},a),c[0]}e.parse=f;function p(s,o=[],a=N.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(g){d.type==="property"&&(d.length=g-d.offset,d=d.parent)}function u(g){return d.children.push(g),g}b(s,{onObjectBegin:g=>{d=u({type:"object",offset:g,length:-1,parent:d,children:[]})},onObjectProperty:(g,A,L)=>{d=u({type:"property",offset:A,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:g,offset:A,length:L,parent:d})},onObjectEnd:(g,A)=>{d.length=g+A-d.offset,d=d.parent,c(g+A)},onArrayBegin:(g,A)=>{d=u({type:"array",offset:g,length:-1,parent:d,children:[]})},onArrayEnd:(g,A)=>{d.length=g+A-d.offset,d=d.parent,c(g+A)},onLiteralValue:(g,A,L)=>{u({type:w(g),offset:A,length:L,parent:d,value:g}),c(A+L)},onSeparator:(g,A,L)=>{d.type==="property"&&(g===":"?d.colonOffset=A:g===","&&c(A))},onError:(g,A,L)=>{o.push({error:g,offset:A,length:L})}},a);const h=d.children[0];return h&&delete h.parent,h}e.parseTree=p;function m(s,o){if(!s)return;let a=s;for(const d of o)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const u of a.children)if(Array.isArray(u.children)&&u.children[0].value===d){a=u.children[1],c=!0;break}if(!c)return}else{const c=d;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=m;function i(s){if(!s.parent||!s.parent.children)return[];const o=i(s.parent);if(s.parent.type==="property"){const a=s.parent.children[0].value;o.push(a)}else if(s.parent.type==="array"){const a=s.parent.children.indexOf(s);a!==-1&&o.push(a)}return o}e.getNodePath=i;function r(s){switch(s.type){case"array":return s.children.map(r);case"object":{const o=Object.create(null);for(const a of s.children){const d=a.children[1];d&&(o[a.children[0].value]=r(d))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=r;function l(s,o,a=!1){return o>=s.offset&&o<s.offset+s.length||a&&o===s.offset+s.length}e.contains=l;function v(s,o,a=!1){if(l(s,o,a)){const d=s.children;if(Array.isArray(d))for(let c=0;c<d.length&&d[c].offset<=o;c++){const u=v(d[c],o,a);if(u)return u}return s}}e.findNodeAtOffset=v;function b(s,o,a=N.DEFAULT){const d=C(s,!1);function c(Ie){return Ie?()=>Ie(d.getTokenOffset(),d.getTokenLength()):()=>!0}function u(Ie){return Ie?G=>Ie(G,d.getTokenOffset(),d.getTokenLength()):()=>!0}const n=c(o.onObjectBegin),h=u(o.onObjectProperty),g=c(o.onObjectEnd),A=c(o.onArrayBegin),L=c(o.onArrayEnd),q=u(o.onLiteralValue),Z=u(o.onSeparator),x=c(o.onComment),O=u(o.onError),F=a&&a.disallowComments,P=a&&a.allowTrailingComma;function B(){for(;;){const Ie=d.scan();switch(d.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:F||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(Ie){case 12:case 13:F?V(10):x();break;case 16:V(1);break;case 15:case 14:break;default:return Ie}}}function V(Ie,G=[],j=[]){if(O(Ie),G.length+j.length>0){let re=d.getToken();for(;re!==17;){if(G.indexOf(re)!==-1){B();break}else if(j.indexOf(re)!==-1)break;re=B()}}}function z(Ie){const G=d.getTokenValue();return Ie?q(G):h(G),B(),!0}function ne(){switch(d.getToken()){case 11:{let Ie=0;try{Ie=JSON.parse(d.getTokenValue()),typeof Ie!="number"&&(V(2),Ie=0)}catch{V(2)}q(Ie);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return B(),!0}function de(){return d.getToken()!==10?(V(3,[],[2,5]),!1):(z(!1),d.getToken()===6?(Z(":"),B(),ae()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function we(){n(),B();let Ie=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(Ie||V(4,[],[]),Z(","),B(),d.getToken()===2&&P)break}else Ie&&V(6,[],[]);de()||V(4,[],[2,5]),Ie=!0}return g(),d.getToken()!==2?V(7,[2],[]):B(),!0}function ue(){A(),B();let Ie=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(Ie||V(4,[],[]),Z(","),B(),d.getToken()===4&&P)break}else Ie&&V(6,[],[]);ae()||V(4,[],[4,5]),Ie=!0}return L(),d.getToken()!==4?V(8,[4],[]):B(),!0}function ae(){switch(d.getToken()){case 3:return ue();case 1:return we();case 10:return z(!0);default:return ne()}}return B(),d.getToken()===17?a.allowEmptyContent?!0:(V(4,[],[]),!1):ae()?(d.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=b;function E(s,o){const a=C(s),d=[];let c,u=0,n;do switch(n=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:u!==n&&d.push(s.substring(u,n)),o!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,o)),u=a.getPosition();break}while(c!==17);return d.join("")}e.stripComments=E;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(Ce[28],ke([1,0]),function(ee,e){"use strict";var t,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function N(m,i,r){let l=m.get(i);return l===void 0&&(l=r,m.set(i,l)),l}e.getOrSet=N;function C(m){const i=[];return m.forEach((r,l)=>{i.push(`${l} => ${r}`)}),`Map(${m.size}) {${i.join(", ")}}`}e.mapToString=C;function R(m){const i=[];return m.forEach(r=>{i.push(r)}),`Set(${m.size}) {${i.join(", ")}}`}e.setToString=R;class D{constructor(i,r){this.uri=i,this.value=r}}class k{constructor(i,r){this[t]="ResourceMap",i instanceof k?(this.b=new Map(i.b),this.c=r??k.a):(this.b=new Map,this.c=i??k.a)}set(i,r){return this.b.set(this.c(i),new D(i,r)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,r){typeof r<"u"&&(i=i.bind(r));for(const[l,v]of this.b)i(v.value,v.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.ResourceMap=k,k.a=m=>m.toString();class M{constructor(i,r){this[T]="ResourceSet",!i||typeof i=="function"?this.a=new k(i):(this.a=new k(r),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,r){this.a.forEach((l,v)=>i.call(r,v,v,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=M;var S;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class f{constructor(){this[y]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,r=0){const l=this.a.get(i);if(!!l)return r!==0&&this.j(l,r),l.value}set(i,r,l=0){let v=this.a.get(i);if(v)v.value=r,l!==0&&this.j(v,l);else{switch(v={key:i,value:r,next:void 0,previous:void 0},l){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(i,v),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this.a.get(i);if(!!r)return this.a.delete(i),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,r){const l=this.e;let v=this.b;for(;v;){if(r?i.bind(r)(v.value,v.key,this):i(v.value,v.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const i=this,r=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(i.e!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return v}values(){const i=this,r=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(i.e!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return v}entries(){const i=this,r=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(i.e!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return v}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this.b,l=this.size;for(;r&&l>i;)this.a.delete(r.key),r=r.next,l--;this.b=r,this.d=l,r&&(r.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const r=i.next,l=i.previous;if(!r||!l)throw new Error("Invalid list");r.previous=l,l.next=r}i.next=void 0,i.previous=void 0,this.e++}j(i,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this.b)return;const l=i.next,v=i.previous;i===this.c?(v.next=void 0,this.c=v):(l.previous=v,v.next=l),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(r===2){if(i===this.c)return;const l=i.next,v=i.previous;i===this.b?(l.previous=void 0,this.b=l):(l.previous=v,v.next=l),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((r,l)=>{i.push([l,r])}),i}fromJSON(i){this.clear();for(const[r,l]of i)this.set(r,l)}}e.LinkedMap=f;class p extends f{constructor(i,r=1){super(),this.k=i,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[110],ke([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Pe,De){for(var Se=0;Se<De.length;Se++){var se=De[Se];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Pe,se.key,se)}}function t(Pe,De,Se){return De&&e(Pe.prototype,De),Se&&e(Pe,Se),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function T(Pe,De){if(!!Pe){if(typeof Pe=="string")return y(Pe,De);var Se=Object.prototype.toString.call(Pe).slice(8,-1);if(Se==="Object"&&Pe.constructor&&(Se=Pe.constructor.name),Se==="Map"||Se==="Set")return Array.from(Pe);if(Se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Se))return y(Pe,De)}}function y(Pe,De){(De==null||De>Pe.length)&&(De=Pe.length);for(var Se=0,se=new Array(De);Se<De;Se++)se[Se]=Pe[Se];return se}function N(Pe,De){var Se=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Se)return(Se=Se.call(Pe)).next.bind(Se);if(Array.isArray(Pe)||(Se=T(Pe))||De&&Pe&&typeof Pe.length=="number"){Se&&(Pe=Se);var se=0;return function(){return se>=Pe.length?{done:!0}:{done:!1,value:Pe[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=C();function R(Pe){ee.defaults=Pe}var D=/[&<>"']/,k=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(De){return f[De]};function m(Pe,De){if(De){if(D.test(Pe))return Pe.replace(k,p)}else if(M.test(Pe))return Pe.replace(S,p);return Pe}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(Pe){return Pe.replace(i,function(De,Se){return Se=Se.toLowerCase(),Se==="colon"?":":Se.charAt(0)==="#"?Se.charAt(1)==="x"?String.fromCharCode(parseInt(Se.substring(2),16)):String.fromCharCode(+Se.substring(1)):""})}var l=/(^|[^\[])\^/g;function v(Pe,De){Pe=typeof Pe=="string"?Pe:Pe.source,De=De||"";var Se={replace:function(ce,Y){return Y=Y.source||Y,Y=Y.replace(l,"$1"),Pe=Pe.replace(ce,Y),Se},getRegex:function(){return new RegExp(Pe,De)}};return Se}var b=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Pe,De,Se){if(Pe){var se;try{se=decodeURIComponent(r(Se)).replace(b,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}De&&!E.test(Se)&&(Se=c(De,Se));try{Se=encodeURI(Se).replace(/%25/g,"%")}catch{return null}return Se}var s={},o=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Pe,De){s[" "+Pe]||(o.test(Pe)?s[" "+Pe]=Pe+"/":s[" "+Pe]=g(Pe,"/",!0)),Pe=s[" "+Pe];var Se=Pe.indexOf(":")===-1;return De.substring(0,2)==="//"?Se?De:Pe.replace(a,"$1")+De:De.charAt(0)==="/"?Se?De:Pe.replace(d,"$1")+De:Pe+De}var u={exec:function(){}};function n(Pe){for(var De=1,Se,se;De<arguments.length;De++){Se=arguments[De];for(se in Se)Object.prototype.hasOwnProperty.call(Se,se)&&(Pe[se]=Se[se])}return Pe}function h(Pe,De){var Se=Pe.replace(/\|/g,function(Y,I,$){for(var H=!1,K=I;--K>=0&&$[K]==="\\";)H=!H;return H?"|":" |"}),se=Se.split(/ \|/),ce=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>De)se.splice(De);else for(;se.length<De;)se.push("");for(;ce<se.length;ce++)se[ce]=se[ce].trim().replace(/\\\|/g,"|");return se}function g(Pe,De,Se){var se=Pe.length;if(se===0)return"";for(var ce=0;ce<se;){var Y=Pe.charAt(se-ce-1);if(Y===De&&!Se)ce++;else if(Y!==De&&Se)ce++;else break}return Pe.slice(0,se-ce)}function A(Pe,De){if(Pe.indexOf(De[1])===-1)return-1;for(var Se=Pe.length,se=0,ce=0;ce<Se;ce++)if(Pe[ce]==="\\")ce++;else if(Pe[ce]===De[0])se++;else if(Pe[ce]===De[1]&&(se--,se<0))return ce;return-1}function L(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function q(Pe,De){if(De<1)return"";for(var Se="";De>1;)De&1&&(Se+=Pe),De>>=1,Pe+=Pe;return Se+Pe}function Z(Pe,De,Se,se){var ce=De.href,Y=De.title?m(De.title):null,I=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){se.state.inLink=!0;var $={type:"link",raw:Se,href:ce,title:Y,text:I,tokens:se.inlineTokens(I)};return se.state.inLink=!1,$}return{type:"image",raw:Se,href:ce,title:Y,text:m(I)}}function x(Pe,De){var Se=Pe.match(/^(\s+)(?:```)/);if(Se===null)return De;var se=Se[1];return De.split(`
`).map(function(ce){var Y=ce.match(/^\s+/);if(Y===null)return ce;var I=Y[0];return I.length>=se.length?ce.slice(se.length):ce}).join(`
`)}var O=function(){function Pe(Se){this.options=Se||ee.defaults}var De=Pe.prototype;return De.space=function(se){var ce=this.rules.block.newline.exec(se);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},De.code=function(se){var ce=this.rules.block.code.exec(se);if(ce){var Y=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:g(Y,`
`)}}},De.fences=function(se){var ce=this.rules.block.fences.exec(se);if(ce){var Y=ce[0],I=x(Y,ce[3]||"");return{type:"code",raw:Y,lang:ce[2]?ce[2].trim():ce[2],text:I}}},De.heading=function(se){var ce=this.rules.block.heading.exec(se);if(ce){var Y=ce[2].trim();if(/#$/.test(Y)){var I=g(Y,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Y=I.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:Y,tokens:this.lexer.inline(Y)}}},De.hr=function(se){var ce=this.rules.block.hr.exec(se);if(ce)return{type:"hr",raw:ce[0]}},De.blockquote=function(se){var ce=this.rules.block.blockquote.exec(se);if(ce){var Y=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},De.list=function(se){var ce=this.rules.block.list.exec(se);if(ce){var Y,I,$,H,K,J,le,Ee,oe,pe,ve,We,He=ce[1].trim(),tt=He.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(We=!1,!(!(ce=et.exec(se))||this.rules.block.hr.test(se)));){if(Y=ce[0],se=se.substring(Y.length),Ee=ce[2].split(`
`,1)[0],oe=se.split(`
`,1)[0],this.options.pedantic?(H=2,ve=Ee.trimLeft()):(H=ce[2].search(/[^ ]/),H=H>4?1:H,ve=Ee.slice(H),H+=ce[1].length),J=!1,!Ee&&/^ *$/.test(oe)&&(Y+=oe+`
`,se=se.substring(oe.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");se&&(pe=se.split(`
`,1)[0],Ee=pe,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(Ee)||st.test(Ee)||it.test(Ee)||dt.test(se)));){if(Ee.search(/[^ ]/)>=H||!Ee.trim())ve+=`
`+Ee.slice(H);else if(!J)ve+=`
`+Ee;else break;!J&&!Ee.trim()&&(J=!0),Y+=pe+`
`,se=se.substring(pe.length+1)}Xe.loose||(le?Xe.loose=!0:/\n *\n *$/.test(Y)&&(le=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(ve),I&&($=I[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Y,task:!!I,checked:$,loose:!1,text:ve}),Xe.raw+=Y}Xe.items[Xe.items.length-1].raw=Y.trimRight(),Xe.items[Xe.items.length-1].text=ve.trimRight(),Xe.raw=Xe.raw.trimRight();var Q=Xe.items.length;for(K=0;K<Q;K++){this.lexer.state.top=!1,Xe.items[K].tokens=this.lexer.blockTokens(Xe.items[K].text,[]);var _=Xe.items[K].tokens.filter(function(Le){return Le.type==="space"}),ge=_.every(function(Le){for(var $e=Le.raw.split(""),Ve=0,Qe=N($e),nt;!(nt=Qe()).done;){var wt=nt.value;if(wt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Xe.loose&&_.length&&ge&&(Xe.loose=!0,Xe.items[K].loose=!0)}return Xe}},De.html=function(se){var ce=this.rules.block.html.exec(se);if(ce){var Y={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ce[0]):m(ce[0]);Y.type="paragraph",Y.text=I,Y.tokens=this.lexer.inline(I)}return Y}},De.def=function(se){var ce=this.rules.block.def.exec(se);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var Y=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ce[0],href:ce[2],title:ce[3]}}},De.table=function(se){var ce=this.rules.block.table.exec(se);if(ce){var Y={type:"table",header:h(ce[1]).map(function(le){return{text:le}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ce[0];var I=Y.align.length,$,H,K,J;for($=0;$<I;$++)/^ *-+: *$/.test(Y.align[$])?Y.align[$]="right":/^ *:-+: *$/.test(Y.align[$])?Y.align[$]="center":/^ *:-+ *$/.test(Y.align[$])?Y.align[$]="left":Y.align[$]=null;for(I=Y.rows.length,$=0;$<I;$++)Y.rows[$]=h(Y.rows[$],Y.header.length).map(function(le){return{text:le}});for(I=Y.header.length,H=0;H<I;H++)Y.header[H].tokens=this.lexer.inline(Y.header[H].text);for(I=Y.rows.length,H=0;H<I;H++)for(J=Y.rows[H],K=0;K<J.length;K++)J[K].tokens=this.lexer.inline(J[K].text);return Y}}},De.lheading=function(se){var ce=this.rules.block.lheading.exec(se);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},De.paragraph=function(se){var ce=this.rules.block.paragraph.exec(se);if(ce){var Y=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:Y,tokens:this.lexer.inline(Y)}}},De.text=function(se){var ce=this.rules.block.text.exec(se);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},De.escape=function(se){var ce=this.rules.inline.escape.exec(se);if(ce)return{type:"escape",raw:ce[0],text:m(ce[1])}},De.tag=function(se){var ce=this.rules.inline.tag.exec(se);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):m(ce[0]):ce[0]}},De.link=function(se){var ce=this.rules.inline.link.exec(se);if(ce){var Y=ce[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var I=g(Y.slice(0,-1),"\\");if((Y.length-I.length)%2===0)return}else{var $=A(ce[2],"()");if($>-1){var H=ce[0].indexOf("!")===0?5:4,K=H+ce[1].length+$;ce[2]=ce[2].substring(0,$),ce[0]=ce[0].substring(0,K).trim(),ce[3]=""}}var J=ce[2],le="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);Ee&&(J=Ee[1],le=Ee[3])}else le=ce[3]?ce[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(Y)?J=J.slice(1):J=J.slice(1,-1)),Z(ce,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:le&&le.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},De.reflink=function(se,ce){var Y;if((Y=this.rules.inline.reflink.exec(se))||(Y=this.rules.inline.nolink.exec(se))){var I=(Y[2]||Y[1]).replace(/\s+/g," ");if(I=ce[I.toLowerCase()],!I||!I.href){var $=Y[0].charAt(0);return{type:"text",raw:$,text:$}}return Z(Y,I,Y[0],this.lexer)}},De.emStrong=function(se,ce,Y){Y===void 0&&(Y="");var I=this.rules.inline.emStrong.lDelim.exec(se);if(!!I&&!(I[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=I[1]||I[2]||"";if(!$||$&&(Y===""||this.rules.inline.punctuation.exec(Y))){var H=I[0].length-1,K,J,le=H,Ee=0,oe=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,ce=ce.slice(-1*se.length+H);(I=oe.exec(ce))!=null;)if(K=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!K){if(J=K.length,I[3]||I[4]){le+=J;continue}else if((I[5]||I[6])&&H%3&&!((H+J)%3)){Ee+=J;continue}if(le-=J,!(le>0)){if(J=Math.min(J,J+le+Ee),Math.min(H,J)%2){var pe=se.slice(1,H+I.index+J);return{type:"em",raw:se.slice(0,H+I.index+J+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var ve=se.slice(2,H+I.index+J-1);return{type:"strong",raw:se.slice(0,H+I.index+J+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},De.codespan=function(se){var ce=this.rules.inline.code.exec(se);if(ce){var Y=ce[2].replace(/\n/g," "),I=/[^ ]/.test(Y),$=/^ /.test(Y)&&/ $/.test(Y);return I&&$&&(Y=Y.substring(1,Y.length-1)),Y=m(Y,!0),{type:"codespan",raw:ce[0],text:Y}}},De.br=function(se){var ce=this.rules.inline.br.exec(se);if(ce)return{type:"br",raw:ce[0]}},De.del=function(se){var ce=this.rules.inline.del.exec(se);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},De.autolink=function(se,ce){var Y=this.rules.inline.autolink.exec(se);if(Y){var I,$;return Y[2]==="@"?(I=m(this.options.mangle?ce(Y[1]):Y[1]),$="mailto:"+I):(I=m(Y[1]),$=I),{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},De.url=function(se,ce){var Y;if(Y=this.rules.inline.url.exec(se)){var I,$;if(Y[2]==="@")I=m(this.options.mangle?ce(Y[0]):Y[0]),$="mailto:"+I;else{var H;do H=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(H!==Y[0]);I=m(Y[0]),Y[1]==="www."?$="http://"+I:$=I}return{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},De.inlineText=function(se,ce){var Y=this.rules.inline.text.exec(se);if(Y){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]:I=m(this.options.smartypants?ce(Y[0]):Y[0]),{type:"text",raw:Y[0],text:I}}},Pe}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=v(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=v(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=v(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=v(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=v(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=v(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=n({},F),F.gfm=n({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=v(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=v(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=n({},F.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:v(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=v(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=v(F._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=v(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=v(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=v(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=v(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=v(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=v(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=v(P.reflink).replace("label",P._label).replace("ref",F._label).getRegex(),P.nolink=v(P.nolink).replace("ref",F._label).getRegex(),P.reflinkSearch=v(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=n({},P),P.pedantic=n({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=n({},P.normal,{escape:v(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=v(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=n({},P.gfm,{br:v(P.br).replace("{2,}","*").getRegex(),text:v(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Pe){var De="",Se,se,ce=Pe.length;for(Se=0;Se<ce;Se++)se=Pe.charCodeAt(Se),Math.random()>.5&&(se="x"+se.toString(16)),De+="&#"+se+";";return De}var z=function(){function Pe(Se){this.tokens=[],this.tokens.links=Object.create(null),this.options=Se||ee.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:F.normal,inline:P.normal};this.options.pedantic?(se.block=F.pedantic,se.inline=P.pedantic):this.options.gfm&&(se.block=F.gfm,this.options.breaks?se.inline=P.breaks:se.inline=P.gfm),this.tokenizer.rules=se}Pe.lex=function(se,ce){var Y=new Pe(ce);return Y.lex(se)},Pe.lexInline=function(se,ce){var Y=new Pe(ce);return Y.inlineTokens(se)};var De=Pe.prototype;return De.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},De.blockTokens=function(se,ce){var Y=this;ce===void 0&&(ce=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(le,Ee,oe){return Ee+"    ".repeat(oe.length)});for(var I,$,H,K;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(le){return(I=le.call({lexer:Y},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.space(se)){se=se.substring(I.raw.length),I.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(I);continue}if(I=this.tokenizer.code(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(I=this.tokenizer.fences(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.heading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.hr(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.blockquote(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.list(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.html(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.def(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.lheading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(H=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var le=1/0,Ee=se.slice(1),oe=void 0;Y.options.extensions.startBlock.forEach(function(pe){oe=pe.call({lexer:this},Ee),typeof oe=="number"&&oe>=0&&(le=Math.min(le,oe))}),le<1/0&&le>=0&&(H=se.substring(0,le+1))}(),this.state.top&&(I=this.tokenizer.paragraph(H))){$=ce[ce.length-1],K&&$.type==="paragraph"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I),K=H.length!==se.length,se=se.substring(I.raw.length);continue}if(I=this.tokenizer.text(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&$.type==="text"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(se){var J="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,ce},De.inline=function(se,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:se,tokens:ce}),ce},De.inlineTokens=function(se,ce){var Y=this;ce===void 0&&(ce=[]);var I,$,H,K=se,J,le,Ee;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)oe.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,J.index)+"["+q("a",J[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,J.index)+"["+q("a",J[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,J.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(le||(Ee=""),le=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(I=ve.call({lexer:Y},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.escape(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.tag(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.link(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.emStrong(se,K,Ee)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.codespan(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.br(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.del(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.autolink(se,V)){se=se.substring(I.raw.length),ce.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(se,V))){se=se.substring(I.raw.length),ce.push(I);continue}if(H=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,We=se.slice(1),He=void 0;Y.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},We),typeof He=="number"&&He>=0&&(ve=Math.min(ve,He))}),ve<1/0&&ve>=0&&(H=se.substring(0,ve+1))}(),I=this.tokenizer.inlineText(H,B)){se=se.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(Ee=I.raw.slice(-1)),le=!0,$=ce[ce.length-1],$&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(se){var pe="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return ce},t(Pe,null,[{key:"rules",get:function(){return{block:F,inline:P}}}]),Pe}(),ne=function(){function Pe(Se){this.options=Se||ee.defaults}var De=Pe.prototype;return De.code=function(se,ce,Y){var I=(ce||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(se,I);$!=null&&$!==se&&(Y=!0,se=$)}return se=se.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+m(I,!0)+'">'+(Y?se:m(se,!0))+`</code></pre>
`:"<pre><code>"+(Y?se:m(se,!0))+`</code></pre>
`},De.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},De.html=function(se){return se},De.heading=function(se,ce,Y,I){if(this.options.headerIds){var $=this.options.headerPrefix+I.slug(Y);return"<h"+ce+' id="'+$+'">'+se+"</h"+ce+`>
`}return"<h"+ce+">"+se+"</h"+ce+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(se,ce,Y){var I=ce?"ol":"ul",$=ce&&Y!==1?' start="'+Y+'"':"";return"<"+I+$+`>
`+se+"</"+I+`>
`},De.listitem=function(se){return"<li>"+se+`</li>
`},De.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(se){return"<p>"+se+`</p>
`},De.table=function(se,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ce+`</table>
`},De.tablerow=function(se){return`<tr>
`+se+`</tr>
`},De.tablecell=function(se,ce){var Y=ce.header?"th":"td",I=ce.align?"<"+Y+' align="'+ce.align+'">':"<"+Y+">";return I+se+("</"+Y+`>
`)},De.strong=function(se){return"<strong>"+se+"</strong>"},De.em=function(se){return"<em>"+se+"</em>"},De.codespan=function(se){return"<code>"+se+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(se){return"<del>"+se+"</del>"},De.link=function(se,ce,Y){if(se=w(this.options.sanitize,this.options.baseUrl,se),se===null)return Y;var I='<a href="'+m(se)+'"';return ce&&(I+=' title="'+ce+'"'),I+=">"+Y+"</a>",I},De.image=function(se,ce,Y){if(se=w(this.options.sanitize,this.options.baseUrl,se),se===null)return Y;var I='<img src="'+se+'" alt="'+Y+'"';return ce&&(I+=' title="'+ce+'"'),I+=this.options.xhtml?"/>":">",I},De.text=function(se){return se},Pe}(),de=function(){function Pe(){}var De=Pe.prototype;return De.strong=function(se){return se},De.em=function(se){return se},De.codespan=function(se){return se},De.del=function(se){return se},De.html=function(se){return se},De.text=function(se){return se},De.link=function(se,ce,Y){return""+Y},De.image=function(se,ce,Y){return""+Y},De.br=function(){return""},Pe}(),we=function(){function Pe(){this.seen={}}var De=Pe.prototype;return De.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(se,ce){var Y=se,I=0;if(this.seen.hasOwnProperty(Y)){I=this.seen[se];do I++,Y=se+"-"+I;while(this.seen.hasOwnProperty(Y))}return ce||(this.seen[se]=I,this.seen[Y]=0),Y},De.slug=function(se,ce){ce===void 0&&(ce={});var Y=this.serialize(se);return this.getNextSafeSlug(Y,ce.dryrun)},Pe}(),ue=function(){function Pe(Se){this.options=Se||ee.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new we}Pe.parse=function(se,ce){var Y=new Pe(ce);return Y.parse(se)},Pe.parseInline=function(se,ce){var Y=new Pe(ce);return Y.parseInline(se)};var De=Pe.prototype;return De.parse=function(se,ce){ce===void 0&&(ce=!0);var Y="",I,$,H,K,J,le,Ee,oe,pe,ve,We,He,tt,Xe,et,it,dt,Fe,st,Q=se.length;for(I=0;I<Q;I++){if(ve=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(st=this.options.extensions.renderers[ve.type].call({parser:this},ve),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){Y+=st||"";continue}switch(ve.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,r(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(oe="",Ee="",K=ve.header.length,$=0;$<K;$++)Ee+=this.renderer.tablecell(this.parseInline(ve.header[$].tokens),{header:!0,align:ve.align[$]});for(oe+=this.renderer.tablerow(Ee),pe="",K=ve.rows.length,$=0;$<K;$++){for(le=ve.rows[$],Ee="",J=le.length,H=0;H<J;H++)Ee+=this.renderer.tablecell(this.parseInline(le[H].tokens),{header:!1,align:ve.align[H]});pe+=this.renderer.tablerow(Ee)}Y+=this.renderer.table(oe,pe);continue}case"blockquote":{pe=this.parse(ve.tokens),Y+=this.renderer.blockquote(pe);continue}case"list":{for(We=ve.ordered,He=ve.start,tt=ve.loose,K=ve.items.length,pe="",$=0;$<K;$++)et=ve.items[$],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),pe+=this.renderer.listitem(Xe,dt,it);Y+=this.renderer.list(pe,We,He);continue}case"html":{Y+=this.renderer.html(ve.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(pe=ve.tokens?this.parseInline(ve.tokens):ve.text;I+1<Q&&se[I+1].type==="text";)ve=se[++I],pe+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);Y+=ce?this.renderer.paragraph(pe):pe;continue}default:{var _='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(_);return}else throw new Error(_)}}}return Y},De.parseInline=function(se,ce){ce=ce||this.renderer;var Y="",I,$,H,K=se.length;for(I=0;I<K;I++){if($=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(H=this.options.extensions.renderers[$.type].call({parser:this},$),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){Y+=H||"";continue}switch($.type){case"escape":{Y+=ce.text($.text);break}case"html":{Y+=ce.html($.text);break}case"link":{Y+=ce.link($.href,$.title,this.parseInline($.tokens,ce));break}case"image":{Y+=ce.image($.href,$.title,$.text);break}case"strong":{Y+=ce.strong(this.parseInline($.tokens,ce));break}case"em":{Y+=ce.em(this.parseInline($.tokens,ce));break}case"codespan":{Y+=ce.codespan($.text);break}case"br":{Y+=ce.br();break}case"del":{Y+=ce.del(this.parseInline($.tokens,ce));break}case"text":{Y+=ce.text($.text);break}default:{var J='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return Y},Pe}();function ae(Pe,De,Se){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof De=="function"&&(Se=De,De=null),De=n({},ae.defaults,De||{}),L(De),Se){var se=De.highlight,ce;try{ce=z.lex(Pe,De)}catch(K){return Se(K)}var Y=function(J){var le;if(!J)try{De.walkTokens&&ae.walkTokens(ce,De.walkTokens),le=ue.parse(ce,De)}catch(Ee){J=Ee}return De.highlight=se,J?Se(J):Se(null,le)};if(!se||se.length<3||(delete De.highlight,!ce.length))return Y();var I=0;ae.walkTokens(ce,function(K){K.type==="code"&&(I++,setTimeout(function(){se(K.text,K.lang,function(J,le){if(J)return Y(J);le!=null&&le!==K.text&&(K.text=le,K.escaped=!0),I--,I===0&&Y()})},0))}),I===0&&Y();return}function $(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+m(K.message+"",!0)+"</pre>";throw K}try{var H=z.lex(Pe,De);if(De.walkTokens){if(De.async)return Promise.all(ae.walkTokens(H,De.walkTokens)).then(function(){return ue.parse(H,De)}).catch($);ae.walkTokens(H,De.walkTokens)}return ue.parse(H,De)}catch(K){$(K)}}ae.options=ae.setOptions=function(Pe){return n(ae.defaults,Pe),R(ae.defaults),ae},ae.getDefaults=C,ae.defaults=ee.defaults,ae.use=function(){for(var Pe=arguments.length,De=new Array(Pe),Se=0;Se<Pe;Se++)De[Se]=arguments[Se];var se=n.apply(void 0,[{}].concat(De)),ce=ae.defaults.extensions||{renderers:{},childTokens:{}},Y;De.forEach(function(I){if(I.extensions&&(Y=!0,I.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var K=ce.renderers?ce.renderers[H.name]:null;K?ce.renderers[H.name]=function(){for(var J=arguments.length,le=new Array(J),Ee=0;Ee<J;Ee++)le[Ee]=arguments[Ee];var oe=H.renderer.apply(this,le);return oe===!1&&(oe=K.apply(this,le)),oe}:ce.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[H.level]?ce[H.level].unshift(H.tokenizer):ce[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ce.startBlock?ce.startBlock.push(H.start):ce.startBlock=[H.start]:H.level==="inline"&&(ce.startInline?ce.startInline.push(H.start):ce.startInline=[H.start]))}H.childTokens&&(ce.childTokens[H.name]=H.childTokens)})),I.renderer&&function(){var H=ae.defaults.renderer||new ne,K=function(Ee){var oe=H[Ee];H[Ee]=function(){for(var pe=arguments.length,ve=new Array(pe),We=0;We<pe;We++)ve[We]=arguments[We];var He=I.renderer[Ee].apply(H,ve);return He===!1&&(He=oe.apply(H,ve)),He}};for(var J in I.renderer)K(J);se.renderer=H}(),I.tokenizer&&function(){var H=ae.defaults.tokenizer||new O,K=function(Ee){var oe=H[Ee];H[Ee]=function(){for(var pe=arguments.length,ve=new Array(pe),We=0;We<pe;We++)ve[We]=arguments[We];var He=I.tokenizer[Ee].apply(H,ve);return He===!1&&(He=oe.apply(H,ve)),He}};for(var J in I.tokenizer)K(J);se.tokenizer=H}(),I.walkTokens){var $=ae.defaults.walkTokens;se.walkTokens=function(H){var K=[];return K.push(I.walkTokens.call(this,H)),$&&(K=K.concat($.call(this,H))),K}}Y&&(se.extensions=ce),ae.setOptions(se)})},ae.walkTokens=function(Pe,De){for(var Se=[],se=function(){var $=Y.value;switch(Se=Se.concat(De.call(ae,$)),$.type){case"table":{for(var H=N($.header),K;!(K=H()).done;){var J=K.value;Se=Se.concat(ae.walkTokens(J.tokens,De))}for(var le=N($.rows),Ee;!(Ee=le()).done;)for(var oe=Ee.value,pe=N(oe),ve;!(ve=pe()).done;){var We=ve.value;Se=Se.concat(ae.walkTokens(We.tokens,De))}break}case"list":{Se=Se.concat(ae.walkTokens($.items,De));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[$.type]?ae.defaults.extensions.childTokens[$.type].forEach(function(He){Se=Se.concat(ae.walkTokens($[He],De))}):$.tokens&&(Se=Se.concat(ae.walkTokens($.tokens,De)))}},ce=N(Pe),Y;!(Y=ce()).done;)se();return Se},ae.parseInline=function(Pe,De){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");De=n({},ae.defaults,De||{}),L(De);try{var Se=z.lexInline(Pe,De);return De.walkTokens&&ae.walkTokens(Se,De.walkTokens),ue.parseInline(Se,De)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+m(se.message+"",!0)+"</pre>";throw se}},ae.Parser=ue,ae.parser=ue.parse,ae.Renderer=ne,ae.TextRenderer=de,ae.Lexer=z,ae.lexer=z.lex,ae.Tokenizer=O,ae.Slugger=we,ae.parse=ae;var Ie=ae.options,G=ae.setOptions,j=ae.use,re=ae.walkTokens,me=ae.parseInline,Te=ae,Be=ue.parse,Ge=z.lex;ee.Lexer=z,ee.Parser=ue,ee.Renderer=ne,ee.Slugger=we,ee.TextRenderer=de,ee.Tokenizer=O,ee.getDefaults=C,ee.lexer=Ge,ee.marked=ae,ee.options=Ie,ee.parse=Te,ee.parseInline=me,ee.parser=Be,ee.setOptions=G,ee.use=j,ee.walkTokens=re,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ce[111],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function t(R,D,k){return Math.min(Math.max(R,D),k)}e.clamp=t;function T(R,D){return(D+R%D)%D}e.rot=T;class y{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=y;class N{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=N;class C{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const k=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ee(y){const N=[];typeof y=="number"&&N.push("code/timeOrigin",y);function C(D){N.push(D,Date.now())}function R(){const D=[];for(let k=0;k<N.length;k+=2)D.push({name:N[k],startTime:N[k+1]});return D}return{mark:C,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))N.push({name:C.name,startTime:Math.round(y+C.startTime)});return N}};if(typeof process=="object"){const y=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function t(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return t(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=t(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=t(T))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var t=e();for(var T in t)(typeof exports=="object"?exports:ee)[T]=t[T]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function t(T){if(e[T])return e[T].exports;var y=e[T]={i:T,l:!1,exports:{}};return ee[T].call(y.exports,y,y.exports,t),y.l=!0,y.exports}return t.m=ee,t.c=e,t.d=function(T,y,N){t.o(T,y)||Object.defineProperty(T,y,{enumerable:!0,get:N})},t.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},t.t=function(T,y){if(1&y&&(T=t(T)),8&y||4&y&&typeof T=="object"&&T&&T.__esModule)return T;var N=Object.create(null);if(t.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:T}),2&y&&typeof T!="string")for(var C in T)t.d(N,C,function(R){return T[R]}.bind(null,C));return N},t.n=function(T){var y=T&&T.__esModule?function(){return T.default}:function(){return T};return t.d(y,"a",y),y},t.o=function(T,y){return Object.prototype.hasOwnProperty.call(T,y)},t.p="",t(t.s=0)}([function(ee,e,t){(function(T){var y;e=ee.exports=j,y=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],D=e.src=[],k=0,M=k++;D[M]="0|[1-9]\\d*";var S=k++;D[S]="[0-9]+";var f=k++;D[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=k++;D[p]="("+D[M]+")\\.("+D[M]+")\\.("+D[M]+")";var m=k++;D[m]="("+D[S]+")\\.("+D[S]+")\\.("+D[S]+")";var i=k++;D[i]="(?:"+D[M]+"|"+D[f]+")";var r=k++;D[r]="(?:"+D[S]+"|"+D[f]+")";var l=k++;D[l]="(?:-("+D[i]+"(?:\\."+D[i]+")*))";var v=k++;D[v]="(?:-?("+D[r]+"(?:\\."+D[r]+")*))";var b=k++;D[b]="[0-9A-Za-z-]+";var E=k++;D[E]="(?:\\+("+D[b]+"(?:\\."+D[b]+")*))";var w=k++,s="v?"+D[p]+D[l]+"?"+D[E]+"?";D[w]="^"+s+"$";var o="[v=\\s]*"+D[m]+D[v]+"?"+D[E]+"?",a=k++;D[a]="^"+o+"$";var d=k++;D[d]="((?:<|>)?=?)";var c=k++;D[c]=D[S]+"|x|X|\\*";var u=k++;D[u]=D[M]+"|x|X|\\*";var n=k++;D[n]="[v=\\s]*("+D[u]+")(?:\\.("+D[u]+")(?:\\.("+D[u]+")(?:"+D[l]+")?"+D[E]+"?)?)?";var h=k++;D[h]="[v=\\s]*("+D[c]+")(?:\\.("+D[c]+")(?:\\.("+D[c]+")(?:"+D[v]+")?"+D[E]+"?)?)?";var g=k++;D[g]="^"+D[d]+"\\s*"+D[n]+"$";var A=k++;D[A]="^"+D[d]+"\\s*"+D[h]+"$";var L=k++;D[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=k++;D[q]="(?:~>?)";var Z=k++;D[Z]="(\\s*)"+D[q]+"\\s+",R[Z]=new RegExp(D[Z],"g");var x=k++;D[x]="^"+D[q]+D[n]+"$";var O=k++;D[O]="^"+D[q]+D[h]+"$";var F=k++;D[F]="(?:\\^)";var P=k++;D[P]="(\\s*)"+D[F]+"\\s+",R[P]=new RegExp(D[P],"g");var B=k++;D[B]="^"+D[F]+D[n]+"$";var V=k++;D[V]="^"+D[F]+D[h]+"$";var z=k++;D[z]="^"+D[d]+"\\s*("+o+")$|^$";var ne=k++;D[ne]="^"+D[d]+"\\s*("+s+")$|^$";var de=k++;D[de]="(\\s*)"+D[d]+"\\s*("+o+"|"+D[n]+")",R[de]=new RegExp(D[de],"g");var we=k++;D[we]="^\\s*("+D[n]+")\\s+-\\s+("+D[n]+")\\s*$";var ue=k++;D[ue]="^\\s*("+D[h]+")\\s+-\\s+("+D[h]+")\\s*$";var ae=k++;D[ae]="(<|>)?=?\\s*\\*";for(var Ie=0;Ie<35;Ie++)y(Ie,D[Ie]),R[Ie]||(R[Ie]=new RegExp(D[Ie]));function G(oe,pe){if(oe instanceof j)return oe;if(typeof oe!="string"||oe.length>N||!(pe?R[a]:R[w]).test(oe))return null;try{return new j(oe,pe)}catch{return null}}function j(oe,pe){if(oe instanceof j){if(oe.loose===pe)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof j))return new j(oe,pe);y("SemVer",oe,pe),this.loose=pe;var ve=oe.trim().match(pe?R[a]:R[w]);if(!ve)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var He=+We;if(He>=0&&He<C)return He}return We}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=G,e.valid=function(oe,pe){var ve=G(oe,pe);return ve?ve.version:null},e.clean=function(oe,pe){var ve=G(oe.trim().replace(/^[=v]+/,""),pe);return ve?ve.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(oe){return y("SemVer.compare",this.version,this.loose,oe),oe instanceof j||(oe=new j(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},j.prototype.compareMain=function(oe){return oe instanceof j||(oe=new j(oe,this.loose)),me(this.major,oe.major)||me(this.minor,oe.minor)||me(this.patch,oe.patch)},j.prototype.comparePre=function(oe){if(oe instanceof j||(oe=new j(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var pe=0;do{var ve=this.prerelease[pe],We=oe.prerelease[pe];if(y("prerelease compare",pe,ve,We),ve===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(ve===void 0)return-1;if(ve!==We)return me(ve,We)}while(++pe)},j.prototype.inc=function(oe,pe){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,pe,ve,We){typeof ve=="string"&&(We=ve,ve=void 0);try{return new j(oe,ve).inc(pe,We).version}catch{return null}},e.diff=function(oe,pe){if(Pe(oe,pe))return null;var ve=G(oe),We=G(pe);if(ve.prerelease.length||We.prerelease.length){for(var He in ve)if((He==="major"||He==="minor"||He==="patch")&&ve[He]!==We[He])return"pre"+He;return"prerelease"}for(var He in ve)if((He==="major"||He==="minor"||He==="patch")&&ve[He]!==We[He])return He},e.compareIdentifiers=me;var re=/^[0-9]+$/;function me(oe,pe){var ve=re.test(oe),We=re.test(pe);return ve&&We&&(oe=+oe,pe=+pe),ve&&!We?-1:We&&!ve?1:oe<pe?-1:oe>pe?1:0}function Te(oe,pe,ve){return new j(oe,ve).compare(new j(pe,ve))}function Be(oe,pe,ve){return Te(oe,pe,ve)>0}function Ge(oe,pe,ve){return Te(oe,pe,ve)<0}function Pe(oe,pe,ve){return Te(oe,pe,ve)===0}function De(oe,pe,ve){return Te(oe,pe,ve)!==0}function Se(oe,pe,ve){return Te(oe,pe,ve)>=0}function se(oe,pe,ve){return Te(oe,pe,ve)<=0}function ce(oe,pe,ve,We){var He;switch(pe){case"===":typeof oe=="object"&&(oe=oe.version),typeof ve=="object"&&(ve=ve.version),He=oe===ve;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof ve=="object"&&(ve=ve.version),He=oe!==ve;break;case"":case"=":case"==":He=Pe(oe,ve,We);break;case"!=":He=De(oe,ve,We);break;case">":He=Be(oe,ve,We);break;case">=":He=Se(oe,ve,We);break;case"<":He=Ge(oe,ve,We);break;case"<=":He=se(oe,ve,We);break;default:throw new TypeError("Invalid operator: "+pe)}return He}function Y(oe,pe){if(oe instanceof Y){if(oe.loose===pe)return oe;oe=oe.value}if(!(this instanceof Y))return new Y(oe,pe);y("comparator",oe,pe),this.loose=pe,this.parse(oe),this.semver===I?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(oe,pe){return me(pe,oe)},e.major=function(oe,pe){return new j(oe,pe).major},e.minor=function(oe,pe){return new j(oe,pe).minor},e.patch=function(oe,pe){return new j(oe,pe).patch},e.compare=Te,e.compareLoose=function(oe,pe){return Te(oe,pe,!0)},e.rcompare=function(oe,pe,ve){return Te(pe,oe,ve)},e.sort=function(oe,pe){return oe.sort(function(ve,We){return e.compare(ve,We,pe)})},e.rsort=function(oe,pe){return oe.sort(function(ve,We){return e.rcompare(ve,We,pe)})},e.gt=Be,e.lt=Ge,e.eq=Pe,e.neq=De,e.gte=Se,e.lte=se,e.cmp=ce,e.Comparator=Y;var I={};function $(oe,pe){if(oe instanceof $)return oe.loose===pe?oe:new $(oe.raw,pe);if(oe instanceof Y)return new $(oe.value,pe);if(!(this instanceof $))return new $(oe,pe);if(this.loose=pe,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function H(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function K(oe,pe,ve,We,He,tt,Xe,et,it,dt,Fe,st,Q){return((pe=H(ve)?"":H(We)?">="+ve+".0.0":H(He)?">="+ve+"."+We+".0":">="+pe)+" "+(et=H(it)?"":H(dt)?"<"+(+it+1)+".0.0":H(Fe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Fe+"-"+st:"<="+et)).trim()}function J(oe,pe){for(var ve=0;ve<oe.length;ve++)if(!oe[ve].test(pe))return!1;if(pe.prerelease.length){for(ve=0;ve<oe.length;ve++)if(y(oe[ve].semver),oe[ve].semver!==I&&oe[ve].semver.prerelease.length>0){var We=oe[ve].semver;if(We.major===pe.major&&We.minor===pe.minor&&We.patch===pe.patch)return!0}return!1}return!0}function le(oe,pe,ve){try{pe=new $(pe,ve)}catch{return!1}return pe.test(oe)}function Ee(oe,pe,ve,We){var He,tt,Xe,et,it;switch(oe=new j(oe,We),pe=new $(pe,We),ve){case">":He=Be,tt=se,Xe=Ge,et=">",it=">=";break;case"<":He=Ge,tt=Se,Xe=Be,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(le(oe,pe,We))return!1;for(var dt=0;dt<pe.set.length;++dt){var Fe=pe.set[dt],st=null,Q=null;if(Fe.forEach(function(_){_.semver===I&&(_=new Y(">=0.0.0")),st=st||_,Q=Q||_,He(_.semver,st.semver,We)?st=_:Xe(_.semver,Q.semver,We)&&(Q=_)}),st.operator===et||st.operator===it||(!Q.operator||Q.operator===et)&&tt(oe,Q.semver)||Q.operator===it&&Xe(oe,Q.semver))return!1}return!0}Y.prototype.parse=function(oe){var pe=this.loose?R[z]:R[ne],ve=oe.match(pe);if(!ve)throw new TypeError("Invalid comparator: "+oe);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new j(ve[2],this.loose):this.semver=I},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(oe){return y("Comparator.test",oe,this.loose),this.semver===I||(typeof oe=="string"&&(oe=new j(oe,this.loose)),ce(oe,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(oe,pe){if(!(oe instanceof Y))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new $(oe.value,pe),le(this.value,ve,pe);if(oe.operator==="")return ve=new $(this.value,pe),le(oe.semver,ve,pe);var We=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),tt=this.semver.version===oe.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),et=ce(this.semver,"<",oe.semver,pe)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),it=ce(this.semver,">",oe.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return We||He||tt&&Xe||et||it},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(oe){var pe=this.loose;oe=oe.trim(),y("range",oe,pe);var ve=pe?R[ue]:R[we];oe=oe.replace(ve,K),y("hyphen replace",oe),oe=oe.replace(R[de],"$1$2$3"),y("comparator trim",oe,R[de]),oe=(oe=(oe=oe.replace(R[Z],"$1~")).replace(R[P],"$1^")).split(/\s+/).join(" ");var We=pe?R[z]:R[ne],He=oe.split(" ").map(function(tt){return function(Xe,et){return y("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Q){y("caret",st,Q);var _=Q?R[V]:R[B];return st.replace(_,function(ge,Le,$e,Ve,Qe){var nt;return y("caret",st,ge,Le,$e,Ve,Qe),H(Le)?nt="":H($e)?nt=">="+Le+".0.0 <"+(+Le+1)+".0.0":H(Ve)?nt=Le==="0"?">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0":">="+Le+"."+$e+".0 <"+(+Le+1)+".0.0":Qe?(y("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),nt=Le==="0"?$e==="0"?">="+Le+"."+$e+"."+Ve+Qe+" <"+Le+"."+$e+"."+(+Ve+1):">="+Le+"."+$e+"."+Ve+Qe+" <"+Le+"."+(+$e+1)+".0":">="+Le+"."+$e+"."+Ve+Qe+" <"+(+Le+1)+".0.0"):(y("no pr"),nt=Le==="0"?$e==="0"?">="+Le+"."+$e+"."+Ve+" <"+Le+"."+$e+"."+(+Ve+1):">="+Le+"."+$e+"."+Ve+" <"+Le+"."+(+$e+1)+".0":">="+Le+"."+$e+"."+Ve+" <"+(+Le+1)+".0.0"),y("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),y("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Q){var _=Q?R[O]:R[x];return st.replace(_,function(ge,Le,$e,Ve,Qe){var nt;return y("tilde",st,ge,Le,$e,Ve,Qe),H(Le)?nt="":H($e)?nt=">="+Le+".0.0 <"+(+Le+1)+".0.0":H(Ve)?nt=">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0":Qe?(y("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),nt=">="+Le+"."+$e+"."+Ve+Qe+" <"+Le+"."+(+$e+1)+".0"):nt=">="+Le+"."+$e+"."+Ve+" <"+Le+"."+(+$e+1)+".0",y("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),y("tildes",Xe),Xe=function(it,dt){return y("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(st,Q){st=st.trim();var _=Q?R[A]:R[g];return st.replace(_,function(ge,Le,$e,Ve,Qe,nt){y("xRange",st,ge,Le,$e,Ve,Qe,nt);var wt=H($e),St=wt||H(Ve),Ct=St||H(Qe);return Le==="="&&Ct&&(Le=""),wt?ge=Le===">"||Le==="<"?"<0.0.0":"*":Le&&Ct?(St&&(Ve=0),Ct&&(Qe=0),Le===">"?(Le=">=",St?($e=+$e+1,Ve=0,Qe=0):Ct&&(Ve=+Ve+1,Qe=0)):Le==="<="&&(Le="<",St?$e=+$e+1:Ve=+Ve+1),ge=Le+$e+"."+Ve+"."+Qe):St?ge=">="+$e+".0.0 <"+(+$e+1)+".0.0":Ct&&(ge=">="+$e+"."+Ve+".0 <"+$e+"."+(+Ve+1)+".0"),y("xRange return",ge),ge})}(Fe,dt)}).join(" ")}(Xe,et),y("xrange",Xe),Xe=function(it,dt){return y("replaceStars",it,dt),it.trim().replace(R[ae],"")}(Xe,et),y("stars",Xe),Xe}(tt,pe)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(We)})),He=He.map(function(tt){return new Y(tt,pe)})},$.prototype.intersects=function(oe,pe){if(!(oe instanceof $))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(We){return oe.set.some(function(He){return He.every(function(tt){return We.intersects(tt,pe)})})})})},e.toComparators=function(oe,pe){return new $(oe,pe).set.map(function(ve){return ve.map(function(We){return We.value}).join(" ").trim().split(" ")})},$.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new j(oe,this.loose));for(var pe=0;pe<this.set.length;pe++)if(J(this.set[pe],oe))return!0;return!1},e.satisfies=le,e.maxSatisfying=function(oe,pe,ve){var We=null,He=null;try{var tt=new $(pe,ve)}catch{return null}return oe.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==-1||(He=new j(We=Xe,ve)))}),We},e.minSatisfying=function(oe,pe,ve){var We=null,He=null;try{var tt=new $(pe,ve)}catch{return null}return oe.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==1||(He=new j(We=Xe,ve)))}),We},e.validRange=function(oe,pe){try{return new $(oe,pe).range||"*"}catch{return null}},e.ltr=function(oe,pe,ve){return Ee(oe,pe,"<",ve)},e.gtr=function(oe,pe,ve){return Ee(oe,pe,">",ve)},e.outside=Ee,e.prerelease=function(oe,pe){var ve=G(oe,pe);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(oe,pe,ve){return oe=new $(oe,ve),pe=new $(pe,ve),oe.intersects(pe)},e.coerce=function(oe){if(oe instanceof j)return oe;if(typeof oe!="string")return null;var pe=oe.match(R[L]);return pe==null?null:G((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,t(1))},function(ee,e){var t,T,y=ee.exports={};function N(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function R(r){if(t===setTimeout)return setTimeout(r,0);if((t===N||!t)&&setTimeout)return t=setTimeout,setTimeout(r,0);try{return t(r,0)}catch{try{return t.call(null,r,0)}catch{return t.call(this,r,0)}}}(function(){try{t=typeof setTimeout=="function"?setTimeout:N}catch{t=N}try{T=typeof clearTimeout=="function"?clearTimeout:C}catch{T=C}})();var D,k=[],M=!1,S=-1;function f(){M&&D&&(M=!1,D.length?k=D.concat(k):S=-1,k.length&&p())}function p(){if(!M){var r=R(f);M=!0;for(var l=k.length;l;){for(D=k,k=[];++S<l;)D&&D[S].run();S=-1,l=k.length}D=null,M=!1,function(v){if(T===clearTimeout)return clearTimeout(v);if((T===C||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(v);try{T(v)}catch{try{return T.call(null,v)}catch{return T.call(this,v)}}}(r)}}function m(r,l){this.fun=r,this.array=l}function i(){}y.nextTick=function(r){var l=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)l[v-1]=arguments[v];k.push(new m(r,l)),k.length!==1||M||R(p)},m.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=i,y.addListener=i,y.once=i,y.off=i,y.removeListener=i,y.removeAllListeners=i,y.emit=i,y.prependListener=i,y.prependOnceListener=i,y.listeners=function(r){return[]},y.binding=function(r){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(r){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ce[112],ke([1,0,11,7]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(E){const w=E;return w?typeof w.read=="function":!1}e.isReadable=y;function N(E){const w=E;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=N;function C(E){const w=E;return w?N(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function R(E,w){return new D(E,w)}e.newWriteableStream=R;class D{constructor(w,s){this.e=w,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(s=>s(w))}h(w){this.c.error.length===0?(0,t.onUnexpectedError)(w):this.c.error.slice(0).forEach(s=>s(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,s){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(w,s){if(this.a.destroyed)return;let o;switch(w){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const a=o.indexOf(s);a>=0&&o.splice(a,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(E,w){const s=[];let o;for(;(o=E.read())!==null;)s.push(o);return w(s)}e.consumeReadable=k;function M(E,w,s){const o=[];let a;for(;(a=E.read())!==null&&o.length<s;)o.push(a);return a===null&&o.length>0?w(o):{read:()=>{if(o.length>0)return o.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return E.read()}}}e.peekReadable=M;function S(E,w){return new Promise((s,o)=>{const a=[];f(E,{onData:d=>{w&&a.push(d)},onError:d=>{w?o(d):s(void 0)},onEnd:()=>{s(w?w(a):void 0)}})})}e.consumeStream=S;function f(E,w){let s=!1;return E.on("error",o=>{s||w.onError(o)}),E.on("end",()=>{s||w.onEnd()}),E.on("data",o=>{s||w.onData(o)}),(0,T.toDisposable)(()=>s=!0)}e.listenStream=f;function p(E,w){return new Promise((s,o)=>{const a=new T.DisposableStore,d=[],c=h=>{if(d.push(h),d.length>w)return a.dispose(),E.pause(),s({stream:E,buffer:d,ended:!1})},u=h=>o(h),n=()=>s({stream:E,buffer:d,ended:!0});a.add((0,T.toDisposable)(()=>E.removeListener("error",u))),E.on("error",u),a.add((0,T.toDisposable)(()=>E.removeListener("end",n))),E.on("end",n),a.add((0,T.toDisposable)(()=>E.removeListener("data",c))),E.on("data",c)})}e.peekStream=p;function m(E,w){const s=R(w);return s.end(E),s}e.toStream=m;function i(){const E=R(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=i;function r(E){let w=!1;return{read:()=>w?null:(w=!0,E)}}e.toReadable=r;function l(E,w,s){const o=R(s);return f(E,{onData:a=>o.write(w.data(a)),onError:a=>o.error(w.error?w.error(a):a),onEnd:()=>o.end()}),o}e.transform=l;function v(E,w,s){let o=!1;return{read:()=>{const a=w.read();return o?a:(o=!0,a!==null?s([E,a]):E)}}}e.prefixedReadable=v;function b(E,w,s){let o=!1;const a=R(s);return f(w,{onData:d=>o?a.write(d):(o=!0,a.write(s([E,d]))),onError:d=>a.error(d),onEnd:()=>{o||(o=!0,a.write(E)),a.end()}}),a}e.prefixedStream=b}),define(Ce[24],ke([1,0,112]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let y,N;class C{static alloc(h){return T?new C(Buffer.allocUnsafe(h)):new C(new Uint8Array(h))}static wrap(h){return T&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new C(h)}static fromString(h,g){return!(g?.dontUseNodeBuffer||!1)&&T?new C(Buffer.from(h)):(y||(y=new TextEncoder),new C(y.encode(h)))}static fromByteArray(h){const g=C.alloc(h.length);for(let A=0,L=h.length;A<L;A++)g.buffer[A]=h[A];return g}static concat(h,g){if(typeof g>"u"){g=0;for(let q=0,Z=h.length;q<Z;q++)g+=h[q].byteLength}const A=C.alloc(g);let L=0;for(let q=0,Z=h.length;q<Z;q++){const x=h[q];A.set(x,L),L+=x.byteLength}return A}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=C.alloc(this.byteLength);return h.set(this),h}toString(){return T?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(h,g){return new C(this.buffer.subarray(h,g))}set(h,g){if(h instanceof C)this.buffer.set(h.buffer,g);else if(h instanceof Uint8Array)this.buffer.set(h,g);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),g);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return k(this.buffer,h)}writeUInt32BE(h,g){M(this.buffer,h,g)}readUInt32LE(h){return S(this.buffer,h)}writeUInt32LE(h,g){f(this.buffer,h,g)}readUInt8(h){return p(this.buffer,h)}writeUInt8(h,g){m(this.buffer,h,g)}}e.VSBuffer=C;function R(n,h){return n[h+0]<<0>>>0|n[h+1]<<8>>>0}e.readUInt16LE=R;function D(n,h,g){n[g+0]=h&255,h=h>>>8,n[g+1]=h&255}e.writeUInt16LE=D;function k(n,h){return n[h]*2**24+n[h+1]*2**16+n[h+2]*2**8+n[h+3]}e.readUInt32BE=k;function M(n,h,g){n[g+3]=h,h=h>>>8,n[g+2]=h,h=h>>>8,n[g+1]=h,h=h>>>8,n[g]=h}e.writeUInt32BE=M;function S(n,h){return n[h+0]<<0>>>0|n[h+1]<<8>>>0|n[h+2]<<16>>>0|n[h+3]<<24>>>0}e.readUInt32LE=S;function f(n,h,g){n[g+0]=h&255,h=h>>>8,n[g+1]=h&255,h=h>>>8,n[g+2]=h&255,h=h>>>8,n[g+3]=h&255}e.writeUInt32LE=f;function p(n,h){return n[h]}e.readUInt8=p;function m(n,h,g){n[g]=h}e.writeUInt8=m;function i(n){return t.consumeReadable(n,h=>C.concat(h))}e.readableToBuffer=i;function r(n){return t.toReadable(n)}e.bufferToReadable=r;function l(n){return t.consumeStream(n,h=>C.concat(h))}e.streamToBuffer=l;async function v(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await l(n.stream)])}e.bufferedStreamToBuffer=v;function b(n){return t.toStream(n,h=>C.concat(h))}e.bufferToStream=b;function E(n){return t.transform(n,{data:h=>typeof h=="string"?C.fromString(h):C.wrap(h)},h=>C.concat(h))}e.streamToBufferReadableStream=E;function w(n){return t.newWriteableStream(h=>C.concat(h),n)}e.newWriteableBufferStream=w;function s(n,h){return t.prefixedReadable(n,h,g=>C.concat(g))}e.prefixedBufferReadable=s;function o(n,h){return t.prefixedStream(n,h,g=>C.concat(g))}e.prefixedBufferStream=o;function a(n){let h=0,g=0,A=0;const L=new Uint8Array(Math.floor(n.length/4*3)),q=x=>{switch(g){case 3:L[A++]=h|x,g=0;break;case 2:L[A++]=h|x>>>2,h=x<<6,g=3;break;case 1:L[A++]=h|x>>>4,h=x<<4,g=2;break;default:h=x<<2,g=1}};for(let x=0;x<n.length;x++){const O=n.charCodeAt(x);if(O>=65&&O<=90)q(O-65);else if(O>=97&&O<=122)q(O-97+26);else if(O>=48&&O<=57)q(O-48+52);else if(O===43||O===45)q(62);else if(O===47||O===95)q(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${n[x]}`)}}const Z=A;for(;g>0;)q(0);return C.wrap(L).slice(0,Z)}e.decodeBase64=a;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:n},h=!0,g=!1){const A=g?c:d;let L="";const q=n.byteLength%3;let Z=0;for(;Z<n.byteLength-q;Z+=3){const x=n[Z+0],O=n[Z+1],F=n[Z+2];L+=A[x>>>2],L+=A[(x<<4|O>>>4)&63],L+=A[(O<<2|F>>>6)&63],L+=A[F&63]}if(q===1){const x=n[Z+0];L+=A[x>>>2],L+=A[x<<4&63],h&&(L+="==")}else if(q===2){const x=n[Z+0],O=n[Z+1];L+=A[x>>>2],L+=A[(x<<4|O>>>4)&63],L+=A[O<<2&63],h&&(L+="=")}return L}e.encodeBase64=u}),define(Ce[34],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const t=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return t.test(y)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(R){for(let D=0;D<R.length;D++)R[D]=Math.floor(Math.random()*256);return R};const N=new Uint8Array(16),C=[];for(let R=0;R<256;R++)C.push(R.toString(16).padStart(2,"0"));return function(){y(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let D=0,k="";return k+=C[N[D++]],k+=C[N[D++]],k+=C[N[D++]],k+=C[N[D++]],k+="-",k+=C[N[D++]],k+=C[N[D++]],k+="-",k+=C[N[D++]],k+=C[N[D++]],k+="-",k+=C[N[D++]],k+=C[N[D++]],k+="-",k+=C[N[D++]],k+=C[N[D++]],k+=C[N[D++]],k+=C[N[D++]],k+=C[N[D++]],k+=C[N[D++]],k}}()}),define(Ce[113],ke([1,0,16,34]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(R){return{id:(0,T.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=y;function N(R,D,k){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:D,data:k}),value:void 0}}e.createFileDataTransferItem=N;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(D){return this.a.has(this.b(D))}get(D){return this.a.get(this.b(D))?.[0]}append(D,k){const M=this.a.get(D);M?M.push(k):this.a.set(this.b(D),[k])}replace(D,k){this.a.set(this.b(D),[k])}delete(D){this.a.delete(this.b(D))}*entries(){for(const[D,k]of this.a.entries())for(const M of k)yield[D,M]}values(){return Array.from(this.a.values()).flat()}forEach(D){for(const[k,M]of this.entries())D(M,k)}b(D){return D.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:R=>(0,t.distinct)(R.map(D=>D.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(D=>!D.startsWith("#"))})}),define(Ce[114],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[115],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var t;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(t=e.IndentAction||(e.IndentAction={}));class T{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let D=0,k=R.notIn.length;D<k;D++)switch(R.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,D){if(R.getTokenCount()===0)return!0;const k=R.findTokenIndexAtOffset(D-2),M=R.getStandardTokenType(k);return this.isOK(M)}g(R,D){for(let k=R;k<=D;k++){const M=String.fromCharCode(k);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=T;class y{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of R)N(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),N(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),N(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),N(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&N(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=y;function N(C,R,D){C.has(R)?C.get(R).push(D):C.set(R,[D])}}),define(Ce[116],ke([17,18]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Ce[117],ke([17,18]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ce[118],ke([1,0,117]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,y=T*60,N=y*24,C=N*7,R=N*30,D=N*365;function k(S,f,p,m){typeof S!="number"&&(S=S.getTime());const i=Math.round((new Date().getTime()-S)/1e3);if(i<-30)return(0,t.localize)(0,null,k(new Date().getTime()+i*1e3,!1));if(!m&&i<30)return(0,t.localize)(1,null);let r;return i<T?(r=i,f?r===1?p?(0,t.localize)(2,null,r):(0,t.localize)(3,null,r):p?(0,t.localize)(4,null,r):(0,t.localize)(5,null,r):r===1?p?(0,t.localize)(6,null,r):(0,t.localize)(7,null,r):p?(0,t.localize)(8,null,r):(0,t.localize)(9,null,r)):i<y?(r=Math.floor(i/T),f?r===1?p?(0,t.localize)(10,null,r):(0,t.localize)(11,null,r):p?(0,t.localize)(12,null,r):(0,t.localize)(13,null,r):r===1?p?(0,t.localize)(14,null,r):(0,t.localize)(15,null,r):p?(0,t.localize)(16,null,r):(0,t.localize)(17,null,r)):i<N?(r=Math.floor(i/y),f?r===1?p?(0,t.localize)(18,null,r):(0,t.localize)(19,null,r):p?(0,t.localize)(20,null,r):(0,t.localize)(21,null,r):r===1?p?(0,t.localize)(22,null,r):(0,t.localize)(23,null,r):p?(0,t.localize)(24,null,r):(0,t.localize)(25,null,r)):i<C?(r=Math.floor(i/N),f?r===1?(0,t.localize)(26,null,r):(0,t.localize)(27,null,r):r===1?(0,t.localize)(28,null,r):(0,t.localize)(29,null,r)):i<R?(r=Math.floor(i/C),f?r===1?p?(0,t.localize)(30,null,r):(0,t.localize)(31,null,r):p?(0,t.localize)(32,null,r):(0,t.localize)(33,null,r):r===1?p?(0,t.localize)(34,null,r):(0,t.localize)(35,null,r):p?(0,t.localize)(36,null,r):(0,t.localize)(37,null,r)):i<D?(r=Math.floor(i/R),f?r===1?p?(0,t.localize)(38,null,r):(0,t.localize)(39,null,r):p?(0,t.localize)(40,null,r):(0,t.localize)(41,null,r):r===1?p?(0,t.localize)(42,null,r):(0,t.localize)(43,null,r):p?(0,t.localize)(44,null,r):(0,t.localize)(45,null,r)):(r=Math.floor(i/D),f?r===1?p?(0,t.localize)(46,null,r):(0,t.localize)(47,null,r):p?(0,t.localize)(48,null,r):(0,t.localize)(49,null,r):r===1?p?(0,t.localize)(50,null,r):(0,t.localize)(51,null,r):p?(0,t.localize)(52,null,r):(0,t.localize)(53,null,r))}e.fromNow=k;function M(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(Ce[119],ke([17,18]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ce[39],ke([1,0,16,9,119]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(S,f){return f&&(S.stack||S.stacktrace)?y.localize(0,null,R(S),C(S.stack)||C(S.stacktrace)):R(S)}function C(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?y.localize(1,null,S.message):S.message||y.localize(2,null)}function D(S=null,f=!1){if(!S)return y.localize(3,null);if(Array.isArray(S)){const p=t.coalesce(S),m=D(p[0],f);return p.length>1?y.localize(4,null,m,p.length):m}if(T.isString(S))return S;if(S.detail){const p=S.detail;if(p.error)return N(p.error,f);if(p.exception)return N(p.exception,f)}return S.stack?N(S,f):S.message?S.message:y.localize(5,null)}e.toErrorMessage=D;function k(S){const f=S;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=k;function M(S,f){let p;return typeof S=="string"?p=new Error(S):p=S,p.actions=f,p}e.createErrorWithActions=M}),define(Ce[62],ke([1,0,19]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(M){const S=(0,t.extname)(M),f=T[S.toLowerCase()];return f!==void 0?f:C(M)}e.getMediaOrTextMime=N;function C(M){const S=(0,t.extname)(M);return y[S.toLowerCase()]}e.getMediaMime=C;function R(M){for(const S in y)if(y[S]===M)return S}e.getExtensionForMimeType=R;const D=/^(.+)\/(.+?)(;.+)?$/;function k(M,S){const f=D.exec(M);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:S?void 0:M}e.normalizeMimeType=k}),define(Ce[120],ke([1,0,4,7,116]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class N extends T.Disposable{constructor(f,p="",m="",i=!0,r){super(),this.h=this.B(new t.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=f,this.m=p,this.u=m,this.w=i,this.C=r}get id(){return this.j}get label(){return this.m}set label(f){this.D(f)}D(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.u}set class(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.h.fire({class:f}))}get enabled(){return this.w}set enabled(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.h.fire({enabled:f}))}get checked(){return this.z}set checked(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.h.fire({checked:f}))}async run(f,p){this.C&&await this.C(f)}}e.Action=N;class C extends T.Disposable{constructor(){super(...arguments),this.f=this.B(new t.Emitter),this.onWillRun=this.f.event,this.h=this.B(new t.Emitter),this.onDidRun=this.h.event}async run(f,p){if(!f.enabled)return;this.f.fire({action:f});let m;try{await this.runAction(f,p)}catch(i){m=i}this.h.fire({action:f,error:m})}async runAction(f,p){await f.run(p)}}e.ActionRunner=C;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let p=[];for(const m of f)m.length&&(p.length?p=[...p,new R,...m]:p=m);return p}async run(){}}e.Separator=R,R.ID="vs.actions.separator";class D{get actions(){return this.a}constructor(f,p,m,i){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=p,this.class=i,this.a=m}async run(){}}e.SubmenuAction=D;class k extends N{constructor(){super(k.ID,y.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=k,k.ID="vs.actions.empty";function M(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async()=>S.run(),tooltip:S.label}}e.toAction=M}),define(Ce[40],ke([1,0,19,21,10,9]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(c){return c===47||c===92}e.isPathSeparator=C;function R(c){return c.replace(/[\\/]/g,t.posix.sep)}e.toSlashes=R;function D(c){return c.indexOf("/")===-1&&(c=R(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=D;function k(c,u=t.posix.sep){if(!c)return"";const n=c.length,h=c.charCodeAt(0);if(C(h)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let A=3;const L=A;for(;A<n&&!C(c.charCodeAt(A));A++);if(L!==A&&!C(c.charCodeAt(A+1))){for(A+=1;A<n;A++)if(C(c.charCodeAt(A)))return c.slice(0,A+1).replace(/[\\/]/g,u)}}return u}else if(l(h)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+u:c.slice(0,2);let g=c.indexOf("://");if(g!==-1){for(g+=3;g<n;g++)if(C(c.charCodeAt(g)))return c.slice(0,g+1)}return""}e.getRoot=k;function M(c){if(!T.isWindows||!c||c.length<5)return!1;let u=c.charCodeAt(0);if(u!==92||(u=c.charCodeAt(1),u!==92))return!1;let n=2;const h=n;for(;n<c.length&&(u=c.charCodeAt(n),u!==92);n++);return!(h===n||(u=c.charCodeAt(n+1),isNaN(u)||u===92))}e.isUNC=M;const S=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,u=T.isWindows){const n=u?S:f;return!(!c||c.length===0||/^\s+$/.test(c)||(n.lastIndex=0,n.test(c))||u&&p.test(c)||c==="."||c===".."||u&&c[c.length-1]==="."||u&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=m;function i(c,u,n){const h=c===u;return!n||h?h:!c||!u?!1:(0,y.equalsIgnoreCase)(c,u)}e.isEqual=i;function r(c,u,n,h=t.sep){if(c===u)return!0;if(!c||!u||u.length>c.length)return!1;if(n){if(!(0,y.startsWithIgnoreCase)(c,u))return!1;if(u.length===c.length)return!0;let A=u.length;return u.charAt(u.length-1)===h&&A--,c.charAt(A)===h}return u.charAt(u.length-1)!==h&&(u+=h),c.indexOf(u)===0}e.isEqualOrParent=r;function l(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=l;function v(c,u){return T.isWindows&&c.endsWith(":")&&(c+=t.sep),(0,t.isAbsolute)(c)||(c=(0,t.join)(u,c)),c=(0,t.normalize)(c),T.isWindows?(c=(0,y.rtrim)(c,t.sep),c.endsWith(":")&&(c+=t.sep)):(c=(0,y.rtrim)(c,t.sep),c||(c=t.sep)),c}e.sanitizeFilePath=v;function b(c){const u=(0,t.normalize)(c);return T.isWindows?c.length>3?!1:E(u)&&(c.length===2||u.charCodeAt(2)===92):u===t.posix.sep}e.isRootOrDriveLetter=b;function E(c,u=T.isWindows){return u?l(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function w(c){return E(c)?c[0]:void 0}e.getDriveLetter=w;function s(c,u,n){return u.length>c.length?-1:c===u?0:(n&&(c=c.toLowerCase(),u=u.toLowerCase()),c.indexOf(u))}e.indexOfPath=s;function o(c){const u=c.split(":");let n,h,g;for(const A of u){const L=Number(A);(0,N.isNumber)(L)?h===void 0?h=L:g===void 0&&(g=L):n=n?[n,A].join(":"):A}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function d(c,u,n=8){let h="";for(let A=0;A<n;A++)h+=a.charAt(Math.floor(Math.random()*a.length));let g;return u?g=`${u}-${h}`:g=h,c?(0,t.join)(c,g):g}e.randomPath=d}),define(Ce[121],ke([1,0,28,10]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Y){return function(I,$){for(let H=0,K=Y.length;H<K;H++){const J=Y[H](I,$);if(J)return J}return null}}e.or=y,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(Y,I,$){if(!$||$.length<I.length)return null;let H;return Y?H=T.startsWithIgnoreCase($,I):H=$.indexOf(I)===0,H?I.length>0?[{start:0,end:I.length}]:[]:null}function C(Y,I){const $=I.toLowerCase().indexOf(Y.toLowerCase());return $===-1?null:[{start:$,end:$+Y.length}]}e.matchesContiguousSubString=C;function R(Y,I){return D(Y.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=R;function D(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]===I[H]){let K=null;return(K=D(Y,I,$+1,H+1))?l({start:H,end:H+1},K):null}return D(Y,I,$,H+1)}function k(Y){return 97<=Y&&Y<=122}function M(Y){return 65<=Y&&Y<=90}e.isUpper=M;function S(Y){return 48<=Y&&Y<=57}function f(Y){return Y===32||Y===9||Y===10||Y===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>p.add(Y.charCodeAt(0)));function m(Y){return f(Y)||p.has(Y)}function i(Y,I){return Y===I||m(Y)&&m(I)}function r(Y){return k(Y)||M(Y)||S(Y)}function l(Y,I){return I.length===0?I=[Y]:Y.end===I[0].start?I[0].start=Y.start:I.unshift(Y),I}function v(Y,I){for(let $=I;$<Y.length;$++){const H=Y.charCodeAt($);if(M(H)||S(H)||$>0&&!r(Y.charCodeAt($-1)))return $}return Y.length}function b(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]!==I[H].toLowerCase())return null;{let K=null,J=H+1;for(K=b(Y,I,$+1,H+1);!K&&(J=v(I,J))<I.length;)K=b(Y,I,$+1,J),J++;return K===null?null:l({start:H,end:H+1},K)}}function E(Y){let I=0,$=0,H=0,K=0,J=0;for(let ve=0;ve<Y.length;ve++)J=Y.charCodeAt(ve),M(J)&&I++,k(J)&&$++,r(J)&&H++,S(J)&&K++;const le=I/Y.length,Ee=$/Y.length,oe=H/Y.length,pe=K/Y.length;return{upperPercent:le,lowerPercent:Ee,alphaPercent:oe,numericPercent:pe}}function w(Y){const{upperPercent:I,lowerPercent:$}=Y;return $===0&&I>.6}function s(Y){const{upperPercent:I,lowerPercent:$,alphaPercent:H,numericPercent:K}=Y;return $>.2&&I<.8&&H>.6&&K<.2}function o(Y){let I=0,$=0,H=0,K=0;for(let J=0;J<Y.length;J++)H=Y.charCodeAt(J),M(H)&&I++,k(H)&&$++,f(H)&&K++;return(I===0||$===0)&&K===0?Y.length<=30:I<=5}function a(Y,I){if(!I||(I=I.trim(),I.length===0)||!o(Y)||I.length>60)return null;const $=E(I);if(!s($)){if(!w($))return null;I=I.toLowerCase()}let H=null,K=0;for(Y=Y.toLowerCase();K<I.length&&(H=b(Y,I,0,K))===null;)K=v(I,K+1);return H}e.matchesCamelCase=a;function d(Y,I,$=!1){if(!I||I.length===0)return null;let H=null,K=0;for(Y=Y.toLowerCase(),I=I.toLowerCase();K<I.length&&(H=c(Y,I,0,K,$))===null;)K=u(I,K+1);return H}e.matchesWords=d;function c(Y,I,$,H,K){if($===Y.length)return[];if(H===I.length)return null;if(i(Y.charCodeAt($),I.charCodeAt(H))){let J=null,le=H+1;if(J=c(Y,I,$+1,H+1,K),!K)for(;!J&&(le=u(I,le))<I.length;)J=c(Y,I,$+1,le,K),le++;return J?Y.charCodeAt($)!==I.charCodeAt(H)?J:l({start:H,end:H+1},J):null}else return null}function u(Y,I){for(let $=I;$<Y.length;$++)if(m(Y.charCodeAt($))||$>0&&m(Y.charCodeAt($-1)))return $;return Y.length}const n=y(e.matchesPrefix,a,C),h=y(e.matchesPrefix,a,R),g=new t.LRUCache(1e4);function A(Y,I,$=!1){if(typeof Y!="string"||typeof I!="string")return null;let H=g.get(Y);H||(H=new RegExp(T.convertSimple2RegExpPattern(Y),"i"),g.set(Y,H));const K=H.exec(I);return K?[{start:K.index,end:K.index+K[0].length}]:$?h(Y,I):n(Y,I)}e.matchesFuzzy=A;function L(Y,I){const $=Be(Y,Y.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?Z($):null}e.matchesFuzzy2=L;function q(Y,I,$,H,K,J){const le=Math.min(13,Y.length);for(;$<le;$++){const Ee=Be(Y,I,$,H,K,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ee)return Ee}return[0,J]}e.anyScore=q;function Z(Y){if(typeof Y>"u")return[];const I=[],$=Y[1];for(let H=Y.length-1;H>1;H--){const K=Y[H]+$,J=I[I.length-1];J&&J.end===K?J.end=K+1:I.push({start:K,end:K+1})}return I}e.createMatches=Z;const x=128;function O(){const Y=[],I=[];for(let $=0;$<=x;$++)I[$]=0;for(let $=0;$<=x;$++)Y.push(I.slice(0));return Y}function F(Y){const I=[];for(let $=0;$<=Y;$++)I[$]=0;return I}const P=F(2*x),B=F(2*x),V=O(),z=O(),ne=O(),de=!1;function we(Y,I,$,H,K){function J(Ee,oe,pe=" "){for(;Ee.length<oe;)Ee=pe+Ee;return Ee}let le=` |   |${H.split("").map(Ee=>J(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=$;Ee++)Ee===0?le+=" |":le+=`${I[Ee-1]}|`,le+=Y[Ee].slice(0,K+1).map(oe=>J(oe.toString(),3)).join("|")+`
`;return le}function ue(Y,I,$,H){Y=Y.substr(I),$=$.substr(H),console.log(we(z,Y,Y.length,$,$.length)),console.log(we(ne,Y,Y.length,$,$.length)),console.log(we(V,Y,Y.length,$,$.length))}function ae(Y,I){if(I<0||I>=Y.length)return!1;const $=Y.codePointAt(I);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise($)}}function Ie(Y,I){if(I<0||I>=Y.length)return!1;switch(Y.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function G(Y,I,$){return I[Y]!==$[Y]}function j(Y,I,$,H,K,J,le=!1){for(;I<$&&K<J;)Y[I]===H[K]&&(le&&(P[I]=K),I+=1),K+=1;return I===$}e.isPatternInWord=j;var re;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(re||(re={}));var me;(function(Y){Y.Default=[-100,0];function I($){return!$||$.length===2&&$[0]===-100&&$[1]===0}Y.isDefault=I})(me=e.FuzzyScore||(e.FuzzyScore={}));class Te{constructor(I,$){this.firstMatchCanBeWeak=I,this.boostFullMatch=$}}e.FuzzyScoreOptions=Te,Te.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(Y,I,$,H,K,J,le=Te.default){const Ee=Y.length>x?x:Y.length,oe=H.length>x?x:H.length;if($>=Ee||J>=oe||Ee-$>oe-J||!j(I,$,Ee,K,J,oe,!0))return;Ge(Ee,oe,$,J,I,K);let pe=1,ve=1,We=$,He=J;const tt=[!1];for(pe=1,We=$;We<Ee;pe++,We++){const Fe=P[We],st=B[We],Q=We+1<Ee?B[We+1]:oe;for(ve=Fe-J+1,He=Fe;He<Q;ve++,He++){let _=Number.MIN_SAFE_INTEGER,ge=!1;He<=st&&(_=Pe(Y,I,We,$,H,K,He,oe,J,V[pe-1][ve-1]===0,tt));let Le=0;_!==Number.MAX_SAFE_INTEGER&&(ge=!0,Le=_+z[pe-1][ve-1]);const $e=He>Fe,Ve=$e?z[pe][ve-1]+(V[pe][ve-1]>0?-5:0):0,Qe=He>Fe+1&&V[pe][ve-1]>0,nt=Qe?z[pe][ve-2]+(V[pe][ve-2]>0?-5:0):0;if(Qe&&(!$e||nt>=Ve)&&(!ge||nt>=Le))z[pe][ve]=nt,ne[pe][ve]=3,V[pe][ve]=0;else if($e&&(!ge||Ve>=Le))z[pe][ve]=Ve,ne[pe][ve]=2,V[pe][ve]=0;else if(ge)z[pe][ve]=Le,ne[pe][ve]=1,V[pe][ve]=V[pe-1][ve-1]+1;else throw new Error("not possible")}}if(de&&ue(Y,$,H,J),!tt[0]&&!le.firstMatchCanBeWeak)return;pe--,ve--;const Xe=[z[pe][ve],J];let et=0,it=0;for(;pe>=1;){let Fe=ve;do{const st=ne[pe][Fe];if(st===3)Fe=Fe-2;else if(st===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[$+pe-1]===K[J+ve-1]&&!G(Fe+J-1,H,K)&&et+1>V[pe][Fe]&&(Fe=ve),Fe===ve?et++:et=1,it||(it=Fe),pe--,ve=Fe-1,Xe.push(ve)}oe===Ee&&le.boostFullMatch&&(Xe[0]+=2);const dt=it-Ee;return Xe[0]-=dt,Xe}e.fuzzyScore=Be;function Ge(Y,I,$,H,K,J){let le=Y-1,Ee=I-1;for(;le>=$&&Ee>=H;)K[le]===J[Ee]&&(B[le]=Ee,le--),Ee--}function Pe(Y,I,$,H,K,J,le,Ee,oe,pe,ve){if(I[$]!==J[le])return Number.MIN_SAFE_INTEGER;let We=1,He=!1;return le===$-H?We=Y[$]===K[le]?7:5:G(le,K,J)&&(le===0||!G(le-1,K,J))?(We=Y[$]===K[le]?7:5,He=!0):ae(J,le)&&(le===0||!ae(J,le-1))?We=5:(ae(J,le-1)||Ie(J,le-1))&&(We=5,He=!0),We>1&&$===H&&(ve[0]=!0),He||(He=G(le,K,J)||ae(J,le-1)||Ie(J,le-1)),$===H?le>oe&&(We-=He?3:5):pe?We+=He?2:0:We+=He?0:1,le+1===Ee&&(We-=He?3:5),We}function De(Y,I,$,H,K,J,le){return se(Y,I,$,H,K,J,!0,le)}e.fuzzyScoreGracefulAggressive=De;function Se(Y,I,$,H,K,J,le){return se(Y,I,$,H,K,J,!1,le)}e.fuzzyScoreGraceful=Se;function se(Y,I,$,H,K,J,le,Ee){let oe=Be(Y,I,$,H,K,J,Ee);if(oe&&!le)return oe;if(Y.length>=3){const pe=Math.min(7,Y.length-1);for(let ve=$+1;ve<pe;ve++){const We=ce(Y,ve);if(We){const He=Be(We,We.toLowerCase(),$,H,K,J,Ee);He&&(He[0]-=3,(!oe||He[0]>oe[0])&&(oe=He))}}}return oe}function ce(Y,I){if(I+1>=Y.length)return;const $=Y[I],H=Y[I+1];if($!==H)return Y.slice(0,I)+H+$+Y.slice(I+2)}}),define(Ce[122],ke([1,0,123,121,10]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const N="$(",C=new RegExp(`\\$\\(${t.CSSIcon.iconNameExpression}(?:${t.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${C.source}`,"g");function D(r){return r.replace(R,(l,v)=>v?l:`\\${l}`)}e.escapeIcons=D;const k=new RegExp(`\\\\${C.source}`,"g");function M(r){return r.replace(k,l=>`\\${l}`)}e.markdownEscapeEscapedIcons=M;const S=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function f(r){return r.indexOf(N)===-1?r:r.replace(S,(l,v,b,E)=>b?l:v||E||"")}e.stripIcons=f;const p=new RegExp(`\\$\\(${t.CSSIcon.iconNameCharacter}+\\)`,"g");function m(r){p.lastIndex=0;let l="";const v=[];let b=0;for(;;){const E=p.lastIndex,w=p.exec(r),s=r.substring(E,w?.index);if(s.length>0){l+=s;for(let o=0;o<s.length;o++)v.push(b)}if(!w)break;b+=w[0].length}return{text:l,iconOffsets:v}}e.parseLabelWithIcons=m;function i(r,l,v=!1){const{text:b,iconOffsets:E}=l;if(!E||E.length===0)return(0,T.matchesFuzzy)(r,b,v);const w=(0,y.ltrim)(b," "),s=b.length-w.length,o=(0,T.matchesFuzzy)(r,w,v);if(o)for(const a of o){const d=E[a.start+s]+s;a.start+=d,a.end+=d}return o}e.matchesFuzzyIconAware=i}),define(Ce[29],ke([1,0,10]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(T||(T={})),function(y){const N="error",C="warning",R="warn",D="info",k="ignore";function M(f){return f?t.equalsIgnoreCase(N,f)?y.Error:t.equalsIgnoreCase(C,f)||t.equalsIgnoreCase(R,f)?y.Warning:t.equalsIgnoreCase(D,f)?y.Info:y.Ignore:y.Ignore}y.fromValue=M;function S(f){switch(f){case y.Error:return N;case y.Warning:return C;case y.Info:return D;default:return k}}y.toString=S}(T||(T={})),e.default=T}),define(Ce[46],ke([1,0,16,10]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const m=p.charCodeAt(0),i=this.b.charCodeAt(this.c);return m-i}value(){return this.b[this.c]}}e.StringIterator=y;class N{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=N;class C{constructor(p=!0,m=!0){this.f=p,this.g=m}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let m=p.length-1;m>=0;m--,this.c--){const i=this.b.charCodeAt(m);if(!(i===47||this.f&&i===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var R;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(R||(R={}));class D{constructor(p,m){this.f=p,this.g=m,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=D;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(M||(M={}));class S{static forUris(p=()=>!1,m=()=>!1){return new S(new D(p,m))}static forPaths(p=!1){return new S(new C(void 0,!p))}static forStrings(){return new S(new y)}static forConfigKeys(){return new S(new N)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,m){if(m){const i=m.slice(0);(0,t.shuffle)(i);for(const r of i)this.set(r,p)}else{const i=p.slice(0);(0,t.shuffle)(i);for(const r of i)this.set(r[0],r[1])}}set(p,m){const i=this.b.reset(p);let r;this.c||(this.c=new k,this.c.segment=i.value());const l=[];for(r=this.c;;){const b=i.cmp(r.segment);if(b>0)r.left||(r.left=new k,r.left.segment=i.value()),l.push([-1,r]),r=r.left;else if(b<0)r.right||(r.right=new k,r.right.segment=i.value()),l.push([1,r]),r=r.right;else if(i.hasNext())i.next(),r.mid||(r.mid=new k,r.mid.segment=i.value()),l.push([0,r]),r=r.mid;else break}const v=r.value;r.value=m,r.key=p;for(let b=l.length-1;b>=0;b--){const E=l[b][1];E.updateHeight();const w=E.balanceFactor();if(w<-1||w>1){const s=l[b][0],o=l[b+1][0];if(s===1&&o===1)l[b][1]=E.rotateLeft();else if(s===-1&&o===-1)l[b][1]=E.rotateRight();else if(s===1&&o===-1)E.right=l[b+1][1]=l[b+1][1].rotateRight(),l[b][1]=E.rotateLeft();else if(s===-1&&o===1)E.left=l[b+1][1]=l[b+1][1].rotateLeft(),l[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(l[b-1][0]){case-1:l[b-1][1].left=l[b][1];break;case 1:l[b-1][1].right=l[b][1];break;case 0:l[b-1][1].mid=l[b][1];break}else this.c=l[0][1]}}return v}get(p){return this.d(p)?.value}d(p){const m=this.b.reset(p);let i=this.c;for(;i;){const r=m.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(m.hasNext())m.next(),i=i.mid;else break}return i}has(p){const m=this.d(p);return!(m?.value===void 0&&m?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,m){const i=this.b.reset(p),r=[];let l=this.c;for(;l;){const v=i.cmp(l.segment);if(v>0)r.push([-1,l]),l=l.left;else if(v<0)r.push([1,l]),l=l.right;else if(i.hasNext())i.next(),r.push([0,l]),l=l.mid;else break}if(!!l){if(m?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const v=this.f(l.right);if(v.key){const{key:b,value:E,segment:w}=v;this.e(v.key,!1),l.key=b,l.value=E,l.segment=w}}else{const v=l.left??l.right;if(r.length>0){const[b,E]=r[r.length-1];switch(b){case-1:E.left=v;break;case 0:E.mid=v;break;case 1:E.right=v;break}}else this.c=v}for(let v=r.length-1;v>=0;v--){const b=r[v][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),r[v][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),r[v][1]=b.rotateRight()),v>0)switch(r[v-1][0]){case-1:r[v-1][1].left=r[v][1];break;case 1:r[v-1][1].right=r[v][1];break;case 0:r[v-1][1].mid=r[v][1];break}else this.c=r[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const m=this.b.reset(p);let i=this.c,r;for(;i;){const l=m.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(m.hasNext())m.next(),r=i.value||r,i=i.mid;else break}return i&&i.value||r}findSuperstr(p){return this.g(p,!1)}g(p,m){const i=this.b.reset(p);let r=this.c;for(;r;){const l=i.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else return r.mid?this.h(r.mid):m?r.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[m,i]of this)p(i,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const m=[];return this.j(p,m),m[Symbol.iterator]()}j(p,m){!p||(p.left&&this.j(p.left,m),p.value&&m.push([p.key,p.value]),p.mid&&this.j(p.mid,m),p.right&&this.j(p.right,m))}_isBalanced(){const p=m=>{if(!m)return!0;const i=m.balanceFactor();return i<-1||i>1?!1:p(m.left)&&p(m.right)};return p(this.c)}}e.TernarySearchTree=S}),define(Ce[82],ke([1,0,24,10,2]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(k){return JSON.stringify(k,R)}e.stringify=N;function C(k){let M=JSON.parse(k);return M=D(M),M}e.parse=C;function R(k,M){return M instanceof RegExp?{$mid:2,source:M.source,flags:(0,T.regExpFlags)(M)}:M}function D(k,M=0){if(!k||M>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return y.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof t.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let S=0;S<k.length;++S)k[S]=D(k[S],M+1);else for(const S in k)Object.hasOwnProperty.call(k,S)&&(k[S]=D(k[S],M+1))}return k}e.revive=D}),define(Ce[13],ke([1,0,21,2]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls",D.vscodeSourceControl="vscode-scm"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${y.vscodeRemoteResource}`}set(k,M,S){this.a[k]=M,this.b[k]=S}setConnectionToken(k,M){this.c[k]=M}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)return this.e(k);const M=k.authority;let S=this.a[M];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const f=this.b[M],p=this.c[M];let m=`path=${encodeURIComponent(k.path)}`;return typeof p=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),T.URI.from({scheme:t.isWeb?this.d:y.vscodeRemoteResource,authority:`${S}:${f}`,path:this.f,query:m})}}e.RemoteAuthorities=new N,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(k){const M=this.b(k,ee);return this.uriToBrowserUri(M)}uriToBrowserUri(k){return k.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===y.file&&(t.isNative||t.isWebWorker&&t.globals.origin===`${y.vscodeFileResource}://${C.a}`)?k.with({scheme:y.vscodeFileResource,authority:k.authority||C.a,query:null,fragment:null}):k}asFileUri(k){const M=this.b(k,ee);return this.uriToFileUri(M)}uriToFileUri(k){return k.scheme===y.vscodeFileResource?k.with({scheme:y.file,authority:k.authority!==C.a?k.authority:null,query:null,fragment:null}):k}b(k,M){return T.URI.isUri(k)?k:T.URI.parse(M.toUrl(k))}}C.a="vscode-app",e.FileAccess=new C;var R;(function(D){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);D.CoopAndCoep=Object.freeze(k.get("3"));const M="vscode-coi";function S(p){let m;typeof p=="string"?m=new URL(p).searchParams:p instanceof URL?m=p.searchParams:T.URI.isUri(p)&&(m=new URL(p.toString(!0)).searchParams);const i=m?.get(M);if(!!i)return k.get(i)}D.getHeadersFromQuery=S;function f(p,m,i){if(!globalThis.crossOriginIsolated)return;const r=m&&i?"3":i?"2":"1";p instanceof URLSearchParams?p.set(M,r):p[M]=r}D.addSearchParam=f})(R=e.COI||(e.COI={}))}),define(Ce[22],ke([1,0,40,13,19,21,10,2]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=D;class k{constructor(m){this.a=m}compare(m,i,r=!1){return m===i?0:(0,C.compare)(this.getComparisonKey(m,r),this.getComparisonKey(i,r))}isEqual(m,i,r=!1){return m===i?!0:!m||!i?!1:this.getComparisonKey(m,r)===this.getComparisonKey(i,r)}getComparisonKey(m,i=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,i,r=!1){if(m.scheme===i.scheme){if(m.scheme===T.Schemas.file)return t.isEqualOrParent(D(m),D(i),this.a(m))&&m.query===i.query&&(r||m.fragment===i.fragment);if((0,e.isEqualAuthority)(m.authority,i.authority))return t.isEqualOrParent(m.path,i.path,this.a(m),"/")&&m.query===i.query&&(r||m.fragment===i.fragment)}return!1}joinPath(m,...i){return R.URI.joinPath(m,...i)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return y.posix.basename(m.path)}extname(m){return y.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let i;return m.scheme===T.Schemas.file?i=R.URI.file(y.dirname(D(m))).path:(i=y.posix.dirname(m.path),m.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),i="/")),m.with({path:i})}normalizePath(m){if(!m.path.length)return m;let i;return m.scheme===T.Schemas.file?i=R.URI.file(y.normalize(D(m))).path:i=y.posix.normalize(m.path),m.with({path:i})}relativePath(m,i){if(m.scheme!==i.scheme||!(0,e.isEqualAuthority)(m.authority,i.authority))return;if(m.scheme===T.Schemas.file){const v=y.relative(D(m),D(i));return N.isWindows?t.toSlashes(v):v}let r=m.path||"/";const l=i.path||"/";if(this.a(m)){let v=0;for(const b=Math.min(r.length,l.length);v<b&&!(r.charCodeAt(v)!==l.charCodeAt(v)&&r.charAt(v).toLowerCase()!==l.charAt(v).toLowerCase());v++);r=l.substr(0,v)+r.substr(v)}return y.posix.relative(r,l)}resolvePath(m,i){if(m.scheme===T.Schemas.file){const r=R.URI.file(y.resolve(D(m),i));return m.with({authority:r.authority,path:r.path})}return i=t.toPosixPath(i),m.with({path:y.posix.resolve(m.path,i)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,i){return m===i||m!==void 0&&i!==void 0&&(0,C.equalsIgnoreCase)(m,i)}hasTrailingPathSeparator(m,i=y.sep){if(m.scheme===T.Schemas.file){const r=D(m);return r.length>t.getRoot(r).length&&r[r.length-1]===i}else{const r=m.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,i=y.sep){return(0,e.hasTrailingPathSeparator)(m,i)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,i=y.sep){let r=!1;if(m.scheme===T.Schemas.file){const l=D(m);r=l!==void 0&&l.length===t.getRoot(l).length&&l[l.length-1]===i}else{i="/";const l=m.path;r=l.length===1&&l.charCodeAt(l.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(m,i)?m.with({path:m.path+"/"}):m}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(p=>p.scheme===T.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new k(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(p,m){const i=[];for(let r=0;r<p.length;r++){const l=m(p[r]);p.some((v,b)=>b===r?!1:(0,e.isEqualOrParent)(l,m(v)))||i.push(p[r])}return i}e.distinctParents=M;var S;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function m(i){const r=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,w]=b.split(":");E&&w&&r.set(E,w)});const v=i.path.substring(0,i.path.indexOf(";"));return v&&r.set(p.META_DATA_MIME,v),r}p.parseMetaData=m})(S=e.DataUri||(e.DataUri={}));function f(p,m,i){if(m){let r=p.path;return r&&r[0]!==y.posix.sep&&(r=y.posix.sep+r),p.with({scheme:i,authority:m,path:r})}return p.with({scheme:i})}e.toLocalResource=f}),define(Ce[14],ke([1,0,20,11,4,7,22,21]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(G){return!!G&&typeof G.then=="function"}e.isThenable=D;function k(G){const j=new t.CancellationTokenSource,re=G(j.token),me=new Promise((Te,Be)=>{const Ge=j.token.onCancellationRequested(()=>{Ge.dispose(),j.dispose(),Be(new T.CancellationError)});Promise.resolve(re).then(Pe=>{Ge.dispose(),j.dispose(),Te(Pe)},Pe=>{Ge.dispose(),j.dispose(),Be(Pe)})});return new class{cancel(){j.cancel()}then(Te,Be){return me.then(Te,Be)}catch(Te){return this.then(void 0,Te)}finally(Te){return me.finally(Te)}}}e.createCancelablePromise=k;function M(G,j,re){return new Promise((me,Te)=>{const Be=j.onCancellationRequested(()=>{Be.dispose(),me(re)});G.then(me,Te).finally(()=>Be.dispose())})}e.raceCancellation=M;function S(G,j){return new Promise((re,me)=>{const Te=j.onCancellationRequested(()=>{Te.dispose(),me(new T.CancellationError)});G.then(re,me).finally(()=>Te.dispose())})}e.raceCancellationError=S;async function f(G){let j=-1;const re=G.map((Te,Be)=>Te.then(Ge=>(j=Be,Ge))),me=await Promise.race(re);return G.forEach((Te,Be)=>{Be!==j&&Te.cancel()}),me}e.raceCancellablePromises=f;function p(G,j,re){let me;const Te=setTimeout(()=>{me?.(void 0),re?.()},j);return Promise.race([G.finally(()=>clearTimeout(Te)),new Promise(Be=>me=Be)])}e.raceTimeout=p;function m(G){return new Promise((j,re)=>{const me=G();D(me)?me.then(j,re):j(me)})}e.asPromise=m;class i{constructor(){this.a=null,this.b=null,this.d=null}queue(j){if(this.a){if(this.d=j,!this.b){const re=()=>{this.b=null;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(re,re).then(me)})}return new Promise((re,me)=>{this.b.then(re,me)})}return this.a=j(),new Promise((re,me)=>{this.a.then(Te=>{this.a=null,re(Te)},Te=>{this.a=null,me(Te)})})}}e.Throttler=i;class r{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.Sequencer=r;class l{constructor(){this.a=new Map}queue(j,re){const Te=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(j)===Te&&this.a.delete(j)});return this.a.set(j,Te),Te}}e.SequencerByKey=l;const v=(G,j)=>{let re=!0;const me=setTimeout(()=>{re=!1,j()},G);return{isTriggered:()=>re,dispose:()=>{clearTimeout(me),re=!1}}},b=G=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,G())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class E{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,re=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((Te,Be)=>{this.d=Te,this.f=Be}).then(()=>{if(this.b=null,this.d=null,this.g){const Te=this.g;return this.g=null,Te()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=re===e.MicrotaskDelay?b(me):v(re,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=E;class w{constructor(j){this.a=new E(j),this.b=new i}trigger(j,re){return this.a.trigger(()=>this.b.queue(j),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class s{constructor(){this.a=!1,this.b=new Promise((j,re)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class o extends s{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=o;function a(G,j){return j?new Promise((re,me)=>{const Te=setTimeout(()=>{Be.dispose(),re()},G),Be=j.onCancellationRequested(()=>{clearTimeout(Te),Be.dispose(),me(new T.CancellationError)})}):k(re=>a(G,re))}e.timeout=a;function d(G,j=0){const re=setTimeout(G,j);return(0,N.toDisposable)(()=>clearTimeout(re))}e.disposableTimeout=d;function c(G){const j=[];let re=0;const me=G.length;function Te(){return re<me?G[re++]():null}function Be(Ge){Ge!=null&&j.push(Ge);const Pe=Te();return Pe?Pe.then(Be):Promise.resolve(j)}return Promise.resolve(null).then(Be)}e.sequence=c;function u(G,j=me=>!!me,re=null){let me=0;const Te=G.length,Be=()=>{if(me>=Te)return Promise.resolve(re);const Ge=G[me++];return Promise.resolve(Ge()).then(De=>j(De)?Promise.resolve(De):Be())};return Be()}e.first=u;function n(G,j=me=>!!me,re=null){if(G.length===0)return Promise.resolve(re);let me=G.length;const Te=()=>{me=-1;for(const Be of G)Be.cancel?.()};return new Promise((Be,Ge)=>{for(const Pe of G)Pe.then(De=>{--me>=0&&j(De)?(Te(),Be(De)):me===0&&Be(re)}).catch(De=>{--me>=0&&(Te(),Ge(De))})})}e.firstParallel=n;class h{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new y.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((re,me)=>{this.f.push({factory:j,c:re,e:me}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const re=j.factory();re.then(j.c,j.e),re.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class g extends h{constructor(){super(1)}}e.Queue=g;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const j=new ne;return this.b.add(j),j.p}d(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,re=C.extUri){const me=re.getComparisonKey(j);let Te=this.a.get(me);return Te||(Te=new g,y.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(me),this.f()}),this.a.set(me,Te)),Te}f(){!this.d()||this.g()}g(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.g()}}e.ResourceQueue=A;class L{constructor(j,re){this.a=-1,typeof j=="function"&&typeof re=="number"&&this.setIfNotSet(j,re)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,re){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},re)}setIfNotSet(j,re){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},re))}}e.TimeoutTimer=L;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,re){this.cancel(),this.a=setInterval(()=>{j()},re)}}e.IntervalTimer=q;class Z{constructor(j,re){this.b=-1,this.a=j,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Z;class x{constructor(j,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=j,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class O extends Z{constructor(j,re){super(j,re),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=O;class F extends N.Disposable{constructor(j,re){super(),this.g=j,this.h=re,this.a=[],this.b=this.B(new N.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of j)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,R.setTimeout0)(()=>{if(j)return;const re=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,re-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(G,j)=>{const re=requestIdleCallback(G,typeof j=="number"?{timeout:j}:void 0);let me=!1;return{dispose(){me||(me=!0,cancelIdleCallback(re))}}}}();class P{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(re){this.g=re}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=P;async function B(G,j,re){let me;for(let Te=0;Te<re;Te++)try{return await G()}catch(Be){me=Be,await a(j)}throw me}e.retry=B;class V{hasPending(j){return this.a?typeof j=="number"?this.a.taskId===j:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(j,re,me){return this.a={taskId:j,cancel:()=>me?.(),promise:re},re.then(()=>this.d(j),()=>this.d(j)),re}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this.b)this.b.run=j;else{let re,me;const Te=new Promise((Be,Ge)=>{re=Be,me=Ge});this.b={run:j,promise:Te,promiseResolve:re,promiseReject:me}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class z{constructor(j,re=()=>Date.now()){this.d=j,this.f=re,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.IntervalCounter=z;class ne{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((j,re)=>{this.a=j,this.b=re})}complete(j){return new Promise(re=>{this.a(j),this.f=!0,re()})}error(j){return new Promise(re=>{this.b(j),this.d=!0,re()})}cancel(){new Promise(j=>{this.b(new T.CancellationError),this.d=!0,j()})}}e.DeferredPromise=ne;var de;(function(G){async function j(me){let Te;const Be=await Promise.all(me.map(Ge=>Ge.then(Pe=>Pe,Pe=>{Te||(Te=Pe)})));if(typeof Te<"u")throw Te;return Be}G.settled=j;function re(me){return new Promise(async(Te,Be)=>{try{await me(Te,Be)}catch(Ge){Be(Ge)}})}G.withAsyncBody=re})(de=e.Promises||(e.Promises={}));var we;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(we||(we={}));class ue{static fromArray(j){return new ue(re=>{re.emitMany(j)})}static fromPromise(j){return new ue(async re=>{re.emitMany(await j)})}static fromPromises(j){return new ue(async re=>{await Promise.all(j.map(async me=>re.emitOne(await me)))})}static merge(j){return new ue(async re=>{await Promise.all(j.map(async me=>{for await(const Te of me)re.emitOne(Te)}))})}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new y.Emitter,queueMicrotask(async()=>{const re={emitOne:me=>this.g(me),emitMany:me=>this.h(me),reject:me=>this.k(me)};try{await Promise.resolve(j(re)),this.j()}catch(me){this.k(me)}finally{re.emitOne=void 0,re.emitMany=void 0,re.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(j,re){return new ue(async me=>{for await(const Te of j)me.emitOne(re(Te))})}map(j){return ue.map(this,j)}static filter(j,re){return new ue(async me=>{for await(const Te of j)re(Te)&&me.emitOne(Te)})}filter(j){return ue.filter(this,j)}static coalesce(j){return ue.filter(j,re=>!!re)}coalesce(){return ue.coalesce(this)}static async toPromise(j){const re=[];for await(const me of j)re.push(me);return re}toPromise(){return ue.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class ae extends ue{constructor(j,re){super(re),this.l=j}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ae;function Ie(G){const j=new t.CancellationTokenSource,re=G(j.token);return new ae(j,async me=>{const Te=j.token.onCancellationRequested(()=>{Te.dispose(),j.dispose(),me.reject(new T.CancellationError)});try{for await(const Be of re){if(j.token.isCancellationRequested)return;me.emitOne(Be)}Te.dispose(),j.dispose()}catch(Be){Te.dispose(),j.dispose(),me.reject(Be)}})}e.createCancelableAsyncIterable=Ie}),define(Ce[124],ke([1,0,14,19]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new t.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),N=new t.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new t.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(h,g,A=!1){const L=h||"",q=g||"",Z=y.value.collator.compare(L,q);return y.value.collatorIsNumeric&&Z===0&&L!==q?L<q?-1:1:Z}e.compareFileNames=R;function D(h,g){const A=N.value.collator;return h=h||"",g=g||"",E(A,h,g)}e.compareFileNamesDefault=D;function k(h,g){const A=N.value.collator;return h=h||"",g=g||"",a(h,g)||E(A,h,g)}e.compareFileNamesUpper=k;function M(h,g){const A=N.value.collator;return h=h||"",g=g||"",o(h,g)||E(A,h,g)}e.compareFileNamesLower=M;function S(h,g){return h=h||"",g=g||"",h===g?0:h<g?-1:1}e.compareFileNamesUnicode=S;function f(h,g){const[A,L]=v(h),[q,Z]=v(g);let x=y.value.collator.compare(L,Z);if(x===0){if(y.value.collatorIsNumeric&&L!==Z)return L<Z?-1:1;if(x=y.value.collator.compare(A,q),y.value.collatorIsNumeric&&x===0&&A!==q)return A<q?-1:1}return x}e.compareFileExtensions=f;function p(h,g){h=h||"",g=g||"";const A=b(h),L=b(g),q=N.value.collator,Z=C.value.collator;return E(Z,A,L)||E(q,h,g)}e.compareFileExtensionsDefault=p;function m(h,g){h=h||"",g=g||"";const A=b(h),L=b(g),q=N.value.collator,Z=C.value.collator;return E(Z,A,L)||a(h,g)||E(q,h,g)}e.compareFileExtensionsUpper=m;function i(h,g){h=h||"",g=g||"";const A=b(h),L=b(g),q=N.value.collator,Z=C.value.collator;return E(Z,A,L)||o(h,g)||E(q,h,g)}e.compareFileExtensionsLower=i;function r(h,g){h=h||"",g=g||"";const A=b(h).toLowerCase(),L=b(g).toLowerCase();return A!==L?A<L?-1:1:h!==g?h<g?-1:1:0}e.compareFileExtensionsUnicode=r;const l=/^(.*?)(\.([^.]*))?$/;function v(h,g=!1){const A=h?l.exec(h):[];let L=[A&&A[1]||"",A&&A[3]||""];return g&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function b(h){const g=h?l.exec(h):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function E(h,g,A){const L=h.compare(g,A);return L!==0?L:g.length!==A.length?g.length<A.length?-1:1:0}function w(h){const g=h.charAt(0);return g.toLocaleUpperCase()!==g}function s(h){const g=h.charAt(0);return g.toLocaleLowerCase()!==g}function o(h,g){return w(h)&&s(g)?-1:s(h)&&w(g)?1:0}function a(h,g){return s(h)&&w(g)?-1:w(h)&&s(g)?1:0}function d(h,g,A=!1){return A||(h=h&&h.toLowerCase(),g=g&&g.toLowerCase()),h===g?0:h<g?-1:1}function c(h,g,A=!1){const L=h.split(T.sep),q=g.split(T.sep),Z=L.length-1,x=q.length-1;let O,F;for(let P=0;;P++){if(O=Z===P,F=x===P,O&&F)return R(L[P],q[P],A);if(O)return-1;if(F)return 1;const B=d(L[P],q[P],A);if(B!==0)return B}}e.comparePaths=c;function u(h,g,A){const L=h.toLowerCase(),q=g.toLowerCase(),Z=n(h,g,A);if(Z)return Z;const x=L.endsWith(A),O=q.endsWith(A);if(x!==O)return x?-1:1;const F=R(L,q);return F!==0?F:L.localeCompare(q)}e.compareAnything=u;function n(h,g,A){const L=h.toLowerCase(),q=g.toLowerCase(),Z=L.startsWith(A),x=q.startsWith(A);if(Z!==x)return Z?-1:1;if(Z&&x){if(L.length<q.length)return-1;if(L.length>q.length)return 1}return 0}e.compareByPrefix=n}),define(Ce[35],ke([1,0,16,14,40,28,19,21,10]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const M="[/\\\\]",S="[^/\\\\]",f=/\//g;function p(ne,de){switch(ne){case 0:return"";case 1:return`${S}*?`;default:return`(?:${M}|${S}+${M}${de?`|${M}${S}+`:""})*?`}}function m(ne,de){if(!ne)return[];const we=[];let ue=!1,ae=!1,Ie="";for(const G of ne){switch(G){case de:if(!ue&&!ae){we.push(Ie),Ie="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}Ie+=G}return Ie&&we.push(Ie),we}e.splitGlobAware=m;function i(ne){if(!ne)return"";let de="";const we=m(ne,e.GLOB_SPLIT);if(we.every(ue=>ue===e.GLOBSTAR))de=".*";else{let ue=!1;we.forEach((ae,Ie)=>{if(ae===e.GLOBSTAR){if(ue)return;de+=p(2,Ie===we.length-1)}else{let G=!1,j="",re=!1,me="";for(const Te of ae){if(Te!=="}"&&G){j+=Te;continue}if(re&&(Te!=="]"||!me)){let Be;Te==="-"?Be=Te:(Te==="^"||Te==="!")&&!me?Be="^":Te===e.GLOB_SPLIT?Be="":Be=(0,D.escapeRegExpCharacters)(Te),me+=Be;continue}switch(Te){case"{":G=!0;continue;case"[":re=!0;continue;case"}":{de+=`(?:${m(j,",").map(Pe=>i(Pe)).join("|")})`,G=!1,j="";break}case"]":{de+="["+me+"]",re=!1,me="";break}case"?":de+=S;continue;case"*":de+=p(1);continue;default:de+=(0,D.escapeRegExpCharacters)(Te)}}Ie<we.length-1&&(we[Ie+1]!==e.GLOBSTAR||Ie+2<we.length)&&(de+=M)}ue=ae===e.GLOBSTAR})}return de}const r=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new N.LRUCache(1e4),o=function(){return!1},a=function(){return null};function d(ne,de){if(!ne)return a;let we;typeof ne!="string"?we=ne.pattern:we=ne,we=we.trim();const ue=`${we}_${!!de.trimForExclusions}`;let ae=s.get(ue);if(ae)return c(ae,ne);let Ie;return r.test(we)?ae=n(we.substr(4),we):(Ie=l.exec(u(we,de)))?ae=h(Ie[1],we):(de.trimForExclusions?b:v).test(we)?ae=g(we,de):(Ie=E.exec(u(we,de)))?ae=A(Ie[1].substr(1),we,!0):(Ie=w.exec(u(we,de)))?ae=A(Ie[1],we,!1):ae=L(we),s.set(ue,ae),c(ae,ne)}function c(ne,de){if(typeof de=="string")return ne;const we=function(ue,ae){return(0,y.isEqualOrParent)(ue,de.base,!R.isLinux)?ne((0,D.ltrim)(ue.substr(de.base.length),C.sep),ae):null};return we.allBasenames=ne.allBasenames,we.allPaths=ne.allPaths,we.basenames=ne.basenames,we.patterns=ne.patterns,we}function u(ne,de){return de.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function n(ne,de){return function(we,ue){return typeof we=="string"&&we.endsWith(ne)?de:null}}function h(ne,de){const we=`/${ne}`,ue=`\\${ne}`,ae=function(G,j){return typeof G!="string"?null:j?j===ne?de:null:G===ne||G.endsWith(we)||G.endsWith(ue)?de:null},Ie=[ne];return ae.basenames=Ie,ae.patterns=[de],ae.allBasenames=Ie,ae}function g(ne,de){const we=V(ne.slice(1,-1).split(",").map(j=>d(j,de)).filter(j=>j!==a),ne),ue=we.length;if(!ue)return a;if(ue===1)return we[0];const ae=function(j,re){for(let me=0,Te=we.length;me<Te;me++)if(we[me](j,re))return ne;return null},Ie=we.find(j=>!!j.allBasenames);Ie&&(ae.allBasenames=Ie.allBasenames);const G=we.reduce((j,re)=>re.allPaths?j.concat(re.allPaths):j,[]);return G.length&&(ae.allPaths=G),ae}function A(ne,de,we){const ue=C.sep===C.posix.sep,ae=ue?ne:ne.replace(f,C.sep),Ie=C.sep+ae,G=C.posix.sep+ne;let j;return we?j=function(re,me){return typeof re=="string"&&(re===ae||re.endsWith(Ie)||!ue&&(re===ne||re.endsWith(G)))?de:null}:j=function(re,me){return typeof re=="string"&&(re===ae||!ue&&re===ne)?de:null},j.allPaths=[(we?"*/":"./")+ne],j}function L(ne){try{const de=new RegExp(`^${i(ne)}$`);return function(we){return de.lastIndex=0,typeof we=="string"&&de.test(we)?ne:null}}catch{return a}}function q(ne,de,we){return!ne||typeof de!="string"?!1:Z(ne)(de,void 0,we)}e.match=q;function Z(ne,de={}){if(!ne)return o;if(typeof ne=="string"||x(ne)){const we=d(ne,de);if(we===a)return o;const ue=function(ae,Ie){return!!we(ae,Ie)};return we.allBasenames&&(ue.allBasenames=we.allBasenames),we.allPaths&&(ue.allPaths=we.allPaths),ue}return P(ne,de)}e.parse=Z;function x(ne){const de=ne;return de?typeof de.base=="string"&&typeof de.pattern=="string":!1}e.isRelativePattern=x;function O(ne){return ne.allBasenames||[]}e.getBasenameTerms=O;function F(ne){return ne.allPaths||[]}e.getPathTerms=F;function P(ne,de){const we=V(Object.getOwnPropertyNames(ne).map(j=>B(j,ne[j],de)).filter(j=>j!==a)),ue=we.length;if(!ue)return a;if(!we.some(j=>!!j.requiresSiblings)){if(ue===1)return we[0];const j=function(Te,Be){let Ge;for(let Pe=0,De=we.length;Pe<De;Pe++){const Se=we[Pe](Te,Be);if(typeof Se=="string")return Se;(0,T.isThenable)(Se)&&(Ge||(Ge=[]),Ge.push(Se))}return Ge?(async()=>{for(const Pe of Ge){const De=await Pe;if(typeof De=="string")return De}return null})():null},re=we.find(Te=>!!Te.allBasenames);re&&(j.allBasenames=re.allBasenames);const me=we.reduce((Te,Be)=>Be.allPaths?Te.concat(Be.allPaths):Te,[]);return me.length&&(j.allPaths=me),j}const ae=function(j,re,me){let Te,Be;for(let Ge=0,Pe=we.length;Ge<Pe;Ge++){const De=we[Ge];De.requiresSiblings&&me&&(re||(re=(0,C.basename)(j)),Te||(Te=re.substr(0,re.length-(0,C.extname)(j).length)));const Se=De(j,re,Te,me);if(typeof Se=="string")return Se;(0,T.isThenable)(Se)&&(Be||(Be=[]),Be.push(Se))}return Be?(async()=>{for(const Ge of Be){const Pe=await Ge;if(typeof Pe=="string")return Pe}return null})():null},Ie=we.find(j=>!!j.allBasenames);Ie&&(ae.allBasenames=Ie.allBasenames);const G=we.reduce((j,re)=>re.allPaths?j.concat(re.allPaths):j,[]);return G.length&&(ae.allPaths=G),ae}function B(ne,de,we){if(de===!1)return a;const ue=d(ne,we);if(ue===a)return a;if(typeof de=="boolean")return ue;if(de){const ae=de.when;if(typeof ae=="string"){const Ie=(G,j,re,me)=>{if(!me||!ue(G,j))return null;const Te=ae.replace("$(basename)",()=>re),Be=me(Te);return(0,T.isThenable)(Be)?Be.then(Ge=>Ge?ne:null):Be?ne:null};return Ie.requiresSiblings=!0,Ie}}return ue}function V(ne,de){const we=ne.filter(j=>!!j.basenames);if(we.length<2)return ne;const ue=we.reduce((j,re)=>{const me=re.basenames;return me?j.concat(me):j},[]);let ae;if(de){ae=[];for(let j=0,re=ue.length;j<re;j++)ae.push(de)}else ae=we.reduce((j,re)=>{const me=re.patterns;return me?j.concat(me):j},[]);const Ie=function(j,re){if(typeof j!="string")return null;if(!re){let Te;for(Te=j.length;Te>0;Te--){const Be=j.charCodeAt(Te-1);if(Be===47||Be===92)break}re=j.substr(Te)}const me=ue.indexOf(re);return me!==-1?ae[me]:null};Ie.basenames=ue,Ie.patterns=ae,Ie.allBasenames=ue;const G=ne.filter(j=>!j.basenames);return G.push(Ie),G}function z(ne,de){return(0,t.equals)(ne,de,(we,ue)=>typeof we=="string"&&typeof ue=="string"?we===ue:typeof we!="string"&&typeof ue!="string"?we.base===ue.base&&we.pattern===ue.pattern:!1)}e.patternsEquals=z}),define(Ce[83],ke([1,0,11,122,22,10,2]),function(ee,e,t,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(l="",v=!1){if(this.value=l,typeof this.value!="string")throw(0,t.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(l,v=0){return this.value+=f(this.supportThemeIcons?(0,T.escapeIcons)(l):l).replace(/([ \t]+)/g,(b,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,v){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(l,v,b){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(l),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(l,v){const b=new RegExp((0,N.escapeRegExpCharacters)(v),"g");return l.replace(b,(E,w)=>l.charAt(w-1)!=="\\"?`\\${E}`:E)}}e.MarkdownString=D;function k(r){return M(r)?!r.value:Array.isArray(r)?r.every(k):!0}e.isEmptyMarkdownString=k;function M(r){return r instanceof D?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=M;function S(r,l){return r===l?!0:!r||!l?!1:r.value===l.value&&r.isTrusted===l.isTrusted&&r.supportThemeIcons===l.supportThemeIcons&&r.supportHtml===l.supportHtml&&(r.baseUri===l.baseUri||!!r.baseUri&&!!l.baseUri&&(0,y.isEqual)(C.URI.from(r.baseUri),C.URI.from(l.baseUri)))}e.markdownStringEqual=S;function f(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function p(r){return r.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function m(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=m;function i(r){const l=[],v=r.split("|").map(E=>E.trim());r=v[0];const b=v[1];if(b){const E=/height=(\d+)/.exec(b),w=/width=(\d+)/.exec(b),s=E?E[1]:"",o=w?w[1]:"",a=isFinite(parseInt(o)),d=isFinite(parseInt(s));a&&l.push(`width="${o}"`),d&&l.push(`height="${s}"`)}return{href:r,dimensions:l}}e.parseHrefAndDimensions=i}),define(Ce[84],ke([1,0,16,40,19,21,22,10]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function D(a,d){const{os:c,tildify:u,relative:n}=d;if(n){const A=k(a,n,c);if(typeof A=="string")return A}let h=a.fsPath;if(c===1&&!N.isWindows?h=h.replace(/\//g,"\\"):c!==1&&N.isWindows&&(h=h.replace(/\\/g,"/")),c!==1&&u?.userHome){const A=u.userHome.fsPath;let L;a.scheme!==u.userHome.scheme&&a.path.startsWith(y.posix.sep)?L=u.userHome.with({path:a.path}).fsPath:L=a.fsPath,h=f(L,A,c)}return(c===1?y.win32:y.posix).normalize(M(h,c===1))}e.getPathLabel=D;function k(a,d,c){const u=c===1?y.win32:y.posix,n=c===3?C.extUri:C.extUriIgnorePathCase,h=d.getWorkspace(),g=(0,t.firstOrDefault)(h.folders);if(!g)return;a.scheme!==g.uri.scheme&&a.path.startsWith(y.posix.sep)&&(a=g.uri.with({path:a.path}));const A=d.getWorkspaceFolder(a);if(!A)return;let L;if(n.isEqual(A.uri,a)?L="":L=n.relativePath(A.uri,a)??"",L&&(L=u.normalize(L)),h.folders.length>1&&!d.noPrefix){const q=A.name?A.name:n.basenameOrAuthority(A.uri);L=L?`${q} \u2022 ${L}`:q}return L}function M(a,d=N.isWindows){return(0,T.hasDriveLetter)(a,d)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=M;let S=Object.create(null);function f(a,d,c=N.OS){if(c===1||!a||!d)return a;let u=S.original===d?S.normalized:void 0;u||(u=d,N.isWindows&&(u=(0,T.toSlashes)(u)),u=`${(0,R.rtrim)(u,y.posix.sep)}${y.posix.sep}`,S={original:d,normalized:u});let n=a;return N.isWindows&&(n=(0,T.toSlashes)(n)),(c===3?n.startsWith(u):(0,R.startsWithIgnoreCase)(n,u))?`~/${n.substr(u.length)}`:a}e.tildify=f;function p(a,d){return a.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=p;const m="\u2026",i="\\\\",r="~";function l(a,d=y.sep){const c=new Array(a.length);let u=!1;for(let n=0;n<a.length;n++){const h=a[n];if(h===""){c[n]=`.${d}`;continue}if(!h){c[n]=h;continue}u=!0;let g="",A=h;A.indexOf(i)===0?(g=A.substr(0,A.indexOf(i)+i.length),A=A.substr(A.indexOf(i)+i.length)):A.indexOf(d)===0?(g=A.substr(0,A.indexOf(d)+d.length),A=A.substr(A.indexOf(d)+d.length)):A.indexOf(r)===0&&(g=A.substr(0,A.indexOf(r)+r.length),A=A.substr(A.indexOf(r)+r.length));const L=A.split(d);for(let q=1;u&&q<=L.length;q++)for(let Z=L.length-q;u&&Z>=0;Z--){u=!1;let x=L.slice(Z,Z+q).join(d);for(let O=0;!u&&O<a.length;O++)if(O!==n&&a[O]&&a[O].indexOf(x)>-1){const F=Z+q===L.length,P=Z>0&&a[O].indexOf(d)>-1?d+x:x,B=a[O].endsWith(P);u=!F||B}if(!u){let O="";(L[0].endsWith(":")||g!=="")&&(Z===1&&(Z=0,q++,x=L[0]+d+x),Z>0&&(O=L[0]+d),O=g+O),Z>0&&(O=O+m+d),O=O+x,Z+q<L.length&&(O=O+d+m),c[n]=O}}u&&(c[n]=h)}return c}e.shorten=l;var v;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function b(a,d=Object.create(null)){const c=[];let u=!1,n="";for(const h of a)if(h==="$"||u&&h==="{")n&&c.push({value:n,type:v.TEXT}),n="",u=!0;else if(h==="}"&&u){const g=d[n];if(typeof g=="string")g.length&&c.push({value:g,type:v.VARIABLE});else if(g){const A=c[c.length-1];(!A||A.type!==v.SEPARATOR)&&c.push({value:g.label,type:v.SEPARATOR})}n="",u=!1}else n+=h;return n&&!u&&c.push({value:n,type:v.TEXT}),c.filter((h,g)=>{if(h.type===v.SEPARATOR){const A=c[g-1],L=c[g+1];return[A,L].every(q=>q&&(q.type===v.VARIABLE||q.type===v.TEXT)&&q.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=b;function E(a,d){return N.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function w(a,d){return N.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,""):N.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function s(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=s;function o(a){const d=a.indexOf("/")!==-1?y.posix:y.win32,c=d.basename(a),u=d.dirname(a);return c.length?{name:c,parentPath:u}:{name:u,parentPath:""}}e.splitName=o}),define(Ce[125],ke([1,0,2]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(M){return M.toJSON()}class y{constructor(S){this.a=S}transformIncoming(S){const f=this.a.transformIncoming(S);return f===S?S:T(t.URI.from(f))}transformOutgoing(S){const f=this.a.transformOutgoing(S);return f===S?S:T(t.URI.from(f))}transformOutgoingURI(S){const f=this.a.transformOutgoing(S);return f===S?S:t.URI.from(f)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(M){return M}transformOutgoing(M){return M}transformOutgoingURI(M){return M}transformOutgoingScheme(M){return M}};function N(M,S,f){if(!M||f>200)return null;if(typeof M=="object"){if(M instanceof t.URI)return S.transformOutgoing(M);for(const p in M)if(Object.hasOwnProperty.call(M,p)){const m=N(M[p],S,f+1);m!==null&&(M[p]=m)}}return null}function C(M,S){const f=N(M,S,0);return f===null?M:f}e.transformOutgoingURIs=C;function R(M,S,f,p){if(!M||p>200)return null;if(typeof M=="object"){if(M.$mid===1)return f?t.URI.revive(S.transformIncoming(M)):S.transformIncoming(M);for(const m in M)if(Object.hasOwnProperty.call(M,m)){const i=R(M[m],S,f,p+1);i!==null&&(M[m]=i)}}return null}function D(M,S){const f=R(M,S,!1,0);return f===null?M:f}e.transformIncomingURIs=D;function k(M,S){const f=R(M,S,!0,0);return f===null?M:f}e.transformAndReviveIncomingURIs=k}),define(Ce[126],ke([1,0,35,19]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(N,C,R,D,k,M){if(Array.isArray(N)){let S=0;for(const f of N){const p=y(f,C,R,D,k,M);if(p===10)return p;p>S&&(S=p)}return S}else{if(typeof N=="string")return D?N==="*"?5:N===R?10:0:0;if(N){const{language:S,pattern:f,scheme:p,hasAccessToAllModels:m,notebookType:i}=N;if(!D&&!m)return 0;i&&k&&(C=k);let r=0;if(p)if(p===C.scheme)r=10;else if(p==="*")r=5;else return 0;if(S)if(S===R)r=10;else if(S==="*")r=Math.max(r,5);else return 0;if(i)if(i===M)r=10;else if(i==="*"&&M!==void 0)r=Math.max(r,5);else return 0;if(f){let l;if(typeof f=="string"?l=f:l={...f,base:(0,T.normalize)(f.base)},l===C.fsPath||(0,t.match)(l,C.fsPath))r=10;else return 0}return r}else return 0}}e.score=y}),define(Ce[85],ke([1,0,24,21]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(y||(y={}));function N(S){for(let f=0,p=S.length;f<p;f+=4){const m=S[f+0],i=S[f+1],r=S[f+2],l=S[f+3];S[f+0]=l,S[f+1]=r,S[f+2]=i,S[f+3]=m}}function C(S){const f=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return T.isLittleEndian()||N(f),t.VSBuffer.wrap(f)}function R(S){const f=S.buffer;if(T.isLittleEndian()||N(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const p=new Uint8Array(f.byteLength);return p.set(f),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(S){const f=new Uint32Array(k(S));let p=0;if(f[p++]=S.id,S.type==="full")f[p++]=1,f[p++]=S.data.length,f.set(S.data,p),p+=S.data.length;else{f[p++]=2,f[p++]=S.deltas.length;for(const m of S.deltas)f[p++]=m.start,f[p++]=m.deleteCount,m.data?(f[p++]=m.data.length,f.set(m.data,p),p+=m.data.length):f[p++]=0}return C(f)}e.encodeSemanticTokensDto=D;function k(S){let f=0;if(f+=1+1,S.type==="full")f+=1+S.data.length;else{f+=1,f+=(1+1+1)*S.deltas.length;for(const p of S.deltas)p.data&&(f+=p.data.length)}return f}function M(S){const f=R(S);let p=0;const m=f[p++];if(f[p++]===1){const v=f[p++],b=f.subarray(p,p+v);return p+=v,{id:m,type:"full",data:b}}const r=f[p++],l=[];for(let v=0;v<r;v++){const b=f[p++],E=f[p++],w=f[p++];let s;w>0&&(s=f.subarray(p,p+w),p+=w),l[v]={start:b,deleteCount:E,data:s}}return{id:m,type:"delta",deltas:l}}e.decodeSemanticTokensDto=M}),define(Ce[127],ke([17,18]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ce[128],ke([1,0,127,21,129,16,23,114]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=k;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class S{constructor(_,ge,Le,$e){this.id=_,this.name=ge,this.defaultValue=Le,this.schema=$e}applyUpdate(_,ge){return p(_,ge)}compute(_,ge,Le){return Le}}class f{constructor(_,ge){this.newValue=_,this.didChange=ge}}e.ApplyUpdateResult=f;function p(Q,_){if(typeof Q!="object"||typeof _!="object"||!Q||!_)return new f(_,Q!==_);if(Array.isArray(Q)||Array.isArray(_)){const Le=Array.isArray(Q)&&Array.isArray(_)&&N.equals(Q,_);return new f(_,!Le)}let ge=!1;for(const Le in _)if(_.hasOwnProperty(Le)){const $e=p(Q[Le],_[Le]);$e.didChange&&(Q[Le]=$e.newValue,ge=!0)}return new f(Q,ge)}class m{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,ge){return p(_,ge)}validate(_){return this.defaultValue}}class i{constructor(_,ge,Le,$e){this.id=_,this.name=ge,this.defaultValue=Le,this.schema=$e}applyUpdate(_,ge){return p(_,ge)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,ge,Le){return Le}}function r(Q,_){return typeof Q>"u"?_:Q==="false"?!1:Boolean(Q)}e.boolean=r;class l extends i{constructor(_,ge,Le,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=Le),super(_,ge,Le,$e)}validate(_){return r(_,this.defaultValue)}}function v(Q,_,ge,Le){if(typeof Q>"u")return _;let $e=parseInt(Q,10);return isNaN($e)?_:($e=Math.max(ge,$e),$e=Math.min(Le,$e),$e|0)}e.clampedInt=v;class b extends i{static clampedInt(_,ge,Le,$e){return v(_,ge,Le,$e)}constructor(_,ge,Le,$e,Ve,Qe=void 0){typeof Qe<"u"&&(Qe.type="integer",Qe.default=Le,Qe.minimum=$e,Qe.maximum=Ve),super(_,ge,Le,Qe),this.minimum=$e,this.maximum=Ve}validate(_){return b.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}class E extends i{static clamp(_,ge,Le){return _<ge?ge:_>Le?Le:_}static float(_,ge){if(typeof _=="number")return _;if(typeof _>"u")return ge;const Le=parseFloat(_);return isNaN(Le)?ge:Le}constructor(_,ge,Le,$e,Ve){typeof Ve<"u"&&(Ve.type="number",Ve.default=Le),super(_,ge,Le,Ve),this.validationFn=$e}validate(_){return this.validationFn(E.float(_,this.defaultValue))}}class w extends i{static string(_,ge){return typeof _!="string"?ge:_}constructor(_,ge,Le,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=Le),super(_,ge,Le,$e)}validate(_){return w.string(_,this.defaultValue)}}function s(Q,_,ge){return typeof Q!="string"||ge.indexOf(Q)===-1?_:Q}e.stringSet=s;class o extends i{constructor(_,ge,Le,$e,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=$e,Ve.default=Le),super(_,ge,Le,Ve),this.c=$e}validate(_){return s(_,this.defaultValue,this.c)}}class a extends S{constructor(_,ge,Le,$e,Ve,Qe,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ve,nt.default=$e),super(_,ge,Le,nt),this.c=Ve,this.d=Qe}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function d(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[t.localize(0,null),t.localize(1,null),t.localize(2,null)],default:"auto",tags:["accessibility"],description:t.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,ge,Le){return Le===0?_.accessibilitySupport:Le}}class u extends S{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:t.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:t.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{insertSpace:r(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function A(Q){switch(Q){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=A;function L(Q){switch(Q){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class q extends m{constructor(){super(135)}compute(_,ge,Le){const $e=["monaco-editor"];return ge.get(36)&&$e.push(ge.get(36)),_.extraEditorClassName&&$e.push(_.extraEditorClassName),ge.get(70)==="default"?$e.push("mouse-default"):ge.get(70)==="copy"&&$e.push("mouse-copy"),ge.get(105)&&$e.push("showUnused"),ge.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class Z extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:t.localize(6,null)})}compute(_,ge,Le){return Le&&_.emptySelectionClipboard}}class x extends S{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:t.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[t.localize(8,null),t.localize(9,null),t.localize(10,null)],description:t.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[t.localize(12,null),t.localize(13,null),t.localize(14,null)],description:t.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:t.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:t.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:t.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{cursorMoveOnType:r(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":s(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":s(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(ge.loop,this.defaultValue.loop)}}}class O extends S{constructor(){super(48,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:t.localize(19,null)},{type:"string",description:t.localize(20,null)}],description:t.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?O.OFF:_==="true"?O.ON:_:Boolean(_)?O.ON:O.OFF}}e.EditorFontLigatures=O,O.OFF='"liga" off, "calt" off',O.ON='"liga" on, "calt" on';class F extends S{constructor(){super(51,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:t.localize(22,null)},{type:"string",description:t.localize(23,null)}],description:t.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?F.OFF:_==="true"?F.TRANSLATE:_:Boolean(_)?F.TRANSLATE:F.OFF}compute(_,ge,Le){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=F,F.OFF="normal",F.TRANSLATE="translate";class P extends m{constructor(){super(47)}compute(_,ge,Le){return _.fontInfo}}class B extends i{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:t.localize(25,null)})}validate(_){const ge=E.float(_,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:E.clamp(ge,6,100)}compute(_,ge,Le){return _.fontInfo.fontSize}}class V extends S{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:t.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:t.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(b.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class z extends S{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[t.localize(28,null),t.localize(29,null),t.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:t.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:t.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:t.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:t.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:t.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:t.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Le,description:t.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Le,description:t.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Le,description:t.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Le,description:t.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Le,description:t.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{multiple:s(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??s(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??s(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??s(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??s(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??s(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ne extends S{constructor(){const _={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:t.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:t.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:t.localize(44,null)},"editor.hover.above":{type:"boolean",default:_.above,description:t.localize(45,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{enabled:r(ge.enabled,this.defaultValue.enabled),delay:b.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:r(ge.sticky,this.defaultValue.sticky),above:r(ge.above,this.defaultValue.above)}}}var de;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(de=e.RenderMinimap||(e.RenderMinimap={}));class we extends m{constructor(){super(138)}compute(_,ge,Le){return we.computeLayout(ge,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio})}static computeContainedMinimapLineCount(_){const ge=_.height/_.lineHeight,Le=Math.floor(_.paddingTop/_.lineHeight);let $e=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&($e=Math.max($e,ge-1));const Ve=(Le+_.viewLineCount+$e)/(_.pixelRatio*_.height),Qe=Math.floor(_.viewLineCount/Ve);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:$e,desiredRatio:Ve,minimapLineCount:Qe}}static c(_,ge){const Le=_.outerWidth,$e=_.outerHeight,Ve=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Qe=ge.stableMinimapLayoutInput,nt=Qe&&_.outerHeight===Qe.outerHeight&&_.lineHeight===Qe.lineHeight&&_.typicalHalfwidthCharacterWidth===Qe.typicalHalfwidthCharacterWidth&&_.pixelRatio===Qe.pixelRatio&&_.scrollBeyondLastLine===Qe.scrollBeyondLastLine&&_.paddingTop===Qe.paddingTop&&_.paddingBottom===Qe.paddingBottom&&_.minimap.enabled===Qe.minimap.enabled&&_.minimap.side===Qe.minimap.side&&_.minimap.size===Qe.minimap.size&&_.minimap.showSlider===Qe.minimap.showSlider&&_.minimap.renderCharacters===Qe.minimap.renderCharacters&&_.minimap.maxColumn===Qe.minimap.maxColumn&&_.minimap.scale===Qe.minimap.scale&&_.verticalScrollbarWidth===Qe.verticalScrollbarWidth&&_.isViewportWrapping===Qe.isViewportWrapping,wt=_.lineHeight,St=_.typicalHalfwidthCharacterWidth,Ct=_.scrollBeyondLastLine,lt=_.minimap.renderCharacters;let at=Ve>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Bt=_.minimap.maxColumn,Ot=_.minimap.size,Ft=_.minimap.side,ft=_.verticalScrollbarWidth,Dt=_.viewLineCount,$t=_.remainingWidth,Mt=_.isViewportWrapping,xe=lt?2:3;let Lt=Math.floor(Ve*$e);const Nt=Lt/Ve;let Ut=!1,gt=!1,kt=xe*at,ye=at/Ve,Ae=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:bt,extraLinesBeyondLastLine:vt,desiredRatio:At,minimapLineCount:pt}=we.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Ct,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:$e,lineHeight:wt,pixelRatio:Ve});if(Dt/pt>1)Ut=!0,gt=!0,at=1,kt=1,ye=at/Ve;else{let ht=!1,Kt=at+1;if(Ot==="fit"){const jt=Math.ceil((bt+Dt+vt)*kt);Mt&&nt&&$t<=ge.stableFitRemainingWidth?(ht=!0,Kt=ge.stableFitMaxMinimapScale):ht=jt>Lt}if(Ot==="fill"||ht){Ut=!0;const jt=at;kt=Math.min(wt*Ve,Math.max(1,Math.floor(1/At))),Mt&&nt&&$t<=ge.stableFitRemainingWidth&&(Kt=ge.stableFitMaxMinimapScale),at=Math.min(Kt,Math.max(1,Math.floor(kt/xe))),at>jt&&(Ae=Math.min(2,at/jt)),ye=at/Ve/Ae,Lt=Math.ceil(Math.max(Ze,bt+Dt+vt)*kt),Mt?(ge.stableMinimapLayoutInput=_,ge.stableFitRemainingWidth=$t,ge.stableFitMaxMinimapScale=at):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const fe=Math.floor(Bt*ye),X=Math.min(fe,Math.max(0,Math.floor(($t-ft-2)*ye/(St+ye)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(Ve*X);const Ne=Re/Ve;Re=Math.floor(Re*Ae);const _e=lt?1:2,ze=Ft==="left"?0:Le-X-ft;return{renderMinimap:_e,minimapLeft:ze,minimapWidth:X,minimapHeightIsEditorHeight:Ut,minimapIsSampling:gt,minimapScale:at,minimapLineHeight:kt,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:Ne,minimapCanvasOuterHeight:Nt}}static computeLayout(_,ge){const Le=ge.outerWidth|0,$e=ge.outerHeight|0,Ve=ge.lineHeight|0,Qe=ge.lineNumbersDigitCount|0,nt=ge.typicalHalfwidthCharacterWidth,wt=ge.maxDigitWidth,St=ge.pixelRatio,Ct=ge.viewLineCount,lt=_.get(130),at=lt==="inherit"?_.get(129):lt,Bt=at==="inherit"?_.get(125):at,Ot=_.get(128),Ft=ge.isDominatedByLongLines,ft=_.get(54),Dt=_.get(64).renderType!==0,$t=_.get(65),Mt=_.get(99),xe=_.get(80),Lt=_.get(69),Nt=_.get(97),Ut=Nt.verticalScrollbarSize,gt=Nt.verticalHasArrows,kt=Nt.arrowSize,ye=Nt.horizontalScrollbarSize,Ae=_.get(40),fe=_.get(104)!=="never";let X=_.get(62);Ae&&fe&&(X+=16);let Re=0;if(Dt){const _t=Math.max(Qe,$t);Re=Math.round(_t*wt)}let Ne=0;ft&&(Ne=Ve);let _e=0,ze=_e+Ne,Ze=ze+Re,bt=Ze+X;const vt=Le-Ne-Re-X;let At=!1,pt=!1,It=-1;at==="inherit"&&Ft?(At=!0,pt=!0):Bt==="on"||Bt==="bounded"?pt=!0:Bt==="wordWrapColumn"&&(It=Ot);const ht=we.c({outerWidth:Le,outerHeight:$e,lineHeight:Ve,typicalHalfwidthCharacterWidth:nt,pixelRatio:St,scrollBeyondLastLine:Mt,paddingTop:xe.top,paddingBottom:xe.bottom,minimap:Lt,verticalScrollbarWidth:Ut,viewLineCount:Ct,remainingWidth:vt,isViewportWrapping:pt},ge.memory||new M);ht.renderMinimap!==0&&ht.minimapLeft===0&&(_e+=ht.minimapWidth,ze+=ht.minimapWidth,Ze+=ht.minimapWidth,bt+=ht.minimapWidth);const Kt=vt-ht.minimapWidth,jt=Math.max(1,Math.floor((Kt-Ut-2)/nt)),Et=gt?kt:0;return pt&&(It=Math.max(1,jt),Bt==="bounded"&&(It=Math.min(It,Ot))),{width:Le,height:$e,glyphMarginLeft:_e,glyphMarginWidth:Ne,lineNumbersLeft:ze,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:X,contentLeft:bt,contentWidth:Kt,minimap:ht,viewportColumn:jt,isWordWrapMinified:At,isViewportWrapping:pt,wrappingColumn:It,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:ye,overviewRuler:{top:Et,width:Ut,height:$e-2*Et,right:0}}}}e.EditorLayoutInfoComputer=we;class ue extends S{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[t.localize(46,null),t.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:t.localize(48,null)}})}validate(_){return s(_,"simple",["simple","advanced"])}compute(_,ge,Le){return ge.get(2)===2?"advanced":Le}}class ae extends S{constructor(){const _={enabled:!0};super(61,"lightbulb",_,{"editor.lightbulb.enabled":{type:"boolean",default:_.enabled,description:t.localize(49,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:r(_.enabled,this.defaultValue.enabled)}}}class Ie extends S{constructor(){const _={enabled:!1,maxLineCount:5};super(109,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:t.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:t.localize(51,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{enabled:r(ge.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class G extends S{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:t.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[t.localize(53,null),t.localize(54,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),t.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),t.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:t.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:t.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:t.localize(59,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:s(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ge.fontFamily,this.defaultValue.fontFamily),padding:r(ge.padding,this.defaultValue.padding)}}}class j extends S{constructor(){super(62,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):b.clampedInt(_,this.defaultValue,0,1e3)}compute(_,ge,Le){return Le<0?b.clampedInt(-Le*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class re extends E{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>E.clamp(_,0,150),{markdownDescription:t.localize(60,null)})}compute(_,ge,Le){return _.fontInfo.lineHeight}}class me extends S{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:t.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:t.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[t.localize(63,null),t.localize(64,null),t.localize(65,null)],default:_.size,description:t.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:t.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:t.localize(68,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:t.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:t.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:t.localize(71,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{enabled:r(ge.enabled,this.defaultValue.enabled),autohide:r(ge.autohide,this.defaultValue.autohide),size:s(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ge.side,this.defaultValue.side,["right","left"]),showSlider:s(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(ge.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ge.scale,1,1,3),maxColumn:b.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Q){return Q==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Be extends S{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:t.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:t.localize(73,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{top:b.clampedInt(ge.top,0,0,1e3),bottom:b.clampedInt(ge.bottom,0,0,1e3)}}}class Ge extends S{constructor(){const _={enabled:!0,cycle:!0};super(81,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:t.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:t.localize(75,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{enabled:r(ge.enabled,this.defaultValue.enabled),cycle:r(ge.cycle,this.defaultValue.cycle)}}}class Pe extends m{constructor(){super(136)}compute(_,ge,Le){return _.pixelRatio}}class De extends S{constructor(){const _={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[t.localize(76,null),t.localize(77,null),t.localize(78,null)]}];super(84,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:_.strings,description:t.localize(79,null)},comments:{anyOf:ge,default:_.comments,description:t.localize(80,null)},other:{anyOf:ge,default:_.other,description:t.localize(81,null)}},default:_,markdownDescription:t.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const St=_?"on":"off";return{comments:St,strings:St,other:St}}if(!_||typeof _!="object")return this.defaultValue;const{other:ge,comments:Le,strings:$e}=_,Ve=["on","inline","off"];let Qe,nt,wt;return typeof ge=="boolean"?Qe=ge?"on":"off":Qe=s(ge,this.defaultValue.other,Ve),typeof Le=="boolean"?nt=Le?"on":"off":nt=s(Le,this.defaultValue.comments,Ve),typeof $e=="boolean"?wt=$e?"on":"off":wt=s($e,this.defaultValue.strings,Ve),{other:Qe,comments:nt,strings:wt}}}var Se;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends S{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[t.localize(83,null),t.localize(84,null),t.localize(85,null),t.localize(86,null)],default:"on",description:t.localize(87,null)})}validate(_){let ge=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(ge=4,Le=_):_==="interval"?ge=3:_==="relative"?ge=2:_==="on"?ge=1:ge=0),{renderType:ge,renderFn:Le}}}function ce(Q){const _=Q.get(92);return _==="editable"?Q.get(86):_!=="on"}e.filterValidationDecorations=ce;class Y extends S{constructor(){const _=[],ge={type:"number",description:t.localize(88,null)};super(96,"rulers",_,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:t.localize(89,null),format:"color-hex"}}}]},default:_,description:t.localize(90,null)})}validate(_){if(Array.isArray(_)){const ge=[];for(const Le of _)if(typeof Le=="number")ge.push({column:b.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const $e=Le;ge.push({column:b.clampedInt($e.column,0,0,1e4),color:$e.color})}return ge.sort((Le,$e)=>Le.column-$e.column),ge}return this.defaultValue}}function I(Q,_){if(typeof Q!="string")return _;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends S{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[t.localize(91,null),t.localize(92,null),t.localize(93,null)],default:"auto",description:t.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[t.localize(95,null),t.localize(96,null),t.localize(97,null)],default:"auto",description:t.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:t.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:t.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:t.localize(101,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_,Le=b.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=b.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(ge.vertical,this.defaultValue.vertical),horizontal:I(ge.horizontal,this.defaultValue.horizontal),useShadows:r(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:b.clampedInt(ge.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:b.clampedInt(ge.verticalSliderSize,$e,0,1e3),scrollByPage:r(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends S{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:t.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:t.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:t.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:t.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:t.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:t.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:t.localize(108,null)}})}applyUpdate(_,ge){let Le=!1;ge.allowedCharacters&&_&&(C.equals(_.allowedCharacters,ge.allowedCharacters)||(_={..._,allowedCharacters:ge.allowedCharacters},Le=!0)),ge.allowedLocales&&_&&(C.equals(_.allowedLocales,ge.allowedLocales)||(_={..._,allowedLocales:ge.allowedLocales},Le=!0));const $e=super.applyUpdate(_,ge);return Le?new f($e.newValue,!0):$e}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{nonBasicASCII:Ee(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ee(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ee(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,ge){if(typeof _!="object"||!_)return ge;const Le={};for(const[$e,Ve]of Object.entries(_))Ve===!0&&(Le[$e]=!0);return Le}}class K extends S{constructor(){const _={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:t.localize(109,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{enabled:r(ge.enabled,this.defaultValue.enabled),mode:s(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class J extends S{constructor(){const _={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:t.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:t.localize(111,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{enabled:r(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class le extends S{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[t.localize(112,null),t.localize(113,null),t.localize(114,null)],default:_.bracketPairs,description:t.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[t.localize(116,null),t.localize(117,null),t.localize(118,null)],default:_.bracketPairsHorizontal,description:t.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:t.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:t.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[t.localize(122,null),t.localize(123,null),t.localize(124,null)],default:_.highlightActiveIndentation,description:t.localize(125,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{bracketPairs:Ee(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ee(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ee(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ee(Q,_,ge){const Le=ge.indexOf(Q);return Le===-1?_:ge[Le]}class oe extends S{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[t.localize(126,null),t.localize(127,null)],default:_.insertMode,description:t.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:t.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:t.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:t.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[t.localize(132,null),t.localize(133,null),t.localize(134,null),t.localize(135,null)],default:_.selectionMode,markdownDescription:t.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:t.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:t.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:t.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:t.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:t.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:t.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:t.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:t.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:t.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:t.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:t.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:t.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:t.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:t.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:t.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:t.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:t.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:t.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:t.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:t.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:t.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:t.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:t.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:t.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:t.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:t.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:t.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:t.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:t.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:t.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:t.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:t.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:t.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:t.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:t.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:t.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:t.localize(173,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ge=_;return{insertMode:s(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(ge.showIcons,this.defaultValue.showIcons),showStatusBar:r(ge.showStatusBar,this.defaultValue.showStatusBar),preview:r(ge.preview,this.defaultValue.preview),previewMode:s(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(ge.showMethods,this.defaultValue.showMethods),showFunctions:r(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:r(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(ge.showFields,this.defaultValue.showFields),showVariables:r(ge.showVariables,this.defaultValue.showVariables),showClasses:r(ge.showClasses,this.defaultValue.showClasses),showStructs:r(ge.showStructs,this.defaultValue.showStructs),showInterfaces:r(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:r(ge.showModules,this.defaultValue.showModules),showProperties:r(ge.showProperties,this.defaultValue.showProperties),showEvents:r(ge.showEvents,this.defaultValue.showEvents),showOperators:r(ge.showOperators,this.defaultValue.showOperators),showUnits:r(ge.showUnits,this.defaultValue.showUnits),showValues:r(ge.showValues,this.defaultValue.showValues),showConstants:r(ge.showConstants,this.defaultValue.showConstants),showEnums:r(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:r(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(ge.showKeywords,this.defaultValue.showKeywords),showWords:r(ge.showWords,this.defaultValue.showWords),showColors:r(ge.showColors,this.defaultValue.showColors),showFiles:r(ge.showFiles,this.defaultValue.showFiles),showReferences:r(ge.showReferences,this.defaultValue.showReferences),showFolders:r(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:r(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(ge.showSnippets,this.defaultValue.showSnippets),showUsers:r(ge.showUsers,this.defaultValue.showUsers),showIssues:r(ge.showIssues,this.defaultValue.showIssues)}}}class pe extends S{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:t.localize(174,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ve extends m{constructor(){super(137)}compute(_,ge,Le){return ge.get(86)?!0:_.tabFocusMode}}var We;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class He extends S{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[t.localize(175,null),t.localize(176,null),t.localize(177,null),t.localize(178,null)],description:t.localize(179,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,ge,Le){return ge.get(2)===2?0:Le}}class tt extends m{constructor(){super(139)}compute(_,ge,Le){const $e=ge.get(138);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class Xe extends S{constructor(){const _={enabled:!0};super(33,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:t.localize(180,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:r(_.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?it:T.isLinux?dt:et,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var st;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.colorDecoratorsLimit=18]="colorDecoratorsLimit",Q[Q.columnSelection=19]="columnSelection",Q[Q.comments=20]="comments",Q[Q.contextmenu=21]="contextmenu",Q[Q.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=23]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=25]="cursorStyle",Q[Q.cursorSurroundingLines=26]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=28]="cursorWidth",Q[Q.disableLayerHinting=29]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Q[Q.domReadOnly=31]="domReadOnly",Q[Q.dragAndDrop=32]="dragAndDrop",Q[Q.dropIntoEditor=33]="dropIntoEditor",Q[Q.emptySelectionClipboard=34]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=36]="extraEditorClassName",Q[Q.fastScrollSensitivity=37]="fastScrollSensitivity",Q[Q.find=38]="find",Q[Q.fixedOverflowWidgets=39]="fixedOverflowWidgets",Q[Q.folding=40]="folding",Q[Q.foldingStrategy=41]="foldingStrategy",Q[Q.foldingHighlight=42]="foldingHighlight",Q[Q.foldingImportsByDefault=43]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=44]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=46]="fontFamily",Q[Q.fontInfo=47]="fontInfo",Q[Q.fontLigatures=48]="fontLigatures",Q[Q.fontSize=49]="fontSize",Q[Q.fontWeight=50]="fontWeight",Q[Q.fontVariations=51]="fontVariations",Q[Q.formatOnPaste=52]="formatOnPaste",Q[Q.formatOnType=53]="formatOnType",Q[Q.glyphMargin=54]="glyphMargin",Q[Q.gotoLocation=55]="gotoLocation",Q[Q.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Q[Q.hover=57]="hover",Q[Q.inDiffEditor=58]="inDiffEditor",Q[Q.inlineSuggest=59]="inlineSuggest",Q[Q.letterSpacing=60]="letterSpacing",Q[Q.lightbulb=61]="lightbulb",Q[Q.lineDecorationsWidth=62]="lineDecorationsWidth",Q[Q.lineHeight=63]="lineHeight",Q[Q.lineNumbers=64]="lineNumbers",Q[Q.lineNumbersMinChars=65]="lineNumbersMinChars",Q[Q.linkedEditing=66]="linkedEditing",Q[Q.links=67]="links",Q[Q.matchBrackets=68]="matchBrackets",Q[Q.minimap=69]="minimap",Q[Q.mouseStyle=70]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=72]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=74]="multiCursorModifier",Q[Q.multiCursorPaste=75]="multiCursorPaste",Q[Q.multiCursorLimit=76]="multiCursorLimit",Q[Q.occurrencesHighlight=77]="occurrencesHighlight",Q[Q.overviewRulerBorder=78]="overviewRulerBorder",Q[Q.overviewRulerLanes=79]="overviewRulerLanes",Q[Q.padding=80]="padding",Q[Q.parameterHints=81]="parameterHints",Q[Q.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=84]="quickSuggestions",Q[Q.quickSuggestionsDelay=85]="quickSuggestionsDelay",Q[Q.readOnly=86]="readOnly",Q[Q.renameOnType=87]="renameOnType",Q[Q.renderControlCharacters=88]="renderControlCharacters",Q[Q.renderFinalNewline=89]="renderFinalNewline",Q[Q.renderLineHighlight=90]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=92]="renderValidationDecorations",Q[Q.renderWhitespace=93]="renderWhitespace",Q[Q.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Q[Q.roundedSelection=95]="roundedSelection",Q[Q.rulers=96]="rulers",Q[Q.scrollbar=97]="scrollbar",Q[Q.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=99]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=100]="scrollPredominantAxis",Q[Q.selectionClipboard=101]="selectionClipboard",Q[Q.selectionHighlight=102]="selectionHighlight",Q[Q.selectOnLineNumbers=103]="selectOnLineNumbers",Q[Q.showFoldingControls=104]="showFoldingControls",Q[Q.showUnused=105]="showUnused",Q[Q.snippetSuggestions=106]="snippetSuggestions",Q[Q.smartSelect=107]="smartSelect",Q[Q.smoothScrolling=108]="smoothScrolling",Q[Q.stickyScroll=109]="stickyScroll",Q[Q.stickyTabStops=110]="stickyTabStops",Q[Q.stopRenderingLineAfter=111]="stopRenderingLineAfter",Q[Q.suggest=112]="suggest",Q[Q.suggestFontSize=113]="suggestFontSize",Q[Q.suggestLineHeight=114]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Q[Q.suggestSelection=116]="suggestSelection",Q[Q.tabCompletion=117]="tabCompletion",Q[Q.tabIndex=118]="tabIndex",Q[Q.unicodeHighlighting=119]="unicodeHighlighting",Q[Q.unusualLineTerminators=120]="unusualLineTerminators",Q[Q.useShadowDOM=121]="useShadowDOM",Q[Q.useTabStops=122]="useTabStops",Q[Q.wordBreak=123]="wordBreak",Q[Q.wordSeparators=124]="wordSeparators",Q[Q.wordWrap=125]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=128]="wordWrapColumn",Q[Q.wordWrapOverride1=129]="wordWrapOverride1",Q[Q.wordWrapOverride2=130]="wordWrapOverride2",Q[Q.wrappingIndent=131]="wrappingIndent",Q[Q.wrappingStrategy=132]="wrappingStrategy",Q[Q.showDeprecated=133]="showDeprecated",Q[Q.inlayHints=134]="inlayHints",Q[Q.editorClassName=135]="editorClassName",Q[Q.pixelRatio=136]="pixelRatio",Q[Q.tabFocusMode=137]="tabFocusMode",Q[Q.layoutInfo=138]="layoutInfo",Q[Q.wrappingInfo=139]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:t.localize(181,null)})),acceptSuggestionOnEnter:Fe(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",t.localize(182,null),""],markdownDescription:t.localize(183,null)})),accessibilitySupport:Fe(new c),accessibilityPageSize:Fe(new b(3,"accessibilityPageSize",10,1,1073741824,{description:t.localize(184,null),tags:["accessibility"]})),ariaLabel:Fe(new w(4,"ariaLabel",t.localize(185,null))),autoClosingBrackets:Fe(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",t.localize(186,null),t.localize(187,null),""],description:t.localize(188,null)})),autoClosingDelete:Fe(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",t.localize(189,null),""],description:t.localize(190,null)})),autoClosingOvertype:Fe(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",t.localize(191,null),""],description:t.localize(192,null)})),autoClosingQuotes:Fe(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",t.localize(193,null),t.localize(194,null),""],description:t.localize(195,null)})),autoIndent:Fe(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[t.localize(196,null),t.localize(197,null),t.localize(198,null),t.localize(199,null),t.localize(200,null)],description:t.localize(201,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[t.localize(202,null),t.localize(203,null),t.localize(204,null),""],description:t.localize(205,null)})),bracketPairColorization:Fe(new J),bracketPairGuides:Fe(new le),stickyTabStops:Fe(new l(110,"stickyTabStops",!1,{description:t.localize(206,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:t.localize(207,null)})),codeLensFontFamily:Fe(new w(15,"codeLensFontFamily","",{description:t.localize(208,null)})),codeLensFontSize:Fe(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:t.localize(209,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:t.localize(210,null)})),colorDecoratorsLimit:Fe(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:t.localize(211,null)})),columnSelection:Fe(new l(19,"columnSelection",!1,{description:t.localize(212,null)})),comments:Fe(new u),contextmenu:Fe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(22,"copyWithSyntaxHighlighting",!0,{description:t.localize(213,null)})),cursorBlinking:Fe(new a(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:t.localize(214,null)})),cursorSmoothCaretAnimation:Fe(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[t.localize(215,null),t.localize(216,null),t.localize(217,null)],description:t.localize(218,null)})),cursorStyle:Fe(new a(25,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:t.localize(219,null)})),cursorSurroundingLines:Fe(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:t.localize(220,null)})),cursorSurroundingLinesStyle:Fe(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[t.localize(221,null),t.localize(222,null)],description:t.localize(223,null)})),cursorWidth:Fe(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:t.localize(224,null)})),disableLayerHinting:Fe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(31,"domReadOnly",!1)),dragAndDrop:Fe(new l(32,"dragAndDrop",!0,{description:t.localize(225,null)})),emptySelectionClipboard:Fe(new Z),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new Ie),experimentalWhitespaceRendering:Fe(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[t.localize(226,null),t.localize(227,null),t.localize(228,null)],description:t.localize(229,null)})),extraEditorClassName:Fe(new w(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new E(37,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:t.localize(230,null)})),find:Fe(new x),fixedOverflowWidgets:Fe(new l(39,"fixedOverflowWidgets",!1)),folding:Fe(new l(40,"folding",!0,{description:t.localize(231,null)})),foldingStrategy:Fe(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[t.localize(232,null),t.localize(233,null)],description:t.localize(234,null)})),foldingHighlight:Fe(new l(42,"foldingHighlight",!0,{description:t.localize(235,null)})),foldingImportsByDefault:Fe(new l(43,"foldingImportsByDefault",!1,{description:t.localize(236,null)})),foldingMaximumRegions:Fe(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:t.localize(237,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:t.localize(238,null)})),fontFamily:Fe(new w(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:t.localize(239,null)})),fontInfo:Fe(new P),fontLigatures2:Fe(new O),fontSize:Fe(new B),fontWeight:Fe(new V),fontVariations:Fe(new F),formatOnPaste:Fe(new l(52,"formatOnPaste",!1,{description:t.localize(240,null)})),formatOnType:Fe(new l(53,"formatOnType",!1,{description:t.localize(241,null)})),glyphMargin:Fe(new l(54,"glyphMargin",!0,{description:t.localize(242,null)})),gotoLocation:Fe(new z),hideCursorInOverviewRuler:Fe(new l(56,"hideCursorInOverviewRuler",!1,{description:t.localize(243,null)})),hover:Fe(new ne),inDiffEditor:Fe(new l(58,"inDiffEditor",!1)),letterSpacing:Fe(new E(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>E.clamp(Q,-5,20),{description:t.localize(244,null)})),lightbulb:Fe(new ae),lineDecorationsWidth:Fe(new j),lineHeight:Fe(new re),lineNumbers:Fe(new se),lineNumbersMinChars:Fe(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(66,"linkedEditing",!1,{description:t.localize(245,null)})),links:Fe(new l(67,"links",!0,{description:t.localize(246,null)})),matchBrackets:Fe(new o(68,"matchBrackets","always",["always","near","never"],{description:t.localize(247,null)})),minimap:Fe(new me),mouseStyle:Fe(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new E(71,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:t.localize(248,null)})),mouseWheelZoom:Fe(new l(72,"mouseWheelZoom",!1,{markdownDescription:t.localize(249,null)})),multiCursorMergeOverlapping:Fe(new l(73,"multiCursorMergeOverlapping",!0,{description:t.localize(250,null)})),multiCursorModifier:Fe(new a(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[t.localize(251,null),t.localize(252,null)],markdownDescription:t.localize(253,null)})),multiCursorPaste:Fe(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[t.localize(254,null),t.localize(255,null)],markdownDescription:t.localize(256,null)})),multiCursorLimit:Fe(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:t.localize(257,null)})),occurrencesHighlight:Fe(new l(77,"occurrencesHighlight",!0,{description:t.localize(258,null)})),overviewRulerBorder:Fe(new l(78,"overviewRulerBorder",!0,{description:t.localize(259,null)})),overviewRulerLanes:Fe(new b(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Be),parameterHints:Fe(new Ge),peekWidgetDefaultFocus:Fe(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[t.localize(260,null),t.localize(261,null)],description:t.localize(262,null)})),definitionLinkOpensInPeek:Fe(new l(83,"definitionLinkOpensInPeek",!1,{description:t.localize(263,null)})),quickSuggestions:Fe(new De),quickSuggestionsDelay:Fe(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:t.localize(264,null)})),readOnly:Fe(new l(86,"readOnly",!1)),renameOnType:Fe(new l(87,"renameOnType",!1,{description:t.localize(265,null),markdownDeprecationMessage:t.localize(266,null)})),renderControlCharacters:Fe(new l(88,"renderControlCharacters",!0,{description:t.localize(267,null),restricted:!0})),renderFinalNewline:Fe(new o(89,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:t.localize(268,null)})),renderLineHighlight:Fe(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",t.localize(269,null)],description:t.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:t.localize(271,null)})),renderValidationDecorations:Fe(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",t.localize(272,null),t.localize(273,null),t.localize(274,null),""],description:t.localize(275,null)})),revealHorizontalRightPadding:Fe(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(95,"roundedSelection",!0,{description:t.localize(276,null)})),rulers:Fe(new Y),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:t.localize(277,null)})),scrollBeyondLastLine:Fe(new l(99,"scrollBeyondLastLine",!0,{description:t.localize(278,null)})),scrollPredominantAxis:Fe(new l(100,"scrollPredominantAxis",!0,{description:t.localize(279,null)})),selectionClipboard:Fe(new l(101,"selectionClipboard",!0,{description:t.localize(280,null),included:T.isLinux})),selectionHighlight:Fe(new l(102,"selectionHighlight",!0,{description:t.localize(281,null)})),selectOnLineNumbers:Fe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[t.localize(282,null),t.localize(283,null),t.localize(284,null)],description:t.localize(285,null)})),showUnused:Fe(new l(105,"showUnused",!0,{description:t.localize(286,null)})),showDeprecated:Fe(new l(133,"showDeprecated",!0,{description:t.localize(287,null)})),inlayHints:Fe(new G),snippetSuggestions:Fe(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[t.localize(288,null),t.localize(289,null),t.localize(290,null),t.localize(291,null)],description:t.localize(292,null)})),smartSelect:Fe(new pe),smoothScrolling:Fe(new l(108,"smoothScrolling",!1,{description:t.localize(293,null)})),stopRenderingLineAfter:Fe(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new oe),inlineSuggest:Fe(new K),suggestFontSize:Fe(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:t.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:t.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(115,"suggestOnTriggerCharacters",!0,{description:t.localize(296,null)})),suggestSelection:Fe(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[t.localize(297,null),t.localize(298,null),t.localize(299,null)],description:t.localize(300,null)})),tabCompletion:Fe(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[t.localize(301,null),t.localize(302,null),t.localize(303,null)],description:t.localize(304,null)})),tabIndex:Fe(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new H),unusualLineTerminators:Fe(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[t.localize(305,null),t.localize(306,null),t.localize(307,null)],description:t.localize(308,null)})),useShadowDOM:Fe(new l(121,"useShadowDOM",!0)),useTabStops:Fe(new l(122,"useTabStops",!0,{description:t.localize(309,null)})),wordBreak:Fe(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[t.localize(310,null),t.localize(311,null)],description:t.localize(312,null)})),wordSeparators:Fe(new w(124,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:t.localize(313,null)})),wordWrap:Fe(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[t.localize(314,null),t.localize(315,null),t.localize(316,null),t.localize(317,null)],description:t.localize(318,null)})),wordWrapBreakAfterCharacters:Fe(new w(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new w(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:t.localize(319,null)})),wordWrapOverride1:Fe(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new q),pixelRatio:Fe(new Pe),tabFocusMode:Fe(new ve),layoutInfo:Fe(new we),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new ue)}}),define(Ce[130],ke([17,18]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[131],ke([17,18]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[132],ke([17,18]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[133],ke([17,18]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ce[134],ke([17,18]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ce[135],ke([17,18]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ce[136],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[137],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[138],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[139],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[140],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[141],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[142],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[143],ke([17,18]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ce[144],ke([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[145],ke([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[146],ke([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[147],ke([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[148],ke([17,18]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[149],ke([17,18]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[150],ke([17,18]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[151],ke([1,0,11]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(N,C){this.a.set(N,C)}updateManifest(N){if(!(typeof N.main>"u"&&typeof N.browser>"u")&&(N.activationEvents===void 0&&Object.assign(N,{activationEvents:[]}),!(!Array.isArray(N.activationEvents)||!N.contributes)))for(const C in N.contributes){const R=this.a.get(C);if(!R)continue;const D=N.contributes[C],k=Array.isArray(D)?D:[D];try{R(k,N.activationEvents)}catch(M){(0,t.onUnexpectedError)(M)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(Ce[152],ke([1,0,22,29,132,250]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function D(l){return l=l.trim(),l==="*"||C.test(l)}e.isValidVersionStr=D;function k(l){if(!D(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=l.match(C);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function M(l){if(!l)return null;const v=l.majorBase,b=l.majorMustEqual,E=l.minorBase;let w=l.minorMustEqual;const s=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(v===0||(w=!1),o=!1);let a=0;if(l.preRelease){const d=R.exec(l.preRelease);if(d){const[,c,u,n]=d;a=Date.UTC(Number(c),Number(u)-1,Number(n))}}return{majorBase:v,majorMustEqual:b,minorBase:E,minorMustEqual:w,patchBase:s,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=M;function S(l,v,b){let E;typeof l=="string"?E=M(k(l)):E=l;let w;v instanceof Date?w=v.getTime():typeof v=="string"&&(w=new Date(v).getTime());let s;if(typeof b=="string"?s=M(k(b)):s=b,!E||!s)return!1;const o=E.majorBase,a=E.minorBase,d=E.patchBase;let c=s.majorBase,u=s.minorBase,n=s.patchBase;const h=s.notBefore;let g=s.majorMustEqual,A=s.minorMustEqual,L=s.patchMustEqual;return s.isMinimum?o>c?!0:o<c?!1:a>u?!0:a<u||w&&w<h?!1:d>=n:(o===1&&c===0&&(!g||!A||!L)&&(c=1,u=0,n=0,g=!0,A=!1,L=!1),o<c?!1:o>c?!g:a<u?!1:a>u?!A:d<n?!1:d>n?!L:!(w&&w<h))}e.isValidVersion=S;function f(l,v,b,E,w){const s=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return s.push([T.default.Error,y.localize(0,null)]),s;if(typeof E.name!="string")return s.push([T.default.Error,y.localize(1,null,"name")]),s;if(typeof E.version!="string")return s.push([T.default.Error,y.localize(2,null,"version")]),s;if(!E.engines)return s.push([T.default.Error,y.localize(3,null,"engines")]),s;if(typeof E.engines.vscode!="string")return s.push([T.default.Error,y.localize(4,null,"engines.vscode")]),s;if(typeof E.extensionDependencies<"u"&&!r(E.extensionDependencies))return s.push([T.default.Error,y.localize(5,null,"extensionDependencies")]),s;if(typeof E.activationEvents<"u"){if(!r(E.activationEvents))return s.push([T.default.Error,y.localize(6,null,"activationEvents")]),s;if(typeof E.main>"u"&&typeof E.browser>"u")return s.push([T.default.Error,y.localize(7,null,"activationEvents","main")]),s}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&s.push([T.default.Warning,y.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return s.push([T.default.Error,y.localize(9,null,"main")]),s;{const d=(0,t.joinPath)(b,E.main);(0,t.isEqualOrParent)(d,b)||s.push([T.default.Warning,y.localize(10,null,d.path,b.path)])}if(typeof E.activationEvents>"u")return s.push([T.default.Error,y.localize(11,null,"activationEvents","main")]),s}if(typeof E.browser<"u"){if(typeof E.browser!="string")return s.push([T.default.Error,y.localize(12,null,"browser")]),s;{const d=(0,t.joinPath)(b,E.browser);(0,t.isEqualOrParent)(d,b)||s.push([T.default.Warning,y.localize(13,null,d.path,b.path)])}if(typeof E.activationEvents>"u")return s.push([T.default.Error,y.localize(14,null,"activationEvents","browser")]),s}if(!N.valid(E.version))return s.push([T.default.Error,y.localize(15,null)]),s;const o=[];if(!p(l,v,E,w,o))for(const d of o)s.push([T.default.Error,d]);return s}e.validateExtensionManifest=f;function p(l,v,b,E,w){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:i(l,v,b.engines.vscode,w)}e.isValidExtensionVersion=p;function m(l,v,b){return l==="*"||i(v,b,l)}e.isEngineValid=m;function i(l,v,b,E=[]){const w=M(k(b));if(!w)return E.push(y.localize(16,null,b)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return E.push(y.localize(17,null,b)),!1}else if(!w.majorMustEqual)return E.push(y.localize(18,null,b)),!1;return S(l,v,w)?!0:(E.push(y.localize(19,null,l,b)),!1)}function r(l){if(!Array.isArray(l))return!1;for(let v=0,b=l.length;v<b;v++)if(typeof l[v]!="string")return!1;return!0}}),define(Ce[86],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class t{constructor(y,N=[],C=!1){this.ctor=y,this.staticArguments=N,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=t}),define(Ce[63],ke([1,0,86]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var y;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function N(R,D,k){D instanceof t.SyncDescriptor||(D=new t.SyncDescriptor(D,[],Boolean(k))),T.push([R,D])}e.registerSingleton=N;function C(){return T}e.getSingletonServiceDescriptors=C}),define(Ce[153],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class t{constructor(N,C){this.key=N,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=t;class T{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const C of this.a.values())C.outgoing.size===0&&N.push(C);return N}insertEdge(N,C){const R=this.lookupOrInsertNode(N),D=this.lookupOrInsertNode(C);R.outgoing.set(D.key,D),D.incoming.set(R.key,R)}removeNode(N){const C=this.b(N);this.a.delete(C);for(const R of this.a.values())R.outgoing.delete(C),R.incoming.delete(C)}lookupOrInsertNode(N){const C=this.b(N);let R=this.a.get(C);return R||(R=new t(C,N),this.a.set(C,R)),R}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[C,R]of this.a)N.push(`${C}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,C]of this.a){const R=new Set([N]),D=this.c(C,R);if(D)return D}}c(N,C){for(const[R,D]of N.outgoing){if(C.has(R))return[...C,R].join(" -> ");C.add(R);const k=this.c(D,C);if(k)return k;C.delete(R)}}}e.Graph=T}),define(Ce[3],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var t;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function R(D){return D[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=R})(t=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function T(C,R,D){R[t.DI_TARGET]===R?R[t.DI_DEPENDENCIES].push({id:C,index:D}):(R[t.DI_DEPENDENCIES]=[{id:C,index:D}],R[t.DI_TARGET]=R)}function y(C){if(t.serviceIds.has(C))return t.serviceIds.get(C);const R=function(D,k,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(R,D,M)};return R.toString=()=>C,t.serviceIds.set(C,R),R}e.createDecorator=y;function N(C){return C}e.refineServiceDecorator=N}),define(Ce[41],ke([1,0,9,2,3]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationOverrides=N;function C(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=C;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=D;function k(l,v){const b=Object.create(null);for(const E in l)M(b,E,l[E],v);return b}e.toValuesTree=k;function M(l,v,b,E){const w=v.split("."),s=w.pop();let o=l;for(let a=0;a<w.length;a++){const d=w[a];let c=o[d];switch(typeof c){case"undefined":c=o[d]=Object.create(null);break;case"object":break;default:E(`Ignoring ${v} as ${w.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}o=c}if(typeof o=="object"&&o!==null)try{o[s]=b}catch{E(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=M;function S(l,v){const b=v.split(".");f(l,b)}e.removeFromValueTree=S;function f(l,v){const b=v.shift();if(v.length===0){delete l[b];return}if(Object.keys(l).indexOf(b)!==-1){const E=l[b];typeof E=="object"&&!Array.isArray(E)&&(f(E,v),Object.keys(E).length===0&&delete l[b])}}function p(l,v,b){function E(o,a){let d=o;for(const c of a){if(typeof d!="object"||d===null)return;d=d[c]}return d}const w=v.split("."),s=E(l,w);return typeof s>"u"?b:s}e.getConfigurationValue=p;function m(l,v,b){Object.keys(v).forEach(E=>{E!=="__proto__"&&(E in l?t.isObject(l[E])&&t.isObject(v[E])?m(l[E],v[E],b):b&&(l[E]=v[E]):l[E]=v[E])})}e.merge=m;function i(l,v,b){const E=l.inspect(v),w=l.inspect(b);return typeof E.userValue<"u"||typeof E.workspaceValue<"u"||typeof E.workspaceFolderValue<"u"?E.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:E.defaultValue}e.getMigratedSettingValue=i;function r(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=r}),define(Ce[42],ke([1,0,21,10,3]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const N=new Map;N.set("false",!1),N.set("true",!0),N.set("isMac",t.isMacintosh),N.set("isLinux",t.isLinux),N.set("isWindows",t.isWindows),N.set("isWeb",t.isWeb),N.set("isMacNative",t.isMacintosh&&!t.isWeb),N.set("isEdge",t.isEdge),N.set("isFirefox",t.isFirefox),N.set("isChrome",t.isChrome),N.set("isSafari",t.isSafari);const C=Object.prototype.hasOwnProperty;var R;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return S.INSTANCE}static true(){return f.INSTANCE}static has(O){return p.create(O)}static equals(O,F){return m.create(O,F)}static notEquals(O,F){return l.create(O,F)}static regex(O,F){return a.create(O,F)}static in(O,F){return i.create(O,F)}static notIn(O,F){return r.create(O,F)}static not(O){return v.create(O)}static and(...O){return u.create(O,null,!0)}static or(...O){return n.create(O,null,!0)}static greater(O,F){return E.create(O,F)}static greaterEquals(O,F){return w.create(O,F)}static smaller(O,F){return s.create(O,F)}static smallerEquals(O,F){return o.create(O,F)}static deserialize(O,F=!1){if(!!O)return this.c(O,F)}static c(O,F){const P=O.split("||");return n.create(P.map(B=>this.d(B,F)),null,!0)}static d(O,F){const P=O.split("&&");return u.create(P.map(B=>this.f(B,F)),null,!0)}static f(O,F){if(O=O.trim(),O.indexOf("!=")>=0){const P=O.split("!=");return l.create(P[0].trim(),this.g(P[1],F))}if(O.indexOf("==")>=0){const P=O.split("==");return m.create(P[0].trim(),this.g(P[1],F))}if(O.indexOf("=~")>=0){const P=O.split("=~");return a.create(P[0].trim(),this.h(P[1],F))}if(O.indexOf(" not in ")>=0){const P=O.split(" not in ");return r.create(P[0].trim(),this.g(P[1],F))}if(O.indexOf(" in ")>=0){const P=O.split(" in ");return i.create(P[0].trim(),this.g(P[1],F))}if(/^[^<=>]+>=[^<=>]+$/.test(O)){const P=O.split(">=");return w.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(O)){const P=O.split(">");return E.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(O)){const P=O.split("<=");return o.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(O)){const P=O.split("<");return s.create(P[0].trim(),P[1].trim())}return/^\!\s*/.test(O)?v.create(O.substr(1).trim()):p.create(O)}static g(O,F){if(O=O.trim(),O==="true")return!0;if(O==="false")return!1;const P=/^'([^']*)'$/.exec(O);return P?P[1].trim():O}static h(O,F){if((0,T.isFalsyOrWhitespace)(O)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const P=O.indexOf("/"),B=O.lastIndexOf("/");if(P===B||P<0){if(F)throw new Error(`bad regexp-value '${O}', missing /-enclosure`);return console.warn(`bad regexp-value '${O}', missing /-enclosure`),null}const V=O.slice(P+1,B),z=O[B+1]==="i"?"i":"";try{return new RegExp(V,z)}catch(ne){if(F)throw new Error(`bad regexp-value '${O}', parse error: ${ne}`);return console.warn(`bad regexp-value '${O}', parse error: ${ne}`),null}}}e.ContextKeyExpr=D;function k(x,O){const F=x?x.substituteConstants():void 0,P=O?O.substituteConstants():void 0;return!F&&!P?!0:!F||!P?!1:F.equals(P)}e.expressionsAreEqualWithConstantSubstitution=k;function M(x,O){return x.cmp(O)}class S{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class f{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class p{static create(O,F=null){const P=N.get(O);return typeof P=="boolean"?P?f.INSTANCE:S.INSTANCE:new p(O,F)}constructor(O,F){this.key=O,this.c=F,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:g(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=N.get(this.key);return typeof O=="boolean"?O?f.INSTANCE:S.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class m{static create(O,F,P=null){if(typeof F=="boolean")return F?p.create(O,P):v.create(O,P);const B=N.get(O);return typeof B=="boolean"?F===(B?"true":"false")?f.INSTANCE:S.INSTANCE:new m(O,F,P)}constructor(O,F,P){this.c=O,this.d=F,this.f=P,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:A(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=N.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?f.INSTANCE:S.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class i{static create(O,F){return new i(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:A(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.f),P=O.getValue(this.d);return Array.isArray(F)?F.includes(P):typeof P=="string"&&typeof F=="object"&&F!==null?C.call(F,P):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=r.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=i;class r{static create(O,F){return new r(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=11,this.c=i.create(O,F)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=r;class l{static create(O,F,P=null){if(typeof F=="boolean")return F?v.create(O,P):p.create(O,P);const B=N.get(O);return typeof B=="boolean"?F===(B?"true":"false")?S.INSTANCE:f.INSTANCE:new l(O,F,P)}constructor(O,F,P){this.c=O,this.d=F,this.f=P,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:A(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=N.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?S.INSTANCE:f.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class v{static create(O,F=null){const P=N.get(O);return typeof P=="boolean"?P?S.INSTANCE:f.INSTANCE:new v(O,F)}constructor(O,F){this.c=O,this.d=F,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:g(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=N.get(this.c);return typeof O=="boolean"?O?S.INSTANCE:f.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function b(x,O){if(typeof x=="string"){const F=parseFloat(x);isNaN(F)||(x=F)}return typeof x=="string"||typeof x=="number"?O(x):S.INSTANCE}class E{static create(O,F,P=null){return b(F,B=>new E(O,B,P))}constructor(O,F,P){this.c=O,this.d=F,this.f=P,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:A(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=E;class w{static create(O,F,P=null){return b(F,B=>new w(O,B,P))}constructor(O,F,P){this.c=O,this.d=F,this.f=P,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:A(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class s{static create(O,F,P=null){return b(F,B=>new s(O,B,P))}constructor(O,F,P){this.c=O,this.d=F,this.f=P,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:A(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class o{static create(O,F,P=null){return b(F,B=>new o(O,B,P))}constructor(O,F,P){this.c=O,this.d=F,this.f=P,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:A(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class a{static create(O,F){return new a(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const F=this.f?this.f.source:"",P=O.f?O.f.source:"";return F<P?-1:F>P?1:0}equals(O){if(O.type===this.type){const F=this.f?this.f.source:"",P=O.f?O.f.source:"";return this.d===O.d&&F===P}return!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=d.create(this)),this.c}}e.ContextKeyRegexExpr=a;class d{static create(O){return new d(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(O){return new d(this.c.map(O))}negate(){return this.c}}e.ContextKeyNotRegexExpr=d;function c(x){let O=null;for(let F=0,P=x.length;F<P;F++){const B=x[F].substituteConstants();if(x[F]!==B&&O===null){O=[];for(let V=0;V<F;V++)O[V]=x[V]}O!==null&&(O[F]=B)}return O===null?x:O}class u{static create(O,F,P){return u.d(O,F,P)}constructor(O,F){this.expr=O,this.c=F,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,P=this.expr.length;F<P;F++){const B=M(this.expr[F],O.expr[F]);if(B!==0)return B}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,P=this.expr.length;F<P;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=c(this.expr);return O===this.expr?this:u.create(O,this.c,!1)}evaluate(O){for(let F=0,P=this.expr.length;F<P;F++)if(!this.expr[F].evaluate(O))return!1;return!0}static d(O,F,P){const B=[];let V=!1;for(const z of O)if(!!z){if(z.type===1){V=!0;continue}if(z.type===0)return S.INSTANCE;if(z.type===6){B.push(...z.expr);continue}B.push(z)}if(B.length===0&&V)return f.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(M);for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];for(;B.length>1;){const z=B[B.length-1];if(z.type!==9)break;B.pop();const ne=B.pop(),de=B.length===0,we=n.create(z.expr.map(ue=>u.create([ue,ne],null,P)),null,de);we&&(B.push(we),B.sort(M))}if(B.length===1)return B[0];if(P){for(let z=0;z<B.length;z++)for(let ne=z+1;ne<B.length;ne++)if(B[z].negate().equals(B[ne]))return S.INSTANCE;if(B.length===1)return B[0]}return new u(B,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new u(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());this.c=n.create(O,this,!0)}return this.c}}class n{static create(O,F,P){return n.d(O,F,P)}constructor(O,F){this.expr=O,this.c=F,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,P=this.expr.length;F<P;F++){const B=M(this.expr[F],O.expr[F]);if(B!==0)return B}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,P=this.expr.length;F<P;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=c(this.expr);return O===this.expr?this:n.create(O,this.c,!1)}evaluate(O){for(let F=0,P=this.expr.length;F<P;F++)if(this.expr[F].evaluate(O))return!0;return!1}static d(O,F,P){let B=[],V=!1;if(O){for(let z=0,ne=O.length;z<ne;z++){const de=O[z];if(!!de){if(de.type===0){V=!0;continue}if(de.type===1)return f.INSTANCE;if(de.type===9){B=B.concat(de.expr);continue}B.push(de)}}if(B.length===0&&V)return S.INSTANCE;B.sort(M)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(P){for(let z=0;z<B.length;z++)for(let ne=z+1;ne<B.length;ne++)if(B[z].negate().equals(B[ne]))return f.INSTANCE;if(B.length===1)return B[0]}return new n(B,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new n(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());for(;O.length>1;){const F=O.shift(),P=O.shift(),B=[];for(const V of Z(F))for(const z of Z(P))B.push(u.create([V,z],null,!1));O.unshift(n.create(B,null,!1))}this.c=n.create(O,this,!0)}return this.c}}class h extends p{static all(){return h.d.values()}constructor(O,F,P){super(O,null),this.f=F,typeof P=="object"?h.d.push({...P,key:O}):P!==!0&&h.d.push({key:O,description:P,type:F!=null?typeof F:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return m.create(this.key,O)}notEqualsTo(O){return l.create(this.key,O)}}e.RawContextKey=h,h.d=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService");function g(x,O){return x<O?-1:x>O?1:0}function A(x,O,F,P){return x<F?-1:x>F?1:O<P?-1:O>P?1:0}function L(x,O){if(x.type===0||O.type===1)return!0;if(x.type===9)return O.type===9?q(x.expr,O.expr):!1;if(O.type===9){for(const F of O.expr)if(L(x,F))return!0;return!1}if(x.type===6){if(O.type===6)return q(O.expr,x.expr);for(const F of x.expr)if(L(F,O))return!0;return!1}return x.equals(O)}e.implies=L;function q(x,O){let F=0,P=0;for(;F<x.length&&P<O.length;){const B=x[F].cmp(O[P]);if(B<0)return!1;B===0&&F++,P++}return F===x.length}function Z(x){return x.type===9?x.expr:[x]}}),define(Ce[154],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,t.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,t.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[87],ke([1,0,131,3]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function N(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function C(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function R(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function D(l,v,b){return R(v,b)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===b?!0:k(b).includes(l)}e.isTargetPlatformCompatible=D;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function M(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=M;var S;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var f;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var p;(function(l){l.Install="install",l.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var m;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var i;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(i=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class r extends Error{constructor(v,b){super(v),this.code=b,this.name=b}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[36],ke([1,0,46,19,10,9,2,133,3]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var M;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(M=e.FileType||(e.FileType={}));var S;(function(z){z[z.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var f;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=p;function m(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=m;function i(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=i;function r(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function l(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=l;function v(z){return p(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var b;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(ne,de){super(ne),this.code=de}}e.FileSystemProviderError=E;function w(z,ne){const de=new E(z.toString(),ne);return o(de,ne),de}e.createFileSystemProviderError=w;function s(z){return z||w((0,R.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function o(z,ne){return z.name=ne?`${ne} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=o;function a(z){if(!z)return b.Unknown;if(z instanceof E)return z.code;const ne=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!ne)return b.Unknown;switch(ne[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=a;function d(z){if(z instanceof A)return z.fileOperationResult;switch(a(z)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=d;var c;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class u{constructor(ne,de,we){this.resource=ne,this.operation=de,this.target=we}isOperation(ne){return this.operation===ne}}e.FileOperationEvent=u;var n;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class h{constructor(ne,de){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const we=new Map;for(const ue of ne){const ae=we.get(ue.type);switch(ae?ae.push([ue.resource,ue]):we.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,ae]of we)switch(ue){case 1:this.a=t.TernarySearchTree.forUris(()=>de),this.a.fill(ae);break;case 0:this.b=t.TernarySearchTree.forUris(()=>de),this.b.fill(ae);break;case 2:this.c=t.TernarySearchTree.forUris(()=>de),this.c.fill(ae);break}}contains(ne,...de){return this.d(ne,{includeChildren:!1},...de)}affects(ne,...de){return this.d(ne,{includeChildren:!0},...de)}d(ne,de,...we){if(!ne)return!1;const ue=we.length>0;return!!((!ue||we.includes(1))&&(this.a?.get(ne)||de.includeChildren&&this.a?.findSuperstr(ne))||(!ue||we.includes(0))&&(this.b?.get(ne)||de.includeChildren&&this.b?.findSuperstr(ne))||(!ue||we.includes(2))&&(this.c?.findSubstr(ne)||de.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=h;function g(z,ne,de){return!z||!ne||z===ne||ne.length>z.length?!1:(ne.charAt(ne.length-1)!==T.sep&&(ne+=T.sep),de?(0,y.startsWithIgnoreCase)(z,ne):z.indexOf(ne)===0)}e.isParent=g;class A extends Error{constructor(ne,de,we){super(ne),this.fileOperationResult=de,this.options=we}}e.FileOperationError=A;class L extends A{constructor(ne,de,we,ue){super(ne,de,ue),this.fileOperationResult=de,this.size=we}}e.TooLargeFileOperationError=L;class q extends A{constructor(ne,de,we){super(ne,2,we),this.stat=de}}e.NotModifiedSinceFileOperationError=q;var Z;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Z=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=O;async function F(z,ne){if(!ne.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(de=>{const we=ne.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===z.scheme&&ue.added&&(we.dispose(),de())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class P{static formatSize(ne){return(0,N.isNumber)(ne)||(ne=0),ne<P.KB?(0,R.localize)(1,null,ne.toFixed(0)):ne<P.MB?(0,R.localize)(2,null,(ne/P.KB).toFixed(2)):ne<P.GB?(0,R.localize)(3,null,(ne/P.MB).toFixed(2)):ne<P.TB?(0,R.localize)(4,null,(ne/P.GB).toFixed(2)):(0,R.localize)(5,null,(ne/P.TB).toFixed(2))}}e.ByteSize=P,P.KB=1024,P.MB=P.KB*P.KB,P.GB=P.MB*P.KB,P.TB=P.GB*P.KB;var B;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function V(z){return{maxFileSize:z===0?300*P.MB:16*P.GB,maxHeapSize:z===0?700*P.MB:2*700*P.MB}}e.getPlatformLimits=V}),define(Ce[64],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class t{constructor(...y){this.a=new Map;for(const[N,C]of y)this.set(N,C)}set(y,N){const C=this.a.get(y);return this.a.set(y,N),C}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.ServiceCollection=t}),define(Ce[155],ke([1,0,14,11,7,86,153,3,64,156]),function(ee,e,t,T,y,N,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const M=!1;class S extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class f{constructor(r=new D.ServiceCollection,l=!1,v,b=M){this.f=r,this.g=l,this.h=v,this.i=b,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=b?v?._globalGraph??new C.Graph(E=>E):void 0}createChild(r){return new f(r,this.g,this,this.i)}invokeFunction(r,...l){const v=m.traceInvocation(this.i,r);let b=!1;try{return r({get:w=>{if(b)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(w,v);if(!s)throw new Error(`[invokeFunction] unknown service '${w}'`);return s}},...l)}finally{b=!0,v.stop()}}createInstance(r,...l){let v,b;return r instanceof N.SyncDescriptor?(v=m.traceCreation(this.i,r.ctor),b=this.j(r.ctor,r.staticArguments.concat(l),v)):(v=m.traceCreation(this.i,r),b=this.j(r,l,v)),v.stop(),b}j(r,l=[],v){const b=R._util.getServiceDependencies(r).sort((s,o)=>s.index-o.index),E=[];for(const s of b){const o=this.m(s.id,v);o||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${s.id}.`,!1),E.push(o)}const w=b.length>0?b[0].index:l.length;if(l.length!==w){console.trace(`[createInstance] First service dependency of ${r.name} at position ${w+1} conflicts with ${l.length} static arguments`);const s=w-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,w)}return Reflect.construct(r,l.concat(E))}k(r,l){if(this.f.get(r)instanceof N.SyncDescriptor)this.f.set(r,l);else if(this.h)this.h.k(r,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const l=this.f.get(r);return!l&&this.h?this.h.l(r):l}m(r,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const v=this.l(r);return v instanceof N.SyncDescriptor?this.q(r,v,l.branch(r,!0)):(l.branch(r,!1),v)}q(r,l,v){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,l,v)}finally{this.o.delete(r)}}r(r,l,v){const b=new C.Graph(s=>s.id.toString());let E=0;const w=[{id:r,desc:l,_trace:v}];for(;w.length;){const s=w.pop();if(b.lookupOrInsertNode(s),E++>1e3)throw new S(b);for(const o of R._util.getServiceDependencies(s.desc.ctor)){const a=this.l(o.id);if(a||this.u(`[createInstance] ${r} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),a instanceof N.SyncDescriptor){const d={id:o.id,desc:a,_trace:s._trace.branch(o.id,!0)};b.insertEdge(s,d),w.push(d)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new S(b);break}for(const{data:o}of s){if(this.l(o.id)instanceof N.SyncDescriptor){const d=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,d)}b.removeNode(o)}}return this.l(r)}s(r,l,v=[],b,E){if(this.f.get(r)instanceof N.SyncDescriptor)return this.t(r,l,v,b,E);if(this.h)return this.h.s(r,l,v,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(r,l,v=[],b,E){if(b){const w=new f(void 0,this.g,this,this.i);w.c=String(r);const s=new Map,o=new t.IdleValue(()=>{const a=w.j(l,v,E);for(const[d,c]of s){const u=a[d];if(typeof u=="function")for(const n of c)u.apply(a,n)}return s.clear(),a});return new Proxy(Object.create(null),{get(a,d){if(!o.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let n=s.get(d);return n||(n=new k.LinkedList,s.set(d,n)),(g,A,L)=>{const q=n.push([g,A,L]);return(0,y.toDisposable)(q)}}if(d in a)return a[d];const c=o.value;let u=c[d];return typeof u!="function"||(u=u.bind(c),a[d]=u),u},set(a,d,c){return o.value[d]=c,!0},getPrototypeOf(a){return l.prototype}})}else return this.j(l,v,E)}u(r,l){if(l&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=f;var p;(function(i){i[i.None=0]="None",i[i.Creation=1]="Creation",i[i.Invocation=2]="Invocation",i[i.Branch=3]="Branch"})(p||(p={}));class m{static traceInvocation(r,l){return r?new m(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(r,l){return r?new m(1,l.name):m.c}constructor(r,l){this.type=r,this.name=l,this.g=Date.now(),this.h=[]}branch(r,l){const v=new m(3,r.toString());return this.h.push([r,l,v]),v}stop(){const r=Date.now()-this.g;m.f+=r;let l=!1;function v(E,w){const s=[],o=new Array(E+1).join("	");for(const[a,d,c]of w.h)if(d&&c){l=!0,s.push(`${o}CREATES -> ${a}`);const u=v(E+1,c);u&&s.push(u)}else s.push(`${o}uses -> ${a}`);return s.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(r>2||l)&&m.all.add(b.join(`
`))}}e.Trace=m,m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0}),define(Ce[12],ke([1,0,39,4,7,28,21,2,3]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function k(){return new Date().toISOString()}var M;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(M=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=M.Info;function S(u,n,h){switch(n){case M.Trace:u.trace(h);break;case M.Debug:u.debug(h);break;case M.Info:u.info(h);break;case M.Warning:u.warn(h);break;case M.Error:u.error(h);break;case M.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=S;function f(u){let n="";for(let h=0;h<u.length;h++){let g=u[h];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}n+=(h>0?" ":"")+g}return n}e.format=f;class p extends y.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==M.Off&&this.b<=n}}e.AbstractLogger=p;class m extends p{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...h){this.f(M.Trace)&&this.g(M.Trace,f([n,...h]))}debug(n,...h){this.f(M.Debug)&&this.g(M.Debug,f([n,...h]))}info(n,...h){this.f(M.Info)&&this.g(M.Info,f([n,...h]))}warn(n,...h){this.f(M.Warning)&&this.g(M.Warning,f([n,...h]))}error(n,...h){if(this.f(M.Error))if(n instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=n.stack,this.g(M.Error,f(g))}else this.g(M.Error,f([n,...h]))}flush(){}}e.AbstractMessageLogger=m;class i extends p{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!C.isWindows}trace(n,...h){this.f(M.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...h):console.log(`[main ${k()}]`,n,...h))}debug(n,...h){this.f(M.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...h):console.log(`[main ${k()}]`,n,...h))}info(n,...h){this.f(M.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...h):console.log(`[main ${k()}]`,n,...h))}warn(n,...h){this.f(M.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,n,...h):console.warn(`[main ${k()}]`,n,...h))}error(n,...h){this.f(M.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,n,...h):console.error(`[main ${k()}]`,n,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=i;class r extends p{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...h){this.f(M.Trace)&&console.log("%cTRACE","color: #888",n,...h)}debug(n,...h){this.f(M.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...h)}info(n,...h){this.f(M.Info)&&console.log("%c INFO","color: #33f",n,...h)}warn(n,...h){this.f(M.Warning)&&console.log("%c WARN","color: #993",n,...h)}error(n,...h){this.f(M.Error)&&console.log("%c  ERR","color: #f33",n,...h)}dispose(){}flush(){}}e.ConsoleLogger=r;class l extends p{constructor(n,h=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(h)}trace(n,...h){this.f(M.Trace)&&this.g.log(M.Trace,[this.h(n),...h])}debug(n,...h){this.f(M.Debug)&&this.g.log(M.Debug,[this.h(n),...h])}info(n,...h){this.f(M.Info)&&this.g.log(M.Info,[this.h(n),...h])}warn(n,...h){this.f(M.Warning)&&this.g.log(M.Warning,[this.h(n),...h])}error(n,...h){this.f(M.Error)&&this.g.log(M.Error,[this.h(n),...h])}h(n){return typeof n=="string"?n:(0,t.toErrorMessage)(n,this.f(M.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class v extends p{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const h of this.g)h.setLevel(n);super.setLevel(n)}trace(n,...h){for(const g of this.g)g.trace(n,...h)}debug(n,...h){for(const g of this.g)g.debug(n,...h)}info(n,...h){for(const g of this.g)g.info(n,...h)}warn(n,...h){for(const g of this.g)g.warn(n,...h)}error(n,...h){for(const g of this.g)g.error(n,...h)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=v;class b extends y.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...h){this.b.trace(n,...h)}debug(n,...h){this.b.debug(n,...h)}info(n,...h){this.b.info(n,...h)}warn(n,...h){this.b.warn(n,...h)}error(n,...h){this.b.error(n,...h)}flush(){this.b.flush()}}e.LogService=b;class E extends y.Disposable{constructor(n,h){super(),this.c=n,this.b=new N.ResourceMap,this.B(h(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,h,g){let A=this.b.get(n)?.logger;return A||(g=h?.always?M.Trace:g,A=this.f(n,g??this.c,h),this.b.set(n,{logger:A,logLevel:g})),A}setLevel(n,h){const g=R.URI.isUri(n)?n:void 0,A=g?h:n;if(g){const L=this.b.get(g);L&&L.logLevel!==A&&(L.logLevel=A,L.logger.setLevel(A))}else this.c=A,this.b.forEach(({logLevel:L,logger:q})=>{L===void 0&&q.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(n){}getLevel(){return M.Info}trace(n,...h){}debug(n,...h){}info(n,...h){}warn(n,...h){}error(n,...h){}critical(n,...h){}dispose(){}flush(){}}e.NullLogger=w;class s extends w{}e.NullLogService=s;class o extends E{constructor(){super(M.Info,T.Event.None)}f(n,h,g){return new w}}e.NullLoggerService=o;function a(u){if(u.verbose)return M.Trace;if(typeof u.logLevel=="string"){const n=c(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function d(u){switch(u){case M.Trace:return"trace";case M.Debug:return"debug";case M.Info:return"info";case M.Warning:return"warn";case M.Error:return"error";case M.Off:return"off"}}e.LogLevelToString=d;function c(u){switch(u){case"trace":return M.Trace;case"debug":return M.Debug;case"info":return M.Info;case"warn":return M.Warning;case"error":return M.Error;case"critical":return M.Error;case"off":return M.Off}}e.parseLogLevel=c}),define(Ce[88],ke([1,0,29,134,3]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(N=e.MarkerTag||(e.MarkerTag={}));var C;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(m,i){return i-m}D.compare=k;const M=Object.create(null);M[D.Error]=(0,T.localize)(0,null),M[D.Warning]=(0,T.localize)(1,null),M[D.Info]=(0,T.localize)(2,null);function S(m){return M[m]||""}D.toString=S;function f(m){switch(m){case t.default.Error:return D.Error;case t.default.Warning:return D.Warning;case t.default.Info:return D.Info;case t.default.Ignore:return D.Hint}}D.fromSeverity=f;function p(m){switch(m){case D.Error:return t.default.Error;case D.Warning:return t.default.Warning;case D.Info:return t.default.Info;case D.Hint:return t.default.Ignore}}D.toSeverity=p}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(D){const k="";function M(f){return S(f,!0)}D.makeKey=M;function S(f,p){const m=[k];return f.source?m.push(f.source.replace("\xA6","\\\xA6")):m.push(k),f.code?typeof f.code=="string"?m.push(f.code.replace("\xA6","\\\xA6")):m.push(f.code.value.replace("\xA6","\\\xA6")):m.push(k),f.severity!==void 0&&f.severity!==null?m.push(C.toString(f.severity)):m.push(k),f.message&&p?m.push(f.message.replace("\xA6","\\\xA6")):m.push(k),f.startLineNumber!==void 0&&f.startLineNumber!==null?m.push(f.startLineNumber.toString()):m.push(k),f.startColumn!==void 0&&f.startColumn!==null?m.push(f.startColumn.toString()):m.push(k),f.endLineNumber!==void 0&&f.endLineNumber!==null?m.push(f.endLineNumber.toString()):m.push(k),f.endColumn!==void 0&&f.endColumn!==null?m.push(f.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}D.makeKeyOptionalMessage=S})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ce[157],ke([1,0,4,29,3]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,y.createDecorator)("notificationService");var N;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(N=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new D,this.onDidClose=t.Event.None,this.onDidChangeVisibility=t.Event.None}updateSeverity(M){}updateMessage(M){}updateActions(M){}close(){}}e.NoOpNotification=R;class D{infinite(){}done(){}total(M){}worked(M){}}e.NoOpProgress=D}),define(Ce[89],ke([1,0,10,2,3]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function N(k,M){return T.URI.isUri(k)?(0,t.equalsIgnoreCase)(k.scheme,M):(0,t.startsWithIgnoreCase)(k,M+":")}e.matchesScheme=N;function C(k,...M){return M.some(S=>N(k,S))}e.matchesSomeScheme=C;function R(k,M){return k.with({fragment:`${M.startLineNumber},${M.startColumn}${M.endLineNumber?`-${M.endLineNumber}${M.endColumn?`,${M.endColumn}`:""}`:""}`})}e.withSelection=R;function D(k){let M;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return S&&(M={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},k=k.with({fragment:""})),{selection:M,uri:k}}e.extractSelection=D}),define(Ce[158],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,t.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ee,e,t,T){var y=arguments.length,N=y<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,t):T,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ee,e,t,T);else for(var R=ee.length-1;R>=0;R--)(C=ee[R])&&(N=(y<3?C(N):y>3?C(e,t,N):C(e,t))||N);return y>3&&N&&Object.defineProperty(e,t,N),N},je=this&&this.__param||function(ee,e){return function(t,T){e(t,T,ee)}};define(Ce[159],ke([1,0,14,20,7,3]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var C;(function(M){M[M.Explorer=1]="Explorer",M[M.Scm=3]="Scm",M[M.Extensions=5]="Extensions",M[M.Window=10]="Window",M[M.Notification=15]="Notification",M[M.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(S){this.b=S}report(S){this.a=S,this.b(this.a)}}e.Progress=R,R.None=Object.freeze({report(){}});let D=class extends y.Disposable{constructor(S,f){super(),this.a=new t.DeferredPromise,f.withProgress(S,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,y.toDisposable)(()=>this.a.complete()))}report(S){this.b?this.b.report(S):this.c=S}};D=qe([je(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends y.Disposable{constructor(S){super(),this.g=S,this.a=0,this.b=this.B(new y.DisposableStore)}start(S){this.stop();const f=++this.a,p=new T.CancellationTokenSource;return this.f=setTimeout(()=>{f===this.a&&(this.c=this.g.show(!0))},S),this.b.add((0,y.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,y.toDisposable)(()=>p.cancel())),this.b.add((0,y.toDisposable)(()=>this.c?this.c.done():void 0)),{id:f,token:p.token,stop:()=>this.h(f),isCurrent:()=>this.a===f}}stop(){this.h(this.a)}h(S){this.a===S&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Ce[30],ke([1,0,47,9]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.a=new Map}add(C,R){t.ok(T.isString(C)),t.ok(T.isObject(R)),t.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,R)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new y}),define(Ce[90],ke([1,0,4,30]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class N{constructor(){this.b=new t.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,k){this.a[y(D)]=k,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const C=new N;T.Registry.add(e.Extensions.JSONContribution,C)}),define(Ce[91],ke([1,0,16,4,9,130,41,90,30]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var M;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=D.Registry.as(R.Extensions.JSONContribution);class f{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const a=new Set;this.n(s,o,a),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(s){const o=new Set;this.o(s,o),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const a=new Set;this.o(o,a),this.n(s,!1,a),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const a=[];for(const{overrides:d,source:c}of s)for(const u in d)if(o.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const n=this.a.get(u),h=n?.valuesSources??new Map;if(c)for(const q of Object.keys(d[u]))h.set(q,c);const g={...n?.value||{},...d[u]};this.a.set(u,{source:c,value:g,valuesSources:h});const A=(0,C.getLanguageTagSettingPlainKey)(u),L={type:"object",default:g,description:N.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:y.isString(c)?void 0:c,defaultValueSource:c};a.push(...i(u)),this.d[u]=L,this.b.properties[u]=L}else{this.a.set(u,{value:d[u],source:c});const n=this.d[u];n&&(this.w(u,n),this.r(u,n))}this.m(a)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:a,source:d}of s)for(const c in a){const u=this.a.get(c),n=y.isString(d)?d:d?.id,h=y.isString(u?.source)?u?.source:u?.source?.id;if(n===h)if(o.add(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const g=this.d[c];g&&(this.w(c,g),this.r(c,g))}}this.u()}deltaConfiguration(s){let o=!1;const a=new Set;s.removedDefaults&&(this.l(s.removedDefaults,a),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,a),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,a),s.addedConfigurations&&this.n(s.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,a){s.forEach(d=>{this.p(d,o,d.extensionInfo,d.restrictedProperties,void 0,a),this.c.push(d),this.q(d)})}o(s,o){const a=d=>{if(d.properties)for(const c in d.properties){o.add(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.s(c,d.properties[c])}d.allOf?.forEach(c=>a(c))};for(const d of s){a(d);const c=this.c.indexOf(d);c!==-1&&this.c.splice(c,1)}}p(s,o=!0,a,d,c=3,u){c=y.isUndefinedOrNull(s.scope)?c:s.scope;const n=s.properties;if(n)for(const g in n){const A=n[g];if(o&&b(g,A)){delete n[g];continue}if(A.source=a,A.defaultDefaultValue=n[g].default,this.w(g,A),e.OVERRIDE_PROPERTY_REGEX.test(g)?A.scope=void 0:(A.scope=y.isUndefinedOrNull(A.scope)?c:A.scope,A.restricted=y.isUndefinedOrNull(A.restricted)?!!d?.includes(g):A.restricted),n[g].hasOwnProperty("included")&&!n[g].included){this.f[g]=n[g],delete n[g];continue}else this.d[g]=n[g],n[g].policy?.name&&this.e.set(n[g].policy.name,g);!n[g].deprecationMessage&&n[g].markdownDeprecationMessage&&(n[g].deprecationMessage=n[g].markdownDeprecationMessage),u.add(g)}const h=s.allOf;if(h)for(const g of h)this.p(g,o,a,d,c,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=a=>{const d=a.properties;if(d)for(const u in d)this.r(u,d[u]);a.allOf?.forEach(o)};o(s)}r(s,o){switch(e.allSettings.properties[s]=o,o.scope){case 1:e.applicationSettings.properties[s]=o;break;case 2:e.machineSettings.properties[s]=o;break;case 6:e.machineOverridableSettings.properties[s]=o;break;case 3:e.windowSettings.properties[s]=o;break;case 4:e.resourceSettings.properties[s]=o;break;case 5:e.resourceSettings.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.allSettings.properties[s],o.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,a={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,a),e.allSettings.properties[o]=a,e.applicationSettings.properties[o]=a,e.machineSettings.properties[o]=a,e.machineOverridableSettings.properties[o]=a,e.windowSettings.properties[o]=a,e.resourceSettings.properties[o]=a}}v(){const s={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}w(s,o){const a=this.a.get(s);let d=a?.value,c=a?.source;y.isUndefined(d)&&(d=o.defaultDefaultValue,c=void 0),y.isUndefined(d)&&(d=l(o.type)),o.default=d,o.defaultValueSource=c}}const p="\\[([^\\]]+)\\]",m=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function i(w){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let o=m.exec(w);for(;o?.length;){const a=o[1].trim();a&&s.push(a),o=m.exec(w)}}return(0,t.distinct)(s)}e.overrideIdentifiersFromKey=i;function r(w){return w.reduce((s,o)=>`${s}[${o}]`,"")}e.keyFromOverrideIdentifiers=r;function l(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const v=new f;D.Registry.add(e.Extensions.Configuration,v);function b(w,s){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?N.localize(7,null,w):v.getConfigurationProperties()[w]!==void 0?N.localize(8,null,w):s.policy?.name&&v.getPolicyConfigurations().get(s.policy?.name)!==void 0?N.localize(9,null,w,s.policy?.name,v.getPolicyConfigurations().get(s.policy?.name)):null:N.localize(6,null)}e.validateProperty=b;function E(){const w=[],s=v.getConfigurationProperties();for(const o of Object.keys(s))w.push([o,s[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=E}),define(Ce[160],ke([1,0,16,4,109,7,28,23,9,2,41,91,30]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(o={},a=[],d=[],c){this.c=o,this.d=a,this.f=d,this.raw=c,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const o=this.raw.map(a=>{if(a instanceof p)return a;const d=new m("");return d.parseRaw(a),d.configurationModel});this.g=o.reduce((a,d)=>d===a?d:a.merge(d),o[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(o){return o?(0,M.getConfigurationValue)(this.contents,o):this.contents}inspect(o,a){const d=this.rawConfiguration.getValue(o),c=a?this.rawConfiguration.getOverrideValue(o,a):void 0,u=a?this.rawConfiguration.override(a).getValue(o):d;return{value:d,override:c,merged:u}}getOverrideValue(o,a){const d=this.l(a);return d?o?(0,M.getConfigurationValue)(d,o):d:void 0}getKeysForOverrideIdentifier(o){const a=[];for(const d of this.overrides)d.identifiers.includes(o)&&a.push(...d.keys);return t.distinct(a)}getAllOverrideIdentifiers(){const o=[];for(const a of this.overrides)o.push(...a.identifiers);return t.distinct(o)}override(o){let a=this.b.get(o);return a||(a=this.h(o),this.b.set(o,a)),a}merge(...o){const a=R.deepClone(this.contents),d=R.deepClone(this.overrides),c=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const n of o)if(u.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(a,n.contents);for(const h of n.overrides){const[g]=d.filter(A=>t.equals(A.identifiers,h.identifiers));g?(this.j(g.contents,h.contents),g.keys.push(...h.keys),g.keys=t.distinct(g.keys)):d.push(R.deepClone(h))}for(const h of n.keys)c.indexOf(h)===-1&&c.push(h)}return new p(a,c,d,u.every(n=>n instanceof p)?void 0:u)}freeze(){return this.a=!0,this}h(o){const a=this.l(o);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const d={};for(const c of t.distinct([...Object.keys(this.contents),...Object.keys(a)])){let u=this.contents[c];const n=a[c];n&&(typeof u=="object"&&typeof n=="object"?(u=R.deepClone(u),this.j(u,n)):u=n),d[c]=u}return new p(d,this.keys,this.overrides)}j(o,a){for(const d of Object.keys(a)){if(d in o&&D.isObject(o[d])&&D.isObject(a[d])){this.j(o[d],a[d]);continue}o[d]=R.deepClone(a[d])}}k(o){return this.a&&!Object.isFrozen(o)?R.deepFreeze(o):o}l(o){let a=null,d=null;const c=u=>{u&&(d?this.j(d,u):d=R.deepClone(u))};for(const u of this.overrides)t.equals(u.identifiers,[o])?a=u.contents:u.identifiers.includes(o)&&c(u.contents);return c(a),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,a){this.m(o),(0,M.addToValueTree)(this.contents,o,a,d=>{throw new Error(d)})}removeValue(o){this.n(o)&&(0,M.removeFromValueTree)(this.contents,o)}m(o){let a=this.keys.length;for(let d=0;d<a;d++)o.indexOf(this.keys[d])===0&&(a=d);this.keys.splice(a,1,o)}n(o){const a=this.keys.indexOf(o);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=p;class m{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,a){if(!D.isUndefinedOrNull(o)){const d=this.g(o);this.parseRaw(d,a)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,a){this.a=o;const{contents:d,keys:c,overrides:u,restricted:n,hasExcludedProperties:h}=this.h(o,a);this.b=new p(d,c,u,h?[o]:void 0),this.c=n||[]}g(o){let a={},d=null,c=[];const u=[],n=[];function h(A){Array.isArray(c)?c.push(A):d!==null&&(c[d]=A)}const g={onObjectBegin:()=>{const A={};h(A),u.push(c),c=A,d=null},onObjectProperty:A=>{d=A},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const A=[];h(A),u.push(c),c=A,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:h,onError:(A,L,q)=>{n.push({error:A,offset:L,length:q})}};if(o)try{y.visit(o,g),a=c[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return a}h(o,a){const d=f.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),c=this.j(o,d,!0,a);o=c.raw;const u=(0,M.toValuesTree)(o,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),n=Object.keys(o),h=this.l(o,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:u,keys:n,overrides:h,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(o,a,d,c){let u=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:o,restricted:[],hasExcludedProperties:u};const n={},h=[];for(const g in o)if(S.OVERRIDE_PROPERTY_REGEX.test(g)&&d){const A=this.j(o[g],a,!1,c);n[g]=A.raw,u=u||A.hasExcludedProperties,h.push(...A.restricted)}else{const A=a[g],L=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&h.push(g),(L===void 0||c.scopes===void 0||c.scopes.includes(L))&&!(c.skipRestricted&&A?.restricted)?n[g]=o[g]:u=!0}return{raw:n,restricted:h,hasExcludedProperties:u}}l(o,a){const d=[];for(const c of Object.keys(o))if(S.OVERRIDE_PROPERTY_REGEX.test(c)){const u={};for(const n in o[c])u[n]=o[c][n];d.push({identifiers:(0,S.overrideIdentifiersFromKey)(c),keys:Object.keys(u),contents:(0,M.toValuesTree)(u,a)})}return d}}e.ConfigurationModelParser=m;class i extends N.Disposable{constructor(o,a,d,c){super(),this.f=o,this.g=a,this.h=c,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new m(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(d.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&d.isEqual(u.resource,o)))(()=>this.c.fire()))}async loadConfiguration(){try{const o=await this.h.readFile(this.f);return this.a.parse(o.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=i;class r{constructor(o,a,d,c,u,n,h,g,A,L,q,Z,x){this.a=o,this.b=a,this.value=d,this.overrideIdentifiers=c,this.c=u,this.d=n,this.f=h,this.g=g,this.h=A,this.j=L,this.k=q,this.l=Z,this.m=x}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(o,a,d,c,u=new p,n=new p,h=new C.ResourceMap,g=new p,A=new C.ResourceMap,L=!0){this.c=o,this.d=a,this.f=d,this.g=c,this.h=u,this.j=n,this.l=h,this.m=g,this.n=A,this.p=L,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(o,a,d){return this.s(o,a,d).getValue(o)}updateValue(o,a,d={}){let c;d.resource?(c=this.n.get(d.resource),c||(c=new p,this.n.set(d.resource,c))):c=this.m,a===void 0?c.removeValue(o):c.setValue(o,a),d.resource||(this.a=null)}inspect(o,a,d){const c=this.s(o,a,d),u=this.w(a.resource,d),n=a.resource?this.n.get(a.resource)||this.m:this.m,h=new Set;for(const g of c.overrides)for(const A of g.identifiers)c.getOverrideValue(o,A)!==void 0&&h.add(A);return new r(o,a,c.getValue(o),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),d?this.j.freeze():void 0,u?u.freeze():void 0,n.inspect(o,a.overrideIdentifier))}keys(o){const a=this.w(void 0,o);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.j=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,a){this.l.set(o,a),this.b.delete(o)}deleteFolderConfiguration(o){this.r.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,a){const d=[];if(!a){const{added:c,updated:u,removed:n}=E(this.c,o);a=[...c,...u,...n]}for(const c of a)for(const u of(0,S.overrideIdentifiersFromKey)(c)){const n=this.c.getKeysForOverrideIdentifier(u),h=o.getKeysForOverrideIdentifier(u),g=[...h.filter(A=>n.indexOf(A)===-1),...n.filter(A=>h.indexOf(A)===-1),...n.filter(A=>!R.equals(this.c.override(u).getValue(A),o.override(u).getValue(A)))];d.push([u,g])}return this.updateDefaultConfiguration(o),{keys:a,overrides:d}}compareAndUpdatePolicyConfiguration(o){const{added:a,updated:d,removed:c}=E(this.d,o),u=[...a,...d,...c];return u.length&&this.updatePolicyConfiguration(o),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:a,updated:d,removed:c,overrides:u}=E(this.applicationConfiguration,o),n=[...a,...d,...c];return n.length&&this.updateApplicationConfiguration(o),{keys:n,overrides:u}}compareAndUpdateLocalUserConfiguration(o){const{added:a,updated:d,removed:c,overrides:u}=E(this.localUserConfiguration,o),n=[...a,...d,...c];return n.length&&this.updateLocalUserConfiguration(o),{keys:n,overrides:u}}compareAndUpdateRemoteUserConfiguration(o){const{added:a,updated:d,removed:c,overrides:u}=E(this.remoteUserConfiguration,o),n=[...a,...d,...c];return n.length&&this.updateRemoteUserConfiguration(o),{keys:n,overrides:u}}compareAndUpdateWorkspaceConfiguration(o){const{added:a,updated:d,removed:c,overrides:u}=E(this.workspaceConfiguration,o),n=[...a,...d,...c];return n.length&&this.updateWorkspaceConfiguration(o),{keys:n,overrides:u}}compareAndUpdateFolderConfiguration(o,a){const d=this.r.get(o),{added:c,updated:u,removed:n,overrides:h}=E(d,a),g=[...c,...u,...n];return(g.length||!d)&&this.updateFolderConfiguration(o,a),{keys:g,overrides:h}}compareAndDeleteFolderConfiguration(o){const a=this.r.get(o);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:d,updated:c,removed:u,overrides:n}=E(a,void 0);return{keys:[...d,...c,...u],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(o,a,d){let c=this.t(a,d);return a.overrideIdentifier&&(c=c.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(c=c.merge(this.d)),c}t({resource:o},a){let d=this.u();if(a&&o){const c=a.getFolder(o);c&&(d=this.v(c.uri)||d);const u=this.n.get(o);u&&(d=d.merge(u))}return d}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(o){let a=this.b.get(o);if(!a){const d=this.u(),c=this.l.get(o);c?(a=d.merge(c),this.p&&(a=a.freeze()),this.b.set(o,a)):a=d}return a}w(o,a){if(a&&o){const d=a.getFolder(o);if(d)return this.l.get(d.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((o,a)=>{const{contents:d,overrides:c,keys:u}=this.l.get(a);return o.push([a,{contents:d,overrides:c,keys:u}]),o},[])}}allKeys(){const o=new Set;return this.c.freeze().keys.forEach(a=>o.add(a)),this.userConfiguration.freeze().keys.forEach(a=>o.add(a)),this.j.freeze().keys.forEach(a=>o.add(a)),this.l.forEach(a=>a.freeze().keys.forEach(d=>o.add(d))),[...o.values()]}x(){const o=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(a=>o.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>o.add(a)),this.j.freeze().getAllOverrideIdentifiers().forEach(a=>o.add(a)),this.l.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(d=>o.add(d))),[...o.values()]}y(o){const a=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(d=>a.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(d=>a.add(d)),this.j.getKeysForOverrideIdentifier(o).forEach(d=>a.add(d)),this.l.forEach(d=>d.getKeysForOverrideIdentifier(o).forEach(c=>a.add(c))),[...a.values()]}static parse(o){const a=this.z(o.defaults),d=this.z(o.policy),c=this.z(o.application),u=this.z(o.user),n=this.z(o.workspace),h=o.folders.reduce((g,A)=>(g.set(k.URI.revive(A[0]),this.z(A[1])),g),new C.ResourceMap);return new l(a,d,c,u,new p,n,h,new p,new C.ResourceMap,!1)}static z(o){return new p(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=l;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const o=new Set,a=new Map;for(const c of s)c.keys.forEach(u=>o.add(u)),c.overrides.forEach(([u,n])=>{const h=(0,C.getOrSet)(a,u,new Set);n.forEach(g=>h.add(g))});const d=[];return a.forEach((c,u)=>d.push([u,[...c.values()]])),{keys:[...o.values()],overrides:d}}e.mergeChanges=v;class b{constructor(o,a,d,c){this.change=o,this.f=a,this.g=d,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const u of o.keys)this.affectedKeys.add(u);for(const[,u]of o.overrides)for(const n of u)this.affectedKeys.add(n);this.d=this.a;for(const u of this.affectedKeys)this.d+=u+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=l.parse(this.f.data)),this.j}affectsConfiguration(o,a){const d=this.a+o,c=this.d.indexOf(d);if(c<0)return!1;const u=c+d.length;if(u>=this.d.length)return!1;const n=this.d.charCodeAt(u);if(n!==this.b&&n!==this.c)return!1;if(a){const h=this.previousConfiguration?this.previousConfiguration.getValue(o,a,this.f?.workspace):void 0,g=this.g.getValue(o,a,this.h);return!R.equals(h,g)}return!0}}e.ConfigurationChangeEvent=b;function E(s,o){const{added:a,removed:d,updated:c}=w(o?.rawConfiguration,s?.rawConfiguration),u=[],n=s?.getAllOverrideIdentifiers()||[],h=o?.getAllOverrideIdentifiers()||[];if(o){const g=h.filter(A=>!n.includes(A));for(const A of g)u.push([A,o.getKeysForOverrideIdentifier(A)])}if(s){const g=n.filter(A=>!h.includes(A));for(const A of g)u.push([A,s.getKeysForOverrideIdentifier(A)])}if(o&&s){for(const g of n)if(h.includes(g)){const A=w({contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)},{contents:o.getOverrideValue(void 0,g)||{},keys:o.getKeysForOverrideIdentifier(g)});u.push([g,[...A.added,...A.removed,...A.updated]])}}return{added:a,removed:d,updated:c,overrides:u}}function w(s,o){const a=s?o?s.keys.filter(u=>o.keys.indexOf(u)===-1):[...s.keys]:[],d=o?s?o.keys.filter(u=>s.keys.indexOf(u)===-1):[...o.keys]:[],c=[];if(s&&o){for(const u of o.keys)if(s.keys.indexOf(u)!==-1){const n=(0,M.getConfigurationValue)(o.contents,u),h=(0,M.getConfigurationValue)(s.contents,u);R.equals(n,h)||c.push(u)}}return{added:a,removed:d,updated:c}}}),define(Ce[92],ke([1,0,11,3]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class N extends t.ErrorNoTelemetry{static isNotAvailable(R){return R instanceof N&&R._code===y.NotAvailable}static isTemporarilyNotAvailable(R){return R instanceof N&&R._code===y.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof N&&R._code===y.NoResolverFound}static isHandled(R){return R instanceof N&&R.isHandled}constructor(R,D=y.Unknown,k){super(R),this._message=R,this._code=D,this._detail=k,this.isHandled=D===y.NotAvailable&&k===!0,Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N}),define(Ce[48],ke([1,0,13]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(k){return k.scheme===t.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=T;function y(k){if(!k)return;const M=k.indexOf("+");return M<0?k:k.substr(0,M)}e.getRemoteName=y;function N(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=N;function C(k){const{host:M,port:S}=D(k);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:M,port:S}}e.parseAuthorityWithPort=C;function R(k,M){let{host:S,port:f}=D(k);return typeof f>"u"&&(f=M),{host:S,port:f}}e.parseAuthorityWithOptionalPort=R;function D(k){const M=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const S=k.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const f=k.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:k,port:void 0}}}),define(Ce[25],ke([1,0,10,3,48]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=N;function C(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var D;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(i){this.value=i,this.c=i.toLowerCase()}static equals(i,r){if(typeof i>"u"||i===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof i=="string"||typeof r=="string"){const l=typeof i=="string"?i:i.value,v=typeof r=="string"?r:r.value;return t.equalsIgnoreCase(l,v)}return i.c===r.c}static toKey(i){return typeof i=="string"?i.toLowerCase():i.c}}e.ExtensionIdentifier=k;function M(m){return S(m)}e.isApplicationScopedExtension=M;function S(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function p(m,i){if(i){const r=`onResolveRemoteAuthority:${(0,y.getRemoteName)(i)}`;return m.activationEvents?.indexOf(r)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[161],ke([1,0,21,49,2,34]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(k){if(t.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function R(k,M,S,f,p,m,i,r,l,v){const b=Object.create(null);b["common.machineId"]=i,b.sessionID=(0,N.generateUuid)()+Date.now(),b.commitHash=p,b.version=m,b["common.platformVersion"]=(M||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,t.PlatformToString)(t.platform),b["common.nodePlatform"]=T.platform,b["common.nodeArch"]=f,b["common.product"]=v||"desktop",r&&(b["common.msftInternal"]=r);let E=0;const w=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),t.isLinuxSnap&&(b["common.snap"]="true");const s=C(S);s&&(b["common.platformDetail"]=s);try{const o=await k.readFile(y.URI.file(l));b["common.source"]=o.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=R;function D(k){const M=T.env.USERDNSDOMAIN;if(!M)return!1;const S=M.toLowerCase();return k.some(f=>S===f)}e.verifyMicrosoftInternalDomain=D}),define(Ce[162],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,t.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,t.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[50],ke([1,0,23,9,4,41,48,161,162]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class k{constructor(n){this.value=n}}e.TrustedTelemetryValue=k;class M{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,h){return Promise.resolve(void 0)}publicLog2(n,h){return this.publicLog(n,h)}publicLogError(n,h){return Promise.resolve(void 0)}publicLogError2(n,h){return this.publicLogError(n,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=M,e.NullTelemetryService=new M;class S{async publicLog(n,h,g){}async publicLogError(n,h,g){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(u,n){return y.Event.debounce(n.onDidChangeConfiguration,(g,A)=>{const L=g?new Set([...g.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:L}},1e3,!0)(g=>{g.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(g.source),configurationKeys:E(g.affectedKeys)})})}e.configurationTelemetry=f;function p(u,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!u.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=p;function m(u,n){return!(n.isBuilt||n.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=m;function i(u){const n=u.getValue(D.TELEMETRY_SETTING_ID),h=u.getValue(D.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function r(u){const n={},h={},g={};b(u,g);for(let A in g){A=A.length>150?A.substr(A.length-149):A;const L=g[A];typeof L=="number"?h[A]=L:typeof L=="boolean"?h[A]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${L.length}`),n[A]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(n[A]=L)}return{properties:n,measurements:h}}e.validateTelemetryData=r;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function v(u){if(!u)return"none";const n=(0,C.getRemoteName)(u);return l.has(n)?n:"other"}e.cleanRemoteAuthority=v;function b(u,n,h=0,g){if(!!u)for(const A of Object.getOwnPropertyNames(u)){const L=u[A],q=g?g+A:A;Array.isArray(L)?n[q]=(0,t.safeStringify)(L):L instanceof Date?n[q]=L.toISOString():(0,T.isObject)(L)?h<2?b(L,n,h+1,q+"."):n[q]=(0,t.safeStringify)(L):n[q]=L}}function E(u){if(!u)return[];const n=[];return w(n,"",u),n}function w(u,n,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(g=>w(u,n?`${n}.${g}`:g,h[g])):u.push(n)}function s(u,n){const h=u.msftInternalDomains||[],g=n.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(h)||g}e.isInternalTelemetry=s;function o(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=o;function a(u,n){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let h=u;const g=[];for(const Z of n)for(;;){const x=Z.exec(u);if(!x)break;g.push([x.index,Z.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let q=0;for(h="";;){const Z=L.exec(u);if(!Z)break;const x=g.some(([O,F])=>Z.index<F&&O<L.lastIndex);!A.test(Z[0])&&!x&&(h+=u.substring(q,Z.index)+"<REDACTED: user-file-path>",q=L.lastIndex)}return q<u.length&&(h+=u.substr(q)),h}function d(u){if(!u)return u;const n=u.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of h)if(g.regex.test(n))return`<REDACTED: ${g.label}>`;return u}function c(u,n){return(0,t.cloneAndChange)(u,h=>{if(h instanceof k)return h.value;if(typeof h=="string"){let g=h.replaceAll("%20"," ");g=a(g,n);for(const A of n)g=g.replace(A,"");return g=d(g),g}})}e.cleanData=c}),define(Ce[163],ke([1,0,10,87,25,21,2,11,49,50]),function(ee,e,t,T,y,N,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function M(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,t.compareIgnoreCase)(a.id,d.id)===0}e.areSameExtensions=M;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(d){const c=d.manifest?d.manifest.version:d.version,u=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new f(d.identifier,c,u)}static parse(d){const c=S.exec(d);return c&&c[1]&&c[2]?new f({id:c[1]},c[2],c[4]||void 0):null}constructor(d,c,u="undefined"){this.version=c,this.targetPlatform=u,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof f?M(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.ExtensionKey=f;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(a){const d=p.exec(a);return d&&d[1]?[r(d[1]),d[2]]:[r(a),void 0]}e.getIdAndVersion=m;function i(a,d){return`${a}.${d}`}e.getExtensionId=i;function r(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function l(a,d){return r(i(a,d))}e.getGalleryExtensionId=l;function v(a,d){const c=[],u=n=>{for(const h of c)if(h.some(g=>M(d(g),d(n))))return h;return null};for(const n of a){const h=u(n);h?h.push(n):c.push([n])}return c}e.groupByExtension=v;function b(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function E(a){return{id:new k.TrustedTelemetryValue(a.identifier.id),name:new k.TrustedTelemetryValue(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function w(a,d){const c=[],u=d.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const n=u.shift();if(n&&c.every(h=>!M(h.identifier,{id:n}))){const h=a.filter(g=>M(g.identifier,{id:n}));h.length===1&&(c.push(h[0]),u.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=w;async function s(a,d){if(!N.isLinux)return!1;let c;try{c=(await a.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await a.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){d.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(n))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function o(a,d){const c=await s(a,d),u=(0,T.getTargetPlatform)(c?"alpine":N.platform,D.arch);return d.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=o}),define(Ce[164],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class t{constructor(y){this.b=y,this.a=new Map}dispose(){for(const y of this.a.values())y.dispose()}startBuffering(y,N,C=5){const R=N(D=>{const k=typeof D=="string"?D:D.data;let M=this.a.get(y);if(M){M.data.push(k);return}const S=setTimeout(()=>this.flushBuffer(y),C);M={data:[k],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(y),R.dispose()}},this.a.set(y,M)});return R}stopBuffering(y){this.a.get(y)?.dispose()}flushBuffer(y){const N=this.a.get(y);N&&(this.a.delete(y),this.b(y,N.data.join("")))}}e.TerminalDataBufferer=t}),define(Ce[165],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var t;(function(N){N.DARK="dark",N.LIGHT="light",N.HIGH_CONTRAST_DARK="hcDark",N.HIGH_CONTRAST_LIGHT="hcLight"})(t=e.ColorScheme||(e.ColorScheme={}));function T(N){return N===t.HIGH_CONTRAST_DARK||N===t.HIGH_CONTRAST_LIGHT}e.isHighContrast=T;function y(N){return N===t.DARK||N===t.HIGH_CONTRAST_DARK}e.isDark=y}),define(Ce[65],ke([1,0,123,4,7,3,30,165]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,N.createDecorator)("themeService");var D;(function(r){function l(v){return v&&typeof v=="object"&&typeof v.id=="string"}r.isThemeColor=l})(D=e.ThemeColor||(e.ThemeColor={}));function k(r){return{id:r}}e.themeColorFromId=k;var M;(function(r){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||D.isThemeColor(d.color))}r.isThemeIcon=l;const v=new RegExp(`^\\$\\((${t.CSSIcon.iconNameExpression}(?:${t.CSSIcon.iconModifierExpression})?)\\)$`);function b(d){const c=v.exec(d);if(!c)return;const[,u]=c;return{id:u}}r.fromString=b;function E(d){return{id:d}}r.fromId=E;function w(d,c){let u=d.id;const n=u.lastIndexOf("~");return n!==-1&&(u=u.substring(0,n)),c&&(u=`${u}~${c}`),{id:u}}r.modify=w;function s(d){const c=d.id.lastIndexOf("~");if(c!==-1)return d.id.substring(c+1)}r.getModifier=s;function o(d,c){return d.id===c.id&&d.color?.id===c.color?.id}r.isEqual=o;function a(d,c){return{id:d.id,color:c?k(c):void 0}}r.asThemeIcon=a,r.asClassNameArray=t.CSSIcon.asClassNameArray,r.asClassName=t.CSSIcon.asClassName,r.asCSSSelector=t.CSSIcon.asCSSSelector})(M=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=t.Codicon.file,e.FolderThemeIcon=t.Codicon.folder;function S(r){switch(r){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.a=[],this.a=[],this.b=new T.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,y.toDisposable)(()=>{const v=this.a.indexOf(l);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new f;C.Registry.add(e.Extensions.ThemingContribution,p);function m(r){return p.onColorThemeChange(r)}e.registerThemingParticipant=m;class i extends y.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,v){let b=this.h.getColor(l);return b&&v&&(b=v(b,this.h)),b?b.toString():null}}e.Themable=i}),define(Ce[166],ke([1,0,4,41,3,12]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(i){i.Http="http",i.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(!!r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function M(i){return e.LOCALHOST_ADDRESSES.indexOf(i)>=0}e.isLocalhost=M,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(i){return e.ALL_INTERFACES_ADDRESSES.indexOf(i)>=0}e.isAllInterfaces=S;function f(i,r,l,v){if(l===1)return!1;if(l===2&&S(r)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(b?.length===4&&parseInt(b[1])>=18)return!1}return i<1024}e.isPortPrivileged=f;class p{constructor(r,l,v){this.remoteAddress=r,this.localAddress=l,this.b=v,this.a=new t.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let m=class{constructor(r,l){this.i=r,this.j=l,this.a=new t.Emitter,this.onTunnelOpened=this.a.event,this.b=new t.Emitter,this.onTunnelClosed=this.b.event,this.c=new t.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const r=this.j.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.e=r,r?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.f=r.elevation,this.g=r.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const r=[],l=Array.from(this.d.values());for(const v of l){const b=Array.from(v.values());for(const E of b){const w=await E.value;w&&r.push(w)}}return r}async dispose(){for(const r of this.d.values()){for(const{value:l}of r.values())await l.then(v=>v?.dispose());r.clear()}this.d.clear()}setEnvironmentTunnel(r,l,v,b,E){this.o(r,l,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:l,localAddress:v,privacy:b,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,l){(S(r)||M(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const v=this.q(r,l);if(v)return++v.refcount,v.value}openTunnel(r,l,v,b,E=!1,w,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${b}.`),!r)return;if(l||(l="localhost"),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.r(r,l,v,b,E,w,s);return o?o.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.m(a);return(a.tunnelRemoteHost!==l||a.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(d),d}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}m(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const l=this.d.get(r.tunnelRemoteHost);if(l){const v=l.get(r.tunnelRemotePort);v&&(v.refcount--,await this.n(r.tunnelRemoteHost,r.tunnelRemotePort,v))}}}}async n(r,l,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${l}.`);const b=v.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(r)&&this.d.get(r).delete(l),b}}async closeTunnel(r,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${l} `);const v=this.d.get(r);if(v&&v.has(l)){const b=v.get(l);b.refcount=0,await this.n(r,l,b)}}o(r,l,v){this.d.has(r)||this.d.set(r,new Map),this.d.get(r).set(l,{refcount:1,value:v})}async p(r,l){const v=this.d.get(r);v&&(await v.get(l)||v.delete(l),v.size===0&&this.d.delete(r))}q(r,l){const v=[r];M(r)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):S(r)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const b=v.map(E=>this.d.get(E));for(const E of b){const w=E?.get(l);if(w)return w}}canTunnel(r){return!!k(r)}s(r,l,v,b,E,w,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${b}.`);const o=v;this.h.add(o);const a=b===void 0?v:b,d={elevationRequired:E?this.isPortPrivileged(a):!1},c={remoteAddress:{host:l,port:v},localAddressPort:b,privacy:w,public:w?w!==R.Private:void 0,protocol:s},u=r.forwardPort(c,d);return u?(this.o(l,v,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),u}};m=qe([je(0,N.ILogService),je(1,T.IConfigurationService)],m),e.AbstractTunnelService=m}),define(Ce[167],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,t.createDecorator)("editSessionIdentityService");var T;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ce[168],ke([1,0,13]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(D){return D.scheme!==t.Schemas.file&&D.scheme!==t.Schemas.vscodeRemote}e.isVirtualResource=T;function y(D){if(D.folders.length)return D.folders.every(k=>T(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&T(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function N(D){return y(D)?.scheme}e.getVirtualWorkspaceScheme=N;function C(D){return y(D)?.authority}e.getVirtualWorkspaceAuthority=C;function R(D){return y(D)!==void 0}e.isVirtualWorkspace=R}),define(Ce[51],ke([1,0,135,19,46,22,2,3,13]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function k(a){const d=a;return typeof d?.id=="string"&&C.URI.isUri(d.uri)}e.isSingleFolderWorkspaceIdentifier=k;function M(a){return typeof a?.id=="string"&&!k(a)&&!f(a)}e.isEmptyWorkspaceIdentifier=M,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(a,d){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,T.basename)(a)}:d?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=a;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=S;function f(a){const d=a;return typeof d?.id=="string"&&C.URI.isUri(d.configPath)}e.isWorkspaceIdentifier=f;function p(a){const d=a;if(d?.uri)return{id:d.id,uri:C.URI.revive(d.uri)};const c=a;if(c?.configPath)return{id:c.id,configPath:C.URI.revive(c.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=p;var m;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function i(a){const d=a;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=i;function r(a){const d=a;return!!(d&&typeof d=="object"&&C.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=r;class l{constructor(d,c,u,n,h){this.h=d,this.j=u,this.k=n,this.l=h,this.c=y.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=y.TernarySearchTree.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class v{constructor(d,c){this.raw=c,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,N.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function b(a){return new v({uri:a,index:0,name:(0,N.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,t.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(a,d){return N.extUriBiasedIgnorePathCase.isEqualOrParent(a,d.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function w(a){let d;return C.URI.isUri(a)?d=a:d=a.configuration,d?.scheme===D.Schemas.tmp}e.isTemporaryWorkspace=w;function s(a,d){return!E(a,d)&&!w(a)}e.isSavedWorkspace=s;function o(a){return(typeof a=="string"?(0,T.extname)(a):(0,N.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(Ce[52],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class t{constructor(y){this.d=y,this.b=new Map,this.c=1}add(y){const N=this.c++;return this.b.set(N,y),this.e(),N}get(y,N){return this.b.has(y)?this.b.get(y)[N]:void 0}delete(y){this.b.delete(y),this.e()}e(){!t.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=t,t.a=!1}),define(Ce[37],ke([1,0,13,22,3]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this.a=new Set(Object.keys(t.Schemas)),this.b=new Map,this.extUri=new T.ExtUri(R=>{const D=this.b.get(R.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(R,D){D===null?this.b.delete(R.scheme):this.b.set(R.scheme,D)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[27],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,t.createDecorator)("IExtHostInitDataService")}),define(Ce[169],ke([1,0,14]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(C,R,D){this.h=new Map,this.a=C,this.b=R,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new t.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of k.values())M.complete()}catch(M){for(const S of k.values())S.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,R){let D=this.f[C];return typeof D>"u"&&(D=R),D}update(C,R){this.f[C]=R;const D=this.h.get(C);if(D!==void 0)return D.p;const k=new t.DeferredPromise;return this.h.set(C,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=T;class y extends T{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,R){super(C.identifier.value,!0,R),this.j=C}}e.ExtensionGlobalMemento=y}),define(Ce[170],ke([1,0,4,2]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this.c=C,this.a=new t.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new t.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,R,D,k){const S=this.c.getNotebookDocument(T.URI.revive(C)).acceptModelChanged(R.value,D,k);this.b.fire(S)}$acceptDirtyStateChanged(C,R){this.c.getNotebookDocument(T.URI.revive(C)).acceptDirty(R)}$acceptModelSaved(C){const R=this.c.getNotebookDocument(T.URI.revive(C));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ce[15],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,t.createDecorator)("IExtHostRpcService");class T{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[171],ke([1,0,25,4]),function(ee,e,t,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(R,D){y.set(this,void 0),this.b=new T.Emitter,this.onDidChange=this.b.event,this.a=t.ExtensionIdentifier.toKey(R.identifier),Je(this,y,D,"f"),Oe(this,y,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(R){return Oe(this,y,"f").get(this.a,R)}store(R,D){return Oe(this,y,"f").store(this.a,R,D)}delete(R){return Oe(this,y,"f").delete(this.a,R)}}e.ExtensionSecrets=N,y=new WeakMap}),define(Ce[66],ke([1,0,3,166,4,15]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(D){function k(S){return{remoteAddress:S.remoteAddress,localAddress:S.localAddress,public:!!S.public,privacy:S.privacy??(S.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:S.protocol}}D.fromApiTunnel=k;function M(S){return{remoteAddress:{host:S.tunnelRemoteHost,port:S.tunnelRemotePort},localAddress:S.localAddress,public:S.privacy!==T.TunnelPrivacyId.ConstantPrivate&&S.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:S.privacy,protocol:S.protocol}}D.fromServiceTunnel=M})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,t.createDecorator)("IExtHostTunnelService");let R=class{constructor(k){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,M){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,M){return{dispose:()=>{}}}async $providePortAttributes(k,M,S,f,p){return[]}async $forwardPort(k,M){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([je(0,N.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(Ce[53],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,t.createDecorator)("IURITransformerService");class T{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=T}),define(Ce[172],ke([1,0,24]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function y(R,D){if(D.serializeBuffersForPostMessage){const k=new T,M=(p,m)=>{if(m instanceof ArrayBuffer){const i=k.add(m);return{$$vscode_array_buffer_reference$$:!0,index:i}}else if(ArrayBuffer.isView(m)){const i=N(m);if(i){const r=k.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:r,view:{type:i,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},S=JSON.stringify(R,M),f=k.buffers.map(p=>{const m=new Uint8Array(p);return t.VSBuffer.wrap(m)});return{message:S,buffers:f}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=y;function N(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(R,D){const k=D.map(f=>{const p=new ArrayBuffer(f.byteLength);return new Uint8Array(p).set(f.buffer),p}),M=D.length?(f,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const m=p,{index:i}=m,r=k[i];if(m.view)switch(m.view.type){case 1:return new Int8Array(r,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return p}:void 0;return{message:JSON.parse(R,M),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(Ce[93],ke([1,0,143,9,2,7,3,30,36,13,39,120,29]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,t.localize)(0,null),providerDisplayName:(0,t.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var p;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(p=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function i(G){const j=G;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}e.isEditorPaneWithSelection=i;function r(G,j,re){for(const me of re.visibleEditorPanes)if(me.group.id===j&&G.matches(me.input))return me.getViewState()}e.findViewStateForEditor=r;function l(G){if(h(G))return!1;const j=G;return y.URI.isUri(j?.resource)}e.isResourceEditorInput=l;function v(G){if(h(G))return!1;const j=G;return j?.original!==void 0&&j.modified!==void 0}e.isResourceDiffEditorInput=v;function b(G){if(h(G)||v(G))return!1;const j=G;return j?.primary!==void 0&&j.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function E(G){if(h(G))return!1;const j=G;return j?j.resource===void 0||j.resource.scheme===k.Schemas.untitled||j.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;const w=/Untitled-\d+/;function s(G){return G.scheme===k.Schemas.untitled&&G.path.length>1&&!w.test(G.path)}e.isUntitledWithAssociatedResource=s;function o(G){if(h(G))return!1;const j=G;return y.URI.isUri(j?.base?.resource)&&y.URI.isUri(j?.input1?.resource)&&y.URI.isUri(j?.input2?.resource)&&y.URI.isUri(j?.result?.resource)}e.isResourceMergeEditorInput=o;var a;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var d;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.a=new Map}registerSource(j,re){let me=this.a.get(j);return me||(me={source:j,label:re},this.a.set(j,me)),me.source}getSourceLabel(j){return this.a.get(j)?.label??j}}e.SaveSourceRegistry=new c;var u;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends N.Disposable{}e.AbstractEditorInput=n;function h(G){return G instanceof n}e.isEditorInput=h;function g(G){const j=G;return y.URI.isUri(j?.preferredResource)}function A(G){const j=G;return h(j?.primary)&&h(j?.secondary)}e.isSideBySideEditorInput=A;function L(G){const j=G;return h(j?.modified)&&h(j?.original)}e.isDiffEditorInput=L;function q(G,j,re,me,Te){return Ie(me,[(0,S.toAction)({id:"workbench.action.openLargeFile",label:(0,t.localize)(2,null),run:()=>{const Be={...re,limits:{size:Number.MAX_VALUE}};G.openEditor(j,Be)}}),(0,S.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,t.localize)(3,null),run:()=>Te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.createTooLargeFileError=q;function Z(G){return h(G?.editor)}e.isEditorInputWithOptions=Z;function x(G){const j=G;return Z(G)&&j?.group!==void 0}e.isEditorInputWithOptionsAndGroup=x;function O(G){const j=G;return typeof j?.groupId=="number"&&h(j.editor)}e.isEditorIdentifier=O;var F;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(F=e.EditorCloseContext||(e.EditorCloseContext={}));var P;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(P=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class V{getOriginalUri(j,re){if(!j)return;if(o(j))return e.EditorResourceAccessor.getOriginalUri(j.result,re);if(re?.supportSideBySide){const{primary:Te,secondary:Be}=this.a(j);if(Te&&Be){if(re?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Te,{filterByScheme:re.filterByScheme}),secondary:this.getOriginalUri(Be,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===B.ANY)return this.getOriginalUri(Te,{filterByScheme:re.filterByScheme})??this.getOriginalUri(Be,{filterByScheme:re.filterByScheme});j=re.supportSideBySide===B.PRIMARY?Te:Be}}if(v(j)||b(j)||o(j))return;const me=g(j)?j.preferredResource:j.resource;return!me||!re||!re.filterByScheme?me:this.b(me,re.filterByScheme)}a(j){return A(j)||b(j)?{primary:j.primary,secondary:j.secondary}:L(j)||v(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,re){if(!j)return;if(o(j))return e.EditorResourceAccessor.getCanonicalUri(j.result,re);if(re?.supportSideBySide){const{primary:Te,secondary:Be}=this.a(j);if(Te&&Be){if(re?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Te,{filterByScheme:re.filterByScheme}),secondary:this.getCanonicalUri(Be,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===B.ANY)return this.getCanonicalUri(Te,{filterByScheme:re.filterByScheme})??this.getCanonicalUri(Be,{filterByScheme:re.filterByScheme});j=re.supportSideBySide===B.PRIMARY?Te:Be}}if(v(j)||b(j)||o(j))return;const me=j.resource;return!me||!re||!re.filterByScheme?me:this.b(me,re.filterByScheme)}b(j,re){if(Array.isArray(re)){if(re.some(me=>j.scheme===me))return j}else if(re===j.scheme)return j}}e.EditorResourceAccessor=new V;var z;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class ne{constructor(){this.c=new Map,this.d=new Map}start(j){const re=this.a=j.get(C.IInstantiationService);for(const[me,Te]of this.c)this.e(me,Te,re);this.c.clear()}e(j,re,me){const Te=me.createInstance(re);this.d.set(j,Te)}registerFileEditorFactory(j){if(this.b)throw new Error("Can only register one file editor factory.");this.b=j}getFileEditorFactory(){return(0,T.assertIsDefined)(this.b)}registerEditorSerializer(j,re){if(this.c.has(j)||this.d.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.a?this.e(j,re,this.a):this.c.set(j,re),(0,N.toDisposable)(()=>{this.c.delete(j),this.d.delete(j)})}getEditorSerializer(j){return this.d.get(typeof j=="string"?j:j.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new ne);async function de(G,j,re){return!G||!G.length?[]:await Promise.all(G.map(async me=>{const Te=y.URI.revive(me.fileUri);if(!Te){re.info("Cannot resolve the path because it is not valid.",me);return}if(!await j.canHandleResource(Te)){re.info("Cannot resolve the path because it cannot be handled",me);return}let Ge=me.exists,Pe=me.type;if(typeof Ge!="boolean"||typeof Pe!="number")try{Pe=(await j.stat(Te)).isDirectory?D.FileType.Directory:D.FileType.Unknown,Ge=!0}catch(Se){re.error(Se),Ge=!1}if(!Ge&&me.openOnlyIfExists){re.info("Cannot resolve the path because it does not exist",me);return}if(Pe===D.FileType.Directory){re.info("Cannot resolve the path because it is a directory",me);return}const De={...me.options,pinned:!0};return Ge?{resource:Te,options:De}:{resource:Te,options:De,forceUntitled:!0}}))}e.pathsToEditors=de;var we;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(we=e.EditorsOrder||(e.EditorsOrder={}));function ue(G){const j=G;if(!j)return!1;const re=j;if(re.modified)return ue(re.modified);const me=j;return!!(me.contributionsState&&me.viewState&&Array.isArray(me.cursorState))}e.isTextEditorViewState=ue;function ae(G){return(0,M.isErrorWithActions)(G)}e.isEditorOpenError=ae;function Ie(G,j,re){const me=(0,M.createErrorWithActions)(G,j);return me.forceMessage=re?.forceMessage,me.forceSeverity=re?.forceSeverity,me.allowDialog=re?.allowDialog,me}e.createEditorOpenError=Ie}),define(Ce[173],ke([1,0,4,14,144]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.f=new Map,this.k=[],this.m=new t.Emitter,this.n=new t.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,D,k,M){const S={command:R};if(D&&Object.keys(D).length>0&&(S.arguments=D),this.s("request",S),typeof M=="number"){const f=setTimeout(()=>{clearTimeout(f);const p=this.f.get(S.seq);if(p){this.f.delete(S.seq);const m={type:"response",seq:0,request_seq:S.seq,success:!1,command:R,message:(0,y.localize)(0,null,M,R)};p(m)}},M)}return k&&this.f.set(S.seq,k),S.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,D){return R.type!=="event"||D.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,T.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const D=R,k=this.f.get(D.request_seq);k&&(this.f.delete(D.request_seq),k(D));break}}}}s(R,D){D.type=R,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((D,k)=>R.set(k,D)),await(0,T.timeout)(500),R.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=N}),define(Ce[174],ke([1,0,145,42,3]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:t.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:t.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:t.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:t.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:t.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:t.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:t.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:t.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:t.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:t.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:t.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:t.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:t.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:t.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:t.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:t.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:t.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:t.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:t.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:t.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:t.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:t.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:t.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:t.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:t.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:t.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:t.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:t.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:t.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:t.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:t.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:t.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:t.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:t.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:t.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:t.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:t.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:t.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:t.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:t.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:t.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:t.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:t.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:t.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:t.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:t.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:t.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:t.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:t.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:t.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:t.localize(50,null)});const N=f=>t.localize(51,null,f);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:t.localize(52,null)};var C;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(C=e.State||(e.State={}));function R(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var D;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(D=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var M;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(M=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var S;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(S=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[175],ke([1,0,10,2,19,23,13]),function(ee,e,t,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function D(a,d,c){return a.replace(R,function(u,n){return d&&n.length>0&&n[0]!=="_"?u:c&&c.hasOwnProperty(n)?c[n]:u})}e.formatPII=D;function k(a){const d={};for(const c of Object.keys(a))c.startsWith("!")||(d[c]=a[c]);return d}e.filterExceptionsFromTelemetry=k;function M(a){return a.configuration.request==="attach"&&!S(a)&&(!a.parentSession||M(a.parentSession))}e.isSessionAttach=M;function S(a){let d=a.configuration.type;if(!!d)return d==="vslsShare"&&(d=a.configuration.adapterProxy.configuration.type),(0,t.equalsIgnoreCase)(d,"extensionhost")||(0,t.equalsIgnoreCase)(d,"pwa-extensionhost")?a:a.parentSession?S(a.parentSession):void 0}e.getExtensionHostDebugSession=S;function f(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=f;function p(a,d,c){let u,n=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=h.exec(a);){const A=g.index+1,L=A+g[0].length;if(A<=d&&L>=c){u=g[0],n=A;break}}if(u){const A=/\w+/g;let L=null;for(;(L=A.exec(u))&&!(L.index+1+n+L[0].length>=c););L&&(u=u.substring(0,A.lastIndex))}return u?{start:n,end:n+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(a){return!!(a&&a.match(m))}e.isUri=i;function r(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(i(a.path))return T.URI.parse(a.path);if((0,y.isAbsolute)(a.path))return T.URI.file(a.path)}return a.path}function l(a){if(typeof a.path=="object"){const d=T.URI.revive(a.path);if(d)return d.scheme===C.Schemas.file?d.fsPath:d.toString()}return a.path}function v(a,d){const c=d?r:l,u=(0,N.deepClone)(a);return E(u,(n,h)=>{n&&h&&(h.path=c(h))}),u}e.convertToDAPaths=v;function b(a,d){const c=d?r:l,u=(0,N.deepClone)(a);return E(u,(n,h)=>{!n&&h&&(h.path=c(h))}),u}e.convertToVSCPaths=b;function E(a,d){switch(a.type){case"event":{const c=a;switch(c.event){case"output":d(!1,c.body.source);break;case"loadedSource":d(!1,c.body.source);break;case"breakpoint":d(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=a;switch(c.command){case"setBreakpoints":d(!0,c.arguments.source);break;case"breakpointLocations":d(!0,c.arguments.source);break;case"source":d(!0,c.arguments.source);break;case"gotoTargets":d(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(u=>d(!1,u));break;default:break}break}case"response":{const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(u=>d(!1,u.source));break;case"loadedSources":c.body.sources.forEach(u=>d(!1,u));break;case"scopes":c.body.scopes.forEach(u=>d(!1,u.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"setBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"disassemble":c.body?.instructions.forEach(n=>d(!1,n.location));break;default:break}break}}}function w(a){return a.filter(d=>!d.presentation?.hidden).sort((d,c)=>d.presentation?c.presentation?d.presentation.group?c.presentation.group?d.presentation.group!==c.presentation.group?d.presentation.group.localeCompare(c.presentation.group):s(d.presentation.order,c.presentation.order):-1:c.presentation.group?1:s(d.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=w;function s(a,d){return typeof a!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:a-d}async function o(a,d){const c=a.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(c!=="none"&&(await d.saveAll(),c==="allEditorsInActiveGroup")){const u=d.activeEditorPane;u&&u.input.resource?.scheme===C.Schemas.untitled&&await d.save({editor:u.input,groupId:u.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=o}),define(Ce[67],ke([1,0,24,35,176,62,13,19,21,42]),function(ee,e,t,T,y,N,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var M;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(M=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json",N.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={}));var f;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var i;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(i=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var r;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(r=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var v;(function(B){B.scheme=C.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${V.join("")}]+`),ne=7;function de(j,re){const me=re.toString(ne),Be=`${me.length<V.length?V[me.length-1]:"z"}${me}s${(0,t.encodeBase64)(t.VSBuffer.fromString(j.scheme),!0,!0)}`;return j.with({scheme:B.scheme,fragment:Be})}B.generate=de;function we(j){if(j.scheme!==B.scheme)return;const re=j.fragment.indexOf("s");if(re<0)return;const me=parseInt(j.fragment.substring(0,re).replace(z,""),ne),Te=(0,t.decodeBase64)(j.fragment.substring(re+1)).toString();if(!isNaN(me))return{handle:me,notebook:j.with({scheme:Te,fragment:null})}}B.parse=we;function ue(j,re){return j.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${j.scheme!==C.Schemas.file?j.scheme:""}`})}B.generateCellOutputUri=ue;function ae(j){if(j.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(j.fragment);if(!re)return;const me=re[1]&&re[1]!==""?re[1]:void 0,Te=re[2];return{outputId:me,notebook:j.with({scheme:Te||C.Schemas.file,fragment:null})}}B.parseCellOutputUri=ae;function Ie(j,re,me){return B.generate(j,re).with({scheme:me})}B.generateCellPropertyUri=Ie;function G(j,re){if(j.scheme===re)return B.parse(j.with({scheme:B.scheme}))}B.parseCellPropertyUri=G})(v=e.CellUri||(e.CellUri={}));const b=B=>D.isWindows?B.replace(/\//g,"\\"):B;class E{constructor(V=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.e=z,this.d=[...new Set(V)].map(ne=>({pattern:ne,matches:T.parse(b(ne))}))}sort(V){const z=new Map(y.Iterable.map(V,de=>[de,b(de)]));let ne=[];for(const{matches:de}of this.d)for(const[we,ue]of z)if(de(ue)){ne.push(we),z.delete(we);break}return z.size&&(ne=ne.concat([...z.keys()].sort((de,we)=>this.e.indexOf(de)-this.e.indexOf(we)))),ne}prioritize(V,z){const ne=this.f(V);if(ne===-1){this.d.unshift({pattern:V,matches:T.parse(b(V))});return}const de=new Set(z.map(ue=>this.f(ue,ne)));de.delete(-1);const we=Array.from(de).sort();this.d.splice(ne+1,0,...we.map(ue=>this.d[ue]));for(let ue=we.length-1;ue>=0;ue--)this.d.splice(we[ue],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,z=this.d.length){const ne=b(V);for(let de=0;de<z;de++)if(this.d[de].matches(ne))return de;return-1}}e.MimeTypeDisplayOrder=E;function w(B,V,z,ne=(de,we)=>de===we){const de=[];function we(Ie,G,j){if(G===0&&j.length===0)return;const re=de[de.length-1];re&&re.start+re.deleteCount===Ie?(re.deleteCount+=G,re.toInsert.push(...j)):de.push({start:Ie,deleteCount:G,toInsert:j})}let ue=0,ae=0;for(;;){if(ue===B.length){we(ue,0,V.slice(ae));break}if(ae===V.length){we(ue,B.length-ue,[]);break}const Ie=B[ue],G=V[ae];if(ne(Ie,G)){ue+=1,ae+=1;continue}z(G)?(we(ue,1,[]),ue+=1):(we(ue,0,[G]),ae+=1)}return de}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(B){B.default="default",B.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(B){const V=B;return!!((typeof V.include=="string"||T.isRelativePattern(V.include))&&(typeof V.exclude=="string"||T.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=o;function a(B,V,z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(V)>=0||B.viewType===V)return!0;if(B.filenamePattern){const ne=o(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,de=o(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(T.match(ne,(0,R.basename)(z.fsPath).toLowerCase()))return!(de&&T.match(de,(0,R.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var d;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(V){return`${c.d}${V}`}static parse(V){if(V.startsWith(c.d))return V.substring(c.d.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c.d="notebook/";function u(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=u;const n=new TextDecoder;function h(B){const V=[];let z=!1;for(const ne of B)(V.length===0||z)&&(V.push(ne),z=!0);return q(V),P(t.VSBuffer.concat(V.map(ne=>t.VSBuffer.wrap(ne))))}e.compressOutputItemStreams=h;const g=`${String.fromCharCode(27)}[A`,A=g.split("").map(B=>B.charCodeAt(0)),L=10;function q(B){B.forEach((V,z)=>{if(z===0||V.length<g.length)return;const ne=B[z-1],de=V.subarray(0,g.length);if(de[0]===A[0]&&de[1]===A[1]&&de[2]===A[2]){const we=ne.lastIndexOf(L);if(we===-1)return;B[z-1]=ne.subarray(0,we),B[z]=V.subarray(g.length)}})}function Z(B){let V=B;do B=V,V=B.replace(/[^\n]\x08/gm,"");while(V.length<B.length);return B}function x(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const V=B.match(/^(.*)\r+/m)[1];let z=B.match(/\r+(.*)$/m)[1];z=z+V.slice(z.length,V.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return B}const O="\b".charCodeAt(0),F="\r".charCodeAt(0);function P(B){return!B.buffer.includes(O)&&!B.buffer.includes(F)?B:t.VSBuffer.fromString(x(Z(n.decode(B.buffer))))}}),define(Ce[177],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,t.createDecorator)("INotebookExecutionService")}),define(Ce[178],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function t(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=t;function T(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=T;function y(C){return Array.from(C.entries()).map(R=>[R[0],t(R[1].map)])}e.serializeEnvironmentVariableCollections=y;function N(C){return new Map(C.map(R=>[R[0],{map:T(R[1])}]))}e.deserializeEnvironmentVariableCollections=N}),define(Ce[43],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var t;(function(N){N.Delimiter="\0"})(t=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(C,R,D=C.parent){if(C._isRoot)return new y([R]);const k=[C.id];for(let M=D;M&&M.id!==R;M=M.parent)k.push(M.id);return k.push(R),new y(k.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const R=C.indexOf("\0");return R===-1?C:C.slice(0,R)}static fromString(C){return new y(C.split("\0"))}static join(C,R){return new y([...C.path,R])}static joinToString(C,R){return C.toString()+"\0"+R}static parentId(C){const R=C.lastIndexOf("\0");return R===-1?void 0:C.slice(0,R)}static localId(C){const R=C.lastIndexOf("\0");return R===-1?C:C.slice(R+1)}static compare(C,R){return C===R?0:R.startsWith(C+"\0")?2:C.startsWith(R+"\0")?3:1}constructor(C,R=C.length){if(this.path=C,this.d=R,C.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new y(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new y(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let R=0;R<C.d&&R<this.d;R++)if(C.path[R]!==this.path[R])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=y}),define(Ce[54],ke([1,0,2,55,43]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var N;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(N=e.TestResultState||(e.TestResultState={}));var C;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var R;(function(u){u.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),u.deserialize=n=>({range:T.Range.lift(n.range),uri:t.URI.revive(n.uri)})})(R=e.IRichLocation||(e.IRichLocation={}));var D;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(D=e.TestMessageType||(e.TestMessageType={}));var k;(function(u){u.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&R.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&R.deserialize(n.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const M=(u,n)=>`${n?"s":"e"}${u}`;e.getMarkId=M;var S;(function(u){u.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&R.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&R.deserialize(n.location)})})(S=e.ITestOutputMessage||(e.ITestOutputMessage={}));var f;(function(u){u.serialize=n=>n.type===0?k.serialize(n):S.serialize(n),u.deserialize=n=>n.type===0?k.deserialize(n):S.deserialize(n)})(f=e.ITestMessage||(e.ITestMessage={}));var p;(function(u){u.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),u.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(f.serialize)}),u.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(f.deserialize)})})(p=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",i=(u,n)=>u+m+n;e.namespaceTestTag=i;const r=u=>{const n=u.indexOf(m);return{ctrlId:u.slice(0,n),tagId:u.slice(n+1)}};e.denamespaceTestTag=r;var l;(function(u){u.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),u.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?t.URI.revive(n.uri):void 0,range:n.range?T.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(l=e.ITestItem||(e.ITestItem={}));var v;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var b;(function(u){u.serialize=n=>({expand:n.expand,item:l.serialize(n.item)}),u.deserialize=n=>({controllerId:y.TestId.root(n.item.extId),expand:n.expand,item:l.deserialize(n.item)})})(b=e.InternalTestItem||(e.InternalTestItem={}));var E;(function(u){u.serialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.uri!==void 0&&(h.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(h.range=n.item.range?.toJSON()),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}},u.deserialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.range!==void 0&&(h.range=n.item.range?T.Range.lift(n.item.range):null),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}}})(E=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(u,n)=>{n.expand!==void 0&&(u.expand=n.expand),n.item!==void 0&&(u.item=u.item?Object.assign(u.item,n.item):n.item)};e.applyTestItemUpdate=w;var s;(function(u){u.serializeWithoutMessages=n=>({...b.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(p.serializeWithoutMessages),retired:n.retired}),u.serialize=n=>({...b.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(p.serialize),retired:n.retired}),u.deserialize=n=>({...b.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(p.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var o;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(o=e.DetailType||(e.DetailType={}));var a;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(u){u.deserialize=n=>n.op===0?{op:n.op,item:b.deserialize(n.item)}:n.op===1?{op:n.op,item:E.deserialize(n.item)}:n.op===2?{op:n.op,uri:t.URI.revive(n.uri),docv:n.docv}:n,u.serialize=n=>n.op===0?{op:n.op,item:b.serialize(n.item)}:n.op===1?{op:n.op,item:E.serialize(n.item)}:n})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const h=this.o();for(const g of n)switch(g.op){case 0:this.j(b.deserialize(g.item),h);break;case 1:this.k(E.deserialize(g.item),h);break;case 3:this.l(g.itemId,h);break;case 5:this.m(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.c.set(g.tag.id,g.tag);break;case 7:this.c.delete(g.id);break}h.complete?.()}j(n,h){const g=y.TestId.parentId(n.item.extId)?.toString();let A;if(!g)A=this.p(n),this.f.add(A),this.d.set(n.item.extId,A);else if(this.d.has(g)){const L=this.d.get(g);L.children.add(n.item.extId),A=this.p(n,L),this.d.set(n.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return h.add?.(A),n.expand===2&&this.g++,A}k(n,h){const g=this.d.get(n.extId);if(!!g)return n.expand!==void 0&&(g.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(g,n),h.update?.(g),g}l(n,h){const g=this.d.get(n);if(!g)return;const A=y.TestId.parentId(g.item.extId)?.toString();A?this.d.get(A).children.delete(g.item.extId):this.f.delete(g);const L=[[n]];for(;L.length;)for(const q of L.pop()){const Z=this.d.get(q);Z&&(L.push(Z.children),this.d.delete(q),h.remove?.(Z,Z!==g),Z.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(Ce[68],ke([1,0,14,4,7,47,54,43]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var D;(function(v){v[v.Upsert=0]="Upsert",v[v.SetTags=1]="SetTags",v[v.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",v[v.RemoveChild=3]="RemoveChild",v[v.SetProp=4]="SetProp",v[v.Bulk=5]="Bulk",v[v.DocumentSynced=6]="DocumentSynced"})(D=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(v,b)=>v===b,S=Object.entries({range:(v,b)=>v===b?!0:!v||!b?!1:v.equalsRange(b),busy:k,label:k,description:k,error:k,sortText:k,tags:(v,b)=>!(v.length!==b.length||v.some(E=>!b.includes(E)))}),f=(v,b)=>{let E;for(const[w,s]of S)s(v[w],b[w])||(E?E[w]=b[w]:E={[w]:b[w]});return E};class p extends y.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new t.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new T.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const E of this.tree.values())this.G(E)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const E of this.k)if(E.op===2&&E.uri===b.uri){E.docv=b.docv;return}break}case 1:{const E=this.k[this.k.length-1];if(E){if(E.op===1&&E.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(E.item,b.item);return}if(E.op===0&&E.item.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(E.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,E){const w=this.tree.get(b);if(!!w){if((w.expandLevels===void 0||E>w.expandLevels)&&(w.expandLevels=E),w.expand===1){const s=this.I(w);return s.isOpen()?this.H(w,E-1):s.wait().then(()=>this.H(w,E-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,E-1)):this.H(w,E-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,E){switch(E.op){case 3:this.L(R.TestId.joinToString(b.fullId,E.id));break;case 0:this.u(E.item,b);break;case 5:for(const w of E.ops)this.p(b,w);break;case 1:this.w(E.new,E.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:E.update}});break;case 6:this.s(b.actual.uri);break;default:(0,N.assertNever)(E)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,E){const w=R.TestId.fromExtHostTestItem(b,this.root.id,E?.actual),s=this.m.getApiFor(b);s.parent&&s.parent!==E?.actual&&this.m.getChildren(s.parent).delete(b.id);let o=this.tree.get(w.toString());if(!o){o={fullId:w,actual:b,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(b,E),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(b)}}),this.F(b,o,E);return}if(o.actual===b){this.D(b,o,E);return}if(o.actual.uri?.toString()!==b.uri?.toString())return this.L(w.toString()),this.u(b,E);const a=this.m.getChildren(o.actual),d=o.actual,c=f(this.m.toITestItem(d),this.m.toITestItem(b));this.m.getApiFor(d).listener=void 0,o.actual=b,o.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(b.tags,d.tags,w.toString()),delete c.tags),this.p(o,{op:4,update:c})),this.F(b,o,E);for(const[u,n]of a)this.m.getChildren(b).get(n.id)||this.L(R.TestId.joinToString(w,n.id));this.s(o.actual.uri)}w(b,E,w){const s=new Set(E.map(o=>o.id));for(const o of b)s.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:w,item:{tags:b.map(o=>(0,C.namespaceTestTag)(this.m.controllerId,o.id))}}}),s.forEach(this.z,this)}y(b){const E=this.j.get(b.id);E?E.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const E=this.j.get(b);E&&!--E.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,b)}))}C(b,E){this.m.getApiFor(b).parent=E&&E.actual!==this.root?E.actual:void 0}D(b,E,w){this.C(b,w);const s=this.m.getApiFor(b);s.parent=w?.actual,s.listener=o=>this.p(E,o),this.G(E)}F(b,E,w){this.D(b,E,w);for(const[s,o]of this.m.getChildren(b))this.u(o,E)}G(b){let E;this.h?b.resolveBarrier?E=b.resolveBarrier.isOpen()?3:2:E=b.actual.canResolveChildren?1:0:E=0,E!==b.expand&&(b.expand=E,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:E}}),E===1&&b.expandLevels!==void 0&&this.I(b))}H(b,E){if(E<0)return;const w=[];for(const[s,o]of this.m.getChildren(b.actual)){const a=this.expand(R.TestId.joinToString(b.fullId,o.id),E);(0,t.isThenable)(a)&&w.push(a)}if(w.length)return Promise.all(w).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const o=new t.Barrier;return o.open(),o}b.expand=2,this.J(b);const E=b.resolveBarrier=new t.Barrier,w=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let s;try{s=this.h(b.actual===this.root?void 0:b.actual)}catch(o){w(o)}return(0,t.isThenable)(s)?s.catch(w).then(()=>{E.open(),this.G(b)}):(E.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const E=this.tree.get(b);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const w=[E];for(;w.length;){const s=w.pop();if(!!s){this.m.getApiFor(s.actual).listener=void 0;for(const o of s.actual.tags)this.z(o.id);this.tree.delete(s.fullId.toString());for(const[o,a]of this.m.getChildren(s.actual))w.push(this.tree.get(R.TestId.joinToString(s.fullId,a.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=p;class m extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=m;class i extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=i;class r extends Error{constructor(b,E,w){super(`TestItem with ID "${b}" is from controller "${E}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=r;const l=(v,b,E)=>{let w=new Map;return{get size(){return w.size},forEach(s,o){for(const a of w.values())s.call(o,a,this)},[Symbol.iterator](){return w.entries()},replace(s){const o=new Map,a=new Set(w.keys()),d={op:5,ops:[]};for(const c of s){if(!(c instanceof E))throw new i(c.id);const u=b(c).controllerId;if(u!==v.controllerId)throw new r(c.id,u,v.controllerId);if(o.has(c.id))throw new m(c.id);o.set(c.id,c),a.delete(c.id),d.ops.push({op:0,item:c})}for(const c of a.keys())d.ops.push({op:3,id:c});v.listener?.(d),w=o},add(s){if(!(s instanceof E))throw new i(s.id);w.set(s.id,s),v.listener?.({op:0,item:s})},delete(s){w.delete(s)&&v.listener?.({op:3,id:s})},get(s){return w.get(s)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=l}),define(Ce[94],ke([1,0,68]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,y=(C,R)=>{const D={controllerId:R};return T.set(C,D),D};e.createPrivateApiFor=y;const N=C=>{const R=T.get(C);if(!R)throw new t.InvalidTestItemError(C?.id||"<unknown>");return R};e.getPrivateApiFor=N}),define(Ce[69],ke([1,0,13,2]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(R,D){return R.scheme===t.Schemas.http||R.scheme===t.Schemas.https?R:(D&&D.authority&&D.isRemote&&R.scheme===t.Schemas.file&&(R=T.URI.from({scheme:t.Schemas.vscodeRemote,authority:D.authority,path:R.path})),T.URI.from({scheme:t.Schemas.https,authority:`${R.scheme}+${N(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=y;function N(R){return R.replace(/./g,D=>{const k=D.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?D:"-"+k.toString(16).padStart(4,"0")})}function C(R){return R.replace(/-([0-9a-f]{4})/g,(D,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=C}),define(Ce[179],ke([1,0,4,7,69]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(R,D,k){this.d=R,this.e=D,this.f=k,this.a=0,this.b=new T.DisposableStore,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const M=D.getVisibleTextEditors();for(const S of this.c.values())M.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,D,k,M,S){let f;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===R){f=b;break}if(!f)throw new Error("not a visible editor");const p=this,m=this.a++,i=new t.Emitter,r=new t.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,y.asWebviewUri)(b,p.f)}get cspSource(){return y.webviewGenericCspSource}set options(b){this.b=b,p.d.$setOptions(m,b)}get options(){return this.b}set html(b){this.a=b,p.d.$setHtml(m,b)}get html(){return this.a}get onDidReceiveMessage(){return i.event}postMessage(b){return p.d.$postMessage(m,b)}},v=new class{constructor(){this.editor=R,this.line=D,this.height=k,this.webview=l,this.onDidDispose=r.event}dispose(){p.c.has(m)&&(p.c.delete(m),p.d.$disposeEditorInset(m),r.fire(),r.dispose(),i.dispose())}};return this.d.$createEditorInset(m,f.id,f.value.document.uri,D+1,k,M||{},S.identifier,S.extensionLocation),this.c.set(m,{editor:R,inset:v,onDidReceiveMessage:i}),v}$onDidDispose(R){const D=this.c.get(R);D&&D.inset.dispose()}$onDidReceiveMessage(R,D){this.c.get(R)?.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=N}),define(Ce[180],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,t.createDecorator)("configurationResolverService");var T;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(C,R){super(R),this.variable=C}}e.VariableError=y}),define(Ce[181],ke([1,0,19,49,9,23,21,84,148,180,10]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class S{constructor(p,m,i,r){this.g=new Map,this.a=p,this.b=m,this.d=i,r&&(this.c=r.then(l=>this.h(l)))}h(p){if(C.isWindows){const m=Object.create(null);return Object.keys(p).forEach(i=>{m[i.toLowerCase()]=p[i]}),m}return p}resolveWithEnvironment(p,m,i){return this.j({env:this.h(p),userHome:void 0},m?m.uri:void 0,i)}async resolveAsync(p,m){const i={env:await this.c,userHome:await this.d};return this.j(i,p?p.uri:void 0,m)}async i(p,m,i,r){const l=N.deepClone(m);C.isWindows&&l.windows?Object.keys(l.windows).forEach(b=>l[b]=l.windows[b]):C.isMacintosh&&l.osx?Object.keys(l.osx).forEach(b=>l[b]=l.osx[b]):C.isLinux&&l.linux&&Object.keys(l.linux).forEach(b=>l[b]=l.linux[b]),delete l.windows,delete l.osx,delete l.linux;const v={env:await this.c,userHome:await this.d};return this.j(v,p?p.uri:void 0,l,i,r)}async resolveAnyAsync(p,m,i){return this.i(p,m,i)}async resolveAnyMap(p,m,i){const r=new Map;return{newConfig:await this.i(p,m,i,r),resolvedVariables:r}}resolveWithInteractionReplace(p,m,i,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,m,i,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,m){if(this.g.has(p))throw new Error("Variable "+p+" is contributed twice.");this.g.set(p,m)}async j(p,m,i,r,l){if(y.isString(i))return this.l(p,m,i,r,l);if(Array.isArray(i))return Promise.all(i.map(v=>this.j(p,m,v,r,l)));if(y.isObject(i)){const v=Object.create(null),b=await Promise.all(Object.keys(i).map(async E=>[await this.l(p,m,E,r,l),await this.j(p,m,i[E],r,l)]));for(const[E,w]of b)v[E]=w;return v}return i}l(p,m,i,r,l){return(0,M.replaceAsync)(i,S.VARIABLE_REGEXP,async(v,b)=>{if(b.includes(S.VARIABLE_LHS))return v;let E=await this.n(p,v,b,m,r);return l?.set(b,E),E!==v&&y.isString(E)&&E.match(S.VARIABLE_REGEXP)&&(E=await this.l(p,m,E,r,l)),E})}m(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async n(p,m,i,r,l){let v;const b=i.split(":");b.length>1&&(i=b[0],v=b[1]);const E=o=>{const a=this.a.getFilePath();if(a)return(0,R.normalizeDriveLetter)(a);throw new k.VariableError(o,(0,D.localize)(0,null,m))},w=o=>{const a=E(o);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,R.normalizeDriveLetter)(d)}throw new k.VariableError(o,(0,D.localize)(1,null,m,t.basename(a)))},s=o=>{if(v){const a=this.a.getFolderUri(v);if(a)return a;throw new k.VariableError(o,(0,D.localize)(2,null,m,v))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(o,(0,D.localize)(3,null,m)):new k.VariableError(o,(0,D.localize)(4,null,m))};switch(i){case"env":if(v){if(p.env){const o=p.env[C.isWindows?v.toLowerCase():v];if(y.isString(o))return o}return""}throw new k.VariableError(k.VariableKind.Env,(0,D.localize)(5,null,m));case"config":if(v){const o=this.a.getConfigurationValue(r,v);if(y.isUndefinedOrNull(o))throw new k.VariableError(k.VariableKind.Config,(0,D.localize)(6,null,m,v));if(y.isObject(o))throw new k.VariableError(k.VariableKind.Config,(0,D.localize)(7,null,m,v));return o}throw new k.VariableError(k.VariableKind.Config,(0,D.localize)(8,null,m));case"command":return this.o(k.VariableKind.Command,m,v,l,"command");case"input":return this.o(k.VariableKind.Input,m,v,l,"input");case"extensionInstallFolder":if(v){const o=await this.a.getExtension(v);if(!o)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,m,v));return this.m(o.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,m));default:switch(i){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(s(k.VariableKind.WorkspaceFolder)));case"cwd":return r||v?(0,R.normalizeDriveLetter)(this.m(s(k.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(t.basename(this.m(s(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,D.localize)(11,null,m))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new k.VariableError(k.VariableKind.LineNumber,(0,D.localize)(12,null,m))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new k.VariableError(k.VariableKind.SelectedText,(0,D.localize)(13,null,m))}case"file":return E(k.VariableKind.File);case"fileWorkspaceFolder":return w(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||v?t.relative(this.m(s(k.VariableKind.RelativeFile)),E(k.VariableKind.RelativeFile)):E(k.VariableKind.RelativeFile);case"relativeFileDirname":{const o=t.dirname(E(k.VariableKind.RelativeFileDirname));if(r||v){const a=t.relative(this.m(s(k.VariableKind.RelativeFileDirname)),o);return a.length===0?".":a}return o}case"fileDirname":return t.dirname(E(k.VariableKind.FileDirname));case"fileExtname":return t.extname(E(k.VariableKind.FileExtname));case"fileBasename":return t.basename(E(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=t.basename(E(k.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-t.extname(o).length)}case"fileDirnameBasename":return t.basename(t.dirname(E(k.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||m}case"execInstallFolder":{const o=this.a.getAppRoot();return o||m}case"pathSeparator":return t.sep;default:try{const o=v?`${i}:${v}`:i;return this.o(k.VariableKind.Unknown,m,o,l,void 0)}catch{return m}}}}o(p,m,i,r,l){if(i&&r){const v=l===void 0?r[i]:r[l+":"+i];if(typeof v=="string")return v;throw new k.VariableError(p,(0,D.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=S,S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[95],ke([1,0,3,93]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,t.createDecorator)("editorGroupsService");var y;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var N;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(N=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var R;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function k(m){const i=m;return(0,T.isEditorInput)(i?.editor)&&(0,T.isEditorInput)(i?.replacement)}e.isEditorReplacement=k;var M;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(S=e.OpenEditorContext||(e.OpenEditorContext={}));function f(m){const i=m;return!!i&&typeof i.id=="number"&&Array.isArray(i.editors)}e.isEditorGroup=f;function p(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Ce[182],ke([1,0,3,95]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,t.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(N){const C=N;return typeof N=="number"||(0,T.isEditorGroup)(C)}e.isPreferredGroup=y}),define(Ce[183],ke([1,0,3,154]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,t.refineServiceDecorator)(T.IEnvironmentService)}),define(Ce[96],ke([1,0,25,4,19]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class N{constructor(S){this.removedDueToLooping=S}}e.DeltaExtensionsResult=N;class C{static isHostExtension(S,f,p){if(f.getExtensionDescription(S))return!1;const m=p.getExtensionDescription(S);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(S){this.c=new T.Emitter,this.onDidChange=this.c.event,this.d=S,this.h()}h(){this.d.sort(D),this.e=new Map,this.f=[],this.g=new Map;for(const S of this.d){if(this.e.has(t.ExtensionIdentifier.toKey(S.identifier))){console.error("Extension `"+S.identifier.value+"` is already registered");continue}if(this.e.set(t.ExtensionIdentifier.toKey(S.identifier),S),this.f.push(S),Array.isArray(S.activationEvents))for(let f of S.activationEvents)f==="onUri"&&(f=`onUri:${t.ExtensionIdentifier.toKey(S.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(S)}}set(S){this.d=S,this.h(),this.c.fire(void 0)}deltaExtensions(S,f){this.d=k(this.d,f),this.d=this.d.concat(S);const p=C.j(this.d);return this.d=k(this.d,p.map(m=>m.identifier)),this.h(),this.c.fire(void 0),new N(p)}static j(S){const f=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,v){this.addNode(l),this.addNode(v),this.c.has(l)?this.c.get(l).push(v):this.c.set(l,[v])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,v){const b=f.getArcs(l);for(let E=0;E<b.length;E++)if(!v.has(b[E]))return!1;return!0}getNodes(){return this.e}},p=new Map;for(const l of S){const v=t.ExtensionIdentifier.toKey(l.identifier);if(p.set(v,l),l.extensionDependencies)for(const b of l.extensionDependencies){const E=t.ExtensionIdentifier.toKey(b);f.addArc(v,E)}}const m=new Set;f.getNodes().filter(l=>f.getArcs(l).length===0).forEach(l=>m.add(l));const i=f.getNodes().filter(l=>!m.has(l));let r;do{r=!1;for(let l=0;l<i.length;l++){const v=i[l];f.hasOnlyGoodArcs(v,m)&&(i.splice(l,1),l--,m.add(v),r=!0)}}while(r);return i.map(l=>p.get(l))}containsActivationEvent(S){return this.g.has(S)}containsExtension(S){return this.e.has(t.ExtensionIdentifier.toKey(S))}getExtensionDescriptionsForActivationEvent(S){const f=this.g.get(S);return f?f.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(S){const f=this.e.get(t.ExtensionIdentifier.toKey(S));return f||void 0}getExtensionDescriptionByUUID(S){for(const f of this.f)if(f.uuid===S)return f}getExtensionDescriptionByIdOrUUID(S,f){return this.getExtensionDescription(S)??(f?this.getExtensionDescriptionByUUID(f):void 0)}}e.ExtensionDescriptionRegistry=C;var R;(function(M){M[M.Builtin=0]="Builtin",M[M.User=1]="User",M[M.Dev=2]="Dev"})(R||(R={}));function D(M,S){const f=M.isBuiltin?0:M.isUnderDevelopment?2:1,p=S.isBuiltin?0:S.isUnderDevelopment?2:1;if(f!==p)return f-p;const m=y.posix.basename(M.extensionLocation.path),i=y.posix.basename(S.extensionLocation.path);return m<i?-1:m>i?1:0}function k(M,S){const f=new Set;return S.forEach(p=>f.add(t.ExtensionIdentifier.toKey(p))),M.filter(p=>!f.has(t.ExtensionIdentifier.toKey(p.identifier)))}}),define(Ce[70],ke([1,0,24]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var N;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(N=e.MessageType||(e.MessageType={}));function C(k){const M=t.VSBuffer.alloc(1);switch(k){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.createMessageOfType=C;function R(k,M){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.isMessageOfType=R;var D;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(D=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[71],ke([1,0,3,4,12,27,70,48,50,23,2]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let S=class{constructor(i,r){this.i=i,this.a=new T.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new T.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=r.createLogger(M.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(i,r,l){const v=this.getTelemetryDetails(),b=new f(r,l,i,this.g,this.f,this.getBuiltInCommonProperties(i),{isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled});return this.h.set(i.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(i,r,l){this.d=i,this.f=r,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(i){const r={};switch(r["common.extname"]=i.name,r["common.extversion"]=i.version,r["common.vscodemachineid"]=this.i.telemetryInfo.machineId,r["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,r["common.vscodeversion"]=this.i.version,r["common.isnewappinstall"]=p(this.i.telemetryInfo.firstSessionDate),r["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:r["common.uikind"]="web";break;case C.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,R.getRemoteName)((0,D.cleanRemoteAuthority)(this.i.remote.authority)),r}$onDidChangeTelemetryLevel(i){this.e=this.getTelemetryConfiguration(),this.d=i;const r=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(i,r){const l=this.h.get(i.value);return!l||l.ignoreUnhandledExtHostErrors?!1:(l.logError(r),!0)}};S=qe([je(0,N.IExtHostInitDataService),je(1,y.ILoggerService)],S),e.ExtHostTelemetry=S;class f{constructor(i,r,l,v,b,E,w){this.g=l,this.h=v,this.i=b,this.j=E,this.b=new T.Emitter,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.e=r?.ignoreBuiltInCommonProperties??!1,this.f=r?.additionalCommonProperties,this.a=i,this.c={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(i,r){this.d&&(this.c={isUsageEnabled:i,isErrorsEnabled:r},this.b.fire(this.d))}mixInCommonPropsAndCleanData(i){let r=i.properties??i;return r=(0,D.cleanData)(r,[]),this.f&&(r=(0,k.mixin)(r,this.f)),this.e||(r=(0,k.mixin)(r,this.j)),i.properties?i.properties=r:i=r,i}k(i,r){this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.a.logEvent(i,r),this.h.trace(i,r)}logUsage(i,r){!this.c.isUsageEnabled||this.k(i,r)}logError(i,r){!this.c.isErrorsEnabled||(typeof i=="string"?this.k(i,r):this.a.logError(i,r))}get apiTelemetryLogger(){if(!this.d){const i=this,r={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.c.isUsageEnabled},get isErrorsEnabled(){return i.c.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.b.event.bind(i)};this.d=Object.freeze(r)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=f;function p(m){const i=Date.now()-new Date(m).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.isNewAppInstall=p,e.IExtHostTelemetry=(0,t.createDecorator)("IExtHostTelemetry")}),define(Ce[26],ke([1,0,4,2,3,25,163]),function(ee,e,t,T,y,N,C){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new N.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class D{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=D;class k{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class M{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=M;class S{constructor(u){this.dependency=u}}e.MissingExtensionDependency=S;var f;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(f=e.ExtensionHostKind||(e.ExtensionHostKind={}));function p(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=p;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,n){const h=[],g=[],A=[],L=[],q=l(this.c),Z=l(u),x=(B,V)=>B.extensionLocation.toString()===V.extensionLocation.toString()||B.isBuiltin===V.isBuiltin||B.isUserBuiltin===V.isUserBuiltin||B.isUnderDevelopment===V.isUnderDevelopment;for(const B of this.c){const V=Z.get(N.ExtensionIdentifier.toKey(B.identifier));if(!V){h.push(B.identifier),q.delete(N.ExtensionIdentifier.toKey(B.identifier));continue}if(!x(B,V)){h.push(B.identifier),q.delete(N.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of u){const V=q.get(N.ExtensionIdentifier.toKey(B.identifier));if(!V){g.push(B);continue}if(!x(V,B)){h.push(V.identifier),q.delete(N.ExtensionIdentifier.toKey(V.identifier));continue}}const O=r(this.d),F=r(n);for(const B of this.d)F.has(N.ExtensionIdentifier.toKey(B))||A.push(B);for(const B of n)O.has(N.ExtensionIdentifier.toKey(B))||L.push(B);const P={toRemove:h,toAdd:g,myToRemove:A,myToAdd:L};return this.delta(P),P}delta(u){const{toRemove:n,toAdd:h,myToRemove:g,myToAdd:A}=u,L=r(n),q=r(g);for(let Z=0;Z<this.c.length;Z++)L.has(N.ExtensionIdentifier.toKey(this.c[Z].identifier))&&(this.c.splice(Z,1),Z--);for(let Z=0;Z<this.d.length;Z++)q.has(N.ExtensionIdentifier.toKey(this.d[Z]))&&(this.d.splice(Z,1),Z--);for(const Z of h)this.c.push(Z);for(const Z of A)this.d.push(Z)}containsExtension(u){for(const n of this.d)if(N.ExtensionIdentifier.equals(n,u))return!0;return!1}}e.ExtensionHostExtensions=m;class i{constructor(u){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=N.ExtensionIdentifier.toKey,u)for(const n of u)this.add(n)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,n){this.c.forEach(h=>u.call(n,h,h,this))}*entries(){for(const[u,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=i;function r(c){const u=new Set;for(const n of c)u.add(N.ExtensionIdentifier.toKey(n));return u}e.extensionIdentifiersArrayToSet=r;function l(c){const u=new Map;for(const n of c)u.set(N.ExtensionIdentifier.toKey(n.identifier),n);return u}function v(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=v;function b(c,u){if(!v(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=b;class E{constructor(u,n,h,g){this.codeLoadingTime=u,this.activateCallTime=n,this.activateResolvedTime=h,this.activationReason=g}}e.ActivationTimes=E;class w{constructor(u,n){this.description=u,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function o(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function a(c,u){return{identifier:new N.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=a;class d{constructor(){this.onDidRegisterExtensions=t.Event.None,this.onDidChangeExtensionsStatus=t.Event.None,this.onDidChangeExtensions=t.Event.None,this.onWillActivateByEvent=t.Event.None,this.onDidChangeResponsiveChange=t.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,n){return Promise.resolve(0)}getInspectPorts(u,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=d}),define(Ce[184],ke([1,0,11,96,25,26,12,14]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(l,v,b,E){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=b,this.activateResolvedTime=E}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class k{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,v){return l===-1||v===-1?-1:v-l}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class M{constructor(l,v,b,E,w,s){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=b,this.module=E,this.exports=w,this.subscriptions=s}}e.ActivatedExtension=M;class S extends M{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=S;class f extends M{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=f;class p extends M{constructor(l){super(!0,l,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(l,v,b,E){this.g=E,this.a=l,this.b=v,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,v]of this.d)v.dispose()}isActivated(l){const v=this.d.get(y.ExtensionIdentifier.toKey(l));return Boolean(v&&v.value)}getActivatedExtension(l){const v=this.d.get(y.ExtensionIdentifier.toKey(l));if(!v||!v.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return v.value}async activateByEvent(l,v){if(this.f[l])return;const b=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(b.map(E=>({id:E.identifier,reason:{startup:v,extensionId:E.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,v){const b=this.a.getExtensionDescription(l);if(!b)throw new Error(`Extension '${l}' is not known`);return this.h([{id:b.identifier,reason:v}])}async h(l){const v=l.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(v.map(b=>b.wait()))}j(l){if(this.d.has(y.ExtensionIdentifier.toKey(l.id)))return this.d.get(y.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const v=this.a.getExtensionDescription(l.id);if(!v){const w=new Error(`Cannot activate unknown extension '${l.id.value}'`),s=this.k(l,null,[],new p(w));return this.c.onExtensionActivationError(l.id,w,new N.MissingExtensionDependency(l.id.value)),s}const b=[],E=typeof v.extensionDependencies>"u"?[]:v.extensionDependencies;for(const w of E){if(this.m(w))continue;const s=this.d.get(y.ExtensionIdentifier.toKey(w));if(s){b.push(s);continue}if(this.l(w)){b.push(this.j({id:this.b.getExtensionDescription(w).identifier,reason:l.reason}));continue}const o=this.a.getExtensionDescription(w);if(o){if(!o.main&&!o.browser)continue;b.push(this.j({id:o.identifier,reason:l.reason}));continue}const a=v.displayName||v.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${w}'`),c=this.k(l,v.displayName,[],new p(d));return this.c.onExtensionActivationError(v.identifier,d,new N.MissingExtensionDependency(w)),c}return this.k(l,v.displayName,b,null)}k(l,v,b,E){const w=new i(l.id,v,l.reason,b,E,this.c,this.g);return this.d.set(y.ExtensionIdentifier.toKey(l.id),w),w}l(l){return T.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const v=this.b.getExtensionDescription(l);return v?!v.main&&!v.browser:!1}};m=qe([je(3,C.ILogService)],m),e.ExtensionsActivator=m;let i=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,v,b,E,w,s,o){this.c=l,this.d=v,this.f=b,this.g=E,this.h=w,this.j=s,this.k=o,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const v=this.g[l];if(v.value&&!v.value.activationFailed){this.g.splice(l,1),l--;continue}if(v.value&&v.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${v.friendlyName}' failed to activate`);b.detail=v.value.activationFailedError,this.h=new p(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const v=new Error;if(l&&l.name&&(v.name=l.name),l&&l.message?v.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:v.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(v.stack=l.stack),this.h=new p(v),this.b&&t.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,v,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};i=qe([je(6,C.ILogService)],i)}),define(Ce[185],ke([1,0,12,27,26]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let N=class extends t.LogService{constructor(R,D){super(R.createLogger(D.logFile,{name:y.ExtensionHostLogFileName}))}};N=qe([je(0,t.ILoggerService),je(1,T.IExtHostInitDataService)],N),e.ExtHostLogService=N});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[6],ke([1,0,16,11,83,28,62,10,9,2,34,36,92,67,26]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m){"use strict";var i,r,l,v,b,E,w,s,o,a,d,c,u,n,h,g,A,L,q,Z,x,O,F;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(W){return Object.assign(W,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(W,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(W,[]);{const[te,...be]=arguments;return Reflect.construct(W,be,te.constructor)}}})}var B;(function(W){W[W.Top=0]="Top",W[W.Bottom=1]="Bottom"})(B=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var V;(function(W){W[W.Command=0]="Command",W[W.Opener=1]="Opener"})(V=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let z=E=class{static from(...U){let te=U;return new E(function(){if(te){for(const be of te)be&&typeof be.dispose=="function"&&be.dispose();te=void 0}})}constructor(U){i.set(this,void 0),Je(this,i,U,"f")}dispose(){typeof Oe(this,i,"f")=="function"&&(Oe(this,i,"f").call(this),Je(this,i,void 0,"f"))}};i=new WeakMap,z=E=qe([P],z),e.Disposable=z;let ne=w=class{static Min(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let be=1;be<U.length;be++){const Ke=U[be];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let be=1;be<U.length;be++){const Ke=U[be];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(U){if(!U)return!1;if(U instanceof w)return!0;const{line:te,character:be}=U;return typeof te=="number"&&typeof be=="number"}static of(U){if(U instanceof w)return U;if(this.isPosition(U))return new w(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("line must be non-negative");if(te<0)throw(0,T.illegalArgument)("character must be non-negative");this.c=U,this.e=te}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,te=0){if(U===null||te===null)throw(0,T.illegalArgument)();let be;return typeof U>"u"?be=0:typeof U=="number"?be=U:(be=typeof U.lineDelta=="number"?U.lineDelta:0,te=typeof U.characterDelta=="number"?U.characterDelta:0),be===0&&te===0?this:new w(this.line+be,this.character+te)}with(U,te=this.character){if(U===null||te===null)throw(0,T.illegalArgument)();let be;return typeof U>"u"?be=this.line:typeof U=="number"?be=U:(be=typeof U.line=="number"?U.line:this.line,te=typeof U.character=="number"?U.character:this.character),be===this.line&&te===this.character?this:new w(be,te)}toJSON(){return{line:this.line,character:this.character}}};ne=w=qe([P],ne),e.Position=ne;let de=s=class{static isRange(U){return U instanceof s?!0:U?ne.isPosition(U.start)&&ne.isPosition(U.end):!1}static of(U){if(U instanceof s)return U;if(this.isRange(U))return new s(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,te,be,Ke){let Ye,ot;if(typeof U=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Ke=="number"?(Ye=new ne(U,te),ot=new ne(be,Ke)):ne.isPosition(U)&&ne.isPosition(te)&&(Ye=ne.of(U),ot=ne.of(te)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(U){return s.isRange(U)?this.contains(U.start)&&this.contains(U.end):ne.isPosition(U)?!(ne.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const te=ne.Max(U.start,this.c),be=ne.Min(U.end,this.e);if(!te.isAfter(be))return new s(te,be)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const te=ne.Min(U.start,this.c),be=ne.Max(U.end,this.end);return new s(te,be)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,te=this.end){if(U===null||te===null)throw(0,T.illegalArgument)();let be;return U?ne.isPosition(U)?be=U:(be=U.start||this.start,te=U.end||this.end):be=this.start,be.isEqual(this.c)&&te.isEqual(this.end)?this:new s(be,te)}toJSON(){return[this.start,this.end]}};de=s=qe([P],de),e.Range=de;let we=o=class extends de{static isSelection(U){return U instanceof o?!0:U?de.isRange(U)&&ne.isPosition(U.anchor)&&ne.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,te,be,Ke){let Ye,ot;if(typeof U=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Ke=="number"?(Ye=new ne(U,te),ot=new ne(be,Ke)):ne.isPosition(U)&&ne.isPosition(te)&&(Ye=ne.of(U),ot=ne.of(te)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};we=o=qe([P],we),e.Selection=we;class ue{constructor(U,te,be){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.illegalArgument)("port");if(typeof be<"u"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z_\-]+$/.test(be)))throw(0,T.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(te),this.connectionToken=be}}e.ResolvedAuthority=ue;class ae extends Error{static NotAvailable(U,te){return new ae(U,f.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(U){return new ae(U,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,te=f.RemoteAuthorityResolverErrorCode.Unknown,be){super(U),this._message=U,this._code=te,this._detail=be,Object.setPrototypeOf(this,ae.prototype)}}e.RemoteAuthorityResolverError=ae;var Ie;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(Ie=e.EndOfLine||(e.EndOfLine={}));var G;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=a=class{static isTextEdit(U){return U instanceof a?!0:U?de.isRange(U)&&typeof U.newText=="string":!1}static replace(U,te){return new a(U,te)}static insert(U,te){return a.replace(new de(U,U),te)}static delete(U){return a.replace(U,"")}static setEndOfLine(U){const te=new a(new de(new ne(0,0),new ne(0,0)),"");return te.newEol=U,te}get range(){return this.c}set range(U){if(U&&!de.isRange(U))throw(0,T.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,T.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,T.illegalArgument)("newEol");this.f=U}constructor(U,te){this.c=U,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};j=a=qe([P],j),e.TextEdit=j;let re=d=class{static isNotebookCellEdit(U){return U instanceof d?!0:U?xt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,te){return new d(U,te)}static insertCells(U,te){return new d(new xt(U,U),te)}static deleteCells(U){return new d(U,[])}static updateCellMetadata(U,te){const be=new d(new xt(U,U),[]);return be.newCellMetadata=te,be}static updateNotebookMetadata(U){const te=new d(new xt(0,0),[]);return te.newNotebookMetadata=U,te}constructor(U,te){this.range=U,this.newCells=te}};re=d=qe([P],re),e.NotebookEdit=re;class me{static isSnippetTextEdit(U){return U instanceof me?!0:U?de.isRange(U.range)&&Ge.isSnippetString(U.snippet):!1}static replace(U,te){return new me(U,te)}static insert(U,te){return me.replace(new de(U,U),te)}constructor(U,te){this.range=U,this.snippet=te}}e.SnippetTextEdit=me;var Te;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Te=e.FileEditType||(e.FileEditType={}));let Be=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,te,be,Ke){this.c.push({_type:1,from:U,to:te,options:be,metadata:Ke})}createFile(U,te,be){this.c.push({_type:1,from:void 0,to:U,options:te,metadata:be})}deleteFile(U,te,be){this.c.push({_type:1,from:U,to:void 0,options:te,metadata:be})}e(U,te,be){this.c.push({_type:3,metadata:be,uri:U,edit:{editType:5,metadata:te},notebookMetadata:te})}f(U,te,be,Ke){const Ye=te.start,ot=te.end;(Ye!==ot||be.length>0)&&this.c.push({_type:5,uri:U,index:Ye,count:ot-Ye,cells:be,metadata:Ke})}g(U,te,be,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:te,metadata:be}})}replace(U,te,be,Ke){this.c.push({_type:2,uri:U,edit:new j(te,be),metadata:Ke})}insert(U,te,be,Ke){this.replace(U,new de(te,te),be,Ke)}delete(U,te,be){this.replace(U,te,"",be)}has(U){return this.c.some(te=>te._type===2&&te.uri.toString()===U.toString())}set(U,te){if(te)for(const be of te){if(!be)continue;let Ke,Ye;if(Array.isArray(be)?(Ke=be[0],Ye=be[1]):Ke=be,re.isNotebookCellEdit(Ke)){if(U.scheme===p.CellUri.scheme)throw new Error("set must be called with a notebook document URI, not a cell URI.");Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,Ye):this.f(U,Ke.range,Ke.newCells,Ye)}else me.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:U,edit:Ke,metadata:Ye})}else{for(let be=0;be<this.c.length;be++){const Ke=this.c[be];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[be]=void 0);break}}(0,t.coalesceInPlace)(this.c)}}get(U){const te=[];for(const be of this.c)be._type===2&&be.uri.toString()===U.toString()&&te.push(be.edit);return te}entries(){const U=new N.ResourceMap;for(const te of this.c)if(te._type===2){let be=U.get(te.uri);be||(be=[te.uri,[]],U.set(te.uri,be)),be[1].push(te.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Be=qe([P],Be),e.WorkspaceEdit=Be;let Ge=c=class{static isSnippetString(U){return U instanceof c?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=c.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,te=this.e++){if(typeof U=="function"){const be=new c;be.e=this.e,U(be),this.e=be.e,U=be.value}else U=c.c(U);return this.value+="${",this.value+=te,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,te=this.e++){const be=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(U,te){if(typeof te=="function"){const be=new c;be.e=this.e,te(be),this.e=be.e,te=be.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,te&&(this.value+=":",this.value+=te),this.value+="}",this}};Ge=c=qe([P],Ge),e.SnippetString=Ge;var Pe;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Pe=e.DiagnosticTag||(e.DiagnosticTag={}));var De;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(De=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Se=u=class{static isLocation(U){return U instanceof u?!0:U?de.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,te){if(this.uri=U,te)if(de.isRange(te))this.range=de.of(te);else if(ne.isPosition(te))this.range=new de(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Se=u=qe([P],Se),e.Location=Se;let se=class{static is(U){return U?typeof U.message=="string"&&U.location&&de.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,te){this.location=U,this.message=te}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.location.range.isEqual(te.location.range)&&U.location.uri.toString()===te.location.uri.toString()}};se=qe([P],se),e.DiagnosticRelatedInformation=se;let ce=class{constructor(U,te,be=De.Error){if(!de.isRange(U))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=U,this.message=te,this.severity=be}toJSON(){return{severity:De[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.severity===te.severity&&U.code===te.code&&U.severity===te.severity&&U.source===te.source&&U.range.isEqual(te.range)&&(0,t.equals)(U.tags,te.tags)&&(0,t.equals)(U.relatedInformation,te.relatedInformation,se.isEqual)}};ce=qe([P],ce),e.Diagnostic=ce;let Y=class{constructor(U,te){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=te}};Y=qe([P],Y),e.Hover=Y;var I;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,te=I.Text){this.range=U,this.kind=te}toJSON(){return{range:this.range,kind:I[this.kind]}}};$=qe([P],$),e.DocumentHighlight=$;var H;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(H=e.SymbolKind||(e.SymbolKind={}));var K;(function(W){W[W.Deprecated=1]="Deprecated"})(K=e.SymbolTag||(e.SymbolTag={}));let J=n=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,te,be,Ke,Ye){this.name=U,this.kind=te,this.containerName=Ye,typeof be=="string"&&(this.containerName=be),Ke instanceof Se?this.location=Ke:be instanceof de&&(this.location=new Se(Ke,be)),n.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};J=n=qe([P],J),e.SymbolInformation=J;let le=h=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(h.validate)}constructor(U,te,be,Ke,Ye){this.name=U,this.detail=te,this.kind=be,this.range=Ke,this.selectionRange=Ye,this.children=[],h.validate(this)}};le=h=qe([P],le),e.DocumentSymbol=le;var Ee;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(Ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(U,te){this.title=U,this.kind=te}};oe=qe([P],oe),e.CodeAction=oe;let pe=g=class{constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};pe.c=".",pe=g=qe([P],pe),e.CodeActionKind=pe,pe.Empty=new pe(""),pe.QuickFix=pe.Empty.append("quickfix"),pe.Refactor=pe.Empty.append("refactor"),pe.RefactorExtract=pe.Refactor.append("extract"),pe.RefactorInline=pe.Refactor.append("inline"),pe.RefactorMove=pe.Refactor.append("move"),pe.RefactorRewrite=pe.Refactor.append("rewrite"),pe.Source=pe.Empty.append("source"),pe.SourceOrganizeImports=pe.Source.append("organizeImports"),pe.SourceFixAll=pe.Source.append("fixAll");let ve=class{constructor(U,te){if(this.range=U,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ve=qe([P],ve),e.SelectionRange=ve;class We{constructor(U,te,be,Ke,Ye,ot){this.kind=U,this.name=te,this.detail=be,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=We;class He{constructor(U,te){this.fromRanges=te,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,te){this.fromRanges=te,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,te){this.range=U,this.command=te}get isResolved(){return!!this.command}};et=qe([P],et),e.CodeLens=et;let it=A=class{static isMarkdownString(U){return U instanceof A?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,te=!1){r.set(this,void 0),Je(this,r,new y.MarkdownString(U,{supportThemeIcons:te}),"f")}get value(){return Oe(this,r,"f").value}set value(U){Oe(this,r,"f").value=U}get isTrusted(){return Oe(this,r,"f").isTrusted}set isTrusted(U){Oe(this,r,"f").isTrusted=U}get supportThemeIcons(){return Oe(this,r,"f").supportThemeIcons}set supportThemeIcons(U){Oe(this,r,"f").supportThemeIcons=U}get supportHtml(){return Oe(this,r,"f").supportHtml}set supportHtml(U){Oe(this,r,"f").supportHtml=U}get baseUri(){return Oe(this,r,"f").baseUri}set baseUri(U){Oe(this,r,"f").baseUri=U}appendText(U){return Oe(this,r,"f").appendText(U),this}appendMarkdown(U){return Oe(this,r,"f").appendMarkdown(U),this}appendCodeblock(U,te){return Oe(this,r,"f").appendCodeblock(te??"",U),this}};r=new WeakMap,it=A=qe([P],it),e.MarkdownString=it;let dt=class{constructor(U,te){this.label=U,this.documentation=te}};dt=qe([P],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,te){this.label=U,this.documentation=te,this.parameters=[]}};Fe=qe([P],Fe),e.SignatureInformation=Fe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([P],st),e.SignatureHelp=st;var Q;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(_=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(U){this.value=U}};ge=qe([P],ge),e.InlayHintLabelPart=ge;let Le=class{constructor(U,te,be){this.position=U,this.label=te,this.kind=be}};Le=qe([P],Le),e.InlayHint=Le;var $e;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var Qe;(function(W){W[W.Deprecated=1]="Deprecated"})(Qe=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,te){this.label=U,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([P],nt),e.CompletionItem=nt;let wt=class{constructor(U=[],te=!1){this.items=U,this.isIncomplete=te}};wt=qe([P],wt),e.CompletionList=wt;let St=class{constructor(U,te,be){this.insertText=U,this.range=te,this.command=be}};St=qe([P],St),e.InlineSuggestion=St;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([P],Ct),e.InlineSuggestionList=Ct;var lt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Bt;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Bt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var $t;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})($t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function U(te){switch(te){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=U}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Mt=class{constructor(U,te){if(te&&!k.URI.isUri(te))throw(0,T.illegalArgument)("target");if(!de.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.target=te}};Mt=qe([P],Mt),e.DocumentLink=Mt;let xe=class{constructor(U,te,be,Ke){this.red=U,this.green=te,this.blue=be,this.alpha=Ke}};xe=qe([P],xe),e.Color=xe;let Lt=class{constructor(U,te){if(te&&!(te instanceof xe))throw(0,T.illegalArgument)("color");if(!de.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.color=te}};Lt=qe([P],Lt),e.ColorInformation=Lt;let Nt=class{constructor(U){if(!U||typeof U!="string")throw(0,T.illegalArgument)("label");this.label=U}};Nt=qe([P],Nt),e.ColorPresentation=Nt;var Ut;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var gt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(gt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var kt;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(kt=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(U,te,be){if(this.startIndex=U,this.length=te,this.tooltip=be,typeof U!="number"||U<0)throw(0,T.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,T.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=ye;class Ae{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Ae;class fe{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=fe;var X;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(X=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=Re;var Ne;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(Ne=e.TaskRevealKind||(e.TaskRevealKind={}));var _e;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(_e=e.TaskPanelKind||(e.TaskPanelKind={}));let ze=L=class{static from(U){switch(U){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(U,te){if(this.label=te,typeof U!="string"||typeof te!="string")throw(0,T.illegalArgument)("name");this.c=U}get id(){return this.c}};ze.Clean=new L("clean","Clean"),ze.Build=new L("build","Build"),ze.Rebuild=new L("rebuild","Rebuild"),ze.Test=new L("test","Test"),ze=L=qe([P],ze),e.TaskGroup=ze;function Ze(W){let U="";for(let te=0;te<W.length;te++)U+=W[te].replace(/,/g,",,")+",";return U}let bt=class{constructor(U,te,be){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.e=[],this.c=U,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=be):this.f=te)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const te of this.e)U.push(te);return Ze(U)}};bt=qe([P],bt),e.ProcessExecution=bt;let vt=class{constructor(U,te,be){if(this.f=[],Array.isArray(te)){if(!U)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U,this.f=te,this.g=be}else{if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U,this.g=te}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)U.push(typeof te=="string"?te:te.value);return Ze(U)}};vt=qe([P],vt),e.ShellExecution=vt;var At;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(At=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,M.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let ht=q=class{constructor(U,te,be,Ke,Ye,ot){this.j=!1,this.k=this.definition=U;let ut;typeof te=="string"?(this.m=this.name=te,this.t=this.source=be,this.execution=Ke,ut=Ye,this.j=!0):te===pt.Global||te===pt.Workspace?(this.target=te,this.m=this.name=be,this.t=this.source=Ke,this.execution=Ye,ut=ot):(this.target=te,this.m=this.name=be,this.t=this.source=Ke,this.execution=Ye,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof bt?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof vt?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,M.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,T.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const te=this.k.type;(q.g===te||q.e===te||q.f===te||q.c===te)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};ht.c="customExecution",ht.e="process",ht.f="shell",ht.g="$empty",ht=q=qe([P],ht),e.Task=ht;var Kt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(Kt=e.ProgressLocation||(e.ProgressLocation={}));var jt;(function(W){function U(te){const be=te;return(0,D.isNumber)(be.value)?be.tooltip&&!(0,D.isString)(be.tooltip)?(console.log("INVALID view badge, invalid tooltip",be.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",be.value),!1)}W.isViewBadge=U})(jt=e.ViewBadge||(e.ViewBadge={}));let Et=Z=class{static isTreeItem(U,te){if(U instanceof Z)return!0;const be=U;if(be.label!==void 0&&!(0,D.isString)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,D.isString)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,D.isString)(be.iconPath)&&!k.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,D.isString)(be.iconPath.id))){const Ke=be.iconPath;if(!Ke||!(0,D.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,D.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}if(be.description!==void 0&&!(0,D.isString)(be.description)&&typeof be.description!="boolean")return console.log("INVALID tree item, invalid description",be.description),!1;if(be.resourceUri!==void 0&&!k.URI.isUri(be.resourceUri))return console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1;if(be.tooltip!==void 0&&!(0,D.isString)(be.tooltip)&&!(be.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",be.tooltip),!1;if(be.command!==void 0&&!be.command.command)return console.log("INVALID tree item, invalid command",be.command),!1;if(be.collapsibleState!==void 0&&be.collapsibleState<_t.None&&be.collapsibleState>_t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1;if(be.contextValue!==void 0&&!(0,D.isString)(be.contextValue))return console.log("INVALID tree item, invalid contextValue",be.contextValue),!1;if(be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1;if(be.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ke=(0,D.isNumber)(be.checkboxState)?be.checkboxState:(0,D.isObject)(be.checkboxState)&&(0,D.isNumber)(be.checkboxState.state)?be.checkboxState.state:void 0,Ye=!(0,D.isNumber)(be.checkboxState)&&(0,D.isObject)(be.checkboxState)?be.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==ri.Checked&&Ke!==ri.Unchecked||Ye!==void 0&&!(0,D.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1}return!0}constructor(U,te=_t.None){this.collapsibleState=te,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};Et=Z=qe([P],Et),e.TreeItem=Et;var _t;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ri;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(ri=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ei=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,te){this.value=U,this.id=te??(0,M.generateUuid)()}};ei=qe([P],ei),e.DataTransferItem=ei;let bi=class{constructor(U){l.set(this,new Map);for(const[te,be]of U??[]){const Ke=Oe(this,l,"f").get(te);Ke?Ke.push(be):Oe(this,l,"f").set(te,[be])}}get(U){return Oe(this,l,"f").get(U)?.[0]}set(U,te){Oe(this,l,"f").set(U,[te])}forEach(U,te){for(const[be,Ke]of Oe(this,l,"f"))for(const Ye of Ke)U.call(te,Ye,be,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[U,te]of Oe(this,l,"f"))for(const be of te)yield[U,be]}};bi=qe([P],bi),e.DataTransfer=bi;let Tt=class{constructor(U){this.insertText=U}};Tt=qe([P],Tt),e.DocumentDropEdit=Tt;let si=class{constructor(U){this.insertText=U}};si=qe([P],si),e.DocumentPasteEdit=si;let Vt=class{constructor(U,te){this.id=U,this.color=te}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};Vt=qe([P],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let ti=class{constructor(U){this.id=U}};ti=qe([P],ti),e.ThemeColor=ti;var oi;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{get base(){return this.c}set base(U){this.c=U,this.e=k.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,te){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,T.illegalArgument)("base");if(typeof te!="string")throw(0,T.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ct=qe([P],ct),e.RelativePattern=ct;const Oi=new WeakMap;function Qt(W,U){Oi.set(W,U)}e.setBreakpointId=Qt;let Wt=class{constructor(U,te,be,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof te=="string"&&(this.condition=te),typeof be=="string"&&(this.hitCondition=be),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=Oi.get(this)??(0,M.generateUuid)()),this.c}};Wt=qe([P],Wt),e.Breakpoint=Wt;let ai=class extends Wt{constructor(U,te,be,Ke,Ye){if(super(te,be,Ke,Ye),U===null)throw(0,T.illegalArgument)("location");this.location=U}};ai=qe([P],ai),e.SourceBreakpoint=ai;let Ei=class extends Wt{constructor(U,te,be,Ke,Ye){super(te,be,Ke,Ye),this.functionName=U}};Ei=qe([P],Ei),e.FunctionBreakpoint=Ei;let ci=class extends Wt{constructor(U,te,be,Ke,Ye,ot,ut){if(super(Ke,Ye,ot,ut),!te)throw(0,T.illegalArgument)("dataId");this.label=U,this.dataId=te,this.canPersist=be}};ci=qe([P],ci),e.DataBreakpoint=ci;let wi=class{constructor(U,te,be){this.command=U,this.args=te||[],this.options=be}};wi=qe([P],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,te){this.port=U,this.host=te}};ui=qe([P],ui),e.DebugAdapterServer=ui;let ii=class{constructor(U){this.path=U}};ii=qe([P],ii),e.DebugAdapterNamedPipeServer=ii;let Si=class{constructor(U){this.implementation=U}};Si=qe([P],Si),e.DebugAdapterInlineImplementation=Si;let ni=class{constructor(U,te){this.range=U,this.expression=te}};ni=qe([P],ni),e.EvaluatableExpression=ni;var yi;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(yi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Di=class{constructor(U,te){this.range=U,this.text=te}};Di=qe([P],Di),e.InlineValueText=Di;let Ii=class{constructor(U,te,be=!0){this.range=U,this.variableName=te,this.caseSensitiveLookup=be}};Ii=qe([P],Ii),e.InlineValueVariableLookup=Ii;let Yt=class{constructor(U,te){this.range=U,this.expression=te}};Yt=qe([P],Yt),e.InlineValueEvaluatableExpression=Yt;let Ci=class{constructor(U,te){this.frameId=U,this.stoppedLocation=te}};Ci=qe([P],Ci),e.InlineValueContext=Ci;var Bi;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Bi=e.FileChangeType||(e.FileChangeType={}));let ki=x=class extends Error{static FileExists(U){return new x(U,S.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(U){return new x(U,S.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(U){return new x(U,S.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(U){return new x(U,S.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(U){return new x(U,S.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(U){return new x(U,S.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(U,te=S.FileSystemProviderErrorCode.Unknown,be){super(k.URI.isUri(U)?U.toString(!0):U),this.code=be?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}};ki=x=qe([P],ki),e.FileSystemError=ki;let Ti=class{constructor(U,te,be){this.start=U,this.end=te,this.kind=be}};Ti=qe([P],Ti),e.FoldingRange=Ti;var $i;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})($i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Pi;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Pi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Fi;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(Fi=e.CommentMode||(e.CommentMode={}));var Mi;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Mi=e.CommentThreadState||(e.CommentThreadState={}));class Ue{constructor(U,te=[]){this.tokenTypes=U,this.tokenModifiers=te}}e.SemanticTokensLegend=Ue;function Gt(W){return typeof W>"u"||(0,D.isStringArray)(W)}class li{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let te=0,be=U.tokenTypes.length;te<be;te++)this.j.set(U.tokenTypes[te],te);for(let te=0,be=U.tokenModifiers.length;te<be;te++)this.k.set(U.tokenModifiers[te],te)}}push(U,te,be,Ke,Ye){if(typeof U=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(U,te,be,Ke,Ye);if(de.isRange(U)&&typeof te=="string"&&Gt(be))return this.m(U,te,be);throw(0,T.illegalArgument)()}m(U,te,be){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,Ye=U.start.character,ot=U.end.character-U.start.character,ut=this.j.get(te);let Rt=0;if(be)for(const Ht of be){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Rt|=1<<qt>>>0}this.n(Ke,Ye,ot,ut,Rt)}n(U,te,be,Ke,Ye){if(this.f&&(U<this.c||U===this.c&&te<this.e)){this.f=!1;const Rt=this.g.length/5|0;let Ht=0,qt=0;for(let Xt=0;Xt<Rt;Xt++){let Jt=this.g[5*Xt],Ai=this.g[5*Xt+1];Jt===0?(Jt=Ht,Ai+=qt):Jt+=Ht,this.g[5*Xt]=Jt,this.g[5*Xt+1]=Ai,Ht=Jt,qt=Ai}}let ot=U,ut=te;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=be,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=U,this.e=te}static o(U){const te=[],be=U.length/5|0;for(let ut=0;ut<be;ut++)te[ut]=ut;te.sort((ut,Rt)=>{const Ht=U[5*ut],qt=U[5*Rt];if(Ht===qt){const Xt=U[5*ut+1],Jt=U[5*Rt+1];return Xt-Jt}return Ht-qt});const Ke=new Uint32Array(U.length);let Ye=0,ot=0;for(let ut=0;ut<be;ut++){const Rt=5*te[ut],Ht=U[Rt+0],qt=U[Rt+1],Xt=U[Rt+2],Jt=U[Rt+3],Ai=U[Rt+4],tn=Ht-Ye,An=tn===0?qt-ot:qt,Ri=5*ut;Ke[Ri+0]=tn,Ke[Ri+1]=An,Ke[Ri+2]=Xt,Ke[Ri+3]=Jt,Ke[Ri+4]=Ai,Ye=Ht,ot=qt}return Ke}build(U){return this.f?new mt(new Uint32Array(this.g),U):new mt(li.o(this.g),U)}}e.SemanticTokensBuilder=li;class mt{constructor(U,te){this.resultId=te,this.data=U}}e.SemanticTokens=mt;class zi{constructor(U,te,be){this.start=U,this.deleteCount=te,this.data=be}}e.SemanticTokensEdit=zi;class Wi{constructor(U,te){this.resultId=te,this.edits=U}}e.SemanticTokensEdits=Wi;var Li;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(Li=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Vt("arrow-left")},di=qe([P],di),e.QuickInputButtons=di;var hi;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(hi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Hi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(Hi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var ji;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(ji=e.ExtensionKind||(e.ExtensionKind={}));class Vi{static validate(U){if(typeof U.badge=="string"){let te=(0,R.nextCharLength)(U.badge,0);if(te<U.badge.length&&(te+=(0,R.nextCharLength)(U.badge,te)),U.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Vt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,te,be){this.badge=U,this.tooltip=te,this.color=be}}e.FileDecoration=Vi;let fi=class{constructor(U){this.kind=U}};fi=qe([P],fi),e.ColorTheme=fi;var qi;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(qi=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(U){return U instanceof xt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("start must be positive");if(te<0)throw(0,T.illegalArgument)("end must be positive");U<=te?(this.c=U,this.e=te):(this.c=te,this.e=U)}with(U){let te=this.c,be=this.e;return U.start!==void 0&&(te=U.start),U.end!==void 0&&(be=U.end),te===this.c&&be===this.e?this:new xt(te,be)}}e.NotebookRange=xt;class mi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(te=>mi.isNotebookCellData(te))}static isNotebookCellData(U){return!0}constructor(U,te,be,Ke,Ye,ot,ut){this.kind=U,this.value=te,this.languageId=be,this.mime=Ke,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=ut,mi.validate(this)}}e.NotebookCellData=mi;class Ki{constructor(U){this.cells=U}}e.NotebookData=Ki;class zt{static isNotebookCellOutputItem(U){return U instanceof zt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const te={name:U.name,message:U.message,stack:U.stack};return zt.json(te,"application/vnd.code.notebook.error")}static stdout(U){return zt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return zt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,te="application/octet-stream"){return new zt(U,te)}static text(U,te=C.Mimes.text){const be=Oe(zt,v,"f",b).encode(String(U));return new zt(be,te)}static json(U,te="text/x-json"){const be=JSON.stringify(U,void 0,"	");return zt.text(be,te)}constructor(U,te){this.data=U,this.mime=te;const be=(0,C.normalizeMimeType)(te,!0);if(!be)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}}e.NotebookCellOutputItem=zt,v=zt,b={value:new TextEncoder};class gi{static isNotebookCellOutput(U){return U instanceof gi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,te=!1){const be=new Set,Ke=new Set;for(let Ye=0;Ye<U.length;Ye++){const ot=U[Ye],ut=(0,C.normalizeMimeType)(ot.mime);if(!be.has(ut)||(0,p.isTextStreamMime)(ut)){be.add(ut);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?U:U.filter((Ye,ot)=>!Ke.has(ot))}constructor(U,te,be){this.items=gi.ensureUniqueMimeTypes(U,!0),typeof te=="string"?(this.id=te,this.metadata=be):(this.id=(0,M.generateUuid)(),this.metadata=te??be)}}e.NotebookCellOutput=gi;var ie;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(ie=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(he=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Me;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Me=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var rt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(rt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class yt{constructor(U,te){this.text=U,this.alignment=te}}e.NotebookCellStatusBarItem=yt;var Pt;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(Pt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var on;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(on=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class an{constructor(U,te=[]){this.uri=U,this.provides=(0,t.asArray)(te)}}e.NotebookRendererScript=an;class cn{constructor(U){this.label=U}}e.NotebookKernelSourceAction=cn;let Gi=class{constructor(U,te){this.label=U,this.timestamp=te}};Gi=qe([P],Gi),e.TimelineItem=Gi;var un;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var ln;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(ln=e.ExtensionRuntime||(e.ExtensionRuntime={}));var dn;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(dn=e.StandardTokenType||(e.StandardTokenType={}));class hn{constructor(U,te){this.ranges=U,this.wordPattern=te}}e.LinkedEditingRanges=hn;class fn{constructor(U,te){this.c=U,this.e=te}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=fn;var mn;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(mn=e.TestResultState||(e.TestResultState={}));var gn;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(gn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xi=class{constructor(U=void 0,te=void 0,be=void 0){this.include=U,this.exclude=te,this.profile=be}};xi=qe([P],xi),e.TestRunRequest=xi;let Xi=O=class{static diff(U,te,be){const Ke=new O(U);return Ke.expectedOutput=te,Ke.actualOutput=be,Ke}constructor(U){this.message=U}};Xi=O=qe([P],Xi),e.TestMessage=Xi;let _i=class{constructor(U){this.id=U}};_i=qe([P],_i),e.TestTag=_i;let pi=class{constructor(U,te){this.covered=U,this.total=te}};pi=qe([P],pi),e.CoveredCount=pi;let Qi=F=class{static fromDetails(U,te){const be=new pi(0,0),Ke=new pi(0,0),Ye=new pi(0,0);for(const ut of te)if("branches"in ut){be.total+=1,be.covered+=ut.executionCount>0?1:0;for(const Rt of ut.branches)Ke.total+=1,Ke.covered+=Rt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ut.executionCount>0?1:0;const ot=new F(U,be,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=te,ot}constructor(U,te,be,Ke){this.uri=U,this.statementCoverage=te,this.branchCoverage=be,this.functionCoverage=Ke}};Qi=F=qe([P],Qi),e.FileCoverage=Qi;let Yi=class{constructor(U,te,be=[]){this.executionCount=U,this.location=te,this.branches=be}};Yi=qe([P],Yi),e.StatementCoverage=Yi;let Ji=class{constructor(U,te){this.executionCount=U,this.location=te}};Ji=qe([P],Ji),e.BranchCoverage=Ji;let Zi=class{constructor(U,te){this.executionCount=U,this.location=te}};Zi=qe([P],Zi),e.FunctionCoverage=Zi;var pn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(pn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bn;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(U,te,be,Ke,Ye,ot){this.kind=U,this.name=te,this.detail=be,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=En;class wn{constructor(U){this.uri=U}}e.TextTabInput=wn;class Sn{constructor(U,te){this.original=U,this.modified=te}}e.TextDiffTabInput=Sn;class yn{constructor(U,te,be,Ke){this.base=U,this.input1=te,this.input2=be,this.result=Ke}}e.TextMergeTabInput=yn;class Dn{constructor(U,te){this.uri=U,this.viewType=te}}e.CustomEditorTabInput=Dn;class In{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=In;class Cn{constructor(U,te){this.uri=U,this.notebookType=te}}e.NotebookEditorTabInput=Cn;class kn{constructor(U,te,be){this.original=U,this.modified=te,this.notebookType=be}}e.NotebookDiffEditorTabInput=kn;class Tn{constructor(){}}e.TerminalEditorTabInput=Tn;class Pn{constructor(U,te){this.uri=U,this.inputBoxUri=te}}e.InteractiveWindowInput=Pn}),define(Ce[97],ke([1,0,47,13,10,251,129,6,16]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function M(m,i){i?k.set(m,i):k.delete(m)}e.setWordDefinitionFor=M;function S(m){return k.get(m)}class f extends N.MirrorTextModel{constructor(i,r,l,v,b,E,w,s){super(r,l,v,b),this.m=i,this.p=E,this.q=w,this.notebook=s,this.b=!1}dispose(){(0,t.ok)(!this.b),this.b=!0,this.q=!1}equalLines(i){return(0,D.equals)(this.d,i)}get document(){if(!this.a){const i=this;this.a={get uri(){return i.c},get fileName(){return i.c.fsPath},get isUntitled(){return i.c.scheme===T.Schemas.untitled},get languageId(){return i.p},get version(){return i.g},get isClosed(){return i.b},get isDirty(){return i.q},save(){return i.r()},getText(r){return r?i.s(r):i.getText()},get eol(){return i.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return i.d.length},lineAt(r){return i.t(r)},offsetAt(r){return i.u(r)},positionAt(r){return i.v(r)},validateRange(r){return i.w(r)},validatePosition(r){return i.x(r)},getWordRangeAtPosition(r,l){return i.y(r,l)}}}return Object.freeze(this.a)}_acceptLanguageId(i){(0,t.ok)(!this.b),this.p=i}_acceptIsDirty(i){(0,t.ok)(!this.b),this.q=i}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(i){const r=this.w(i);if(r.isEmpty)return"";if(r.isSingleLine)return this.d[r.start.line].substring(r.start.character,r.end.character);const l=this.f,v=r.start.line,b=r.end.line,E=[];E.push(this.d[v].substring(r.start.character));for(let w=v+1;w<b;w++)E.push(this.d[w]);return E.push(this.d[b].substring(0,r.end.character)),E.join(l)}t(i){let r;if(i instanceof R.Position?r=i.line:typeof i=="number"&&(r=i),typeof r!="number"||r<0||r>=this.d.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new p(r,this.d[r],r===this.d.length-1)}u(i){return i=this.x(i),this.k(),this.h.getPrefixSum(i.line-1)+i.character}v(i){i=Math.floor(i),i=Math.max(0,i),this.k();const r=this.h.getIndexOf(i),l=this.d[r.index].length;return new R.Position(r.index,Math.min(r.remainder,l))}w(i){if(!(i instanceof R.Range))throw new Error("Invalid argument");const r=this.x(i.start),l=this.x(i.end);return r===i.start&&l===i.end?i:new R.Range(r.line,r.character,l.line,l.character)}x(i){if(!(i instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return i.with(0,0);let{line:r,character:l}=i,v=!1;if(r<0)r=0,l=0,v=!0;else if(r>=this.d.length)r=this.d.length-1,l=this.d[r].length,v=!0;else{const b=this.d[r].length;l<0?(l=0,v=!0):l>b&&(l=b,v=!0)}return v?new R.Position(r,l):i}y(i,r){const l=this.x(i);if(!r)r=S(this.p);else if((0,y.regExpLeadsToEndlessLoop)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const v=(0,C.getWordAtText)(l.character+1,(0,C.ensureValidWordDefinition)(r),this.d[l.line],0);if(v)return new R.Range(l.line,v.startColumn-1,l.line,v.endColumn-1)}}e.ExtHostDocumentData=f;class p{constructor(i,r,l){this.a=i,this.b=r,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=p}),define(Ce[186],ke([1,0,6,15,4]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(R){this.a=new t.ColorTheme(t.ColorThemeKind.Dark),this.b=new y.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let D;switch(R){case"light":D=t.ColorThemeKind.Light;break;case"hcDark":D=t.ColorThemeKind.HighContrast;break;case"hcLight":D=t.ColorThemeKind.HighContrastLight;break;default:D=t.ColorThemeKind.Dark}this.a=new t.ColorTheme(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};N=qe([je(0,T.IExtHostRpcService)],N),e.ExtHostTheming=N}),define(Ce[8],ke([1,0,16,24,113,187,83,28,110,82,62,23,9,2,55,72,88,94,93,67,43,54,182,6]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E,w,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ye){function Ae(X){const{selectionStartLineNumber:Re,selectionStartColumn:Ne,positionLineNumber:_e,positionColumn:ze}=X,Ze=new o.Position(Re-1,Ne-1),bt=new o.Position(_e-1,ze-1);return new o.Selection(Ze,bt)}ye.to=Ae;function fe(X){const{anchor:Re,active:Ne}=X;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}ye.from=fe})(a=e.Selection||(e.Selection={}));var d;(function(ye){function Ae(X){if(!X)return;const{start:Re,end:Ne}=X;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}ye.from=Ae;function fe(X){if(!X)return;const{startLineNumber:Re,startColumn:Ne,endLineNumber:_e,endColumn:ze}=X;return new o.Range(Re-1,Ne-1,_e-1,ze-1)}ye.to=fe})(d=e.Range||(e.Range={}));var c;(function(ye){function Ae(fe){switch(fe){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}ye.to=Ae})(c=e.TokenType||(e.TokenType={}));var u;(function(ye){function Ae(X){return new o.Position(X.lineNumber-1,X.column-1)}ye.to=Ae;function fe(X){return{lineNumber:X.line+1,column:X.character+1}}ye.from=fe})(u=e.Position||(e.Position={}));var n;(function(ye){function Ae(Re,Ne){return(0,t.coalesce)((0,t.asArray)(Re).map(_e=>fe(_e,Ne)))}ye.from=Ae;function fe(Re,Ne){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:X(Re.scheme,Ne),pattern:_.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function X(Re,Ne){return Ne&&typeof Re=="string"?Ne.transformOutgoingScheme(Re):Re}})(n=e.DocumentSelector||(e.DocumentSelector={}));var h;(function(ye){function Ae(X){switch(X){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}ye.from=Ae;function fe(X){switch(X){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}ye.to=fe})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(ye){function Ae(X){let Re;return X.code&&((0,f.isString)(X.code)||(0,f.isNumber)(X.code)?Re=String(X.code):Re={value:String(X.code.value),target:X.code.target}),{...d.from(X.range),message:X.message,source:X.source,code:Re,severity:L.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(A.from),tags:Array.isArray(X.tags)?(0,t.coalesce)(X.tags.map(h.from)):void 0}}ye.from=Ae;function fe(X){const Re=new o.Diagnostic(d.to(X),X.message,L.to(X.severity));return Re.source=X.source,Re.code=(0,f.isString)(X.code)?X.code:X.code?.value,Re.relatedInformation=X.relatedInformation&&X.relatedInformation.map(A.to),Re.tags=X.tags&&(0,t.coalesce)(X.tags.map(h.to)),Re}ye.to=fe})(g=e.Diagnostic||(e.Diagnostic={}));var A;(function(ye){function Ae(X){return{...d.from(X.location.range),message:X.message,resource:X.location.uri}}ye.from=Ae;function fe(X){return new o.DiagnosticRelatedInformation(new o.Location(X.resource,d.to(X)),X.message)}ye.to=fe})(A=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(ye){function Ae(X){switch(X){case o.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}ye.from=Ae;function fe(X){switch(X){case r.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}ye.to=fe})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var q;(function(ye){function Ae(X){return typeof X=="number"&&X>=o.ViewColumn.One?X-1:X===o.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}ye.from=Ae;function fe(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=fe})(q=e.ViewColumn||(e.ViewColumn={}));function Z(ye){return typeof ye.range<"u"}function x(ye){return ye.length===0?!0:!!Z(ye[0])}e.isDecorationOptionsArr=x;var O;(function(ye){function Ae(ze){return ze.map(ye.from)}ye.fromMany=Ae;function fe(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function X(ze){let Ze;if(fe(ze)){const{language:pt,value:It}=ze;Ze={value:"```"+pt+`
`+It+"\n```\n"}}else o.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const bt=Object.create(null);Ze.uris=bt;const vt=pt=>{try{let It=p.URI.parse(pt,!0);It=It.with({query:Re(It.query,bt)}),bt[pt]=It}catch{}return""},At=new D.marked.Renderer;return At.link=vt,At.image=pt=>typeof pt=="string"?vt(C.parseHrefAndDimensions(pt).href):"",(0,D.marked)(Ze.value,{renderer:At}),Ze}ye.from=X;function Re(ze,Ze){if(!ze)return ze;let bt;try{bt=(0,k.parse)(ze)}catch{}if(!bt)return ze;let vt=!1;return bt=(0,S.cloneAndChange)(bt,At=>{if(p.URI.isUri(At)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[pt]=At,vt=!0,pt}else return}),vt?JSON.stringify(bt):ze}function Ne(ze){const Ze=new o.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?p.URI.from(ze.baseUri):void 0,Ze}ye.to=Ne;function _e(ze){if(!!ze)return typeof ze=="string"?ze:ye.from(ze)}ye.fromStrict=_e})(O=e.MarkdownString||(e.MarkdownString={}));function F(ye){return x(ye)?ye.map(Ae=>({range:d.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?O.fromMany(Ae.hoverMessage):Ae.hoverMessage?O.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):ye.map(Ae=>({range:d.from(Ae)}))}e.fromRangeOrRangeWithMessage=F;function P(ye){return typeof ye>"u"?ye:typeof ye=="string"?p.URI.file(ye):ye}e.pathOrURIToURI=P;var B;(function(ye){function Ae(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?P(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ye.from=Ae})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var V;(function(ye){function Ae(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Ae})(V=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(ye){function Ae(fe){if(typeof fe>"u")return fe;switch(fe){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Ae})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ne;(function(ye){function Ae(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?z.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?V.from(fe.light):void 0,dark:fe.dark?V.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Ae})(ne=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var de;(function(ye){function Ae(X){return{text:X.newText,eol:X.newEol&&it.from(X.newEol),range:d.from(X.range)}}ye.from=Ae;function fe(X){const Re=new o.TextEdit(d.to(X.range),X.text);return Re.newEol=typeof X.eol>"u"?void 0:it.to(X.eol),Re}ye.to=fe})(de=e.TextEdit||(e.TextEdit={}));var we;(function(ye){function Ae(X,Re){const Ne={edits:[]};if(X instanceof o.WorkspaceEdit){const _e=new R.ResourceSet;for(const ze of X._allEntries())ze._type===1&&p.URI.isUri(ze.to)&&ze.from===void 0&&_e.add(ze.to);for(const ze of X._allEntries())ze._type===1?Ne.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Ne.edits.push({resource:ze.uri,textEdit:de.from(ze.edit),versionId:_e.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Ne.edits.push({resource:ze.uri,textEdit:{range:d.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:_e.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Ne.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Ne.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(wt.from)}})}return Ne}ye.from=Ae;function fe(X){const Re=new o.WorkspaceEdit;for(const Ne of X.edits)Ne.textEdit?Re.replace(p.URI.revive(Ne.resource),d.to(Ne.textEdit.range),Ne.textEdit.text):Re.renameFile(p.URI.revive(Ne.oldResource),p.URI.revive(Ne.newResource),Ne.options);return Re}ye.to=fe})(we=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(ye){const Ae=Object.create(null);Ae[o.SymbolKind.File]=0,Ae[o.SymbolKind.Module]=1,Ae[o.SymbolKind.Namespace]=2,Ae[o.SymbolKind.Package]=3,Ae[o.SymbolKind.Class]=4,Ae[o.SymbolKind.Method]=5,Ae[o.SymbolKind.Property]=6,Ae[o.SymbolKind.Field]=7,Ae[o.SymbolKind.Constructor]=8,Ae[o.SymbolKind.Enum]=9,Ae[o.SymbolKind.Interface]=10,Ae[o.SymbolKind.Function]=11,Ae[o.SymbolKind.Variable]=12,Ae[o.SymbolKind.Constant]=13,Ae[o.SymbolKind.String]=14,Ae[o.SymbolKind.Number]=15,Ae[o.SymbolKind.Boolean]=16,Ae[o.SymbolKind.Array]=17,Ae[o.SymbolKind.Object]=18,Ae[o.SymbolKind.Key]=19,Ae[o.SymbolKind.Null]=20,Ae[o.SymbolKind.EnumMember]=21,Ae[o.SymbolKind.Struct]=22,Ae[o.SymbolKind.Event]=23,Ae[o.SymbolKind.Operator]=24,Ae[o.SymbolKind.TypeParameter]=25;function fe(Re){return typeof Ae[Re]=="number"?Ae[Re]:6}ye.from=fe;function X(Re){for(const Ne in Ae)if(Ae[Ne]===Re)return Number(Ne);return o.SymbolKind.Property}ye.to=X})(ue=e.SymbolKind||(e.SymbolKind={}));var ae;(function(ye){function Ae(X){switch(X){case o.SymbolTag.Deprecated:return 1}}ye.from=Ae;function fe(X){switch(X){case 1:return o.SymbolTag.Deprecated}}ye.to=fe})(ae=e.SymbolTag||(e.SymbolTag={}));var Ie;(function(ye){function Ae(X){return{name:X.name,kind:ue.from(X.kind),tags:X.tags&&X.tags.map(ae.from),containerName:X.containerName,location:Te.from(X.location)}}ye.from=Ae;function fe(X){const Re=new o.SymbolInformation(X.name,ue.to(X.kind),X.containerName,Te.to(X.location));return Re.tags=X.tags&&X.tags.map(ae.to),Re}ye.to=fe})(Ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(ye){function Ae(X){const Re={name:X.name||"!!MISSING: name!!",detail:X.detail,range:d.from(X.range),selectionRange:d.from(X.selectionRange),kind:ue.from(X.kind),tags:X.tags?.map(ae.from)??[]};return X.children&&(Re.children=X.children.map(Ae)),Re}ye.from=Ae;function fe(X){const Re=new o.DocumentSymbol(X.name,X.detail,ue.to(X.kind),d.to(X.range),d.to(X.selectionRange));return(0,t.isNonEmptyArray)(X.tags)&&(Re.tags=X.tags.map(ae.to)),X.children&&(Re.children=X.children.map(fe)),Re}ye.to=fe})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var j;(function(ye){function Ae(X){const Re=new o.CallHierarchyItem(ue.to(X.kind),X.name,X.detail||"",p.URI.revive(X.uri),d.to(X.range),d.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}ye.to=Ae;function fe(X,Re,Ne){if(Re=Re??X._sessionId,Ne=Ne??X._itemId,Re===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ne,name:X.name,detail:X.detail,kind:ue.from(X.kind),uri:X.uri,range:d.from(X.range),selectionRange:d.from(X.selectionRange),tags:X.tags?.map(ae.from)}}ye.from=fe})(j=e.CallHierarchyItem||(e.CallHierarchyItem={}));var re;(function(ye){function Ae(fe){return new o.CallHierarchyIncomingCall(j.to(fe.from),fe.fromRanges.map(X=>d.to(X)))}ye.to=Ae})(re=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var me;(function(ye){function Ae(fe){return new o.CallHierarchyOutgoingCall(j.to(fe.to),fe.fromRanges.map(X=>d.to(X)))}ye.to=Ae})(me=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Te;(function(ye){function Ae(X){return{range:X.range&&d.from(X.range),uri:X.uri}}ye.from=Ae;function fe(X){return new o.Location(p.URI.revive(X.uri),d.to(X.range))}ye.to=fe})(Te=e.location||(e.location={}));var Be;(function(ye){function Ae(X){const Re=X,Ne=X;return{originSelectionRange:Re.originSelectionRange?d.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ne.uri,range:d.from(Re.targetRange?Re.targetRange:Ne.range),targetSelectionRange:Re.targetSelectionRange?d.from(Re.targetSelectionRange):void 0}}ye.from=Ae;function fe(X){return{targetUri:p.URI.revive(X.uri),targetRange:d.to(X.range),targetSelectionRange:X.targetSelectionRange?d.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?d.to(X.originSelectionRange):void 0}}ye.to=fe})(Be=e.DefinitionLink||(e.DefinitionLink={}));var Ge;(function(ye){function Ae(X){return{range:d.from(X.range),contents:O.fromMany(X.contents)}}ye.from=Ae;function fe(X){return new o.Hover(X.contents.map(O.to),d.to(X.range))}ye.to=fe})(Ge=e.Hover||(e.Hover={}));var Pe;(function(ye){function Ae(X){return{range:d.from(X.range),expression:X.expression}}ye.from=Ae;function fe(X){return new o.EvaluatableExpression(d.to(X.range),X.expression)}ye.to=fe})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var De;(function(ye){function Ae(X){if(X instanceof o.InlineValueText)return{type:"text",range:d.from(X.range),text:X.text};if(X instanceof o.InlineValueVariableLookup)return{type:"variable",range:d.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Ae;function fe(X){switch(X.type){case"text":return{range:d.to(X.range),text:X.text};case"variable":return{range:d.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:d.to(X.range),expression:X.expression}}}ye.to=fe})(De=e.InlineValue||(e.InlineValue={}));var Se;(function(ye){function Ae(X){return{frameId:X.frameId,stoppedLocation:d.from(X.stoppedLocation)}}ye.from=Ae;function fe(X){return new o.InlineValueContext(X.frameId,d.to(X.stoppedLocation))}ye.to=fe})(Se=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(ye){function Ae(X){return{range:d.from(X.range),kind:X.kind}}ye.from=Ae;function fe(X){return new o.DocumentHighlight(d.to(X.range),X.kind)}ye.to=fe})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(ye){function Ae(fe){switch(fe){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}ye.to=Ae})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(ye){function Ae(fe){return{triggerKind:ce.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ye.to=Ae})(Y=e.CompletionContext||(e.CompletionContext={}));var I;(function(ye){function Ae(X){switch(X){case o.CompletionItemTag.Deprecated:return 1}}ye.from=Ae;function fe(X){switch(X){case 1:return o.CompletionItemTag.Deprecated}}ye.to=fe})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(ye){const Ae=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function fe(Ne){return Ae.get(Ne)??9}ye.from=fe;const X=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Re(Ne){return X.get(Ne)??o.CompletionItemKind.Property}ye.to=Re})($=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(ye){function Ae(fe,X){const Re=new o.CompletionItem(fe.label);return Re.insertText=fe.insertText,Re.kind=$.to(fe.kind),Re.tags=fe.tags?.map(I.to),Re.detail=fe.detail,Re.documentation=C.isMarkdownString(fe.documentation)?O.to(fe.documentation):fe.documentation,Re.sortText=fe.sortText,Re.filterText=fe.filterText,Re.preselect=fe.preselect,Re.commitCharacters=fe.commitCharacters,m.Range.isIRange(fe.range)?Re.range=d.to(fe.range):typeof fe.range=="object"&&(Re.range={inserting:d.to(fe.range.insert),replacing:d.to(fe.range.replace)}),Re.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Re.insertText=new o.SnippetString(fe.insertText):(Re.insertText=fe.insertText,Re.textEdit=Re.range instanceof o.Range?new o.TextEdit(Re.range,Re.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Re.additionalTextEdits=fe.additionalTextEdits.map(Ne=>de.to(Ne))),Re.command=X&&fe.command?X.fromInternal(fe.command):void 0,Re}ye.to=Ae})(H=e.CompletionItem||(e.CompletionItem={}));var K;(function(ye){function Ae(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:O.fromStrict(X.documentation)}}ye.from=Ae;function fe(X){return{label:X.label,documentation:C.isMarkdownString(X.documentation)?O.to(X.documentation):X.documentation}}ye.to=fe})(K=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(ye){function Ae(X){return{label:X.label,documentation:O.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(K.from):[],activeParameter:X.activeParameter}}ye.from=Ae;function fe(X){return{label:X.label,documentation:C.isMarkdownString(X.documentation)?O.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(K.to):[],activeParameter:X.activeParameter}}ye.to=fe})(J=e.SignatureInformation||(e.SignatureInformation={}));var le;(function(ye){function Ae(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.from):[]}}ye.from=Ae;function fe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.to):[]}}ye.to=fe})(le=e.SignatureHelp||(e.SignatureHelp={}));var Ee;(function(ye){function Ae(fe,X){const Re=new o.InlayHint(u.to(X.position),typeof X.label=="string"?X.label:X.label.map(oe.to.bind(void 0,fe)),X.kind&&pe.to(X.kind));return Re.textEdits=X.textEdits&&X.textEdits.map(de.to),Re.tooltip=C.isMarkdownString(X.tooltip)?O.to(X.tooltip):X.tooltip,Re.paddingLeft=X.paddingLeft,Re.paddingRight=X.paddingRight,Re}ye.to=Ae})(Ee=e.InlayHint||(e.InlayHint={}));var oe;(function(ye){function Ae(fe,X){const Re=new o.InlayHintLabelPart(X.label);return Re.tooltip=C.isMarkdownString(X.tooltip)?O.to(X.tooltip):X.tooltip,i.Command.is(X.command)&&(Re.command=fe.fromInternal(X.command)),X.location&&(Re.location=Te.to(X.location)),Re}ye.to=Ae})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var pe;(function(ye){function Ae(X){return X}ye.from=Ae;function fe(X){return X}ye.to=fe})(pe=e.InlayHintKind||(e.InlayHintKind={}));var ve;(function(ye){function Ae(X){return{range:d.from(X.range),url:X.target,tooltip:X.tooltip}}ye.from=Ae;function fe(X){let Re;if(X.url)try{Re=typeof X.url=="string"?p.URI.parse(X.url,!0):p.URI.revive(X.url)}catch{}return new o.DocumentLink(d.to(X.range),Re)}ye.to=fe})(ve=e.DocumentLink||(e.DocumentLink={}));var We;(function(ye){function Ae(X){const Re=new o.ColorPresentation(X.label);return X.textEdit&&(Re.textEdit=de.to(X.textEdit)),X.additionalTextEdits&&(Re.additionalTextEdits=X.additionalTextEdits.map(Ne=>de.to(Ne))),Re}ye.to=Ae;function fe(X){return{label:X.label,textEdit:X.textEdit?de.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Re=>de.from(Re)):void 0}}ye.from=fe})(We=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(ye){function Ae(X){return new o.Color(X[0],X[1],X[2],X[3])}ye.to=Ae;function fe(X){return[X.red,X.green,X.blue,X.alpha]}ye.from=fe})(He=e.Color||(e.Color={}));var tt;(function(ye){function Ae(X){return{range:d.from(X.range)}}ye.from=Ae;function fe(X){return new o.SelectionRange(d.to(X.range))}ye.to=fe})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(ye){function Ae(fe){switch(fe){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}ye.to=Ae})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(ye){function Ae(X){switch(X){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Ae;function fe(X){switch(X){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}ye.to=fe})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(ye){function Ae(X){if(X===o.EndOfLine.CRLF)return 1;if(X===o.EndOfLine.LF)return 0}ye.from=Ae;function fe(X){if(X===1)return o.EndOfLine.CRLF;if(X===0)return o.EndOfLine.LF}ye.to=fe})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(ye){function Ae(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Ae})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(ye){function Ae(fe){const X={start:fe.start+1,end:fe.end+1};return fe.kind&&(X.kind=st.from(fe.kind)),X}ye.from=Ae})(Fe=e.FoldingRange||(e.FoldingRange={}));var st;(function(ye){function Ae(fe){if(fe)switch(fe){case o.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}ye.from=Ae})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(ye){function Ae(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?d.from(fe.selection):void 0,override:typeof fe.override=="boolean"?v.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Ae})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var _;(function(ye){function Ae(Ne){return Ne instanceof o.RelativePattern?Ne.toJSON():typeof Ne=="string"?Ne:fe(Ne)||X(Ne)?new o.RelativePattern(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}ye.from=Ae;function fe(Ne){const _e=Ne;return _e?p.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function X(Ne){const _e=Ne;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Re(Ne){return typeof Ne=="string"?Ne:new o.RelativePattern(p.URI.revive(Ne.baseUri),Ne.pattern)}ye.to=Re})(_=e.GlobPattern||(e.GlobPattern={}));var ge;(function(ye){function Ae(fe){if(fe){if(Array.isArray(fe))return fe.map(Ae);if(typeof fe=="string")return fe;{const X=fe;return{language:X.language,scheme:X.scheme,pattern:_.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}ye.from=Ae})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Le;(function(ye){function Ae(X){return{start:X.start,end:X.end}}ye.from=Ae;function fe(X){return new o.NotebookRange(X.start,X.end)}ye.to=fe})(Le=e.NotebookRange||(e.NotebookRange={}));var $e;(function(ye){function Ae(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}ye.to=Ae;function fe(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}ye.from=fe})($e=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ve;(function(ye){function Ae(fe){if(fe===b.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(fe===b.NotebookCellExecutionState.Pending)return;if(fe===b.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ye.to=Ae})(Ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Qe;(function(ye){function Ae(X){switch(X){case o.NotebookCellKind.Markup:return b.CellKind.Markup;case o.NotebookCellKind.Code:default:return b.CellKind.Code}}ye.from=Ae;function fe(X){switch(X){case b.CellKind.Markup:return o.NotebookCellKind.Markup;case b.CellKind.Code:default:return o.NotebookCellKind.Code}}ye.to=fe})(Qe=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(ye){function Ae(X){const Re={metadata:X.metadata??Object.create(null),cells:[]};for(const Ne of X.cells)o.NotebookCellData.validate(Ne),Re.cells.push(wt.from(Ne));return Re}ye.from=Ae;function fe(X){const Re=new o.NotebookData(X.cells.map(wt.to));return(0,f.isEmptyObject)(X.metadata)||(Re.metadata=X.metadata),Re}ye.to=fe})(nt=e.NotebookData||(e.NotebookData={}));var wt;(function(ye){function Ae(X){return{cellKind:Qe.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:$e.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ct.from):[]}}ye.from=Ae;function fe(X){return new o.NotebookCellData(Qe.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ct.to):void 0,X.metadata,X.internalMetadata?$e.to(X.internalMetadata):void 0)}ye.to=fe})(wt=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(ye){function Ae(X){return{mime:X.mime,valueBytes:T.VSBuffer.wrap(X.data)}}ye.from=Ae;function fe(X){return new o.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}ye.to=fe})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(ye){function Ae(X){return{outputId:X.id,items:X.items.map(St.from),metadata:X.metadata}}ye.from=Ae;function fe(X){const Re=X.items.map(St.to);return new o.NotebookCellOutput(Re,X.outputId,X.metadata)}ye.to=fe})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(ye){function Ae(Re){return X(Re)?{include:(0,f.withNullAsUndefined)(_.from(Re.include)),exclude:(0,f.withNullAsUndefined)(_.from(Re.exclude))}:(0,f.withNullAsUndefined)(_.from(Re))}ye.from=Ae;function fe(Re){return X(Re)?{include:_.to(Re.include),exclude:_.to(Re.exclude)}:_.to(Re)}ye.to=fe;function X(Re){const Ne=Re;return Ne?!(0,f.isUndefinedOrNull)(Ne.include)&&!(0,f.isUndefinedOrNull)(Ne.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(ye){function Ae(fe,X,Re){const Ne=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Ne,Re),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ye.from=Ae})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Bt;(function(ye){function Ae(fe,X,Re){const Ne=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:X.toInternal(Ne,Re),label:fe.label,description:fe.description,detail:fe.detail}}ye.from=Ae})(Bt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ot;(function(ye){function Ae(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ye.from=Ae})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(ye){function Ae(X){return{uri:X.uri,provides:X.provides}}ye.from=Ae;function fe(X){return new o.NotebookRendererScript(p.URI.revive(X.uri),X.provides)}ye.to=fe})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(ye){function Ae(X){return{message:O.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location&&{range:d.from(X.location.range),uri:X.location.uri}}}ye.from=Ae;function fe(X){const Re=new o.TestMessage(typeof X.message=="string"?X.message:O.to(X.message));return Re.actualOutput=X.actual,Re.expectedOutput=X.expected,Re.location=X.location?Te.to(X.location):void 0,Re}ye.to=fe})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(ye){ye.namespace=w.namespaceTestTag,ye.denamespace=w.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var $t;(function(ye){function Ae(X){const Re=(0,l.getPrivateApiFor)(X).controllerId;return{extId:E.TestId.fromExtHostTestItem(X,Re).toString(),label:X.label,uri:p.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(Ne=>Dt.namespace(Re,Ne.id)),range:m.Range.lift(d.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&O.fromStrict(X.error)||null}}ye.from=Ae;function fe(X){return{parent:void 0,error:void 0,id:E.TestId.fromString(X.extId).localId,label:X.label,uri:p.URI.revive(X.uri),tags:(X.tags||[]).map(Re=>{const{tagId:Ne}=Dt.denamespace(Re);return new o.TestTag(Ne)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}ye.toPlain=fe})($t=e.TestItem||(e.TestItem={})),function(ye){function Ae(X){return{id:X.id}}ye.from=Ae;function fe(X){return new o.TestTag(X.id)}ye.to=fe}(Dt=e.TestTag||(e.TestTag={}));var Mt;(function(ye){const Ae=(X,Re)=>{const Ne=[];for(const[ze,Ze]of Re)E.TestId.compare(Ze.item.extId,ze)===2&&(Re.delete(ze),Ne.push(Ze));const _e={...$t.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Ne.map(ze=>Ae(ze,Re))};for(const ze of _e.children)ze.parent=_e;return _e};function fe(X){const Re=[],Ne=new Map;for(const _e of X.items){Ne.set(_e.item.extId,_e);const ze=E.TestId.root(_e.item.extId);X.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(_e.item.extId))&&Re.push(_e)}return{completedAt:X.completedAt,results:Re.map(_e=>Ae(_e,Ne))}}ye.to=fe})(Mt=e.TestResults||(e.TestResults={}));var xe;(function(ye){function Ae(Ne){return{covered:Ne.covered,total:Ne.covered}}function fe(Ne){return"line"in Ne?u.from(Ne):d.from(Ne)}function X(Ne){return"branches"in Ne?{count:Ne.executionCount,location:fe(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(_e=>({count:_e.executionCount,location:_e.location&&fe(_e.location)})):void 0}:{type:0,count:Ne.executionCount,location:fe(Ne.location)}}ye.fromDetailed=X;function Re(Ne){return{uri:Ne.uri,statement:Ae(Ne.statementCoverage),branch:Ne.branchCoverage&&Ae(Ne.branchCoverage),function:Ne.functionCoverage&&Ae(Ne.functionCoverage),details:Ne.detailedCoverage?.map(X)}}ye.fromFile=Re})(xe=e.TestCoverage||(e.TestCoverage={}));var Lt;(function(ye){function Ae(fe){switch(fe){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}ye.to=Ae})(Lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(ye){function Ae(X){const Re=new o.TypeHierarchyItem(ue.to(X.kind),X.name,X.detail||"",p.URI.revive(X.uri),d.to(X.range),d.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}ye.to=Ae;function fe(X,Re,Ne){if(Re=Re??X._sessionId,Ne=Ne??X._itemId,Re===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ne,kind:ue.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:d.from(X.range),selectionRange:d.from(X.selectionRange),tags:X.tags?.map(ae.from)}}ye.from=fe})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(ye){function Ae(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}ye.from=Ae})(Ut=e.ViewBadge||(e.ViewBadge={}));var gt;(function(ye){function Ae(Ne,_e,ze){const Ze=_e.fileData;return Ze?new class extends o.DataTransferItem{asFile(){return{name:Ze.name,uri:p.URI.revive(Ze.uri),data:(0,N.once)(()=>ze())}}}("",_e.id):Ne===M.Mimes.uriList&&_e.uriListData?new o.DataTransferItem(Re(_e.uriListData)):new o.DataTransferItem(_e.asString)}ye.to=Ae;async function fe(Ne,_e){const ze=await _e.asString();if(Ne===M.Mimes.uriList)return{id:_e.id,asString:"",fileData:void 0,uriListData:X(ze)};const Ze=_e.asFile();return{id:_e.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=fe;function X(Ne){return y.UriList.split(Ne).map(_e=>{if(_e.startsWith("#"))return _e;try{return p.URI.parse(_e)}catch{}return _e})}function Re(Ne){return y.UriList.create(Ne.map(_e=>typeof _e=="string"?_e:p.URI.revive(_e)))}})(gt=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(ye){function Ae(X,Re){const Ne=X.items.map(([_e,ze])=>[_e,gt.to(_e,ze,()=>Re(ze.id))]);return new o.DataTransfer(Ne)}ye.toDataTransfer=Ae;async function fe(X){const Re={items:[]},Ne=[];return X.forEach((_e,ze)=>{Ne.push((async()=>{Re.items.push([ze,await gt.from(ze,_e)])})())}),await Promise.all(Ne),Re}ye.toDataTransferDTO=fe})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[188],ke([1,0,2,11,6,8,156]),function(ee,e,t,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(k,M,S,f={timeout:1500,errors:3}){this.c=k,this.d=M,this.f=S,this.g=f,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(M,S,f)=>{const m={dispose:this.a.push([M,S,k])};return Array.isArray(f)&&f.push(m),m}}async $participateInSave(k,M){const S=t.URI.revive(k);let f=!1;const p=setTimeout(()=>f=!0,this.g.timeout),m=[];try{for(const i of[...this.a]){if(f)break;const r=this.d.getDocument(S),l=await this.h(i,{document:r,reason:N.TextDocumentSaveReason.to(M)});m.push(l)}}finally{clearTimeout(p)}return m}h([k,M,S],f){const p=this.b.get(k);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(S,k,M,f).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const i=this.b.get(k);this.b.set(k,i?i+1:1),typeof i=="number"&&i>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,M,S,f){const p=[],m=Date.now(),{document:i,reason:r}=f,{version:l}=i,v=Object.freeze({document:i,reason:r,waitUntil(b){if(Object.isFrozen(p))throw(0,T.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(b))}});try{M.apply(S,[v])}catch(b){return Promise.reject(b)}return Object.freeze(p),new Promise((b,E)=>{const w=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(p).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(w),b(s)}).catch(s=>{clearTimeout(w),E(s)})}).then(b=>{const E={edits:[]};for(const w of b)if(Array.isArray(w)&&w.every(s=>s instanceof y.TextEdit))for(const{newText:s,newEol:o,range:a}of w)E.edits.push({resource:i.uri,versionId:void 0,textEdit:{range:a&&N.Range.from(a),text:s,eol:o&&N.EndOfLine.from(o)}});if(E.edits.length!==0)return l===i.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Ce[189],ke([1,0,13,2,8,6,67]),function(ee,e,t,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(S,f,p,m){this.start=S,this.deletedCount=f,this.deletedItems=p,this.items=m}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(S,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,f,p){this.notebook=S,this.h=f,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(y.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(y.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:y.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return S.g},set mime(m){S.g=m},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(p)}return this.f}setOutputs(S){this.a=S.map(y.NotebookCellOutput.to)}setOutputItems(S,f,p){const m=p.map(y.NotebookCellOutputItem.to),i=this.a.find(r=>r.id===S);if(i&&(f||(i.items.length=0),i.items.push(...m),i.items.length>1&&i.items.every(r=>C.isTextStreamMime(r.mime)))){const r=new Map,l=[];i.items.forEach(v=>{let b;r.has(v.mime)?b=r.get(v.mime):(b=[],r.set(v.mime,b),l.push(v.mime)),b.push(v.data)}),i.items.length=0,l.forEach(v=>{const b=C.compressOutputItemStreams(r.get(v));i.items.push({mime:v,data:b.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(y.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.ExtHostCell=D;class k{constructor(S,f,p,m,i){this.k=S,this.l=f,this.m=p,this.uri=m,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=i.viewType,this.f=Object.freeze(i.metadata??Object.create(null)),this.r([[0,0,i.cells]],!0,void 0),this.g=i.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const S=this,f={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===t.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(p){return p=S.n(p),S.b[p].apiCell},getCells(p){return(p?S.p(p):S.b).map(i=>i.apiCell)},save(){return S.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,f,p){this.g=S.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:p});const m={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},i=[];for(const l of S.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,m.contentChanges):l.kind===C.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,m.contentChanges):l.kind===C.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),i.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),i.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),i.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===C.NotebookCellsChangeType.ChangeCellContent?i.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),i.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),i.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const r=new Map;for(let l=0;l<i.length;l++){const v=i[l],b=r.get(v.cell);if(b===void 0){const E=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});r.set(v.cell,E-1)}else m.cellChanges[b]={...m.cellChanges[b],...v}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let f=S.start|0,p=S.end|0;return f<0&&(f=0),p>this.b.length&&(p=this.b.length),S.with({start:f,end:p})}p(S){S=this.o(S);const f=[];for(let p=S.start;p<S.end;p++)f.push(this.b[p]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,f,p){if(this.j)return;const m=[],i=[],r=[];if(S.reverse().forEach(l=>{const b=l[2].map(s=>{const o=new D(this,this.l,s);return f||i.push(D.asModelAddData(this.apiNotebook,s)),o}),E=new R(l[0],l[1],[],b),w=this.b.splice(l[0],l[1],...b);for(const s of w)r.push(s.uri),E.deletedItems.push(s.apiCell);m.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:i,removedDocuments:r}),p)for(const l of m)p.push(l.asApiEvent())}s(S,f,p,m){const i=this.b.splice(S,f);this.b.splice(p,0,...i);const r=[new R(S,f,i.map(l=>l.apiCell),[]),new R(p,0,[],i)];for(const l of r)m.push(l.asApiEvent())}t(S,f){this.b[S].setOutputs(f)}u(S,f,p,m){this.b[S].setOutputItems(f,p,m)}v(S,f){const p=this.b[S];p.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(p.uri,f)}w(S,f){const p=this.b[S];p.apiCell.mime=f}x(S,f){this.b[S].setMetadata(f)}y(S,f){this.b[S].setInternalMetadata(f)}getCellFromApiCell(S){return this.b.find(f=>f.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(f=>f.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.ExtHostNotebookDocument=k,k.a=0}),define(Ce[98],ke([1,0,11,8,6]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(R,D,k,M,S,f){this.id=R,this.f=D,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=M,this.c=f}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(D){this.selections=[D]},get selections(){return R.a},set selections(D){if(!Array.isArray(D)||!D.every(y.NotebookRange.isNotebookRange))throw(0,t.illegalArgument)("selections");R.a=D,R.g(D)},get visibleRanges(){return R.b},revealRange(D,k){R.f.$tryRevealRange(R.id,T.NotebookRange.from(D),k??y.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(T.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.ExtHostNotebookEditor=N,N.apiEditorsToExtHost=new WeakMap}),define(Ce[190],ke([1,0,4,12,8]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let N=class{constructor(R,D){this.c=R,this.d=D,this.a=new t.Emitter,this.b=new t.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,D){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,D);const k=this.d.getEditorById(R);D.visibleRanges&&k._acceptVisibleRanges(D.visibleRanges.ranges.map(y.NotebookRange.to)),D.selections&&k._acceptSelections(D.selections.selections.map(y.NotebookRange.to)),D.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),D.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const D in R)this.d.getEditorById(D)._acceptViewColumn(y.ViewColumn.to(R[D]))}};N=qe([je(0,T.ILogService)],N),e.ExtHostNotebookEditors=N}),define(Ce[191],ke([1,0,8,159,138,20,61,11]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,p,m){const i=this.b++,{title:r,location:l,cancellable:v}=p,b={label:(0,y.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(i,{location:t.ProgressLocation.from(l),title:r,source:b,cancellable:v},f.isUnderDevelopment?void 0:f.identifier.value).catch(R.onUnexpectedExternalError),this.d(i,m,!!v)}d(f,p,m){let i;m&&(i=new N.CancellationTokenSource,this.c.set(f,i));const r=v=>{this.a.$progressEnd(v),this.c.delete(v),i?.dispose()};let l;try{l=p(new M(this.a,f),m&&i?i.token:N.CancellationToken.None)}catch(v){throw r(f),v}return l.then(v=>r(f),v=>r(f)),l}$acceptProgressCanceled(f){const p=this.c.get(f);p&&(p.cancel(),this.c.delete(f))}}e.ExtHostProgress=D;function k(S,f){return S.message=f.message,typeof f.increment=="number"&&(typeof S.increment=="number"?S.increment+=f.increment:S.increment=f.increment),S}class M extends T.Progress{constructor(f,p){super(m=>this.throttledReport(m)),this.c=f,this.d=p}throttledReport(f){this.c.$progressReport(this.d,f)}}qe([(0,C.throttle)(100,(S,f)=>k(S,f),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(Ce[99],ke([1,0,55,94,43,68,54,8,2]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(b,E,w,s)=>{let o=E;return{enumerable:!0,configurable:!1,get(){return o},set(a){if(!w(o,a)){const d=o;o=a,b.listener?.(s(a,d))}}}},M=(b,E)=>b===E,S={range:(b,E)=>b===E?!0:!b||!E?!1:b.isEqual(E),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(b,E)=>!(b.length!==E.length||b.some(w=>!E.find(s=>w.id===s.id)))},f=b=>E=>({op:4,update:b(E)}),p=(b,E)=>({range:(()=>{let w;const s=f(o=>({range:t.Range.lift(R.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return w},set(o){b.listener?.({op:6}),S.range(w,o)||(w=o,b.listener?.(s(o)))}}})(),label:k(b,E,S.label,f(w=>({label:w}))),description:k(b,void 0,S.description,f(w=>({description:w}))),sortText:k(b,void 0,S.sortText,f(w=>({sortText:w}))),canResolveChildren:k(b,!1,S.canResolveChildren,w=>({op:2,state:w})),busy:k(b,!1,S.busy,f(w=>({busy:w}))),error:k(b,void 0,S.error,f(w=>({error:R.MarkdownString.fromStrict(w)||null}))),tags:k(b,[],S.tags,(w,s)=>({op:1,new:w.map(R.TestTag.from),old:s.map(R.TestTag.from)}))}),m=b=>{const E=y.TestId.fromString(b.extId),w=new r(E.controllerId,E.localId,b.label,D.URI.revive(b.uri)||void 0);return w.range=R.Range.to(b.range||void 0),w.description=b.description||void 0,w.sortText=b.sortText||void 0,w.tags=b.tags.map(s=>R.TestTag.to({id:(0,C.denamespaceTestTag)(s).tagId})),w},i=b=>{let E;for(const w of b.tests){const s=m(w.item);(0,T.getPrivateApiFor)(s).parent=E,E=s}return E};e.toItemFromContext=i;class r{constructor(E,w,s,o){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const a=(0,T.createPrivateApiFor)(this,E);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof l?void 0:a.parent}},children:{value:(0,N.createTestItemChildren)(a,T.getPrivateApiFor,r),enumerable:!0,writable:!1},...p(a,s)})}}e.TestItemImpl=r;class l extends r{constructor(E,w){super(E,E,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class v extends N.TestItemCollection{constructor(E,w,s){super({controllerId:E,getDocumentVersion:o=>o&&s.getDocument(o)?.version,getApiFor:T.getPrivateApiFor,getChildren:o=>o.children,root:new l(E,w),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ce[100],ke([1,0,47,11,81,8,6]),function(ee,e,t,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(f,p,m){const i=R.c.nextId();f.$registerTextEditorDecorationType(p.identifier,i,N.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:i,dispose(){f.$removeTextEditorDecorationType(i)}})}}e.TextEditorDecorationType=R,R.c=new y.IdGenerator("TextEditorDecorationType");class D{constructor(f,p){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,p){this.k();let m=null;if(f instanceof C.Position)m=new C.Range(f,f);else if(f instanceof C.Range)m=f;else throw new Error("Unrecognized location");this.l(m,p,!1)}insert(f,p){this.k(),this.l(new C.Range(f,f),p,!0)}delete(f){this.k();let p=null;if(f instanceof C.Range)p=f;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(f,p,m){const i=this.c.validateRange(f);this.g.push({range:i,text:p,forceMoveMarkers:m})}setEndOfLine(f){if(this.k(),f!==C.EndOfLine.LF&&f!==C.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this.h=f}}class k{constructor(f,p,m,i){this.c=f,this.d=p,this._accept(m),this.e=i;const r=this;this.value={get tabSize(){return r.f},set tabSize(l){r.m(l)},get indentSize(){return r.g},set indentSize(l){r.o(l)},get insertSpaces(){return r.h},set insertSpaces(l){r.q(l)},get cursorStyle(){return r.j},set cursorStyle(l){r.s(l)},get lineNumbers(){return r.k},set lineNumbers(l){r.t(l)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=N.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const p=Math.floor(f);return p>0?p:null}if(typeof f=="string"){const p=parseInt(f,10);return isNaN(p)?null:p>0?p:null}return null}m(f){const p=this.l(f);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const p=Math.floor(f);return p>0?p:null}if(typeof f=="string"){const p=parseInt(f,10);return isNaN(p)?null:p>0?p:null}return null}o(f){const p=this.n(f);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}q(f){const p=this.p(f);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(f)})))}assign(f){const p={};let m=!1;if(typeof f.tabSize<"u"){const i=this.l(f.tabSize);i==="auto"?(m=!0,p.tabSize=i):typeof i=="number"&&this.f!==i&&(this.f=i,m=!0,p.tabSize=i)}if(typeof f.indentSize<"u"){const i=this.n(f.indentSize);i==="tabSize"?(m=!0,p.indentSize=i):typeof i=="number"&&this.g!==i&&(this.g=i,m=!0,p.indentSize=i)}if(typeof f.insertSpaces<"u"){const i=this.p(f.insertSpaces);i==="auto"?(m=!0,p.insertSpaces=i):this.h!==i&&(this.h=i,m=!0,p.insertSpaces=i)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,m=!0,p.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,m=!0,p.lineNumbers=N.TextEditorLineNumbersStyle.from(f.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(f,p){p.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(m)})}}e.ExtHostTextEditorOptions=k;class M{constructor(f,p,m,i,r,l,v,b){this.id=f,this.j=p,this.k=m,this.g=!1,this.h=new Set,this.c=r,this.d=new k(this.j,this.id,l,m),this.e=v,this.f=b;const E=this;this.value=Object.freeze({get document(){return i.getValue()},set document(w){throw(0,T.readonly)("document")},get selection(){return E.c&&E.c[0]},set selection(w){if(!(w instanceof C.Selection))throw(0,T.illegalArgument)("selection");E.c=[w],E.l()},get selections(){return E.c},set selections(w){if(!Array.isArray(w)||w.some(s=>!(s instanceof C.Selection)))throw(0,T.illegalArgument)("selections");E.c=w,E.l()},get visibleRanges(){return E.e},set visibleRanges(w){throw(0,T.readonly)("visibleRanges")},get options(){return E.d.value},set options(w){E.g||E.d.assign(w)},get viewColumn(){return E.f},set viewColumn(w){throw(0,T.readonly)("viewColumn")},edit(w,s={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new D(i.getValue(),s);return w(o),E.m(o)},insertSnippet(w,s,o={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!s||Array.isArray(s)&&s.length===0)a=E.c.map(d=>N.Range.from(d));else if(s instanceof C.Position){const{lineNumber:d,column:c}=N.Position.from(s);a=[{startLineNumber:d,startColumn:c,endLineNumber:d,endColumn:c}]}else if(s instanceof C.Range)a=[N.Range.from(s)];else{a=[];for(const d of s)if(d instanceof C.Range)a.push(N.Range.from(d));else{const{lineNumber:c,column:u}=N.Position.from(d);a.push({startLineNumber:c,startColumn:u,endLineNumber:c,endColumn:u})}}return p.$tryInsertSnippet(f,i.getValue().version,w.value,a,o)},setDecorations(w,s){const o=s.length===0;o&&!E.h.has(w.key)||(o?E.h.delete(w.key):E.h.add(w.key),E.n(()=>{if(N.isDecorationOptionsArr(s))return p.$trySetDecorations(f,w.key,N.fromRangeOrRangeWithMessage(s));{const a=new Array(4*s.length);for(let d=0,c=s.length;d<c;d++){const u=s[d];a[4*d]=u.start.line+1,a[4*d+1]=u.start.character+1,a[4*d+2]=u.end.line+1,a[4*d+3]=u.end.character+1}return p.$trySetDecorationsFast(f,w.key,a)}}))},revealRange(w,s){E.n(()=>p.$tryRevealRange(f,N.Range.from(w),s||C.TextEditorRevealType.Default))},show(w){p.$tryShowEditor(f,N.ViewColumn.from(w))},hide(){p.$tryHideEditor(f)}})}dispose(){(0,t.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,t.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,t.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,t.ok)(!this.g),this.f=f}_acceptSelections(f){(0,t.ok)(!this.g),this.c=f}async l(){const f=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const p=f.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const m=p.edits.map(r=>r.range);m.sort((r,l)=>r.end.line===l.end.line?r.end.character===l.end.character?r.start.line===l.start.line?r.start.character-l.start.character:r.start.line-l.start.line:r.end.character-l.end.character:r.end.line-l.end.line);for(let r=0,l=m.length-1;r<l;r++){const v=m[r].end;if(m[r+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const i=p.edits.map(r=>({range:N.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,i,{setEndOfLine:typeof p.setEndOfLine=="number"?N.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.ExtHostTextEditor=M}),define(Ce[192],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[193],ke([1,0,149,11,29,87,90,30,25,192,158,151]),function(ee,e,t,T,y,N,C,R,D,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=R.Registry.as(C.Extensions.JSONContribution);class p{constructor(w,s,o){this.a=w,this.b=s,this.c=o}d(w,s){this.a({type:w,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(y.default.Error,w)}warn(w){this.d(y.default.Warning,w)}info(w){this.d(y.default.Info,w)}}e.ExtensionMessageCollector=p;class m{static a(w){const s=new Set;for(let o=0,a=w.length;o<a;o++)s.add(D.ExtensionIdentifier.toKey(w[o].description.identifier));return s}static compute(w,s){if(!w||!w.length)return new m(s,[]);if(!s||!s.length)return new m([],w);const o=this.a(w),a=this.a(s),d=s.filter(u=>!o.has(D.ExtensionIdentifier.toKey(u.description.identifier))),c=w.filter(u=>!a.has(D.ExtensionIdentifier.toKey(u.description.identifier)));return new m(d,c)}constructor(w,s){this.added=w,this.removed=s}}e.ExtensionPointUserDelta=m;class i{constructor(w,s){this.name=w,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=m.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,T.onUnexpectedError)(w)}}}e.ExtensionPoint=i;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[t.localize(0,null),t.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:t.localize(2,null),properties:{vscode:{type:"string",description:t.localize(3,null),default:"^1.22.0"}}},publisher:{description:t.localize(4,null),type:"string"},displayName:{description:t.localize(5,null),type:"string"},categories:{description:t.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:t.localize(7,null)}]}},galleryBanner:{type:"object",description:t.localize(8,null),properties:{color:{description:t.localize(9,null),type:"string"},theme:{description:t.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:t.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:t.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:t.localize(13,null)},enabledApiProposals:{markdownDescription:t.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:t.localize(15,null),type:"string",enum:["none"],enumDescriptions:[t.localize(16,null)]},activationEvents:{description:t.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:t.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:t.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:t.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:t.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:t.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:t.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:t.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:t.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:t.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:t.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:t.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:t.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:t.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:t.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:t.localize(32,null)},{label:"onUri",body:"onUri",description:t.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:t.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:t.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:t.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:t.localize(37,null)},{label:"onRenderer",description:t.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:t.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:t.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:t.localize(41,null)},{label:"*",description:t.localize(42,null),body:"*"}]}},badges:{type:"array",description:t.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:t.localize(44,null)},href:{type:"string",description:t.localize(45,null)},description:{type:"string",description:t.localize(46,null)}}}},markdown:{type:"string",description:t.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:t.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:t.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:t.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:t.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:t.localize(52,null)},{body:["workspace"],description:t.localize(53,null)},{body:["ui","workspace"],description:t.localize(54,null)},{body:["workspace","ui"],description:t.localize(55,null)},{body:[],description:t.localize(56,null)}]},capabilities:{description:t.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:t.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:t.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[t.localize(60,null),t.localize(61,null),t.localize(62,null)]},description:{type:"string",markdownDescription:t.localize(63,null)}}},untrustedWorkspaces:{description:t.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:t.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[t.localize(66,null),t.localize(67,null),t.localize(68,null)]},restrictedConfigurations:{description:t.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:t.localize(70,null)}}}}},sponsor:{description:t.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:t.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:t.localize(73,null),type:"string"},"vscode:uninstall":{description:t.localize(74,null),type:"string"}}},icon:{type:"string",description:t.localize(75,null)},l10n:{type:"string",description:t.localize(76,null)}}};class v{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const s=new i(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,s),w.activationEventsGenerator&&S.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,f.registerSchema(l,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=v;const b={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(b.ExtensionsRegistry,new v),e.ExtensionsRegistry=R.Registry.as(b.ExtensionsRegistry),f.registerSchema(l,e.schema),f.registerSchema(M.productSchemaId,{properties:{extensionEnabledApiProposals:{description:t.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[194],ke([1,0,146,9,23,193,42,4]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:t.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:t.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:t.localize(2,null),default:""}}};var k;(function(f){function p(m,i,r){if(!m)return;const l=T.isString(m.type)?m.type:void 0;if(!l||l.length===0){r.error(t.localize(3,null));return}const v=[];if(Array.isArray(m.required))for(const b of m.required)T.isString(b)&&v.push(b);return{extensionId:i.value,taskType:l,required:v,properties:m.properties?y.deepClone(m.properties):{},when:m.when?C.ContextKeyExpr.deserialize(m.when):void 0}}f.from=p})(k||(k={}));const M=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:t.localize(4,null),type:"array",items:D}});class S{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,m)=>{M.setHandler((i,r)=>{this.c=void 0;try{for(const l of r.removed){const v=l.value;for(const b of v)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const l of r.added){const v=l.value;for(const b of v){const E=k.from(b,l.description.identifier,l.collector);E&&(this.a[E.taskType]=E)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const m of this.all()){const i={type:"object",additionalProperties:!1};m.required.length>0&&(i.required=m.required.slice(0)),m.properties!==void 0?i.properties=y.deepClone(m.properties):i.properties=Object.create(null),i.properties.type={type:"string",enum:[m.taskType]},p.push(i)}this.c={oneOf:p}}return this.c}}e.TaskDefinitionRegistry=new S}),define(Ce[195],ke([1,0,147,9,22,23,42,194]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,t.localize(0,null)),e.TASKS_CATEGORY={value:t.localize(1,null),original:"Tasks"};var D;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(D=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(P){function B(V){if(!V)return P.Strong;switch(V.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=B}(D=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var M;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(M=e.RevealKind||(e.RevealKind={})),function(P){function B(V){switch(V.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=B}(M=e.RevealKind||(e.RevealKind={}));var S;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(S=e.RevealProblemKind||(e.RevealProblemKind={})),function(P){function B(V){switch(V.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=B}(S=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(P){function B(V){switch(V.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=B}(f=e.PanelKind||(e.PanelKind={}));var p;(function(P){P.defaults={echo:!0,reveal:M.Always,revealProblems:S.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(p=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(P){function B(z){switch(z.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=B;function V(z){switch(z){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=V}(m=e.RuntimeType||(e.RuntimeType={}));var i;(function(P){function B(V){return T.isString(V)?V:V.value}P.value=B})(i=e.CommandString||(e.CommandString={}));var r;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function B(z){return z===P.Clean._id||z===P.Build._id||z===P.Rebuild._id||z===P.Test._id}P.is=B;function V(z){if(z!==void 0)return T.isString(z)?B(z)?{_id:z,isDefault:!1}:void 0:z}P.from=V})(r=e.TaskGroup||(e.TaskGroup={}));var l;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var v;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function B(V){switch(V){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=B})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(P){P.parallel="parallel",P.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var E;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(E=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class s{constructor(B,V,z,ne,de,we){this._label="",this._id=B,V&&(this._label=V),z&&(this.type=z),this.runOptions=ne,this.configurationProperties=de,this._source=we}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,V=!1){if(B===void 0)return!1;if(T.isString(B))return B===this._label||B===this.configurationProperties.identifier||V&&B===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class o extends s{constructor(B,V,z,ne,de,we,ue,ae){super(B,z,void 0,ue,ae,V),this.command={},this._source=V,this.hasDefinedMatchers=we,de&&(this.command=de)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case m.Shell:V="shell";break;case m.Process:V="process";break;case m.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(B){return B instanceof o}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:V};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new o(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=o;class a extends s{constructor(B,V,z,ne,de,we,ue){super(B,z,ne,we,ue,V),this._source=V,this.configures=de}static is(B){return B instanceof a}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:V};return JSON.stringify(z)}}e.ConfiguringTask=a;class d extends s{constructor(B,V,z,ne,de,we,ue,ae,Ie){super(B,z,ne,ae,Ie,V),this.defines=de,this.hasDefinedMatchers=ue,this.command=we,this.icon=Ie.icon,this.hide=Ie.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof d}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new d(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=d;class c extends s{constructor(B,V,z,ne,de,we){super(B,z,ne,de,we,V),this._source=V}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new c(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=c;var u;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(P){P._default=P.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(B){this.c=new Map;for(let V=0;V<B.length;V++)this.c.set(B[V].uri.toString(),V)}compare(B,V){const z=B.getWorkspaceFolder(),ne=V.getWorkspaceFolder();if(z&&ne){let de=this.c.get(z.uri.toString());de=de===void 0?0:de+1;let we=this.c.get(ne.uri.toString());return we=we===void 0?0:we+1,de===we?B._label.localeCompare(V._label):de-we}else return!z&&ne?-1:z&&!ne?1:0}}e.TaskSorter=h;var g;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var A;(function(P){P.SingleRun="singleRun",P.Background="background"})(A=e.TaskRunType||(e.TaskRunType={}));var L;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var q;(function(P){function B(V,z,ne,de){if(z){const we={kind:V,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ne,__task:z};return V==="start"?we.resolvedVariables=de:V==="processStarted"?we.processId=de:V==="processEnded"&&(we.exitCode=de),Object.freeze(we)}else return Object.freeze({kind:"changed"})}P.create=B})(q=e.TaskEvent||(e.TaskEvent={}));var Z;(function(P){function B(z){const ne=Object.keys(z).sort();let de="";for(const we of ne){let ue=z[we];ue instanceof Object?ue=B(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),de+=we+","+ue+","}return de}function V(z){const de={_key:B(z),type:z.taskType};return Object.assign(de,z),de}P.create=V})(Z=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var O;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(O=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var F;(function(P){function B(V,z){const ne=R.TaskDefinitionRegistry.get(V.type);if(ne===void 0){const ae=N.deepClone(V);return delete ae._key,Z.create(ae)}const de=Object.create(null);de.type=ne.taskType;const we=new Set;ne.required.forEach(ae=>we.add(ae));const ue=ne.properties;for(const ae of Object.keys(ue)){const Ie=V[ae];if(Ie!=null)de[ae]=Ie;else if(we.has(ae)){const G=ue[ae];if(G.default!==void 0)de[ae]=N.deepClone(G.default);else switch(G.type){case"boolean":de[ae]=!1;break;case"number":case"integer":de[ae]=0;break;case"string":de[ae]="";break;default:z.error(t.localize(2,null,JSON.stringify(V,void 0,0),ae));return}}}return Z.create(de)}P.createTaskIdentifier=B})(F=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[196],ke([1,0,11]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,R)=>{this.b=C,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,t.onUnexpectedError)(C))}then(C,R){return this.j().then(C,R)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=T;class y extends T{constructor(){super(),this.h=!0,this.i=new t.CancellationError}}e.CanceledLazyPromise=y}),define(Ce[44],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class t{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++t.count}}e.ProxyIdentifier=t,t.count=0;const T=[];function y(R){const D=new t(R);return T[D.nid]=D,D}e.createProxyIdentifier=y;function N(R){return T[R].sid}e.getStringIdentifierForProxy=N;class C{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=C}),define(Ce[5],ke([1,0,44]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(i){i[i.UnknownInput=0]="UnknownInput",i[i.TextInput=1]="TextInput",i[i.TextDiffInput=2]="TextDiffInput",i[i.TextMergeInput=3]="TextMergeInput",i[i.NotebookInput=4]="NotebookInput",i[i.NotebookDiffInput=5]="NotebookDiffInput",i[i.CustomEditorInput=6]="CustomEditorInput",i[i.WebviewEditorInput=7]="WebviewEditorInput",i[i.TerminalEditorInput=8]="TerminalEditorInput",i[i.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var N;(function(i){i[i.TAB_OPEN=0]="TAB_OPEN",i[i.TAB_CLOSE=1]="TAB_CLOSE",i[i.TAB_UPDATE=2]="TAB_UPDATE",i[i.TAB_MOVE=3]="TAB_MOVE"})(N=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(i){i[i.Editable=0]="Editable",i[i.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(i){i[i.Int8Array=1]="Int8Array",i[i.Uint8Array=2]="Uint8Array",i[i.Uint8ClampedArray=3]="Uint8ClampedArray",i[i.Int16Array=4]="Int16Array",i[i.Uint16Array=5]="Uint16Array",i[i.Int32Array=6]="Int32Array",i[i.Uint32Array=7]="Uint32Array",i[i.Float32Array=8]="Float32Array",i[i.Float64Array=9]="Float64Array",i[i.BigInt64Array=10]="BigInt64Array",i[i.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(i){i[i.Text=1]="Text",i[i.Error=2]="Error",i[i.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var M;(function(i){i[i.None=0]="None",i[i.Process=1]="Process",i[i.Output=2]="Output"})(M=e.CandidatePortSource||(e.CandidatePortSource={}));class S{static mixin(r){return r._id=S.a++,r}}e.IdObject=S,S.a=0;var f;(function(i){i.label="a",i.kind="b",i.detail="c",i.documentation="d",i.sortText="e",i.filterText="f",i.preselect="g",i.insertText="h",i.insertTextRules="i",i.range="j",i.commitCharacters="k",i.additionalTextEdits="l",i.kindModifier="m",i.commandIdent="n",i.commandId="o",i.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(i){i.defaultRanges="a",i.completions="b",i.isIncomplete="c",i.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(i){i[i.Workspace=0]="Workspace",i[i.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,t.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,t.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,t.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,t.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,t.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,t.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,t.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,t.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,t.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,t.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,t.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,t.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,t.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,t.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,t.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,t.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,t.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,t.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,t.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,t.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,t.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,t.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,t.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,t.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,t.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,t.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,t.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,t.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,t.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,t.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,t.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,t.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,t.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,t.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,t.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,t.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,t.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,t.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,t.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,t.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,t.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,t.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,t.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,t.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,t.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,t.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,t.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,t.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,t.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,t.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,t.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,t.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,t.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,t.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,t.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,t.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,t.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,t.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,t.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,t.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,t.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,t.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,t.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,t.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,t.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,t.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,t.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,t.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,t.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,t.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,t.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,t.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,t.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,t.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,t.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,t.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,t.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,t.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,t.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,t.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,t.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,t.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,t.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,t.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,t.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,t.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,t.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,t.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,t.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,t.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,t.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,t.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,t.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,t.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,t.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,t.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,t.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,t.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,t.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,t.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,t.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,t.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,t.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,t.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,t.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,t.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,t.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,t.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,t.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,t.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,t.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[73],ke([1,0,3,12,5,15]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,t.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(D,k){this.c=k,this.a=new Set,this.b=D.getProxy(y.MainContext.MainThreadTelemetry)}report(D,k,M){const S=this.d(D,k);this.a.has(S)||(this.a.add(S),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}d(D,k){return`${D}-${k.identifier.value}`}};C=qe([je(0,N.IExtHostRpcService),je(1,T.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(R,D,k){}})}),define(Ce[197],ke([1,0,4,5,6,25]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(D){this.b=new Map,this.c=[],this.d=new t.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=D.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(D){return this.c=D,Promise.resolve()}async getSession(D,k,M,S={}){const f=N.ExtensionIdentifier.toKey(D.identifier),p=this.f.get(f)||[],m=[...M].sort().join(" ");let i=p.find(r=>r.providerId===k&&r.scopes===m);if(i)return i.result;{const r=this.g(D,f,k,M,S);i={providerId:k,scopes:m,result:r},p.push(i),this.f.set(f,p);try{await r}finally{const l=p.findIndex(v=>v.providerId===k&&v.scopes===m);l>-1&&(p.splice(l),this.f.set(f,p))}return r}}async g(D,k,M,S,f={}){await this.a.$ensureProvider(M);const p=D.displayName||D.name;return this.a.$getSession(M,S,k,p,f)}async removeSession(D,k){const M=this.b.get(D);return M?M.provider.removeSession(k):this.a.$removeSession(D,k)}registerAuthenticationProvider(D,k,M,S){if(this.b.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this.b.set(D,{label:k,provider:M,options:S??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===D)||this.c.push({id:D,label:k});const f=M.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(D,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(D,k,S?.supportsMultipleAccounts??!1),new y.Disposable(()=>{f.dispose(),this.b.delete(D);const p=this.c.findIndex(m=>m.id===D);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const M=this.b.get(D);if(M)return Promise.resolve(M.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const M=this.b.get(D);if(M)return Promise.resolve(M.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const M=this.b.get(D);if(M)return Promise.resolve(M.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this.d.fire({provider:{id:D,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ce[198],ke([1,0,5,15,8]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(R,D){this.a=R.getProxy(t.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>D.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,D,k){const M=y.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,k?.isRefactoring??!1)}};N=qe([je(0,T.IExtHostRpcService)],N),e.ExtHostBulkEdits=N}),define(Ce[199],ke([1,0,5]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(N){const C=N.getProxy(t.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(R){return C.$writeText(R)}})}}e.ExtHostClipboard=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[38],ke([1,0,9,6,8,23,5,16,12,82,55,252,2,7,3,15,99,24,44,39,74,50]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E,w){"use strict";var s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(g,A){s.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),Je(this,s,g.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=A,Je(this,o,g.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,L=>{const q=this.c.get(L);return q?.result===u.Void?q:void 0},A),this.f=[{processArgument(L){return(0,k.revive)(L)}},{processArgument(L){return(0,N.cloneAndChange)(L,function(q){if(M.Range.isIRange(q))return y.Range.to(q);if(S.Position.isIPosition(q))return y.Position.to(q);if(M.Range.isIRange(q.range)&&f.URI.isUri(q.uri))return y.location.to(q);if(q instanceof l.VSBuffer)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const A=this.registerCommand(!1,g.id,async(...L)=>{const q=g.args.map((x,O)=>{if(!x.validate(L[O]))throw new Error(`Invalid argument '${x.name}' when running '${g.id}', received: ${L[O]}`);return x.convert(L[O])}),Z=await this.executeCommand(g.internalId,...q);return g.result.convert(Z,L,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new T.Disposable(()=>{A.dispose(),this.c.delete(g.id)})}registerCommand(g,A,L,q,Z,x){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:L,thisArg:q,description:Z,extension:x}),g&&Oe(this,s,"f").$registerCommand(A),new T.Disposable(()=>{this.b.delete(A)&&g&&Oe(this,s,"f").$unregisterCommand(A)})}executeCommand(g,...A){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,A,!0)}async g(g,A,L){if(this.b.has(g))return Oe(this,s,"f").$fireCommandActivationEvent(g),this.h(g,A,!1);{let q=!1;const Z=(0,N.cloneAndChange)(A,function(x){if(x instanceof T.Position)return y.Position.from(x);if(x instanceof T.Range)return y.Range.from(x);if(x instanceof T.Location)return y.location.from(x);if(T.NotebookRange.isNotebookRange(x))return y.NotebookRange.from(x);if(x instanceof ArrayBuffer)return q=!0,l.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return q=!0,l.VSBuffer.wrap(x);if(x instanceof l.VSBuffer)return q=!0,x;if(!Array.isArray(x))return x});try{const x=await Oe(this,s,"f").$executeCommand(g,q?new v.SerializableObjectWithBuffers(Z):Z,L);return(0,k.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(g,A,!1);throw x}}}async h(g,A,L){const q=this.b.get(g);if(!q)throw new Error("Unknown command");const{callback:Z,thisArg:x,description:O}=q;if(O)for(let P=0;P<O.args.length;P++)try{(0,t.validateConstraint)(A[P],O.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${O.args[P].name}' - ${O.args[P].description}`)}const F=E.StopWatch.create();try{return await Z.apply(x,A)}catch(P){if(g===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...A);B&&(g=B.command)}throw this.d.error(P,g,q.extension?.identifier),L?new class extends Error{constructor(){super((0,b.toErrorMessage)(P)),this.id=g,this.source=q.extension?.displayName??q.extension?.name}}:P}finally{this.j(q,g,F.elapsed())}}j(g,A,L){!g.extension||Oe(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new w.TrustedTelemetryValue(A),duration:L})}$executeContributedCommand(g,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const L=this.b.get(g);return L?(A=A.map(q=>this.f.reduce((Z,x)=>x.processArgument(Z,L.extension?.identifier),q)),this.h(g,A,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),Oe(this,s,"f").$getCommands().then(A=>(g&&(A=A.filter(L=>L[0]!=="_")),A))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[A,L]of this.b){const{description:q}=L;q&&(g[A]=q)}return Promise.resolve(g)}};s=new WeakMap,o=new WeakMap,a=qe([je(0,i.IExtHostRpcService),je(1,D.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class d{constructor(g,A,L){this.d=g,this.f=A,this.g=L,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,A){if(!g)return;const L={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return L;const q=this.f(g.command);if(q)L.id=q.internalId,L.arguments=q.args.map((Z,x)=>Z.convert(g.arguments&&g.arguments[x]));else if((0,R.isNonEmptyArray)(g.arguments)){const Z=`${g.command}/${++this.c}`;this.b.set(Z,g),A.add((0,p.toDisposable)(()=>{this.b.delete(Z),this.g.trace("CommandsConverter#DISPOSE",Z)})),L.$ident=Z,L.id=this.delegatingCommandId,L.arguments=[Z],this.g.trace("CommandsConverter#CREATE",g.command,Z)}return L}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const A=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=d;class c{constructor(g,A,L,q){this.name=g,this.description=A,this.validate=L,this.convert=q}optional(){return new c(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,A){return new c(g??this.name,A??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",h=>f.URI.isUri(h),h=>h),c.Position=new c("position","A position in a text document",h=>T.Position.isPosition(h),y.Position.from),c.Range=new c("range","A range in a text document",h=>T.Range.isRange(h),y.Range.from),c.Selection=new c("selection","A selection in a text document",h=>T.Selection.isSelection(h),y.Selection.from),c.Number=new c("number","",h=>typeof h=="number",h=>h),c.String=new c("string","",h=>typeof h=="string",h=>h),c.CallHierarchyItem=new c("item","A call hierarchy item",h=>h instanceof T.CallHierarchyItem,y.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",h=>h instanceof T.TypeHierarchyItem,y.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",h=>h instanceof r.TestItemImpl,y.TestItem.from);class u{constructor(g,A){this.description=g,this.convert=A}}e.ApiCommandResult=u,u.Void=new u("no result",h=>h);class n{constructor(g,A,L,q,Z){this.id=g,this.internalId=A,this.description=L,this.args=q,this.result=Z}}e.ApiCommand=n}),define(Ce[200],ke([1,0,2,8,6,72,38,16,85,89,13]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(T.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,r)=>{if((0,R.isFalsyOrEmpty)(i))return;class l extends y.SymbolInformation{static to(b){const E=new l(b.name,T.SymbolKind.to(b.kind),b.containerName||"",new y.Location(r[0],T.Range.to(b.range)));return E.detail=b.detail,E.range=E.location.range,E.selectionRange=T.Range.to(b.selectionRange),E.children=b.children?b.children.map(l.to):[],E}}return i.map(l.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new C.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(T.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(T.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(T.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(r=>y.Position.isPosition(r)),i=>i.map(T.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(r=>{let l;for(const v of r.reverse())l=new y.SelectionRange(T.Range.to(v),l);return l}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(T.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",i=>i.map(T.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",i=>i.map(T.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",i=>i.map(T.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:T.Range.to(i.range),placeholder:i.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return T.WorkspaceEdit.to(i)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(T.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new y.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const r=(0,D.decodeSemanticTokensDto)(i);if(r.type==="full")return new y.SemanticTokens(r.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new y.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const r=(0,D.decodeSemanticTokensDto)(i);if(r.type==="full")return new y.SemanticTokens(r.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,r,l)=>{if(!i)return new y.CompletionList([]);const v=i.suggestions.map(b=>T.CompletionItem.to(b,l));return new y.CompletionList(v,i.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return T.SignatureHelp.to(i)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,r,l)=>p(v=>new y.CodeLens(T.Range.to(v.range),v.command&&l.fromInternal(v.command)))(i))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>y.Range.isRange(i),i=>y.Selection.isSelection(i)?T.Selection.from(i):T.Range.from(i)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,r,l)=>p(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const b=new y.CodeAction(v.title,v.kind?new y.CodeActionKind(v.kind):void 0);return v.edit&&(b.edit=T.WorkspaceEdit.to(v.edit)),v.command&&(b.command=l.fromInternal(v.command)),b.isPreferred=v.isPreferred,b}})(i))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(r=>new y.ColorInformation(T.Range.to(r.range),T.Color.to(r.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",i=>i instanceof y.Color,T.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:T.Range.from(i.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(T.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,r,l)=>i.map(T.InlayHint.to.bind(void 0,l)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(r=>T.NotebookExclusiveDocumentPattern.to(r))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(T.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",i=>t.URI.isUri(i)||typeof i=="string"&&(0,k.matchesSomeScheme)(i,M.Schemas.http,M.Schemas.https),i=>i),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[T.ViewColumn.from(i),void 0]:[T.ViewColumn.from(i.viewColumn),T.TextEditorOpenOptions.from(i)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[T.ViewColumn.from(i),void 0]:[T.ViewColumn.from(i.viewColumn),T.TextEditorOpenOptions.from(i)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[T.ViewColumn.from(i.viewColumn),T.TextEditorOpenOptions.from(i)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,i=>i)],C.ApiCommandResult.Void)];class f{static register(r){S.forEach(r.registerApiCommand,r)}}e.ExtHostApiCommands=f;function p(i){return r=>{if(Array.isArray(r))return r.map(i)}}function m(i){if(!Array.isArray(i))return;const r=[];for(const l of i)N.isLocationLink(l)?r.push(T.DefinitionLink.to(l)):r.push(T.location.to(l));return r}}),define(Ce[201],ke([1,0,14,61,4,7,2,72,25,8,6,26,5]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(m,i,r){const l=m.getProxy(f.MainContext.MainThreadComments);class v{constructor(){this.b=new Map,this.c=new Map,i.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const n=this.b.get(u.handle);return n?n.value:u}else if(u&&u.$mid===7){const n=this.b.get(u.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.commentThreadHandle);return h?h.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);return h?u.$mid===8?h.value:{thread:h.value,text:u.text}:u}else if(u&&u.$mid===10){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);if(!h)return u;const g=u.commentUniqueId,A=h.getCommentByUniqueId(g);return A||u}else if(u&&u.$mid===11){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);if(!h)return u;const g=u.text,A=u.commentUniqueId,L=h.getCommentByUniqueId(A);return L?(typeof L.body=="string"?L.body=g:L.body=new M.MarkdownString(g),L):u}return u}})}createCommentController(u,n,h){const g=v.a++,A=new E(u,g,n,h);this.b.set(A.handle,A);const L=this.c.get(D.ExtensionIdentifier.toKey(u.identifier))||[];return L.push(A),this.c.set(D.ExtensionIdentifier.toKey(u.identifier),L),A.value}$createCommentThreadTemplate(u,n,h){const g=this.b.get(u);!g||g.$createCommentThreadTemplate(n,h)}async $updateCommentThreadTemplate(u,n,h){const g=this.b.get(u);!g||g.$updateCommentThreadTemplate(n,h)}$deleteCommentThread(u,n){this.b.get(u)?.$deleteCommentThread(n)}$provideCommentingRanges(u,n,h){const g=this.b.get(u);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const A=r.getDocument(C.URI.revive(n));return(0,t.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(A,h)).then(L=>L?L.map(q=>k.Range.from(q)):void 0)}$toggleReaction(u,n,h,g,A){const L=this.b.get(u);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,t.asPromise)(()=>{const q=L.getCommentThread(n);if(q){const Z=q.getCommentByUniqueId(g.uniqueIdInThread);if(L!==void 0&&Z&&L.reactionHandler)return L.reactionHandler(Z,o(A))}return Promise.resolve(void 0)})}dispose(){}}v.a=0;class b{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(u){(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,n,h,g,A,L,q,Z){this.m=n,this.n=h,this.o=g,this.p=A,this.q=L,this.extensionDescription=q,this.r=Z,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new y.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.MutableDisposable,this.l.value=new N.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),l.$createCommentThread(n,this.handle,this.n,this.o,k.Range.from(this.p),q.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{l.$deleteCommentThread(n,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(O){x.range=O},get comments(){return x.comments},set comments(O){x.comments=O},get collapsibleState(){return x.collapsibleState},set collapsibleState(O){x.collapsibleState=O},get canReply(){return x.canReply},set canReply(O){x.canReply=O},get contextValue(){return x.contextValue},set contextValue(O){x.contextValue=O},get label(){return x.label},set label(O){x.label=O},get state(){return x.state},set state(O){x.state=O},dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.DisposableStore);const u=h=>Object.prototype.hasOwnProperty.call(this.b,h),n={};u("range")&&(n.range=k.Range.from(this.p)),u("label")&&(n.label=this.label),u("contextValue")&&(n.contextValue=this.contextValue??null),u("comments")&&(n.comments=this.q.map(h=>w(this,h,this.k))),u("collapsibleState")&&(n.collapseState=a(this.g)),u("canReply")&&(n.canReply=this.canReply),u("state")&&(n.state=d(this.h)),u("isTemplate")&&(n.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(u){for(const n of this.k){const h=n[0],g=n[1];if(u===g)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}b.a=0,qe([(0,T.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,n,h,g){this.f=u,this.g=n,this.h=h,this.i=g,this.a=new Map,l.$registerCommentController(this.handle,h,g);const A=this;this.value=Object.freeze({id:A.id,label:A.label,get options(){return A.options},set options(L){A.options=L},get commentingRangeProvider(){return A.commentingRangeProvider},set commentingRangeProvider(L){A.commentingRangeProvider=L},get reactionHandler(){return A.reactionHandler},set reactionHandler(L){A.reactionHandler=L},createCommentThread(L,q,Z){return A.createCommentThread(L,q,Z).value},dispose:()=>{A.dispose()}}),this.e=[],this.e.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(u,n,h,g){if(typeof u=="string"){const A=new b(this.id,this.handle,u,n,h,g,this.f,!1);return this.a.set(A.handle,A),A}else{const A=new b(this.id,this.handle,void 0,u,n,h,this.f,!1);return this.a.set(A.handle,A),A}}$createCommentThreadTemplate(u,n){const h=new b(this.id,this.handle,void 0,C.URI.revive(u),k.Range.to(n),[],this.f,!0);return h.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(h.handle,h),h}$updateCommentThreadTemplate(u,n){const h=this.a.get(u);h&&(h.range=k.Range.to(n))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function w(c,u,n){let h=n.get(u);h||(h=++c.commentHandle,n.set(u,h));const g=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:h,body:typeof u.body=="string"?u.body:k.MarkdownString.from(u.body),userName:u.author.name,userIconPath:g,label:u.label,commentReactions:u.reactions?u.reactions.map(A=>s(A)):void 0,timestamp:u.timestamp?.toJSON()}}function s(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function o(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function a(c){if(c!==void 0)switch(c){case M.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function d(c){if(c!==void 0)switch(c){case M.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new v}e.createExtHostComments=p}),define(Ce[202],ke([1,0,23,5,27,15]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(M,S){this.a=M.getProxy(T.MainContext.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(M,S){const f=this,p=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){f.e(M,S,p,arguments)}})}e(M,S,f,p){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:D(p,this.b)}),this.c&&this.f(M,f,p)}};C=qe([je(0,N.IExtHostRpcService),je(1,y.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const R=1e5;function D(k,M){const S=[];if(k.length)for(let f=0;f<k.length;f++){let p=k[f];if(typeof p>"u")p="undefined";else if(p instanceof Error){const m=p;m.stack?p=m.stack:p=m.toString()}S.push(p)}if(M){const f=new Error().stack;f&&S.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,t.safeStringify)(S);return f.length>R?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Ce[101],ke([1,0,2,5,6,3,15,12,16,10,19,26]),function(ee,e,t,T,y,N,C,R,D,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class Ni{constructor(m,i){this.h=i,this.f=new Map,this.g=m.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,i){const r=Ni.c++;this.f.set(r,{provider:m,extensionDescription:i}),this.g.$registerDecorationProvider(r,i.identifier.value);const l=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(r,null);return}const b=(0,D.asArray)(v);if(b.length<=Ni.d){this.g.$onDidChange(r,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",i.identifier.value,b.length);const E=b.map(o=>({uri:o,rank:(0,k.count)(o.path,"/")})),w=(0,D.groupBy)(E,(o,a)=>o.rank-a.rank||(0,k.compare)(o.uri.path,a.uri.path)),s=[];e:for(const o of w){let a;for(const d of o){const c=(0,M.dirname)(d.uri.path);if(a!==c&&(a=c,s.push(d.uri)>=Ni.d))break e}}this.g.$onDidChange(r,s)});return new y.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(m,i,r){if(!this.f.has(m))return Object.create(null);const l=Object.create(null),{provider:v,extensionDescription:b}=this.f.get(m);return await Promise.all(i.map(async E=>{try{const{uri:w,id:s}=E,o=await Promise.resolve(v.provideFileDecoration(t.URI.revive(w),r));if(!o)return;try{y.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,S.checkProposedApiEnabled)(b,"codiconDecoration"),l[s]=[o.propagate,o.tooltip,o.badge,o.color]}catch(a){this.h.warn(`INVALID decoration from extension '${b}': ${a}`)}}catch(w){this.h.error(w)}})),l}};f.c=0,f.d=250,f=qe([je(0,C.IExtHostRpcService),je(1,R.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[203],ke([1,0,136,88,2,5,6,8,4,12,28,37]),function(ee,e,t,T,y,N,C,R,D,k,M,S){"use strict";var f,p,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class i{constructor(v,b,E,w,s,o,a){this.d=v,this.e=b,this.f=E,this.g=w,f.set(this,void 0),p.set(this,void 0),m.set(this,void 0),this.c=!1,Je(this,m,new M.ResourceMap(d=>s.getComparisonKey(d)),"f"),Je(this,f,o,"f"),Je(this,p,a,"f")}dispose(){this.c||(Oe(this,p,"f").fire([...Oe(this,m,"f").keys()]),Oe(this,f,"f")?.$clear(this.e),Oe(this,m,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(v,b){if(!v){this.clear();return}this.h();let E=[];if(y.URI.isUri(v)){if(!b){this.delete(v);return}Oe(this,m,"f").set(v,b.slice()),E=[v]}else if(Array.isArray(v)){E=[];let s;v=[...v].sort(i.j);for(const o of v){const[a,d]=o;if((!s||a.toString()!==s.toString())&&(s&&Oe(this,m,"f").get(s).length===0&&Oe(this,m,"f").delete(s),s=a,E.push(a),Oe(this,m,"f").set(a,[])),d)Oe(this,m,"f").get(a)?.push(...d);else{const c=Oe(this,m,"f").get(a);c&&(c.length=0)}}}if(Oe(this,p,"f").fire(E),!Oe(this,f,"f"))return;const w=[];for(const s of E){let o=[];const a=Oe(this,m,"f").get(s);if(a)if(a.length>this.f){o=[];const d=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const u of a)if(u.severity===d[c]&&o.push({...R.Diagnostic.from(u),modelVersionId:this.g(s)})===this.f)break e;o.push({severity:T.MarkerSeverity.Info,message:(0,t.localize)(0,null,a.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=a.map(d=>({...R.Diagnostic.from(d),modelVersionId:this.g(s)}));w.push([s,o])}Oe(this,f,"f").$changeMany(this.e,w)}delete(v){this.h(),Oe(this,p,"f").fire([v]),Oe(this,m,"f").delete(v),Oe(this,f,"f")?.$changeMany(this.e,[[v,void 0]])}clear(){this.h(),Oe(this,p,"f").fire([...Oe(this,m,"f").keys()]),Oe(this,m,"f").clear(),Oe(this,f,"f")?.$clear(this.e)}forEach(v,b){this.h();for(const[E,w]of this)v.call(b,E,w,this)}*[(f=new WeakMap,p=new WeakMap,m=new WeakMap,Symbol.iterator)](){this.h();for(const v of Oe(this,m,"f").keys())yield[v,this.get(v)]}get(v){this.h();const b=Oe(this,m,"f").get(v);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(v){return this.h(),Array.isArray(Oe(this,m,"f").get(v))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(v,b){return v[0].toString()<b[0].toString()?-1:v[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=i;let r=class vi{static _mapper(v){const b=new M.ResourceMap;for(const E of v)b.set(E,E);return{uris:Object.freeze(Array.from(b.values()))}}constructor(v,b,E,w){this.h=b,this.j=E,this.k=w,this.f=new Map,this.g=new D.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.g.event,vi._mapper),this.e=v.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,b){const{f:E,e:w,g:s,h:o,j:a,k:d}=this,c=new class{$changeMany(h,g){w.$changeMany(h,g),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,h,g.length===0?"CLEARING":g)}$clear(h){w.$clear(h),o.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,h)}dispose(){w.dispose()}};let u;if(!b)b="_generated_diagnostic_collection_name_#"+vi.c++,u=b;else if(!E.has(b))u=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do u=b+vi.c++;while(E.has(u))}return new class extends i{constructor(){super(b,u,vi.d,h=>d.getDocument(h)?.version,a.extUri,c,s),E.set(u,this)}dispose(){super.dispose(),E.delete(u)}}}getDiagnostics(v){if(v)return this.l(v);{const b=new Map,E=[];for(const w of this.f.values())w.forEach((s,o)=>{let a=b.get(s.toString());typeof a>"u"&&(a=E.length,b.set(s.toString(),a),E.push([s,[]])),E[a][1]=E[a][1].concat(...o)});return E}}l(v){let b=[];for(const E of this.f.values())E.has(v)&&(b=b.concat(E.get(v)));return b}$acceptMarkersChange(v){if(!this.m){const b="_generated_mirror",E=new i(b,b,vi.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(b,E),this.m=E}for(const[b,E]of v)this.m.set(y.URI.revive(b),E.map(R.Diagnostic.to))}};r.c=0,r.d=1e3,r=qe([je(1,k.ILogService),je(2,S.IExtHostFileSystemInfo)],r),e.ExtHostDiagnostics=r}),define(Ce[204],ke([1,0,2,5]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this.a=C.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(R=>R?R.map(D=>t.URI.revive(D)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(R=>R?t.URI.revive(R):void 0)}}e.ExtHostDialogs=y}),define(Ce[205],ke([1,0,11,2,6,5,13,20,10]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(S,f,p){this.d=f,this.e=p,this.b=new Map,this.c=S.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,f){if(Object.keys(C.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const p=k.a++;this.b.set(p,f),this.c.$registerTextContentProvider(p,S);let m;return typeof f.onDidChange=="function"&&(m=f.onDidChange(i=>{if(i.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${i.scheme}' which will be IGNORED`);return}this.d.getDocument(i)&&this.$provideTextDocumentContent(p,i).then(r=>{if(!r&&typeof r!="string")return;const l=this.d.getDocument(i);if(!l)return;const v=(0,D.splitLines)(r);if(!l.equalLines(v))return this.c.$onVirtualDocumentChange(i,r)},t.onUnexpectedError)})),new y.Disposable(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(S,f){const p=this.b.get(S);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(f),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(Ce[206],ke([1,0,4,7,2,5,97,8,9,23,6]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(p,m){this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.DisposableStore,this.h=new Map,this.f=p.getProxy(N.MainContext.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(i=>{for(const r of i)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(i=>{for(const r of i)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const m=this.g.getDocument(p);if(m)return m}getDocument(p){const m=this.getDocumentData(p);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return m.document}ensureDocumentData(p){const m=this.g.getDocument(p);if(m)return Promise.resolve(m);let i=this.h.get(p.toString());return i||(i=this.f.$tryOpenDocument(p).then(r=>{this.h.delete(p.toString());const l=y.URI.revive(r);return(0,D.assertIsDefined)(this.g.getDocument(l))},r=>(this.h.delete(p.toString()),Promise.reject(r))),this.h.set(p.toString(),i)),i}createDocumentData(p){return this.f.$tryCreateDocument(p).then(m=>y.URI.revive(m))}$acceptModelLanguageChanged(p,m){const i=y.URI.revive(p),r=this.g.getDocument(i);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(m),this.a.fire(r.document)}$acceptModelSaved(p){const m=y.URI.revive(p),i=this.g.getDocument(m);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(i.document)}$acceptDirtyStateChanged(p,m){const i=y.URI.revive(p),r=this.g.getDocument(i);if(!r)throw new Error("unknown document");r._acceptIsDirty(m),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,m,i){const r=y.URI.revive(p),l=this.g.getDocument(r);if(!l)throw new Error("unknown document");l._acceptIsDirty(i),l.onEvents(m);let v;m.isUndoing?v=M.TextDocumentChangeReason.Undo:m.isRedoing&&(v=M.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:m.changes.map(b=>({range:R.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:v}))}setWordDefinitionFor(p,m){(0,C.setWordDefinitionFor)(p,m)}}e.ExtHostDocuments=S}),define(Ce[56],ke([1,0,47,4,7,2,3,5,97,15,100,8,12,28,13,176,207]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let v=class{constructor(E,w){this.h=E,this.i=w,this.a=null,this.b=new Map,this.c=new p.ResourceMap,this.d=new T.Emitter,this.e=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const w=[],s=[],o=[];if(E.removedDocuments)for(const a of E.removedDocuments){const d=N.URI.revive(a),c=this.c.get(d);c?.unref()&&(this.c.delete(d),w.push(c.value))}if(E.addedDocuments)for(const a of E.addedDocuments){const d=N.URI.revive(a.uri);let c=this.c.get(d);if(c&&d.scheme!==m.Schemas.vscodeNotebookCell&&d.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);c||(c=new l(new D.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(d,c),s.push(c.value)),c.ref()}if(E.removedEditors)for(const a of E.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&o.push(d)}if(E.addedEditors)for(const a of E.addedEditors){const d=N.URI.revive(a.documentUri);t.ok(this.c.has(d),`document '${d}' does not exist`),t.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(d).value,u=new M.ExtHostTextEditor(a.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new r.Lazy(()=>c.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(n=>S.Range.to(n)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,u)}E.newActiveEditor!==void 0&&(t.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,y.dispose)(w),(0,y.dispose)(o),E.removedDocuments&&this.e.fire(w),E.addedDocuments&&this.d.fire(s),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return i.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const w=this.b.get(this.a);return E?w:w?.value}allEditors(){return[...this.b.values()]}};v=qe([je(0,k.IExtHostRpcService),je(1,f.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[57],ke([1,0,8,5,2,4,3,6,15,9,80]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class S{constructor(r,l,v){this.e=v,this.d=l,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,l={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(y.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(y.URI.revive(this.b.input.base),y.URI.revive(this.b.input.input1),y.URI.revive(this.b.input.input2),y.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(y.URI.revive(this.b.input.uri),y.URI.revive(this.b.input.inputBoxUri));default:return}}}class f{constructor(r,l){this.c=[],this.d="",this.b=r,this.e=l;for(const v of r.tabs)v.isActive&&(this.d=v.id),this.c.push(new S(v,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,l={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return t.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(v=>v.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(v=>v.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const v=new S(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,v),r.tabDto.isActive&&(this.d=v.tabId),v}else if(r.kind===1){const v=this.c.splice(r.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return v.tabId===this.d&&(this.d=""),v}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this.c.splice(r.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,v),v}const l=this.c.find(v=>v.tabId===r.tabDto.id);if(!l)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(r.tabDto),l}activeTabId(){return this.d}}let p=class{constructor(r){this.b=new N.Emitter,this.c=new N.Emitter,this.e=[],this.a=r.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,l={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(v=>v.apiObject))},get activeTabGroup(){const v=r.d;return(0,k.assertIsDefined)(r.e.find(E=>E.groupId===v)?.apiObject)},close:async(v,b)=>{const E=Array.isArray(v)?v:[v];return E.length?m(E[0])?this.j(E,b):this.i(E,b):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(r){const l=new Set(this.e.map(a=>a.groupId)),v=new Set(r.map(a=>a.groupId)),b=(0,M.diffSets)(l,v),E=this.e.filter(a=>b.removed.includes(a.groupId)).map(a=>a.apiObject),w=[],s=[];this.e=r.map(a=>{const d=new f(a,()=>this.d);return b.added.includes(d.groupId)?w.push(d.apiObject):s.push(d.apiObject),d});const o=(0,k.assertIsDefined)(r.find(a=>a.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:w,closed:E,changed:s}))}$acceptTabGroupUpdate(r){const l=this.e.find(v=>v.groupId===r.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const l=this.e.find(b=>b.groupId===r.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const v=l.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}g(r){for(const l of this.e)for(const v of l.tabs)if(v.apiObject===r)return v}h(r){return this.e.find(l=>l.apiObject===r)}async i(r,l){const v=[];for(const b of r){const E=this.g(b);if(!E)throw new Error("Tab close: Invalid tab not found!");v.push(E.tabId)}return this.a.$closeTab(v,l)}async j(r,l){const v=[];for(const b of r){const E=this.h(b);if(!E)throw new Error("Group close: Invalid group not found!");v.push(E.groupId)}return this.a.$closeGroup(v,l)}};p=qe([je(0,D.IExtHostRpcService)],p),e.ExtHostEditorTabs=p;function m(i){return i.tabs!==void 0}}),define(Ce[208],ke([1,0,2,5,7,6,8,253,10,24,26]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class S{constructor(){this.a=[]}add(m){this.b=void 0,this.a.push(m)}delete(m){const i=this.a.indexOf(m);i>=0&&(this.a.splice(i,1),this.b=void 0)}c(){if(!this.b){const m=this.a.sort(),i=[];let r,l,v=14,b=14;for(const E of m){let w=r?(0,D.commonPrefixLength)(r,E):0;for(w===0?l=1:l=b;w<E.length;w++)w+1===E.length?(v=b,b=9):b+=1,i.push([l,E.toUpperCase().charCodeAt(w),b]),i.push([l,E.toLowerCase().charCodeAt(w),b]),l=b;r=E,b=v}i.push([9,58,10]),i.push([10,47,12]),this.b=new R.StateMachine(i)}}provideDocumentLinks(m){this.c();const i=[],r=R.LinkComputer.computeLinks({getLineContent(l){return m.lineAt(l-1).text},getLineCount(){return m.lineCount}},this.b);for(const l of r){const v=C.DocumentLink.to(l);v.target&&i.push(v)}return i}}class f{constructor(m,i){this.i=i,this.b=new S,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=m.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(m,i,r,l={}){if(this.d.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(m,"*",this.b));const v=this.h++;this.b.add(i),this.d.add(i),this.c.set(v,r);let b=2;l.isCaseSensitive&&(b+=1024),l.isReadonly&&(b+=2048),typeof r.copy=="function"&&(b+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,M.checkProposedApiEnabled)(m,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(v,i,b).catch(w=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${i}`),console.error(w)});const E=r.onDidChangeFile(w=>{const s=[];for(const o of w){const{uri:a,type:d}=o;if(a.scheme!==i)continue;let c;switch(d){case N.FileChangeType.Changed:c=0;break;case N.FileChangeType.Created:c=1;break;case N.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:a,type:c})}this.a.$onFileSystemChange(v,s)});return(0,y.toDisposable)(()=>{E.dispose(),this.b.delete(i),this.d.delete(i),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(m){const{type:i,ctime:r,mtime:l,size:v,permissions:b}=m;return{type:i,ctime:r,mtime:l,size:v,permissions:b}}$stat(m,i){return Promise.resolve(this.k(m).stat(t.URI.revive(i))).then(r=>f.j(r))}$readdir(m,i){return Promise.resolve(this.k(m).readDirectory(t.URI.revive(i)))}$readFile(m,i){return Promise.resolve(this.k(m).readFile(t.URI.revive(i))).then(r=>k.VSBuffer.wrap(r))}$writeFile(m,i,r,l){return Promise.resolve(this.k(m).writeFile(t.URI.revive(i),r.buffer,l))}$delete(m,i,r){return Promise.resolve(this.k(m).delete(t.URI.revive(i),r))}$rename(m,i,r,l){return Promise.resolve(this.k(m).rename(t.URI.revive(i),t.URI.revive(r),l))}$copy(m,i,r,l){const v=this.k(m);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(t.URI.revive(i),t.URI.revive(r),l))}$mkdir(m,i){return Promise.resolve(this.k(m).createDirectory(t.URI.revive(i)))}$watch(m,i,r,l){const v=this.k(m).watch(t.URI.revive(r),l);this.f.set(i,v)}$unwatch(m,i){const r=this.f.get(i);r&&(r.dispose(),this.f.delete(i))}$open(m,i,r){const l=this.k(m);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(t.URI.revive(i),r))}$close(m,i){const r=this.k(m);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(i))}$read(m,i,r,l){const v=this.k(m);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(l);return Promise.resolve(v.read(i,r,b.buffer,0,l)).then(E=>b.slice(0,E))}$write(m,i,r,l){const v=this.k(m);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(i,r,l.buffer,0,l.byteLength))}k(m){const i=this.c.get(m);if(!i){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return i}}e.ExtHostFileSystem=f}),define(Ce[58],ke([1,0,5,36,6,24,3,15,37,7]),function(ee,e,t,T,y,N,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let M=class Zt{constructor(f,p){this.b=new Map,this.a=f.getProxy(t.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(i){try{const r=m.b.get(i.scheme);if(!r)return await m.a.$stat(i);await m.a.$ensureActivation(i.scheme);const l=await r.stat(i);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(r){Zt.c(r)}},async readDirectory(i){try{const r=m.b.get(i.scheme);return r?(await m.a.$ensureActivation(i.scheme),(await r.readDirectory(i)).slice()):await m.a.$readdir(i)}catch(r){return Zt.c(r)}},async createDirectory(i){try{return await m.a.$mkdir(i)}catch(r){return Zt.c(r)}},async readFile(i){try{const r=m.b.get(i.scheme);return r?(await m.a.$ensureActivation(i.scheme),(await r.readFile(i)).slice()):(await m.a.$readFile(i)).buffer}catch(r){return Zt.c(r)}},async writeFile(i,r){try{return await m.a.$writeFile(i,N.VSBuffer.wrap(r))}catch(l){return Zt.c(l)}},async delete(i,r){try{const l=m.b.get(i.scheme);return l?(await m.a.$ensureActivation(i.scheme),await l.delete(i,{recursive:!1,...r})):await m.a.$delete(i,{recursive:!1,useTrash:!1,...r})}catch(l){return Zt.c(l)}},async rename(i,r,l){try{return await m.a.$rename(i,r,{overwrite:!1,...l})}catch(v){return Zt.c(v)}},async copy(i,r,l){try{return await m.a.$copy(i,r,{overwrite:!1,...l})}catch(v){return Zt.c(v)}},isWritableFileSystem(i){const r=p.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}static c(f){if(f instanceof y.FileSystemError)throw f;if(!(f instanceof Error))throw new y.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw y.FileSystemError.Unavailable(f.message);switch(f.name){case T.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(f.message);default:throw new y.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,p){return this.b.set(f,p),(0,k.toDisposable)(()=>this.b.delete(f))}};M=qe([je(0,R.IExtHostRpcService),je(1,D.IExtHostFileSystemInfo)],M),e.ExtHostConsumerFileSystem=M,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[209],ke([1,0,4,35,2,5,8,6]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(S,f,p,m,i,r,l,v){this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter;const b=this.h(S,p,i);this.g=0,r&&(this.g+=1),l&&(this.g+=2),v&&(this.g+=4);const E=(0,T.parse)(i),w=typeof i=="string",s=m(o=>{if(!r)for(const a of o.created){const d=y.URI.revive(a);E(d.fsPath)&&(!w||f.getWorkspaceFolder(d))&&this.a.fire(d)}if(!l)for(const a of o.changed){const d=y.URI.revive(a);E(d.fsPath)&&(!w||f.getWorkspaceFolder(d))&&this.b.fire(d)}if(!v)for(const a of o.deleted){const d=y.URI.revive(a);E(d.fsPath)&&(!w||f.getWorkspaceFolder(d))&&this.c.fire(d)}});this.d=R.Disposable.from(b,this.a,this.b,this.c,s)}h(S,f,p){const m=R.Disposable.from();if(typeof p=="string")return m;const i=S.getProxy(N.MainContext.MainThreadFileSystem);let r=!1;(p.pattern.includes(T.GLOBSTAR)||p.pattern.includes(T.GLOB_SPLIT))&&(r=!0);const l=Math.random();return i.$watch(f.identifier.value,l,p.baseUri,{recursive:r,excludes:[]}),R.Disposable.from({dispose:()=>i.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(S,f,p){this.j=S,this.k=f,this.l=p,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.g=new t.AsyncEmitter,this.h=new t.AsyncEmitter,this.i=new t.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,f,p,m,i,r){return new D(this.j,S,f,this.a.event,C.GlobPattern.from(p),m,i,r)}$onFileEvent(S){this.a.fire(S)}$onDidRunFileOperation(S,f){switch(S){case 2:this.b.fire(Object.freeze({files:f.map(p=>({oldUri:y.URI.revive(p.source),newUri:y.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(p=>y.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(p=>y.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,f){return(p,m,i)=>{const r=function(v){p.call(m,v)};return r.extension=S,f.event(r,void 0,i)}}async $onWillRunFileOperation(S,f,p,m){switch(S){case 2:return await this.n(this.g,{files:f.map(i=>({oldUri:y.URI.revive(i.source),newUri:y.URI.revive(i.target)}))},p,m);case 1:return await this.n(this.i,{files:f.map(i=>y.URI.revive(i.target))},p,m);case 0:case 3:return await this.n(this.h,{files:f.map(i=>y.URI.revive(i.target))},p,m)}}async n(S,f,p,m){const i=new Set,r=[];if(await S.fireAsync(f,m,async(v,b)=>{const E=Date.now(),w=await Promise.resolve(v);w instanceof R.WorkspaceEdit&&(r.push([b.extension,w]),i.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-E>p&&this.k.warn("SLOW file-participant",b.extension.identifier)}),m.isCancellationRequested||r.length===0)return;const l={edits:[]};for(const[,v]of r){const{edits:b}=C.WorkspaceEdit.from(v,{getTextDocumentVersion:E=>this.l.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(b)}return{edit:l,extensionNames:Array.from(i)}}}e.ExtHostFileSystemEventService=k}),define(Ce[210],ke([1,0,2,38]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,R,D,k,M){this.a=R,this.b=D,this.c=k;const S=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new T.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new T.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new T.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new T.ApiCommandResult("Notebook and input URI",f=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const p=this.a.getEditorById(f.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:t.URI.revive(f.notebookUri),inputUri:t.URI.revive(f.inputUri),notebookEditor:p.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:t.URI.revive(f.notebookUri),inputUri:t.URI.revive(f.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(C,R,D,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:D,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(t.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(Ce[211],ke([1,0,7,5]),function(ee,e,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this.b=0,this.a=C.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,C),(0,t.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=y}),define(Ce[212],ke([1,0,2,23,8,6,72,5,10,55,16,9,254,20,7,85,81,52,74,11,14,26]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(I,$){this.d=I,this.e=$}async provideDocumentSymbols(I,$){const H=this.d.getDocument(I),K=await this.e.provideDocumentSymbols(H,$);if(!(0,M.isFalsyOrEmpty)(K))return K[0]instanceof N.DocumentSymbol?K.map(y.DocumentSymbol.from):s.f(K)}static f(I){I=I.slice(0).sort((K,J)=>{let le=K.location.range.start.compareTo(J.location.range.start);return le===0&&(le=J.location.range.end.compareTo(K.location.range.end)),le});const $=[],H=[];for(const K of I){const J={name:K.name||"!!MISSING: name!!",kind:y.SymbolKind.from(K.kind),tags:K.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:y.Range.from(K.location.range),selectionRange:y.Range.from(K.location.range),children:[]};for(;;){if(H.length===0){H.push(J),$.push(J);break}const le=H[H.length-1];if(k.Range.containsRange(le.range,J.range)&&!k.Range.equalsRange(le.range,J.range)){le.children?.push(J),H.push(J);break}H.pop()}}return $}}class o{constructor(I,$,H){this.g=I,this.h=$,this.j=H,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,$){const H=this.g.getDocument(I),K=await this.j.provideCodeLenses(H,$);if(!K||$.isCancellationRequested)return;const J=this.e.add(K),le=new m.DisposableStore;this.f.set(J,le);const Ee={cacheId:J,lenses:[]};for(let oe=0;oe<K.length;oe++)Ee.lenses.push({cacheId:[J,oe],range:y.Range.from(K[oe].range),command:this.h.toInternal(K[oe].command,le)});return Ee}async resolveCodeLens(I,$){const H=I.cacheId&&this.e.get(...I.cacheId);if(!H)return;let K;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?K=H:K=await this.j.resolveCodeLens(H,$),K||(K=H),$.isCancellationRequested)return;const J=I.cacheId&&this.f.get(I.cacheId[0]);if(!!J)return I.command=this.h.toInternal(K.command??o.d,J),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}o.d={command:"missing",title:"!!MISSING: command!!"};function a(Y){return Array.isArray(Y)?Y.map(y.DefinitionLink.from):Y?[y.DefinitionLink.from(Y)]:[]}class d{constructor(I,$){this.d=I,this.e=$}async provideDefinition(I,$,H){const K=this.d.getDocument(I),J=y.Position.to($),le=await this.e.provideDefinition(K,J,H);return a(le)}}class c{constructor(I,$){this.d=I,this.e=$}async provideDeclaration(I,$,H){const K=this.d.getDocument(I),J=y.Position.to($),le=await this.e.provideDeclaration(K,J,H);return a(le)}}class u{constructor(I,$){this.d=I,this.e=$}async provideImplementation(I,$,H){const K=this.d.getDocument(I),J=y.Position.to($),le=await this.e.provideImplementation(K,J,H);return a(le)}}class n{constructor(I,$){this.d=I,this.e=$}async provideTypeDefinition(I,$,H){const K=this.d.getDocument(I),J=y.Position.to($),le=await this.e.provideTypeDefinition(K,J,H);return a(le)}}class h{constructor(I,$){this.d=I,this.e=$}async provideHover(I,$,H){const K=this.d.getDocument(I),J=y.Position.to($),le=await this.e.provideHover(K,J,H);if(!(!le||(0,M.isFalsyOrEmpty)(le.contents)))return le.range||(le.range=K.getWordRangeAtPosition(J)),le.range||(le.range=new N.Range(J,J)),y.Hover.from(le)}}class g{constructor(I,$){this.d=I,this.e=$}async provideEvaluatableExpression(I,$,H){const K=this.d.getDocument(I),J=y.Position.to($),le=await this.e.provideEvaluatableExpression(K,J,H);if(le)return y.EvaluatableExpression.from(le)}}class A{constructor(I,$){this.d=I,this.e=$}async provideInlineValues(I,$,H,K){const J=this.d.getDocument(I),le=await this.e.provideInlineValues(J,y.Range.to($),y.InlineValueContext.to(H),K);if(Array.isArray(le))return le.map(Ee=>y.InlineValue.from(Ee))}}class L{constructor(I,$){this.d=I,this.e=$}async provideDocumentHighlights(I,$,H){const K=this.d.getDocument(I),J=y.Position.to($),le=await this.e.provideDocumentHighlights(K,J,H);if(Array.isArray(le))return le.map(y.DocumentHighlight.from)}}class q{constructor(I,$){this.d=I,this.e=$}async provideLinkedEditingRanges(I,$,H){const K=this.d.getDocument(I),J=y.Position.to($),le=await this.e.provideLinkedEditingRanges(K,J,H);if(le&&Array.isArray(le.ranges))return{ranges:(0,M.coalesce)(le.ranges.map(y.Range.from)),wordPattern:le.wordPattern}}}class Z{constructor(I,$){this.d=I,this.e=$}async provideReferences(I,$,H,K){const J=this.d.getDocument(I),le=y.Position.to($),Ee=await this.e.provideReferences(J,le,H,K);if(Array.isArray(Ee))return Ee.map(y.location.from)}}class x{constructor(I,$,H,K,J,le,Ee){this.g=I,this.h=$,this.j=H,this.k=K,this.l=J,this.m=le,this.n=Ee,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,$,H,K){const J=this.g.getDocument(I),le=f.Selection.isISelection($)?y.Selection.to($):y.Range.to($),Ee=[];for(const tt of this.j.getDiagnostics(I))if(le.intersection(tt.range)&&Ee.push(tt)>x.d)break;const oe={diagnostics:Ee,only:H.only?new N.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},pe=await this.k.provideCodeActions(J,le,oe,K);if(!(0,M.isNonEmptyArray)(pe)||K.isCancellationRequested)return;const ve=this.e.add(pe),We=new m.DisposableStore;this.f.set(ve,We);const He=[];for(let tt=0;tt<pe.length;tt++){const Xe=pe[tt];!Xe||(x.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(oe.only&&(Xe.kind?oe.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[ve,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(y.Diagnostic.from),edit:Xe.edit&&y.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:ve,actions:He}}async resolveCodeAction(I,$){const[H,K]=I,J=this.e.get(H,K);if(!J||x.o(J)||!this.k.resolveCodeAction)return;const le=await this.k.resolveCodeAction(J,$)??J;return le?.edit?y.WorkspaceEdit.from(le.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}x.d=1e3;class O{constructor(I,$,H,K){this.d=I,this.e=$,this.f=H,this.g=K}async prepareDocumentPaste(I,$,H,K){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(I),le=$.map(oe=>y.Range.to(oe)),Ee=y.DataTransfer.toDataTransfer(H,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(J,le,Ee,K),y.DataTransfer.toDataTransferDTO(Ee)}async providePasteEdits(I,$,H,K,J){const le=this.e.getDocument($),Ee=H.map(ve=>y.Range.to(ve)),oe=y.DataTransfer.toDataTransfer(K,async ve=>(await this.d.$resolvePasteFileData(this.g,I,ve)).buffer),pe=await this.f.provideDocumentPasteEdits(le,Ee,oe,J);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?y.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class F{constructor(I,$){this.d=I,this.e=$}async provideDocumentFormattingEdits(I,$,H){const K=this.d.getDocument(I),J=await this.e.provideDocumentFormattingEdits(K,$,H);if(Array.isArray(J))return J.map(y.TextEdit.from)}}class P{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeFormattingEdits(I,$,H,K){const J=this.d.getDocument(I),le=y.Range.to($),Ee=await this.e.provideDocumentRangeFormattingEdits(J,le,H,K);if(Array.isArray(Ee))return Ee.map(y.TextEdit.from)}}class B{constructor(I,$){this.d=I,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,$,H,K,J){const le=this.d.getDocument(I),Ee=y.Position.to($),oe=await this.e.provideOnTypeFormattingEdits(le,Ee,H,K,J);if(Array.isArray(oe))return oe.map(y.TextEdit.from)}}class V{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,$){const H=await this.e.provideWorkspaceSymbols(I,$);if(!(0,M.isNonEmptyArray)(H))return{symbols:[]};const K=this.d.add(H),J={cacheId:K,symbols:[]};for(let le=0;le<H.length;le++){const Ee=H[le];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}J.symbols.push({...y.WorkspaceSymbol.from(Ee),cacheId:[K,le]})}return J}async resolveWorkspaceSymbol(I,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this.d.get(...I.cacheId);if(H){const K=await this.e.resolveWorkspaceSymbol(H,$);return K&&(0,T.mixin)(I,y.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class z{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideRenameEdits(I,$,H,K){const J=this.d.getDocument(I),le=y.Position.to($);try{const Ee=await this.e.provideRenameEdits(J,le,H,K);return Ee?y.WorkspaceEdit.from(Ee):void 0}catch(Ee){const oe=z.g(Ee);return oe?{rejectReason:oe,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(I,$,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(I),J=y.Position.to($);try{const le=await this.e.prepareRename(K,J,H);let Ee,oe;if(N.Range.isRange(le)?(Ee=le,oe=K.getText(le)):(0,S.isObject)(le)&&(Ee=le.range,oe=le.placeholder),!Ee||!oe)return;if(Ee.start.line>J.line||Ee.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(Ee),text:oe}}catch(le){const Ee=z.g(le);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(le)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class ne{constructor(I,$){this.resultId=I,this.tokens=$}}class de{constructor(I,$){this.f=I,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,$,H){const K=this.f.getDocument(I),J=$!==0?this.d.get($):null;let le=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,J.resultId,H):await this.g.provideDocumentSemanticTokens(K,H);return J&&this.d.delete($),le?(le=de.h(le),this.o(de.n(J,le),le)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return de.j(I)?de.k(I)?I:new N.SemanticTokens(new Uint32Array(I.data),I.resultId):de.l(I)?de.m(I)?I:new N.SemanticTokensEdits(I.edits.map($=>new N.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const $ of I.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(I,$){if(!de.j($)||!I||!I.tokens)return $;const H=I.tokens,K=H.length,J=$.data,le=J.length;let Ee=0;const oe=Math.min(K,le);for(;Ee<oe&&H[Ee]===J[Ee];)Ee++;if(Ee===K&&Ee===le)return new N.SemanticTokensEdits([],$.resultId);let pe=0;const ve=oe-Ee;for(;pe<ve&&H[K-pe-1]===J[le-pe-1];)pe++;return new N.SemanticTokensEdits([{start:Ee,deleteCount:K-Ee-pe,data:J.subarray(Ee,le-pe)}],$.resultId)}o(I,$){if(de.j(I)){const H=this.e++;return this.d.set(H,new ne(I.resultId,I.data)),(0,i.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(de.l(I)){const H=this.e++;return de.j($)?this.d.set(H,new ne($.resultId,$.data)):this.d.set(H,new ne(I.resultId)),(0,i.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class we{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeSemanticTokens(I,$,H){const K=this.d.getDocument(I),J=await this.e.provideDocumentRangeSemanticTokens(K,y.Range.to($),H);return J?this.f(J):null}f(I){return(0,i.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ue{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,$,H,K,J){this.f=I,this.g=$,this.h=H,this.j=K,this.k=J,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,$,H,K){const J=this.f.getDocument(I),le=y.Position.to($),Ee=J.getWordRangeAtPosition(le)||new N.Range(le,le),oe=Ee.with({end:le}),pe=new v.StopWatch(!0),ve=await this.h.provideCompletionItems(J,le,K,y.CompletionContext.to(H));if(!ve||K.isCancellationRequested)return;const We=Array.isArray(ve)?new N.CompletionList(ve):ve,He=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new m.DisposableStore;this.e.set(He,tt);const Xe=[],et={x:He,b:Xe,a:{replace:y.Range.from(Ee),insert:y.Range.from(oe)},c:We.isIncomplete||void 0,d:pe.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[He,it],oe,Ee);Xe.push(Fe)}return et}async resolveCompletionItem(I,$){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...I);if(!H)return;const K=await this.h.resolveCompletionItem(H,$);if(!!K)return this.l(K,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$,H,K){const J=this.e.get($[0]);if(!J)throw Error("DisposableStore is missing...");const le=this.g.toInternal(I.command,J),Ee={x:$,a:I.label,b:I.kind!==void 0?y.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(y.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:y.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(y.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=I.textEdit.newText):typeof I.insertText=="string"?Ee.h=I.insertText:I.insertText instanceof N.SnippetString&&(Ee.h=I.insertText.value,Ee.i|=4);let oe;return I.textEdit?oe=I.textEdit.range:I.range&&(oe=I.range),N.Range.isRange(oe)?Ee.j=y.Range.from(oe):oe&&(!H?.isEqual(oe.inserting)||!K?.isEqual(oe.replacing))&&(Ee.j={insert:y.Range.from(oe.inserting),replace:y.Range.from(oe.replacing)}),Ee}}class ae{async provideInlineCompletions(I,$,H,K){}disposeCompletions(I){}handleDidShowCompletionItem(I,$){}}class Ie extends ae{constructor(I,$,H,K){super(),this.f=I,this.g=$,this.h=H,this.j=K,this.d=new G,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,$,H,K){const J=this.g.getDocument(I),le=y.Position.to($),Ee=await this.h.provideInlineCompletionItems(J,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},K);if(!Ee||K.isCancellationRequested)return;const oe=Array.isArray(Ee)?Ee:Ee.items,pe=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[];let ve;return{pid:this.d.createReferenceId({dispose(){ve?.dispose()},items:oe}),items:oe.map((He,tt)=>{let Xe;He.command&&(ve||(ve=new m.DisposableStore),Xe=this.j.toInternal(He.command,ve));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?y.Range.from(He.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:pe.map(He=>(ve||(ve=new m.DisposableStore),this.j.toInternal(He,ve)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,$){const H=this.d.get(I)?.items[$];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const $=this.e++;return this.d.set($,I),$}disposeReferenceId(I){const $=this.d.get(I);return this.d.delete(I),$}get(I){return this.d.get(I)}}class j{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,$,H,K){const J=this.e.getDocument(I),le=y.Position.to($),Ee=this.g(H),oe=await this.f.provideSignatureHelp(J,le,K,Ee);if(oe){const pe=this.d.add([oe]);return{...y.SignatureHelp.from(oe),id:pe}}}g(I){let $;if(I.activeSignatureHelp){const H=y.SignatureHelp.to(I.activeSignatureHelp),K=this.d.get(I.activeSignatureHelp.id,0);K?($=K,$.activeSignature=H.activeSignature,$.activeParameter=H.activeParameter):$=H}return{...I,activeSignatureHelp:$}}releaseSignatureHelp(I){this.d.delete(I)}}class re{constructor(I,$,H,K,J){this.f=I,this.g=$,this.h=H,this.j=K,this.k=J,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,$,H){const K=this.f.getDocument(I),J=y.Range.to($),le=await this.h.provideInlayHints(K,J,H);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(H.isCancellationRequested)return;const Ee=this.d.add(le);this.e.set(Ee,new m.DisposableStore);const oe={hints:[],cacheId:Ee};for(let pe=0;pe<le.length;pe++)this.l(le[pe],J)&&oe.hints.push(this.m(le[pe],[Ee,pe]));return this.j.trace(`[InlayHints] ${oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),oe}async resolveInlayHint(I,$){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...I);if(!H)return;const K=await this.h.resolveInlayHint(H,$);if(!!K&&!!this.l(K))return this.m(K,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!($&&!$.contains(I.position))}m(I,$){const H=this.e.get($[0]);if(!H)throw Error("DisposableStore is missing...");const K={label:"",cacheId:$,tooltip:y.MarkdownString.fromStrict(I.tooltip),position:y.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(y.TextEdit.from),kind:I.kind&&y.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?K.label=I.label:K.label=I.label.map(J=>{const le={label:J.value};return le.tooltip=y.MarkdownString.fromStrict(J.tooltip),N.Location.isLocation(J.location)&&(le.location=y.location.from(J.location)),J.command&&(le.command=this.g.toInternal(J.command,H)),le}),K}}class me{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("DocumentLink")}async provideLinks(I,$){const H=this.e.getDocument(I),K=await this.f.provideDocumentLinks(H,$);if(!(!Array.isArray(K)||K.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(me.g).map(y.DocumentLink.from)};{const J=this.d.add(K),le={links:[],cacheId:J};for(let Ee=0;Ee<K.length;Ee++){if(!me.g(K[Ee]))continue;const oe=y.DocumentLink.from(K[Ee]);oe.cacheId=[J,Ee],le.links.push(oe)}return le}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,$){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...I);if(!H)return;const K=await this.f.resolveDocumentLink(H,$);if(!(!K||!me.g(K)))return y.DocumentLink.from(K)}releaseLinks(I){this.d.delete(I)}}class Te{constructor(I,$){this.d=I,this.e=$}async provideColors(I,$){const H=this.d.getDocument(I),K=await this.e.provideDocumentColors(H,$);return Array.isArray(K)?K.map(le=>({color:y.Color.from(le.color),range:y.Range.from(le.range)})):[]}async provideColorPresentations(I,$,H){const K=this.d.getDocument(I),J=y.Range.to($.range),le=y.Color.to($.color),Ee=await this.e.provideColorPresentations(le,{document:K,range:J},H);if(!!Array.isArray(Ee))return Ee.map(y.ColorPresentation.from)}}class Be{constructor(I,$){this.d=I,this.e=$}async provideFoldingRanges(I,$,H){const K=this.d.getDocument(I),J=await this.e.provideFoldingRanges(K,$,H);if(!!Array.isArray(J))return J.map(y.FoldingRange.from)}}class Ge{constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideSelectionRanges(I,$,H){const K=this.d.getDocument(I),J=$.map(y.Position.to),le=await this.e.provideSelectionRanges(K,J,H);if(!(0,M.isNonEmptyArray)(le))return[];if(le.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let oe=0;oe<J.length;oe++){const pe=[];Ee.push(pe);let ve=J[oe],We=le[oe];for(;;){if(!We.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(pe.push(y.SelectionRange.from(We)),!We.parent)break;ve=We.range,We=We.parent}}return Ee}}class Pe{constructor(I,$){this.f=I,this.g=$,this.d=new r.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const K=this.f.getDocument(I),J=y.Position.to($),le=await this.g.prepareCallHierarchy(K,J,H);if(!le)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(le)?le.map(oe=>this.h(Ee,oe)):[this.h(Ee,le)]}async provideCallsTo(I,$,H){const K=this.j(I,$);if(!K)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(K,H);if(!!J)return J.map(le=>({from:this.h(I,le.from),fromRanges:le.fromRanges.map(Ee=>y.Range.from(Ee))}))}async provideCallsFrom(I,$,H){const K=this.j(I,$);if(!K)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(K,H);if(!!J)return J.map(le=>({to:this.h(I,le.to),fromRanges:le.fromRanges.map(Ee=>y.Range.from(Ee))}))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),K=y.CallHierarchyItem.from($,I,H.size.toString(36));return H.set(K._itemId,$),K}j(I,$){return this.e.get(I)?.get($)}}class De{constructor(I,$){this.f=I,this.g=$,this.d=new r.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const K=this.f.getDocument(I),J=y.Position.to($),le=await this.g.prepareTypeHierarchy(K,J,H);if(!le)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(le)?le.map(oe=>this.h(Ee,oe)):[this.h(Ee,le)]}async provideSupertypes(I,$,H){const K=this.j(I,$);if(!K)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(K,H);if(!!J)return J.map(le=>this.h(I,le))}async provideSubtypes(I,$,H){const K=this.j(I,$);if(!K)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(K,H);if(!!J)return J.map(le=>this.h(I,le))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),K=y.TypeHierarchyItem.from($,I,H.size.toString(36));return H.set(K._itemId,$),K}j(I,$){return this.e.get(I)?.get($)}}class Se{constructor(I,$,H,K){this.d=I,this.e=$,this.f=H,this.g=K}async provideDocumentOnDropEdits(I,$,H,K,J){const le=this.e.getDocument($),Ee=y.Position.to(H),oe=y.DataTransfer.toDataTransfer(K,async ve=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,ve)).buffer),pe=await this.f.provideDocumentDropEdits(le,Ee,oe,J);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?y.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class se{constructor(I,$){this.adapter=I,this.extension=$}}class ce{constructor(I,$,H,K,J,le,Ee,oe){this.g=$,this.h=H,this.j=K,this.k=J,this.l=le,this.m=Ee,this.n=oe,this.f=new Map,this.e=I.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(I){return y.DocumentSelector.from(I,this.g)}p(I){return new N.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ce.d++}async s(I,$,H,K,J,le=!1){const Ee=this.f.get(I);if(!Ee||!(Ee.adapter instanceof $))return K;const oe=Date.now();le||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const pe=H(Ee.adapter,Ee.extension);return Promise.resolve(pe).catch(ve=>{(0,b.isCancellationError)(ve)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(ve),this.n.onExtensionError(Ee.extension.identifier,ve))}).finally(()=>{le||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-oe}ms`)}),p.CancellationToken.isCancellationToken(J)?(0,E.raceCancellationError)(pe,J):pe}t(I,$){const H=this.q();return this.f.set(H,new se(I,$)),H}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,$,H,K){const J=this.t(new s(this.h,H),I),le=K&&K.label||ce.u(I);return this.e.$registerDocumentSymbolProvider(J,this.o($),le),this.p(J)}$provideDocumentSymbols(I,$,H){return this.s(I,s,K=>K.provideDocumentSymbols(t.URI.revive($),H),void 0,H)}registerCodeLensProvider(I,$,H){const K=this.q(),J=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new se(new o(this.h,this.j.converter,H),I)),this.e.$registerCodeLensSupport(K,this.o($),J);let le=this.p(K);if(J!==void 0){const Ee=H.onDidChangeCodeLenses(oe=>this.e.$emitCodeLensEvent(J));le=N.Disposable.from(le,Ee)}return le}$provideCodeLenses(I,$,H){return this.s(I,o,K=>K.provideCodeLenses(t.URI.revive($),H),void 0,H)}$resolveCodeLens(I,$,H){return this.s(I,o,K=>K.resolveCodeLens($,H),void 0,void 0)}$releaseCodeLenses(I,$){this.s(I,o,H=>Promise.resolve(H.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(I,$,H){const K=this.t(new d(this.h,H),I);return this.e.$registerDefinitionSupport(K,this.o($)),this.p(K)}$provideDefinition(I,$,H,K){return this.s(I,d,J=>J.provideDefinition(t.URI.revive($),H,K),[],K)}registerDeclarationProvider(I,$,H){const K=this.t(new c(this.h,H),I);return this.e.$registerDeclarationSupport(K,this.o($)),this.p(K)}$provideDeclaration(I,$,H,K){return this.s(I,c,J=>J.provideDeclaration(t.URI.revive($),H,K),[],K)}registerImplementationProvider(I,$,H){const K=this.t(new u(this.h,H),I);return this.e.$registerImplementationSupport(K,this.o($)),this.p(K)}$provideImplementation(I,$,H,K){return this.s(I,u,J=>J.provideImplementation(t.URI.revive($),H,K),[],K)}registerTypeDefinitionProvider(I,$,H){const K=this.t(new n(this.h,H),I);return this.e.$registerTypeDefinitionSupport(K,this.o($)),this.p(K)}$provideTypeDefinition(I,$,H,K){return this.s(I,n,J=>J.provideTypeDefinition(t.URI.revive($),H,K),[],K)}registerHoverProvider(I,$,H,K){const J=this.t(new h(this.h,H),I);return this.e.$registerHoverProvider(J,this.o($)),this.p(J)}$provideHover(I,$,H,K){return this.s(I,h,J=>J.provideHover(t.URI.revive($),H,K),void 0,K)}registerEvaluatableExpressionProvider(I,$,H,K){const J=this.t(new g(this.h,H),I);return this.e.$registerEvaluatableExpressionProvider(J,this.o($)),this.p(J)}$provideEvaluatableExpression(I,$,H,K){return this.s(I,g,J=>J.provideEvaluatableExpression(t.URI.revive($),H,K),void 0,K)}registerInlineValuesProvider(I,$,H,K){const J=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new A(this.h,H),I);this.e.$registerInlineValuesProvider(le,this.o($),J);let Ee=this.p(le);if(J!==void 0){const oe=H.onDidChangeInlineValues(pe=>this.e.$emitInlineValuesEvent(J));Ee=N.Disposable.from(Ee,oe)}return Ee}$provideInlineValues(I,$,H,K,J){return this.s(I,A,le=>le.provideInlineValues(t.URI.revive($),H,K,J),void 0,J)}registerDocumentHighlightProvider(I,$,H){const K=this.t(new L(this.h,H),I);return this.e.$registerDocumentHighlightProvider(K,this.o($)),this.p(K)}$provideDocumentHighlights(I,$,H,K){return this.s(I,L,J=>J.provideDocumentHighlights(t.URI.revive($),H,K),void 0,K)}registerLinkedEditingRangeProvider(I,$,H){const K=this.t(new q(this.h,H),I);return this.e.$registerLinkedEditingRangeProvider(K,this.o($)),this.p(K)}$provideLinkedEditingRanges(I,$,H,K){return this.s(I,q,async J=>{const le=await J.provideLinkedEditingRanges(t.URI.revive($),H,K);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?ce.w(le.wordPattern):void 0}},void 0,K)}registerReferenceProvider(I,$,H){const K=this.t(new Z(this.h,H),I);return this.e.$registerReferenceSupport(K,this.o($)),this.p(K)}$provideReferences(I,$,H,K,J){return this.s(I,Z,le=>le.provideReferences(t.URI.revive($),H,K,J),void 0,J)}registerCodeActionProvider(I,$,H,K){const J=new m.DisposableStore,le=this.t(new x(this.h,this.j.converter,this.k,H,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(le,this.o($),{providedKinds:K?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:K?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,J)}))},ce.u(I),Boolean(H.resolveCodeAction)),J.add(this.p(le)),J}$provideCodeActions(I,$,H,K,J){return this.s(I,x,le=>le.provideCodeActions(t.URI.revive($),H,K,J),void 0,J)}$resolveCodeAction(I,$,H){return this.s(I,x,K=>K.resolveCodeAction($,H),void 0,void 0)}$releaseCodeActions(I,$){this.s(I,x,H=>Promise.resolve(H.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(I,$,H){const K=this.t(new F(this.h,H),I);return this.e.$registerDocumentFormattingSupport(K,this.o($),I.identifier,I.displayName||I.name),this.p(K)}$provideDocumentFormattingEdits(I,$,H,K){return this.s(I,F,J=>J.provideDocumentFormattingEdits(t.URI.revive($),H,K),void 0,K)}registerDocumentRangeFormattingEditProvider(I,$,H){const K=this.t(new P(this.h,H),I);return this.e.$registerRangeFormattingSupport(K,this.o($),I.identifier,I.displayName||I.name),this.p(K)}$provideDocumentRangeFormattingEdits(I,$,H,K,J){return this.s(I,P,le=>le.provideDocumentRangeFormattingEdits(t.URI.revive($),H,K,J),void 0,J)}registerOnTypeFormattingEditProvider(I,$,H,K){const J=this.t(new B(this.h,H),I);return this.e.$registerOnTypeFormattingSupport(J,this.o($),K,I.identifier),this.p(J)}$provideOnTypeFormattingEdits(I,$,H,K,J,le){return this.s(I,B,Ee=>Ee.provideOnTypeFormattingEdits(t.URI.revive($),H,K,J,le),void 0,le)}registerWorkspaceSymbolProvider(I,$){const H=this.t(new V($,this.l),I);return this.e.$registerNavigateTypeSupport(H,typeof $.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(I,$,H){return this.s(I,V,K=>K.provideWorkspaceSymbols($,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,$,H){return this.s(I,V,K=>K.resolveWorkspaceSymbol($,H),void 0,void 0)}$releaseWorkspaceSymbols(I,$){this.s(I,V,H=>H.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(I,$,H){const K=this.t(new z(this.h,H,this.l),I);return this.e.$registerRenameSupport(K,this.o($),z.supportsResolving(H)),this.p(K)}$provideRenameEdits(I,$,H,K,J){return this.s(I,z,le=>le.provideRenameEdits(t.URI.revive($),H,K,J),void 0,J)}$resolveRenameLocation(I,$,H,K){return this.s(I,z,J=>J.resolveRenameLocation(t.URI.revive($),H,K),void 0,K)}registerDocumentSemanticTokensProvider(I,$,H,K){const J=this.t(new de(this.h,H),I),le=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o($),K,le);let Ee=this.p(J);if(le){const oe=H.onDidChangeSemanticTokens(pe=>this.e.$emitDocumentSemanticTokensEvent(le));Ee=N.Disposable.from(Ee,oe)}return Ee}$provideDocumentSemanticTokens(I,$,H,K){return this.s(I,de,J=>J.provideDocumentSemanticTokens(t.URI.revive($),H,K),null,K)}$releaseDocumentSemanticTokens(I,$){this.s(I,de,H=>H.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,$,H,K){const J=this.t(new we(this.h,H),I);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o($),K),this.p(J)}$provideDocumentRangeSemanticTokens(I,$,H,K){return this.s(I,we,J=>J.provideDocumentRangeSemanticTokens(t.URI.revive($),H,K),null,K)}registerCompletionItemProvider(I,$,H,K){const J=this.t(new ue(this.h,this.j.converter,H,this.m,I),I);return this.e.$registerCompletionsProvider(J,this.o($),K,ue.supportsResolving(H),`${I.identifier.value}(${K.join("")})`),this.p(J)}$provideCompletionItems(I,$,H,K,J){return this.s(I,ue,le=>le.provideCompletionItems(t.URI.revive($),H,K,J),void 0,J)}$resolveCompletionItem(I,$,H){return this.s(I,ue,K=>K.resolveCompletionItem($,H),void 0,H)}$releaseCompletionItems(I,$){this.s(I,ue,H=>H.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(I,$,H){const K=new Ie(I,this.h,H,this.j.converter),J=this.t(K,I);return this.e.$registerInlineCompletionsSupport(J,this.o($),K.supportsHandleDidShowCompletionItem),this.p(J)}$provideInlineCompletions(I,$,H,K,J){return this.s(I,ae,le=>le.provideInlineCompletions(t.URI.revive($),H,K,J),void 0,J)}$handleInlineCompletionDidShow(I,$,H){this.s(I,ae,async K=>{K.handleDidShowCompletionItem($,H)},void 0,void 0)}$freeInlineCompletionsList(I,$){this.s(I,ae,async H=>{H.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(I,$,H,K){const J=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,le=this.t(new j(this.h,H),I);return this.e.$registerSignatureHelpProvider(le,this.o($),J),this.p(le)}$provideSignatureHelp(I,$,H,K,J){return this.s(I,j,le=>le.provideSignatureHelp(t.URI.revive($),H,K,J),void 0,J)}$releaseSignatureHelp(I,$){this.s(I,j,H=>H.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(I,$,H){const K=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,J=this.t(new re(this.h,this.j.converter,H,this.l,I),I);this.e.$registerInlayHintsProvider(J,this.o($),typeof H.resolveInlayHint=="function",K,ce.u(I));let le=this.p(J);if(K!==void 0){const Ee=H.onDidChangeInlayHints(oe=>this.e.$emitInlayHintsEvent(K));le=N.Disposable.from(le,Ee)}return le}$provideInlayHints(I,$,H,K){return this.s(I,re,J=>J.provideInlayHints(t.URI.revive($),H,K),void 0,K)}$resolveInlayHint(I,$,H){return this.s(I,re,K=>K.resolveInlayHint($,H),void 0,H)}$releaseInlayHints(I,$){this.s(I,re,H=>H.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(I,$,H){const K=this.t(new me(this.h,H),I);return this.e.$registerDocumentLinkProvider(K,this.o($),typeof H.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(I,$,H){return this.s(I,me,K=>K.provideLinks(t.URI.revive($),H),void 0,H,$.scheme==="output")}$resolveDocumentLink(I,$,H){return this.s(I,me,K=>K.resolveLink($,H),void 0,void 0,!0)}$releaseDocumentLinks(I,$){this.s(I,me,H=>H.releaseLinks($),void 0,void 0,!0)}registerColorProvider(I,$,H){const K=this.t(new Te(this.h,H),I);return this.e.$registerDocumentColorProvider(K,this.o($)),this.p(K)}$provideDocumentColors(I,$,H){return this.s(I,Te,K=>K.provideColors(t.URI.revive($),H),[],H)}$provideColorPresentations(I,$,H,K){return this.s(I,Te,J=>J.provideColorPresentations(t.URI.revive($),H,K),void 0,K)}registerFoldingRangeProvider(I,$,H){const K=this.q(),J=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new se(new Be(this.h,H),I)),this.e.$registerFoldingRangeProvider(K,this.o($),I.identifier,J);let le=this.p(K);if(J!==void 0){const Ee=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));le=N.Disposable.from(le,Ee)}return le}$provideFoldingRanges(I,$,H,K){return this.s(I,Be,J=>J.provideFoldingRanges(t.URI.revive($),H,K),void 0,K)}registerSelectionRangeProvider(I,$,H){const K=this.t(new Ge(this.h,H,this.l),I);return this.e.$registerSelectionRangeProvider(K,this.o($)),this.p(K)}$provideSelectionRanges(I,$,H,K){return this.s(I,Ge,J=>J.provideSelectionRanges(t.URI.revive($),H,K),[],K)}registerCallHierarchyProvider(I,$,H){const K=this.t(new Pe(this.h,H),I);return this.e.$registerCallHierarchyProvider(K,this.o($)),this.p(K)}$prepareCallHierarchy(I,$,H,K){return this.s(I,Pe,J=>Promise.resolve(J.prepareSession(t.URI.revive($),H,K)),void 0,K)}$provideCallHierarchyIncomingCalls(I,$,H,K){return this.s(I,Pe,J=>J.provideCallsTo($,H,K),void 0,K)}$provideCallHierarchyOutgoingCalls(I,$,H,K){return this.s(I,Pe,J=>J.provideCallsFrom($,H,K),void 0,K)}$releaseCallHierarchy(I,$){this.s(I,Pe,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(I,$,H){const K=this.t(new De(this.h,H),I);return this.e.$registerTypeHierarchyProvider(K,this.o($)),this.p(K)}$prepareTypeHierarchy(I,$,H,K){return this.s(I,De,J=>Promise.resolve(J.prepareSession(t.URI.revive($),H,K)),void 0,K)}$provideTypeHierarchySupertypes(I,$,H,K){return this.s(I,De,J=>J.provideSupertypes($,H,K),void 0,K)}$provideTypeHierarchySubtypes(I,$,H,K){return this.s(I,De,J=>J.provideSubtypes($,H,K),void 0,K)}$releaseTypeHierarchy(I,$){this.s(I,De,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(I,$,H){const K=this.q();return this.f.set(K,new se(new Se(this.e,this.h,H,K),I)),this.e.$registerDocumentOnDropEditProvider(K,this.o($)),this.p(K)}$provideDocumentOnDropEdits(I,$,H,K,J,le){return this.s(I,Se,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits($,t.URI.revive(H),K,J,le)),void 0,void 0)}registerDocumentPasteEditProvider(I,$,H,K){const J=this.q();return this.f.set(J,new se(new O(this.e,this.h,H,J),I)),this.e.$registerPasteEditProvider(J,this.o($),!!H.prepareDocumentPaste,K.pasteMimeTypes),this.p(J)}$prepareDocumentPaste(I,$,H,K,J){return this.s(I,O,le=>le.prepareDocumentPaste(t.URI.revive($),H,K,J),void 0,J)}$providePasteEdits(I,$,H,K,J,le){return this.s(I,O,Ee=>Ee.providePasteEdits($,t.URI.revive(H),K,J,le),void 0,le)}static w(I){return{pattern:I.source,flags:(0,D.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ce.w(I.decreaseIndentPattern),increaseIndentPattern:ce.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ce.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ce.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ce.w(I.beforeText),afterText:I.afterText?ce.w(I.afterText):void 0,previousLineText:I.previousLineText?ce.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ce.z)}setLanguageConfiguration(I,$,H){const{wordPattern:K}=H;if(K&&(0,D.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor($,K):this.h.setWordDefinitionFor($,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const J=this.q(),le={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ce.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ce.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ce.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(J,$,le),this.p(J)}$setWordDefinitions(I){for(const $ of I)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ce[213],ke([1,0,5,8,6,29,14,7]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(M,S,f,p){this.c=S,this.d=f,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=M.getProxy(t.MainContext.MainThreadLanguages)}$acceptLanguageIds(M){this.b=M}async getLanguages(){return this.b.slice(0)}async changeLanguage(M,S){await this.a.$changeLanguage(M,S);const f=this.c.getDocumentData(M);if(!f)throw new Error(`document '${M.toString()}' NOT found`);return f.document}async tokenAtPosition(M,S){const f=M.version,p=T.Position.from(S),m=await this.a.$tokensAtPosition(M.uri,p),i={type:y.StandardTokenType.Other,range:M.getWordRangeAtPosition(S)??new y.Range(S.line,S.character,S.line,S.character)};if(!m)return i;const r={range:T.Range.to(m.range),type:T.TokenType.to(m.type)};return!r.range.contains(S)||f!==M.version?i:r}createLanguageStatusItem(M,S,f){const p=this.f++,m=this.a,i=this.g,r=`${M.identifier.value}/${S}`;if(i.has(r))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);i.add(r);const l={selector:f,id:S,name:M.displayName??M.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const b=new R.DisposableStore,E=()=>{v?.dispose(),v=(0,C.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(p,{id:r,name:l.name??M.displayName??M.name,source:M.displayName??M.name,selector:T.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===y.LanguageStatusSeverity.Error?N.default.Error:l.severity===y.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:l.command&&this.d.toInternal(l.command,b),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},w={dispose(){b.dispose(),v?.dispose(),m.$removeLanguageStatus(p),i.delete(r)},get id(){return l.id},get name(){return l.name},set name(s){l.name=s,E()},get selector(){return l.selector},set selector(s){l.selector=s,E()},get text(){return l.text},set text(s){l.text=s,E()},get detail(){return l.detail},set detail(s){l.detail=s,E()},get severity(){return l.severity},set severity(s){l.severity=s,E()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(s){l.accessibilityInformation=s,E()},get command(){return l.command},set command(s){l.command=s,E()},get busy(){return l.busy},set busy(s){l.busy=s,E()}};return E(),w}}e.ExtHostLanguages=D}),define(Ce[75],ke([1,0,21,10,2,3,12,5,27,15]),function(ee,e,t,T,y,N,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let M=class{constructor(f,p,m){this.f=m,this.d=new Map,this.a=p.getProxy(R.MainContext.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===t.LANGUAGE_DEFAULT}getMessage(f,p){const{message:m,args:i,comment:r}=p;if(this.c)return(0,T.format2)(m,i??{});let l=m;r&&r.length>0&&(l+=`/${Array.isArray(r)?r.join():r}`);const v=this.d.get(f)?.contents[l];return v||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,T.format2)(v??m,i??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let p;const m=await this.g(f);if(!m){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const i=await this.a.$fetchBundleContents(m),r=JSON.parse(i);p=f.isBuiltin?r.contents?.bundle:r}catch(i){this.f.error(`Failed to load translations for ${f.identifier.value} from ${m}: ${i.message}`);return}p&&this.d.set(f.identifier.value,{contents:p,uri:m})}async g(f){if(f.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(f.identifier.value);return y.URI.revive(p)}return f.l10n?y.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};M=qe([je(0,D.IExtHostInitDataService),je(1,k.IExtHostRpcService),je(2,C.ILogService)],M),e.ExtHostLocalizationService=M,e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(Ce[214],ke([1,0,12,5,27,15,2,4,9]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends t.AbstractLoggerService{constructor(f,p){super(p.logLevel,R.Event.None),this.g=f.getProxy(T.MainContext.MainThreadLogger)}$setLevel(f,p){p?this.setLevel(C.URI.revive(p),f):(0,D.isUndefined)(f)||this.setLevel(f)}f(f,p,m){return new M(this.g,f,p,m)}};k=qe([je(0,N.IExtHostRpcService),je(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class M extends t.AbstractMessageLogger{constructor(f,p,m,i){super(i?.always),this.m=f,this.n=p,this.k=!1,this.l=[],this.setLevel(m),this.m.$createLogger(p,i).then(()=>{this.r(this.l),this.k=!0})}g(f,p){const m=[[f,p]];this.k?this.r(m):this.l.push(...m)}r(f){this.m.$log(this.n,f)}}}),define(Ce[215],ke([1,0,5,12,26]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(R){return R&&R.title}let C=class{constructor(D,k){this.b=k,this.a=D.getProxy(t.MainContext.MainThreadMessageService)}showMessage(D,k,M,S,f){const p={source:{identifier:D.identifier,label:D.displayName||D.name}};let m;typeof S=="string"||N(S)?m=[S,...f]:(p.modal=S?.modal,p.useCustom=S?.useCustom,p.detail=S?.detail,m=f),p.useCustom&&(0,y.checkProposedApiEnabled)(D,"resolvers");const i=[];for(let r=0;r<m.length;r++){const l=m[r];if(typeof l=="string")i.push({title:l,handle:r,isCloseAffordance:!1});else if(typeof l=="object"){const{title:v,isCloseAffordance:b}=l;i.push({title:v,isCloseAffordance:!!b,handle:r})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,M,p,i).then(r=>{if(typeof r=="number")return m[r]})}};C=qe([je(1,T.ILogService)],C),e.ExtHostMessageService=C}),define(Ce[216],ke([1,0,24,4,7,28,10,9,2,52,5,38,8,6,44,189,98]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,E,w,s){this.q=w,this.r=s,this.f=new Map,this.g=new N.ResourceMap,this.h=new Map,this.j=new T.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new T.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new T.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(M.MainContext.MainThreadNotebook),this.c=b.getProxy(M.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(M.MainContext.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const a=o.notebookEditor?.notebookUri,d=o.cell.handle,u=this.g.get(a)?.getCell(d);if(u)return u.apiCell}if(o&&o.$mid===14){const a=o.uri,d=this.g.get(a);if(d)return d.apiNotebook}return o}}),l.x(E)}getEditorById(b){const E=this.h.get(b);if(!E)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(b){for(const[E,w]of this.h)if(w.apiEditor===b)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,E){const w=this.g.get(b);if(!w&&!E)throw new Error(`NO notebook document for '${b}'`);return w}static s(b,E){if(!E)return;const w=E.filenamePattern.map(s=>f.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(E.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:E.displayName,filenamePattern:w,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,E,w){const s=l.a++,o=typeof w.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(s,w),this.b.$registerNotebookCellStatusBarItemProvider(s,o,E);let a;return o!==void 0&&(a=w.onDidChangeCellStatusBarItems(d=>this.b.$emitCellStatusBarEvent(o))),new p.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,o),a?.dispose()})}async createNotebookDocument(b){const E=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&f.NotebookData.from(b.content)});return D.URI.revive(E)}async openNotebookDocument(b){const E=this.g.get(b);if(E)return E.apiNotebook;const w=await this.c.$tryOpenNotebook(b),s=this.g.get(D.URI.revive(w));return(0,R.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(b,E){D.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let w;typeof E=="object"?w={position:f.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(f.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:w={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,w),o=s&&this.h.get(s)?.apiEditor;if(o)return o;throw s?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,E,w,s){const o=this.f.get(b),a=D.URI.revive(E),d=this.g.get(a);if(!d||!o)return;const c=d.getCellFromIndex(w);if(!c)return;const u=await o.provideCellStatusBarItems(c.apiCell,s);if(!u)return;const n=new y.DisposableStore,h=this.p.add([n]),A=(Array.isArray(u)?u:[u]).map(L=>f.NotebookStatusBarItem.from(L,this.i,n));return{cacheId:h,items:A}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,E,w,s,o){if((0,C.isFalsyOrWhitespace)(E))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,w),this.b.$registerNotebookSerializer(a,{id:b.identifier,location:b.extensionLocation},E,f.NotebookDocumentContentOptions.from(s),l.s(b,o)),(0,y.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(b,E,w){const s=this.u.get(b);if(!s)throw new Error("NO serializer found");const o=await s.deserializeNotebook(E.buffer,w);return new m.SerializableObjectWithBuffers(f.NotebookData.from(o))}async $notebookToData(b,E,w){const s=this.u.get(b);if(!s)throw new Error("NO serializer found");const o=await s.serializeNotebook(f.NotebookData.to(E.value),w);return t.VSBuffer.wrap(o)}w(b,E,w){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const s=new r.ExtHostNotebookEditor(E,this.d,b,w.visibleRanges.map(f.NotebookRange.to),w.selections.map(f.NotebookRange.to),typeof w.viewColumn=="number"?f.ViewColumn.to(w.viewColumn):void 0);this.h.set(E,s)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const w of b.value.removedDocuments){const s=D.URI.revive(w),o=this.g.get(s);o&&(o.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(o.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===s.toString()&&this.h.delete(a.id)}if(b.value.addedDocuments){const w=[];for(const s of b.value.addedDocuments){const o=D.URI.revive(s.uri);if(this.g.has(o))throw new Error(`adding EXISTING notebook ${o} `);const a=new i.ExtHostNotebookDocument(this.c,this.q,this.r,o,s);w.push(...s.cells.map(d=>i.ExtHostCell.asModelAddData(a.apiNotebook,d))),this.g.get(o)?.dispose(),this.g.set(o,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(a.apiNotebook)}}if(b.value.addedEditors)for(const w of b.value.addedEditors){if(this.h.has(w.id))return;const s=D.URI.revive(w.documentUri),o=this.g.get(s);o&&this.w(o,w.id,w)}const E=[];if(b.value.removedEditors)for(const w of b.value.removedEditors){const s=this.h.get(w);s&&(this.h.delete(w),this.k?.id===s.id&&(this.k=void 0),E.push(s))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const w=new Set;this.l.forEach(s=>w.add(s.id));for(const s of this.h.values()){const o=w.has(s.id);s._acceptVisibility(o)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const E=S.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new S.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>t.VSBuffer.wrap(o))],new S.ApiCommandResult("Notebook Data",o=>f.NotebookData.to(o.value))),s=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new m.SerializableObjectWithBuffers(f.NotebookData.from(o)))],new S.ApiCommandResult("Bytes",o=>o.buffer));b.registerApiCommand(w),b.registerApiCommand(s)}}e.ExtHostNotebookController=l,l.a=0}),define(Ce[217],ke([1,0,16,14,20,4,7,28,2,25,12,52,5,38,8,6,69,177,26,44]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let E=class{constructor(c,u,n,h,g){this.k=u,this.l=n,this.m=h,this.n=g,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new S.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(f.MainContext.MainThreadNotebookKernels);const A=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const q=this.l.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:q}}else if(L&&"notebookEditor"in L){const q=this.l.getIdByEditor(L.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return L})],p.ApiCommandResult.Void);this.m.registerApiCommand(A)}createNotebookController(c,u,n,h,g,A){for(const ae of this.h.values())if(ae.controller.id===u&&k.ExtensionIdentifier.equals(c.identifier,ae.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const L=this.i++,q=this;this.n.trace(`NotebookController[${L}], CREATED by ${c.identifier.value}, ${u}`);const Z=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${c.identifier}'`);let x=!1;const O=new C.DisposableStore,F=new N.Emitter,P=new N.Emitter,B={id:a(c.identifier,u),notebookType:n,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:h||c.identifier.value,preloads:A?A.map(m.NotebookRendererScript.from):[]};let V=g??Z,z;this.a.$addKernel(L,B).catch(ae=>{console.log(ae),x=!0});let ne=0;const de=()=>{if(x)return;const ae=++ne;Promise.resolve().then(()=>{ae===ne&&this.a.$updateKernel(L,B)})},we=new R.ResourceMap,ue={get id(){return u},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return B.label},set label(ae){B.label=ae??c.displayName??c.name,de()},get detail(){return B.detail??""},set detail(ae){B.detail=ae,de()},get description(){return B.description??""},set description(ae){B.description=ae,de()},get kind(){return(0,v.checkProposedApiEnabled)(c,"notebookControllerKind"),B.kind??""},set kind(ae){(0,v.checkProposedApiEnabled)(c,"notebookControllerKind"),B.kind=ae,de()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ae){B.supportedLanguages=ae,de()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){B.supportsExecutionOrder=ae,de()},get rendererScripts(){return B.preloads?B.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(ae){V=ae??Z},get interruptHandler(){return z},set interruptHandler(ae){z=ae,B.supportsInterrupt=Boolean(ae),de()},createNotebookCellExecution(ae){if(x)throw new Error("notebook controller is DISPOSED");if(!we.has(ae.notebook.uri))throw q.n.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(we.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return q._createNotebookCellExecution(ae,a(c.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${L}], DISPOSED`),x=!0,this.h.delete(L),O.dispose(),F.dispose(),P.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(ae,Ie){Ie===i.NotebookControllerAffinity2.Hidden&&(0,v.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(L,ae.uri,Ie)},onDidReceiveMessage:P.event,postMessage(ae,Ie){return(0,v.checkProposedApiEnabled)(c,"notebookMessaging"),q.a.$postMessage(L,Ie&&q.l.getIdByEditor(Ie),ae)},asWebviewUri(ae){return(0,v.checkProposedApiEnabled)(c,"notebookMessaging"),(0,r.asWebviewUri)(ae,q.k.remote)}};return this.h.set(L,{extensionId:c.identifier,controller:ue,onDidReceiveMessage:P,onDidChangeSelection:F,associatedNotebooks:we}),ue}getIdByController(c){for(const[u,n]of this.h)if(n.controller===c)return a(n.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,u){const n=this.d++,h=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(n,u);const g={dispose:()=>{this.c.delete(n),h.a.$removeKernelDetectionTask(n)}};return this.c.set(n,g),g}registerKernelSourceActionProvider(c,u,n){const h=this.f++,g=this;return this.e.set(h,n),this.n.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(h,u),{dispose:()=>{this.e.delete(h),g.a.$removeKernelSourceActionProvider(h)}}}async $provideKernelSourceActions(c,u){const n=this.e.get(c);if(n){const h=new C.DisposableStore;return this.g.add([h]),(await n.provideNotebookKernelSourceActions(u)??[]).map(A=>m.NotebookKernelSourceAction.from(A,this.m.converter,h))}return[]}$acceptNotebookAssociation(c,u,n){const h=this.h.get(c);if(h){const g=this.l.getNotebookDocument(D.URI.revive(u));n?h.associatedNotebooks.set(g.uri,!0):h.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,g.uri.toString(),n),h.onDidChangeSelection.fire({selected:n,notebook:g.apiNotebook})}}async $executeCells(c,u,n){const h=this.h.get(c);if(!h)return;const g=this.l.getNotebookDocument(D.URI.revive(u)),A=[];for(const L of n){const q=g.getCell(L);q&&A.push(q.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,g.uri.toString(),A.length),await h.controller.executeHandler.call(h.controller,A,g.apiNotebook,h.controller)}catch(L){this.n.error(`NotebookController[${c}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(c,u,n){const h=this.h.get(c);if(!h)return;const g=this.l.getNotebookDocument(D.URI.revive(u));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,g.apiNotebook);else for(const A of n){const L=g.getCell(A);L&&this.b.get(L.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,u,n){const h=this.h.get(c);if(!h)return;const g=this.l.getEditorById(u);h.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:n}))}$cellExecutionChanged(c,u,n){const g=this.l.getNotebookDocument(D.URI.revive(c)).getCell(u);if(g){const A=n?m.NotebookCellExecutionState.to(n):i.NotebookCellExecutionState.Idle;A!==void 0&&this.j.fire({cell:g.apiCell,state:A})}}_createNotebookCellExecution(c,u){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const g=new s(u,h,this.a);this.b.set(h.uri,g);const A=g.onDidChangeState(()=>{g.state===w.Resolved&&(g.dispose(),A.dispose(),this.b.delete(h.uri))});return g.asApiObject()}};E=qe([je(4,M.ILogService)],E),e.ExtHostNotebookKernels=E;var w;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(w||(w={}));class s extends C.Disposable{get state(){return this.f}constructor(c,u,n){super(),this.j=u,this.k=n,this.b=s.a++,this.c=new N.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new y.CancellationTokenSource),this.h=new o(10,h=>this.m(h)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const u=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(u))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let u=this.j;if(c&&(u=this.j.notebook.getCellFromApiCell(c)),!u)throw new Error("INVALID cell");return u.handle}s(c){return c.map(u=>{const n=i.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return n===u.items?m.NotebookCellOutput.from(u):m.NotebookCellOutput.from({items:n,id:u.id,metadata:u.metadata})})}async t(c,u,n){const h=this.r(u),g=this.s((0,t.asArray)(c));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:h,append:n,outputs:g})}async w(c,u,n){return c=i.NotebookCellOutput.ensureUniqueMimeTypes((0,t.asArray)(c),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:c.map(m.NotebookCellOutputItem.from),outputId:u.id,append:n})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(n){c.i=n,c.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(n){if(c.f===w.Resolved||c.f===w.Started)throw new Error("Cannot call start again");c.f=w.Started,c.c.fire(),c.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,h){if(c.f===w.Resolved)throw new Error("Cannot call resolve twice");c.f=w.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new b.SerializableObjectWithBuffers({runEndTime:h,lastRunSuccess:n}))},clearOutput(n){return c.n(),c.t([],n,!1)},appendOutput(n,h){return c.n(),c.t(n,h,!0)},replaceOutput(n,h){return c.n(),c.t(n,h,!1)},appendOutputItems(n,h){return c.n(),c.w(n,h,!0)},replaceOutputItems(n,h){return c.n(),c.w(n,h,!1)}})}}s.a=0;class o{constructor(c,u){this.d=c,this.e=u,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new T.DeferredPromise,this.b=Date.now(),(0,T.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>c.complete())}}function a(d,c){return`${d.value}/${c}`}e.createKernelId=a}),define(Ce[218],ke([1,0,4,5,98]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(R,D){this.c=D,this.a=new Map,this.b=R.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,D,k){const M=this.c.getEditorById(R);this.a.get(D)?.fire({editor:M.apiEditor,message:k})}createRendererMessaging(R,D){if(!R.contributes?.notebookRenderer?.some(M=>M.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(M,S,f)=>this.d(D).event(M,S,f),postMessage:(M,S)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(M)&&([M,S]=[S,M]);const f=S&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(S);return this.b.$postMessage(f?.id,D,M)}}}d(R){let D=this.a.get(R);return D||(D=new t.Emitter({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(R)}}),this.a.set(R,D),D)}}e.ExtHostNotebookRenderers=N}),define(Ce[219],ke([1,0,7,9,2,26,5]),function(ee,e,t,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(k){this.b=new Map,this.a=k.getProxy(C.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,M,S){if((0,N.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,S),this.a.$registerProfileContentHandler(M,S.name,S.description,k.identifier.value),(0,t.toDisposable)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(k,M,S,f){const p=this.b.get(k);if(!p)throw new Error(`Unknown handler with id: ${k}`);return p.saveProfile(M,S,f)}async $readProfile(k,M,S){const f=this.b.get(k);if(!f)throw new Error(`Unknown handler with id: ${k}`);return f.readProfile((0,T.isString)(M)?M:y.URI.revive(M),S)}}e.ExtHostProfileContentHandlers=R}),define(Ce[220],ke([1,0,20,4,7,5,2,6,11,16,29,65]),function(ee,e,t,T,y,N,C,R,D,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(p,m,i){const r=p.getProxy(N.MainContext.MainThreadQuickOpen);class l{constructor(c,u){this.e=new Map,this.f=0,this.a=c,this.b=u}showQuickPick(c,u,n=t.CancellationToken.None){this.c=void 0;const h=Promise.resolve(c),g=++this.f,A=r.$show(g,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},n),L={},q=A.then(()=>L);return Promise.race([q,h]).then(Z=>{if(Z!==L)return h.then(x=>{const O=[];for(let F=0;F<x.length;F++){const P=x[F];typeof P=="string"?O.push({label:P,handle:F}):P.kind===R.QuickPickItemKind.Separator?O.push({type:"separator",label:P.label}):O.push({label:P.label,description:P.description,detail:P.detail,picked:P.picked,alwaysShow:P.alwaysShow,handle:F})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=F=>{u.onDidSelectItem(x[F])}),r.$setItems(g,O),A.then(F=>{if(typeof F=="number")return x[F];if(Array.isArray(F))return F.map(P=>x[P])})})}).then(void 0,Z=>{if(!(0,D.isCancellationError)(Z))return r.$setError(g,Z),Promise.reject(Z)})}$onItemSelected(c){this.c?.(c)}showInput(c,u=t.CancellationToken.None){return this.d=c?.validateInput,r.$input(c,typeof this.d=="function",u).then(void 0,n=>{if(!(0,D.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(c){if(!this.d)return;const u=await this.d(c);if(!u||typeof u=="string")return u;let n;switch(u.severity){case R.InputBoxValidationSeverity.Info:n=M.default.Info;break;case R.InputBoxValidationSeverity.Warning:n=M.default.Warning;break;case R.InputBoxValidationSeverity.Error:n=M.default.Error;break;default:n=u.message?M.default.Error:M.default.Ignore;break}return{content:u.message,severity:n}}async showWorkspaceFolderPick(c,u=t.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!n)return;const h=await this.a.getWorkspaceFolders2();if(!!h)return h.find(g=>g.uri.toString()===n.uri.toString())}createQuickPick(c){const u=new o(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(c){const u=new a(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(c,u){this.e.get(c)?._fireDidChangeValue(u)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,u){const n=this.e.get(c);n instanceof o&&n._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const n=this.e.get(c);n instanceof o&&n._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){this.e.get(c)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,n){const h=this.e.get(c);h instanceof o&&h._fireDidTriggerItemButton(u,n)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class v{constructor(c,u){this.x=c,this.y=u,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.Emitter,this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.z({title:c})}get step(){return this.c}set step(c){this.c=c,this.z({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.z({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.z({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.z({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.z({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.z({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.z({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((u,n)=>{const h=u===R.QuickInputButtons.Back?-1:n;this.o.set(h,u)}),this.z({buttons:c.map((u,n)=>({...s(u),tooltip:u.tooltip,handle:u===R.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const u=this.o.get(c);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,y.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(c){if(!this.v){for(const u of Object.keys(c)){const n=c[u];this.u[u]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}v.a=1;function b(d){if(d instanceof R.ThemeIcon)return{id:d.id};const c=w(d),u=E(d);return{dark:typeof c=="string"?C.URI.file(c):c,light:typeof u=="string"?C.URI.file(u):u}}function E(d){return typeof d=="object"&&"light"in d?d.light:d}function w(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const c=b(d.iconPath);let u,n;return"id"in c?n=S.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:n}}class o extends v{constructor(c,u){super(c.identifier,u),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.Emitter,this.L=[],this.M=new T.Emitter,this.N=new T.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(c){this.B=c.slice(),this.C.clear(),this.D.clear(),c.forEach((n,h)=>{this.C.set(h,n),this.D.set(n,h)});const u=[];for(let n=0;n<c.length;n++){const h=c[n];h.kind===R.QuickPickItemKind.Separator?u.push({type:"separator",label:h.label}):u.push({handle:n,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((g,A)=>({...s(g),tooltip:g.tooltip,handle:A}))})}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(c){this.E=c,this.z({canSelectMany:c})}get matchOnDescription(){return this.F}set matchOnDescription(c){this.F=c,this.z({matchOnDescription:c})}get matchOnDetail(){return this.G}set matchOnDetail(c){this.G=c,this.z({matchOnDetail:c})}get sortByLabel(){return this.H}set sortByLabel(c){this.H=c,this.z({sortByLabel:c})}get keepScrollPosition(){return this.I}set keepScrollPosition(c){this.I=c,this.z({keepScrollPosition:c})}get activeItems(){return this.J}set activeItems(c){this.J=c.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(c){this.L=c.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(c){const u=(0,k.coalesce)(c.map(n=>this.C.get(n)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(c){const u=(0,k.coalesce)(c.map(n=>this.C.get(n)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(c,u){const n=this.C.get(c);if(!n||!n.buttons||!n.buttons.length)return;const h=n.buttons[u];h&&this.N.fire({button:h,item:n})}}class a extends v{constructor(c,u){super(c.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(c){this.B=c,this.z({password:c})}get prompt(){return this.C}set prompt(c){this.C=c,this.z({prompt:c})}get valueSelection(){return this.D}set valueSelection(c){this.D=c,this.z({valueSelection:c})}get validationMessage(){return this.E}set validationMessage(c){this.E=c,c?typeof c=="string"?this.z({validationMessage:c,severity:M.default.Error}):this.z({validationMessage:c.message,severity:c.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new l(m,i)}e.createExtHostQuickOpen=f});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t};define(Ce[221],ke([1,0,2,4,61,7,14,5,16,124,12,25,65,8,26]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m){"use strict";var i,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(h){if(h)return typeof h.iconPath=="string"?t.URI.file(h.iconPath):t.URI.isUri(h.iconPath)||f.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function v(h,g){if(!h.iconPath&&!g.iconPath)return 0;if(h.iconPath){if(!g.iconPath)return 1}else return-1;const A=typeof h.iconPath=="string"?h.iconPath:t.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,L=typeof g.iconPath=="string"?g.iconPath:t.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,k.comparePaths)(A,L)}function b(h,g){let A=0;if(h.strikeThrough!==g.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==g.faded)return h.faded?1:-1;if(h.tooltip!==g.tooltip)return(h.tooltip||"").localeCompare(g.tooltip||"");if(A=v(h,g),A!==0)return A;if(h.light&&g.light)A=v(h.light,g.light);else{if(h.light)return 1;if(g.light)return-1}if(A!==0)return A;if(h.dark&&g.dark)A=v(h.dark,g.dark);else{if(h.dark)return 1;if(g.dark)return-1}return A}function E(h,g){if(h.command!==g.command)return h.command<g.command?-1:1;if(h.title!==g.title)return h.title<g.title?-1:1;if(h.tooltip!==g.tooltip){if(h.tooltip!==void 0&&g.tooltip!==void 0)return h.tooltip<g.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(h.arguments===g.arguments)return 0;if(h.arguments)if(g.arguments){if(h.arguments.length!==g.arguments.length)return h.arguments.length-g.arguments.length}else return 1;else return-1;for(let A=0;A<h.arguments.length;A++){const L=h.arguments[A],q=g.arguments[A];if(L!==q)return L<q?-1:1}return 0}function w(h,g){let A=(0,k.comparePaths)(h.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(A!==0)return A;if(h.command&&g.command)A=E(h.command,g.command);else{if(h.command)return 1;if(g.command)return-1}if(A!==0)return A;if(h.decorations&&g.decorations)A=b(h.decorations,g.decorations);else{if(h.decorations)return 1;if(g.decorations)return-1}return A}function s(h,g){for(let A=0;A<h.length;A++)if(h[A]!==g[A])return!1;return!0}function o(h,g){return h.command===g.command&&h.title===g.title&&h.tooltip===g.tooltip&&(h.arguments&&g.arguments?s(h.arguments,g.arguments):h.arguments===g.arguments)}function a(h,g){return(0,D.equals)(h,g,o)}class d{get value(){return this.d}set value(g){g=g??"",Oe(this,i,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Oe(this,i,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,m.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Oe(this,i,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Oe(this,i,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Oe(this,i,"f").$setInputBoxVisibility(this.l,g))}constructor(g,A,L){this.k=g,this.l=L,i.set(this,void 0),this.d="",this.e=new T.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,i,A,"f")}showValidationMessage(g,A){(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),Oe(this,i,"f").$showValidationMessage(this.l,g,A)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=d,i=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,A,L,q,Z){this.q=g,this.s=A,this.t=L,this.u=q,this.v=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,A){const L=this.h.get(g);return L?(0,C.asPromise)(()=>this.s.executeCommand(L.command,...L.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(w),L=(0,D.sortedDiff)(this.o,g,w).map(x=>{const O=x.toInsert.map(F=>{const P=this.e++;this.g.set(P,F);const B=F.resourceUri;let V;if(F.command)if(F.command.command==="vscode.open"||F.command.command==="vscode.diff"){const re=new N.DisposableStore;V=this.s.converter.toInternal(F.command,re),this.j.set(P,re)}else this.h.set(P,F.command);const z=l(F.decorations),ne=F.decorations&&l(F.decorations.light)||z,de=F.decorations&&l(F.decorations.dark)||z,we=[ne,de],ue=F.decorations&&F.decorations.tooltip||"",ae=F.decorations&&!!F.decorations.strikeThrough,Ie=F.decorations&&!!F.decorations.faded,G=F.contextValue||"";return{rawResource:[P,B,we,ue,ae,Ie,G,V],handle:P}});return{start:x.start,deleteCount:x.deleteCount,toInsert:O}}),q=L.map(({start:x,deleteCount:O,toInsert:F})=>[x,O,F.map(P=>P.rawResource)]),Z=L.reverse();for(const{start:x,deleteCount:O,toInsert:F}of Z){const P=F.map(V=>V.handle),B=this.n.splice(x,O,...P);for(const V of B)this.g.delete(V),this.h.delete(V),this.j.get(V)?.dispose(),this.j.delete(V)}return this.o=g,q}dispose(){this.l=!0,this.m.fire()}}c.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Oe(this,r,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Oe(this,r,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Oe(this,r,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new N.DisposableStore,this.l=g;const A=this.v.converter.toInternal(g,this.k.value);Oe(this,r,"f").$updateSourceControl(this.t,{acceptInputCommand:A})}get actionButton(){return(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new N.DisposableStore,this.n=g;const A=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(L=>L.map(q=>this.v.converter.toInternal(q,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Oe(this,r,"f").$updateSourceControl(this.t,{actionButton:A??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&a(this.p,g))return;this.o.value=new N.DisposableStore,this.p=g;const A=(g||[]).map(L=>this.v.converter.toInternal(L,this.o.value));Oe(this,r,"f").$updateSourceControl(this.t,{statusBarCommands:A})}get selected(){return this.q}constructor(g,A,L,q,Z,x){this.u=g,this.v=L,this.w=q,this.x=Z,this.y=x,r.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new N.MutableDisposable,this.l=void 0,this.m=new N.MutableDisposable,this.o=new N.MutableDisposable,this.p=void 0,this.q=!1,this.s=new T.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,Je(this,r,A,"f"),this.f=new d(g,Oe(this,r,"f"),this.t),Oe(this,r,"f").$registerSourceControl(this.t,q,Z,x)}createResourceGroup(g,A){const L=new c(Oe(this,r,"f"),this.v,this.t,g,A),q=T.Event.once(L.onDidDispose)(()=>this.z.delete(L));return this.z.set(L,q),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const g=[],A=[];for(const[L,q]of this.z){q.dispose();const Z=L.onDidUpdateResourceStates(()=>{this.A.add(L),this.eventuallyUpdateResourceStates()});T.Event.once(L.onDidDispose)(()=>{this.A.delete(L),Z.dispose(),this.e.delete(L.handle),Oe(this,r,"f").$unregisterGroup(this.t,L.handle)}),g.push([L.handle,L.id,L.label,L.features]);const x=L._takeResourceStateSnapshot();x.length>0&&A.push([L.handle,x]),this.e.set(L.handle,L)}Oe(this,r,"f").$registerGroups(this.t,g,A),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(A=>{const L=A._takeResourceStateSnapshot();L.length!==0&&g.push([A.handle,L])}),g.length>0&&Oe(this,r,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Oe(this,r,"f").$unregisterSourceControl(this.t)}}r=new WeakMap,u.d=0,qe([(0,y.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,y.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let n=class nn{get onDidChangeActiveProvider(){return this.j.event}constructor(g,A,L){this.l=A,this.m=L,this.g=new Map,this.h=new Map,this.j=new T.Emitter,this.e=g.getProxy(R.MainContext.MainThreadSCM),this.f=g.getProxy(R.MainContext.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const Z=this.g.get(q.sourceControlHandle);if(!Z)return q;const x=Z.getResourceGroup(q.groupHandle);return x?x.getResourceState(q.handle):q}else if(q&&q.$mid===4){const Z=this.g.get(q.sourceControlHandle);return Z?Z.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const Z=this.g.get(q.handle);return Z||q}return q}})}createSourceControl(g,A,L,q){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,A,L,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const Z=nn.d++,x=new u(g,this.e,this.l,A,L,q);this.g.set(Z,x);const O=this.h.get(S.ExtensionIdentifier.toKey(g.identifier))||[];return O.push(x),this.h.set(S.ExtensionIdentifier.toKey(g.identifier),O),x}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const A=this.h.get(S.ExtensionIdentifier.toKey(g.identifier)),L=A&&A[A.length-1];return L&&L.inputBox}$provideOriginalResource(g,A,L){const q=t.URI.revive(A);this.m.trace("ExtHostSCM#$provideOriginalResource",g,q.toString());const Z=this.g.get(g);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>Z.quickDiffProvider.provideOriginalResource(q,L)).then(x=>x||null)}$onInputBoxValueChange(g,A){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const L=this.g.get(g);return L&&L.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(g,A,L,q){this.m.trace("ExtHostSCM#$executeResourceCommand",g,A,L);const Z=this.g.get(g);if(!Z)return Promise.resolve(void 0);const x=Z.getResourceGroup(A);return x?x.$executeResourceCommand(L,q):Promise.resolve(void 0)}$validateInput(g,A,L){this.m.trace("ExtHostSCM#$validateInput",g);const q=this.g.get(g);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>q.inputBox.validateInput(A,L)).then(Z=>{if(!Z)return Promise.resolve(void 0);const x=p.MarkdownString.fromStrict(Z.message);return x?Promise.resolve([x,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};n.d=0,n=qe([je(2,M.ILogService)],n),e.ExtHostSCM=n}),define(Ce[76],ke([1,0,5,4,3]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(R){this.b=new T.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(t.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,D){return this.a.$getPassword(R,D)}store(R,D,k){return this.a.$setPassword(R,D,k)}delete(R,D){return this.a.$deletePassword(R,D)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[222],ke([1,0,6,5,139,7,8,9]),function(ee,e,t,T,y,N,C,R){"use strict";var D,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class M{constructor(m,i,r,l,v=t.StatusBarAlignment.Left,b){D.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new N.DisposableStore,Je(this,D,m,"f"),Je(this,k,i,"f"),this.c=M.a++,this.e=r,this.f=l,this.g=v,this.h=this.t(b)}t(m){if(!!(0,R.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(m){this.k=m,this.u()}set name(m){this.m=m,this.u()}set tooltip(m){this.l=m,this.u()}set color(m){this.n=m,this.u()}set backgroundColor(m){m&&!M.b.has(m.id)&&(m=void 0),this.o=m,this.u()}set command(m){this.q?.fromApi!==m&&(this.p.clear(),typeof m=="string"?this.q={fromApi:m,internal:Oe(this,k,"f").toInternal({title:"",command:m},this.p)}:m?this.q={fromApi:m,internal:Oe(this,k,"f").toInternal(m,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(m){this.s=m,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Oe(this,D,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let i;this.m?i=this.m:i=(0,y.localize)(0,null,this.e.displayName||this.e.name);let r=this.n;this.o&&(r=M.b.get(this.o.id));const l=C.MarkdownString.fromStrict(this.l);Oe(this,D,"f").$setEntry(this.c,m,i,this.k,l,this.q?.internal,r,this.o,this.g===t.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=M,D=new WeakMap,k=new WeakMap,M.a=0,M.b=new Map([["statusBarItem.errorBackground",new t.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new t.ThemeColor("statusBarItem.warningForeground")]]);class S{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",t.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,y.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const i={message:m};return this.b.unshift(i),this.c(),new t.Disposable(()=>{const r=this.b.indexOf(i);r>=0&&(this.b.splice(r,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(m,i){this.a=m.getProxy(T.MainContext.MainThreadStatusBar),this.b=i,this.c=new S(this)}createStatusBarEntry(m,i,r,l){return new M(this.a,this.b,m,i,r,l)}setStatusBarMessage(m,i){const r=this.c.setMessage(m);let l;return typeof i=="number"?l=setTimeout(()=>r.dispose(),i):typeof i<"u"&&i.then(()=>r.dispose(),()=>r.dispose()),new t.Disposable(()=>{r.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=f}),define(Ce[77],ke([1,0,5,4,3]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(R,D){this.c=D,this.b=new T.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(t.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,D){this.a.$registerExtensionStorageKeysToSync(R,D)}async initializeExtensionStorage(R,D,k){const M=await this.a.$initializeExtensionStorage(R,D);let S;return M&&(S=this.d(R,D,M)),S||k}setValue(R,D,k){return this.a.$setValue(R,D,k)}$acceptValue(R,D,k){const M=this.d(R,D,k);M&&this.b.fire({shared:R,key:D,value:M})}d(R,D,k){try{return JSON.parse(k)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${R}): ${M}`)}}}e.ExtHostStorage=N,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ce[78],ke([1,0,3,27,12,58,2]),function(ee,e,t,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,t.createDecorator)("IExtensionStoragePaths");let R=class{constructor(k,M,S){this.d=M,this.f=S,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(k){return C.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,M=await this.g(k);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(C.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(k){if(this.c)return C.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return C.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([je(0,T.IExtHostInitDataService),je(1,y.ILogService),je(2,N.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(Ce[59],ke([1,0,4,5,3,2,15,7,6,140,11,178,20,34,164,65,9,14,8]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(n,h,g,A){this.k=n,this._id=h,this.l=g,this.m=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(q=>this.f=q);const L=this;this.value={get name(){return L.m||""},get processId(){return L.b},get creationOptions(){return L.l},get exitStatus(){return L.h},get state(){return L.j},sendText(q,Z=!0){L.o(),L.k.$sendText(L._id,q,Z)},show(q){L.o(),L.k.$show(L._id,q)},hide(){L.o(),L.k.$hide(L._id)},dispose(){L.a||(L.a=!0,L.k.$dispose(L._id))},get dimensions(){if(!(L.d===void 0||L.g===void 0))return{columns:L.d,rows:L.g}}}}async create(n,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,r.withNullAsUndefined)(n.shellPath),shellArgs:(0,r.withNullAsUndefined)(n.shellArgs),cwd:(0,r.withNullAsUndefined)(n.cwd),env:(0,r.withNullAsUndefined)(n.env),icon:(0,r.withNullAsUndefined)(d(n.iconPath)),color:i.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,r.withNullAsUndefined)(n.message),strictEnv:(0,r.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,r.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,r.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,r.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this.n(n.location,h?.resolvedExtHostIdentifier),isTransient:(0,r.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,h,g,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:i.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.n(n,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,h){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in n?{viewColumn:v.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,h){this.h=Object.freeze({code:n,reason:h})}setDimensions(n,h){return n===this.d&&h===this.g||n===0||h===0?!1:(this.d=n,this.g=h,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(h=>{h!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=b;class E{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new t.Emitter,this.onProcessData=this.a.event,this.b=new t.Emitter,this.d=new t.Emitter,this.onDidChangeProperty=this.d.event,this.f=new t.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${h}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,h){this.g.setDimensions?.({columns:n,rows:h})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(h=>this.a.fire(h)),this.g.onDidClose?.((h=void 0)=>{this.f.fire(h===void 0?void 0:h)}),this.g.onDidOverrideDimensions?.(h=>{h&&this.d.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this.g.onDidChangeName?.(h=>{this.d.fire({type:"title",value:h})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,s=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,h){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new t.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new t.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new t.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new t.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new t.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new t.Emitter,this.onDidChangeShell=this.J.event,this.a=h.getProxy(T.MainContext.MainThreadTerminalService),this.s=new m.TerminalDataBufferer(this.a.$sendProcessData),this.I=new t.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[g,A]of this.g)A.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,h){const g=new b(this.a,(0,p.generateUuid)(),n,n.name),A=new E(n.pty);return g.createExtensionTerminal(n.location,this.L(n,h).resolvedExtHostIdentifier,d(n.iconPath),c(n.color)).then(L=>{const q=this.M(L,A);this.h[L]=q}),this.f.push(g),g.value}L(n,h){if(h=h||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const g=n.location.parentTerminal;if(g){const A=this.f.find(L=>L.value===g);A&&(h.resolvedExtHostIdentifier=A._id)}}else n.location&&typeof n.location!="object"?h.location=n.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(n,h){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const A=new E(h),L=this.M(n,A);this.h[n]=L}async $acceptActiveTerminalChanged(n){const h=this.b;if(n===null){this.b=void 0,h!==this.b&&this.F.fire(this.b);return}const g=this.O(n);g&&(this.b=g,h!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,h){const g=this.O(n);g&&this.I.fire({terminal:g.value,data:h})}async $acceptTerminalDimensions(n,h,g){const A=this.O(n);A&&A.setDimensions(h,g)&&this.G.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptTerminalMaximumDimensions(n,h,g){this.g.get(n)?.resize(h,g)}async $acceptTerminalTitleChange(n,h){const g=this.O(n);g&&(g.name=h)}async $acceptTerminalClosed(n,h,g){const A=this.Q(this.f,n);if(A!==null){const L=this.f.splice(A,1)[0];L.setExitStatus(h,g),this.C.fire(L.value)}}$acceptTerminalOpened(n,h,g,A){if(h){const Z=this.Q(this.f,h);if(Z!==null){this.f[Z]._id=n,this.D.fire(this.terminals[Z]),this.f[Z].isOpen=!0;return}}const L={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:N.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},q=new b(this.a,n,L,g);this.f.push(q),this.D.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(n,h){this.O(n)?._setProcessId(h)}async $startExtensionTerminal(n,h){const g=this.O(n);if(!g)return{message:(0,k.localize)(0,null,n)};g.isOpen||await new Promise(L=>{const q=this.onDidOpenTerminal(async Z=>{Z===g.value&&(q.dispose(),L())})});const A=this.g.get(n);A?A.startSendingEvents(h):this.j[n]={initialDimensions:h}}M(n,h){const g=new R.DisposableStore;g.add(h.onProcessReady(L=>this.a.$sendProcessReady(n,L.pid,L.cwd))),g.add(h.onDidChangeProperty(L=>this.a.$sendProcessProperty(n,L))),this.s.startBuffering(n,h.onProcessData),g.add(h.onProcessExit(L=>this.N(n,L))),this.g.set(n,h);const A=this.j[n];return A&&h instanceof E&&(h.startSendingEvents(A.initialDimensions),delete this.j[n]),g}$acceptProcessAckDataEvent(n,h){this.g.get(n)?.acknowledgeDataEvent(h)}$acceptProcessInput(n,h){this.g.get(n)?.input(h)}$acceptTerminalInteraction(n){const h=this.O(n);h?.setInteractedWith()&&this.H.fire(h.value)}$acceptProcessResize(n,h,g){try{this.g.get(n)?.resize(h,g)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(n,h){this.g.get(n)?.shutdown(h)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(h=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(h=>this.a.$sendProcessProperty(n,{type:"cwd",value:h}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new D.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,h,g){if(this.v.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this.v.set(h,g),this.a.$registerProfileProvider(h,n.identifier.value),new D.Disposable(()=>{this.v.delete(h),this.a.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(n,h,g){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,g),this.a.$registerQuickFixProvider(n,h),new D.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,h){const g=new f.CancellationTokenSource().token;if(g.isCancellationRequested)return;const A=this.w.get(n);if(!A)return;const L=await A.provideTerminalQuickFixes(h,g);if(L!==null)return L}async $createContributedProfileTerminal(n,h){const g=new f.CancellationTokenSource().token;let A=await this.v.get(n)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,h);return}this.createTerminalFromOptions(A.options,h)}}async $provideLinks(n,h){const g=this.O(n);if(!g)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const L=new f.CancellationTokenSource;this.z.set(n,L);const q=[],Z={terminal:g.value,line:h},x=[];for(const P of this.u)x.push(l.Promises.withAsyncBody(async B=>{L.token.onCancellationRequested(()=>B({provider:P,links:[]}));const V=await P.provideTerminalLinks(Z,L.token)||[];L.token.isCancellationRequested||B({provider:P,links:V})}));const O=await Promise.all(x);if(L.token.isCancellationRequested)return[];const F=new Map;for(const P of O)P&&P.links.length>0&&q.push(...P.links.map(B=>{const V={id:w++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return F.set(V.id,{provider:P.provider,link:B}),V}));return this.y.set(n,F),q}$activateLink(n,h){const g=this.y.get(n)?.get(h);!g||g.provider.handleTerminalLink(g.link)}N(n,h){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const g=this.h[n];g&&(g.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,h)}O(n){return this.P(this.f,n)}P(n,h){const g=this.Q(n,h);return g!==null?n[g]:null}Q(n,h){let g=null;return n.some((A,L)=>A._id===h?(g=L,!0):!1),g}getEnvironmentVariableCollection(n){let h=this.l.get(n.identifier.value);return h||(h=new o,this.S(n.identifier.value,h)),h}R(n,h){const g=(0,S.serializeEnvironmentVariableCollection)(h.map);this.a.$setEnvironmentVariableCollection(n,h.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(n){n.forEach(h=>{const g=h[0],A=new o(h[1]);this.S(g,A)})}$acceptDefaultProfile(n,h){const g=this.m;this.m=n,this.n=h,g?.path!==n.path&&this.J.fire(n.path)}S(n,h){this.l.set(n,h),h.onDidChangeCollection(()=>{this.R(n,h)})}};s=qe([je(1,C.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class o{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new t.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,h){this.d(n,{value:h,type:D.EnvironmentVariableMutatorType.Replace})}append(n,h){this.d(n,{value:h,type:D.EnvironmentVariableMutatorType.Append})}prepend(n,h){this.d(n,{value:h,type:D.EnvironmentVariableMutatorType.Prepend})}d(n,h){const g=this.map.get(n);(!g||g.value!==h.value||g.type!==h.type)&&(this.map.set(n,h),this.b.fire())}get(n){return this.map.get(n)}forEach(n,h){this.map.forEach((g,A)=>n.call(h,A,g,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let a=class extends s{constructor(n){super(!1,n)}createTerminal(n,h,g){throw new M.NotSupportedError}createTerminalFromOptions(n,h){throw new M.NotSupportedError}};a=qe([je(0,C.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function d(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function c(u){return i.ThemeColor.isThemeColor(u)?u:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t};define(Ce[223],ke([1,0,16,14,24,20,4,187,224,7,23,9,34,5,15,99,8,6,43,68,54]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E){"use strict";var w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(F,P,B){this.j=B,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=F.getProxy(p.MainContext.MainThreadTesting),this.h=new q(this.f),this.g=new u(this.f),P.registerArgumentProcessor({processArgument:V=>{if(V?.$mid!==15)return V;const z=V,ne=z.tests[z.tests.length-1].item.extId;return this.d.get(v.TestId.root(ne))?.collection.tree.get(ne)?.actual??(0,i.toItemFromContext)(V)}})}createTestController(F,P,B){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const V=new k.DisposableStore,z=V.add(new i.ExtHostTestItemCollection(F,P,this.j));z.root.label=P;const ne=new Map,de=this.f,we={items:z.root.children,get label(){return P},set label(ae){P=ae,z.root.label=ae,de.$updateController(F,{label:P})},get refreshHandler(){return B},set refreshHandler(ae){B=ae,de.$updateController(F,{canRefresh:!!ae})},get id(){return F},createRunProfile:(ae,Ie,G,j,re)=>{let me=(0,D.hash)(ae);for(;ne.has(me);)me++;return new Z(this.f,ne,F,me,ae,Ie,G,j,re)},createTestItem(ae,Ie,G){return new i.TestItemImpl(F,ae,Ie,G)},createTestRun:(ae,Ie,G=!0)=>this.g.createTestRun(F,z,ae,Ie,G),set resolveHandler(ae){z.resolveHandler=ae},get resolveHandler(){return z.resolveHandler},dispose:()=>{V.dispose()}};de.$registerTestController(F,P,!!B),V.add((0,k.toDisposable)(()=>de.$unregisterTestController(F)));const ue={controller:we,collection:z,profiles:ne};return this.d.set(F,ue),V.add((0,k.toDisposable)(()=>this.d.delete(F))),V.add(z.onDidGenerateDiff(ae=>de.$publishDiff(F,ae.map(E.TestsDiffOp.serialize)))),we}createTestObserver(){return this.h.checkout()}async runTests(F,P=N.CancellationToken.None){const B=n(F);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.d.get(B.controllerId);if(!V)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(z=>v.TestId.fromExtHostTestItem(z,V.collection.root.id).toString())??[V.collection.root.id],profileGroup:x[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:F.exclude?.map(z=>z.id)},P)}$syncTests(){for(const{collection:F}of this.d.values())F.flushDiff();return Promise.resolve()}$provideFileCoverage(F,P,B){return(0,t.mapFind)(this.g.trackers,z=>z.id===F?z.getCoverage(P):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(F,P,B,V){return(0,t.mapFind)(this.g.trackers,ne=>ne.id===F?ne.getCoverage(P):void 0)?.resolveFileCoverage(B,V)??Promise.resolve([])}$configureRunProfile(F,P){this.d.get(F)?.profiles.get(P)?.configureHandler?.()}async $refreshTests(F,P){await this.d.get(F)?.controller.refreshHandler?.(P)}$publishTestResults(F){this.results=Object.freeze(F.map(P=>(0,M.deepFreeze)(r.TestResults.to(P))).concat(this.results).sort((P,B)=>B.completedAt-P.completedAt).slice(0,32)),this.c.fire()}async $expandTest(F,P){const B=this.d.get(v.TestId.fromString(F).controllerId)?.collection;B&&(await B.expand(F,P<0?1/0:P),B.flushDiff())}$acceptDiff(F){this.h.applyDiff(F.map(E.TestsDiffOp.deserialize))}async $runControllerTests(F,P){return Promise.all(F.map(B=>this.runControllerTestRequest(B,P)))}async runControllerTestRequest(F,P){const B=this.d.get(F.controllerId);if(!B)return{};const{collection:V,profiles:z}=B,ne=z.get(F.profileId);if(!ne)return{};const de=F.testIds.map(Ie=>V.tree.get(Ie)).filter(S.isDefined),we=F.excludeExtIds.map(Ie=>B.collection.tree.get(Ie)).filter(S.isDefined).filter(Ie=>de.some(G=>G.fullId.compare(Ie.fullId)===2));if(!de.length)return{};const ue=new l.TestRunRequest(de.some(Ie=>Ie.actual instanceof i.TestItemRootImpl)?void 0:de.map(Ie=>Ie.actual),we.map(Ie=>Ie.actual),ne),ae=this.g.prepareForMainThreadTestRun(ue,h.fromInternal(F,B.collection),P);try{return await ne.runHandler(ue,P),{}}catch(Ie){return{error:String(Ie)}}finally{ae.hasRunningTasks&&!P.isCancellationRequested&&await C.Event.toPromise(ae.onEnd),ae.dispose()}}$cancelExtensionTestRun(F){F===void 0?this.g.cancelAllRuns():this.g.cancelRunById(F)}};o=qe([je(0,m.IExtHostRpcService)],o),e.ExtHostTesting=o;const a=1e4;var d;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(d||(d={}));class c extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(F,P,B){super(),this.k=F,this.l=P,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new N.CancellationTokenSource(B));const V=this.B(new T.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>V.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(F){return this.f.get(F)?.coverage}createRun(F){const P=this.k.id,B=this.k.controllerId,V=(0,f.generateUuid)(),z=new g(this.l,P,V),ne=ae=>(Ie,...G)=>{if(we){console.warn(`Setting the state of test "${Ie.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(Ie)||(this.s(Ie),ae(Ie,...G))},de=(ae,Ie)=>{const G=Ie instanceof Array?Ie.map(r.TestMessage.from):[r.TestMessage.from(Ie)];if(ae.uri&&ae.range){const j={range:r.Range.from(ae.range),uri:ae.uri};for(const re of G)re.location=re.location||j}this.l.$appendTestMessagesInRun(P,V,v.TestId.fromExtHostTestItem(ae,B).toString(),G)};let we=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:F,get coverageProvider(){return z.coverageProvider},set coverageProvider(ae){z.coverageProvider=ae},enqueued:ne(ae=>{this.l.$updateTestStateInRun(P,V,v.TestId.fromExtHostTestItem(ae,B).toString(),1)}),skipped:ne(ae=>{this.l.$updateTestStateInRun(P,V,v.TestId.fromExtHostTestItem(ae,B).toString(),5)}),started:ne(ae=>{this.l.$updateTestStateInRun(P,V,v.TestId.fromExtHostTestItem(ae,B).toString(),2)}),errored:ne((ae,Ie,G)=>{de(ae,Ie),this.l.$updateTestStateInRun(P,V,v.TestId.fromExtHostTestItem(ae,B).toString(),6,G)}),failed:ne((ae,Ie,G)=>{de(ae,Ie),this.l.$updateTestStateInRun(P,V,v.TestId.fromExtHostTestItem(ae,B).toString(),4,G)}),passed:ne((ae,Ie)=>{this.l.$updateTestStateInRun(P,V,v.TestId.fromExtHostTestItem(ae,this.k.controllerId).toString(),3,Ie)}),appendOutput:(ae,Ie,G)=>{we||(G&&(this.k.isIncluded(G)?this.s(G):G=void 0),this.l.$appendOutputToRun(P,V,y.VSBuffer.fromString(ae),Ie&&r.location.from(Ie),G&&v.TestId.fromExtHostTestItem(G,B).toString()))},end:()=>{we||(we=!0,this.l.$finishedTestRunTask(P,V),this.f.delete(V),this.f.size||this.p())}};return this.f.set(V,{run:ue,coverage:z}),this.l.$startedTestRunTask(P,{id:V,name:F,running:!0}),ue}m(){for(const{run:F}of this.f.values())F.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(F){if(!(F instanceof i.TestItemImpl))throw new b.InvalidTestItemError(F.id);if(this.g.has(v.TestId.fromExtHostTestItem(F,this.k.controllerId).toString()))return;const P=[],B=this.k.colllection.root;for(;;){const V=r.TestItem.from(F);if(P.unshift(V),this.g.has(V.extId)||(this.g.add(V.extId),F===B))break;F=F.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,P)}}class u{get trackers(){return this.c.values()}constructor(F){this.d=F,this.c=new Map}prepareForMainThreadTestRun(F,P,B){return this.f(F,P,B)}cancelRunById(F){for(const P of this.c.values())if(P.id===F){P.cancel();return}}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,P,B,V,z){const ne=this.c.get(B);if(ne)return ne.createRun(V);const de=h.fromPublic(F,P,B,z),we=n(B);this.d.$startedExtensionTestRun({controllerId:F,profile:we&&{group:x[we.kind],id:we.profileId},exclude:B.exclude?.map(ae=>v.TestId.fromExtHostTestItem(ae,P.root.id).toString())??[],id:de.id,include:B.include?.map(ae=>v.TestId.fromExtHostTestItem(ae,P.root.id).toString())??[P.root.id],persist:z});const ue=this.f(B,de);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(de.id),ue.dispose()}),ue.createRun(V)}f(F,P,B){const V=new c(P,this.d,B);return this.c.set(F,V),V.onEnd(()=>this.c.delete(F)),V}}e.TestRunCoordinator=u;const n=O=>{if(!!O.profile){if(!(O.profile instanceof Z))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class h{static fromPublic(F,P,B,V){return new h(F,(0,f.generateUuid)(),B.include?.map(z=>v.TestId.fromExtHostTestItem(z,F).toString())??[F],B.exclude?.map(z=>v.TestId.fromExtHostTestItem(z,F).toString())??[],V,P)}static fromInternal(F,P){return new h(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,P)}constructor(F,P,B,V,z,ne){this.controllerId=F,this.id=P,this.isPersisted=z,this.colllection=ne,this.c=B.map(de=>de+"\0"),this.d=V.map(de=>de+"\0")}isIncluded(F){const P=v.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const B of this.d)if(P===B||P.startsWith(B))return!1;for(const B of this.c)if(P===B||P.startsWith(B))return!0;return!1}}e.TestRunDto=h;class g{set coverageProvider(F){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this.c=F,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(F,P,B){this.f=F,this.g=P,this.h=B}async provideFileCoverage(F){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(F))());try{return(await this.d)?.map(r.TestCoverage.fromFile)??[]}catch(P){throw this.d=void 0,P}}async resolveFileCoverage(F,P){const B=await this.d;let V=B?.[F];return!this.c||!B||!V?[]:(V.detailedCoverage||(V=B[F]=await this.c.resolveFileCoverage?.(V,P)??V),V.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class A{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(F){this.h=F,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,r.TestItem.toPlain(F.item)),this.c.has(F)||this.d.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.d.delete(F);const P=v.TestId.parentId(F.item.extId);if(P&&this.g.has(P.toString())){this.g.add(F.item.extId);return}this.f.add(F)}getChangeEvent(){const{c:F,d:P,f:B}=this;return{get added(){return[...F].map(V=>V.revived)},get updated(){return[...P].map(V=>V.revived)},get removed(){return[...B].map(V=>V.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class L extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(F){return this.d.get(F)}getMirroredTestDataByReference(F){return this.d.get(F.id)}p(F,P){return{...F,revived:r.TestItem.toPlain(F.item),depth:P?P.depth+1:0,children:new Set}}o(){return new A(this.q)}}e.MirroredTestCollection=L;class q{constructor(F){this.d=F}checkout(){this.c||(this.c=this.f());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(P=>P.revived)},dispose:(0,R.once)(()=>{--F.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}f(){const F=new L;return this.d.$subscribeToDiffs(),{observers:0,tests:F}}}class Z{get label(){return this.d}set label(F){F!==this.d&&(this.d=F,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this.f}set isDefault(F){F!==this.f&&(this.f=F,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?r.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}constructor(F,P,B,V,z,ne,de,we=!1,ue=void 0){this.controllerId=B,this.profileId=V,this.d=z,this.kind=ne,this.runHandler=de,this.f=we,this._tag=ue,w.set(this,void 0),s.set(this,void 0),Je(this,w,F,"f"),Je(this,s,P,"f"),P.set(V,this);const ae=x[ne];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${ne}`);Oe(this,w,"f").$publishTestRunProfile({profileId:V,controllerId:B,tag:ue?r.TestTag.namespace(this.controllerId,ue.id):null,label:z,group:ae,isDefault:we,hasConfigurationHandler:!1})}dispose(){Oe(this,s,"f")?.delete(this.profileId)&&(Je(this,s,void 0,"f"),Oe(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=Z,w=new WeakMap,s=new WeakMap;const x={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ce[225],ke([1,0,16,4,5,100,8,6]),function(ee,e,t,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(M,S){this.i=S,this.a=new T.Emitter,this.b=new T.Emitter,this.c=new T.Emitter,this.d=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(y.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(f=>this.g.fire(f)),this.i.onDidChangeActiveTextEditor(f=>this.f.fire(f))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const S=this.i.allEditors();return M?S:S.map(f=>f.value)}async showTextDocument(M,S,f){let p;typeof S=="number"?p={position:C.ViewColumn.from(S),preserveFocus:f}:typeof S=="object"?p={position:C.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?C.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:p={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(M.uri,p),i=m&&this.i.getEditor(m);if(i)return i.value;throw m?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,S){return new N.TextEditorDecorationType(this.h,M,S).value}$acceptEditorPropertiesChanged(M,S){const f=this.i.getEditor(M);if(!f)throw new Error("unknown text editor");if(S.options&&f._acceptOptions(S.options),S.selections){const p=S.selections.selections.map(C.Selection.to);f._acceptSelections(p)}if(S.visibleRanges){const p=t.coalesce(S.visibleRanges.map(C.Range.to));f._acceptVisibleRanges(p)}if(S.options&&this.b.fire({textEditor:f.value,options:{...S.options,lineNumbers:C.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const p=R.TextEditorSelectionChangeKind.fromValue(S.selections.source),m=S.selections.selections.map(C.Selection.to);this.a.fire({textEditor:f.value,selections:m,kind:p})}if(S.visibleRanges){const p=t.coalesce(S.visibleRanges.map(C.Range.to));this.c.fire({textEditor:f.value,visibleRanges:p})}}$acceptEditorPositionData(M){for(const S in M){const f=this.i.getEditor(S);if(!f)throw new Error("Unknown text editor");const p=C.ViewColumn.to(M[S]);f.value.viewColumn!==p&&(f._acceptViewColumn(p),this.d.fire({textEditor:f.value,viewColumn:p}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.ExtHostEditors=D}),define(Ce[226],ke([1,0,2,3,5,7,6,8,25,9]),function(ee,e,t,T,y,N,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class M{constructor(p,m){this.b=new Map,this.c=new Map,this.a=p.getProxy(y.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(i,r)=>{if(i&&i.$mid===12)if(this.b.get(i.source)&&D.ExtensionIdentifier.equals(r,this.b.get(i.source)?.extension)){const l=i.uri===void 0?void 0:t.URI.revive(i.uri);return this.c.get(i.source)?.get(S(l))?.get(i.handle)}else return;return i}})}async $getTimeline(p,m,i,r){return this.b.get(p)?.provider.provideTimeline(t.URI.revive(m),i,r)}registerTimelineProvider(p,m,i,r){const l=new N.DisposableStore,v=this.d(m.id,r,l).bind(this);let b;m.onDidChange&&(b=m.onDidChange(w=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:m.id}),this));const E=this.c;return this.f({...m,scheme:p,onDidChange:void 0,async provideTimeline(w,s,o){s?.resetCache&&(l.clear(),E.get(m.id)?.clear());const a=await m.provideTimeline(w,s,o);if(a==null)return;const d=v(w,s);return{...a,source:m.id,items:a.items.map(d)}},dispose(){for(const w of E.values())w.get(m.id)?.clear();b?.dispose(),l.dispose()}},i)}d(p,m,i){return(r,l)=>{let v;if(l?.cacheResults){let b=this.c.get(p);b===void 0&&(b=new Map,this.c.set(p,b));const E=S(r);v=b.get(E),v===void 0&&(v=new Map,b.set(E,v))}return b=>{const{iconPath:E,...w}=b,s=`${p}|${b.id??b.timestamp}`;v?.set(s,b);let o,a,d;b.iconPath&&(E instanceof C.ThemeIcon?d={id:E.id,color:E.color}:t.URI.isUri(E)?(o=E,a=E):{light:o,dark:a}=E);let c;return C.MarkdownString.isMarkdownString(w.tooltip)?c=R.MarkdownString.from(w.tooltip):(0,k.isString)(w.tooltip)?c=w.tooltip:C.MarkdownString.isMarkdownString(w.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=R.MarkdownString.from(w.detail)):(0,k.isString)(w.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=w.detail),{...w,id:w.id??void 0,handle:s,source:p,command:b.command?m.toInternal(b.command,i):void 0,icon:o,iconDark:a,themeIcon:d,tooltip:c,accessibilityInformation:b.accessibilityInformation}}}}f(p,m){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:m}),(0,N.toDisposable)(()=>{for(const r of this.c.values())r.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=M;function S(f){return f?.toString()}}),define(Ce[227],ke([1,0,7,13,2,5]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(D){this.c=new Map,this.b=D.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,M,S){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const f=S.schemes.find(p=>!C.a.has(p));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(k,M),this.b.$registerUriOpener(k,S.schemes,D,S.label),(0,t.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(D,k,M){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener with id: ${D}`);const f=y.URI.revive(k);return S.canOpenExternalUri(f,M)}async $openUri(D,k,M){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener id: '${D}'`);return S.openExternalUri(y.URI.revive(k.resolvedUri),{sourceUri:y.URI.revive(k.sourceUri)},M)}}e.ExtHostUriOpeners=C,C.a=new Set([T.Schemas.http,T.Schemas.https])}),define(Ce[228],ke([1,0,5,2,7,11,25]),function(ee,e,t,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(t.MainContext.MainThreadUrls)}registerUriHandler(k,M){if(this.c.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const S=R.a++;return this.c.add(C.ExtensionIdentifier.toKey(k)),this.d.set(S,M),this.b.$registerUriHandler(S,k),(0,y.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(k)),this.d.delete(S),this.b.$unregisterUriHandler(S)})}$handleExternalUri(k,M){const S=this.d.get(k);if(!S)return Promise.resolve(void 0);try{S.handleUri(T.URI.revive(M))}catch(f){(0,N.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=R,R.a=0});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[60],ke([1,0,4,13,23,2,152,172,69,5]),function(ee,e,t,T,y,N,C,R,D,k){"use strict";var M,S,f,p,m,i,r,l,v,b,E,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(L,q,Z,x,O,F,P){M.set(this,void 0),S.set(this,void 0),f.set(this,void 0),p.set(this,void 0),m.set(this,void 0),i.set(this,void 0),r.set(this,""),l.set(this,void 0),v.set(this,!1),b.set(this,!1),E.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new t.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new t.Emitter),this._onDidDispose=Oe(this,s,"f").event,Je(this,M,L,"f"),Je(this,S,q,"f"),Je(this,l,Z,"f"),Je(this,p,x,"f"),Je(this,m,O,"f"),Je(this,i,F,"f"),Je(this,E,a(F),"f"),Je(this,w,d(F),"f"),Je(this,f,P,"f")}dispose(){Je(this,v,!0,"f"),Oe(this,s,"f").fire(),Oe(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Je(this,b,!0,"f"),(0,D.asWebviewUri)(L,Oe(this,p,"f"))}get cspSource(){const L=Oe(this,i,"f").extensionLocation;if(L.scheme===T.Schemas.https||L.scheme===T.Schemas.http){let q=L.toString();return q.endsWith("/")||(q+="/"),q+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.a(),Oe(this,r,"f")}set html(L){this.a(),Oe(this,r,"f")!==L&&(Je(this,r,L,"f"),Oe(this,w,"f")&&!Oe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Je(this,b,!0,"f"),Oe(this,f,"f").report("Webview vscode-resource: uris",Oe(this,i,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,S,"f").$setHtml(Oe(this,M,"f"),this.b(L)))}get options(){return this.a(),Oe(this,l,"f")}set options(L){this.a(),y.equals(Oe(this,l,"f"),L)||Oe(this,S,"f").$setOptions(Oe(this,M,"f"),n(Oe(this,i,"f"),Oe(this,m,"f"),L)),Je(this,l,L,"f")}async postMessage(L){if(Oe(this,v,"f"))return!1;const q=(0,R.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,S,"f").$postMessage(Oe(this,M,"f"),q.message,...q.buffers)}a(){if(Oe(this,v,"f"))throw new Error("Webview is disposed")}b(L){if(!Oe(this,w,"f"))return L;const q=Oe(this,i,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,Z=Oe(this,i,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Oe(this,i,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,O,F,P,B,V)=>{const z=N.URI.from({scheme:P||"file",path:decodeURIComponent(B)}),ne=(0,D.asWebviewUri)(z,{isRemote:q,authority:Z}).toString();return`${O}${ne}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,O,F,P,B,V)=>{const z=N.URI.from({scheme:P||"file",path:decodeURIComponent(B)}),ne=(0,D.asWebviewUri)(z,{isRemote:q,authority:Z}).toString();return`${O}${ne}${V}`})}}e.ExtHostWebview=o,M=new WeakMap,S=new WeakMap,f=new WeakMap,p=new WeakMap,m=new WeakMap,i=new WeakMap,r=new WeakMap,l=new WeakMap,v=new WeakMap,b=new WeakMap,E=new WeakMap,w=new WeakMap,s=new WeakMap;function a(A){try{const L=(0,C.normalizeVersion)((0,C.parseVersion)(A.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function d(A){try{const L=(0,C.normalizeVersion)((0,C.parseVersion)(A.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class c{constructor(L,q,Z,x,O){this.c=q,this.d=Z,this.e=x,this.f=O,this.b=new Map,this.a=L.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(L,q,Z){const x=this.g(L);if(x){const{message:O}=(0,R.deserializeWebviewMessage)(q,Z.value);x._onMessageEmitter.fire(O)}}$onMissingCsp(L,q){this.e.warn(`${q} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,q,Z){const x=new o(L,this.a,h(q),this.c,this.d,Z,this.f);return this.b.set(L,x),x._onDidDispose(()=>{this.b.delete(L)}),x}deleteWebview(L){this.b.delete(L)}g(L){return this.b.get(L)}}e.ExtHostWebviews=c;function u(A){return{id:A.identifier,location:A.extensionLocation}}e.toExtensionData=u;function n(A,L,q){return{enableCommandUris:q.enableCommandUris,enableScripts:q.enableScripts,enableForms:q.enableForms,portMapping:q.portMapping,localResourceRoots:q.localResourceRoots||g(A,L)}}e.serializeWebviewOptions=n;function h(A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,enableForms:A.enableForms,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots?.map(L=>N.URI.from(L))}}function g(A,L){return[...(L?.getWorkspaceFolders()||[]).map(q=>q.uri),A.extensionLocation]}}),define(Ce[229],ke([1,0,20,224,7,13,22,2,8,60,52,5,6]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(o,a){this.document=o,this.b=a,this.a=1,this.c=new M.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,a){await this.f(o).undo(),a||this.disposeBackup()}async redo(o,a){await this.f(o).redo(),a||this.disposeBackup()}disposeEdits(o){for(const a of o)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=w(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const a=this.c.get(o,0);if(!a)throw new Error("No edit found");return a}}class m{constructor(){this.a=new Map}get(o,a){return this.a.get(this.b(o,a))}add(o,a,d){const c=this.b(o,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${o} resource:${a.uri}`);const u=new p(a,d);return this.a.set(c,u),u}delete(o,a){const d=this.b(o,a.uri);this.a.delete(d)}b(o,a){return`${o}@@@${a}`}}var i;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(i||(i={}));class r{constructor(){this.a=new Map}addTextProvider(o,a,d){return this.b(0,o,a,d)}addCustomProvider(o,a,d){return this.b(1,o,a,d)}get(o){return this.a.get(o)}b(o,a,d,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:o,extension:d,provider:c}),new f.Disposable(()=>this.a.delete(a))}}class l{constructor(o,a,d,c,u){this.d=a,this.f=d,this.g=c,this.h=u,this.b=new r,this.c=new m,this.a=o.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,a,d,c){const u=new y.DisposableStore;return b(d)?(u.add(this.b.addTextProvider(a,o,d)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(o),a,c.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(o))):(u.add(this.b.addCustomProvider(a,o,d)),v(d)&&u.add(d.onDidChangeCustomDocument(n=>{const h=this.i(a,n.document.uri);if(E(n)){const g=h.addEdit(n);this.a.$onDidEdit(n.document.uri,a,g,n.label)}else this.a.$onContentChange(n.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(o),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(o))),f.Disposable.from(u,new f.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(o,a,d,c,u){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${a}'`);const h=R.URI.revive(o),g=await n.provider.openCustomDocument(h,{backupId:d,untitledDocumentData:c?.buffer},u);let A;return v(n.provider)&&this.f&&(A=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(a,g,A),{editable:v(n.provider)}}async $disposeCustomDocument(o,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=R.URI.revive(o),{document:u}=this.i(a,c);this.c.delete(a,u),u.dispose()}async $resolveCustomEditor(o,a,d,c,u,n){console.log("xxxx");const h=this.b.get(d);if(!h)throw new Error(`No provider found for '${d}'`);const g=D.ViewColumn.to(u),A=this.g.createNewWebview(a,c.contentOptions,h.extension),L=this.h.createNewWebviewPanel(a,d,c.title,g,c.options,A,!0),q=R.URI.revive(o);switch(h.type){case 1:{const{document:Z}=this.i(d,q);return h.provider.resolveCustomEditor(Z,L,n)}case 0:{const Z=this.d.getDocument(q);return h.provider.resolveCustomTextEditor(Z,L,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,a,d){this.i(a,o).disposeEdits(d)}async $onMoveCustomEditor(o,a,d){const c=this.b.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this.h.getWebviewPanel(o);if(!u)throw new Error("No webview found");const n=R.URI.revive(a),h=this.d.getDocument(n);await c.provider.moveCustomTextEditor(h,u,t.CancellationToken.None)}async $undo(o,a,d,c){return this.i(a,o).undo(d,c)}async $redo(o,a,d,c){return this.i(a,o).redo(d,c)}async $revert(o,a,d){const c=this.i(a,o);await this.j(a).revertCustomDocument(c.document,d),c.disposeBackup()}async $onSave(o,a,d){const c=this.i(a,o);await this.j(a).saveCustomDocument(c.document,d),c.disposeBackup()}async $onSaveAs(o,a,d,c){const u=this.i(a,o);return this.j(a).saveCustomDocumentAs(u.document,R.URI.revive(d),c)}async $backup(o,a,d){const c=this.i(a,o),n=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},d);return c.updateBackup(n),n.id}i(o,a){const d=this.c.get(o,R.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(o){const d=this.b.get(o)?.provider;if(!d||!v(d))throw new Error("Custom document is not editable");return d}}e.ExtHostCustomEditors=l;function v(s){return!!s.onDidChangeCustomDocument}function b(s){return typeof s.resolveCustomTextEditor=="function"}function E(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function w(s){const o=s.scheme===N.Schemas.file||s.scheme===N.Schemas.untitled?s.fsPath:s.toString();return(0,T.hash)(o)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[230],ke([1,0,4,7,2,34,8,60,5,6]),function(ee,e,t,T,y,N,C,R,D,k){"use strict";var M,S,f,p,m,i,r,l,v,b,E,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends T.Disposable{constructor(u,n,h,g){super(),M.set(this,void 0),S.set(this,void 0),f.set(this,void 0),p.set(this,void 0),m.set(this,void 0),i.set(this,void 0),r.set(this,void 0),l.set(this,void 0),v.set(this,!0),b.set(this,void 0),E.set(this,!1),w.set(this,this.B(new t.Emitter)),this.onDidDispose=Oe(this,w,"f").event,s.set(this,this.B(new t.Emitter)),this.onDidChangeViewState=Oe(this,s,"f").event,Je(this,M,u,"f"),Je(this,S,n,"f"),Je(this,p,h,"f"),Je(this,f,g.viewType,"f"),Je(this,m,g.panelOptions,"f"),Je(this,l,g.viewColumn,"f"),Je(this,i,g.title,"f"),Je(this,b,g.active,"f")}dispose(){Oe(this,E,"f")||(Je(this,E,!0,"f"),Oe(this,w,"f").fire(),Oe(this,S,"f").$disposeWebview(Oe(this,M,"f")),Oe(this,p,"f").dispose(),super.dispose())}get webview(){return this.c(),Oe(this,p,"f")}get viewType(){return this.c(),Oe(this,f,"f")}get title(){return this.c(),Oe(this,i,"f")}set title(u){this.c(),Oe(this,i,"f")!==u&&(Je(this,i,u,"f"),Oe(this,S,"f").$setTitle(Oe(this,M,"f"),u))}get iconPath(){return this.c(),Oe(this,r,"f")}set iconPath(u){this.c(),Oe(this,r,"f")!==u&&(Je(this,r,u,"f"),Oe(this,S,"f").$setIconPath(Oe(this,M,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Oe(this,m,"f")}get viewColumn(){if(this.c(),!(typeof Oe(this,l,"f")=="number"&&Oe(this,l,"f")<0))return Oe(this,l,"f")}get active(){return this.c(),Oe(this,b,"f")}get visible(){return this.c(),Oe(this,v,"f")}_updateViewState(u){Oe(this,E,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Je(this,b,u.active,"f"),Je(this,v,u.visible,"f"),Je(this,l,u.viewColumn,"f"),Oe(this,s,"f").fire({webviewPanel:this}))}reveal(u,n){this.c(),Oe(this,S,"f").$reveal(Oe(this,M,"f"),{viewColumn:typeof u>"u"?void 0:C.ViewColumn.from(u),preserveFocus:!!n})}c(){if(Oe(this,E,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,S=new WeakMap,f=new WeakMap,p=new WeakMap,m=new WeakMap,i=new WeakMap,r=new WeakMap,l=new WeakMap,v=new WeakMap,b=new WeakMap,E=new WeakMap,w=new WeakMap,s=new WeakMap;class a{static c(){return(0,N.generateUuid)()}constructor(u,n,h){this.g=n,this.h=h,this.e=new Map,this.f=new Map,this.d=u.getProxy(D.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,n,h,g,A={}){const L=typeof g=="object"?g.viewColumn:g,q={viewColumn:C.ViewColumn.from(L),preserveFocus:typeof g=="object"&&!!g.preserveFocus},Z=(0,R.shouldSerializeBuffersForPostMessage)(u),x=a.c();this.d.$createWebviewPanel((0,R.toExtensionData)(u),x,n,{title:h,panelOptions:d(A),webviewOptions:(0,R.serializeWebviewOptions)(u,this.h,A),serializeBuffersForPostMessage:Z},q);const O=this.g.createNewWebview(x,A,u);return this.createNewWebviewPanel(x,n,h,L,A,O,!0)}$onDidChangeWebviewPanelViewStates(u){const n=Object.keys(u);n.sort((h,g)=>{const A=u[h],L=u[g];return A.active?1:L.active?-1:+A.visible-+L.visible});for(const h of n){const g=this.getWebviewPanel(h);if(!g)continue;const A=u[h];g._updateViewState({active:A.active,visible:A.visible,viewColumn:C.ViewColumn.to(A.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,n,h){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:h,extension:u}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(u)}),new k.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(u,n,h,g){const A=this.f.get(n);if(!A)throw new Error(`No serializer found for '${n}'`);const{serializer:L,extension:q}=A,Z=this.g.createNewWebview(u,h.webviewOptions,q),x=this.createNewWebviewPanel(u,n,h.title,g,h.panelOptions,Z,h.active);await L.deserializeWebviewPanel(x,h.state)}createNewWebviewPanel(u,n,h,g,A,L,q){const Z=new o(u,this.d,L,{viewType:n,title:h,viewColumn:g,panelOptions:A,active:q});return this.e.set(u,Z),Z}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=a;function d(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[231],ke([1,0,4,7,60,8,5,6]),function(ee,e,t,T,y,N,C,R){"use strict";var D,k,M,S,f,p,m,i,r,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends T.Disposable{constructor(s,o,a,d,c,u){super(),D.set(this,void 0),k.set(this,void 0),M.set(this,void 0),S.set(this,void 0),f.set(this,!1),p.set(this,void 0),m.set(this,void 0),i.set(this,void 0),r.set(this,void 0),l.set(this,this.B(new t.Emitter)),this.onDidChangeVisibility=Oe(this,l,"f").event,v.set(this,this.B(new t.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Je(this,M,a,"f"),Je(this,m,d,"f"),Je(this,D,s,"f"),Je(this,k,o,"f"),Je(this,S,c,"f"),Je(this,p,u,"f")}dispose(){Oe(this,f,"f")||(Je(this,f,!0,"f"),Oe(this,v,"f").fire(),Oe(this,S,"f").dispose(),super.dispose())}get title(){return this.a(),Oe(this,m,"f")}set title(s){this.a(),Oe(this,m,"f")!==s&&(Je(this,m,s,"f"),Oe(this,k,"f").$setWebviewViewTitle(Oe(this,D,"f"),s))}get description(){return this.a(),Oe(this,i,"f")}set description(s){this.a(),Oe(this,i,"f")!==s&&(Je(this,i,s,"f"),Oe(this,k,"f").$setWebviewViewDescription(Oe(this,D,"f"),s))}get visible(){return Oe(this,p,"f")}get webview(){return Oe(this,S,"f")}get viewType(){return Oe(this,M,"f")}_setVisible(s){s===Oe(this,p,"f")||Oe(this,f,"f")||(Je(this,p,s,"f"),Oe(this,l,"f").fire())}get badge(){return this.a(),Oe(this,r,"f")}set badge(s){this.a(),!(s?.value===Oe(this,r,"f")?.value&&s?.tooltip===Oe(this,r,"f")?.tooltip)&&(Je(this,r,N.ViewBadge.from(s),"f"),Oe(this,k,"f").$setWebviewViewBadge(Oe(this,D,"f"),s))}show(s){this.a(),Oe(this,k,"f").$show(Oe(this,D,"f"),!!s)}a(){if(Oe(this,f,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,k=new WeakMap,M=new WeakMap,S=new WeakMap,f=new WeakMap,p=new WeakMap,m=new WeakMap,i=new WeakMap,r=new WeakMap,l=new WeakMap,v=new WeakMap;class E{constructor(s,o){this.d=o,this.b=new Map,this.c=new Map,this.a=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,o,a,d){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:a,extension:s}),this.a.$registerWebviewViewProvider((0,y.toExtensionData)(s),o,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(s)}),new R.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(s,o,a,d,c){const u=this.b.get(o);if(!u)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:h}=u,g=this.d.createNewWebview(s,{},h),A=new b(s,this.a,o,a,g,!0);this.c.set(s,A),await n.resolveWebviewView(A,{state:d},c)}async $onDidChangeWebviewViewVisibility(s,o){this.e(s)._setVisible(o)}async $disposeWebviewView(s){const o=this.e(s);this.c.delete(s),o.dispose(),this.d.deleteWebview(s)}e(s){const o=this.c.get(s);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=E}),define(Ce[102],ke([1,0,4,5,2,13,10,3,15]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class rn{get state(){return this.d}constructor(S){this.c=new t.Emitter,this.onDidChangeWindowState=this.c.event,this.d=rn.a,this.b=S.getProxy(T.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(S){S!==this.d.focused&&(this.d={...this.d,focused:S},this.c.fire(this.d))}openUri(S,f){let p;if(typeof S=="string"){p=S;try{S=y.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,C.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,p,f)}async asExternalUri(S,f){if((0,C.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(S,f);return y.URI.from(p)}};k.a={focused:!0},k=qe([je(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Ce[232],ke([1,0,202,27,15]),function(ee,e,t,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=class extends t.AbstractExtHostConsoleForwarder{constructor(R,D){super(R,D)}f(R,D,k){D.apply(console,k)}};N=qe([je(0,y.IExtHostRpcService),je(1,T.IExtHostInitDataService)],N),e.ExtHostConsoleForwarder=N}),define(Ce[233],ke([1,0,14,24,20,11,4,7,125,196,44]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(A,L){try{return JSON.stringify(A,L)}catch{return"null"}}const p="$$ref$$",m={[p]:-1};class i{constructor(L,q){this.jsonString=L,this.referencedBuffers=q}}function r(A,L=null,q=!1){const Z=[];return{jsonString:(q?f:JSON.stringify)(A,(O,F)=>{if(typeof F>"u")return m;if(typeof F=="object"){if(F instanceof T.VSBuffer){const P=Z.push(F)-1;return{[p]:P}}if(L)return L(O,F)}return F}),referencedBuffers:Z}}e.stringifyJsonWithBufferRefs=r;function l(A,L,q){return JSON.parse(A,(Z,x)=>{if(x){const O=x[p];if(typeof O=="number")return L[O];if(q&&x.$mid===1)return q.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=l;function v(A,L){return JSON.stringify(A,L)}function b(A){return A?(L,q)=>q&&q.$mid===1?A.transformOutgoing(q):q:null}var E;(function(A){A[A.LocalSide=0]="LocalSide",A[A.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(A){A[A.Responsive=0]="Responsive",A[A.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},o=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends R.Disposable{constructor(L,q=null,Z=null){super(),this[S]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=q,this.g=Z,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,O=M.ProxyIdentifier.count;x<O;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new t.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.s).forEach(L=>{this.s[L].resolveErr(N.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(L){this.u===0&&(this.v=Date.now()+d.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(L){this.v=Date.now()+d.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(L){this.t!==L&&(this.t=L,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(L){return this.g?(0,D.transformIncomingURIs)(L,this.g):L}getProxy(L){const{nid:q,sid:Z}=L;return this.l[q]||(this.l[q]=this.F(q,Z)),this.l[q]}F(L,q){const Z={get:(x,O)=>(typeof O=="string"&&!x[O]&&O.charCodeAt(0)===36&&(x[O]=(...F)=>this.O(L,O,F)),O===a?q:x[O])};return new Proxy(Object.create(null),Z)}set(L,q){return this.k[L.nid]=q,q}assertRegistered(L){for(let q=0,Z=L.length;q<Z;q++){const x=L[q];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(L){if(this.j)return;const q=L.byteLength,Z=c.read(L,0),x=Z.readUInt8(),O=Z.readUInt32();switch(x){case 1:case 2:{let{rpcId:F,method:P,args:B}=n.deserializeRequestJSONArgs(Z);this.g&&(B=(0,D.transformIncomingURIs)(B,this.g)),this.H(q,O,F,P,B,x===2);break}case 3:case 4:{let{rpcId:F,method:P,args:B}=n.deserializeRequestMixedArgs(Z);this.g&&(B=(0,D.transformIncomingURIs)(B,this.g)),this.H(q,O,F,P,B,x===4);break}case 5:{this.f?.logIncoming(q,O,0,"ack"),this.z(O);break}case 6:{this.I(q,O);break}case 7:{this.J(q,O,void 0);break}case 9:{let F=n.deserializeReplyOKJSON(Z);this.g&&(F=(0,D.transformIncomingURIs)(F,this.g)),this.J(q,O,F);break}case 10:{const F=n.deserializeReplyOKJSONWithBuffers(Z,this.g);this.J(q,O,F);break}case 8:{const F=n.deserializeReplyOKVSBuffer(Z);this.J(q,O,F);break}case 11:{let F=n.deserializeReplyErrError(Z);this.g&&(F=(0,D.transformIncomingURIs)(F,this.g)),this.L(q,O,F);break}case 12:{this.L(q,O,void 0);break}default:console.error("received unexpected message"),console.error(L)}}H(L,q,Z,x,O,F){this.f?.logIncoming(L,q,1,`receiveRequest ${(0,M.getStringIdentifierForProxy)(Z)}.${x}(`,O);const P=String(q);let B,V;if(F){const ne=new y.CancellationTokenSource;O.push(ne.token),B=this.M(Z,x,O),V=()=>ne.cancel()}else B=this.M(Z,x,O),V=s;this.p[P]=V;const z=n.serializeAcknowledged(q);this.f?.logOutgoing(z.byteLength,q,1,"ack"),this.c.send(z),B.then(ne=>{delete this.p[P];const de=n.serializeReplyOK(q,ne,this.h);this.f?.logOutgoing(de.byteLength,q,1,"reply:",ne),this.c.send(de)},ne=>{delete this.p[P];const de=n.serializeReplyErr(q,ne);this.f?.logOutgoing(de.byteLength,q,1,"replyErr:",ne),this.c.send(de)})}I(L,q){this.f?.logIncoming(L,q,1,"receiveCancel");const Z=String(q);this.p[Z]?.()}J(L,q,Z){this.f?.logIncoming(L,q,0,"receiveReply:",Z);const x=String(q);if(!this.s.hasOwnProperty(x))return;const O=this.s[x];delete this.s[x],O.resolveOk(Z)}L(L,q,Z){this.f?.logIncoming(L,q,0,"receiveReplyErr:",Z);const x=String(q);if(!this.s.hasOwnProperty(x))return;const O=this.s[x];delete this.s[x];let F;Z&&(Z.$isError?(F=new Error,F.name=Z.name,F.message=Z.message,F.stack=Z.stack):F=Z),O.resolveErr(F)}M(L,q,Z){try{return Promise.resolve(this.N(L,q,Z))}catch(x){return Promise.reject(x)}}N(L,q,Z){const x=this.k[L];if(!x)throw new Error("Unknown actor "+(0,M.getStringIdentifierForProxy)(L));const O=x[q];if(typeof O!="function")throw new Error("Unknown method "+q+" on actor "+(0,M.getStringIdentifierForProxy)(L));return O.apply(x,Z)}O(L,q,Z){if(this.j)return new k.CanceledLazyPromise;let x=null;if(Z.length>0&&y.CancellationToken.isCancellationToken(Z[Z.length-1])&&(x=Z.pop()),x&&x.isCancellationRequested)return Promise.reject(N.canceled());const O=n.serializeRequestArguments(Z,this.h),F=++this.m,P=String(F),B=new k.LazyPromise;x&&x.onCancellationRequested(()=>{const z=n.serializeCancel(F);this.f?.logOutgoing(z.byteLength,F,0,"cancel"),this.c.send(n.serializeCancel(F))}),this.s[P]=B,this.y(F);const V=n.serializeRequest(F,L,q,O,!!x);return this.f?.logOutgoing(V.byteLength,F,0,`request: ${(0,M.getStringIdentifierForProxy)(L)}.${q}(`,Z),this.c.send(V),B}}e.RPCProtocol=d,S=o,d.a=3*1e3;class c{static alloc(L,q,Z){const x=new c(T.VSBuffer.alloc(Z+1+4),0);return x.writeUInt8(L),x.writeUInt32(q),x}static read(L,q){return new c(L,q)}get buffer(){return this.a}constructor(L,q){this.a=L,this.b=q}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+L).toString();return this.b+=L,Z}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+L).toString();return this.b+=L,Z}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+L);return this.b+=L,q}static sizeMixedArray(L){let q=0;q+=1;for(let Z=0,x=L.length;Z<x;Z++){const O=L[Z];switch(q+=1,O.type){case 1:q+=this.sizeLongString(O.value);break;case 2:q+=this.sizeVSBuffer(O.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(O.value);for(let F=0;F<O.buffers.length;++F)q+=this.sizeVSBuffer(O.buffers[F]);break;case 4:break}}return q}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let q=0,Z=L.length;q<Z;q++){const x=L[q];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let O=0;O<x.buffers.length;++O)this.writeBuffer(x.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const q=new Array(L);for(let Z=0;Z<L;Z++)switch(this.readUInt8()){case 1:q[Z]=this.readLongString();break;case 2:q[Z]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),F=this.readLongString(),P=[];for(let B=0;B<O;++B)P.push(this.readVSBuffer());q[Z]=new M.SerializableObjectWithBuffers(l(F,P,null));break}case 4:q[Z]=void 0;break}return q}}c.sizeUInt32=4;var u;(function(A){A[A.Simple=0]="Simple",A[A.Mixed=1]="Mixed"})(u||(u={}));class n{static a(L){for(let q=0,Z=L.length;q<Z;q++)if(L[q]instanceof T.VSBuffer||L[q]instanceof M.SerializableObjectWithBuffers||typeof L[q]>"u")return!0;return!1}static serializeRequestArguments(L,q){if(this.a(L)){const Z=[];for(let x=0,O=L.length;x<O;x++){const F=L[x];if(F instanceof T.VSBuffer)Z[x]={type:2,value:F};else if(typeof F>"u")Z[x]={type:4};else if(F instanceof M.SerializableObjectWithBuffers){const{jsonString:P,referencedBuffers:B}=r(F.value,q);Z[x]={type:3,value:T.VSBuffer.fromString(P),buffers:B}}else Z[x]={type:1,value:T.VSBuffer.fromString(v(F,q))}}return{type:1,args:Z}}return{type:0,args:v(L,q)}}static serializeRequest(L,q,Z,x,O){switch(x.type){case 0:return this.b(L,q,Z,x.args,O);case 1:return this.c(L,q,Z,x.args,O)}}static b(L,q,Z,x,O){const F=T.VSBuffer.fromString(Z),P=T.VSBuffer.fromString(x);let B=0;B+=c.sizeUInt8(),B+=c.sizeShortString(F),B+=c.sizeLongString(P);const V=c.alloc(O?2:1,L,B);return V.writeUInt8(q),V.writeShortString(F),V.writeLongString(P),V.buffer}static deserializeRequestJSONArgs(L){const q=L.readUInt8(),Z=L.readShortString(),x=L.readLongString();return{rpcId:q,method:Z,args:JSON.parse(x)}}static c(L,q,Z,x,O){const F=T.VSBuffer.fromString(Z);let P=0;P+=c.sizeUInt8(),P+=c.sizeShortString(F),P+=c.sizeMixedArray(x);const B=c.alloc(O?4:3,L,P);return B.writeUInt8(q),B.writeShortString(F),B.writeMixedArray(x),B.buffer}static deserializeRequestMixedArgs(L){const q=L.readUInt8(),Z=L.readShortString(),x=L.readMixedArray(),O=new Array(x.length);for(let F=0,P=x.length;F<P;F++){const B=x[F];typeof B=="string"?O[F]=JSON.parse(B):O[F]=B}return{rpcId:q,method:Z,args:O}}static serializeAcknowledged(L){return c.alloc(5,L,0).buffer}static serializeCancel(L){return c.alloc(6,L,0).buffer}static serializeReplyOK(L,q,Z){if(typeof q>"u")return this.d(L);if(q instanceof T.VSBuffer)return this.e(L,q);if(q instanceof M.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:O}=r(q.value,Z,!0);return this.g(L,x,O)}else return this.f(L,f(q,Z))}static d(L){return c.alloc(7,L,0).buffer}static e(L,q){let Z=0;Z+=c.sizeVSBuffer(q);const x=c.alloc(8,L,Z);return x.writeVSBuffer(q),x.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,q){const Z=T.VSBuffer.fromString(q);let x=0;x+=c.sizeLongString(Z);const O=c.alloc(9,L,x);return O.writeLongString(Z),O.buffer}static g(L,q,Z){const x=T.VSBuffer.fromString(q);let O=0;O+=c.sizeUInt32,O+=c.sizeLongString(x);for(const P of Z)O+=c.sizeVSBuffer(P);const F=c.alloc(10,L,O);F.writeUInt32(Z.length),F.writeLongString(x);for(const P of Z)F.writeBuffer(P);return F.buffer}static deserializeReplyOKJSON(L){const q=L.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(L,q){const Z=L.readUInt32(),x=L.readLongString(),O=[];for(let F=0;F<Z;++F)O.push(L.readVSBuffer());return new M.SerializableObjectWithBuffers(l(x,O,q))}static serializeReplyErr(L,q){const Z=q?f(N.transformErrorForSerialization(q),null):void 0;if(typeof Z!="string")return this.h(L);const x=T.VSBuffer.fromString(Z);let O=0;O+=c.sizeLongString(x);const F=c.alloc(11,L,O);return F.writeLongString(x),F.buffer}static deserializeReplyErrError(L){const q=L.readLongString();return JSON.parse(q)}static h(L){return c.alloc(12,L,0).buffer}}var h;(function(A){A[A.RequestJSONArgs=1]="RequestJSONArgs",A[A.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",A[A.RequestMixedArgs=3]="RequestMixedArgs",A[A.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",A[A.Acknowledged=5]="Acknowledged",A[A.Cancel=6]="Cancel",A[A.ReplyOKEmpty=7]="ReplyOKEmpty",A[A.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",A[A.ReplyOKJSON=9]="ReplyOKJSON",A[A.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",A[A.ReplyErrError=11]="ReplyErrError",A[A.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var g;(function(A){A[A.String=1]="String",A[A.VSBuffer=2]="VSBuffer",A[A.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",A[A.Undefined=4]="Undefined"})(g||(g={}))}),define(Ce[234],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const t=function(N){const C=R=>{self.removeEventListener("message",C);const D=R.data;Object.defineProperties(self,{postMessage:{value(k,M){D.postMessage(k,M)}},onmessage:{get(){return D.onmessage},set(k){D.onmessage=k}}}),D.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};self.addEventListener("message",C)}.toString();class T extends EventTarget{constructor(N,C,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${t})('${C}'))`,k=new Blob([D],{type:"application/javascript"}),M=URL.createObjectURL(k),S=new MessageChannel,f=M,p={type:"_newWorker",id:f,port:S.port2,url:M,options:R};N(p,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{N({type:"_terminateWorker",id:f}),URL.revokeObjectURL(M),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(m){S.port1.onmessage=m}},onmessageerror:{get(){return S.port1.onmessageerror},set(m){S.port1.onmessageerror=m}}}),S.port1.addEventListener("messageerror",m=>{const i=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(i)}),S.port1.addEventListener("message",m=>{const i=new MessageEvent("message",{data:m.data});this.dispatchEvent(i)}),S.port1.start()}}e.NestedWorker=T}),define(Ce[235],ke([1,0,4,30,42,3,36,11,14]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class M{constructor(){this.a=new Map,this.b=new t.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new t.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(m){this.a.has(m.id)||(this.a.set(m.id,m),this.b.fire(m.id))}getChannels(){const m=[];return this.a.forEach(i=>m.push(i)),m}getChannel(m){return this.a.get(m)}removeChannel(m){this.a.delete(m),this.c.fire(m)}}T.Registry.add(e.Extensions.OutputChannels,new M);function S(p,m,i,r,l){return(0,D.createCancelablePromise)(async v=>{await(0,C.whenProviderRegistered)(i,r);const b=T.Registry.as(e.Extensions.OutputChannels);try{await f(i,1,r,l,v),b.registerChannel({id:p,label:m,file:i,log:!0})}catch(E){(0,R.isCancellationError)(E)||l.error("Error while registering log channel",i.toString(),(0,R.getErrorMessage)(E))}})}e.registerLogChannel=S;async function f(p,m,i,r,l){if(!await i.exists(p)){if(l.isCancellationRequested)throw new R.CancellationError;if(m>10)throw new Error("Timed out while waiting for file to be created");r.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",p.toString()),await(0,D.timeout)(1e3,l),await f(p,m+1,i,r,l)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(Ce[103],ke([1,0,5,3,15,25,12,235,58,27,37,118,24,9,36,4,7]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(w,s,o,a,d){super(),this.id=w,this.name=s,this.m=o,this.n=a,this.extension=d,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,w)}replace(w){const s=this.k;this.info(w),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,s),this.visible&&this.m.flush()}show(w,s){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:s))}hide(){this.n.$close(this.id)}g(w,s){this.k+=f.VSBuffer.fromString(s).byteLength,(0,C.log)(this.m,w,s),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class v extends l{appendLine(w){this.append(w)}}let b=class{constructor(w,s,o,a,d,c){this.i=s,this.j=o,this.k=a,this.l=d,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(t.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[s,o]of this.g)o.visible=s===this.h}createOutputChannel(w,s,o){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const a=typeof s=="object"&&s.log,d=(0,p.isString)(s)?s:void 0;if((0,p.isString)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const u=this.i.environment.extensionLogLevel?.find(([h])=>N.ExtensionIdentifier.equals(o.identifier,h))?.[1];u&&(c=(0,C.parseLogLevel)(u));const n=a?this.o(w,c,o):this.n(w,d,o);return n.then(h=>{this.g.set(h.id,h),h.visible=h.id===this.h}),a?this.r(w,c??this.m.getLevel(),n):this.q(w,n)}async n(w,s,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(w,d,!1,s,o.identifier.value);return new l(u,w,c,this.a,o)}async o(w,s,o){const a=await this.p(o),d=this.k.extUri.joinPath(a,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{name:w},s),u=await this.a.$register(w,d,!0,void 0,o.identifier.value);return new v(u,w,c,this.a,o)}p(w){let s=this.d.get(w.identifier.value);if(!s){const o=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(o)}catch(a){if((0,m.toFileSystemProviderErrorCode)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}return o})())}return s}q(w,s){let o=!1;const a=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return w},append(d){a(),s.then(c=>c.append(d))},appendLine(d){a(),s.then(c=>c.appendLine(d))},clear(){a(),s.then(d=>d.clear())},replace(d){a(),s.then(c=>c.replace(d))},show(d,c){a(),s.then(u=>u.show(d,c))},hide(){a(),s.then(d=>d.hide())},dispose(){o=!0,s.then(d=>d.dispose())}}}r(w,s,o){const a=new r.DisposableStore,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new i.Emitter);return o.then(u=>{a.add(u),a.add(u.onDidChangeLogLevel(n=>{s=n,c.fire(n)}))}),{...this.q(w,o),get logLevel(){return s},onDidChangeLogLevel:c.event,trace(u,...n){d(),o.then(h=>h.trace(u,...n))},debug(u,...n){d(),o.then(h=>h.debug(u,...n))},info(u,...n){d(),o.then(h=>h.info(u,...n))},warn(u,...n){d(),o.then(h=>h.warn(u,...n))},error(u,...n){d(),o.then(h=>h.error(u,...n))},dispose(){a.dispose()}}}};b=qe([je(0,y.IExtHostRpcService),je(1,k.IExtHostInitDataService),je(2,D.IExtHostConsumerFileSystem),je(3,M.IExtHostFileSystemInfo),je(4,C.ILoggerService),je(5,C.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Ce[236],ke([1,0,3]),function(ee,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,t.createDecorator)("remoteAgentService")}),define(Ce[237],ke([1,0,40,13,19,21,22,2,3,168,51,183,236]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let p=class sn{constructor(i,r,l,v){this.d=i,this.e=r,this.f=l,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??i})()}hasValidBasename(i,r,l){return typeof r=="string"||typeof r>"u"?this.a.then(v=>this.h(i,v,r)):this.h(i,r,l)}h(i,r,l){return i.scheme===T.Schemas.file||i.scheme===T.Schemas.vscodeRemote?(0,t.isValidBasename)(l??(0,C.basename)(i),r===1):!0}get defaultUriScheme(){return sn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(i,r){if(i.remoteAuthority)return T.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(r.getWorkspace());if(l)return l;const v=r.getWorkspace().folders[0];if(v)return v.uri.scheme;const b=r.getWorkspace().configuration;return b?b.scheme:T.Schemas.file}userHome(i){return i?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(i=>i===1?y.win32:y.posix)}async fileURI(i){let r="";if(await this.a===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const v=i.indexOf("/",2);v===-1?(r=i.substring(2),i="/"):(r=i.substring(2,v),i=i.substring(v)||"/")}return R.URI.from({scheme:T.Schemas.file,authority:r,path:i,query:"",fragment:""})}};p=qe([je(1,f.IRemoteAgentService),je(2,S.IWorkbenchEnvironmentService),je(3,M.IWorkspaceContextService)],p),e.AbstractPathService=p}),define(Ce[104],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class t{constructor(C,R){this.line=C,this.character=R}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,R){return new t(0,0)}with(C){return new t(0,0)}}e.Position=t;class T{constructor(C,R,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new t(C,R),this.end=new t(D,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new T(0,0,0,0)}with(C){return new T(0,0,0,0)}}e.Range=T;var y;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[45],ke([1,0,16,35,23,40,10,3,19,11,104,14]),function(ee,e,t,T,y,N,C,R,D,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",p=" characters skipped \u27EB",m=(f.length+p.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var i;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(i=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function l(ue){return!!ue.preview}e.resultIsMatch=l;function v(ue){return!!ue.resource}e.isFileMatch=v;function b(ue){return!!ue.message}e.isProgressMessage=b;var E;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(E=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(ae){this.resource=ae,this.results=[]}}e.FileMatch=w;class s{constructor(ae,Ie,G){this.ranges=Ie;const j=Array.isArray(Ie)?Ie:[Ie];if(G&&G.matchLines===1&&o(j)){ae=(0,C.getNLines)(ae,G.matchLines);let re="",me=0,Te=0;const Be=Math.floor(G.charsPerLine/5),Ge=[];for(const Pe of j){const De=Math.max(Pe.startColumn-Be,0),Se=Pe.startColumn+G.charsPerLine;if(De>Te+Be+m){const se=f+(De-Te)+p;re+=se+ae.slice(De,Se),me+=De-(Te+se.length)}else re+=ae.slice(Te,Se);Ge.push(new d(0,Pe.startColumn-me,Pe.endColumn-me)),Te=Se}this.preview={text:re,matches:Array.isArray(this.ranges)?Ge:Ge[0]}}else{const re=Array.isArray(Ie)?Ie[0].startLineNumber:Ie.startLineNumber;this.preview={text:ae,matches:(0,t.mapArrayOrNot)(Ie,me=>new a(me.startLineNumber-re,me.startColumn,me.endLineNumber-re,me.endColumn))}}}}e.TextSearchMatch=s;function o(ue){const ae=ue[0].startLineNumber;for(const Ie of ue)if(Ie.startLineNumber!==ae||Ie.endLineNumber!==ae)return!1;return!0}class a{constructor(ae,Ie,G,j){this.startLineNumber=ae,this.startColumn=Ie,this.endLineNumber=G,this.endColumn=j}}e.SearchRange=a;class d extends a{constructor(ae,Ie,G){super(ae,Ie,ae,G)}}e.OneLineRange=d;var c;(function(ue){ue.List="list",ue.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var u;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function n(ue,ae=!0){const Ie=ue&&ue.files&&ue.files.exclude,G=ae&&ue&&ue.search&&ue.search.exclude;if(!Ie&&!G)return;if(!Ie||!G)return Ie||G;let j=Object.create(null);return j=y.mixin(j,y.deepClone(Ie)),j=y.mixin(j,y.deepClone(G),!0),j}e.getExcludes=n;function h(ue,ae){return ue.excludePattern&&T.match(ue.excludePattern,ae)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&T.match(ue.includePattern,ae)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(Ie=>{const G=Ie.folder.fsPath;if(N.isEqualOrParent(ae,G)){const j=D.relative(G,ae);return!Ie.includePattern||!!T.match(Ie.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(ae,Ie){super(ae),this.code=Ie}}e.SearchError=A;function L(ue){const ae=ue.message;if((0,k.isCancellationError)(ue))return new A(ae,g.canceled);try{const Ie=JSON.parse(ae);return new A(Ie.message,Ie.code)}catch{return new A(ae,g.other)}}e.deserializeSearchError=L;function q(ue){const ae={message:ue.message,code:ue.code};return new Error(JSON.stringify(ae))}e.serializeSearchError=q;function Z(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=Z;function x(ue){return ue.type==="success"}e.isSerializedSearchSuccess=x;function O(ue){return!!ue.path}e.isSerializedFileMatch=O;function F(ue,ae){const Ie=ue.searchPath?ue.searchPath:ue.relativePath;return(0,C.fuzzyContains)(Ie,ae)}e.isFilePatternMatch=F;class P{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=P;function B(ue,ae){const Ie={...ue||{},...ae||{}};return Object.keys(Ie).filter(G=>{const j=Ie[G];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=B;class V{constructor(ae,Ie){this.c=null,this.a={...ae.excludePattern||{},...Ie.excludePattern||{}},this.b=T.parse(this.a);let G=ae.includePattern;Ie.includePattern&&(G?G={...G,...Ie.includePattern}:G=Ie.includePattern),G&&(this.c=T.parse(G))}matchesExcludesSync(ae,Ie,G){return!!(this.b&&this.b(ae,Ie,G))}includedInQuerySync(ae,Ie,G){return!(this.b&&this.b(ae,Ie,G)||this.c&&!this.c(ae,Ie,G))}includedInQuery(ae,Ie,G){const j=this.b(ae,Ie,G),re=()=>this.c?!!this.c(ae,Ie,G):!0;return(0,S.isThenable)(j)?j.then(me=>me?!1:re()):re()}hasSiblingExcludeClauses(){return z(this.a)}}e.QueryGlobTester=V;function z(ue){for(const ae in ue)if(typeof ue[ae]!="boolean")return!0;return!1}function ne(ue){if(!ue)return;let ae;return Ie=>(ae||(ae=(ue()||Promise.resolve([])).then(G=>G?we(G):{})),ae.then(G=>!!G[Ie]))}e.hasSiblingPromiseFn=ne;function de(ue){if(!ue)return;let ae;return Ie=>{if(!ae){const G=ue();ae=G?we(G):{}}return!!ae[Ie]}}e.hasSiblingFn=de;function we(ue){const ae={};for(const Ie of ue)ae[Ie]=!0;return ae}}),define(Ce[31],ke([1,0,16,14,20,4,7,46,13,111,22,10,9,2,142,3,12,157,51,37,27,15,8,6,53,45,5]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E,w,s,o,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(x,O,F){return new M.ExtUri(P=>A(P,F)).isEqual(x,O)}function n(x,O,F){return u(x.uri,O.uri,F)?0:(0,S.compare)(x.uri.toString(),O.uri.toString())}function h(x,O,F){return x.index!==O.index?x.index<O.index?-1:1:u(x.uri,O.uri,F)?(0,S.compare)(x.name,O.name):(0,S.compare)(x.uri.toString(),O.uri.toString())}function g(x,O,F,P){const B=x.slice(0).sort((z,ne)=>F(z,ne,P)),V=O.slice(0).sort((z,ne)=>F(z,ne,P));return(0,t.delta)(B,V,(z,ne)=>F(z,ne,P))}function A(x,O){const F=O.getCapabilities(x.scheme);return!(F&&F&1024)}class L extends v.Workspace{static toExtHostWorkspace(O,F,P,B){if(!O)return{workspace:null,added:[],removed:[]};const{id:V,name:z,folders:ne,configuration:de,transient:we,isUntitled:ue}=O,ae=[],Ie=F;F?ne.forEach((me,Te)=>{const Be=p.URI.revive(me.uri),Ge=L.e(P||F,Be,B);Ge?(Ge.name=me.name,Ge.index=me.index,ae.push(Ge)):ae.push({uri:Be,name:me.name,index:Te})}):ae.push(...ne.map(({uri:me,name:Te,index:Be})=>({uri:p.URI.revive(me),name:Te,index:Be}))),ae.sort((me,Te)=>me.index<Te.index?-1:1);const G=new L(V,z,ae,!!we,de?p.URI.revive(de):null,!!ue,me=>A(me,B)),{added:j,removed:re}=g(Ie?Ie.workspaceFolders:[],G.workspaceFolders,n,B);return{workspace:G,added:j,removed:re}}static e(O,F,P){for(let B=0;B<O.folders.length;B++){const V=O.workspaceFolders[B];if(u(V.uri,F,P))return V}}constructor(O,F,P,B,V,z,ne){super(O,P.map(de=>new v.WorkspaceFolder(de)),B,V,ne),this.s=F,this.t=z,this.o=[],this.q=R.TernarySearchTree.forUris(ne),P.forEach(de=>{this.o.push(de),this.q.set(de.uri,de)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(O,F){return F&&this.q.get(O)&&(O=(0,M.dirname)(O)),this.q.findSubstr(O)}resolveWorkspaceFolder(O){return this.q.get(O)}}let q=class{constructor(O,F,P,B,V){this.c=new N.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new N.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=B,this.q=P,this.s=V,this.h=new k.Counter,this.j=new T.Barrier,this.n=O.getProxy(c.MainContext.MainThreadWorkspace),this.o=O.getProxy(c.MainContext.MainThreadMessageService);const z=F.workspace;this.k=z?new L(z.id,z.name,[],!!z.transient,z.configuration?p.URI.revive(z.configuration):null,!!z.isUntitled,ne=>A(ne,P)):void 0}$initializeWorkspace(O,F){this.u=F,this.$acceptWorkspaceData(O),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?p.URI.from({scheme:D.Schemas.untitled,path:(0,M.basename)((0,M.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(O,F,P,...B){const V=[];if(Array.isArray(B)&&B.forEach(ue=>{p.URI.isUri(ue.uri)&&!V.some(ae=>u(ae.uri,ue.uri,this.q))&&V.push({uri:ue.uri,name:ue.name||(0,M.basenameOrAuthority)(ue.uri)})}),this.l||[F,P].some(ue=>typeof ue!="number"||ue<0)||P===0&&V.length===0)return!1;const z=this.w?this.w.workspaceFolders:[];if(F+P>z.length)return!1;const ne=z.slice(0);ne.splice(F,P,...V.map(ue=>({uri:ue.uri,name:ue.name||(0,M.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<ne.length;ue++){const ae=ne[ue];if(ne.some((Ie,G)=>G!==ue&&u(ae.uri,Ie.uri,this.q)))return!1}ne.forEach((ue,ae)=>ue.index=ae);const{added:de,removed:we}=g(z,ne,h,this.q);if(de.length===0&&we.length===0)return!1;if(this.n){const ue=O.displayName||O.name;this.n.$updateWorkspaceFolders(ue,F,P,V).then(void 0,ae=>{this.l=void 0;const Ie={source:{identifier:O.identifier,label:O.displayName||O.name}};this.o.$showMessage(l.Severity.Error,(0,m.localize)(0,null,ue,ae.toString()),Ie,[])})}return this.x(ne),!0}getWorkspaceFolder(O,F){if(!!this.w)return this.w.getWorkspaceFolder(O,F)}async getWorkspaceFolder2(O,F){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(O,F)}async resolveWorkspaceFolder(O){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(O)}getPath(){if(!this.w)return;const{folders:O}=this.w;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,F){let P,B="";if(typeof O=="string"?(P=p.URI.file(O),B=O):typeof O<"u"&&(P=O,B=O.fsPath),!P)return B;const V=this.getWorkspaceFolder(P,!0);if(!V)return B;typeof F>"u"&&this.w&&(F=this.w.folders.length>1);let z=(0,M.relativePath)(V.uri,P);return F&&V.name&&(z=`${V.name}/${z}`),z}x(O){this.w&&(this.l=L.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:O,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:F,added:P,removed:B}=L.toExtHostWorkspace(O,this.k,this.l,this.q);this.k=F||void 0,this.l=void 0,this.c.fire(Object.freeze({added:P,removed:B}))}findFiles(O,F,P,B,V=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let z;if(F===null?z=!1:F&&(typeof F=="string"?z=F:z=F.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:ne,folder:de}=Z(s.GlobPattern.from(O));return this.n.$startFileSearch((0,f.withUndefinedAsNull)(ne),(0,f.withUndefinedAsNull)(de),(0,f.withUndefinedAsNull)(z),(0,f.withUndefinedAsNull)(P),V).then(we=>Array.isArray(we)?we.map(ue=>p.URI.revive(ue)):[])}async findTextInFiles(O,F,P,B,V=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const z=this.h.getNext(),ne=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:de,folder:we}=Z(s.GlobPattern.from(F.include)),ue=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,ae={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:ne,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:de,excludePattern:ue},Ie=!1;if(this.t[z]=G=>{if(Ie)return;const j=p.URI.revive(G.resource);G.results.forEach(re=>{(0,d.resultIsMatch)(re)?P({uri:j,preview:{text:re.preview.text,matches:(0,t.mapArrayOrNot)(re.preview.matches,me=>new o.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))},ranges:(0,t.mapArrayOrNot)(re.ranges,me=>new o.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))}):P({uri:j,text:re.text,lineNumber:re.lineNumber})})},V.isCancellationRequested)return{};try{const G=await this.n.$startTextSearch(O,(0,f.withUndefinedAsNull)(we),ae,z,V);return delete this.t[z],G||{}}catch(G){throw delete this.t[z],G}}$handleTextSearchResult(O,F){this.t[F]?.(O)}saveAll(O){return this.n.$saveAll(O)}resolveProxy(O){return this.n.$resolveProxy(O)}get trusted(){return this.u}requestWorkspaceTrust(O){return this.n.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(O,F){if(this.v.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.v.set(O,F);const P=this.s.transformOutgoingScheme(O),B=this.y++;return this.n.$registerEditSessionIdentityProvider(B,P),(0,C.toDisposable)(()=>{this.v.delete(O),this.n.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(O,F){this.g.info("Getting edit session identifier for workspaceFolder",O);const P=await this.resolveWorkspaceFolder(p.URI.revive(O));if(!P){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const B=this.v.get(P.uri.scheme);if(this.g.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!B),!B)return;const V=await B.provideEditSessionIdentity(P,F);if(this.g.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(O,F,P,B){this.g.info("Getting edit session identifier for workspaceFolder",O);const V=await this.resolveWorkspaceFolder(p.URI.revive(O));if(!V){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const z=this.v.get(V.uri.scheme);if(this.g.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!z),!z)return;const ne=await z.provideEditSessionIdentityMatch?.(F,P,B);if(this.g.info("Provider returned edit session identifier match result: ",ne),!!ne)return ne}};q=qe([je(0,w.IExtHostRpcService),je(1,E.IExtHostInitDataService),je(2,b.IExtHostFileSystemInfo),je(3,r.ILogService),je(4,a.IURITransformerService)],q),e.ExtHostWorkspace=q,e.IExtHostWorkspace=(0,i.createDecorator)("IExtHostWorkspace");function Z(x){let O,F;return x&&(typeof x=="string"?O=x:(O=x.pattern,F=p.URI.revive(x.baseUri))),{includePattern:O,folder:F}}}),define(Ce[32],ke([1,0,23,4,31,5,6,160,91,9,14,3,15,12,2]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function i(o,a){if(a){const d=a.split(".");let c=o;for(let u=0;c&&u<d.length;u++)c=c[d[u]];return c}}function r(o){return o instanceof m.URI}function l(o){return o&&o.uri instanceof m.URI&&o.languageId&&typeof o.languageId=="string"}function v(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function b(o){return o&&o.uri instanceof m.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function E(o){if(r(o))return{resource:o};if(l(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(v(o))return{overrideIdentifier:o.languageId};if(b(o))return{resource:o.uri};if(o===null)return{resource:null}}let w=class{constructor(a,d,c){this.a=a.getProxy(N.MainContext.MainThreadConfiguration),this.c=d,this.b=c,this.d=new M.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new s(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,d))}};w=qe([je(0,f.IExtHostRpcService),je(1,y.IExtHostWorkspace),je(2,p.ILogService)],w),e.ExtHostConfiguration=w;class s{constructor(a,d,c,u){this.a=new T.Emitter,this.b=a,this.f=u,this.c=d,this.e=R.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,c))}getConfiguration(a,d,c){const u=E(d)||{},n=this.g(a?i(this.e.getValue(void 0,u,this.c.workspace),a):this.e.getValue(void 0,u,this.c.workspace));a&&this.h(a,u,c?.identifier);function h(A){if(A==null)return null;if(typeof A=="boolean")return A?2:5;switch(A){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(A){return typeof i(n,A)<"u"},get:(A,L)=>{this.h(a?`${a}.${A}`:A,u,c?.identifier);let q=i(n,A);if(typeof q>"u")q=L;else{let Z;const x=(O,F)=>{let P;const B=()=>{Z=Z||(0,t.deepClone)(n),P=P||i(Z,F)};return(0,k.isObject)(O)?new Proxy(O,{get:(V,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return B(),()=>P;if(Z)return P=P||i(Z,F),P[z];const ne=V[z];return typeof z=="string"?x(ne,`${F}.${z}`):ne},set:(V,z,ne)=>(B(),P&&(P[z]=ne),!0),deleteProperty:(V,z)=>(B(),P&&delete P[z],!0),defineProperty:(V,z,ne)=>(B(),P&&Object.defineProperty(P,z,ne),!0)}):O};q=x(q,A)}return q},update:(A,L,q,Z)=>{A=a?`${a}.${A}`:A;const x=h(q);return L!==void 0?this.b.$updateConfigurationOption(x,A,L,u,Z):this.b.$removeConfigurationOption(x,A,u,Z)},inspect:A=>{A=a?`${a}.${A}`:A;const L=this.e.inspect(A,u,this.c.workspace);if(L)return{key:A,defaultValue:(0,t.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,t.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,t.deepClone)(L.workspace?.value),workspaceFolderValue:(0,t.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,t.deepClone)(L.default?.override),globalLanguageValue:(0,t.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,t.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,t.deepClone)(L.workspaceFolder?.override),languageIds:(0,t.deepClone)(L.overrideIdentifiers)}}};return typeof n=="object"&&(0,t.mixin)(g,n,!1),Object.freeze(g)}g(a){const d=c=>(0,k.isObject)(c)?new Proxy(c,{get:(u,n)=>d(u[n]),set:(u,n,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(u,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(u,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return d(a)}h(a,d,c){const u=D.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),n=c?`[${c.value}] `:"";if(u===4){typeof d?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){d?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const c=new R.ConfigurationChangeEvent(a,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,n)=>c.affectsConfiguration(u,E(n))})}k(a){return a.reduce((d,c)=>(d.set(c[0],c[1]),d),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[105],ke([1,0,2,14,4,5,6,31,56,32,20,59,15,27,3,13,21,12,73,195,11]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(O){function F(B){if(B!=null)return B}O.from=F;function P(B){if(B!=null)return B}O.to=P})(s||(s={}));var o;(function(O){function F(B){if(B!=null)return B}O.from=F;function P(B){if(B!=null)return B}O.to=P})(o||(o={}));var a;(function(O){function F(B){if(B!=null)return B}O.from=F;function P(B){if(B!=null)return B}O.to=P})(a||(a={}));var d;(function(O){function F(V){if(V){const z=V;return z&&!!z.process}else return!1}O.is=F;function P(V){if(V==null)return;const z={process:V.process,args:V.args};return V.options&&(z.options=a.from(V.options)),z}O.from=P;function B(V){if(V!=null)return new C.ProcessExecution(V.process,V.args,V.options)}O.to=B})(d||(d={}));var c;(function(O){function F(B){if(B!=null)return B}O.from=F;function P(B){if(B!=null)return B}O.to=P})(c||(c={}));var u;(function(O){function F(V){if(V){const z=V;return z&&(!!z.commandLine||!!z.command)}else return!1}O.is=F;function P(V){if(V==null)return;const z={};return V.commandLine!==void 0?z.commandLine=V.commandLine:(z.command=V.command,z.args=V.args),V.options&&(z.options=c.from(V.options)),z}O.from=P;function B(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new C.ShellExecution(V.commandLine,V.options):new C.ShellExecution(V.command,V.args?V.args:[],V.options)}O.to=B})(u||(u={}));var n;(function(O){function F(V){if(V){const z=V;return z&&z.customExecution==="customExecution"}else return!1}O.is=F;function P(V){return{customExecution:"customExecution"}}O.from=P;function B(V,z){return z.get(V)}O.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(O){function F(P,B){let V;return P.scope!==void 0&&typeof P.scope!="number"?V=P.scope.uri:P.scope!==void 0&&typeof P.scope=="number"&&(P.scope===C.TaskScope.Workspace&&B&&B.workspaceFile?V=B.workspaceFile:V=b.USER_TASKS_GROUP_KEY),{id:P._id,workspaceFolder:V}}O.from=F})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(O){function F(P){if(P!=null)return{_id:P.id,isDefault:P.isDefault}}O.from=F})(g||(g={}));var A;(function(O){function F(V,z){if(V==null)return[];const ne=[];for(const de of V){const we=P(de,z);we&&ne.push(we)}return ne}O.fromMany=F;function P(V,z){if(V==null)return;let ne;V.execution instanceof C.ProcessExecution?ne=d.from(V.execution):V.execution instanceof C.ShellExecution?ne=u.from(V.execution):V.execution&&V.execution instanceof C.CustomExecution&&(ne=n.from(V.execution));const de=s.from(V.definition);let we;return V.scope?typeof V.scope=="number"?we=V.scope:we=V.scope.uri:we=C.TaskScope.Workspace,!de||!we?void 0:{_id:V._id,definition:de,name:V.name,source:{extensionId:z.identifier.value,label:V.source,scope:we},execution:ne,isBackground:V.isBackground,group:g.from(V.group),presentationOptions:o.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}O.from=P;async function B(V,z,ne){if(V==null)return;let de;d.is(V.execution)?de=d.to(V.execution):u.is(V.execution)?de=u.to(V.execution):n.is(V.execution)&&(de=n.to(V._id,ne));const we=s.to(V.definition);let ue;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?ue=V.source.scope:ue=await z.resolveWorkspaceFolder(t.URI.revive(V.source.scope)):ue=C.TaskScope.Workspace),!we||!ue)return;const ae=new C.Task(we,ue,V.name,V.source.label,de,V.problemMatchers);return V.isBackground!==void 0&&(ae.isBackground=V.isBackground),V.group!==void 0&&(ae.group=C.TaskGroup.from(V.group._id),ae.group&&V.group.isDefault&&(ae.group=new C.TaskGroup(ae.group.id,ae.group.label),V.group.isDefault===!0&&(ae.group.isDefault=V.group.isDefault))),V.presentationOptions&&(ae.presentationOptions=o.to(V.presentationOptions)),V._id&&(ae._id=V._id),V.detail&&(ae.detail=V.detail),ae}O.to=B})(A=e.TaskDTO||(e.TaskDTO={}));var L;(function(O){function F(B){return B}O.from=F;function P(B){if(!!B)return Object.assign(Object.create(null),B)}O.to=P})(L||(L={}));class q{constructor(F,P,B){this._id=P,this.a=B,w.set(this,void 0),Je(this,w,F,"f")}get task(){return this.a}terminate(){Oe(this,w,"f").terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}w=new WeakMap;let Z=class{constructor(F,P,B,V,z,ne,de,we){this.q=new y.Emitter,this.r=new y.Emitter,this.s=new y.Emitter,this.t=new y.Emitter,this.a=F.getProxy(N.MainContext.MainThreadTask),this.b=B,this.c=V,this.d=z,this.e=ne,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,P,B){if(!B)return new C.Disposable(()=>{});const V=this.w();return this.j.set(V,{type:P,provider:B,extension:F}),this.a.$registerTaskProvider(V,P),new C.Disposable(()=>{this.j.delete(V),this.a.$unregisterTaskProvider(V)})}registerTaskSystem(F,P){this.a.$registerTaskSystem(F,P)}fetchTasks(F){return this.a.$fetchTasks(L.from(F)).then(async P=>{const B=[];for(const V of P){const z=await A.to(V,this.b,this.m);z&&B.push(z)}return B})}get taskExecutions(){const F=[];return this.k.forEach(P=>F.push(P)),F}terminateTask(F){if(!(F instanceof q))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,P,B){const V=this.m.get(F.id);V&&(this.o.set(F.id,V),this.e.attachPtyToTerminal(P,await V.callback(B))),this.p=F.id,this.q.fire({execution:await this.y(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){const P=await this.y(F);this.l.delete(F.id),this.k.delete(F.id),this.A(F),this.r.fire({execution:P})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const P=await this.y(F.id);this.s.fire({execution:P,processId:F.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(F){const P=await this.y(F.id);this.t.fire({execution:P,exitCode:F.exitCode})}$provideTasks(F,P){const B=this.j.get(F);if(!B)return Promise.reject(new Error("no handler found"));const V=[],z=(0,T.asPromise)(()=>B.provider.provideTasks(M.CancellationToken.None)).then(ne=>this.u(P,V,B,ne));return new Promise(ne=>{z.then(de=>{Promise.all(V).then(()=>{ne(de)})})})}async $resolveTask(F,P){const B=this.j.get(F);if(!B)return Promise.reject(new Error("no handler found"));if(P.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${P.definition.type}] cannot be resolved by provider of type [${B.type}].`);const V=await A.to(P,this.b,this.m);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const z=await B.provider.resolveTask(V,M.CancellationToken.None);if(!z)return;this.z(z,B);const ne=A.from(z,B.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(ne.execution)&&await this.x(ne,z,!0),await this.v(ne)}w(){return this.h++}async x(F,P,B){const V=await this.a.$createTaskId(F);!B&&!this.m.has(V)&&(this.n.add(V),this.o.set(V,P.execution)),this.m.set(V,P.execution)}async y(F,P){if(typeof F=="string"){const z=this.l.get(F);if(!z)throw new E.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const B=this.l.get(F.id);if(B)return B;const V=new Promise((z,ne)=>{function de(we,ue,ae){ae?z(new q(we,ue.id,ae)):ne("Unexpected: Task does not exist.")}P?de(this,F,P):A.to(F.task,this.b,this.m).then(we=>de(this,F,we))});return this.l.set(F.id,V),V.then(z=>(this.k.set(F.id,z),z),z=>Promise.reject(z))}z(F,P){F._deprecated&&this.g.report("Task.constructor",P.extension,"Use the Task constructor that takes a `scope` instead.")}A(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const B=this.n.values();let V=B.next();for(;!V.done;)!this.o.has(V.value)&&this.p!==V.value&&(this.m.delete(V.value),this.n.delete(V.value)),V=B.next()}};Z=qe([je(0,f.IExtHostRpcService),je(1,p.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,D.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,S.IExtHostTerminalService),je(6,l.ILogService),je(7,v.IExtHostApiDeprecationService)],Z),e.ExtHostTaskBase=Z;let x=class extends Z{constructor(F,P,B,V,z,ne,de,we){super(F,P,B,V,z,ne,de,we),this.registerTaskSystem(i.Schemas.vscodeRemote,{scheme:i.Schemas.vscodeRemote,authority:"",platform:r.PlatformToString(0)})}async executeTask(F,P){if(!P.execution)throw new Error("Tasks to execute must include an execution");const B=A.from(P,F);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.x(B,P,!1);else throw new E.NotSupportedError;const V=await this.y(await this.a.$getTaskExecution(B),P);return this.a.$executeTask(B).catch(z=>{throw new Error(z)}),V}u(F,P,B,V){const z=[];if(V)for(const ne of V){this.z(ne,B),(!ne.definition||!F[ne.definition.type])&&this.f.warn(`The task [${ne.source}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`);const de=A.from(ne,B.extension);de&&n.is(de.execution)?(z.push(de),P.push(this.x(de,ne,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:B.extension}}async v(F){if(n.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,P){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,P,B){}};x=qe([je(0,f.IExtHostRpcService),je(1,p.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,D.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,S.IExtHostTerminalService),je(6,l.ILogService),je(7,v.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(Ce[238],ke([1,0,19,20,39,35,22,74,45]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(f,p,m){this.k=f,this.l=p,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&N.parse(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&N.parse(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const p=this.k.folderQueries||[];return new Promise((m,i)=>{const r=l=>{this.f++,f(l)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const v=l.toString(),b=t.basename(v);this.j&&this.j(v,b)||this.v(r,{base:l,basename:b})}),Promise.all(p.map(l=>this.p(l,r))).then(l=>{m({limitHit:this.e,stats:l[0]||void 0})},l=>{i(new Error((0,y.toErrorMessage)(l)))})})}async p(f,p){const m=new T.CancellationTokenSource,i=this.q(f),r=this.r(),l=new D.QueryGlobTester(this.k,f),v=!l.hasSiblingExcludeClauses();let b;try{this.h.add(m),b=R.StopWatch.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},i,m.token),w=b.elapsed(),s=R.StopWatch.create();return this.g&&!this.e||(E&&E.forEach(o=>{const a=t.posix.relative(f.folder.path,o.path);if(v){const d=t.basename(o.path);this.v(p,{base:f.folder,relativePath:a,basename:d});return}this.s(r,f.folder,a,p)}),this.g&&!this.e)?null:(this.u(r,l,p),{providerTime:w,postProcessTime:s.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(f){const p=(0,D.resolvePatternsForProvider)(this.k.includePattern,f.includePattern),m=(0,D.resolvePatternsForProvider)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:m,includes:p,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},p,m,i){if(m===this.a){const l=t.basename(this.a);this.v(i,{base:p,relativePath:this.a,basename:l})}function r(l){const v=t.basename(l),b=t.dirname(l);let E=f[b];E||(E=f[b]=[],r(b)),E.push({base:p,relativePath:l,basename:v})}r(m)}u({rootEntries:f,pathToEntries:p},m,i){const r=this,l=this.a;function v(b){const E=(0,D.hasSiblingFn)(()=>b.map(w=>w.basename));for(let w=0,s=b.length;w<s;w++){const o=b[w],{relativePath:a,basename:d}=o;if(m.matchesExcludesSync(a,d,l!==d?E:void 0))continue;const c=p[a];if(c)v(c);else{if(a===l)continue;r.v(i,o)}if(r.e)break}}v(f)}v(f,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(p))}}class M{constructor(){this.b=new Map}fileSearch(f,p,m,i){const r=this.c(f.cacheKey),l=new k(f,p,r&&r.token);let v=0;const b=E=>{v+=E.length,m(E.map(w=>this.d(w)))};return this.e(l,M.a,b,i).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:E.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(!!f)return this.b.has(f)||this.b.set(f,new T.CancellationTokenSource),this.b.get(f)}d(f){return f.relativePath?{resource:C.joinPath(f.base,f.relativePath)}:{resource:f.base}}e(f,p,m,i){i.onCancellationRequested(()=>{f.cancel()});const r=v=>{v&&(l.push(v),p>0&&l.length>=p&&(m(l),l=[]))};let l=[];return f.search(r).then(v=>(l.length&&m(l),v),v=>(l.length&&m(l),Promise.reject(v)))}}e.FileSearchManager=M,M.a=512}),define(Ce[239],ke([1,0,16,80,35,84,28,13,19,22,10,9,2,255,150,41,12,51,95,237,45]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(g,A,L,q,Z){this.a=g,this.b=A,this.c=L,this.d=q,this.e=Z}text(g,A,L={}){g=this.f(g,L);const q=this.a.getValue(),Z=A&&A.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(A?.map(l.toWorkspaceFolder),L),type:2,contentPattern:g,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:q.search.usePCRE2||Z||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(g,A){const L=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const q={...g,wordSeparators:L.editor.wordSeparators};return this.j(g,A)&&(q.isCaseSensitive=!0),this.k(g)&&(q.isMultiline=!0),q}file(g,A={}){return{...this.h(g,A),type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey}}g(g,A){return g?(g=Array.isArray(g)?g.map(c):c(g),A?this.parseSearchPaths(g):{pattern:o(...Array.isArray(g)?g:[g])}):{}}h(g=[],A={}){const L=this.g(A.includePattern,A.expandPatterns),q=this.g(A.excludePattern,A.expandPatterns),Z=g.length>1,x=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(P=>this.q(P,A,q)):g.map(P=>this.r(P,A,q,Z))).filter(P=>!!P),O={_reason:A._reason,folderQueries:x,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:q.pattern,includePattern:L.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const P=t.coalesce(t.flatten(this.c.groups.map(z=>z.editors.map(ne=>ne.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(P));const B=P.filter(z=>(0,E.pathIncludedInQuery)(O,z.fsPath)),V=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...O,...V}}const F=A.extraFileResources&&A.extraFileResources.filter(P=>(0,E.pathIncludedInQuery)(O,P.fsPath));return O.extraFileResources=F&&F.length?F:void 0,O}i(g){const A=[],L=new C.ResourceMap,q={};let Z=!1;return g.forEach(x=>{if(x.scheme===R.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(x)){const F=this.b.getWorkspaceFolder(x)?.uri??x.with({path:D.dirname(x.fsPath)});let P=L.get(F);P||(Z=!0,P={folder:F,includePattern:{}},A.push(P),L.set(F,P));const B=D.relative(F.fsPath,x.fsPath);(0,S.assertIsDefined)(P.includePattern)[B.replace(/\\/g,"/")]=!0}else x.fsPath&&(Z=!0,q[x.fsPath]=!0)}),{folderQueries:A,includePattern:q,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}j(g,A){if(A.isSmartCase){if(g.isRegExp){if(M.containsUppercaseCharacter(g.pattern,!0))return!0}else if(M.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,p.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const A=V=>D.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),q=(Array.isArray(g)?g:a(g)).map(V=>{const z=this.e.resolvedUserHome;return z?(0,N.untildify)(V,z.scheme===R.Schemas.file?z.fsPath:z.path):V}),Z=T.groupBy(q,V=>A(V)?"searchPaths":"exprSegments"),x=(Z.exprSegments||[]).map(V=>M.rtrim(V,"/")).map(V=>M.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),d(V))),O={},F=this.m(Z.searchPaths||[]);F&&F.length&&(O.searchPaths=F);const P=t.flatten(x),B=o(...P);return B&&(O.pattern=B),O}l(g,A){return A.disregardExcludeSettings?void 0:(0,E.getExcludes)(g,!A.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const A=g.flatMap(q=>{let{pathPortion:Z,globPortion:x}=s(q);return x&&(x=u(x)),this.n(Z).flatMap(F=>this.o(F,x))}),L=new Map;return A.forEach(q=>{const Z=q.searchPath.toString(),x=L.get(Z);x?q.pattern&&(x.pattern=x.pattern||{},x.pattern[q.pattern]=!0):L.set(Z,{searchPath:q.searchPath,pattern:q.pattern?o(q.pattern):void 0})}),Array.from(L.values())}n(g){if(D.isAbsolute(g)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==R.Schemas.file?[{searchPath:A[0].uri.with({path:g})}]:[{searchPath:f.URI.file(D.normalize(g))}]}if(this.b.getWorkbenchState()===2){const A=this.b.getWorkspace().folders[0].uri;if(g=c(g),g.startsWith("../")||g===".."){const q=D.posix.resolve(A.path,g);return[{searchPath:A.with({path:q})}]}const L=u(g);return[{searchPath:A,pattern:L}]}else{if(g==="./"||g===".\\")return[];{const A=g.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(Z=>{const x=A.match(new RegExp(`^${M.escapeRegExpCharacters(Z.name)}(?:/(.*)|$)`));return x?{match:x,folder:Z}:null}).filter(S.isDefined);if(q.length)return q.map(Z=>{const x=Z.match[1];return{searchPath:Z.folder.uri,pattern:x&&u(x)}});{const Z=g.match(/\.[\/\\](.+)[\/\\]?/),x=Z?Z[1]:g,O=m.localize(0,null,x);throw new Error(O)}}}}o(g,A){const L=g.pattern&&A?`${g.pattern}/${A}`:g.pattern||A,q=[{searchPath:g.searchPath,pattern:L}];return L&&!L.endsWith("**")&&q.push({searchPath:g.searchPath,pattern:L+"/**"}),q}q(g,A,L){const q=this.r((0,l.toWorkspaceFolder)(g.searchPath),A,L,!1);return q?{...q,includePattern:g.pattern}:null}r(g,A,L,q){let Z;const x=f.URI.isUri(g)?g:g.uri;if(L.searchPaths){const V=L.searchPaths.filter(z=>(0,k.isEqual)(z.searchPath,x))[0];if(V&&!V.pattern)return null;V&&(Z=V.pattern)}const O=this.a.getValue({resource:x}),P={...this.l(O,A)||{},...Z||{}},B=f.URI.isUri(g)?(0,k.basename)(g):g.name;return{folder:x,folderName:q?B:void 0,excludePattern:Object.keys(P).length>0?P:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!O.search.followSymlinks}}};w=qe([je(0,i.IConfigurationService),je(1,l.IWorkspaceContextService),je(2,v.IEditorGroupsService),je(3,r.ILogService),je(4,b.IPathService)],w),e.QueryBuilder=w;function s(h){const g=h.match(/[\*\{\}\(\)\[\]\?]/);if(g){const A=g.index,L=h.substr(0,A).match(/[/|\\][^/\\]*$/);if(L){let q=h.substr(0,L.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:h.substr((L.index||0)+1)}}}return{pathPortion:h}}function o(...h){return h.length?h.reduce((g,A)=>(g[A]=!0,g),Object.create(null)):void 0}function a(h){return y.splitGlobAware(h,",").map(g=>g.trim()).filter(g=>!!g.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function c(h){return h.replace(/\\/g,"/")}function u(h){return c(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(h,g){h=t.distinct(h,q=>q.toString());const A=[],L=g.getWorkspace();return h&&h.forEach(q=>{let Z;if(g.getWorkbenchState()===2)Z=(0,k.relativePath)(L.folders[0].uri,q),Z&&Z!=="."&&(Z="./"+Z);else{const x=g.getWorkspaceFolder(q);if(x){const O=x.name;if(L.folders.filter(P=>P.name===O).length===1){const P=(0,k.relativePath)(x.uri,q);P===""?Z=`./${x.name}`:Z=`./${x.name}/${P}`}else Z=q.fsPath}}Z&&A.push(Z)}),A}e.resolveResourcesForSearchIncludes=n}),define(Ce[240],ke([1,0,22,2,20,11,3,239,45,51]),function(ee,e,t,T,y,N,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const M=7e3;function S(i,r){const l=r.activationEvents;if(!l)return Promise.resolve(void 0);const v=[],b=[];for(const d of l)if(/^workspaceContains:/.test(d)){const c=d.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||i.forceUsingSearch?b.push(c):v.push(c)}if(v.length===0&&b.length===0)return Promise.resolve(void 0);let E;const w=new Promise((d,c)=>{E=d}),s=d=>E({activationEvent:d}),o=Promise.all(v.map(d=>f(i,d,s))).then(()=>{}),a=p(i,r.identifier,b,s);return Promise.all([o,a]).then(()=>{E(void 0)}),w}e.checkActivateWorkspaceContainsExtension=S;async function f(i,r,l){for(const v of i.folders)if(await i.exists(t.joinPath(T.URI.revive(v),r))){l(`workspaceContains:${r}`);return}}async function p(i,r,l,v){if(l.length===0)return Promise.resolve(void 0);const b=new y.CancellationTokenSource,E=i.checkExists(i.folders,l,b.token),w=setTimeout(async()=>{b.cancel(),i.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},M);let s=!1;try{s=await E}catch(o){N.isCancellationError(o)||N.onUnexpectedError(o)}b.dispose(),clearTimeout(w),s&&v(`workspaceContains:${l.join(",")}`)}function m(i,r,l,v){const b=i.get(C.IInstantiationService),E=i.get(D.ISearchService),s=b.createInstance(R.QueryBuilder).file(r.map(o=>(0,k.toWorkspaceFolder)(T.URI.revive(o))),{_reason:"checkExists",includePattern:l,exists:!0});return E.fileSearch(s,v).then(o=>!!o.limitHit,o=>N.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=m});var Je=this&&this.__classPrivateFieldSet||function(ee,e,t,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,t):y?y.value=t:e.set(ee,t),t},Oe=this&&this.__classPrivateFieldGet||function(ee,e,t,T){if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return t==="m"?T:t==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[33],ke([1,0,137,19,79,22,14,7,46,2,12,5,32,184,77,31,26,96,11,25,24,169,6,92,3,27,78,15,64,66,59,4,240,76,171,13,75,74]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E,w,s,o,a,d,c,u,n,h,g,A,L,q,Z,x,O,F){"use strict";var P,B,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let z=class Ui extends R.Disposable{constructor(G,j,re,me,Te,Be,Ge,Pe,De,Se,se){super(),this.a=this.B(new A.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=j,this.g=re,this.f=Ge,this.j=me,this.k=Te,this.l=Be,this.m=De,this.p=Se,this.s=se,this.t=this.g.getProxy(S.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(S.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(S.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const ce=(0,r.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(we(this.F,ce)),this.G=new m.ExtHostStorage(this.g,this.l),this.H=new q.ExtHostSecretState(this.g),this.I=Pe,this.h=G.createChild(new n.ServiceCollection([m.IExtHostStorage,this.G],[q.IExtHostSecretState,this.H])),this.J=this.B(new p.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(Y,I,$)=>{this.v.$onExtensionActivationError(Y,v.transformErrorForSerialization(I),$)},actualActivateExtension:async(Y,I)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(Y,this.D,this.F))return await this.v.$activateExtension(Y,I),new p.HostExtension;const $=this.D.getExtensionDescription(Y);return this.Y($,I)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),y.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(G){v.onUnexpectedError(G)}}async Q(){this.I.onWillDeactivateAll();let G=[];try{G=this.D.getAllExtensionDescriptions().map(Te=>Te.identifier).filter(Te=>this.isActivated(Te)).map(Te=>this.X(Te))}catch{}await Promise.all(G)}terminate(G,j=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${G}`),this.l.flush(),this.p.dispose(),this.J.dispose(),v.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const re=this.Q();Promise.race([(0,C.timeout)(5e3),re]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${j}`):this.l.info(`Extension host exiting with code ${j}`),this.l.flush(),this.l.dispose(),this.c.exit(j)})}isActivated(G){return this.z.isOpen()?this.J.isActivated(G):!1}async getExtension(G){const j=await this.v.$getExtension(G);let re;if(j?.browserNlsBundleUris){re={};for(const me of Object.keys(j.browserNlsBundleUris))re[me]=k.URI.revive(j.browserNlsBundleUris[me])}return j&&{...j,identifier:new b.ExtensionIdentifier(j.identifier.value),extensionLocation:k.URI.revive(j.extensionLocation),browserNlsBundleUris:re}}R(G,j){return this.J.activateByEvent(G,j)}S(G,j){return this.J.activateById(G,j)}activateByIdWithErrors(G,j){return this.S(G,j).then(()=>{const re=this.J.getActivatedExtension(G);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(G=>this.D)}getExtensionExports(G){return this.z.isOpen()?this.J.getActivatedExtension(G).exports:null}async U(G){if(G.scheme!==x.Schemas.file)return G;const j=await this.c.realpath(G.fsPath);return k.URI.file(j)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(G=>new ae(G))),this.L}async W(G){const j=D.TernarySearchTree.forUris(re=>N.extUriBiasedIgnorePathCase.ignorePathCasing(re));return await Promise.all(G.map(async re=>{if(this.ob(re)){const me=await this.U(re.extensionLocation);j.set(me,re)}})),j}X(G){let j=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(G))return j;const re=this.J.getActivatedExtension(G);if(!re)return j;try{typeof re.module.deactivate=="function"&&(j=Promise.resolve(re.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${G.value}':`),this.l.error(me)}try{(0,R.dispose)(re.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.l.error(me)}return j}async Y(G,j){return this.f.remote.isRemote?this.v.$onWillActivateExtension(G.identifier):await this.v.$onWillActivateExtension(G.identifier),this.ab(G,j).then(re=>{const me=re.activationTimes;return this.v.$onDidActivateExtension(G.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,j),this.Z(G,j,"success",me),re},re=>{throw this.Z(G,j,"failure"),re})}Z(G,j,re,me){const Te=ne(G,j);this.u.$publicLog2("extensionActivationTimes",{...Te,...me||{},outcome:re})}ab(G,j){const re=ne(G,j);this.u.$publicLog2("activatePlugin",re);const me=this.ob(G);if(!me)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${j.startup}, activationEvent: '${j.activationEvent}'${G.identifier.value!==j.extensionId.value?`, root cause: ${j.extensionId.value}`:""}`),this.l.flush();const Te=new p.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this.pb(G,(0,N.joinPath)(G.extensionLocation,me),Te),this.bb(G)]).then(Be=>(y.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),Ui.cb(this.l,G.identifier,Be[0],Be[1],Te))).then(Be=>(y.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),Be))}bb(G){const j=new w.ExtensionGlobalMemento(G,this.G),re=new w.ExtensionMemento(G.identifier.value,!1,this.G),me=new Z.ExtensionSecrets(G,this.H),Te=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Be=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([j.whenReady,re.whenReady,this.I.whenReady]).then(()=>{const Ge=this;let Pe,De;const Se=(0,r.isProposedApiEnabled)(G,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:j,workspaceState:re,secrets:me,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(se){return T.join(G.extensionLocation.fsPath,se)},get storagePath(){return Ge.I.workspaceValue(G)?.fsPath},get globalStoragePath(){return Ge.I.globalValue(G).fsPath},get logPath(){return T.join(Ge.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return k.URI.joinPath(Ge.f.logsLocation,G.identifier.value)},get storageUri(){return Ge.I.workspaceValue(G)},get globalStorageUri(){return Ge.I.globalValue(G)},get extensionMode(){return Te},get extension(){return Pe===void 0&&(Pe=new de(Ge,G.identifier,G,Be,!1)),Pe},get extensionRuntime(){return(0,r.checkProposedApiEnabled)(G,"extensionRuntime"),Ge.extensionRuntime},get environmentVariableCollection(){return Ge.p.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!De){if(!Se)return;const se=A.Event.buffer(A.Event.fromDOMEventEmitter(Se,"message",ce=>ce.data));Se.start(),De={onDidReceiveMessage:se,postMessage:Se.postMessage.bind(Se)}}return De}})})}static cb(G,j,re,me,Te){return re=re||{activate:void 0,deactivate:void 0},this.db(G,j,re,me,Te).then(Be=>new p.ActivatedExtension(!1,null,Te.build(),re,Be,me.subscriptions))}static db(G,j,re,me,Te){if(typeof re.activate=="function")try{Te.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${j.value}`);const Be=typeof global=="object"?global:self,Ge=re.activate.apply(Be,[me]);return Te.activateCallStop(),Te.activateResolveStart(),Promise.resolve(Ge).then(Pe=>(Te.activateResolveStop(),Pe))}catch(Be){return Promise.reject(Be)}else return Promise.resolve(re)}eb(G,j){this.S(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:j}).then(void 0,re=>{this.l.error(re)})}fb(){this.v.$setPerformanceMarks(y.getMarks());for(const G of this.D.getAllExtensionDescriptions())if(G.activationEvents)for(const j of G.activationEvents)j==="onStartupFinished"&&this.eb(G,j)}gb(){const G=this.R("*",!0).then(void 0,Te=>{this.l.error(Te)});this.B(this.j.onDidChangeWorkspace(Te=>this.hb(Te.added)));const j=this.j.workspace?this.j.workspace.folders:[],re=this.hb(j),me=Promise.all([G,re]).then(()=>{});return Promise.race([me,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),me}hb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(j=>this.ib(G,j))).then(()=>{})}async ib(G,j){if(this.isActivated(j.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:G.map(Be=>Be.uri),forceUsingSearch:re,exists:Be=>this.c.exists(Be.fsPath),checkExists:(Be,Ge,Pe)=>this.t.$checkExists(Be,Ge,Pe)},Te=await(0,L.checkActivateWorkspaceContainsExtension)(me,j);if(!!Te)return this.S(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:Te.activationEvent}).then(void 0,Be=>this.l.error(Be))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(G){throw console.error(G),G}}async jb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:j}=this.f.environment;if(!G||!j)throw new Error(t.localize(0,null));const re=await this.pb(null,j,new p.ExtensionActivationTimesBuilder(!1));if(!re||typeof re.run!="function")throw new Error(t.localize(1,null,j.toString()));return new Promise((me,Te)=>{const Be=(De,Se)=>{De?Te(De):me(typeof Se=="number"&&Se>0?1:0)},Ge=(0,N.originalFSPath)(j),Pe=re.run(Ge,Be);Pe&&Pe.then&&Pe.then(()=>{me(0)}).catch(De=>{Te(De instanceof Error&&De.stack?De.stack:String(De))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,j){return this.M[G]=j,(0,R.toDisposable)(()=>{delete this.M[G]})}async lb(G){const j=G.indexOf("+");if(j===-1)throw new Error("Not an authority that can be resolved!");const re=G.substr(0,j);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.M[re]}}async $resolveAuthority(G,j){const re=F.StopWatch.create(!1),me=()=>`[resolveAuthority(${ue(G)},${j})][${re.elapsed()}ms] `,Te=Se=>this.l.info(`${me()}${Se}`),Be=(Se,se=void 0)=>this.l.error(`${me()}${Se}`,se);Te("activating resolver...");const{authorityPrefix:Ge,resolver:Pe}=await this.lb(G);if(!Pe)return Be("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ge}.`,detail:void 0}};const De=new C.IntervalTimer;try{Te("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Pe)),De.cancelAndSet(()=>Te("waiting..."),1e3),Te("invoking resolve()..."),y.mark(`code/extHost/willResolveAuthority/${Ge}`);const Se=await Pe.resolve(G,{resolveAttempt:j});y.mark(`code/extHost/didResolveAuthorityOK/${Ge}`),De.dispose(),Te(`returned ${Se.host}:${Se.port}`);const se={authority:G,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},ce={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:se,options:ce,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(y.mark(`code/extHost/didResolveAuthorityError/${Ge}`),De.dispose(),Be("returned an error",Se),Se instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(G,j){this.l.info(`$getCanonicalURI invoked for authority (${ue(G)})`);const{resolver:re}=await this.lb(G);if(!re)return null;const me=k.URI.revive(j);if(typeof re.getCanonicalURI>"u")return me;const Te=await(0,C.asPromise)(()=>re.getCanonicalURI(me));return Te||me}static mb(G,j,re){const me=new l.ExtensionDescriptionRegistry(G.getAllExtensionDescriptions());me.deltaExtensions(re.toAdd,re.toRemove);const Te=(0,r.extensionIdentifiersArrayToSet)(j.getAllExtensionDescriptions().map(Ge=>Ge.identifier));for(const Ge of re.myToRemove)Te.delete(b.ExtensionIdentifier.toKey(Ge));for(const Ge of re.myToAdd)Te.add(b.ExtensionIdentifier.toKey(Ge));const Be=we(me,Te);return{globalRegistry:me,myExtensions:Be}}$startExtensionHost(G){G.toAdd.forEach(me=>me.extensionLocation=k.URI.revive(me.extensionLocation));const{globalRegistry:j,myExtensions:re}=Ui.mb(this.F,this.D,G);return this.F.set(j.getAllExtensionDescriptions()),this.D.set(re),this.kb()}$activateByEvent(G,j){return j===1?this.R(G,!1):this.z.wait().then(re=>this.R(G,!1))}async $activate(G,j){return await this.z.wait(),this.D.getExtensionDescription(G)?(await this.S(G,j),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(Be=>Be.extensionLocation=k.URI.revive(Be.extensionLocation));const{globalRegistry:j,myExtensions:re}=Ui.mb(this.F,this.D,G),me=await this.W(re);return(await this.getExtensionPathIndex()).setSearchTree(me),this.F.set(j.getAllExtensionDescriptions()),this.D.set(re),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const j=E.VSBuffer.alloc(G),re=Math.random()%256;for(let me=0;me<G;me++)j.writeUInt8(re,me);return j}async $updateRemoteConnectionData(G){this.P=G,this.a.fire()}};z=qe([je(0,a.IInstantiationService),je(1,e.IHostUtils),je(2,u.IExtHostRpcService),je(3,i.IExtHostWorkspace),je(4,f.IExtHostConfiguration),je(5,M.ILogService),je(6,d.IExtHostInitDataService),je(7,c.IExtensionStoragePaths),je(8,h.IExtHostTunnelService),je(9,g.IExtHostTerminalService),je(10,O.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function ne(Ie,G){return{id:Ie.identifier.value,name:Ie.name,extensionVersion:Ie.version,publisherDisplayName:Ie.publisher,activationEvents:Ie.activationEvents?Ie.activationEvents.join(","):null,isBuiltin:Ie.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class de{constructor(G,j,re,me,Te){P.set(this,void 0),B.set(this,void 0),V.set(this,void 0),Je(this,P,G,"f"),Je(this,B,j,"f"),Je(this,V,re.identifier,"f"),this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=T.normalize((0,N.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=me,this.isFromDifferentExtensionHost=Te}get isActive(){return Oe(this,P,"f").isActivated(Oe(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,P,"f").getExtensionExports(Oe(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,P,"f").activateByIdWithErrors(Oe(this,V,"f"),{startup:!1,extensionId:Oe(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=de,P=new WeakMap,B=new WeakMap,V=new WeakMap;function we(Ie,G){return Ie.getAllExtensionDescriptions().filter(j=>G.has(b.ExtensionIdentifier.toKey(j.identifier)))}function ue(Ie){const G=Ie.indexOf("+");return G===-1?Ie:Ie.substring(0,G)}class ae{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.ExtensionPaths=ae}),define(Ce[241],ke([1,0,79,2,5,32,26,25,15,27,3,33,49,12,10]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let i=class{constructor(w,s,o,a,d,c,u){this.c=w,this.d=s,this.e=o,this.f=a,this.g=d,this.h=c,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),t.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();t.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new l(this.c,s,this.d,w,this.i)),this.register(this.e.createInstance(v,s)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,s,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const s of w.nodeModuleName)this.a.set(s,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(s=>w.alternativeModuleName(s))}};i=qe([je(2,M.IInstantiationService),je(3,N.IExtHostConfiguration),je(4,S.IExtHostExtensionService),je(5,k.IExtHostInitDataService),je(6,p.ILogService)],i),e.RequireInterceptor=i;let r=class en{constructor(w){if(w.environment.appRoot&&en.a.size){const s=(0,m.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),o="[a-z0-9_.-]",a=`@${o}+\\/${o}+|${o}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const s=this.b.exec(this.c(w));if(!s)return;const[,o,a,d]=s,c=en.a.get(a);if(c!==void 0)return console.warn(`${a} as been renamed to ${c}, please update your imports`),o+c+d}c(w){return w.replace(/\\/g,"/")}};r.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),r=qe([je(0,k.IExtHostInitDataService)],r);class l{constructor(w,s,o,a,d){this.c=w,this.d=s,this.e=o,this.f=a,this.g=d,this.nodeModuleName="vscode",this.a=new Map}load(w,s){const o=this.d.findSubstr(s);if(o){let a=this.a.get(R.ExtensionIdentifier.toKey(o.identifier));return a||(a=this.c(o,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(o.identifier),a)),a}if(!this.b){let a="";this.d.forEach((d,c)=>a+=`	${c} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${a}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let v=class{constructor(w,s,o){this.d=w,this.nodeModuleName="keytar",this.a=s.getProxy(y.MainContext.MainThreadTelemetry);const{environment:a}=o,d=s.getProxy(y.MainContext.MainThreadKeytar);if(a.appRoot){let c=a.appRoot.fsPath;f.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,u)=>d.$getPassword(c,u),setPassword:(c,u,n)=>d.$setPassword(c,u,n),deletePassword:(c,u)=>d.$deletePassword(c,u),findPassword:c=>d.$findPassword(c),findCredentials(c){return d.$findCredentials(c)}}}load(w,s){const o=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const s=w.length;if(s<=7||!this.b)return;const o=s-7;if((w.charAt(o)==="/"||w.charAt(o)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};v=qe([je(1,D.IExtHostRpcService),je(2,k.IExtHostInitDataService)],v);let b=class{constructor(w,s,o){this.e=w,this.f=s,this.nodeModuleName=["open","opn"],this.d=o.getProxy(y.MainContext.MainThreadTelemetry);const a=o.getProxy(y.MainContext.MainThreadWindow);this.c=(d,c)=>{const u=T.URI.parse(d);return c?this.g(d,c):u.scheme==="http"||u.scheme==="https"?a.$openUri(u,d,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?a.$openUri(u,d,{}):this.g(d,c)}}load(w,s,o){const a=this.e.findSubstr(s);return a&&(this.a=a.identifier.value,this.h()),this.b=o(w),this.c}g(w,s){return this.i(),this.b(w,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([je(2,D.IExtHostRpcService)],b)}),define(Ce[106],ke([1,0,207,7,19,49,3,56,57,33,6,31,181,32]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class m extends f.AbstractVariableResolverService{constructor(l,v,b,E,w,s,o){function a(){if(b){const d=b.activeEditor();if(d)return d.document.uri;const c=E.tabGroups.all.find(u=>u.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof M.TextDiffTabInput||c.input instanceof M.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof M.TextTabInput||c.input instanceof M.NotebookEditorTabInput||c.input instanceof M.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:d=>{const c=s.folders.filter(u=>u.name===d);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(d,c)=>w.getConfiguration(void 0,d).get(c),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return y.normalize(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const d=a();if(d){const c=v.getWorkspaceFolder(d);if(c)return y.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(b){const d=b.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(b){const d=b.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>l.getExtension(d)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(N.env))}}let i=class extends T.Disposable{constructor(l,v,b,E,w){super(),this.b=l,this.c=v,this.g=b,this.h=E,this.i=w,this.a=new t.Lazy(async()=>{const s=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.i,s,a,this.j())})}getResolver(){return this.a.getValue()}j(){}};i=qe([je(0,k.IExtHostExtensionService),je(1,S.IExtHostWorkspace),je(2,R.IExtHostDocumentsAndEditors),je(3,p.IExtHostConfiguration),je(4,D.IExtHostEditorTabs)],i),e.ExtHostVariableResolverProviderService=i}),define(Ce[107],ke([1,0,14,4,9,2,3,5,57,33,15,6,31,173,175,32,106]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,d,c,u,n,h){this.D=d,this.E=c,this.F=u,this.G=n,this.H=h,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new T.Emitter,this.n=new T.Emitter,this.o=new T.Emitter,this.u=new T.Emitter,this.k=a.getProxy(R.MainContext.MainThreadDebugService),this.z=new T.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(A=>{this.I(g)}),this.I(g)})}asDebugSourceUri(a,d){const c=a;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let u=`debug:${encodeURIComponent(c.path||"")}`,n="?";return d&&(u+=`${n}session=${encodeURIComponent(d.id)}`,n="&"),u+=`${n}ref=${c.sourceReference}`,N.URI.parse(u)}else{if(c.path)return N.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(a){const d=[];for(const c of a.getAllExtensionDescriptions())if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0)for(const n of u)(0,m.isDebuggerMainContribution)(n)&&d.push(n.type)}this.k.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const a=[];return this.w.forEach(d=>a.push(d)),a}addBreakpoints(a){this.T();const d=a.filter(n=>{const h=n.id;return this.w.has(h)?!1:(this.w.set(h,n),!0)});this.U(d,[],[]);const c=[],u=new Map;for(const n of d)if(n instanceof S.SourceBreakpoint){let h=u.get(n.location.uri.toString());h||(h={type:"sourceMulti",uri:n.location.uri,lines:[]},u.set(n.location.uri.toString(),h),c.push(h)),h.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof S.FunctionBreakpoint&&c.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(a){this.T();const d=a.filter(h=>this.w.delete(h.id));this.U([],d,[]);const c=d.filter(h=>h instanceof S.SourceBreakpoint).map(h=>h.id),u=d.filter(h=>h instanceof S.FunctionBreakpoint).map(h=>h.id),n=d.filter(h=>h instanceof S.DataBreakpoint).map(h=>h.id);return this.k.$unregisterBreakpoints(c,u,n)}startDebugging(a,d,c){return this.k.$startDebugging(a?a.uri:void 0,d,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,d,c){if(!d)return new S.Disposable(()=>{});const u=this.d++;return this.f.push({type:a,handle:u,provider:d}),this.k.$registerDebugConfigurationProvider(a,c,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,u),new S.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==d),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(a,d,c){if(!c)return new S.Disposable(()=>{});if(!this.P(a,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.M(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:d,handle:u,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(d,u),new S.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(a,d){if(!d)return new S.Disposable(()=>{});const c=this.i++;return this.j.push({type:a,handle:c,factory:d}),new S.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==d)})}async $runInTerminal(a,d){return Promise.resolve(void 0)}async $substituteVariables(a,d){let c;const u=await this.W(a);return u&&(c={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,d)}J(a,d){if(a.type==="implementation")return new w(a.implementation)}K(){}async $startDASession(a,d){const c=this,u=await this.V(d);return this.R(this.M(u.type),u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const h=this.L(n),g=this.J(h,u);if(!g)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const A=g;return this.A.set(a,A),this.Q(u).then(L=>(L&&this.B.set(a,L),A.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const Z=q,x={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const O=await this.C.sign(Z.arguments.value);x.body={signature:O},A.sendResponse(x)}else throw new Error("no signer")}catch(O){x.success=!1,x.message=O.message,A.sendResponse(x)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(q),q=(0,m.convertToVSCPaths)(q,!0),c.k.$acceptDAMessage(a,q)}),A.onError(q=>{L&&L.onError&&L.onError(q),this.k.$acceptDAError(a,q.name,q.message,q.stack)}),A.onExit(q=>{L&&L.onExit&&L.onExit((0,y.withNullAsUndefined)(q),void 0),this.k.$acceptDAExit(a,(0,y.withNullAsUndefined)(q),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),A.startSession()))})}$sendDAMessage(a,d){d=(0,m.convertToDAPaths)(d,!1);const c=this.B.get(a);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(d),this.A.get(a)?.sendMessage(d)}$stopDASession(a){const d=this.B.get(a);this.B.delete(a),d&&d.onWillStopSession&&d.onWillStopSession();const c=this.A.get(a);return this.A.delete(a),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const d=[],c=[],u=[];if(a.added)for(const n of a.added){const h=n.id;if(h&&!this.w.has(h)){let g;if(n.type==="function")g=new S.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")g=new S.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const A=N.URI.revive(n.uri);g=new S.SourceBreakpoint(new S.Location(A,new S.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,S.setBreakpointId)(g,h),this.w.set(h,g),d.push(g)}}if(a.removed)for(const n of a.removed){const h=this.w.get(n);h&&(this.w.delete(n),c.push(h))}if(a.changed){for(const n of a.changed)if(n.id){const h=this.w.get(n.id);if(h){if(h instanceof S.FunctionBreakpoint&&n.type==="function"){const g=h;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.functionName=n.functionName}else if(h instanceof S.SourceBreakpoint&&n.type==="source"){const g=h;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.location=new S.Location(N.URI.revive(n.uri),new S.Position(n.line,n.character))}u.push(h)}}}this.U(d,c,u)}$provideDebugConfigurations(a,d,c){return(0,t.asPromise)(async()=>{const u=this.O(a);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(d);return u.provideDebugConfigurations(n,c)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(a,d,c,u){return(0,t.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.W(d);return n.resolveDebugConfiguration(h,c,u)})}$resolveDebugConfigurationWithSubstitutedVariables(a,d,c,u){return(0,t.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.W(d);return n.resolveDebugConfigurationWithSubstitutedVariables(h,c,u)})}async $provideDebugAdapter(a,d){const c=this.N(a);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(d);return this.R(c,u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(a){const d=await this.V(a);this.m.fire(d)}async $acceptDebugSessionTerminated(a){const d=await this.V(a);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,d){(await this.V(a))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(a,d){const u={session:await this.V(a),event:d.event,body:d.body};this.u.fire(u)}L(a){if(a instanceof S.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof S.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}M(a){const d=this.h.filter(c=>c.type===a);if(d.length>0)return d[0].factory}N(a){const d=this.h.filter(c=>c.handle===a);if(d.length>0)return d[0].factory}O(a){const d=this.f.filter(c=>c.handle===a);if(d.length>0)return d[0].provider}P(a,d){if(a.contributes){const c=a.contributes.debuggers;if(c&&c.length>0){for(const u of c)if(u.label&&u.type&&u.type===d)return!0}}return!1}Q(a){const c=a.configuration.type,u=this.j.filter(n=>n.type===c||n.type==="*").map(n=>(0,t.asPromise)(()=>n.factory.createDebugAdapterTracker(a)).then(h=>h,h=>null));return Promise.race([Promise.all(u).then(n=>{const h=n.filter(g=>!!g);if(h.length>0)return new E(h)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(a,d){const c=d.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new S.DebugAdapterServer(c));if(a){const n=await this.E.getExtensionRegistry();return(0,t.asPromise)(()=>a.createDebugAdapterDescriptor(d,this.S(d,n))).then(h=>{if(h)return h})}const u=await this.E.getExtensionRegistry();return Promise.resolve(this.S(d,u))}S(a,d){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(a,d,c){(a.length>0||d.length>0||c.length>0)&&this.z.fire(Object.freeze({added:a,removed:d,changed:c}))}async V(a){if(a)if(typeof a=="string"){const d=this.l.get(a);if(d)return d}else{let d=this.l.get(a.id);if(!d){const c=await this.W(a.folderUri),u=a.parent?this.l.get(a.parent):void 0;d=new v(this.k,a.id,a.type,a.name,c,a.configuration,u),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(a){if(a){const d=N.URI.revive(a);return this.D.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};l=qe([je(0,M.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,i.IExtHostConfiguration),je(4,D.IExtHostEditorTabs),je(5,r.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class v{constructor(a,d,c,u,n,h,g){this.d=a,this.f=d,this.g=c,this.h=u,this.i=n,this.j=h,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,d){return this.d.$customDebugAdapterRequest(this.f,a,d)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=v;class b{constructor(a){this.value=Object.freeze({append(d){a.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=b;class E{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(d=>d.onError?d.onError(a):void 0)}onExit(a,d){this.d.forEach(c=>c.onExit?c.onExit(a,d):void 0)}}class w extends p.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends l{constructor(a,d,c,u,n,h){super(a,d,c,u,n,h)}};s=qe([je(0,M.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,i.IExtHostConfiguration),je(4,D.IExtHostEditorTabs),je(5,r.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(Ce[242],ke([1,0,11,79,2,5,233,12,63,64,27,155,15,53,33,71]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class r{static async installEarlyHandler(b){const E=b.get(R.ILogService),s=b.get(f.IExtHostRpcService).getProxy(N.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(o=>{E.error(o);const a=t.transformErrorForSerialization(o);s.$onUnexpectedError(a)})}static async installFullHandler(b){const E=b.get(R.ILogService),w=b.get(f.IExtHostRpcService),s=b.get(m.IExtHostExtensionService),o=b.get(i.IExtHostTelemetry),a=w.getProxy(N.MainContext.MainThreadExtensionService),d=w.getProxy(N.MainContext.MainThreadErrors),c=await s.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(n,h)=>{let g="",A,L;for(const q of h)g+=`
	at ${q.toString()}`,L=q.getFileName(),!A&&L&&(A=c.findSubstr(y.URI.file(L)));return u.set(n,A?.identifier),`${n.name||"Error"}: ${n.message||""}${g}`},t.setUnexpectedErrorHandler(n=>{E.error(n);const h=t.transformErrorForSerialization(n),g=u.get(n);if(!g){d.$onUnexpectedError(h);return}a.$onExtensionRuntimeError(g,h);const A=o.onExtensionError(g,n);E.trace("forwarded error to extension?",A,g)})}}Error.stackTraceLimit=100;class l{constructor(b,E,w,s,o){this.a=w,this.b=new C.RPCProtocol(b,null,s),E=l.e(E,this.b);const a=new k.ServiceCollection(...(0,D.getSingletonServiceDescriptors)());a.set(M.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:o}),a.set(f.IExtHostRpcService,new f.ExtHostRpcService(this.b)),a.set(p.IURITransformerService,new p.URITransformerService(s)),a.set(m.IHostUtils,w);const d=new S.InstantiationService(a,!0);d.invokeFunction(r.installEarlyHandler),this.d=d.invokeFunction(c=>c.get(R.ILogService)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=d.invokeFunction(c=>c.get(m.IExtHostExtensionService)),this.c.initialize(),d.invokeFunction(r.installFullHandler)}async asBrowserUri(b){const E=this.b.getProxy(N.MainContext.MainThreadExtensionService);return y.URI.revive(await E.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,E){b.allExtensions.forEach(s=>{s.extensionLocation=y.URI.revive(E.transformIncomingURIs(s.extensionLocation));const o={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(a=>o[a]=y.URI.revive(E.transformIncomingURIs(s.browserNlsBundleUris[a]))),s.browserNlsBundleUris=o)}),b.environment.appRoot=y.URI.revive(E.transformIncomingURIs(b.environment.appRoot));const w=b.environment.extensionDevelopmentLocationURI;return w&&(b.environment.extensionDevelopmentLocationURI=w.map(s=>y.URI.revive(E.transformIncomingURIs(s)))),b.environment.extensionTestsLocationURI=y.URI.revive(E.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=y.URI.revive(E.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=y.URI.revive(E.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=y.URI.revive(E.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=y.URI.revive(E.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=y.URI.revive(E.transformIncomingURIs(b.logsLocation)),b.logFile=y.URI.revive(E.transformIncomingURIs(b.logFile)),b.workspace=E.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=l}),define(Ce[243],ke([1,0,16,14,20,39,13,19,22,2,45]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class S{constructor(v,b,E,w){this.d=v,this.e=b,this.f=E,this.g=w,this.a=null,this.b=!1,this.c=0}search(v,b){const E=this.d.folderQueries||[],w=new y.CancellationTokenSource;return b.onCancellationRequested(()=>w.cancel()),new Promise((s,o)=>{this.a=new p(v);let a=!1;const d=(c,u)=>{if(!a&&!this.b){const n=this.h(c);i(c)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,a=!0,w.cancel(),c=this.j(c,this.d.maxResults-this.c));const h=this.h(c);this.c+=h,(h>0||!i(c))&&this.a.add(c,u)}};Promise.all(E.map((c,u)=>this.k(c,n=>d(n,u),w.token))).then(c=>{w.dispose(),this.a.flush();const u=c.some(n=>!!n&&!!n.limitHit);s({limitHit:this.b||u,messages:(0,t.flatten)(c.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},c=>{w.dispose();const u=(0,N.toErrorMessage)(c);o(new Error(u))})})}h(v){return i(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}j(v,b){const E=Array.isArray(v.ranges)?v.ranges:[v.ranges],w=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:E.slice(0,b),preview:{matches:w.slice(0,b),text:v.preview.text},uri:v.uri}}async k(v,b,E){const w=new M.QueryGlobTester(this.d,v),s=[],o={report:c=>{if(!this.l(c))return;const u=v.folder.scheme===C.Schemas.file?(0,M.hasSiblingPromiseFn)(()=>this.f.readdir(D.dirname(c.uri))):void 0,n=D.relativePath(v.folder,c.uri);if(n){const h=w.includedInQuery(n,R.basename(n),u);(0,T.isThenable)(h)?s.push(h.then(g=>{g&&b(c)})):h&&b(c)}}},a=this.n(v),d=await this.e.provideTextSearchResults(f(this.d.contentPattern),a,o,E);return s.length&&await Promise.all(s),d}l(v){if(i(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(v){const b=(0,M.resolvePatternsForProvider)(this.d.includePattern,v.includePattern),E=(0,M.resolvePatternsForProvider)(this.d.excludePattern,v.excludePattern),w={folder:k.URI.from(v.folder),excludes:E,includes:b,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.f.toCanonicalName(v.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=S;function f(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class p{constructor(v){this.e=v,this.b=-1,this.d=null,this.a=new r(512,b=>this.g(b))}add(v,b){this.d&&(this.b!==b||!D.isEqual(this.c,v.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:v.uri,results:[]}),this.d.results.push(m(v))}f(){const v=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,v)}flush(){this.f(),this.a.flush()}g(v){this.e(v)}}e.TextSearchResultsCollector=p;function m(l){return i(l)?{preview:{matches:(0,t.mapArrayOrNot)(l.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:l.preview.text},ranges:(0,t.mapArrayOrNot)(l.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function i(l){return!!l.preview}e.extensionResultIsMatch=i;class r{constructor(v,b){this.g=v,this.h=b,this.c=0,this.d=[],this.e=0}addItem(v,b){!v||this.j(v,b)}addItems(v,b){!v||this.k(v,b)}j(v,b){this.d.push(v),this.e+=b,this.l()}k(v,b){this.d=this.d.concat(v),this.e+=b,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=r,r.a=4e3,r.b=50}),define(Ce[108],ke([1,0,7,5,3,238,15,53,12,2,243]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let S=class{constructor(i,r,l){this.k=i,this.l=r,this.n=l,this.c=this.k.getProxy(T.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new N.FileSearchManager}o(i){return this.l.transformOutgoingScheme(i)}registerTextSearchProvider(i,r){if(this.g.has(i))throw new Error(`a text search provider for the scheme '${i}' is already registered`);this.g.add(i);const l=this.d++;return this.e.set(l,r),this.c.$registerTextSearchProvider(l,this.o(i)),(0,t.toDisposable)(()=>{this.g.delete(i),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(i,r){if(this.i.has(i))throw new Error(`a file search provider for the scheme '${i}' is already registered`);this.i.add(i);const l=this.d++;return this.h.set(l,r),this.c.$registerFileSearchProvider(l,this.o(i)),(0,t.toDisposable)(()=>{this.i.delete(i),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(i,r,l,v){const b=f(l),E=this.h.get(i);if(E)return this.j.fileSearch(b,E,w=>{this.c.$handleFileMatch(i,r,w.map(s=>s.resource))},v);throw new Error("unknown provider: "+i)}$clearCache(i){return this.j.clearCache(i),Promise.resolve(void 0)}$provideTextSearchResults(i,r,l,v){const b=this.e.get(i);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${i}`);const E=f(l);return this.q(E,b).search(s=>this.c.$handleTextMatch(i,r,s),v)}$enableExtensionHostSearch(){}q(i,r){return new M.TextSearchManager(i,r,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};S=qe([je(0,C.IExtHostRpcService),je(1,R.IURITransformerService),je(2,D.ILogService)],S),e.ExtHostSearch=S;function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(p),extraFileResources:m.extraFileResources&&m.extraFileResources.map(i=>k.URI.revive(i))}}e.reviveQuery=f;function p(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(Ce[244],ke([1,0,63,103,31,101,32,38,56,59,105,107,108,77,66,73,102,58,37,76,71,57,214,12,185,106,75]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E,w,s,o,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,t.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,t.registerSingleton)(o.ILoggerService,s.ExtHostLoggerService,1),(0,t.registerSingleton)(o.ILogService,a.ExtHostLogService,1),(0,t.registerSingleton)(i.IExtHostApiDeprecationService,i.ExtHostApiDeprecationService,1),(0,t.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,t.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,t.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,t.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService,0),(0,t.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,0),(0,t.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors,0),(0,t.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,0),(0,t.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,t.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,t.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage,0),(0,t.registerSingleton)(M.IExtHostTask,M.WorkerExtHostTask,0),(0,t.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,t.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,t.registerSingleton)(r.IExtHostWindow,r.ExtHostWindow,0),(0,t.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,t.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,t.registerSingleton)(E.IExtHostTelemetry,E.ExtHostTelemetry,0),(0,t.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,t.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,0)}),define(Ce[245],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class t{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(y){if(y&&this.a.has(y)){const N=this.a.get(y);return this.a.delete(y),N}}addDragOperationTransfer(y,N){this.a.set(y,N)}getRenderedTreeElement(y){if(this.b.has(y))return this.b.get(y)}addRenderedTreeItemElement(y,N){this.b.set(y,N)}removeRenderedTreeItemElement(y){this.b.has(y)&&this.b.delete(y)}}e.TreeviewsService=t}),define(Ce[246],ke([1,0,141,6,22,2,4,7,14,6,9,16,8,20,245,26]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function r(b,E){if((0,M.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let w;return Array.isArray(b.highlights)&&(w=b.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),w=w.length?w:void 0),{label:b.label,highlights:w}}}class l{constructor(E,w,s){this.d=E,this.e=w,this.f=s,this.a=new Map,this.b=new m.TreeviewsService;function o(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:a=>o(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(d=>o(d)?this.i(d):d):a})}registerTreeDataProvider(E,w,s){const o=this.createTreeView(E,{treeDataProvider:w},s);return{dispose:()=>o.dispose()}}createTreeView(E,w,s){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=w.dragAndDropController?.dropMimeTypes??[],a=w.dragAndDropController?.dragMimeTypes??[],d=!!w.dragAndDropController?.handleDrag,c=!!w.dragAndDropController?.handleDrop,u=this.h(E,w,s),n=this.d.$registerTreeViewDataProvider(E,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:o,dragMimeTypes:a,hasHandleDrag:d,hasHandleDrop:c});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,i.checkProposedApiEnabled)(s,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(h){u.message=h},get title(){return u.title},set title(h){u.title=h},get description(){return u.description},set description(h){u.description=h},get badge(){return u.badge},set badge(h){h!==void 0&&k.ViewBadge.isViewBadge(h)?u.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(u.badge=void 0)},reveal:(h,g)=>u.reveal(h,g),dispose:async()=>{await n,this.a.delete(E),u.dispose()}}}$getChildren(E,w){const s=this.a.get(E);return s?s.getChildren(w):Promise.reject(new Error((0,t.localize)(0,null,E)))}async $handleDrop(E,w,s,o,a,d,c,u){const n=this.a.get(E);if(!n)return Promise.reject(new Error((0,t.localize)(1,null,E)));const h=f.DataTransfer.toDataTransfer(s,async g=>(await this.d.$resolveDropFileData(E,w,g)).buffer);return c===E&&u&&await this.g(h,n,u,a,d),n.onDrop(h,o,a)}async g(E,w,s,o,a){const d=this.b.removeDragOperationTransfer(a);if(d)(await d)?.forEach((c,u)=>{c&&E.set(u,c)});else if(a&&w.handleDrag){const c=w.handleDrag(s,E,o);this.b.addDragOperationTransfer(a,c),await c}return E}async $handleDrag(E,w,s,o){const a=this.a.get(E);if(!a)return Promise.reject(new Error((0,t.localize)(2,null,E)));const d=await this.g(new T.DataTransfer,a,w,o,s);if(!!d)return f.DataTransfer.toDataTransferDTO(d)}async $hasResolve(E){const w=this.a.get(E);if(!w)throw new Error((0,t.localize)(3,null,E));return w.hasResolve}$resolve(E,w,s){const o=this.a.get(E);if(!o)throw new Error((0,t.localize)(4,null,E));return o.resolveTreeItem(w,s)}$setExpanded(E,w,s){const o=this.a.get(E);if(!o)throw new Error((0,t.localize)(5,null,E));o.setExpanded(w,s)}$setSelection(E,w){const s=this.a.get(E);if(!s)throw new Error((0,t.localize)(6,null,E));s.setSelection(w)}$setFocus(E,w){const s=this.a.get(E);if(!s)throw new Error((0,t.localize)(7,null,E));s.setFocus(w)}$setVisible(E,w){const s=this.a.get(E);if(!s)throw new Error((0,t.localize)(8,null,E));s.setVisible(w)}$changeCheckboxState(E,w){const s=this.a.get(E);if(!s)throw new Error((0,t.localize)(9,null,E));s.setCheckboxState(w)}h(E,w,s){const o=new v(E,w,this.d,this.e.converter,this.f,s);return this.a.set(E,o),o}i(E){const w=this.a.get(E.$treeViewId);return w&&"$treeItemHandle"in E?w.getExtensionElement(E.$treeItemHandle):w&&"$focusedTreeItem"in E&&E.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=l;class v extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(E=>this.getExtensionElement(E)).filter(E=>!(0,M.isUndefinedOrNull)(E))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(E,w,s,o,a,d){if(super(),this.C=E,this.D=s,this.F=o,this.G=a,this.H=d,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new p.CancellationTokenSource,d.contributes&&d.contributes.views)for(const n in d.contributes.views)for(const h of d.contributes.views[n])h.id===E&&(this.J=h.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let c,u;this.B(C.Event.debounce(this.w.event,(n,h)=>(n||(n={message:!1,elements:[]}),h.element!==!1&&(c||(c=new Promise(g=>u=g),this.y=this.y.then(()=>c)),Array.isArray(h.element)?n.elements.push(...h.element):n.elements.push(h.element)),h.message&&(n.message=!0),n),200,!0)(({message:n,elements:h})=>{h.length&&(this.z=this.z.then(()=>{const g=u;return c=null,this.U(h).then(()=>g())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(E){const w=E?this.getExtensionElement(E):void 0;if(E&&!w)return this.G.error(`No tree item with id '${E}' found.`),Promise.resolve([]);let s=this.Q(E);return s||(s=await this.R(w)),s?s.map(o=>o.item):void 0}getExtensionElement(E){return this.i.get(E)}reveal(E,w){w=w||{select:!0,focus:!1};const s=(0,M.isUndefinedOrNull)(w.select)?!0:w.select,o=(0,M.isUndefinedOrNull)(w.focus)?!1:w.focus,a=(0,M.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):E?this.y.then(()=>this.N(E)).then(d=>this.P(E,d[d.length-1]).then(c=>this.D.$reveal(this.C,{item:c.item,parentChain:d.map(u=>u.item)},{select:s,focus:o,expand:a})),d=>this.G.error(d)):this.D.$reveal(this.C,void 0,{select:s,focus:o,expand:a})}get message(){return this.I}set message(E){this.I=E,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(E){this.J=E,this.D.$setTitle(this.C,E,this.L)}get description(){return this.L}set description(E){this.L=E,this.D.$setTitle(this.C,this.J,E)}get badge(){return this.M}set badge(E){this.M?.value===E?.value&&this.M?.tooltip===E?.tooltip||(this.M=f.ViewBadge.from(E),this.D.$setBadge(this.C,E))}setExpanded(E,w){const s=this.getExtensionElement(E);s&&(w?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(E){(0,S.equals)(this.l,E)||(this.l=E,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(E){this.m=E}setVisible(E){E!==this.k&&(this.k=E,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(E){const w=(await Promise.all(E.map(async s=>{const o=this.getExtensionElement(s.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);w.forEach(s=>{s.treeItem.checkboxState=s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(s=>[s.extensionItem,s.newState])})}async handleDrag(E,w,s){const o=[];for(const a of E){const d=this.getExtensionElement(a);d&&o.push(d)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,w,s),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(E,w,s){const o=w?this.getExtensionElement(w):void 0;if(!(!o&&w||!this.g?.handleDrop))return(0,D.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(o,E,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(E,w){if(!this.f.resolveTreeItem)return;const s=this.i.get(E);if(s){const o=this.j.get(s);if(o){const a=await this.f.resolveTreeItem(o.extensionItem,s,w)??o.extensionItem;return this.db(a),o.item.tooltip=this.ab(a.tooltip),o.item.command=this.bb(o.disposableStore,a.command),o.item}}}N(E){return this.O(E).then(w=>w?this.N(w).then(s=>this.P(w,s[s.length-1]).then(o=>(s.push(o),s))):Promise.resolve([]))}O(E){const w=this.j.get(E);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,D.asPromise)(()=>this.f.getParent(E))}P(E,w){const s=this.j.get(E);return s?Promise.resolve(s):(0,D.asPromise)(()=>this.f.getTreeItem(E)).then(o=>this.gb(E,o,w,!0)).then(o=>this.getChildren(w?w.item.handle:void 0).then(()=>{const a=this.getExtensionElement(o);if(a){const d=this.j.get(a);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}Q(E){if(E){let w;if(typeof E=="string"){const s=this.getExtensionElement(E);w=s?this.j.get(s):void 0}else w=E;return w&&w.children||void 0}return this.h}async R(E){this.nb(E);const w=new p.CancellationTokenSource(this.S.token);try{const s=E?this.j.get(E):void 0,o=await this.f.getChildren(E);if(w.token.isCancellationRequested)return;const a=await Promise.all((0,S.coalesce)(o||[]).map(async d=>{const c=await this.f.getTreeItem(d);return c&&!w.token.isCancellationRequested?this.Z(d,c,s):null}));return w.token.isCancellationRequested?void 0:(0,S.coalesce)(a)}finally{w.dispose()}}U(E){if(E.some(s=>!s))return this.S.dispose(!0),this.S=new p.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(E);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(E){const w=new Set,s=E.map(a=>this.j.get(a));for(const a of s)if(a&&!w.has(a.item.handle)){let d=a;for(;d&&d.parent&&s.findIndex(c=>d&&d.parent&&c&&c.item.handle===d.parent.item.handle)===-1;){const c=this.i.get(d.parent.item.handle);d=c?this.j.get(c):void 0}d&&!d.parent&&w.add(a.item.handle)}const o=[];return w.forEach(a=>{const d=this.i.get(a);if(d){const c=this.j.get(d);c&&(!c.parent||!w.has(c.parent.item.handle))&&o.push(a)}}),o}X(E){const w={};return Promise.all(E.map(s=>this.Y(s).then(o=>{o&&(w[s]=o.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(E){const w=this.getExtensionElement(E);if(w){const s=this.j.get(w);if(s)return this.nb(w),(0,D.asPromise)(()=>this.f.getTreeItem(w)).then(o=>{if(o){const a=this.eb(w,o,s.parent);return this.lb(w,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}Z(E,w,s){const o=this.eb(E,w,s);if(w.id&&this.i.has(o.item.handle))throw new Error((0,t.localize)(10,null,w.id));return this.kb(E,o),this.mb(o,s),o}ab(E){return k.MarkdownString.isMarkdownString(E)?f.MarkdownString.from(E):E}bb(E,w){return w?{...this.F.toInternal(w,E),originalId:w.command}:void 0}cb(E){if(!E.checkboxState)return;let w,s;return typeof E.checkboxState=="number"?w=E.checkboxState:(w=E.checkboxState.state,s=E.checkboxState.tooltip),{isChecked:w===k.TreeItemCheckboxState.Checked,tooltip:s}}db(E){if(!k.TreeItem.isTreeItem(E,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(E,w,s){this.db(w);const o=new R.DisposableStore,a=this.gb(E,w,s),d=this.hb(w);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:r(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(o,w.command),contextValue:w.contextValue,icon:d,iconDark:this.ib(w)||d,themeIcon:this.fb(w),collapsibleState:(0,M.isUndefinedOrNull)(w.collapsibleState)?k.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:s,children:void 0,disposableStore:o,dispose(){o.dispose()}}}fb(E){return E.iconPath instanceof k.ThemeIcon?E.iconPath:void 0}gb(E,{id:w,label:s,resourceUri:o},a,d){if(w)return`${v.b}/${w}`;const c=r(s,this.H),u=a?a.item.handle:v.a;let n=c?c.label:o?(0,y.basename)(o):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const h=this.j.has(E)?this.j.get(E).item.handle:void 0,g=this.Q(a)||[];let A,L=0;do{if(A=`${u}/${L}:${n}`,d||!this.i.has(A)||h===A)break;L++}while(L<=g.length);return A}hb(E){if(E.iconPath&&!(E.iconPath instanceof k.ThemeIcon))return typeof E.iconPath=="string"||N.URI.isUri(E.iconPath)?this.jb(E.iconPath):this.jb(E.iconPath.light)}ib(E){if(E.iconPath&&!(E.iconPath instanceof k.ThemeIcon)&&E.iconPath.dark)return this.jb(E.iconPath.dark)}jb(E){return N.URI.isUri(E)?E:N.URI.file(E)}kb(E,w){this.i.set(w.item.handle,E),this.j.set(E,w)}lb(E,w,s,o){this.i.delete(w.item.handle),this.j.delete(E),w.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(E,w);const a=this.Q(o)||[],d=a.filter(c=>c.item.handle===s.item.handle)[0];d&&a.splice(a.indexOf(d),1,w)}mb(E,w){w?(w.children||(w.children=[]),w.children.push(E)):(this.h||(this.h=[]),this.h.push(E))}nb(E){if(E){const w=this.j.get(E);if(w){if(w.children)for(const s of w.children){const o=this.i.get(s.item.handle);o&&this.ob(o)}w.children=void 0}}else this.pb()}ob(E){const w=this.j.get(E);if(w){if(w.children)for(const s of w.children){const o=this.i.get(s.item.handle);o&&this.ob(o)}this.j.delete(E),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(E=>E.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}v.a="0",v.b="1"}),define(Ce[247],ke([1,0,20,11,4,29,2,128,256,115,126,36,5,70,200,199,38,201,32,203,204,205,188,206,56,33,208,209,212,213,215,103,191,220,221,222,77,59,225,246,8,6,50,228,60,102,31,179,211,48,101,105,107,108,12,53,15,27,216,186,66,73,197,226,78,58,231,229,230,198,37,223,227,76,57,71,217,104,218,13,89,190,170,210,7,26,174,75,167,219]),function(ee,e,t,T,y,N,C,R,D,k,M,S,f,p,m,i,r,l,v,b,E,w,s,o,a,d,c,u,n,h,g,A,L,q,Z,x,O,F,P,B,V,z,ne,de,we,ue,ae,Ie,G,j,re,me,Te,Be,Ge,Pe,De,Se,se,ce,Y,I,$,H,K,J,le,Ee,oe,pe,ve,We,He,tt,Xe,et,it,dt,Fe,st,Q,_,ge,Le,$e,Ve,Qe,nt,wt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ct(lt){const at=lt.get(Se.IExtHostInitDataService),Bt=lt.get(ve.IExtHostFileSystemInfo),Ot=lt.get(J.IExtHostConsumerFileSystem),Ft=lt.get(d.IExtHostExtensionService),ft=lt.get(ae.IExtHostWorkspace),Dt=lt.get(et.IExtHostTelemetry),$t=lt.get(v.IExtHostConfiguration),Mt=lt.get(Pe.IURITransformerService),xe=lt.get(De.IExtHostRpcService),Lt=lt.get(O.IExtHostStorage),Nt=lt.get(K.IExtensionStoragePaths),Ut=lt.get(Ge.ILoggerService),gt=lt.get(Ge.ILogService),kt=lt.get(Y.IExtHostTunnelService),ye=lt.get(I.IExtHostApiDeprecationService),Ae=lt.get(ue.IExtHostWindow),fe=lt.get(tt.IExtHostSecretState),X=lt.get(Xe.IExtHostEditorTabs);xe.set(f.ExtHostContext.ExtHostFileSystemInfo,Bt),xe.set(f.ExtHostContext.ExtHostLogLevelServiceShape,Ut),xe.set(f.ExtHostContext.ExtHostWorkspace,ft),xe.set(f.ExtHostContext.ExtHostConfiguration,$t),xe.set(f.ExtHostContext.ExtHostExtensionService,Ft),xe.set(f.ExtHostContext.ExtHostStorage,Lt),xe.set(f.ExtHostContext.ExtHostTunnelService,kt),xe.set(f.ExtHostContext.ExtHostWindow,Ae),xe.set(f.ExtHostContext.ExtHostSecretState,fe),xe.set(f.ExtHostContext.ExtHostTelemetry,Dt),xe.set(f.ExtHostContext.ExtHostEditorTabs,X);const Re=xe.set(f.ExtHostContext.ExtHostDecorations,lt.get(re.IExtHostDecorations)),Ne=xe.set(f.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(a.IExtHostDocumentsAndEditors)),_e=xe.set(f.ExtHostContext.ExtHostCommands,lt.get(r.IExtHostCommands)),ze=xe.set(f.ExtHostContext.ExtHostTerminalService,lt.get(F.IExtHostTerminalService)),Ze=xe.set(f.ExtHostContext.ExtHostDebugService,lt.get(Te.IExtHostDebugService)),bt=xe.set(f.ExtHostContext.ExtHostSearch,lt.get(Be.IExtHostSearch)),vt=xe.set(f.ExtHostContext.ExtHostTask,lt.get(me.IExtHostTask)),At=xe.set(f.ExtHostContext.ExtHostOutputService,lt.get(A.IExtHostOutputService)),pt=xe.set(f.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),It=xe.set(f.ExtHostContext.ExtHostUrls,new de.ExtHostUrls(xe)),ht=xe.set(f.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(xe,Ne)),Kt=xe.set(f.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(xe,Ne,gt)),jt=xe.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(gt,ht,xe.getProxy(f.MainContext.MainThreadBulkEdits))),Et=xe.set(f.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(xe,_e,Ne,ht)),_t=xe.set(f.ExtHostContext.ExtHostNotebookDocuments,new ge.ExtHostNotebookDocuments(Et)),ri=xe.set(f.ExtHostContext.ExtHostNotebookEditors,new _.ExtHostNotebookEditors(gt,Et)),ei=xe.set(f.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(xe,at,Et,_e,gt)),bi=xe.set(f.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(xe,Et)),Tt=xe.set(f.ExtHostContext.ExtHostEditors,new P.ExtHostEditors(xe,Ne)),si=xe.set(f.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(xe.getProxy(f.MainContext.MainThreadTreeViews),_e,gt)),Vt=xe.set(f.ExtHostContext.ExtHostEditorInsets,new Ie.ExtHostEditorInsets(xe.getProxy(f.MainContext.MainThreadEditorInsets),Tt,at.remote)),ti=xe.set(f.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,gt,Bt,Ne)),oi=xe.set(f.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(xe,ht,_e.converter,Mt)),ct=xe.set(f.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(xe,Mt,ht,_e,ti,gt,ye,Dt)),Oi=xe.set(f.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(xe,ct)),Qt=xe.set(f.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(xe,gt,Ne)),Wt=xe.set(f.ExtHostContext.ExtHostQuickOpen,(0,q.createExtHostQuickOpen)(xe,ft,_e)),ai=xe.set(f.ExtHostContext.ExtHostSCM,new Z.ExtHostSCM(xe,_e,gt)),Ei=xe.set(f.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(xe,_e,ht)),ci=xe.set(f.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(xe.getProxy(f.MainContext.MainThreadProgress))),wi=xe.set(f.ExtHostContext.ExtHosLabelService,new G.ExtHostLabelService(xe)),ui=xe.set(f.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(xe)),ii=xe.set(f.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(xe)),Si=xe.set(f.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(xe,_e)),ni=xe.set(f.ExtHostContext.ExtHostWebviews,new we.ExtHostWebviews(xe,at.remote,ft,gt,ye)),yi=xe.set(f.ExtHostContext.ExtHostWebviewPanels,new oe.ExtHostWebviewPanels(xe,ni,ft)),Di=xe.set(f.ExtHostContext.ExtHostCustomEditors,new Ee.ExtHostCustomEditors(xe,ht,Nt,ni,yi)),Ii=xe.set(f.ExtHostContext.ExtHostWebviewViews,new le.ExtHostWebviewViews(xe,ni)),Yt=xe.set(f.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(xe,_e,Ne)),Ci=xe.set(f.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(xe)),Bi=xe.set(f.ExtHostContext.ExtHostProfileContentHandlers,new St.ExtHostProfileContentHandlers(xe));xe.set(f.ExtHostContext.ExtHostInteractive,new Le.ExtHostInteractive(xe,Et,Ne,_e,gt));const ki=Object.values(f.ExtHostContext);xe.assertRegistered(ki);const Ti=new pe.ExtHostBulkEdits(xe,Ne),$i=new i.ExtHostClipboard(xe),Pi=new g.ExtHostMessageService(xe,gt),Fi=new E.ExtHostDialogs(xe),Mi=new x.ExtHostStatusBar(xe,_e.converter);return m.ExtHostApiCommands.register(_e),function(Ue,Gt,li){const mt=function(){let ie=!Ue.isUnderDevelopment;function he(){ie||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Me(rt){if(Array.isArray(rt))rt.forEach(Me);else if(typeof rt=="string")he();else{const yt=rt;typeof yt.scheme>"u"&&he(),typeof yt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),zi={getSession(ie,he,Me){return ii.getSession(Ue,ie,he,Me)},async hasSession(ie,he){return(0,Ve.checkProposedApiEnabled)(Ue,"authSession"),!!await ii.getSession(Ue,ie,he,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(ie,he,Me,rt){return ii.registerAuthenticationProvider(ie,he,Me,rt)}},Wi={registerCommand(ie,he,Me){return _e.registerCommand(!0,ie,he,Me,void 0,Ue)},registerTextEditorCommand(ie,he,Me){return _e.registerCommand(!0,ie,(...rt)=>{const yt=Tt.getActiveTextEditor();if(!yt){gt.warn("Cannot execute "+ie+" because there is no active text editor.");return}return yt.edit(Pt=>{he.apply(Me,[yt,Pt,...rt])}).then(Pt=>{Pt||gt.warn("Edits from command "+ie+" were not applied.")},Pt=>{gt.warn("An error occurred while running command "+ie,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ie,he,Me)=>((0,Ve.checkProposedApiEnabled)(Ue,"diffCommand"),_e.registerCommand(!0,ie,async(...rt)=>{const yt=Ne.activeEditor(!0);if(!yt){gt.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(yt.id);he.apply(Me,[Pt,...rt])},void 0,void 0,Ue)),executeCommand(ie,...he){return _e.executeCommand(ie,...he)},getCommands(ie=!1){return _e.getCommands(ie)}},Li={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return $i.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Ue,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetryLogger"),Dt.instantiateLogger(Ue,ie)},openExternal(ie,he){return Ae.openUri(ie,{allowTunneling:!!at.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===at.environment.appUriScheme)return It.createAppUri(ie);try{return await Ae.asExternalUri(ie,{allowTunneling:!!at.remote.authority})}catch(he){if((0,Q.matchesScheme)(ie,st.Schemas.http)||(0,Q.matchesScheme)(ie,st.Schemas.https))return ie;throw he}},get remoteName(){return(0,j.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return gt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Li);const di={createTestController(ie,he,Me){return Yt.createTestController(ie,he,Me)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),Yt.createTestObserver()},runTests(ie){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),Yt.runTests(ie)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),Yt.results}},hi=at.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,Hi={getExtension(ie,he){(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Me=Gt.mine.getExtensionDescription(ie);if(Me)return new d.Extension(Ft,Ue.identifier,Me,hi,!1);if(he){const rt=Gt.all.getExtensionDescription(ie);if(rt)return new d.Extension(Ft,Ue.identifier,rt,hi,!0)}},get all(){const ie=[];for(const he of Gt.mine.getAllExtensionDescriptions())ie.push(new d.Extension(Ft,Ue.identifier,he,hi,!1));return ie},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Ue,"extensionsAny");const ie=new Ve.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),he=[];for(const Me of Gt.all.getAllExtensionDescriptions()){const rt=!ie.has(Me.identifier);he.push(new d.Extension(Ft,Ue.identifier,Me,hi,rt))}return he},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")?y.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},ji={createDiagnosticCollection(ie){return ti.createDiagnosticCollection(Ue.identifier,ie)},get onDidChangeDiagnostics(){return ti.onDidChangeDiagnostics},getDiagnostics:ie=>ti.getDiagnostics(ie),getLanguages(){return oi.getLanguages()},setTextDocumentLanguage(ie,he){return oi.changeLanguage(ie.uri,he)},match(ie,he){const Me=ht.getDocumentData(he.uri)?.notebook;return(0,M.score)(V.LanguageSelector.from(ie),he.uri,he.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ie,he,Me){return ct.registerCodeActionProvider(Ue,mt(ie),he,Me)},registerDocumentPasteEditProvider(ie,he,Me){return(0,Ve.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,mt(ie),he,Me)},registerCodeLensProvider(ie,he){return ct.registerCodeLensProvider(Ue,mt(ie),he)},registerDefinitionProvider(ie,he){return ct.registerDefinitionProvider(Ue,mt(ie),he)},registerDeclarationProvider(ie,he){return ct.registerDeclarationProvider(Ue,mt(ie),he)},registerImplementationProvider(ie,he){return ct.registerImplementationProvider(Ue,mt(ie),he)},registerTypeDefinitionProvider(ie,he){return ct.registerTypeDefinitionProvider(Ue,mt(ie),he)},registerHoverProvider(ie,he){return ct.registerHoverProvider(Ue,mt(ie),he,Ue.identifier)},registerEvaluatableExpressionProvider(ie,he){return ct.registerEvaluatableExpressionProvider(Ue,mt(ie),he,Ue.identifier)},registerInlineValuesProvider(ie,he){return ct.registerInlineValuesProvider(Ue,mt(ie),he,Ue.identifier)},registerDocumentHighlightProvider(ie,he){return ct.registerDocumentHighlightProvider(Ue,mt(ie),he)},registerLinkedEditingRangeProvider(ie,he){return ct.registerLinkedEditingRangeProvider(Ue,mt(ie),he)},registerReferenceProvider(ie,he){return ct.registerReferenceProvider(Ue,mt(ie),he)},registerRenameProvider(ie,he){return ct.registerRenameProvider(Ue,mt(ie),he)},registerDocumentSymbolProvider(ie,he,Me){return ct.registerDocumentSymbolProvider(Ue,mt(ie),he,Me)},registerWorkspaceSymbolProvider(ie){return ct.registerWorkspaceSymbolProvider(Ue,ie)},registerDocumentFormattingEditProvider(ie,he){return ct.registerDocumentFormattingEditProvider(Ue,mt(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return ct.registerDocumentRangeFormattingEditProvider(Ue,mt(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Me,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,mt(ie),he,[Me].concat(rt))},registerDocumentSemanticTokensProvider(ie,he,Me){return ct.registerDocumentSemanticTokensProvider(Ue,mt(ie),he,Me)},registerDocumentRangeSemanticTokensProvider(ie,he,Me){return ct.registerDocumentRangeSemanticTokensProvider(Ue,mt(ie),he,Me)},registerSignatureHelpProvider(ie,he,Me,...rt){return typeof Me=="object"?ct.registerSignatureHelpProvider(Ue,mt(ie),he,Me):ct.registerSignatureHelpProvider(Ue,mt(ie),he,typeof Me>"u"?[]:[Me,...rt])},registerCompletionItemProvider(ie,he,...Me){return ct.registerCompletionItemProvider(Ue,mt(ie),he,Me)},registerInlineCompletionItemProvider(ie,he){return he.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,mt(ie),he)},registerDocumentLinkProvider(ie,he){return ct.registerDocumentLinkProvider(Ue,mt(ie),he)},registerColorProvider(ie,he){return ct.registerColorProvider(Ue,mt(ie),he)},registerFoldingRangeProvider(ie,he){return ct.registerFoldingRangeProvider(Ue,mt(ie),he)},registerSelectionRangeProvider(ie,he){return ct.registerSelectionRangeProvider(Ue,ie,he)},registerCallHierarchyProvider(ie,he){return ct.registerCallHierarchyProvider(Ue,ie,he)},registerTypeHierarchyProvider(ie,he){return ct.registerTypeHierarchyProvider(Ue,ie,he)},setLanguageConfiguration:(ie,he)=>ct.setLanguageConfiguration(Ue,ie,he),getTokenInformationAtPosition(ie,he){return(0,Ve.checkProposedApiEnabled)(Ue,"tokenInformation"),oi.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return ct.registerInlayHintsProvider(Ue,ie,he)},createLanguageStatusItem(ie,he){return oi.createLanguageStatusItem(Ue,ie,he)},registerDocumentDropEditProvider(ie,he){return ct.registerDocumentOnDropEditProvider(Ue,ie,he)}},Vi={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ie,he,Me){const rt=await(C.URI.isUri(ie)?Promise.resolve(fi.openTextDocument(ie)):Promise.resolve(ie));return Tt.showTextDocument(rt,he,Me)},createTextEditorDecorationType(ie){return Tt.createTextEditorDecorationType(Ue,ie)},onDidChangeActiveTextEditor(ie,he,Me){return Tt.onDidChangeActiveTextEditor(ie,he,Me)},onDidChangeVisibleTextEditors(ie,he,Me){return Tt.onDidChangeVisibleTextEditors(ie,he,Me)},onDidChangeTextEditorSelection(ie,he,Me){return Tt.onDidChangeTextEditorSelection(ie,he,Me)},onDidChangeTextEditorOptions(ie,he,Me){return Tt.onDidChangeTextEditorOptions(ie,he,Me)},onDidChangeTextEditorVisibleRanges(ie,he,Me){return Tt.onDidChangeTextEditorVisibleRanges(ie,he,Me)},onDidChangeTextEditorViewColumn(ie,he,Me){return Tt.onDidChangeTextEditorViewColumn(ie,he,Me)},onDidCloseTerminal(ie,he,Me){return ze.onDidCloseTerminal(ie,he,Me)},onDidOpenTerminal(ie,he,Me){return ze.onDidOpenTerminal(ie,he,Me)},onDidChangeActiveTerminal(ie,he,Me){return ze.onDidChangeActiveTerminal(ie,he,Me)},onDidChangeTerminalDimensions(ie,he,Me){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ie,he,Me)},onDidChangeTerminalState(ie,he,Me){return ze.onDidChangeTerminalState(ie,he,Me)},onDidWriteTerminalData(ie,he,Me){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ie,he,Me)},get state(){return Ae.state},onDidChangeWindowState(ie,he,Me){return Ae.onDidChangeWindowState(ie,he,Me)},showInformationMessage(ie,...he){return Pi.showMessage(Ue,N.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return Pi.showMessage(Ue,N.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return Pi.showMessage(Ue,N.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Me){return Wt.showQuickPick(ie,he,Me)},showWorkspaceFolderPick(ie){return Wt.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Wt.showInput(ie,he)},showOpenDialog(ie){return Fi.showOpenDialog(ie)},showSaveDialog(ie){return Fi.showSaveDialog(ie)},createStatusBarItem(ie,he,Me){let rt,yt,Pt;return typeof ie=="string"?(rt=ie,yt=he,Pt=Me):(yt=ie,Pt=he),Mi.createStatusBarEntry(Ue,rt,yt,Pt)},setStatusBarMessage(ie,he){return Mi.setStatusBarMessage(ie,he)},withScmProgress(ie){return ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ci.withProgress(Ue,{location:z.ProgressLocation.SourceControl},(he,Me)=>ie({report(rt){}}))},withProgress(ie,he){return ci.withProgress(Ue,ie,he)},createOutputChannel(ie,he){return At.createOutputChannel(ie,he,Ue)},createWebviewPanel(ie,he,Me,rt){return yi.createWebviewPanel(Ue,ie,he,Me,rt)},createWebviewTextEditorInset(ie,he,Me,rt){return(0,Ve.checkProposedApiEnabled)(Ue,"editorInsets"),Vt.createWebviewEditorInset(ie,he,Me,rt,Ue)},createTerminal(ie,he,Me){return typeof ie=="object"?"pty"in ie?ze.createExtensionTerminal(ie):ze.createTerminalFromOptions(ie):ze.createTerminal(ie,he,Me)},registerTerminalLinkProvider(ie){return ze.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return ze.registerProfileProvider(Ue,ie,he)},registerTerminalQuickFixProvider(ie,he){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ie,Ue.identifier.value,he)},registerTreeDataProvider(ie,he){return si.registerTreeDataProvider(ie,he,Ue)},createTreeView(ie,he){return si.createTreeView(ie,he,Ue)},registerWebviewPanelSerializer:(ie,he)=>yi.registerWebviewPanelSerializer(Ue,ie,he),registerCustomEditorProvider:(ie,he,Me={})=>Di.registerCustomEditorProvider(Ue,ie,he,Me),registerFileDecorationProvider(ie){return Re.registerFileDecorationProvider(ie,Ue)},registerUriHandler(ie){return It.registerUriHandler(Ue.identifier,ie)},createQuickPick(){return Wt.createQuickPick(Ue)},createInputBox(){return Wt.createInputBox(Ue)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Me){return ui.onDidChangeActiveColorTheme(ie,he,Me)},registerWebviewViewProvider(ie,he,Me){return Ii.registerWebviewViewProvider(Ue,ie,he,Me?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Me){return Et.onDidChangeActiveNotebookEditor(ie,he,Me)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Me){return ri.onDidChangeNotebookEditorSelection(ie,he,Me)},onDidChangeNotebookEditorVisibleRanges(ie,he,Me){return ri.onDidChangeNotebookEditorVisibleRanges(ie,he,Me)},showNotebookDocument(ie,he){return Et.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Me){return(0,Ve.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ci.registerExternalUriOpener(Ue.identifier,ie,he,Me)},registerProfileContentHandler(ie,he){return(0,Ve.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Bi.registrProfileContentHandler(Ue,ie,he)},get tabGroups(){return X.tabGroups}},fi={get rootPath(){return ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ie){throw T.readonly()},getWorkspaceFolder(ie){return ft.getWorkspaceFolder(ie)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ie){throw T.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ie){throw T.readonly()},updateWorkspaceFolders:(ie,he,...Me)=>ft.updateWorkspaceFolders(Ue,ie,he||0,...Me),onDidChangeWorkspaceFolders:function(ie,he,Me){return ft.onDidChangeWorkspace(ie,he,Me)},asRelativePath:(ie,he)=>ft.getRelativePath(ie,he),findFiles:(ie,he,Me,rt)=>ft.findFiles(ie,he,Me,Ue.identifier,rt),findTextInFiles:(ie,he,Me,rt)=>{(0,Ve.checkProposedApiEnabled)(Ue,"findTextInFiles");let yt,Pt;return typeof he=="object"?(yt=he,Pt=Me):(yt={},Pt=he,rt=Me),ft.findTextInFiles(ie,yt||{},Pt,Ue.identifier,rt)},saveAll:ie=>ft.saveAll(ie),applyEdit(ie,he){return Ti.applyWorkspaceEdit(ie,Ue,he)},createFileSystemWatcher:(ie,he,Me,rt)=>Qt.createFileSystemWatcher(ft,Ue,ie,he,Me,rt),get textDocuments(){return ht.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw T.readonly()},openTextDocument(ie){let he;const Me=ie;if(typeof ie=="string")he=Promise.resolve(C.URI.file(ie));else if(C.URI.isUri(ie))he=Promise.resolve(ie);else if(!Me||typeof Me=="object")he=ht.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>ht.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(ie,he,Me)=>ht.onDidAddDocument(ie,he,Me),onDidCloseTextDocument:(ie,he,Me)=>ht.onDidRemoveDocument(ie,he,Me),onDidChangeTextDocument:(ie,he,Me)=>ht.onDidChangeDocument(ie,he,Me),onDidSaveTextDocument:(ie,he,Me)=>ht.onDidSaveDocument(ie,he,Me),onWillSaveTextDocument:(ie,he,Me)=>jt.getOnWillSaveTextDocumentEvent(Ue)(ie,he,Me),get notebookDocuments(){return Et.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Me;if(C.URI.isUri(ie))Me=ie,await Et.openNotebookDocument(ie);else if(typeof ie=="string")Me=C.URI.revive(await Et.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ie,he,Me){return _t.onDidSaveNotebookDocument(ie,he,Me)},onDidChangeNotebookDocument(ie,he,Me){return _t.onDidChangeNotebookDocument(ie,he,Me)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Me,rt){return Et.registerNotebookSerializer(Ue,ie,he,Me,(0,Ve.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ie,he,Me)=>li.onDidChangeConfiguration(ie,he,Me),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,li.getConfiguration(ie,he,Ue)},registerTextDocumentContentProvider(ie,he){return Kt.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ue,ie,he)),registerFileSystemProvider(ie,he,Me){return(0,$e.combinedDisposable)(Oi.registerFileSystemProvider(Ue,ie,he,Me),Ot.addFileSystemProvider(ie,he))},get fs(){return Ot.value},registerFileSearchProvider:(ie,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),Ft.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),wi.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Me)=>Qt.onDidCreateFile(ie,he,Me),onDidDeleteFiles:(ie,he,Me)=>Qt.onDidDeleteFile(ie,he,Me),onDidRenameFiles:(ie,he,Me)=>Qt.onDidRenameFile(ie,he,Me),onWillCreateFiles:(ie,he,Me)=>Qt.getOnWillCreateFileEvent(Ue)(ie,he,Me),onWillDeleteFiles:(ie,he,Me)=>Qt.getOnWillDeleteFileEvent(Ue)(ie,he,Me),onWillRenameFiles:(ie,he,Me)=>Qt.getOnWillRenameFileEvent(Ue)(ie,he,Me),openTunnel:ie=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),kt.openTunnel(Ue,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),kt.getTunnels()},onDidChangeTunnels:(ie,he,Me)=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),kt.onDidChangeTunnels(ie,he,Me)),registerPortAttributesProvider:(ie,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"portsAttributes"),kt.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"timeline"),Si.registerTimelineProvider(ie,he,Ue.identifier,_e.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ie=>((0,Ve.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Me)=>ft.onDidGrantWorkspaceTrust(ie,he,Me),registerEditSessionIdentityProvider:(ie,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ie,he))},qi={get inputBox(){return ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ai.getLastInputBox(Ue)},createSourceControl(ie,he,Me){return ai.createSourceControl(Ue,ie,he,Me)}},xt={createCommentController(ie,he){return Ei.createCommentController(Ue,ie,he)}},mi={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ie,he,Me){return Ze.onDidStartDebugSession(ie,he,Me)},onDidTerminateDebugSession(ie,he,Me){return Ze.onDidTerminateDebugSession(ie,he,Me)},onDidChangeActiveDebugSession(ie,he,Me){return Ze.onDidChangeActiveDebugSession(ie,he,Me)},onDidReceiveDebugSessionCustomEvent(ie,he,Me){return Ze.onDidReceiveDebugSessionCustomEvent(ie,he,Me)},onDidChangeBreakpoints(ie,he,Me){return Ze.onDidChangeBreakpoints(ie,he,Me)},registerDebugConfigurationProvider(ie,he,Me){return Ze.registerDebugConfigurationProvider(ie,he,Me||Qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return Ze.registerDebugAdapterDescriptorFactory(Ue,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return Ze.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Me){return!Me||typeof Me=="object"&&"configuration"in Me?Ze.startDebugging(ie,he,{parentSession:Me}):Ze.startDebugging(ie,he,Me||{})},stopDebugging(ie){return Ze.stopDebugging(ie)},addBreakpoints(ie){return Ze.addBreakpoints(ie)},removeBreakpoints(ie){return Ze.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return Ze.asDebugSourceUri(ie,he)}},Ki={registerTaskProvider:(ie,he)=>vt.registerTaskProvider(Ue,ie,he),fetchTasks:ie=>vt.fetchTasks(ie),executeTask:ie=>vt.executeTask(Ue,ie),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ie,he,Me)=>vt.onDidStartTask(ie,he,Me),onDidEndTask:(ie,he,Me)=>vt.onDidEndTask(ie,he,Me),onDidStartTaskProcess:(ie,he,Me)=>vt.onDidStartTaskProcess(ie,he,Me),onDidEndTaskProcess:(ie,he,Me)=>vt.onDidEndTaskProcess(ie,he,Me)},zt={createNotebookController(ie,he,Me,rt,yt){return ei.createNotebookController(Ue,ie,he,Me,rt,(0,Ve.isProposedApiEnabled)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ie,he),createRendererMessaging(ie){return bi.createRendererMessaging(Ue,ie)},createNotebookControllerDetectionTask(ie){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ei.createNotebookControllerDetectionTask(Ue,ie)},registerKernelSourceActionProvider(ie,he){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ei.registerKernelSourceActionProvider(Ue,ie,he)},onDidChangeNotebookCellExecutionState(ie,he,Me){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),ei.onDidChangeNotebookCellExecutionState(ie,he,Me)}},gi={t(...ie){if(typeof ie[0]=="string"){const he=ie.shift(),Me=!ie||typeof ie[0]!="object"?ie:ie[0];return pt.getMessage(Ue.identifier.value,{message:he,args:Me})}return pt.getMessage(Ue.identifier.value,ie[0])},get bundle(){return pt.getBundle(Ue.identifier.value)},get uri(){return pt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:zi,commands:Wi,comments:xt,debug:mi,env:Li,extensions:Hi,l10n:gi,languages:ji,notebooks:zt,scm:qi,tasks:Ki,tests:di,window:Vi,workspace:fi,Breakpoint:z.Breakpoint,TerminalOutputAnchor:z.TerminalOutputAnchor,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:t.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileDecoration2:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestionList,Hover:z.Hover,IndentAction:k.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalQuickFixCommand:z.TerminalQuickFixCommand,TerminalQuickFixOpener:z.TerminalQuickFixOpener,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TerminalExitReason:z.TerminalExitReason,TerminalQuickFixType:z.TerminalQuickFixType,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:p.UIKind,Uri:C.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,NotebookKernelSourceAction:z.NotebookKernelSourceAction,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TrustedTelemetryValue:ne.TrustedTelemetryValue,LogLevel:Ge.LogLevel,EditSessionIdentityMatch:wt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Ct}),define(Ce[248],ke([1,0,247,33,2,241,6,14,232]),function(ee,e,t,T,y,N,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends N.RequireInterceptor{j(){}getModule(p,m){for(const i of this.b){const r=i(p);if(r){p=r;break}}if(this.a.has(p))return this.a.get(p).load(p,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(D.ExtHostConsoleForwarder);const p=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,p,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(p){return p.browser}async pb(p,m,i){m=m.with({path:S(m.path,".js")});const r=p?.identifier.value;r&&performance.mark(`code/extHost/willFetchExtensionCode/${r}`);const l=y.URI.revive(await this.v.$asBrowserUri(m)),v=await fetch(l.toString(!0));if(r&&performance.mark(`code/extHost/didFetchExtensionCode/${r}`),v.status!==200)throw new Error(v.statusText);const b=await v.text(),E=`${m.toString(!0)}#vscode-extension`,w=`${b}
//# sourceURL=${E}`;let s;try{s=new Function("module","exports","require",w)}catch(c){throw console.error(r?`Loading code for extension ${r} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${m.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}p&&await this.s.initializeLocalizedMessages(p);const o={},a={exports:o},d=c=>{const u=this.r.getModule(c,m);if(u===void 0)throw new Error(`Cannot load module '${c}'`);return u};try{return i.codeLoadingStart(),r&&performance.mark(`code/extHost/willLoadExtensionCode/${r}`),s(a,o,d),a.exports!==o?a.exports:o}finally{r&&performance.mark(`code/extHost/didLoadExtensionCode/${r}`),i.codeLoadingStop()}}async $setRemoteEnvironment(p){}async tb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+p;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=M;function S(f,p){return f.endsWith(p)?f:f+p}}),define(Ce[249],ke([1,0,63,33,78,248]),function(ee,e,t,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,t.registerSingleton)(T.IExtHostExtensionService,N.ExtHostExtensionService,0),(0,t.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(Ce[257],ke([1,0,24,4,70,242,234,19,79,13,2,244,249]),function(ee,e,t,T,y,N,C,R,D,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(s){return/^(file|vscode-remote):/i.test(s)}const m=fetch.bind(self);function i(s){self.fetch=async function(o,a){return o instanceof Request||p(String(o))&&(o=(await s(M.URI.parse(String(o)))).toString(!0)),m(o,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,a,d,c,u){(async()=>(p(a.toString())&&(a=(await s(M.URI.parse(a.toString()))).toString(!0)),super.open(o,a,d??!0,c,u)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(o,a){if(/^file:/i.test(o.toString()))o=k.FileAccess.uriToBrowserUri(M.URI.parse(o.toString())).toString(!0);else if(/^vscode-remote:/i.test(o.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(g){function A(Z){return typeof Z=="string"||Z instanceof URL?String(Z).replace(/^file:\/\//i,"vscode-file://vscode-app"):Z}const L=fetch.bind(self);self.fetch=function(Z,x){return Z instanceof Request?L(Z,x):L(A(Z),x)},self.XMLHttpRequest=class extends XMLHttpRequest{open(Z,x,O,F,P){return super.open(Z,A(x),O??!0,F,P)}};const q=importScripts.bind(self);self.importScripts=(...Z)=>{q(...Z.map(A))},q(g)}.toString()}('${o}'))`;a=a||{},a.name=a.name||R.basename(o.toString());const u=new Blob([c],{type:"application/javascript"}),n=URL.createObjectURL(u);return new s(n,a)}}else self.Worker=class extends C.NestedWorker{constructor(s,o){super(f,s,{name:R.basename(s.toString()),...o})}};const r=new class{constructor(){this.pid=void 0}exit(s){S()}async exists(s){return!0}async realpath(s){return s}};class l{constructor(){const o=new MessageChannel,a=new T.Emitter;let d=!1;f(o.port2,[o.port2]),o.port1.onmessage=c=>{const{data:u}=c;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const n=t.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,y.isMessageOfType)(n,2)){d=!0,b("received terminate message from renderer");return}a.fire(n)},this.protocol={onMessage:a.event,send:c=>{if(!d){const u=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);o.port1.postMessage(u,[u])}}}}}function v(s){return new Promise(o=>{const a=s.onMessage(d=>{a.dispose();const c=JSON.parse(d.toString());s.send((0,y.createMessageOfType)(0)),o({protocol:s,initData:c})});s.send((0,y.createMessageOfType)(1))})}let b=s=>S();function E(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function w(){D.mark("code/extHost/willConnectToRenderer");const s=new l;return{onmessage(o){!E(o)||v(s.protocol).then(a=>{D.mark("code/extHost/didWaitForInitData");const d=new N.ExtensionHostMain(a.protocol,a.initData,r,null,o.data);i(c=>d.asBrowserUri(c)),b=c=>d.terminate(c)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/717d7d62c8b4566ab6704de931e7fe8e0649d810/core/vs/workbench/api/worker/extensionHostWorker.js.map
